/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/resources","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/objects","fs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/product/common/productService","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/product/common/product","vs/base/common/map","os","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/process","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/userDataPath","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/base/parts/sandbox/electron-sandbox/globals","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","vs/platform/log/common/bufferLog","vs/platform/log/common/fileLog","vs/platform/log/node/loggerService","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/environment/node/environmentService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","path","util","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],Z=function(G){for(var e=[],v=0,A=G.length;v<A;v++)e[v]=Q[G[v]];return e};define(Q[85],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(A,k){if(!A)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=v}),define(Q[62],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function A(I){const h=[];for(let w in I)v.call(I,w)&&h.push(I[w]);return h}e.values=A;function k(I,h){for(let w in I)if(v.call(I,w)&&h({key:w,value:I[w]},function(){delete I[w]})===!1)return}e.forEach=k;function R(I,h){const w=Object.create(null);for(const D of I){const a=h(D);let C=w[a];C||(C=w[a]=[]),C.push(D)}return w}e.groupBy=R;function O(I){const h=Object.create(null);return I&&I.forEach((w,D)=>{h[D]=w}),h}e.fromMap=O;function L(I,h){const w=[],D=[];for(let a of I)h.has(a)||w.push(a);for(let a of h)I.has(a)||D.push(a);return{removed:w,added:D}}e.diffSets=L;function g(I,h){const w=[],D=[];for(let[a,C]of I)h.has(a)||w.push(C);for(let[a,C]of h)I.has(a)||D.push(C);return{removed:w,added:D}}e.diffMaps=g;class S{constructor(){this.map=new Map}add(h,w){let D=this.map.get(h);D||(D=new Set,this.map.set(h,D)),D.add(w)}delete(h,w){const D=this.map.get(h);!D||(D.delete(w),D.size===0&&this.map.delete(h))}forEach(h,w){const D=this.map.get(h);!D||D.forEach(w)}}e.SetMap=S}),define(Q[86],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function v(g){return(S,I,h)=>{let w=null,D=null;if(typeof h.value=="function"?(w="value",D=h.value):typeof h.get=="function"&&(w="get",D=h.get),!D)throw new Error("not supported");h[w]=g(D,I)}}e.createDecorator=v;let A=0;function k(){const g=`$memoize${A++}`;let S;const I=function(w,D,a){let C=null,b=null;if(typeof a.value=="function"?(C="value",b=a.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(C="get",b=a.get),!b)throw new Error("not supported");const p=`${g}:${D}`;a[C]=function(...E){return S=this,this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!0,enumerable:!1,writable:!0,value:b.apply(this,E)}),this[p]}};return I.clear=()=>{typeof S!="undefined"&&Object.getOwnPropertyNames(S).forEach(h=>{h.indexOf(g)===0&&delete S[h]})},I}e.createMemoizer=k;function R(g,S,I){return k()(g,S,I)}e.memoize=R;function O(g,S,I){return v((h,w)=>{const D=`$debounce$${w}`,a=`$debounce$result$${w}`;return function(...C){this[a]||(this[a]=I?I():void 0),clearTimeout(this[D]),S&&(this[a]=S(this[a],...C),C=[this[a]]),this[D]=setTimeout(()=>{h.apply(this,C),this[a]=I?I():void 0},g)}})}e.debounce=O;function L(g,S,I){return v((h,w)=>{const D=`$throttle$timer$${w}`,a=`$throttle$result$${w}`,C=`$throttle$lastRun$${w}`,b=`$throttle$pending$${w}`;return function(...p){if(this[a]||(this[a]=I?I():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),S&&(this[a]=S(this[a],...p)),!this[b]){const E=this[C]+g;E<=Date.now()?(this[C]=Date.now(),h.apply(this,[this[a]]),this[a]=I?I():void 0):(this[b]=!0,this[D]=setTimeout(()=>{this[b]=!1,this[C]=Date.now(),h.apply(this,[this[a]]),this[a]=I?I():void 0},E-Date.now()))}}})}e.throttle=L}),define(Q[15],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function A(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=A;function k(i){g(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=k;function R(i){g(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=R;function O(i){if(i instanceof Error){let{name:t,message:n}=i;const r=i.stacktrace||i.stack;return{$isError:!0,name:t,message:n,stack:r}}return i}e.transformErrorForSerialization=O;const L="Canceled";function g(i){return i instanceof Error&&i.name===L&&i.message===L}e.isPromiseCanceledError=g;class S extends Error{constructor(){super(L);this.name=this.message}}e.CancellationError=S;function I(){const i=new Error(L);return i.name=i.message,i}e.canceled=I;function h(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=h;function w(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=w;function D(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=D;function a(i){const t=new Error(`${i} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function C(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=C;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class p extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=p;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function m(i){const t=i;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=m;function o(i,t=Object.create(null)){const n=new Error(i);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=o}),define(Q[18],Z([0,1,15]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function A(B,M=0){return B[B.length-(1+M)]}e.tail=A;function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=k;function R(B,M,F=(T,U)=>T===U){if(B===M)return!0;if(!B||!M||B.length!==M.length)return!1;for(let T=0,U=B.length;T<U;T++)if(!F(B[T],M[T]))return!1;return!0}e.equals=R;function O(B,M,F){let T=0,U=B.length-1;for(;T<=U;){const N=(T+U)/2|0,$=F(B[N],M);if($<0)T=N+1;else if($>0)U=N-1;else return N}return-(T+1)}e.binarySearch=O;function L(B,M){let F=0,T=B.length;if(T===0)return 0;for(;F<T;){const U=Math.floor((F+T)/2);M(B[U])?T=U:F=U+1}return F}e.findFirstInSorted=L;function g(B,M,F){if(B=B|0,B>=M.length)throw new TypeError("invalid index");let T=M[Math.floor(M.length*Math.random())],U=[],N=[],$=[];for(let H of M){const K=F(H,T);K<0?U.push(H):K>0?N.push(H):$.push(H)}return B<U.length?g(B,U,F):B<U.length+$.length?$[0]:g(B-(U.length+$.length),N,F)}e.quickSelect=g;function S(B,M){const F=[];let T;for(const U of B.slice(0).sort(M))!T||M(T[0],U)!==0?(T=[U],F.push(T)):T.push(U);return F}e.groupBy=S;function I(B,M,F){const T=[];function U(H,K,te){if(!(K===0&&te.length===0)){const X=T[T.length-1];X&&X.start+X.deleteCount===H?(X.deleteCount+=K,X.toInsert.push(...te)):T.push({start:H,deleteCount:K,toInsert:te})}}let N=0,$=0;for(;;){if(N===B.length){U(N,0,M.slice($));break}if($===M.length){U(N,B.length-N,[]);break}const H=B[N],K=M[$],te=F(H,K);te===0?(N+=1,$+=1):te<0?(U(N,1,[]),N+=1):te>0&&(U(N,0,[K]),$+=1)}return T}e.sortedDiff=I;function h(B,M,F){const T=I(B,M,F),U=[],N=[];for(const $ of T)U.push(...B.slice($.start,$.start+$.deleteCount)),N.push(...$.toInsert);return{removed:U,added:N}}e.delta=h;function w(B,M,F){if(F===0)return[];const T=B.slice(0,F).sort(M);return a(B,M,T,F,B.length),T}e.top=w;function D(B,M,F,T,U){return F===0?Promise.resolve([]):new Promise((N,$)=>{(async()=>{const H=B.length,K=B.slice(0,F).sort(M);for(let te=F,X=Math.min(F+T,H);te<H;te=X,X=Math.min(X+T,H)){if(te>F&&await new Promise(ie=>setTimeout(ie)),U&&U.isCancellationRequested)throw(0,v.canceled)();a(B,M,K,te,X)}return K})().then(N,$)})}e.topAsync=D;function a(B,M,F,T,U){for(const N=F.length;T<U;T++){const $=B[T];if(M($,F[N-1])<0){F.pop();const H=L(F,K=>M($,K)<0);F.splice(H,0,$)}}}function C(B){return B.filter(M=>!!M)}e.coalesce=C;function b(B){let M=0;for(let F=0;F<B.length;F++)B[F]&&(B[M]=B[F],M+=1);B.length=M}e.coalesceInPlace=b;function p(B,M,F){B.splice(F,0,B.splice(M,1)[0])}e.move=p;function E(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=E;function m(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=m;function o(B,M){if(!M)return B.filter((T,U)=>B.indexOf(T)===U);const F=Object.create(null);return B.filter(T=>{const U=M(T);return F[U]?!1:(F[U]=!0,!0)})}e.distinct=o;function i(B){const M=new Set;return B.filter(F=>M.has(F)?!1:(M.add(F),!0))}e.distinctES6=i;function t(B){const M=Object.create(null);return F=>{const T=B(F);return M[T]?!1:(M[T]=!0,!0)}}e.uniqueFilter=t;function n(B,M){for(let F=B.length-1;F>=0;F--){const T=B[F];if(M(T))return F}return-1}e.lastIndex=n;function r(B,M){return B.length>0?B[0]:M}e.firstOrDefault=r;function c(B,M,F=(T,U)=>T===U){let T=0;for(let U=0,N=Math.min(B.length,M.length);U<N&&F(B[U],M[U]);U++)T++;return T}e.commonPrefixLength=c;function s(B){return[].concat(...B)}e.flatten=s;function l(B,M){let F=typeof M=="number"?B:0;typeof M=="number"?F=B:(F=0,M=B);const T=[];if(F<=M)for(let U=F;U<M;U++)T.push(U);else for(let U=F;U>M;U--)T.push(U);return T}e.range=l;function d(B,M,F){return B.reduce((T,U)=>(T[M(U)]=F?F(U):U,T),Object.create(null))}e.index=d;function f(B,M){return B.push(M),()=>y(B,M)}e.insert=f;function y(B,M){const F=B.indexOf(M);if(F>-1)return B.splice(F,1),M}e.remove=y;function u(B,M,F){const T=B.slice(0,M),U=B.slice(M);return T.concat(F,U)}e.arrayInsert=u;function P(B,M){let F;if(typeof M=="number"){let T=M;F=()=>{const U=Math.sin(T++)*179426549;return U-Math.floor(U)}}else F=Math.random;for(let T=B.length-1;T>0;T-=1){const U=Math.floor(F()*(T+1)),N=B[T];B[T]=B[U],B[U]=N}}e.shuffle=P;function _(B,M){const F=B.indexOf(M);F>-1&&(B.splice(F,1),B.unshift(M))}e.pushToStart=_;function z(B,M){const F=B.indexOf(M);F>-1&&(B.splice(F,1),B.push(M))}e.pushToEnd=z;function j(B,M){return Array.isArray(B)?B.map(M):M(B)}e.mapArrayOrNot=j;function W(B){return Array.isArray(B)?B:[B]}e.asArray=W;function q(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=q;function x(B,M){for(const F of B){const T=M(F);if(T!==void 0)return T}}e.mapFind=x}),define(Q[63],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(A){const k=this;let R=!1,O;return function(){return R||(R=!0,O=A.apply(k,arguments)),O}}e.once=v}),define(Q[52],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(A){function k(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}A.is=k;const R=Object.freeze([]);function O(){return R}A.empty=O;function*L(i){yield i}A.single=L;function g(i){return i||R}A.from=g;function S(i){return!i||i[Symbol.iterator]().next().done===!0}A.isEmpty=S;function I(i){return i[Symbol.iterator]().next().value}A.first=I;function h(i,t){for(const n of i)if(t(n))return!0;return!1}A.some=h;function w(i,t){for(const n of i)if(t(n))return n}A.find=w;function*D(i,t){for(const n of i)t(n)&&(yield n)}A.filter=D;function*a(i,t){for(const n of i)yield t(n)}A.map=a;function*C(...i){for(const t of i)for(const n of t)yield n}A.concat=C;function*b(i){for(const t of i)for(const n of t)yield n}A.concatNested=b;function p(i,t,n){let r=n;for(const c of i)r=t(r,c);return r}A.reduce=p;function*E(i,t,n=i.length){for(t<0&&(t+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);t<n;t++)yield i[t]}A.slice=E;function m(i,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,i];const r=i[Symbol.iterator]();for(let c=0;c<t;c++){const s=r.next();if(s.done)return[n,A.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return r}}]}A.consume=m;function o(i,t,n=(r,c)=>r===c){const r=i[Symbol.iterator](),c=t[Symbol.iterator]();for(;;){const s=r.next(),l=c.next();if(s.done!==l.done)return!1;if(s.done)return!0;if(!n(s.value,l.value))return!1}}A.equals=o})(v=e.Iterable||(e.Iterable={}))}),define(Q[32],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function O(t,n=!1){let r=0,c=t.length,s="",l=0,d=16,f=0;function y(q){let x=0,B=0;for(;x<q;){const M=t.charCodeAt(r);if(M>=48&&M<=57)B=B*16+M-48;else if(M>=65&&M<=70)B=B*16+M-65+10;else if(M>=97&&M<=102)B=B*16+M-97+10;else break;r++,x++}return x<q&&(B=-1),B}function u(q){r=q,s="",l=0,d=16,f=0}function P(){const q=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&S(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&S(t.charCodeAt(r)))for(r++;r<t.length&&S(t.charCodeAt(r));)r++;else return f=3,t.substring(q,r);let x=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&S(t.charCodeAt(r))){for(r++;r<t.length&&S(t.charCodeAt(r));)r++;x=r}else f=3;return t.substring(q,x)}function _(){let q="",x=r;for(;;){if(r>=c){q+=t.substring(x,r),f=2;break}const B=t.charCodeAt(r);if(B===34){q+=t.substring(x,r),r++;break}if(B===92){if(q+=t.substring(x,r),r++,r>=c){f=2;break}switch(t.charCodeAt(r++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:const F=y(4);F>=0?q+=String.fromCharCode(F):f=4;break;default:f=5}x=r;continue}if(B>=0&&B<=31)if(g(B)){q+=t.substring(x,r),f=2;break}else f=6;r++}return q}function z(){if(s="",f=0,l=r,r>=c)return l=c,d=17;let q=t.charCodeAt(r);if(L(q)){do r++,s+=String.fromCharCode(q),q=t.charCodeAt(r);while(L(q));return d=15}if(g(q))return r++,s+=String.fromCharCode(q),q===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),d=14;switch(q){case 123:return r++,d=1;case 125:return r++,d=2;case 91:return r++,d=3;case 93:return r++,d=4;case 58:return r++,d=6;case 44:return r++,d=5;case 34:return r++,s=_(),d=10;case 47:const x=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<c&&!g(t.charCodeAt(r));)r++;return s=t.substring(x,r),d=12}if(t.charCodeAt(r+1)===42){r+=2;const B=c-1;let M=!1;for(;r<B;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,M=!0;break}r++}return M||(r++,f=1),s=t.substring(x,r),d=13}return s+=String.fromCharCode(q),r++,d=16;case 45:if(s+=String.fromCharCode(q),r++,r===c||!S(t.charCodeAt(r)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=P(),d=11;default:for(;r<c&&j(q);)r++,q=t.charCodeAt(r);if(l!==r){switch(s=t.substring(l,r),s){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return s+=String.fromCharCode(q),r++,d=16}}function j(q){if(L(q)||g(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=z();while(q>=12&&q<=15);return q}return{setPosition:u,getPosition:()=>r,scan:n?W:z,getToken:()=>d,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>f}}e.createScanner=O;function L(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function h(t,n){const r=[],c=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function f(y,u,P,_){l.value=y,l.offset=u,l.length=P,l.type=_,l.colonOffset=void 0,s=l}try{m(t,{onObjectBegin:(y,u)=>{if(n<=y)throw c;s=void 0,d=n>y,r.push("")},onObjectProperty:(y,u,P)=>{if(n<u||(f(y,u,P,"property"),r[r.length-1]=y,n<=u+P))throw c},onObjectEnd:(y,u)=>{if(n<=y)throw c;s=void 0,r.pop()},onArrayBegin:(y,u)=>{if(n<=y)throw c;s=void 0,r.push(0)},onArrayEnd:(y,u)=>{if(n<=y)throw c;s=void 0,r.pop()},onLiteralValue:(y,u,P)=>{if(n<u||(f(y,u,P,i(y)),n<=u+P))throw c},onSeparator:(y,u,P)=>{if(n<=u)throw c;if(y===":"&&s&&s.type==="property")s.colonOffset=u,d=!1,s=void 0;else if(y===","){const _=r[r.length-1];typeof _=="number"?r[r.length-1]=_+1:(d=!0,r[r.length-1]=""),s=void 0}}})}catch(y){if(y!==c)throw y}return{path:r,previousNode:s,isAtPropertyKey:d,matches:y=>{let u=0;for(let P=0;u<y.length&&P<r.length;P++)if(y[u]===r[P]||y[u]==="*")u++;else if(y[u]!=="**")return!1;return u===y.length}}}e.getLocation=h;function w(t,n=[],r=R.DEFAULT){let c=null,s=[];const l=[];function d(y){Array.isArray(s)?s.push(y):c!==null&&(s[c]=y)}return m(t,{onObjectBegin:()=>{const y={};d(y),l.push(s),s=y,c=null},onObjectProperty:y=>{c=y},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const y=[];d(y),l.push(s),s=y,c=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:d,onError:(y,u,P)=>{n.push({error:y,offset:u,length:P})}},r),s[0]}e.parse=w;function D(t,n=[],r=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){c.type==="property"&&(c.length=y-c.offset,c=c.parent)}function l(y){return c.children.push(y),y}m(t,{onObjectBegin:y=>{c=l({type:"object",offset:y,length:-1,parent:c,children:[]})},onObjectProperty:(y,u,P)=>{c=l({type:"property",offset:u,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:y,offset:u,length:P,parent:c})},onObjectEnd:(y,u)=>{c.length=y+u-c.offset,c=c.parent,s(y+u)},onArrayBegin:(y,u)=>{c=l({type:"array",offset:y,length:-1,parent:c,children:[]})},onArrayEnd:(y,u)=>{c.length=y+u-c.offset,c=c.parent,s(y+u)},onLiteralValue:(y,u,P)=>{l({type:i(y),offset:u,length:P,parent:c,value:y}),s(u+P)},onSeparator:(y,u,P)=>{c.type==="property"&&(y===":"?c.colonOffset=u:y===","&&s(u))},onError:(y,u,P)=>{n.push({error:y,offset:u,length:P})}},r);const f=c.children[0];return f&&delete f.parent,f}e.parseTree=D;function a(t,n){if(!!t){let r=t;for(let c of n)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===c){r=l.children[1],s=!0;break}if(!s)return}else{const s=c;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}}e.findNodeAtLocation=a;function C(t){if(!t.parent||!t.parent.children)return[];const n=C(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.getNodePath=C;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const n=Object.create(null);for(let r of t.children){const c=r.children[1];c&&(n[r.children[0].value]=b(c))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function p(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.contains=p;function E(t,n,r=!1){if(p(t,n,r)){const c=t.children;if(Array.isArray(c))for(let s=0;s<c.length&&c[s].offset<=n;s++){const l=E(c[s],n,r);if(l)return l}return t}}e.findNodeAtOffset=E;function m(t,n,r=R.DEFAULT){const c=O(t,!1);function s(K){return K?()=>K(c.getTokenOffset(),c.getTokenLength()):()=>!0}function l(K){return K?te=>K(te,c.getTokenOffset(),c.getTokenLength()):()=>!0}const d=s(n.onObjectBegin),f=l(n.onObjectProperty),y=s(n.onObjectEnd),u=s(n.onArrayBegin),P=s(n.onArrayEnd),_=l(n.onLiteralValue),z=l(n.onSeparator),j=s(n.onComment),W=l(n.onError),q=r&&r.disallowComments,x=r&&r.allowTrailingComma;function B(){for(;;){const K=c.scan();switch(c.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:q||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(K){case 12:case 13:q?M(10):j();break;case 16:M(1);break;case 15:case 14:break;default:return K}}}function M(K,te=[],X=[]){if(W(K),te.length+X.length>0){let ie=c.getToken();for(;ie!==17;){if(te.indexOf(ie)!==-1){B();break}else if(X.indexOf(ie)!==-1)break;ie=B()}}}function F(K){const te=c.getTokenValue();return K?_(te):f(te),B(),!0}function T(){switch(c.getToken()){case 11:let K=0;try{K=JSON.parse(c.getTokenValue()),typeof K!="number"&&(M(2),K=0)}catch(te){M(2)}_(K);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return B(),!0}function U(){return c.getToken()!==10?(M(3,[],[2,5]),!1):(F(!1),c.getToken()===6?(z(":"),B(),H()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function N(){d(),B();let K=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(K||M(4,[],[]),z(","),B(),c.getToken()===2&&x)break}else K&&M(6,[],[]);U()||M(4,[],[2,5]),K=!0}return y(),c.getToken()!==2?M(7,[2],[]):B(),!0}function $(){u(),B();let K=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(K||M(4,[],[]),z(","),B(),c.getToken()===4&&x)break}else K&&M(6,[],[]);H()||M(4,[],[4,5]),K=!0}return P(),c.getToken()!==4?M(8,[4],[]):B(),!0}function H(){switch(c.getToken()){case 3:return $();case 1:return N();case 10:return F(!0);default:return T()}}return B(),c.getToken()===17?r.allowEmptyContent?!0:(M(4,[],[]),!1):H()?(c.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=m;function o(t,n){let r=O(t),c=[],s,l=0,d;do switch(d=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:l!==d&&c.push(t.substring(l,d)),n!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,n)),l=r.getPosition();break}while(s!==17);return c.join("")}e.stripComments=o;function i(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=i}),define(Q[46],Z([0,1,32]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function A(g,S,I){let h,w,D,a,C;if(S){for(a=S.offset,C=a+S.length,D=a;D>0&&!L(g,D-1);)D--;let l=C;for(;l<g.length&&!L(g,l);)l++;w=g.substring(D,l),h=R(w,I)}else w=g,h=0,D=0,a=0,C=g.length;const b=O(I,g);let p=!1,E=0,m;I.insertSpaces?m=k(" ",I.tabSize||4):m="	";const o=(0,v.createScanner)(w,!1);let i=!1;function t(){return b+k(m,h+E)}function n(){let l=o.scan();for(p=!1;l===15||l===14;)p=p||l===14,l=o.scan();return i=l===16||o.getTokenError()!==0,l}const r=[];function c(l,d,f){!i&&d<C&&f>a&&g.substring(d,f)!==l&&r.push({offset:d,length:f-d,content:l})}let s=n();if(s!==17){const l=o.getTokenOffset()+D,d=k(m,h);c(d,D,l)}for(;s!==17;){let l=o.getTokenOffset()+o.getTokenLength()+D,d=n(),f="";for(;!p&&(d===12||d===13);){const u=o.getTokenOffset()+D;c(" ",l,u),l=o.getTokenOffset()+o.getTokenLength()+D,f=d===12?t():"",d=n()}if(d===2)s!==1&&(E--,f=t());else if(d===4)s!==3&&(E--,f=t());else{switch(s){case 3:case 1:E++,f=t();break;case 5:case 12:f=t();break;case 13:p?f=t():f=" ";break;case 6:f=" ";break;case 10:if(d===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?f=" ":d!==5&&d!==17&&(i=!0);break;case 16:i=!0;break}p&&(d===12||d===13)&&(f=t())}const y=o.getTokenOffset()+D;c(f,l,y),s=d}return r}e.format=A;function k(g,S){let I="";for(let h=0;h<S;h++)I+=g;return I}function R(g,S){let I=0,h=0;const w=S.tabSize||4;for(;I<g.length;){const D=g.charAt(I);if(D===" ")h++;else if(D==="	")h+=w;else break;I++}return Math.floor(h/w)}function O(g,S){for(let I=0;I<S.length;I++){const h=S.charAt(I);if(h==="\r")return I+1<S.length&&S.charAt(I+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return g&&g.eol||`
`}e.getEOL=O;function L(g,S){return`\r
`.indexOf(g.charAt(S))!==-1}e.isEOL=L}),define(Q[41],Z([0,1,32,46]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(S,I,h){return R(S,I,void 0,h)}e.removeProperty=k;function R(S,I,h,w,D){const a=I.slice(),C=[],b=(0,v.parseTree)(S,C);let p,E;for(;a.length>0&&(E=a.pop(),p=(0,v.findNodeAtLocation)(b,a),p===void 0&&h!==void 0);)typeof E=="string"?h={[E]:h}:h=[h];if(p)if(p.type==="object"&&typeof E=="string"&&Array.isArray(p.children)){const m=(0,v.findNodeAtLocation)(p,[E]);if(m!==void 0)if(h===void 0){if(!m.parent)throw new Error("Malformed AST");const o=p.children.indexOf(m.parent);let i,t=m.parent.offset+m.parent.length;if(o>0){const n=p.children[o-1];i=n.offset+n.length}else i=p.offset+1,p.children.length>1&&(t=p.children[1].offset);return O(S,{offset:i,length:t-i,content:""},w)}else return O(S,{offset:m.offset,length:m.length,content:JSON.stringify(h)},w);else{if(h===void 0)return[];const o=`${JSON.stringify(E)}: ${JSON.stringify(h)}`,i=D?D(p.children.map(n=>n.children[0].value)):p.children.length;let t;if(i>0){const n=p.children[i-1];t={offset:n.offset+n.length,length:0,content:","+o}}else p.children.length===0?t={offset:p.offset+1,length:0,content:o}:t={offset:p.offset+1,length:0,content:o+","};return O(S,t,w)}}else if(p.type==="array"&&typeof E=="number"&&Array.isArray(p.children))if(h!==void 0){const m=`${JSON.stringify(h)}`;let o;if(p.children.length===0||E===0)o={offset:p.offset+1,length:0,content:p.children.length===0?m:m+","};else{const i=E===-1||E>p.children.length?p.children.length:E,t=p.children[i-1];o={offset:t.offset+t.length,length:0,content:","+m}}return O(S,o,w)}else{const m=E,o=p.children[m];let i;if(p.children.length===1)i={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===m){const t=p.children[m-1],n=t.offset+t.length,r=p.offset+p.length;i={offset:n,length:r-2-n,content:""}}else i={offset:o.offset,length:p.children[m+1].offset-o.offset,content:""};return O(S,i,w)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${p.type}`);else{if(h===void 0)throw new Error("Can not delete in empty document");return O(S,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(h)},w)}}e.setProperty=R;function O(S,I,h){let w=L(S,I),D=I.offset,a=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;D>0&&!(0,A.isEOL)(w,D-1);)D--;for(;a<w.length&&!(0,A.isEOL)(w,a);)a++}const C=(0,A.format)(w,{offset:D,length:a-D},h);for(let p=C.length-1;p>=0;p--){const E=C[p];w=L(w,E),D=Math.min(D,E.offset),a=Math.max(a,E.offset+E.length),a+=E.content.length-E.length}const b=S.length-(w.length-a)-D;return[{offset:D,length:b,content:w.substring(D,a)}]}e.withFormatting=O;function L(S,I){return S.substring(0,I.offset)+I.content+S.substring(I.offset+I.length)}e.applyEdit=L;function g(S,I){let h=I.slice(0).sort((D,a)=>{const C=D.offset-a.offset;return C===0?D.length-a.length:C}),w=S.length;for(let D=h.length-1;D>=0;D--){let a=h[D];if(a.offset+a.length<=w)S=L(S,a);else throw new Error("Overlapping edit");w=a.offset}return S}e.applyEdits=g}),define(Q[2],Z([0,1,63,52]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const k=!1;let R=null;function O(m){R=m}if(e.setDisposableTracker=O,k){const m="__is_disposable_tracked__";R=new class{trackDisposable(o){const i=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[m]||console.log(i)},3e3)}markTracked(o){if(o&&o!==C.None)try{o[m]=!0}catch(i){}}}}function L(m){!R||R.markTracked(m)}function g(m){return R&&R.trackDisposable(m),m}e.trackDisposable=g;class S extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=S;function I(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=I;function h(m){if(A.Iterable.is(m)){let o=[];for(const i of m)if(i){L(i);try{i.dispose()}catch(t){o.push(t)}}if(o.length===1)throw o[0];if(o.length>1)throw new S(o);return Array.isArray(m)?[]:m}else if(m)return L(m),m.dispose(),m}e.dispose=h;function w(...m){return m.forEach(L),D(()=>h(m))}e.combinedDisposable=w;function D(m){const o=g({dispose:()=>{L(o),m()}});return o}e.toDisposable=D;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(L(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return L(o),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new a,g(this)}dispose(){L(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class b{constructor(){this._isDisposed=!1,g(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var i;this._isDisposed||o===this._value||((i=this._value)===null||i===void 0||i.dispose(),o&&L(o),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,L(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}e.MutableDisposable=b;class p{constructor(){this.references=new Map}acquire(o,...i){let t=this.references.get(o);t||(t={counter:0,object:this.createReferencedObject(o,...i)},this.references.set(o,t));const{object:n}=t,r=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(o,t.object),this.references.delete(o))});return t.counter++,{object:n,dispose:r}}}e.ReferenceCollection=p;class E{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=E}),define(Q[64],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(R){this.element=R,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class A{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,O){const L=new v(R);if(this._first===v.Undefined)this._first=L,this._last=L;else if(O){const S=this._last;this._last=L,L.prev=S,S.next=L}else{const S=this._first;this._first=L,L.next=S,S.prev=L}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(L))}}shift(){if(this._first!==v.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==v.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==v.Undefined&&R.next!==v.Undefined){const O=R.prev;O.next=R.next,R.next.prev=O}else R.prev===v.Undefined&&R.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):R.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):R.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==v.Undefined;)yield R.element,R=R.next}}e.LinkedList=A});"use strict";(function(){function G(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function O(g){R.push(g,Date.now())}function L(){const g=[];for(let S=0;S<R.length;S+=2)g.push({name:R[S],startTime:R[S+1]});return g}return{mark:O,getMarks:L}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const O of performance.getEntriesByType("mark"))R.push({name:O.name,startTime:Math.round(k+O.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=v(A))})(),define(Q[7],Z([0,1]),function(G,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const A="en";let k=!1,R=!1,O=!1,L=!1,g=!1,S=!1,I=!1,h,w=A,D,a;const C=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof process!="undefined"?b=process:typeof C.vscode!="undefined"&&(b=C.vscode.process);const p=typeof((v=b==null?void 0:b.versions)===null||v===void 0?void 0:v.electron)=="string"&&b.type==="renderer";if(e.isElectronSandboxed=p&&(b==null?void 0:b.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=b==null?void 0:b.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p)a=navigator.userAgent,k=a.indexOf("Windows")>=0,R=a.indexOf("Macintosh")>=0,I=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=a.indexOf("Linux")>=0,S=!0,h=navigator.language,w=h;else if(typeof b=="object"){k=b.platform==="win32",R=b.platform==="darwin",O=b.platform==="linux",L=O&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,h=A,w=A;const s=b.env.VSCODE_NLS_CONFIG;if(s)try{const l=JSON.parse(s),d=l.availableLanguages["*"];h=l.locale,w=d||A,D=l._translationsConfigFile}catch(l){}g=!0}else console.error("Unable to resolve platform.");var E;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function m(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let o=0;R?o=1:k?o=3:O&&(o=2),e.isWindows=k,e.isMacintosh=R,e.isLinux=O,e.isLinuxSnap=L,e.isNative=g,e.isWeb=S,e.isIOS=I,e.platform=o,e.userAgent=a,e.language=w;var i;(function(s){function l(){return e.language}s.value=l;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=d;function f(){return e.language==="en"}s.isDefault=f})(i=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=D,e.globals=C,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let d=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeSetImmediateId)for(let u=0,P=d.length;u<P;u++){const _=d[u];if(_.id===y.data.vscodeSetImmediateId){d.splice(u,1),_.callback();return}}});let f=0;return y=>{const u=++f;d.push({id:u,callback:y}),e.globals.postMessage({vscodeSetImmediateId:u},"*")}}if(b&&typeof b.nextTick=="function")return b.nextTick.bind(b);const l=Promise.resolve();return d=>l.then(d)}();var t;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||I?2:k?1:3;let n=!0,r=!1;function c(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,n=new Uint16Array(s.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=c}),define(Q[53],Z([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let A;typeof process!="undefined"?A=process:typeof v.globals.vscode!="undefined"?A={get platform(){return v.globals.vscode.process.platform},get env(){return v.globals.vscode.process.env},nextTick(k){return(0,v.setImmediate)(k)},cwd(){return v.globals.vscode.process.env.VSCODE_CWD||v.globals.vscode.process.execPath.substr(0,v.globals.vscode.process.execPath.lastIndexOf(v.globals.vscode.process.platform==="win32"?"\\":"/"))}}:A={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(k){return(0,v.setImmediate)(k)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.nextTick=A.nextTick}),define(Q[8],Z([0,1,53]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,k=97,R=90,O=122,L=46,g=47,S=92,I=58,h=63;class w extends Error{constructor(o,i,t){let n;typeof i=="string"&&i.indexOf("not ")===0?(n="must not be",i=i.replace(/^not /,"")):n="must be";const r=o.indexOf(".")!==-1?"property":"argument";let c=`The "${o}" ${r} ${n} of type ${i}`;c+=`. Received type ${typeof t}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function D(m,o){if(typeof m!="string")throw new w(o,"string",m)}function a(m){return m===g||m===S}function C(m){return m===g}function b(m){return m>=A&&m<=R||m>=k&&m<=O}function p(m,o,i,t){let n="",r=0,c=-1,s=0,l=0;for(let d=0;d<=m.length;++d){if(d<m.length)l=m.charCodeAt(d);else{if(t(l))break;l=g}if(t(l)){if(!(c===d-1||s===1))if(s===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==L||n.charCodeAt(n.length-2)!==L){if(n.length>2){const f=n.lastIndexOf(i);f===-1?(n="",r=0):(n=n.slice(0,f),r=n.length-1-n.lastIndexOf(i)),c=d,s=0;continue}else if(n.length!==0){n="",r=0,c=d,s=0;continue}}o&&(n+=n.length>0?`${i}..`:"..",r=2)}else n.length>0?n+=`${i}${m.slice(c+1,d)}`:n=m.slice(c+1,d),r=d-c-1;c=d,s=0}else l===L&&s!==-1?++s:s=-1}return n}function E(m,o){if(o===null||typeof o!="object")throw new w("pathObject","Object",o);const i=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return i?i===o.root?`${i}${t}`:`${i}${m}${t}`:t}e.win32={resolve(...m){let o="",i="",t=!1;for(let n=m.length-1;n>=-1;n--){let r;if(n>=0){if(r=m[n],D(r,"path"),r.length===0)continue}else o.length===0?r=v.cwd():(r=v.env[`=${o}`]||v.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===S)&&(r=`${o}\\`));const c=r.length;let s=0,l="",d=!1;const f=r.charCodeAt(0);if(c===1)a(f)&&(s=1,d=!0);else if(a(f))if(d=!0,a(r.charCodeAt(1))){let y=2,u=y;for(;y<c&&!a(r.charCodeAt(y));)y++;if(y<c&&y!==u){const P=r.slice(u,y);for(u=y;y<c&&a(r.charCodeAt(y));)y++;if(y<c&&y!==u){for(u=y;y<c&&!a(r.charCodeAt(y));)y++;(y===c||y!==u)&&(l=`\\\\${P}\\${r.slice(u,y)}`,s=y)}}}else s=1;else b(f)&&r.charCodeAt(1)===I&&(l=r.slice(0,2),s=2,c>2&&a(r.charCodeAt(2))&&(d=!0,s=3));if(l.length>0)if(o.length>0){if(l.toLowerCase()!==o.toLowerCase())continue}else o=l;if(t){if(o.length>0)break}else if(i=`${r.slice(s)}\\${i}`,t=d,d&&o.length>0)break}return i=p(i,!t,"\\",a),t?`${o}\\${i}`:`${o}${i}`||"."},normalize(m){D(m,"path");const o=m.length;if(o===0)return".";let i=0,t,n=!1;const r=m.charCodeAt(0);if(o===1)return C(r)?"\\":m;if(a(r))if(n=!0,a(m.charCodeAt(1))){let s=2,l=s;for(;s<o&&!a(m.charCodeAt(s));)s++;if(s<o&&s!==l){const d=m.slice(l,s);for(l=s;s<o&&a(m.charCodeAt(s));)s++;if(s<o&&s!==l){for(l=s;s<o&&!a(m.charCodeAt(s));)s++;if(s===o)return`\\\\${d}\\${m.slice(l)}\\`;s!==l&&(t=`\\\\${d}\\${m.slice(l,s)}`,i=s)}}}else i=1;else b(r)&&m.charCodeAt(1)===I&&(t=m.slice(0,2),i=2,o>2&&a(m.charCodeAt(2))&&(n=!0,i=3));let c=i<o?p(m.slice(i),!n,"\\",a):"";return c.length===0&&!n&&(c="."),c.length>0&&a(m.charCodeAt(o-1))&&(c+="\\"),t===void 0?n?`\\${c}`:c:n?`${t}\\${c}`:`${t}${c}`},isAbsolute(m){D(m,"path");const o=m.length;if(o===0)return!1;const i=m.charCodeAt(0);return a(i)||o>2&&b(i)&&m.charCodeAt(1)===I&&a(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let o,i;for(let r=0;r<m.length;++r){const c=m[r];D(c,"path"),c.length>0&&(o===void 0?o=i=c:o+=`\\${c}`)}if(o===void 0)return".";let t=!0,n=0;if(typeof i=="string"&&a(i.charCodeAt(0))){++n;const r=i.length;r>1&&a(i.charCodeAt(1))&&(++n,r>2&&(a(i.charCodeAt(2))?++n:t=!1))}if(t){for(;n<o.length&&a(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.win32.normalize(o)},relative(m,o){if(D(m,"from"),D(o,"to"),m===o)return"";const i=e.win32.resolve(m),t=e.win32.resolve(o);if(i===t||(m=i.toLowerCase(),o=t.toLowerCase(),m===o))return"";let n=0;for(;n<m.length&&m.charCodeAt(n)===S;)n++;let r=m.length;for(;r-1>n&&m.charCodeAt(r-1)===S;)r--;const c=r-n;let s=0;for(;s<o.length&&o.charCodeAt(s)===S;)s++;let l=o.length;for(;l-1>s&&o.charCodeAt(l-1)===S;)l--;const d=l-s,f=c<d?c:d;let y=-1,u=0;for(;u<f;u++){const _=m.charCodeAt(n+u);if(_!==o.charCodeAt(s+u))break;_===S&&(y=u)}if(u!==f){if(y===-1)return t}else{if(d>f){if(o.charCodeAt(s+u)===S)return t.slice(s+u+1);if(u===2)return t.slice(s+u)}c>f&&(m.charCodeAt(n+u)===S?y=u:u===2&&(y=3)),y===-1&&(y=0)}let P="";for(u=n+y+1;u<=r;++u)(u===r||m.charCodeAt(u)===S)&&(P+=P.length===0?"..":"\\..");return s+=y,P.length>0?`${P}${t.slice(s,l)}`:(t.charCodeAt(s)===S&&++s,t.slice(s,l))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const o=e.win32.resolve(m);if(o.length<=2)return m;if(o.charCodeAt(0)===S){if(o.charCodeAt(1)===S){const i=o.charCodeAt(2);if(i!==h&&i!==L)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(b(o.charCodeAt(0))&&o.charCodeAt(1)===I&&o.charCodeAt(2)===S)return`\\\\?\\${o}`;return m},dirname(m){D(m,"path");const o=m.length;if(o===0)return".";let i=-1,t=0;const n=m.charCodeAt(0);if(o===1)return a(n)?m:".";if(a(n)){if(i=t=1,a(m.charCodeAt(1))){let s=2,l=s;for(;s<o&&!a(m.charCodeAt(s));)s++;if(s<o&&s!==l){for(l=s;s<o&&a(m.charCodeAt(s));)s++;if(s<o&&s!==l){for(l=s;s<o&&!a(m.charCodeAt(s));)s++;if(s===o)return m;s!==l&&(i=t=s+1)}}}}else b(n)&&m.charCodeAt(1)===I&&(i=o>2&&a(m.charCodeAt(2))?3:2,t=i);let r=-1,c=!0;for(let s=o-1;s>=t;--s)if(a(m.charCodeAt(s))){if(!c){r=s;break}}else c=!1;if(r===-1){if(i===-1)return".";r=i}return m.slice(0,r)},basename(m,o){o!==void 0&&D(o,"ext"),D(m,"path");let i=0,t=-1,n=!0,r;if(m.length>=2&&b(m.charCodeAt(0))&&m.charCodeAt(1)===I&&(i=2),o!==void 0&&o.length>0&&o.length<=m.length){if(o===m)return"";let c=o.length-1,s=-1;for(r=m.length-1;r>=i;--r){const l=m.charCodeAt(r);if(a(l)){if(!n){i=r+1;break}}else s===-1&&(n=!1,s=r+1),c>=0&&(l===o.charCodeAt(c)?--c==-1&&(t=r):(c=-1,t=s))}return i===t?t=s:t===-1&&(t=m.length),m.slice(i,t)}for(r=m.length-1;r>=i;--r)if(a(m.charCodeAt(r))){if(!n){i=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":m.slice(i,t)},extname(m){D(m,"path");let o=0,i=-1,t=0,n=-1,r=!0,c=0;m.length>=2&&m.charCodeAt(1)===I&&b(m.charCodeAt(0))&&(o=t=2);for(let s=m.length-1;s>=o;--s){const l=m.charCodeAt(s);if(a(l)){if(!r){t=s+1;break}continue}n===-1&&(r=!1,n=s+1),l===L?i===-1?i=s:c!==1&&(c=1):i!==-1&&(c=-1)}return i===-1||n===-1||c===0||c===1&&i===n-1&&i===t+1?"":m.slice(i,n)},format:E.bind(null,"\\"),parse(m){D(m,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return o;const i=m.length;let t=0,n=m.charCodeAt(0);if(i===1)return a(n)?(o.root=o.dir=m,o):(o.base=o.name=m,o);if(a(n)){if(t=1,a(m.charCodeAt(1))){let y=2,u=y;for(;y<i&&!a(m.charCodeAt(y));)y++;if(y<i&&y!==u){for(u=y;y<i&&a(m.charCodeAt(y));)y++;if(y<i&&y!==u){for(u=y;y<i&&!a(m.charCodeAt(y));)y++;y===i?t=y:y!==u&&(t=y+1)}}}}else if(b(n)&&m.charCodeAt(1)===I){if(i<=2)return o.root=o.dir=m,o;if(t=2,a(m.charCodeAt(2))){if(i===3)return o.root=o.dir=m,o;t=3}}t>0&&(o.root=m.slice(0,t));let r=-1,c=t,s=-1,l=!0,d=m.length-1,f=0;for(;d>=t;--d){if(n=m.charCodeAt(d),a(n)){if(!l){c=d+1;break}continue}s===-1&&(l=!1,s=d+1),n===L?r===-1?r=d:f!==1&&(f=1):r!==-1&&(f=-1)}return s!==-1&&(r===-1||f===0||f===1&&r===s-1&&r===c+1?o.base=o.name=m.slice(c,s):(o.name=m.slice(c,r),o.base=m.slice(c,s),o.ext=m.slice(r,s))),c>0&&c!==t?o.dir=m.slice(0,c-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let o="",i=!1;for(let t=m.length-1;t>=-1&&!i;t--){const n=t>=0?m[t]:v.cwd();D(n,"path"),n.length!==0&&(o=`${n}/${o}`,i=n.charCodeAt(0)===g)}return o=p(o,!i,"/",C),i?`/${o}`:o.length>0?o:"."},normalize(m){if(D(m,"path"),m.length===0)return".";const o=m.charCodeAt(0)===g,i=m.charCodeAt(m.length-1)===g;return m=p(m,!o,"/",C),m.length===0?o?"/":i?"./":".":(i&&(m+="/"),o?`/${m}`:m)},isAbsolute(m){return D(m,"path"),m.length>0&&m.charCodeAt(0)===g},join(...m){if(m.length===0)return".";let o;for(let i=0;i<m.length;++i){const t=m[i];D(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(m,o){if(D(m,"from"),D(o,"to"),m===o||(m=e.posix.resolve(m),o=e.posix.resolve(o),m===o))return"";const i=1,t=m.length,n=t-i,r=1,c=o.length-r,s=n<c?n:c;let l=-1,d=0;for(;d<s;d++){const y=m.charCodeAt(i+d);if(y!==o.charCodeAt(r+d))break;y===g&&(l=d)}if(d===s)if(c>s){if(o.charCodeAt(r+d)===g)return o.slice(r+d+1);if(d===0)return o.slice(r+d)}else n>s&&(m.charCodeAt(i+d)===g?l=d:d===0&&(l=0));let f="";for(d=i+l+1;d<=t;++d)(d===t||m.charCodeAt(d)===g)&&(f+=f.length===0?"..":"/..");return`${f}${o.slice(r+l)}`},toNamespacedPath(m){return m},dirname(m){if(D(m,"path"),m.length===0)return".";const o=m.charCodeAt(0)===g;let i=-1,t=!0;for(let n=m.length-1;n>=1;--n)if(m.charCodeAt(n)===g){if(!t){i=n;break}}else t=!1;return i===-1?o?"/":".":o&&i===1?"//":m.slice(0,i)},basename(m,o){o!==void 0&&D(o,"ext"),D(m,"path");let i=0,t=-1,n=!0,r;if(o!==void 0&&o.length>0&&o.length<=m.length){if(o===m)return"";let c=o.length-1,s=-1;for(r=m.length-1;r>=0;--r){const l=m.charCodeAt(r);if(l===g){if(!n){i=r+1;break}}else s===-1&&(n=!1,s=r+1),c>=0&&(l===o.charCodeAt(c)?--c==-1&&(t=r):(c=-1,t=s))}return i===t?t=s:t===-1&&(t=m.length),m.slice(i,t)}for(r=m.length-1;r>=0;--r)if(m.charCodeAt(r)===g){if(!n){i=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":m.slice(i,t)},extname(m){D(m,"path");let o=-1,i=0,t=-1,n=!0,r=0;for(let c=m.length-1;c>=0;--c){const s=m.charCodeAt(c);if(s===g){if(!n){i=c+1;break}continue}t===-1&&(n=!1,t=c+1),s===L?o===-1?o=c:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||t===-1||r===0||r===1&&o===t-1&&o===i+1?"":m.slice(o,t)},format:E.bind(null,"/"),parse(m){D(m,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return o;const i=m.charCodeAt(0)===g;let t;i?(o.root="/",t=1):t=0;let n=-1,r=0,c=-1,s=!0,l=m.length-1,d=0;for(;l>=t;--l){const f=m.charCodeAt(l);if(f===g){if(!s){r=l+1;break}continue}c===-1&&(s=!1,c=l+1),f===L?n===-1?n=l:d!==1&&(d=1):n!==-1&&(d=-1)}if(c!==-1){const f=r===0&&i?1:r;n===-1||d===0||d===1&&n===c-1&&n===r+1?o.base=o.name=m.slice(f,c):(o.name=m.slice(f,n),o.base=m.slice(f,c),o.ext=m.slice(n,c))}return r>0?o.dir=m.slice(0,r-1):i&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var A in v)(typeof exports=="object"?exports:G)[A]=v[A]}}(typeof self!="undefined"?self:this,function(){return function(G){var e={};function v(A){if(e[A])return e[A].exports;var k=e[A]={i:A,l:!1,exports:{}};return G[A].call(k.exports,k,k.exports,v),k.l=!0,k.exports}return v.m=G,v.c=e,v.d=function(A,k,R){v.o(A,k)||Object.defineProperty(A,k,{enumerable:!0,get:R})},v.r=function(A){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},v.t=function(A,k){if(1&k&&(A=v(A)),8&k||4&k&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(v.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&k&&typeof A!="string")for(var O in A)v.d(R,O,function(L){return A[L]}.bind(null,O));return R},v.n=function(A){var k=A&&A.__esModule?function(){return A.default}:function(){return A};return v.d(k,"a",k),k},v.o=function(A,k){return Object.prototype.hasOwnProperty.call(A,k)},v.p="",v(v.s=0)}([function(G,e,v){(function(A){var k;e=G.exports=X,k=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,L=e.re=[],g=e.src=[],S=0,I=S++;g[I]="0|[1-9]\\d*";var h=S++;g[h]="[0-9]+";var w=S++;g[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=S++;g[D]="("+g[I]+")\\.("+g[I]+")\\.("+g[I]+")";var a=S++;g[a]="("+g[h]+")\\.("+g[h]+")\\.("+g[h]+")";var C=S++;g[C]="(?:"+g[I]+"|"+g[w]+")";var b=S++;g[b]="(?:"+g[h]+"|"+g[w]+")";var p=S++;g[p]="(?:-("+g[C]+"(?:\\."+g[C]+")*))";var E=S++;g[E]="(?:-?("+g[b]+"(?:\\."+g[b]+")*))";var m=S++;g[m]="[0-9A-Za-z-]+";var o=S++;g[o]="(?:\\+("+g[m]+"(?:\\."+g[m]+")*))";var i=S++,t="v?"+g[D]+g[p]+"?"+g[o]+"?";g[i]="^"+t+"$";var n="[v=\\s]*"+g[a]+g[E]+"?"+g[o]+"?",r=S++;g[r]="^"+n+"$";var c=S++;g[c]="((?:<|>)?=?)";var s=S++;g[s]=g[h]+"|x|X|\\*";var l=S++;g[l]=g[I]+"|x|X|\\*";var d=S++;g[d]="[v=\\s]*("+g[l]+")(?:\\.("+g[l]+")(?:\\.("+g[l]+")(?:"+g[p]+")?"+g[o]+"?)?)?";var f=S++;g[f]="[v=\\s]*("+g[s]+")(?:\\.("+g[s]+")(?:\\.("+g[s]+")(?:"+g[E]+")?"+g[o]+"?)?)?";var y=S++;g[y]="^"+g[c]+"\\s*"+g[d]+"$";var u=S++;g[u]="^"+g[c]+"\\s*"+g[f]+"$";var P=S++;g[P]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=S++;g[_]="(?:~>?)";var z=S++;g[z]="(\\s*)"+g[_]+"\\s+",L[z]=new RegExp(g[z],"g");var j=S++;g[j]="^"+g[_]+g[d]+"$";var W=S++;g[W]="^"+g[_]+g[f]+"$";var q=S++;g[q]="(?:\\^)";var x=S++;g[x]="(\\s*)"+g[q]+"\\s+",L[x]=new RegExp(g[x],"g");var B=S++;g[B]="^"+g[q]+g[d]+"$";var M=S++;g[M]="^"+g[q]+g[f]+"$";var F=S++;g[F]="^"+g[c]+"\\s*("+n+")$|^$";var T=S++;g[T]="^"+g[c]+"\\s*("+t+")$|^$";var U=S++;g[U]="(\\s*)"+g[c]+"\\s*("+n+"|"+g[d]+")",L[U]=new RegExp(g[U],"g");var N=S++;g[N]="^\\s*("+g[d]+")\\s+-\\s+("+g[d]+")\\s*$";var $=S++;g[$]="^\\s*("+g[f]+")\\s+-\\s+("+g[f]+")\\s*$";var H=S++;g[H]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)k(K,g[K]),L[K]||(L[K]=new RegExp(g[K]));function te(J,ne){if(J instanceof X)return J;if(typeof J!="string"||J.length>R||!(ne?L[r]:L[i]).test(J))return null;try{return new X(J,ne)}catch(re){return null}}function X(J,ne){if(J instanceof X){if(J.loose===ne)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof X))return new X(J,ne);k("SemVer",J,ne),this.loose=ne;var re=J.trim().match(ne?L[r]:L[i]);if(!re)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+re[1],this.minor=+re[2],this.patch=+re[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");re[4]?this.prerelease=re[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var V=+ge;if(V>=0&&V<O)return V}return ge}):this.prerelease=[],this.build=re[5]?re[5].split("."):[],this.format()}e.parse=te,e.valid=function(J,ne){var re=te(J,ne);return re?re.version:null},e.clean=function(J,ne){var re=te(J.trim().replace(/^[=v]+/,""),ne);return re?re.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(J){return k("SemVer.compare",this.version,this.loose,J),J instanceof X||(J=new X(J,this.loose)),this.compareMain(J)||this.comparePre(J)},X.prototype.compareMain=function(J){return J instanceof X||(J=new X(J,this.loose)),se(this.major,J.major)||se(this.minor,J.minor)||se(this.patch,J.patch)},X.prototype.comparePre=function(J){if(J instanceof X||(J=new X(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var ne=0;do{var re=this.prerelease[ne],ge=J.prerelease[ne];if(k("prerelease compare",ne,re,ge),re===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(re===void 0)return-1;if(re!==ge)return se(re,ge)}while(++ne)},X.prototype.inc=function(J,ne){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ne);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ne);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ne),this.inc("pre",ne);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ne),this.inc("pre",ne);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var re=this.prerelease.length;--re>=0;)typeof this.prerelease[re]=="number"&&(this.prerelease[re]++,re=-2);re===-1&&this.prerelease.push(0)}ne&&(this.prerelease[0]===ne?isNaN(this.prerelease[1])&&(this.prerelease=[ne,0]):this.prerelease=[ne,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,ne,re,ge){typeof re=="string"&&(ge=re,re=void 0);try{return new X(J,re).inc(ne,ge).version}catch(V){return null}},e.diff=function(J,ne){if(we(J,ne))return null;var re=te(J),ge=te(ne);if(re.prerelease.length||ge.prerelease.length){for(var V in re)if((V==="major"||V==="minor"||V==="patch")&&re[V]!==ge[V])return"pre"+V;return"prerelease"}for(var V in re)if((V==="major"||V==="minor"||V==="patch")&&re[V]!==ge[V])return V},e.compareIdentifiers=se;var ie=/^[0-9]+$/;function se(J,ne){var re=ie.test(J),ge=ie.test(ne);return re&&ge&&(J=+J,ne=+ne),re&&!ge?-1:ge&&!re?1:J<ne?-1:J>ne?1:0}function ce(J,ne,re){return new X(J,re).compare(new X(ne,re))}function he(J,ne,re){return ce(J,ne,re)>0}function me(J,ne,re){return ce(J,ne,re)<0}function we(J,ne,re){return ce(J,ne,re)===0}function Ie(J,ne,re){return ce(J,ne,re)!==0}function Te(J,ne,re){return ce(J,ne,re)>=0}function ke(J,ne,re){return ce(J,ne,re)<=0}function Fe(J,ne,re,ge){var V;switch(ne){case"===":typeof J=="object"&&(J=J.version),typeof re=="object"&&(re=re.version),V=J===re;break;case"!==":typeof J=="object"&&(J=J.version),typeof re=="object"&&(re=re.version),V=J!==re;break;case"":case"=":case"==":V=we(J,re,ge);break;case"!=":V=Ie(J,re,ge);break;case">":V=he(J,re,ge);break;case">=":V=Te(J,re,ge);break;case"<":V=me(J,re,ge);break;case"<=":V=ke(J,re,ge);break;default:throw new TypeError("Invalid operator: "+ne)}return V}function Ue(J,ne){if(J instanceof Ue){if(J.loose===ne)return J;J=J.value}if(!(this instanceof Ue))return new Ue(J,ne);k("comparator",J,ne),this.loose=ne,this.parse(J),this.semver===Me?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(J,ne){return se(ne,J)},e.major=function(J,ne){return new X(J,ne).major},e.minor=function(J,ne){return new X(J,ne).minor},e.patch=function(J,ne){return new X(J,ne).patch},e.compare=ce,e.compareLoose=function(J,ne){return ce(J,ne,!0)},e.rcompare=function(J,ne,re){return ce(ne,J,re)},e.sort=function(J,ne){return J.sort(function(re,ge){return e.compare(re,ge,ne)})},e.rsort=function(J,ne){return J.sort(function(re,ge){return e.rcompare(re,ge,ne)})},e.gt=he,e.lt=me,e.eq=we,e.neq=Ie,e.gte=Te,e.lte=ke,e.cmp=Fe,e.Comparator=Ue;var Me={};function De(J,ne){if(J instanceof De)return J.loose===ne?J:new De(J.raw,ne);if(J instanceof Ue)return new De(J.value,ne);if(!(this instanceof De))return new De(J,ne);if(this.loose=ne,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(re){return this.parseRange(re.trim())},this).filter(function(re){return re.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ae(J){return!J||J.toLowerCase()==="x"||J==="*"}function $e(J,ne,re,ge,V,ee,oe,ae,le,de,ve,ye,Ee){return((ne=Ae(re)?"":Ae(ge)?">="+re+".0.0":Ae(V)?">="+re+"."+ge+".0":">="+ne)+" "+(ae=Ae(le)?"":Ae(de)?"<"+(+le+1)+".0.0":Ae(ve)?"<"+le+"."+(+de+1)+".0":ye?"<="+le+"."+de+"."+ve+"-"+ye:"<="+ae)).trim()}function He(J,ne){for(var re=0;re<J.length;re++)if(!J[re].test(ne))return!1;if(ne.prerelease.length){for(re=0;re<J.length;re++)if(k(J[re].semver),J[re].semver!==Me&&J[re].semver.prerelease.length>0){var ge=J[re].semver;if(ge.major===ne.major&&ge.minor===ne.minor&&ge.patch===ne.patch)return!0}return!1}return!0}function Ne(J,ne,re){try{ne=new De(ne,re)}catch(ge){return!1}return ne.test(J)}function ze(J,ne,re,ge){var V,ee,oe,ae,le;switch(J=new X(J,ge),ne=new De(ne,ge),re){case">":V=he,ee=ke,oe=me,ae=">",le=">=";break;case"<":V=me,ee=Te,oe=he,ae="<",le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(J,ne,ge))return!1;for(var de=0;de<ne.set.length;++de){var ve=ne.set[de],ye=null,Ee=null;if(ve.forEach(function(be){be.semver===Me&&(be=new Ue(">=0.0.0")),ye=ye||be,Ee=Ee||be,V(be.semver,ye.semver,ge)?ye=be:oe(be.semver,Ee.semver,ge)&&(Ee=be)}),ye.operator===ae||ye.operator===le||(!Ee.operator||Ee.operator===ae)&&ee(J,Ee.semver)||Ee.operator===le&&oe(J,Ee.semver))return!1}return!0}Ue.prototype.parse=function(J){var ne=this.loose?L[F]:L[T],re=J.match(ne);if(!re)throw new TypeError("Invalid comparator: "+J);this.operator=re[1],this.operator==="="&&(this.operator=""),re[2]?this.semver=new X(re[2],this.loose):this.semver=Me},Ue.prototype.toString=function(){return this.value},Ue.prototype.test=function(J){return k("Comparator.test",J,this.loose),this.semver===Me||(typeof J=="string"&&(J=new X(J,this.loose)),Fe(J,this.operator,this.semver,this.loose))},Ue.prototype.intersects=function(J,ne){if(!(J instanceof Ue))throw new TypeError("a Comparator is required");var re;if(this.operator==="")return re=new De(J.value,ne),Ne(this.value,re,ne);if(J.operator==="")return re=new De(this.value,ne),Ne(J.semver,re,ne);var ge=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),V=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),ee=this.semver.version===J.semver.version,oe=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),ae=Fe(this.semver,"<",J.semver,ne)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),le=Fe(this.semver,">",J.semver,ne)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return ge||V||ee&&oe||ae||le},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(J){var ne=this.loose;J=J.trim(),k("range",J,ne);var re=ne?L[$]:L[N];J=J.replace(re,$e),k("hyphen replace",J),J=J.replace(L[U],"$1$2$3"),k("comparator trim",J,L[U]),J=(J=(J=J.replace(L[z],"$1~")).replace(L[x],"$1^")).split(/\s+/).join(" ");var ge=ne?L[F]:L[T],V=J.split(" ").map(function(ee){return function(oe,ae){return k("comp",oe),oe=function(le,de){return le.trim().split(/\s+/).map(function(ve){return function(ye,Ee){k("caret",ye,Ee);var be=Ee?L[M]:L[B];return ye.replace(be,function(Pe,Se,pe,Ce,Re){var Oe;return k("caret",ye,Pe,Se,pe,Ce,Re),Ae(Se)?Oe="":Ae(pe)?Oe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ae(Ce)?Oe=Se==="0"?">="+Se+"."+pe+".0 <"+Se+"."+(+pe+1)+".0":">="+Se+"."+pe+".0 <"+(+Se+1)+".0.0":Re?(k("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Oe=Se==="0"?pe==="0"?">="+Se+"."+pe+"."+Ce+Re+" <"+Se+"."+pe+"."+(+Ce+1):">="+Se+"."+pe+"."+Ce+Re+" <"+Se+"."+(+pe+1)+".0":">="+Se+"."+pe+"."+Ce+Re+" <"+(+Se+1)+".0.0"):(k("no pr"),Oe=Se==="0"?pe==="0"?">="+Se+"."+pe+"."+Ce+" <"+Se+"."+pe+"."+(+Ce+1):">="+Se+"."+pe+"."+Ce+" <"+Se+"."+(+pe+1)+".0":">="+Se+"."+pe+"."+Ce+" <"+(+Se+1)+".0.0"),k("caret return",Oe),Oe})}(ve,de)}).join(" ")}(oe,ae),k("caret",oe),oe=function(le,de){return le.trim().split(/\s+/).map(function(ve){return function(ye,Ee){var be=Ee?L[W]:L[j];return ye.replace(be,function(Pe,Se,pe,Ce,Re){var Oe;return k("tilde",ye,Pe,Se,pe,Ce,Re),Ae(Se)?Oe="":Ae(pe)?Oe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ae(Ce)?Oe=">="+Se+"."+pe+".0 <"+Se+"."+(+pe+1)+".0":Re?(k("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Oe=">="+Se+"."+pe+"."+Ce+Re+" <"+Se+"."+(+pe+1)+".0"):Oe=">="+Se+"."+pe+"."+Ce+" <"+Se+"."+(+pe+1)+".0",k("tilde return",Oe),Oe})}(ve,de)}).join(" ")}(oe,ae),k("tildes",oe),oe=function(le,de){return k("replaceXRanges",le,de),le.split(/\s+/).map(function(ve){return function(ye,Ee){ye=ye.trim();var be=Ee?L[u]:L[y];return ye.replace(be,function(Pe,Se,pe,Ce,Re,Oe){k("xRange",ye,Pe,Se,pe,Ce,Re,Oe);var fe=Ae(pe),Le=fe||Ae(Ce),_e=Le||Ae(Re);return Se==="="&&_e&&(Se=""),fe?Pe=Se===">"||Se==="<"?"<0.0.0":"*":Se&&_e?(Le&&(Ce=0),_e&&(Re=0),Se===">"?(Se=">=",Le?(pe=+pe+1,Ce=0,Re=0):_e&&(Ce=+Ce+1,Re=0)):Se==="<="&&(Se="<",Le?pe=+pe+1:Ce=+Ce+1),Pe=Se+pe+"."+Ce+"."+Re):Le?Pe=">="+pe+".0.0 <"+(+pe+1)+".0.0":_e&&(Pe=">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0"),k("xRange return",Pe),Pe})}(ve,de)}).join(" ")}(oe,ae),k("xrange",oe),oe=function(le,de){return k("replaceStars",le,de),le.trim().replace(L[H],"")}(oe,ae),k("stars",oe),oe}(ee,ne)}).join(" ").split(/\s+/);return this.loose&&(V=V.filter(function(ee){return!!ee.match(ge)})),V=V.map(function(ee){return new Ue(ee,ne)})},De.prototype.intersects=function(J,ne){if(!(J instanceof De))throw new TypeError("a Range is required");return this.set.some(function(re){return re.every(function(ge){return J.set.some(function(V){return V.every(function(ee){return ge.intersects(ee,ne)})})})})},e.toComparators=function(J,ne){return new De(J,ne).set.map(function(re){return re.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},De.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new X(J,this.loose));for(var ne=0;ne<this.set.length;ne++)if(He(this.set[ne],J))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(J,ne,re){var ge=null,V=null;try{var ee=new De(ne,re)}catch(oe){return null}return J.forEach(function(oe){ee.test(oe)&&(ge&&V.compare(oe)!==-1||(V=new X(ge=oe,re)))}),ge},e.minSatisfying=function(J,ne,re){var ge=null,V=null;try{var ee=new De(ne,re)}catch(oe){return null}return J.forEach(function(oe){ee.test(oe)&&(ge&&V.compare(oe)!==1||(V=new X(ge=oe,re)))}),ge},e.validRange=function(J,ne){try{return new De(J,ne).range||"*"}catch(re){return null}},e.ltr=function(J,ne,re){return ze(J,ne,"<",re)},e.gtr=function(J,ne,re){return ze(J,ne,">",re)},e.outside=ze,e.prerelease=function(J,ne){var re=te(J,ne);return re&&re.prerelease.length?re.prerelease:null},e.intersects=function(J,ne,re){return J=new De(J,re),ne=new De(ne,re),J.intersects(ne)},e.coerce=function(J){if(J instanceof X)return J;if(typeof J!="string")return null;var ne=J.match(L[P]);return ne==null?null:te((ne[1]||"0")+"."+(ne[2]||"0")+"."+(ne[3]||"0"))}}).call(this,v(1))},function(G,e){var v,A,k=G.exports={};function R(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function L(b){if(v===setTimeout)return setTimeout(b,0);if((v===R||!v)&&setTimeout)return v=setTimeout,setTimeout(b,0);try{return v(b,0)}catch(p){try{return v.call(null,b,0)}catch(E){return v.call(this,b,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:R}catch(b){v=R}try{A=typeof clearTimeout=="function"?clearTimeout:O}catch(b){A=O}})();var g,S=[],I=!1,h=-1;function w(){I&&g&&(I=!1,g.length?S=g.concat(S):h=-1,S.length&&D())}function D(){if(!I){var b=L(w);I=!0;for(var p=S.length;p;){for(g=S,S=[];++h<p;)g&&g[h].run();h=-1,p=S.length}g=null,I=!1,function(E){if(A===clearTimeout)return clearTimeout(E);if((A===O||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(E);try{A(E)}catch(m){try{return A.call(null,E)}catch(o){return A.call(this,E)}}}(b)}}function a(b,p){this.fun=b,this.array=p}function C(){}k.nextTick=function(b){var p=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)p[E-1]=arguments[E];S.push(new a(b,p)),S.length!==1||I||L(D)},a.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=C,k.addListener=C,k.once=C,k.off=C,k.removeListener=C,k.removeAllListeners=C,k.emit=C,k.prependListener=C,k.prependOnceListener=C,k.listeners=function(b){return[]},k.binding=function(b){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(b){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Q[87],Z([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(O){this._highResolution=A&&O,this._startTime=this._now(),this._stopTime=-1}static create(O=!0){return new k(O)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Q[3],Z([0,1,15,63,2,64,87]),function(G,e,v,A,k,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var L;(function(p){p.None=()=>k.Disposable.None;function E(W){return(q,x=null,B)=>{let M=!1,F;return F=W(T=>{if(!M)return F?F.dispose():M=!0,q.call(x,T)},null,B),M&&F.dispose(),F}}p.once=E;function m(W,q){return c((x,B=null,M)=>W(F=>x.call(B,q(F)),null,M))}p.map=m;function o(W,q){return c((x,B=null,M)=>W(F=>{q(F),x.call(B,F)},null,M))}p.forEach=o;function i(W,q){return c((x,B=null,M)=>W(F=>q(F)&&x.call(B,F),null,M))}p.filter=i;function t(W){return W}p.signal=t;function n(...W){return(q,x=null,B)=>(0,k.combinedDisposable)(...W.map(M=>M(F=>q.call(x,F),null,B)))}p.any=n;function r(W,q,x){let B=x;return m(W,M=>(B=q(B,M),B))}p.reduce=r;function c(W){let q;const x=new w({onFirstListenerAdd(){q=W(x.fire,x)},onLastListenerRemove(){q.dispose()}});return x.event}p.snapshot=c;function s(W,q,x=100,B=!1,M){let F,T,U,N=0;const $=new w({leakWarningThreshold:M,onFirstListenerAdd(){F=W(H=>{N++,T=q(T,H),B&&!U&&($.fire(T),T=void 0),clearTimeout(U),U=setTimeout(()=>{const K=T;T=void 0,U=void 0,(!B||N>1)&&$.fire(K),N=0},x)})},onLastListenerRemove(){F.dispose()}});return $.event}p.debounce=s;function l(W){const q=new Date().getTime();return m(E(W),x=>new Date().getTime()-q)}p.stopwatch=l;function d(W){let q=!0,x;return i(W,B=>{const M=q||B!==x;return q=!1,x=B,M})}p.latch=d;function f(W,q=!1,x=[]){let B=x.slice(),M=W(U=>{B?B.push(U):T.fire(U)});const F=()=>{B&&B.forEach(U=>T.fire(U)),B=null},T=new w({onFirstListenerAdd(){M||(M=W(U=>T.fire(U)))},onFirstListenerDidAdd(){B&&(q?setTimeout(F):F())},onLastListenerRemove(){M&&M.dispose(),M=null}});return T.event}p.buffer=f;class y{constructor(q){this.event=q}map(q){return new y(m(this.event,q))}forEach(q){return new y(o(this.event,q))}filter(q){return new y(i(this.event,q))}reduce(q,x){return new y(r(this.event,q,x))}latch(){return new y(d(this.event))}debounce(q,x=100,B=!1,M){return new y(s(this.event,q,x,B,M))}on(q,x,B){return this.event(q,x,B)}once(q,x,B){return E(this.event)(q,x,B)}}function u(W){return new y(W)}p.chain=u;function P(W,q,x=B=>B){const B=(...U)=>T.fire(x(...U)),M=()=>W.on(q,B),F=()=>W.removeListener(q,B),T=new w({onFirstListenerAdd:M,onLastListenerRemove:F});return T.event}p.fromNodeEventEmitter=P;function _(W,q,x=B=>B){const B=(...U)=>T.fire(x(...U)),M=()=>W.addEventListener(q,B),F=()=>W.removeEventListener(q,B),T=new w({onFirstListenerAdd:M,onLastListenerRemove:F});return T.event}p.fromDOMEventEmitter=_;function z(W){const q=new w;let x=!1;return W.then(void 0,()=>null).then(()=>{x?q.fire(void 0):setTimeout(()=>q.fire(void 0),0)}),x=!0,q.event}p.fromPromise=z;function j(W){return new Promise(q=>E(W)(q))}p.toPromise=j})(L=e.Event||(e.Event={}));class g{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${g._idPool++}`}start(E){this._stopWatch=new O.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}g._idPool=0;let S=-1;function I(p){const E=S;return S=p,{dispose(){S=E}}}e.setGlobalLeakWarningThreshold=I;class h{constructor(E,m=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let m=S;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),!(m<=0||E<m)){this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(o)||0;if(this._stacks.set(o,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let t,n=0;for(const[r,c]of this._stacks)(!t||n<c)&&(t=r,n=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(o)||0;this._stacks.set(o,t-1)}}}}class w{constructor(E){var m;this._disposed=!1,this._options=E,this._leakageMon=S>0?new h(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((m=this._options)===null||m===void 0?void 0:m._profName)?new g(this._options._profName):void 0}get event(){return this._event||(this._event=(E,m,o)=>{var i;this._listeners||(this._listeners=new R.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(m?[E,m]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,m);const r=(i=this._leakageMon)===null||i===void 0?void 0:i.check(this._listeners.size);let c;return c={dispose:()=>{r&&r(),c.dispose=w._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},o instanceof k.DisposableStore?o.add(c):Array.isArray(o)&&o.push(c),c}),this._event}fire(E){var m,o;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new R.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,E]);for((m=this._perfMon)===null||m===void 0||m.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,t]=this._deliveryQueue.shift();try{typeof i=="function"?i.call(void 0,t):i[0].call(i[1],t)}catch(n){(0,v.onUnexpectedError)(n)}}(o=this._perfMon)===null||o===void 0||o.stop()}}dispose(){var E,m,o;(E=this._listeners)===null||E===void 0||E.clear(),(m=this._deliveryQueue)===null||m===void 0||m.clear(),(o=this._leakageMon)===null||o===void 0||o.dispose(),this._disposed=!0}}e.Emitter=w,w._noop=function(){};class D extends w{constructor(E){super(E);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=D;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const m={event:E,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const o=()=>{this.hasListeners&&this.unhook(m);const i=this.events.indexOf(m);this.events.splice(i,1)};return(0,k.toDisposable)((0,A.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(m=>this.emitter.fire(m))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class C{constructor(){this.buffers=[]}wrapEvent(E){return(m,o,i)=>E(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>m.call(o,t)):m.call(o,t)},void 0,i)}bufferEvents(E){const m=[];this.buffers.push(m);const o=E();return this.buffers.pop(),m.forEach(i=>i()),o}}e.EventBufferer=C;class b{constructor(){this.listening=!1,this.inputEvent=L.None,this.inputEventListener=k.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(Q[29],Z([0,1,3]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(L,g){const S=setTimeout(L.bind(g),0);return{dispose(){clearTimeout(S)}}});var k;(function(L){function g(S){return S===L.None||S===L.Cancelled||S instanceof R?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}L.isCancellationToken=g,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class O{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=O}),define(Q[47],Z([0,1,15,2]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(b){const p=b;return p&&[p.on,p.pause,p.resume,p.destroy].every(E=>typeof E=="function")}e.isReadableStream=k;function R(b){const p=b;return p&&k(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean"}e.isReadableBufferedStream=R;function O(b,p){return new L(b,p)}e.newWriteableStream=O;class L{constructor(p,E){this.reducer=p,this.options=E,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){var E;if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof((E=this.options)===null||E===void 0?void 0:E.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(E=>E(p))}emitError(p){this.listeners.error.length===0?(0,v.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(E=>E(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,E){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(E),this.resume();break;case"end":this.listeners.end.push(E),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(E),this.state.flowing&&this.flowErrors();break}}removeListener(p,E){if(!this.state.destroyed){let m;switch(p){case"data":m=this.listeners.data;break;case"end":m=this.listeners.end;break;case"error":m=this.listeners.error;break}if(m){const o=m.indexOf(E);o>=0&&m.splice(o,1)}}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const E=[...this.pendingWritePromises];this.pendingWritePromises.length=0,E.forEach(m=>m())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(b,p){const E=[];let m;for(;(m=b.read())!==null;)E.push(m);return p(E)}e.consumeReadable=g;function S(b,p,E){const m=[];let o;for(;(o=b.read())!==null&&m.length<E;)m.push(o);return o===null&&m.length>0?p(m):{read:()=>{if(m.length>0)return m.shift();if(typeof o!="undefined"){const i=o;return o=void 0,i}return b.read()}}}e.peekReadable=S;function I(b,p){return new Promise((E,m)=>{const o=[];h(b,{onData:i=>{p&&o.push(i)},onError:i=>{p?m(i):E(void 0)},onEnd:()=>{E(p?p(o):void 0)}})})}e.consumeStream=I;function h(b,p){b.on("error",E=>p.onError(E)),b.on("end",()=>p.onEnd()),b.on("data",E=>p.onData(E))}e.listenStream=h;function w(b,p){return new Promise((E,m)=>{const o=new A.DisposableStore,i=[],t=c=>{if(i.push(c),i.length>p)return o.dispose(),b.pause(),E({stream:b,buffer:i,ended:!1})},n=c=>m(c),r=()=>E({stream:b,buffer:i,ended:!0});o.add((0,A.toDisposable)(()=>b.removeListener("error",n))),b.on("error",n),o.add((0,A.toDisposable)(()=>b.removeListener("end",r))),b.on("end",r),o.add((0,A.toDisposable)(()=>b.removeListener("data",t))),b.on("data",t)})}e.peekStream=w;function D(b,p){const E=O(p);return E.end(b),E}e.toStream=D;function a(b){let p=!1;return{read:()=>p?null:(p=!0,b)}}e.toReadable=a;function C(b,p,E){const m=O(E);return h(b,{onData:o=>m.write(p.data(o)),onError:o=>m.error(p.error?p.error(o):o),onEnd:()=>m.end()}),m}e.transform=C}),define(Q[21],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(V){return!V||typeof V!="string"?!0:V.trim().length===0}e.isFalsyOrWhitespace=v;const A=/{(\d+)}/g;function k(V,...ee){return ee.length===0?V:V.replace(A,function(oe,ae){const le=parseInt(ae,10);return isNaN(le)||le<0||le>=ee.length?oe:ee[le]})}e.format=k;function R(V){return V.replace(/[<>&]/g,function(ee){switch(ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ee}})}e.escape=R;function O(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=O;function L(V,ee){let oe=0;const ae=ee.charCodeAt(0);for(let le=V.length-1;le>=0;le--)V.charCodeAt(le)===ae&&oe++;return oe}e.count=L;function g(V,ee,oe="\u2026"){return V.length<=ee?V:`${V.substr(0,ee)}${oe}`}e.truncate=g;function S(V,ee=" "){const oe=I(V,ee);return h(oe,ee)}e.trim=S;function I(V,ee){if(!V||!ee)return V;const oe=ee.length;if(oe===0||V.length===0)return V;let ae=0;for(;V.indexOf(ee,ae)===ae;)ae=ae+oe;return V.substring(ae)}e.ltrim=I;function h(V,ee){if(!V||!ee)return V;const oe=ee.length,ae=V.length;if(oe===0||ae===0)return V;let le=ae,de=-1;for(;de=V.lastIndexOf(ee,le-1),!(de===-1||de+oe!==le);){if(de===0)return"";le=de}return V.substring(0,le)}e.rtrim=h;function w(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function D(V){return V.replace(/\*/g,"")}e.stripWildcards=D;function a(V,ee,oe={}){if(!V)throw new Error("Cannot create regex from empty string");ee||(V=O(V)),oe.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let ae="";return oe.global&&(ae+="g"),oe.matchCase||(ae+="i"),oe.multiline&&(ae+="m"),oe.unicode&&(ae+="u"),new RegExp(V,ae)}e.createRegExp=a;function C(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}e.regExpLeadsToEndlessLoop=C;function b(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function p(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}e.regExpFlags=p;function E(V){return V.split(/\r\n|\r|\n/)}e.splitLines=E;function m(V){for(let ee=0,oe=V.length;ee<oe;ee++){const ae=V.charCodeAt(ee);if(ae!==32&&ae!==9)return ee}return-1}e.firstNonWhitespaceIndex=m;function o(V,ee=0,oe=V.length){for(let ae=ee;ae<oe;ae++){const le=V.charCodeAt(ae);if(le!==32&&le!==9)return V.substring(ee,ae)}return V.substring(ee,oe)}e.getLeadingWhitespace=o;function i(V,ee=V.length-1){for(let oe=ee;oe>=0;oe--){const ae=V.charCodeAt(oe);if(ae!==32&&ae!==9)return oe}return-1}e.lastNonWhitespaceIndex=i;function t(V,ee){return V<ee?-1:V>ee?1:0}e.compare=t;function n(V,ee,oe=0,ae=V.length,le=0,de=ee.length){for(;oe<ae&&le<de;oe++,le++){let Ee=V.charCodeAt(oe),be=ee.charCodeAt(le);if(Ee<be)return-1;if(Ee>be)return 1}const ve=ae-oe,ye=de-le;return ve<ye?-1:ve>ye?1:0}e.compareSubstring=n;function r(V,ee){return c(V,ee,0,V.length,0,ee.length)}e.compareIgnoreCase=r;function c(V,ee,oe=0,ae=V.length,le=0,de=ee.length){for(;oe<ae&&le<de;oe++,le++){let Ee=V.charCodeAt(oe),be=ee.charCodeAt(le);if(Ee!==be){const Pe=Ee-be;if(!(Pe===32&&l(be))&&!(Pe===-32&&l(Ee)))return s(Ee)&&s(be)?Pe:n(V.toLowerCase(),ee.toLowerCase(),oe,ae,le,de)}}const ve=ae-oe,ye=de-le;return ve<ye?-1:ve>ye?1:0}e.compareSubstringIgnoreCase=c;function s(V){return V>=97&&V<=122}e.isLowerAsciiLetter=s;function l(V){return V>=65&&V<=90}e.isUpperAsciiLetter=l;function d(V){return s(V)||l(V)}function f(V,ee){return V.length===ee.length&&y(V,ee)}e.equalsIgnoreCase=f;function y(V,ee,oe=V.length){for(let ae=0;ae<oe;ae++){const le=V.charCodeAt(ae),de=ee.charCodeAt(ae);if(le!==de){if(d(le)&&d(de)){const ve=Math.abs(le-de);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(le).toLowerCase()!==String.fromCharCode(de).toLowerCase())return!1}}return!0}function u(V,ee){const oe=ee.length;return ee.length>V.length?!1:y(V,ee,oe)}e.startsWithIgnoreCase=u;function P(V,ee){let oe,ae=Math.min(V.length,ee.length);for(oe=0;oe<ae;oe++)if(V.charCodeAt(oe)!==ee.charCodeAt(oe))return oe;return ae}e.commonPrefixLength=P;function _(V,ee){let oe,ae=Math.min(V.length,ee.length);const le=V.length-1,de=ee.length-1;for(oe=0;oe<ae;oe++)if(V.charCodeAt(le-oe)!==ee.charCodeAt(de-oe))return oe;return ae}e.commonSuffixLength=_;function z(V){return 55296<=V&&V<=56319}e.isHighSurrogate=z;function j(V){return 56320<=V&&V<=57343}e.isLowSurrogate=j;function W(V,ee){return(V-55296<<10)+(ee-56320)+65536}e.computeCodePoint=W;function q(V,ee,oe){const ae=V.charCodeAt(oe);if(z(ae)&&oe+1<ee){const le=V.charCodeAt(oe+1);if(j(le))return W(ae,le)}return ae}e.getNextCodePoint=q;function x(V,ee){const oe=V.charCodeAt(ee-1);if(j(oe)&&ee>1){const ae=V.charCodeAt(ee-2);if(z(ae))return W(ae,oe)}return oe}function B(V,ee){const oe=re.getInstance(),ae=ee,le=V.length,de=q(V,le,ee);ee+=de>=65536?2:1;let ve=oe.getGraphemeBreakType(de);for(;ee<le;){const ye=q(V,le,ee),Ee=oe.getGraphemeBreakType(ye);if(J(ve,Ee))break;ee+=ye>=65536?2:1,ve=Ee}return ee-ae}e.nextCharLength=B;function M(V,ee){const oe=re.getInstance(),ae=ee,le=x(V,ee);ee-=le>=65536?2:1;let de=oe.getGraphemeBreakType(le);for(;ee>0;){const ve=x(V,ee),ye=oe.getGraphemeBreakType(ve);if(J(ye,de))break;ee-=ve>=65536?2:1,de=ye}return ae-ee}e.prevCharLength=M;function F(V,ee){const oe=re.getInstance(),ae=V.length,le=ee,de=q(V,ae,ee),ve=oe.getGraphemeBreakType(de);ee+=de>=65536?2:1;let ye=ve;for(;ee<ae;){const be=q(V,ae,ee),Pe=oe.getGraphemeBreakType(be);if(J(ye,Pe))break;ee+=be>=65536?2:1,ye=Pe}const Ee=ee;for(ee=le,ye=ve;ee>0;){const be=x(V,ee),Pe=oe.getGraphemeBreakType(be);if(J(Pe,ye))break;ee-=be>=65536?2:1,ye=Pe}return[ee,Ee]}function T(V,ee){return ee>0&&j(V.charCodeAt(ee))?F(V,ee-1):F(V,ee)}e.getCharContainingOffset=T;function U(V){const ee=V.length;let oe=0,ae=0;for(;ae<ee;){const ve=q(V,ee,ae);ae+=ve>=65536?2:1,ve<128?oe+=1:ve<2048?oe+=2:ve<65536?oe+=3:oe+=4}const le=new Uint8Array(oe);ae=0;let de=0;for(;ae<ee;){const ve=q(V,ee,ae);ae+=ve>=65536?2:1,ve<128?le[de++]=ve:ve<2048?(le[de++]=192|(ve&1984)>>>6,le[de++]=128|(ve&63)>>>0):ve<65536?(le[de++]=224|(ve&61440)>>>12,le[de++]=128|(ve&4032)>>>6,le[de++]=128|(ve&63)>>>0):(le[de++]=240|(ve&1835008)>>>18,le[de++]=128|(ve&258048)>>>12,le[de++]=128|(ve&4032)>>>6,le[de++]=128|(ve&63)>>>0)}return le}e.encodeUTF8=U;function N(V){const ee=V.byteLength,oe=[];let ae=0;for(;ae<ee;){const le=V[ae];let de;if(le>=240&&ae+3<ee?de=(V[ae++]&7)<<18>>>0|(V[ae++]&63)<<12>>>0|(V[ae++]&63)<<6>>>0|(V[ae++]&63)<<0>>>0:le>=224&&ae+2<ee?de=(V[ae++]&15)<<12>>>0|(V[ae++]&63)<<6>>>0|(V[ae++]&63)<<0>>>0:le>=192&&ae+1<ee?de=(V[ae++]&31)<<6>>>0|(V[ae++]&63)<<0>>>0:de=V[ae++],de>=0&&de<=55295||de>=57344&&de<=65535)oe.push(String.fromCharCode(de));else if(de>=65536&&de<=1114111){const ve=de-65536,ye=55296+((ve&1047552)>>>10),Ee=56320+((ve&1023)>>>0);oe.push(String.fromCharCode(ye)),oe.push(String.fromCharCode(Ee))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=N;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function H(V){return $.test(V)}e.containsRTL=H;const K=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function te(V){return K.test(V)}e.containsEmoji=te;const X=/^[\t\n\r\x20-\x7E]*$/;function ie(V){return X.test(V)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(V){return e.UNUSUAL_LINE_TERMINATORS.test(V)}e.containsUnusualLineTerminators=se;function ce(V){for(let ee=0,oe=V.length;ee<oe;ee++)if(he(V.charCodeAt(ee)))return!0;return!1}e.containsFullWidthCharacter=ce;function he(V){return V=+V,V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}e.isFullWidthCharacter=he;function me(V){return V>=127462&&V<=127487||V===8986||V===8987||V===9200||V===9203||V>=9728&&V<=10175||V===11088||V===11093||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129003||V>=129280&&V<=129535||V>=129648&&V<=129750}e.isEmojiImprecise=me;function we(V,ee){if(V.length<ee)return V;const oe=/\b/g;let ae=0;for(;oe.test(V)&&!(V.length-oe.lastIndex<ee);)ae=oe.lastIndex,oe.lastIndex+=1;return V.substring(ae).replace(/^\s/,"")}e.lcut=we;const Ie=/\x1B\x5B[12]?K/g,Te=/\x1b\[\d+m/g,ke=/\x1b\[0?m/g;function Fe(V){return V&&(V=V.replace(Ie,""),V=V.replace(Te,""),V=V.replace(ke,"")),V}e.removeAnsiEscapeCodes=Fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ue(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ue;function Me(V){return Ue(V)?V.substr(1):V}e.stripUTF8BOM=Me;function De(V,ee){if(!V||!ee||V.length<ee.length)return!1;const oe=ee.length,ae=V.toLowerCase();let le=0,de=-1;for(;le<oe;){const ve=ae.indexOf(ee[le],de+1);if(ve<0)return!1;de=ve,le++}return!0}e.fuzzyContains=De;function Ae(V,ee=!1){return V?(ee&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}e.containsUppercaseCharacter=Ae;function $e(V){return V.charAt(0).toUpperCase()+V.slice(1)}e.uppercaseFirstLetter=$e;function He(V,ee=1){if(ee===0)return"";let oe=-1;do oe=V.indexOf(`
`,oe+1),ee--;while(ee>0&&oe>=0);return oe===-1?V:(V[oe-1]==="\r"&&oe--,V.substr(0,oe))}e.getNLines=He;function Ne(V){const ee=90-65+1;return V=V%(2*ee),V<ee?String.fromCharCode(97+V):String.fromCharCode(65+V-ee)}e.singleLetterHash=Ne;function ze(V){return re.getInstance().getGraphemeBreakType(V)}e.getGraphemeBreakType=ze;function J(V,ee){return V===0?ee!==5&&ee!==7:V===2&&ee===3?!1:V===4||V===2||V===3||ee===4||ee===2||ee===3?!0:!(V===8&&(ee===8||ee===9||ee===11||ee===12)||(V===11||V===9)&&(ee===9||ee===10)||(V===12||V===10)&&ee===10||ee===5||ee===13||ee===7||V===1||V===13&&ee===14||V===6&&ee===6)}e.breakBetweenGraphemeBreakType=J;var ne;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(ne=e.GraphemeBreakType||(e.GraphemeBreakType={}));class re{constructor(){this._data=ge()}static getInstance(){return re._INSTANCE||(re._INSTANCE=new re),re._INSTANCE}getGraphemeBreakType(ee){if(ee<32)return ee===10?3:ee===13?2:4;if(ee<127)return 0;const oe=this._data,ae=oe.length/3;let le=1;for(;le<=ae;)if(ee<oe[3*le])le=2*le;else if(ee>oe[3*le+1])le=2*le+1;else return oe[3*le+2];return 0}}re._INSTANCE=null;function ge(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(Q[22],Z([0,1,21,47]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",R=typeof TextEncoder!="undefined",O=typeof TextDecoder!="undefined";let L,g;class S{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return k?new S(Buffer.allocUnsafe(s)):new S(new Uint8Array(s))}static wrap(s){return k&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new S(s)}static fromString(s,l){return!((l==null?void 0:l.dontUseNodeBuffer)||!1)&&k?new S(Buffer.from(s)):R?(L||(L=new TextEncoder),new S(L.encode(s))):new S(v.encodeUTF8(s))}static concat(s,l){if(typeof l=="undefined"){l=0;for(let y=0,u=s.length;y<u;y++)l+=s[y].byteLength}const d=S.alloc(l);let f=0;for(let y=0,u=s.length;y<u;y++){const P=s[y];d.set(P,f),f+=P.byteLength}return d}toString(){return k?this.buffer.toString():O?(g||(g=new TextDecoder),g.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(s,l){return new S(this.buffer.subarray(s,l))}set(s,l){s instanceof S?this.buffer.set(s.buffer,l):this.buffer.set(s,l)}readUInt32BE(s){return w(this.buffer,s)}writeUInt32BE(s,l){D(this.buffer,s,l)}readUInt32LE(s){return a(this.buffer,s)}writeUInt32LE(s,l){C(this.buffer,s,l)}readUInt8(s){return b(this.buffer,s)}writeUInt8(s,l){p(this.buffer,s,l)}}e.VSBuffer=S;function I(c,s){return c[s+0]<<0>>>0|c[s+1]<<8>>>0}e.readUInt16LE=I;function h(c,s,l){c[l+0]=s&255,s=s>>>8,c[l+1]=s&255}e.writeUInt16LE=h;function w(c,s){return c[s]*2**24+c[s+1]*2**16+c[s+2]*2**8+c[s+3]}e.readUInt32BE=w;function D(c,s,l){c[l+3]=s,s=s>>>8,c[l+2]=s,s=s>>>8,c[l+1]=s,s=s>>>8,c[l]=s}e.writeUInt32BE=D;function a(c,s){return c[s+0]<<0>>>0|c[s+1]<<8>>>0|c[s+2]<<16>>>0|c[s+3]<<24>>>0}e.readUInt32LE=a;function C(c,s,l){c[l+0]=s&255,s=s>>>8,c[l+1]=s&255,s=s>>>8,c[l+2]=s&255,s=s>>>8,c[l+3]=s&255}e.writeUInt32LE=C;function b(c,s){return c[s]}e.readUInt8=b;function p(c,s,l){c[l]=s}e.writeUInt8=p;function E(c){return A.consumeReadable(c,s=>S.concat(s))}e.readableToBuffer=E;function m(c){return A.toReadable(c)}e.bufferToReadable=m;function o(c){return A.consumeStream(c,s=>S.concat(s))}e.streamToBuffer=o;async function i(c){return c.ended?S.concat(c.buffer):S.concat([...c.buffer,await o(c.stream)])}e.bufferedStreamToBuffer=i;function t(c){return A.toStream(c,s=>S.concat(s))}e.bufferToStream=t;function n(c){return A.transform(c,{data:s=>typeof s=="string"?S.fromString(s):S.wrap(s)},s=>S.concat(s))}e.streamToBufferReadableStream=n;function r(c){return A.newWriteableStream(s=>S.concat(s),c)}e.newWriteableBufferStream=r}),define(Q[17],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(s){return Array.isArray(s)}e.isArray=v;function A(s){return typeof s=="string"}e.isString=A;function k(s){return Array.isArray(s)&&s.every(l=>A(l))}e.isStringArray=k;function R(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=R;function O(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=O;function L(s){return s===!0||s===!1}e.isBoolean=L;function g(s){return typeof s=="undefined"}e.isUndefined=g;function S(s){return!I(s)}e.isDefined=S;function I(s){return g(s)||s===null}e.isUndefinedOrNull=I;function h(s,l){if(!s)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=h;function w(s){if(I(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=w;function D(...s){const l=[];for(let d=0;d<s.length;d++){const f=s[d];if(I(f))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);l.push(f)}return l}e.assertAllDefined=D;const a=Object.prototype.hasOwnProperty;function C(s){if(!R(s))return!1;for(let l in s)if(a.call(s,l))return!1;return!0}e.isEmptyObject=C;function b(s){return typeof s=="function"}e.isFunction=b;function p(...s){return s.length>0&&s.every(b)}e.areFunctions=p;function E(s,l){const d=Math.min(s.length,l.length);for(let f=0;f<d;f++)m(s[f],l[f])}e.validateConstraints=E;function m(s,l){if(A(l)){if(typeof s!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(b(l)){try{if(s instanceof l)return}catch(d){}if(!I(s)&&s.constructor===l||l.length===1&&l.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function o(s){let l=[],d=Object.getPrototypeOf(s);for(;Object.prototype!==d;)l=l.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return l}e.getAllPropertyNames=o;function i(s){const l=[];for(const d of o(s))typeof s[d]=="function"&&l.push(d);return l}e.getAllMethodNames=i;function t(s,l){const d=y=>function(){const u=Array.prototype.slice.call(arguments,0);return l(y,u)};let f={};for(const y of s)f[y]=d(y);return f}e.createProxyObject=t;function n(s){return s===null?void 0:s}e.withNullAsUndefined=n;function r(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=r;function c(s){return class{constructor(){return new Proxy({},{get(l,d){if(l[d])return l[d];throw new Error(`Not Implemented: ${s}->${String(d)}`)}})}}}e.NotImplementedProxy=c}),define(Q[42],Z([0,1,7,21,8,17]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function O(n){return n===47||n===92}e.isPathSeparator=O;function L(n){return n.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=L;function g(n,r=k.posix.sep){if(!n)return"";const c=n.length,s=n.charCodeAt(0);if(O(s)){if(O(n.charCodeAt(1))&&!O(n.charCodeAt(2))){let d=3;const f=d;for(;d<c&&!O(n.charCodeAt(d));d++);if(f!==d&&!O(n.charCodeAt(d+1))){for(d+=1;d<c;d++)if(O(n.charCodeAt(d)))return n.slice(0,d+1).replace(/[\\/]/g,r)}}return r}else if(b(s)&&n.charCodeAt(1)===58)return O(n.charCodeAt(2))?n.slice(0,2)+r:n.slice(0,2);let l=n.indexOf("://");if(l!==-1){for(l+=3;l<c;l++)if(O(n.charCodeAt(l)))return n.slice(0,l+1)}return""}e.getRoot=g;function S(n){if(!v.isWindows||!n||n.length<5)return!1;let r=n.charCodeAt(0);if(r!==92||(r=n.charCodeAt(1),r!==92))return!1;let c=2;const s=c;for(;c<n.length&&(r=n.charCodeAt(c),r!==92);c++);return!(s===c||(r=n.charCodeAt(c+1),isNaN(r)||r===92))}e.isUNC=S;const I=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(n,r=v.isWindows){const c=r?I:h;return!(!n||n.length===0||/^\s+$/.test(n)||(c.lastIndex=0,c.test(n))||r&&w.test(n)||n==="."||n===".."||r&&n[n.length-1]==="."||r&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=D;function a(n,r,c){const s=n===r;return!c||s?s:!n||!r?!1:(0,A.equalsIgnoreCase)(n,r)}e.isEqual=a;function C(n,r,c,s=k.sep){if(n===r)return!0;if(!n||!r||r.length>n.length)return!1;if(c){if(!(0,A.startsWithIgnoreCase)(n,r))return!1;if(r.length===n.length)return!0;let d=r.length;return r.charAt(r.length-1)===s&&d--,n.charAt(d)===s}return r.charAt(r.length-1)!==s&&(r+=s),n.indexOf(r)===0}e.isEqualOrParent=C;function b(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=b;function p(n,r){return v.isWindows&&n.endsWith(":")&&(n+=k.sep),(0,k.isAbsolute)(n)||(n=(0,k.join)(r,n)),n=(0,k.normalize)(n),v.isWindows?(n=(0,A.rtrim)(n,k.sep),n.endsWith(":")&&(n+=k.sep)):(n=(0,A.rtrim)(n,k.sep),n||(n=k.sep)),n}e.sanitizeFilePath=p;function E(n){const r=(0,k.normalize)(n);return v.isWindows?n.length>3?!1:m(r)&&(n.length===2||r.charCodeAt(2)===92):r===k.posix.sep}e.isRootOrDriveLetter=E;function m(n){return v.isWindows?b(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function o(n){return m(n)?n[0]:void 0}e.getDriveLetter=o;function i(n,r,c){return r.length>n.length?-1:n===r?0:(c&&(n=n.toLowerCase(),r=r.toLowerCase()),n.indexOf(r))}e.indexOfPath=i;function t(n){const r=n.split(":");let c,s,l;if(r.forEach(d=>{const f=Number(d);(0,R.isNumber)(f)?s===void 0?s=f:l===void 0&&(l=f):c=c?[c,d].join(":"):d}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:s!==void 0?s:void 0,column:l!==void 0?l:s!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Q[26],Z([0,1,17]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const C=Array.isArray(a)?[]:{};return Object.keys(a).forEach(b=>{a[b]&&typeof a[b]=="object"?C[b]=A(a[b]):C[b]=a[b]}),C}e.deepClone=A;function k(a){if(!a||typeof a!="object")return a;const C=[a];for(;C.length>0;){const b=C.shift();Object.freeze(b);for(const p in b)if(R.call(b,p)){const E=b[p];typeof E=="object"&&!Object.isFrozen(E)&&C.push(E)}}return a}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function O(a,C){return L(a,C,new Set)}e.cloneAndChange=O;function L(a,C,b){if((0,v.isUndefinedOrNull)(a))return a;const p=C(a);if(typeof p!="undefined")return p;if((0,v.isArray)(a)){const E=[];for(const m of a)E.push(L(m,C,b));return E}if((0,v.isObject)(a)){if(b.has(a))throw new Error("Cannot clone recursive data-structure");b.add(a);const E={};for(let m in a)R.call(a,m)&&(E[m]=L(a[m],C,b));return b.delete(a),E}return a}function g(a,C,b=!0){return(0,v.isObject)(a)?((0,v.isObject)(C)&&Object.keys(C).forEach(p=>{p in a?b&&((0,v.isObject)(a[p])&&(0,v.isObject)(C[p])?g(a[p],C[p],b):a[p]=C[p]):a[p]=C[p]}),a):C}e.mixin=g;function S(a,C){if(a===C)return!0;if(a==null||C===null||C===void 0||typeof a!=typeof C||typeof a!="object"||Array.isArray(a)!==Array.isArray(C))return!1;let b,p;if(Array.isArray(a)){if(a.length!==C.length)return!1;for(b=0;b<a.length;b++)if(!S(a[b],C[b]))return!1}else{const E=[];for(p in a)E.push(p);E.sort();const m=[];for(p in C)m.push(p);if(m.sort(),!S(E,m))return!1;for(b=0;b<E.length;b++)if(!S(a[E[b]],C[E[b]]))return!1}return!0}e.equals=S;function I(a){const C=new Set;return JSON.stringify(a,(b,p)=>{if((0,v.isObject)(p)||Array.isArray(p)){if(C.has(p))return"[Circular]";C.add(p)}return p})}e.safeStringify=I;function h(a,C,b){const p=C(a);return typeof p=="undefined"?b:p}e.getOrDefault=h;function w(a,C){const b=Object.create(null);return!a||!C||Object.keys(C).forEach(E=>{const m=a[E],o=C[E];S(m,o)||(b[E]=o)}),b}e.distinct=w;function D(a,C){const b=C.toLowerCase(),p=Object.keys(a).find(E=>E.toLowerCase()===b);return p?a[p]:a[C]}e.getCaseInsensitive=D}),define(Q[5],Z([0,1,7,8]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,O=/^\/\//;function L(r,c){if(!r.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(r,c){return!r&&!c?"file":r}function S(r,c){switch(r){case"https":case"http":case"file":c?c[0]!==h&&(c=h+c):c=h;break}return c}const I="",h="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class D{constructor(c,s,l,d,f,y=!1){typeof c=="object"?(this.scheme=c.scheme||I,this.authority=c.authority||I,this.path=c.path||I,this.query=c.query||I,this.fragment=c.fragment||I):(this.scheme=g(c,y),this.authority=s||I,this.path=S(this.scheme,l||I),this.query=d||I,this.fragment=f||I,L(this,y))}static isUri(c){return c instanceof D?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}get fsPath(){return m(this,!1)}with(c){if(!c)return this;let{scheme:s,authority:l,path:d,query:f,fragment:y}=c;return s===void 0?s=this.scheme:s===null&&(s=I),l===void 0?l=this.authority:l===null&&(l=I),d===void 0?d=this.path:d===null&&(d=I),f===void 0?f=this.query:f===null&&(f=I),y===void 0?y=this.fragment:y===null&&(y=I),s===this.scheme&&l===this.authority&&d===this.path&&f===this.query&&y===this.fragment?this:new C(s,l,d,f,y)}static parse(c,s=!1){const l=w.exec(c);return l?new C(l[2]||I,n(l[4]||I),n(l[5]||I),n(l[7]||I),n(l[9]||I),s):new C(I,I,I,I,I)}static file(c){let s=I;if(v.isWindows&&(c=c.replace(/\\/g,h)),c[0]===h&&c[1]===h){const l=c.indexOf(h,2);l===-1?(s=c.substring(2),c=h):(s=c.substring(2,l),c=c.substring(l)||h)}return new C("file",s,c,I,I)}static from(c){return new C(c.scheme,c.authority,c.path,c.query,c.fragment)}static joinPath(c,...s){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return v.isWindows&&c.scheme==="file"?l=D.file(A.win32.join(m(c,!0),...s)).path:l=A.posix.join(c.path,...s),c.with({path:l})}toString(c=!1){return o(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof D)return c;{const s=new C(c);return s._formatted=c.external,s._fsPath=c._sep===a?c.fsPath:null,s}}else return c}}e.URI=D;const a=v.isWindows?1:void 0;class C extends D{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(c=!1){return c?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=a),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(r,c){let s,l=-1;for(let d=0;d<r.length;d++){const f=r.charCodeAt(d);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||c&&f===47)l!==-1&&(s+=encodeURIComponent(r.substring(l,d)),l=-1),s!==void 0&&(s+=r.charAt(d));else{s===void 0&&(s=r.substr(0,d));const y=b[f];y!==void 0?(l!==-1&&(s+=encodeURIComponent(r.substring(l,d)),l=-1),s+=y):l===-1&&(l=d)}}return l!==-1&&(s+=encodeURIComponent(r.substring(l))),s!==void 0?s:r}function E(r){let c;for(let s=0;s<r.length;s++){const l=r.charCodeAt(s);l===35||l===63?(c===void 0&&(c=r.substr(0,s)),c+=b[l]):c!==void 0&&(c+=r[s])}return c!==void 0?c:r}function m(r,c){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?c?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,v.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=m;function o(r,c){const s=c?E:p;let l="",{scheme:d,authority:f,path:y,query:u,fragment:P}=r;if(d&&(l+=d,l+=":"),(f||d==="file")&&(l+=h,l+=h),f){let _=f.indexOf("@");if(_!==-1){const z=f.substr(0,_);f=f.substr(_+1),_=z.indexOf(":"),_===-1?l+=s(z,!1):(l+=s(z.substr(0,_),!1),l+=":",l+=s(z.substr(_+1),!1)),l+="@"}f=f.toLowerCase(),_=f.indexOf(":"),_===-1?l+=s(f,!1):(l+=s(f.substr(0,_),!1),l+=f.substr(_))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const _=y.charCodeAt(1);_>=65&&_<=90&&(y=`/${String.fromCharCode(_+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const _=y.charCodeAt(0);_>=65&&_<=90&&(y=`${String.fromCharCode(_+32)}:${y.substr(2)}`)}l+=s(y,!0)}return u&&(l+="?",l+=s(u,!1)),P&&(l+="#",l+=c?P:p(P,!1)),l}function i(r){try{return decodeURIComponent(r)}catch(c){return r.length>3?r.substr(0,3)+i(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,c=>i(c)):r}}),define(Q[88],Z([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(S){const I=S;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=A;function k(S){const I=[];let h;try{const w=JSON.parse(S.arguments),D=w[w.length-1];D&&D.__$stack&&(w.pop(),h=D.__$stack),I.push(...w)}catch(w){I.push("Unable to log remote console arguments",S.arguments)}return{args:I,stack:h}}e.parse=k;function R(S){if(typeof S!="string")return R(k(S).stack);const I=S;if(I){const h=O(I),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(h||"");if(w&&w.length===4)return{uri:v.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=R;function O(S){if(!S)return S;const I=S.indexOf(`
`);return I===-1?S:S.substring(0,I)}function L(S,I){const{args:h,stack:w}=k(S),D=typeof h[0]=="string"&&h.length===1;let a=O(w);a&&(a=`(${a.trim()})`);let C=[];if(typeof h[0]=="string"?a&&D?C=[`%c[${I}] %c${h[0]} %c${a}`,g("blue"),g(""),g("grey")]:C=[`%c[${I}] %c${h[0]}`,g("blue"),g(""),...h.slice(1)]:C=[`%c[${I}]%`,g("blue"),...h],a&&!D&&C.push(a),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,C)}e.log=L;function g(S){return`color: ${S}`}}),define(Q[37],Z([0,1,5,21]),function(G,e,v,A){"use strict";var k,R;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function O(o,i,t){let n=o.get(i);return n===void 0&&(n=t,o.set(i,n)),n}e.getOrSet=O;function L(o){const i=[];return o.forEach((t,n)=>{i.push(`${n} => ${t}`)}),`Map(${o.size}) {${i.join(", ")}}`}e.mapToString=L;function g(o){const i=[];return o.forEach(t=>{i.push(t)}),`Set(${o.size}) {${i.join(", ")}}`}e.setToString=g;class S{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const t=i.charCodeAt(0),n=this._value.charCodeAt(this._pos);return t-n}value(){return this._value[this._pos]}}e.StringIterator=S;class I{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,A.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class h{constructor(i=!0,t=!0){this._splitOnBackslash=i,this._caseSensitive=t}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,A.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var w;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(w||(w={}));class D{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,A.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=D;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class C{constructor(i){this._iter=i}static forUris(i=()=>!1){return new C(new D(i))}static forPaths(){return new C(new h)}static forStrings(){return new C(new S)}static forConfigKeys(){return new C(new I)}clear(){this._root=void 0}set(i,t){const n=this._iter.reset(i);let r;for(this._root||(this._root=new a,this._root.segment=n.value()),r=this._root;;){const s=n.cmp(r.segment);if(s>0)r.left||(r.left=new a,r.left.segment=n.value()),r=r.left;else if(s<0)r.right||(r.right=new a,r.right.segment=n.value()),r=r.right;else if(n.hasNext())n.next(),r.mid||(r.mid=new a,r.mid.segment=n.value()),r=r.mid;else break}const c=r.value;return r.value=t,r.key=i,c}get(i){var t;return(t=this._getNode(i))===null||t===void 0?void 0:t.value}_getNode(i){const t=this._iter.reset(i);let n=this._root;for(;n;){const r=t.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else break}return n}has(i){const t=this._getNode(i);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,t){const n=this._iter.reset(i),r=[];let c=this._root;for(;c;){const s=n.cmp(c.segment);if(s>0)r.push([1,c]),c=c.left;else if(s<0)r.push([-1,c]),c=c.right;else if(n.hasNext())n.next(),r.push([0,c]),c=c.mid;else{for(t?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;r.length>0&&c.isEmpty();){let[l,d]=r.pop();switch(l){case 1:d.left=void 0;break;case 0:d.mid=void 0;break;case-1:d.right=void 0;break}c=d}break}}}findSubstr(i){const t=this._iter.reset(i);let n=this._root,r;for(;n;){const c=t.cmp(n.segment);if(c>0)n=n.left;else if(c<0)n=n.right;else if(t.hasNext())t.next(),r=n.value||r,n=n.mid;else break}return n&&n.value||r}findSuperstr(i){const t=this._iter.reset(i);let n=this._root;for(;n;){const r=t.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(i){for(const[t,n]of this)i(n,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=C;class b{constructor(i,t){this[k]="ResourceMap",i instanceof b?(this.map=new Map(i.map),this.toKey=t!=null?t:b.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:b.defaultToKey)}set(i,t){return this.map.set(this.toKey(i),t),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,t){typeof t!="undefined"&&(i=i.bind(t));for(let[n,r]of this.map)i(r,v.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield v.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[v.URI.parse(i[0]),i[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[v.URI.parse(i[0]),i[1]]}}e.ResourceMap=b,b.defaultToKey=o=>o.toString();var p;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class E{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,t=0){const n=this._map.get(i);if(!!n)return t!==0&&this.touch(n,t),n.value}set(i,t,n=0){let r=this._map.get(i);if(r)r.value=t,n!==0&&this.touch(r,n);else{switch(r={key:i,value:t,next:void 0,previous:void 0},n){case 0:this.addItemLast(r);break;case 1:this.addItemFirst(r);break;case 2:this.addItemLast(r);break;default:this.addItemLast(r);break}this._map.set(i,r),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const t=this._map.get(i);if(!!t)return this._map.delete(i),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,t){const n=this._state;let r=this._head;for(;r;){if(t?i.bind(t)(r.value,r.key,this):i(r.value,r.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const i=this,t=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const c={value:n.key,done:!1};return n=n.next,c}else return{value:void 0,done:!0}}};return r}values(){const i=this,t=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const c={value:n.value,done:!1};return n=n.next,c}else return{value:void 0,done:!0}}};return r}entries(){const i=this,t=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const c={value:[n.key,n.value],done:!1};return n=n.next,c}else return{value:void 0,done:!0}}};return r}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let t=this._head,n=this.size;for(;t&&n>i;)this._map.delete(t.key),t=t.next,n--;this._head=t,this._size=n,t&&(t.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const t=i.next,n=i.previous;if(!t||!n)throw new Error("Invalid list");t.previous=n,n.next=t}i.next=void 0,i.previous=void 0,this._state++}touch(i,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(i===this._head)return;const n=i.next,r=i.previous;i===this._tail?(r.next=void 0,this._tail=r):(n.previous=r,r.next=n),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(t===2){if(i===this._tail)return;const n=i.next,r=i.previous;i===this._head?(n.previous=void 0,this._head=n):(n.previous=r,r.next=n),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((t,n)=>{i.push([n,t])}),i}fromJSON(i){this.clear();for(const[t,n]of i)this.set(t,n)}}e.LinkedMap=E;class m extends E{constructor(i,t=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,t=2){return super.get(i,t)}peek(i){return super.get(i,0)}set(i,t){return super.set(i,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m}),define(Q[89],Z([0,1,22,21,5]),function(G,e,v,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(S){return JSON.stringify(S,L)}e.stringify=R;function O(S){let I=JSON.parse(S);return I=g(I),I}e.parse=O;function L(S,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,A.regExpFlags)(I)}:I}function g(S,I=0){if(!S||I>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return k.URI.revive(S);case 2:return new RegExp(S.source,S.flags)}if(S instanceof v.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let h=0;h<S.length;++h)S[h]=g(S[h],I+1);else for(const h in S)Object.hasOwnProperty.call(S,h)&&(S[h]=g(S[h],I+1))}return S}e.revive=g}),define(Q[16],Z([0,1,5,7]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(L){L.inMemory="inmemory",L.vscode="vscode",L.internal="private",L.walkThrough="walkThrough",L.walkThroughSnippet="walkThroughSnippet",L.http="http",L.https="https",L.file="file",L.mailto="mailto",L.untitled="untitled",L.data="data",L.command="command",L.vscodeRemote="vscode-remote",L.vscodeRemoteResource="vscode-remote-resource",L.userData="vscode-userdata",L.vscodeCustomEditor="vscode-custom-editor",L.vscodeNotebook="vscode-notebook",L.vscodeNotebookCell="vscode-notebook-cell",L.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",L.vscodeSettings="vscode-settings",L.vscodeWorkspaceTrust="vscode-workspace-trust",L.webviewPanel="webview-panel",L.vscodeWebview="vscode-webview",L.vscodeWebviewResource="vscode-webview-resource",L.extension="extension",L.vscodeFileResource="vscode-file"})(k=e.Schemas||(e.Schemas={}));class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}set(g,S,I){this._hosts[g]=S,this._ports[g]=I}setConnectionToken(g,S){this._connectionTokens[g]=S}rewrite(g){if(this._delegate)return this._delegate(g);const S=g.authority;let I=this._hosts[S];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const h=this._ports[S],w=this._connectionTokens[S];let D=`path=${encodeURIComponent(g.path)}`;return typeof w=="string"&&(D+=`&tkn=${encodeURIComponent(w)}`),v.URI.from({scheme:A.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${I}:${h}`,path:"/vscode-remote-resource",query:D})}}e.RemoteAuthorities=new R;class O{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(g,S,I){const h=this.toUri(g,S);return h.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(h):A.isNative&&(I||A.isPreferringBrowserCodeLoad)&&h.scheme===k.file?h.with({scheme:k.vscodeFileResource,authority:h.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):h}asFileUri(g,S){const I=this.toUri(g,S);return I.scheme===k.vscodeFileResource?I.with({scheme:k.file,authority:I.authority!==this.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(g,S){return v.URI.isUri(g)?g:v.URI.parse(S.toUrl(g))}}e.FileAccess=new O}),define(Q[65],Z([0,1,37]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const A=new v.LRUCache(1e4);function k(S){return g(S,"NFC",A)}e.normalizeNFC=k;const R=new v.LRUCache(1e4);function O(S){return g(S,"NFD",R)}e.normalizeNFD=O;const L=/[^\u0000-\u0080]/;function g(S,I,h){if(!e.canNormalize||!S)return S;const w=h.get(S);if(w)return w;let D;return L.test(S)?D=S.normalize(I):D=S,h.set(S,D),D}e.removeAccents=function(){if(e.canNormalize){const S=/[\u0300-\u036f]/g;return function(I){return O(I).replace(S,"")}}else return function(S){return S}}()}),define(Q[11],Z([0,1,42,8,5,21,16,7]),function(G,e,v,A,k,R,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(D){return(0,k.uriToFsPath)(D,!0)}e.originalFSPath=g;class S{constructor(a){this._ignorePathCasing=a}compare(a,C,b=!1){return a===C?0:(0,R.compare)(this.getComparisonKey(a,b),this.getComparisonKey(C,b))}isEqual(a,C,b=!1){return a===C?!0:!a||!C?!1:this.getComparisonKey(a,b)===this.getComparisonKey(C,b)}getComparisonKey(a,C=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,C,b=!1){if(a.scheme===C.scheme){if(a.scheme===O.Schemas.file)return v.isEqualOrParent(g(a),g(C),this._ignorePathCasing(a))&&a.query===C.query&&(b||a.fragment===C.fragment);if((0,e.isEqualAuthority)(a.authority,C.authority))return v.isEqualOrParent(a.path,C.path,this._ignorePathCasing(a),"/")&&a.query===C.query&&(b||a.fragment===C.fragment)}return!1}joinPath(a,...C){return k.URI.joinPath(a,...C)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return A.posix.basename(a.path)}extname(a){return A.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let C;return a.scheme===O.Schemas.file?C=k.URI.file(A.dirname(g(a))).path:(C=A.posix.dirname(a.path),a.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),C="/")),a.with({path:C})}normalizePath(a){if(!a.path.length)return a;let C;return a.scheme===O.Schemas.file?C=k.URI.file(A.normalize(g(a))).path:C=A.posix.normalize(a.path),a.with({path:C})}relativePath(a,C){if(!(a.scheme!==C.scheme||!(0,e.isEqualAuthority)(a.authority,C.authority))){if(a.scheme===O.Schemas.file){const E=A.relative(g(a),g(C));return L.isWindows?v.toSlashes(E):E}let b=a.path||"/",p=C.path||"/";if(this._ignorePathCasing(a)){let E=0;for(const m=Math.min(b.length,p.length);E<m&&!(b.charCodeAt(E)!==p.charCodeAt(E)&&b.charAt(E).toLowerCase()!==p.charAt(E).toLowerCase());E++);b=p.substr(0,E)+b.substr(E)}return A.posix.relative(b,p)}}resolvePath(a,C){if(a.scheme===O.Schemas.file){const b=k.URI.file(A.resolve(g(a),C));return a.with({authority:b.authority,path:b.path})}return C.indexOf("/")===-1&&(C=v.toSlashes(C),/^[a-zA-Z]:(\/|$)/.test(C)&&(C="/"+C)),a.with({path:A.posix.resolve(a.path,C)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,C){return a===C||(0,R.equalsIgnoreCase)(a,C)}hasTrailingPathSeparator(a,C=A.sep){if(a.scheme===O.Schemas.file){const b=g(a);return b.length>v.getRoot(b).length&&b[b.length-1]===C}else{const b=a.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,C=A.sep){return(0,e.hasTrailingPathSeparator)(a,C)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,C=A.sep){let b=!1;if(a.scheme===O.Schemas.file){const p=g(a);b=p!==void 0&&p.length===v.getRoot(p).length&&p[p.length-1]===C}else{C="/";const p=a.path;b=p.length===1&&p.charCodeAt(p.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(a,C)?a.with({path:a.path+"/"}):a}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(D=>D.scheme===O.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new S(D=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(D,a){const C=[];for(let b=0;b<D.length;b++){const p=a(D[b]);D.some((E,m)=>m===b?!1:(0,e.isEqualOrParent)(p,a(E)))||C.push(D[b])}return C}e.distinctParents=I;var h;(function(D){D.META_DATA_LABEL="label",D.META_DATA_DESCRIPTION="description",D.META_DATA_SIZE="size",D.META_DATA_MIME="mime";function a(C){const b=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(m=>{const[o,i]=m.split(":");o&&i&&b.set(o,i)});const E=C.path.substring(0,C.path.indexOf(";"));return E&&b.set(D.META_DATA_MIME,E),b}D.parseMetaData=a})(h=e.DataUri||(e.DataUri={}));function w(D,a,C){if(a){let b=D.path;return b&&b[0]!==A.posix.sep&&(b=A.posix.sep+b),D.with({scheme:C,authority:a,path:b})}return D.with({scheme:C})}e.toLocalResource=w}),define(Q[6],Z([0,1,29,15,3,2,64,11]),function(G,e,v,A,k,R,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(F){return!!F&&typeof F.then=="function"}e.isThenable=g;function S(F){const T=new v.CancellationTokenSource,U=F(T.token),N=new Promise(($,H)=>{T.token.onCancellationRequested(()=>{H((0,A.canceled)())}),Promise.resolve(U).then(K=>{T.dispose(),$(K)},K=>{T.dispose(),H(K)})});return new class{cancel(){T.cancel()}then($,H){return N.then($,H)}catch($){return this.then(void 0,$)}finally($){return N.finally($)}}}e.createCancelablePromise=S;function I(F,T,U){return Promise.race([F,new Promise(N=>T.onCancellationRequested(()=>N(U)))])}e.raceCancellation=I;async function h(F){let T=-1;const U=F.map(($,H)=>$.then(K=>(T=H,K))),N=await Promise.race(U);return F.forEach(($,H)=>{H!==T&&$.cancel()}),N}e.raceCancellablePromises=h;function w(F,T,U){let N;const $=setTimeout(()=>{N==null||N(void 0),U==null||U()},T);return Promise.race([F.finally(()=>clearTimeout($)),new Promise(H=>N=H)])}e.raceTimeout=w;function D(F){return new Promise((T,U)=>{const N=F();g(N)?N.then(T,U):T(N)})}e.asPromise=D;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(U,U).then(N)})}return new Promise((U,N)=>{this.queuedPromise.then(U,N)})}return this.activePromise=T(),new Promise((U,N)=>{this.activePromise.then($=>{this.activePromise=null,U($)},$=>{this.activePromise=null,N($)})})}}e.Throttler=a;class C{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=C;class b{constructor(){this.promiseMap=new Map}queue(T,U){var N;const H=((N=this.promiseMap.get(T))!==null&&N!==void 0?N:Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(T)===H&&this.promiseMap.delete(T)});return this.promiseMap.set(T,H),H}}e.SequencerByKey=b;class p{constructor(T){this.defaultDelay=T,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,U=this.defaultDelay){return this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,$)=>{this.doResolve=N,this.doReject=$}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,A.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=p;class E{constructor(T){this.delayer=new p(T),this.throttler=new a}trigger(T,U){return this.delayer.trigger(()=>this.throttler.queue(T),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class m{constructor(){this._isOpen=!1,this._promise=new Promise((T,U)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class o extends m{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function i(F,T){return T?new Promise((U,N)=>{const $=setTimeout(U,F);T.onCancellationRequested(()=>{clearTimeout($),N((0,A.canceled)())})}):S(U=>i(F,U))}e.timeout=i;function t(F,T=0){const U=setTimeout(F,T);return(0,R.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=t;function n(F){return F.then(void 0,T=>{})}e.ignoreErrors=n;function r(F){const T=[];let U=0;const N=F.length;function $(){return U<N?F[U++]():null}function H(K){K!=null&&T.push(K);const te=$();return te?te.then(H):Promise.resolve(T)}return Promise.resolve(null).then(H)}e.sequence=r;function c(F,T=N=>!!N,U=null){let N=0;const $=F.length,H=()=>{if(N>=$)return Promise.resolve(U);const K=F[N++];return Promise.resolve(K()).then(X=>T(X)?Promise.resolve(X):H())};return H()}e.first=c;function s(F,T=N=>!!N,U=null){if(F.length===0)return Promise.resolve(U);let N=F.length;const $=()=>{var H,K;N=-1;for(const te of F)(K=(H=te).cancel)===null||K===void 0||K.call(H)};return new Promise((H,K)=>{for(const te of F)te.then(X=>{--N>=0&&T(X)?($(),H(X)):N===0&&H(U)}).catch(X=>{--N>=0&&($(),K(X))})})}e.firstParallel=s;class l{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(T){return this._size++,new Promise((U,N)=>{this.outstandingPromises.push({factory:T,c:U,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const U=T.factory();U.then(T.c,T.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class d extends l{constructor(){super(1)}}e.Queue=d;class f{constructor(){this.queues=new Map}queueFor(T,U=L.extUri){const N=U.getComparisonKey(T);let $=this.queues.get(N);return $||($=new d,k.Event.once($.onFinished)(()=>{$==null||$.dispose(),this.queues.delete(N)}),this.queues.set(N,$)),$}dispose(){this.queues.forEach(T=>T.dispose()),this.queues.clear()}}e.ResourceQueue=f;class y{constructor(T,U){this._token=-1,typeof T=="function"&&typeof U=="number"&&this.setIfNotSet(T,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},U)}setIfNotSet(T,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},U))}}e.TimeoutTimer=y;class u{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,U){this.cancel(),this._token=setInterval(()=>{T()},U)}}e.IntervalTimer=u;class P{constructor(T,U){this.timeoutToken=-1,this.runner=T,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class _ extends P{constructor(T,U){super(T,U);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const F=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=T=>{const U=setTimeout(()=>T(F));let N=!1;return{dispose(){N||(N=!0,clearTimeout(U))}}}}else e.runWhenIdle=(F,T)=>{const U=requestIdleCallback(F,typeof T=="number"?{timeout:T}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(U))}}}}();class z{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function j(F,T,U){let N;for(let $=0;$<U;$++)try{return await F()}catch(H){N=H,await i(T)}throw N}e.retry=j;class W{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var T;(T=this._pending)===null||T===void 0||T.cancel()}setPending(T,U,N){return this._pending={taskId:T,cancel:()=>N==null?void 0:N(),promise:U},U.then(()=>this.donePending(T),()=>this.donePending(T)),U}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let U,N;const $=new Promise((H,K)=>{U=H,N=K});this._next={run:T,promise:$,promiseResolve:U,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=W;class q{constructor(T){this.interval=T,this.lastIncrementTime=0,this.value=0}increment(){const T=Date.now();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,U)=>{this.completeCallback=T,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(U=>{this.completeCallback(T),this.resolved=!0,U()})}error(T){return new Promise(U=>{this.errorCallback(T),this.rejected=!0,U()})}cancel(){new Promise(T=>{this.errorCallback((0,A.canceled)()),this.rejected=!0,T()})}}e.DeferredPromise=x;class B extends k.Emitter{async fireAsync(T,U,N){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new O.LinkedList);for(const $ of this._listeners)this._asyncDeliveryQueue.push([$,T]);for(;this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[$,H]=this._asyncDeliveryQueue.shift(),K=[],te=Object.assign(Object.assign({},H),{waitUntil:X=>{if(Object.isFrozen(K))throw new Error("waitUntil can NOT be called asynchronous");N&&(X=N(X,typeof $=="function"?$:$[0])),K.push(X)}});try{typeof $=="function"?$.call(void 0,te):$[0].call($[1],te)}catch(X){(0,A.onUnexpectedError)(X);continue}Object.freeze(K),await M.settled(K).catch(X=>(0,A.onUnexpectedError)(X))}}}}e.AsyncEmitter=B;var M;(function(F){async function T(H){return typeof Promise.allSettled=="function"?U(H):N(H)}F.allSettled=T;async function U(H){return Promise.allSettled(H)}async function N(H){return Promise.all(H.map(K=>K.then(te=>({status:"fulfilled",value:te}),te=>({status:"rejected",reason:te}))))}async function $(H){let K;const te=await Promise.all(H.map(X=>X.then(ie=>ie,ie=>{K||(K=ie)})));if(typeof K!="undefined")throw K;return te}F.settled=$})(M=e.Promises||(e.Promises={}))}),define(Q[90],Z([0,1,21,42,8,37,6]),function(G,e,v,A,k,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function L(){return Object.create(null)}e.getEmptyExpression=L;const g="**",S="/",I="[/\\\\]",h="[^/\\\\]",w=/\//g;function D(U){switch(U){case 0:return"";case 1:return`${h}*?`;default:return`(?:${I}|${h}+${I}|${I}${h}+)*?`}}function a(U,N){if(!U)return[];const $=[];let H=!1,K=!1,te="";for(const X of U){switch(X){case N:if(!H&&!K){$.push(te),te="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":K=!0;break;case"]":K=!1;break}te+=X}return te&&$.push(te),$}e.splitGlobAware=a;function C(U){if(!U)return"";let N="";const $=a(U,S);if($.every(H=>H===g))N=".*";else{let H=!1;$.forEach((K,te)=>{if(K===g){H||(N+=D(2),H=!0);return}let X=!1,ie="",se=!1,ce="";for(const he of K){if(he!=="}"&&X){ie+=he;continue}if(se&&(he!=="]"||!ce)){let me;he==="-"?me=he:(he==="^"||he==="!")&&!ce?me="^":he===S?me="":me=v.escapeRegExpCharacters(he),ce+=me;continue}switch(he){case"{":X=!0;continue;case"[":se=!0;continue;case"}":N+=`(?:${a(ie,",").map(Ie=>C(Ie)).join("|")})`,X=!1,ie="";break;case"]":N+="["+ce+"]",se=!1,ce="";break;case"?":N+=h;continue;case"*":N+=D(1);continue;default:N+=v.escapeRegExpCharacters(he)}}te<$.length-1&&($[te+1]!==g||te+2<$.length)&&(N+=I),H=!1})}return N}const b=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),n=function(){return!1},r=function(){return null};function c(U,N){if(!U)return r;let $;typeof U!="string"?$=U.pattern:$=U,$=$.trim();const H=`${$}_${!!N.trimForExclusions}`;let K=t.get(H);if(K)return s(K,U);let te;if(b.test($)){const X=$.substr(4);K=function(ie,se){return typeof ie=="string"&&ie.endsWith(X)?$:null}}else(te=p.exec(l($,N)))?K=d(te[1],$):(N.trimForExclusions?m:E).test($)?K=f($,N):(te=o.exec(l($,N)))?K=y(te[1].substr(1),$,!0):(te=i.exec(l($,N)))?K=y(te[1],$,!1):K=u($);return t.set(H,K),s(K,U)}function s(U,N){return typeof N=="string"?U:function($,H){return A.isEqualOrParent($,N.base)?U(k.relative(N.base,$),H):null}}function l(U,N){return N.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function d(U,N){const $=`/${U}`,H=`\\${U}`,K=function(X,ie){return typeof X!="string"?null:ie?ie===U?N:null:X===U||X.endsWith($)||X.endsWith(H)?N:null},te=[U];return K.basenames=te,K.patterns=[N],K.allBasenames=te,K}function f(U,N){const $=T(U.slice(1,-1).split(",").map(ie=>c(ie,N)).filter(ie=>ie!==r),U),H=$.length;if(!H)return r;if(H===1)return $[0];const K=function(ie,se){for(let ce=0,he=$.length;ce<he;ce++)if($[ce](ie,se))return U;return null},te=$.find(ie=>!!ie.allBasenames);te&&(K.allBasenames=te.allBasenames);const X=$.reduce((ie,se)=>se.allPaths?ie.concat(se.allPaths):ie,[]);return X.length&&(K.allPaths=X),K}function y(U,N,$){const H=k.sep===k.posix.sep,K=H?U:U.replace(w,k.sep),te=k.sep+K,X=k.posix.sep+U,ie=$?function(se,ce){return typeof se=="string"&&(se===K||se.endsWith(te)||!H&&(se===U||se.endsWith(X)))?N:null}:function(se,ce){return typeof se=="string"&&(se===K||!H&&se===U)?N:null};return ie.allPaths=[($?"*/":"./")+U],ie}function u(U){try{const N=new RegExp(`^${C(U)}$`);return function($){return N.lastIndex=0,typeof $=="string"&&N.test($)?U:null}}catch(N){return r}}function P(U,N,$){return!U||typeof N!="string"?!1:_(U)(N,void 0,$)}e.match=P;function _(U,N={}){if(!U)return n;if(typeof U=="string"||q(U)){const $=c(U,N);if($===r)return n;const H=function(K,te){return!!$(K,te)};return $.allBasenames&&(H.allBasenames=$.allBasenames),$.allPaths&&(H.allPaths=$.allPaths),H}return M(U,N)}e.parse=_;function z(U){if(!!U){let N;return $=>(N||(N=(U()||Promise.resolve([])).then(H=>H?W(H):{})),N.then(H=>!!H[$]))}}e.hasSiblingPromiseFn=z;function j(U){if(!!U){let N;return $=>{if(!N){const H=U();N=H?W(H):{}}return!!N[$]}}}e.hasSiblingFn=j;function W(U){const N={};for(const $ of U)N[$]=!0;return N}function q(U){const N=U;return N&&typeof N.base=="string"&&typeof N.pattern=="string"}e.isRelativePattern=q;function x(U){return U.allBasenames||[]}e.getBasenameTerms=x;function B(U){return U.allPaths||[]}e.getPathTerms=B;function M(U,N){const $=T(Object.getOwnPropertyNames(U).map(ie=>F(ie,U[ie],N)).filter(ie=>ie!==r)),H=$.length;if(!H)return r;if(!$.some(ie=>!!ie.requiresSiblings)){if(H===1)return $[0];const ie=function(he,me){for(let we=0,Ie=$.length;we<Ie;we++){const Te=$[we](he,me);if(Te)return Te}return null},se=$.find(he=>!!he.allBasenames);se&&(ie.allBasenames=se.allBasenames);const ce=$.reduce((he,me)=>me.allPaths?he.concat(me.allPaths):he,[]);return ce.length&&(ie.allPaths=ce),ie}const K=function(ie,se,ce){let he;for(let me=0,we=$.length;me<we;me++){const Ie=$[me];Ie.requiresSiblings&&ce&&(se||(se=k.basename(ie)),he||(he=se.substr(0,se.length-k.extname(ie).length)));const Te=Ie(ie,se,he,ce);if(Te)return Te}return null},te=$.find(ie=>!!ie.allBasenames);te&&(K.allBasenames=te.allBasenames);const X=$.reduce((ie,se)=>se.allPaths?ie.concat(se.allPaths):ie,[]);return X.length&&(K.allPaths=X),K}function F(U,N,$){if(N===!1)return r;const H=c(U,$);if(H===r)return r;if(typeof N=="boolean")return H;if(N){const K=N.when;if(typeof K=="string"){const te=(X,ie,se,ce)=>{if(!ce||!H(X,ie))return null;const he=K.replace("$(basename)",se),me=ce(he);return(0,O.isThenable)(me)?me.then(we=>we?U:null):me?U:null};return te.requiresSiblings=!0,te}}return H}function T(U,N){const $=U.filter(ie=>!!ie.basenames);if($.length<2)return U;const H=$.reduce((ie,se)=>{const ce=se.basenames;return ce?ie.concat(ce):ie},[]);let K;if(N){K=[];for(let ie=0,se=H.length;ie<se;ie++)K.push(N)}else K=$.reduce((ie,se)=>{const ce=se.patterns;return ce?ie.concat(ce):ie},[]);const te=function(ie,se){if(typeof ie!="string")return null;if(!se){let he;for(he=ie.length;he>0;he--){const me=ie.charCodeAt(he-1);if(me===47||me===92)break}se=ie.substr(he)}const ce=H.indexOf(se);return ce!==-1?K[ce]:null};te.basenames=H,te.patterns=K,te.allBasenames=H;const X=U.filter(ie=>!ie.basenames);return X.push(te),X}}),define(Q[91],Z([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function A(I){return I.toJSON()}class k{constructor(h){this._uriTransformer=h}transformIncoming(h){const w=this._uriTransformer.transformIncoming(h);return w===h?h:A(v.URI.from(w))}transformOutgoing(h){const w=this._uriTransformer.transformOutgoing(h);return w===h?h:A(v.URI.from(w))}transformOutgoingURI(h){const w=this._uriTransformer.transformOutgoing(h);return w===h?h:v.URI.from(w)}transformOutgoingScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,h,w){if(!I||w>200)return null;if(typeof I=="object"){if(I instanceof v.URI)return h.transformOutgoing(I);for(let D in I)if(Object.hasOwnProperty.call(I,D)){const a=R(I[D],h,w+1);a!==null&&(I[D]=a)}}return null}function O(I,h){const w=R(I,h,0);return w===null?I:w}e.transformOutgoingURIs=O;function L(I,h,w,D){if(!I||D>200)return null;if(typeof I=="object"){if(I.$mid===1)return w?v.URI.revive(h.transformIncoming(I)):h.transformIncoming(I);for(let a in I)if(Object.hasOwnProperty.call(I,a)){const C=L(I[a],h,w,D+1);C!==null&&(I[a]=C)}}return null}function g(I,h){const w=L(I,h,!1,0);return w===null?I:w}e.transformIncomingURIs=g;function S(I,h){const w=L(I,h,!0,0);return w===null?I:w}e.transformAndReviveIncomingURIs=S}),define(Q[30],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(g){return v.test(g)}e.isUUID=A;const k=new Uint8Array(16),R=[];for(let g=0;g<256;g++)R.push(g.toString(16).padStart(2,"0"));let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(g){for(let S=0;S<g.length;S++)g[S]=Math.floor(Math.random()*256);return g};function L(){O(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let g=0,S="";return S+=R[k[g++]],S+=R[k[g++]],S+=R[k[g++]],S+=R[k[g++]],S+="-",S+=R[k[g++]],S+=R[k[g++]],S+="-",S+=R[k[g++]],S+=R[k[g++]],S+="-",S+=R[k[g++]],S+=R[k[g++]],S+="-",S+=R[k[g++]],S+=R[k[g++]],S+=R[k[g++]],S+=R[k[g++]],S+=R[k[g++]],S+=R[k[g++]],S}e.generateUuid=L}),define(Q[66],Z([0,1,201]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class A{constructor(R="utf8"){this.stringDecoder=new v.StringDecoder(R),this.remaining=null}write(R){const O=[],L=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(L.length<1)return O;let g=0,S,I=g;for(;I<L.length;)if(S=L.charCodeAt(I),S===13||S===10){if(O.push(L.substring(g,I)),I++,I<L.length){const h=S;S=L.charCodeAt(I),(h===13&&S===10||h===10&&S===13)&&I++}g=I}else I++;return this.remaining=g<L.length?L.substr(g):null,O}end(){return this.remaining}}e.LineDecoder=A}),define(Q[92],Z([0,1,38]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(L){const g=L.replace(/\-/g,":").toLowerCase();return!A.has(g)}function R(){return new Promise(async(L,g)=>{const S=setTimeout(()=>g("Unable to retrieve mac address (timeout after 10s)"),1e4);try{L(await O())}catch(I){g(I)}finally{clearTimeout(S)}})}e.getMac=R;function O(){return new Promise((L,g)=>{try{const S=(0,v.networkInterfaces)();for(const[,I]of Object.entries(S))for(const h of I)if(k(h.mac))return L(h.mac);g("Unable to retrieve mac address (unexpected format)")}catch(S){g(S)}})}}),define(Q[93],Z([0,1,15,30,38,37,92]),function(G,e,v,A,k,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,h=0;const w=(0,k.networkInterfaces)();for(let D in w)if(Object.prototype.hasOwnProperty.call(w,D))for(const{mac:a,internal:C}of w[D])C||(h+=1,this._isVirtualMachineMacAdress(a.toUpperCase())&&(I+=1));this._value=h>0?I/h:0}return this._value}};let L;async function g(){return L||(L=(async()=>await S()||A.generateUuid())()),L}e.getMachineId=g;async function S(){try{const I=await new Promise((w,D)=>{G(["crypto"],w,D)}),h=await(0,O.getMac)();return I.createHash("sha256").update(h,"utf8").digest("hex")}catch(I){v.onUnexpectedError(I);return}}}),define(Q[23],Z([0,1,27,38,8,6,7,42,30,65,11,5]),function(G,e,v,A,k,R,O,L,g,S,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var w;(function(x){x[x.UNLINK=0]="UNLINK",x[x.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function D(x,B=w.UNLINK){if((0,L.isRootOrDriveLetter)(x))throw new Error("rimraf - will refuse to recursively delete root");return B===w.UNLINK?C(x):a(x)}e.rimraf=D;async function a(x){try{const B=(0,k.join)((0,A.tmpdir)(),(0,g.generateUuid)());try{await v.promises.rename(x,B)}catch(M){return C(x)}C(B).catch(M=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function C(x){return v.promises.rmdir(x,{recursive:!0,maxRetries:3})}function b(x){if((0,L.isRootOrDriveLetter)(x))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(x,{recursive:!0})}e.rimrafSync=b;async function p(x,B){return o(await(B?E(x):v.promises.readdir(x)))}e.readdir=p;async function E(x){try{return await v.promises.readdir(x,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const B=[],M=await p(x);for(const F of M){let T=!1,U=!1,N=!1;try{const $=await v.promises.lstat((0,k.join)(x,F));T=$.isFile(),U=$.isDirectory(),N=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}B.push({name:F,isFile:()=>T,isDirectory:()=>U,isSymbolicLink:()=>N})}return B}function m(x){return o(v.readdirSync(x))}e.readdirSync=m;function o(x){return x.map(B=>typeof B=="string"?O.isMacintosh?(0,S.normalizeNFC)(B):B:(B.name=O.isMacintosh?(0,S.normalizeNFC)(B.name):B.name,B))}async function i(x){const B=await p(x),M=[];for(const F of B)await n.existsDirectory((0,k.join)(x,F))&&M.push(F);return M}e.readDirsInDir=i;function t(x,B=1e3){return new Promise(M=>{let F=!1;const T=setInterval(()=>{F||(F=!0,v.access(x,U=>{F=!1,U&&(clearInterval(T),M(void 0))}))},B)})}e.whenDeleted=t;var n;(function(x){async function B(T){let U;try{if(U=await v.promises.lstat(T),!U.isSymbolicLink())return{stat:U}}catch(N){}try{return{stat:await v.promises.stat(T),symbolicLink:(U==null?void 0:U.isSymbolicLink())?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(O.isWindows&&N.code==="EACCES")try{return{stat:await v.promises.stat(await v.promises.readlink(T)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw $}throw N}}x.stat=B;async function M(T){try{const{stat:U,symbolicLink:N}=await x.stat(T);return U.isFile()&&(N==null?void 0:N.dangling)!==!0}catch(U){}return!1}x.existsFile=M;async function F(T){try{const{stat:U,symbolicLink:N}=await x.stat(T);return U.isDirectory()&&(N==null?void 0:N.dangling)!==!0}catch(U){}return!1}x.existsDirectory=F})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new R.ResourceQueue;function c(x,B,M){return r.queueFor(h.URI.file(x),I.extUriBiasedIgnorePathCase).queue(()=>{const F=f(M);return new Promise((T,U)=>l(x,B,F,N=>N?U(N):T()))})}e.writeFile=c;let s=!0;function l(x,B,M,F){if(!s)return v.writeFile(x,B,{mode:M.mode,flag:M.flag},F);v.open(x,M.flag,M.mode,(T,U)=>{if(T)return F(T);v.writeFile(U,B,N=>{if(N)return v.close(U,()=>F(N));v.fdatasync(U,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),s=!1),v.close(U,H=>F(H))))})})}function d(x,B,M){const F=f(M);if(!s)return v.writeFileSync(x,B,{mode:F.mode,flag:F.flag});const T=v.openSync(x,F.flag,F.mode);try{v.writeFileSync(T,B);try{v.fdatasyncSync(T)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),s=!1}}finally{v.closeSync(T)}}e.writeFileSync=d;function f(x){return x?{mode:typeof x.mode=="number"?x.mode:438,flag:typeof x.flag=="string"?x.flag:"w"}:{mode:438,flag:"w"}}async function y(x,B){if(x!==B){async function M(F){try{const T=await v.promises.lstat(F);if(T.isDirectory()||T.isSymbolicLink())return;const U=await v.promises.open(F,"a");try{await U.utimes(T.atime,new Date)}finally{await U.close()}}catch(T){}}try{await v.promises.rename(x,B),await M(B)}catch(F){if(x.toLowerCase()!==B.toLowerCase()&&F.code==="EXDEV"||x.endsWith("."))await u(x,B,{preserveSymlinks:!1}),await D(x,w.MOVE),await M(B);else throw F}}}e.move=y;async function u(x,B,M){return _(x,B,{root:{source:x,target:B},options:M,handledSourcePaths:new Set})}e.copy=u;const P=511;async function _(x,B,M){if(!M.handledSourcePaths.has(x)){M.handledSourcePaths.add(x);const{stat:F,symbolicLink:T}=await n.stat(x);if(T){if(M.options.preserveSymlinks)try{return await W(x,B,M)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(T.dangling)return}return F.isDirectory()?z(x,B,F.mode&P,M):j(x,B,F.mode&P)}}async function z(x,B,M,F){await v.promises.mkdir(B,{recursive:!0,mode:M});const T=await p(x);for(const U of T)await _((0,k.join)(x,U),(0,k.join)(B,U),F)}async function j(x,B,M){await v.promises.copyFile(x,B),await v.promises.chmod(B,M)}async function W(x,B,M){let F=await v.promises.readlink(x);(0,L.isEqualOrParent)(F,M.root.source,!O.isLinux)&&(F=(0,k.join)(M.root.target,F.substr(M.root.source.length+1))),await v.promises.symlink(F,B)}async function q(x){try{return await v.promises.access(x),!0}catch(B){return!1}}e.exists=q}),define(Q[94],Z([0,1,27,21,8,23]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function O(I){const h=(0,k.dirname)(I);if(I===h)return I;const w=((0,k.basename)(I)||I).toLowerCase();try{const a=(0,R.readdirSync)(h).filter(C=>C.toLowerCase()===w);if(a.length===1){const C=O(h);if(C)return(0,k.join)(C,a[0])}else if(a.length>1){const C=a.indexOf(w);if(C>=0){const b=O(h);if(b)return(0,k.join)(b,a[C])}}}catch(D){}return null}e.realcaseSync=O;async function L(I){try{return await v.promises.realpath(I)}catch(h){const w=S(I);return await v.promises.access(w,v.constants.R_OK),w}}e.realpath=L;function g(I){try{return v.realpathSync(I)}catch(h){const w=S(I);return v.accessSync(w,v.constants.R_OK),w}}e.realpathSync=g;function S(I){return(0,A.rtrim)((0,k.normalize)(I),k.sep)}}),define(Q[95],Z([0,1,48,16]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(O){return new Promise((L,g)=>{let S;const I=new Map;function h(a,C,b,p,E){const m=I.get(C);if(a===O||m){const o={name:w(b),cmd:b,pid:a,ppid:C,load:p,mem:E};I.set(a,o),a===O&&(S=o),m&&(m.children||(m.children=[]),m.children.push(o),m.children.length>1&&(m.children=m.children.sort((i,t)=>i.pid-t.pid)))}}function w(a){const C=/--disable-blink-features=Auxclick/,b=/\\watcher\\win32\\CodeHelper\.exe/,p=/--crashes-directory/,E=/\\pipe\\winpty-control/,m=/conhost\.exe/,o=/--type=([a-zA-Z-]+)/;if(b.exec(a))return"watcherService ";if(p.exec(a))return"electron-crash-reporter";if(E.exec(a))return"winpty-process";if(m.exec(a))return"console-window-host (Windows internal process)";let i=o.exec(a);if(i&&i.length===2)return i[1]==="renderer"?C.exec(a)?"shared-process":"window":i[1];const t=/[a-zA-Z-]+\.js/g;let n="";do i=t.exec(a),i&&(n+=i+" ");while(i);return n&&a.indexOf("node ")<0&&a.indexOf("node.exe")<0?`electron_node ${n}`:a}if(process.platform==="win32"){const a=C=>C.indexOf("\\\\?\\")===0||C.indexOf("\\??\\")===0?C.substr(4):C.indexOf('"\\\\?\\')===0||C.indexOf('"\\??\\')===0?'"'+C.substr(5):C;new Promise((C,b)=>{G(["windows-process-tree"],C,b)}).then(C=>{C.getProcessList(O,b=>{C.getProcessCpuUsage(b,p=>{const E=new Map;p.forEach(m=>{const o=a(m.commandLine||"");E.set(m.pid,{name:w(o),cmd:o,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),S=E.get(O),S?(E.forEach(m=>{const o=E.get(m.ppid);o&&(o.children||(o.children=[]),o.children.push(m))}),E.forEach(m=>{m.children&&(m.children=m.children.sort((o,i)=>o.pid-i.pid))}),L(S)):g(new Error(`Root process ${O} not found`))})},C.ProcessDataFlag.CommandLine|C.ProcessDataFlag.Memory)})}else{function D(){let a=[S];const C=[];for(;a.length;){const p=a.shift();p&&(C.push(p.pid),p.children&&(a=a.concat(p.children)))}let b=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",G).fsPath);b+=" "+C.join(" "),(0,v.exec)(b,{},(p,E,m)=>{if(p||m)g(p||new Error(m.toString()));else{const o=E.toString().split(`
`);for(let i=0;i<C.length;i++){const t=I.get(C[i]);t.load=parseFloat(o[i])}if(!S){g(new Error(`Root process ${O} not found`));return}L(S)}})}(0,v.exec)("which ps",{},(a,C,b)=>{if(a||b)if(process.platform!=="linux")g(a||new Error(b.toString()));else{const p=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh",G).fsPath);(0,v.exec)(p,{},(E,m,o)=>{E||o?g(E||new Error(o.toString())):(R(m,h),D())})}else{const p=C.toString().trim(),E="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${p} ${E}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,o,i)=>{m||i&&!i.includes("screen size is bogus")?g(m||new Error(i.toString())):(R(o,h),process.platform==="linux"?D():S?L(S):g(new Error(`Root process ${O} not found`)))})}})}})}e.listProcesses=k;function R(O,L){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=O.toString().split(`
`);for(const I of S){const h=g.exec(I.trim());h&&h.length===6&&L(parseInt(h[1]),parseInt(h[2]),h[5],parseFloat(h[3]),parseFloat(h[4]))}}}),function(){"use strict";function G(e,v,A){function k(){let R=process.env.VSCODE_APPDATA;if(!R)switch(process.platform){case"win32":if(R=process.env.APPDATA,!R){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");R=e.join(O,"AppData","Roaming")}break;case"darwin":R=e.join(v.homedir(),"Library","Application Support");break;case"linux":R=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(R,A)}return{getDefaultUserDataPath:k}}if(typeof define=="function")define(Q[96],Z([0,202,38,16,11]),function(e,v,A,k,R){const O=R.dirname(k.FileAccess.asFileUri("",e)),L=e.__$__nodeRequire(R.joinPath(O,"package.json").fsPath);return G(v,A,L.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../package.json"),v=require("path"),A=require("os");module.exports=G(v,A,e.name)}else throw new Error("Unknown context")}(),define(Q[97],Z([0,1,8,27,7,65,2,23]),function(G,e,v,A,k,R,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function g(h,w,D){return I({path:h,isDirectory:!1},w,D)}e.watchFile=g;function S(h,w,D){return I({path:h,isDirectory:!0},w,D)}e.watchFolder=S,e.CHANGE_BUFFER_DELAY=100;function I(h,w,D){const a=(0,v.basename)(h.path),C=new Map;let b=!1,p=[(0,O.toDisposable)(()=>{C.forEach(E=>(0,O.dispose)(E)),C.clear()})];try{const E=(0,A.watch)(h.path);p.push((0,O.toDisposable)(()=>{E.removeAllListeners(),E.close()}));const m=new Set;h.isDirectory&&(0,L.readdir)(h.path).then(o=>o.forEach(i=>m.add(i))),E.on("error",(o,i)=>{b||D(`Failed to watch ${h.path} for changes using fs.watch() (${o}, ${i})`)}),E.on("change",(o,i)=>{if(!b){let t="";if(i&&(t=i.toString(),k.isMacintosh&&(t=(0,R.normalizeNFC)(t))),!(!t||o!=="change"&&o!=="rename")){const n=h.isDirectory?(0,v.join)(h.path,t):h.path;if(h.isDirectory)if(o==="rename"){const r=C.get(n);r&&(0,O.dispose)(r);const c=setTimeout(async()=>{C.delete(n);const s=await(0,L.exists)(n);if(!b){let l;s?m.has(t)?l="changed":(l="added",m.add(t)):(m.delete(t),l="deleted"),w(l,n)}},e.CHANGE_BUFFER_DELAY);C.set(n,(0,O.toDisposable)(()=>clearTimeout(c)))}else{let r;m.has(t)?r="changed":(r="added",m.add(t)),w(r,n)}else if(o==="rename"||t!==a){const r=setTimeout(async()=>{const c=await(0,L.exists)(n);b||(c?(w("changed",n),p=[I(h,w,D)]):w("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,O.dispose)(p),p=[(0,O.toDisposable)(()=>clearTimeout(r))]}else w("changed",n)}}})}catch(E){(0,L.exists)(h.path).then(m=>{m&&!b&&D(`Failed to watch ${h.path} for changes using fs.watch() (${E.toString()})`)})}return(0,O.toDisposable)(()=>{b=!0,p=(0,O.dispose)(p)})}}),define(Q[33],Z([0,1,3,2,6,29,15,22,18,17,89,21]),function(G,e,v,A,k,R,O,L,g,S,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function D(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function C(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(b||(b={}));class p{constructor(T){this.buffer=T,this.pos=0}read(T){const U=this.buffer.slice(this.pos,this.pos+T);return this.pos+=U.byteLength,U}}class E{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}var m;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(m||(m={}));function o(F){const T=L.VSBuffer.alloc(4);return T.writeUInt32BE(F,0),T}function i(F){return F.read(4).readUInt32BE(0)}function t(F){const T=L.VSBuffer.alloc(1);return T.writeUInt8(F,0),T}const n={Undefined:t(m.Undefined),String:t(m.String),Buffer:t(m.Buffer),VSBuffer:t(m.VSBuffer),Array:t(m.Array),Object:t(m.Object)},r=typeof Buffer!="undefined";function c(F,T){if(typeof T=="undefined")F.write(n.Undefined);else if(typeof T=="string"){const U=L.VSBuffer.fromString(T);F.write(n.String),F.write(o(U.byteLength)),F.write(U)}else if(r&&Buffer.isBuffer(T)){const U=L.VSBuffer.wrap(T);F.write(n.Buffer),F.write(o(U.byteLength)),F.write(U)}else if(T instanceof L.VSBuffer)F.write(n.VSBuffer),F.write(o(T.byteLength)),F.write(T);else if(Array.isArray(T)){F.write(n.Array),F.write(o(T.length));for(const U of T)c(F,U)}else{const U=L.VSBuffer.fromString(JSON.stringify(T));F.write(n.Object),F.write(o(U.byteLength)),F.write(U)}}function s(F){switch(F.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return F.read(i(F)).toString();case m.Buffer:return F.read(i(F)).buffer;case m.VSBuffer:return F.read(i(F));case m.Array:{const U=i(F),N=[];for(let $=0;$<U;$++)N.push(s(F));return N}case m.Object:return JSON.parse(F.read(i(F)).toString())}}class l{constructor(T,U,N=null,$=1e3){this.protocol=T,this.ctx=U,this.logger=N,this.timeoutDelay=$,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:200})}registerChannel(T,U){this.channels.set(T,U),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const U=this.send([T.type]);this.logger&&this.logger.logOutgoing(U,0,1,C(T.type));return}case 201:case 202:case 204:case 203:{const U=this.send([T.type,T.id],T.data);this.logger&&this.logger.logOutgoing(U,T.id,1,C(T.type),T.data);return}}}send(T,U=void 0){const N=new E;return c(N,T),c(N,U),this.sendBuffer(N.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(U){return 0}}onRawMessage(T){const U=new p(T),N=s(U),$=s(U),H=N[0];switch(H){case 100:return this.logger&&this.logger.logIncoming(T.byteLength,N[1],1,`${D(H)}: ${N[2]}.${N[3]}`,$),this.onPromise({type:H,id:N[1],channelName:N[2],name:N[3],arg:$});case 102:return this.logger&&this.logger.logIncoming(T.byteLength,N[1],1,`${D(H)}: ${N[2]}.${N[3]}`,$),this.onEventListen({type:H,id:N[1],channelName:N[2],name:N[3],arg:$});case 101:return this.logger&&this.logger.logIncoming(T.byteLength,N[1],1,`${D(H)}`),this.disposeActiveRequest({type:H,id:N[1]});case 103:return this.logger&&this.logger.logIncoming(T.byteLength,N[1],1,`${D(H)}`),this.disposeActiveRequest({type:H,id:N[1]})}}onPromise(T){const U=this.channels.get(T.channelName);if(!U){this.collectPendingRequest(T);return}const N=new R.CancellationTokenSource;let $;try{$=U.call(this.ctx,T.name,T.arg,N.token)}catch(te){$=Promise.reject(te)}const H=T.id;$.then(te=>{this.sendResponse({id:H,data:te,type:201}),this.activeRequests.delete(T.id)},te=>{te instanceof Error?this.sendResponse({id:H,data:{message:te.message,name:te.name,stack:te.stack?te.stack.split?te.stack.split(`
`):te.stack:void 0},type:202}):this.sendResponse({id:H,data:te,type:203}),this.activeRequests.delete(T.id)});const K=(0,A.toDisposable)(()=>N.cancel());this.activeRequests.set(T.id,K)}onEventListen(T){const U=this.channels.get(T.channelName);if(!U){this.collectPendingRequest(T);return}const N=T.id,H=U.listen(this.ctx,T.name,T.arg)(K=>this.sendResponse({id:N,data:K,type:204}));this.activeRequests.set(T.id,H)}disposeActiveRequest(T){const U=this.activeRequests.get(T.id);U&&(U.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let U=this.pendingRequests.get(T.channelName);U||(U=[],this.pendingRequests.set(T.channelName,U));const N=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);U.push({request:T,timeoutTimer:N})}flushPendingRequests(T){const U=this.pendingRequests.get(T);if(U){for(const N of U)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var d;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class f{constructor(T,U=null){this.protocol=T,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=U}getChannel(T){const U=this;return{call(N,$,H){return U.isDisposed?Promise.reject(O.canceled()):U.requestPromise(T,N,$,H)},listen(N,$){return U.isDisposed?Promise.reject(O.canceled()):U.requestEvent(T,N,$)}}}requestPromise(T,U,N,$=R.CancellationToken.None){const H=this.lastRequestId++,te={id:H,type:100,channelName:T,name:U,arg:N};if($.isCancellationRequested)return Promise.reject(O.canceled());let X;return new Promise((se,ce)=>{if($.isCancellationRequested)return ce(O.canceled());const he=()=>{const Te=ke=>{switch(ke.type){case 201:this.handlers.delete(H),se(ke.data);break;case 202:this.handlers.delete(H);const Fe=new Error(ke.data.message);Fe.stack=ke.data.stack,Fe.name=ke.data.name,ce(Fe);break;case 203:this.handlers.delete(H),ce(ke.data);break}};this.handlers.set(H,Te),this.sendRequest(te)};let me=null;this.state===b.Idle?he():(me=(0,k.createCancelablePromise)(Te=>this.whenInitialized()),me.then(()=>{me=null,he()}));const we=()=>{me?(me.cancel(),me=null):this.sendRequest({id:H,type:101}),ce(O.canceled())},Ie=$.onCancellationRequested(we);X=(0,A.combinedDisposable)((0,A.toDisposable)(we),Ie),this.activeRequests.add(X)}).finally(()=>{this.activeRequests.delete(X)})}requestEvent(T,U,N){const $=this.lastRequestId++,K={id:$,type:102,channelName:T,name:U,arg:N};let te=null;const X=new v.Emitter({onFirstListenerAdd:()=>{te=(0,k.createCancelablePromise)(se=>this.whenInitialized()),te.then(()=>{te=null,this.activeRequests.add(X),this.sendRequest(K)})},onLastListenerRemove:()=>{te?(te.cancel(),te=null):(this.activeRequests.delete(X),this.sendRequest({id:$,type:103}))}}),ie=se=>X.fire(se.data);return this.handlers.set($,ie),X.event}sendRequest(T){switch(T.type){case 100:case 102:{const U=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger&&this.logger.logOutgoing(U,T.id,0,`${D(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const U=this.send([T.type,T.id]);this.logger&&this.logger.logOutgoing(U,T.id,0,D(T.type));return}}}send(T,U=void 0){const N=new E;return c(N,T),c(N,U),this.sendBuffer(N.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(U){return 0}}onBuffer(T){const U=new p(T),N=s(U),$=s(U),H=N[0];switch(H){case 200:return this.logger&&this.logger.logIncoming(T.byteLength,0,0,C(H)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(T.byteLength,N[1],0,C(H),$),this.onResponse({type:N[0],id:N[1],data:$})}}onResponse(T){if(T.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const U=this.handlers.get(T.id);U&&U(T)}whenInitialized(){return this.state===b.Idle?Promise.resolve():v.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelClient=f;class y{constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:U,onDidClientDisconnect:N})=>{v.Event.once(U.onMessage)(H=>{const K=new p(H),te=s(K),X=new l(U,te),ie=new f(U);this.channels.forEach((ce,he)=>X.registerChannel(he,ce));const se={channelServer:X,channelClient:ie,ctx:te};this._connections.add(se),this._onDidAddConnection.fire(se),N(()=>{X.dispose(),ie.dispose(),this._connections.delete(se),this._onDidRemoveConnection.fire(se)})})})}get connections(){const T=[];return this._connections.forEach(U=>T.push(U)),T}getChannel(T,U){const N=this;return{call($,H,K){let te;if((0,S.isFunction)(U)){let ie=(0,g.getRandomElement)(N.connections.filter(U));te=ie?Promise.resolve(ie):v.Event.toPromise(v.Event.filter(N.onDidAddConnection,U))}else te=U.routeCall(N,$,H);const X=te.then(ie=>ie.channelClient.getChannel(T));return P(X).call($,H,K)},listen($,H){if((0,S.isFunction)(U))return N.getMulticastEvent(T,U,$,H);const K=U.routeEvent(N,$,H).then(te=>te.channelClient.getChannel(T));return P(K).listen($,H)}}}getMulticastEvent(T,U,N,$){const H=this;let K=new A.DisposableStore;const te=new v.Emitter({onFirstListenerAdd:()=>{K=new A.DisposableStore;const X=new v.EventMultiplexer,ie=new Map,se=he=>{const we=he.channelClient.getChannel(T).listen(N,$),Ie=X.add(we);ie.set(he,Ie)},ce=he=>{const me=ie.get(he);!me||(me.dispose(),ie.delete(he))};H.connections.filter(U).forEach(se),v.Event.filter(H.onDidAddConnection,U)(se,void 0,K),H.onDidRemoveConnection(ce,void 0,K),X.event(te.fire,te,K),K.add(X)},onLastListenerRemove:()=>{K.dispose()}});return te.event}registerChannel(T,U){this.channels.set(T,U),this._connections.forEach(N=>{N.channelServer.registerChannel(T,U)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=y;class u{constructor(T,U,N=null){const $=new E;c($,U),T.send($.buffer),this.channelClient=new f(T,N),this.channelServer=new l(T,U,N)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,U){this.channelServer.registerChannel(T,U)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=u;function P(F){return{call(T,U,N){return F.then($=>$.call(T,U,N))},listen(T,U){const N=new v.Relay;return F.then($=>N.input=$.listen(T,U)),N.event}}}e.getDelayedChannel=P;function _(F){let T=!1;return{call(U,N,$){return T?F.call(U,N,$):(0,k.timeout)(0).then(()=>T=!0).then(()=>F.call(U,N,$))},listen(U,N){if(T)return F.listen(U,N);const $=new v.Relay;return(0,k.timeout)(0).then(()=>T=!0).then(()=>$.input=F.listen(U,N)),$.event}}}e.getNextTickChannel=_;class z{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const U of T.connections)if(await Promise.resolve(this.fn(U.ctx)))return Promise.resolve(U);return await v.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=z;var j;(function(F){function T($,H){const K=$,te=H&&H.disableMarshalling,X=new Map;for(const ie in K)N(ie)&&X.set(ie,v.Event.buffer(K[ie],!0));return new class{listen(ie,se){const ce=X.get(se);if(ce)return ce;throw new Error(`Event not found: ${se}`)}call(ie,se,ce){const he=K[se];if(typeof he=="function"){if(!te&&Array.isArray(ce))for(let me=0;me<ce.length;me++)ce[me]=(0,I.revive)(ce[me]);return he.apply(K,ce)}throw new Error(`Method not found: ${se}`)}}}F.fromService=T;function U($,H){const K=H&&H.disableMarshalling;return new Proxy({},{get(te,X){var ie;if(typeof X=="string")return((ie=H==null?void 0:H.properties)===null||ie===void 0?void 0:ie.has(X))?H.properties.get(X):N(X)?$.listen(X):async function(...se){let ce;H&&!(0,S.isUndefinedOrNull)(H.context)?ce=[H.context,...se]:ce=se;const he=await $.call(X,ce);return K?he:(0,I.revive)(he)};throw new Error(`Property not found: ${String(X)}`)}})}F.toService=U;function N($){return $[0]==="o"&&$[1]==="n"&&h.isUpperAsciiLetter($.charCodeAt(2))}})(j=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let T=F.toString();if(T!=="[object Object]")return T}return F}function x(F){return Array.isArray(F)?F.map(q):q(F)}function B(F,T,U,N,$,H,K){K=x(K);const te=W[$],X=te[N%te.length];let ie=[`%c[${F}]%c[${String(T).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${X}`];/\($/.test(H)?(ie=ie.concat(K),ie.push(")")):ie.push(K),console.log.apply(console,ie)}e.logWithColors=B;class M{constructor(T,U){this._outgoingPrefix=T,this._incomingPrefix=U,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,U,N,$,H){this._totalOutgoing+=T,B(this._outgoingPrefix,this._totalOutgoing,T,U,N,$,H)}logIncoming(T,U,N,$,H){this._totalIncoming+=T,B(this._incomingPrefix,this._totalIncoming,T,U,N,$,H)}}e.IPCLogger=M}),define(Q[98],Z([0,1,3,33,22]),function(G,e,v,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(g){this.port=g,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",S=>k.VSBuffer.wrap(S.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class O extends A.IPCClient{constructor(g,S){const I=new R(g);super(I,S);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=O}),define(Q[99],Z([0,1,100,3,33,98]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class O extends k.IPCServer{static getOnDidClientConnect(){const g=A.Event.fromNodeEventEmitter(v.ipcRenderer,"vscode:createMessageChannel",(S,I)=>I);return A.Event.map(g,S=>{const{port1:I,port2:h}=new MessageChannel,D={protocol:new R.Protocol(I),onDidClientDisconnect:A.Event.fromDOMEventEmitter(I,"close")};return v.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[h]),D})}constructor(){super(O.getOnDidClientConnect())}}e.Server=O}),define(Q[101],Z([0,1,15,22]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(L,g){L.proxyAuthorization&&(L.headers=Object.assign(Object.assign({},L.headers||{}),{"Proxy-Authorization":L.proxyAuthorization}));const S=new XMLHttpRequest;return new Promise((I,h)=>{S.open(L.type||"GET",L.url||"",!0,L.user,L.password),R(S,L),S.responseType="arraybuffer",S.onerror=w=>h(new Error(S.statusText&&"XHR failed: "+S.statusText||"XHR failed")),S.onload=w=>{I({res:{statusCode:S.status,headers:O(S)},stream:(0,A.bufferToStream)(A.VSBuffer.wrap(new Uint8Array(S.response)))})},S.ontimeout=w=>h(new Error(`XHR timeout: ${L.timeout}ms`)),L.timeout&&(S.timeout=L.timeout),S.send(L.data),g.onCancellationRequested(()=>{S.abort(),h((0,v.canceled)())})})}e.request=k;function R(L,g){if(g.headers){e:for(let S in g.headers){switch(S){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}L.setRequestHeader(S,g.headers[S])}}}function O(L){const g=Object.create(null);for(const S of L.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(S){const I=S.indexOf(":");g[S.substr(0,I).trim().toLowerCase()]=S.substr(I+1).trim()}return g}}),define(Q[102],Z([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.context=e.process=e.crashReporter=e.webFrame=e.ipcMessagePort=e.ipcRenderer=void 0,e.ipcRenderer=v.globals.vscode.ipcRenderer,e.ipcMessagePort=v.globals.vscode.ipcMessagePort,e.webFrame=v.globals.vscode.webFrame,e.crashReporter=v.globals.vscode.crashReporter,e.process=v.globals.vscode.process,e.context=v.globals.vscode.context}),define(Q[67],Z([0,1,2,3,6,17]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var O;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(O=e.StorageHint||(e.StorageHint={}));var L;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(L||(L={}));class g extends v.Disposable{constructor(h,w=Object.create(null)){super();this.database=h,this.options=w,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=L.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){var w,D;(w=h.changed)===null||w===void 0||w.forEach((a,C)=>this.accept(C,a)),(D=h.deleted)===null||D===void 0||D.forEach(a=>this.accept(a,void 0))}accept(h,w){if(this.state!==L.Closed){let D=!1;(0,R.isUndefinedOrNull)(w)?D=this.cache.delete(h):this.cache.get(h)!==w&&(this.cache.set(h,w),D=!0),D&&this._onDidChangeStorage.fire(h)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===L.None&&(this.state=L.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,w){const D=this.cache.get(h);return(0,R.isUndefinedOrNull)(D)?w:D}getBoolean(h,w){const D=this.get(h);return(0,R.isUndefinedOrNull)(D)?w:D==="true"}getNumber(h,w){const D=this.get(h);return(0,R.isUndefinedOrNull)(D)?w:parseInt(D,10)}async set(h,w){if(this.state!==L.Closed){if((0,R.isUndefinedOrNull)(w))return this.delete(h);const D=String(w);if(this.cache.get(h)!==D)return this.cache.set(h,D),this.pendingInserts.set(h,D),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(h){if(this.state!==L.Closed&&!!this.cache.delete(h))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=L.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(h){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{var w;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(w=this.whenFlushedCallbacks.pop())===null||w===void 0||w()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class S{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((w,D)=>this.items.set(D,w)),h.delete&&h.delete.forEach(w=>this.items.delete(w))}async close(){}}e.InMemoryStorageDatabase=S}),define(Q[103],Z([12,13]),function(G,e){return G.create("vs/base/common/date",e)}),define(Q[54],Z([0,1,103]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,k=A*60,R=k*24,O=R*7,L=R*30,g=R*365;function S(h,w){typeof h!="number"&&(h=h.getTime());const D=Math.round((new Date().getTime()-h)/1e3);if(D<-30)return(0,v.localize)(0,null,S(new Date().getTime()+D*1e3,!1));if(D<30)return(0,v.localize)(1,null);let a;return D<A?(a=D,w?a===1?(0,v.localize)(2,null,a):(0,v.localize)(3,null,a):a===1?(0,v.localize)(4,null,a):(0,v.localize)(5,null,a)):D<k?(a=Math.floor(D/A),w?a===1?(0,v.localize)(6,null,a):(0,v.localize)(7,null,a):a===1?(0,v.localize)(8,null,a):(0,v.localize)(9,null,a)):D<R?(a=Math.floor(D/k),w?a===1?(0,v.localize)(10,null,a):(0,v.localize)(11,null,a):a===1?(0,v.localize)(12,null,a):(0,v.localize)(13,null,a)):D<O?(a=Math.floor(D/R),w?a===1?(0,v.localize)(14,null,a):(0,v.localize)(15,null,a):a===1?(0,v.localize)(16,null,a):(0,v.localize)(17,null,a)):D<L?(a=Math.floor(D/O),w?a===1?(0,v.localize)(18,null,a):(0,v.localize)(19,null,a):a===1?(0,v.localize)(20,null,a):(0,v.localize)(21,null,a)):D<g?(a=Math.floor(D/L),w?a===1?(0,v.localize)(22,null,a):(0,v.localize)(23,null,a):a===1?(0,v.localize)(24,null,a):(0,v.localize)(25,null,a)):(a=Math.floor(D/g),w?a===1?(0,v.localize)(26,null,a):(0,v.localize)(27,null,a):a===1?(0,v.localize)(28,null,a):(0,v.localize)(29,null,a))}e.fromNow=S;function I(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(Q[104],Z([12,13]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(Q[43],Z([0,1,104,17,18]),function(G,e,v,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function R(S,I){return I&&(S.stack||S.stacktrace)?v.localize(0,null,L(S),O(S.stack)||O(S.stacktrace)):L(S)}function O(S){return Array.isArray(S)?S.join(`
`):S}function L(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?v.localize(1,null,S.message):S.message||v.localize(2,null)}function g(S=null,I=!1){if(!S)return v.localize(3,null);if(Array.isArray(S)){const h=k.coalesce(S),w=g(h[0],I);return h.length>1?v.localize(4,null,w,h.length):w}if(A.isString(S))return S;if(S.detail){const h=S.detail;if(h.error)return R(h.error,I);if(h.exception)return R(h.exception,I)}return S.stack?R(S,I):S.message?S.message:v.localize(5,null)}e.toErrorMessage=g}),define(Q[105],Z([12,13]),function(G,e){return G.create("vs/base/node/processes",e)}),define(Q[106],Z([0,1,8,27,23,48,105,17,26,42,7,66,16]),function(G,e,v,A,k,R,O,L,g,S,I,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function D(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(o,i){if(I.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};i&&(t.cwd=i);const n=R.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(r=>{n.once("error",c=>{r({success:!1,error:c})}),n.once("exit",(c,s)=>{r(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?D(t.status):1})}else if(I.isLinux||I.isMacintosh)try{const t=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(n=>{R.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,c,s)=>{n(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function C(o=process.env){return o.comspec||"cmd.exe"}e.getWindowsShell=C;class b{constructor(i,t,n,r){if(t!==void 0&&n!==void 0&&r!==void 0)this.cmd=i,this.args=t,this.shell=n,this.options=r;else{const c=i;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(process.env).forEach(s=>{c[s]=process.env[s]}),Object.keys(this.options.env).forEach(s=>{c[s]=this.options.env[s]}),this.options.env=c}}getSanitizedCommand(){let i=this.cmd.toLowerCase();const t=i.lastIndexOf(v.sep);return t!==-1&&(i=i.substring(t+1)),b.WellKnowCommands[i]?i:"other"}start(i){return I.isWindows&&(this.options&&this.options.cwd&&S.isUNC(this.options.cwd)||!this.options&&S.isUNC(process.cwd()))?Promise.reject(new Error(O.localize(0,null))):this.useExec().then(t=>{let n,r;const c=new Promise((s,l)=>{n=s,r=l});if(t){let s=this.cmd;this.args&&(s=s+" "+this.args.join(" ")),this.childProcess=R.exec(s,this.options,(l,d,f)=>{this.childProcess=null;const y=l;y&&y.killed?r({killed:this.terminateRequested,stdout:d.toString(),stderr:f.toString()}):this.handleExec(n,i,l,d,f)})}else{let s=null;const l=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,n,i,r);const f={terminated:this.terminateRequested};L.isNumber(d)&&(f.cmdCode=d),n(f)};if(this.shell&&I.isWindows){const d=g.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let f=!1,y=!1;const u=[];let P=this.ensureQuotes(this.cmd);u.push(P.value),f=P.quoted,this.args&&this.args.forEach(z=>{P=this.ensureQuotes(z),u.push(P.value),y=y&&P.quoted});const _=["/s","/c"];f?y?_.push('"'+u.join(" ")+'"'):u.length>1?_.push('"'+u[0]+'" '+u.slice(1).join(" ")):_.push('"'+u[0]+'"'):_.push(u.join(" ")),s=R.spawn(C(),_,d)}else this.cmd&&(s=R.spawn(this.cmd,this.args,this.options));s&&(this.childProcess=s,this.childProcessPromise=Promise.resolve(s),this.pidResolve&&(this.pidResolve(L.isNumber(s.pid)?s.pid:-1),this.pidResolve=void 0),s.on("error",d=>{this.childProcess=null,r({terminated:this.terminateRequested,error:d})}),s.pid&&(this.childProcess.on("close",l),this.handleSpawn(s,n,i,r,!0)))}return c})}handleClose(i,t,n,r){}ensureQuotes(i){return b.regexp.test(i)?{value:'"'+i+'"',quoted:!0}:{value:i,quoted:i.length>0&&i[0]==='"'&&i[i.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(i=>i.pid,i=>-1):new Promise(i=>{this.pidResolve=i})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(i=>(this.terminateRequested=!0,a(i,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),i=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(i=>{if(!this.shell||!I.isWindows)return i(!1);const t=R.spawn(C(),["/s","/c"]);t.on("error",n=>i(!0)),t.on("exit",n=>i(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class p extends b{constructor(i,t,n,r){super(i,t,n,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(i,t,n,r,c){[r,c].forEach((s,l)=>{const d=new h.LineDecoder;d.write(s).forEach(u=>{t({line:u,source:l===0?0:1})});const y=d.end();y&&t({line:y,source:l===0?0:1})}),i({terminated:this.terminateRequested,error:n})}handleSpawn(i,t,n,r,c){const s=new h.LineDecoder,l=new h.LineDecoder;i.stdout.on("data",d=>{s.write(d).forEach(y=>n({line:y,source:0}))}),i.stderr.on("data",d=>{l.write(d).forEach(y=>n({line:y,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=l}handleClose(i,t,n,r){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&n({line:c,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&n({line:s,source:1})}}e.LineProcess=p;function E(o){let i=[],t=!1;const n=function(r){if(t){i.push(r);return}(!o.send(r,s=>{if(s&&console.error(s),t=!1,i.length>0){const l=i.slice(0);i=[],l.forEach(d=>n(d))}})||I.isWindows)&&(t=!0)};return{send:n}}e.createQueuedSender=E;var m;(function(o){async function i(t,n,r){if(v.isAbsolute(t))return t;if(n===void 0&&(n=process.cwd()),v.dirname(t)!=="."||(r===void 0&&L.isString(process.env.PATH)&&(r=process.env.PATH.split(v.delimiter)),r===void 0||r.length===0))return v.join(n,t);async function s(l){return await k.exists(l)?!(await A.promises.stat(l)).isDirectory():!1}for(let l of r){let d;if(v.isAbsolute(l)?d=v.join(l,t):d=v.join(n,l,t),await s(d))return d;let f=d+".com";if(await s(f)||(f=d+".exe",await s(f)))return f}return v.join(n,t)}o.findExecutable=i})(m=e.win32||(e.win32={}))}),define(Q[49],Z([0,1,48,2,6,26,3,106,33,88,29,15,22,7]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class a extends g.ChannelServer{constructor(p){super({send:E=>{try{process.send&&process.send(E.buffer.toString("base64"))}catch(m){}},onMessage:O.Event.fromNodeEventEmitter(process,"message",E=>w.VSBuffer.wrap(Buffer.from(E,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=a;class C{constructor(p,E){this.modulePath=p,this.options=E,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new O.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=E&&E.timeout?E.timeout:6e4;this.disposeDelayer=new k.Delayer(m),this.child=null,this._client=null}getChannel(p){const E=this;return{call(m,o,i){return E.requestPromise(p,m,o,i)},listen(m,o){return E.requestEvent(p,m,o)}}}requestPromise(p,E,m,o=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(h.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(p),t=(0,k.createCancelablePromise)(c=>i.call(E,m,c)),n=o.onCancellationRequested(()=>t.cancel()),r=(0,A.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{n.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(p,E,m){if(!this.disposeDelayer)return O.Event.None;this.disposeDelayer.cancel();let o;const i=new O.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(p).listen(E,m)(i.fire,i),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],E=Object.create(null);E.env=Object.assign(Object.assign({},(0,R.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(E.env=Object.assign(Object.assign({},E.env),this.options.env)),this.options&&this.options.freshExecArgv&&(E.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(E.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(E.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),E.execArgv===void 0&&(E.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),D.isMacintosh&&E.env&&delete E.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,p,E);const m=new O.Emitter;O.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,S.isRemoteConsoleLog)(s)){(0,S.log)(s,`IPC Library: ${this.options.serverName}`);return}m.fire(w.VSBuffer.wrap(Buffer.from(s,"base64")))});const i=this.options.useQueue?(0,L.createQueuedSender)(this.child):this.child,t=s=>this.child&&this.child.connected&&i.send(s.buffer.toString("base64")),n=m.event,r={send:t,onMessage:n};this._client=new g.ChannelClient(r);const c=()=>this.disposeClient();process.once("exit",c),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,l)=>{process.removeListener("exit",c),this.activeRequests.forEach(d=>(0,A.dispose)(d)),this.activeRequests.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:l})})}return this._client}getCachedChannel(p){let E=this.channels.get(p);return E||(E=this.client.getChannel(p),this.channels.set(p,E)),E}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(Q[107],Z([12,13]),function(G,e){return G.create("vs/base/node/zip",e)}),define(Q[108],Z([12,13]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[109],Z([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[110],Z([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Q[111],Z([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Q[112],Z([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Q[113],Z([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Q[114],Z([12,13]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[115],Z([12,13]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(Q[116],Z([12,13]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(Q[117],Z([12,13]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(Q[118],Z([12,13]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[119],Z([12,13]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(Q[120],Z([12,13]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[121],Z([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Q[122],Z([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Q[123],Z([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Q[124],Z([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Q[125],Z([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Q[126],Z([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Q[127],Z([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const A=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,R=/^([^@]+@)?([^:]+)(:\d+)?$/,O=/([^@:.]+\.[^@:.]+)(:\d+)?$/,L=/^\s*url\s*=\s*(.+\S)\s*$/mg,g=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(b){const p=b.match(O);return p?p[1]:null}function I(b){if(b.indexOf("://")===-1){const p=b.match(A);return p?S(p[2]):null}try{const p=v.URI.parse(b);if(p.authority)return S(p.authority)}catch(p){}return null}function h(b,p){const E=new Set;let m;for(;m=L.exec(b);){const i=I(m[1]);i&&E.add(i)}const o=new Set(p);return Array.from(E).map(i=>o.has(i)?i:i.replace(g,"a"))}e.getDomainsOfRemotes=h;function w(b){const p=b.match(R);return p?p[2]:null}function D(b,p,E){return b&&p?(E&&p.endsWith(".git")&&(p=p.substr(0,p.length-4)),p.indexOf("/")===0?`${b}${p}`:`${b}/${p}`):null}function a(b,p){if(b.indexOf("://")===-1){const E=b.match(k);if(E)return D(E[2],E[3],p)}try{const E=v.URI.parse(b);if(E.authority)return D(w(E.authority),E.path,p)}catch(E){}return null}function C(b,p=!1){const E=[];let m;for(;m=L.exec(b);){const o=a(m[1],p);o&&E.push(o)}return E}e.getRemotes=C}),define(Q[128],Z([0,1,3,5,91,26,2]),function(G,e,v,A,k,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function L(a,C){return A.URI.revive(C?C.transformIncoming(a):a)}function g(a,C){return C?C.transformOutgoingURI(a):a}function S(a,C){C=C||k.DefaultURITransformer;const b=a.manifest,p=(0,k.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},a),{manifest:void 0}),C);return Object.assign(Object.assign({},p),{manifest:b})}function I(a,C){return C?(0,R.cloneAndChange)(a,b=>b instanceof A.URI?C.transformOutgoingURI(b):void 0):a}class h{constructor(C,b){this.service=C,this.getUriTransformer=b,this.onInstallExtension=v.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtension=v.Event.buffer(C.onDidInstallExtension,!0),this.onUninstallExtension=v.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=v.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,b){const p=this.getUriTransformer(C);switch(b){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return v.Event.map(this.onDidInstallExtension,E=>Object.assign(Object.assign({},E),{local:E.local?I(E.local,p):E.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,b,p){const E=this.getUriTransformer(C);switch(b){case"zip":return this.service.zip(S(p[0],E)).then(m=>g(m,E));case"unzip":return this.service.unzip(L(p[0],E));case"install":return this.service.install(L(p[0],E));case"getManifest":return this.service.getManifest(L(p[0],E));case"canInstall":return this.service.canInstall(p[0]);case"installFromGallery":return this.service.installFromGallery(p[0],p[1]);case"uninstall":return this.service.uninstall(S(p[0],E),p[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(S(p[0],E));case"getInstalled":return this.service.getInstalled(p[0]).then(m=>m.map(o=>I(o,E)));case"updateMetadata":return this.service.updateMetadata(S(p[0],E),p[1]).then(m=>I(m,E));case"updateExtensionScope":return this.service.updateExtensionScope(S(p[0],E),p[1]).then(m=>I(m,E));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=h;class w extends O.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new v.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new v.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new v.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new v.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(b=>this._onInstallExtension.fire(b))),this._register(this.channel.listen("onDidInstallExtension")(b=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},b),{local:b.local?S(b.local,null):b.local})))),this._register(this.channel.listen("onUninstallExtension")(b=>this._onUninstallExtension.fire(b))),this._register(this.channel.listen("onDidUninstallExtension")(b=>this._onDidUninstallExtension.fire(b)))}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(b=>A.URI.revive(b)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C){return Promise.resolve(this.channel.call("install",[C])).then(b=>S(b,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}async canInstall(C){return!0}installFromGallery(C,b){return Promise.resolve(this.channel.call("installFromGallery",[C,b])).then(p=>S(p,null))}uninstall(C,b){return Promise.resolve(this.channel.call("uninstall",[C,b]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(b=>b.map(p=>S(p,null)))}updateMetadata(C,b){return Promise.resolve(this.channel.call("updateMetadata",[C,b])).then(p=>S(p,null))}updateExtensionScope(C,b){return Promise.resolve(this.channel.call("updateExtensionScope",[C,b])).then(p=>S(p,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=w;class D{constructor(C){this.service=C}listen(C,b){throw new Error("Invalid listen")}call(C,b,p){switch(b){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=D}),define(Q[129],Z([0,1,26]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const A=/^%([\w\d.-]+)%$/i;function k(R,O){const L=g=>{if(typeof g=="string"){const S=A.exec(g);if(!!S)return O[S[1]]||g}};return(0,v.cloneAndChange)(R,L)}e.localizeManifest=k}),define(Q[130],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class v{constructor(R){this.channel=R}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(R,O,L,g){return this.channel.call("promptImportantExtensionsInstallNotification",[R,O,L,g])}promptWorkspaceRecommendations(R){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=v;class A{constructor(R){this.service=R}listen(R,O){throw new Error(`Event not found: ${O}`)}call(R,O,L){switch(O){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(L[0],L[1],L[2],L[3])}throw new Error(`Call not found: ${O}`)}}e.ExtensionRecommendationNotificationServiceChannel=A}),define(Q[68],Z([0,1,114]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function k(h){return h=h.trim(),h==="*"||A.test(h)}e.isValidVersionStr=k;function R(h){if(!k(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=h.match(A);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=R;function O(h){if(!h)return null;let w=h.majorBase,D=h.majorMustEqual,a=h.minorBase,C=h.minorMustEqual,b=h.patchBase,p=h.patchMustEqual;return h.hasCaret&&(w===0||(C=!1),p=!1),{majorBase:w,majorMustEqual:D,minorBase:a,minorMustEqual:C,patchBase:b,patchMustEqual:p,isMinimum:h.hasGreaterEquals}}e.normalizeVersion=O;function L(h,w){let D;typeof h=="string"?D=O(R(h)):D=h;let a;if(typeof w=="string"?a=O(R(w)):a=w,!D||!a)return!1;let C=D.majorBase,b=D.minorBase,p=D.patchBase,E=a.majorBase,m=a.minorBase,o=a.patchBase,i=a.majorMustEqual,t=a.minorMustEqual,n=a.patchMustEqual;return a.isMinimum?C>E?!0:C<E?!1:b>m?!0:b<m?!1:p>=o:(C===1&&E===0&&(!i||!t||!n)&&(E=1,m=0,o=0,i=!0,t=!1,n=!1),C<E?!1:C>E?!i:b<m?!1:b>m?!t:p<o?!1:p>o?!n:!0)}e.isValidVersion=L;function g(h,w,D){return w.isBuiltin||typeof w.main=="undefined"?!0:I(h,w.engines.vscode,D)}e.isValidExtensionVersion=g;function S(h,w){return h==="*"||I(w,h)}e.isEngineValid=S;function I(h,w,D=[]){let a=O(R(w));if(!a)return D.push(v.localize(0,null,w)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return D.push(v.localize(1,null,w)),!1}else if(!a.majorMustEqual)return D.push(v.localize(2,null,w)),!1;return L(h,a)?!0:(D.push(v.localize(3,null,h,w)),!1)}e.isVersionValid=I}),define(Q[131],Z([0,1,33,49,2,16]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class O extends k.Disposable{constructor(g,S,I,h){super();this.folders=g,this.onDidFilesChange=S,this.onLogMessage=I,this.verboseLogging=h,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const g=this._register(new A.Client(R.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(g.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(g.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(S=>!this.isDisposed&&this.onDidFilesChange(S))),this._register(this.service.onDidLogMessage(S=>this.onLogMessage(S))),this.setFolders(this.folders)}setVerboseLogging(g){this.verboseLogging=g,!this.isDisposed&&this.service&&this.service.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${g}`})}setFolders(g){this.folders=g,this.service&&this.service.setRoots(g)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=O,O.MAX_RESTARTS=5}),define(Q[132],Z([0,1,33,49,2,16]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class O extends k.Disposable{constructor(g,S,I,h,w={}){super();this.folders=g,this.onDidFilesChange=S,this.onLogMessage=I,this.verboseLogging=h,this.watcherOptions=w,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const g=this._register(new A.Client(R.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(g.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(g.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(S=>!this.isDisposed&&this.onDidFilesChange(S))),this._register(this.service.onDidLogMessage(S=>this.onLogMessage(S))),this.service.setRoots(this.folders)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${g}`})}setVerboseLogging(g){this.verboseLogging=g,this.service&&this.service.setVerboseLogging(g)}setFolders(g){this.folders=g,this.service&&this.service.setRoots(g)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=O,O.MAX_RESTARTS=5}),define(Q[133],Z([0,1,48,66,90,16]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class O{constructor(g,S,I,h,w){this.watchedFolder=g,this.eventCallback=I,this.logCallback=h,this.verboseLogging=w,this.restartCounter=0,Array.isArray(S)?this.ignored=S.map(D=>k.parse(D)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${g}`),this.startWatcher()}startWatcher(){const g=[this.watchedFolder];this.verboseLogging&&g.push("-verbose"),this.handle=v.spawn(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",G).fsPath,g);const S=new A.LineDecoder;this.handle.stdout.on("data",I=>{const h=[];S.write(I).forEach(w=>{const D=w.split("|");if(D.length===2){const a=Number(D[0]),C=D[1];if(a>=0&&a<3){if(this.ignored&&this.ignored.some(b=>b(C))){this.verboseLogging&&this.log(C);return}h.push({type:O.changeTypeMap[a],path:C})}else this.log(D[1])}}),h.length>0&&this.eventCallback(h)}),this.handle.on("error",I=>this.onError(I)),this.handle.stderr.on("data",I=>this.onError(I)),this.handle.on("exit",(I,h)=>this.onExit(I,h))}onError(g){this.error("process error: "+g.toString())}onExit(g,S){this.handle&&(this.error(`terminated unexpectedly (code: ${g}, signal: ${S})`),this.restartCounter<=O.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(g){this.logCallback({type:"error",message:`[File Watcher (C#)] ${g}`})}log(g){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${g}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=O,O.MAX_RESTARTS=5,O.changeTypeMap=[0,1,2]}),define(Q[134],Z([0,1,133,8,21]),function(G,e,v,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class R{constructor(L,g,S,I){this.onDidFilesChange=g,this.onLogMessage=S,this.verboseLogging=I,this.service=void 0,this.folder=L[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=(0,k.rtrim)(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,L=>this.onFileEvents(L),L=>this.onLogMessage(L),this.verboseLogging)}setVerboseLogging(L){this.verboseLogging=L,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(L){this.isDisposed||L.length>0&&this.onDidFilesChange(L)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=R}),define(Q[50],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(R,O=[],L=!1){this.ctor=R,this.staticArguments=O,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=v;const A=(k,...R)=>new v(k,R);e.createSyncDescriptor=A}),define(Q[135],Z([0,1,50]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const A=[];function k(O,L,g){L instanceof v.SyncDescriptor||(L=new v.SyncDescriptor(L,[],g)),A.push([O,L])}e.registerSingleton=k;function R(){return A}e.getSingletonServiceDescriptors=R}),define(Q[136],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=v;class A{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let O of this._nodes.values())O.outgoing.size===0&&R.push(O);return R}insertEdge(R,O){const L=this.lookupOrInsertNode(R),g=this.lookupOrInsertNode(O);L.outgoing.set(this._hashFn(O),g),g.incoming.set(this._hashFn(R),L)}removeNode(R){const O=this._hashFn(R);this._nodes.delete(O);for(let L of this._nodes.values())L.outgoing.delete(O),L.incoming.delete(O)}lookupOrInsertNode(R){const O=this._hashFn(R);let L=this._nodes.get(O);return L||(L=new v(R),this._nodes.set(O,L)),L}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[O,L]of this._nodes)R.push(`${O}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return R.join(`
`)}}e.Graph=A}),define(Q[4],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function g(S){return S[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=g})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function A(L,g,S,I){g[v.DI_TARGET]===g?g[v.DI_DEPENDENCIES].push({id:L,index:S,optional:I}):(g[v.DI_DEPENDENCIES]=[{id:L,index:S,optional:I}],g[v.DI_TARGET]=g)}function k(L){if(v.serviceIds.has(L))return v.serviceIds.get(L);const g=function(S,I,h){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(g,S,h,!1)};return g.toString=()=>L,v.serviceIds.set(L,g),g}e.createDecorator=k;function R(L){return L}e.refineServiceDecorator=R;function O(L){return function(g,S,I){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");A(L,g,I,!0)}}e.optional=O}),define(Q[137],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,v.createDecorator)("checksumService")}),define(Q[138],Z([0,1,21,4,7]),function(G,e,v,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let R=k.userAgent||"";const O=new Map;O.set("false",!1),O.set("true",!0),O.set("isMac",k.isMacintosh),O.set("isLinux",k.isLinux),O.set("isWindows",k.isWindows),O.set("isWeb",k.isWeb),O.set("isMacNative",k.isMacintosh&&!k.isWeb),O.set("isEdge",R.indexOf("Edg/")>=0),O.set("isFirefox",R.indexOf("Firefox")>=0),O.set("isChrome",R.indexOf("Chrome")>=0),O.set("isSafari",R.indexOf("Safari")>=0),O.set("isIPad",R.indexOf("iPad")>=0);const L=Object.prototype.hasOwnProperty;var g;(function(y){y[y.False=0]="False",y[y.True=1]="True",y[y.Defined=2]="Defined",y[y.Not=3]="Not",y[y.Equals=4]="Equals",y[y.NotEquals=5]="NotEquals",y[y.And=6]="And",y[y.Regex=7]="Regex",y[y.NotRegex=8]="NotRegex",y[y.Or=9]="Or",y[y.In=10]="In",y[y.NotIn=11]="NotIn",y[y.Greater=12]="Greater",y[y.GreaterEquals=13]="GreaterEquals",y[y.Smaller=14]="Smaller",y[y.SmallerEquals=15]="SmallerEquals"})(g=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return h.INSTANCE}static true(){return w.INSTANCE}static has(u){return D.create(u)}static equals(u,P){return a.create(u,P)}static notEquals(u,P){return p.create(u,P)}static regex(u,P){return n.create(u,P)}static in(u,P){return C.create(u,P)}static not(u){return E.create(u)}static and(...u){return c.create(u)}static or(...u){return s.create(u)}static greater(u,P){return m.create(u,P)}static less(u,P){return i.create(u,P)}static deserialize(u,P=!1){if(!!u)return this._deserializeOrExpression(u,P)}static _deserializeOrExpression(u,P){let _=u.split("||");return s.create(_.map(z=>this._deserializeAndExpression(z,P)))}static _deserializeAndExpression(u,P){let _=u.split("&&");return c.create(_.map(z=>this._deserializeOne(z,P)))}static _deserializeOne(u,P){if(u=u.trim(),u.indexOf("!=")>=0){let _=u.split("!=");return p.create(_[0].trim(),this._deserializeValue(_[1],P))}if(u.indexOf("==")>=0){let _=u.split("==");return a.create(_[0].trim(),this._deserializeValue(_[1],P))}if(u.indexOf("=~")>=0){let _=u.split("=~");return n.create(_[0].trim(),this._deserializeRegexValue(_[1],P))}if(u.indexOf(" in ")>=0){let _=u.split(" in ");return C.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(u)){const _=u.split(">=");return o.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(u)){const _=u.split(">");return m.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(u)){const _=u.split("<=");return t.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(u)){const _=u.split("<");return i.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(u)?E.create(u.substr(1).trim()):D.create(u)}static _deserializeValue(u,P){if(u=u.trim(),u==="true")return!0;if(u==="false")return!1;let _=/^'([^']*)'$/.exec(u);return _?_[1].trim():u}static _deserializeRegexValue(u,P){if((0,v.isFalsyOrWhitespace)(u)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=u.indexOf("/"),z=u.lastIndexOf("/");if(_===z||_<0){if(P)throw new Error(`bad regexp-value '${u}', missing /-enclosure`);return console.warn(`bad regexp-value '${u}', missing /-enclosure`),null}let j=u.slice(_+1,z),W=u[z+1]==="i"?"i":"";try{return new RegExp(j,W)}catch(q){if(P)throw new Error(`bad regexp-value '${u}', parse error: ${q}`);return console.warn(`bad regexp-value '${u}', parse error: ${q}`),null}}}e.ContextKeyExpr=S;function I(y,u){return y.cmp(u)}class h{constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=h,h.INSTANCE=new h;class w{constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return h.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class D{constructor(u){this.key=u,this.type=2}static create(u){const P=O.get(u);return typeof P=="boolean"?P?w.INSTANCE:h.INSTANCE:new D(u)}cmp(u){return u.type!==this.type?this.type-u.type:d(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=D;class a{constructor(u,P){this.key=u,this.value=P,this.type=4}static create(u,P){if(typeof P=="boolean")return P?D.create(u):E.create(u);const _=O.get(u);return typeof _=="boolean"?P===(_?"true":"false")?w.INSTANCE:h.INSTANCE:new a(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(u){return u.mapEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class C{constructor(u,P){this.key=u,this.valueKey=P,this.type=10}static create(u,P){return new C(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.valueKey,u.key,u.valueKey)}equals(u){return u.type===this.type?this.key===u.key&&this.valueKey===u.valueKey:!1}evaluate(u){const P=u.getValue(this.valueKey),_=u.getValue(this.key);return Array.isArray(P)?P.indexOf(_)>=0:typeof _=="string"&&typeof P=="object"&&P!==null?L.call(P,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(u){return u.mapIn(this.key,this.valueKey)}negate(){return b.create(this)}}e.ContextKeyInExpr=C;class b{constructor(u){this._actual=u,this.type=11}static create(u){return new b(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new b(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class p{constructor(u,P){this.key=u,this.value=P,this.type=5}static create(u,P){if(typeof P=="boolean")return P?E.create(u):D.create(u);const _=O.get(u);return typeof _=="boolean"?P===(_?"true":"false")?h.INSTANCE:w.INSTANCE:new p(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(u){return u.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=p;class E{constructor(u){this.key=u,this.type=3}static create(u){const P=O.get(u);return typeof P=="boolean"?P?h.INSTANCE:w.INSTANCE:new E(u)}cmp(u){return u.type!==this.type?this.type-u.type:d(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!u.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(u){return u.mapNot(this.key)}negate(){return D.create(this.key)}}e.ContextKeyNotExpr=E;class m{constructor(u,P){this.key=u,this.value=P,this.type=12}static create(u,P){return new m(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=m;class o{constructor(u,P){this.key=u,this.value=P,this.type=13}static create(u,P){return new o(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreaterEquals(this.key,this.value)}negate(){return i.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=o;class i{constructor(u,P){this.key=u,this.value=P,this.type=14}static create(u,P){return new i(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmaller(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerExpr=i;class t{constructor(u,P){this.key=u,this.value=P,this.type=15}static create(u,P){return new t(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmallerEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(u,P){this.key=u,this.regexp=P,this.type=7}static create(u,P){return new n(u,P)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.key<u.key)return-1;if(this.key>u.key)return 1;const P=this.regexp?this.regexp.source:"",_=u.regexp?u.regexp.source:"";return P<_?-1:P>_?1:0}equals(u){if(u.type===this.type){const P=this.regexp?this.regexp.source:"",_=u.regexp?u.regexp.source:"";return this.key===u.key&&P===_}return!1}evaluate(u){let P=u.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const u=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${u}`}keys(){return[this.key]}map(u){return u.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=n;class r{constructor(u){this._actual=u,this.type=8}static create(u){return new r(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new r(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class c{constructor(u){this.expr=u,this.type=6}static create(u){return c._normalizeArr(u)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const z=I(this.expr[P],u.expr[P]);if(z!==0)return z}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(u.expr[P]))return!1;return!0}return!1}evaluate(u){for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].evaluate(u))return!1;return!0}static _normalizeArr(u){const P=[];let _=!1;for(const z of u)if(!!z){if(z.type===1){_=!0;continue}if(z.type===0)return h.INSTANCE;if(z.type===6){P.push(...z.expr);continue}P.push(z)}if(P.length===0&&_)return w.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(I);P.length>1;){const z=P[P.length-1];if(z.type!==9)break;P.pop();const j=P.pop(),W=s.create(z.expr.map(q=>c.create([q,j])));W&&(P.push(W),P.sort(I))}return P.length===1?P[0]:new c(P)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(let P of this.expr)u.push(...P.keys());return u}map(u){return new c(this.expr.map(P=>P.map(u)))}negate(){let u=[];for(let P of this.expr)u.push(P.negate());return s.create(u)}}e.ContextKeyAndExpr=c;class s{constructor(u){this.expr=u,this.type=9}static create(u){const P=s._normalizeArr(u);if(P.length!==0)return P.length===1?P[0]:new s(P)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const z=I(this.expr[P],u.expr[P]);if(z!==0)return z}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(u.expr[P]))return!1;return!0}return!1}evaluate(u){for(let P=0,_=this.expr.length;P<_;P++)if(this.expr[P].evaluate(u))return!0;return!1}static _normalizeArr(u){let P=[],_=!1;if(u){for(let z=0,j=u.length;z<j;z++){const W=u[z];if(!!W){if(W.type===0){_=!0;continue}if(W.type===1)return[w.INSTANCE];if(W.type===9){P=P.concat(W.expr);continue}P.push(W)}}if(P.length===0&&_)return[h.INSTANCE];P.sort(I)}return P}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(let P of this.expr)u.push(...P.keys());return u}map(u){return new s(this.expr.map(P=>P.map(u)))}negate(){let u=[];for(let _ of this.expr)u.push(_.negate());const P=_=>_.type===9?_.expr:[_];for(;u.length>1;){const _=u.shift(),z=u.shift(),j=[];for(const W of P(_))for(const q of P(z))j.push(S.and(W,q));u.unshift(S.or(...j))}return u[0]}}e.ContextKeyOrExpr=s;class l extends D{constructor(u,P,_){super(u);this.key=u,this._defaultValue=P,typeof _=="object"?l._info.push(Object.assign(Object.assign({},_),{key:u})):_!==!0&&l._info.push({key:u,description:_,type:P!=null?typeof P:void 0})}static all(){return l._info.values()}bindTo(u){return u.createKey(this.key,this._defaultValue)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return S.not(this.key)}isEqualTo(u){return S.equals(this.key,u)}notEqualsTo(u){return S.notEquals(this.key,u)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,A.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(y,u){return y<u?-1:y>u?1:0}function f(y,u,P,_){return y<P?-1:y>P?1:u<_?-1:u>_?1:0}}),define(Q[69],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function A(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=A}),define(Q[70],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,v.createDecorator)("downloadService")}),define(Q[10],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)});var ue=this&&this.__decorate||function(G,e,v,A){var k=arguments.length,R=k<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,v):A,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(G,e,v,A);else for(var L=G.length-1;L>=0;L--)(O=G[L])&&(R=(k<3?O(R):k>3?O(e,v,R):O(e,v))||R);return k>3&&R&&Object.defineProperty(e,v,R),R},Y=this&&this.__param||function(G,e){return function(v,A){e(v,A,G)}};define(Q[139],Z([0,1,10,8,23,15,2,6]),function(G,e,v,A,k,R,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let g=class extends O.Disposable{constructor(I){super();this.environmentService=I,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let I=setTimeout(()=>{I=void 0;const h=(0,A.basename)(this.environmentService.logsPath),w=(0,A.dirname)(this.environmentService.logsPath);(0,k.readdir)(w).then(D=>{const C=D.filter(p=>/^\d{8}T\d{6}$/.test(p)).sort().filter((p,E)=>p!==h),b=C.slice(0,Math.max(0,C.length-9));return L.Promises.settled(b.map(p=>(0,k.rimraf)((0,A.join)(w,p))))}).then(null,R.onUnexpectedError)},10*1e3);this._register((0,O.toDisposable)(()=>{I&&(clearTimeout(I),I=void 0)}))}};g=ue([Y(0,v.IEnvironmentService)],g),e.LogsDataCleaner=g}),define(Q[140],Z([0,1,27,10,8,23,15,2]),function(G,e,v,A,k,R,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let g=class ot extends L.Disposable{constructor(I,h){super();this.backupWorkspacesPath=I,this.environmentService=h,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let I=setTimeout(()=>{I=void 0,(async()=>{try{const h=await v.promises.readFile(this.backupWorkspacesPath,"utf8"),D=JSON.parse(h).emptyWorkspaceInfos.map(b=>b.backupFolder),a=await(0,R.readdir)(this.environmentService.workspaceStorageHome.fsPath),C=[];a.forEach(b=>{b.length!==ot.NON_EMPTY_WORKSPACE_ID_LENGTH&&D.indexOf(b)===-1&&C.push((0,R.rimraf)((0,k.join)(this.environmentService.workspaceStorageHome.fsPath,b)))}),await Promise.all(C)}catch(h){(0,O.onUnexpectedError)(h)}})()},30*1e3);this._register((0,L.toDisposable)(()=>{I&&(clearTimeout(I),I=void 0)}))}};g.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,g=ue([Y(1,A.INativeEnvironmentService)],g),e.StorageDataCleaner=g}),define(Q[28],Z([0,1,109,4,16]),function(G,e,v,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function R(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=R;var O;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=5]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(O=e.SortBy||(e.SortBy={}));var L;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(L=e.SortOrder||(e.SortOrder={}));var g;(function(h){h.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var S;(function(h){h[h.None=0]="None",h[h.Install=1]="Install",h[h.Update=2]="Update"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class I extends Error{constructor(w,D){super(w);this.code=D}}e.ExtensionManagementError=I,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,A.createDecorator)("IExtensionManagementCLIService")}),define(Q[141],Z([0,1,2,28]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let k=class extends v.Disposable{constructor(O){super();this.extensionManagementService=O,this._register(O),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};k=ue([Y(0,A.IExtensionManagementService)],k),e.DeprecatedExtensionsCleaner=k}),define(Q[71],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var A;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(A=e.RecommendationSource||(e.RecommendationSource={}));function k(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var R;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(R=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,v.createDecorator)("IExtensionRecommendationNotificationService")}),define(Q[72],Z([0,1,21,4]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function k(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class O{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,h){if(typeof I=="undefined"||I===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof I=="string"||typeof h=="string"){let w=typeof I=="string"?I:I.value,D=typeof h=="string"?h:h.value;return v.equalsIgnoreCase(w,D)}return I._lower===h._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=O;function L(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function g(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=g,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[34],Z([0,1,21,72]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(D,a){return D.uuid&&a.uuid?D.uuid===a.uuid:D.id===a.id?!0:(0,v.compareIgnoreCase)(D.id,a.id)===0}e.areSameExtensions=k;class R{constructor(a,C){this.version=C,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof R?k(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=R;function O(D,a){return`${D}.${a}`}e.getExtensionId=O;function L(D){return D.toLocaleLowerCase()}e.adoptToGalleryExtensionId=L;function g(D,a){return L(O(D,a))}e.getGalleryExtensionId=g;function S(D,a){const C=[],b=p=>{for(const E of C)if(E.some(m=>k(a(m),a(p))))return E;return null};for(const p of D){const E=b(p);E?E.push(p):C.push([p])}return C}e.groupByExtension=S;function I(D){return{id:D.identifier.id,name:D.manifest.name,galleryId:null,publisherId:D.publisherId,publisherName:D.manifest.publisher,publisherDisplayName:D.publisherDisplayName,dependencies:D.manifest.extensionDependencies&&D.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function h(D){return Object.assign({id:D.identifier.id,name:D.name,galleryId:D.identifier.uuid,publisherId:D.publisherId,publisherName:D.publisher,publisherDisplayName:D.publisherDisplayName,dependencies:!!(D.properties.dependencies&&D.properties.dependencies.length>0)},D.telemetryData)}e.getGalleryExtensionTelemetryData=h,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function w(D){const a=new Set;for(const C of D)C.malicious&&a.add(C.id.id);return a}e.getMaliciousExtensionsSet=w}),define(Q[142],Z([0,1,2,8,72,23]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends v.Disposable{constructor(g,S){super();this.environmentService=g,this.extensionsManifestCache=(0,A.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(S.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(S.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtension(g){g.error||this.invalidate()}onDidUnInstallExtension(g){g.error||this.invalidate()}invalidate(){R.rimraf(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(Q[9],Z([0,1,116,8,5,4,21,17,37]),function(G,e,v,A,k,R,O,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=(0,R.createDecorator)("fileService");var S;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(S=e.FileType||(e.FileType={}));var I;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=h;function w(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=w;function D(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=D;function a(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=a;var C;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(W,q){super(W);this.code=q}}e.FileSystemProviderError=b;function p(j,W){const q=new b(j.toString(),W);return m(q,W),q}e.createFileSystemProviderError=p;function E(j){return j||p((0,v.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=E;function m(j,W){return j.name=W?`${W} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=m;function o(j){if(!j)return C.Unknown;if(j instanceof b)return j.code;const W=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!W)return C.Unknown;switch(W[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=o;function i(j){if(j instanceof l)return j.fileOperationResult;switch(o(j)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var t;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class n{constructor(W,q,x){this.resource=W,this.operation=q,this.target=x}isOperation(W){return this.operation===W}}e.FileOperationEvent=n;var r;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class c{constructor(W,q){this.ignorePathCasing=q,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=W;for(const x of W)switch(x.type){case 1:this.added||(this.added=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(x.resource,x);break;case 0:this.updated||(this.updated=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(x.resource,x);break;case 2:this.deleted||(this.deleted=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(x.resource,x);break}}contains(W,...q){return this.doContains(W,{includeChildren:!1},...q)}affects(W,...q){return this.doContains(W,{includeChildren:!0},...q)}doContains(W,q,...x){var B,M,F,T,U,N;if(!W)return!1;const $=x.length>0;return!!((!$||x.includes(1))&&(((B=this.added)===null||B===void 0?void 0:B.get(W))||q.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(W)))||(!$||x.includes(0))&&(((F=this.updated)===null||F===void 0?void 0:F.get(W))||q.includeChildren&&((T=this.updated)===null||T===void 0?void 0:T.findSuperstr(W)))||(!$||x.includes(2))&&(((U=this.deleted)===null||U===void 0?void 0:U.findSubstr(W))||q.includeChildren&&((N=this.deleted)===null||N===void 0?void 0:N.findSuperstr(W))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(W){const q=[],x=W===1?this.added:W===0?this.updated:this.deleted;if(x)for(const[,B]of x)q.push(B);return q}filter(W){return new c(this.changes.filter(q=>W(q)),this.ignorePathCasing)}}e.FileChangesEvent=c;function s(j,W,q){return!j||!W||j===W||W.length>j.length?!1:(W.charAt(W.length-1)!==A.sep&&(W+=A.sep),q?(0,O.startsWithIgnoreCase)(j,W):j.indexOf(W)===0)}e.isParent=s;class l extends Error{constructor(W,q,x){super(W);this.fileOperationResult=q,this.options=x}static isFileOperationError(W){return W instanceof Error&&!(0,L.isUndefinedOrNull)(W.fileOperationResult)}}e.FileOperationError=l;var d;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_READ_ONLY=5]="FILE_READ_ONLY",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(d=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var f;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(f=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function y(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=y;async function u(j,W){if(!W.canHandleResource(k.URI.from({scheme:j.scheme})))return new Promise(q=>{const x=W.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===j.scheme&&B.added&&(x.dispose(),q())})})}e.whenProviderRegistered=u,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class P{static formatSize(W){return(0,L.isNumber)(W)||(W=0),W<P.KB?(0,v.localize)(1,null,W.toFixed(0)):W<P.MB?(0,v.localize)(2,null,(W/P.KB).toFixed(2)):W<P.GB?(0,v.localize)(3,null,(W/P.MB).toFixed(2)):W<P.TB?(0,v.localize)(4,null,(W/P.GB).toFixed(2)):(0,v.localize)(5,null,(W/P.TB).toFixed(2))}}e.ByteSize=P,P.KB=1024,P.MB=P.KB*P.KB,P.GB=P.MB*P.KB,P.TB=P.GB*P.KB;var _;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(_=e.Arch||(e.Arch={}));function z(j){return{maxFileSize:j===0?300*P.MB:16*P.GB,maxHeapSize:j===0?700*P.MB:2*700*P.MB}}e.getPlatformLimits=z}),define(Q[143],Z([0,1,144,47,9]),function(G,e,v,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let R=class{constructor(L){this.fileService=L}checksum(L){return new Promise(async(g,S)=>{const I=(0,v.createHash)("md5"),h=(await this.fileService.readFileStream(L)).value;(0,A.listenStream)(h,{onData:w=>I.update(w.buffer),onError:w=>S(w),onEnd:()=>g(I.digest("base64").replace(/=+$/,""))})})}};R=ue([Y(0,k.IFileService)],R),e.ChecksumService=R}),define(Q[73],Z([0,1,117,22,9,15]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(I,h,w,D,a,C){let b;try{await L(I,h,w,D,a,C)}catch(p){b=p}finally{b&&a.errorTransformer&&(b=a.errorTransformer(b)),typeof b!="undefined"&&w.error(b),w.end()}}e.readFileIntoStream=O;async function L(I,h,w,D,a,C){g(C);const b=await I.open(h,{create:!1});try{g(C);let p=0,E=0,m=a&&typeof a.length=="number"?a.length:void 0,o=A.VSBuffer.alloc(Math.min(a.bufferSize,typeof m=="number"?m:a.bufferSize)),i=a&&typeof a.position=="number"?a.position:0,t=0;do E=await I.read(b,i,o.buffer,t,o.byteLength-t),i+=E,t+=E,p+=E,typeof m=="number"&&(m-=E),t===o.byteLength&&(await w.write(D(o)),o=A.VSBuffer.alloc(Math.min(a.bufferSize,typeof m=="number"?m:a.bufferSize)),t=0);while(E>0&&(typeof m!="number"||m>0)&&g(C)&&S(p,a));if(t>0){let n=t;typeof m=="number"&&(n=Math.min(t,m)),w.write(D(o.slice(0,n)))}}catch(p){throw(0,k.ensureFileSystemProviderError)(p)}finally{await I.close(b)}}function g(I){if(I.isCancellationRequested)throw(0,R.canceled)();return!0}function S(I,h){if(h==null?void 0:h.limits){if(typeof h.limits.memory=="number"&&I>h.limits.memory)throw(0,k.createFileSystemProviderError)((0,v.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof h.limits.size=="number"&&I>h.limits.size)throw(0,k.createFileSystemProviderError)((0,v.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[74],Z([0,1,5,9,7]),function(G,e,v,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function R(g){return g.map(S=>({type:S.type,resource:v.URI.file(S.path)}))}e.toFileChanges=R;function O(g){const S=new L;for(const I of g)S.processEvent(I);return S.normalize()}e.normalizeFileChanges=O;class L{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(S){const I=this.mapPathToChange.get(S.path);if(I){const h=I.type,w=S.type;h===1&&w===2?(this.mapPathToChange.delete(S.path),this.normalized.splice(this.normalized.indexOf(I),1)):h===2&&w===1?I.type=0:h===1&&w===0||(I.type=w)}else this.normalized.push(S),this.mapPathToChange.set(S.path,S)}normalize(){const S=[],I=[];return this.normalized.filter(h=>h.type!==2?(S.push(h),!1):!0).sort((h,w)=>h.path.length-w.path.length).filter(h=>I.some(w=>(0,A.isParent)(h.path,w,!k.isLinux))?!1:(I.push(h.path),!0)).concat(S)}}}),define(Q[145],Z([0,1,74,2,23,94,97,6,8]),function(G,e,v,A,k,R,O,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S extends A.Disposable{constructor(h,w,D,a){super();this.path=h,this.onDidFilesChange=w,this.onLogMessage=D,this.verboseLogging=a,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(O.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(h){this.verboseLogging=h}async startWatching(){try{const{stat:h,symbolicLink:w}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let D=this.path;if(w)try{D=await(0,R.realpath)(D)}catch(a){if(this.onError(a),w.dangling)return}h.isDirectory()?this._register((0,O.watchFolder)(D,(a,C)=>{this.onFileChange({type:a==="changed"?0:a==="added"?1:2,path:(0,g.join)(this.path,(0,g.basename)(C))})},a=>this.onError(a))):this._register((0,O.watchFile)(D,a=>{this.onFileChange({type:a==="changed"?0:2,path:this.path})},a=>this.onError(a)))}catch(h){h.code!=="ENOENT"&&this.onError(h)}}onFileChange(h){this.fileChangesBuffer.push(h),this.verboseLogging&&this.onVerbose(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`),this.fileChangesDelayer.trigger(async()=>{const w=this.fileChangesBuffer;this.fileChangesBuffer=[];const D=(0,v.normalizeFileChanges)(w);this.verboseLogging&&D.forEach(a=>{this.onVerbose(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`)}),D.length>0&&this.onDidFilesChange(D)})}onError(h){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${h}`})}onVerbose(h){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=S}),define(Q[75],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(let[R,O]of k)this.set(R,O)}set(k,R){const O=this._entries.get(k);return this._entries.set(k,R),O}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(Q[146],Z([0,1,15,136,50,4,75,6]),function(G,e,v,A,k,R,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const g=!1;class S extends Error{constructor(a){super("cyclic dependency between services");this.message=a.toString()}}class I{constructor(a=new O.ServiceCollection,C=!1,b){this._activeInstantiations=new Set,this._services=a,this._strict=C,this._parent=b,this._services.set(R.IInstantiationService,this)}createChild(a){return new I(a,this._strict,this)}invokeFunction(a,...C){let b=w.traceInvocation(a),p=!1;try{return a({get:(m,o)=>{if(p)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(m,b);if(!i&&o!==R.optional)throw new Error(`[invokeFunction] unknown service '${m}'`);return i}},...C)}finally{p=!0,b.stop()}}createInstance(a,...C){let b,p;return a instanceof k.SyncDescriptor?(b=w.traceCreation(a.ctor),p=this._createInstance(a.ctor,a.staticArguments.concat(C),b)):(b=w.traceCreation(a),p=this._createInstance(a,C,b)),b.stop(),p}_createInstance(a,C=[],b){let p=R._util.getServiceDependencies(a).sort((o,i)=>o.index-i.index),E=[];for(const o of p){let i=this._getOrCreateServiceInstance(o.id,b);if(!i&&this._strict&&!o.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${o.id}.`);E.push(i)}let m=p.length>0?p[0].index:C.length;if(C.length!==m){console.warn(`[createInstance] First service dependency of ${a.name} at position ${m+1} conflicts with ${C.length} static arguments`);let o=m-C.length;o>0?C=C.concat(new Array(o)):C=C.slice(0,m)}return new a(...[...C,...E])}_setServiceInstance(a,C){if(this._services.get(a)instanceof k.SyncDescriptor)this._services.set(a,C);else if(this._parent)this._parent._setServiceInstance(a,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let C=this._services.get(a);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):C}_getOrCreateServiceInstance(a,C){let b=this._getServiceInstanceOrDescriptor(a);return b instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,b,C.branch(a,!0)):(C.branch(a,!1),b)}_safeCreateAndCacheServiceInstance(a,C,b){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,C,b)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,C,b){const p=new A.Graph(o=>o.id.toString());let E=0;const m=[{id:a,desc:C,_trace:b}];for(;m.length;){const o=m.pop();if(p.lookupOrInsertNode(o),E++>1e3)throw new S(p);for(let i of R._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(i.id);if(!t&&!i.optional&&console.warn(`[createInstance] ${a} depends on ${i.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const n={id:i.id,desc:t,_trace:o._trace.branch(i.id,!0)};p.insertEdge(o,n),m.push(n)}}}for(;;){const o=p.roots();if(o.length===0){if(!p.isEmpty())throw new S(p);break}for(const{data:i}of o){if(this._getServiceInstanceOrDescriptor(i.id)instanceof k.SyncDescriptor){const n=this._createServiceInstanceWithOwner(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this._setServiceInstance(i.id,n)}p.removeNode(i)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,C,b=[],p,E){if(this._services.get(a)instanceof k.SyncDescriptor)return this._createServiceInstance(C,b,p,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,C,b,p,E);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(a,C=[],b,p){if(b){const E=new L.IdleValue(()=>this._createInstance(a,C,p));return new Proxy(Object.create(null),{get(m,o){if(o in m)return m[o];let i=E.value,t=i[o];return typeof t!="function"||(t=t.bind(i),m[o]=t),t},set(m,o,i){return E.value[o]=i,!0}})}else return this._createInstance(a,C,p)}}e.InstantiationService=I;var h;(function(D){D[D.Creation=0]="Creation",D[D.Invocation=1]="Invocation",D[D.Branch=2]="Branch"})(h||(h={}));class w{constructor(a,C){this.type=a,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return g?new w(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(a){return g?new w(0,a.name):w._None}branch(a,C){let b=new w(2,a.toString());return this._dep.push([a,C,b]),b}stop(){let a=Date.now()-this._start;w._totals+=a;let C=!1;function b(E,m){let o=[],i=new Array(E+1).join("	");for(const[t,n,r]of m._dep)if(n&&r){C=!0,o.push(`${i}CREATES -> ${t}`);let c=b(E+1,r);c&&o.push(c)}else o.push(`${i}uses -> ${t}`);return o.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(a>2||C)&&console.log(p.join(`
`))}}w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(Q[147],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class v{constructor(k,R){this.server=k,this.router=R}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,R){this.server.registerChannel(k,R)}}e.MessagePortMainProcessService=v}),define(Q[148],Z([0,1,33,50,135,4]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class O{constructor(D,a,C){const b=C.getChannel(D);return L(a)?new a.channelClientCtor(b):v.ProxyChannel.toService(b,a==null?void 0:a.proxyOptions)}}function L(w){const D=w;return!!(D==null?void 0:D.channelClientCtor)}e.IMainProcessService=(0,R.createDecorator)("mainProcessService");let g=class extends O{constructor(D,a,C){super(D,a,C)}};g=ue([Y(2,e.IMainProcessService)],g);function S(w,D,a){(0,k.registerSingleton)(w,new A.SyncDescriptor(g,[D,a],a==null?void 0:a.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=(0,R.createDecorator)("sharedProcessService");let I=class extends O{constructor(D,a,C){super(D,a,C)}};I=ue([Y(2,e.ISharedProcessService)],I);function h(w,D,a){(0,k.registerSingleton)(w,new A.SyncDescriptor(I,[D,a],a==null?void 0:a.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=h}),define(Q[55],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,v.createDecorator)("localizationsService");function A(k){if(typeof k.languageId!="string"||!Array.isArray(k.translations)||k.translations.length===0)return!1;for(const R of k.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(k.languageName&&typeof k.languageName!="string"||k.localizedLanguageName&&typeof k.localizedLanguageName!="string")}e.isValidLocalization=A}),define(Q[149],Z([0,1,2,55]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends v.Disposable{constructor(O){super();this.localizationsService=O,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=ue([Y(0,A.ILocalizationsService)],k),e.LocalizationsUpdater=k}),define(Q[14],Z([0,1,4,2,7,3,43]),function(G,e,v,A,k,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function L(){return new Date().toISOString()}var g;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;class S extends A.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=S;class I extends S{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(g.Trace)&&this.log(g.Trace,this.format([i,...t]))}debug(i,...t){this.checkLogLevel(g.Debug)&&this.log(g.Debug,this.format([i,...t]))}info(i,...t){this.checkLogLevel(g.Info)&&this.log(g.Info,this.format([i,...t]))}warn(i,...t){this.checkLogLevel(g.Warning)&&this.log(g.Warning,this.format([i,...t]))}error(i,...t){if(this.checkLogLevel(g.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(g.Error,this.format(n))}else this.log(g.Error,this.format([i,...t]))}critical(i,...t){this.checkLogLevel(g.Critical)&&this.log(g.Critical,this.format([i,...t]))}flush(){}format(i){let t="";for(let n=0;n<i.length;n++){let r=i[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(c){}t+=(n>0?" ":"")+r}return t}}e.AbstractMessageLogger=I;class h extends S{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!k.isWindows}trace(i,...t){this.getLevel()<=g.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,i,...t):console.log(`[main ${L()}]`,i,...t))}debug(i,...t){this.getLevel()<=g.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,i,...t):console.log(`[main ${L()}]`,i,...t))}info(i,...t){this.getLevel()<=g.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,i,...t):console.log(`[main ${L()}]`,i,...t))}warn(i,...t){this.getLevel()<=g.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,i,...t):console.warn(`[main ${L()}]`,i,...t))}error(i,...t){this.getLevel()<=g.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,i,...t):console.error(`[main ${L()}]`,i,...t))}critical(i,...t){this.getLevel()<=g.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,i,...t):console.error(`[main ${L()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class w extends S{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=g.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=g.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=g.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=g.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=g.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=g.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=w;class D extends S{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=g.Trace&&this.adapter.log(g.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=g.Debug&&this.adapter.log(g.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=g.Info&&this.adapter.log(g.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=g.Warning&&this.adapter.log(g.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=g.Error&&this.adapter.log(g.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=g.Critical&&this.adapter.log(g.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,O.toErrorMessage)(i,this.getLevel()<=g.Trace)}dispose(){}flush(){}}e.AdapterLogger=D;class a extends S{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const n of this.logServices)n.trace(i,...t)}debug(i,...t){for(const n of this.logServices)n.debug(i,...t)}info(i,...t){for(const n of this.logServices)n.info(i,...t)}warn(i,...t){for(const n of this.logServices)n.warn(i,...t)}error(i,...t){for(const n of this.logServices)n.error(i,...t)}critical(i,...t){for(const n of this.logServices)n.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=a;class C extends A.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=C;class b{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(i){}getLevel(){return g.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=b;function p(o){if(o.verbose)return g.Trace;if(typeof o.logLevel=="string"){const i=E(o.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function E(o){switch(o){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Critical;case"off":return g.Off}}e.parseLogLevel=E;function m(o){switch(o){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Critical:return"critical";case g.Off:return"off"}}e.LogLevelToString=m}),define(Q[150],Z([0,1,27,2,9,28,10,5,11,34,14,30,56,7,6]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends A.Disposable{constructor(E,m,o,i){super();this.fileService=m,this.extensionGalleryService=o,this.logService=i,this.extensionsDownloadDir=L.URI.file(E.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(E,m){await this.cleanUpPromise;const o=this.getName(E),i=(0,g.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(i)){const t=(0,g.joinPath)(this.extensionsDownloadDir,`.${o}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(E,t,m),await this.rename(t,i,Date.now()+2*60*1e3)}return i}async delete(E){}async rename(E,m,o){try{await v.promises.rename(E.fsPath,m.fsPath)}catch(i){if(D.isWindows&&i&&i.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${E} to ${m} with 'EPERM' error. Trying again...`),this.rename(E,m,o);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const E=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(E.children){const m=[],o=[];for(const n of E.children){const r=this.parse(n.name);r&&o.push([r,n])}const i=(0,S.groupByExtension)(o,([n])=>n),t=[];for(const n of i)n.sort((r,c)=>w.rcompare(r[0].version,c[0].version)),m.push(...n.slice(1).map(r=>r[1].resource)),t.push(n[0][1]);t.sort((n,r)=>n.mtime-r.mtime),m.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(n=>n.resource)),await a.Promises.settled(m.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(E){this.logService.error(E)}}getName(E){return this.cache?new S.ExtensionIdentifierWithVersion(E.identifier,E.version).key().toLowerCase():(0,h.generateUuid)()}parse(E){const m=C.exec(E);return m&&m[1]&&m[2]?new S.ExtensionIdentifierWithVersion({id:m[1]},m[2]):null}};b=ue([Y(0,O.INativeEnvironmentService),Y(1,k.IFileService),Y(2,R.IExtensionGalleryService),Y(3,I.ILogService)],b),e.ExtensionsDownloader=b}),define(Q[151],Z([0,1,2,14,48,43,8,6,3,16,23,10]),function(G,e,v,A,k,R,O,L,g,S,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let w=class extends v.Disposable{constructor(a,C){super();this.environmentService=a,this.logService=C,this.processesLimiter=new L.Limiter(5)}async postUninstall(a){const C=this.parseScript(a,"uninstall");return C&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,a).then(()=>this.logService.info(a.identifier.id,a.manifest.version,"Finished running post uninstall script"),b=>this.logService.error(a.identifier.id,a.manifest.version,`Failed to run post uninstall script: ${b}`)))),(0,I.rimraf)(this.getExtensionStoragePath(a)).then(void 0,b=>this.logService.error("Error while removing extension storage path",b))}parseScript(a,C){const b=`vscode:${C}`;if(a.location.scheme===S.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[b]=="string"){const p=a.manifest.scripts[b].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${b} should be a node script`),null):{script:(0,O.join)(a.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(a,C,b,p,E){return new Promise((m,o)=>{const i=this.start(a,C,b,E);let t;const n=r=>{t&&(clearTimeout(t),t=null),r?o(r):m(void 0)};i.on("error",r=>{n((0,R.toErrorMessage)(r)||"Unknown")}),i.on("exit",(r,c)=>{n(r?`post-${C} process exited with code ${r}`:void 0)}),p&&(t=setTimeout(()=>{t=null,i.kill(),o("timed out")},5e3))})}start(a,C,b,p){const E={silent:!0,execArgv:void 0},m=(0,k.fork)(a,[`--type=extension-post-${C}`,...b],E);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const o=g.Event.fromNodeEventEmitter(m.stdout,"data"),i=g.Event.fromNodeEventEmitter(m.stderr,"data");o(r=>this.logService.info(p.identifier.id,p.manifest.version,`post-${C}`,r)),i(r=>this.logService.error(p.identifier.id,p.manifest.version,`post-${C}`,r));const t=g.Event.any(g.Event.map(o,r=>({data:`%c${r}`,format:[""]})),g.Event.map(i,r=>({data:`%c${r}`,format:["color: red"]})));return g.Event.debounce(t,(r,c)=>r?{data:r.data+c.data,format:[...r.format,...c.format]}:{data:c.data,format:c.format},100)(r=>{console.group(p.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),m}getExtensionStoragePath(a){return(0,O.join)(this.environmentService.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};w=ue([Y(0,h.IEnvironmentService),Y(1,A.ILogService)],w),e.ExtensionsLifecycle=w}),define(Q[152],Z([0,1,115,153,2,9,3,11,37,18,14,22,47,6,29,16,73,52]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class extends k.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new O.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(o,i){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,A.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:i});const t=new k.DisposableStore;return t.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new R.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),t.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:o}))),typeof i.onDidErrorOccur=="function"&&t.add(i.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,k.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:i}),this.provider.delete(o),(0,k.dispose)(t)})}async activateProvider(o){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){i.push(t)}}),!this.provider.has(o)&&await D.Promises.settled(i)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,i){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&i)}listCapabilities(){return p.Iterable.map(this.provider,([o,i])=>({scheme:o,capabilities:i.capabilities}))}async withProvider(o){if(!(0,L.isAbsolutePath)(o))throw new R.FileOperationError((0,v.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const i=this.provider.get(o.scheme);if(!i){const t=new Error;throw t.name="ENOPRO",t.message=(0,v.localize)(1,null,o.toString()),t}return i}async withReadProvider(o){const i=await this.withProvider(o);if((0,R.hasOpenReadWriteCloseCapability)(i)||(0,R.hasReadWriteCapability)(i)||(0,R.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const i=await this.withProvider(o);if((0,R.hasOpenReadWriteCloseCapability)(i)||(0,R.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,i){try{return await this.doResolveFile(o,i)}catch(t){throw(0,R.toFileSystemProviderErrorCode)(t)===R.FileSystemProviderErrorCode.FileNotFound?new R.FileOperationError((0,v.localize)(2,null,this.resourceForError(o)),1):(0,R.ensureFileSystemProviderError)(t)}}async doResolveFile(o,i){const t=await this.withProvider(o),n=this.isPathCaseSensitive(t),r=i==null?void 0:i.resolveTo,c=i==null?void 0:i.resolveSingleChildDescendants,s=i==null?void 0:i.resolveMetadata,l=await t.stat(o);let d;return this.toFileStat(t,o,l,void 0,!!s,(f,y)=>(d||(d=g.TernarySearchTree.forUris(()=>!n),d.set(o,!0),(0,S.isNonEmptyArray)(r)&&r.forEach(u=>d.set(u,!0))),Boolean(d.findSuperstr(f.resource)||d.get(f.resource))?!0:f.isDirectory&&c?y===1:!1))}async toFileStat(o,i,t,n,r,c){const{providerExtUri:s}=this.getExtUri(o),l={resource:i,name:s.basename(i),isFile:(t.type&R.FileType.File)!=0,isDirectory:(t.type&R.FileType.Directory)!=0,isSymbolicLink:(t.type&R.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,R.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&c(l,n)){try{const d=await o.readdir(i),f=await D.Promises.settled(d.map(async([y,u])=>{try{const P=s.joinPath(i,y),_=r?await o.stat(P):{type:u};return await this.toFileStat(o,P,_,d.length,r,c)}catch(P){return this.logService.trace(P),null}}));l.children=(0,S.coalesce)(f)}catch(d){this.logService.trace(d),l.children=[]}return l}return l}async resolveAll(o){return D.Promises.settled(o.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const i=await this.withProvider(o);try{return!!await i.stat(o)}catch(t){return!1}}async canCreateFile(o,i){try{await this.doValidateCreateFile(o,i)}catch(t){return t}return!0}async doValidateCreateFile(o,i){if(!(i==null?void 0:i.overwrite)&&await this.exists(o))throw new R.FileOperationError((0,v.localize)(3,null,this.resourceForError(o)),3,i)}async createFile(o,i=h.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const n=await this.writeFile(o,i);return this._onDidRunOperation.fire(new R.FileOperationEvent(o,0,n)),n}async writeFile(o,i,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,o,t)||await this.mkdirp(n,r.dirname(o));let s;if((0,R.hasReadWriteCapability)(n)&&!(i instanceof h.VSBuffer))if((0,w.isReadableStream)(i)){const l=await(0,w.peekStream)(i,3);l.ended?s=h.VSBuffer.concat(l.buffer):s=l}else s=(0,w.peekReadable)(i,l=>h.VSBuffer.concat(l),3);else s=i;!(0,R.hasOpenReadWriteCloseCapability)(n)||(0,R.hasReadWriteCapability)(n)&&s instanceof h.VSBuffer?await this.doWriteUnbuffered(n,o,s):await this.doWriteBuffered(n,o,s instanceof h.VSBuffer?(0,h.bufferToReadable)(s):s)}catch(c){throw new R.FileOperationError((0,v.localize)(4,null,this.resourceForError(o),(0,R.ensureFileSystemProviderError)(c).toString()),(0,R.toFileOperationResult)(c),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,i,t){let n;try{n=await o.stat(i)}catch(r){return}if((n.type&R.FileType.Directory)!=0)throw new R.FileOperationError((0,v.localize)(5,null,this.resourceForError(i)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==R.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,R.etag)({mtime:t.mtime,size:n.size}))throw new R.FileOperationError((0,v.localize)(6,null),3,t);return n}async readFile(o,i){const t=await this.withReadProvider(o);return(i==null?void 0:i.atomic)?this.doReadFileAtomic(t,o,i):this.doReadFile(t,o,i)}async doReadFileAtomic(o,i,t){return new Promise((n,r)=>{this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(o,i,t);n(c)}catch(c){r(c)}})})}async doReadFile(o,i,t){const n=await this.doReadFileStream(o,i,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},n),{value:await(0,h.streamToBuffer)(n.value)})}async readFileStream(o,i){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,i)}async doReadFileStream(o,i,t){const n=new a.CancellationTokenSource,r=this.validateReadFile(i,t).then(s=>s,s=>{throw n.cancel(),s});let c;try{t&&typeof t.etag=="string"&&t.etag!==R.ETAG_DISABLED&&await r,!((0,R.hasOpenReadWriteCloseCapability)(o)||(0,R.hasFileReadStreamCapability)(o))||(0,R.hasReadWriteCapability)(o)&&(t==null?void 0:t.preferUnbuffered)?c=this.readFileUnbuffered(o,i,t):(0,R.hasFileReadStreamCapability)(o)?c=this.readFileStreamed(o,i,n.token,t):c=this.readFileBuffered(o,i,n.token,t);const s=await r;return Object.assign(Object.assign({},s),{value:c})}catch(s){throw c&&await(0,w.consumeStream)(c),new R.FileOperationError((0,v.localize)(7,null,this.resourceForError(i),(0,R.ensureFileSystemProviderError)(s).toString()),(0,R.toFileOperationResult)(s),t)}}readFileStreamed(o,i,t,n=Object.create(null)){const r=o.readFileStream(i,n,t);return(0,w.transform)(r,{data:c=>c instanceof h.VSBuffer?c:h.VSBuffer.wrap(c),error:c=>new R.FileOperationError((0,v.localize)(8,null,this.resourceForError(i),(0,R.ensureFileSystemProviderError)(c).toString()),(0,R.toFileOperationResult)(c),n)},c=>h.VSBuffer.concat(c))}readFileBuffered(o,i,t,n=Object.create(null)){const r=(0,h.newWriteableBufferStream)();return(0,b.readFileIntoStream)(o,i,r,c=>c,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:c=>new R.FileOperationError((0,v.localize)(9,null,this.resourceForError(i),(0,R.ensureFileSystemProviderError)(c).toString()),(0,R.toFileOperationResult)(c),n)}),t),r}readFileUnbuffered(o,i,t){const n=(0,w.newWriteableStream)(r=>h.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(i);t&&typeof t.position=="number"&&(r=r.slice(t.position)),t&&typeof t.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(i,r.byteLength,t),n.end(h.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(o,i){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new R.FileOperationError((0,v.localize)(10,null,this.resourceForError(o)),0,i);if(i&&typeof i.etag=="string"&&i.etag!==R.ETAG_DISABLED&&i.etag===t.etag)throw new R.FileOperationError((0,v.localize)(11,null),2,i);return this.validateReadFileLimits(o,t.size,i),t}validateReadFileLimits(o,i,t){if(t==null?void 0:t.limits){let n;if(typeof t.limits.memory=="number"&&i>t.limits.memory&&(n=9),typeof t.limits.size=="number"&&i>t.limits.size&&(n=7),typeof n=="number")throw new R.FileOperationError((0,v.localize)(12,null,this.resourceForError(o)),n)}}async canMove(o,i,t){return this.doCanMoveCopy(o,i,"move",t)}async canCopy(o,i,t){return this.doCanMoveCopy(o,i,"copy",t)}async doCanMoveCopy(o,i,t,n){if(o.toString()!==i.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,o,c,i,t,n)}catch(r){return r}return!0}async move(o,i,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),c=await this.doMoveCopy(n,o,r,i,"move",!!t),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,c==="move"?2:3,s)),s}async copy(o,i,t){const n=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),c=await this.doMoveCopy(n,o,r,i,"copy",!!t),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,c==="copy"?3:2,s)),s}async doMoveCopy(o,i,t,n,r,c){if(i.toString()===n.toString())return r;const{exists:s,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(o,i,t,n,r,c);if(s&&!l&&c&&await this.del(n,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n)),r==="copy"){if(o===t&&(0,R.hasFileFolderCopyCapability)(o))await o.copy(i,n,{overwrite:c});else{const d=await this.resolve(i);d.isDirectory?await this.doCopyFolder(o,d,t,n):await this.doCopyFile(o,i,t,n)}return r}else return o===t?(await o.rename(i,n,{overwrite:c}),r):(await this.doMoveCopy(o,i,t,n,"copy",c),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(o,i,t,n){if((0,R.hasOpenReadWriteCloseCapability)(o)&&(0,R.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,i,t,n);if((0,R.hasOpenReadWriteCloseCapability)(o)&&(0,R.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,i,t,n);if((0,R.hasReadWriteCapability)(o)&&(0,R.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,i,t,n);if((0,R.hasReadWriteCapability)(o)&&(0,R.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,i,t,n)}async doCopyFolder(o,i,t,n){await t.mkdir(n),Array.isArray(i.children)&&await D.Promises.settled(i.children.map(async r=>{const c=this.getExtUri(t).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),t,c):this.doCopyFile(o,r.resource,t,c)}))}async doValidateMoveCopy(o,i,t,n,r,c){let s=!1;if(o===t){const{providerExtUri:d,isPathCaseSensitive:f}=this.getExtUri(o);if(f||(s=d.isEqual(i,n)),s&&r==="copy")throw new Error((0,v.localize)(13,null,this.resourceForError(i),this.resourceForError(n)));if(!s&&d.isEqualOrParent(n,i))throw new Error((0,v.localize)(14,null,this.resourceForError(i),this.resourceForError(n)))}const l=await this.exists(n);if(l&&!s){if(!c)throw new R.FileOperationError((0,v.localize)(15,null,this.resourceForError(i),this.resourceForError(n)),4);if(o===t){const{providerExtUri:d}=this.getExtUri(o);if(d.isEqualOrParent(i,n))throw new Error((0,v.localize)(16,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:s}}getExtUri(o){const i=this.isPathCaseSensitive(o);return{providerExtUri:i?L.extUri:L.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(i,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,0,t)),t}async mkdirp(o,i){const t=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(i,n.dirname(i));)try{if(((await o.stat(i)).type&R.FileType.Directory)==0)throw new Error((0,v.localize)(17,null,this.resourceForError(i)));break}catch(r){if((0,R.toFileSystemProviderErrorCode)(r)!==R.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(n.basename(i)),i=n.dirname(i)}for(let r=t.length-1;r>=0;r--){i=n.joinPath(i,t[r]);try{await o.mkdir(i)}catch(c){if((0,R.toFileSystemProviderErrorCode)(c)!==R.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(o,i){try{await this.doValidateDelete(o,i)}catch(t){return t}return!0}async doValidateDelete(o,i){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(i==null?void 0:i.useTrash)&&!(t.capabilities&4096))throw new Error((0,v.localize)(18,null,this.resourceForError(o)));const r=await this.exists(o);if(!r)throw new R.FileOperationError((0,v.localize)(19,null,this.resourceForError(o)),1);if(!!!(i==null?void 0:i.recursive)&&r){const s=await this.resolve(o);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,v.localize)(20,null,this.resourceForError(o)))}return t}async del(o,i){const t=await this.doValidateDelete(o,i),n=!!(i==null?void 0:i.useTrash),r=!!(i==null?void 0:i.recursive);await t.delete(o,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new R.FileOperationEvent(o,1))}watch(o,i={recursive:!1,excludes:[]}){let t=!1,n=()=>{t=!0};return this.doWatch(o,i).then(r=>{t?(0,k.dispose)(r):n=()=>(0,k.dispose)(r)},r=>this.logService.error(r)),(0,k.toDisposable)(()=>n())}async doWatch(o,i){const t=await this.withProvider(o),n=this.toWatchKey(t,o,i),r=this.activeWatchers.get(n)||{count:0,disposable:t.watch(o,i)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,r),r.count+=1,(0,k.toDisposable)(()=>{r.count--,r.count===0&&((0,k.dispose)(r.disposable),this.activeWatchers.delete(n))})}toWatchKey(o,i,t){const{providerExtUri:n}=this.getExtUri(o);return[n.getComparisonKey(i),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>(0,k.dispose)(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,i,t){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(i,{create:!0});try{(0,w.isReadableStream)(t)||(0,w.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(o,n,t):await this.doWriteReadableBufferedQueued(o,n,t)}catch(r){throw(0,R.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,i,t){let n=0,r;if((0,w.isReadableBufferedStream)(t)){if(t.buffer.length>0){const c=h.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,i,c,c.byteLength,n,0),n+=c.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise(async(c,s)=>{(0,w.listenStream)(r,{onData:async l=>{r.pause();try{await this.doWriteBuffer(o,i,l,l.byteLength,n,0)}catch(d){return s(d)}n+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>s(l),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(o,i,t){let n=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(o,i,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(o,i,t,n,r,c){let s=0;for(;s<n;)s+=await o.write(i,r+s,t.buffer,c+s,n-s)}async doWriteUnbuffered(o,i,t){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,i,t))}async doWriteUnbufferedQueued(o,i,t){let n;t instanceof h.VSBuffer?n=t:(0,w.isReadableStream)(t)?n=await(0,h.streamToBuffer)(t):(0,w.isReadableBufferedStream)(t)?n=await(0,h.bufferedStreamToBuffer)(t):n=(0,h.readableToBuffer)(t),await o.writeFile(i,n.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(o,i,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,i,t,n))}async doPipeBufferedQueued(o,i,t,n){let r,c;try{r=await o.open(i,{create:!1}),c=await t.open(n,{create:!0});const s=h.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,d=0,f=0;do f=await o.read(r,l,s.buffer,d,s.byteLength-d),await this.doWriteBuffer(t,c,s,f,l,d),l+=f,d+=f,d===s.byteLength&&(d=0);while(f>0)}catch(s){throw(0,R.ensureFileSystemProviderError)(s)}finally{await D.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof c=="number"?t.close(c):Promise.resolve()])}}async doPipeUnbuffered(o,i,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,i,t,n))}async doPipeUnbufferedQueued(o,i,t,n){return t.writeFile(n,await o.readFile(i),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(o,i,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,i,t,n))}async doPipeUnbufferedToBufferedQueued(o,i,t,n){const r=await t.open(n,{create:!0});try{const c=await o.readFile(i);await this.doWriteBuffer(t,r,h.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,R.ensureFileSystemProviderError)(c)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(o,i,t,n){const r=await(0,h.streamToBuffer)(this.readFileBuffered(o,i,a.CancellationToken.None));await this.doWriteUnbuffered(t,n,r)}throwIfFileSystemIsReadonly(o,i){if(o.capabilities&2048)throw new R.FileOperationError((0,v.localize)(21,null,this.resourceForError(i)),6);return o}resourceForError(o){return o.scheme===C.Schemas.file?o.fsPath:o.toString(!0)}};E=ue([Y(0,I.ILogService)],E),e.FileService=E}),define(Q[154],Z([0,1,27,203,2,9,3,7,23,8,11,42,6,14,118,74,132,134,131,145,47,73,18,22]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b,p,E,m,o,i,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class r extends k.Disposable{constructor(s,l){var d;super();this.logService=s,this.options=l,this.BUFFER_SIZE=((d=this.options)===null||d===void 0?void 0:d.bufferSize)||64*1024,this.onDidChangeCapabilities=O.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new O.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new w.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:l,symbolicLink:d}=await g.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(l,d),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(s){try{const l=await(0,g.readdir)(this.toFilePath(s),{withFileTypes:!0}),d=[];return await Promise.all(l.map(async f=>{try{let y;f.isSymbolicLink()?y=(await this.stat((0,I.joinPath)(s,f.name))).type:y=this.toType(f),d.push([f.name,y])}catch(y){this.logService.trace(y)}})),d}catch(l){throw this.toFileSystemProviderError(l)}}toType(s,l){let d;return(l==null?void 0:l.dangling)?d=R.FileType.Unknown:s.isFile()?d=R.FileType.File:s.isDirectory()?d=R.FileType.Directory:d=R.FileType.Unknown,l&&(d|=R.FileType.SymbolicLink),d}async readFile(s){try{const l=this.toFilePath(s);return await v.promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(s,l,d){const f=(0,o.newWriteableStream)(y=>n.VSBuffer.concat(y.map(u=>n.VSBuffer.wrap(u))).buffer);return(0,i.readFileIntoStream)(this,s,f,y=>y.buffer,Object.assign(Object.assign({},l),{bufferSize:this.BUFFER_SIZE}),d),f}async writeFile(s,l,d){let f;try{const y=this.toFilePath(s);if(!d.create||!d.overwrite){if(await(0,g.exists)(y)){if(!d.overwrite)throw(0,R.createFileSystemProviderError)((0,a.localize)(0,null),R.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw(0,R.createFileSystemProviderError)((0,a.localize)(1,null),R.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(s,{create:!0}),await this.write(f,0,l,0,l.byteLength)}catch(y){throw this.toFileSystemProviderError(y)}finally{typeof f=="number"&&await this.close(f)}}async open(s,l){try{const d=this.toFilePath(s);let f;if(l.create){if(L.isWindows)try{await v.promises.truncate(d,0),f="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}f||(f="w")}else f="r";const y=await(0,A.promisify)(v.open)(d,f);return this.mapHandleToPos.set(y,0),l.create&&this.writeHandles.add(y),y}catch(d){throw this.toFileSystemProviderError(d)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await(0,A.promisify)(v.fdatasync)(s)}catch(l){this.canFlush=!1,this.logService.error(l)}return await(0,A.promisify)(v.close)(s)}catch(l){throw this.toFileSystemProviderError(l)}}async read(s,l,d,f,y){const u=this.normalizePos(s,l);let P=null;try{const _=await(0,A.promisify)(v.read)(s,d,f,y,u);return typeof _=="number"?P=_:P=_.bytesRead,P}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(s,u,P)}}normalizePos(s,l){return l===this.mapHandleToPos.get(s)?null:l}updatePos(s,l,d){const f=this.mapHandleToPos.get(s);typeof f=="number"&&(typeof l=="number"||(typeof d=="number"?this.mapHandleToPos.set(s,f+d):this.mapHandleToPos.delete(s)))}async write(s,l,d,f,y){return(0,w.retry)(()=>this.doWrite(s,l,d,f,y),100,3)}async doWrite(s,l,d,f,y){const u=this.normalizePos(s,l);let P=null;try{const _=await(0,A.promisify)(v.write)(s,d,f,y,u);return typeof _=="number"?P=_:P=_.bytesWritten,P}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(s,u,P)}}async mkdir(s){try{await v.promises.mkdir(this.toFilePath(s))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(s,l){try{const d=this.toFilePath(s);await this.doDelete(d,l)}catch(d){throw this.toFileSystemProviderError(d)}}async doDelete(s,l){l.recursive?await(0,g.rimraf)(s,g.RimRafMode.MOVE):await v.promises.unlink(s)}async rename(s,l,d){const f=this.toFilePath(s),y=this.toFilePath(l);if(f!==y)try{await this.validateTargetDeleted(s,l,"move",d.overwrite),await(0,g.move)(f,y)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,a.localize)(2,null,(0,S.basename)(f),(0,S.basename)((0,S.dirname)(y)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(s,l,d){const f=this.toFilePath(s),y=this.toFilePath(l);if(f!==y)try{await this.validateTargetDeleted(s,l,"copy",d.overwrite),await(0,g.copy)(f,y,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,a.localize)(3,null,(0,S.basename)(f),(0,S.basename)((0,S.dirname)(y)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(s,l,d,f){const y=this.toFilePath(s),u=this.toFilePath(l);let P=!1;if(!!(this.capabilities&1024)||(P=(0,h.isEqual)(y,u,!0)),P&&d==="copy")throw(0,R.createFileSystemProviderError)((0,a.localize)(4,null),R.FileSystemProviderErrorCode.FileExists);if(!P&&await(0,g.exists)(u)){if(!f)throw(0,R.createFileSystemProviderError)((0,a.localize)(5,null),R.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}watch(s,l){return l.recursive?this.watchRecursive(s,l.excludes):this.watchNonRecursive(s)}watchRecursive(s,l){const d={path:this.toFilePath(s),excludes:l},f=(0,t.insert)(this.recursiveFoldersToWatch,d);return this.refreshRecursiveWatchers(),(0,k.toDisposable)(()=>{f(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,l,d;if(this.recursiveWatcher instanceof E.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,k.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let f,y;((l=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||l===void 0?void 0:l.usePolling)?(f=b.FileWatcher,y=(d=this.options)===null||d===void 0?void 0:d.watcher):this.recursiveFoldersToWatch.length===1?L.isWindows?f=p.FileWatcher:f=b.FileWatcher:f=E.FileWatcher,this.recursiveWatcher=new f(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,C.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===D.LogLevel.Trace,y),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)}))}}watchNonRecursive(s){const l=new m.FileWatcher(this.toFilePath(s),f=>this._onDidChangeFile.fire((0,C.toFileChanges)(f)),f=>{f.type==="error"&&this._onDidWatchErrorOccur.fire(f.message),this.logService[f.type](f.message)},this.logService.getLevel()===D.LogLevel.Trace),d=this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)});return(0,k.combinedDisposable)(l,d)}toFilePath(s){return(0,S.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof R.FileSystemProviderError)return s;let l;switch(s.code){case"ENOENT":l=R.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=R.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=R.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=R.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=R.FileSystemProviderErrorCode.NoPermissions;break;default:l=R.FileSystemProviderErrorCode.Unknown}return(0,R.createFileSystemProviderError)(s,l)}dispose(){super.dispose(),(0,k.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,k.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=r}),define(Q[155],Z([0,1,23,27,144,28,2,10,6,34,14,55,18,3,16,8]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let b=class extends O.Disposable{constructor(m,o,i){super();this.extensionManagementService=m,this.logService=i,this._onDidLanguagesChange=this._register(new D.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new p(o,i)),this._register(m.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(m.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(m=>{const o=["en",...Object.keys(m)];return(0,w.distinct)(o)})}onDidInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",m.identifier.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(m){this.cache.getLanguagePacks().then(o=>{Object.keys(o).some(i=>o[i]&&o[i].extensions.some(t=>(0,S.areSameExtensions)(t.extensionIdentifier,m)))&&(this.logService.debug("Removing language packs from the extension",m.id),this.update().then(i=>{i&&this._onDidLanguagesChange.fire()}))})}async update(){const[m,o]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(o);return!(0,w.equals)(Object.keys(m),Object.keys(i))}};b=ue([Y(0,R.IExtensionManagementService),Y(1,L.INativeEnvironmentService),Y(2,I.ILogService)],b),e.LocalizationsService=b;let p=class extends O.Disposable{constructor(m,o){super();this.logService=o,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new g.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(o=>{Object.keys(o).forEach(i=>delete o[i]),this.createLanguagePacksFromExtensions(o,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...o){for(const i of o)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,i);Object.keys(m).forEach(i=>this.updateHash(m[i]))}createLanguagePacksFromExtension(m,o){const i=o.identifier,t=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const n of t)if(o.location.scheme===a.Schemas.file&&(0,h.isValidLocalization)(n)){let r=m[n.languageId];r||(r={hash:"",extensions:[],translations:{}},m[n.languageId]=r);let c=r.extensions.filter(s=>(0,S.areSameExtensions)(s.extensionIdentifier,i))[0];c?c.version=o.manifest.version:r.extensions.push({extensionIdentifier:i,version:o.manifest.version});for(const s of n.translations)r.translations[s.id]=(0,C.join)(o.location.fsPath,s.path)}}updateHash(m){if(m){const o=(0,k.createHash)("md5");for(const i of m.extensions)o.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);m.hash=o.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let o=null;return A.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch(t){return{}}}).then(i=>(o=m(i),i)).then(i=>{for(const n of Object.keys(i))i[n]||delete i[n];this.languagePacks=i,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),(0,v.writeFile)(this.languagePacksFilePath,t)}).then(()=>o,i=>this.logService.error(i))})}};p=ue([Y(0,L.INativeEnvironmentService),Y(1,I.ILogService)],p)}),define(Q[156],Z([0,1,14]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function A(R,O){switch(O){case v.LogLevel.Trace:return R.trace;case v.LogLevel.Debug:return R.debug;case v.LogLevel.Info:return R.info;case v.LogLevel.Warning:return R.warn;case v.LogLevel.Error:return R.error;case v.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends v.AbstractLogger{constructor(O=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(O),this._register(this.onDidChangeLogLevel(L=>{this._logger&&this._logger.setLevel(L)}))}set logger(O){this._logger=O;for(const{level:L,args:g}of this.buffer)A(O,L).apply(O,g);this.buffer=[]}_log(O,...L){this._logger?A(this._logger,O).apply(this._logger,L):this.getLevel()<=O&&this.buffer.push({level:O,args:L})}trace(O,...L){this._log(v.LogLevel.Trace,O,...L)}debug(O,...L){this._log(v.LogLevel.Debug,O,...L)}info(O,...L){this._log(v.LogLevel.Info,O,...L)}warn(O,...L){this._log(v.LogLevel.Warning,O,...L)}error(O,...L){this._log(v.LogLevel.Error,O,...L)}critical(O,...L){this._log(v.LogLevel.Critical,O,...L)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k}),define(Q[157],Z([0,1,14,9,6,22,11,2,4,156]),function(G,e,v,A,k,R,O,L,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const I=5*A.ByteSize.MB;let h=class extends v.AbstractLogger{constructor(a,C,b,p){super();this.name=a,this.resource=C,this.fileService=p,this.backupIndex=1,this.setLevel(b),this.queue=this._register(new k.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=v.LogLevel.Trace&&this._log(v.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=v.LogLevel.Debug&&this._log(v.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=v.LogLevel.Info&&this._log(v.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=v.LogLevel.Warning&&this._log(v.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=v.LogLevel.Error){const a=arguments[0];if(a instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=a.stack,this._log(v.LogLevel.Error,this.format(C))}else this._log(v.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=v.LogLevel.Critical&&this._log(v.LogLevel.Critical,this.format(arguments))}flush(){}log(a,C){this._log(a,this.format(C))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(a){if(a.fileOperationResult!==3)throw a}}_log(a,C){this.queue.queue(async()=>{await this.initializePromise;let b=await this.loadContent();b.length>I&&(await this.fileService.writeFile(this.getBackupResource(),R.VSBuffer.fromString(b)),b=""),b+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(a)}] ${C}
`,await this.fileService.writeFile(this.resource,R.VSBuffer.fromString(b))})}getCurrentTimestamp(){const a=p=>p<10?`0${p}`:p,C=p=>p<10?`00${p}`:p<100?`0${p}`:p,b=new Date;return`${b.getFullYear()}-${a(b.getMonth()+1)}-${a(b.getDate())} ${a(b.getHours())}:${a(b.getMinutes())}:${a(b.getSeconds())}.${C(b.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,O.joinPath)((0,O.dirname)(this.resource),`${(0,O.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(a){return""}}stringifyLogLevel(a){switch(a){case v.LogLevel.Critical:return"critical";case v.LogLevel.Debug:return"debug";case v.LogLevel.Error:return"error";case v.LogLevel.Info:return"info";case v.LogLevel.Trace:return"trace";case v.LogLevel.Warning:return"warning"}return""}format(a){let C="";for(let b=0;b<a.length;b++){let p=a[b];if(typeof p=="object")try{p=JSON.stringify(p)}catch(E){}C+=(b>0?" ":"")+p}return C}};h=ue([Y(3,A.IFileService)],h),e.FileLogger=h;let w=class extends L.Disposable{constructor(a,C,b){super();this.logService=a,this.instantiationService=C,this.fileService=b,this.loggers=new Map,this._register(a.onDidChangeLogLevel(p=>this.loggers.forEach(E=>E.setLevel(p))))}createLogger(a){let C=this.loggers.get(a.toString());return C||(C=new S.BufferLogService(this.logService.getLevel()),this.loggers.set(a.toString(),C),(0,A.whenProviderRegistered)(a,this.fileService).then(()=>C.logger=this.instantiationService.createInstance(h,(0,O.basename)(a),a,this.logService.getLevel()))),C}dispose(){this.loggers.forEach(a=>a.dispose()),this.loggers.clear(),super.dispose()}};w=ue([Y(0,v.ILogService),Y(1,g.IInstantiationService),Y(2,A.IFileService)],w),e.FileLoggerService=w}),define(Q[76],Z([0,1,14,3,5]),function(G,e,v,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(w){this.service=w,this.onDidChangeLogLevel=A.Event.buffer(w.onDidChangeLogLevel,!0)}listen(w,D){switch(D){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${D}`)}async call(w,D,a){switch(D){case"setLevel":return this.service.setLevel(a)}throw new Error(`Call not found: ${D}`)}}e.LogLevelChannel=R;class O{constructor(w){this.channel=w}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(w){O.setLevel(this.channel,w)}static setLevel(w,D){return w.call("setLevel",D)}}e.LogLevelChannelClient=O;class L{constructor(w){this.loggerService=w,this.loggers=new Map}listen(w,D){throw new Error(`Event not found: ${D}`)}async call(w,D,a){switch(D){case"createLogger":this.createLogger(k.URI.revive(a[0]),a[1]);return;case"log":return this.log(k.URI.revive(a[0]),a[1]);case"consoleLog":return this.consoleLog(a[0],a[1])}throw new Error(`Call not found: ${D}`)}createLogger(w,D){this.loggers.set(w.toString(),this.loggerService.createLogger(w,D))}consoleLog(w,D){let a=console.log;switch(w){case v.LogLevel.Error:a=console.error;break;case v.LogLevel.Warning:a=console.warn;break;case v.LogLevel.Info:a=console.info;break}a.call(console,...D)}log(w,D){const a=this.loggers.get(w.toString());if(!a)throw new Error("Create the logger before logging");for(const[C,b]of D)switch(C){case v.LogLevel.Trace:a.trace(b);break;case v.LogLevel.Debug:a.debug(b);break;case v.LogLevel.Info:a.info(b);break;case v.LogLevel.Warning:a.warn(b);break;case v.LogLevel.Error:a.error(b);break;case v.LogLevel.Critical:a.critical(b);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=L;class g{constructor(w){this.channel=w}createConsoleMainLogger(){return new v.AdapterLogger({log:(w,D)=>{this.channel.call("consoleLog",[w,D])}})}createLogger(w,D){return new S(this.channel,w,D)}}e.LoggerChannelClient=g;class S extends v.AbstractMessageLogger{constructor(w,D,a){super(a==null?void 0:a.always);this.channel=w,this.file=D,this.isLoggerCreated=!1,this.buffer=[],this.channel.call("createLogger",[D,a]).then(()=>{this._log(this.buffer),this.isLoggerCreated=!0})}log(w,D){this._log([[w,D]])}_log(w){this.isLoggerCreated?this.channel.call("log",[this.file,w]):this.buffer.push(...w)}}class I extends v.LogService{constructor(w,D){super(D);this.parent=w,this._register(w.onDidChangeLogLevel(a=>D.setLevel(a)))}setLevel(w){super.setLevel(w),this.parent.setLevel(w)}}e.FollowerLogService=I}),define(Q[77],Z([0,1,14,9]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(g,S,I,h){try{const w=await new Promise((D,a)=>{G(["spdlog"],D,a)});return w.setAsyncMode(8192,500),w.createRotatingLoggerAsync(g,S,I,h)}catch(w){console.error(w)}return null}function R(g,S,I,h){return G.__$__nodeRequire("spdlog").createRotatingLogger(g,S,I,h)}e.createRotatingLogger=R;function O(g,S,I){switch(S){case v.LogLevel.Trace:g.trace(I);break;case v.LogLevel.Debug:g.debug(I);break;case v.LogLevel.Info:g.info(I);break;case v.LogLevel.Warning:g.warn(I);break;case v.LogLevel.Error:g.error(I);break;case v.LogLevel.Critical:g.critical(I);break;default:throw new Error("Invalid log level")}}class L extends v.AbstractMessageLogger{constructor(S,I,h,w){super();this.name=S,this.filepath=I,this.rotating=h,this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(D=>{this._logger&&this._logger.setLevel(D)}))}_createSpdLogLogger(){const S=this.rotating?6:1,I=30/S*A.ByteSize.MB;return k(this.name,this.filepath,I,S).then(h=>{if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:w,message:D}of this.buffer)O(this._logger,w,D);this.buffer=[]}})}log(S,I){this._logger?O(this._logger,S,I):this.getLevel()<=S&&this.buffer.push({level:S,message:I})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=L}),define(Q[158],Z([0,1,14,2,11,16,157,77,9,30]),function(G,e,v,A,k,R,O,L,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let I=class extends A.Disposable{constructor(w,D){super();this.logService=w,this.fileService=D,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(w.onDidChangeLogLevel(a=>this.logLevelChangeableLoggers.forEach(C=>C.setLevel(a))))}createLogger(w,D){var a;let C=this.loggers.get(w.toString());return C||(w.scheme===R.Schemas.file?(C=new L.SpdLogLogger((D==null?void 0:D.name)||(0,S.generateUuid)(),w.fsPath,!(D==null?void 0:D.donotRotate),this.logService.getLevel()),(D==null?void 0:D.donotUseFormatters)&&C.clearFormatters()):C=new O.FileLogger((a=D==null?void 0:D.name)!==null&&a!==void 0?a:(0,k.basename)(w),w,this.logService.getLevel(),this.fileService),this.loggers.set(w.toString(),C),(D==null?void 0:D.always)?C.setLevel(v.LogLevel.Trace):this.logLevelChangeableLoggers.push(C)),C}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(w=>w.dispose()),this.loggers.clear(),super.dispose()}};I=ue([Y(0,v.ILogService),Y(1,g.IFileService)],I),e.LoggerService=I}),define(Q[57],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,v.createDecorator)("nativeHostService")}),define(Q[36],Z([0,1,7,53,16,11]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;if(v.isWeb||typeof G=="undefined"||typeof G.__$__nodeRequire!="function")O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.55.0-dev",nameShort:v.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:v.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser"]});else{const L=(0,R.dirname)(k.FileAccess.asFileUri("",G));O=G.__$__nodeRequire((0,R.joinPath)(L,"product.json").fsPath);const g=G.__$__nodeRequire((0,R.joinPath)(L,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`}),Object.assign(O,{version:g.version})}e.default=O}),define(Q[159],Z([0,1,27,8,23,36,2,15,14,10]),function(G,e,v,A,k,R,O,L,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends O.Disposable{constructor(w,D){super();this._environmentService=w,this._logService=D,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let w=setTimeout(async()=>{w=void 0,this._logService.info("Starting to clean up unused language packs.");const D=R.default.nameLong.indexOf("Insiders")>=0?1e3*60*60*24*7:1e3*60*60*24*30*3;try{const a=Object.create(null),C=JSON.parse(await v.promises.readFile(A.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let m of Object.keys(C)){const o=C[m];a[`${o.hash}.${m}`]=!0}const b=A.join(this._environmentService.userDataPath,"clp");if(!await k.exists(b))return;for(let m of await k.readdir(b)){if(a[m]){this._logService.info(`Skipping directory ${m}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",m),await k.rimraf(A.join(b,m))}const E=Date.now();for(let m of Object.keys(a)){const o=A.join(b,m);for(let i of await k.readdir(o))if(i!=="tcf.json"){const t=A.join(o,i),n=await v.promises.stat(t);n.isDirectory()&&E-n.mtime.getTime()>D&&(this._logService.info("Removing language pack cache entry: ",A.join(m,i)),await k.rimraf(t))}}}catch(a){(0,L.onUnexpectedError)(a)}},40*1e3);this._register((0,O.toDisposable)(()=>{w!==void 0&&clearTimeout(w)}))}};I=ue([Y(0,S.INativeEnvironmentService),Y(1,g.ILogService)],I),e.LanguagePackCachedDataCleaner=I}),define(Q[160],Z([0,1,27,8,15,2,23,36]),function(G,e,v,A,k,R,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;class g{constructor(I){this.nodeCachedDataDir=I,this._disposables=new R.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!!this.nodeCachedDataDir){const I=(0,A.dirname)(this.nodeCachedDataDir),h=(0,A.basename)(this.nodeCachedDataDir);let w=setTimeout(()=>{w=void 0,(0,O.readdir)(I).then(D=>{const a=Date.now(),C=[];return D.forEach(b=>{if(b!==h){const p=(0,A.join)(I,b);C.push(v.promises.stat(p).then(E=>{if(E.isDirectory()&&a-E.mtime.getTime()>g._DataMaxAge)return(0,O.rimraf)(p)}))}}),Promise.all(C)}).then(void 0,k.onUnexpectedError)},30*1e3);this._disposables.add((0,R.toDisposable)(()=>{w&&(clearTimeout(w),w=void 0)}))}}}e.NodeCachedDataCleaner=g,g._DataMaxAge=L.default.nameLong.indexOf("Insiders")>=0?1e3*60*60*24*7:1e3*60*60*24*30*3}),define(Q[161],Z([0,1,38,36,96,8,11,86,54,16,5]),function(G,e,v,A,k,R,O,L,g,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataDir=e.parsePathArg=e.parseSearchPort=e.parseExtensionHostPort=e.NativeEnvironmentService=void 0;class h{constructor(E){if(this._args=E,!E.logsPath){const m=(0,g.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");E.logsPath=(0,R.join)(this.userDataPath,"logs",m)}this.logsPath=E.logsPath}get args(){return this._args}get appRoot(){return(0,R.dirname)(S.FileAccess.asFileUri("",G).fsPath)}get userHome(){return I.URI.file((0,v.homedir)())}get userDataPath(){const E=process.env.VSCODE_PORTABLE;return E?(0,R.join)(E,"user-data"):b(this._args,process)}get appSettingsHome(){return I.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file((0,v.tmpdir)())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,O.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,O.joinPath)(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return I.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.joinPath)(I.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return I.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return I.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,O.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,O.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=process.env.VSCODE_PORTABLE;return E?I.URI.file((0,R.join)(E,"argv.json")):(0,O.joinPath)(this.userHome,A.default.dataFolderName,"argv.json")}get snippetsHome(){return(0,O.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=C(this._args["builtin-extensions-dir"],process);return E||(0,R.normalize)((0,R.join)(S.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const E=C(this._args["extensions-download-dir"],process);return E||(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const E=C(this._args["extensions-dir"],process);if(E)return E;const m=process.env.VSCODE_EXTENSIONS;if(m)return m;const o=process.env.VSCODE_PORTABLE;return o?(0,R.join)(o,"extensions"):(0,O.joinPath)(this.userHome,A.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this._args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(m=>/^[^:/?#]+?:\/\//.test(m)?I.URI.parse(m):I.URI.file((0,R.normalize)(m)))}get extensionTestsLocationURI(){const E=this._args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?I.URI.parse(E):I.URI.file((0,R.normalize)(E))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const E=this._args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return w(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get serviceMachineIdResource(){return(0,O.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return I.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}ue([L.memoize],h.prototype,"appRoot",null),ue([L.memoize],h.prototype,"userHome",null),ue([L.memoize],h.prototype,"userDataPath",null),ue([L.memoize],h.prototype,"appSettingsHome",null),ue([L.memoize],h.prototype,"tmpDir",null),ue([L.memoize],h.prototype,"userRoamingDataHome",null),ue([L.memoize],h.prototype,"settingsResource",null),ue([L.memoize],h.prototype,"userDataSyncHome",null),ue([L.memoize],h.prototype,"userDataSyncLogResource",null),ue([L.memoize],h.prototype,"sync",null),ue([L.memoize],h.prototype,"machineSettingsResource",null),ue([L.memoize],h.prototype,"globalStorageHome",null),ue([L.memoize],h.prototype,"workspaceStorageHome",null),ue([L.memoize],h.prototype,"keybindingsResource",null),ue([L.memoize],h.prototype,"keyboardLayoutResource",null),ue([L.memoize],h.prototype,"argvResource",null),ue([L.memoize],h.prototype,"snippetsHome",null),ue([L.memoize],h.prototype,"isExtensionDevelopment",null),ue([L.memoize],h.prototype,"untitledWorkspacesHome",null),ue([L.memoize],h.prototype,"installSourcePath",null),ue([L.memoize],h.prototype,"builtinExtensionsPath",null),ue([L.memoize],h.prototype,"extensionsPath",null),ue([L.memoize],h.prototype,"extensionDevelopmentLocationURI",null),ue([L.memoize],h.prototype,"extensionTestsLocationURI",null),ue([L.memoize],h.prototype,"debugExtensionHost",null),ue([L.memoize],h.prototype,"serviceMachineIdResource",null),ue([L.memoize],h.prototype,"telemetryLogResource",null),e.NativeEnvironmentService=h;function w(p,E){return a(p["inspect-extensions"],p["inspect-brk-extensions"],5870,E,p.debugId)}e.parseExtensionHostPort=w;function D(p,E){return a(p["inspect-search"],p["inspect-brk-search"],5876,E)}e.parseSearchPort=D;function a(p,E,m,o,i){const n=Number(E||p)||(o?null:m),r=n?Boolean(!!E):!1;return{port:n,break:r,debugId:i}}function C(p,E){if(!!p){const m=(0,R.resolve)(p);return(0,R.normalize)(p)===m?m:(0,R.resolve)(E.env.VSCODE_CWD||E.cwd(),p)}}e.parsePathArg=C;function b(p,E){return C(p["user-data-dir"],E)||(0,R.resolve)((0,k.getDefaultUserDataPath)())}e.parseUserDataDir=b}),define(Q[31],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(Q[35],Z([0,1,17,85]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(O,L){A.ok(v.isString(O)),A.ok(v.isObject(L)),A.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,L)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}e.Registry=new k}),define(Q[78],Z([0,1,35,3]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class R{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,S){this.schemasById[k(g)]=S,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new R;v.Registry.add(e.Extensions.JSONContribution,O)}),define(Q[39],Z([0,1,108,3,35,17,78]),function(G,e,v,A,k,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const g=k.Registry.as(O.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,E=!0){this.registerConfigurations([p],E)}registerConfigurations(p,E=!0){const m=[];p.forEach(o=>{m.push(...this.validateAndRegisterProperties(o,E)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(p){const E=[],m=o=>{if(o.properties)for(const i in o.properties)E.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,o.properties[i]);o.allOf&&o.allOf.forEach(i=>m(i))};for(const o of p){m(o);const i=this.configurationContributors.indexOf(o);i!==-1&&this.configurationContributors.splice(i,1)}g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(p){const E=[],m=[];for(const o of p)for(const i in o)if(E.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]=Object.assign(Object.assign({},this.defaultValues[i]||{}),o[i]);const t={type:"object",default:this.defaultValues[i],description:v.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};m.push(h(i)),this.configurationProperties[i]=t,this.defaultLanguageConfigurationOverridesNode.properties[i]=t}else{this.defaultValues[i]=o[i];const t=this.configurationProperties[i];t&&(this.updatePropertyDefaultValue(i,t),this.updateSchema(i,t))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(p){const E=[];for(const m of p)for(const o in m)if(E.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const i=this.configurationProperties[o];i&&(this.updatePropertyDefaultValue(o,i),this.updateSchema(o,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const E of p)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,E=!0,m=3){m=R.isUndefinedOrNull(p.scope)?m:p.scope;let o=[],i=p.properties;if(i)for(let n in i){if(E&&a(n)){delete i[n];continue}const r=i[n];if(this.updatePropertyDefaultValue(n,r),e.OVERRIDE_PROPERTY_PATTERN.test(n)?r.scope=void 0:r.scope=R.isUndefinedOrNull(r.scope)?m:r.scope,i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),o.push(n)}let t=p.allOf;if(t)for(let n of t)o.push(...this.validateAndRegisterProperties(n,E,m));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const E=m=>{let o=m.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let i=m.allOf;i&&i.forEach(E)};E(p)}updateSchema(p,E){switch(e.allSettings.properties[p]=E,E.scope){case 1:e.applicationSettings.properties[p]=E;break;case 2:e.machineSettings.properties[p]=E;break;case 6:e.machineOverridableSettings.properties[p]=E;break;case 3:e.windowSettings.properties[p]=E;break;case 4:e.resourceSettings.properties[p]=E;break;case 5:e.resourceSettings.properties[p]=E,this.resourceLanguageSettingsSchema.properties[p]=E;break}}removeFromSchema(p,E){switch(delete e.allSettings.properties[p],E.scope){case 1:delete e.applicationSettings.properties[p];break;case 2:delete e.machineSettings.properties[p];break;case 6:delete e.machineOverridableSettings.properties[p];break;case 3:delete e.windowSettings.properties[p];break;case 4:case 5:delete e.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const E=`[${p}]`,m={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,m),e.allSettings.properties[E]=m,e.applicationSettings.properties[E]=m,e.machineSettings.properties[E]=m,e.machineOverridableSettings.properties[E]=m,e.windowSettings.properties[E]=m,e.resourceSettings.properties[E]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,E){let m=this.defaultValues[p];R.isUndefined(m)&&(m=E.default),R.isUndefined(m)&&(m=w(E.type)),E.default=m}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function h(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=h;function w(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const D=new S;k.Registry.add(e.Extensions.Configuration,D);function a(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?v.localize(5,null,b):D.getConfigurationProperties()[b]!==void 0?v.localize(6,null,b):null:v.localize(4,null)}e.validateProperty=a;function C(){const b=[],p=D.getConfigurationProperties();for(const E of Object.keys(p))b.push([E,p[E].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=C}),define(Q[24],Z([0,1,26,17,5,35,4,39]),function(G,e,v,A,k,R,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,O.createDecorator)("configurationService");function g(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof k.URI)}e.isConfigurationOverrides=g;var S;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=I;function h(n,r){const c=r?n?r.keys.filter(P=>n.keys.indexOf(P)===-1):[...r.keys]:[],s=n?r?n.keys.filter(P=>r.keys.indexOf(P)===-1):[...n.keys]:[],l=[];if(r&&n){for(const P of n.keys)if(r.keys.indexOf(P)!==-1){const _=p(n.contents,P),z=p(r.contents,P);v.equals(_,z)||l.push(P)}}const d=[],f=P=>{const _={};for(const z of P)for(const j of z.identifiers)_[i(j)]=z;return _},y=r?f(r.overrides):{},u=n?f(n.overrides):{};if(Object.keys(y).length)for(const P of c){const _=y[P];_&&d.push([(0,L.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(u).length)for(const P of s){const _=u[P];_&&d.push([(0,L.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(y).length&&Object.keys(u).length)for(const P of l){const _=u[P],z=y[P];if(_&&z){const j=h({contents:_.contents,keys:_.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});d.push([(0,L.overrideIdentifierFromKey)(P),[...j.added,...j.removed,...j.updated]])}}return{added:c,removed:s,updated:l,overrides:d}}e.compare=h;function w(n,r){const c=[];for(const s of Object.keys(n))if(L.OVERRIDE_PROPERTY_PATTERN.test(s)){const l={};for(const d in n[s])l[d]=n[s][d];c.push({identifiers:[(0,L.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(l),contents:D(l,r)})}return c}e.toOverrides=w;function D(n,r){const c=Object.create(null);for(let s in n)a(c,s,n[s],r);return c}e.toValuesTree=D;function a(n,r,c,s){const l=r.split("."),d=l.pop();let f=n;for(let y=0;y<l.length;y++){let u=l[y],P=f[u];switch(typeof P){case"undefined":P=f[u]=Object.create(null);break;case"object":break;default:s(`Ignoring ${r} as ${l.slice(0,y+1).join(".")} is ${JSON.stringify(P)}`);return}f=P}if(typeof f=="object"&&f!==null)try{f[d]=c}catch(y){s(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(f)}`)}else s(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(f)}`)}e.addToValueTree=a;function C(n,r){const c=r.split(".");b(n,c)}e.removeFromValueTree=C;function b(n,r){const c=r.shift();if(r.length===0){delete n[c];return}if(Object.keys(n).indexOf(c)!==-1){const s=n[c];typeof s=="object"&&!Array.isArray(s)&&(b(s,r),Object.keys(s).length===0&&delete n[c])}}function p(n,r,c){function s(f,y){let u=f;for(const P of y){if(typeof u!="object"||u===null)return;u=u[P]}return u}const l=r.split("."),d=s(n,l);return typeof d=="undefined"?c:d}e.getConfigurationValue=p;function E(n,r,c){Object.keys(r).forEach(s=>{s!=="__proto__"&&(s in n?A.isObject(n[s])&&A.isObject(r[s])?E(n[s],r[s],c):c&&(n[s]=r[s]):n[s]=r[s])})}e.merge=E;function m(){const n=R.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=m;function o(){const n=Object.create(null),r=R.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let c in r){let s=r[c].default;a(n,c,s,l=>console.error(`Conflict in default settings: ${l}`))}return n}e.getDefaultValues=o;function i(n){return`[${n}]`}e.keyFromOverrideIdentifier=i;function t(n,r,c){const s=n.inspect(r),l=n.inspect(c);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:s.defaultValue}e.getMigratedSettingValue=t}),define(Q[162],Z([0,1,32,37,18,17,26,5,39,24,35,2,3]),function(G,e,v,A,k,R,O,L,g,S,I,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class D{constructor(t={},n=[],r=[]){this._contents=t,this._keys=n,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,S.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const r=this.getContentsForOverrideIdentifer(n);return r?t?(0,S.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const c of k.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[c],l=n[c];l&&(typeof s=="object"&&typeof l=="object"?(s=O.deepClone(s),this.mergeContents(s,l)):s=l),r[c]=s}return new D(r,this.keys,this.overrides)}merge(...t){const n=O.deepClone(this.contents),r=O.deepClone(this.overrides),c=[...this.keys];for(const s of t){this.mergeContents(n,s.contents);for(const l of s.overrides){const[d]=r.filter(f=>k.equals(f.identifiers,l.identifiers));d?this.mergeContents(d.contents,l.contents):r.push(O.deepClone(l))}for(const l of s.keys)c.indexOf(l)===-1&&c.push(l)}return new D(n,c,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const r of Object.keys(n)){if(r in t&&R.isObject(t[r])&&R.isObject(n[r])){this.mergeContents(t[r],n[r]);continue}t[r]=O.deepClone(n[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?O.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,S.addToValueTree)(this.contents,t,n,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,S.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let r=0;r<n;r++)t.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=D;class a extends D{constructor(){const t=(0,S.getDefaultValues)(),n=(0,S.getConfigurationKeys)(),r=[];for(const c of Object.keys(t))g.OVERRIDE_PROPERTY_PATTERN.test(c)&&r.push({identifiers:[(0,g.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(t[c]),contents:(0,S.toValuesTree)(t[c],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,n,r)}}e.DefaultConfigurationModel=a;class C{constructor(t,n){this._name=t,this._scopes=n,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new D}get errors(){return this._parseErrors}parseContent(t){if(!R.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n)}}parseRaw(t){this._raw=t;const n=this.doParseRaw(t);this._configurationModel=new D(n.contents,n.keys,n.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let n={},r=null,c=[],s=[],l=[];function d(y){Array.isArray(c)?c.push(y):r&&(c[r]=y)}let f={onObjectBegin:()=>{let y={};d(y),s.push(c),c=y,r=null},onObjectProperty:y=>{r=y},onObjectEnd:()=>{c=s.pop()},onArrayBegin:()=>{let y=[];d(y),s.push(c),c=y,r=null},onArrayEnd:()=>{c=s.pop()},onLiteralValue:d,onError:(y,u,P)=>{l.push({error:y,offset:u,length:P})}};if(t)try{v.visit(t,f),n=c[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return n}doParseRaw(t){if(this._scopes){const s=I.Registry.as(g.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,s,!0,this._scopes)}const n=(0,S.toValuesTree)(t,s=>console.error(`Conflict in settings file ${this._name}: ${s}`)),r=Object.keys(t),c=(0,S.toOverrides)(t,s=>console.error(`Conflict in settings file ${this._name}: ${s}`));return{contents:n,keys:r,overrides:c}}filterByScope(t,n,r,c){const s={};for(let l in t)if(g.OVERRIDE_PROPERTY_PATTERN.test(l)&&r)s[l]=this.filterByScope(t[l],n,!1,c);else{const d=this.getScope(l,n);(d===void 0||c.indexOf(d)!==-1)&&(s[l]=t[l])}return s}getScope(t,n){const r=n[t];return r?typeof r.scope!="undefined"?r.scope:3:void 0}}e.ConfigurationModelParser=C;class b extends h.Disposable{constructor(t,n,r,c){super();this.userSettingsResource=t,this.scopes=n,this.fileService=c,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(w.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new D}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=b;class p{constructor(t,n,r=new D,c=new D,s=new A.ResourceMap,l=new D,d=new A.ResourceMap,f=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=c,this._folderConfigurations=s,this._memoryConfiguration=l,this._memoryConfigurationByResource=d,this._freeze=f,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(t)}updateValue(t,n,r={}){let c;r.resource?(c=this._memoryConfigurationByResource.get(r.resource),c||(c=new D,this._memoryConfigurationByResource.set(r.resource,c))):c=this._memoryConfiguration,n===void 0?c.removeValue(t):c.setValue(t,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,r){const c=this.getConsolidateConfigurationModel(n,r),s=this.getFolderConfigurationModelForResource(n.resource,r),l=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,d=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),f=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),y=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),u=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,_=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,z=n.overrideIdentifier?l.override(n.overrideIdentifier).getValue(t):l.getValue(t),j=c.getValue(t),W=k.distinct(k.flatten(c.overrides.map(q=>q.identifiers))).filter(q=>c.getOverrideValue(t,q)!==void 0);return{defaultValue:d,userValue:f,userLocalValue:y,userRemoteValue:u,workspaceValue:P,workspaceFolderValue:_,memoryValue:z,value:j,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:f!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:y!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:u!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:s==null?void 0:s.freeze().getValue(t),override:n.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:l.getValue(t),override:n.overrideIdentifier?l.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=n.filter(c=>g.OVERRIDE_PROPERTY_PATTERN.test(c)).map(c=>{const s=(0,g.overrideIdentifierFromKey)(c),l=this._defaultConfiguration.getKeysForOverrideIdentifier(s),d=t.getKeysForOverrideIdentifier(s),f=[...d.filter(y=>l.indexOf(y)===-1),...l.filter(y=>d.indexOf(y)===-1),...l.filter(y=>!O.equals(this._defaultConfiguration.override(s).getValue(y),t.override(s).getValue(y)))];return[s,f]});return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:c,overrides:s}=(0,S.compare)(this.localUserConfiguration,t),l=[...n,...r,...c];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:c,overrides:s}=(0,S.compare)(this.remoteUserConfiguration,t);let l=[...n,...r,...c];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:c,overrides:s}=(0,S.compare)(this.workspaceConfiguration,t);let l=[...n,...r,...c];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:s}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:c,updated:s,removed:l,overrides:d}=(0,S.compare)(r,n);let f=[...c,...s,...l];return(f.length||!r)&&this.updateFolderConfiguration(t,n),{keys:f,overrides:d}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:c,removed:s,overrides:l}=(0,S.compare)(n,void 0);return{keys:[...r,...c,...s],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let r=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const c=n.getFolder(t);c&&(r=this.getFolderConsolidatedConfiguration(c.uri)||r);const s=this._memoryConfigurationByResource.get(t);s&&(r=r.merge(s))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(t);c?(n=r.merge(c),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=r}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:r,overrides:c,keys:s}=this._folderConfigurations.get(n);return t.push([n,{contents:r,overrides:c,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(c=>n.add(c))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),c=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((l,d)=>(l.set(L.URI.revive(d[0]),this.parseConfigurationModel(d[1])),l),new A.ResourceMap);return new p(n,r,new D,c,s,new D,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new D(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=p;function E(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const t=new Set,n=new Map;for(const c of i)c.keys.forEach(s=>t.add(s)),c.overrides.forEach(([s,l])=>{const d=(0,A.getOrSet)(n,s,new Set);l.forEach(f=>d.add(f))});const r=[];return n.forEach((c,s)=>r.push([s,[...c.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=E;class m{constructor(t,n,r,c){this.change=t,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=c,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(d=>s.add(d)),t.overrides.forEach(([,d])=>d.forEach(f=>s.add(f))),this.affectedKeys=[...s.values()];const l=new D;this.affectedKeys.forEach(d=>l.setValue(d,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var r;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const c=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(r=this.previous)===null||r===void 0?void 0:r.workspace):void 0,s=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!O.equals(c,s)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let r=(0,S.toValuesTree)({[n]:!0},()=>{}),c;for(;typeof r=="object"&&(c=Object.keys(r)[0]);){if(t=t[c],!t)return!1;r=r[c]}return!0}}e.ConfigurationChangeEvent=m;class o extends m{constructor(t,n,r,c){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=r,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=o}),define(Q[163],Z([0,1,35,39,2,24,162,3,6,11]),function(G,e,v,A,k,R,O,L,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends k.Disposable{constructor(w,D){super();this.settingsResource=w,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new O.UserSettings(this.settingsResource,void 0,S.extUriBiasedIgnorePathCase,D)),this.configuration=new O.Configuration(new O.DefaultConfigurationModel,new O.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new g.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(A.Extensions.Configuration).onDidUpdateConfiguration(a=>this.onDidDefaultConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const w=await this.userConfiguration.loadConfiguration();this.configuration=new O.Configuration(new O.DefaultConfigurationModel,w)}getConfigurationData(){return this.configuration.toData()}getValue(w,D){const a=typeof w=="string"?w:void 0,C=(0,R.isConfigurationOverrides)(w)?w:(0,R.isConfigurationOverrides)(D)?D:{};return this.configuration.getValue(a,C,void 0)}updateValue(w,D,a,C){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const D=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(a,D,1)}onDidDefaultConfigurationChange(w){const D=this.configuration.toData(),a=this.configuration.compareAndUpdateDefaultConfiguration(new O.DefaultConfigurationModel,w);this.trigger(a,D,6)}trigger(w,D,a){const C=new O.ConfigurationChangeEvent(w,{data:D},this.configuration);C.source=a,C.sourceConfig=this.getTargetConfiguration(a),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(w){switch(w){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(Q[164],Z([0,1,24,14,101]),function(G,e,v,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let R=class{constructor(L,g){this.configurationService=L,this.logService=g}request(L,g){return this.logService.trace("RequestService#request",L.url),L.proxyAuthorization||(L.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,k.request)(L,g)}async resolveProxy(L){}};R=ue([Y(0,v.IConfigurationService),Y(1,A.ILogService)],R),e.RequestService=R}),define(Q[40],Z([0,1,119,4,39,35,22]),function(G,e,v,A,k,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function L(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=L;function g(h){return h.res.statusCode===204}async function S(h){if(!L(h))throw new Error("Server returned "+h.res.statusCode);return g(h)?null:(await(0,O.streamToBuffer)(h.stream)).toString()}e.asText=S;async function I(h){if(!L(h))throw new Error("Server returned "+h.res.statusCode);if(g(h))return null;const D=(await(0,O.streamToBuffer)(h.stream)).toString();try{return JSON.parse(D)}catch(a){throw a.message+=`:
`+D,a}}e.asJson=I,R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:(0,v.localize)(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,v.localize)(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,v.localize)(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,v.localize)(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,v.localize)(4,null),(0,v.localize)(5,null),(0,v.localize)(6,null)],default:"override",description:(0,v.localize)(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:(0,v.localize)(8,null)}}})}),define(Q[165],Z([0,1,40,29,9,16]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(g,S){this.requestService=g,this.fileService=S}async download(g,S,I=A.CancellationToken.None){if(g.scheme===R.Schemas.file||g.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(g,S);return}const h={type:"GET",url:g.toString()},w=await this.requestService.request(h,I);if(w.res.statusCode===200)await this.fileService.writeFile(S,w.stream);else{const D=await(0,v.asText)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${D}`)}}};O=ue([Y(0,v.IRequestService),Y(1,k.IFileService)],O),e.DownloadService=O}),define(Q[166],Z([0,1,31,9,18,62,40,29,14,11,127,2]),function(G,e,v,A,k,R,O,L,g,S,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let w=class extends h.Disposable{constructor(a,C,b,p){super();this.fileService=a,this.productService=C,this.requestService=b,this.logService=p,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:E})=>this.allConfigBasedTips.set(E.configPath,E))}getConfigBasedTips(a){return this.getValidConfigBasedTips(a)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(a){const C=[];for(const[b,p]of this.allConfigBasedTips)try{const E=await this.fileService.readFile((0,S.joinPath)(a,b)),m=new Map;(0,R.forEach)(p.recommendations,({key:i,value:t})=>{if((0,k.isNonEmptyArray)(t.remotes))for(const n of t.remotes)m.set(n,{extensionId:i,extensionName:t.name,configName:p.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else C.push({extensionId:i,extensionName:t.name,configName:p.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=(0,I.getDomainsOfRemotes)(E.value.toString(),[...m.keys()]);for(const i of o){const t=m.get(i);t&&C.push(t)}}catch(E){}return C}async fetchWorkspacesTips(){var a,C;if(!((a=this.productService.extensionsGallery)===null||a===void 0?void 0:a.recommendationsUrl))return[];try{const b=await this.requestService.request({type:"GET",url:(C=this.productService.extensionsGallery)===null||C===void 0?void 0:C.recommendationsUrl},L.CancellationToken.None);if(b.res.statusCode!==200)return[];const p=await(0,O.asJson)(b);return p?p.workspaceRecommendations||[]:[]}catch(b){return this.logService.error(b),[]}}};w=ue([Y(0,A.IFileService),Y(1,v.IProductService),Y(2,O.IRequestService),Y(3,g.ILogService)],w),e.ExtensionTipsService=w}),define(Q[44],Z([0,1,30,22]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,O,L){let g=L&&L.get("storage.serviceMachineId",0)||null;if(g)return g;try{const I=(await O.readFile(R.serviceMachineIdResource)).value.toString();g=(0,v.isUUID)(I)?I:null}catch(S){g=null}if(!g){g=(0,v.generateUuid)();try{await O.writeFile(R.serviceMachineIdResource,A.VSBuffer.fromString(g))}catch(S){}}return L&&L.store("storage.serviceMachineId",g,0,1),g}e.getServiceMachineId=k}),define(Q[19],Z([0,1,4,3,2,17,67,6]),function(G,e,v,A,k,R,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const g="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var S;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(S=e.WillSaveStateReason||(e.WillSaveStateReason={}));var I;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(I=e.StorageScope||(e.StorageScope={}));var h;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(h=e.StorageTarget||(e.StorageTarget={}));class w extends k.Disposable{constructor(b={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,p){p===g?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:p,target:this.getKeyTargets(b)[p]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,p,E){var m;return(m=this.getStorage(p))===null||m===void 0?void 0:m.get(b,E)}getBoolean(b,p,E){var m;return(m=this.getStorage(p))===null||m===void 0?void 0:m.getBoolean(b,E)}getNumber(b,p,E){var m;return(m=this.getStorage(p))===null||m===void 0?void 0:m.getNumber(b,E)}store(b,p,E,m){if((0,R.isUndefinedOrNull)(p)){this.remove(b,E);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(b,E,m),(o=this.getStorage(E))===null||o===void 0||o.set(b,p)})}remove(b,p){this.withPausedEmitters(()=>{var E;this.updateKeyTarget(b,p,void 0),(E=this.getStorage(p))===null||E===void 0||E.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,p){const E=[],m=this.getKeyTargets(b);for(const o of Object.keys(m))m[o]===p&&E.push(o);return E}updateKeyTarget(b,p,E){var m,o;const i=this.getKeyTargets(p);typeof E=="number"?i[b]!==E&&(i[b]=E,(m=this.getStorage(p))===null||m===void 0||m.set(g,JSON.stringify(i))):typeof i[b]=="number"&&(delete i[b],(o=this.getStorage(p))===null||o===void 0||o.set(g,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const p=this.get(g,b);if(p)try{return JSON.parse(p)}catch(E){}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(){var b,p,E,m;this._onWillSaveState.fire({reason:S.NONE}),await L.Promises.settled([(p=(b=this.getStorage(0))===null||b===void 0?void 0:b.whenFlushed())!==null&&p!==void 0?p:Promise.resolve(),(m=(E=this.getStorage(1))===null||E===void 0?void 0:E.whenFlushed())!==null&&m!==void 0?m:Promise.resolve()])}async logStorage(){var b,p,E,m,o,i;const t=(p=(b=this.getStorage(0))===null||b===void 0?void 0:b.items)!==null&&p!==void 0?p:new Map,n=(m=(E=this.getStorage(1))===null||E===void 0?void 0:E.items)!==null&&m!==void 0?m:new Map;return a(t,n,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(i=this.getLogDetails(1))!==null&&i!==void 0?i:"")}}e.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class D extends w{constructor(){super();this.globalStorage=new O.Storage(new O.InMemoryStorageDatabase),this.workspaceStorage=new O.Storage(new O.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=D;async function a(C,b,p,E){const m=s=>{try{return JSON.parse(s)}catch(l){return s}},o=new Map,i=new Map;C.forEach((s,l)=>{o.set(l,s),i.set(l,m(s))});const t=new Map,n=new Map;b.forEach((s,l)=>{t.set(l,s),n.set(l,m(s))}),console.group(`Storage: Global (path: ${p})`);let r=[];o.forEach((s,l)=>{r.push({key:l,value:s})}),console.table(r),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${E})`);let c=[];t.forEach((s,l)=>{c.push({key:l,value:s})}),console.table(c),console.groupEnd(),console.log(n)}e.logStorage=a}),define(Q[167],Z([0,1,3,2,28,34,19,17]),function(G,e,v,A,k,R,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let g=class extends A.Disposable{constructor(h){super();this._onDidChangeEnablement=new v.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new S(h)),this._register(this.storageManger.onDidChange(w=>this._onDidChangeEnablement.fire({extensions:w,source:"storage"})))}async enableExtension(h,w){return this._removeFromDisabledExtensions(h)?(this._onDidChangeEnablement.fire({extensions:[h],source:w}),!0):!1}async disableExtension(h,w){return this._addToDisabledExtensions(h)?(this._onDidChangeEnablement.fire({extensions:[h],source:w}),!0):!1}getDisabledExtensions(){return this._getExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(h){let w=this.getDisabledExtensions();return w.every(D=>!(0,R.areSameExtensions)(D,h))?(w.push(h),this._setDisabledExtensions(w),!0):!1}_removeFromDisabledExtensions(h){let w=this.getDisabledExtensions();for(let D=0;D<w.length;D++){const a=w[D];if((0,R.areSameExtensions)(a,h))return w.splice(D,1),this._setDisabledExtensions(w),!0}return!1}_setDisabledExtensions(h){this._setExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH,h)}_getExtensions(h){return this.storageManger.get(h,0)}_setExtensions(h,w){this.storageManger.set(h,w,0)}};g=ue([Y(0,O.IStorageService)],g),e.GlobalExtensionEnablementService=g;class S extends A.Disposable{constructor(h){super();this.storageService=h,this.storage=Object.create(null),this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._register(h.onDidChangeValue(w=>this.onDidStorageChange(w)))}get(h,w){let D;return w===0?((0,L.isUndefinedOrNull)(this.storage[h])&&(this.storage[h]=this._get(h,w)),D=this.storage[h]):D=this._get(h,w),JSON.parse(D)}set(h,w,D){let a=JSON.stringify(w.map(({id:b,uuid:p})=>({id:b,uuid:p})));this._get(h,D)!==a&&(D===0&&(w.length?this.storage[h]=a:delete this.storage[h]),this._set(h,w.length?a:void 0,D))}onDidStorageChange(h){if(h.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[h.key])&&this._get(h.key,h.scope)!==this.storage[h.key]){const D=this.get(h.key,h.scope);delete this.storage[h.key];const a=this.get(h.key,h.scope),C=D.filter(p=>!a.some(E=>(0,R.areSameExtensions)(p,E))),b=a.filter(p=>!D.some(E=>(0,R.areSameExtensions)(E,p)));(C.length||b.length)&&this._onDidChange.fire([...C,...b])}}_get(h,w){return this.storageService.get(h,w,"[]")}_set(h,w,D){w?this.storageService.store(h,w,D,1):this.storageService.remove(h,D)}}e.StorageManager=S}),define(Q[168],Z([0,1,3,2]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class k extends A.Disposable{constructor(S,I){super();this.channel=S,this.workspace=I}async getItems(){const S={workspace:this.workspace},I=await this.channel.call("getItems",S);return new Map(I)}updateItems(S){const I={workspace:this.workspace};return S.insert&&(I.insert=Array.from(S.insert.entries())),S.delete&&(I.delete=Array.from(S.delete.values())),this.channel.call("updateItems",I)}}class R extends k{constructor(S){super(S,void 0);this._onDidChangeItemsExternal=this._register(new v.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(S=>this.onDidChangeGlobalStorage(S)))}onDidChangeGlobalStorage(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this._onDidChangeItemsExternal.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}async close(){this.dispose()}}class O extends k{constructor(S,I){super(S,I);this.onDidChangeItemsExternal=v.Event.None}async close(){const S={workspace:this.workspace};return this.channel.call("close",S)}}class L extends A.Disposable{constructor(S,I){super();this.channel=S,this.workspace=I,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new R(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new O(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=L}),define(Q[169],Z([0,1,2,19,67,6,153,168,11]),function(G,e,v,A,k,R,O,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends A.AbstractStorageService{constructor(h,w,D){super();this.mainProcessService=w,this.environmentService=D,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new v.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(h)}createGlobalStorage(){const h=new L.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),w=new k.Storage(h.globalStorage);return this._register(w.onDidChangeStorage(D=>this.emitDidChangeValue(0,D))),w}createWorkspaceStorage(h){const w=new L.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),h);if(w.workspaceStorage){const D=new k.Storage(w.workspaceStorage);return this.workspaceStorageDisposable.value=D.onDidChangeStorage(a=>this.emitDidChangeValue(1,a)),this.workspaceStorageId=h==null?void 0:h.id,D}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var h,w;(0,O.mark)("code/willInitStorage");try{await R.Promises.settled([this.globalStorage.init(),(w=(h=this.workspaceStorage)===null||h===void 0?void 0:h.init())!==null&&w!==void 0?w:Promise.resolve()])}finally{(0,O.mark)("code/didInitStorage")}}getStorage(h){return h===0?this.globalStorage:this.workspaceStorage}getLogDetails(h){return h===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,g.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var h,w;this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),(w=(h=this.workspaceStorage)===null||h===void 0?void 0:h.close())!==null&&w!==void 0?w:Promise.resolve()])}async migrate(h){var w;const D=this.workspaceStorage,a=(w=D==null?void 0:D.items)!==null&&w!==void 0?w:new Map;D&&(await D.close(),D.dispose()),this.workspaceStorage=this.createWorkspaceStorage(h),await this.workspaceStorage.init();for(const[C,b]of a)this.workspaceStorage.set(C,b)}}e.NativeStorageService=S}),define(Q[170],Z([0,1,7,53,30,5]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function O(g,S,I,h,w,D,a,C,b){const p=Object.create(null);p["common.machineId"]=D,p.sessionID=(0,k.generateUuid)()+Date.now(),p.commitHash=h,p.version=w,p["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,v.PlatformToString)(v.platform),p["common.nodePlatform"]=A.platform,p["common.nodeArch"]=I,p["common.product"]=b||"desktop";const E=L(a||[]);E&&(p["common.msftInternal"]=E);let m=0;const o=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),v.isLinuxSnap&&(p["common.snap"]="true");try{const i=await g.readFile(R.URI.file(C));p["common.source"]=i.value.toString().slice(0,30)}catch(i){}return p}e.resolveCommonProperties=O;function L(g){const S=A.env.USERDNSDOMAIN;if(!S)return!1;const I=S.toLowerCase();return g.some(h=>I===h)}}),define(Q[25],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Q[171],Z([0,1,38,93,69,27,8,32,95,36,7,5,25,52,16,9,23]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function p(t,n){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],c=new Map,s=new Map,l=2e4;function d(u,P,_,z){const j=P.substring(u.length+1);return new Promise(async W=>{var q,x,B;let M;try{M=await(0,b.readdir)(P,{withFileTypes:!0})}catch(U){W();return}if(z.count>=l){z.count+=M.length,z.maxReached=!0,W();return}let F=M.length;if(F===0){W();return}let T=M;z.count+M.length>l&&(z.maxReached=!0,F=l-z.count,T=M.slice(0,F)),z.count+=M.length;for(const U of T)if(U.isDirectory()){if(_.includes(U.name)||await d(u,(0,O.join)(P,U.name),_,z),--F==0){W();return}}else{const N=U.name.lastIndexOf(".");if(N>=0){const $=U.name.substring(N+1);$&&c.set($,((q=c.get($))!==null&&q!==void 0?q:0)+1)}for(const $ of r)((x=$.relativePathPattern)===null||x===void 0?void 0:x.test(j))!==!1&&$.filePattern.test(U.name)&&s.set($.tag,((B=s.get($.tag))!==null&&B!==void 0?B:0)+1);if(--F==0){W();return}}})}const f={count:0,maxReached:!1};await d(t,t,n,f);const y=await o(t);return{configFiles:E(s),fileTypes:E(c),fileCount:f.count,maxFilesReached:f.maxReached,launchConfigFiles:y}}e.collectWorkspaceStats=p;function E(t){return[...D.Iterable.map(t.entries(),([n,r])=>({name:n,count:r}))].sort((n,r)=>r.count-n.count)}function m(){const t={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/C.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/C.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(A.virtualMachineHint.value()*100)}%`},n=v.cpus();return n&&n.length>0&&(t.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),t}e.getMachineInfo=m;function o(t){let n=new Map,r=(0,O.join)(t,".vscode","launch.json");return new Promise((c,s)=>{(0,R.exists)(r,l=>{if(l)(0,R.readFile)(r,(d,f)=>{if(d)return c([]);const y=[],u=(0,L.parse)(f.toString(),y);if(y.length)return console.log(`Unable to parse ${r}`),c([]);if((0,L.getNodeType)(u)==="object"&&u.configurations)for(const P of u.configurations){const _=P.type;_&&(n.has(_)?n.set(_,n.get(_)+1):n.set(_,1))}return c(E(n))});else return c([])})})}e.collectLaunchConfigs=o;let i=class{constructor(n){this.telemetryService=n}formatMachineInfo(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}formatEnvironment(n){const r=[];r.push(`Version:          ${S.default.nameShort} ${S.default.version} (${S.default.commit||"Commit unknown"}, ${S.default.date||"Date unknown"})`),r.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const c=v.cpus();return c&&c.length>0&&r.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),r.push(`Memory (System):  ${(v.totalmem()/C.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/C.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||r.push(`Load (avg):       ${v.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(A.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,g.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async c=>{let[s,l]=c,d=this.formatProcessList(n,s);return r.forEach(f=>{if((0,k.isRemoteDiagnosticError)(f))d+=`
${f.errorMessage}`,l+=`
${f.errorMessage}`;else if(d+=`

Remote: ${f.hostName}`,f.processes&&(d+=`
${this.formatProcessList(n,f.processes)}`),f.workspaceMetadata){l+=`
|  Remote: ${f.hostName}`;for(const y of Object.keys(f.workspaceMetadata)){const u=f.workspaceMetadata[y];let P=`${u.fileCount} files`;u.maxFilesReached&&(P=`more than ${P}`),l+=`|    Folder (${y}): ${P}`,l+=this.formatWorkspaceStats(u)}}}),{processInfo:d,workspaceInfo:l}})}async getSystemInfo(n,r){const{memory:c,vmHint:s,os:l,cpus:d}=m(),f={os:l,memory:c,cpus:d,vmHint:s,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return I.isWindows||(f.load=`${v.loadavg().map(y=>Math.round(y)).join(", ")}`),I.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(n,r){const c=[];return(0,g.listProcesses)(n.mainPID).then(async s=>(c.push(""),c.push(this.formatEnvironment(n)),c.push(""),c.push(this.formatProcessList(n,s)),n.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.formatWorkspaceMetadata(n))),r.forEach(l=>{if((0,k.isRemoteDiagnosticError)(l))c.push(`
${l.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${l.hostName}`),c.push(this.formatMachineInfo(l.machineInfo)),l.processes&&c.push(this.formatProcessList(n,l.processes)),l.workspaceMetadata)for(const d of Object.keys(l.workspaceMetadata)){const f=l.workspaceMetadata[d];let y=`${f.fileCount} files`;f.maxFilesReached&&(y=`more than ${y}`),c.push(`Folder (${d}): ${y}`),c.push(this.formatWorkspaceStats(f))}}),c.push(""),c.push(""),c.join(`
`)))}formatWorkspaceStats(n){const r=[],c=60;let s=0;const l=(u,P)=>{const _=` ${u}(${P})`;s+_.length>c?(r.push(d),d="|                 ",s=d.length):s+=_.length,d+=_};let d="|      File types:";const f=10;let y=n.fileTypes.length>f?f:n.fileTypes.length;for(let u=0;u<y;u++){const P=n.fileTypes[u];l(P.name,P.count)}if(r.push(d),n.configFiles.length>=0&&(d="|      Conf files:",s=0,n.configFiles.forEach(u=>{l(u.name,u.count)}),r.push(d)),n.launchConfigFiles.length>0){let u="|      Launch Configs:";n.launchConfigFiles.forEach(P=>{u+=P.count>1?` ${P.name}(${P.count})`:` ${P.name}`}),r.push(u)}return r.join(`
`)}expandGPUFeatures(n){const r=Math.max(...Object.keys(n).map(c=>c.length));return Object.keys(n).map(c=>`${c}:  ${" ".repeat(r-c.length)}  ${n[c]}`).join(`
                  `)}formatWorkspaceMetadata(n){const r=[],c=[];return n.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const d=h.URI.revive(l);if(d.scheme===a.Schemas.file){const f=d.fsPath;c.push(p(f,["node_modules",".git"]).then(y=>{let u=`${y.fileCount} files`;y.maxFilesReached&&(u=`more than ${u}`),r.push(`|    Folder (${(0,O.basename)(f)}): ${u}`),r.push(this.formatWorkspaceStats(y))}).catch(y=>{r.push(`|      Error: Unable to collect workspace stats for folder ${f} (${y.toString()})`)}))}else r.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(n,r){const c=new Map;n.windows.forEach(l=>c.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(n.mainPID,c,s,r,0),s.join(`
`)}formatProcessItem(n,r,c,s,l){const d=l===0;let f;d?f=s.pid===n?`${S.default.applicationName} main`:"remote agent":(f=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(f=`${f} (${r.get(s.pid)})`));const y=process.platform==="win32"?s.mem:v.totalmem()*(s.mem/100);c.push(`${s.load.toFixed(0).padStart(5," ")}	${(y/C.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(s.children)&&s.children.forEach(u=>this.formatProcessItem(n,r,c,u,l+1))}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const c=h.URI.revive(r);if(c.scheme===a.Schemas.file){const s=c.fsPath;try{const l=await p(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),l.fileTypes.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:d.name,count:d.count})}),l.launchConfigFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:d.name,count:d.count})}),l.configFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:d.name,count:d.count})})}catch(l){}}}}};i=ue([Y(0,w.ITelemetryService)],i),e.DiagnosticsService=i}),define(Q[172],Z([0,1,15,28,34,26,25,40,68,10,29,14,9,5,31,19,44,4,11]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var m;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished"})(m||(m={}));function o(...T){return String(T.reduce((U,N)=>U|N,0))}var i;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:m.None,criteria:[],assetTypes:[]};class s{constructor(U=c){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(U,N=this.state.pageSize){return new s(Object.assign(Object.assign({},this.state),{pageNumber:U,pageSize:N}))}withFilter(U,...N){const $=[...this.state.criteria,...N.length?N.map(H=>({filterType:U,value:H})):[{filterType:U}]];return new s(Object.assign(Object.assign({},this.state),{criteria:$}))}withSortBy(U){return new s(Object.assign(Object.assign({},this.state),{sortBy:U}))}withSortOrder(U){return new s(Object.assign(Object.assign({},this.state),{sortOrder:U}))}withFlags(...U){return new s(Object.assign(Object.assign({},this.state),{flags:U.reduce((N,$)=>N|$,0)}))}withAssetTypes(...U){return new s(Object.assign(Object.assign({},this.state),{assetTypes:U}))}get raw(){const{criteria:U,pageNumber:N,pageSize:$,sortBy:H,sortOrder:K,flags:te,assetTypes:X}=this.state;return{filters:[{criteria:U,pageNumber:N,pageSize:$,sortBy:H,sortOrder:K}],assetTypes:X,flags:te}}get searchText(){const U=this.state.criteria.filter(N=>N.filterType===i.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(T,U){const N=(T||[]).filter($=>$.statisticName===U)[0];return N?N.value:0}function d(T){const U="Microsoft.VisualStudio.Code.Translation.";return T.files.filter($=>$.assetType.indexOf(U)===0).reduce(($,H)=>{const K=P(T,H.assetType);return K&&$.push([H.assetType.substring(U.length),K]),$},[])}function f(T){if(T.properties){const U=T.properties.filter(H=>H.key===t.Repository),N=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),$=U.filter(H=>N.test(H.value))[0];return $?{uri:$.value,fallbackUri:$.value}:null}return P(T,t.Repository)}function y(T){return{uri:`${T.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${T.fallbackAssetUri}/${t.VSIX}`}}function u(T){const U=P(T,t.Icon);if(U)return U;const N=A.DefaultIconPath;return{uri:N,fallbackUri:N}}function P(T,U){return T.files.filter($=>$.assetType===U)[0]?{uri:`${T.assetUri}/${U}`,fallbackUri:`${T.fallbackAssetUri}/${U}`}:null}function _(T,U){const N=T.properties?T.properties.filter(H=>H.key===U):[],$=N.length>0&&N[0].value;return $?$.split(",").map(H=>(0,k.adoptToGalleryExtensionId)(H)):[]}function z(T){const U=T.properties?T.properties.filter(N=>N.key===n.Engine):[];return U.length>0&&U[0].value||""}function j(T){const U=T.properties?T.properties.filter($=>$.key===n.LocalizedLanguages):[],N=U.length>0&&U[0].value||"";return N?N.split(","):[]}function W(T){return T.indexOf("preview")!==-1}function q(T){const U=T.properties?T.properties.find(N=>N.key===n.WebExtension):void 0;return!!U&&U.value==="true"}function x(T){return T.files.some(U=>U.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,E.joinPath)(D.URI.parse(T.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function B(T,U,N,$,H){const K={manifest:P(U,t.Manifest),readme:P(U,t.Details),changelog:P(U,t.Changelog),license:P(U,t.License),repository:f(U),download:y(U),icon:u(U),coreTranslations:d(U)};return{identifier:{id:(0,k.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:U.version,date:U.lastUpdated,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,description:T.shortDescription||"",installCount:l(T.statistics,"install"),rating:l(T.statistics,"averagerating"),ratingCount:l(T.statistics,"ratingcount"),assetUri:D.URI.parse(U.assetUri),webResource:x(U),assetTypes:U.files.map(({assetType:te})=>te),assets:K,properties:{dependencies:_(U,n.Dependency),extensionPack:_(U,n.ExtensionPack),engine:z(U),localizedLanguages:j(U),webExtension:q(U)},telemetryData:{index:($.pageNumber-1)*$.pageSize+N,searchText:$.searchText,querySource:H},preview:W(T.flags)}}let M=class{constructor(U,N,$,H,K,te,X){this.requestService=U,this.logService=N,this.environmentService=$,this.telemetryService=H,this.fileService=K,this.productService=te;const ie=te.extensionsGallery;this.extensionsGalleryUrl=ie&&ie.serviceUrl,this.extensionsControlUrl=ie&&ie.controlUrl,this.commonHeadersPromise=F(te.version,this.environmentService,this.fileService,X)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,N){const $=[];let{total:H,firstPage:K,getPage:te}=await this.query({names:U,pageSize:U.length},N);$.push(...K);for(let X=1;$.length<H&&(K=await te(X,N),K.length);X++)$.push(...K);return $}async getCompatibleExtension(U,N){const $=await this.getCompatibleExtensionByEngine(U,N);return($==null?void 0:$.properties.webExtension)?$.webResource?$:null:$}async getCompatibleExtensionByEngine(U,N){const $=(0,A.isIExtensionIdentifier)(U)?null:U;if($&&$.properties.engine&&(0,g.isEngineValid)($.properties.engine,this.productService.version))return $;const{id:H,uuid:K}=$?$.identifier:U;let te=new s().withFlags(m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");K?te=te.withFilter(i.ExtensionId,K):te=te.withFilter(i.ExtensionName,H);const{galleryExtensions:X}=await this.queryGallery(te,I.CancellationToken.None),[ie]=X;if(!ie||!ie.versions.length)return null;if(N){const ce=ie.versions.filter(he=>he.version===N)[0];if(ce){const he=B(ie,ce,0,te);if(he.properties.engine&&(0,g.isEngineValid)(he.properties.engine,this.productService.version))return he}return null}const se=await this.getLastValidExtensionVersion(ie,ie.versions);return se?B(ie,se,0,te):null}async query(U,N){const $=I.CancellationToken.isCancellationToken(U)?{}:U,H=I.CancellationToken.isCancellationToken(U)?U:N;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let K=$.text||"";const te=(0,R.getOrDefault)($,me=>me.pageSize,50);let X=new s().withFlags(m.IncludeLatestVersionOnly,m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,te).withFilter(i.Target,"Microsoft.VisualStudio.Code");K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,we,Ie)=>(X=X.withFilter(i.Category,Ie||we),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,we,Ie)=>(X=X.withFilter(i.Tag,Ie||we),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(i.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),X=X.withFilter(i.SearchText,K)),X=X.withSortBy(0)):$.ids?X=X.withFilter(i.ExtensionId,...$.ids):$.names?X=X.withFilter(i.ExtensionName,...$.names):X=X.withSortBy(4),typeof $.sortBy=="number"&&(X=X.withSortBy($.sortBy)),typeof $.sortOrder=="number"&&(X=X.withSortOrder($.sortOrder));const{galleryExtensions:ie,total:se}=await this.queryGallery(X,H),ce=ie.map((me,we)=>B(me,me.versions[0],we,X,$.source)),he=async(me,we)=>{if(we.isCancellationRequested)throw(0,v.canceled)();const Ie=X.withPage(me+1),{galleryExtensions:Te}=await this.queryGallery(Ie,we);return Te.map((ke,Fe)=>B(ke,ke.versions[0],Fe,Ie,$.source))};return{firstPage:ce,total:se,pageSize:X.pageSize,getPage:he}}async queryGallery(U,N){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,m.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,o(m.Unpublished));const $=await this.commonHeadersPromise,H=JSON.stringify(U.raw),K=Object.assign(Object.assign({},$),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)}),te=new Date().getTime();let X,ie,se=0;try{if(X=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:K},N),X.res.statusCode&&X.res.statusCode>=400&&X.res.statusCode<500)return{galleryExtensions:[],total:se};const ce=await(0,L.asJson)(X);if(ce){const he=ce.results[0],me=he.extensions,we=he.resultMetadata&&he.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return se=we&&we.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:se}}return{galleryExtensions:[],total:se}}catch(ce){throw ie=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},U.telemetryData),{requestBodySize:String(H.length),duration:new Date().getTime()-te,success:!!X&&(0,L.isSuccess)(X),responseBodySize:X==null?void 0:X.res.headers["Content-Length"],statusCode:X?String(X.res.statusCode):void 0,errorCode:ie?(0,v.isPromiseCanceledError)(ie)?"canceled":(0,v.getErrorMessage)(ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(se)}))}}async reportStatistic(U,N,$,H){if(!!this.isEnabled()){const K=await this.commonHeadersPromise,te=Object.assign(Object.assign({},K),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${U}/extensions/${N}/${$}/stats?statType=${H}`),headers:te},I.CancellationToken.None)}catch(X){}}}async download(U,N,$){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const H=(0,k.getGalleryExtensionTelemetryData)(U),K=new Date().getTime(),te=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},H),{duration:ce})),X=$===1?"install":$===2?"update":"",ie=X?{uri:`${U.assets.download.uri}&${X}=true`,fallbackUri:`${U.assets.download.fallbackUri}?${X}=true`}:U.assets.download,se=await this.getAsset(ie);await this.fileService.writeFile(N,se.stream),te(new Date().getTime()-K)}async getReadme(U,N){if(U.assets.readme){const $=await this.getAsset(U.assets.readme,{},N);return await(0,L.asText)($)||""}return""}async getManifest(U,N){if(U.assets.manifest){const $=await this.getAsset(U.assets.manifest,{},N),H=await(0,L.asText)($);return H?JSON.parse(H):null}return null}async getCoreTranslation(U,N){const $=U.assets.coreTranslations.filter(H=>H[0]===N.toUpperCase())[0];if($){const H=await this.getAsset($[1]),K=await(0,L.asText)(H);return K?JSON.parse(K):null}return null}async getChangelog(U,N){if(U.assets.changelog){const $=await this.getAsset(U.assets.changelog,{},N);return await(0,L.asText)($)||""}return""}async getAllVersions(U,N){let $=new s().withFlags(m.IncludeVersions,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");U.identifier.uuid?$=$.withFilter(i.ExtensionId,U.identifier.uuid):$=$.withFilter(i.ExtensionName,U.identifier.id);const H=[],{galleryExtensions:K}=await this.queryGallery($,I.CancellationToken.None);return K.length&&(N?await Promise.all(K[0].versions.map(async te=>{let X;try{X=await this.getEngine(te)}catch(ie){}X&&(0,g.isEngineValid)(X,this.productService.version)&&H.push({version:te.version,date:te.lastUpdated})})):H.push(...K[0].versions.map(te=>({version:te.version,date:te.lastUpdated})))),H}async getAsset(U,N={},$=I.CancellationToken.None){const H=await this.commonHeadersPromise,K={type:"GET"},te=Object.assign(Object.assign({},H),N.headers||{});N=Object.assign(Object.assign(Object.assign({},N),K),{headers:te});const X=U.uri,ie=U.fallbackUri,se=Object.assign(Object.assign({},N),{url:X});try{const ce=await this.requestService.request(se,$);if(ce.res.statusCode===200)return ce;const he=await(0,L.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${he}`)}catch(ce){if((0,v.isPromiseCanceledError)(ce))throw ce;const he=(0,v.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:X,message:he});const me=Object.assign(Object.assign({},N),{url:ie});return this.requestService.request(me,$)}}async getLastValidExtensionVersion(U,N){const $=this.getLastValidExtensionVersionFromProperties(U,N);return $||this.getLastValidExtensionVersionRecursively(U,N)}getLastValidExtensionVersionFromProperties(U,N){for(const $ of N){const H=z($);if(!H)return null;if((0,g.isEngineValid)(H,this.productService.version))return $}return null}async getEngine(U){const N=z(U);if(N)return N;const $=P(U,t.Manifest);if(!$)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},K=await this.getAsset($,{headers:H}),te=await(0,L.asJson)(K);if(te)return te.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(U,N){if(!N.length)return null;const $=N[0],H=await this.getEngine($);return(0,g.isEngineValid)(H,this.productService.version)?($.properties=$.properties||[],$.properties.push({key:n.Engine,value:H}),$):this.getLastValidExtensionVersionRecursively(U,N.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const N=await(0,L.asJson)(U),$=new Map;if(N)for(const H of N.malicious){const K=$.get(H)||{id:{id:H},malicious:!0,slow:!1};K.malicious=!0,$.set(H,K)}return[...$.values()]}};M=ue([Y(0,L.IRequestService),Y(1,h.ILogService),Y(2,S.IEnvironmentService),Y(3,O.ITelemetryService),Y(4,w.IFileService),Y(5,a.IProductService),Y(6,(0,p.optional)(C.IStorageService))],M),e.ExtensionGalleryService=M;async function F(T,U,N,$){const H={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T}`},K=await(0,b.getServiceMachineId)(U,N,$);return H["X-Market-User-Id"]=K,H}e.resolveMarketplaceHeaders=F}),define(Q[173],Z([0,1,5,8,31,10,102,9,7,18,28,62,40,14,166,6,25,71,110,19,3,57]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b,p,E,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",n="extensionTips/lastPromptedMediumImpExeTime";let r=class extends a.ExtensionTipsService{constructor(s,l,d,f,y,u,P,_,z,j){super(P,_,z,j);this.environmentService=s,this.telemetryService=l,this.extensionManagementService=d,this.storageService=f,this.nativeHostService=y,this.extensionRecommendationNotificationService=u,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&(0,h.forEach)(_.exeBasedExtensionTips,({key:W,value:q})=>{const x=[],B=[],M=[];(0,h.forEach)(q.recommendations,({key:F,value:T})=>{T.important?q.important?x.push({extensionId:F,extensionName:T.name,isExtensionPack:!!T.isExtensionPack}):B.push({extensionId:F,extensionName:T.name,isExtensionPack:!!T.isExtensionPack}):M.push({extensionId:F,extensionName:T.name,isExtensionPack:!!T.isExtensionPack})}),x.length&&this.highImportanceExecutableTips.set(W,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:x}),B.length&&this.mediumImportanceExecutableTips.set(W,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:B}),M.length&&this.allOtherExecutableTips.set(W,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:M})}),(0,C.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),d=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,d),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,d)}groupImportantTipsByExe(s,l){const d=new Map;s.forEach(_=>d.set(_.extensionId.toLowerCase(),_));const{installed:f,uninstalled:y}=this.groupByInstalled([...d.keys()],l);for(const _ of f){const z=d.get(_);z&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:(0,A.basename)(z.windowsPath)})}for(const _ of y){const z=d.get(_);z&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:(0,A.basename)(z.windowsPath)})}const u=this.getPromptedExecutableTips(),P=new Map;for(const _ of y){const z=d.get(_);if(z&&(!u[z.exeName]||!u[z.exeName].includes(z.extensionId))){let j=P.get(z.exeName);j||(j=[],P.set(z.exeName,j)),j.push(z)}}return P}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size!==0){const[s,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(d=>{switch(d){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":const f=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const y=this._register((0,C.disposableTimeout)(()=>{y.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size!==0){const s=this.getLastPromptedMediumExeTime(),l=Date.now()-s,d=7*24*60*60*1e3;if(l<d){const u=this._register((0,C.disposableTimeout)(()=>{u.dispose(),this.promptMediumImportanceExeBasedTip()},d-l));return}const[f,y]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(y).then(u=>{switch(u){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(y[0].exeName,y);const P=this._register((0,C.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},d));break;case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const _=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const z=this._register((0,C.disposableTimeout)(()=>{z.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}}promptExeRecommendations(s){const l=s.map(({extensionId:f})=>f.toLowerCase()),d=(0,E.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,d,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(n,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(n,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(s,l){const d=this.getPromptedExecutableTips();d[s]=l.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(t,JSON.stringify(d),0,0)}groupByInstalled(s,l){const d=[],f=[],y=l.reduce((u,P)=>(u.add(P.identifier.id.toLowerCase()),u),new Set);return s.forEach(u=>{y.has(u.toLowerCase())?d.push(u):f.push(u)}),{installed:d,uninstalled:f}}async getValidExecutableBasedExtensionTips(s){const l=[],d=new Map;for(const f of s.keys()){const y=s.get(f);if(!(!y||!(0,S.isNonEmptyArray)(y.recommendations))){const u=[];g.isWindows?y.windowsPath&&u.push(y.windowsPath.replace("%USERPROFILE%",O.process.env.USERPROFILE).replace("%ProgramFiles(x86)%",O.process.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",O.process.env.ProgramFiles).replace("%APPDATA%",O.process.env.APPDATA).replace("%WINDIR%",O.process.env.WINDIR)):(u.push((0,A.join)("/usr/local/bin",f)),u.push((0,A.join)("/usr/bin",f)),u.push((0,A.join)(this.environmentService.userHome.fsPath,f)));for(const P of u){let _=d.get(P);if(_===void 0&&(_=await this.fileService.exists(v.URI.file(P)),d.set(P,_)),_)for(const{extensionId:z,extensionName:j,isExtensionPack:W}of y.recommendations)l.push({extensionId:z,extensionName:j,isExtensionPack:W,exeName:f,exeFriendlyName:y.exeFriendlyName,windowsPath:y.windowsPath})}}}return l}};r=ue([Y(0,R.INativeEnvironmentService),Y(1,b.ITelemetryService),Y(2,I.IExtensionManagementService),Y(3,m.IStorageService),Y(4,i.INativeHostService),Y(5,p.IExtensionRecommendationNotificationService),Y(6,L.IFileService),Y(7,k.IProductService),Y(8,w.IRequestService),Y(9,D.ILogService)],r),e.ExtensionTipsService=r}),define(Q[79],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(R){this.appender=R}listen(R,O){throw new Error(`Event not found: ${O}`)}call(R,O,{eventName:L,data:g}){return this.appender.log(L,g),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class A{constructor(R){this.channel=R}log(R,O){return this.channel.call("log",{eventName:R,data:O}).then(void 0,L=>`Failed to log telemetry: ${console.warn(L)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(Q[80],Z([0,1,36,120,21,4,24,39,2,26,35]),function(G,e,v,A,k,R,O,L,g,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let h=class{constructor(a,C){this._configurationService=C,this._experimentProperties={},this._disposables=new g.DisposableStore,this._cleanupPatterns=[],this._appender=a.appender,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(b),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(b=>{const p=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!p})}))}setExperimentProperty(a,C){this._experimentProperties[a]=C}setEnabled(a){this._enabled=a}_updateUserOptIn(){var a;const C=(a=this._configurationService)===null||a===void 0?void 0:a.getValue(w);this._userOptIn=C?C.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const a=await this._commonProperties;let C=a.sessionID,b=a["common.instanceId"],p=a["common.machineId"],E=a["common.firstSessionDate"],m=a["common.msftInternal"];return{sessionId:C,instanceId:b,machineId:p,firstSessionDate:E,msftInternal:m}}dispose(){this._disposables.dispose()}publicLog(a,C,b){return this.isOptedIn?this._commonProperties.then(p=>{C=(0,S.mixin)(C,p),C=(0,S.mixin)(C,this._experimentProperties),C=(0,S.cloneAndChange)(C,E=>{if(typeof E=="string")return this._cleanupInfo(E,b)}),this._appender.log(a,C)},p=>{console.error(p)}):Promise.resolve(void 0)}publicLog2(a,C,b){return this.publicLog(a,C,b)}publicLogError(a,C){return this.sendErrorTelemetry?this.publicLog(a,C,!0):Promise.resolve(void 0)}publicLogError2(a,C){return this.publicLogError(a,C)}_cleanupInfo(a,C){let b=a;if(C){const p=[];for(let i of this._cleanupPatterns)for(;;){const t=i.exec(a);if(!t)break;p.push([t.index,i.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(b="";;){const i=m.exec(a);if(!i)break;!E.test(i[0])&&p.every(([t,n])=>i.index<t||i.index>=n)&&(b+=a.substring(o,i.index)+"<REDACTED: user-file-path>",o=m.lastIndex)}o<a.length&&(b+=a.substr(o))}for(let p of this._cleanupPatterns)b=b.replace(p,"");return b}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=ue([Y(1,(0,R.optional)(O.IConfigurationService))],h),e.TelemetryService=h;const w="telemetry";I.Registry.as(L.Extensions.Configuration).registerConfiguration({id:w,order:110,type:"object",title:(0,A.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,A.localize)(2,null,v.default.privacyStatementUrl):(0,A.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Q[58],Z([0,1,24,26,17,6]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(a,C){return Promise.resolve(void 0)}publicLog2(a,C){return this.publicLog(a,C)}publicLogError(a,C){return Promise.resolve(void 0)}publicLogError2(a,C){return this.publicLogError(a,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class O{async publicLog(C,b,p){}async publicLogError(C,b,p){}}e.NullEndpointTelemetryService=O;function L(...a){return{log:(C,b)=>a.forEach(p=>p.log(C,b)),flush:()=>R.Promises.settled(a.map(C=>C.flush()))}}e.combinedAppender=L,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(a,C){return C.onDidChangeConfiguration(b=>{b.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,v.ConfigurationTargetToString)(b.source),configurationKeys:w(b.sourceConfig)})})}e.configurationTelemetry=g;function S(a){const C=Object.create(null),b=Object.create(null),p=Object.create(null);h(a,p);for(let E in p){E=E.length>150?E.substr(E.length-149):E;const m=p[E];typeof m=="number"?b[E]=m:typeof m=="boolean"?b[E]=m?1:0:typeof m=="string"?C[E]=m.substring(0,1023):typeof m!="undefined"&&m!==null&&(C[E]=m)}return{properties:C,measurements:b}}e.validateTelemetryData=S;function I(a){if(!a)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(p=>{a.indexOf(`${p}+`)===0&&(C=p)}),C}e.cleanRemoteAuthority=I;function h(a,C,b=0,p){if(!!a)for(let E of Object.getOwnPropertyNames(a)){const m=a[E],o=p?p+E:E;Array.isArray(m)?C[o]=(0,A.safeStringify)(m):m instanceof Date?C[o]=m.toISOString():(0,k.isObject)(m)?b<2?h(m,C,b+1,o+"."):C[o]=(0,A.safeStringify)(m):C[o]=m}}function w(a){if(!a)return[];const C=[];return D(C,"",a),C}function D(a,C,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(p=>D(a,C?`${C}.${p}`:p,b[p])):a.push(C)}}),define(Q[174],Z([0,1,2,10,14,58]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let O=class extends v.Disposable{constructor(g,S){super();this.logger=this._register(g.createLogger(S.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(g,S){this.logger.trace(`telemetry/${g}`,(0,R.validateTelemetryData)(S))}};O=ue([Y(0,k.ILoggerService),Y(1,A.IEnvironmentService)],O),e.TelemetryLogAppender=O}),define(Q[175],Z([0,1,15,26,58]),function(G,e,v,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function R(L){const g=await new Promise((I,h)=>{G(["applicationinsights"],I,h)});let S;return g.defaultClient?(S=new g.TelemetryClient(L),S.channel.setUseDiskRetryCaching(!0)):(g.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),S=g.defaultClient),L.indexOf("AIF-")===0&&(S.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),S}class O{constructor(g,S,I){this._eventPrefix=g,this._defaultData=S,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(g){if(!!this._aiClient){if(typeof this._aiClient!="string"){g(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(S=>{g(S)},S=>{(0,v.onUnexpectedError)(S),console.error(S)})}}log(g,S){!this._aiClient||(S=(0,A.mixin)(S,this._defaultData),S=(0,k.validateTelemetryData)(S),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+g,properties:S.properties,measurements:S.measurements})))}flush(){return this._aiClient?new Promise(g=>{this._withAIClient(S=>{S.flush({callback:()=>{this._aiClient=void 0,g(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=O}),define(Q[176],Z([0,1,49,79,16,80,24,25]),function(G,e,v,A,k,R,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let g=class{constructor(I,h){this.configurationService=I,this.telemetryService=h,this.customTelemetryServices=new Map}async getCustomTelemetryService(I){if(!this.customTelemetryServices.has(I.id)){const{machineId:h,sessionId:w}=await this.telemetryService.getTelemetryInfo(),D=Object.create(null);D["common.vscodemachineid"]=h,D["common.vscodesessionid"]=w;const a=[I.id,JSON.stringify(D),I.aiKey],b=new v.Client(k.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:a,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),p=new A.TelemetryAppenderClient(b);this.customTelemetryServices.set(I.id,new R.TelemetryService({appender:p,sendErrorTelemetry:I.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(I.id)}async publicLog(I,h,w){await(await this.getCustomTelemetryService(I)).publicLog(h,w)}async publicLogError(I,h,w){await(await this.getCustomTelemetryService(I)).publicLogError(h,w)}};g=ue([Y(0,O.IConfigurationService),Y(1,L.ITelemetryService)],g),e.CustomEndpointTelemetryService=g}),define(Q[81],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.WindowsShellType=void 0;var A;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(k=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,v.createDecorator)("localTerminalService"),e.IPtyService=(0,v.createDecorator)("ptyService");var R;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var O;(function(g){g[g.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",g[g.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(O=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var L;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(L=e.FlowControlConstants||(e.FlowControlConstants={}))}),define(Q[177],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,v.createDecorator)("localPtyService")}),define(Q[178],Z([0,1,2,14,81,49,16,33,3,76]),function(G,e,v,A,k,R,O,L,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var I;(function(D){D[D.MaxRestarts=5]="MaxRestarts"})(I||(I={}));let h=0,w=class extends v.Disposable{constructor(a){super();this._logService=a,this._restartCount=0,this._isDisposed=!1,this._onPtyHostExit=this._register(new g.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new g.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new g.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new g.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onProcessData=this._register(new g.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new g.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new g.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new g.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new g.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new g.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new g.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new g.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new g.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._register((0,v.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new R.Client(O.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:h,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),L.ProxyChannel.toService(a.getChannel(k.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._register(a.onDidProcessExit(E=>{this._onPtyHostExit.fire(E.code),this._isDisposed||(this._restartCount<=I.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${E.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${E.code}, giving up`))}));const b=a.getChannel(k.TerminalIpcChannels.Log);this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(b,this._logService.getLevel())}));const p=L.ProxyChannel.toService(a.getChannel(k.TerminalIpcChannels.PtyHost));return this._register(p.onProcessData(E=>this._onProcessData.fire(E))),this._register(p.onProcessExit(E=>this._onProcessExit.fire(E))),this._register(p.onProcessReady(E=>this._onProcessReady.fire(E))),this._register(p.onProcessTitleChanged(E=>this._onProcessTitleChanged.fire(E))),this._register(p.onProcessShellTypeChanged(E=>this._onProcessShellTypeChanged.fire(E))),this._register(p.onProcessOverrideDimensions(E=>this._onProcessOverrideDimensions.fire(E))),this._register(p.onProcessResolvedShellLaunchConfig(E=>this._onProcessResolvedShellLaunchConfig.fire(E))),this._register(p.onProcessReplay(E=>this._onProcessReplay.fire(E))),this._register(p.onProcessOrphanQuestion(E=>this._onProcessOrphanQuestion.fire(E))),[a,p]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,C,b,p,E,m,o,i,t,n){const r=setTimeout(()=>this._handleUnresponsiveCreateProcess(),k.HeartbeatConstants.CreateProcessTimeout),c=await this._proxy.createProcess(a,C,b,p,E,m,o,i,t,n);return clearTimeout(r),h=Math.max(h,c),c}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(a){return this._proxy.listProcesses(a)}start(a){return this._proxy.start(a)}shutdown(a,C){return this._proxy.shutdown(a,C)}input(a,C){return this._proxy.input(a,C)}resize(a,C,b){return this._proxy.resize(a,C,b)}acknowledgeDataEvent(a,C){return this._proxy.acknowledgeDataEvent(a,C)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async restartPtyHost(){this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier+k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${k.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}};w=ue([Y(0,A.ILogService)],w),e.PtyHostService=w}),define(Q[51],Z([0,1,41]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function A(O,L,g,S){const I=(0,v.setProperty)(O,L,g,S)[0];return I&&(O=O.substring(0,I.offset)+I.content+O.substring(I.offset+I.length)),O}e.edit=A;function k(O,L,g){let S=g;for(;S>=0;){if(O.charAt(S)===L.charAt(L.length-1)&&L.length===1)return S+1;if(S--,L.length===2&&S>=0&&O.charAt(S)===L.charAt(0))return S+2}return 0}e.getLineStartOffset=k;function R(O,L,g){let S=g;for(;S>=0;)if(O.charAt(S)===L.charAt(L.length-1)&&L.length===1||(S++,L.length===2&&S>=0&&O.charAt(S)===L.charAt(1)))return S;return O.length-1}e.getLineEndOffset=R}),define(Q[179],Z([0,1,26,56]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(h,w,D,a,C){var b,p;const E=[],m=[],o=[];if(!w){const z=h.filter(({identifier:j})=>C.every(W=>W.toLowerCase()!==j.id.toLowerCase()));return{added:E,removed:m,updated:o,remote:z.length>0?z:null}}h=h.map(S),w=w.map(S),D=D?D.map(S):null;const i=new Map,t=z=>{z.uuid&&i.set(z.id.toLowerCase(),z.uuid)};h.forEach(({identifier:z})=>t(z)),w.forEach(({identifier:z})=>t(z)),D&&D.forEach(({identifier:z})=>t(z));const n=z=>{const j=z.identifier.uuid||i.get(z.identifier.id.toLowerCase());return j?`uuid:${j}`:`id:${z.identifier.id.toLowerCase()}`},r=(z,j)=>(z.set(n(j),j),z),c=h.reduce(r,new Map),s=w.reduce(r,new Map),l=w.reduce((z,j)=>{const W=n(j);j=(0,v.deepClone)(j);const q=c.get(W);return q&&(q.installed&&(j.installed=!0),j.version||(j.version=q.version)),r(z,j)},new Map),d=D?D.reduce(r,new Map):null,f=a.reduce(r,new Map),y=C.reduce((z,j)=>{const W=i.get(j.toLowerCase());return z.add(W?`uuid:${W}`:`id:${j.toLowerCase()}`)},new Set),u=R(c,s,y);if(u.added.size>0||u.removed.size>0||u.updated.size>0){const z=R(d,c,y),j=R(d,s,y),W=(q,x)=>{const B=c.get(q);if(B){const M=s.get(q);return Object.assign(Object.assign({},x?M:B),{version:(M.version&&A.gt(M.version,B.version),B.version),state:O(B,M,d==null?void 0:d.get(q))})}};for(const q of j.removed.values()){const x=c.get(q);x&&m.push(x.identifier)}for(const q of j.added.values())if(z.added.has(q)){if(u.updated.has(q)){const x=W(q,!0);x&&(o.push(I(x,q)),l.set(q,x))}}else{const x=s.get(q);x.installed&&E.push(I(x,q))}for(const q of j.updated.values()){const x=W(q,!0);x&&(o.push(I(x,q)),l.set(q,x))}for(const q of z.added.values())j.added.has(q)||l.set(q,c.get(q));for(const q of z.updated.values())if(!j.removed.has(q)&&!j.updated.has(q)){const x=W(q,!1);x&&(((b=l.get(q))===null||b===void 0?void 0:b.installed)&&(x.installed=!0),l.set(q,x))}for(const q of z.removed.values())!f.has(q)&&!j.updated.has(q)&&((p=d==null?void 0:d.get(q))===null||p===void 0?void 0:p.installed)&&l.delete(q)}const P=[],_=R(s,l,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&l.forEach((z,j)=>P.push(I(z,j))),{added:E,removed:m,updated:o,remote:P.length?P:null}}e.merge=k;function R(h,w,D,{checkInstalledProperty:a,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const b=h?[...h.keys()].filter(i=>!D.has(i)):[],p=[...w.keys()].filter(i=>!D.has(i)),E=p.filter(i=>b.indexOf(i)===-1).reduce((i,t)=>(i.add(t),i),new Set),m=b.filter(i=>p.indexOf(i)===-1).reduce((i,t)=>(i.add(t),i),new Set),o=new Set;for(const i of b)if(!m.has(i)){const t=h.get(i),n=w.get(i);(!n||t.disabled!==n.disabled||!g(t.state,n.state)||C&&t.version!==n.version||a&&t.installed!==n.installed)&&o.add(i)}return{added:E,removed:m,updated:o}}function O(h,w,D){const a=h.state,C=w.state,b=D==null?void 0:D.state;if(!w.version||a&&A.gt(h.version,w.version))return a;if(C&&A.gt(w.version,h.version)||!a)return C;if(!C)return a;const p=(0,v.deepClone)(a),E=b?L(b,C):{added:Object.keys(C).reduce((o,i)=>(o.add(i),o),new Set),removed:new Set,updated:new Set},m=b?L(b,a):{added:Object.keys(a).reduce((o,i)=>(o.add(i),o),new Set),removed:new Set,updated:new Set};for(const o of[...E.added.values(),...E.updated.values()])p[o]=C[o];for(const o of E.removed.values())m.updated.has(o)||delete p[o];return p}function L(h,w){const D=Object.keys(h),a=Object.keys(w),C=a.filter(E=>D.indexOf(E)===-1).reduce((E,m)=>(E.add(m),E),new Set),b=D.filter(E=>a.indexOf(E)===-1).reduce((E,m)=>(E.add(m),E),new Set),p=new Set;for(const E of D)if(!b.has(E)){const m=h[E],o=w[E];(0,v.equals)(m,o)||p.add(E)}return{added:C,removed:b,updated:p}}function g(h={},w={}){const{added:D,removed:a,updated:C}=L(h,w);return D.size===0&&a.size===0&&C.size===0}function S(h){return Object.assign(Object.assign({},h),{disabled:!!h.disabled,installed:!!h.installed})}function I(h,w){const D={identifier:{id:h.identifier.id,uuid:w.startsWith("uuid:")?w.substring("uuid:".length):void 0}};return h.version&&(D.version=h.version),h.disabled&&(D.disabled=!0),h.installed&&(D.installed=!0),h.state&&(D.state=h.state),D}}),define(Q[82],Z([0,1,18,3,2,34,4,31,19]),function(G,e,v,A,k,R,O,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,O.createDecorator)("IExtensionsStorageSyncService");const S=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let I=class Ye extends k.Disposable{constructor(w,D){super();this.storageService=w,this.productService=D,this._onDidChangeExtensionsStorage=this._register(new A.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(a=>this.onDidChangeStorageValue(a)))}static toKey(w){return`extensionKeys/${(0,R.adoptToGalleryExtensionId)(w.id)}@${w.version}`}static fromKey(w){const D=S.exec(w);if(D&&D[1])return{id:D[1],version:D[2]}}initialize(){const w=this.storageService.keys(0,1);for(const D of w){const a=Ye.fromKey(D);a&&this.extensionsWithKeysForSync.add(a.id.toLowerCase())}}onDidChangeStorageValue(w){if(w.scope===0){if(this.extensionsWithKeysForSync.has(w.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const D=Ye.fromKey(w.key);if(D){this.extensionsWithKeysForSync.add(D.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}}setKeysForSync(w,D){this.storageService.store(Ye.toKey(w),JSON.stringify(D),0,1)}getKeysForSync(w){var D;const a=(D=this.productService.extensionSyncedKeys)===null||D===void 0?void 0:D[w.id.toLowerCase()],C=this.storageService.get(Ye.toKey(w),0),b=C?JSON.parse(C):void 0;return b&&a?(0,v.distinct)([...b,...a]):b||a}};I=ue([Y(0,g.IStorageService),Y(1,L.IProductService)],I),e.ExtensionsStorageSyncService=I}),define(Q[83],Z([0,1,18,24,4]),function(G,e,v,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let R=class{constructor(L){this.configurationService=L}hasToNeverSyncExtension(L){return this.getConfiguredIgnoredExtensions().includes(L.toLowerCase())}hasToAlwaysSyncExtension(L){return this.getConfiguredIgnoredExtensions().includes(`-${L.toLowerCase()}`)}updateIgnoredExtensions(L,g){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return S=S.filter(I=>I!==L&&I!==`-${L}`),g&&S.push(L.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,1)}updateSynchronizedExtensions(L,g){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return S=S.filter(I=>I!==L&&I!==`-${L}`),g&&S.push(`-${L.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,1)}getIgnoredExtensions(L){const g=L.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),S=this.getConfiguredIgnoredExtensions().map(w=>w.toLowerCase()),I=[],h=[];if(Array.isArray(S))for(const w of S)w.startsWith("-")?h.push(w.substring(1)):I.push(w);return(0,v.distinct)([...g,...I].filter(w=>h.indexOf(w)===-1))}getConfiguredIgnoredExtensions(){let L=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return L!==void 0||(L=this.configurationService.inspect("sync.ignoredExtensions").userValue,L!==void 0)?L:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(g=>g.toLowerCase())}};R=ue([Y(0,A.IConfigurationService)],R),e.IgnoredExtensionsManagementService=R}),define(Q[180],Z([0,1,26,32,18,138,51]),function(G,e,v,A,k,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function L(o){return(0,A.parse)(o)||[]}e.parseKeybindings=L;async function g(o,i,t,n,r){const c=L(o),s=L(i),l=t?L(t):null,d=[...c,...s,...l||[]].map(B=>B.key),f=await r.resolveUserBindings(d);let y=I(c,s,l,f);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:i,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const u=w(c),P=w(s),_=l?w(l):null,z=a(u,P,f),j=_?a(_,u,f):{added:[...u.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set},W=_?a(_,P,f):{added:[...P.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set},q=S(z,j,W);let x=o;for(const B of q.removed.values())q.conflicts.has(B)||(x=E(x,B,n));for(const B of q.added.values())if(!q.conflicts.has(B)){const M=P.get(B);if(M.some(F=>F.command!==`-${B}`&&y.conflicts.has(f[F.key]))){q.conflicts.add(B);continue}x=p(x,M,n)}for(const B of q.updated.values())if(!q.conflicts.has(B)){const M=P.get(B);if(M.some(F=>F.command!==`-${B}`&&y.conflicts.has(f[F.key]))){q.conflicts.add(B);continue}x=m(x,B,M,n)}return{mergeContent:x,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.merge=g;function S(o,i,t){const n=new Set,r=new Set,c=new Set,s=new Set;for(const l of i.removed.values())t.updated.has(l)&&s.add(l);for(const l of t.removed.values())s.has(l)||(i.updated.has(l)?s.add(l):r.add(l));for(const l of i.added.values())s.has(l)||t.added.has(l)&&o.updated.has(l)&&s.add(l);for(const l of t.added.values())s.has(l)||(i.added.has(l)?o.updated.has(l)&&s.add(l):n.add(l));for(const l of i.updated.values())s.has(l)||t.updated.has(l)&&o.updated.has(l)&&s.add(l);for(const l of t.updated.values())s.has(l)||(i.updated.has(l)?o.updated.has(l)&&s.add(l):c.add(l));return{added:n,removed:r,updated:c,conflicts:s}}function I(o,i,t,n){const r=new Set,c=h(o,n),s=h(i,n),l=t?h(t,n):null,d=D(c,s);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const f=l?D(l,c):{added:[...c.keys()].reduce((j,W)=>(j.add(W),j),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const y=l?D(l,s):{added:[...s.keys()].reduce((j,W)=>(j.add(W),j),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:u,removed:P,updated:_,conflicts:z}=S(d,f,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:P,updated:_,conflicts:z}}function h(o,i){const t=new Map;for(const n of o){const r=i[n.key];let c=t.get(r);c||(c=[],t.set(r,c)),c.push(n)}return t}function w(o){const i=new Map;for(const t of o){const n=t.command[0]==="-"?t.command.substring(1):t.command;let r=i.get(n);r||(r=[],i.set(n,r)),r.push(t)}return i}function D(o,i){const t=[...o.keys()],n=[...i.keys()],r=n.filter(l=>t.indexOf(l)===-1).reduce((l,d)=>(l.add(d),l),new Set),c=t.filter(l=>n.indexOf(l)===-1).reduce((l,d)=>(l.add(d),l),new Set),s=new Set;for(const l of t)if(!c.has(l)){const d=o.get(l).map(y=>Object.assign(Object.assign({},y),{key:l})),f=i.get(l).map(y=>Object.assign(Object.assign({},y),{key:l}));(0,k.equals)(d,f,(y,u)=>b(y,u))||s.add(l)}return{added:r,removed:c,updated:s}}function a(o,i,t){const n=[...o.keys()],r=[...i.keys()],c=r.filter(d=>n.indexOf(d)===-1).reduce((d,f)=>(d.add(f),d),new Set),s=n.filter(d=>r.indexOf(d)===-1).reduce((d,f)=>(d.add(f),d),new Set),l=new Set;for(const d of n)if(!s.has(d)){const f=o.get(d).map(u=>Object.assign(Object.assign({},u),{key:t[u.key]})),y=i.get(d).map(u=>Object.assign(Object.assign({},u),{key:t[u.key]}));C(f,y)||l.add(d)}return{added:c,removed:s,updated:l}}function C(o,i){return!(!(0,k.equals)(o.filter(({command:t})=>t[0]!=="-"),i.filter(({command:t})=>t[0]!=="-"),(t,n)=>b(t,n))||!(0,k.equals)(o.filter(({command:t})=>t[0]==="-"),i.filter(({command:t})=>t[0]==="-"),(t,n)=>b(t,n)))}function b(o,i){if(o.command!==i.command||o.key!==i.key)return!1;const t=R.ContextKeyExpr.deserialize(o.when),n=R.ContextKeyExpr.deserialize(i.when);return!(t&&!n||!t&&n||t&&n&&!t.equals(n)||!v.equals(o.args,i.args))}function p(o,i,t){for(const n of i)o=O.edit(o,[-1],n,t);return o}function E(o,i,t){const n=L(o);for(let r=n.length-1;r>=0;r--)(n[r].command===i||n[r].command===`-${i}`)&&(o=O.edit(o,[r],void 0,t));return o}function m(o,i,t,n){const r=L(o),c=r.findIndex(s=>s.command===i||s.command===`-${i}`);for(let s=r.length-1;s>=0;s--)(r[s].command===i||r[s].command===`-${i}`)&&(o=O.edit(o,[s],void 0,n));for(let s=t.length-1;s>=0;s--)o=O.edit(o,[c],t[s],n);return o}}),define(Q[181],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function v(R,O,L){const g={},S={},I=new Set;if(!O)return{local:{added:g,updated:S,removed:[...I.values()]},remote:{added:R,updated:{},removed:[]},conflicts:[]};const h=A(R,O);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{local:{added:g,updated:S,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=A(L,R),D=A(L,O),a={},C={},b=new Set,p=new Set;for(const E of w.removed.values())D.updated.has(E)?g[E]=O[E]:b.add(E);for(const E of D.removed.values())p.has(E)||(w.updated.has(E)?p.add(E):I.add(E));for(const E of w.updated.values())p.has(E)||(D.updated.has(E)?h.updated.has(E)&&p.add(E):C[E]=R[E]);for(const E of D.updated.values())p.has(E)||(w.updated.has(E)?h.updated.has(E)&&p.add(E):R[E]!==void 0&&(S[E]=O[E]));for(const E of w.added.values())p.has(E)||(D.added.has(E)?h.updated.has(E)&&p.add(E):a[E]=R[E]);for(const E of D.added.values())p.has(E)||(w.added.has(E)?h.updated.has(E)&&p.add(E):g[E]=O[E]);return{local:{added:g,removed:[...I.values()],updated:S},remote:{added:a,removed:[...b.values()],updated:C},conflicts:[...p.values()]}}e.merge=v;function A(R,O){const L=R?Object.keys(R):[],g=O?Object.keys(O):[],S=g.filter(w=>L.indexOf(w)===-1).reduce((w,D)=>(w.add(D),w),new Set),I=L.filter(w=>g.indexOf(w)===-1).reduce((w,D)=>(w.add(D),w),new Set),h=new Set;for(const w of L)if(!I.has(w)){const D=R[w],a=O[w];D!==a&&h.add(w)}return{added:S,removed:I,updated:h}}function k(R,O){const{added:L,removed:g,updated:S}=A(R,O);return L.size===0&&g.size===0&&S.size===0}e.areSame=k}),define(Q[20],Z([0,1,4,28,35,39,125,78,11,18,17]),function(G,e,v,A,k,R,O,L,g,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function h(){const s=k.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(l=>!!s[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=h;function w(){const s=k.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(s).filter(y=>!!s[y].ignoreSync),d=Object.keys(s).filter(y=>s[y].scope===2||s[y].scope===6),f=h();return(0,S.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...d,...f])}e.getDefaultIgnoredSettings=w;function D(){const s="vscode://schemas/ignoredSettings",l=k.Registry.as(R.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,O.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,O.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,O.localize)(2,null),items:[{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,O.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,O.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=k.Registry.as(L.Extensions.JSONContribution),f=()=>{const y=h(),u=w().filter(j=>j!==e.CONFIGURATION_SYNC_STORE_KEY),P=Object.keys(R.allSettings.properties).filter(j=>u.indexOf(j)===-1),_=u.filter(j=>y.indexOf(j)===-1),z={items:{type:"string",enum:[...P,..._.map(j=>`-${j}`)]}};d.registerSchema(s,z)};return l.onDidUpdateConfiguration(()=>f())}e.registerConfiguration=D;function a(s){return s&&(0,I.isObject)(s)&&(0,I.isString)(s.id)&&(0,I.isArray)(s.scopes)}e.isAuthenticationProvider=a;var C;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Extensions="extensions",s.GlobalState="globalState"})(C=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=(0,v.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,v.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,v.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(s){const l={};return l[e.HEADER_EXECUTION_ID]=s,l}e.createSyncHeaders=b;var p;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.NoRef="NoRef",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(p=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class E extends Error{constructor(l,d,f,y){super(l);this.code=d,this.resource=f,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=E;class m extends E{constructor(l,d,f,y){super(l,f,void 0,y);this.url=d,this.operationId=y}}e.UserDataSyncStoreError=m;class o extends E{constructor(l,d){super(l,d)}}e.UserDataAutoSyncError=o,function(s){function l(d){if(d instanceof s)return d;const f=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(f&&f[1]){const y=f[2]==="unknown"?void 0:f[2],u=f[3]==="unknown"?void 0:f[3];return new s(d.message,f[1],y,u)}return new s(d.message,p.Unknown)}s.toUserDataSyncError=l}(E=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var t;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var n;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(s){return`sync.enable.${s}`}e.getEnablementKey=r,e.IUserDataSyncResourceEnablementService=(0,v.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,v.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,v.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,v.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,v.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,v.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function c(s,l){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,g.isEqualOrParent)(s,(0,g.joinPath)(l.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=c}),define(Q[45],Z([0,1,2,9,22,5,20,10,11,6,3,25,32,121,24,17,21,18,44,19,29]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b,p,E,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function i(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=i;function t(l,d,f){return f.joinPath(d.userDataSyncHome,l,`lastSync${l}.json`)}let n=class extends v.Disposable{constructor(d,f,y,u,P,_,z,j,W,q){super();this.resource=d,this.fileService=f,this.environmentService=y,this.userDataSyncStoreService=P,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=z,this.telemetryService=j,this.logService=W,this.configurationService=q,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new I.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new I.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new S.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new I.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.syncHeaders={},this.syncResourceLogLabel=(0,b.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(y.userDataSyncHome,1024)?g.extUri:g.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(y.userDataSyncHome,d),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,O.PREVIEW_DIR_NAME),this.lastSyncResource=t(d,y,this.extUri),this.currentMachineIdPromise=(0,E.getServiceMachineId)(y,f,u)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const d=await this.syncPreviewPromise;this.syncPreviewPromise=null;const f=await this.performSync(d.remoteUserData,d.lastSyncUserData,!0);this.setStatus(f)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const d=await this.getLastSyncUserData();(d?(await this.doGenerateSyncResourcePreview(d,d,!0,o.CancellationToken.None)).resourcePreviews.some(({remoteChange:y})=>y!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(d){if(this._status!==d){const f=this._status;d==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),f==="hasConflicts"&&d==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=d,this._onDidChangStatus.fire(d)}}async sync(d,f={}){await this._sync(d,!0,f)}async preview(d,f={}){return this._sync(d,!1,f)}async apply(d,f={}){try{this.syncHeaders=Object.assign({},f);const y=await this.doApply(d);return this.setStatus(y),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(d,f,y){try{if(this.syncHeaders=Object.assign({},y),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let u="idle";try{const P=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(d,P);return u=await this.performSync(_,P,f),u==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):u==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(u)}}finally{this.syncHeaders={}}}async replace(d){const f=await this.resolveContent(d);if(!f)return!1;const y=this.parseSyncData(f);if(!y)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const u=await this.getLastSyncUserData(),P=await this.getLatestRemoteUserData(null,u),_=await this.generateSyncPreview({ref:P.ref,syncData:y},u,o.CancellationToken.None),z=[];for(const j of _){const W=await this.getAcceptResult(j,j.remoteResource,void 0,o.CancellationToken.None),{remoteChange:q}=await this.getAcceptResult(j,j.previewResource,j.remoteContent,o.CancellationToken.None);z.push([j,Object.assign(Object.assign({},W),{remoteChange:q!==0?q:2})])}await this.applyResult(P,u,z,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(d,f){if(f){const y=d&&d.latest?d.latest[this.resource]:void 0;if(f.ref===y||y===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async performSync(d,f,y){if(d.syncData&&d.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new O.UserDataSyncError((0,D.localize)(0,null,this.resource,this.version,d.syncData.version),O.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(d,f,y)}catch(u){if(u instanceof O.UserDataSyncError)switch(u.code){case O.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(d,f,y);case O.UserDataSyncErrorCode.Conflict:case O.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),d=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.performSync(d,f,y)}throw u}}async doSync(d,f,y){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,S.createCancelablePromise)(P=>this.doGenerateSyncResourcePreview(d,f,y,P)));const u=await this.syncPreviewPromise;return this.updateConflicts(u.resourcePreviews),u.resourcePreviews.some(({mergeState:P})=>P==="conflict")?"hasConflicts":y?await this.doApply(!1):"syncing"}catch(u){throw this.syncPreviewPromise=null,u}}async merge(d){return await this.updateSyncResourcePreview(d,async f=>{const y=await this.getMergeResult(f,o.CancellationToken.None);await this.fileService.writeFile(f.previewResource,k.VSBuffer.fromString((y==null?void 0:y.content)||""));const u=y&&!y.hasConflicts?await this.getAcceptResult(f,f.previewResource,void 0,o.CancellationToken.None):void 0;return f.acceptResult=u,f.mergeState=y.hasConflicts?"conflict":u?"accepted":"preview",f.localChange=u?u.localChange:y.localChange,f.remoteChange=u?u.remoteChange:y.remoteChange,f}),this.syncPreviewPromise}async accept(d,f){return await this.updateSyncResourcePreview(d,async y=>{const u=await this.getAcceptResult(y,d,f,o.CancellationToken.None);return y.acceptResult=u,y.mergeState="accepted",y.localChange=u.localChange,y.remoteChange=u.remoteChange,y}),this.syncPreviewPromise}async discard(d){return await this.updateSyncResourcePreview(d,async f=>{const y=await this.getMergeResult(f,o.CancellationToken.None);return await this.fileService.writeFile(f.previewResource,k.VSBuffer.fromString(y.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=y.localChange,f.remoteChange=y.remoteChange,f}),this.syncPreviewPromise}async updateSyncResourcePreview(d,f){if(!!this.syncPreviewPromise){let y=await this.syncPreviewPromise;const u=y.resourcePreviews.findIndex(({localResource:P,remoteResource:_,previewResource:z})=>this.extUri.isEqual(P,d)||this.extUri.isEqual(_,d)||this.extUri.isEqual(z,d));u!==-1&&(this.syncPreviewPromise=(0,S.createCancelablePromise)(async P=>{const _=[...y.resourcePreviews];return _[u]=await f(_[u]),Object.assign(Object.assign({},y),{resourcePreviews:_})}),y=await this.syncPreviewPromise,this.updateConflicts(y.resourcePreviews),y.resourcePreviews.some(({mergeState:P})=>P==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}}async doApply(d){if(!this.syncPreviewPromise)return"idle";const f=await this.syncPreviewPromise;return f.resourcePreviews.some(({mergeState:y})=>y==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:y})=>y!=="accepted")?"syncing":(await this.applyResult(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(y=>[y,y.acceptResult]),d),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(d){}}updateConflicts(d){const f=d.filter(({mergeState:y})=>y==="conflict");(0,p.equals)(this._conflicts,f,(y,u)=>this.extUri.isEqual(y.previewResource,u.previewResource))||(this._conflicts=f,this._onDidChangeConflicts.fire(f))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:f,ref:y})=>({created:f,uri:this.toRemoteBackupResource(y)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:f,ref:y})=>({created:f,uri:this.toLocalBackupResource(y)}))}toRemoteBackupResource(d){return R.URI.from({scheme:O.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${d}`})}toLocalBackupResource(d){return R.URI.from({scheme:O.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${d}`})}async getMachineId({uri:d}){const f=this.extUri.basename(d);if(this.extUri.isEqual(d,this.toRemoteBackupResource(f))){const{content:y}=await this.getUserData(f);if(y){const u=this.parseSyncData(y);return u==null?void 0:u.machineId}}}async resolveContent(d){const f=this.extUri.basename(d);if(this.extUri.isEqual(d,this.toRemoteBackupResource(f))){const{content:y}=await this.getUserData(f);return y}return this.extUri.isEqual(d,this.toLocalBackupResource(f))?this.userDataSyncBackupStoreService.resolveContent(this.resource,f):null}async resolvePreviewContent(d){const f=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(f)for(const y of f.resourcePreviews){if(this.extUri.isEqual(y.acceptedResource,d))return y.acceptResult?y.acceptResult.content:null;if(this.extUri.isEqual(y.remoteResource,d))return y.remoteContent;if(this.extUri.isEqual(y.localResource,d))return y.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(d){}}async doGenerateSyncResourcePreview(d,f,y,u){var P;const _=await this.currentMachineIdPromise,z=!!((P=d.syncData)===null||P===void 0?void 0:P.machineId)&&d.syncData.machineId===_,j=f===null&&z?d:f,W=await this.generateSyncPreview(d,j,u),q=[];for(const x of W){const B=x.previewResource.with({scheme:O.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(x.localChange===0&&x.remoteChange===0)q.push(Object.assign(Object.assign({},x),{acceptedResource:B,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const M=y?await this.getMergeResult(x,u):void 0;if(u.isCancellationRequested)break;await this.fileService.writeFile(x.previewResource,k.VSBuffer.fromString((M==null?void 0:M.content)||""));const F=M&&!M.hasConflicts?await this.getAcceptResult(x,x.previewResource,void 0,u):void 0;q.push(Object.assign(Object.assign({},x),{acceptResult:F,mergeState:(M==null?void 0:M.hasConflicts)?"conflict":F?"accepted":"preview",localChange:F?F.localChange:M?M.localChange:x.localChange,remoteChange:F?F.remoteChange:M?M.remoteChange:x.remoteChange}))}}return{remoteUserData:d,lastSyncUserData:f,resourcePreviews:q,isLastSyncFromCurrentMachine:z}}async getLastSyncUserData(){try{const d=await this.fileService.readFile(this.lastSyncResource),f=JSON.parse(d.value.toString()),y=f;if(y.content===null)return{ref:f.ref,syncData:null};const u=JSON.parse(y.content);if(i(u))return Object.assign(Object.assign({},f),{syncData:u,content:void 0})}catch(d){d instanceof A.FileOperationError&&d.fileOperationResult===1||this.logService.error(d)}return null}async updateLastSyncUserData(d,f={}){const y=Object.assign({ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null},f);await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(y)))}async getRemoteUserData(d){const{ref:f,content:y}=await this.getUserData(d);let u=null;return y!==null&&(u=this.parseSyncData(y)),{ref:f,syncData:u}}parseSyncData(d){try{const f=JSON.parse(d);if(i(f))return f}catch(f){this.logService.error(f)}throw new O.UserDataSyncError((0,D.localize)(1,null),O.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(d){if((0,C.isString)(d)){const f=await this.userDataSyncStoreService.resolveContent(this.resource,d);return{ref:d,content:f}}else{const f=d?{ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,f,this.syncHeaders)}}async updateRemoteUserData(d,f){const y=await this.currentMachineIdPromise,u={version:this.version,machineId:y,content:d};return f=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(u),f,this.syncHeaders),{ref:f,syncData:u}}async backupLocal(d){const f={version:this.version,content:d};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(f))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};n=ue([Y(1,A.IFileService),Y(2,L.IEnvironmentService),Y(3,m.IStorageService),Y(4,O.IUserDataSyncStoreService),Y(5,O.IUserDataSyncBackupStoreService),Y(6,O.IUserDataSyncResourceEnablementService),Y(7,h.ITelemetryService),Y(8,O.IUserDataSyncLogService),Y(9,a.IConfigurationService)],n),e.AbstractSynchroniser=n;let r=class extends n{constructor(d,f,y,u,P,_,z,j,W,q,x){super(f,y,u,P,_,z,j,W,q,x);this.file=d,this._register(this.fileService.watch(this.extUri.dirname(d))),this._register(this.fileService.onDidFilesChange(B=>this.onFileChanges(B)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(d){return null}}async updateLocalFileContent(d,f,y){try{f?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(d),y?void 0:f):await this.fileService.createFile(this.file,k.VSBuffer.fromString(d),{overwrite:y})}catch(u){throw u instanceof A.FileOperationError&&u.fileOperationResult===1||u instanceof A.FileOperationError&&u.fileOperationResult===3?new O.UserDataSyncError(u.message,O.UserDataSyncErrorCode.LocalPreconditionFailed):u}}onFileChanges(d){!d.contains(this.file)||this.triggerLocalChange()}};r=ue([Y(2,A.IFileService),Y(3,L.IEnvironmentService),Y(4,m.IStorageService),Y(5,O.IUserDataSyncStoreService),Y(6,O.IUserDataSyncBackupStoreService),Y(7,O.IUserDataSyncResourceEnablementService),Y(8,h.ITelemetryService),Y(9,O.IUserDataSyncLogService),Y(10,a.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let c=class extends r{constructor(d,f,y,u,P,_,z,j,W,q,x,B){super(d,f,y,u,P,_,z,j,W,q,B);this.userDataSyncUtilService=x,this._formattingOptions=void 0}hasErrors(d){const f=[];return(0,w.parse)(d,f,{allowEmptyContent:!0,allowTrailingComma:!0}),f.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};c=ue([Y(2,A.IFileService),Y(3,L.IEnvironmentService),Y(4,m.IStorageService),Y(5,O.IUserDataSyncStoreService),Y(6,O.IUserDataSyncBackupStoreService),Y(7,O.IUserDataSyncResourceEnablementService),Y(8,h.ITelemetryService),Y(9,O.IUserDataSyncLogService),Y(10,O.IUserDataSyncUtilService),Y(11,a.IConfigurationService)],c),e.AbstractJsonFileSynchroniser=c;let s=class{constructor(d,f,y,u){this.resource=d,this.environmentService=f,this.logService=y,this.fileService=u,this.extUri=this.fileService.hasCapability(f.userDataSyncHome,1024)?g.extUri:g.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,f,g.extUri)}async initialize({ref:d,content:f}){if(!f){this.logService.info("Remote content does not exist.",this.resource);return}const y=this.parseSyncData(f);if(!!y){if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:d,syncData:y})}catch(P){this.logService.error(P)}}}parseSyncData(d){try{const f=JSON.parse(d);if(i(f))return f}catch(f){this.logService.error(f)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(d,f={}){const y=Object.assign({ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null},f);await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(y)))}};s=ue([Y(1,L.IEnvironmentService),Y(2,O.IUserDataSyncLogService),Y(3,A.IFileService)],s),e.AbstractInitializer=s}),define(Q[182],Z([0,1,20,3,10,28,34,9,24,179,45,25,5,46,41,21,19,29,83,15,82,6]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b,p,E,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(l,d){const f=JSON.parse(l.content);if(l.version===1||l.version===2){const y=(await d.getInstalled(0)).filter(u=>u.isBuiltin);for(const u of f)l.version===1&&(u.enabled===!1&&(u.disabled=!0),delete u.enabled),l.version===2&&y.every(P=>!(0,O.areSameExtensions)(P.identifier,u.identifier))&&(u.installed=!0)}return f}function n(l,d,f){const y=f.get((0,O.getExtensionId)(l,d),0)||"{}";return JSON.parse(y)}function r(l,d,f,y){y.store((0,O.getExtensionId)(l,d),JSON.stringify(f),0,1)}let c=class rt extends I.AbstractSynchroniser{constructor(d,f,y,u,P,_,z,j,W,q,x,B,M,F){super("extensions",f,d,y,u,P,B,M,W,x);this.storageService=y,this.extensionManagementService=_,this.extensionEnablementService=z,this.ignoredExtensionsManagementService=j,this.extensionGalleryService=q,this.extensionsStorageSyncService=F,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.Event.debounce(A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtension,T=>!!T.gallery),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,T=>!T.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(d,f){const y=d.syncData?await t(d.syncData,this.extensionManagementService):null,u=(f==null?void 0:f.skippedExtensions)||[],P=(f==null?void 0:f.syncData)?await t(f.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(),z=this.getLocalExtensions(_),j=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);y?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:W,removed:q,updated:x,remote:B}=(0,S.merge)(z,y,P,u,j),M={added:W,removed:q,updated:x,remote:B,content:this.getPreviewContent(z,W,x,q),localChange:W.length>0||q.length>0||x.length>0?2:0,remoteChange:B!==null?2:0};return[{skippedExtensions:u,localResource:this.localResource,localContent:this.format(z),localExtensions:z,remoteResource:this.remoteResource,remoteContent:y?this.format(y):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(d,f,y,u){const P=[...f,...y],_=new Set,z=j=>{_.add(j.id.toLowerCase()),j.uuid&&_.add(j.uuid)};P.forEach(({identifier:j})=>z(j)),u.forEach(z);for(const j of d)_.has(j.identifier.id.toLowerCase())||j.identifier.uuid&&_.has(j.identifier.uuid)||P.push(j);return this.format(P)}async getMergeResult(d,f){return Object.assign(Object.assign({},d.previewResult),{hasConflicts:!1})}async getAcceptResult(d,f,y,u){if(this.extUri.isEqual(f,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(f,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(f,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async acceptLocal(d){const f=await this.extensionManagementService.getInstalled(),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),u=(0,S.merge)(d.localExtensions,null,null,d.skippedExtensions,y),{added:P,removed:_,updated:z,remote:j}=u;return{content:d.localContent,added:P,removed:_,updated:z,remote:j,localChange:P.length>0||_.length>0||z.length>0?2:0,remoteChange:j!==null?2:0}}async acceptRemote(d){const f=await this.extensionManagementService.getInstalled(),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),u=d.remoteContent?JSON.parse(d.remoteContent):null;if(u!==null){const P=(0,S.merge)(d.localExtensions,u,d.localExtensions,[],y),{added:_,removed:z,updated:j,remote:W}=P;return{content:d.remoteContent,added:_,removed:z,updated:j,remote:W,localChange:_.length>0||z.length>0||j.length>0?2:0,remoteChange:W!==null?2:0}}else return{content:d.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(d,f,y,u){let{skippedExtensions:P,localExtensions:_}=y[0][0],{added:z,removed:j,updated:W,remote:q,localChange:x,remoteChange:B}=y[0][1];if(x===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),x!==0&&(await this.backupLocal(JSON.stringify(_)),P=await this.updateLocalExtensions(z,j,W,P)),q){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify(q);d=await this.updateRemoteUserData(M,u?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(f==null?void 0:f.ref)!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(d,{skippedExtensions:P}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"extensions.json"),comparableResource:rt.EXTENSIONS_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,rt.EXTENSIONS_DATA_URI)){const y=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(y),P=this.getLocalExtensions(y).filter(_=>!u.some(z=>(0,O.areSameExtensions)({id:z},_.identifier)));return this.format(P)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let f=await super.resolveContent(d);if(f)return f;if(f=await super.resolveContent(this.extUri.dirname(d)),f){const y=this.parseSyncData(f);if(y)switch(this.extUri.basename(d)){case"extensions.json":return this.format(this.parseExtensions(y))}}return null}format(d){d.sort((u,P)=>!u.identifier.uuid&&P.identifier.uuid?-1:u.identifier.uuid&&!P.identifier.uuid?1:(0,C.compare)(u.identifier.id,P.identifier.id));const f=JSON.stringify(d),y=(0,D.format)(f,void 0,{});return(0,a.applyEdits)(f,y)}async hasLocalData(){try{const d=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(d).some(y=>y.installed||y.disabled))return!0}catch(d){}return!1}async updateLocalExtensions(d,f,y,u){const P=[],_=[],z=await this.extensionManagementService.getInstalled();if(f.length){const W=z.filter(({identifier:q,isBuiltin:x})=>!x&&f.some(B=>(0,O.areSameExtensions)(q,B)));await i.Promises.settled(W.map(async q=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,q.identifier.id),await this.extensionManagementService.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,q.identifier.id),P.push(q.identifier)}))}(d.length||y.length)&&await i.Promises.settled([...d,...y].map(async W=>{const q=z.find(B=>(0,O.areSameExtensions)(B.identifier,W.identifier));if(q&&q.isBuiltin){W.state&&q.manifest.version===W.version&&this.updateExtensionState(W.state,q.manifest.publisher,q.manifest.name,q.manifest.version),W.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,W.identifier.id),await this.extensionEnablementService.disableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,W.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,W.identifier.id),await this.extensionEnablementService.enableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,W.identifier.id)),P.push(W.identifier);return}const x=await this.extensionGalleryService.getCompatibleExtension(W.identifier);if(W.state&&(q?q.manifest.version===W.version:!!x)){const B=q?q.manifest.publisher:x.publisher,M=q?q.manifest.name:x.name;this.updateExtensionState(W.state,B,M,q==null?void 0:q.manifest.version)}if(x)try{W.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,W.identifier.id,x.version),await this.extensionEnablementService.disableExtension(x.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,W.identifier.id,x.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,W.identifier.id,x.version),await this.extensionEnablementService.enableExtension(x.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,W.identifier.id,x.version)),q||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,W.identifier.id,x.version),await this.extensionManagementService.installFromGallery(x,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,W.identifier.id,x.version),P.push(x.identifier))}catch(B){_.push(W),this.logService.error(B),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,x.displayName||x.identifier.id)}else _.push(W)}));const j=[];for(const W of u)P.some(q=>(0,O.areSameExtensions)(q,W.identifier))||j.push(W);for(const W of _)j.some(q=>(0,O.areSameExtensions)(q.identifier,W.identifier))||j.push(W);return j}updateExtensionState(d,f,y,u){const P=n(f,y,this.storageService),_=u?this.extensionsStorageSyncService.getKeysForSync({id:(0,O.getGalleryExtensionId)(f,y),version:u}):void 0;_?_.forEach(z=>{P[z]=d[z]}):Object.keys(d).forEach(z=>P[z]=d[z]),r(f,y,P,this.storageService)}parseExtensions(d){return JSON.parse(d.content)}getLocalExtensions(d){const f=this.extensionEnablementService.getDisabledExtensions();return d.map(({identifier:y,isBuiltin:u,manifest:P})=>{const _={identifier:y,version:P.version};f.some(z=>(0,O.areSameExtensions)(z,y))&&(_.disabled=!0),u||(_.installed=!0);try{const z=this.extensionsStorageSyncService.getKeysForSync({id:y.id,version:P.version});if(z){const j=n(P.publisher,P.name,this.storageService);_.state=Object.keys(j).reduce((W,q)=>(z.includes(q)&&(W[q]=j[q]),W),{})}}catch(z){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,m.getErrorMessage)(z))}return _})}};c.EXTENSIONS_DATA_URI=w.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),c=ue([Y(0,k.IEnvironmentService),Y(1,L.IFileService),Y(2,b.IStorageService),Y(3,v.IUserDataSyncStoreService),Y(4,v.IUserDataSyncBackupStoreService),Y(5,R.IExtensionManagementService),Y(6,R.IGlobalExtensionEnablementService),Y(7,E.IIgnoredExtensionsManagementService),Y(8,v.IUserDataSyncLogService),Y(9,R.IExtensionGalleryService),Y(10,g.IConfigurationService),Y(11,v.IUserDataSyncResourceEnablementService),Y(12,h.ITelemetryService),Y(13,o.IExtensionsStorageSyncService)],c),e.ExtensionsSynchroniser=c;let s=class extends I.AbstractInitializer{constructor(d,f,y,u,P,_,z,j){super("extensions",z,j,_);this.extensionManagementService=d,this.galleryService=f,this.extensionEnablementService=y,this.storageService=u,this.ignoredExtensionsManagementService=P}async doInitialize(d){const f=d.syncData?await t(d.syncData,this.extensionManagementService):null;if(!f){this.logService.info("Skipping initializing extensions because remote extensions does not exist.");return}await this.initializeRemoteExtensions(f)}async initializeRemoteExtensions(d){const f=[],y=await this.extensionManagementService.getInstalled(),u=new Map,P=[],_={names:[],uuids:[]},z=[];for(const j of d)if(!this.ignoredExtensionsManagementService.hasToNeverSyncExtension(j.identifier.id)){const W=y.find(q=>(0,O.areSameExtensions)(q.identifier,j.identifier));W?(P.push({syncExtension:j,installedExtension:W}),j.disabled&&z.push(j.identifier)):j.installed&&(u.set(j.identifier.id.toLowerCase(),j),j.identifier.uuid?_.uuids.push(j.identifier.uuid):_.names.push(j.identifier.id),j.disabled&&z.push(j.identifier))}for(const{syncExtension:j,installedExtension:W}of P)if(j.state){const q=n(W.manifest.publisher,W.manifest.name,this.storageService);Object.keys(j.state).forEach(x=>q[x]=j.state[x]),r(W.manifest.publisher,W.manifest.name,q,this.storageService)}if(z.length)for(const j of z)this.logService.trace("Disabling extension...",j.id),await this.extensionEnablementService.disableExtension(j),this.logService.info("Disabling extension",j.id);if(_.names.length||_.uuids.length){const j=(await this.galleryService.query({ids:_.uuids,names:_.names,pageSize:_.uuids.length+_.names.length},p.CancellationToken.None)).firstPage;for(const W of j)try{const q=u.get(W.identifier.id.toLowerCase());q.state&&r(W.publisher,W.name,q.state,this.storageService),this.logService.trace("Installing extension...",W.identifier.id);const x=await this.extensionManagementService.installFromGallery(W,{isMachineScoped:!1});z.some(B=>(0,O.areSameExtensions)(B,W.identifier))||f.push(x),this.logService.info("Installed extension.",W.identifier.id)}catch(q){this.logService.error(q)}}return f}};s=ue([Y(0,R.IExtensionManagementService),Y(1,R.IExtensionGalleryService),Y(2,R.IGlobalExtensionEnablementService),Y(3,b.IStorageService),Y(4,E.IIgnoredExtensionsManagementService),Y(5,L.IFileService),Y(6,k.IEnvironmentService),Y(7,v.IUserDataSyncLogService)],s),e.ExtensionsInitializer=s}),define(Q[183],Z([0,1,26,20]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(L,g,S,I,h){if(!g)return{remote:Object.keys(L).length>0?L:null,local:{added:{},removed:[],updated:{}}};const w=R(L,g);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const D=S?R(S,g):{added:Object.keys(g).reduce((E,m)=>(E.add(m),E),new Set),removed:new Set,updated:new Set},a=S?R(S,L):{added:Object.keys(L).reduce((E,m)=>(E.add(m),E),new Set),removed:new Set,updated:new Set},C={added:{},removed:[],updated:{}},b=v.deepClone(g),p=!S;for(const E of a.added.values())E!==A.SYNC_SERVICE_URL_TYPE&&p&&D.added.has(E)||(b[E]=L[E]);for(const E of a.updated.values())b[E]=L[E];for(const E of a.removed.values())I.unregistered.includes(E)||delete b[E];for(const E of D.added.values()){const m=g[E];if(I.machine.includes(E)){h.info(`GlobalState: Skipped adding ${E} in local storage because it is declared as machine scoped.`);continue}if(!(S&&a.added.has(E))){const o=L[E];o&&o.value===m.value||E===A.SYNC_SERVICE_URL_TYPE&&p&&a.added.has(E)||(o?C.updated[E]=m:C.added[E]=m)}}for(const E of D.updated.values()){const m=g[E];if(I.machine.includes(E)){h.info(`GlobalState: Skipped updating ${E} in local storage because it is declared as machine scoped.`);continue}if(!(a.updated.has(E)||a.removed.has(E))){const o=L[E];o&&o.value===m.value||(C.updated[E]=m)}}for(const E of D.removed.values()){if(I.machine.includes(E)){h.trace(`GlobalState: Skipped removing ${E} in local storage because it is declared as machine scoped.`);continue}a.updated.has(E)||a.removed.has(E)||C.removed.push(E)}return{local:C,remote:O(b,g)?null:b}}e.merge=k;function R(L,g){const S=Object.keys(L),I=Object.keys(g),h=I.filter(a=>S.indexOf(a)===-1).reduce((a,C)=>(a.add(C),a),new Set),w=S.filter(a=>I.indexOf(a)===-1).reduce((a,C)=>(a.add(C),a),new Set),D=new Set;for(const a of S)if(!w.has(a)){const C=L[a],b=g[a];v.equals(C,b)||D.add(a)}return{added:h,removed:w,updated:D}}function O(L,g){const{added:S,removed:I,updated:h}=R(L,g);return S.size===0&&I.size===0&&h.size===0}}),define(Q[184],Z([0,1,20,22,3,10,9,51,183,32,45,25,24,5,46,41,19,7,44,30,14]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b,p,E,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const i="globalState.argv.",t=["locale"];function n(d){const f=d.storage?Object.keys(d.storage).sort():[],y={};f.forEach(_=>y[_]=d.storage[_]),d.storage=y;const u=JSON.stringify(d),P=(0,a.format)(u,void 0,{});return(0,C.applyEdits)(u,P)}const r=1;let c=class st extends I.AbstractSynchroniser{constructor(f,y,u,P,_,z,j,W,q){super("globalState",f,_,q,y,u,z,j,P,W);this.environmentService=_,this.storageService=q,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(f.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(f.onDidFilesChange,x=>x.contains(this.environmentService.argvResource)),k.Event.filter(q.onDidChangeValue,x=>x.scope===0&&x.target!==void 0?x.target===0:q.keys(0,0).includes(x.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(f,y,u){const P=f.syncData?JSON.parse(f.syncData.content):null,_=y&&y.syncData?JSON.parse(y.syncData.content):null,z=await this.getLocalGlobalState();P?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const j=this.getStorageKeys(_),{local:W,remote:q}=(0,g.merge)(z.storage,P?P.storage:null,_?_.storage:null,j,this.logService),x={content:null,local:W,remote:q,localChange:Object.keys(W.added).length>0||Object.keys(W.updated).length>0||W.removed.length>0?2:0,remoteChange:q!==null?2:0};return[{localResource:this.localResource,localContent:n(z),localUserData:z,remoteResource:this.remoteResource,remoteContent:P?n(P):null,previewResource:this.previewResource,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.acceptedResource,storageKeys:j}]}async getMergeResult(f,y){return Object.assign(Object.assign({},f.previewResult),{hasConflicts:!1})}async getAcceptResult(f,y,u,P){if(this.extUri.isEqual(y,this.localResource))return this.acceptLocal(f);if(this.extUri.isEqual(y,this.remoteResource))return this.acceptRemote(f);if(this.extUri.isEqual(y,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${y.toString()}`)}async acceptLocal(f){return{content:f.localContent,local:{added:{},removed:[],updated:{}},remote:f.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(f){if(f.remoteContent!==null){const y=JSON.parse(f.remoteContent),{local:u,remote:P}=(0,g.merge)(f.localUserData.storage,y.storage,null,f.storageKeys,this.logService);return{content:f.remoteContent,local:u,remote:P,localChange:Object.keys(u.added).length>0||Object.keys(u.updated).length>0||u.removed.length>0?2:0,remoteChange:P!==null?2:0}}else return{content:f.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(f,y,u,P){let{localUserData:_}=u[0][0],{local:z,remote:j,localChange:W,remoteChange:q}=u[0][1];if(W===0&&q===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),W!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(_)),await this.writeLocalGlobalState(z),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),q!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const x=JSON.stringify({storage:j});f=await this.updateRemoteUserData(x,P?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(y==null?void 0:y.ref)!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:f}){return[{resource:this.extUri.joinPath(f,"globalState.json"),comparableResource:st.GLOBAL_STATE_DATA_URI}]}async resolveContent(f){if(this.extUri.isEqual(f,st.GLOBAL_STATE_DATA_URI)){const u=await this.getLocalGlobalState();return n(u)}if(this.extUri.isEqual(this.remoteResource,f)||this.extUri.isEqual(this.localResource,f)||this.extUri.isEqual(this.acceptedResource,f))return this.resolvePreviewContent(f);let y=await super.resolveContent(f);if(y)return y;if(y=await super.resolveContent(this.extUri.dirname(f)),y){const u=this.parseSyncData(y);if(u)switch(this.extUri.basename(f)){case"globalState.json":return n(JSON.parse(u.content))}}return null}async hasLocalData(){var f;try{const{storage:y}=await this.getLocalGlobalState();if(Object.keys(y).length>1||((f=y[`${i}.locale`])===null||f===void 0?void 0:f.value)!=="en")return!0}catch(y){}return!1}async getLocalGlobalState(){const f={},y=await this.getLocalArgvContent(),u=(0,S.parse)(y);for(const P of t)u[P]!==void 0&&(f[`${i}${P}`]={version:1,value:u[P]});for(const P of this.storageService.keys(0,0)){const _=this.storageService.get(P,0);_&&(f[P]={version:1,value:_})}return{storage:f}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(f){}return"{}"}async writeLocalGlobalState({added:f,removed:y,updated:u}){const P={},_={},z=(W,q)=>{for(const x of W){if(x.startsWith(i)){P[x.substring(i.length)]=q?q[x].value:void 0;continue}if(q){const B=q[x];B.value!==String(this.storageService.get(x,0))&&(_[x]=B.value)}else this.storageService.get(x,0)!==void 0&&(_[x]=void 0)}};if(z(Object.keys(f),f),z(Object.keys(u),u),z(y),Object.keys(P).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(P),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(_).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const W of Object.keys(_))this.storageService.store(W,_[W],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(_))}}async updateArgv(f){const y=await this.getLocalArgvContent();let u=y;for(const P of Object.keys(f))u=(0,L.edit)(u,[P],f[P],{});y!==u&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,A.VSBuffer.fromString(u)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(f){const y=this.storageService.keys(0,0),u=this.storageService.keys(0,1),P=[...y,...u],_=(f==null?void 0:f.storage)?Object.keys(f.storage).filter(z=>!z.startsWith(i)&&!P.includes(z)&&this.storageService.get(z,0)!==void 0):[];if(!p.isWeb){const z=[...v.ALL_SYNC_RESOURCES.map(j=>(0,v.getEnablementKey)(j)),v.SYNC_SERVICE_URL_TYPE];_.push(...z),u.push(...z)}return{user:y,machine:u,unregistered:_}}};c.GLOBAL_STATE_DATA_URI=D.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),c=ue([Y(0,O.IFileService),Y(1,v.IUserDataSyncStoreService),Y(2,v.IUserDataSyncBackupStoreService),Y(3,v.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,v.IUserDataSyncResourceEnablementService),Y(6,h.ITelemetryService),Y(7,w.IConfigurationService),Y(8,b.IStorageService)],c),e.GlobalStateSynchroniser=c;let s=class extends I.AbstractInitializer{constructor(f,y,u,P){super("globalState",u,P,y);this.storageService=f}async doInitialize(f){const y=f.syncData?JSON.parse(f.syncData.content):null;if(!y){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const u={},P={};for(const _ of Object.keys(y.storage))_.startsWith(i)?u[_.substring(i.length)]=y.storage[_].value:this.storageService.get(_,0)===void 0&&(P[_]=y.storage[_].value);if(Object.keys(u).length){let _="{}";try{_=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(z){}for(const z of Object.keys(u))_=(0,L.edit)(_,[z],u[z],{});await this.fileService.writeFile(this.environmentService.argvResource,A.VSBuffer.fromString(_))}if(Object.keys(P).length)for(const _ of Object.keys(P))this.storageService.store(_,P[_],0,0)}};s=ue([Y(0,b.IStorageService),Y(1,O.IFileService),Y(2,R.IEnvironmentService),Y(3,v.IUserDataSyncLogService)],s),e.GlobalStateInitializer=s;let l=class{constructor(f,y,u,P,_){this.userDataSyncStoreClient=f,this.storageService=y,this.environmentService=u,this.fileService=P,this.logService=_}getSyncStoreType(f){var y;const u=this.parseGlobalState(f);return(y=u==null?void 0:u.storage[v.SYNC_SERVICE_URL_TYPE])===null||y===void 0?void 0:y.value}async sync(f){const y=(0,v.createSyncHeaders)((0,m.generateUuid)());try{return await this.doSync(f,y)}catch(u){if(u instanceof v.UserDataSyncError)switch(u.code){case v.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(f,y)}throw u}}async doSync(f,y){const u=await this.userDataSyncStoreClient.read("globalState",null,y),P=this.parseGlobalState(u)||{storage:{}};P.storage[v.SYNC_SERVICE_URL_TYPE]={value:f,version:r};const _=await(0,E.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),z={version:r,machineId:_,content:n(P)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(z),u.ref,y)}parseGlobalState({content:f}){if(!f)return null;const y=JSON.parse(f);if((0,I.isSyncData)(y))return y?JSON.parse(y.content):null;throw new Error("Invalid remote data")}};l=ue([Y(1,b.IStorageService),Y(2,R.IEnvironmentService),Y(3,O.IFileService),Y(4,o.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Q[185],Z([0,1,9,20,180,32,122,10,24,7,17,18,45,25,19,22,3]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function p(o,i){const t=JSON.parse(o);if(!i)return(0,I.isUndefined)(t.all)?null:t.all;switch(S.OS){case 2:return(0,I.isUndefined)(t.mac)?null:t.mac;case 3:return(0,I.isUndefined)(t.linux)?null:t.linux;case 1:return(0,I.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=p;let E=class extends w.AbstractJsonFileSynchroniser{constructor(i,t,n,r,c,s,l,d,f,y){super(l.keybindingsResource,"keybindings",s,l,d,i,t,c,y,n,f,r);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(b.Event.filter(r.onDidChangeConfiguration,u=>u.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(i,t,n){const r=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null,c=t?this.getKeybindingsContentFromLastSyncUserData(t):null,s=await this.getLocalFileContent(),l=await this.getFormattingOptions();let d=null,f=!1,y=!1,u=!1;if(r){let _=s?s.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new A.UserDataSyncError((0,O.localize)(0,null),A.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!c||c!==_||c!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,k.merge)(_,r,c,l,this.userDataSyncUtilService);z.hasChanges&&(d=z.mergeContent,u=z.hasConflicts,f=u||z.mergeContent!==_,y=u||z.mergeContent!==r)}}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=s.value.toString(),y=!0);const P={content:d,localChange:f?s?2:1:0,remoteChange:y?2:0,hasConflicts:u};return[{fileContent:s,localResource:this.localResource,localContent:s?s.value.toString():null,localChange:P.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:P.remoteChange,previewResource:this.previewResource,previewResult:P,acceptedResource:this.acceptedResource}]}async getMergeResult(i,t){return i.previewResult}async getAcceptResult(i,t,n,r){if(this.extUri.isEqual(t,this.localResource))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:i.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(i,t,n,r){var c;const{fileContent:s}=n[0][0];let{content:l,localChange:d,remoteChange:f}=n[0][1];if(d===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l)))throw new A.UserDataSyncError((0,O.localize)(1,null),A.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(l||"[]",s,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),f!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const y=this.toSyncContent(l||"[]",(c=i.syncData)===null||c===void 0?void 0:c.content);i=await this.updateRemoteUserData(y,r?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(y){}(t==null?void 0:t.ref)!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(i,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const t=(0,R.parse)(i.value.toString());if((0,h.isNonEmptyArray)(t))return!0}}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:i}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(i,"keybindings.json"),comparableResource:t}]}async resolveContent(i){if(this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i))return this.resolvePreviewContent(i);let t=await super.resolveContent(i);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(i)),t){const n=this.parseSyncData(t);if(n)switch(this.extUri.basename(i)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(n.content)}}return null}getKeybindingsContentFromLastSyncUserData(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(i.syncData.content)}getKeybindingsContentFromSyncContent(i){try{return p(i,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(i,t){let n={};try{n=JSON.parse(t||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=i,S.OS){case 2:n.mac=i;break;case 3:n.linux=i;break;case 1:n.windows=i;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){let i=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return i!==void 0||(i=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,i!==void 0)?i:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};E=ue([Y(0,A.IUserDataSyncStoreService),Y(1,A.IUserDataSyncBackupStoreService),Y(2,A.IUserDataSyncLogService),Y(3,g.IConfigurationService),Y(4,A.IUserDataSyncResourceEnablementService),Y(5,v.IFileService),Y(6,L.IEnvironmentService),Y(7,a.IStorageService),Y(8,A.IUserDataSyncUtilService),Y(9,D.ITelemetryService)],E),e.KeybindingsSynchroniser=E;let m=class extends w.AbstractInitializer{constructor(i,t,n){super("keybindings",t,n,i)}async doInitialize(i){const t=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,C.VSBuffer.fromString(t)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,R.parse)(i.value.toString());return!(0,h.isNonEmptyArray)(t)}catch(i){return i.fileOperationResult===1}}getKeybindingsContentFromSyncContent(i){try{return p(i,!0)}catch(t){return this.logService.error(t),null}}};m=ue([Y(0,v.IFileService),Y(1,L.IEnvironmentService),Y(2,A.IUserDataSyncLogService)],m),e.KeybindingsInitializer=m}),define(Q[186],Z([0,1,26,32,41,46,51,20,18]),function(G,e,v,A,k,R,O,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function S(l,d,f){let y=[];f?y=h(f):y=I(d);const u=[],P=[...(0,L.getDisallowedIgnoredSettings)()];if(Array.isArray(y))for(const _ of y)_.startsWith("-")?P.push(_.substring(1)):u.push(_);return(0,g.distinct)([...l,...u].filter(_=>P.indexOf(_)===-1))}e.getIgnoredSettings=S;function I(l){let d=l.inspect("settingsSync.ignoredSettings").userValue;return d!==void 0||(d=l.inspect("sync.ignoredSettings").userValue,d!==void 0)?d:l.getValue("settingsSync.ignoredSettings")||[]}function h(l){const d=(0,A.parse)(l);return d?d["settingsSync.ignoredSettings"]||d["sync.ignoredSettings"]||[]:[]}function w(l,d,f,y){if(f.length){const u=s(d),P=(0,A.parse)(d),_=(0,A.parse)(l),z=[];for(const j of f){const W=P[j],q=_[j];W===void 0?l=O.edit(l,[j],void 0,y):q!==void 0?l=O.edit(l,[j],W,y):z.push(i(j,u))}z.sort((j,W)=>j.startOffset-W.startOffset),z.forEach(j=>l=p(j.setting.key,d,l,y))}return l}e.updateIgnoredSettings=w;function D(l,d,f,y,u,P){const _=w(l,d,y,P),z=f!==_,j=f!==d;if(!z&&!j)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!j)return{conflictsSettings:[],localContent:null,remoteContent:_,hasConflicts:!1};if(j&&!z)return{conflictsSettings:[],localContent:w(d,l,y,P),remoteContent:null,hasConflicts:!1};if(f===null&&C(l)){const se=a(l,d,y)?null:w(d,l,y,P);return{conflictsSettings:[],localContent:se,remoteContent:null,hasConflicts:!1}}let W=l,q=d;const x=(0,A.parse)(l),B=(0,A.parse)(d),M=f?(0,A.parse)(f):null,F=y.reduce((se,ce)=>(se.add(ce),se),new Set),T=b(x,B,F),U=b(M,x,F),N=b(M,B,F),$=new Map,H=new Set,K=se=>{H.add(se);const ce=u.filter(({key:he})=>he===se)[0];ce?(W=O.edit(W,[se],ce.value,P),q=O.edit(q,[se],ce.value,P)):$.set(se,{key:se,localValue:x[se],remoteValue:B[se]})};for(const se of U.removed.values())N.updated.has(se)?K(se):q=O.edit(q,[se],void 0,P);for(const se of N.removed.values())H.has(se)||(U.updated.has(se)?K(se):W=O.edit(W,[se],void 0,P));for(const se of U.updated.values())H.has(se)||(N.updated.has(se)?T.updated.has(se)&&K(se):q=O.edit(q,[se],x[se],P));for(const se of N.updated.values())H.has(se)||(U.updated.has(se)?T.updated.has(se)&&K(se):W=O.edit(W,[se],B[se],P));for(const se of U.added.values())H.has(se)||(N.added.has(se)?T.updated.has(se)&&K(se):q=p(se,W,q,P));for(const se of N.added.values())H.has(se)||(U.added.has(se)?T.updated.has(se)&&K(se):W=p(se,q,W,P));const te=$.size>0||!a(W,q,y),X=te||!a(W,l,[]),ie=te||!a(q,d,[]);return{localContent:X?W:null,remoteContent:ie?q:null,conflictsSettings:[...$.values()],hasConflicts:te}}e.merge=D;function a(l,d,f){if(l===d)return!0;const y=(0,A.parse)(l),u=(0,A.parse)(d),P=f.reduce((j,W)=>(j.add(W),j),new Set),_=s(l).filter(j=>!(j.setting&&P.has(j.setting.key))),z=s(d).filter(j=>!(j.setting&&P.has(j.setting.key)));if(_.length!==z.length)return!1;for(let j=0;j<_.length;j++){const W=_[j],q=z[j];if(W.setting&&q.setting){if(W.setting.key!==q.setting.key||!v.equals(y[W.setting.key],u[W.setting.key]))return!1}else if(!W.setting&&!q.setting){if(W.value!==q.value)return!1}else return!1}return!0}e.areSame=a;function C(l){return l?s(l).length===0:!0}e.isEmpty=C;function b(l,d,f){const y=l?Object.keys(l).filter(j=>!f.has(j)):[],u=Object.keys(d).filter(j=>!f.has(j)),P=u.filter(j=>y.indexOf(j)===-1).reduce((j,W)=>(j.add(W),j),new Set),_=y.filter(j=>u.indexOf(j)===-1).reduce((j,W)=>(j.add(W),j),new Set),z=new Set;if(l){for(const j of y)if(!_.has(j)){const W=l[j],q=d[j];v.equals(W,q)||z.add(j)}}return{added:P,removed:_,updated:z}}function p(l,d,f,y){const u=(0,A.parse)(d),P=s(d),_=s(f),z=E(l,P,_);return m(f,l,u[l],z,_,y)}e.addSetting=p;function E(l,d,f){const y=d.findIndex(P=>{var _;return((_=P.setting)===null||_===void 0?void 0:_.key)===l}),u=d[y-1];if(u){if(u.setting){const _=i(u.setting.key,f);if(_)return{index:f.indexOf(_),insertAfter:!0}}else{const _=t(y,d);if(_){const z=i(_.setting.key,f);if(z){const j=n(f.indexOf(z),f),W=r(d,_,d[y]);if(j){const q=r(f,z,j),x=c(W,q);return x?{index:f.indexOf(x),insertAfter:!0}:{index:f.indexOf(j),insertAfter:!1}}else{const q=r(f,z,f[f.length-1]),x=c(W,q);return x?{index:f.indexOf(x),insertAfter:!0}:{index:f.length-1,insertAfter:!0}}}}}const P=d[y+1];if(P)if(P.setting){const _=i(P.setting.key,f);if(_)return{index:f.indexOf(_),insertAfter:!1}}else{const _=n(y,d);if(_){const z=i(_.setting.key,f);if(z){const j=t(f.indexOf(z),f),W=r(d,d[y],_);if(j){const q=r(f,j,z),x=c(W.reverse(),q.reverse());return x?{index:f.indexOf(x),insertAfter:!1}:{index:f.indexOf(j),insertAfter:!0}}else{const q=r(f,f[0],z),x=c(W.reverse(),q.reverse());return x?{index:f.indexOf(x),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:f.length-1,insertAfter:!0}}function m(l,d,f,y,u,P){let _;return y.index===-1?_=(0,k.setProperty)(l,[d],f,P):_=o(l,d,f,y,u,P).map(z=>(0,k.withFormatting)(l,z,P)[0]),(0,k.applyEdits)(l,_)}function o(l,d,f,y,u,P){var _;const z=`${JSON.stringify(d)}: ${JSON.stringify(f)}`,j=(0,R.getEOL)(P,l),W=u[y.index];if(y.insertAfter){const q=[];if(W.setting)q.push({offset:W.endOffset,length:0,content:","+z});else{const x=n(y.index,u),B=t(y.index,u),M=(_=B==null?void 0:B.setting)===null||_===void 0?void 0:_.commaOffset;B&&M===void 0&&q.push({offset:B.endOffset,length:0,content:","});const F=M!==void 0&&M>W.endOffset;q.push({offset:F?M+1:W.endOffset,length:0,content:x?j+z+",":j+z})}return q}else{if(W.setting)return[{offset:W.startOffset,length:0,content:z+","}];const q=(u[y.index-1]&&!u[y.index-1].setting?j:"")+z+(n(y.index,u)?",":"")+j;return[{offset:W.startOffset,length:0,content:q}]}}function i(l,d){return d.filter(f=>{var y;return((y=f.setting)===null||y===void 0?void 0:y.key)===l})[0]}function t(l,d){for(let f=l-1;f>=0;f--)if(d[f].setting)return d[f]}function n(l,d){for(let f=l+1;f<d.length;f++)if(d[f].setting)return d[f]}function r(l,d,f){const y=l.indexOf(d),u=l.indexOf(f);return l.filter((P,_)=>y<_&&_<u)}function c(l,d){if(l.length&&d.length){let f=0;for(;f<d.length&&f<l.length;f++)if(l[f].value!==d[f].value)return d[f-1];return d[f-1]}}function s(l){const d=[];let f=-1,y,u;const P={onObjectBegin:_=>{f++},onObjectProperty:(_,z,j)=>{f===0&&(y=z,u=_)},onObjectEnd:(_,z)=>{f--,f===0&&d.push({startOffset:y,endOffset:_+z,value:l.substring(y,_+z),setting:{key:u,commaOffset:void 0}})},onArrayBegin:(_,z)=>{f++},onArrayEnd:(_,z)=>{f--,f===0&&d.push({startOffset:y,endOffset:_+z,value:l.substring(y,_+z),setting:{key:u,commaOffset:void 0}})},onLiteralValue:(_,z,j)=>{f===0&&d.push({startOffset:y,endOffset:z+j,value:l.substring(y,z+j),setting:{key:u,commaOffset:void 0}})},onSeparator:(_,z,j)=>{if(f===0&&_===","){let W=d.length-1;for(;W>=0&&!d[W].setting;W--);const q=d[W];q&&d.splice(W,1,{startOffset:q.startOffset,endOffset:q.endOffset,value:q.value,setting:{key:q.setting.key,commaOffset:z}})}},onComment:(_,z)=>{f===0&&d.push({startOffset:_,endOffset:_+z,value:l.substring(_,_+z)})}};return(0,A.visit)(l,P),d}}),define(Q[187],Z([0,1,9,20,22,123,3,10,24,186,51,45,25,28,19,41]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function b(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function p(i){const t=JSON.parse(i);return b(t)?t:{settings:i}}e.parseSettingsSyncContent=p;let E=class extends h.AbstractJsonFileSynchroniser{constructor(t,n,r,c,s,l,d,f,y,u,P){super(n.settingsResource,"settings",t,n,r,c,s,y,u,l,d,f);this.extensionManagementService=P,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,n,r){const c=await this.getLocalFileContent(),s=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t),d=n?this.getSettingsSyncContent(n):null,f=await this.getIgnoredSettings();let y=null,u=!1,P=!1,_=!1;if(l){let j=c?c.value.toString().trim():"{}";j=j||"{}",this.validateContent(j),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const W=(0,S.merge)(j,l.settings,d?d.settings:null,f,[],s);y=W.localContent||W.remoteContent,u=W.localContent!==null,P=W.remoteContent!==null,_=W.hasConflicts}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),y=c.value.toString(),P=!0);const z={content:y,localChange:u?2:0,remoteChange:P?2:0,hasConflicts:_};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,n){const r=await this.getFormattingOptions(),c=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?(0,S.updateIgnoredSettings)(t.previewResult.content,"{}",c,r):null})}async getAcceptResult(t,n,r,c){const s=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(n,this.localResource))return{content:t.fileContent?(0,S.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:t.remoteContent!==null?(0,S.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return r===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:r!==null?(0,S.updateIgnoredSettings)(r,t.fileContent?t.fileContent.value.toString():"{}",l,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(t,n,r,c){const{fileContent:s}=r[0][0];let{content:l,localChange:d,remoteChange:f}=r[0][1];if(d===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(l,s,c),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),f!==0){const y=await this.getFormattingOptions(),u=this.getSettingsSyncContent(t),P=await this.getIgnoredSettings(l);l=(0,S.updateIgnoredSettings)(l,u?u.settings:"{}",P,y),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),c?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(y){}(n==null?void 0:n.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const n=await this.getFormattingOptions(),r=(0,I.edit)(t.value.toString(),[A.CONFIGURATION_SYNC_STORE_KEY],void 0,n);return!(0,S.isEmpty)(r)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const n=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:n}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let n=await super.resolveContent(t);if(n)return n;if(n=await super.resolveContent(this.extUri.dirname(t)),n){const r=this.parseSyncData(n);if(r){const c=this.parseSettingsSyncContent(r.content);if(c)switch(this.extUri.basename(t)){case"settings.json":return c.settings}}}return null}async resolvePreviewContent(t){let n=await super.resolvePreviewContent(t);if(n){const r=await this.getFormattingOptions(),c=await this.getIgnoredSettings();n=(0,S.updateIgnoredSettings)(n,"{}",c,r)}return n}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return p(t)}catch(n){this.logService.error(n)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtension,c=>!!c.gallery),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,c=>!c.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const n=await this._defaultIgnoredSettings;return(0,S.getIgnoredSettings)(n,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new A.UserDataSyncError((0,R.localize)(0,null),A.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const n=JSON.parse(t.value.toString());if(!o(n))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const r=this.parseSettingsSyncContent(n.content);if(!r||!r.settings)return;let c=r.settings;const s=await this.getFormattingOptions();for(const l in n)if(["version","content","machineId"].indexOf(l)===-1&&n[l]!==void 0){const d=(0,C.setProperty)(c,[l],n[l],s);d.length&&(c=(0,C.applyEdits)(c,d))}await this.fileService.writeFile(this.file,k.VSBuffer.fromString(c))}catch(t){}}};E=ue([Y(0,v.IFileService),Y(1,L.IEnvironmentService),Y(2,a.IStorageService),Y(3,A.IUserDataSyncStoreService),Y(4,A.IUserDataSyncBackupStoreService),Y(5,A.IUserDataSyncLogService),Y(6,A.IUserDataSyncUtilService),Y(7,g.IConfigurationService),Y(8,A.IUserDataSyncResourceEnablementService),Y(9,w.ITelemetryService),Y(10,D.IExtensionManagementService)],E),e.SettingsSynchroniser=E;let m=class extends h.AbstractInitializer{constructor(t,n,r){super("settings",n,r,t)}async doInitialize(t){const n=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!n){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,k.VSBuffer.fromString(n.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,S.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return p(t)}catch(n){this.logService.error(n)}return null}};m=ue([Y(0,v.IFileService),Y(1,L.IEnvironmentService),Y(2,A.IUserDataSyncLogService)],m),e.SettingsInitializer=m;function o(i){return!!(i&&i.version!==void 0&&typeof i.version=="number"&&i.content!==void 0&&typeof i.content=="string"&&i.machineId!==void 0&&typeof i.machineId=="string")}}),define(Q[188],Z([0,1,20,10,9,24,45,25,22,181,19,26,3]),function(G,e,v,A,k,R,O,L,g,S,I,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let D=class extends O.AbstractSynchroniser{constructor(b,p,E,m,o,i,t,n,r){super("snippets",p,b,E,m,o,n,r,i,t);this.version=1,this.snippetsFolder=b.snippetsHome,this._register(this.fileService.watch(b.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(w.Event.filter(this.fileService.onDidFilesChange,c=>c.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(b,p,E){const m=await this.getSnippetsFileContents(),o=this.toSnippetsContents(m),i=b.syncData?this.parseSnippets(b.syncData):null,t=p&&p.syncData?this.parseSnippets(p.syncData):null;i?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,S.merge)(o,i,t);return this.getResourcePreviews(n,m,i||{})}async getMergeResult(b,p){return b.previewResult}async getAcceptResult(b,p,E,m){if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:b.fileContent?b.fileContent.value.toString():null,localChange:0,remoteChange:b.fileContent?b.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:b.remoteContent,localChange:b.remoteContent!==null?b.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder))return E===void 0?{content:b.previewResult.content,localChange:b.previewResult.localChange,remoteChange:b.previewResult.remoteChange}:{content:E,localChange:E===null?b.fileContent!==null?3:0:2,remoteChange:E===null?b.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async applyResult(b,p,E,m){const o=E.map(([i,t])=>Object.assign(Object.assign({},i),{acceptResult:t}));o.every(({localChange:i,remoteChange:t})=>i===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:i})=>i!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,m)),o.some(({remoteChange:i})=>i!==0)&&(b=await this.updateRemoteSnippets(o,b,m)),(p==null?void 0:p.ref)!==b.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(b),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:i}of o)try{await this.fileService.del(i)}catch(t){}}getResourcePreviews(b,p,E){const m=new Map;for(const o of Object.keys(b.local.added)){const i={content:b.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};m.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:E[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(b.local.updated)){const i={content:b.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[o],localContent:p[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:E[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of b.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[o],localContent:p[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(b.remote.added)){const i={content:b.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[o],localContent:p[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(b.remote.updated)){const i={content:b.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[o],localContent:p[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:E[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of b.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:E[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of b.conflicts){const i={content:p[o]?p[o].value.toString():null,hasConflicts:!0,localChange:p[o]?2:1,remoteChange:E[o]?2:1};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[o]||null,localContent:p[o]?p[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:E[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(p))if(!m.has(o)){const i={content:p[o]?p[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[o]||null,localContent:p[o]?p[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:E[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...m.values()]}async getAssociatedResources({uri:b}){let p=await super.resolveContent(b);if(p){const E=this.parseSyncData(p);if(E){const m=this.parseSnippets(E),o=[];for(const i of Object.keys(m)){const t=this.extUri.joinPath(b,i),n=this.extUri.joinPath(this.snippetsFolder,i),r=await this.fileService.exists(n);o.push({resource:t,comparableResource:r?n:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(b){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(b);let p=await super.resolveContent(b);if(p)return p;if(p=await super.resolveContent(this.extUri.dirname(b)),p){const E=this.parseSyncData(p);if(E)return this.parseSnippets(E)[this.extUri.basename(b)]||null}return null}async hasLocalData(){try{const b=await this.getSnippetsFileContents();if(Object.keys(b).length)return!0}catch(b){}return!1}async updateLocalBackup(b){const p={};for(const E of b)E.fileContent&&(p[this.extUri.basename(E.localResource)]=E.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(p)))}async updateLocalSnippets(b,p){for(const{fileContent:E,acceptResult:m,localResource:o,remoteResource:i,localChange:t}of b)if(t!==0){const n=i?this.extUri.basename(i):this.extUri.basename(o),r=this.extUri.joinPath(this.snippetsFolder,n);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,g.VSBuffer.fromString(m.content),{overwrite:p}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,g.VSBuffer.fromString(m.content),p?void 0:E),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(b,p,E){const m=p.syncData?this.parseSnippets(p.syncData):{},o=(0,h.deepClone)(m);for(const{acceptResult:i,localResource:t,remoteResource:n,remoteChange:r}of b)if(r!==0){const c=t?this.extUri.basename(t):this.extUri.basename(n);r===3?delete o[c]:o[c]=i.content}return(0,S.areSame)(m,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),p=await this.updateRemoteUserData(JSON.stringify(o),E?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),p}parseSnippets(b){return JSON.parse(b.content)}toSnippetsContents(b){const p={};for(const E of Object.keys(b))p[E]=b[E].value.toString();return p}async getSnippetsFileContents(){const b={};let p;try{p=await this.fileService.resolve(this.snippetsFolder)}catch(E){if(E instanceof k.FileOperationError&&E.fileOperationResult===1)return b;throw E}for(const E of p.children||[]){const m=E.resource,o=this.extUri.extname(m);if(o===".json"||o===".code-snippets"){const i=this.extUri.relativePath(this.snippetsFolder,m),t=await this.fileService.readFile(m);b[i]=t}}return b}};D=ue([Y(0,A.IEnvironmentService),Y(1,k.IFileService),Y(2,I.IStorageService),Y(3,v.IUserDataSyncStoreService),Y(4,v.IUserDataSyncBackupStoreService),Y(5,v.IUserDataSyncLogService),Y(6,R.IConfigurationService),Y(7,v.IUserDataSyncResourceEnablementService),Y(8,L.ITelemetryService)],D),e.SnippetsSynchroniser=D;let a=class extends O.AbstractInitializer{constructor(b,p,E){super("snippets",p,E,b)}async doInitialize(b){const p=b.syncData?JSON.parse(b.syncData.content):null;if(!p){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const m of Object.keys(p)){const o=p[m];if(o){const i=this.extUri.joinPath(this.environmentService.snippetsHome,m);await this.fileService.createFile(i,g.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(i))}}await this.updateLastSyncUserData(b)}async isEmpty(){var b;try{return!((b=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||b===void 0?void 0:b.length)}catch(p){return p.fileOperationResult===1}}};a=ue([Y(0,k.IFileService),Y(1,A.IEnvironmentService),Y(2,v.IUserDataSyncLogService)],a),e.SnippetsInitializer=a}),define(Q[59],Z([0,1,4,3,2,20]),function(G,e,v,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,v.createDecorator)("IUserDataSyncAccountService");let O=class extends k.Disposable{constructor(g){super();this.userDataSyncStoreService=g,this._onDidChangeAccount=this._register(new A.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(g.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(g.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(g){(g&&this._account?g.token!==this._account.token||g.authenticationProviderId!==this._account.authenticationProviderId:g!==this._account)&&(this._account=g,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(g))}};O=ue([Y(0,R.IUserDataSyncStoreService)],O),e.UserDataSyncAccountService=O}),define(Q[189],Z([0,1,2,20,11,24,9,10,54,22,6]),function(G,e,v,A,k,R,O,L,g,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let h=class extends v.Disposable{constructor(D,a,C,b){super();this.environmentService=D,this.fileService=a,this.configurationService=C,this.logService=b,A.ALL_SYNC_RESOURCES.forEach(p=>this.cleanUpBackup(p))}async getAllRefs(D){const a=(0,k.joinPath)(this.environmentService.userDataSyncHome,D),C=await this.fileService.resolve(a);return C.children?C.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.getCreationTime(p)})):[]}async resolveContent(D,a){if(!a){const C=await this.getAllRefs(D);C.length&&(a=C[C.length-1].ref)}if(a){const C=(0,k.joinPath)(this.environmentService.userDataSyncHome,D,a);return(await this.fileService.readFile(C)).value.toString()}return null}async backup(D,a){const C=(0,k.joinPath)(this.environmentService.userDataSyncHome,D),b=(0,k.joinPath)(C,`${(0,g.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(b,S.VSBuffer.fromString(a))}catch(p){this.logService.error(p)}try{this.cleanUpBackup(D)}catch(p){}}async cleanUpBackup(D){const a=(0,k.joinPath)(this.environmentService.userDataSyncHome,D);try{try{if(!await this.fileService.exists(a))return}catch(b){return}const C=await this.fileService.resolve(a);if(C.children){const b=C.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),p=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let E=b.filter(o=>Date.now()-this.getCreationTime(o)>p);const m=b.length-E.length;m<10&&(E=E.slice(10-m)),await I.Promises.settled(E.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(C){this.logService.error(C)}}getCreationTime(D){return D.ctime||new Date(parseInt(D.name.substring(0,4)),parseInt(D.name.substring(4,6))-1,parseInt(D.name.substring(6,8)),parseInt(D.name.substring(9,11)),parseInt(D.name.substring(11,13)),parseInt(D.name.substring(13,15))).getTime()}};h=ue([Y(0,L.IEnvironmentService),Y(1,O.IFileService),Y(2,R.IConfigurationService),Y(3,A.IUserDataSyncLogService)],h),e.UserDataSyncBackupStoreService=h}),define(Q[190],Z([0,1,5,2]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(w){this.service=w}listen(w,D){switch(D){case"onError":return this.service.onError}throw new Error(`Event not found: ${D}`)}call(w,D,a){switch(D){case"triggerSync":return this.service.triggerSync(a[0],a[1],a[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(a[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class R{constructor(w){this.service=w}listen(w,D){throw new Error(`Event not found: ${D}`)}call(w,D,a){switch(D){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(a[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(v.URI.revive(a[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=R;class O{constructor(w){this.channel=w}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(w){return this.channel.call("resolveUserKeybindings",[w])}async resolveFormattingOptions(w){return this.channel.call("resolveFormattingOptions",[w])}}e.UserDataSyncUtilServiceClient=O;class L{constructor(w){this.service=w}listen(w,D){switch(D){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${D}`)}async call(w,D,a){switch(D){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(a[0],a[1]);case"setEnablement":return this.service.setEnablement(a[0],a[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=L;class g{constructor(w){this.service=w}listen(w,D){switch(D){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${D}`)}call(w,D,a){switch(D){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(a)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=g;class S{constructor(w){this.service=w}listen(w,D){switch(D){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${D}`)}call(w,D,a){switch(D){case"switch":return this.service.switch(a[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class I extends A.Disposable{constructor(w){super();this.channel=w,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(w){return this.channel.call("switch",[w])}async getPreviousUserDataSyncStore(){const w=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(w)}revive(w){return{url:v.URI.revive(w.url),type:w.type,defaultUrl:v.URI.revive(w.defaultUrl),insidersUrl:v.URI.revive(w.insidersUrl),stableUrl:v.URI.revive(w.stableUrl),canSwitch:w.canSwitch,authenticationProviders:w.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(Q[191],Z([0,1,14,10]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends v.AbstractLogger{constructor(O,L){super();this.logger=this._register(O.createLogger(L.userDataSyncLogResource,{name:"settingssync"}))}trace(O,...L){this.logger.trace(O,...L)}debug(O,...L){this.logger.debug(O,...L)}info(O,...L){this.logger.info(O,...L)}warn(O,...L){this.logger.warn(O,...L)}error(O,...L){this.logger.error(O,...L)}critical(O,...L){this.logger.critical(O,...L)}flush(){this.logger.flush()}};k=ue([Y(0,v.ILoggerService),Y(1,A.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(Q[60],Z([0,1,4,2,44,10,9,19,20,126,31,7,21,3]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,v.createDecorator)("IUserDataSyncMachinesService");const a="sync.currentMachineName";let C=class xe extends A.Disposable{constructor(p,E,m,o,i,t){super();this.storageService=m,this.userDataSyncStoreService=o,this.logService=i,this.productService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,k.getServiceMachineId)(p,E,m)}async getMachines(p){const E=await this.currentMachineIdPromise;return(await this.readMachinesData(p)).machines.map(o=>Object.assign(Object.assign({},o),{isCurrent:o.id===E}))}async addCurrentMachine(p){const E=await this.currentMachineIdPromise,m=await this.readMachinesData(p);m.machines.some(({id:o})=>o===E)||(m.machines.push({id:E,name:this.computeCurrentMachineName(m.machines)}),await this.writeMachinesData(m))}async removeCurrentMachine(p){const E=await this.currentMachineIdPromise,m=await this.readMachinesData(p),o=m.machines.filter(({id:i})=>i!==E);o.length!==m.machines.length&&(m.machines=o,await this.writeMachinesData(m))}async renameMachine(p,E,m){const o=await this.currentMachineIdPromise,i=await this.readMachinesData(m),t=i.machines.find(({id:n})=>n===p);t&&(t.name=E,await this.writeMachinesData(i),i.machines.some(({id:n})=>n===o)&&this.storageService.store(a,E,0,1))}async setEnablement(p,E){const m=await this.readMachinesData(),o=m.machines.find(({id:i})=>i===p);o&&(o.disabled=E?void 0:!0,await this.writeMachinesData(m))}computeCurrentMachineName(p){const E=this.storageService.get(a,0);if(E)return E;const m=`${this.productService.nameLong} (${(0,h.PlatformToString)(h.isWeb?0:h.platform)})`,o=new RegExp(`${(0,w.escapeRegExpCharacters)(m)}\\s#(\\d+)`);let i=0;for(const t of p){const n=o.exec(t.name),r=n?parseInt(n[1]):0;i=r>i?r:i}return`${m} #${i+1}`}async readMachinesData(p){this.userData=await this.readUserData(p);const E=this.parse(this.userData);if(E.version!==xe.VERSION)throw new Error((0,S.localize)(0,null,this.productService.nameLong));return E}async writeMachinesData(p){var E;const m=JSON.stringify(p),o=await this.userDataSyncStoreService.write(xe.RESOURCE,m,((E=this.userData)===null||E===void 0?void 0:E.ref)||null);this.userData={ref:o,content:m},this._onDidChange.fire()}async readUserData(p){if(this.userData){const E=p&&p.latest?p.latest[xe.RESOURCE]:void 0;if(this.userData.ref===E)return this.userData;if(E===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(xe.RESOURCE,this.userData)}parse(p){if(p.content!==null)try{return JSON.parse(p.content)}catch(E){this.logService.error(E)}return{version:xe.VERSION,machines:[]}}};C.VERSION=1,C.RESOURCE="machines",C=ue([Y(0,R.IEnvironmentService),Y(1,O.IFileService),Y(2,L.IStorageService),Y(3,g.IUserDataSyncStoreService),Y(4,g.IUserDataSyncLogService),Y(5,I.IProductService)],C),e.UserDataSyncMachinesService=C}),define(Q[84],Z([0,1,6,3,2,20,59,25,15,19,10,60,124,54,5,11,7,31]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const E="sync.enable",m="sync.disableMachineEventually",o="sync.sessionId",i="sync.storeUrl",t="sync.productQuality";let n=class extends k.Disposable{constructor(l,d,f){super();this.storageService=l,this.environmentService=d,this.userDataSyncStoreManagementService=f,this._onDidChangeEnablement=new A.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(l.onDidChangeValue(y=>this.onDidStorageChange(y)))}isEnabled(l){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,0,!!l)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(l){l&&!this.canToggleEnablement()||this.storageService.store(E,l,0,1)}onDidStorageChange(l){if(l.scope===0&&E===l.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=ue([Y(0,S.IStorageService),Y(1,I.IEnvironmentService),Y(2,R.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let r=class extends k.Disposable{constructor(l,d,f,y,u,P,_,z,j,W,q){var x;super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=f,this.userDataSyncResourceEnablementService=y,this.userDataSyncService=u,this.logService=P,this.userDataSyncAccountService=_,this.telemetryService=z,this.userDataSyncMachinesService=j,this.storageService=W,this.autoSync=this._register(new k.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=q,this.syncTriggerDelayer=this._register(new v.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(x=d.userDataSyncStore)===null||x===void 0?void 0:x.url,this.previousProductQuality=this.productQuality,this.productQuality=l.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{var B,M;(0,C.isEqual)(this.syncUrl,(B=d.userDataSyncStore)===null||B===void 0?void 0:B.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(M=d.userDataSyncStore)===null||M===void 0?void 0:M.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(f.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(A.Event.debounce(u.onDidChangeLocal,(B,M)=>B?[...B,M]:[M],1e3)(B=>this.triggerSync(B,!1,!1))),this._register(A.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,B])=>B)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const l=this.storageService.get(i,0);return l?a.URI.parse(l):void 0}set syncUrl(l){l?this.storageService.store(i,l.toString(),0,1):this.storageService.remove(i,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(l){l?this.storageService.store(t,l,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:l,message:d}=this.isAutoSyncEnabled();l?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(f=>this.onDidFinishSync(f))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,D.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(l,d,f){try{this.userDataSyncAccountService.account&&!f&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(o,0),l?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(y){if(d)this.logService.error(y),this.updateEnablement(!1);else throw y}}updateEnablement(l){this.userDataAutoSyncEnablementService.isEnabled()!==l&&(this.telemetryService.publicLog2(E,{enabled:l}),this.userDataAutoSyncEnablementService.setEnablement(l),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(l){if(!l){this.successiveFailures=0;return}const d=R.UserDataSyncError.toUserDataSyncError(l);d instanceof R.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code===R.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code===R.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code===R.UserDataSyncErrorCode.LocalTooManyRequests||d.code===R.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code===R.UserDataSyncErrorCode.UpgradeRequired||d.code===R.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code===R.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code===R.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code===R.UserDataSyncErrorCode.ServiceChanged||d.code===R.UserDataSyncErrorCode.DefaultServiceChanged?b.isWeb&&d.code===R.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(m,!0,0,1),await(0,v.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(m,0,!1)}stopDisableMachineEventually(){this.storageService.remove(m,0)}async triggerSync(l,d,f){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...l),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",f)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=ue([Y(0,p.IProductService),Y(1,R.IUserDataSyncStoreManagementService),Y(2,R.IUserDataSyncStoreService),Y(3,R.IUserDataSyncResourceEnablementService),Y(4,R.IUserDataSyncService),Y(5,R.IUserDataSyncLogService),Y(6,O.IUserDataSyncAccountService),Y(7,L.ITelemetryService),Y(8,h.IUserDataSyncMachinesService),Y(9,S.IStorageService),Y(10,R.IUserDataAutoSyncEnablementService)],r),e.UserDataAutoSyncService=r;class c extends k.Disposable{constructor(l,d,f,y,u,P,_,z){super();this.lastSyncUrl=l,this.interval=d,this.userDataSyncStoreManagementService=f,this.userDataSyncStoreService=y,this.userDataSyncService=u,this.userDataSyncMachinesService=P,this.logService=_,this.storageService=z,this.intervalHandler=this._register(new k.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,k.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,v.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(l,d){const f=(0,v.createCancelablePromise)(async y=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,g.isPromiseCanceledError)(u))return}return this.doSync(l,d,y)});return this.syncPromise=f,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var l;return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,(l=this.userDataSyncStoreManagementService.userDataSyncStore)===null||l===void 0?void 0:l.url)}async hasDefaultServiceChanged(){const l=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!l&&(!(0,C.isEqual)(d.defaultUrl,l.defaultUrl)||!(0,C.isEqual)(d.insidersUrl,l.insidersUrl)||!(0,C.isEqual)(d.stableUrl,l.stableUrl))}async doSync(l,d,f){this.logService.info(`Auto Sync: Triggered by ${l}`),this._onDidStartSync.fire();let y;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(d),f.isCancellationRequested)return;let u=this.syncTask.manifest;if(u===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new R.UserDataAutoSyncError((0,w.localize)(0,null),R.UserDataSyncErrorCode.DefaultServiceChanged):new R.UserDataAutoSyncError((0,w.localize)(1,null),R.UserDataSyncErrorCode.ServiceChanged):new R.UserDataAutoSyncError((0,w.localize)(2,null),R.UserDataSyncErrorCode.TurnedOff);const P=this.storageService.get(o,0);if(P&&u&&P!==u.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new R.UserDataAutoSyncError((0,w.localize)(3,null),R.UserDataSyncErrorCode.DefaultServiceChanged):new R.UserDataAutoSyncError((0,w.localize)(4,null),R.UserDataSyncErrorCode.ServiceChanged):new R.UserDataAutoSyncError((0,w.localize)(5,null),R.UserDataSyncErrorCode.SessionExpired);const _=await this.userDataSyncMachinesService.getMachines(u||void 0);if(f.isCancellationRequested)return;const z=_.find(j=>j.isCurrent);if(z==null?void 0:z.disabled)throw new R.UserDataAutoSyncError((0,w.localize)(6,null),R.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),u===null&&(u=await this.userDataSyncStoreService.manifest()),u&&u.session!==P&&this.storageService.store(o,u.session,0,1),f.isCancellationRequested)return;z||await this.userDataSyncMachinesService.addCurrentMachine(u||void 0)}catch(u){this.logService.error(u),y=u}this._onDidFinishSync.fire(y)}register(l){return super._register(l)}}c.INTERVAL_SYNCING="Interval"}),define(Q[192],Z([0,1,20,2,3,19,25,7]),function(G,e,v,A,k,R,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let g=class extends A.Disposable{constructor(I,h){super();this.storageService=I,this.telemetryService=h,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(I.onDidChangeValue(w=>this.onDidStorageChange(w)))}isResourceEnabled(I){return this.storageService.getBoolean((0,v.getEnablementKey)(I),0,!0)}setResourceEnablement(I,h){if(this.isResourceEnabled(I)!==h){const w=(0,v.getEnablementKey)(I);this.telemetryService.publicLog2(w,{enabled:h}),this.storeResourceEnablement(w,h)}}storeResourceEnablement(I,h){this.storageService.store(I,h,0,L.isWeb?0:1)}onDidStorageChange(I){if(I.scope===0){const h=v.ALL_SYNC_RESOURCES.filter(w=>(0,v.getEnablementKey)(w)===I.key)[0];if(h){this._onDidChangeResourceEnablement.fire([h,this.isResourceEnabled(h)]);return}}}};g=ue([Y(0,R.IStorageService),Y(1,O.ITelemetryService)],g),e.UserDataSyncResourceEnablementService=g}),define(Q[193],Z([0,1,20,2,4,3,182,185,184,43,25,18,19,187,11,188,30,6,15]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const m="sync.lastSyncTime";let o=class extends A.Disposable{constructor(r,c,s,l,d,f){super();this.userDataSyncStoreService=r,this.userDataSyncStoreManagementService=c,this.instantiationService=s,this.logService=l,this.telemetryService=d,this.storageService=f,this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new R.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new R.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(D.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(L.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(C.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(g.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(O.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(R.Event.any(...this.synchronisers.map(y=>R.Event.map(y.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(R.Event.any(...this.synchronisers.map(y=>R.Event.map(y.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(m,0,void 0),this.onDidChangeLocal=R.Event.any(...this.synchronisers.map(y=>R.Event.map(y.onDidChangeLocal,()=>y.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(r){await this.checkEnablement();const c=(0,b.generateUuid)();let s;try{const y=(0,v.createSyncHeaders)(c);r&&(y["Cache-Control"]="no-cache"),s=await this.userDataSyncStoreService.manifest(y)}catch(y){const u=v.UserDataSyncError.toUserDataSyncError(y);throw this.reportUserDataSyncError(u,c),u}let l=!1;const d=this;let f;return{manifest:s,run(){if(l)throw new Error("Can run a task only once");return f=(0,p.createCancelablePromise)(y=>d.sync(s,c,y)),f.finally(()=>f=void 0)},async stop(){if(f&&f.cancel(),d.status!=="idle")return d.stop()}}}async createManualSyncTask(){await this.checkEnablement();const r=(0,b.generateUuid)(),c=(0,v.createSyncHeaders)(r);let s;try{s=await this.userDataSyncStoreService.manifest(c)}catch(l){const d=v.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(d,r),d}return new i(r,s,c,this.synchronisers,this.logService)}async sync(r,c,s){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),!s.isCancellationRequested){const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const d=(0,v.createSyncHeaders)(c);for(const f of this.synchronisers){if(s.isCancellationRequested)return;try{await f.sync(r,d)}catch(y){if(y instanceof v.UserDataSyncError)switch(y.code){case v.UserDataSyncErrorCode.TooLarge:throw new v.UserDataSyncError(y.message,y.code,f.resource);case v.UserDataSyncErrorCode.TooManyRequests:case v.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case v.UserDataSyncErrorCode.LocalTooManyRequests:case v.UserDataSyncErrorCode.Gone:case v.UserDataSyncErrorCode.UpgradeRequired:case v.UserDataSyncErrorCode.IncompatibleRemoteContent:case v.UserDataSyncErrorCode.IncompatibleLocalContent:throw y}const u=v.UserDataSyncError.toUserDataSyncError(y);this.reportUserDataSyncError(u,c),this.logService.error(y),this.logService.error(`${f.resource}: ${(0,S.toErrorMessage)(y)}`),this._syncErrors.push([f.resource,u])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(d){const f=v.UserDataSyncError.toUserDataSyncError(d);throw this.reportUserDataSyncError(f,c),f}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}}async stop(){if(this.status!=="idle")for(const r of this.synchronisers)try{r.status!=="idle"&&await r.stop()}catch(c){this.logService.error(c)}}async replace(r){await this.checkEnablement();for(const c of this.synchronisers)if(await c.replace(r))return}async accept(r,c,s,l){await this.checkEnablement();const d=this.getSynchroniser(r);await d.accept(c,s),l&&await d.apply(!1,(0,v.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(r){for(const c of this.synchronisers){const s=await c.resolveContent(r);if(s)return s}return null}getRemoteSyncResourceHandles(r){return this.getSynchroniser(r).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(r){return this.getSynchroniser(r).getLocalSyncResourceHandles()}getAssociatedResources(r,c){return this.getSynchroniser(r).getAssociatedResources(c)}getMachineId(r,c){return this.getSynchroniser(r).getMachineId(c)}async hasLocalData(){const r=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const c of r)if(await c.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(r){this.logService.error(r)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(m,0);for(const r of this.synchronisers)try{await r.resetLocal()}catch(c){this.logService.error(`${r.resource}: ${(0,S.toErrorMessage)(c)}`),this.logService.error(c)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const r of this.synchronisers)if(await r.hasPreviouslySynced())return!0;return!1}setStatus(r){const c=this._status;this._status!==r&&(this._status=r,this._onDidChangeStatus.fire(r),c==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const r=this.computeStatus();this.setStatus(r)}updateConflicts(){const r=this.computeConflicts();(0,h.equals)(this._conflicts,r,([c,s],[l,d])=>c===c&&(0,h.equals)(s,d,(f,y)=>(0,a.isEqual)(f.previewResource,y.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(r))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(m,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(r,c){this.telemetryService.publicLog2("sync/error",{code:r.code,url:r instanceof v.UserDataSyncStoreError?r.url:void 0,resource:r.resource,executionId:c,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(r=>r.status==="hasConflicts").map(r=>[r.resource,r.conflicts.map(t)])}getSynchroniser(r){return this.synchronisers.find(c=>c.resource===r)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=ue([Y(0,v.IUserDataSyncStoreService),Y(1,v.IUserDataSyncStoreManagementService),Y(2,k.IInstantiationService),Y(3,v.IUserDataSyncLogService),Y(4,I.ITelemetryService),Y(5,w.IStorageService)],o),e.UserDataSyncService=o;class i extends A.Disposable{constructor(r,c,s,l,d){super();this.id=r,this.manifest=c,this.syncHeaders=s,this.synchronisers=l,this.logService=d,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new R.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,p.createCancelablePromise)(r=>this.getPreviews(r))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(r){throw this.logService.error(r),r}}async accept(r,c){try{return await this.performAction(r,s=>s.accept(r,c))}catch(s){throw this.logService.error(s),s}}async merge(r){try{return r?await this.performAction(r,c=>c.merge(r)):await this.mergeAll()}catch(c){throw this.logService.error(c),c}}async discard(r){try{return await this.performAction(r,c=>c.discard(r))}catch(c){throw this.logService.error(c),c}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const r=[];for(const[,c]of this.previews)for(const s of c.resourcePreviews)s.mergeState==="conflict"&&r.push(s.previewResource);for(const c of r)await this.discard(c);return this.previews}catch(r){throw this.logService.error(r),r}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const r=[];for(const[c,s]of this.previews){this.synchronizingResources.push([c,s.resourcePreviews.map(f=>f.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(f=>f.resource===c);for(const f of s.resourcePreviews)(f.localChange!==0||f.remoteChange!==0)&&f.mergeState==="preview"&&await l.merge(f.previewResource);const d=await l.apply(!1,this.syncHeaders);d&&r.push(this.toSyncResourcePreview(l.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(f=>f[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}catch(r){throw this.logService.error(r),r}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,c]of this.previews){this.synchronizingResources.push([r,c.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const s=this.synchronisers.find(l=>l.resource===r);for(const l of c.resourcePreviews)await s.accept(l.remoteResource);await s.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,c]of this.previews){this.synchronizingResources.push([r,c.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const s=this.synchronisers.find(l=>l.resource===r);for(const l of c.resourcePreviews)await s.accept(l.localResource);await s.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async stop(){for(const r of this.synchronisers)try{await r.stop()}catch(c){(0,E.isPromiseCanceledError)(c)||this.logService.error(c)}this.reset()}async performAction(r,c){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const s=this.previews.findIndex(([,z])=>z.resourcePreviews.some(({localResource:j,previewResource:W,remoteResource:q})=>(0,a.isEqual)(r,j)||(0,a.isEqual)(r,W)||(0,a.isEqual)(r,q)));if(s===-1)return this.previews;const[l,d]=this.previews[s],f=d.resourcePreviews.find(({localResource:z,remoteResource:j,previewResource:W})=>(0,a.isEqual)(z,r)||(0,a.isEqual)(j,r)||(0,a.isEqual)(W,r));if(!f)return this.previews;let y=this.synchronizingResources.find(z=>z[0]===l);y||(y=[l,[]],this.synchronizingResources.push(y)),y[1].some(z=>(0,a.isEqual)(z,f.localResource))||(y[1].push(f.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const u=this.synchronisers.find(z=>z.resource===this.previews[s][0]),P=await c(u);P?this.previews.splice(s,1,this.toSyncResourcePreview(u.resource,P)):this.previews.splice(s,1);const _=this.synchronizingResources.findIndex(z=>z[0]===l);return this.synchronizingResources[_][1].splice(y[1].findIndex(z=>(0,a.isEqual)(z,f.localResource)),1),y[1].length||(this.synchronizingResources.splice(_,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const r=[];for(const[c,s]of this.previews){this.synchronizingResources.push([c,s.resourcePreviews.map(f=>f.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(f=>f.resource===c);let d=s;for(const f of s.resourcePreviews)(f.localChange!==0||f.remoteChange!==0)&&f.mergeState==="preview"&&(d=await l.merge(f.previewResource));d&&r.push(this.toSyncResourcePreview(l.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(f=>f[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}async getPreviews(r){const c=[];for(const s of this.synchronisers){if(r.isCancellationRequested)return[];const l=await s.preview(this.manifest,this.syncHeaders);l&&c.push(this.toSyncResourcePreview(s.resource,l))}return c}toSyncResourcePreview(r,c){return[r,{isLastSyncFromCurrentMachine:c.isLastSyncFromCurrentMachine,resourcePreviews:c.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(n){return{localResource:n.localResource,previewResource:n.previewResource,remoteResource:n.remoteResource,acceptedResource:n.acceptedResource,localChange:n.localChange,remoteChange:n.remoteChange,mergeState:n.mergeState}}}),define(Q[194],Z([0,1,3,20,5,2,17]),function(G,e,v,A,k,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class L{constructor(h,w){this.service=h,this.logService=w,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new v.Emitter}listen(h,w){switch(w){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${w}`)}async call(h,w,D){try{return await this._call(h,w,D)}catch(a){throw this.logService.error(a),a}}async _call(h,w,D){switch(w){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(D[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(D[0],k.URI.revive(D[1]),D[2],D[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(D[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(D[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(D[0]);case"getAssociatedResources":return this.service.getAssociatedResources(D[0],{created:D[1].created,uri:k.URI.revive(D[1].uri)});case"getMachineId":return this.service.getMachineId(D[0],{created:D[1].created,uri:k.URI.revive(D[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(w.startsWith("manualSync/")){const a=w.substring("manualSync/".length),C=D[0],b=this.getManualSyncTask(C);switch(D=D.slice(1),a){case"preview":return b.preview();case"accept":return b.accept(k.URI.revive(D[0]),D[1]);case"merge":return b.merge(k.URI.revive(D[0]));case"discard":return b.discard(k.URI.revive(D[0]));case"discardConflicts":return b.discardConflicts();case"apply":return b.apply();case"pull":return b.pull();case"push":return b.push();case"stop":return b.stop();case"_getStatus":return b.status;case"dispose":return this.disposeManualSyncTask(b)}}throw new Error("Invalid call")}getManualSyncTask(h){const w=this.manualSyncTasks.get(this.createKey(h));if(!w)throw new Error(`Manual sync taks not found: ${h}`);return w.manualSyncTask}async createManualSyncTask(){const h=new R.DisposableStore,w=h.add(await this.service.createManualSyncTask());return h.add(w.onSynchronizeResources(D=>this.onManualSynchronizeResources.fire({manualSyncTaskId:w.id,data:D}))),this.manualSyncTasks.set(this.createKey(w.id),{manualSyncTask:w,disposables:h}),{id:w.id,manifest:w.manifest,status:w.status}}disposeManualSyncTask(h){var w;h.dispose();const D=this.createKey(h.id);(w=this.manualSyncTasks.get(D))===null||w===void 0||w.disposables.dispose(),this.manualSyncTasks.delete(D)}createKey(h){return`manualSyncTask-${h}`}}e.UserDataSyncChannel=L;class g extends R.Disposable{constructor(h){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new v.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new v.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new v.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new v.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(w,D,a){return h.call(w,D,a).then(null,C=>{throw A.UserDataSyncError.toUserDataSyncError(C)})},listen(w,D){return h.listen(w,D)}},this.channel.call("_getInitialData").then(([w,D,a])=>{this.updateStatus(w),this.updateConflicts(D),a&&this.updateLastSyncTime(a),this._register(this.channel.listen("onDidChangeStatus")(C=>this.updateStatus(C))),this._register(this.channel.listen("onDidChangeLastSyncTime")(C=>this.updateLastSyncTime(C)))}),this._register(this.channel.listen("onDidChangeConflicts")(w=>this.updateConflicts(w))),this._register(this.channel.listen("onSyncErrors")(w=>this._onSyncErrors.fire(w.map(([D,a])=>[D,A.UserDataSyncError.toUserDataSyncError(a)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:h,manifest:w,status:D}=await this.channel.call("createManualSyncTask"),a=this,C=new S(h,w,D,{async call(b,p,E){return a.channel.call(`manualSync/${b}`,[h,...(0,O.isArray)(p)?p:[p]],E)},listen(b,p){return v.Event.map(v.Event.filter(a.channel.listen(`manualSync/${b}`,p),E=>!C.isDiposed()&&E.manualSyncTaskId===h),E=>E.data)}});return C}replace(h){return this.channel.call("replace",[h])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(h,w,D,a){return this.channel.call("accept",[h,w,D,a])}resolveContent(h){return this.channel.call("resolveContent",[h])}async getLocalSyncResourceHandles(h){return(await this.channel.call("getLocalSyncResourceHandles",[h])).map(({created:D,uri:a})=>({created:D,uri:k.URI.revive(a)}))}async getRemoteSyncResourceHandles(h){return(await this.channel.call("getRemoteSyncResourceHandles",[h])).map(({created:D,uri:a})=>({created:D,uri:k.URI.revive(a)}))}async getAssociatedResources(h,w){return(await this.channel.call("getAssociatedResources",[h,w])).map(({resource:a,comparableResource:C})=>({resource:k.URI.revive(a),comparableResource:k.URI.revive(C)}))}async getMachineId(h,w){return this.channel.call("getMachineId",[h,w])}async updateStatus(h){this._status=h,this._onDidChangeStatus.fire(h)}async updateConflicts(h){this._conflicts=h.map(([w,D])=>[w,D.map(a=>Object.assign(Object.assign({},a),{localResource:k.URI.revive(a.localResource),remoteResource:k.URI.revive(a.remoteResource),previewResource:k.URI.revive(a.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(h){this._lastSyncTime!==h&&(this._lastSyncTime=h,this._onDidChangeLastSyncTime.fire(h))}}e.UserDataSyncChannelClient=g;class S extends R.Disposable{constructor(h,w,D,a){super();this.id=h,this.manifest=w,this._disposed=!1,this._status=D;const C=this;this.channel={async call(b,p,E){try{const m=await a.call(b,p,E);return C.isDiposed()||(C._status=await a.call("_getStatus")),m}catch(m){throw A.UserDataSyncError.toUserDataSyncError(m)}},listen(b,p){return a.listen(b,p)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const h=await this.channel.call("preview");return this.deserializePreviews(h)}async accept(h,w){const D=await this.channel.call("accept",[h,w]);return this.deserializePreviews(D)}async merge(h){const w=await this.channel.call("merge",[h]);return this.deserializePreviews(w)}async discard(h){const w=await this.channel.call("discard",[h]);return this.deserializePreviews(w)}async discardConflicts(){const h=await this.channel.call("discardConflicts");return this.deserializePreviews(h)}async apply(){const h=await this.channel.call("apply");return this.deserializePreviews(h)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(h){return h.map(([w,D])=>[w,{isLastSyncFromCurrentMachine:D.isLastSyncFromCurrentMachine,resourcePreviews:D.resourcePreviews.map(a=>Object.assign(Object.assign({},a),{localResource:k.URI.revive(a.localResource),remoteResource:k.URI.revive(a.remoteResource),previewResource:k.URI.revive(a.previewResource),acceptedResource:k.URI.revive(a.acceptedResource)}))}])}}}),define(Q[195],Z([0,1,2,20,40,11,29,24,31,44,10,9,19,30,7,3,6,17,5,15]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const o="sync.previous.store",i="sync.donot-make-requests-until",t="sync.user-session-id",n="sync.machine-session-id",r=100,c=1e3*60*5;let s=class extends v.Disposable{constructor(P,_,z){super();this.productService=P,this.configurationService=_,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new C.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(C.Event.filter(z.onDidChangeValue,j=>{var W;return j.key===A.SYNC_SERVICE_URL_TYPE&&j.scope===0&&this.userDataSyncStoreType!==((W=this.userDataSyncStore)===null||W===void 0?void 0:W.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(A.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(P){this.storageService.store(A.SYNC_SERVICE_URL_TYPE,P,0,a.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[A.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(A.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(P,_){P=a.isWeb&&(P==null?void 0:P.web)?Object.assign(Object.assign({},P),P.web):P;const z=Object.assign(Object.assign({},P||{}),_||{});if(z&&(0,p.isString)(z.url)&&(0,p.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(j=>(0,p.isArray)(z.authenticationProviders[j].scopes))){const j=z,W=!!j.canSwitch&&!(_==null?void 0:_.url),q=j.url===j.insidersUrl?"insiders":"stable",x=(W?this.userDataSyncStoreType:void 0)||q,B=(_==null?void 0:_.url)||(x==="insiders"?j.insidersUrl:x==="stable"?j.stableUrl:j.url);return{url:E.URI.parse(B),type:x,defaultType:q,defaultUrl:E.URI.parse(j.url),stableUrl:E.URI.parse(j.stableUrl),insidersUrl:E.URI.parse(j.insidersUrl),canSwitch:W,authenticationProviders:Object.keys(j.authenticationProviders).reduce((M,F)=>(M.push({id:F,scopes:j.authenticationProviders[F].scopes}),M),[])}}}};s=ue([Y(0,g.IProductService),Y(1,L.IConfigurationService),Y(2,w.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let l=class extends s{constructor(P,_,z){super(P,_,z);const j=this.storageService.get(o,0);j&&(this.previousConfigurationSyncStore=JSON.parse(j));const W=this.productService[A.CONFIGURATION_SYNC_STORE_KEY];W?this.storageService.store(o,JSON.stringify(W),0,1):this.storageService.remove(o,0)}async switch(P){P!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=P,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=ue([Y(0,g.IProductService),Y(1,L.IConfigurationService),Y(2,w.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let d=class extends v.Disposable{constructor(P,_,z,j,W,q,x){super();this.requestService=z,this.logService=j,this.storageService=x,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new C.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new C.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(P),this.commonHeadersPromise=(0,S.getServiceMachineId)(W,q,x).then(B=>{const M={"X-Client-Name":`${_.applicationName}${a.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":B};return _.commit&&(M["X-Client-Commit"]=_.commit),M}),this.session=new y(r,c,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,v.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(P,_){this.authToken={token:P,type:_}}updateUserDataSyncStoreUrl(P){this.userDataSyncStoreUrl=P?(0,R.joinPath)(P,"v1"):void 0}initDonotMakeRequestsUntil(){const P=this.storageService.getNumber(i,0);P&&Date.now()<P&&this.setDonotMakeRequestsUntil(new Date(P))}setDonotMakeRequestsUntil(P){var _;((_=this._donotMakeRequestsUntil)===null||_===void 0?void 0:_.getTime())!==(P==null?void 0:P.getTime())&&(this._donotMakeRequestsUntil=P,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,b.createCancelablePromise)(z=>(0,b.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),z).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,z=>null)):this.storageService.remove(i,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P),z={},j=await this.request(_.toString(),{type:"GET",headers:z},[],O.CancellationToken.None);return(await(0,k.asJson)(j)||[]).map(({url:q,created:x})=>({ref:(0,R.relativePath)(_,_.with({path:q})),created:x*1e3}))}async resolveContent(P,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P,_).toString(),j={};j["Cache-Control"]="no-cache";const W=await this.request(z,{type:"GET",headers:j},[],O.CancellationToken.None);return await(0,k.asText)(W)}async delete(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString(),z={};await this.request(_,{type:"DELETE",headers:z},[],O.CancellationToken.None)}async read(P,_,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P,"latest").toString();z=Object.assign({},z),z["Cache-Control"]="no-cache",_&&(z["If-None-Match"]=_.ref);const W=await this.request(j,{type:"GET",headers:z},[304],O.CancellationToken.None);if(W.res.statusCode===304)return _;const q=W.res.headers.etag;if(!q)throw new A.UserDataSyncStoreError("Server did not return the ref",j,A.UserDataSyncErrorCode.NoRef,W.res.headers[A.HEADER_OPERATION_ID]);const x=await(0,k.asText)(W);return{ref:q,content:x}}async write(P,_,z,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString();j=Object.assign({},j),j["Content-Type"]="text/plain",z&&(j["If-Match"]=z);const q=await this.request(W,{type:"POST",data:_,headers:j},[],O.CancellationToken.None),x=q.res.headers.etag;if(!x)throw new A.UserDataSyncStoreError("Server did not return the ref",W,A.UserDataSyncErrorCode.NoRef,q.res.headers[A.HEADER_OPERATION_ID]);return x}async manifest(P={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();P=Object.assign({},P),P["Content-Type"]="application/json";const z=await this.request(_,{type:"GET",headers:P},[],O.CancellationToken.None),j=await(0,k.asJson)(z),W=this.storageService.get(t,0);return W&&j&&W!==j.session&&this.clearSession(),j===null&&W&&this.clearSession(),j&&this.storageService.store(t,j.session,0,1),j}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const P=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":"text/plain"};await this.request(P,{type:"DELETE",headers:_},[],O.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,0),this.storageService.remove(n,0)}async request(P,_,z,j){if(!this.authToken)throw new A.UserDataSyncStoreError("No Auth Token Available",P,A.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,A.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const W=await this.commonHeadersPromise;_.headers=Object.assign(Object.assign(Object.assign({},_.headers||{}),W),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:P,type:_.type,headers:Object.assign(Object.assign({},_.headers),{authorization:void 0})});let q;try{q=await this.session.request(P,_,j)}catch(F){if(!(F instanceof A.UserDataSyncStoreError)){const T=(0,m.isPromiseCanceledError)(F)?A.UserDataSyncErrorCode.RequestCanceled:(0,m.getErrorMessage)(F).startsWith("XHR timeout")?A.UserDataSyncErrorCode.RequestTimeout:A.UserDataSyncErrorCode.RequestFailed;F=new A.UserDataSyncStoreError(`Connection refused for the request '${P}'.`,P,T,void 0)}throw this.logService.info("Request failed",P),F}const x=q.res.headers[A.HEADER_OPERATION_ID],B={url:P,status:q.res.statusCode,"execution-id":_.headers[A.HEADER_EXECUTION_ID],"operation-id":x},M=(0,k.isSuccess)(q)||q.res.statusCode&&z.indexOf(q.res.statusCode)!==-1;if(M?this.logService.trace("Request succeeded",B):this.logService.info("Request failed",B),q.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new A.UserDataSyncStoreError(`Request '${P}' failed because of Unauthorized (401).`,P,A.UserDataSyncErrorCode.Unauthorized,x);if(this._onTokenSucceed.fire(),q.res.statusCode===409)throw new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,P,A.UserDataSyncErrorCode.Conflict,x);if(q.res.statusCode===410)throw new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because the requested resource is not longer available (410).`,P,A.UserDataSyncErrorCode.Gone,x);if(q.res.statusCode===412)throw new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,P,A.UserDataSyncErrorCode.PreconditionFailed,x);if(q.res.statusCode===413)throw new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too large payload (413).`,P,A.UserDataSyncErrorCode.TooLarge,x);if(q.res.statusCode===426)throw new A.UserDataSyncStoreError(`${_.type} request '${P}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,P,A.UserDataSyncErrorCode.UpgradeRequired,x);if(q.res.statusCode===429){const F=q.res.headers["retry-after"];throw F?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(F)*1e3)),new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,A.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,x)):new A.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,A.UserDataSyncErrorCode.TooManyRequests,x)}if(!M)throw new A.UserDataSyncStoreError("Server returned "+q.res.statusCode,P,A.UserDataSyncErrorCode.Unknown,x);return q}addSessionHeaders(P){let _=this.storageService.get(n,0);_===void 0&&(_=(0,D.generateUuid)(),this.storageService.store(n,_,0,1)),P["X-Machine-Session-Id"]=_;const z=this.storageService.get(t,0);z!==void 0&&(P["X-User-Session-Id"]=z)}};d=ue([Y(1,g.IProductService),Y(2,k.IRequestService),Y(3,A.IUserDataSyncLogService),Y(4,I.IEnvironmentService),Y(5,h.IFileService),Y(6,w.IStorageService)],d),e.UserDataSyncStoreClient=d;let f=class extends d{constructor(P,_,z,j,W,q,x){var B;super((B=P.userDataSyncStore)===null||B===void 0?void 0:B.url,_,z,j,W,q,x);this._register(P.onDidChangeUserDataSyncStore(()=>{var M;return this.updateUserDataSyncStoreUrl((M=P.userDataSyncStore)===null||M===void 0?void 0:M.url)}))}};f=ue([Y(0,A.IUserDataSyncStoreManagementService),Y(1,g.IProductService),Y(2,k.IRequestService),Y(3,A.IUserDataSyncLogService),Y(4,I.IEnvironmentService),Y(5,h.IFileService),Y(6,w.IStorageService)],f),e.UserDataSyncStoreService=f;class y{constructor(P,_,z,j){this.limit=P,this.interval=_,this.requestService=z,this.logService=j,this.requests=[],this.startTime=void 0}request(P,_,z){if(this.isExpired()&&this.reset(),_.url=P,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new A.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,P,A.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(P),this.requestService.request(_,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=y}),define(Q[196],Z([0,1,20,3,57,84,59,25,19,60,31]),function(G,e,v,A,k,R,O,L,g,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let h=class extends R.UserDataAutoSyncService{constructor(D,a,C,b,p,E,m,o,i,t,n,r){super(D,a,C,b,p,m,o,i,t,n,r);this._register(A.Event.debounce(A.Event.any(A.Event.map(E.onDidFocusWindow,()=>"windowFocus"),A.Event.map(E.onDidOpenWindow,()=>"windowOpen")),(c,s)=>c?[...c,s]:[s],1e3)(c=>this.triggerSync(c,!0,!1)))}};h=ue([Y(0,I.IProductService),Y(1,v.IUserDataSyncStoreManagementService),Y(2,v.IUserDataSyncStoreService),Y(3,v.IUserDataSyncResourceEnablementService),Y(4,v.IUserDataSyncService),Y(5,k.INativeHostService),Y(6,v.IUserDataSyncLogService),Y(7,O.IUserDataSyncAccountService),Y(8,L.ITelemetryService),Y(9,S.IUserDataSyncMachinesService),Y(10,g.IStorageService),Y(11,v.IUserDataAutoSyncEnablementService)],h),e.UserDataAutoSyncService=h}),define(Q[197],Z([0,1,3,2,6]),function(G,e,v,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends A.Disposable{constructor({onDidOpenWindow:L,onDidFocusWindow:g,getActiveWindowId:S}){super();this.disposables=this._register(new A.DisposableStore),v.Event.latch(v.Event.any(L,g))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>S()),(async()=>{try{const h=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:h}catch(h){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(L){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=L}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Q[61],Z([0,1,107,8,27,6,23,204,205,17]),function(G,e,v,A,k,R,O,L,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(t,n){let r=n.message;switch(t){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=t,this.cause=n}}e.ExtractError=I;function h(i){const t=i.externalFileAttributes>>16||33188;return[448,56,7].map(n=>t&n).reduce((n,r)=>n+r,t&61440)}function w(i){if(i instanceof I)return i;let t;return/end of central directory record signature not found/.test(i.message)&&(t="CorruptZip"),new I(t,i)}function D(i,t,n,r,c,s){const l=A.dirname(t),d=A.join(r,l);if(!d.startsWith(r))return Promise.reject(new Error(v.localize(0,null,t)));const f=A.join(r,t);let y;return s.onCancellationRequested(()=>{y&&y.destroy()}),Promise.resolve(k.promises.mkdir(d,{recursive:!0})).then(()=>new Promise((u,P)=>{if(!s.isCancellationRequested)try{y=(0,k.createWriteStream)(f,{mode:n}),y.once("close",()=>u()),y.once("error",P),i.once("error",P),i.pipe(y)}catch(_){P(_)}}))}function a(i,t,n,r){let c=(0,R.createCancelablePromise)(()=>Promise.resolve()),s=0;return r.onCancellationRequested(()=>{c.cancel(),i.close()}),new Promise((l,d)=>{const f=new R.Sequencer,y=u=>{u.isCancellationRequested||(s++,i.readEntry())};i.once("error",d),i.once("close",()=>c.then(()=>{r.isCancellationRequested||i.entryCount===s?l():d(new I("Incomplete",new Error(v.localize(1,null,s,i.entryCount))))},d)),i.readEntry(),i.on("entry",u=>{if(!r.isCancellationRequested){if(!n.sourcePathRegex.test(u.fileName)){y(r);return}const P=u.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(P)){const j=A.join(t,P);c=(0,R.createCancelablePromise)(W=>k.promises.mkdir(j,{recursive:!0}).then(()=>y(W)).then(void 0,d));return}const _=b(i,u),z=h(u);c=(0,R.createCancelablePromise)(j=>f.queue(()=>_.then(W=>D(W,P,z,t,n,j).then(()=>y(j)))).then(null,d))}})})}function C(i,t=!1){return new Promise((n,r)=>{(0,L.open)(i,t?{lazyEntries:!0}:void 0,(c,s)=>{c?r(w(c)):n((0,S.assertIsDefined)(s))})})}function b(i,t){return new Promise((n,r)=>{i.openReadStream(t,(c,s)=>{c?r(w(c)):n((0,S.assertIsDefined)(s))})})}function p(i,t){return new Promise((n,r)=>{const c=new g.ZipFile;t.forEach(l=>{l.contents?c.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&c.addFile(l.localPath,l.path)}),c.end();const s=(0,k.createWriteStream)(i);c.outputStream.pipe(s),c.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(i))})}e.zip=p;function E(i,t,n={},r){const c=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let s=C(i,!0);return n.overwrite&&(s=s.then(l=>(0,O.rimraf)(t).then(()=>l))),s.then(l=>a(l,t,{sourcePathRegex:c},r))}e.extract=E;function m(i,t){return C(i).then(n=>new Promise((r,c)=>{n.on("entry",s=>{s.fileName===t&&b(n,s).then(l=>r(l),l=>c(l))}),n.once("close",()=>c(new Error(v.localize(2,null,t))))}))}function o(i,t){return m(i,t).then(n=>new Promise((r,c)=>{const s=[];n.once("error",c),n.on("data",l=>s.push(l)),n.on("end",()=>r(Buffer.concat(s)))}))}e.buffer=o}),define(Q[198],Z([0,1,61,112]),function(G,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(R){return(0,v.buffer)(R,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch(L){throw new Error((0,A.localize)(0,null))}})}e.getManifest=k}),define(Q[199],Z([0,1,27,56,2,23,8,14,28,34,6,5,10,129,113,31,61,7,18,16,9,11]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b,p,E,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const t="scanningSystem",n="scanningUser",r="extracting",c="deleting",s="renaming";let l=class extends k.Disposable{constructor(f,y,u,P,_){super();this.beforeRemovingExtension=f,this.fileService=y,this.logService=u,this.environmentService=P,this.productService=_,this._devSystemExtensionsPath=null,this.systemExtensionsPath=P.builtinExtensionsPath,this.extensionsPath=P.extensionsPath,this.uninstalledPath=O.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new I.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(f){const y=[];(f===null||f===0)&&y.push(this.scanSystemExtensions().then(null,u=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(u).message,t)))),(f===null||f===1)&&y.push(this.scanUserExtensions(!0).then(null,u=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(u).message,n))));try{const u=await Promise.all(y);return(0,E.flatten)(u)}catch(u){throw this.joinErrors(u)}}async scanUserExtensions(f){this.logService.trace("Started scanning user extensions");let[y,u]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return u=u.filter(P=>!y[new S.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]),f&&(u=(0,S.groupByExtension)(u,_=>_.identifier).map(_=>_.sort((z,j)=>A.rcompare(z.manifest.version,j.manifest.version))[0])),this.logService.trace("Scanned user extensions:",u.length),u}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(f,y,u){const P=f.key(),_=O.join(this.extensionsPath,`.${P}`),z=O.join(this.extensionsPath,P);try{await R.rimraf(z)}catch(W){try{await R.rimraf(z)}catch(q){}throw new g.ExtensionManagementError((0,a.localize)(0,null,z,f.id),c)}await this.extractAtLocation(f,y,_,u);try{await this.rename(f,_,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(W){this.logService.info("Rename failed. Deleting from extracted location",_);try{R.rimraf(_)}catch(q){}throw W}let j=null;try{j=await this.scanExtension(h.URI.file(O.join(this.extensionsPath,P)),1)}catch(W){}if(j)return j;throw new Error((0,a.localize)(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(f,y){this.setMetadata(f,y),y.isMachineScoped=y.isMachineScoped||void 0,y.isBuiltin=y.isBuiltin||void 0;const u=O.join(f.location.fsPath,"package.json"),P=await v.promises.readFile(u,"utf8"),{manifest:_}=await this.parseManifest(P);return _.__metadata=y,await R.writeFile(u,JSON.stringify(_,null,"	")),f}getUninstalledExtensions(){return this.withUninstalledExtensions(f=>f)}async withUninstalledExtensions(f){return this.uninstalledFileLimiter.queue(async()=>{let y;try{y=await v.promises.readFile(this.uninstalledPath,"utf8")}catch(_){if(_.code!=="ENOENT")throw _}let u={};if(y)try{u=JSON.parse(y)}catch(_){}const P=f(u);return Object.keys(u).length?await R.writeFile(this.uninstalledPath,JSON.stringify(u)):await R.rimraf(this.uninstalledPath),P})}async removeExtension(f,y){this.logService.trace(`Deleting ${y} extension from disk`,f.identifier.id,f.location.fsPath),await R.rimraf(f.location.fsPath),this.logService.info("Deleted from disk",f.identifier.id,f.location.fsPath)}async removeUninstalledExtension(f){await this.removeExtension(f,"uninstalled"),await this.withUninstalledExtensions(y=>delete y[new S.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version).key()])}async extractAtLocation(f,y,u,P){this.logService.trace(`Started extracting the extension from ${y} to ${u}`);try{await R.rimraf(u)}catch(_){throw new g.ExtensionManagementError(this.joinErrors(_).message,c)}try{await(0,b.extract)(y,u,{sourcePath:"extension",overwrite:!0},P),this.logService.info(`Extracted extension to ${u}:`,f.id)}catch(_){try{await R.rimraf(u)}catch(z){}throw new g.ExtensionManagementError(_.message,_ instanceof b.ExtractError&&_.type?_.type:r)}}async rename(f,y,u,P){try{await v.promises.rename(y,u)}catch(_){if(p.isWindows&&_&&_.code==="EPERM"&&Date.now()<P)return this.logService.info(`Failed renaming ${y} to ${u} with 'EPERM' error. Trying again...`,f.id),this.rename(f,y,u,P);throw new g.ExtensionManagementError(_.message||(0,a.localize)(2,null,y,u),_.code||s)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const f=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return f;const y=this.scanDevSystemExtensions(),[u,P]=await Promise.all([f,y]);return[...u,...P]}async scanExtensionsInDir(f,y){const u=new I.Limiter(10),P=await this.fileService.resolve(h.URI.file(f));return P.children?(await Promise.all(P.children.filter(z=>z.isDirectory).map(z=>u.queue(()=>this.scanExtension(z.resource,y))))).filter(z=>z&&z.identifier):[]}async scanExtension(f,y){var u,P;if(y===1&&(0,i.basename)(f).indexOf(".")===0)return null;try{const _=await this.fileService.resolve(f);if(_.children){const{manifest:z,metadata:j}=await this.readManifest(f.fsPath),W=(u=_.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M)))===null||u===void 0?void 0:u.resource,q=(P=_.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M)))===null||P===void 0?void 0:P.resource,x={id:(0,S.getGalleryExtensionId)(z.publisher,z.name)},B={type:y,identifier:x,manifest:z,location:f,readmeUrl:W,changelogUrl:q,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:y===0};return j&&this.setMetadata(B,j),B}}catch(_){y!==0&&this.logService.trace(_)}return null}async scanDefaultSystemExtensions(){const f=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",f.length),f}async scanDevSystemExtensions(){const f=this.getDevSystemExtensionsList();if(f.length){const y=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",y.length),y.filter(u=>f.some(P=>(0,S.areSameExtensions)(u.identifier,{id:P})))}else return[]}setMetadata(f,y){f.publisherDisplayName=y.publisherDisplayName||null,f.publisherId=y.publisherId||null,f.identifier.uuid=y.id,f.isMachineScoped=!!y.isMachineScoped,f.isBuiltin=f.type===0||!!y.isBuiltin}async removeUninstalledExtensions(){const f=await this.getUninstalledExtensions(),y=await this.scanAllUserExtensions(),u=new Set;for(const z of y)f[new S.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]||u.add(z.identifier.id.toLowerCase());const P=(0,S.groupByExtension)(y,z=>z.identifier);await I.Promises.settled(P.map(async z=>{const j=z.sort((W,q)=>A.rcompare(W.manifest.version,q.manifest.version))[0];u.has(j.identifier.id.toLowerCase())||await this.beforeRemovingExtension(j)}));const _=y.filter(z=>f[new S.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]);await I.Promises.settled(_.map(z=>this.removeUninstalledExtension(z)))}async removeOutdatedExtensions(){const f=await this.scanAllUserExtensions(),y=[],u=(0,S.groupByExtension)(f,P=>P.identifier);y.push(...(0,E.flatten)(u.map(P=>P.sort((_,z)=>A.rcompare(_.manifest.version,z.manifest.version)).slice(1)))),await I.Promises.settled(y.map(P=>this.removeExtension(P,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(f=>f.name)}joinErrors(f){const y=Array.isArray(f)?f:[f];return y.length===1?y[0]instanceof Error?y[0]:new Error(y[0]):y.reduce((u,P)=>new Error(`${u.message}${u.message?",":""}${P instanceof Error?P.message:P}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=O.normalize(O.join(m.FileAccess.asFileUri("",G).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(f){const y=[v.promises.readFile(O.join(f,"package.json"),"utf8").then(z=>this.parseManifest(z)),v.promises.readFile(O.join(f,"package.nls.json"),"utf8").then(void 0,z=>z.code!=="ENOENT"?Promise.reject(z):"{}").then(z=>JSON.parse(z))],[{manifest:u,metadata:P},_]=await Promise.all(y);return{manifest:(0,D.localizeManifest)(u,_),metadata:P}}parseManifest(f){return new Promise((y,u)=>{try{const P=JSON.parse(f),_=P.__metadata||null;y({manifest:P,metadata:_})}catch(P){u(new Error((0,a.localize)(3,null)))}})}};l=ue([Y(1,o.IFileService),Y(2,L.ILogService),Y(3,w.INativeEnvironmentService),Y(4,C.IProductService)],l),e.ExtensionsScanner=l}),define(Q[200],Z([0,1,27,111,8,23,2,18,61,28,34,10,6,3,56,5,36,7,14,142,43,25,68,11,30,70,4,16,29,198,150,199,151]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b,p,E,m,o,i,t,n,r,c,s,l,d,f,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const _="unsetUninstalled",z="downloading",j="validating",W="local",q="unknown";let x=class extends O.Disposable{constructor(M,F,T,U,N,$){super();this.environmentService=M,this.galleryService=F,this.logService=T,this.downloadService=U,this.telemetryService=N,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new D.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const H=this._register($.createInstance(P.ExtensionsLifecycle));this.extensionsScanner=this._register($.createInstance(u.ExtensionsScanner,K=>H.postUninstall(K))),this.manifestCache=this._register(new m.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register($.createInstance(y.ExtensionsDownloader)),this._register((0,O.toDisposable)(()=>{this.installingExtensions.forEach(K=>K.cancel()),this.uninstallingExtensions.forEach(K=>K.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const F=await this.collectFiles(M),T=await(0,g.zip)((0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)()).fsPath,F);return C.URI.file(T)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const F=await this.downloadVsix(M),T=k.resolve(F.fsPath);return(0,f.getManifest)(T)}async collectFiles(M){const F=async U=>{let N=await R.readdir(U);N=N.map(K=>k.join(U,K));const $=await Promise.all(N.map(K=>v.promises.stat(K)));let H=Promise.resolve([]);return $.forEach((K,te)=>{const X=N[te];K.isFile()&&(H=H.then(ie=>[...ie,X])),K.isDirectory()&&(H=H.then(ie=>F(X).then(se=>[...ie,...se])))}),H};return(await F(M.location.fsPath)).map(U=>({path:`extension/${k.relative(M.location.fsPath,U)}`,localPath:U}))}async install(M,F={}){return this.logService.trace("ExtensionManagementService#install",M.toString()),(0,w.createCancelablePromise)(async T=>{const U=await this.downloadVsix(M),N=k.resolve(U.fsPath),$=await(0,f.getManifest)(N),H={id:(0,I.getGalleryExtensionId)($.publisher,$.name)};let K=1;if($.engines&&$.engines.vscode&&!(0,t.isEngineValid)($.engines.vscode,b.default.version))throw new Error(A.localize(0,null,H.id,b.default.version));const te=new I.ExtensionIdentifierWithVersion(H,$.version),ie=(await this.getInstalled(1)).find(ce=>(0,I.areSameExtensions)(H,ce.identifier));if(ie)if(F.isMachineScoped=F.isMachineScoped||ie.isMachineScoped,F.isBuiltin=F.isBuiltin||ie.isBuiltin,K=2,te.equals(new I.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version)))try{await this.extensionsScanner.removeExtension(ie,"existing")}catch(ce){throw new Error(A.localize(1,null,$.displayName||$.name))}else a.gt(ie.manifest.version,$.version)&&await this.uninstallExtension(ie);else{const ce=await this.unsetUninstalledAndGetLocal(te);if(ce)try{await this.extensionsScanner.removeExtension(ce,"existing")}catch(he){throw new Error(A.localize(2,null,$.displayName||$.name))}}this.logService.info("Installing the extension:",H.id),this._onInstallExtension.fire({identifier:H,zipPath:N});let se;try{se=await this.getGalleryMetadata((0,I.getGalleryExtensionId)($.publisher,$.name))}catch(ce){}try{const ce=await this.installFromZipPath(te,N,Object.assign(Object.assign({},se||{}),F),F,K,T);return this.logService.info("Successfully installed the extension:",H.id),ce}catch(ce){throw this.logService.error("Failed to install the extension:",H.id,ce.message),ce}})}async downloadVsix(M){if(M.scheme===l.Schemas.file)return M;if(!this.downloadService)throw new Error("Download service is not available");const F=(0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)());return await this.downloadService.download(M,F),F}async installFromZipPath(M,F,T,U,N,$){try{const H=await this.installExtension({zipPath:F,identifierWithVersion:M,metadata:T},$);try{await this.installDependenciesAndPackExtensions(H,void 0,U)}catch(K){(0,L.isNonEmptyArray)(H.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",H.identifier.id,K.message),(0,L.isNonEmptyArray)(H.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",H.identifier.id,K.message)}return this._onDidInstallExtension.fire({identifier:M,zipPath:F,local:H,operation:N}),H}catch(H){throw this._onDidInstallExtension.fire({identifier:M,zipPath:F,operation:N,error:H}),H}}async canInstall(M){return!0}async installFromGallery(M,F={}){if(!this.galleryService.isEnabled())throw new Error(A.localize(3,null));try{M=await this.checkAndGetCompatibleVersion(M)}catch(N){const $=N&&N.code?N.code:q;throw this.logService.error("Failed to install extension:",M.identifier.id,N?N.message:$),this.reportTelemetry(this.getTelemetryEvent(1),(0,I.getGalleryExtensionTelemetryData)(M),void 0,N),N instanceof Error&&(N.name=$),N}const T=new I.ExtensionIdentifierWithVersion(M.identifier,M.version).key();let U=this.installingExtensions.get(T);return U||(U=(0,w.createCancelablePromise)(N=>this.doInstallFromGallery(M,F,N)),this.installingExtensions.set(T,U),U.finally(()=>this.installingExtensions.delete(T))),U}async doInstallFromGallery(M,F,T){const U=new Date().getTime();let N=1;this.logService.info("Installing extension:",M.identifier.id),this._onInstallExtension.fire({identifier:M.identifier,gallery:M});try{const H=(await this.getInstalled(1)).find(X=>(0,I.areSameExtensions)(X.identifier,M.identifier));H&&(N=2);const K=await this.downloadInstallableExtension(M,N);K.metadata.isMachineScoped=F.isMachineScoped||(H==null?void 0:H.isMachineScoped),K.metadata.isBuiltin=F.isBuiltin||(H==null?void 0:H.isBuiltin);const te=await this.installExtension(K,T);try{await this.extensionsDownloader.delete(C.URI.file(K.zipPath))}catch(X){}if(!F.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(te,H,F)}catch(X){try{await this.uninstall(te)}catch(ie){}throw X}return H&&a.neq(H.manifest.version,M.version)&&await this.setUninstalled(H),this.logService.info("Extensions installed successfully:",M.identifier.id),this._onDidInstallExtension.fire({identifier:M.identifier,gallery:M,local:te,operation:N}),this.reportTelemetry(this.getTelemetryEvent(N),(0,I.getGalleryExtensionTelemetryData)(M),new Date().getTime()-U,void 0),te}catch($){const H=$&&$.code?$.code:q;throw this.logService.error("Failed to install extension:",M.identifier.id,$?$.message:H),this._onDidInstallExtension.fire({identifier:M.identifier,gallery:M,operation:N,error:H}),this.reportTelemetry(this.getTelemetryEvent(N),(0,I.getGalleryExtensionTelemetryData)(M),new Date().getTime()-U,$),$ instanceof Error&&($.name=H),$}}async checkAndGetCompatibleVersion(M){if(await this.isMalicious(M))throw new S.ExtensionManagementError(A.localize(4,null),S.INSTALL_ERROR_MALICIOUS);const F=await this.galleryService.getCompatibleExtension(M);if(!F)throw new S.ExtensionManagementError(A.localize(5,null,M.identifier.id,b.default.version),S.INSTALL_ERROR_INCOMPATIBLE);return F}async reinstallFromGallery(M){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.galleryService.isEnabled())throw new Error(A.localize(6,null));const F=await this.findGalleryExtension(M);if(!F)throw new Error(A.localize(7,null));await this.setUninstalled(M);try{await this.extensionsScanner.removeUninstalledExtension(M)}catch(T){throw new Error(A.localize(8,null,(0,o.toErrorMessage)(T)))}await this.installFromGallery(F)}getTelemetryEvent(M){return M===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(M){const F=await this.getExtensionsReport();return(0,I.getMaliciousExtensionsSet)(F).has(M.identifier.id)}async downloadInstallableExtension(M,F){const T={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let U;try{this.logService.trace("Started downloading extension:",M.identifier.id);const N=await this.extensionsDownloader.downloadExtension(M,F);this.logService.info("Downloaded extension:",M.identifier.id,U),U=N.fsPath}catch(N){throw new S.ExtensionManagementError(this.joinErrors(N).message,z)}try{const N=await(0,f.getManifest)(U);return{zipPath:U,identifierWithVersion:new I.ExtensionIdentifierWithVersion(M.identifier,N.version),metadata:T}}catch(N){throw new S.ExtensionManagementError(this.joinErrors(N).message,j)}}async installExtension(M,F){try{const T=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(T)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(T,M.metadata):T}catch(T){throw p.isMacintosh?new S.ExtensionManagementError(A.localize(9,null),_):new S.ExtensionManagementError(A.localize(10,null),_)}return this.extractAndInstall(M,F)}async unsetUninstalledAndGetLocal(M){return await this.isUninstalled(M)?(this.logService.trace("Removing the extension from uninstalled list:",M.id),await this.unsetUninstalled(M),this.logService.info("Removed the extension from uninstalled list:",M.id),(await this.getInstalled(1)).find(U=>new I.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version).equals(M))||null):null}async extractAndInstall({zipPath:M,identifierWithVersion:F,metadata:T},U){let N=await this.extensionsScanner.extractUserExtension(F,M,U);return this.logService.info("Installation completed.",F.id),T&&(N=await this.extensionsScanner.saveMetadataForLocalExtension(N,T)),N}async installDependenciesAndPackExtensions(M,F,T){if(!!this.galleryService.isEnabled()){const U=M.manifest.extensionDependencies||[];if(M.manifest.extensionPack)for(const N of M.manifest.extensionPack)F&&F.manifest.extensionPack&&F.manifest.extensionPack.some($=>(0,I.areSameExtensions)({id:$},{id:N}))||U.every($=>!(0,I.areSameExtensions)({id:$},{id:N}))&&U.push(N);if(U.length){const N=await this.getInstalled(),$=U.filter(H=>N.every(({identifier:K})=>!(0,I.areSameExtensions)(K,{id:H})));if($.length){const K=(await this.galleryService.query({names:$,pageSize:U.length},d.CancellationToken.None)).firstPage;try{await w.Promises.settled(K.map(te=>this.installFromGallery(te,T)))}catch(te){try{await this.rollback(K)}catch(X){}throw te}}}}}async rollback(M){const T=(await this.getInstalled(1)).filter(U=>M.some(N=>new I.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version).equals(new I.ExtensionIdentifierWithVersion(N.identifier,N.version))));await w.Promises.settled(T.map(U=>this.uninstall(U)))}async uninstall(M,F={}){this.logService.trace("ExtensionManagementService#uninstall",M.identifier.id);const T=await this.getInstalled(1),U=T.find(N=>(0,I.areSameExtensions)(N.identifier,M.identifier));if(!U)throw new Error(A.localize(11,null,M.manifest.displayName||M.manifest.name));try{await this.checkForDependenciesAndUninstall(U,T,F)}catch(N){throw this.joinErrors(N)}}async updateMetadata(M,F){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,Object.assign(Object.assign({},M.manifest.__metadata||{}),F)),this.manifestCache.invalidate(),M}async updateExtensionScope(M,F){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,Object.assign(Object.assign({},M.manifest.__metadata||{}),{isMachineScoped:F})),this.manifestCache.invalidate(),M}async getGalleryMetadata(M){const F=await this.findGalleryExtensionByName(M);return F?{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId}:void 0}async findGalleryExtension(M){if(M.identifier.uuid){const F=await this.findGalleryExtensionById(M.identifier.uuid);return F||this.findGalleryExtensionByName(M.identifier.id)}return this.findGalleryExtensionByName(M.identifier.id)}async findGalleryExtensionById(M){return(await this.galleryService.query({ids:[M],pageSize:1},d.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(M){return(await this.galleryService.query({names:[M],pageSize:1},d.CancellationToken.None)).firstPage[0]}joinErrors(M){const F=Array.isArray(M)?M:[M];return F.length===1?F[0]instanceof Error?F[0]:new Error(F[0]):F.reduce((T,U)=>new Error(`${T.message}${T.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}async checkForDependenciesAndUninstall(M,F,T){try{await this.preUninstallExtension(M);const U=T.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(M,F);await this.uninstallExtensions(M,U,F,T)}catch(U){throw await this.postUninstallExtension(M,new S.ExtensionManagementError(U instanceof Error?U.message:U,W)),U}await this.postUninstallExtension(M)}async uninstallExtensions(M,F,T,U){const N=[M,...F];if(!U.donotCheckDependents)for(const $ of N)this.checkForDependents($,N,T,M);await w.Promises.settled([this.uninstallExtension(M),...F.map($=>this.doUninstall($))])}checkForDependents(M,F,T,U){const N=this.getDependents(M,T);if(N.length){const $=N.filter(H=>F.indexOf(H)===-1);if($.length)throw new Error(this.getDependentsErrorMessage(M,$,U))}}getDependentsErrorMessage(M,F,T){return T===M?F.length===1?A.localize(12,null,T.manifest.displayName||T.manifest.name,F[0].manifest.displayName||F[0].manifest.name):F.length===2?A.localize(13,null,T.manifest.displayName||T.manifest.name,F[0].manifest.displayName||F[0].manifest.name,F[1].manifest.displayName||F[1].manifest.name):A.localize(14,null,T.manifest.displayName||T.manifest.name,F[0].manifest.displayName||F[0].manifest.name,F[1].manifest.displayName||F[1].manifest.name):F.length===1?A.localize(15,null,T.manifest.displayName||T.manifest.name,M.manifest.displayName||M.manifest.name,F[0].manifest.displayName||F[0].manifest.name):F.length===2?A.localize(16,null,T.manifest.displayName||T.manifest.name,M.manifest.displayName||M.manifest.name,F[0].manifest.displayName||F[0].manifest.name,F[1].manifest.displayName||F[1].manifest.name):A.localize(17,null,T.manifest.displayName||T.manifest.name,M.manifest.displayName||M.manifest.name,F[0].manifest.displayName||F[0].manifest.name,F[1].manifest.displayName||F[1].manifest.name)}getAllPackExtensionsToUninstall(M,F,T=[]){if(T.indexOf(M)!==-1)return[];T.push(M);const U=M.manifest.extensionPack?M.manifest.extensionPack:[];if(U.length){const N=F.filter(H=>!H.isBuiltin&&U.some(K=>(0,I.areSameExtensions)({id:K},H.identifier))),$=[];for(const H of N)$.push(...this.getAllPackExtensionsToUninstall(H,F,T));return[...N,...$]}return[]}getDependents(M,F){return F.filter(T=>T.manifest.extensionDependencies&&T.manifest.extensionDependencies.some(U=>(0,I.areSameExtensions)({id:U},M.identifier)))}async doUninstall(M){try{await this.preUninstallExtension(M),await this.uninstallExtension(M)}catch(F){throw await this.postUninstallExtension(M,new S.ExtensionManagementError(F instanceof Error?F.message:F,W)),F}await this.postUninstallExtension(M)}async preUninstallExtension(M){if(!await R.exists(M.location.fsPath))throw new Error(A.localize(18,null));this.logService.info("Uninstalling extension:",M.identifier.id),this._onUninstallExtension.fire(M.identifier)}async uninstallExtension(M){let F=this.uninstallingExtensions.get(M.identifier.id);return F||(F=(0,w.createCancelablePromise)(async()=>{const T=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...T.filter(U=>(0,I.areSameExtensions)(U.identifier,M.identifier)))}),this.uninstallingExtensions.set(M.identifier.id,F),F.finally(()=>this.uninstallingExtensions.delete(M.identifier.id))),F}async postUninstallExtension(M,F){if(F)this.logService.error("Failed to uninstall extension:",M.identifier.id,F.message);else if(this.logService.info("Successfully uninstalled extension:",M.identifier.id),M.identifier.uuid)try{await this.galleryService.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"uninstall")}catch(U){}this.reportTelemetry("extensionGallery:uninstall",(0,I.getLocalExtensionTelemetryData)(M),void 0,F);const T=F?F instanceof S.ExtensionManagementError?F.code:q:void 0;this._onDidUninstallExtension.fire({identifier:M.identifier,error:T})}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(M){return(await this.filterUninstalled(M)).length===1}filterUninstalled(...M){return this.extensionsScanner.withUninstalledExtensions(F=>{const T=[];for(const U of M)F[U.key()]&&T.push(U.key());return T})}setUninstalled(...M){const F=M.map(T=>new I.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version));return this.extensionsScanner.withUninstalledExtensions(T=>(F.forEach(U=>T[U.key()]=!0),T))}unsetUninstalled(M){return this.extensionsScanner.withUninstalledExtensions(F=>delete F[M.key()])}getExtensionsReport(){const M=new Date().getTime();return(!this.reportedExtensions||M-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=M),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const M=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${M.length} reported extensions from service`),M}catch(M){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(M,F,T,U){const N=U?U instanceof S.ExtensionManagementError?U.code:q:void 0;this.telemetryService.publicLogError(M,Object.assign(Object.assign({},F),{success:!U,duration:T,errorcode:N}))}};x=ue([Y(0,h.INativeEnvironmentService),Y(1,S.IExtensionGalleryService),Y(2,E.ILogService),Y(3,(0,s.optional)(c.IDownloadService)),Y(4,i.ITelemetryService),Y(5,s.IInstantiationService)],x),e.ExtensionManagementService=x}),define(Q[206],Z([0,1,27,38,207,100,36,99,33,75,50,146,10,161,128,28,200,172,24,163,40,164,25,58,170,79,80,175,14,76,155,55,2,165,70,160,159,140,139,148,147,77,171,69,152,9,154,16,31,20,193,195,190,57,158,191,196,169,19,167,192,59,189,173,60,71,130,197,174,84,83,82,4,149,141,15,43,8,81,178,177,194,137,143,176]),function(G,e,v,A,k,R,O,L,g,S,I,h,w,D,a,C,b,p,E,m,o,i,t,n,r,c,s,l,d,f,y,u,P,_,z,j,W,q,x,B,M,F,T,U,N,$,H,K,te,X,ie,se,ce,he,me,we,Ie,Te,ke,Fe,Ue,Me,De,Ae,$e,He,Ne,ze,J,ne,re,ge,V,ee,oe,ae,le,de,ve,ye,Ee,be,Pe,Se,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ce extends P.Disposable{constructor(fe){super();this.configuration=fe,this.server=this._register(new L.Server),(0,k.gracefulify)(v),this.registerListeners()}registerListeners(){const fe=()=>this.dispose();process.once("exit",fe),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",fe)}async open(){const fe=await this.initServices();(0,X.registerConfiguration)(),fe.invokeFunction(Le=>{const _e=Le.get(d.ILogService);_e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Le),this.registerErrorHandler(_e)}),this._register((0,P.combinedDisposable)(new j.NodeCachedDataCleaner(this.configuration.nodeCachedDataDir),fe.createInstance(W.LanguagePackCachedDataCleaner),fe.createInstance(q.StorageDataCleaner,this.configuration.backupWorkspacesPath),fe.createInstance(x.LogsDataCleaner),fe.createInstance(ee.LocalizationsUpdater),fe.createInstance(oe.DeprecatedExtensionsCleaner)))}async initServices(){const fe=new S.ServiceCollection,Le=new D.NativeEnvironmentService(this.configuration.args);fe.set(w.INativeEnvironmentService,Le);const _e=new g.StaticRouter(je=>je==="main"),Ze=new f.LogLevelChannelClient(this.server.getChannel("logLevel",_e)),et=this._register(new d.MultiplexLogService([this._register(new d.ConsoleLogger(this.configuration.logLevel)),this._register(new F.SpdLogLogger("sharedprocess",(0,de.join)(Le.logsPath,"sharedprocess.log"),!0,this.configuration.logLevel))])),qe=this._register(new f.FollowerLogService(Ze,et));fe.set(d.ILogService,qe);const Ge=new M.MessagePortMainProcessService(this.server,_e);fe.set(B.IMainProcessService,Ge);const Be=this._register(new N.FileService(qe));fe.set($.IFileService,Be);const tt=this._register(new H.DiskFileSystemProvider(qe));Be.registerProvider(K.Schemas.file,tt);const We=this._register(new m.ConfigurationService(Le.settingsResource,Be));fe.set(E.IConfigurationService,We),await We.initialize();const Ke=new Te.NativeStorageService(void 0,Ge,Le);fe.set(ke.IStorageService,Ke),await Ke.initialize(),this._register((0,P.toDisposable)(()=>Ke.flush())),fe.set(te.IProductService,Object.assign({_serviceBrand:void 0},O.default)),fe.set(o.IRequestService,new I.SyncDescriptor(i.RequestService)),fe.set(Pe.IChecksumService,new I.SyncDescriptor(Se.ChecksumService));const Je=g.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});fe.set(he.INativeHostService,Je),fe.set(z.IDownloadService,new I.SyncDescriptor(_.DownloadService));const it=this._register(new ze.ActiveWindowManager(Je)),nt=new g.StaticRouter(je=>it.getActiveClientId().then(ft=>je===ft));fe.set(He.IExtensionRecommendationNotificationService,new Ne.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",nt)));const Xe=this._register(new me.LoggerService(qe,Be));fe.set(d.ILoggerService,Xe);const{appRoot:at,extensionsPath:ct,extensionDevelopmentLocationURI:lt,isBuilt:ut,installSourcePath:ht}=Le;let Qe,Ve;if(!lt&&!Le.disableTelemetry&&O.default.enableTelemetry){if(Ve=new J.TelemetryLogAppender(Xe,Le),O.default.aiConfig&&O.default.aiConfig.asimovKey&&ut){const je=new l.AppInsightsAppender("monacoworkbench",null,O.default.aiConfig.asimovKey);this._register((0,P.toDisposable)(()=>je.flush())),Ve=(0,n.combinedAppender)(je,Ve)}Qe=new s.TelemetryService({appender:Ve,commonProperties:(0,r.resolveCommonProperties)(Be,(0,A.release)(),process.arch,O.default.commit,O.default.version,this.configuration.machineId,O.default.msftInternalDomains,ht),sendErrorTelemetry:!0,piiPaths:[at,ct]},We)}else Qe=n.NullTelemetryService,Ve=n.NullAppender;this.server.registerChannel("telemetryAppender",new c.TelemetryAppenderChannel(Ve)),fe.set(t.ITelemetryService,Qe);const dt=new pe.CustomEndpointTelemetryService(We,Qe);return fe.set(t.ICustomEndpointTelemetryService,dt),fe.set(C.IExtensionManagementService,new I.SyncDescriptor(b.ExtensionManagementService)),fe.set(C.IExtensionGalleryService,new I.SyncDescriptor(p.ExtensionGalleryService)),fe.set(C.IExtensionTipsService,new I.SyncDescriptor(Ae.ExtensionTipsService)),fe.set(u.ILocalizationsService,new I.SyncDescriptor(y.LocalizationsService)),fe.set(U.IDiagnosticsService,new I.SyncDescriptor(T.DiagnosticsService)),fe.set(Me.IUserDataSyncAccountService,new I.SyncDescriptor(Me.UserDataSyncAccountService)),fe.set(X.IUserDataSyncLogService,new I.SyncDescriptor(we.UserDataSyncLogService)),fe.set(X.IUserDataSyncUtilService,new ce.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",je=>je.ctx!=="main"))),fe.set(C.IGlobalExtensionEnablementService,new I.SyncDescriptor(Fe.GlobalExtensionEnablementService)),fe.set(re.IIgnoredExtensionsManagementService,new I.SyncDescriptor(re.IgnoredExtensionsManagementService)),fe.set(ge.IExtensionsStorageSyncService,new I.SyncDescriptor(ge.ExtensionsStorageSyncService)),fe.set(X.IUserDataSyncStoreManagementService,new I.SyncDescriptor(se.UserDataSyncStoreManagementService)),fe.set(X.IUserDataSyncStoreService,new I.SyncDescriptor(se.UserDataSyncStoreService)),fe.set($e.IUserDataSyncMachinesService,new I.SyncDescriptor($e.UserDataSyncMachinesService)),fe.set(X.IUserDataSyncBackupStoreService,new I.SyncDescriptor(De.UserDataSyncBackupStoreService)),fe.set(X.IUserDataAutoSyncEnablementService,new I.SyncDescriptor(ne.UserDataAutoSyncEnablementService)),fe.set(X.IUserDataSyncResourceEnablementService,new I.SyncDescriptor(Ue.UserDataSyncResourceEnablementService)),fe.set(X.IUserDataSyncService,new I.SyncDescriptor(ie.UserDataSyncService)),fe.set(Ee.ILocalPtyService,this._register(new ye.PtyHostService(qe))),new h.InstantiationService(fe)}initChannels(fe){const Le=new a.ExtensionManagementChannel(fe.get(C.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Le);const _e=g.ProxyChannel.fromService(fe.get(u.ILocalizationsService));this.server.registerChannel("localizations",_e);const Ze=g.ProxyChannel.fromService(fe.get(U.IDiagnosticsService));this.server.registerChannel("diagnostics",Ze);const et=new a.ExtensionTipsChannel(fe.get(C.IExtensionTipsService));this.server.registerChannel("extensionTipsService",et);const qe=g.ProxyChannel.fromService(fe.get(Pe.IChecksumService));this.server.registerChannel("checksum",qe);const Ge=new ce.UserDataSyncMachinesServiceChannel(fe.get($e.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ge);const Be=g.ProxyChannel.fromService(fe.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Be);const tt=new ce.UserDataSyncAccountServiceChannel(fe.get(Me.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",tt);const We=new ce.UserDataSyncStoreManagementServiceChannel(fe.get(X.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",We);const Ke=new be.UserDataSyncChannel(fe.get(X.IUserDataSyncService),fe.get(d.ILogService));this.server.registerChannel("userDataSync",Ke);const Je=this._register(fe.get(V.IInstantiationService).createInstance(Ie.UserDataAutoSyncService)),it=new ce.UserDataAutoSyncChannel(Je);this.server.registerChannel("userDataAutoSync",it);const nt=fe.get(Ee.ILocalPtyService),Xe=g.ProxyChannel.fromService(nt);this.server.registerChannel(ve.TerminalIpcChannels.LocalPty,Xe)}registerErrorHandler(fe){window.addEventListener("unhandledrejection",Le=>{(0,ae.onUnexpectedError)(Le.reason),Le.preventDefault()}),(0,ae.setUnexpectedErrorHandler)(Le=>{const _e=(0,le.toErrorMessage)(Le,!0);!_e||fe.error(`[uncaught exception in sharedProcess]: ${_e}`)})}}async function Re(Oe){const fe=new Ce(Oe);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await fe.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Re})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/06b54543d660353a04cdab6554d1f27266a537fd/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
