/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/network","vs/base/common/async","electron","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/resources","vs/platform/files/common/files","vs/platform/product/common/product","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","vs/base/common/strings","vs/base/common/buffer","fs","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","os","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/parts/ipc/common/ipc","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/node/state","vs/base/common/labels","vs/platform/request/common/request","vs/platform/update/common/update","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","child_process","vs/platform/configuration/common/configurationRegistry","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/process","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/remote/common/tunnel","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","vs/base/common/stream","crypto","net","vs/platform/environment/node/argv","vs/platform/product/common/productService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/theme/electron-main/themeMainService","vs/platform/webview/common/resourceLoader","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/common/glob","vs/base/node/decoder","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/userDataPath","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/code/electron-main/protocol","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/mimeTypes","vs/platform/webview/common/webviewManagerService","vs/platform/webview/common/webviewPortMapping","vs/platform/webview/electron-main/webviewPortMappingProvider","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","path","minimist","assert","util","stream","vs/code/electron-main/main"],x=function(H){for(var e=[],p=0,R=H.length;p<R;p++)e[p]=Z[H[p]];return e};define(Z[99],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(R,L){if(!R)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=p}),define(Z[50],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function p(S){return(i,M,f)=>{let E=null,g=null;if(typeof f.value=="function"?(E="value",g=f.value):typeof f.get=="function"&&(E="get",g=f.get),!g)throw new Error("not supported");f[E]=S(g,M)}}e.createDecorator=p;let R=0;function L(){const S=`$memoize${R++}`;let i;const M=function(E,g,d){let w=null,y=null;if(typeof d.value=="function"?(w="value",y=d.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(w="get",y=d.get),!y)throw new Error("not supported");const v=`${S}:${g}`;d[w]=function(...o){return i=this,this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!0,enumerable:!1,writable:!0,value:y.apply(this,o)}),this[v]}};return M.clear=()=>{typeof i!="undefined"&&Object.getOwnPropertyNames(i).forEach(f=>{f.indexOf(S)===0&&delete i[f]})},M}e.createMemoizer=L;function b(S,i,M){return L()(S,i,M)}e.memoize=b;function P(S,i,M){return p((f,E)=>{const g=`$debounce$${E}`,d=`$debounce$result$${E}`;return function(...w){this[d]||(this[d]=M?M():void 0),clearTimeout(this[g]),i&&(this[d]=i(this[d],...w),w=[this[d]]),this[g]=setTimeout(()=>{f.apply(this,w),this[d]=M?M():void 0},S)}})}e.debounce=P;function n(S,i,M){return p((f,E)=>{const g=`$throttle$timer$${E}`,d=`$throttle$result$${E}`,w=`$throttle$lastRun$${E}`,y=`$throttle$pending$${E}`;return function(...v){if(this[d]||(this[d]=M?M():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),i&&(this[d]=i(this[d],...v)),!this[y]){const o=this[w]+S;o<=Date.now()?(this[w]=Date.now(),f.apply(this,[this[d]]),this[d]=M?M():void 0):(this[y]=!0,this[g]=setTimeout(()=>{this[y]=!1,this[w]=Date.now(),f.apply(this,[this[d]]),this[d]=M?M():void 0},o-Date.now()))}}})}e.throttle=n}),define(Z[19],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function R(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=R;function L(s){S(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=L;function b(s){S(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=b;function P(s){if(s instanceof Error){let{name:t,message:r}=s;const a=s.stacktrace||s.stack;return{$isError:!0,name:t,message:r,stack:a}}return s}e.transformErrorForSerialization=P;const n="Canceled";function S(s){return s instanceof Error&&s.name===n&&s.message===n}e.isPromiseCanceledError=S;class i extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=i;function M(){const s=new Error(n);return s.name=s.message,s}e.canceled=M;function f(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=f;function E(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=E;function g(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function d(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function w(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=w;class y extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=y;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class o extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=o;function c(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function l(s,t=Object.create(null)){const r=new Error(s);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=l}),define(Z[34],x([0,1,19]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(U,W=0){return U[U.length-(1+W)]}e.tail=R;function L(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=L;function b(U,W,O=(D,k)=>D===k){if(U===W)return!0;if(!U||!W||U.length!==W.length)return!1;for(let D=0,k=U.length;D<k;D++)if(!O(U[D],W[D]))return!1;return!0}e.equals=b;function P(U,W,O){let D=0,k=U.length-1;for(;D<=k;){const F=(D+k)/2|0,_=O(U[F],W);if(_<0)D=F+1;else if(_>0)k=F-1;else return F}return-(D+1)}e.binarySearch=P;function n(U,W){let O=0,D=U.length;if(D===0)return 0;for(;O<D;){const k=Math.floor((O+D)/2);W(U[k])?D=k:O=k+1}return O}e.findFirstInSorted=n;function S(U,W,O){if(U=U|0,U>=W.length)throw new TypeError("invalid index");let D=W[Math.floor(W.length*Math.random())],k=[],F=[],_=[];for(let C of W){const j=O(C,D);j<0?k.push(C):j>0?F.push(C):_.push(C)}return U<k.length?S(U,k,O):U<k.length+_.length?_[0]:S(U-(k.length+_.length),F,O)}e.quickSelect=S;function i(U,W){const O=[];let D;for(const k of U.slice(0).sort(W))!D||W(D[0],k)!==0?(D=[k],O.push(D)):D.push(k);return O}e.groupBy=i;function M(U,W,O){const D=[];function k(C,j,G){if(!(j===0&&G.length===0)){const K=D[D.length-1];K&&K.start+K.deleteCount===C?(K.deleteCount+=j,K.toInsert.push(...G)):D.push({start:C,deleteCount:j,toInsert:G})}}let F=0,_=0;for(;;){if(F===U.length){k(F,0,W.slice(_));break}if(_===W.length){k(F,U.length-F,[]);break}const C=U[F],j=W[_],G=O(C,j);G===0?(F+=1,_+=1):G<0?(k(F,1,[]),F+=1):G>0&&(k(F,0,[j]),_+=1)}return D}e.sortedDiff=M;function f(U,W,O){const D=M(U,W,O),k=[],F=[];for(const _ of D)k.push(...U.slice(_.start,_.start+_.deleteCount)),F.push(..._.toInsert);return{removed:k,added:F}}e.delta=f;function E(U,W,O){if(O===0)return[];const D=U.slice(0,O).sort(W);return d(U,W,D,O,U.length),D}e.top=E;function g(U,W,O,D,k){return O===0?Promise.resolve([]):new Promise((F,_)=>{(async()=>{const C=U.length,j=U.slice(0,O).sort(W);for(let G=O,K=Math.min(O+D,C);G<C;G=K,K=Math.min(K+D,C)){if(G>O&&await new Promise(V=>setTimeout(V)),k&&k.isCancellationRequested)throw(0,p.canceled)();d(U,W,j,G,K)}return j})().then(F,_)})}e.topAsync=g;function d(U,W,O,D,k){for(const F=O.length;D<k;D++){const _=U[D];if(W(_,O[F-1])<0){O.pop();const C=n(O,j=>W(_,j)<0);O.splice(C,0,_)}}}function w(U){return U.filter(W=>!!W)}e.coalesce=w;function y(U){let W=0;for(let O=0;O<U.length;O++)U[O]&&(U[W]=U[O],W+=1);U.length=W}e.coalesceInPlace=y;function v(U,W,O){U.splice(O,0,U.splice(W,1)[0])}e.move=v;function o(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=o;function c(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=c;function l(U,W){if(!W)return U.filter((D,k)=>U.indexOf(D)===k);const O=Object.create(null);return U.filter(D=>{const k=W(D);return O[k]?!1:(O[k]=!0,!0)})}e.distinct=l;function s(U){const W=new Set;return U.filter(O=>W.has(O)?!1:(W.add(O),!0))}e.distinctES6=s;function t(U){const W=Object.create(null);return O=>{const D=U(O);return W[D]?!1:(W[D]=!0,!0)}}e.uniqueFilter=t;function r(U,W){for(let O=U.length-1;O>=0;O--){const D=U[O];if(W(D))return O}return-1}e.lastIndex=r;function a(U,W){return U.length>0?U[0]:W}e.firstOrDefault=a;function h(U,W,O=(D,k)=>D===k){let D=0;for(let k=0,F=Math.min(U.length,W.length);k<F&&O(U[k],W[k]);k++)D++;return D}e.commonPrefixLength=h;function u(U){return[].concat(...U)}e.flatten=u;function m(U,W){let O=typeof W=="number"?U:0;typeof W=="number"?O=U:(O=0,W=U);const D=[];if(O<=W)for(let k=O;k<W;k++)D.push(k);else for(let k=O;k>W;k--)D.push(k);return D}e.range=m;function I(U,W,O){return U.reduce((D,k)=>(D[W(k)]=O?O(k):k,D),Object.create(null))}e.index=I;function A(U,W){return U.push(W),()=>T(U,W)}e.insert=A;function T(U,W){const O=U.indexOf(W);if(O>-1)return U.splice(O,1),W}e.remove=T;function N(U,W,O){const D=U.slice(0,W),k=U.slice(W);return D.concat(O,k)}e.arrayInsert=N;function $(U,W){let O;if(typeof W=="number"){let D=W;O=()=>{const k=Math.sin(D++)*179426549;return k-Math.floor(k)}}else O=Math.random;for(let D=U.length-1;D>0;D-=1){const k=Math.floor(O()*(D+1)),F=U[D];U[D]=U[k],U[k]=F}}e.shuffle=$;function X(U,W){const O=U.indexOf(W);O>-1&&(U.splice(O,1),U.unshift(W))}e.pushToStart=X;function ne(U,W){const O=U.indexOf(W);O>-1&&(U.splice(O,1),U.push(W))}e.pushToEnd=ne;function Y(U,W){return Array.isArray(U)?U.map(W):W(U)}e.mapArrayOrNot=Y;function Q(U){return Array.isArray(U)?U:[U]}e.asArray=Q;function B(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=B;function z(U,W){for(const O of U){const D=W(O);if(D!==void 0)return D}}e.mapFind=z}),define(Z[42],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(R){const L=this;let b=!1,P;return function(){return b||(b=!0,P=R.apply(L,arguments)),P}}e.once=p}),define(Z[64],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(R){function L(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}R.is=L;const b=Object.freeze([]);function P(){return b}R.empty=P;function*n(s){yield s}R.single=n;function S(s){return s||b}R.from=S;function i(s){return!s||s[Symbol.iterator]().next().done===!0}R.isEmpty=i;function M(s){return s[Symbol.iterator]().next().value}R.first=M;function f(s,t){for(const r of s)if(t(r))return!0;return!1}R.some=f;function E(s,t){for(const r of s)if(t(r))return r}R.find=E;function*g(s,t){for(const r of s)t(r)&&(yield r)}R.filter=g;function*d(s,t){for(const r of s)yield t(r)}R.map=d;function*w(...s){for(const t of s)for(const r of t)yield r}R.concat=w;function*y(s){for(const t of s)for(const r of t)yield r}R.concatNested=y;function v(s,t,r){let a=r;for(const h of s)a=t(a,h);return a}R.reduce=v;function*o(s,t,r=s.length){for(t<0&&(t+=s.length),r<0?r+=s.length:r>s.length&&(r=s.length);t<r;t++)yield s[t]}R.slice=o;function c(s,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,s];const a=s[Symbol.iterator]();for(let h=0;h<t;h++){const u=a.next();if(u.done)return[r,R.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return a}}]}R.consume=c;function l(s,t,r=(a,h)=>a===h){const a=s[Symbol.iterator](),h=t[Symbol.iterator]();for(;;){const u=a.next(),m=h.next();if(u.done!==m.done)return!1;if(u.done)return!0;if(!r(u.value,m.value))return!1}}R.equals=l})(p=e.Iterable||(e.Iterable={}))}),define(Z[43],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var b;(function(t){t.DEFAULT={allowTrailingComma:!0}})(b=e.ParseOptions||(e.ParseOptions={}));function P(t,r=!1){let a=0,h=t.length,u="",m=0,I=16,A=0;function T(B){let z=0,U=0;for(;z<B;){const W=t.charCodeAt(a);if(W>=48&&W<=57)U=U*16+W-48;else if(W>=65&&W<=70)U=U*16+W-65+10;else if(W>=97&&W<=102)U=U*16+W-97+10;else break;a++,z++}return z<B&&(U=-1),U}function N(B){a=B,u="",m=0,I=16,A=0}function $(){const B=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&i(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&i(t.charCodeAt(a)))for(a++;a<t.length&&i(t.charCodeAt(a));)a++;else return A=3,t.substring(B,a);let z=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&i(t.charCodeAt(a))){for(a++;a<t.length&&i(t.charCodeAt(a));)a++;z=a}else A=3;return t.substring(B,z)}function X(){let B="",z=a;for(;;){if(a>=h){B+=t.substring(z,a),A=2;break}const U=t.charCodeAt(a);if(U===34){B+=t.substring(z,a),a++;break}if(U===92){if(B+=t.substring(z,a),a++,a>=h){A=2;break}switch(t.charCodeAt(a++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const O=T(4);O>=0?B+=String.fromCharCode(O):A=4;break;default:A=5}z=a;continue}if(U>=0&&U<=31)if(S(U)){B+=t.substring(z,a),A=2;break}else A=6;a++}return B}function ne(){if(u="",A=0,m=a,a>=h)return m=h,I=17;let B=t.charCodeAt(a);if(n(B)){do a++,u+=String.fromCharCode(B),B=t.charCodeAt(a);while(n(B));return I=15}if(S(B))return a++,u+=String.fromCharCode(B),B===13&&t.charCodeAt(a)===10&&(a++,u+=`
`),I=14;switch(B){case 123:return a++,I=1;case 125:return a++,I=2;case 91:return a++,I=3;case 93:return a++,I=4;case 58:return a++,I=6;case 44:return a++,I=5;case 34:return a++,u=X(),I=10;case 47:const z=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<h&&!S(t.charCodeAt(a));)a++;return u=t.substring(z,a),I=12}if(t.charCodeAt(a+1)===42){a+=2;const U=h-1;let W=!1;for(;a<U;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,W=!0;break}a++}return W||(a++,A=1),u=t.substring(z,a),I=13}return u+=String.fromCharCode(B),a++,I=16;case 45:if(u+=String.fromCharCode(B),a++,a===h||!i(t.charCodeAt(a)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=$(),I=11;default:for(;a<h&&Y(B);)a++,B=t.charCodeAt(a);if(m!==a){switch(u=t.substring(m,a),u){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return u+=String.fromCharCode(B),a++,I=16}}function Y(B){if(n(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let B;do B=ne();while(B>=12&&B<=15);return B}return{setPosition:N,getPosition:()=>a,scan:r?Q:ne,getToken:()=>I,getTokenValue:()=>u,getTokenOffset:()=>m,getTokenLength:()=>a-m,getTokenError:()=>A}}e.createScanner=P;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function i(t){return t>=48&&t<=57}var M;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(M||(M={}));function f(t,r){const a=[],h=new Object;let u;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function A(T,N,$,X){m.value=T,m.offset=N,m.length=$,m.type=X,m.colonOffset=void 0,u=m}try{c(t,{onObjectBegin:(T,N)=>{if(r<=T)throw h;u=void 0,I=r>T,a.push("")},onObjectProperty:(T,N,$)=>{if(r<N||(A(T,N,$,"property"),a[a.length-1]=T,r<=N+$))throw h},onObjectEnd:(T,N)=>{if(r<=T)throw h;u=void 0,a.pop()},onArrayBegin:(T,N)=>{if(r<=T)throw h;u=void 0,a.push(0)},onArrayEnd:(T,N)=>{if(r<=T)throw h;u=void 0,a.pop()},onLiteralValue:(T,N,$)=>{if(r<N||(A(T,N,$,s(T)),r<=N+$))throw h},onSeparator:(T,N,$)=>{if(r<=N)throw h;if(T===":"&&u&&u.type==="property")u.colonOffset=N,I=!1,u=void 0;else if(T===","){const X=a[a.length-1];typeof X=="number"?a[a.length-1]=X+1:(I=!0,a[a.length-1]=""),u=void 0}}})}catch(T){if(T!==h)throw T}return{path:a,previousNode:u,isAtPropertyKey:I,matches:T=>{let N=0;for(let $=0;N<T.length&&$<a.length;$++)if(T[N]===a[$]||T[N]==="*")N++;else if(T[N]!=="**")return!1;return N===T.length}}}e.getLocation=f;function E(t,r=[],a=b.DEFAULT){let h=null,u=[];const m=[];function I(T){Array.isArray(u)?u.push(T):h!==null&&(u[h]=T)}return c(t,{onObjectBegin:()=>{const T={};I(T),m.push(u),u=T,h=null},onObjectProperty:T=>{h=T},onObjectEnd:()=>{u=m.pop()},onArrayBegin:()=>{const T=[];I(T),m.push(u),u=T,h=null},onArrayEnd:()=>{u=m.pop()},onLiteralValue:I,onError:(T,N,$)=>{r.push({error:T,offset:N,length:$})}},a),u[0]}e.parse=E;function g(t,r=[],a=b.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(T){h.type==="property"&&(h.length=T-h.offset,h=h.parent)}function m(T){return h.children.push(T),T}c(t,{onObjectBegin:T=>{h=m({type:"object",offset:T,length:-1,parent:h,children:[]})},onObjectProperty:(T,N,$)=>{h=m({type:"property",offset:N,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:T,offset:N,length:$,parent:h})},onObjectEnd:(T,N)=>{h.length=T+N-h.offset,h=h.parent,u(T+N)},onArrayBegin:(T,N)=>{h=m({type:"array",offset:T,length:-1,parent:h,children:[]})},onArrayEnd:(T,N)=>{h.length=T+N-h.offset,h=h.parent,u(T+N)},onLiteralValue:(T,N,$)=>{m({type:s(T),offset:N,length:$,parent:h,value:T}),u(N+$)},onSeparator:(T,N,$)=>{h.type==="property"&&(T===":"?h.colonOffset=N:T===","&&u(N))},onError:(T,N,$)=>{r.push({error:T,offset:N,length:$})}},a);const A=h.children[0];return A&&delete A.parent,A}e.parseTree=g;function d(t,r){if(!!t){let a=t;for(let h of r)if(typeof h=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let u=!1;for(const m of a.children)if(Array.isArray(m.children)&&m.children[0].value===h){a=m.children[1],u=!0;break}if(!u)return}else{const u=h;if(a.type!=="array"||u<0||!Array.isArray(a.children)||u>=a.children.length)return;a=a.children[u]}return a}}e.findNodeAtLocation=d;function w(t){if(!t.parent||!t.parent.children)return[];const r=w(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;r.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&r.push(a)}return r}e.getNodePath=w;function y(t){switch(t.type){case"array":return t.children.map(y);case"object":const r=Object.create(null);for(let a of t.children){const h=a.children[1];h&&(r[a.children[0].value]=y(h))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=y;function v(t,r,a=!1){return r>=t.offset&&r<t.offset+t.length||a&&r===t.offset+t.length}e.contains=v;function o(t,r,a=!1){if(v(t,r,a)){const h=t.children;if(Array.isArray(h))for(let u=0;u<h.length&&h[u].offset<=r;u++){const m=o(h[u],r,a);if(m)return m}return t}}e.findNodeAtOffset=o;function c(t,r,a=b.DEFAULT){const h=P(t,!1);function u(j){return j?()=>j(h.getTokenOffset(),h.getTokenLength()):()=>!0}function m(j){return j?G=>j(G,h.getTokenOffset(),h.getTokenLength()):()=>!0}const I=u(r.onObjectBegin),A=m(r.onObjectProperty),T=u(r.onObjectEnd),N=u(r.onArrayBegin),$=u(r.onArrayEnd),X=m(r.onLiteralValue),ne=m(r.onSeparator),Y=u(r.onComment),Q=m(r.onError),B=a&&a.disallowComments,z=a&&a.allowTrailingComma;function U(){for(;;){const j=h.scan();switch(h.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:B||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(j){case 12:case 13:B?W(10):Y();break;case 16:W(1);break;case 15:case 14:break;default:return j}}}function W(j,G=[],K=[]){if(Q(j),G.length+K.length>0){let V=h.getToken();for(;V!==17;){if(G.indexOf(V)!==-1){U();break}else if(K.indexOf(V)!==-1)break;V=U()}}}function O(j){const G=h.getTokenValue();return j?X(G):A(G),U(),!0}function D(){switch(h.getToken()){case 11:let j=0;try{j=JSON.parse(h.getTokenValue()),typeof j!="number"&&(W(2),j=0)}catch(G){W(2)}X(j);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return U(),!0}function k(){return h.getToken()!==10?(W(3,[],[2,5]),!1):(O(!1),h.getToken()===6?(ne(":"),U(),C()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function F(){I(),U();let j=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(j||W(4,[],[]),ne(","),U(),h.getToken()===2&&z)break}else j&&W(6,[],[]);k()||W(4,[],[2,5]),j=!0}return T(),h.getToken()!==2?W(7,[2],[]):U(),!0}function _(){N(),U();let j=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(j||W(4,[],[]),ne(","),U(),h.getToken()===4&&z)break}else j&&W(6,[],[]);C()||W(4,[],[4,5]),j=!0}return $(),h.getToken()!==4?W(8,[4],[]):U(),!0}function C(){switch(h.getToken()){case 3:return _();case 1:return F();case 10:return O(!0);default:return D()}}return U(),h.getToken()===17?a.allowEmptyContent?!0:(W(4,[],[]),!1):C()?(h.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=c;function l(t,r){let a=P(t),h=[],u,m=0,I;do switch(I=a.getPosition(),u=a.scan(),u){case 12:case 13:case 17:m!==I&&h.push(t.substring(m,I)),r!==void 0&&h.push(a.getTokenValue().replace(/[^\r\n]/g,r)),m=a.getPosition();break}while(u!==17);return h.join("")}e.stripComments=l;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(Z[100],x([0,1,43]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(S,i,M){let f,E,g,d,w;if(i){for(d=i.offset,w=d+i.length,g=d;g>0&&!n(S,g-1);)g--;let m=w;for(;m<S.length&&!n(S,m);)m++;E=S.substring(g,m),f=b(E,M)}else E=S,f=0,g=0,d=0,w=S.length;const y=P(M,S);let v=!1,o=0,c;M.insertSpaces?c=L(" ",M.tabSize||4):c="	";const l=(0,p.createScanner)(E,!1);let s=!1;function t(){return y+L(c,f+o)}function r(){let m=l.scan();for(v=!1;m===15||m===14;)v=v||m===14,m=l.scan();return s=m===16||l.getTokenError()!==0,m}const a=[];function h(m,I,A){!s&&I<w&&A>d&&S.substring(I,A)!==m&&a.push({offset:I,length:A-I,content:m})}let u=r();if(u!==17){const m=l.getTokenOffset()+g,I=L(c,f);h(I,g,m)}for(;u!==17;){let m=l.getTokenOffset()+l.getTokenLength()+g,I=r(),A="";for(;!v&&(I===12||I===13);){const N=l.getTokenOffset()+g;h(" ",m,N),m=l.getTokenOffset()+l.getTokenLength()+g,A=I===12?t():"",I=r()}if(I===2)u!==1&&(o--,A=t());else if(I===4)u!==3&&(o--,A=t());else{switch(u){case 3:case 1:o++,A=t();break;case 5:case 12:A=t();break;case 13:v?A=t():A=" ";break;case 6:A=" ";break;case 10:if(I===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?A=" ":I!==5&&I!==17&&(s=!0);break;case 16:s=!0;break}v&&(I===12||I===13)&&(A=t())}const T=l.getTokenOffset()+g;h(A,m,T),u=I}return a}e.format=R;function L(S,i){let M="";for(let f=0;f<i;f++)M+=S;return M}function b(S,i){let M=0,f=0;const E=i.tabSize||4;for(;M<S.length;){const g=S.charAt(M);if(g===" ")f++;else if(g==="	")f+=E;else break;M++}return Math.floor(f/E)}function P(S,i){for(let M=0;M<i.length;M++){const f=i.charAt(M);if(f==="\r")return M+1<i.length&&i.charAt(M+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=P;function n(S,i){return`\r
`.indexOf(S.charAt(i))!==-1}e.isEOL=n}),define(Z[101],x([0,1,43,100]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(i,M,f){return b(i,M,void 0,f)}e.removeProperty=L;function b(i,M,f,E,g){const d=M.slice(),w=[],y=(0,p.parseTree)(i,w);let v,o;for(;d.length>0&&(o=d.pop(),v=(0,p.findNodeAtLocation)(y,d),v===void 0&&f!==void 0);)typeof o=="string"?f={[o]:f}:f=[f];if(v)if(v.type==="object"&&typeof o=="string"&&Array.isArray(v.children)){const c=(0,p.findNodeAtLocation)(v,[o]);if(c!==void 0)if(f===void 0){if(!c.parent)throw new Error("Malformed AST");const l=v.children.indexOf(c.parent);let s,t=c.parent.offset+c.parent.length;if(l>0){const r=v.children[l-1];s=r.offset+r.length}else s=v.offset+1,v.children.length>1&&(t=v.children[1].offset);return P(i,{offset:s,length:t-s,content:""},E)}else return P(i,{offset:c.offset,length:c.length,content:JSON.stringify(f)},E);else{if(f===void 0)return[];const l=`${JSON.stringify(o)}: ${JSON.stringify(f)}`,s=g?g(v.children.map(r=>r.children[0].value)):v.children.length;let t;if(s>0){const r=v.children[s-1];t={offset:r.offset+r.length,length:0,content:","+l}}else v.children.length===0?t={offset:v.offset+1,length:0,content:l}:t={offset:v.offset+1,length:0,content:l+","};return P(i,t,E)}}else if(v.type==="array"&&typeof o=="number"&&Array.isArray(v.children))if(f!==void 0){const c=`${JSON.stringify(f)}`;let l;if(v.children.length===0||o===0)l={offset:v.offset+1,length:0,content:v.children.length===0?c:c+","};else{const s=o===-1||o>v.children.length?v.children.length:o,t=v.children[s-1];l={offset:t.offset+t.length,length:0,content:","+c}}return P(i,l,E)}else{const c=o,l=v.children[c];let s;if(v.children.length===1)s={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===c){const t=v.children[c-1],r=t.offset+t.length,a=v.offset+v.length;s={offset:r,length:a-2-r,content:""}}else s={offset:l.offset,length:v.children[c+1].offset-l.offset,content:""};return P(i,s,E)}else throw new Error(`Can not add ${typeof o!="number"?"index":"property"} to parent of type ${v.type}`);else{if(f===void 0)throw new Error("Can not delete in empty document");return P(i,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(f)},E)}}e.setProperty=b;function P(i,M,f){let E=n(i,M),g=M.offset,d=M.offset+M.content.length;if(M.length===0||M.content.length===0){for(;g>0&&!(0,R.isEOL)(E,g-1);)g--;for(;d<E.length&&!(0,R.isEOL)(E,d);)d++}const w=(0,R.format)(E,{offset:g,length:d-g},f);for(let v=w.length-1;v>=0;v--){const o=w[v];E=n(E,o),g=Math.min(g,o.offset),d=Math.max(d,o.offset+o.length),d+=o.content.length-o.length}const y=i.length-(E.length-d)-g;return[{offset:g,length:y,content:E.substring(g,d)}]}e.withFormatting=P;function n(i,M){return i.substring(0,M.offset)+M.content+i.substring(M.offset+M.length)}e.applyEdit=n;function S(i,M){let f=M.slice(0).sort((g,d)=>{const w=g.offset-d.offset;return w===0?g.length-d.length:w}),E=i.length;for(let g=f.length-1;g>=0;g--){let d=f[g];if(d.offset+d.length<=E)i=n(i,d);else throw new Error("Overlapping edit");E=d.offset}return i}e.applyEdits=S}),define(Z[56],x([0,1,19]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var R;(function(o){o[o.Unknown=0]="Unknown",o[o.Backspace=1]="Backspace",o[o.Tab=2]="Tab",o[o.Enter=3]="Enter",o[o.Shift=4]="Shift",o[o.Ctrl=5]="Ctrl",o[o.Alt=6]="Alt",o[o.PauseBreak=7]="PauseBreak",o[o.CapsLock=8]="CapsLock",o[o.Escape=9]="Escape",o[o.Space=10]="Space",o[o.PageUp=11]="PageUp",o[o.PageDown=12]="PageDown",o[o.End=13]="End",o[o.Home=14]="Home",o[o.LeftArrow=15]="LeftArrow",o[o.UpArrow=16]="UpArrow",o[o.RightArrow=17]="RightArrow",o[o.DownArrow=18]="DownArrow",o[o.Insert=19]="Insert",o[o.Delete=20]="Delete",o[o.KEY_0=21]="KEY_0",o[o.KEY_1=22]="KEY_1",o[o.KEY_2=23]="KEY_2",o[o.KEY_3=24]="KEY_3",o[o.KEY_4=25]="KEY_4",o[o.KEY_5=26]="KEY_5",o[o.KEY_6=27]="KEY_6",o[o.KEY_7=28]="KEY_7",o[o.KEY_8=29]="KEY_8",o[o.KEY_9=30]="KEY_9",o[o.KEY_A=31]="KEY_A",o[o.KEY_B=32]="KEY_B",o[o.KEY_C=33]="KEY_C",o[o.KEY_D=34]="KEY_D",o[o.KEY_E=35]="KEY_E",o[o.KEY_F=36]="KEY_F",o[o.KEY_G=37]="KEY_G",o[o.KEY_H=38]="KEY_H",o[o.KEY_I=39]="KEY_I",o[o.KEY_J=40]="KEY_J",o[o.KEY_K=41]="KEY_K",o[o.KEY_L=42]="KEY_L",o[o.KEY_M=43]="KEY_M",o[o.KEY_N=44]="KEY_N",o[o.KEY_O=45]="KEY_O",o[o.KEY_P=46]="KEY_P",o[o.KEY_Q=47]="KEY_Q",o[o.KEY_R=48]="KEY_R",o[o.KEY_S=49]="KEY_S",o[o.KEY_T=50]="KEY_T",o[o.KEY_U=51]="KEY_U",o[o.KEY_V=52]="KEY_V",o[o.KEY_W=53]="KEY_W",o[o.KEY_X=54]="KEY_X",o[o.KEY_Y=55]="KEY_Y",o[o.KEY_Z=56]="KEY_Z",o[o.Meta=57]="Meta",o[o.ContextMenu=58]="ContextMenu",o[o.F1=59]="F1",o[o.F2=60]="F2",o[o.F3=61]="F3",o[o.F4=62]="F4",o[o.F5=63]="F5",o[o.F6=64]="F6",o[o.F7=65]="F7",o[o.F8=66]="F8",o[o.F9=67]="F9",o[o.F10=68]="F10",o[o.F11=69]="F11",o[o.F12=70]="F12",o[o.F13=71]="F13",o[o.F14=72]="F14",o[o.F15=73]="F15",o[o.F16=74]="F16",o[o.F17=75]="F17",o[o.F18=76]="F18",o[o.F19=77]="F19",o[o.NumLock=78]="NumLock",o[o.ScrollLock=79]="ScrollLock",o[o.US_SEMICOLON=80]="US_SEMICOLON",o[o.US_EQUAL=81]="US_EQUAL",o[o.US_COMMA=82]="US_COMMA",o[o.US_MINUS=83]="US_MINUS",o[o.US_DOT=84]="US_DOT",o[o.US_SLASH=85]="US_SLASH",o[o.US_BACKTICK=86]="US_BACKTICK",o[o.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",o[o.US_BACKSLASH=88]="US_BACKSLASH",o[o.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",o[o.US_QUOTE=90]="US_QUOTE",o[o.OEM_8=91]="OEM_8",o[o.OEM_102=92]="OEM_102",o[o.NUMPAD_0=93]="NUMPAD_0",o[o.NUMPAD_1=94]="NUMPAD_1",o[o.NUMPAD_2=95]="NUMPAD_2",o[o.NUMPAD_3=96]="NUMPAD_3",o[o.NUMPAD_4=97]="NUMPAD_4",o[o.NUMPAD_5=98]="NUMPAD_5",o[o.NUMPAD_6=99]="NUMPAD_6",o[o.NUMPAD_7=100]="NUMPAD_7",o[o.NUMPAD_8=101]="NUMPAD_8",o[o.NUMPAD_9=102]="NUMPAD_9",o[o.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",o[o.NUMPAD_ADD=104]="NUMPAD_ADD",o[o.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",o[o.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",o[o.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",o[o.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",o[o.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",o[o.ABNT_C1=110]="ABNT_C1",o[o.ABNT_C2=111]="ABNT_C2",o[o.MAX_VALUE=112]="MAX_VALUE"})(R=e.KeyCode||(e.KeyCode={}));class L{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(c,l){this._keyCodeToStr[c]=l,this._strToKeyCode[l.toLowerCase()]=c}keyCodeToStr(c){return this._keyCodeToStr[c]}strToKeyCode(c){return this._strToKeyCode[c.toLowerCase()]||0}}const b=new L,P=new L,n=new L;(function(){function o(c,l,s=l,t=s){b.define(c,l),P.define(c,s),n.define(c,t)}o(0,"unknown"),o(1,"Backspace"),o(2,"Tab"),o(3,"Enter"),o(4,"Shift"),o(5,"Ctrl"),o(6,"Alt"),o(7,"PauseBreak"),o(8,"CapsLock"),o(9,"Escape"),o(10,"Space"),o(11,"PageUp"),o(12,"PageDown"),o(13,"End"),o(14,"Home"),o(15,"LeftArrow","Left"),o(16,"UpArrow","Up"),o(17,"RightArrow","Right"),o(18,"DownArrow","Down"),o(19,"Insert"),o(20,"Delete"),o(21,"0"),o(22,"1"),o(23,"2"),o(24,"3"),o(25,"4"),o(26,"5"),o(27,"6"),o(28,"7"),o(29,"8"),o(30,"9"),o(31,"A"),o(32,"B"),o(33,"C"),o(34,"D"),o(35,"E"),o(36,"F"),o(37,"G"),o(38,"H"),o(39,"I"),o(40,"J"),o(41,"K"),o(42,"L"),o(43,"M"),o(44,"N"),o(45,"O"),o(46,"P"),o(47,"Q"),o(48,"R"),o(49,"S"),o(50,"T"),o(51,"U"),o(52,"V"),o(53,"W"),o(54,"X"),o(55,"Y"),o(56,"Z"),o(57,"Meta"),o(58,"ContextMenu"),o(59,"F1"),o(60,"F2"),o(61,"F3"),o(62,"F4"),o(63,"F5"),o(64,"F6"),o(65,"F7"),o(66,"F8"),o(67,"F9"),o(68,"F10"),o(69,"F11"),o(70,"F12"),o(71,"F13"),o(72,"F14"),o(73,"F15"),o(74,"F16"),o(75,"F17"),o(76,"F18"),o(77,"F19"),o(78,"NumLock"),o(79,"ScrollLock"),o(80,";",";","OEM_1"),o(81,"=","=","OEM_PLUS"),o(82,",",",","OEM_COMMA"),o(83,"-","-","OEM_MINUS"),o(84,".",".","OEM_PERIOD"),o(85,"/","/","OEM_2"),o(86,"`","`","OEM_3"),o(110,"ABNT_C1"),o(111,"ABNT_C2"),o(87,"[","[","OEM_4"),o(88,"\\","\\","OEM_5"),o(89,"]","]","OEM_6"),o(90,"'","'","OEM_7"),o(91,"OEM_8"),o(92,"OEM_102"),o(93,"NumPad0"),o(94,"NumPad1"),o(95,"NumPad2"),o(96,"NumPad3"),o(97,"NumPad4"),o(98,"NumPad5"),o(99,"NumPad6"),o(100,"NumPad7"),o(101,"NumPad8"),o(102,"NumPad9"),o(103,"NumPad_Multiply"),o(104,"NumPad_Add"),o(105,"NumPad_Separator"),o(106,"NumPad_Subtract"),o(107,"NumPad_Decimal"),o(108,"NumPad_Divide")})();var S;(function(o){function c(a){return b.keyCodeToStr(a)}o.toString=c;function l(a){return b.strToKeyCode(a)}o.fromString=l;function s(a){return P.keyCodeToStr(a)}o.toUserSettingsUS=s;function t(a){return n.keyCodeToStr(a)}o.toUserSettingsGeneral=t;function r(a){return P.strToKeyCode(a)||n.strToKeyCode(a)}o.fromUserSettings=r})(S=e.KeyCodeUtils||(e.KeyCodeUtils={}));var i;(function(o){o[o.CtrlCmd=2048]="CtrlCmd",o[o.Shift=1024]="Shift",o[o.Alt=512]="Alt",o[o.WinCtrl=256]="WinCtrl",o[o.KeyCode=255]="KeyCode"})(i||(i={}));var M;(function(o){o[o.CtrlCmd=2048]="CtrlCmd",o[o.Shift=1024]="Shift",o[o.Alt=512]="Alt",o[o.WinCtrl=256]="WinCtrl"})(M=e.KeyMod||(e.KeyMod={}));function f(o,c){const l=(c&65535)<<16>>>0;return(o|l)>>>0}e.KeyChord=f;function E(o,c){if(o===0)return null;const l=(o&65535)>>>0,s=(o&4294901760)>>>16;return s!==0?new w([g(l,c),g(s,c)]):new w([g(l,c)])}e.createKeybinding=E;function g(o,c){const l=!!(o&2048),s=!!(o&256),t=c===2?s:l,r=!!(o&1024),a=!!(o&512),h=c===2?l:s,u=o&255;return new d(t,r,a,h,u)}e.createSimpleKeybinding=g;class d{constructor(c,l,s,t,r){this.ctrlKey=c,this.shiftKey=l,this.altKey=s,this.metaKey=t,this.keyCode=r}equals(c){return this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",s=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${c}${l}${s}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class w{constructor(c){if(c.length===0)throw(0,p.illegalArgument)("parts");this.parts=c}getHashCode(){let c="";for(let l=0,s=this.parts.length;l<s;l++)l!==0&&(c+=";"),c+=this.parts[l].getHashCode();return c}equals(c){if(c===null||this.parts.length!==c.parts.length)return!1;for(let l=0;l<this.parts.length;l++)if(!this.parts[l].equals(c.parts[l]))return!1;return!0}}e.ChordKeybinding=w;class y{constructor(c,l,s,t,r,a){this.ctrlKey=c,this.shiftKey=l,this.altKey=s,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=a}}e.ResolvedKeybindingPart=y;class v{}e.ResolvedKeybinding=v}),define(Z[2],x([0,1,42,64]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const L=!1;let b=null;function P(c){b=c}if(e.setDisposableTracker=P,L){const c="__is_disposable_tracked__";b=new class{trackDisposable(l){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[c]||console.log(s)},3e3)}markTracked(l){if(l&&l!==w.None)try{l[c]=!0}catch(s){}}}}function n(c){!b||b.markTracked(c)}function S(c){return b&&b.trackDisposable(c),c}e.trackDisposable=S;class i extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=i;function M(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=M;function f(c){if(R.Iterable.is(c)){let l=[];for(const s of c)if(s){n(s);try{s.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new i(l);return Array.isArray(c)?[]:c}else if(c)return n(c),c.dispose(),c}e.dispose=f;function E(...c){return c.forEach(n),g(()=>f(c))}e.combinedDisposable=E;function g(c){const l=S({dispose:()=>{n(l),c()}});return l}e.toDisposable=g;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return n(l),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new d,S(this)}dispose(){n(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var s;this._isDisposed||l===this._value||((s=this._value)===null||s===void 0||s.dispose(),l&&n(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,n(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=y;class v{constructor(){this.references=new Map}acquire(l,...s){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...s)},this.references.set(l,t));const{object:r}=t,a=(0,p.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:r,dispose:a}}}e.ReferenceCollection=v;class o{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=o}),define(Z[76],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(b){this.element=b,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class R{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(b){return this._insert(b,!1)}push(b){return this._insert(b,!0)}_insert(b,P){const n=new p(b);if(this._first===p.Undefined)this._first=n,this._last=n;else if(P){const i=this._last;this._last=n,n.prev=i,i.next=n}else{const i=this._first;this._first=n,n.next=i,i.prev=n}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(n))}}shift(){if(this._first!==p.Undefined){const b=this._first.element;return this._remove(this._first),b}}pop(){if(this._last!==p.Undefined){const b=this._last.element;return this._remove(this._last),b}}_remove(b){if(b.prev!==p.Undefined&&b.next!==p.Undefined){const P=b.prev;P.next=b.next,b.next.prev=P}else b.prev===p.Undefined&&b.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):b.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):b.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let b=this._first;for(;b!==p.Undefined;)yield b.element,b=b.next}}e.LinkedList=R});"use strict";(function(){function H(L){const b=[];typeof L=="number"&&b.push("code/timeOrigin",L);function P(S){b.push(S,Date.now())}function n(){const S=[];for(let i=0;i<b.length;i+=2)S.push({name:b[i],startTime:b[i+1]});return S}return{mark:P,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const b=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const P of performance.getEntriesByType("mark"))b.push({name:P.name,startTime:Math.round(L+P.startTime)});return b}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function p(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=p(R))})(),define(Z[3],x([0,1]),function(H,e){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const R="en";let L=!1,b=!1,P=!1,n=!1,S=!1,i=!1,M=!1,f,E=R,g,d;const w=typeof self=="object"?self:typeof global=="object"?global:{};let y;typeof process!="undefined"?y=process:typeof w.vscode!="undefined"&&(y=w.vscode.process);const v=typeof((p=y==null?void 0:y.versions)===null||p===void 0?void 0:p.electron)=="string"&&y.type==="renderer";if(e.isElectronSandboxed=v&&(y==null?void 0:y.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const u=y==null?void 0:y.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof u=="string")return u==="none"||u==="code"||u==="bypassHeatCheck"||u==="bypassHeatCheckAndEagerCompile"?u:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!v)d=navigator.userAgent,L=d.indexOf("Windows")>=0,b=d.indexOf("Macintosh")>=0,M=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=d.indexOf("Linux")>=0,i=!0,f=navigator.language,E=f;else if(typeof y=="object"){L=y.platform==="win32",b=y.platform==="darwin",P=y.platform==="linux",n=P&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,f=R,E=R;const u=y.env.VSCODE_NLS_CONFIG;if(u)try{const m=JSON.parse(u),I=m.availableLanguages["*"];f=m.locale,E=I||R,g=m._translationsConfigFile}catch(m){}S=!0}else console.error("Unable to resolve platform.");var o;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(o=e.Platform||(e.Platform={}));function c(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let l=0;b?l=1:L?l=3:P&&(l=2),e.isWindows=L,e.isMacintosh=b,e.isLinux=P,e.isLinuxSnap=n,e.isNative=S,e.isWeb=i,e.isIOS=M,e.platform=l,e.userAgent=d,e.language=E;var s;(function(u){function m(){return e.language}u.value=m;function I(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=I;function A(){return e.language==="en"}u.isDefault=A})(s=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=g,e.globals=w,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let I=[];e.globals.addEventListener("message",T=>{if(T.data&&T.data.vscodeSetImmediateId)for(let N=0,$=I.length;N<$;N++){const X=I[N];if(X.id===T.data.vscodeSetImmediateId){I.splice(N,1),X.callback();return}}});let A=0;return T=>{const N=++A;I.push({id:N,callback:T}),e.globals.postMessage({vscodeSetImmediateId:N},"*")}}if(y&&typeof y.nextTick=="function")return y.nextTick.bind(y);const m=Promise.resolve();return I=>m.then(I)}();var t;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=b||M?2:L?1:3;let r=!0,a=!1;function h(){if(!a){a=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=h}),define(Z[51],x([0,1,3]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;typeof process!="undefined"?R=process:typeof p.globals.vscode!="undefined"?R={get platform(){return p.globals.vscode.process.platform},get env(){return p.globals.vscode.process.env},nextTick(L){return(0,p.setImmediate)(L)},cwd(){return p.globals.vscode.process.env.VSCODE_CWD||p.globals.vscode.process.execPath.substr(0,p.globals.vscode.process.execPath.lastIndexOf(p.globals.vscode.process.platform==="win32"?"\\":"/"))}}:R={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(L){return(0,p.setImmediate)(L)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(Z[8],x([0,1,51]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,L=97,b=90,P=122,n=46,S=47,i=92,M=58,f=63;class E extends Error{constructor(l,s,t){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const a=l.indexOf(".")!==-1?"property":"argument";let h=`The "${l}" ${a} ${r} of type ${s}`;h+=`. Received type ${typeof t}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function g(c,l){if(typeof c!="string")throw new E(l,"string",c)}function d(c){return c===S||c===i}function w(c){return c===S}function y(c){return c>=R&&c<=b||c>=L&&c<=P}function v(c,l,s,t){let r="",a=0,h=-1,u=0,m=0;for(let I=0;I<=c.length;++I){if(I<c.length)m=c.charCodeAt(I);else{if(t(m))break;m=S}if(t(m)){if(!(h===I-1||u===1))if(u===2){if(r.length<2||a!==2||r.charCodeAt(r.length-1)!==n||r.charCodeAt(r.length-2)!==n){if(r.length>2){const A=r.lastIndexOf(s);A===-1?(r="",a=0):(r=r.slice(0,A),a=r.length-1-r.lastIndexOf(s)),h=I,u=0;continue}else if(r.length!==0){r="",a=0,h=I,u=0;continue}}l&&(r+=r.length>0?`${s}..`:"..",a=2)}else r.length>0?r+=`${s}${c.slice(h+1,I)}`:r=c.slice(h+1,I),a=I-h-1;h=I,u=0}else m===n&&u!==-1?++u:u=-1}return r}function o(c,l){if(l===null||typeof l!="object")throw new E("pathObject","Object",l);const s=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return s?s===l.root?`${s}${t}`:`${s}${c}${t}`:t}e.win32={resolve(...c){let l="",s="",t=!1;for(let r=c.length-1;r>=-1;r--){let a;if(r>=0){if(a=c[r],g(a,"path"),a.length===0)continue}else l.length===0?a=p.cwd():(a=p.env[`=${l}`]||p.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==l.toLowerCase()&&a.charCodeAt(2)===i)&&(a=`${l}\\`));const h=a.length;let u=0,m="",I=!1;const A=a.charCodeAt(0);if(h===1)d(A)&&(u=1,I=!0);else if(d(A))if(I=!0,d(a.charCodeAt(1))){let T=2,N=T;for(;T<h&&!d(a.charCodeAt(T));)T++;if(T<h&&T!==N){const $=a.slice(N,T);for(N=T;T<h&&d(a.charCodeAt(T));)T++;if(T<h&&T!==N){for(N=T;T<h&&!d(a.charCodeAt(T));)T++;(T===h||T!==N)&&(m=`\\\\${$}\\${a.slice(N,T)}`,u=T)}}}else u=1;else y(A)&&a.charCodeAt(1)===M&&(m=a.slice(0,2),u=2,h>2&&d(a.charCodeAt(2))&&(I=!0,u=3));if(m.length>0)if(l.length>0){if(m.toLowerCase()!==l.toLowerCase())continue}else l=m;if(t){if(l.length>0)break}else if(s=`${a.slice(u)}\\${s}`,t=I,I&&l.length>0)break}return s=v(s,!t,"\\",d),t?`${l}\\${s}`:`${l}${s}`||"."},normalize(c){g(c,"path");const l=c.length;if(l===0)return".";let s=0,t,r=!1;const a=c.charCodeAt(0);if(l===1)return w(a)?"\\":c;if(d(a))if(r=!0,d(c.charCodeAt(1))){let u=2,m=u;for(;u<l&&!d(c.charCodeAt(u));)u++;if(u<l&&u!==m){const I=c.slice(m,u);for(m=u;u<l&&d(c.charCodeAt(u));)u++;if(u<l&&u!==m){for(m=u;u<l&&!d(c.charCodeAt(u));)u++;if(u===l)return`\\\\${I}\\${c.slice(m)}\\`;u!==m&&(t=`\\\\${I}\\${c.slice(m,u)}`,s=u)}}}else s=1;else y(a)&&c.charCodeAt(1)===M&&(t=c.slice(0,2),s=2,l>2&&d(c.charCodeAt(2))&&(r=!0,s=3));let h=s<l?v(c.slice(s),!r,"\\",d):"";return h.length===0&&!r&&(h="."),h.length>0&&d(c.charCodeAt(l-1))&&(h+="\\"),t===void 0?r?`\\${h}`:h:r?`${t}\\${h}`:`${t}${h}`},isAbsolute(c){g(c,"path");const l=c.length;if(l===0)return!1;const s=c.charCodeAt(0);return d(s)||l>2&&y(s)&&c.charCodeAt(1)===M&&d(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let l,s;for(let a=0;a<c.length;++a){const h=c[a];g(h,"path"),h.length>0&&(l===void 0?l=s=h:l+=`\\${h}`)}if(l===void 0)return".";let t=!0,r=0;if(typeof s=="string"&&d(s.charCodeAt(0))){++r;const a=s.length;a>1&&d(s.charCodeAt(1))&&(++r,a>2&&(d(s.charCodeAt(2))?++r:t=!1))}if(t){for(;r<l.length&&d(l.charCodeAt(r));)r++;r>=2&&(l=`\\${l.slice(r)}`)}return e.win32.normalize(l)},relative(c,l){if(g(c,"from"),g(l,"to"),c===l)return"";const s=e.win32.resolve(c),t=e.win32.resolve(l);if(s===t||(c=s.toLowerCase(),l=t.toLowerCase(),c===l))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===i;)r++;let a=c.length;for(;a-1>r&&c.charCodeAt(a-1)===i;)a--;const h=a-r;let u=0;for(;u<l.length&&l.charCodeAt(u)===i;)u++;let m=l.length;for(;m-1>u&&l.charCodeAt(m-1)===i;)m--;const I=m-u,A=h<I?h:I;let T=-1,N=0;for(;N<A;N++){const X=c.charCodeAt(r+N);if(X!==l.charCodeAt(u+N))break;X===i&&(T=N)}if(N!==A){if(T===-1)return t}else{if(I>A){if(l.charCodeAt(u+N)===i)return t.slice(u+N+1);if(N===2)return t.slice(u+N)}h>A&&(c.charCodeAt(r+N)===i?T=N:N===2&&(T=3)),T===-1&&(T=0)}let $="";for(N=r+T+1;N<=a;++N)(N===a||c.charCodeAt(N)===i)&&($+=$.length===0?"..":"\\..");return u+=T,$.length>0?`${$}${t.slice(u,m)}`:(t.charCodeAt(u)===i&&++u,t.slice(u,m))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const l=e.win32.resolve(c);if(l.length<=2)return c;if(l.charCodeAt(0)===i){if(l.charCodeAt(1)===i){const s=l.charCodeAt(2);if(s!==f&&s!==n)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(y(l.charCodeAt(0))&&l.charCodeAt(1)===M&&l.charCodeAt(2)===i)return`\\\\?\\${l}`;return c},dirname(c){g(c,"path");const l=c.length;if(l===0)return".";let s=-1,t=0;const r=c.charCodeAt(0);if(l===1)return d(r)?c:".";if(d(r)){if(s=t=1,d(c.charCodeAt(1))){let u=2,m=u;for(;u<l&&!d(c.charCodeAt(u));)u++;if(u<l&&u!==m){for(m=u;u<l&&d(c.charCodeAt(u));)u++;if(u<l&&u!==m){for(m=u;u<l&&!d(c.charCodeAt(u));)u++;if(u===l)return c;u!==m&&(s=t=u+1)}}}}else y(r)&&c.charCodeAt(1)===M&&(s=l>2&&d(c.charCodeAt(2))?3:2,t=s);let a=-1,h=!0;for(let u=l-1;u>=t;--u)if(d(c.charCodeAt(u))){if(!h){a=u;break}}else h=!1;if(a===-1){if(s===-1)return".";a=s}return c.slice(0,a)},basename(c,l){l!==void 0&&g(l,"ext"),g(c,"path");let s=0,t=-1,r=!0,a;if(c.length>=2&&y(c.charCodeAt(0))&&c.charCodeAt(1)===M&&(s=2),l!==void 0&&l.length>0&&l.length<=c.length){if(l===c)return"";let h=l.length-1,u=-1;for(a=c.length-1;a>=s;--a){const m=c.charCodeAt(a);if(d(m)){if(!r){s=a+1;break}}else u===-1&&(r=!1,u=a+1),h>=0&&(m===l.charCodeAt(h)?--h==-1&&(t=a):(h=-1,t=u))}return s===t?t=u:t===-1&&(t=c.length),c.slice(s,t)}for(a=c.length-1;a>=s;--a)if(d(c.charCodeAt(a))){if(!r){s=a+1;break}}else t===-1&&(r=!1,t=a+1);return t===-1?"":c.slice(s,t)},extname(c){g(c,"path");let l=0,s=-1,t=0,r=-1,a=!0,h=0;c.length>=2&&c.charCodeAt(1)===M&&y(c.charCodeAt(0))&&(l=t=2);for(let u=c.length-1;u>=l;--u){const m=c.charCodeAt(u);if(d(m)){if(!a){t=u+1;break}continue}r===-1&&(a=!1,r=u+1),m===n?s===-1?s=u:h!==1&&(h=1):s!==-1&&(h=-1)}return s===-1||r===-1||h===0||h===1&&s===r-1&&s===t+1?"":c.slice(s,r)},format:o.bind(null,"\\"),parse(c){g(c,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return l;const s=c.length;let t=0,r=c.charCodeAt(0);if(s===1)return d(r)?(l.root=l.dir=c,l):(l.base=l.name=c,l);if(d(r)){if(t=1,d(c.charCodeAt(1))){let T=2,N=T;for(;T<s&&!d(c.charCodeAt(T));)T++;if(T<s&&T!==N){for(N=T;T<s&&d(c.charCodeAt(T));)T++;if(T<s&&T!==N){for(N=T;T<s&&!d(c.charCodeAt(T));)T++;T===s?t=T:T!==N&&(t=T+1)}}}}else if(y(r)&&c.charCodeAt(1)===M){if(s<=2)return l.root=l.dir=c,l;if(t=2,d(c.charCodeAt(2))){if(s===3)return l.root=l.dir=c,l;t=3}}t>0&&(l.root=c.slice(0,t));let a=-1,h=t,u=-1,m=!0,I=c.length-1,A=0;for(;I>=t;--I){if(r=c.charCodeAt(I),d(r)){if(!m){h=I+1;break}continue}u===-1&&(m=!1,u=I+1),r===n?a===-1?a=I:A!==1&&(A=1):a!==-1&&(A=-1)}return u!==-1&&(a===-1||A===0||A===1&&a===u-1&&a===h+1?l.base=l.name=c.slice(h,u):(l.name=c.slice(h,a),l.base=c.slice(h,u),l.ext=c.slice(a,u))),h>0&&h!==t?l.dir=c.slice(0,h-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let l="",s=!1;for(let t=c.length-1;t>=-1&&!s;t--){const r=t>=0?c[t]:p.cwd();g(r,"path"),r.length!==0&&(l=`${r}/${l}`,s=r.charCodeAt(0)===S)}return l=v(l,!s,"/",w),s?`/${l}`:l.length>0?l:"."},normalize(c){if(g(c,"path"),c.length===0)return".";const l=c.charCodeAt(0)===S,s=c.charCodeAt(c.length-1)===S;return c=v(c,!l,"/",w),c.length===0?l?"/":s?"./":".":(s&&(c+="/"),l?`/${c}`:c)},isAbsolute(c){return g(c,"path"),c.length>0&&c.charCodeAt(0)===S},join(...c){if(c.length===0)return".";let l;for(let s=0;s<c.length;++s){const t=c[s];g(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(c,l){if(g(c,"from"),g(l,"to"),c===l||(c=e.posix.resolve(c),l=e.posix.resolve(l),c===l))return"";const s=1,t=c.length,r=t-s,a=1,h=l.length-a,u=r<h?r:h;let m=-1,I=0;for(;I<u;I++){const T=c.charCodeAt(s+I);if(T!==l.charCodeAt(a+I))break;T===S&&(m=I)}if(I===u)if(h>u){if(l.charCodeAt(a+I)===S)return l.slice(a+I+1);if(I===0)return l.slice(a+I)}else r>u&&(c.charCodeAt(s+I)===S?m=I:I===0&&(m=0));let A="";for(I=s+m+1;I<=t;++I)(I===t||c.charCodeAt(I)===S)&&(A+=A.length===0?"..":"/..");return`${A}${l.slice(a+m)}`},toNamespacedPath(c){return c},dirname(c){if(g(c,"path"),c.length===0)return".";const l=c.charCodeAt(0)===S;let s=-1,t=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===S){if(!t){s=r;break}}else t=!1;return s===-1?l?"/":".":l&&s===1?"//":c.slice(0,s)},basename(c,l){l!==void 0&&g(l,"ext"),g(c,"path");let s=0,t=-1,r=!0,a;if(l!==void 0&&l.length>0&&l.length<=c.length){if(l===c)return"";let h=l.length-1,u=-1;for(a=c.length-1;a>=0;--a){const m=c.charCodeAt(a);if(m===S){if(!r){s=a+1;break}}else u===-1&&(r=!1,u=a+1),h>=0&&(m===l.charCodeAt(h)?--h==-1&&(t=a):(h=-1,t=u))}return s===t?t=u:t===-1&&(t=c.length),c.slice(s,t)}for(a=c.length-1;a>=0;--a)if(c.charCodeAt(a)===S){if(!r){s=a+1;break}}else t===-1&&(r=!1,t=a+1);return t===-1?"":c.slice(s,t)},extname(c){g(c,"path");let l=-1,s=0,t=-1,r=!0,a=0;for(let h=c.length-1;h>=0;--h){const u=c.charCodeAt(h);if(u===S){if(!r){s=h+1;break}continue}t===-1&&(r=!1,t=h+1),u===n?l===-1?l=h:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||t===-1||a===0||a===1&&l===t-1&&l===s+1?"":c.slice(l,t)},format:o.bind(null,"/"),parse(c){g(c,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return l;const s=c.charCodeAt(0)===S;let t;s?(l.root="/",t=1):t=0;let r=-1,a=0,h=-1,u=!0,m=c.length-1,I=0;for(;m>=t;--m){const A=c.charCodeAt(m);if(A===S){if(!u){a=m+1;break}continue}h===-1&&(u=!1,h=m+1),A===n?r===-1?r=m:I!==1&&(I=1):r!==-1&&(I=-1)}if(h!==-1){const A=a===0&&s?1:a;r===-1||I===0||I===1&&r===h-1&&r===a+1?l.base=l.name=c.slice(A,h):(l.name=c.slice(A,r),l.base=c.slice(A,h),l.ext=c.slice(r,h))}return a>0?l.dir=c.slice(0,a-1):s&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[77],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var p;(function(n){n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(p=e.ScanCode||(e.ScanCode={}));const R=[],L=Object.create(null),b=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>b[n]||0,toEnum:n=>L[n]||0,toString:n=>R[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class P{constructor(S,i,M,f,E){this.ctrlKey=S,this.shiftKey=i,this.altKey=M,this.metaKey=f,this.scanCode=E}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.scanCode===S.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=P,function(){function n(S,i){R[S]=i,L[i]=S,b[i.toLowerCase()]=S}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let S=0;S<=193;S++)e.IMMUTABLE_CODE_TO_KEY_CODE[S]=-1;for(let S=0;S<=112;S++)e.IMMUTABLE_KEY_CODE_TO_CODE[S]=-1;function n(S,i){e.IMMUTABLE_CODE_TO_KEY_CODE[S]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[i]=S)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Z[102],x([0,1,56,77]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class L{static _readModifiers(P){P=P.toLowerCase().trim();let n=!1,S=!1,i=!1,M=!1,f;do f=!1,/^ctrl(\+|\-)/.test(P)&&(n=!0,P=P.substr("ctrl-".length),f=!0),/^shift(\+|\-)/.test(P)&&(S=!0,P=P.substr("shift-".length),f=!0),/^alt(\+|\-)/.test(P)&&(i=!0,P=P.substr("alt-".length),f=!0),/^meta(\+|\-)/.test(P)&&(M=!0,P=P.substr("meta-".length),f=!0),/^win(\+|\-)/.test(P)&&(M=!0,P=P.substr("win-".length),f=!0),/^cmd(\+|\-)/.test(P)&&(M=!0,P=P.substr("cmd-".length),f=!0);while(f);let E;const g=P.indexOf(" ");return g>0?(E=P.substring(0,g),P=P.substring(g)):(E=P,P=""),{remains:P,ctrl:n,shift:S,alt:i,meta:M,key:E}}static parseSimpleKeybinding(P){const n=this._readModifiers(P),S=p.KeyCodeUtils.fromUserSettings(n.key);return[new p.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,S),n.remains]}static parseKeybinding(P,n){if(!P)return null;const S=[];let i;do[i,P]=this.parseSimpleKeybinding(P),S.push(i);while(P.length>0);return new p.ChordKeybinding(S)}static parseSimpleUserBinding(P){const n=this._readModifiers(P),S=n.key.match(/^\[([^\]]+)\]$/);if(S){const M=S[1],f=R.ScanCodeUtils.lowerCaseToEnum(M);return[new R.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,f),n.remains]}const i=p.KeyCodeUtils.fromUserSettings(n.key);return[new p.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,i),n.remains]}static parseUserBinding(P){if(!P)return[];const n=[];let S;for(;P.length>0;)[S,P]=this.parseSimpleUserBinding(P),n.push(S);return n}}e.KeybindingParser=L}),define(Z[103],x([0,1,3]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=p.globals.performance&&typeof p.globals.performance.now=="function";class L{constructor(P){this._highResolution=R&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new L(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=L}),define(Z[4],x([0,1,19,42,2,76,103]),function(H,e,p,R,L,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(v){v.None=()=>L.Disposable.None;function o(Q){return(B,z=null,U)=>{let W=!1,O;return O=Q(D=>{if(!W)return O?O.dispose():W=!0,B.call(z,D)},null,U),W&&O.dispose(),O}}v.once=o;function c(Q,B){return h((z,U=null,W)=>Q(O=>z.call(U,B(O)),null,W))}v.map=c;function l(Q,B){return h((z,U=null,W)=>Q(O=>{B(O),z.call(U,O)},null,W))}v.forEach=l;function s(Q,B){return h((z,U=null,W)=>Q(O=>B(O)&&z.call(U,O),null,W))}v.filter=s;function t(Q){return Q}v.signal=t;function r(...Q){return(B,z=null,U)=>(0,L.combinedDisposable)(...Q.map(W=>W(O=>B.call(z,O),null,U)))}v.any=r;function a(Q,B,z){let U=z;return c(Q,W=>(U=B(U,W),U))}v.reduce=a;function h(Q){let B;const z=new E({onFirstListenerAdd(){B=Q(z.fire,z)},onLastListenerRemove(){B.dispose()}});return z.event}v.snapshot=h;function u(Q,B,z=100,U=!1,W){let O,D,k,F=0;const _=new E({leakWarningThreshold:W,onFirstListenerAdd(){O=Q(C=>{F++,D=B(D,C),U&&!k&&(_.fire(D),D=void 0),clearTimeout(k),k=setTimeout(()=>{const j=D;D=void 0,k=void 0,(!U||F>1)&&_.fire(j),F=0},z)})},onLastListenerRemove(){O.dispose()}});return _.event}v.debounce=u;function m(Q){const B=new Date().getTime();return c(o(Q),z=>new Date().getTime()-B)}v.stopwatch=m;function I(Q){let B=!0,z;return s(Q,U=>{const W=B||U!==z;return B=!1,z=U,W})}v.latch=I;function A(Q,B=!1,z=[]){let U=z.slice(),W=Q(k=>{U?U.push(k):D.fire(k)});const O=()=>{U&&U.forEach(k=>D.fire(k)),U=null},D=new E({onFirstListenerAdd(){W||(W=Q(k=>D.fire(k)))},onFirstListenerDidAdd(){U&&(B?setTimeout(O):O())},onLastListenerRemove(){W&&W.dispose(),W=null}});return D.event}v.buffer=A;class T{constructor(B){this.event=B}map(B){return new T(c(this.event,B))}forEach(B){return new T(l(this.event,B))}filter(B){return new T(s(this.event,B))}reduce(B,z){return new T(a(this.event,B,z))}latch(){return new T(I(this.event))}debounce(B,z=100,U=!1,W){return new T(u(this.event,B,z,U,W))}on(B,z,U){return this.event(B,z,U)}once(B,z,U){return o(this.event)(B,z,U)}}function N(Q){return new T(Q)}v.chain=N;function $(Q,B,z=U=>U){const U=(...k)=>D.fire(z(...k)),W=()=>Q.on(B,U),O=()=>Q.removeListener(B,U),D=new E({onFirstListenerAdd:W,onLastListenerRemove:O});return D.event}v.fromNodeEventEmitter=$;function X(Q,B,z=U=>U){const U=(...k)=>D.fire(z(...k)),W=()=>Q.addEventListener(B,U),O=()=>Q.removeEventListener(B,U),D=new E({onFirstListenerAdd:W,onLastListenerRemove:O});return D.event}v.fromDOMEventEmitter=X;function ne(Q){const B=new E;let z=!1;return Q.then(void 0,()=>null).then(()=>{z?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),z=!0,B.event}v.fromPromise=ne;function Y(Q){return new Promise(B=>o(Q)(B))}v.toPromise=Y})(n=e.Event||(e.Event={}));class S{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${S._idPool++}`}start(o){this._stopWatch=new P.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let i=-1;function M(v){const o=i;return i=v,{dispose(){i=o}}}e.setGlobalLeakWarningThreshold=M;class f{constructor(o,c=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let c=i;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),!(c<=0||o<c)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(l)||0;if(this._stacks.set(l,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,r=0;for(const[a,h]of this._stacks)(!t||r<h)&&(t=a,r=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class E{constructor(o){var c;this._disposed=!1,this._options=o,this._leakageMon=i>0?new f(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(o,c,l)=>{var s;this._listeners||(this._listeners=new b.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(c?[o,c]:o);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,c);const a=(s=this._leakageMon)===null||s===void 0?void 0:s.check(this._listeners.size);let h;return h={dispose:()=>{a&&a(),h.dispose=E._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof L.DisposableStore?l.add(h):Array.isArray(l)&&l.push(h),h}),this._event}fire(o){var c,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,o]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(r){(0,p.onUnexpectedError)(r)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var o,c,l;(o=this._listeners)===null||o===void 0||o.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=E,E._noop=function(){};class g extends E{constructor(o){super(o);this._isPaused=0,this._eventQueue=new b.LinkedList,this._mergeFn=o==null?void 0:o.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=g;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const c={event:o,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const l=()=>{this.hasListeners&&this.unhook(c);const s=this.events.indexOf(c);this.events.splice(s,1)};return(0,L.toDisposable)((0,R.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(c=>this.emitter.fire(c))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class w{constructor(){this.buffers=[]}wrapEvent(o){return(c,l,s)=>o(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>c.call(l,t)):c.call(l,t)},void 0,s)}bufferEvents(o){const c=[];this.buffers.push(c);const l=o();return this.buffers.pop(),c.forEach(s=>s()),l}}e.EventBufferer=w;class y{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=L.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=y}),define(Z[25],x([0,1,4]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(n,S){const i=setTimeout(n.bind(S),0);return{dispose(){clearTimeout(i)}}});var L;(function(n){function S(i){return i===n.None||i===n.Cancelled||i instanceof b?!0:!i||typeof i!="object"?!1:typeof i.isCancellationRequested=="boolean"&&typeof i.onCancellationRequested=="function"}n.isCancellationToken=S,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(L=e.CancellationToken||(e.CancellationToken={}));class b{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new b),this._token}cancel(){this._token?this._token instanceof b&&this._token.cancel():this._token=L.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof b&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=P}),define(Z[104],x([0,1,4]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(M){const f=this._icons.get(M.id);f?M.description?f.description=M.description:console.error(`Duplicate registration of codicon ${M.id}`):(this._icons.set(M.id,M),this._onDidRegister.fire(M))}get(M){return this._icons.get(M)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const L=new R;e.iconRegistry=L;function b(i,M){return new P(i,M)}e.registerCodicon=b;class P{constructor(M,f,E){this.id=M,this.definition=f,this.description=E,L.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function n(i,M){const f=["codicon","codicon-"+i];return M&&f.push("codicon-modifier-"+M),f}e.getClassNamesArray=n;var S;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const M=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function f(d){if(d instanceof P)return["codicon","codicon-"+d.id];const w=M.exec(d.id);if(!w)return f(P.error);let[,y,v]=w;const o=["codicon","codicon-"+y];return v&&o.push("codicon-modifier-"+v.substr(1)),o}i.asClassNameArray=f;function E(d){return f(d).join(" ")}i.asClassName=E;function g(d){return"."+f(d).join(".")}i.asCSSSelector=g})(S=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personAdd=new i("person-add",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnknown=new i("workspace-unknown",{fontCharacter:"\\ebc3"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(Z[57],x([0,1,19,2]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(y){const v=y;return v&&[v.on,v.pause,v.resume,v.destroy].every(o=>typeof o=="function")}e.isReadableStream=L;function b(y){const v=y;return v&&L(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean"}e.isReadableBufferedStream=b;function P(y,v){return new n(y,v)}e.newWriteableStream=P;class n{constructor(v,o){this.reducer=v,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){var o;if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof((o=this.options)===null||o===void 0?void 0:o.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v!="undefined"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(o=>o(v))}emitError(v){this.listeners.error.length===0?(0,p.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(o=>o(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,o){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(v,o){if(!this.state.destroyed){let c;switch(v){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const l=c.indexOf(o);l>=0&&c.splice(l,1)}}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(y,v){const o=[];let c;for(;(c=y.read())!==null;)o.push(c);return v(o)}e.consumeReadable=S;function i(y,v,o){const c=[];let l;for(;(l=y.read())!==null&&c.length<o;)c.push(l);return l===null&&c.length>0?v(c):{read:()=>{if(c.length>0)return c.shift();if(typeof l!="undefined"){const s=l;return l=void 0,s}return y.read()}}}e.peekReadable=i;function M(y,v){return new Promise((o,c)=>{const l=[];f(y,{onData:s=>{v&&l.push(s)},onError:s=>{v?c(s):o(void 0)},onEnd:()=>{o(v?v(l):void 0)}})})}e.consumeStream=M;function f(y,v){y.on("error",o=>v.onError(o)),y.on("end",()=>v.onEnd()),y.on("data",o=>v.onData(o))}e.listenStream=f;function E(y,v){return new Promise((o,c)=>{const l=new R.DisposableStore,s=[],t=h=>{if(s.push(h),s.length>v)return l.dispose(),y.pause(),o({stream:y,buffer:s,ended:!1})},r=h=>c(h),a=()=>o({stream:y,buffer:s,ended:!0});l.add((0,R.toDisposable)(()=>y.removeListener("error",r))),y.on("error",r),l.add((0,R.toDisposable)(()=>y.removeListener("end",a))),y.on("end",a),l.add((0,R.toDisposable)(()=>y.removeListener("data",t))),y.on("data",t)})}e.peekStream=E;function g(y,v){const o=P(v);return o.end(y),o}e.toStream=g;function d(y){let v=!1;return{read:()=>v?null:(v=!0,y)}}e.toReadable=d;function w(y,v,o){const c=P(o);return f(y,{onData:l=>c.write(v.data(l)),onError:l=>c.error(v.error?v.error(l):l),onEnd:()=>c.end()}),c}e.transform=w}),define(Z[20],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function p(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=p;const R=/{(\d+)}/g;function L(q,...te){return te.length===0?q:q.replace(R,function(oe,ae){const de=parseInt(ae,10);return isNaN(de)||de<0||de>=te.length?oe:te[de]})}e.format=L;function b(q){return q.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=b;function P(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function n(q,te){let oe=0;const ae=te.charCodeAt(0);for(let de=q.length-1;de>=0;de--)q.charCodeAt(de)===ae&&oe++;return oe}e.count=n;function S(q,te,oe="\u2026"){return q.length<=te?q:`${q.substr(0,te)}${oe}`}e.truncate=S;function i(q,te=" "){const oe=M(q,te);return f(oe,te)}e.trim=i;function M(q,te){if(!q||!te)return q;const oe=te.length;if(oe===0||q.length===0)return q;let ae=0;for(;q.indexOf(te,ae)===ae;)ae=ae+oe;return q.substring(ae)}e.ltrim=M;function f(q,te){if(!q||!te)return q;const oe=te.length,ae=q.length;if(oe===0||ae===0)return q;let de=ae,ve=-1;for(;ve=q.lastIndexOf(te,de-1),!(ve===-1||ve+oe!==de);){if(ve===0)return"";de=ve}return q.substring(0,de)}e.rtrim=f;function E(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=E;function g(q){return q.replace(/\*/g,"")}e.stripWildcards=g;function d(q,te,oe={}){if(!q)throw new Error("Cannot create regex from empty string");te||(q=P(q)),oe.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let ae="";return oe.global&&(ae+="g"),oe.matchCase||(ae+="i"),oe.multiline&&(ae+="m"),oe.unicode&&(ae+="u"),new RegExp(q,ae)}e.createRegExp=d;function w(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function y(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=y;function v(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=v;function o(q){return q.split(/\r\n|\r|\n/)}e.splitLines=o;function c(q){for(let te=0,oe=q.length;te<oe;te++){const ae=q.charCodeAt(te);if(ae!==32&&ae!==9)return te}return-1}e.firstNonWhitespaceIndex=c;function l(q,te=0,oe=q.length){for(let ae=te;ae<oe;ae++){const de=q.charCodeAt(ae);if(de!==32&&de!==9)return q.substring(te,ae)}return q.substring(te,oe)}e.getLeadingWhitespace=l;function s(q,te=q.length-1){for(let oe=te;oe>=0;oe--){const ae=q.charCodeAt(oe);if(ae!==32&&ae!==9)return oe}return-1}e.lastNonWhitespaceIndex=s;function t(q,te){return q<te?-1:q>te?1:0}e.compare=t;function r(q,te,oe=0,ae=q.length,de=0,ve=te.length){for(;oe<ae&&de<ve;oe++,de++){let Te=q.charCodeAt(oe),Fe=te.charCodeAt(de);if(Te<Fe)return-1;if(Te>Fe)return 1}const Se=ae-oe,ke=ve-de;return Se<ke?-1:Se>ke?1:0}e.compareSubstring=r;function a(q,te){return h(q,te,0,q.length,0,te.length)}e.compareIgnoreCase=a;function h(q,te,oe=0,ae=q.length,de=0,ve=te.length){for(;oe<ae&&de<ve;oe++,de++){let Te=q.charCodeAt(oe),Fe=te.charCodeAt(de);if(Te!==Fe){const Ne=Te-Fe;if(!(Ne===32&&m(Fe))&&!(Ne===-32&&m(Te)))return u(Te)&&u(Fe)?Ne:r(q.toLowerCase(),te.toLowerCase(),oe,ae,de,ve)}}const Se=ae-oe,ke=ve-de;return Se<ke?-1:Se>ke?1:0}e.compareSubstringIgnoreCase=h;function u(q){return q>=97&&q<=122}e.isLowerAsciiLetter=u;function m(q){return q>=65&&q<=90}e.isUpperAsciiLetter=m;function I(q){return u(q)||m(q)}function A(q,te){return q.length===te.length&&T(q,te)}e.equalsIgnoreCase=A;function T(q,te,oe=q.length){for(let ae=0;ae<oe;ae++){const de=q.charCodeAt(ae),ve=te.charCodeAt(ae);if(de!==ve){if(I(de)&&I(ve)){const Se=Math.abs(de-ve);if(Se!==0&&Se!==32)return!1}else if(String.fromCharCode(de).toLowerCase()!==String.fromCharCode(ve).toLowerCase())return!1}}return!0}function N(q,te){const oe=te.length;return te.length>q.length?!1:T(q,te,oe)}e.startsWithIgnoreCase=N;function $(q,te){let oe,ae=Math.min(q.length,te.length);for(oe=0;oe<ae;oe++)if(q.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return ae}e.commonPrefixLength=$;function X(q,te){let oe,ae=Math.min(q.length,te.length);const de=q.length-1,ve=te.length-1;for(oe=0;oe<ae;oe++)if(q.charCodeAt(de-oe)!==te.charCodeAt(ve-oe))return oe;return ae}e.commonSuffixLength=X;function ne(q){return 55296<=q&&q<=56319}e.isHighSurrogate=ne;function Y(q){return 56320<=q&&q<=57343}e.isLowSurrogate=Y;function Q(q,te){return(q-55296<<10)+(te-56320)+65536}e.computeCodePoint=Q;function B(q,te,oe){const ae=q.charCodeAt(oe);if(ne(ae)&&oe+1<te){const de=q.charCodeAt(oe+1);if(Y(de))return Q(ae,de)}return ae}e.getNextCodePoint=B;function z(q,te){const oe=q.charCodeAt(te-1);if(Y(oe)&&te>1){const ae=q.charCodeAt(te-2);if(ne(ae))return Q(ae,oe)}return oe}function U(q,te){const oe=Ue.getInstance(),ae=te,de=q.length,ve=B(q,de,te);te+=ve>=65536?2:1;let Se=oe.getGraphemeBreakType(ve);for(;te<de;){const ke=B(q,de,te),Te=oe.getGraphemeBreakType(ke);if(Ve(Se,Te))break;te+=ke>=65536?2:1,Se=Te}return te-ae}e.nextCharLength=U;function W(q,te){const oe=Ue.getInstance(),ae=te,de=z(q,te);te-=de>=65536?2:1;let ve=oe.getGraphemeBreakType(de);for(;te>0;){const Se=z(q,te),ke=oe.getGraphemeBreakType(Se);if(Ve(ke,ve))break;te-=Se>=65536?2:1,ve=ke}return ae-te}e.prevCharLength=W;function O(q,te){const oe=Ue.getInstance(),ae=q.length,de=te,ve=B(q,ae,te),Se=oe.getGraphemeBreakType(ve);te+=ve>=65536?2:1;let ke=Se;for(;te<ae;){const Fe=B(q,ae,te),Ne=oe.getGraphemeBreakType(Fe);if(Ve(ke,Ne))break;te+=Fe>=65536?2:1,ke=Ne}const Te=te;for(te=de,ke=Se;te>0;){const Fe=z(q,te),Ne=oe.getGraphemeBreakType(Fe);if(Ve(Ne,ke))break;te-=Fe>=65536?2:1,ke=Ne}return[te,Te]}function D(q,te){return te>0&&Y(q.charCodeAt(te))?O(q,te-1):O(q,te)}e.getCharContainingOffset=D;function k(q){const te=q.length;let oe=0,ae=0;for(;ae<te;){const Se=B(q,te,ae);ae+=Se>=65536?2:1,Se<128?oe+=1:Se<2048?oe+=2:Se<65536?oe+=3:oe+=4}const de=new Uint8Array(oe);ae=0;let ve=0;for(;ae<te;){const Se=B(q,te,ae);ae+=Se>=65536?2:1,Se<128?de[ve++]=Se:Se<2048?(de[ve++]=192|(Se&1984)>>>6,de[ve++]=128|(Se&63)>>>0):Se<65536?(de[ve++]=224|(Se&61440)>>>12,de[ve++]=128|(Se&4032)>>>6,de[ve++]=128|(Se&63)>>>0):(de[ve++]=240|(Se&1835008)>>>18,de[ve++]=128|(Se&258048)>>>12,de[ve++]=128|(Se&4032)>>>6,de[ve++]=128|(Se&63)>>>0)}return de}e.encodeUTF8=k;function F(q){const te=q.byteLength,oe=[];let ae=0;for(;ae<te;){const de=q[ae];let ve;if(de>=240&&ae+3<te?ve=(q[ae++]&7)<<18>>>0|(q[ae++]&63)<<12>>>0|(q[ae++]&63)<<6>>>0|(q[ae++]&63)<<0>>>0:de>=224&&ae+2<te?ve=(q[ae++]&15)<<12>>>0|(q[ae++]&63)<<6>>>0|(q[ae++]&63)<<0>>>0:de>=192&&ae+1<te?ve=(q[ae++]&31)<<6>>>0|(q[ae++]&63)<<0>>>0:ve=q[ae++],ve>=0&&ve<=55295||ve>=57344&&ve<=65535)oe.push(String.fromCharCode(ve));else if(ve>=65536&&ve<=1114111){const Se=ve-65536,ke=55296+((Se&1047552)>>>10),Te=56320+((Se&1023)>>>0);oe.push(String.fromCharCode(ke)),oe.push(String.fromCharCode(Te))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=F;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function C(q){return _.test(q)}e.containsRTL=C;const j=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function G(q){return j.test(q)}e.containsEmoji=G;const K=/^[\t\n\r\x20-\x7E]*$/;function V(q){return K.test(q)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function J(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=J;function re(q){for(let te=0,oe=q.length;te<oe;te++)if(ie(q.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=re;function ie(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=ie;function se(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=se;function me(q,te){if(q.length<te)return q;const oe=/\b/g;let ae=0;for(;oe.test(q)&&!(q.length-oe.lastIndex<te);)ae=oe.lastIndex,oe.lastIndex+=1;return q.substring(ae).replace(/^\s/,"")}e.lcut=me;const le=/\x1B\x5B[12]?K/g,ce=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function Ie(q){return q&&(q=q.replace(le,""),q=q.replace(ce,""),q=q.replace(ge,"")),q}e.removeAnsiEscapeCodes=Ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function We(q){return Re(q)?q.substr(1):q}e.stripUTF8BOM=We;function He(q,te){if(!q||!te||q.length<te.length)return!1;const oe=te.length,ae=q.toLowerCase();let de=0,ve=-1;for(;de<oe;){const Se=ae.indexOf(te[de],ve+1);if(Se<0)return!1;ve=Se,de++}return!0}e.fuzzyContains=He;function qe(q,te=!1){return q?(te&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=qe;function Ge(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=Ge;function nt(q,te=1){if(te===0)return"";let oe=-1;do oe=q.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?q:(q[oe-1]==="\r"&&oe--,q.substr(0,oe))}e.getNLines=nt;function Je(q){const te=90-65+1;return q=q%(2*te),q<te?String.fromCharCode(97+q):String.fromCharCode(65+q-te)}e.singleLetterHash=Je;function rt(q){return Ue.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=rt;function Ve(q,te){return q===0?te!==5&&te!==7:q===2&&te===3?!1:q===4||q===2||q===3||te===4||te===2||te===3?!0:!(q===8&&(te===8||te===9||te===11||te===12)||(q===11||q===9)&&(te===9||te===10)||(q===12||q===10)&&te===10||te===5||te===13||te===7||q===1||q===13&&te===14||q===6&&te===6)}e.breakBetweenGraphemeBreakType=Ve;var st;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(st=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=ot()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,ae=oe.length/3;let de=1;for(;de<=ae;)if(te<oe[3*de])de=2*de;else if(te>oe[3*de+1])de=2*de+1;else return oe[3*de+2];return 0}}Ue._INSTANCE=null;function ot(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(Z[21],x([0,1,20,57]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined",b=typeof TextEncoder!="undefined",P=typeof TextDecoder!="undefined";let n,S;class i{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return L?new i(Buffer.allocUnsafe(u)):new i(new Uint8Array(u))}static wrap(u){return L&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new i(u)}static fromString(u,m){return!((m==null?void 0:m.dontUseNodeBuffer)||!1)&&L?new i(Buffer.from(u)):b?(n||(n=new TextEncoder),new i(n.encode(u))):new i(p.encodeUTF8(u))}static concat(u,m){if(typeof m=="undefined"){m=0;for(let T=0,N=u.length;T<N;T++)m+=u[T].byteLength}const I=i.alloc(m);let A=0;for(let T=0,N=u.length;T<N;T++){const $=u[T];I.set($,A),A+=$.byteLength}return I}toString(){return L?this.buffer.toString():P?(S||(S=new TextDecoder),S.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(u,m){return new i(this.buffer.subarray(u,m))}set(u,m){u instanceof i?this.buffer.set(u.buffer,m):this.buffer.set(u,m)}readUInt32BE(u){return E(this.buffer,u)}writeUInt32BE(u,m){g(this.buffer,u,m)}readUInt32LE(u){return d(this.buffer,u)}writeUInt32LE(u,m){w(this.buffer,u,m)}readUInt8(u){return y(this.buffer,u)}writeUInt8(u,m){v(this.buffer,u,m)}}e.VSBuffer=i;function M(h,u){return h[u+0]<<0>>>0|h[u+1]<<8>>>0}e.readUInt16LE=M;function f(h,u,m){h[m+0]=u&255,u=u>>>8,h[m+1]=u&255}e.writeUInt16LE=f;function E(h,u){return h[u]*2**24+h[u+1]*2**16+h[u+2]*2**8+h[u+3]}e.readUInt32BE=E;function g(h,u,m){h[m+3]=u,u=u>>>8,h[m+2]=u,u=u>>>8,h[m+1]=u,u=u>>>8,h[m]=u}e.writeUInt32BE=g;function d(h,u){return h[u+0]<<0>>>0|h[u+1]<<8>>>0|h[u+2]<<16>>>0|h[u+3]<<24>>>0}e.readUInt32LE=d;function w(h,u,m){h[m+0]=u&255,u=u>>>8,h[m+1]=u&255,u=u>>>8,h[m+2]=u&255,u=u>>>8,h[m+3]=u&255}e.writeUInt32LE=w;function y(h,u){return h[u]}e.readUInt8=y;function v(h,u,m){h[m]=u}e.writeUInt8=v;function o(h){return R.consumeReadable(h,u=>i.concat(u))}e.readableToBuffer=o;function c(h){return R.toReadable(h)}e.bufferToReadable=c;function l(h){return R.consumeStream(h,u=>i.concat(u))}e.streamToBuffer=l;async function s(h){return h.ended?i.concat(h.buffer):i.concat([...h.buffer,await l(h.stream)])}e.bufferedStreamToBuffer=s;function t(h){return R.toStream(h,u=>i.concat(u))}e.bufferToStream=t;function r(h){return R.transform(h,{data:u=>typeof u=="string"?i.fromString(u):i.wrap(u)},u=>i.concat(u))}e.streamToBufferReadableStream=r;function a(h){return R.newWriteableStream(u=>i.concat(u),h)}e.newWriteableBufferStream=a}),define(Z[78],x([0,1,20]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(v){return L(v,0)}e.hash=R;function L(v,o){switch(typeof v){case"object":return v===null?b(349,o):Array.isArray(v)?S(v,o):i(v,o);case"string":return n(v,o);case"boolean":return P(v,o);case"number":return b(v,o);case"undefined":return b(937,o);default:return b(617,o)}}e.doHash=L;function b(v,o){return(o<<5)-o+v|0}function P(v,o){return b(v?433:863,o)}function n(v,o){o=b(149417,o);for(let c=0,l=v.length;c<l;c++)o=b(v.charCodeAt(c),o);return o}e.stringHash=n;function S(v,o){return o=b(104579,o),v.reduce((c,l)=>L(l,c),o)}function i(v,o){return o=b(181387,o),Object.keys(v).sort().reduce((c,l)=>(c=n(l,c),L(v[l],c)),o)}class M{constructor(){this._value=0}get value(){return this._value}hash(o){return this._value=L(o,this._value),this._value}}e.Hasher=M;var f;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(f||(f={}));function E(v,o,c=32){const l=c-o,s=~((1<<l)-1);return(v<<o|(s&v)>>>l)>>>0}function g(v,o=0,c=v.byteLength,l=0){for(let s=0;s<c;s++)v[o+s]=l}function d(v,o,c="0"){for(;v.length<o;)v=c+v;return v}function w(v,o=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(c=>c.toString(16).padStart(2,"0")).join(""):d((v>>>0).toString(16),o/4)}e.toHexString=w;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(o){const c=o.length;if(c!==0){const l=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,r,a;for(t!==0?(r=t,a=-1,t=0):(r=o.charCodeAt(0),a=0);;){let h=r;if(p.isHighSurrogate(r))if(a+1<c){const u=o.charCodeAt(a+1);p.isLowSurrogate(u)?(a++,h=p.computeCodePoint(r,u)):h=65533}else{t=r;break}else p.isLowSurrogate(r)&&(h=65533);if(s=this._push(l,s,h),a++,a<c)r=o.charCodeAt(a);else break}this._buffLen=s,this._leftoverHighSurrogate=t}}_push(o,c,l){return l<128?o[c++]=l:l<2048?(o[c++]=192|(l&1984)>>>6,o[c++]=128|(l&63)>>>0):l<65536?(o[c++]=224|(l&61440)>>>12,o[c++]=128|(l&4032)>>>6,o[c++]=128|(l&63)>>>0):(o[c++]=240|(l&1835008)>>>18,o[c++]=128|(l&258048)>>>12,o[c++]=128|(l&4032)>>>6,o[c++]=128|(l&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const o=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(o/4294967296),!1),this._buffDV.setUint32(60,o%4294967296,!1),this._step()}_step(){const o=y._bigBlock32,c=this._buffDV;for(let I=0;I<64;I+=4)o.setUint32(I,c.getUint32(I,!1),!1);for(let I=64;I<320;I+=4)o.setUint32(I,E(o.getUint32(I-12,!1)^o.getUint32(I-32,!1)^o.getUint32(I-56,!1)^o.getUint32(I-64,!1),1),!1);let l=this._h0,s=this._h1,t=this._h2,r=this._h3,a=this._h4,h,u,m;for(let I=0;I<80;I++)I<20?(h=s&t|~s&r,u=1518500249):I<40?(h=s^t^r,u=1859775393):I<60?(h=s&t|s&r|t&r,u=2400959708):(h=s^t^r,u=3395469782),m=E(l,5)+h+a+u+o.getUint32(I*4,!1)&4294967295,a=r,r=t,t=E(s,30),s=l,l=m;this._h0=this._h0+l&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[13],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(u){return Array.isArray(u)}e.isArray=p;function R(u){return typeof u=="string"}e.isString=R;function L(u){return Array.isArray(u)&&u.every(m=>R(m))}e.isStringArray=L;function b(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=b;function P(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=P;function n(u){return u===!0||u===!1}e.isBoolean=n;function S(u){return typeof u=="undefined"}e.isUndefined=S;function i(u){return!M(u)}e.isDefined=i;function M(u){return S(u)||u===null}e.isUndefinedOrNull=M;function f(u,m){if(!u)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=f;function E(u){if(M(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=E;function g(...u){const m=[];for(let I=0;I<u.length;I++){const A=u[I];if(M(A))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);m.push(A)}return m}e.assertAllDefined=g;const d=Object.prototype.hasOwnProperty;function w(u){if(!b(u))return!1;for(let m in u)if(d.call(u,m))return!1;return!0}e.isEmptyObject=w;function y(u){return typeof u=="function"}e.isFunction=y;function v(...u){return u.length>0&&u.every(y)}e.areFunctions=v;function o(u,m){const I=Math.min(u.length,m.length);for(let A=0;A<I;A++)c(u[A],m[A])}e.validateConstraints=o;function c(u,m){if(R(m)){if(typeof u!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(y(m)){try{if(u instanceof m)return}catch(I){}if(!M(u)&&u.constructor===m||m.length===1&&m.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function l(u){let m=[],I=Object.getPrototypeOf(u);for(;Object.prototype!==I;)m=m.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return m}e.getAllPropertyNames=l;function s(u){const m=[];for(const I of l(u))typeof u[I]=="function"&&m.push(I);return m}e.getAllMethodNames=s;function t(u,m){const I=T=>function(){const N=Array.prototype.slice.call(arguments,0);return m(T,N)};let A={};for(const T of u)A[T]=I(T);return A}e.createProxyObject=t;function r(u){return u===null?void 0:u}e.withNullAsUndefined=r;function a(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=a;function h(u){return class{constructor(){return new Proxy({},{get(m,I){if(m[I])return m[I];throw new Error(`Not Implemented: ${u}->${String(I)}`)}})}}}e.NotImplementedProxy=h}),define(Z[29],x([0,1,3,20,8,13]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function P(r){return r===47||r===92}e.isPathSeparator=P;function n(r){return r.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=n;function S(r,a=L.posix.sep){if(!r)return"";const h=r.length,u=r.charCodeAt(0);if(P(u)){if(P(r.charCodeAt(1))&&!P(r.charCodeAt(2))){let I=3;const A=I;for(;I<h&&!P(r.charCodeAt(I));I++);if(A!==I&&!P(r.charCodeAt(I+1))){for(I+=1;I<h;I++)if(P(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,a)}}return a}else if(y(u)&&r.charCodeAt(1)===58)return P(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let m=r.indexOf("://");if(m!==-1){for(m+=3;m<h;m++)if(P(r.charCodeAt(m)))return r.slice(0,m+1)}return""}e.getRoot=S;function i(r){if(!p.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let h=2;const u=h;for(;h<r.length&&(a=r.charCodeAt(h),a!==92);h++);return!(u===h||(a=r.charCodeAt(h+1),isNaN(a)||a===92))}e.isUNC=i;const M=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,a=p.isWindows){const h=a?M:f;return!(!r||r.length===0||/^\s+$/.test(r)||(h.lastIndex=0,h.test(r))||a&&E.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=g;function d(r,a,h){const u=r===a;return!h||u?u:!r||!a?!1:(0,R.equalsIgnoreCase)(r,a)}e.isEqual=d;function w(r,a,h,u=L.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(h){if(!(0,R.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let I=a.length;return a.charAt(a.length-1)===u&&I--,r.charAt(I)===u}return a.charAt(a.length-1)!==u&&(a+=u),r.indexOf(a)===0}e.isEqualOrParent=w;function y(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=y;function v(r,a){return p.isWindows&&r.endsWith(":")&&(r+=L.sep),(0,L.isAbsolute)(r)||(r=(0,L.join)(a,r)),r=(0,L.normalize)(r),p.isWindows?(r=(0,R.rtrim)(r,L.sep),r.endsWith(":")&&(r+=L.sep)):(r=(0,R.rtrim)(r,L.sep),r||(r=L.sep)),r}e.sanitizeFilePath=v;function o(r){const a=(0,L.normalize)(r);return p.isWindows?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===L.posix.sep}e.isRootOrDriveLetter=o;function c(r){return p.isWindows?y(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(r){return c(r)?r[0]:void 0}e.getDriveLetter=l;function s(r,a,h){return a.length>r.length?-1:r===a?0:(h&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=s;function t(r){const a=r.split(":");let h,u,m;if(a.forEach(I=>{const A=Number(I);(0,b.isNumber)(A)?u===void 0?u=A:m===void 0&&(m=A):h=h?[h,I].join(":"):I}),!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:u!==void 0?u:void 0,column:m!==void 0?m:u!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Z[44],x([0,1,13]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const w=Array.isArray(d)?[]:{};return Object.keys(d).forEach(y=>{d[y]&&typeof d[y]=="object"?w[y]=R(d[y]):w[y]=d[y]}),w}e.deepClone=R;function L(d){if(!d||typeof d!="object")return d;const w=[d];for(;w.length>0;){const y=w.shift();Object.freeze(y);for(const v in y)if(b.call(y,v)){const o=y[v];typeof o=="object"&&!Object.isFrozen(o)&&w.push(o)}}return d}e.deepFreeze=L;const b=Object.prototype.hasOwnProperty;function P(d,w){return n(d,w,new Set)}e.cloneAndChange=P;function n(d,w,y){if((0,p.isUndefinedOrNull)(d))return d;const v=w(d);if(typeof v!="undefined")return v;if((0,p.isArray)(d)){const o=[];for(const c of d)o.push(n(c,w,y));return o}if((0,p.isObject)(d)){if(y.has(d))throw new Error("Cannot clone recursive data-structure");y.add(d);const o={};for(let c in d)b.call(d,c)&&(o[c]=n(d[c],w,y));return y.delete(d),o}return d}function S(d,w,y=!0){return(0,p.isObject)(d)?((0,p.isObject)(w)&&Object.keys(w).forEach(v=>{v in d?y&&((0,p.isObject)(d[v])&&(0,p.isObject)(w[v])?S(d[v],w[v],y):d[v]=w[v]):d[v]=w[v]}),d):w}e.mixin=S;function i(d,w){if(d===w)return!0;if(d==null||w===null||w===void 0||typeof d!=typeof w||typeof d!="object"||Array.isArray(d)!==Array.isArray(w))return!1;let y,v;if(Array.isArray(d)){if(d.length!==w.length)return!1;for(y=0;y<d.length;y++)if(!i(d[y],w[y]))return!1}else{const o=[];for(v in d)o.push(v);o.sort();const c=[];for(v in w)c.push(v);if(c.sort(),!i(o,c))return!1;for(y=0;y<o.length;y++)if(!i(d[o[y]],w[o[y]]))return!1}return!0}e.equals=i;function M(d){const w=new Set;return JSON.stringify(d,(y,v)=>{if((0,p.isObject)(v)||Array.isArray(v)){if(w.has(v))return"[Circular]";w.add(v)}return v})}e.safeStringify=M;function f(d,w,y){const v=w(d);return typeof v=="undefined"?y:v}e.getOrDefault=f;function E(d,w){const y=Object.create(null);return!d||!w||Object.keys(w).forEach(o=>{const c=d[o],l=w[o];i(c,l)||(y[o]=l)}),y}e.distinct=E;function g(d,w){const y=w.toLowerCase(),v=Object.keys(d).find(o=>o.toLowerCase()===y);return v?d[v]:d[w]}e.getCaseInsensitive=g}),define(Z[7],x([0,1,3,8]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,b=/^\//,P=/^\/\//;function n(a,h){if(!a.scheme&&h)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!L.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!b.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(a,h){return!a&&!h?"file":a}function i(a,h){switch(a){case"https":case"http":case"file":h?h[0]!==f&&(h=f+h):h=f;break}return h}const M="",f="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(h,u,m,I,A,T=!1){typeof h=="object"?(this.scheme=h.scheme||M,this.authority=h.authority||M,this.path=h.path||M,this.query=h.query||M,this.fragment=h.fragment||M):(this.scheme=S(h,T),this.authority=u||M,this.path=i(this.scheme,m||M),this.query=I||M,this.fragment=A||M,n(this,T))}static isUri(h){return h instanceof g?!0:h?typeof h.authority=="string"&&typeof h.fragment=="string"&&typeof h.path=="string"&&typeof h.query=="string"&&typeof h.scheme=="string"&&typeof h.fsPath=="string"&&typeof h.with=="function"&&typeof h.toString=="function":!1}get fsPath(){return c(this,!1)}with(h){if(!h)return this;let{scheme:u,authority:m,path:I,query:A,fragment:T}=h;return u===void 0?u=this.scheme:u===null&&(u=M),m===void 0?m=this.authority:m===null&&(m=M),I===void 0?I=this.path:I===null&&(I=M),A===void 0?A=this.query:A===null&&(A=M),T===void 0?T=this.fragment:T===null&&(T=M),u===this.scheme&&m===this.authority&&I===this.path&&A===this.query&&T===this.fragment?this:new w(u,m,I,A,T)}static parse(h,u=!1){const m=E.exec(h);return m?new w(m[2]||M,r(m[4]||M),r(m[5]||M),r(m[7]||M),r(m[9]||M),u):new w(M,M,M,M,M)}static file(h){let u=M;if(p.isWindows&&(h=h.replace(/\\/g,f)),h[0]===f&&h[1]===f){const m=h.indexOf(f,2);m===-1?(u=h.substring(2),h=f):(u=h.substring(2,m),h=h.substring(m)||f)}return new w("file",u,h,M,M)}static from(h){return new w(h.scheme,h.authority,h.path,h.query,h.fragment)}static joinPath(h,...u){if(!h.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return p.isWindows&&h.scheme==="file"?m=g.file(R.win32.join(c(h,!0),...u)).path:m=R.posix.join(h.path,...u),h.with({path:m})}toString(h=!1){return l(this,h)}toJSON(){return this}static revive(h){if(h){if(h instanceof g)return h;{const u=new w(h);return u._formatted=h.external,u._fsPath=h._sep===d?h.fsPath:null,u}}else return h}}e.URI=g;const d=p.isWindows?1:void 0;class w extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(h=!1){return h?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const h={$mid:1};return this._fsPath&&(h.fsPath=this._fsPath,h._sep=d),this._formatted&&(h.external=this._formatted),this.path&&(h.path=this.path),this.scheme&&(h.scheme=this.scheme),this.authority&&(h.authority=this.authority),this.query&&(h.query=this.query),this.fragment&&(h.fragment=this.fragment),h}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(a,h){let u,m=-1;for(let I=0;I<a.length;I++){const A=a.charCodeAt(I);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||h&&A===47)m!==-1&&(u+=encodeURIComponent(a.substring(m,I)),m=-1),u!==void 0&&(u+=a.charAt(I));else{u===void 0&&(u=a.substr(0,I));const T=y[A];T!==void 0?(m!==-1&&(u+=encodeURIComponent(a.substring(m,I)),m=-1),u+=T):m===-1&&(m=I)}}return m!==-1&&(u+=encodeURIComponent(a.substring(m))),u!==void 0?u:a}function o(a){let h;for(let u=0;u<a.length;u++){const m=a.charCodeAt(u);m===35||m===63?(h===void 0&&(h=a.substr(0,u)),h+=y[m]):h!==void 0&&(h+=a[u])}return h!==void 0?h:a}function c(a,h){let u;return a.authority&&a.path.length>1&&a.scheme==="file"?u=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?h?u=a.path.substr(1):u=a.path[1].toLowerCase()+a.path.substr(2):u=a.path,p.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=c;function l(a,h){const u=h?o:v;let m="",{scheme:I,authority:A,path:T,query:N,fragment:$}=a;if(I&&(m+=I,m+=":"),(A||I==="file")&&(m+=f,m+=f),A){let X=A.indexOf("@");if(X!==-1){const ne=A.substr(0,X);A=A.substr(X+1),X=ne.indexOf(":"),X===-1?m+=u(ne,!1):(m+=u(ne.substr(0,X),!1),m+=":",m+=u(ne.substr(X+1),!1)),m+="@"}A=A.toLowerCase(),X=A.indexOf(":"),X===-1?m+=u(A,!1):(m+=u(A.substr(0,X),!1),m+=A.substr(X))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const X=T.charCodeAt(1);X>=65&&X<=90&&(T=`/${String.fromCharCode(X+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const X=T.charCodeAt(0);X>=65&&X<=90&&(T=`${String.fromCharCode(X+32)}:${T.substr(2)}`)}m+=u(T,!0)}return N&&(m+="?",m+=u(N,!1)),$&&(m+="#",m+=h?$:v($,!1)),m}function s(a){try{return decodeURIComponent(a)}catch(h){return a.length>3?a.substr(0,3)+s(a.substr(3)):a}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(a){return a.match(t)?a.replace(t,h=>s(h)):a}}),define(Z[105],x([0,1,7]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(i){const M=i;return M&&typeof M.type=="string"&&typeof M.severity=="string"}e.isRemoteConsoleLog=R;function L(i){const M=[];let f;try{const E=JSON.parse(i.arguments),g=E[E.length-1];g&&g.__$stack&&(E.pop(),f=g.__$stack),M.push(...E)}catch(E){M.push("Unable to log remote console arguments",i.arguments)}return{args:M,stack:f}}e.parse=L;function b(i){if(typeof i!="string")return b(L(i).stack);const M=i;if(M){const f=P(M),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(E&&E.length===4)return{uri:p.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=b;function P(i){if(!i)return i;const M=i.indexOf(`
`);return M===-1?i:i.substring(0,M)}function n(i,M){const{args:f,stack:E}=L(i),g=typeof f[0]=="string"&&f.length===1;let d=P(E);d&&(d=`(${d.trim()})`);let w=[];if(typeof f[0]=="string"?d&&g?w=[`%c[${M}] %c${f[0]} %c${d}`,S("blue"),S(""),S("grey")]:w=[`%c[${M}] %c${f[0]}`,S("blue"),S(""),...f.slice(1)]:w=[`%c[${M}]%`,S("blue"),...f],d&&!g&&w.push(d),typeof console[i.severity]!="function")throw new Error("Unknown console method");console[i.severity].apply(console,w)}e.log=n;function S(i){return`color: ${i}`}}),define(Z[35],x([0,1,7,20]),function(H,e,p,R){"use strict";var L,b;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(l,s,t){let r=l.get(s);return r===void 0&&(r=t,l.set(s,r)),r}e.getOrSet=P;function n(l){const s=[];return l.forEach((t,r)=>{s.push(`${r} => ${t}`)}),`Map(${l.size}) {${s.join(", ")}}`}e.mapToString=n;function S(l){const s=[];return l.forEach(t=>{s.push(t)}),`Set(${l.size}) {${s.join(", ")}}`}e.setToString=S;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const t=s.charCodeAt(0),r=this._value.charCodeAt(this._pos);return t-r}value(){return this._value[this._pos]}}e.StringIterator=i;class M{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,R.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=M;class f{constructor(s=!0,t=!0){this._splitOnBackslash=s,this._caseSensitive=t}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,R.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var E;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(E||(E={}));class g{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,R.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(s){this._iter=s}static forUris(s=()=>!1){return new w(new g(s))}static forPaths(){return new w(new f)}static forStrings(){return new w(new i)}static forConfigKeys(){return new w(new M)}clear(){this._root=void 0}set(s,t){const r=this._iter.reset(s);let a;for(this._root||(this._root=new d,this._root.segment=r.value()),a=this._root;;){const u=r.cmp(a.segment);if(u>0)a.left||(a.left=new d,a.left.segment=r.value()),a=a.left;else if(u<0)a.right||(a.right=new d,a.right.segment=r.value()),a=a.right;else if(r.hasNext())r.next(),a.mid||(a.mid=new d,a.mid.segment=r.value()),a=a.mid;else break}const h=a.value;return a.value=t,a.key=s,h}get(s){var t;return(t=this._getNode(s))===null||t===void 0?void 0:t.value}_getNode(s){const t=this._iter.reset(s);let r=this._root;for(;r;){const a=t.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else break}return r}has(s){const t=this._getNode(s);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,t){const r=this._iter.reset(s),a=[];let h=this._root;for(;h;){const u=r.cmp(h.segment);if(u>0)a.push([1,h]),h=h.left;else if(u<0)a.push([-1,h]),h=h.right;else if(r.hasNext())r.next(),a.push([0,h]),h=h.mid;else{for(t?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;a.length>0&&h.isEmpty();){let[m,I]=a.pop();switch(m){case 1:I.left=void 0;break;case 0:I.mid=void 0;break;case-1:I.right=void 0;break}h=I}break}}}findSubstr(s){const t=this._iter.reset(s);let r=this._root,a;for(;r;){const h=t.cmp(r.segment);if(h>0)r=r.left;else if(h<0)r=r.right;else if(t.hasNext())t.next(),a=r.value||a,r=r.mid;else break}return r&&r.value||a}findSuperstr(s){const t=this._iter.reset(s);let r=this._root;for(;r;){const a=t.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(s){for(const[t,r]of this)s(r,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){s&&(yield*this._entries(s.left),s.value&&(yield[s.key,s.value]),yield*this._entries(s.mid),yield*this._entries(s.right))}}e.TernarySearchTree=w;class y{constructor(s,t){this[L]="ResourceMap",s instanceof y?(this.map=new Map(s.map),this.toKey=t!=null?t:y.defaultToKey):(this.map=new Map,this.toKey=s!=null?s:y.defaultToKey)}set(s,t){return this.map.set(this.toKey(s),t),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,t){typeof t!="undefined"&&(s=s.bind(t));for(let[r,a]of this.map)s(a,p.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield p.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[p.URI.parse(s[0]),s[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[p.URI.parse(s[0]),s[1]]}}e.ResourceMap=y,y.defaultToKey=l=>l.toString();var v;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class o{constructor(){this[b]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,t=0){const r=this._map.get(s);if(!!r)return t!==0&&this.touch(r,t),r.value}set(s,t,r=0){let a=this._map.get(s);if(a)a.value=t,r!==0&&this.touch(a,r);else{switch(a={key:s,value:t,next:void 0,previous:void 0},r){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(s,a),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const t=this._map.get(s);if(!!t)return this._map.delete(s),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}}forEach(s,t){const r=this._state;let a=this._head;for(;a;){if(t?s.bind(t)(a.value,a.key,this):s(a.value,a.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const s=this,t=this._state;let r=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const h={value:r.key,done:!1};return r=r.next,h}else return{value:void 0,done:!0}}};return a}values(){const s=this,t=this._state;let r=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const h={value:r.value,done:!1};return r=r.next,h}else return{value:void 0,done:!0}}};return a}entries(){const s=this,t=this._state;let r=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const h={value:[r.key,r.value],done:!1};return r=r.next,h}else return{value:void 0,done:!0}}};return a}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(!(s>=this.size)){if(s===0){this.clear();return}let t=this._head,r=this.size;for(;t&&r>s;)this._map.delete(t.key),t=t.next,r--;this._head=t,this._size=r,t&&(t.previous=void 0),this._state++}}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const t=s.next,r=s.previous;if(!t||!r)throw new Error("Invalid list");t.previous=r,r.next=t}s.next=void 0,s.previous=void 0,this._state++}touch(s,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(s===this._head)return;const r=s.next,a=s.previous;s===this._tail?(a.next=void 0,this._tail=a):(r.previous=a,a.next=r),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(t===2){if(s===this._tail)return;const r=s.next,a=s.previous;s===this._head?(r.previous=void 0,this._head=r):(r.previous=a,a.next=r),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((t,r)=>{s.push([r,t])}),s}fromJSON(s){this.clear();for(const[t,r]of s)this.set(t,r)}}e.LinkedMap=o;class c extends o{constructor(s,t=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,t=2){return super.get(s,t)}peek(s){return super.get(s,0)}set(s,t){return super.set(s,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c}),define(Z[106],x([0,1,21,20,7]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function b(i){return JSON.stringify(i,n)}e.stringify=b;function P(i){let M=JSON.parse(i);return M=S(M),M}e.parse=P;function n(i,M){return M instanceof RegExp?{$mid:2,source:M.source,flags:(0,R.regExpFlags)(M)}:M}function S(i,M=0){if(!i||M>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return L.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof p.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let f=0;f<i.length;++f)i[f]=S(i[f],M+1);else for(const f in i)Object.hasOwnProperty.call(i,f)&&(i[f]=S(i[f],M+1))}return i}e.revive=S}),define(Z[9],x([0,1,7,3]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.vscodeWebviewResource="vscode-webview-resource",n.extension="extension",n.vscodeFileResource="vscode-file"})(L=e.Schemas||(e.Schemas={}));class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,i,M){this._hosts[S]=i,this._ports[S]=M}setConnectionToken(S,i){this._connectionTokens[S]=i}rewrite(S){if(this._delegate)return this._delegate(S);const i=S.authority;let M=this._hosts[i];M&&M.indexOf(":")!==-1&&(M=`[${M}]`);const f=this._ports[i],E=this._connectionTokens[i];let g=`path=${encodeURIComponent(S.path)}`;return typeof E=="string"&&(g+=`&tkn=${encodeURIComponent(E)}`),p.URI.from({scheme:R.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${M}:${f}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new b;class P{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,i,M){const f=this.toUri(S,i);return f.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(f):R.isNative&&(M||R.isPreferringBrowserCodeLoad)&&f.scheme===L.file?f.with({scheme:L.vscodeFileResource,authority:f.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):f}asFileUri(S,i){const M=this.toUri(S,i);return M.scheme===L.vscodeFileResource?M.with({scheme:L.file,authority:M.authority!==this.FALLBACK_AUTHORITY?M.authority:null,query:null,fragment:null}):M}toUri(S,i){return p.URI.isUri(S)?S:p.URI.parse(i.toUrl(S))}}e.FileAccess=new P}),define(Z[65],x([0,1,35]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new p.LRUCache(1e4);function L(i){return S(i,"NFC",R)}e.normalizeNFC=L;const b=new p.LRUCache(1e4);function P(i){return S(i,"NFD",b)}e.normalizeNFD=P;const n=/[^\u0000-\u0080]/;function S(i,M,f){if(!e.canNormalize||!i)return i;const E=f.get(i);if(E)return E;let g;return n.test(i)?g=i.normalize(M):g=i,f.set(i,g),g}e.removeAccents=function(){if(e.canNormalize){const i=/[\u0300-\u036f]/g;return function(M){return P(M).replace(i,"")}}else return function(i){return i}}()}),define(Z[15],x([0,1,29,8,7,20,9,3]),function(H,e,p,R,L,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(g){return(0,L.uriToFsPath)(g,!0)}e.originalFSPath=S;class i{constructor(d){this._ignorePathCasing=d}compare(d,w,y=!1){return d===w?0:(0,b.compare)(this.getComparisonKey(d,y),this.getComparisonKey(w,y))}isEqual(d,w,y=!1){return d===w?!0:!d||!w?!1:this.getComparisonKey(d,y)===this.getComparisonKey(w,y)}getComparisonKey(d,w=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,w,y=!1){if(d.scheme===w.scheme){if(d.scheme===P.Schemas.file)return p.isEqualOrParent(S(d),S(w),this._ignorePathCasing(d))&&d.query===w.query&&(y||d.fragment===w.fragment);if((0,e.isEqualAuthority)(d.authority,w.authority))return p.isEqualOrParent(d.path,w.path,this._ignorePathCasing(d),"/")&&d.query===w.query&&(y||d.fragment===w.fragment)}return!1}joinPath(d,...w){return L.URI.joinPath(d,...w)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return R.posix.basename(d.path)}extname(d){return R.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let w;return d.scheme===P.Schemas.file?w=L.URI.file(R.dirname(S(d))).path:(w=R.posix.dirname(d.path),d.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),w="/")),d.with({path:w})}normalizePath(d){if(!d.path.length)return d;let w;return d.scheme===P.Schemas.file?w=L.URI.file(R.normalize(S(d))).path:w=R.posix.normalize(d.path),d.with({path:w})}relativePath(d,w){if(!(d.scheme!==w.scheme||!(0,e.isEqualAuthority)(d.authority,w.authority))){if(d.scheme===P.Schemas.file){const o=R.relative(S(d),S(w));return n.isWindows?p.toSlashes(o):o}let y=d.path||"/",v=w.path||"/";if(this._ignorePathCasing(d)){let o=0;for(const c=Math.min(y.length,v.length);o<c&&!(y.charCodeAt(o)!==v.charCodeAt(o)&&y.charAt(o).toLowerCase()!==v.charAt(o).toLowerCase());o++);y=v.substr(0,o)+y.substr(o)}return R.posix.relative(y,v)}}resolvePath(d,w){if(d.scheme===P.Schemas.file){const y=L.URI.file(R.resolve(S(d),w));return d.with({authority:y.authority,path:y.path})}return w.indexOf("/")===-1&&(w=p.toSlashes(w),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w)),d.with({path:R.posix.resolve(d.path,w)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,w){return d===w||(0,b.equalsIgnoreCase)(d,w)}hasTrailingPathSeparator(d,w=R.sep){if(d.scheme===P.Schemas.file){const y=S(d);return y.length>p.getRoot(y).length&&y[y.length-1]===w}else{const y=d.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,w=R.sep){return(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,w=R.sep){let y=!1;if(d.scheme===P.Schemas.file){const v=S(d);y=v!==void 0&&v.length===p.getRoot(v).length&&v[v.length-1]===w}else{w="/";const v=d.path;y=v.length===1&&v.charCodeAt(v.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path+"/"}):d}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(g=>g.scheme===P.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new i(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function M(g,d){const w=[];for(let y=0;y<g.length;y++){const v=d(g[y]);g.some((o,c)=>c===y?!1:(0,e.isEqualOrParent)(v,d(o)))||w.push(g[y])}return w}e.distinctParents=M;var f;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function d(w){const y=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(c=>{const[l,s]=c.split(":");l&&s&&y.set(l,s)});const o=w.path.substring(0,w.path.indexOf(";"));return o&&y.set(g.META_DATA_MIME,o),y}g.parseMetaData=d})(f=e.DataUri||(e.DataUri={}));function E(g,d,w){if(d){let y=g.path;return y&&y[0]!==R.posix.sep&&(y=R.posix.sep+y),g.with({scheme:w,authority:d,path:y})}return g.with({scheme:w})}e.toLocalResource=E}),define(Z[10],x([0,1,25,19,4,2,76,15]),function(H,e,p,R,L,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(O){return!!O&&typeof O.then=="function"}e.isThenable=S;function i(O){const D=new p.CancellationTokenSource,k=O(D.token),F=new Promise((_,C)=>{D.token.onCancellationRequested(()=>{C((0,R.canceled)())}),Promise.resolve(k).then(j=>{D.dispose(),_(j)},j=>{D.dispose(),C(j)})});return new class{cancel(){D.cancel()}then(_,C){return F.then(_,C)}catch(_){return this.then(void 0,_)}finally(_){return F.finally(_)}}}e.createCancelablePromise=i;function M(O,D,k){return Promise.race([O,new Promise(F=>D.onCancellationRequested(()=>F(k)))])}e.raceCancellation=M;async function f(O){let D=-1;const k=O.map((_,C)=>_.then(j=>(D=C,j))),F=await Promise.race(k);return O.forEach((_,C)=>{C!==D&&_.cancel()}),F}e.raceCancellablePromises=f;function E(O,D,k){let F;const _=setTimeout(()=>{F==null||F(void 0),k==null||k()},D);return Promise.race([O.finally(()=>clearTimeout(_)),new Promise(C=>F=C)])}e.raceTimeout=E;function g(O){return new Promise((D,k)=>{const F=O();S(F)?F.then(D,k):D(F)})}e.asPromise=g;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(D){if(this.activePromise){if(this.queuedPromiseFactory=D,!this.queuedPromise){const k=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(k,k).then(F)})}return new Promise((k,F)=>{this.queuedPromise.then(k,F)})}return this.activePromise=D(),new Promise((k,F)=>{this.activePromise.then(_=>{this.activePromise=null,k(_)},_=>{this.activePromise=null,F(_)})})}}e.Throttler=d;class w{constructor(){this.current=Promise.resolve(null)}queue(D){return this.current=this.current.then(()=>D(),()=>D())}}e.Sequencer=w;class y{constructor(){this.promiseMap=new Map}queue(D,k){var F;const C=((F=this.promiseMap.get(D))!==null&&F!==void 0?F:Promise.resolve()).catch(()=>{}).then(k).finally(()=>{this.promiseMap.get(D)===C&&this.promiseMap.delete(D)});return this.promiseMap.set(D,C),C}}e.SequencerByKey=y;class v{constructor(D){this.defaultDelay=D,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(D,k=this.defaultDelay){return this.task=D,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,_)=>{this.doResolve=F,this.doReject=_}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},k),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class o{constructor(D){this.delayer=new v(D),this.throttler=new d}trigger(D,k){return this.delayer.trigger(()=>this.throttler.queue(D),k)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=o;class c{constructor(){this._isOpen=!1,this._promise=new Promise((D,k)=>{this._completePromise=D})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class l extends c{constructor(D){super();this._timeout=setTimeout(()=>this.open(),D)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function s(O,D){return D?new Promise((k,F)=>{const _=setTimeout(k,O);D.onCancellationRequested(()=>{clearTimeout(_),F((0,R.canceled)())})}):i(k=>s(O,k))}e.timeout=s;function t(O,D=0){const k=setTimeout(O,D);return(0,b.toDisposable)(()=>clearTimeout(k))}e.disposableTimeout=t;function r(O){return O.then(void 0,D=>{})}e.ignoreErrors=r;function a(O){const D=[];let k=0;const F=O.length;function _(){return k<F?O[k++]():null}function C(j){j!=null&&D.push(j);const G=_();return G?G.then(C):Promise.resolve(D)}return Promise.resolve(null).then(C)}e.sequence=a;function h(O,D=F=>!!F,k=null){let F=0;const _=O.length,C=()=>{if(F>=_)return Promise.resolve(k);const j=O[F++];return Promise.resolve(j()).then(K=>D(K)?Promise.resolve(K):C())};return C()}e.first=h;function u(O,D=F=>!!F,k=null){if(O.length===0)return Promise.resolve(k);let F=O.length;const _=()=>{var C,j;F=-1;for(const G of O)(j=(C=G).cancel)===null||j===void 0||j.call(C)};return new Promise((C,j)=>{for(const G of O)G.then(K=>{--F>=0&&D(K)?(_(),C(K)):F===0&&C(k)}).catch(K=>{--F>=0&&(_(),j(K))})})}e.firstParallel=u;class m{constructor(D){this._size=0,this.maxDegreeOfParalellism=D,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(D){return this._size++,new Promise((k,F)=>{this.outstandingPromises.push({factory:D,c:k,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const D=this.outstandingPromises.shift();this.runningPromises++;const k=D.factory();k.then(D.c,D.e),k.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=m;class I extends m{constructor(){super(1)}}e.Queue=I;class A{constructor(){this.queues=new Map}queueFor(D,k=n.extUri){const F=k.getComparisonKey(D);let _=this.queues.get(F);return _||(_=new I,L.Event.once(_.onFinished)(()=>{_==null||_.dispose(),this.queues.delete(F)}),this.queues.set(F,_)),_}dispose(){this.queues.forEach(D=>D.dispose()),this.queues.clear()}}e.ResourceQueue=A;class T{constructor(D,k){this._token=-1,typeof D=="function"&&typeof k=="number"&&this.setIfNotSet(D,k)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(D,k){this.cancel(),this._token=setTimeout(()=>{this._token=-1,D()},k)}setIfNotSet(D,k){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,D()},k))}}e.TimeoutTimer=T;class N{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(D,k){this.cancel(),this._token=setInterval(()=>{D()},k)}}e.IntervalTimer=N;class ${constructor(D,k){this.timeoutToken=-1,this.runner=D,this.timeout=k,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(D=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,D)}get delay(){return this.timeout}set delay(D){this.timeout=D}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=$;class X extends ${constructor(D,k){super(D,k);this.units=[]}work(D){this.units.push(D),this.isScheduled()||this.schedule()}doRun(){const D=this.units;this.units=[],this.runner&&this.runner(D)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const O=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=D=>{const k=setTimeout(()=>D(O));let F=!1;return{dispose(){F||(F=!0,clearTimeout(k))}}}}else e.runWhenIdle=(O,D)=>{const k=requestIdleCallback(O,typeof D=="number"?{timeout:D}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(k))}}}}();class ne{constructor(D){this._didRun=!1,this._executor=()=>{try{this._value=D()}catch(k){this._error=k}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=ne;async function Y(O,D,k){let F;for(let _=0;_<k;_++)try{return await O()}catch(C){F=C,await s(D)}throw F}e.retry=Y;class Q{hasPending(D){return this._pending?typeof D=="number"?this._pending.taskId===D:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var D;(D=this._pending)===null||D===void 0||D.cancel()}setPending(D,k,F){return this._pending={taskId:D,cancel:()=>F==null?void 0:F(),promise:k},k.then(()=>this.donePending(D),()=>this.donePending(D)),k}donePending(D){this._pending&&D===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const D=this._next;this._next=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this._next)this._next.run=D;else{let k,F;const _=new Promise((C,j)=>{k=C,F=j});this._next={run:D,promise:_,promiseResolve:k,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=Q;class B{constructor(D){this.interval=D,this.lastIncrementTime=0,this.value=0}increment(){const D=Date.now();return D-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=D,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((D,k)=>{this.completeCallback=D,this.errorCallback=k})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(D){return new Promise(k=>{this.completeCallback(D),this.resolved=!0,k()})}error(D){return new Promise(k=>{this.errorCallback(D),this.rejected=!0,k()})}cancel(){new Promise(D=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,D()})}}e.DeferredPromise=z;class U extends L.Emitter{async fireAsync(D,k,F){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,D]);for(;this._asyncDeliveryQueue.size>0&&!k.isCancellationRequested;){const[_,C]=this._asyncDeliveryQueue.shift(),j=[],G=Object.assign(Object.assign({},C),{waitUntil:K=>{if(Object.isFrozen(j))throw new Error("waitUntil can NOT be called asynchronous");F&&(K=F(K,typeof _=="function"?_:_[0])),j.push(K)}});try{typeof _=="function"?_.call(void 0,G):_[0].call(_[1],G)}catch(K){(0,R.onUnexpectedError)(K);continue}Object.freeze(j),await W.settled(j).catch(K=>(0,R.onUnexpectedError)(K))}}}}e.AsyncEmitter=U;var W;(function(O){async function D(C){return typeof Promise.allSettled=="function"?k(C):F(C)}O.allSettled=D;async function k(C){return Promise.allSettled(C)}async function F(C){return Promise.all(C.map(j=>j.then(G=>({status:"fulfilled",value:G}),G=>({status:"rejected",reason:G}))))}async function _(C){let j;const G=await Promise.all(C.map(K=>K.then(V=>V,V=>{j||(j=V)})));if(typeof j!="undefined")throw j;return G}O.settled=_})(W=e.Promises||(e.Promises={}))}),define(Z[79],x([0,1,20,29,8,35,10]),function(H,e,p,R,L,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const S="**",i="/",M="[/\\\\]",f="[^/\\\\]",E=/\//g;function g(k){switch(k){case 0:return"";case 1:return`${f}*?`;default:return`(?:${M}|${f}+${M}|${M}${f}+)*?`}}function d(k,F){if(!k)return[];const _=[];let C=!1,j=!1,G="";for(const K of k){switch(K){case F:if(!C&&!j){_.push(G),G="";continue}break;case"{":C=!0;break;case"}":C=!1;break;case"[":j=!0;break;case"]":j=!1;break}G+=K}return G&&_.push(G),_}e.splitGlobAware=d;function w(k){if(!k)return"";let F="";const _=d(k,i);if(_.every(C=>C===S))F=".*";else{let C=!1;_.forEach((j,G)=>{if(j===S){C||(F+=g(2),C=!0);return}let K=!1,V="",J=!1,re="";for(const ie of j){if(ie!=="}"&&K){V+=ie;continue}if(J&&(ie!=="]"||!re)){let se;ie==="-"?se=ie:(ie==="^"||ie==="!")&&!re?se="^":ie===i?se="":se=p.escapeRegExpCharacters(ie),re+=se;continue}switch(ie){case"{":K=!0;continue;case"[":J=!0;continue;case"}":F+=`(?:${d(V,",").map(le=>w(le)).join("|")})`,K=!1,V="";break;case"]":F+="["+re+"]",J=!1,re="";break;case"?":F+=f;continue;case"*":F+=g(1);continue;default:F+=p.escapeRegExpCharacters(ie)}}G<_.length-1&&(_[G+1]!==S||G+2<_.length)&&(F+=M),C=!1})}return F}const y=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,o=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new b.LRUCache(1e4),r=function(){return!1},a=function(){return null};function h(k,F){if(!k)return a;let _;typeof k!="string"?_=k.pattern:_=k,_=_.trim();const C=`${_}_${!!F.trimForExclusions}`;let j=t.get(C);if(j)return u(j,k);let G;if(y.test(_)){const K=_.substr(4);j=function(V,J){return typeof V=="string"&&V.endsWith(K)?_:null}}else(G=v.exec(m(_,F)))?j=I(G[1],_):(F.trimForExclusions?c:o).test(_)?j=A(_,F):(G=l.exec(m(_,F)))?j=T(G[1].substr(1),_,!0):(G=s.exec(m(_,F)))?j=T(G[1],_,!1):j=N(_);return t.set(C,j),u(j,k)}function u(k,F){return typeof F=="string"?k:function(_,C){return R.isEqualOrParent(_,F.base)?k(L.relative(F.base,_),C):null}}function m(k,F){return F.trimForExclusions&&k.endsWith("/**")?k.substr(0,k.length-2):k}function I(k,F){const _=`/${k}`,C=`\\${k}`,j=function(K,V){return typeof K!="string"?null:V?V===k?F:null:K===k||K.endsWith(_)||K.endsWith(C)?F:null},G=[k];return j.basenames=G,j.patterns=[F],j.allBasenames=G,j}function A(k,F){const _=D(k.slice(1,-1).split(",").map(V=>h(V,F)).filter(V=>V!==a),k),C=_.length;if(!C)return a;if(C===1)return _[0];const j=function(V,J){for(let re=0,ie=_.length;re<ie;re++)if(_[re](V,J))return k;return null},G=_.find(V=>!!V.allBasenames);G&&(j.allBasenames=G.allBasenames);const K=_.reduce((V,J)=>J.allPaths?V.concat(J.allPaths):V,[]);return K.length&&(j.allPaths=K),j}function T(k,F,_){const C=L.sep===L.posix.sep,j=C?k:k.replace(E,L.sep),G=L.sep+j,K=L.posix.sep+k,V=_?function(J,re){return typeof J=="string"&&(J===j||J.endsWith(G)||!C&&(J===k||J.endsWith(K)))?F:null}:function(J,re){return typeof J=="string"&&(J===j||!C&&J===k)?F:null};return V.allPaths=[(_?"*/":"./")+k],V}function N(k){try{const F=new RegExp(`^${w(k)}$`);return function(_){return F.lastIndex=0,typeof _=="string"&&F.test(_)?k:null}}catch(F){return a}}function $(k,F,_){return!k||typeof F!="string"?!1:X(k)(F,void 0,_)}e.match=$;function X(k,F={}){if(!k)return r;if(typeof k=="string"||B(k)){const _=h(k,F);if(_===a)return r;const C=function(j,G){return!!_(j,G)};return _.allBasenames&&(C.allBasenames=_.allBasenames),_.allPaths&&(C.allPaths=_.allPaths),C}return W(k,F)}e.parse=X;function ne(k){if(!!k){let F;return _=>(F||(F=(k()||Promise.resolve([])).then(C=>C?Q(C):{})),F.then(C=>!!C[_]))}}e.hasSiblingPromiseFn=ne;function Y(k){if(!!k){let F;return _=>{if(!F){const C=k();F=C?Q(C):{}}return!!F[_]}}}e.hasSiblingFn=Y;function Q(k){const F={};for(const _ of k)F[_]=!0;return F}function B(k){const F=k;return F&&typeof F.base=="string"&&typeof F.pattern=="string"}e.isRelativePattern=B;function z(k){return k.allBasenames||[]}e.getBasenameTerms=z;function U(k){return k.allPaths||[]}e.getPathTerms=U;function W(k,F){const _=D(Object.getOwnPropertyNames(k).map(V=>O(V,k[V],F)).filter(V=>V!==a)),C=_.length;if(!C)return a;if(!_.some(V=>!!V.requiresSiblings)){if(C===1)return _[0];const V=function(ie,se){for(let me=0,le=_.length;me<le;me++){const ce=_[me](ie,se);if(ce)return ce}return null},J=_.find(ie=>!!ie.allBasenames);J&&(V.allBasenames=J.allBasenames);const re=_.reduce((ie,se)=>se.allPaths?ie.concat(se.allPaths):ie,[]);return re.length&&(V.allPaths=re),V}const j=function(V,J,re){let ie;for(let se=0,me=_.length;se<me;se++){const le=_[se];le.requiresSiblings&&re&&(J||(J=L.basename(V)),ie||(ie=J.substr(0,J.length-L.extname(V).length)));const ce=le(V,J,ie,re);if(ce)return ce}return null},G=_.find(V=>!!V.allBasenames);G&&(j.allBasenames=G.allBasenames);const K=_.reduce((V,J)=>J.allPaths?V.concat(J.allPaths):V,[]);return K.length&&(j.allPaths=K),j}function O(k,F,_){if(F===!1)return a;const C=h(k,_);if(C===a)return a;if(typeof F=="boolean")return C;if(F){const j=F.when;if(typeof j=="string"){const G=(K,V,J,re)=>{if(!re||!C(K,V))return null;const ie=j.replace("$(basename)",J),se=re(ie);return(0,P.isThenable)(se)?se.then(me=>me?k:null):se?k:null};return G.requiresSiblings=!0,G}}return C}function D(k,F){const _=k.filter(V=>!!V.basenames);if(_.length<2)return k;const C=_.reduce((V,J)=>{const re=J.basenames;return re?V.concat(re):V},[]);let j;if(F){j=[];for(let V=0,J=C.length;V<J;V++)j.push(F)}else j=_.reduce((V,J)=>{const re=J.patterns;return re?V.concat(re):V},[]);const G=function(V,J){if(typeof V!="string")return null;if(!J){let ie;for(ie=V.length;ie>0;ie--){const se=V.charCodeAt(ie-1);if(se===47||se===92)break}J=V.substr(ie)}const re=C.indexOf(J);return re!==-1?j[re]:null};G.basenames=C,G.patterns=j,G.allBasenames=C;const K=k.filter(V=>!V.basenames);return K.push(G),K}}),define(Z[38],x([0,1,7,8,20,9,3,15,29]),function(H,e,p,R,L,b,P,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function i(h,u,m){if(typeof h=="string"&&(h=p.URI.file(h)),m){const A=m.getWorkspaceFolder(h);if(A){const T=m.getWorkspace().folders.length>1;let N;if((0,n.isEqual)(A.uri,h)?N="":N=(0,n.relativePath)(A.uri,h),T){const $=A.name?A.name:(0,n.basename)(A.uri);N=N?$+" \u2022 "+N:$}return N}}if(h.scheme!==b.Schemas.file&&h.scheme!==b.Schemas.untitled)return h.with({query:null,fragment:null}).toString(!0);if((0,S.hasDriveLetter)(h.fsPath))return(0,R.normalize)(f(h.fsPath));let I=(0,R.normalize)(h.fsPath);return!P.isWindows&&(u==null?void 0:u.userHome)&&(I=g(I,u.userHome.fsPath)),I}e.getPathLabel=i;function M(h){if(!!h){typeof h=="string"&&(h=p.URI.file(h));const u=(0,n.basename)(h)||(h.scheme===b.Schemas.file?h.fsPath:h.path);return P.isWindows&&(0,S.isRootOrDriveLetter)(u)?f(u):u}}e.getBaseLabel=M;function f(h){return(0,S.hasDriveLetter)(h)?h.charAt(0).toUpperCase()+h.slice(1):h}e.normalizeDriveLetter=f;let E=Object.create(null);function g(h,u){if(P.isWindows||!h||!u)return h;let m=E.original===u?E.normalized:void 0;return m||(m=`${(0,L.rtrim)(u,R.posix.sep)}${R.posix.sep}`,E={original:u,normalized:m}),(P.isLinux?h.startsWith(m):(0,L.startsWithIgnoreCase)(h,m))&&(h=`~/${h.substr(m.length)}`),h}e.tildify=g;function d(h,u){return h.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=d;const w="\u2026",y="\\\\",v="~";function o(h,u=R.sep){const m=new Array(h.length);let I=!1;for(let A=0;A<h.length;A++){let T=h[A];if(T===""){m[A]=`.${u}`;continue}if(!T){m[A]=T;continue}I=!0;let N="";T.indexOf(y)===0?(N=T.substr(0,T.indexOf(y)+y.length),T=T.substr(T.indexOf(y)+y.length)):T.indexOf(u)===0?(N=T.substr(0,T.indexOf(u)+u.length),T=T.substr(T.indexOf(u)+u.length)):T.indexOf(v)===0&&(N=T.substr(0,T.indexOf(v)+v.length),T=T.substr(T.indexOf(v)+v.length));const $=T.split(u);for(let X=1;I&&X<=$.length;X++)for(let ne=$.length-X;I&&ne>=0;ne--){I=!1;let Y=$.slice(ne,ne+X).join(u);for(let Q=0;!I&&Q<h.length;Q++)if(Q!==A&&h[Q]&&h[Q].indexOf(Y)>-1){const B=ne+X===$.length,z=ne>0&&h[Q].indexOf(u)>-1?u+Y:Y,U=h[Q].endsWith(z);I=!B||U}if(!I){let Q="";($[0].endsWith(":")||N!=="")&&(ne===1&&(ne=0,X++,Y=$[0]+u+Y),ne>0&&(Q=$[0]+u),Q=N+Q),ne>0&&(Q=Q+w+u),Q=Q+Y,ne+X<$.length&&(Q=Q+u+w),m[A]=Q}}I&&(m[A]=T)}return m}e.shorten=o;var c;(function(h){h[h.TEXT=0]="TEXT",h[h.VARIABLE=1]="VARIABLE",h[h.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function l(h,u=Object.create(null)){const m=[];let I=!1,A="";for(const T of h)if(T==="$"||I&&T==="{")A&&m.push({value:A,type:c.TEXT}),A="",I=!0;else if(T==="}"&&I){const N=u[A];if(typeof N=="string")N.length&&m.push({value:N,type:c.VARIABLE});else if(N){const $=m[m.length-1];(!$||$.type!==c.SEPARATOR)&&m.push({value:N.label,type:c.SEPARATOR})}A="",I=!1}else A+=T;return A&&!I&&m.push({value:A,type:c.TEXT}),m.filter((T,N)=>{if(T.type===c.SEPARATOR){const $=m[N-1],X=m[N+1];return[$,X].every(ne=>ne&&(ne.type===c.VARIABLE||ne.type===c.TEXT)&&ne.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=l;function s(h,u){return P.isMacintosh||u?h.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):h.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=s;function t(h,u){return P.isMacintosh||u?h.replace(/\(&&\w\)|&&/g,""):P.isWindows?h.replace(/&&|&/g,m=>m==="&"?"&&":"&"):h.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(h){return h.replace(/&/g,"&&")}e.unmnemonicLabel=r;function a(h){const u=h.indexOf("/")!==-1?R.posix:R.win32,m=u.basename(h),I=u.dirname(h);return m.length?{name:m,parentPath:I}:{name:I,parentPath:""}}e.splitName=a}),define(Z[107],x([0,1,8,20,79,9,15]),function(H,e,p,R,L,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let n=[],S=[],i=[];function M(l,s=!1){const t=f(l);n.push(t),t.userConfigured?i.push(t):S.push(t),s&&!t.userConfigured&&n.forEach(r=>{r.mime===t.mime||r.userConfigured||(t.extension&&r.extension===t.extension&&console.warn(`Overwriting extension <<${t.extension}>> to now point to mime <<${t.mime}>>`),t.filename&&r.filename===t.filename&&console.warn(`Overwriting filename <<${t.filename}>> to now point to mime <<${t.mime}>>`),t.filepattern&&r.filepattern===t.filepattern&&console.warn(`Overwriting filepattern <<${t.filepattern}>> to now point to mime <<${t.mime}>>`),t.firstline&&r.firstline===t.firstline&&console.warn(`Overwriting firstline <<${t.firstline}>> to now point to mime <<${t.mime}>>`))})}e.registerTextMime=M;function f(l){return{id:l.id,mime:l.mime,filename:l.filename,extension:l.extension,filepattern:l.filepattern,firstline:l.firstline,userConfigured:l.userConfigured,filenameLowercase:l.filename?l.filename.toLowerCase():void 0,extensionLowercase:l.extension?l.extension.toLowerCase():void 0,filepatternLowercase:l.filepattern?l.filepattern.toLowerCase():void 0,filepatternOnPath:l.filepattern?l.filepattern.indexOf(p.posix.sep)>=0:!1}}function E(l){l?(n=n.filter(s=>!s.userConfigured),i=[]):(n=[],S=[],i=[])}e.clearTextMimes=E;function g(l,s){let t;if(l)switch(l.scheme){case b.Schemas.file:t=l.fsPath;break;case b.Schemas.data:t=P.DataUri.parseMetaData(l).get(P.DataUri.META_DATA_LABEL);break;default:t=l.path}if(!t)return[e.MIME_UNKNOWN];t=t.toLowerCase();const r=(0,p.basename)(t),a=d(t,r,i);if(a)return[a,e.MIME_TEXT];const h=d(t,r,S);if(h)return[h,e.MIME_TEXT];if(s){const u=w(s);if(u)return[u,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=g;function d(l,s,t){let r=null,a=null,h=null;for(let u=t.length-1;u>=0;u--){const m=t[u];if(s===m.filenameLowercase){r=m;break}if(m.filepattern&&(!a||m.filepattern.length>a.filepattern.length)){const I=m.filepatternOnPath?l:s;(0,L.match)(m.filepatternLowercase,I)&&(a=m)}m.extension&&(!h||m.extension.length>h.extension.length)&&s.endsWith(m.extensionLowercase)&&(h=m)}return r?r.mime:a?a.mime:h?h.mime:null}function w(l){if((0,R.startsWithUTF8BOM)(l)&&(l=l.substr(1)),l.length>0)for(let s=n.length-1;s>=0;s--){const t=n[s];if(!!t.firstline){const r=l.match(t.firstline);if(r&&r.length>0)return t.mime}}return null}function y(l){return l?typeof l=="string"?l===e.MIME_BINARY||l===e.MIME_TEXT||l===e.MIME_UNKNOWN:l.length===1&&y(l[0]):!0}e.isUnspecific=y;const v={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(l){const s=(0,p.extname)(l);return v[s.toLowerCase()]}e.getMediaMime=o;function c(l){for(const s in v)if(v[s]===l)return s}e.getExtensionForMimeType=c}),define(Z[30],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(S){return p.test(S)}e.isUUID=R;const L=new Uint8Array(16),b=[];for(let S=0;S<256;S++)b.push(S.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(S){for(let i=0;i<S.length;i++)S[i]=Math.floor(Math.random()*256);return S};function n(){P(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,i="";return i+=b[L[S++]],i+=b[L[S++]],i+=b[L[S++]],i+=b[L[S++]],i+="-",i+=b[L[S++]],i+=b[L[S++]],i+="-",i+=b[L[S++]],i+=b[L[S++]],i+="-",i+=b[L[S++]],i+=b[L[S++]],i+="-",i+=b[L[S++]],i+=b[L[S++]],i+=b[L[S++]],i+=b[L[S++]],i+=b[L[S++]],i+=b[L[S++]],i}e.generateUuid=n}),define(Z[108],x([0,1,22,58,42]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function b(P,n){if(await new Promise((M,f)=>{const E=p.createReadStream(P),g=R.createHash("sha1");E.pipe(g);const d=(0,L.once)((w,y)=>{E.removeAllListeners(),g.removeAllListeners(),w?f(w):M(y)});E.once("error",d),E.once("end",d),g.once("error",d),g.once("data",w=>d(void 0,w.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=b}),define(Z[80],x([0,1,232]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(b="utf8"){this.stringDecoder=new p.StringDecoder(b),this.remaining=null}write(b){const P=[],n=this.remaining?this.remaining+this.stringDecoder.write(b):this.stringDecoder.write(b);if(n.length<1)return P;let S=0,i,M=S;for(;M<n.length;)if(i=n.charCodeAt(M),i===13||i===10){if(P.push(n.substring(S,M)),M++,M<n.length){const f=i;i=n.charCodeAt(M),(f===13&&i===10||f===10&&i===13)&&M++}S=M}else M++;return this.remaining=S<n.length?n.substr(S):null,P}end(){return this.remaining}}e.LineDecoder=R}),define(Z[109],x([0,1,27]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(n){const S=n.replace(/\-/g,":").toLowerCase();return!R.has(S)}function b(){return new Promise(async(n,S)=>{const i=setTimeout(()=>S("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await P())}catch(M){S(M)}finally{clearTimeout(i)}})}e.getMac=b;function P(){return new Promise((n,S)=>{try{const i=(0,p.networkInterfaces)();for(const[,M]of Object.entries(i))for(const f of M)if(L(f.mac))return n(f.mac);S("Unable to retrieve mac address (unexpected format)")}catch(i){S(i)}})}}),define(Z[66],x([0,1,19,30,27,35,109]),function(H,e,p,R,L,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(M){return this._virtualMachineOUIs||(this._virtualMachineOUIs=b.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(M)}value(){if(this._value===void 0){let M=0,f=0;const E=(0,L.networkInterfaces)();for(let g in E)if(Object.prototype.hasOwnProperty.call(E,g))for(const{mac:d,internal:w}of E[g])w||(f+=1,this._isVirtualMachineMacAdress(d.toUpperCase())&&(M+=1));this._value=f>0?M/f:0}return this._value}};let n;async function S(){return n||(n=(async()=>await i()||R.generateUuid())()),n}e.getMachineId=S;async function i(){try{const M=await new Promise((E,g)=>{H(["crypto"],E,g)}),f=await(0,P.getMac)();return M.createHash("sha256").update(f,"utf8").digest("hex")}catch(M){p.onUnexpectedError(M);return}}}),define(Z[23],x([0,1,22,27,8,10,3,29,30,65,15,7]),function(H,e,p,R,L,b,P,n,S,i,M,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var E;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function g(z,U=E.UNLINK){if((0,n.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return U===E.UNLINK?w(z):d(z)}e.rimraf=g;async function d(z){try{const U=(0,L.join)((0,R.tmpdir)(),(0,S.generateUuid)());try{await p.promises.rename(z,U)}catch(W){return w(z)}w(U).catch(W=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function w(z){return p.promises.rmdir(z,{recursive:!0,maxRetries:3})}function y(z){if((0,n.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(z,{recursive:!0})}e.rimrafSync=y;async function v(z,U){return l(await(U?o(z):p.promises.readdir(z)))}e.readdir=v;async function o(z){try{return await p.promises.readdir(z,{withFileTypes:!0})}catch(O){console.warn("[node.js fs] readdir with filetypes failed with error: ",O)}const U=[],W=await v(z);for(const O of W){let D=!1,k=!1,F=!1;try{const _=await p.promises.lstat((0,L.join)(z,O));D=_.isFile(),k=_.isDirectory(),F=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}U.push({name:O,isFile:()=>D,isDirectory:()=>k,isSymbolicLink:()=>F})}return U}function c(z){return l(p.readdirSync(z))}e.readdirSync=c;function l(z){return z.map(U=>typeof U=="string"?P.isMacintosh?(0,i.normalizeNFC)(U):U:(U.name=P.isMacintosh?(0,i.normalizeNFC)(U.name):U.name,U))}async function s(z){const U=await v(z),W=[];for(const O of U)await r.existsDirectory((0,L.join)(z,O))&&W.push(O);return W}e.readDirsInDir=s;function t(z,U=1e3){return new Promise(W=>{let O=!1;const D=setInterval(()=>{O||(O=!0,p.access(z,k=>{O=!1,k&&(clearInterval(D),W(void 0))}))},U)})}e.whenDeleted=t;var r;(function(z){async function U(D){let k;try{if(k=await p.promises.lstat(D),!k.isSymbolicLink())return{stat:k}}catch(F){}try{return{stat:await p.promises.stat(D),symbolicLink:(k==null?void 0:k.isSymbolicLink())?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&k)return{stat:k,symbolicLink:{dangling:!0}};if(P.isWindows&&F.code==="EACCES")try{return{stat:await p.promises.stat(await p.promises.readlink(D)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&k)return{stat:k,symbolicLink:{dangling:!0}};throw _}throw F}}z.stat=U;async function W(D){try{const{stat:k,symbolicLink:F}=await z.stat(D);return k.isFile()&&(F==null?void 0:F.dangling)!==!0}catch(k){}return!1}z.existsFile=W;async function O(D){try{const{stat:k,symbolicLink:F}=await z.stat(D);return k.isDirectory()&&(F==null?void 0:F.dangling)!==!0}catch(k){}return!1}z.existsDirectory=O})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new b.ResourceQueue;function h(z,U,W){return a.queueFor(f.URI.file(z),M.extUriBiasedIgnorePathCase).queue(()=>{const O=A(W);return new Promise((D,k)=>m(z,U,O,F=>F?k(F):D()))})}e.writeFile=h;let u=!0;function m(z,U,W,O){if(!u)return p.writeFile(z,U,{mode:W.mode,flag:W.flag},O);p.open(z,W.flag,W.mode,(D,k)=>{if(D)return O(D);p.writeFile(k,U,F=>{if(F)return p.close(k,()=>O(F));p.fdatasync(k,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),u=!1),p.close(k,C=>O(C))))})})}function I(z,U,W){const O=A(W);if(!u)return p.writeFileSync(z,U,{mode:O.mode,flag:O.flag});const D=p.openSync(z,O.flag,O.mode);try{p.writeFileSync(D,U);try{p.fdatasyncSync(D)}catch(k){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",k),u=!1}}finally{p.closeSync(D)}}e.writeFileSync=I;function A(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function T(z,U){if(z!==U){async function W(O){try{const D=await p.promises.lstat(O);if(D.isDirectory()||D.isSymbolicLink())return;const k=await p.promises.open(O,"a");try{await k.utimes(D.atime,new Date)}finally{await k.close()}}catch(D){}}try{await p.promises.rename(z,U),await W(U)}catch(O){if(z.toLowerCase()!==U.toLowerCase()&&O.code==="EXDEV"||z.endsWith("."))await N(z,U,{preserveSymlinks:!1}),await g(z,E.MOVE),await W(U);else throw O}}}e.move=T;async function N(z,U,W){return X(z,U,{root:{source:z,target:U},options:W,handledSourcePaths:new Set})}e.copy=N;const $=511;async function X(z,U,W){if(!W.handledSourcePaths.has(z)){W.handledSourcePaths.add(z);const{stat:O,symbolicLink:D}=await r.stat(z);if(D){if(W.options.preserveSymlinks)try{return await Q(z,U,W)}catch(k){console.warn("[node.js fs] copy of symlink failed: ",k)}if(D.dangling)return}return O.isDirectory()?ne(z,U,O.mode&$,W):Y(z,U,O.mode&$)}}async function ne(z,U,W,O){await p.promises.mkdir(U,{recursive:!0,mode:W});const D=await v(z);for(const k of D)await X((0,L.join)(z,k),(0,L.join)(U,k),O)}async function Y(z,U,W){await p.promises.copyFile(z,U),await p.promises.chmod(U,W)}async function Q(z,U,W){let O=await p.promises.readlink(z);(0,n.isEqualOrParent)(O,W.root.source,!P.isLinux)&&(O=(0,L.join)(W.root.target,O.substr(W.root.source.length+1))),await p.promises.symlink(O,U)}async function B(z){try{return await p.promises.access(z),!0}catch(U){return!1}}e.exists=B}),define(Z[110],x([0,1,22,20,8,23]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(M){const f=(0,L.dirname)(M);if(M===f)return M;const E=((0,L.basename)(M)||M).toLowerCase();try{const d=(0,b.readdirSync)(f).filter(w=>w.toLowerCase()===E);if(d.length===1){const w=P(f);if(w)return(0,L.join)(w,d[0])}else if(d.length>1){const w=d.indexOf(E);if(w>=0){const y=P(f);if(y)return(0,L.join)(y,d[w])}}}catch(g){}return null}e.realcaseSync=P;async function n(M){try{return await p.promises.realpath(M)}catch(f){const E=i(M);return await p.promises.access(E,p.constants.R_OK),E}}e.realpath=n;function S(M){try{return p.realpathSync(M)}catch(f){const E=i(M);return p.accessSync(E,p.constants.R_OK),E}}e.realpathSync=S;function i(M){return(0,R.rtrim)((0,L.normalize)(M),L.sep)}}),define(Z[111],x([0,1,59]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=e.randomPort=void 0;function R(){const S=1025;return S+Math.floor((65535-S)*Math.random())}e.randomPort=R;function L(S,i,M){let f=!1;return new Promise(E=>{const g=setTimeout(()=>{if(!f)return f=!0,E(0)},M);b(S,i,d=>{if(!f)return f=!0,clearTimeout(g),E(d)})})}e.findFreePort=L;function b(S,i,M){if(i===0)return M(0);const f=new p.Socket;f.once("connect",()=>(n(f),b(S+1,i-1,M))),f.once("data",()=>{}),f.once("error",E=>(n(f),E.code!=="ECONNREFUSED"?b(S+1,i-1,M):M(S))),f.connect(S,"127.0.0.1")}function P(S,i,M){let f=!1,E,g=1;const d=p.createServer({pauseOnConnect:!0});function w(y,v){f||(f=!0,d.removeAllListeners(),d.close(),E&&clearTimeout(E),v(y))}return new Promise(y=>{E=setTimeout(()=>{w(0,y)},M),d.on("listening",()=>{w(S,y)}),d.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&g<i?(S++,g++,d.listen(S,"127.0.0.1")):w(0,y)}),d.on("close",()=>{w(0,y)}),d.listen(S,"127.0.0.1")})}e.findFreePortFaster=P;function n(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(i){console.error(i)}}});var Le=this&&this.__await||function(H){return this instanceof Le?(this.v=H,this):new Le(H)},mt=this&&this.__asyncGenerator||function(H,e,p){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var R=p.apply(H,e||[]),L,b=[];return L={},P("next"),P("throw"),P("return"),L[Symbol.asyncIterator]=function(){return this},L;function P(E){R[E]&&(L[E]=function(g){return new Promise(function(d,w){b.push([E,g,d,w])>1||n(E,g)})})}function n(E,g){try{S(R[E](g))}catch(d){f(b[0][3],d)}}function S(E){E.value instanceof Le?Promise.resolve(E.value.v).then(i,M):f(b[0][2],E)}function i(E){n("next",E)}function M(E){n("throw",E)}function f(E,g){E(g),b.shift(),b.length&&n(b[0][0],b[0][1])}},vt=this&&this.__asyncValues||function(H){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=H[Symbol.asyncIterator],p;return e?e.call(H):(H=typeof __values=="function"?__values(H):H[Symbol.iterator](),p={},R("next"),R("throw"),R("return"),p[Symbol.asyncIterator]=function(){return this},p);function R(b){p[b]=H[b]&&function(P){return new Promise(function(n,S){P=H[b](P),L(n,S,P.done,P.value)})}}function L(b,P,n,S){Promise.resolve(S).then(function(i){b({value:i,done:n})},P)}};define(Z[112],x([0,1,23,27,8,51]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,n=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var i;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(i||(i={}));let M;switch(process.arch){case"ia32":case"x32":M=1;break;case"arm":case"arm64":M=2;break;default:M=0;break}let f;process.env.PROCESSOR_ARCHITEW6432?f=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?f=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?f=1:f=0;class E{constructor(t,r,a){this.exePath=t,this.displayName=r,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await p.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:s=!1}={}){return s?M===0?b.env["ProgramFiles(x86)"]||null:f===0&&b.env.ProgramW6432||null:b.env.ProgramFiles||null}async function d({useAlternateBitness:s=!1,findPreview:t=!1}={}){const r=g({useAlternateBitness:s});if(!r)return null;const a=L.join(r,"PowerShell");if(!await p.SymlinkSupport.existsDirectory(a))return null;let h=-1,u=null;for(const A of await p.readdir(a)){let T=-1;if(t){const $=A.indexOf("-");if($<0)continue;const X=A.substring(0,$);if(!P.test(X)||A.substring($+1)!=="preview")continue;T=parseInt(X,10)}else{if(!P.test(A))continue;T=parseInt(A,10)}if(!(T<=h)){const N=L.join(a,A,"pwsh.exe");!await p.SymlinkSupport.existsFile(N)||(u=N,h=T)}}if(!u)return null;const m=r.includes("x86")?" (x86)":"",I=t?" Preview":"";return new E(u,`PowerShell${I}${m}`,!0)}async function w({findPreview:s}={}){if(!b.env.LOCALAPPDATA)return null;const t=L.join(b.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await p.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:r,pwshMsixName:a}=s?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:n,pwshMsixName:"PowerShell (Store)"};for(const h of await p.readdir(t))if(r.test(h)){const u=L.join(t,h,"pwsh.exe");return new E(u,a)}return null}function y(){const s=L.join(R.homedir(),".dotnet","tools","pwsh.exe");return new E(s,".NET Core PowerShell Global Tool")}function v(){const s=L.join(b.env.windir,M===1&&f!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(s,"Windows PowerShell",!0)}function o(){return mt(this,arguments,function*(){let t=yield Le(d());t&&(yield yield Le(t)),t=yield Le(d({useAlternateBitness:!0})),t&&(yield yield Le(t)),t=yield Le(w()),t&&(yield yield Le(t)),t=y(),t&&(yield yield Le(t)),t=yield Le(d({findPreview:!0})),t&&(yield yield Le(t)),t=yield Le(w({findPreview:!0})),t&&(yield yield Le(t)),t=yield Le(d({useAlternateBitness:!0,findPreview:!0})),t&&(yield yield Le(t)),t=v(),t&&(yield yield Le(t))})}function c(){return mt(this,arguments,function*(){var t,r;try{for(var a=vt(o()),h;h=yield Le(a.next()),!h.done;){const u=h.value;(yield Le(u.exists()))&&(yield yield Le(u))}}catch(u){t={error:u}}finally{try{h&&!h.done&&(r=a.return)&&(yield Le(r.call(a)))}finally{if(t)throw t.error}}})}e.enumeratePowerShellInstallations=c;async function l(){var s,t;try{for(var r=vt(c()),a;a=await r.next(),!a.done;)return a.value}catch(h){s={error:h}}finally{try{a&&!a.done&&(t=r.return)&&await t.call(r)}finally{if(s)throw s.error}}return null}e.getFirstAvailablePowerShellInstallation=l}),define(Z[81],x([0,1,45,9]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(P){return new Promise((n,S)=>{let i;const M=new Map;function f(d,w,y,v,o){const c=M.get(w);if(d===P||c){const l={name:E(y),cmd:y,pid:d,ppid:w,load:v,mem:o};M.set(d,l),d===P&&(i=l),c&&(c.children||(c.children=[]),c.children.push(l),c.children.length>1&&(c.children=c.children.sort((s,t)=>s.pid-t.pid)))}}function E(d){const w=/--disable-blink-features=Auxclick/,y=/\\watcher\\win32\\CodeHelper\.exe/,v=/--crashes-directory/,o=/\\pipe\\winpty-control/,c=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(y.exec(d))return"watcherService ";if(v.exec(d))return"electron-crash-reporter";if(o.exec(d))return"winpty-process";if(c.exec(d))return"console-window-host (Windows internal process)";let s=l.exec(d);if(s&&s.length===2)return s[1]==="renderer"?w.exec(d)?"shared-process":"window":s[1];const t=/[a-zA-Z-]+\.js/g;let r="";do s=t.exec(d),s&&(r+=s+" ");while(s);return r&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${r}`:d}if(process.platform==="win32"){const d=w=>w.indexOf("\\\\?\\")===0||w.indexOf("\\??\\")===0?w.substr(4):w.indexOf('"\\\\?\\')===0||w.indexOf('"\\??\\')===0?'"'+w.substr(5):w;new Promise((w,y)=>{H(["windows-process-tree"],w,y)}).then(w=>{w.getProcessList(P,y=>{w.getProcessCpuUsage(y,v=>{const o=new Map;v.forEach(c=>{const l=d(c.commandLine||"");o.set(c.pid,{name:E(l),cmd:l,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),i=o.get(P),i?(o.forEach(c=>{const l=o.get(c.ppid);l&&(l.children||(l.children=[]),l.children.push(c))}),o.forEach(c=>{c.children&&(c.children=c.children.sort((l,s)=>l.pid-s.pid))}),n(i)):S(new Error(`Root process ${P} not found`))})},w.ProcessDataFlag.CommandLine|w.ProcessDataFlag.Memory)})}else{function g(){let d=[i];const w=[];for(;d.length;){const v=d.shift();v&&(w.push(v.pid),v.children&&(d=d.concat(v.children)))}let y=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",H).fsPath);y+=" "+w.join(" "),(0,p.exec)(y,{},(v,o,c)=>{if(v||c)S(v||new Error(c.toString()));else{const l=o.toString().split(`
`);for(let s=0;s<w.length;s++){const t=M.get(w[s]);t.load=parseFloat(l[s])}if(!i){S(new Error(`Root process ${P} not found`));return}n(i)}})}(0,p.exec)("which ps",{},(d,w,y)=>{if(d||y)if(process.platform!=="linux")S(d||new Error(y.toString()));else{const v=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",H).fsPath);(0,p.exec)(v,{},(o,c,l)=>{o||l?S(o||new Error(l.toString())):(b(c,f),g())})}else{const v=w.toString().trim(),o="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${v} ${o}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,l,s)=>{c||s&&!s.includes("screen size is bogus")?S(c||new Error(s.toString())):(b(l,f),process.platform==="linux"?g():i?n(i):S(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=L;function b(P,n){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,i=P.toString().split(`
`);for(const M of i){const f=S.exec(M.trim());f&&f.length===6&&n(parseInt(f[1]),parseInt(f[2]),f[5],parseFloat(f[3]),parseFloat(f[4]))}}}),function(){"use strict";function H(e,p,R){function L(){let b=process.env.VSCODE_APPDATA;if(!b)switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(P,"AppData","Roaming")}break;case"darwin":b=e.join(p.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,R)}return{getDefaultUserDataPath:L}}if(typeof define=="function")define(Z[113],x([0,233,27,9,15]),function(e,p,R,L,b){const P=b.dirname(L.FileAccess.asFileUri("",e)),n=e.__$__nodeRequire(b.joinPath(P,"package.json").fsPath);return H(p,R,n.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../package.json"),p=require("path"),R=require("os");module.exports=H(p,R,e.name)}else throw new Error("Unknown context")}(),define(Z[114],x([0,1,8,22,3,65,2,23]),function(H,e,p,R,L,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function S(f,E,g){return M({path:f,isDirectory:!1},E,g)}e.watchFile=S;function i(f,E,g){return M({path:f,isDirectory:!0},E,g)}e.watchFolder=i,e.CHANGE_BUFFER_DELAY=100;function M(f,E,g){const d=(0,p.basename)(f.path),w=new Map;let y=!1,v=[(0,P.toDisposable)(()=>{w.forEach(o=>(0,P.dispose)(o)),w.clear()})];try{const o=(0,R.watch)(f.path);v.push((0,P.toDisposable)(()=>{o.removeAllListeners(),o.close()}));const c=new Set;f.isDirectory&&(0,n.readdir)(f.path).then(l=>l.forEach(s=>c.add(s))),o.on("error",(l,s)=>{y||g(`Failed to watch ${f.path} for changes using fs.watch() (${l}, ${s})`)}),o.on("change",(l,s)=>{if(!y){let t="";if(s&&(t=s.toString(),L.isMacintosh&&(t=(0,b.normalizeNFC)(t))),!(!t||l!=="change"&&l!=="rename")){const r=f.isDirectory?(0,p.join)(f.path,t):f.path;if(f.isDirectory)if(l==="rename"){const a=w.get(r);a&&(0,P.dispose)(a);const h=setTimeout(async()=>{w.delete(r);const u=await(0,n.exists)(r);if(!y){let m;u?c.has(t)?m="changed":(m="added",c.add(t)):(c.delete(t),m="deleted"),E(m,r)}},e.CHANGE_BUFFER_DELAY);w.set(r,(0,P.toDisposable)(()=>clearTimeout(h)))}else{let a;c.has(t)?a="changed":(a="added",c.add(t)),E(a,r)}else if(l==="rename"||t!==d){const a=setTimeout(async()=>{const h=await(0,n.exists)(r);y||(h?(E("changed",r),v=[M(f,E,g)]):E("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,P.dispose)(v),v=[(0,P.toDisposable)(()=>clearTimeout(a))]}else E("changed",r)}}})}catch(o){(0,n.exists)(f.path).then(c=>{c&&!y&&g(`Failed to watch ${f.path} for changes using fs.watch() (${o.toString()})`)})}return(0,P.toDisposable)(()=>{y=!0,v=(0,P.dispose)(v)})}}),define(Z[115],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[116],x([0,1,11,115,13]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function b(){p.ipcMain.on(R.CONTEXT_MENU_CHANNEL,(n,S,i,M,f)=>{const E=P(n,M,i);E.popup({window:(0,L.withNullAsUndefined)(p.BrowserWindow.fromWebContents(n.sender)),x:f?f.x:void 0,y:f?f.y:void 0,positioningItem:f?f.positioningItem:void 0,callback:()=>{E&&n.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,S)}})})}e.registerContextMenuListener=b;function P(n,S,i){const M=new p.Menu;return i.forEach(f=>{let E;f.type==="separator"?E=new p.MenuItem({type:f.type}):Array.isArray(f.submenu)?E=new p.MenuItem({submenu:P(n,S,f.submenu),label:f.label}):E=new p.MenuItem({label:f.label,type:f.type,accelerator:f.accelerator,checked:f.checked,enabled:f.enabled,visible:f.visible,click:(g,d,w)=>n.sender.send(S,f.id,w)}),M.append(E)}),M}}),define(Z[33],x([0,1,4,2,10,25,19,21,34,13,106,20]),function(H,e,p,R,L,b,P,n,S,i,M,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(O){O[O.Promise=100]="Promise",O[O.PromiseCancel=101]="PromiseCancel",O[O.EventListen=102]="EventListen",O[O.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function g(O){switch(O){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(O){O[O.Initialize=200]="Initialize",O[O.PromiseSuccess=201]="PromiseSuccess",O[O.PromiseError=202]="PromiseError",O[O.PromiseErrorObj=203]="PromiseErrorObj",O[O.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function w(O){switch(O){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(O){O[O.Uninitialized=0]="Uninitialized",O[O.Idle=1]="Idle"})(y||(y={}));class v{constructor(D){this.buffer=D,this.pos=0}read(D){const k=this.buffer.slice(this.pos,this.pos+D);return this.pos+=k.byteLength,k}}class o{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(D){this.buffers.push(D)}}var c;(function(O){O[O.Undefined=0]="Undefined",O[O.String=1]="String",O[O.Buffer=2]="Buffer",O[O.VSBuffer=3]="VSBuffer",O[O.Array=4]="Array",O[O.Object=5]="Object"})(c||(c={}));function l(O){const D=n.VSBuffer.alloc(4);return D.writeUInt32BE(O,0),D}function s(O){return O.read(4).readUInt32BE(0)}function t(O){const D=n.VSBuffer.alloc(1);return D.writeUInt8(O,0),D}const r={Undefined:t(c.Undefined),String:t(c.String),Buffer:t(c.Buffer),VSBuffer:t(c.VSBuffer),Array:t(c.Array),Object:t(c.Object)},a=typeof Buffer!="undefined";function h(O,D){if(typeof D=="undefined")O.write(r.Undefined);else if(typeof D=="string"){const k=n.VSBuffer.fromString(D);O.write(r.String),O.write(l(k.byteLength)),O.write(k)}else if(a&&Buffer.isBuffer(D)){const k=n.VSBuffer.wrap(D);O.write(r.Buffer),O.write(l(k.byteLength)),O.write(k)}else if(D instanceof n.VSBuffer)O.write(r.VSBuffer),O.write(l(D.byteLength)),O.write(D);else if(Array.isArray(D)){O.write(r.Array),O.write(l(D.length));for(const k of D)h(O,k)}else{const k=n.VSBuffer.fromString(JSON.stringify(D));O.write(r.Object),O.write(l(k.byteLength)),O.write(k)}}function u(O){switch(O.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return O.read(s(O)).toString();case c.Buffer:return O.read(s(O)).buffer;case c.VSBuffer:return O.read(s(O));case c.Array:{const k=s(O),F=[];for(let _=0;_<k;_++)F.push(u(O));return F}case c.Object:return JSON.parse(O.read(s(O)).toString())}}class m{constructor(D,k,F=null,_=1e3){this.protocol=D,this.ctx=k,this.logger=F,this.timeoutDelay=_,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(C=>this.onRawMessage(C)),this.sendResponse({type:200})}registerChannel(D,k){this.channels.set(D,k),setTimeout(()=>this.flushPendingRequests(D),0)}sendResponse(D){switch(D.type){case 200:{const k=this.send([D.type]);this.logger&&this.logger.logOutgoing(k,0,1,w(D.type));return}case 201:case 202:case 204:case 203:{const k=this.send([D.type,D.id],D.data);this.logger&&this.logger.logOutgoing(k,D.id,1,w(D.type),D.data);return}}}send(D,k=void 0){const F=new o;return h(F,D),h(F,k),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(k){return 0}}onRawMessage(D){const k=new v(D),F=u(k),_=u(k),C=F[0];switch(C){case 100:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${g(C)}: ${F[2]}.${F[3]}`,_),this.onPromise({type:C,id:F[1],channelName:F[2],name:F[3],arg:_});case 102:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${g(C)}: ${F[2]}.${F[3]}`,_),this.onEventListen({type:C,id:F[1],channelName:F[2],name:F[3],arg:_});case 101:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${g(C)}`),this.disposeActiveRequest({type:C,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${g(C)}`),this.disposeActiveRequest({type:C,id:F[1]})}}onPromise(D){const k=this.channels.get(D.channelName);if(!k){this.collectPendingRequest(D);return}const F=new b.CancellationTokenSource;let _;try{_=k.call(this.ctx,D.name,D.arg,F.token)}catch(G){_=Promise.reject(G)}const C=D.id;_.then(G=>{this.sendResponse({id:C,data:G,type:201}),this.activeRequests.delete(D.id)},G=>{G instanceof Error?this.sendResponse({id:C,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:C,data:G,type:203}),this.activeRequests.delete(D.id)});const j=(0,R.toDisposable)(()=>F.cancel());this.activeRequests.set(D.id,j)}onEventListen(D){const k=this.channels.get(D.channelName);if(!k){this.collectPendingRequest(D);return}const F=D.id,C=k.listen(this.ctx,D.name,D.arg)(j=>this.sendResponse({id:F,data:j,type:204}));this.activeRequests.set(D.id,C)}disposeActiveRequest(D){const k=this.activeRequests.get(D.id);k&&(k.dispose(),this.activeRequests.delete(D.id))}collectPendingRequest(D){let k=this.pendingRequests.get(D.channelName);k||(k=[],this.pendingRequests.set(D.channelName,k));const F=setTimeout(()=>{console.error(`Unknown channel: ${D.channelName}`),D.type===100&&this.sendResponse({id:D.id,data:{name:"Unknown channel",message:`Channel name '${D.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);k.push({request:D,timeoutTimer:F})}flushPendingRequests(D){const k=this.pendingRequests.get(D);if(k){for(const F of k)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(D)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var I;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(I=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(D,k=null){this.protocol=D,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=k}getChannel(D){const k=this;return{call(F,_,C){return k.isDisposed?Promise.reject(P.canceled()):k.requestPromise(D,F,_,C)},listen(F,_){return k.isDisposed?Promise.reject(P.canceled()):k.requestEvent(D,F,_)}}}requestPromise(D,k,F,_=b.CancellationToken.None){const C=this.lastRequestId++,G={id:C,type:100,channelName:D,name:k,arg:F};if(_.isCancellationRequested)return Promise.reject(P.canceled());let K;return new Promise((J,re)=>{if(_.isCancellationRequested)return re(P.canceled());const ie=()=>{const ce=ge=>{switch(ge.type){case 201:this.handlers.delete(C),J(ge.data);break;case 202:this.handlers.delete(C);const Ie=new Error(ge.data.message);Ie.stack=ge.data.stack,Ie.name=ge.data.name,re(Ie);break;case 203:this.handlers.delete(C),re(ge.data);break}};this.handlers.set(C,ce),this.sendRequest(G)};let se=null;this.state===y.Idle?ie():(se=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),se.then(()=>{se=null,ie()}));const me=()=>{se?(se.cancel(),se=null):this.sendRequest({id:C,type:101}),re(P.canceled())},le=_.onCancellationRequested(me);K=(0,R.combinedDisposable)((0,R.toDisposable)(me),le),this.activeRequests.add(K)}).finally(()=>{this.activeRequests.delete(K)})}requestEvent(D,k,F){const _=this.lastRequestId++,j={id:_,type:102,channelName:D,name:k,arg:F};let G=null;const K=new p.Emitter({onFirstListenerAdd:()=>{G=(0,L.createCancelablePromise)(J=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(K),this.sendRequest(j)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(K),this.sendRequest({id:_,type:103}))}}),V=J=>K.fire(J.data);return this.handlers.set(_,V),K.event}sendRequest(D){switch(D.type){case 100:case 102:{const k=this.send([D.type,D.id,D.channelName,D.name],D.arg);this.logger&&this.logger.logOutgoing(k,D.id,0,`${g(D.type)}: ${D.channelName}.${D.name}`,D.arg);return}case 101:case 103:{const k=this.send([D.type,D.id]);this.logger&&this.logger.logOutgoing(k,D.id,0,g(D.type));return}}}send(D,k=void 0){const F=new o;return h(F,D),h(F,k),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(k){return 0}}onBuffer(D){const k=new v(D),F=u(k),_=u(k),C=F[0];switch(C){case 200:return this.logger&&this.logger.logIncoming(D.byteLength,0,0,w(C)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],0,w(C),_),this.onResponse({type:F[0],id:F[1],data:_})}}onResponse(D){if(D.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const k=this.handlers.get(D.id);k&&k(D)}whenInitialized(){return this.state===y.Idle?Promise.resolve():p.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelClient=A;class T{constructor(D){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,D(({protocol:k,onDidClientDisconnect:F})=>{p.Event.once(k.onMessage)(C=>{const j=new v(C),G=u(j),K=new m(k,G),V=new A(k);this.channels.forEach((re,ie)=>K.registerChannel(ie,re));const J={channelServer:K,channelClient:V,ctx:G};this._connections.add(J),this._onDidAddConnection.fire(J),F(()=>{K.dispose(),V.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const D=[];return this._connections.forEach(k=>D.push(k)),D}getChannel(D,k){const F=this;return{call(_,C,j){let G;if((0,i.isFunction)(k)){let V=(0,S.getRandomElement)(F.connections.filter(k));G=V?Promise.resolve(V):p.Event.toPromise(p.Event.filter(F.onDidAddConnection,k))}else G=k.routeCall(F,_,C);const K=G.then(V=>V.channelClient.getChannel(D));return $(K).call(_,C,j)},listen(_,C){if((0,i.isFunction)(k))return F.getMulticastEvent(D,k,_,C);const j=k.routeEvent(F,_,C).then(G=>G.channelClient.getChannel(D));return $(j).listen(_,C)}}}getMulticastEvent(D,k,F,_){const C=this;let j=new R.DisposableStore;const G=new p.Emitter({onFirstListenerAdd:()=>{j=new R.DisposableStore;const K=new p.EventMultiplexer,V=new Map,J=ie=>{const me=ie.channelClient.getChannel(D).listen(F,_),le=K.add(me);V.set(ie,le)},re=ie=>{const se=V.get(ie);!se||(se.dispose(),V.delete(ie))};C.connections.filter(k).forEach(J),p.Event.filter(C.onDidAddConnection,k)(J,void 0,j),C.onDidRemoveConnection(re,void 0,j),K.event(G.fire,G,j),j.add(K)},onLastListenerRemove:()=>{j.dispose()}});return G.event}registerChannel(D,k){this.channels.set(D,k),this._connections.forEach(F=>{F.channelServer.registerChannel(D,k)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class N{constructor(D,k,F=null){const _=new o;h(_,k),D.send(_.buffer),this.channelClient=new A(D,F),this.channelServer=new m(D,k,F)}getChannel(D){return this.channelClient.getChannel(D)}registerChannel(D,k){this.channelServer.registerChannel(D,k)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=N;function $(O){return{call(D,k,F){return O.then(_=>_.call(D,k,F))},listen(D,k){const F=new p.Relay;return O.then(_=>F.input=_.listen(D,k)),F.event}}}e.getDelayedChannel=$;function X(O){let D=!1;return{call(k,F,_){return D?O.call(k,F,_):(0,L.timeout)(0).then(()=>D=!0).then(()=>O.call(k,F,_))},listen(k,F){if(D)return O.listen(k,F);const _=new p.Relay;return(0,L.timeout)(0).then(()=>D=!0).then(()=>_.input=O.listen(k,F)),_.event}}}e.getNextTickChannel=X;class ne{constructor(D){this.fn=D}routeCall(D){return this.route(D)}routeEvent(D){return this.route(D)}async route(D){for(const k of D.connections)if(await Promise.resolve(this.fn(k.ctx)))return Promise.resolve(k);return await p.Event.toPromise(D.onDidAddConnection),await this.route(D)}}e.StaticRouter=ne;var Y;(function(O){function D(_,C){const j=_,G=C&&C.disableMarshalling,K=new Map;for(const V in j)F(V)&&K.set(V,p.Event.buffer(j[V],!0));return new class{listen(V,J){const re=K.get(J);if(re)return re;throw new Error(`Event not found: ${J}`)}call(V,J,re){const ie=j[J];if(typeof ie=="function"){if(!G&&Array.isArray(re))for(let se=0;se<re.length;se++)re[se]=(0,M.revive)(re[se]);return ie.apply(j,re)}throw new Error(`Method not found: ${J}`)}}}O.fromService=D;function k(_,C){const j=C&&C.disableMarshalling;return new Proxy({},{get(G,K){var V;if(typeof K=="string")return((V=C==null?void 0:C.properties)===null||V===void 0?void 0:V.has(K))?C.properties.get(K):F(K)?_.listen(K):async function(...J){let re;C&&!(0,i.isUndefinedOrNull)(C.context)?re=[C.context,...J]:re=J;const ie=await _.call(K,re);return j?ie:(0,M.revive)(ie)};throw new Error(`Property not found: ${String(K)}`)}})}O.toService=k;function F(_){return _[0]==="o"&&_[1]==="n"&&f.isUpperAsciiLetter(_.charCodeAt(2))}})(Y=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(O){if(Array.isArray(O))return O;if(O&&typeof O=="object"&&typeof O.toString=="function"){let D=O.toString();if(D!=="[object Object]")return D}return O}function z(O){return Array.isArray(O)?O.map(B):B(O)}function U(O,D,k,F,_,C,j){j=z(j);const G=Q[_],K=G[F%G.length];let V=[`%c[${O}]%c[${String(D).padStart(7," ")}]%c[len: ${String(k).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${C}`,"color: darkgreen","color: grey","color: grey",`color: ${K}`];/\($/.test(C)?(V=V.concat(j),V.push(")")):V.push(j),console.log.apply(console,V)}e.logWithColors=U;class W{constructor(D,k){this._outgoingPrefix=D,this._incomingPrefix=k,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(D,k,F,_,C){this._totalOutgoing+=D,U(this._outgoingPrefix,this._totalOutgoing,D,k,F,_,C)}logIncoming(D,k,F,_,C){this._totalIncoming+=D,U(this._incomingPrefix,this._totalIncoming,D,k,F,_,C)}}e.IPCLogger=W}),define(Z[117],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(L,b){this.sender=L,this.onMessage=b}send(L){try{this.sender.send("vscode:message",L.buffer)}catch(b){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(Z[118],x([0,1,4,33,21]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class b{constructor(S){this.port=S,this.onMessage=p.Event.fromDOMEventEmitter(this.port,"message",i=>L.VSBuffer.wrap(i.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=b;class P extends R.IPCClient{constructor(S,i){const M=new b(S);super(M,i);this.protocol=M}dispose(){this.protocol.disconnect()}}e.Client=P}),define(Z[82],x([0,1,4,33,2,21,3,51]),function(H,e,p,R,L,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let S=null;function i(){return S||(S=b.VSBuffer.alloc(0)),S}class M{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,h){if(a===0)return i();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const A=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=a),A}if(this._chunks[0].byteLength>a){const A=this._chunks[0].slice(0,a);return h&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),A}let u=b.VSBuffer.alloc(a),m=0,I=0;for(;a>0;){const A=this._chunks[I];if(A.byteLength>a){const T=A.slice(0,a);u.set(T,m),m+=a,h&&(this._chunks[I]=A.slice(a),this._totalLength-=a),a-=a}else u.set(A,m),m+=A.byteLength,h?(this._chunks.shift(),this._totalLength-=A.byteLength):I++,a-=A.byteLength}return u}}e.ChunkStream=M;var f;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(f||(f={}));var E;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(a,h,u,m){this.type=a,this.id=h,this.ack=u,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends L.Disposable{constructor(a){super();this._onMessage=this._register(new p.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new M,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5);else{const u=this._state.messageType,m=this._state.id,I=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new g(u,m,I,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(a){this._isDisposed=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(a){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(a){if(!this._isDisposed){a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=b.VSBuffer.alloc(13);h.writeUInt8(a.type,0),h.writeUInt32BE(a.id,1),h.writeUInt32BE(a.ack,5),h.writeUInt32BE(a.data.byteLength,9),this._writeSoon(h,a.data)}}_bufferAdd(a,h){const u=this._totalLength===0;return this._data.push(a,h),this._totalLength+=a.byteLength+h.byteLength,u}_bufferTake(){const a=b.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,h){this._bufferAdd(a,h)&&P.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class y extends L.Disposable{constructor(a){super();this._onMessage=new p.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new g(1,0,0,a))}}e.Protocol=y;class v extends R.IPCClient{constructor(a,h,u=null){super(a,h,u);this.protocol=a}static fromSocket(a,h){return new v(new y(a),h)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=v;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new p.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class c{constructor(a){this.data=a,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let a=[],h=0,u=this._first;for(;u;)a[h++]=u.data,u=u.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const h=new c(a);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class s{constructor(){this.lastRuns=[];const a=Date.now();for(let h=0;h<s._HISTORY_LENGTH;h++)this.lastRuns[h]=a-1e3*h;setInterval(()=>{for(let h=s._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const a=Date.now(),h=(1+s._HISTORY_LENGTH)*1e3;let u=0;for(let m=0;m<s._HISTORY_LENGTH;m++)a-this.lastRuns[m]<=h&&u++;return 1-u/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(a,h=null){this._loadEstimator=s.getInstance(),this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=a,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),h&&this._socketReader.acceptChunk(h),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new g(5,0,0,i());this._socketWriter.write(a),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const a=Date.now()-this._socketWriter.lastWriteTime;if(a>=5e3){const h=new g(4,0,0,i());this._socketWriter.write(h),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-a+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const a=Date.now()-this._socketReader.lastReadTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-a,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,h){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=a,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1;const a=this._outgoingUnackMsg.toArray();for(let h=0,u=a.length;h<u;h++)this._socketWriter.write(a[h]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(a.type===1){if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new g(6,0,0,i())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data)}else if(a.type===2)this._onControlMessage.fire(a.data);else if(a.type===5)this._onDidDispose.fire();else if(a.type===6){const h=this._outgoingUnackMsg.toArray();for(let u=0,m=h.length;u<m;u++)this._socketWriter.write(h[u]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new g(1,h,this._incomingAckId,a);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(a){const h=new g(2,0,0,a);this._socketWriter.write(h)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const a=this._outgoingUnackMsg.peek(),h=Date.now()-a.writtenTime;if(h>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-h,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const a=new g(3,0,this._incomingAckId,i());this._socketWriter.write(a)}}}e.PersistentProtocol=t}),define(Z[119],x([0,1,11,4,33,117,2,21]),function(H,e,p,R,L,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function S(M,f){const E=R.Event.fromNodeEventEmitter(p.ipcMain,f,(d,w)=>({event:d,message:w})),g=R.Event.filter(E,({event:d})=>d.sender.id===M);return R.Event.map(g,({message:d})=>d&&n.VSBuffer.wrap(d))}class i extends L.IPCServer{constructor(){super(i.getOnDidClientConnect())}static getOnDidClientConnect(){const f=R.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:E})=>E);return R.Event.map(f,E=>{const g=E.id,d=i.Clients.get(g);d&&d.dispose();const w=new R.Emitter;i.Clients.set(g,(0,P.toDisposable)(()=>w.fire()));const y=S(g,"vscode:message"),v=R.Event.any(R.Event.signal(S(g,"vscode:disconnect")),w.event);return{protocol:new b.Protocol(E,y),onDidClientDisconnect:v}})}}e.Server=i,i.Clients=new Map}),define(Z[83],x([0,1,11,4,30,118]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class P extends b.Client{constructor(i,M){super({addEventListener:(f,E)=>i.addListener(f,E),removeEventListener:(f,E)=>i.removeListener(f,E),postMessage:f=>i.postMessage(f),start:()=>i.start(),close:()=>i.close()},M)}}e.Client=P;async function n(S){if(S.isDestroyed()||S.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const i=(0,L.generateUuid)();S.webContents.send("vscode:createMessageChannel",i);const M=R.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(E,g)=>({nonce:g,port:E.ports[0]})),{port:f}=await R.Event.toPromise(R.Event.once(R.Event.filter(M,E=>E.nonce===i)));return f}e.connect=n}),define(Z[84],x([0,1,2,4,10,13]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var P;(function(M){M[M.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));var n;(function(M){M[M.None=0]="None",M[M.Initialized=1]="Initialized",M[M.Closed=2]="Closed"})(n||(n={}));class S extends p.Disposable{constructor(f,E=Object.create(null)){super();this.database=f,this.options=E,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){var E,g;(E=f.changed)===null||E===void 0||E.forEach((d,w)=>this.accept(w,d)),(g=f.deleted)===null||g===void 0||g.forEach(d=>this.accept(d,void 0))}accept(f,E){if(this.state!==n.Closed){let g=!1;(0,b.isUndefinedOrNull)(E)?g=this.cache.delete(f):this.cache.get(f)!==E&&(this.cache.set(f,E),g=!0),g&&this._onDidChangeStorage.fire(f)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,E){const g=this.cache.get(f);return(0,b.isUndefinedOrNull)(g)?E:g}getBoolean(f,E){const g=this.get(f);return(0,b.isUndefinedOrNull)(g)?E:g==="true"}getNumber(f,E){const g=this.get(f);return(0,b.isUndefinedOrNull)(g)?E:parseInt(g,10)}async set(f,E){if(this.state!==n.Closed){if((0,b.isUndefinedOrNull)(E))return this.delete(f);const g=String(E);if(this.cache.get(f)!==g)return this.cache.set(f,g),this.pendingInserts.set(f,g),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(f){if(this.state!==n.Closed&&!!this.cache.delete(f))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{var E;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(E=this.whenFlushedCallbacks.pop())===null||E===void 0||E()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((E,g)=>this.items.set(g,E)),f.delete&&f.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=i}),define(Z[120],x([0,1,22,4,10,35,8,23]),function(H,e,p,R,L,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class S{constructor(f,E=Object.create(null)){this.path=f,this.options=E,this.name=(0,P.basename)(this.path),this.logger=new i(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return R.Event.None}async getItems(){const f=await this.whenConnected,E=new Map;return(await this.all(f,"SELECT * FROM ItemTable")).forEach(d=>E.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(f){const E=await this.whenConnected;return this.doUpdateItems(E,f)}doUpdateItems(f,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,b.mapToString)(E.insert):"0"}), delete(${E.delete?(0,b.setToString)(E.delete):"0"})`),this.transaction(f,()=>{const g=E.insert,d=E.delete;if(g&&g.size>0){const w=[];w.push([]);let y=0;g.forEach((v,o)=>{let c=w[y];c.length>S.MAX_HOST_PARAMETERS&&(y++,c=[],w.push(c)),c.push(o,v)}),w.forEach(v=>{this.prepare(f,`INSERT INTO ItemTable VALUES ${new Array(v.length/2).fill("(?,?)").join(",")}`,o=>o.run(v),()=>{const o=[];let c=0;return g.forEach((l,s)=>{o.push(s),c+=l.length}),`Keys: ${o.join(", ")} Length: ${c}`})})}if(d&&d.size){const w=[];w.push([]);let y=0;d.forEach(v=>{let o=w[y];o.length>S.MAX_HOST_PARAMETERS&&(y++,o=[],w.push(o)),o.push(v)}),w.forEach(v=>{this.prepare(f,`DELETE FROM ItemTable WHERE key IN (${new Array(v.length).fill("?").join(",")})`,o=>o.run(v),()=>{const o=[];return d.forEach(c=>{o.push(c)}),`Keys: ${o.join(", ")}`})})}})}async close(f){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,f)}doClose(f,E){return new Promise((g,d)=>{f.db.close(w=>(w&&this.handleSQLiteError(f,`[storage ${this.name}] close(): ${w}`),this.path===S.IN_MEMORY_PATH?g():!f.isErroneous&&!f.isInMemory?this.backup().then(g,y=>(this.logger.error(`[storage ${this.name}] backup(): ${y}`),g())):typeof E=="function"?p.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(y=>{const v=()=>this.doClose(y,void 0);return this.doUpdateItems(y,{insert:E()}).then(()=>v(),o=>(v(),Promise.reject(o)))})).then(g,d):d(w||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const f=this.toBackupPath(this.path);return(0,n.copy)(this.path,f,{preserveSymlinks:!1})}toBackupPath(f){return`${f}.backup`}async checkIntegrity(f){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${f})`);const E=await this.whenConnected,g=await this.get(E,f?"PRAGMA integrity_check":"PRAGMA quick_check"),d=f?g.integrity_check:g.quick_check;return E.isErroneous?`${d} (last error: ${E.lastError})`:E.isInMemory?`${d} (in-memory!)`:d}async connect(f,E=!0){this.logger.trace(`[storage ${this.name}] open(${f}, retryOnBusy: ${E})`);try{return await this.doConnect(f)}catch(g){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${g}`),g.code==="SQLITE_BUSY"&&E)return await(0,L.timeout)(S.BUSY_OPEN_TIMEOUT),this.connect(f,!1);try{await p.promises.unlink(f);try{await p.promises.rename(this.toBackupPath(f),f)}catch(d){}return await this.doConnect(f)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(S.IN_MEMORY_PATH)}}}handleSQLiteError(f,E){f.isErroneous=!0,f.lastError=E,this.logger.error(E)}doConnect(f){return new Promise((E,g)=>{new Promise((d,w)=>{H(["vscode-sqlite3"],d,w)}).then(d=>{const w={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(f,y=>y?w.db?w.db.close(()=>g(y)):g(y):this.exec(w,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(w),v=>w.db.close(()=>g(v)))),isInMemory:f===S.IN_MEMORY_PATH};w.db.on("error",y=>this.handleSQLiteError(w,`[storage ${this.name}] Error (event): ${y}`)),this.logger.isTracing&&w.db.on("trace",y=>this.logger.trace(`[storage ${this.name}] Trace (event): ${y}`))},g)})}exec(f,E){return new Promise((g,d)=>{f.db.exec(E,w=>w?(this.handleSQLiteError(f,`[storage ${this.name}] exec(): ${w}`),d(w)):g())})}get(f,E){return new Promise((g,d)=>{f.db.get(E,(w,y)=>w?(this.handleSQLiteError(f,`[storage ${this.name}] get(): ${w}`),d(w)):g(y))})}all(f,E){return new Promise((g,d)=>{f.db.all(E,(w,y)=>w?(this.handleSQLiteError(f,`[storage ${this.name}] all(): ${w}`),d(w)):g(y))})}transaction(f,E){return new Promise((g,d)=>{f.db.serialize(()=>{f.db.run("BEGIN TRANSACTION"),E(),f.db.run("END TRANSACTION",w=>w?(this.handleSQLiteError(f,`[storage ${this.name}] transaction(): ${w}`),d(w)):g())})})}prepare(f,E,g,d){const w=f.db.prepare(E),y=v=>{this.handleSQLiteError(f,`[storage ${this.name}] prepare(): ${v} (${E}). Details: ${d()}`)};w.on("error",y),g(w),w.finalize(v=>{v&&y(v),w.removeListener("error",y)})}}e.SQLiteStorageDatabase=S,S.IN_MEMORY_PATH=":memory:",S.BUSY_OPEN_TIMEOUT=2e3,S.MAX_HOST_PARAMETERS=256;class i{constructor(f){f&&typeof f.logTrace=="function"&&process.env[i.VSCODE_TRACE_STORAGE]&&(this.logTrace=f.logTrace),f&&typeof f.logError=="function"&&(this.logError=f.logError)}get isTracing(){return!!this.logTrace}trace(f){this.logTrace&&this.logTrace(f)}error(f){this.logError&&this.logError(f)}}i.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[121],x([14,12]),function(H,e){return H.create("vs/base/common/date",e)}),define(Z[122],x([0,1,121]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,L=R*60,b=L*24,P=b*7,n=b*30,S=b*365;function i(f,E){typeof f!="number"&&(f=f.getTime());const g=Math.round((new Date().getTime()-f)/1e3);if(g<-30)return(0,p.localize)(0,null,i(new Date().getTime()+g*1e3,!1));if(g<30)return(0,p.localize)(1,null);let d;return g<R?(d=g,E?d===1?(0,p.localize)(2,null,d):(0,p.localize)(3,null,d):d===1?(0,p.localize)(4,null,d):(0,p.localize)(5,null,d)):g<L?(d=Math.floor(g/R),E?d===1?(0,p.localize)(6,null,d):(0,p.localize)(7,null,d):d===1?(0,p.localize)(8,null,d):(0,p.localize)(9,null,d)):g<b?(d=Math.floor(g/L),E?d===1?(0,p.localize)(10,null,d):(0,p.localize)(11,null,d):d===1?(0,p.localize)(12,null,d):(0,p.localize)(13,null,d)):g<P?(d=Math.floor(g/b),E?d===1?(0,p.localize)(14,null,d):(0,p.localize)(15,null,d):d===1?(0,p.localize)(16,null,d):(0,p.localize)(17,null,d)):g<n?(d=Math.floor(g/P),E?d===1?(0,p.localize)(18,null,d):(0,p.localize)(19,null,d):d===1?(0,p.localize)(20,null,d):(0,p.localize)(21,null,d)):g<S?(d=Math.floor(g/n),E?d===1?(0,p.localize)(22,null,d):(0,p.localize)(23,null,d):d===1?(0,p.localize)(24,null,d):(0,p.localize)(25,null,d)):(d=Math.floor(g/S),E?d===1?(0,p.localize)(26,null,d):(0,p.localize)(27,null,d):d===1?(0,p.localize)(28,null,d):(0,p.localize)(29,null,d))}e.fromNow=i;function M(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=M}),define(Z[123],x([14,12]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(Z[67],x([0,1,123,13,34]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function b(i,M){return M&&(i.stack||i.stacktrace)?p.localize(0,null,n(i),P(i.stack)||P(i.stacktrace)):n(i)}function P(i){return Array.isArray(i)?i.join(`
`):i}function n(i){return typeof i.code=="string"&&typeof i.errno=="number"&&typeof i.syscall=="string"?p.localize(1,null,i.message):i.message||p.localize(2,null)}function S(i=null,M=!1){if(!i)return p.localize(3,null);if(Array.isArray(i)){const f=L.coalesce(i),E=S(f[0],M);return f.length>1?p.localize(4,null,E,f.length):E}if(R.isString(i))return i;if(i.detail){const f=i.detail;if(f.error)return b(f.error,M);if(f.exception)return b(f.exception,M)}return i.stack?b(i,M):i.message?i.message:p.localize(5,null)}e.toErrorMessage=S}),define(Z[124],x([14,12]),function(H,e){return H.create("vs/base/common/keybindingLabels",e)}),define(Z[125],x([0,1,124]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class R{constructor(P,n,S=n){this.modifierLabels=[null],this.modifierLabels[2]=P,this.modifierLabels[1]=n,this.modifierLabels[3]=S}toLabel(P,n,S){if(n.length===0)return null;const i=[];for(let M=0,f=n.length;M<f;M++){const E=n[M],g=S(E);if(g===null)return null;i[M]=L(E,g,this.modifierLabels[P])}return i.join(" ")}}e.ModifierLabelProvider=R,e.UILabelProvider=new R({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new R({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new R({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new R({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function L(b,P,n){if(P===null)return"";const S=[];return b.ctrlKey&&S.push(n.ctrlKey),b.shiftKey&&S.push(n.shiftKey),b.altKey&&S.push(n.altKey),b.metaKey&&S.push(n.metaKey),P!==""&&S.push(P),S.join(n.separator)}}),define(Z[126],x([14,12]),function(H,e){return H.create("vs/base/node/processes",e)}),define(Z[85],x([0,1,8,22,23,45,126,13,44,29,3,80,9]),function(H,e,p,R,L,b,P,n,S,i,M,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function g(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(l,s){if(M.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};s&&(t.cwd=s);const r=b.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],t);return new Promise(a=>{r.once("error",h=>{a({success:!1,error:h})}),r.once("exit",(h,u)=>{a(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?g(t.status):1})}else if(M.isLinux||M.isMacintosh)try{const t=E.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",H).fsPath;return new Promise(r=>{b.execFile(t,[l.pid.toString()],{encoding:"utf8",shell:!0},(a,h,u)=>{r(a?{success:!1,error:a}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function w(l=process.env){return l.comspec||"cmd.exe"}e.getWindowsShell=w;class y{constructor(s,t,r,a){if(t!==void 0&&r!==void 0&&a!==void 0)this.cmd=s,this.args=t,this.shell=r,this.options=a;else{const h=s;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(process.env).forEach(u=>{h[u]=process.env[u]}),Object.keys(this.options.env).forEach(u=>{h[u]=this.options.env[u]}),this.options.env=h}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const t=s.lastIndexOf(p.sep);return t!==-1&&(s=s.substring(t+1)),y.WellKnowCommands[s]?s:"other"}start(s){return M.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(process.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(t=>{let r,a;const h=new Promise((u,m)=>{r=u,a=m});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=b.exec(u,this.options,(m,I,A)=>{this.childProcess=null;const T=m;T&&T.killed?a({killed:this.terminateRequested,stdout:I.toString(),stderr:A.toString()}):this.handleExec(r,s,m,I,A)})}else{let u=null;const m=I=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(I,r,s,a);const A={terminated:this.terminateRequested};n.isNumber(I)&&(A.cmdCode=I),r(A)};if(this.shell&&M.isWindows){const I=S.deepClone(this.options);I.windowsVerbatimArguments=!0,I.detached=!1;let A=!1,T=!1;const N=[];let $=this.ensureQuotes(this.cmd);N.push($.value),A=$.quoted,this.args&&this.args.forEach(ne=>{$=this.ensureQuotes(ne),N.push($.value),T=T&&$.quoted});const X=["/s","/c"];A?T?X.push('"'+N.join(" ")+'"'):N.length>1?X.push('"'+N[0]+'" '+N.slice(1).join(" ")):X.push('"'+N[0]+'"'):X.push(N.join(" ")),u=b.spawn(w(),X,I)}else this.cmd&&(u=b.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(n.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",I=>{this.childProcess=null,a({terminated:this.terminateRequested,error:I})}),u.pid&&(this.childProcess.on("close",m),this.handleSpawn(u,r,s,a,!0)))}return h})}handleClose(s,t,r,a){}ensureQuotes(s){return y.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,d(s,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!M.isWindows)return s(!1);const t=b.spawn(w(),["/s","/c"]);t.on("error",r=>s(!0)),t.on("exit",r=>s(!1))})}}e.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class v extends y{constructor(s,t,r,a){super(s,t,r,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,t,r,a,h){[a,h].forEach((u,m)=>{const I=new f.LineDecoder;I.write(u).forEach(N=>{t({line:N,source:m===0?0:1})});const T=I.end();T&&t({line:T,source:m===0?0:1})}),s({terminated:this.terminateRequested,error:r})}handleSpawn(s,t,r,a,h){const u=new f.LineDecoder,m=new f.LineDecoder;s.stdout.on("data",I=>{u.write(I).forEach(T=>r({line:T,source:0}))}),s.stderr.on("data",I=>{m.write(I).forEach(T=>r({line:T,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=m}handleClose(s,t,r,a){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&r({line:h,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&r({line:u,source:1})}}e.LineProcess=v;function o(l){let s=[],t=!1;const r=function(a){if(t){s.push(a);return}(!l.send(a,u=>{if(u&&console.error(u),t=!1,s.length>0){const m=s.slice(0);s=[],m.forEach(I=>r(I))}})||M.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=o;var c;(function(l){async function s(t,r,a){if(p.isAbsolute(t))return t;if(r===void 0&&(r=process.cwd()),p.dirname(t)!=="."||(a===void 0&&n.isString(process.env.PATH)&&(a=process.env.PATH.split(p.delimiter)),a===void 0||a.length===0))return p.join(r,t);async function u(m){return await L.exists(m)?!(await R.promises.stat(m)).isDirectory():!1}for(let m of a){let I;if(p.isAbsolute(m)?I=p.join(m,t):I=p.join(r,m,t),await u(I))return I;let A=I+".com";if(await u(A)||(A=I+".exe",await u(A)))return A}return p.join(r,t)}l.findExecutable=s})(c=e.win32||(e.win32={}))}),define(Z[127],x([0,1,27,3,112,85]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(g,d){return g===3?R.isWindows?f():b.getWindowsShell(d):i(g,d)}e.getSystemShell=P;function n(g,d){return g===3?R.isWindows?E(d):b.getWindowsShell(d):i(g,d)}e.getSystemShellSync=n;let S=null;function i(g,d){if(R.isLinux&&g===1||R.isMacintosh&&g===2)return"/bin/bash";if(!S){let w;if(R.isWindows)w="/bin/bash";else{if(w=d.SHELL,!w)try{w=p.userInfo().shell}catch(y){}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}S=w}return S}let M=null;async function f(){return M||(M=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),M}function E(g){if(M)return M;const d=R.isWindows&&parseFloat(p.release())>=10,w=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${g.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?y:b.getWindowsShell(g)}}),define(Z[86],x([0,1,45,2,10,44,4,85,33,105,25,19,21,3]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends S.ChannelServer{constructor(v){super({send:o=>{try{process.send&&process.send(o.buffer.toString("base64"))}catch(c){}},onMessage:P.Event.fromNodeEventEmitter(process,"message",o=>E.VSBuffer.wrap(Buffer.from(o,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=d;class w{constructor(v,o){this.modulePath=v,this.options=o,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=o&&o.timeout?o.timeout:6e4;this.disposeDelayer=new L.Delayer(c),this.child=null,this._client=null}getChannel(v){const o=this;return{call(c,l,s){return o.requestPromise(v,c,l,s)},listen(c,l){return o.requestEvent(v,c,l)}}}requestPromise(v,o,c,l=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(f.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(v),t=(0,L.createCancelablePromise)(h=>s.call(o,c,h)),r=l.onCancellationRequested(()=>t.cancel()),a=(0,R.toDisposable)(()=>t.cancel());return this.activeRequests.add(a),t.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(v,o,c){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let l;const s=new P.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(v).listen(o,c)(s.fire,s),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],o=Object.create(null);o.env=Object.assign(Object.assign({},(0,b.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(o.env=Object.assign(Object.assign({},o.env),this.options.env)),this.options&&this.options.freshExecArgv&&(o.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),g.isMacintosh&&o.env&&delete o.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,v,o);const c=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,i.isRemoteConsoleLog)(u)){(0,i.log)(u,`IPC Library: ${this.options.serverName}`);return}c.fire(E.VSBuffer.wrap(Buffer.from(u,"base64")))});const s=this.options.useQueue?(0,n.createQueuedSender)(this.child):this.child,t=u=>this.child&&this.child.connected&&s.send(u.buffer.toString("base64")),r=c.event,a={send:t,onMessage:r};this._client=new S.ChannelClient(a);const h=()=>this.disposeClient();process.once("exit",h),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,m)=>{process.removeListener("exit",h),this.activeRequests.forEach(I=>(0,R.dispose)(I)),this.activeRequests.clear(),u!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:m})})}return this._client}getCachedChannel(v){let o=this.channels.get(v);return o||(o=this.client.getChannel(v),this.channels.set(v,o)),o}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(Z[128],x([14,12]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(Z[129],x([14,12]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[130],x([14,12]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[131],x([14,12]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(Z[132],x([14,12]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(Z[133],x([14,12]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[134],x([14,12]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[135],x([14,12]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(Z[136],x([14,12]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(Z[137],x([14,12]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(Z[138],x([14,12]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[139],x([14,12]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[140],x([14,12]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[141],x([14,12]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(Z[142],x([14,12]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[143],x([14,12]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[144],x([14,12]),function(H,e){return H.create("vs/platform/windows/electron-main/window",e)}),define(Z[145],x([14,12]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[146],x([14,12]),function(H,e){return H.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[147],x([14,12]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[148],x([14,12]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[149],x([0,1,4,2]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class L{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(n,S,i){switch(S){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:i[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:i[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:i[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:i[0],port:i[1],subId:i[2]}))}throw new Error("Method not implemented.")}listen(n,S,i){switch(S){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=L,L.ChannelName="extensionhostdebugservice";class b extends R.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,S,i){this.channel.call("attach",[n,S,i])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,S){this.channel.call("terminate",[n,S])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,S,i){return this.channel.call("openExtensionDevelopmentHostWindow",[n,S,i])}}e.ExtensionHostDebugChannelClient=b}),define(Z[60],x([0,1,234,131,3]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const b={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,w,y=P){const v={},o=[],c=[];for(let r in w){const a=w[r];a.alias&&(v[r]=a.alias),a.type==="string"||a.type==="string[]"?(o.push(r),a.deprecates&&o.push(a.deprecates)):a.type==="boolean"&&(c.push(r),a.deprecates&&c.push(a.deprecates))}const l=p(d,{string:o,boolean:c,alias:v}),s={},t=l;s._=l._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in w){const a=w[r];a.alias&&delete t[a.alias];let h=t[r];a.deprecates&&t.hasOwnProperty(a.deprecates)&&(h||(h=t[a.deprecates]),delete t[a.deprecates]),typeof h!="undefined"&&(a.type==="string[]"?h&&!Array.isArray(h)&&(h=[h]):a.type==="string"&&Array.isArray(h)&&(h=h.pop(),y.onMultipleValues(r,h)),s[r]=h),delete t[r]}for(let r in t)y.onUnknownOption(r);return s}e.parseArgs=n;function S(d,w){let y="";return w.args&&(Array.isArray(w.args)?y=` <${w.args.join("> <")}>`:y=` <${w.args}>`),w.alias?`-${w.alias} --${d}${y}`:`--${d}${y}`}function i(d,w){let y=0,v=[];for(const s in d){const t=d[s],r=S(s,t);y=Math.max(y,r.length),v.push([r,t.description])}let o=y+2+1;if(w-o<25)return v.reduce((s,t)=>s.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let c=w-o-1,l=[];for(const s of v){let t=s[0],r=f(s[1],c),a=M(o-t.length-2);l.push("  "+t+a+r[0]);for(let h=1;h<r.length;h++)l.push(M(o)+r[h])}return l}e.formatOptions=i;function M(d){return" ".repeat(d)}function f(d,w){let y=[];for(;d.length;){let v=d.length<w?d.length:d.lastIndexOf(" ",w),o=d.slice(0,v).trim();d=d.slice(v),y.push(o)}return y}function E(d,w,y,v,o=!0){const c=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${d} ${y}`];l.push(""),l.push(`${(0,R.localize)(32,null)}: ${w} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),l.push(""),o&&(L.isWindows?l.push((0,R.localize)(35,null,w)):l.push((0,R.localize)(36,null,w)),l.push(""));const s={};for(const t in v){const r=v[t];if(r.description&&r.cat){let a=s[r.cat];a||(s[r.cat]=a={}),a[t]=r}}for(let t in s){const r=t;let a=s[r];a&&(l.push(b[r]),l.push(...i(a,c)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=E;function g(d,w){return`${d||(0,R.localize)(37,null)}
${w||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=g}),define(Z[150],x([0,1,60,59,149]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class b extends L.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,S,i){return S==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(i[0],i[1],i[2]):super.call(n,S,i)}async openExtensionDevelopmentHostWindow(n,S,i){const M=(0,p.parseArgs)(n,p.OPTIONS);M.debugRenderer=i;const f=M.extensionDevelopmentPath;if(!f)return{};const[E]=this.windowsMainService.openExtensionDevelopmentHostWindow(f,{context:5,cli:M,userEnv:Object.keys(S).length>0?S:void 0});if(!i)return{};const g=E.win;if(!g)return{};const d=g.webContents.debugger;let w=d.isAttached()?Infinity:0;const y=(0,R.createServer)(v=>{w++==0&&d.attach();let o=!1;const c=t=>{o||v.write(JSON.stringify(t)+"\0")},l=(t,r,a,h)=>c({method:r,params:a,sessionId:h});g.on("close",()=>{d.removeListener("message",l),v.end(),o=!0}),d.addListener("message",l);let s=Buffer.alloc(0);v.on("data",t=>{s=Buffer.concat([s,t]);for(let r=s.indexOf(0);r!==-1;r=s.indexOf(0)){let a;try{const h=s.slice(0,r).toString("utf8");s=s.slice(r+1),a=JSON.parse(h)}catch(h){console.error("error reading cdp line",h)}d.sendCommand(a.method,a.params,a.sessionId).then(h=>c({id:a.id,sessionId:a.sessionId,result:h})).catch(h=>c({id:a.id,sessionId:a.sessionId,error:{code:0,message:h.message}}))}}),v.on("error",t=>{console.error("error on cdp pipe:",t)}),v.on("close",()=>{o=!0,--w==0&&d.detach()})});return await new Promise(v=>y.listen(0,v)),g.on("close",()=>y.close()),{rendererDebugPort:y.address().port}}}e.ElectronExtensionHostDebugBroadcastChannel=b}),define(Z[151],x([0,1,22,27,8]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function b(P){const n=(0,L.join)((0,R.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return p.writeFileSync(n,""),P&&console.log(`Marker file for --wait created: ${n}`),n}catch(S){P&&console.error(`Failed to create marker file for --wait: ${S}`);return}}e.createWaitMarkerFile=b}),define(Z[152],x([0,1,134]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function L(f){return f=f.trim(),f==="*"||R.test(f)}e.isValidVersionStr=L;function b(f){if(!L(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=f.match(R);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=b;function P(f){if(!f)return null;let E=f.majorBase,g=f.majorMustEqual,d=f.minorBase,w=f.minorMustEqual,y=f.patchBase,v=f.patchMustEqual;return f.hasCaret&&(E===0||(w=!1),v=!1),{majorBase:E,majorMustEqual:g,minorBase:d,minorMustEqual:w,patchBase:y,patchMustEqual:v,isMinimum:f.hasGreaterEquals}}e.normalizeVersion=P;function n(f,E){let g;typeof f=="string"?g=P(b(f)):g=f;let d;if(typeof E=="string"?d=P(b(E)):d=E,!g||!d)return!1;let w=g.majorBase,y=g.minorBase,v=g.patchBase,o=d.majorBase,c=d.minorBase,l=d.patchBase,s=d.majorMustEqual,t=d.minorMustEqual,r=d.patchMustEqual;return d.isMinimum?w>o?!0:w<o?!1:y>c?!0:y<c?!1:v>=l:(w===1&&o===0&&(!s||!t||!r)&&(o=1,c=0,l=0,s=!0,t=!1,r=!1),w<o?!1:w>o?!s:y<c?!1:y>c?!t:v<l?!1:v>l?!r:!0)}e.isValidVersion=n;function S(f,E,g){return E.isBuiltin||typeof E.main=="undefined"?!0:M(f,E.engines.vscode,g)}e.isValidExtensionVersion=S;function i(f,E){return f==="*"||M(E,f)}e.isEngineValid=i;function M(f,E,g=[]){let d=P(b(E));if(!d)return g.push(p.localize(0,null,E)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return g.push(p.localize(1,null,E)),!1}else if(!d.majorMustEqual)return g.push(p.localize(2,null,E)),!1;return n(f,d)?!0:(g.push(p.localize(3,null,f,E)),!1)}e.isVersionValid=M}),define(Z[153],x([0,1,33,86,2,9]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends L.Disposable{constructor(S,i,M,f){super();this.folders=S,this.onDidFilesChange=i,this.onLogMessage=M,this.verboseLogging=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new R.Client(b.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.setFolders(this.folders)}setVerboseLogging(S){this.verboseLogging=S,!this.isDisposed&&this.service&&this.service.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Z[154],x([0,1,33,86,2,9]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends L.Disposable{constructor(S,i,M,f,E={}){super();this.folders=S,this.onDidFilesChange=i,this.onLogMessage=M,this.verboseLogging=f,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new R.Client(b.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(S.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.service.setRoots(this.folders)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${S}`})}setVerboseLogging(S){this.verboseLogging=S,this.service&&this.service.setVerboseLogging(S)}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Z[155],x([0,1,45,80,79,9]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class P{constructor(S,i,M,f,E){this.watchedFolder=S,this.eventCallback=M,this.logCallback=f,this.verboseLogging=E,this.restartCounter=0,Array.isArray(i)?this.ignored=i.map(g=>L.parse(g)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${S}`),this.startWatcher()}startWatcher(){const S=[this.watchedFolder];this.verboseLogging&&S.push("-verbose"),this.handle=p.spawn(b.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",H).fsPath,S);const i=new R.LineDecoder;this.handle.stdout.on("data",M=>{const f=[];i.write(M).forEach(E=>{const g=E.split("|");if(g.length===2){const d=Number(g[0]),w=g[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(y=>y(w))){this.verboseLogging&&this.log(w);return}f.push({type:P.changeTypeMap[d],path:w})}else this.log(g[1])}}),f.length>0&&this.eventCallback(f)}),this.handle.on("error",M=>this.onError(M)),this.handle.stderr.on("data",M=>this.onError(M)),this.handle.on("exit",(M,f)=>this.onExit(M,f))}onError(S){this.error("process error: "+S.toString())}onExit(S,i){this.handle&&(this.error(`terminated unexpectedly (code: ${S}, signal: ${i})`),this.restartCounter<=P.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(S){this.logCallback({type:"error",message:`[File Watcher (C#)] ${S}`})}log(S){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${S}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=P,P.MAX_RESTARTS=5,P.changeTypeMap=[0,1,2]}),define(Z[156],x([0,1,155,8,20]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b{constructor(n,S,i,M){this.onDidFilesChange=S,this.onLogMessage=i,this.verboseLogging=M,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new p.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=b}),define(Z[68],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class p{constructor(b,P=[],n=!1){this.ctor=b,this.staticArguments=P,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=p;const R=(L,...b)=>new p(L,b);e.createSyncDescriptor=R}),define(Z[157],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(b){this.incoming=new Map,this.outgoing=new Map,this.data=b}}e.Node=p;class R{constructor(b){this._hashFn=b,this._nodes=new Map}roots(){const b=[];for(let P of this._nodes.values())P.outgoing.size===0&&b.push(P);return b}insertEdge(b,P){const n=this.lookupOrInsertNode(b),S=this.lookupOrInsertNode(P);n.outgoing.set(this._hashFn(P),S),S.incoming.set(this._hashFn(b),n)}removeNode(b){const P=this._hashFn(b);this._nodes.delete(P);for(let n of this._nodes.values())n.outgoing.delete(P),n.incoming.delete(P)}lookupOrInsertNode(b){const P=this._hashFn(b);let n=this._nodes.get(P);return n||(n=new p(b),this._nodes.set(P,n)),n}lookup(b){return this._nodes.get(this._hashFn(b))}isEmpty(){return this._nodes.size===0}toString(){let b=[];for(let[P,n]of this._nodes)b.push(`${P}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return b.join(`
`)}}e.Graph=R}),define(Z[5],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function S(i){return i[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=S})(p=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function R(n,S,i,M){S[p.DI_TARGET]===S?S[p.DI_DEPENDENCIES].push({id:n,index:i,optional:M}):(S[p.DI_DEPENDENCIES]=[{id:n,index:i,optional:M}],S[p.DI_TARGET]=S)}function L(n){if(p.serviceIds.has(n))return p.serviceIds.get(n);const S=function(i,M,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(S,i,f,!1)};return S.toString=()=>n,p.serviceIds.set(n,S),S}e.createDecorator=L;function b(n){return n}e.refineServiceDecorator=b;function P(n){return function(S,i,M){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(n,S,M,!0)}}e.optional=P}),define(Z[69],x([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function R(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=R}),define(Z[87],x([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class R{constructor(b){this.machineId=b}encryption(){return new Promise((b,P)=>H(["vscode-encrypt"],b,P))}async encrypt(b){try{return(await this.encryption()).encrypt(this.machineId,b)}catch(P){return b}}async decrypt(b){try{return(await this.encryption()).decrypt(this.machineId,b)}catch(P){return b}}}e.EncryptionMainService=R}),define(Z[52],x([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[158],x([0,1,133,5,9]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=b;var P;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=5]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var n;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var S;(function(f){f.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var i;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(i=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class M extends Error{constructor(E,g){super(E);this.code=g}}e.ExtensionManagementError=M,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",H).toString(!0),e.ExtensionsLabel=(0,p.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,p.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(Z[159],x([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(Z[160],x([0,1,20,5]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function L(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));class P{constructor(M){this.value=M,this._lower=M.toLowerCase()}static equals(M,f){if(typeof M=="undefined"||M===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof M=="string"||typeof f=="string"){let E=typeof M=="string"?M:M.value,g=typeof f=="string"?f:f.value;return p.equalsIgnoreCase(E,g)}return M._lower===f._lower}static toKey(M){return typeof M=="string"?M.toLowerCase():M._lower}}e.ExtensionIdentifier=P;function n(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=n;function S(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[161],x([0,1,20,160]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(g,d){return g.uuid&&d.uuid?g.uuid===d.uuid:g.id===d.id?!0:(0,p.compareIgnoreCase)(g.id,d.id)===0}e.areSameExtensions=L;class b{constructor(d,w){this.version=w,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof b?L(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=b;function P(g,d){return`${g}.${d}`}e.getExtensionId=P;function n(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function S(g,d){return n(P(g,d))}e.getGalleryExtensionId=S;function i(g,d){const w=[],y=v=>{for(const o of w)if(o.some(c=>L(d(c),d(v))))return o;return null};for(const v of g){const o=y(v);o?o.push(v):w.push([v])}return w}e.groupByExtension=i;function M(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=M;function f(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function E(g){const d=new Set;for(const w of g)w.malicious&&d.add(w.id.id);return d}e.getMaliciousExtensionsSet=E}),define(Z[16],x([0,1,136,8,7,5,20,13,35]),function(H,e,p,R,L,b,P,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");var i;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var M;(function(Y){Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash"})(M=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(Y){return!!(Y.capabilities&2)}e.hasReadWriteCapability=f;function E(Y){return!!(Y.capabilities&8)}e.hasFileFolderCopyCapability=E;function g(Y){return!!(Y.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function d(Y){return!!(Y.capabilities&16)}e.hasFileReadStreamCapability=d;var w;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",Y.FileTooLarge="EntryTooLarge",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(Q,B){super(Q);this.code=B}}e.FileSystemProviderError=y;function v(Y,Q){const B=new y(Y.toString(),Q);return c(B,Q),B}e.createFileSystemProviderError=v;function o(Y){return Y||v((0,p.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=o;function c(Y,Q){return Y.name=Q?`${Q} (FileSystemError)`:"FileSystemError",Y}e.markAsFileSystemProviderError=c;function l(Y){if(!Y)return w.Unknown;if(Y instanceof y)return Y.code;const Q=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!Q)return w.Unknown;switch(Q[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=l;function s(Y){if(Y instanceof m)return Y.fileOperationResult;switch(l(Y)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var t;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class r{constructor(Q,B,z){this.resource=Q,this.operation=B,this.target=z}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=r;var a;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class h{constructor(Q,B){this.ignorePathCasing=B,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=Q;for(const z of Q)switch(z.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(z.resource,z);break}}contains(Q,...B){return this.doContains(Q,{includeChildren:!1},...B)}affects(Q,...B){return this.doContains(Q,{includeChildren:!0},...B)}doContains(Q,B,...z){var U,W,O,D,k,F;if(!Q)return!1;const _=z.length>0;return!!((!_||z.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(Q))||B.includeChildren&&((W=this.added)===null||W===void 0?void 0:W.findSuperstr(Q)))||(!_||z.includes(0))&&(((O=this.updated)===null||O===void 0?void 0:O.get(Q))||B.includeChildren&&((D=this.updated)===null||D===void 0?void 0:D.findSuperstr(Q)))||(!_||z.includes(2))&&(((k=this.deleted)===null||k===void 0?void 0:k.findSubstr(Q))||B.includeChildren&&((F=this.deleted)===null||F===void 0?void 0:F.findSuperstr(Q))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(Q){const B=[],z=Q===1?this.added:Q===0?this.updated:this.deleted;if(z)for(const[,U]of z)B.push(U);return B}filter(Q){return new h(this.changes.filter(B=>Q(B)),this.ignorePathCasing)}}e.FileChangesEvent=h;function u(Y,Q,B){return!Y||!Q||Y===Q||Q.length>Y.length?!1:(Q.charAt(Q.length-1)!==R.sep&&(Q+=R.sep),B?(0,P.startsWithIgnoreCase)(Y,Q):Y.indexOf(Q)===0)}e.isParent=u;class m extends Error{constructor(Q,B,z){super(Q);this.fileOperationResult=B,this.options=z}static isFileOperationError(Q){return Q instanceof Error&&!(0,n.isUndefinedOrNull)(Q.fileOperationResult)}}e.FileOperationError=m;var I;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_READ_ONLY=5]="FILE_READ_ONLY",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",Y[Y.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(I=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function T(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.etag=T;async function N(Y,Q){if(!Q.canHandleResource(L.URI.from({scheme:Y.scheme})))return new Promise(B=>{const z=Q.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===Y.scheme&&U.added&&(z.dispose(),B())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(Q){return(0,n.isNumber)(Q)||(Q=0),Q<$.KB?(0,p.localize)(1,null,Q.toFixed(0)):Q<$.MB?(0,p.localize)(2,null,(Q/$.KB).toFixed(2)):Q<$.GB?(0,p.localize)(3,null,(Q/$.MB).toFixed(2)):Q<$.TB?(0,p.localize)(4,null,(Q/$.GB).toFixed(2)):(0,p.localize)(5,null,(Q/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var X;(function(Y){Y[Y.IA32=0]="IA32",Y[Y.OTHER=1]="OTHER"})(X=e.Arch||(e.Arch={}));function ne(Y){return{maxFileSize:Y===0?300*$.MB:16*$.GB,maxHeapSize:Y===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=ne}),define(Z[53],x([0,1,235,132,16,60]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function P(E,g){const d={onUnknownOption:y=>{console.warn((0,R.localize)(0,null,y))},onMultipleValues:(y,v)=>{console.warn((0,R.localize)(1,null,y,v))}},w=(0,b.parseArgs)(E,b.OPTIONS,g?d:void 0);return w.goto&&w._.forEach(y=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,R.localize)(2,null))),w["max-memory"]&&p(parseInt(w["max-memory"])>=L.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${L.MIN_MAX_MEMORY_SIZE_MB} MB.`),w}function n(E){const g=E.findIndex(d=>!/^-/.test(d));if(g>-1)return[...E.slice(0,g),...E.slice(g+1)]}function S(E){let[,...g]=E;process.env.VSCODE_DEV&&(g=n(g)||[]);const d=!f(process.env);return P(g,d)}e.parseMainProcessArgv=S;function i(E){const[,,...g]=E;return P(g,!0)}e.parseCLIProcessArgv=i;function M(E,...g){const d=E.indexOf("--");return d===-1?E.push(...g):E.splice(d,0,...g),E}e.addArg=M;function f(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=f}),define(Z[88],x([0,1,45,30,3,53,67,127]),function(H,e,p,R,L,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function S(f,E,g){return E["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):L.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(g)&&!E["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(g)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),i||(i=M(f)),i)}e.resolveShellEnv=S;let i;async function M(f){const E=new Promise(async(g,d)=>{const w=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",w);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",y);const v=(0,R.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(v+"(.*)"+v),c=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"}),l=`'${process.execPath}' -p '"${v}" + JSON.stringify(process.env) + "${v}"'`;f.trace("getUnixShellEnvironment#env",c),f.trace("getUnixShellEnvironment#spawn",l);const s=await(0,n.getSystemShell)(L.platform,c);f.trace("getUnixShellEnvironment#shell",s);const t=(0,p.spawn)(s,["-ilc",l],{detached:!0,stdio:["ignore","pipe",process.stderr],env:c}),r=[];t.on("error",()=>g({})),t.stdout.on("data",a=>r.push(a)),t.on("close",a=>{if(a!==0)return d(new Error("Failed to get environment"));const h=Buffer.concat(r).toString("utf8");f.trace("getUnixShellEnvironment#raw",h);const u=o.exec(h),m=u?u[1]:"{}";try{const I=JSON.parse(m);w?I.ELECTRON_RUN_AS_NODE=w:delete I.ELECTRON_RUN_AS_NODE,y?I.ELECTRON_NO_ATTACH_CONSOLE=y:delete I.ELECTRON_NO_ATTACH_CONSOLE,delete I.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",I),g(I)}catch(I){f.error("getUnixShellEnvironment#error",I),d(I)}})});try{return await E}catch(g){return f.error("getUnixShellEnvironment#error",(0,P.toErrorMessage)(g)),{}}}}),define(Z[89],x([0,1,137,21,16,19]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(M,f,E,g,d,w){let y;try{await n(M,f,E,g,d,w)}catch(v){y=v}finally{y&&d.errorTransformer&&(y=d.errorTransformer(y)),typeof y!="undefined"&&E.error(y),E.end()}}e.readFileIntoStream=P;async function n(M,f,E,g,d,w){S(w);const y=await M.open(f,{create:!1});try{S(w);let v=0,o=0,c=d&&typeof d.length=="number"?d.length:void 0,l=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof c=="number"?c:d.bufferSize)),s=d&&typeof d.position=="number"?d.position:0,t=0;do o=await M.read(y,s,l.buffer,t,l.byteLength-t),s+=o,t+=o,v+=o,typeof c=="number"&&(c-=o),t===l.byteLength&&(await E.write(g(l)),l=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof c=="number"?c:d.bufferSize)),t=0);while(o>0&&(typeof c!="number"||c>0)&&S(w)&&i(v,d));if(t>0){let r=t;typeof c=="number"&&(r=Math.min(t,c)),E.write(g(l.slice(0,r)))}}catch(v){throw(0,L.ensureFileSystemProviderError)(v)}finally{await M.close(y)}}function S(M){if(M.isCancellationRequested)throw(0,b.canceled)();return!0}function i(M,f){if(f==null?void 0:f.limits){if(typeof f.limits.memory=="number"&&M>f.limits.memory)throw(0,L.createFileSystemProviderError)((0,p.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof f.limits.size=="number"&&M>f.limits.size)throw(0,L.createFileSystemProviderError)((0,p.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[90],x([0,1,7,16,3]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function b(S){return S.map(i=>({type:i.type,resource:p.URI.file(i.path)}))}e.toFileChanges=b;function P(S){const i=new n;for(const M of S)i.processEvent(M);return i.normalize()}e.normalizeFileChanges=P;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(i){const M=this.mapPathToChange.get(i.path);if(M){const f=M.type,E=i.type;f===1&&E===2?(this.mapPathToChange.delete(i.path),this.normalized.splice(this.normalized.indexOf(M),1)):f===2&&E===1?M.type=0:f===1&&E===0||(M.type=E)}else this.normalized.push(i),this.mapPathToChange.set(i.path,i)}normalize(){const i=[],M=[];return this.normalized.filter(f=>f.type!==2?(i.push(f),!1):!0).sort((f,E)=>f.path.length-E.path.length).filter(f=>M.some(E=>(0,R.isParent)(f.path,E,!L.isLinux))?!1:(M.push(f.path),!0)).concat(i)}}}),define(Z[162],x([0,1,90,2,23,110,114,10,8]),function(H,e,p,R,L,b,P,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends R.Disposable{constructor(f,E,g,d){super();this.path=f,this.onDidFilesChange=E,this.onLogMessage=g,this.verboseLogging=d,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(f){this.verboseLogging=f}async startWatching(){try{const{stat:f,symbolicLink:E}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let g=this.path;if(E)try{g=await(0,b.realpath)(g)}catch(d){if(this.onError(d),E.dangling)return}f.isDirectory()?this._register((0,P.watchFolder)(g,(d,w)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(w))})},d=>this.onError(d))):this._register((0,P.watchFile)(g,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(f){f.code!=="ENOENT"&&this.onError(f)}}onFileChange(f){this.fileChangesBuffer.push(f),this.verboseLogging&&this.onVerbose(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const g=(0,p.normalizeFileChanges)(E);this.verboseLogging&&g.forEach(d=>{this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`)}),g.length>0&&this.onDidFilesChange(g)})}onError(f){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${f}`})}onVerbose(f){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=i}),define(Z[70],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...L){this._entries=new Map;for(let[b,P]of L)this.set(b,P)}set(L,b){const P=this._entries.get(L);return this._entries.set(L,b),P}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=p}),define(Z[163],x([0,1,19,157,68,5,70,10]),function(H,e,p,R,L,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class i extends Error{constructor(d){super("cyclic dependency between services");this.message=d.toString()}}class M{constructor(d=new P.ServiceCollection,w=!1,y){this._activeInstantiations=new Set,this._services=d,this._strict=w,this._parent=y,this._services.set(b.IInstantiationService,this)}createChild(d){return new M(d,this._strict,this)}invokeFunction(d,...w){let y=E.traceInvocation(d),v=!1;try{return d({get:(c,l)=>{if(v)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(c,y);if(!s&&l!==b.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return s}},...w)}finally{v=!0,y.stop()}}createInstance(d,...w){let y,v;return d instanceof L.SyncDescriptor?(y=E.traceCreation(d.ctor),v=this._createInstance(d.ctor,d.staticArguments.concat(w),y)):(y=E.traceCreation(d),v=this._createInstance(d,w,y)),y.stop(),v}_createInstance(d,w=[],y){let v=b._util.getServiceDependencies(d).sort((l,s)=>l.index-s.index),o=[];for(const l of v){let s=this._getOrCreateServiceInstance(l.id,y);if(!s&&this._strict&&!l.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${l.id}.`);o.push(s)}let c=v.length>0?v[0].index:w.length;if(w.length!==c){console.warn(`[createInstance] First service dependency of ${d.name} at position ${c+1} conflicts with ${w.length} static arguments`);let l=c-w.length;l>0?w=w.concat(new Array(l)):w=w.slice(0,c)}return new d(...[...w,...o])}_setServiceInstance(d,w){if(this._services.get(d)instanceof L.SyncDescriptor)this._services.set(d,w);else if(this._parent)this._parent._setServiceInstance(d,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let w=this._services.get(d);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):w}_getOrCreateServiceInstance(d,w){let y=this._getServiceInstanceOrDescriptor(d);return y instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,y,w.branch(d,!0)):(w.branch(d,!1),y)}_safeCreateAndCacheServiceInstance(d,w,y){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,w,y)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,w,y){const v=new R.Graph(l=>l.id.toString());let o=0;const c=[{id:d,desc:w,_trace:y}];for(;c.length;){const l=c.pop();if(v.lookupOrInsertNode(l),o++>1e3)throw new i(v);for(let s of b._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${d} depends on ${s.id} which is NOT registered.`),t instanceof L.SyncDescriptor){const r={id:s.id,desc:t,_trace:l._trace.branch(s.id,!0)};v.insertEdge(l,r),c.push(r)}}}for(;;){const l=v.roots();if(l.length===0){if(!v.isEmpty())throw new i(v);break}for(const{data:s}of l){if(this._getServiceInstanceOrDescriptor(s.id)instanceof L.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}v.removeNode(s)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,w,y=[],v,o){if(this._services.get(d)instanceof L.SyncDescriptor)return this._createServiceInstance(w,y,v,o);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,w,y,v,o);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(d,w=[],y,v){if(y){const o=new n.IdleValue(()=>this._createInstance(d,w,v));return new Proxy(Object.create(null),{get(c,l){if(l in c)return c[l];let s=o.value,t=s[l];return typeof t!="function"||(t=t.bind(s),c[l]=t),t},set(c,l,s){return o.value[l]=s,!0}})}else return this._createInstance(d,w,v)}}e.InstantiationService=M;var f;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(f||(f={}));class E{constructor(d,w){this.type=d,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return S?new E(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(d){return S?new E(0,d.name):E._None}branch(d,w){let y=new E(2,d.toString());return this._dep.push([d,w,y]),y}stop(){let d=Date.now()-this._start;E._totals+=d;let w=!1;function y(o,c){let l=[],s=new Array(o+1).join("	");for(const[t,r,a]of c._dep)if(r&&a){w=!0,l.push(`${s}CREATES -> ${t}`);let h=y(o+1,a);h&&l.push(h)}else l.push(`${s}uses -> ${t}`);return l.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(d>2||w)&&console.log(v.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(Z[164],x([0,1,19,125,56]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class b extends L.ResolvedKeybinding{constructor(n,S){super();if(S.length===0)throw(0,p.illegalArgument)("parts");this._os=n,this._parts=S}getLabel(){return R.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return R.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:R.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return R.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new L.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=b}),define(Z[165],x([0,1,56,164]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class L extends R.BaseResolvedKeybinding{constructor(P,n){super(n,P.parts)}_keyCodeToUILabel(P){if(this._os===2)switch(P){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(P)}_getLabel(P){return P.isDuplicateModifierCase()?"":this._keyCodeToUILabel(P.keyCode)}_getAriaLabel(P){return P.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(P.keyCode)}_keyCodeToElectronAccelerator(P){if(P>=93&&P<=108)return null;switch(P){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return p.KeyCodeUtils.toString(P)}_getElectronAccelerator(P){return P.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(P.keyCode)}_getUserSettingsLabel(P){if(P.isDuplicateModifierCase())return"";const n=p.KeyCodeUtils.toUserSettingsUS(P.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(P){return L.getDispatchStr(P)}static getDispatchStr(P){if(P.isModifierKey())return null;let n="";return P.ctrlKey&&(n+="ctrl+"),P.shiftKey&&(n+="shift+"),P.altKey&&(n+="alt+"),P.metaKey&&(n+="meta+"),n+=p.KeyCodeUtils.toString(P.keyCode),n}_getSingleModifierDispatchPart(P){return P.keyCode===5&&!P.shiftKey&&!P.altKey&&!P.metaKey?"ctrl":P.keyCode===4&&!P.ctrlKey&&!P.altKey&&!P.metaKey?"shift":P.keyCode===6&&!P.ctrlKey&&!P.shiftKey&&!P.metaKey?"alt":P.keyCode===57&&!P.ctrlKey&&!P.shiftKey&&!P.altKey?"meta":null}}e.USLayoutResolvedKeybinding=L}),define(Z[166],x([0,1,10]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function R(L,b){if(L.length===0)return Promise.resolve(!1);const P=[];let n=!1;for(let S of L){if(S===!0)return Promise.resolve(!0);(0,p.isThenable)(S)&&P.push(S.then(i=>{i&&(n=!0)},i=>{b(i),n=!0}))}return p.Promises.settled(P).then(()=>n)}e.handleVetos=R}),define(Z[6],x([0,1,5,2,3,4,67]),function(H,e,p,R,L,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function n(){return new Date().toISOString()}var S;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class i extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=i;class M extends i{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...t){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([s,...t]))}debug(s,...t){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([s,...t]))}info(s,...t){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([s,...t]))}warn(s,...t){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([s,...t]))}error(s,...t){if(this.checkLogLevel(S.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(S.Error,this.format(r))}else this.log(S.Error,this.format([s,...t]))}critical(s,...t){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([s,...t]))}flush(){}format(s){let t="";for(let r=0;r<s.length;r++){let a=s[r];if(typeof a=="object")try{a=JSON.stringify(a)}catch(h){}t+=(r>0?" ":"")+a}return t}}e.AbstractMessageLogger=M;class f extends i{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!L.isWindows}trace(s,...t){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,s,...t):console.log(`[main ${n()}]`,s,...t))}debug(s,...t){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,s,...t):console.log(`[main ${n()}]`,s,...t))}info(s,...t){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,s,...t):console.log(`[main ${n()}]`,s,...t))}warn(s,...t){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,s,...t):console.warn(`[main ${n()}]`,s,...t))}error(s,...t){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,s,...t):console.error(`[main ${n()}]`,s,...t))}critical(s,...t){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,s,...t):console.error(`[main ${n()}]`,s,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class E extends i{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...t){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",s,...t)}debug(s,...t){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...t)}info(s,...t){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",s,...t)}warn(s,...t){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",s,...t)}error(s,...t){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",s,...t)}critical(s,...t){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...t)}dispose(){}flush(){}}e.ConsoleLogger=E;class g extends i{constructor(s,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(t)}trace(s,...t){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(s),...t])}debug(s,...t){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(s),...t])}info(s,...t){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(s),...t])}warn(s,...t){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(s),...t])}error(s,...t){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(s),...t])}critical(s,...t){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(s),...t])}extractMessage(s){return typeof s=="string"?s:(0,P.toErrorMessage)(s,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class d extends i{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const t of this.logServices)t.setLevel(s);super.setLevel(s)}trace(s,...t){for(const r of this.logServices)r.trace(s,...t)}debug(s,...t){for(const r of this.logServices)r.debug(s,...t)}info(s,...t){for(const r of this.logServices)r.info(s,...t)}warn(s,...t){for(const r of this.logServices)r.warn(s,...t)}error(s,...t){for(const r of this.logServices)r.error(s,...t)}critical(s,...t){for(const r of this.logServices)r.critical(s,...t)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=d;class w extends R.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...t){this.logger.trace(s,...t)}debug(s,...t){this.logger.debug(s,...t)}info(s,...t){this.logger.info(s,...t)}warn(s,...t){this.logger.warn(s,...t)}error(s,...t){this.logger.error(s,...t)}critical(s,...t){this.logger.critical(s,...t)}flush(){this.logger.flush()}}e.LogService=w;class y{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(s){}getLevel(){return S.Info}trace(s,...t){}debug(s,...t){}info(s,...t){}warn(s,...t){}error(s,...t){}critical(s,...t){}dispose(){}flush(){}}e.NullLogService=y;function v(l){if(l.verbose)return S.Trace;if(typeof l.logLevel=="string"){const s=o(l.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function o(l){switch(l){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=o;function c(l){switch(l){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=c});var he=this&&this.__decorate||function(H,e,p,R){var L=arguments.length,b=L<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,p):R,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")b=Reflect.decorate(H,e,p,R);else for(var n=H.length-1;n>=0;n--)(P=H[n])&&(b=(L<3?P(b):L>3?P(e,p,b):P(e,p))||b);return L>3&&b&&Object.defineProperty(e,p,b),b},ee=this&&this.__param||function(H,e){return function(p,R){e(p,R,H)}};define(Z[167],x([0,1,4,2,9,7,52,11,6,35,3]),function(H,e,p,R,L,b,P,n,S,i,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileProtocolHandler=void 0;let f=class extends R.Disposable{constructor(g,d){super();this.logService=d,this.validRoots=i.TernarySearchTree.forUris(()=>!M.isLinux);const{defaultSession:w}=n.session;this.validRoots.set(b.URI.file(g.appRoot),!0),this.validRoots.set(b.URI.file(g.extensionsPath),!0),this.validRoots.set(g.globalStorageHome,!0),this.validRoots.set(g.workspaceStorageHome,!0),w.protocol.registerFileProtocol(L.Schemas.vscodeFileResource,(y,v)=>this.handleResourceRequest(y,v)),w.protocol.interceptFileProtocol(L.Schemas.file,(y,v)=>this.handleFileRequest(y,v)),this._register((0,R.toDisposable)(()=>{w.protocol.unregisterProtocol(L.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(L.Schemas.file)}))}injectWindowsMainService(g){this._register(g.onDidSignalReadyWindow(d=>{var w,y;if(((w=d.config)===null||w===void 0?void 0:w.extensionDevelopmentPath)||((y=d.config)===null||y===void 0?void 0:y.extensionTestsPath)){const v=new R.DisposableStore;if(v.add(p.Event.any(d.onDidClose,d.onDidDestroy)(()=>v.dispose())),d.config.extensionDevelopmentPath)for(const o of d.config.extensionDevelopmentPath)v.add(this.addValidRoot(b.URI.file(o)));d.config.extensionTestsPath&&v.add(this.addValidRoot(b.URI.file(d.config.extensionTestsPath)))}}))}addValidRoot(g){return this.validRoots.get(g)?R.Disposable.None:(this.validRoots.set(g,!0),(0,R.toDisposable)(()=>this.validRoots.delete(g)))}async handleFileRequest(g,d){const w=b.URI.parse(g.url);return M.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${w.fsPath} from ${L.Schemas.file}: protocol (original URL: ${g.url})`),d({error:-3})):this.validRoots.findSubstr(w)?d({path:w.fsPath}):(this.logService.error(`${L.Schemas.file}: Refused to load resource ${w.fsPath} from ${L.Schemas.file}: protocol (original URL: ${g.url})`),d({error:-3}))}async handleResourceRequest(g,d){const w=b.URI.parse(g.url),y=L.FileAccess.asFileUri(w);return this.validRoots.findSubstr(y)?d({path:y.fsPath}):(this.logService.error(`${L.Schemas.vscodeFileResource}: Refused to load resource ${y.fsPath} from ${L.Schemas.vscodeFileResource}: protocol (original URL: ${g.url})`),d({error:-3}))}};f=he([ee(0,P.INativeEnvironmentService),ee(1,S.ILogService)],f),e.FileProtocolHandler=f}),define(Z[168],x([0,1,135,169,2,16,4,15,35,34,6,21,57,10,25,9,89,64]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let o=class extends L.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new g.ResourceQueue)}registerProvider(l,s){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,R.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:s});const t=new L.DisposableStore;return t.add(s.onDidChangeFile(r=>this._onDidFilesChange.fire(new b.FileChangesEvent(r,!this.isPathCaseSensitive(s))))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:l}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,L.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:s}),this.provider.delete(l),(0,L.dispose)(t)})}async activateProvider(l){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){s.push(t)}}),!this.provider.has(l)&&await g.Promises.settled(s)}canHandleResource(l){return this.provider.has(l.scheme)}hasCapability(l,s){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return v.Iterable.map(this.provider,([l,s])=>({scheme:l,capabilities:s.capabilities}))}async withProvider(l){if(!(0,n.isAbsolutePath)(l))throw new b.FileOperationError((0,p.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const s=this.provider.get(l.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=(0,p.localize)(1,null,l.toString()),t}return s}async withReadProvider(l){const s=await this.withProvider(l);if((0,b.hasOpenReadWriteCloseCapability)(s)||(0,b.hasReadWriteCapability)(s)||(0,b.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const s=await this.withProvider(l);if((0,b.hasOpenReadWriteCloseCapability)(s)||(0,b.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,s){try{return await this.doResolveFile(l,s)}catch(t){throw(0,b.toFileSystemProviderErrorCode)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,p.localize)(2,null,this.resourceForError(l)),1):(0,b.ensureFileSystemProviderError)(t)}}async doResolveFile(l,s){const t=await this.withProvider(l),r=this.isPathCaseSensitive(t),a=s==null?void 0:s.resolveTo,h=s==null?void 0:s.resolveSingleChildDescendants,u=s==null?void 0:s.resolveMetadata,m=await t.stat(l);let I;return this.toFileStat(t,l,m,void 0,!!u,(A,T)=>(I||(I=S.TernarySearchTree.forUris(()=>!r),I.set(l,!0),(0,i.isNonEmptyArray)(a)&&a.forEach(N=>I.set(N,!0))),Boolean(I.findSuperstr(A.resource)||I.get(A.resource))?!0:A.isDirectory&&h?T===1:!1))}async toFileStat(l,s,t,r,a,h){const{providerExtUri:u}=this.getExtUri(l),m={resource:s,name:u.basename(s),isFile:(t.type&b.FileType.File)!=0,isDirectory:(t.type&b.FileType.Directory)!=0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,b.etag)({mtime:t.mtime,size:t.size})};if(m.isDirectory&&h(m,r)){try{const I=await l.readdir(s),A=await g.Promises.settled(I.map(async([T,N])=>{try{const $=u.joinPath(s,T),X=a?await l.stat($):{type:N};return await this.toFileStat(l,$,X,I.length,a,h)}catch($){return this.logService.trace($),null}}));m.children=(0,i.coalesce)(A)}catch(I){this.logService.trace(I),m.children=[]}return m}return m}async resolveAll(l){return g.Promises.settled(l.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const s=await this.withProvider(l);try{return!!await s.stat(l)}catch(t){return!1}}async canCreateFile(l,s){try{await this.doValidateCreateFile(l,s)}catch(t){return t}return!0}async doValidateCreateFile(l,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(l))throw new b.FileOperationError((0,p.localize)(3,null,this.resourceForError(l)),3,s)}async createFile(l,s=f.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const r=await this.writeFile(l,s);return this._onDidRunOperation.fire(new b.FileOperationEvent(l,0,r)),r}async writeFile(l,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:a}=this.getExtUri(r);try{await this.validateWriteFile(r,l,t)||await this.mkdirp(r,a.dirname(l));let u;if((0,b.hasReadWriteCapability)(r)&&!(s instanceof f.VSBuffer))if((0,E.isReadableStream)(s)){const m=await(0,E.peekStream)(s,3);m.ended?u=f.VSBuffer.concat(m.buffer):u=m}else u=(0,E.peekReadable)(s,m=>f.VSBuffer.concat(m),3);else u=s;!(0,b.hasOpenReadWriteCloseCapability)(r)||(0,b.hasReadWriteCapability)(r)&&u instanceof f.VSBuffer?await this.doWriteUnbuffered(r,l,u):await this.doWriteBuffered(r,l,u instanceof f.VSBuffer?(0,f.bufferToReadable)(u):u)}catch(h){throw new b.FileOperationError((0,p.localize)(4,null,this.resourceForError(l),(0,b.ensureFileSystemProviderError)(h).toString()),(0,b.toFileOperationResult)(h),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,s,t){let r;try{r=await l.stat(s)}catch(a){return}if((r.type&b.FileType.Directory)!=0)throw new b.FileOperationError((0,p.localize)(5,null,this.resourceForError(s)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,b.etag)({mtime:t.mtime,size:r.size}))throw new b.FileOperationError((0,p.localize)(6,null),3,t);return r}async readFile(l,s){const t=await this.withReadProvider(l);return(s==null?void 0:s.atomic)?this.doReadFileAtomic(t,l,s):this.doReadFile(t,l,s)}async doReadFileAtomic(l,s,t){return new Promise((r,a)=>{this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{try{const h=await this.doReadFile(l,s,t);r(h)}catch(h){a(h)}})})}async doReadFile(l,s,t){const r=await this.doReadFileStream(l,s,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await(0,f.streamToBuffer)(r.value)})}async readFileStream(l,s){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,s)}async doReadFileStream(l,s,t){const r=new d.CancellationTokenSource,a=this.validateReadFile(s,t).then(u=>u,u=>{throw r.cancel(),u});let h;try{t&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&await a,!((0,b.hasOpenReadWriteCloseCapability)(l)||(0,b.hasFileReadStreamCapability)(l))||(0,b.hasReadWriteCapability)(l)&&(t==null?void 0:t.preferUnbuffered)?h=this.readFileUnbuffered(l,s,t):(0,b.hasFileReadStreamCapability)(l)?h=this.readFileStreamed(l,s,r.token,t):h=this.readFileBuffered(l,s,r.token,t);const u=await a;return Object.assign(Object.assign({},u),{value:h})}catch(u){throw h&&await(0,E.consumeStream)(h),new b.FileOperationError((0,p.localize)(7,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(u).toString()),(0,b.toFileOperationResult)(u),t)}}readFileStreamed(l,s,t,r=Object.create(null)){const a=l.readFileStream(s,r,t);return(0,E.transform)(a,{data:h=>h instanceof f.VSBuffer?h:f.VSBuffer.wrap(h),error:h=>new b.FileOperationError((0,p.localize)(8,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(h).toString()),(0,b.toFileOperationResult)(h),r)},h=>f.VSBuffer.concat(h))}readFileBuffered(l,s,t,r=Object.create(null)){const a=(0,f.newWriteableBufferStream)();return(0,y.readFileIntoStream)(l,s,a,h=>h,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:h=>new b.FileOperationError((0,p.localize)(9,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(h).toString()),(0,b.toFileOperationResult)(h),r)}),t),a}readFileUnbuffered(l,s,t){const r=(0,E.newWriteableStream)(a=>f.VSBuffer.concat(a));return(async()=>{try{let a=await l.readFile(s);t&&typeof t.position=="number"&&(a=a.slice(t.position)),t&&typeof t.length=="number"&&(a=a.slice(0,t.length)),this.validateReadFileLimits(s,a.byteLength,t),r.end(f.VSBuffer.wrap(a))}catch(a){r.error(a),r.end()}})(),r}async validateReadFile(l,s){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new b.FileOperationError((0,p.localize)(10,null,this.resourceForError(l)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==b.ETAG_DISABLED&&s.etag===t.etag)throw new b.FileOperationError((0,p.localize)(11,null),2,s);return this.validateReadFileLimits(l,t.size,s),t}validateReadFileLimits(l,s,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&s>t.limits.size&&(r=7),typeof r=="number")throw new b.FileOperationError((0,p.localize)(12,null,this.resourceForError(l)),r)}}async canMove(l,s,t){return this.doCanMoveCopy(l,s,"move",t)}async canCopy(l,s,t){return this.doCanMoveCopy(l,s,"copy",t)}async doCanMoveCopy(l,s,t,r){if(l.toString()!==s.toString())try{const a=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),h=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(a,l,h,s,t,r)}catch(a){return a}return!0}async move(l,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),h=await this.doMoveCopy(r,l,a,s,"move",!!t),u=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(l,h==="move"?2:3,u)),u}async copy(l,s,t){const r=await this.withReadProvider(l),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),h=await this.doMoveCopy(r,l,a,s,"copy",!!t),u=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(l,h==="copy"?3:2,u)),u}async doMoveCopy(l,s,t,r,a,h){if(s.toString()===r.toString())return a;const{exists:u,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(l,s,t,r,a,h);if(u&&!m&&h&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),a==="copy"){if(l===t&&(0,b.hasFileFolderCopyCapability)(l))await l.copy(s,r,{overwrite:h});else{const I=await this.resolve(s);I.isDirectory?await this.doCopyFolder(l,I,t,r):await this.doCopyFile(l,s,t,r)}return a}else return l===t?(await l.rename(s,r,{overwrite:h}),a):(await this.doMoveCopy(l,s,t,r,"copy",h),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(l,s,t,r){if((0,b.hasOpenReadWriteCloseCapability)(l)&&(0,b.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(l,s,t,r);if((0,b.hasOpenReadWriteCloseCapability)(l)&&(0,b.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(l,s,t,r);if((0,b.hasReadWriteCapability)(l)&&(0,b.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(l,s,t,r);if((0,b.hasReadWriteCapability)(l)&&(0,b.hasReadWriteCapability)(t))return this.doPipeUnbuffered(l,s,t,r)}async doCopyFolder(l,s,t,r){await t.mkdir(r),Array.isArray(s.children)&&await g.Promises.settled(s.children.map(async a=>{const h=this.getExtUri(t).providerExtUri.joinPath(r,a.name);return a.isDirectory?this.doCopyFolder(l,await this.resolve(a.resource),t,h):this.doCopyFile(l,a.resource,t,h)}))}async doValidateMoveCopy(l,s,t,r,a,h){let u=!1;if(l===t){const{providerExtUri:I,isPathCaseSensitive:A}=this.getExtUri(l);if(A||(u=I.isEqual(s,r)),u&&a==="copy")throw new Error((0,p.localize)(13,null,this.resourceForError(s),this.resourceForError(r)));if(!u&&I.isEqualOrParent(r,s))throw new Error((0,p.localize)(14,null,this.resourceForError(s),this.resourceForError(r)))}const m=await this.exists(r);if(m&&!u){if(!h)throw new b.FileOperationError((0,p.localize)(15,null,this.resourceForError(s),this.resourceForError(r)),4);if(l===t){const{providerExtUri:I}=this.getExtUri(l);if(I.isEqualOrParent(s,r))throw new Error((0,p.localize)(16,null,this.resourceForError(s),this.resourceForError(r)))}}return{exists:m,isSameResourceWithDifferentPathCase:u}}getExtUri(l){const s=this.isPathCaseSensitive(l);return{providerExtUri:s?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(s,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(l,0,t)),t}async mkdirp(l,s){const t=[],{providerExtUri:r}=this.getExtUri(l);for(;!r.isEqual(s,r.dirname(s));)try{if(((await l.stat(s)).type&b.FileType.Directory)==0)throw new Error((0,p.localize)(17,null,this.resourceForError(s)));break}catch(a){if((0,b.toFileSystemProviderErrorCode)(a)!==b.FileSystemProviderErrorCode.FileNotFound)throw a;t.push(r.basename(s)),s=r.dirname(s)}for(let a=t.length-1;a>=0;a--){s=r.joinPath(s,t[a]);try{await l.mkdir(s)}catch(h){if((0,b.toFileSystemProviderErrorCode)(h)!==b.FileSystemProviderErrorCode.FileExists)throw h}}}async canDelete(l,s){try{await this.doValidateDelete(l,s)}catch(t){return t}return!0}async doValidateDelete(l,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error((0,p.localize)(18,null,this.resourceForError(l)));const a=await this.exists(l);if(!a)throw new b.FileOperationError((0,p.localize)(19,null,this.resourceForError(l)),1);if(!!!(s==null?void 0:s.recursive)&&a){const u=await this.resolve(l);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,p.localize)(20,null,this.resourceForError(l)))}return t}async del(l,s){const t=await this.doValidateDelete(l,s),r=!!(s==null?void 0:s.useTrash),a=!!(s==null?void 0:s.recursive);await t.delete(l,{recursive:a,useTrash:r}),this._onDidRunOperation.fire(new b.FileOperationEvent(l,1))}watch(l,s={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(l,s).then(a=>{t?(0,L.dispose)(a):r=()=>(0,L.dispose)(a)},a=>this.logService.error(a)),(0,L.toDisposable)(()=>r())}async doWatch(l,s){const t=await this.withProvider(l),r=this.toWatchKey(t,l,s),a=this.activeWatchers.get(r)||{count:0,disposable:t.watch(l,s)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,a),a.count+=1,(0,L.toDisposable)(()=>{a.count--,a.count===0&&((0,L.dispose)(a.disposable),this.activeWatchers.delete(r))})}toWatchKey(l,s,t){const{providerExtUri:r}=this.getExtUri(l);return[r.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(l=>(0,L.dispose)(l.disposable)),this.activeWatchers.clear()}async doWriteBuffered(l,s,t){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{const r=await l.open(s,{create:!0});try{(0,E.isReadableStream)(t)||(0,E.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(l,r,t):await this.doWriteReadableBufferedQueued(l,r,t)}catch(a){throw(0,b.ensureFileSystemProviderError)(a)}finally{await l.close(r)}})}async doWriteStreamBufferedQueued(l,s,t){let r=0,a;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const h=f.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,s,h,h.byteLength,r,0),r+=h.byteLength}if(t.ended)return;a=t.stream}else a=t;return new Promise(async(h,u)=>{(0,E.listenStream)(a,{onData:async m=>{a.pause();try{await this.doWriteBuffer(l,s,m,m.byteLength,r,0)}catch(I){return u(I)}r+=m.byteLength,setTimeout(()=>a.resume())},onError:m=>u(m),onEnd:()=>h()})})}async doWriteReadableBufferedQueued(l,s,t){let r=0,a;for(;(a=t.read())!==null;)await this.doWriteBuffer(l,s,a,a.byteLength,r,0),r+=a.byteLength}async doWriteBuffer(l,s,t,r,a,h){let u=0;for(;u<r;)u+=await l.write(s,a+u,t.buffer,h+u,r-u)}async doWriteUnbuffered(l,s,t){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,s,t))}async doWriteUnbufferedQueued(l,s,t){let r;t instanceof f.VSBuffer?r=t:(0,E.isReadableStream)(t)?r=await(0,f.streamToBuffer)(t):(0,E.isReadableBufferedStream)(t)?r=await(0,f.bufferedStreamToBuffer)(t):r=(0,f.readableToBuffer)(t),await l.writeFile(s,r.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(l,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,s,t,r))}async doPipeBufferedQueued(l,s,t,r){let a,h;try{a=await l.open(s,{create:!1}),h=await t.open(r,{create:!0});const u=f.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,I=0,A=0;do A=await l.read(a,m,u.buffer,I,u.byteLength-I),await this.doWriteBuffer(t,h,u,A,m,I),m+=A,I+=A,I===u.byteLength&&(I=0);while(A>0)}catch(u){throw(0,b.ensureFileSystemProviderError)(u)}finally{await g.Promises.settled([typeof a=="number"?l.close(a):Promise.resolve(),typeof h=="number"?t.close(h):Promise.resolve()])}}async doPipeUnbuffered(l,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,s,t,r))}async doPipeUnbufferedQueued(l,s,t,r){return t.writeFile(r,await l.readFile(s),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(l,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,s,t,r))}async doPipeUnbufferedToBufferedQueued(l,s,t,r){const a=await t.open(r,{create:!0});try{const h=await l.readFile(s);await this.doWriteBuffer(t,a,f.VSBuffer.wrap(h),h.byteLength,0,0)}catch(h){throw(0,b.ensureFileSystemProviderError)(h)}finally{await t.close(a)}}async doPipeBufferedToUnbuffered(l,s,t,r){const a=await(0,f.streamToBuffer)(this.readFileBuffered(l,s,d.CancellationToken.None));await this.doWriteUnbuffered(t,r,a)}throwIfFileSystemIsReadonly(l,s){if(l.capabilities&2048)throw new b.FileOperationError((0,p.localize)(21,null,this.resourceForError(s)),6);return l}resourceForError(l){return l.scheme===w.Schemas.file?l.fsPath:l.toString(!0)}};o=he([ee(0,M.ILogService)],o),e.FileService=o}),define(Z[170],x([0,1,22,236,2,16,4,3,23,8,15,29,10,6,138,90,154,156,153,162,57,89,34,21]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y,v,o,c,l,s,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class a extends L.Disposable{constructor(u,m){var I;super();this.logService=u,this.options=m,this.BUFFER_SIZE=((I=this.options)===null||I===void 0?void 0:I.bufferSize)||64*1024,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new P.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new E.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8,n.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(u){try{const{stat:m,symbolicLink:I}=await S.SymlinkSupport.stat(this.toFilePath(u));return{type:this.toType(m,I),ctime:m.birthtime.getTime(),mtime:m.mtime.getTime(),size:m.size}}catch(m){throw this.toFileSystemProviderError(m)}}async readdir(u){try{const m=await(0,S.readdir)(this.toFilePath(u),{withFileTypes:!0}),I=[];return await Promise.all(m.map(async A=>{try{let T;A.isSymbolicLink()?T=(await this.stat((0,M.joinPath)(u,A.name))).type:T=this.toType(A),I.push([A.name,T])}catch(T){this.logService.trace(T)}})),I}catch(m){throw this.toFileSystemProviderError(m)}}toType(u,m){let I;return(m==null?void 0:m.dangling)?I=b.FileType.Unknown:u.isFile()?I=b.FileType.File:u.isDirectory()?I=b.FileType.Directory:I=b.FileType.Unknown,m&&(I|=b.FileType.SymbolicLink),I}async readFile(u){try{const m=this.toFilePath(u);return await p.promises.readFile(m)}catch(m){throw this.toFileSystemProviderError(m)}}readFileStream(u,m,I){const A=(0,l.newWriteableStream)(T=>r.VSBuffer.concat(T.map(N=>r.VSBuffer.wrap(N))).buffer);return(0,s.readFileIntoStream)(this,u,A,T=>T.buffer,Object.assign(Object.assign({},m),{bufferSize:this.BUFFER_SIZE}),I),A}async writeFile(u,m,I){let A;try{const T=this.toFilePath(u);if(!I.create||!I.overwrite){if(await(0,S.exists)(T)){if(!I.overwrite)throw(0,b.createFileSystemProviderError)((0,d.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!I.create)throw(0,b.createFileSystemProviderError)((0,d.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}A=await this.open(u,{create:!0}),await this.write(A,0,m,0,m.byteLength)}catch(T){throw this.toFileSystemProviderError(T)}finally{typeof A=="number"&&await this.close(A)}}async open(u,m){try{const I=this.toFilePath(u);let A;if(m.create){if(n.isWindows)try{await p.promises.truncate(I,0),A="r+"}catch(N){N.code!=="ENOENT"&&this.logService.trace(N)}A||(A="w")}else A="r";const T=await(0,R.promisify)(p.open)(I,A);return this.mapHandleToPos.set(T,0),m.create&&this.writeHandles.add(T),T}catch(I){throw this.toFileSystemProviderError(I)}}async close(u){try{if(this.mapHandleToPos.delete(u),this.writeHandles.delete(u)&&this.canFlush)try{await(0,R.promisify)(p.fdatasync)(u)}catch(m){this.canFlush=!1,this.logService.error(m)}return await(0,R.promisify)(p.close)(u)}catch(m){throw this.toFileSystemProviderError(m)}}async read(u,m,I,A,T){const N=this.normalizePos(u,m);let $=null;try{const X=await(0,R.promisify)(p.read)(u,I,A,T,N);return typeof X=="number"?$=X:$=X.bytesRead,$}catch(X){throw this.toFileSystemProviderError(X)}finally{this.updatePos(u,N,$)}}normalizePos(u,m){return m===this.mapHandleToPos.get(u)?null:m}updatePos(u,m,I){const A=this.mapHandleToPos.get(u);typeof A=="number"&&(typeof m=="number"||(typeof I=="number"?this.mapHandleToPos.set(u,A+I):this.mapHandleToPos.delete(u)))}async write(u,m,I,A,T){return(0,E.retry)(()=>this.doWrite(u,m,I,A,T),100,3)}async doWrite(u,m,I,A,T){const N=this.normalizePos(u,m);let $=null;try{const X=await(0,R.promisify)(p.write)(u,I,A,T,N);return typeof X=="number"?$=X:$=X.bytesWritten,$}catch(X){throw this.toFileSystemProviderError(X)}finally{this.updatePos(u,N,$)}}async mkdir(u){try{await p.promises.mkdir(this.toFilePath(u))}catch(m){throw this.toFileSystemProviderError(m)}}async delete(u,m){try{const I=this.toFilePath(u);await this.doDelete(I,m)}catch(I){throw this.toFileSystemProviderError(I)}}async doDelete(u,m){m.recursive?await(0,S.rimraf)(u,S.RimRafMode.MOVE):await p.promises.unlink(u)}async rename(u,m,I){const A=this.toFilePath(u),T=this.toFilePath(m);if(A!==T)try{await this.validateTargetDeleted(u,m,"move",I.overwrite),await(0,S.move)(A,T)}catch(N){throw(N.code==="EINVAL"||N.code==="EBUSY"||N.code==="ENAMETOOLONG")&&(N=new Error((0,d.localize)(2,null,(0,i.basename)(A),(0,i.basename)((0,i.dirname)(T)),N.toString()))),this.toFileSystemProviderError(N)}}async copy(u,m,I){const A=this.toFilePath(u),T=this.toFilePath(m);if(A!==T)try{await this.validateTargetDeleted(u,m,"copy",I.overwrite),await(0,S.copy)(A,T,{preserveSymlinks:!0})}catch(N){throw(N.code==="EINVAL"||N.code==="EBUSY"||N.code==="ENAMETOOLONG")&&(N=new Error((0,d.localize)(3,null,(0,i.basename)(A),(0,i.basename)((0,i.dirname)(T)),N.toString()))),this.toFileSystemProviderError(N)}}async validateTargetDeleted(u,m,I,A){const T=this.toFilePath(u),N=this.toFilePath(m);let $=!1;if(!!(this.capabilities&1024)||($=(0,f.isEqual)(T,N,!0)),$&&I==="copy")throw(0,b.createFileSystemProviderError)((0,d.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!$&&await(0,S.exists)(N)){if(!A)throw(0,b.createFileSystemProviderError)((0,d.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(m,{recursive:!0,useTrash:!1})}}watch(u,m){return m.recursive?this.watchRecursive(u,m.excludes):this.watchNonRecursive(u)}watchRecursive(u,m){const I={path:this.toFilePath(u),excludes:m},A=(0,t.insert)(this.recursiveFoldersToWatch,I);return this.refreshRecursiveWatchers(),(0,L.toDisposable)(()=>{A(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var u,m,I;if(this.recursiveWatcher instanceof o.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let A,T;((m=(u=this.options)===null||u===void 0?void 0:u.watcher)===null||m===void 0?void 0:m.usePolling)?(A=y.FileWatcher,T=(I=this.options)===null||I===void 0?void 0:I.watcher):this.recursiveFoldersToWatch.length===1?n.isWindows?A=v.FileWatcher:A=y.FileWatcher:A=o.FileWatcher,this.recursiveWatcher=new A(this.recursiveFoldersToWatch,N=>this._onDidChangeFile.fire((0,w.toFileChanges)(N)),N=>{N.type==="error"&&this._onDidWatchErrorOccur.fire(N.message),this.logService[N.type](N.message)},this.logService.getLevel()===g.LogLevel.Trace,T),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))}}watchNonRecursive(u){const m=new c.FileWatcher(this.toFilePath(u),A=>this._onDidChangeFile.fire((0,w.toFileChanges)(A)),A=>{A.type==="error"&&this._onDidWatchErrorOccur.fire(A.message),this.logService[A.type](A.message)},this.logService.getLevel()===g.LogLevel.Trace),I=this.logService.onDidChangeLogLevel(()=>{m.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)});return(0,L.combinedDisposable)(m,I)}toFilePath(u){return(0,i.normalize)(u.fsPath)}toFileSystemProviderError(u){if(u instanceof b.FileSystemProviderError)return u;let m;switch(u.code){case"ENOENT":m=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":m=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":m=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":m=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":m=b.FileSystemProviderErrorCode.NoPermissions;break;default:m=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(u,m)}dispose(){super.dispose(),(0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,L.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=a}),define(Z[91],x([0,1,6]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function R(b,P){switch(P){case p.LogLevel.Trace:return b.trace;case p.LogLevel.Debug:return b.debug;case p.LogLevel.Info:return b.info;case p.LogLevel.Warning:return b.warn;case p.LogLevel.Error:return b.error;case p.LogLevel.Critical:return b.critical;default:throw new Error("Invalid log level")}}class L extends p.AbstractLogger{constructor(P=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(P){this._logger=P;for(const{level:n,args:S}of this.buffer)R(P,n).apply(P,S);this.buffer=[]}_log(P,...n){this._logger?R(this._logger,P).apply(this._logger,n):this.getLevel()<=P&&this.buffer.push({level:P,args:n})}trace(P,...n){this._log(p.LogLevel.Trace,P,...n)}debug(P,...n){this._log(p.LogLevel.Debug,P,...n)}info(P,...n){this._log(p.LogLevel.Info,P,...n)}warn(P,...n){this._log(p.LogLevel.Warning,P,...n)}error(P,...n){this._log(p.LogLevel.Error,P,...n)}critical(P,...n){this._log(p.LogLevel.Critical,P,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=L}),define(Z[171],x([0,1,6,16,10,21,15,2,5,91]),function(H,e,p,R,L,b,P,n,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const M=5*R.ByteSize.MB;let f=class extends p.AbstractLogger{constructor(d,w,y,v){super();this.name=d,this.resource=w,this.fileService=v,this.backupIndex=1,this.setLevel(y),this.queue=this._register(new L.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=p.LogLevel.Trace&&this._log(p.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=p.LogLevel.Debug&&this._log(p.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=p.LogLevel.Info&&this._log(p.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=p.LogLevel.Warning&&this._log(p.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=p.LogLevel.Error){const d=arguments[0];if(d instanceof Error){const w=Array.prototype.slice.call(arguments);w[0]=d.stack,this._log(p.LogLevel.Error,this.format(w))}else this._log(p.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=p.LogLevel.Critical&&this._log(p.LogLevel.Critical,this.format(arguments))}flush(){}log(d,w){this._log(d,this.format(w))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(d){if(d.fileOperationResult!==3)throw d}}_log(d,w){this.queue.queue(async()=>{await this.initializePromise;let y=await this.loadContent();y.length>M&&(await this.fileService.writeFile(this.getBackupResource(),b.VSBuffer.fromString(y)),y=""),y+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(d)}] ${w}
`,await this.fileService.writeFile(this.resource,b.VSBuffer.fromString(y))})}getCurrentTimestamp(){const d=v=>v<10?`0${v}`:v,w=v=>v<10?`00${v}`:v<100?`0${v}`:v,y=new Date;return`${y.getFullYear()}-${d(y.getMonth()+1)}-${d(y.getDate())} ${d(y.getHours())}:${d(y.getMinutes())}:${d(y.getSeconds())}.${w(y.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,P.joinPath)((0,P.dirname)(this.resource),`${(0,P.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(d){return""}}stringifyLogLevel(d){switch(d){case p.LogLevel.Critical:return"critical";case p.LogLevel.Debug:return"debug";case p.LogLevel.Error:return"error";case p.LogLevel.Info:return"info";case p.LogLevel.Trace:return"trace";case p.LogLevel.Warning:return"warning"}return""}format(d){let w="";for(let y=0;y<d.length;y++){let v=d[y];if(typeof v=="object")try{v=JSON.stringify(v)}catch(o){}w+=(y>0?" ":"")+v}return w}};f=he([ee(3,R.IFileService)],f),e.FileLogger=f;let E=class extends n.Disposable{constructor(d,w,y){super();this.logService=d,this.instantiationService=w,this.fileService=y,this.loggers=new Map,this._register(d.onDidChangeLogLevel(v=>this.loggers.forEach(o=>o.setLevel(v))))}createLogger(d){let w=this.loggers.get(d.toString());return w||(w=new i.BufferLogService(this.logService.getLevel()),this.loggers.set(d.toString(),w),(0,R.whenProviderRegistered)(d,this.fileService).then(()=>w.logger=this.instantiationService.createInstance(f,(0,P.basename)(d),d,this.logService.getLevel()))),w}dispose(){this.loggers.forEach(d=>d.dispose()),this.loggers.clear(),super.dispose()}};E=he([ee(0,p.ILogService),ee(1,S.IInstantiationService),ee(2,R.IFileService)],E),e.FileLoggerService=E}),define(Z[172],x([0,1,6,4,7]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class b{constructor(E){this.service=E,this.onDidChangeLogLevel=R.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(E,g,d){switch(g){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=b;class P{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){P.setLevel(this.channel,E)}static setLevel(E,g){return E.call("setLevel",g)}}e.LogLevelChannelClient=P;class n{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,g){throw new Error(`Event not found: ${g}`)}async call(E,g,d){switch(g){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${g}`)}createLogger(E,g){this.loggers.set(E.toString(),this.loggerService.createLogger(E,g))}consoleLog(E,g){let d=console.log;switch(E){case p.LogLevel.Error:d=console.error;break;case p.LogLevel.Warning:d=console.warn;break;case p.LogLevel.Info:d=console.info;break}d.call(console,...g)}log(E,g){const d=this.loggers.get(E.toString());if(!d)throw new Error("Create the logger before logging");for(const[w,y]of g)switch(w){case p.LogLevel.Trace:d.trace(y);break;case p.LogLevel.Debug:d.debug(y);break;case p.LogLevel.Info:d.info(y);break;case p.LogLevel.Warning:d.warn(y);break;case p.LogLevel.Error:d.error(y);break;case p.LogLevel.Critical:d.critical(y);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class S{constructor(E){this.channel=E}createConsoleMainLogger(){return new p.AdapterLogger({log:(E,g)=>{this.channel.call("consoleLog",[E,g])}})}createLogger(E,g){return new i(this.channel,E,g)}}e.LoggerChannelClient=S;class i extends p.AbstractMessageLogger{constructor(E,g,d){super(d==null?void 0:d.always);this.channel=E,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.channel.call("createLogger",[g,d]).then(()=>{this._log(this.buffer),this.isLoggerCreated=!0})}log(E,g){this._log([[E,g]])}_log(E){this.isLoggerCreated?this.channel.call("log",[this.file,E]):this.buffer.push(...E)}}class M extends p.LogService{constructor(E,g){super(g);this.parent=E,this._register(E.onDidChangeLogLevel(d=>g.setLevel(d)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=M}),define(Z[92],x([0,1,6,16]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function L(S,i,M,f){try{const E=await new Promise((g,d)=>{H(["spdlog"],g,d)});return E.setAsyncMode(8192,500),E.createRotatingLoggerAsync(S,i,M,f)}catch(E){console.error(E)}return null}function b(S,i,M,f){return H.__$__nodeRequire("spdlog").createRotatingLogger(S,i,M,f)}e.createRotatingLogger=b;function P(S,i,M){switch(i){case p.LogLevel.Trace:S.trace(M);break;case p.LogLevel.Debug:S.debug(M);break;case p.LogLevel.Info:S.info(M);break;case p.LogLevel.Warning:S.warn(M);break;case p.LogLevel.Error:S.error(M);break;case p.LogLevel.Critical:S.critical(M);break;default:throw new Error("Invalid log level")}}class n extends p.AbstractMessageLogger{constructor(i,M,f,E){super();this.name=i,this.filepath=M,this.rotating=f,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(g=>{this._logger&&this._logger.setLevel(g)}))}_createSpdLogLogger(){const i=this.rotating?6:1,M=30/i*R.ByteSize.MB;return L(this.name,this.filepath,M,i).then(f=>{if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:E,message:g}of this.buffer)P(this._logger,E,g);this.buffer=[]}})}log(i,M){this._logger?P(this._logger,i,M):this.getLevel()<=i&&this.buffer.push({level:i,message:M})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Z[173],x([0,1,6,2,15,9,171,92,16,30]),function(H,e,p,R,L,b,P,n,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let M=class extends R.Disposable{constructor(E,g){super();this.logService=E,this.fileService=g,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(E.onDidChangeLogLevel(d=>this.logLevelChangeableLoggers.forEach(w=>w.setLevel(d))))}createLogger(E,g){var d;let w=this.loggers.get(E.toString());return w||(E.scheme===b.Schemas.file?(w=new n.SpdLogLogger((g==null?void 0:g.name)||(0,i.generateUuid)(),E.fsPath,!(g==null?void 0:g.donotRotate),this.logService.getLevel()),(g==null?void 0:g.donotUseFormatters)&&w.clearFormatters()):w=new P.FileLogger((d=g==null?void 0:g.name)!==null&&d!==void 0?d:(0,L.basename)(E),E,this.logService.getLevel(),this.fileService),this.loggers.set(E.toString(),w),(g==null?void 0:g.always)?w.setLevel(p.LogLevel.Trace):this.logLevelChangeableLoggers.push(w)),w}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(E=>E.dispose()),this.loggers.clear(),super.dispose()}};M=he([ee(0,p.ILogService),ee(1,S.IFileService)],M),e.LoggerService=M}),define(Z[174],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(P){return P.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function R(P){return P.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=R;function L(P){return P.uri!==void 0}e.isMenubarMenuItemRecentAction=L;function b(P){return!p(P)&&!R(P)&&!L(P)}e.isMenubarMenuItemAction=b}),define(Z[17],x([0,1,3,51,9,15]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(p.isWeb||typeof H=="undefined"||typeof H.__$__nodeRequire!="function")P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.55.0-dev",nameShort:p.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:p.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser"]});else{const n=(0,b.dirname)(L.FileAccess.asFileUri("",H));P=H.__$__nodeRequire((0,b.joinPath)(n,"product.json").fsPath);const S=H.__$__nodeRequire((0,b.joinPath)(n,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:S.version})}e.default=P}),define(Z[175],x([0,1,27,17,113,8,15,50,122,9,7]),function(H,e,p,R,L,b,P,n,S,i,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataDir=e.parsePathArg=e.parseSearchPort=e.parseExtensionHostPort=e.NativeEnvironmentService=void 0;class f{constructor(o){if(this._args=o,!o.logsPath){const c=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");o.logsPath=(0,b.join)(this.userDataPath,"logs",c)}this.logsPath=o.logsPath}get args(){return this._args}get appRoot(){return(0,b.dirname)(i.FileAccess.asFileUri("",H).fsPath)}get userHome(){return M.URI.file((0,p.homedir)())}get userDataPath(){const o=process.env.VSCODE_PORTABLE;return o?(0,b.join)(o,"user-data"):y(this._args,process)}get appSettingsHome(){return M.URI.file((0,b.join)(this.userDataPath,"User"))}get tmpDir(){return M.URI.file((0,p.tmpdir)())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return M.URI.file((0,b.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(M.URI.file((0,b.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return M.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return M.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const o=process.env.VSCODE_PORTABLE;return o?M.URI.file((0,b.join)(o,"argv.json")):(0,P.joinPath)(this.userHome,R.default.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return M.URI.file((0,b.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,b.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const o=w(this._args["builtin-extensions-dir"],process);return o||(0,b.normalize)((0,b.join)(i.FileAccess.asFileUri("",H).fsPath,"..","extensions"))}get extensionsDownloadPath(){const o=w(this._args["extensions-download-dir"],process);return o||(0,b.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const o=w(this._args["extensions-dir"],process);if(o)return o;const c=process.env.VSCODE_EXTENSIONS;if(c)return c;const l=process.env.VSCODE_PORTABLE;return l?(0,b.join)(l,"extensions"):(0,P.joinPath)(this.userHome,R.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const o=this._args.extensionDevelopmentPath;if(Array.isArray(o))return o.map(c=>/^[^:/?#]+?:\/\//.test(c)?M.URI.parse(c):M.URI.file((0,b.normalize)(c)))}get extensionTestsLocationURI(){const o=this._args.extensionTestsPath;if(o)return/^[^:/?#]+?:\/\//.test(o)?M.URI.parse(o):M.URI.file((0,b.normalize)(o))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const o=this._args["disable-extension"];if(o){if(typeof o=="string")return[o];if(Array.isArray(o)&&o.length>0)return o}return!1}get debugExtensionHost(){return E(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get serviceMachineIdResource(){return(0,P.joinPath)(M.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return M.URI.file((0,b.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}he([n.memoize],f.prototype,"appRoot",null),he([n.memoize],f.prototype,"userHome",null),he([n.memoize],f.prototype,"userDataPath",null),he([n.memoize],f.prototype,"appSettingsHome",null),he([n.memoize],f.prototype,"tmpDir",null),he([n.memoize],f.prototype,"userRoamingDataHome",null),he([n.memoize],f.prototype,"settingsResource",null),he([n.memoize],f.prototype,"userDataSyncHome",null),he([n.memoize],f.prototype,"userDataSyncLogResource",null),he([n.memoize],f.prototype,"sync",null),he([n.memoize],f.prototype,"machineSettingsResource",null),he([n.memoize],f.prototype,"globalStorageHome",null),he([n.memoize],f.prototype,"workspaceStorageHome",null),he([n.memoize],f.prototype,"keybindingsResource",null),he([n.memoize],f.prototype,"keyboardLayoutResource",null),he([n.memoize],f.prototype,"argvResource",null),he([n.memoize],f.prototype,"snippetsHome",null),he([n.memoize],f.prototype,"isExtensionDevelopment",null),he([n.memoize],f.prototype,"untitledWorkspacesHome",null),he([n.memoize],f.prototype,"installSourcePath",null),he([n.memoize],f.prototype,"builtinExtensionsPath",null),he([n.memoize],f.prototype,"extensionsPath",null),he([n.memoize],f.prototype,"extensionDevelopmentLocationURI",null),he([n.memoize],f.prototype,"extensionTestsLocationURI",null),he([n.memoize],f.prototype,"debugExtensionHost",null),he([n.memoize],f.prototype,"serviceMachineIdResource",null),he([n.memoize],f.prototype,"telemetryLogResource",null),e.NativeEnvironmentService=f;function E(v,o){return d(v["inspect-extensions"],v["inspect-brk-extensions"],5870,o,v.debugId)}e.parseExtensionHostPort=E;function g(v,o){return d(v["inspect-search"],v["inspect-brk-search"],5876,o)}e.parseSearchPort=g;function d(v,o,c,l,s){const r=Number(o||v)||(l?null:c),a=r?Boolean(!!o):!1;return{port:r,break:a,debugId:s}}function w(v,o){if(!!v){const c=(0,b.resolve)(v);return(0,b.normalize)(v)===c?c:(0,b.resolve)(o.env.VSCODE_CWD||o.cwd(),v)}}e.parsePathArg=w;function y(v,o){return w(v["user-data-dir"],o)||(0,b.resolve)((0,L.getDefaultUserDataPath)())}e.parseUserDataDir=y}),define(Z[61],x([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Z[176],x([0,1,58,6,61]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let b=class{constructor(n,S){this.productService=n,this.logService=S,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,S){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const i=/^(.*)#([^#]+)$/.exec(S);if(!i)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",S),!1;const[,M,f]=i;let E=this.trustedExtensionUrlPublicKeys.get(n);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[n],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...E])}const g=Buffer.from(decodeURIComponent(f),"base64");if(g.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",S),!1;const d=g.slice(0,6),w=g.readUIntBE(0,6),y=Date.now()-w;if(y<0||y>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",S),!1;const v=g.slice(6),o=p.createVerify("SHA256");o.write(d),o.write(Buffer.from(M)),o.end();for(let c=0;c<E.length;c++){let l=E[c];if(l!==null){if(typeof l=="string")try{l=p.createPublicKey({key:Buffer.from(l,"base64"),format:"der",type:"spki"}),E[c]=l}catch(s){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${n}:`,s),E[c]=null;continue}if(o.verify(l,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",S),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",S),!1}};b=he([ee(0,L.IProductService),ee(1,R.ILogService)],b),e.ExtensionUrlTrustService=b}),define(Z[36],x([0,1,13,99]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(P,n){R.ok(p.isString(P)),R.ok(p.isObject(n)),R.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,n)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new L}),define(Z[177],x([0,1,36,4]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class b{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,i){this.schemasById[L(S)]=i,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new b;p.Registry.add(e.Extensions.JSONContribution,P)}),define(Z[46],x([0,1,129,4,36,13,177]),function(H,e,p,R,L,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=L.Registry.as(P.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,o=!0){this.registerConfigurations([v],o)}registerConfigurations(v,o=!0){const c=[];v.forEach(l=>{c.push(...this.validateAndRegisterProperties(l,o)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(v){const o=[],c=l=>{if(l.properties)for(const s in l.properties)o.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,l.properties[s]);l.allOf&&l.allOf.forEach(s=>c(s))};for(const l of v){c(l);const s=this.configurationContributors.indexOf(l);s!==-1&&this.configurationContributors.splice(s,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(v){const o=[],c=[];for(const l of v)for(const s in l)if(o.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),l[s]);const t={type:"object",default:this.defaultValues[s],description:p.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};c.push(f(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=l[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(v){const o=[];for(const c of v)for(const l in c)if(o.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const s=this.configurationProperties[l];s&&(this.updatePropertyDefaultValue(l,s),this.updateSchema(l,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const o of v)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,o=!0,c=3){c=b.isUndefinedOrNull(v.scope)?c:v.scope;let l=[],s=v.properties;if(s)for(let r in s){if(o&&d(r)){delete s[r];continue}const a=s[r];if(this.updatePropertyDefaultValue(r,a),e.OVERRIDE_PROPERTY_PATTERN.test(r)?a.scope=void 0:a.scope=b.isUndefinedOrNull(a.scope)?c:a.scope,s[r].hasOwnProperty("included")&&!s[r].included){this.excludedConfigurationProperties[r]=s[r],delete s[r];continue}else this.configurationProperties[r]=s[r];!s[r].deprecationMessage&&s[r].markdownDeprecationMessage&&(s[r].deprecationMessage=s[r].markdownDeprecationMessage),l.push(r)}let t=v.allOf;if(t)for(let r of t)l.push(...this.validateAndRegisterProperties(r,o,c));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const o=c=>{let l=c.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let s=c.allOf;s&&s.forEach(o)};o(v)}updateSchema(v,o){switch(e.allSettings.properties[v]=o,o.scope){case 1:e.applicationSettings.properties[v]=o;break;case 2:e.machineSettings.properties[v]=o;break;case 6:e.machineOverridableSettings.properties[v]=o;break;case 3:e.windowSettings.properties[v]=o;break;case 4:e.resourceSettings.properties[v]=o;break;case 5:e.resourceSettings.properties[v]=o,this.resourceLanguageSettingsSchema.properties[v]=o;break}}removeFromSchema(v,o){switch(delete e.allSettings.properties[v],o.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const o=`[${v}]`,c={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,c),e.allSettings.properties[o]=c,e.applicationSettings.properties[o]=c,e.machineSettings.properties[o]=c,e.machineOverridableSettings.properties[o]=c,e.windowSettings.properties[o]=c,e.resourceSettings.properties[o]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,o){let c=this.defaultValues[v];b.isUndefined(c)&&(c=o.default),b.isUndefined(c)&&(c=E(o.type)),o.default=c}}const M="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(M);function f(y){return y.substring(1,y.length-1)}e.overrideIdentifierFromKey=f;function E(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const g=new i;L.Registry.add(e.Extensions.Configuration,g);function d(y){return y.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(y)?p.localize(5,null,y):g.getConfigurationProperties()[y]!==void 0?p.localize(6,null,y):null:p.localize(4,null)}e.validateProperty=d;function w(){const y=[],v=g.getConfigurationProperties();for(const o of Object.keys(v))y.push([o,v[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=w}),define(Z[24],x([0,1,44,13,7,36,5,46]),function(H,e,p,R,L,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function S(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=S;var i;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(i=e.ConfigurationTarget||(e.ConfigurationTarget={}));function M(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=M;function f(r,a){const h=a?r?a.keys.filter($=>r.keys.indexOf($)===-1):[...a.keys]:[],u=r?a?r.keys.filter($=>a.keys.indexOf($)===-1):[...r.keys]:[],m=[];if(a&&r){for(const $ of r.keys)if(a.keys.indexOf($)!==-1){const X=v(r.contents,$),ne=v(a.contents,$);p.equals(X,ne)||m.push($)}}const I=[],A=$=>{const X={};for(const ne of $)for(const Y of ne.identifiers)X[s(Y)]=ne;return X},T=a?A(a.overrides):{},N=r?A(r.overrides):{};if(Object.keys(T).length)for(const $ of h){const X=T[$];X&&I.push([(0,n.overrideIdentifierFromKey)($),X.keys])}if(Object.keys(N).length)for(const $ of u){const X=N[$];X&&I.push([(0,n.overrideIdentifierFromKey)($),X.keys])}if(Object.keys(T).length&&Object.keys(N).length)for(const $ of m){const X=N[$],ne=T[$];if(X&&ne){const Y=f({contents:X.contents,keys:X.keys,overrides:[]},{contents:ne.contents,keys:ne.keys,overrides:[]});I.push([(0,n.overrideIdentifierFromKey)($),[...Y.added,...Y.removed,...Y.updated]])}}return{added:h,removed:u,updated:m,overrides:I}}e.compare=f;function E(r,a){const h=[];for(const u of Object.keys(r))if(n.OVERRIDE_PROPERTY_PATTERN.test(u)){const m={};for(const I in r[u])m[I]=r[u][I];h.push({identifiers:[(0,n.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(m),contents:g(m,a)})}return h}e.toOverrides=E;function g(r,a){const h=Object.create(null);for(let u in r)d(h,u,r[u],a);return h}e.toValuesTree=g;function d(r,a,h,u){const m=a.split("."),I=m.pop();let A=r;for(let T=0;T<m.length;T++){let N=m[T],$=A[N];switch(typeof $){case"undefined":$=A[N]=Object.create(null);break;case"object":break;default:u(`Ignoring ${a} as ${m.slice(0,T+1).join(".")} is ${JSON.stringify($)}`);return}A=$}if(typeof A=="object"&&A!==null)try{A[I]=h}catch(T){u(`Ignoring ${a} as ${m.join(".")} is ${JSON.stringify(A)}`)}else u(`Ignoring ${a} as ${m.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=d;function w(r,a){const h=a.split(".");y(r,h)}e.removeFromValueTree=w;function y(r,a){const h=a.shift();if(a.length===0){delete r[h];return}if(Object.keys(r).indexOf(h)!==-1){const u=r[h];typeof u=="object"&&!Array.isArray(u)&&(y(u,a),Object.keys(u).length===0&&delete r[h])}}function v(r,a,h){function u(A,T){let N=A;for(const $ of T){if(typeof N!="object"||N===null)return;N=N[$]}return N}const m=a.split("."),I=u(r,m);return typeof I=="undefined"?h:I}e.getConfigurationValue=v;function o(r,a,h){Object.keys(a).forEach(u=>{u!=="__proto__"&&(u in r?R.isObject(r[u])&&R.isObject(a[u])?o(r[u],a[u],h):h&&(r[u]=a[u]):r[u]=a[u])})}e.merge=o;function c(){const r=b.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=c;function l(){const r=Object.create(null),a=b.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let h in a){let u=a[h].default;d(r,h,u,m=>console.error(`Conflict in default settings: ${m}`))}return r}e.getDefaultValues=l;function s(r){return`[${r}]`}e.keyFromOverrideIdentifier=s;function t(r,a,h){const u=r.inspect(a),m=r.inspect(h);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:u.defaultValue}e.getMigratedSettingValue=t}),define(Z[178],x([0,1,43,35,34,13,44,7,46,24,36,2,4]),function(H,e,p,R,L,b,P,n,S,i,M,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},r=[],a=[]){this._contents=t,this._keys=r,this._overrides=a,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const a=this.getContentsForOverrideIdentifer(r);return a?t?(0,i.getConfigurationValue)(a,t):a:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let a={};for(const h of L.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[h],m=r[h];m&&(typeof u=="object"&&typeof m=="object"?(u=P.deepClone(u),this.mergeContents(u,m)):u=m),a[h]=u}return new g(a,this.keys,this.overrides)}merge(...t){const r=P.deepClone(this.contents),a=P.deepClone(this.overrides),h=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const m of u.overrides){const[I]=a.filter(A=>L.equals(A.identifiers,m.identifiers));I?this.mergeContents(I.contents,m.contents):a.push(P.deepClone(m))}for(const m of u.keys)h.indexOf(m)===-1&&h.push(m)}return new g(r,h,a)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const a of Object.keys(r)){if(a in t&&b.isObject(t[a])&&b.isObject(r[a])){this.mergeContents(t[a],r[a]);continue}t[a]=P.deepClone(r[a])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,i.addToValueTree)(this.contents,t,r,a=>{throw new Error(a)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let a=0;a<r;a++)t.indexOf(this.keys[a])===0&&(r=a);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=g;class d extends g{constructor(){const t=(0,i.getDefaultValues)(),r=(0,i.getConfigurationKeys)(),a=[];for(const h of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(h)&&a.push({identifiers:[(0,S.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(t[h]),contents:(0,i.toValuesTree)(t[h],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,a)}}e.DefaultConfigurationModel=d;class w{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get errors(){return this._parseErrors}parseContent(t){if(!b.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new g(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},a=null,h=[],u=[],m=[];function I(T){Array.isArray(h)?h.push(T):a&&(h[a]=T)}let A={onObjectBegin:()=>{let T={};I(T),u.push(h),h=T,a=null},onObjectProperty:T=>{a=T},onObjectEnd:()=>{h=u.pop()},onArrayBegin:()=>{let T=[];I(T),u.push(h),h=T,a=null},onArrayEnd:()=>{h=u.pop()},onLiteralValue:I,onError:(T,N,$)=>{m.push({error:T,offset:N,length:$})}};if(t)try{p.visit(t,A),r=h[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return r}doParseRaw(t){if(this._scopes){const u=M.Registry.as(S.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,u,!0,this._scopes)}const r=(0,i.toValuesTree)(t,u=>console.error(`Conflict in settings file ${this._name}: ${u}`)),a=Object.keys(t),h=(0,i.toOverrides)(t,u=>console.error(`Conflict in settings file ${this._name}: ${u}`));return{contents:r,keys:a,overrides:h}}filterByScope(t,r,a,h){const u={};for(let m in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(m)&&a)u[m]=this.filterByScope(t[m],r,!1,h);else{const I=this.getScope(m,r);(I===void 0||h.indexOf(I)!==-1)&&(u[m]=t[m])}return u}getScope(t,r){const a=r[t];return a?typeof a.scope!="undefined"?a.scope:3:void 0}}e.ConfigurationModelParser=w;class y extends f.Disposable{constructor(t,r,a,h){super();this.userSettingsResource=t,this.scopes=r,this.fileService=h,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(E.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new g}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=y;class v{constructor(t,r,a=new g,h=new g,u=new R.ResourceMap,m=new g,I=new R.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=a,this._workspaceConfiguration=h,this._folderConfigurations=u,this._memoryConfiguration=m,this._memoryConfigurationByResource=I,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,a){return this.getConsolidateConfigurationModel(r,a).getValue(t)}updateValue(t,r,a={}){let h;a.resource?(h=this._memoryConfigurationByResource.get(a.resource),h||(h=new g,this._memoryConfigurationByResource.set(a.resource,h))):h=this._memoryConfiguration,r===void 0?h.removeValue(t):h.setValue(t,r),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,a){const h=this.getConsolidateConfigurationModel(r,a),u=this.getFolderConfigurationModelForResource(r.resource,a),m=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,I=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),N=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),$=a?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,X=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,ne=r.overrideIdentifier?m.override(r.overrideIdentifier).getValue(t):m.getValue(t),Y=h.getValue(t),Q=L.distinct(L.flatten(h.overrides.map(B=>B.identifiers))).filter(B=>h.getOverrideValue(t,B)!==void 0);return{defaultValue:I,userValue:A,userLocalValue:T,userRemoteValue:N,workspaceValue:$,workspaceFolderValue:X,memoryValue:ne,value:Y,default:I!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:N!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:$!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:X!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:r.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:m.getValue(t),override:r.overrideIdentifier?m.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Q.length?Q:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const a=r.filter(h=>S.OVERRIDE_PROPERTY_PATTERN.test(h)).map(h=>{const u=(0,S.overrideIdentifierFromKey)(h),m=this._defaultConfiguration.getKeysForOverrideIdentifier(u),I=t.getKeysForOverrideIdentifier(u),A=[...I.filter(T=>m.indexOf(T)===-1),...m.filter(T=>I.indexOf(T)===-1),...m.filter(T=>!P.equals(this._defaultConfiguration.override(u).getValue(T),t.override(u).getValue(T)))];return[u,A]});return this.updateDefaultConfiguration(t),{keys:r,overrides:a}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:a,removed:h,overrides:u}=(0,i.compare)(this.localUserConfiguration,t),m=[...r,...a,...h];return m.length&&this.updateLocalUserConfiguration(t),{keys:m,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:a,removed:h,overrides:u}=(0,i.compare)(this.remoteUserConfiguration,t);let m=[...r,...a,...h];return m.length&&this.updateRemoteUserConfiguration(t),{keys:m,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:a,removed:h,overrides:u}=(0,i.compare)(this.workspaceConfiguration,t);let m=[...r,...a,...h];return m.length&&this.updateWorkspaceConfiguration(t),{keys:m,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const a=this.folderConfigurations.get(t),{added:h,updated:u,removed:m,overrides:I}=(0,i.compare)(a,r);let A=[...h,...u,...m];return(A.length||!a)&&this.updateFolderConfiguration(t,r),{keys:A,overrides:I}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:a,updated:h,removed:u,overrides:m}=(0,i.compare)(r,void 0);return{keys:[...a,...h,...u],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let a=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?a.override(t.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:t},r){let a=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const h=r.getFolder(t);h&&(a=this.getFolderConsolidatedConfiguration(h.uri)||a);const u=this._memoryConfigurationByResource.get(t);u&&(a=a.merge(u))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const a=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(t);h?(r=a.merge(h),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=a}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const a=r.getFolder(t);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:a,overrides:h,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:a,overrides:h,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(a=>t.add(a))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(t).forEach(h=>r.add(h))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),a=this.parseConfigurationModel(t.user),h=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((m,I)=>(m.set(n.URI.revive(I[0]),this.parseConfigurationModel(I[1])),m),new R.ResourceMap);return new v(r,a,new g,h,u,new g,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function o(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,r=new Map;for(const h of s)h.keys.forEach(u=>t.add(u)),h.overrides.forEach(([u,m])=>{const I=(0,R.getOrSet)(r,u,new Set);m.forEach(A=>I.add(A))});const a=[];return r.forEach((h,u)=>a.push([u,[...h.values()]])),{keys:[...t.values()],overrides:a}}e.mergeChanges=o;class c{constructor(t,r,a,h){this.change=t,this.previous=r,this.currentConfiguraiton=a,this.currentWorkspace=h,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(I=>u.add(I)),t.overrides.forEach(([,I])=>I.forEach(A=>u.add(A))),this.affectedKeys=[...u.values()];const m=new g;this.affectedKeys.forEach(I=>m.setValue(I,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var a;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const h=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(a=this.previous)===null||a===void 0?void 0:a.workspace):void 0,u=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!P.equals(h,u)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let a=(0,i.toValuesTree)({[r]:!0},()=>{}),h;for(;typeof a=="object"&&(h=Object.keys(a)[0]);){if(t=t[h],!t)return!1;a=a[h]}return!0}}e.ConfigurationChangeEvent=c;class l extends c{constructor(t,r,a,h){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=a,this.sourceConfig=h}}e.AllKeysConfigurationChangeEvent=l}),define(Z[179],x([0,1,36,46,2,24,178,4,10,15]),function(H,e,p,R,L,b,P,n,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class M extends L.Disposable{constructor(E,g){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,i.extUriBiasedIgnorePathCase,g)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(R.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,g){const d=typeof E=="string"?E:void 0,w=(0,b.isConfigurationOverrides)(E)?E:(0,b.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(d,w,void 0)}updateValue(E,g,d,w){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const g=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(d,g,1)}onDidDefaultConfigurationChange(E){const g=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,E);this.trigger(d,g,6)}trigger(E,g,d){const w=new P.ConfigurationChangeEvent(E,{data:g},this.configuration);w.source=d,w.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=M}),define(Z[180],x([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var R;(function(b){b.Unknown="Unknown",b.NotAvailable="NotAvailable",b.TemporarilyNotAvailable="TemporarilyNotAvailable",b.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(P,n=R.Unknown,S){super(P);this._message=P,this._code=n,this._detail=S,this.isHandled=n===R.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(P){return P instanceof L&&P._code===R.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof L&&P._code===R.NoResolverFound}static isHandled(P){return P instanceof L&&P.isHandled}}e.RemoteAuthorityResolverError=L}),define(Z[181],x([0,1,82,30,2,21,4,180,19,10,25]),function(H,e,p,R,L,b,P,n,S,i,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const f=30*1e3;var E;(function(_){_[_.Management=1]="Management",_[_.ExtensionHost=2]="ExtensionHost",_[_.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function g(_){switch(_){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(_){const C=new M.CancellationTokenSource;return setTimeout(()=>C.cancel(),_),C.token}function w(_,C){if(_.isCancellationRequested||C.isCancellationRequested)return M.CancellationToken.Cancelled;const j=new M.CancellationTokenSource;return _.onCancellationRequested(()=>j.cancel()),C.onCancellationRequested(()=>j.cancel()),j.token}class y{constructor(C){this._state="pending",this._disposables=new L.DisposableStore,this.promise=new Promise((j,G)=>{this._resolvePromise=j,this._rejectPromise=G}),C.isCancellationRequested?this._timeout():this._disposables.add(C.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(C){this._state==="pending"?this._disposables.add(C):C.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const C=new Error("Time limit reached");return C.code="ETIMEDOUT",C.syscall="connect",C}resolve(C){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(C))}reject(C){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(C))}}function v(_,C){const j=new y(C);return j.registerDisposable(_.onControlMessage(G=>{const K=JSON.parse(G.toString()),V=W(K);V?j.reject(V):j.resolve(K)})),j.promise}function o(_,C,j,G,K,V){const J=new y(V);return C.connect(j,G,K,(re,ie)=>{J.didTimeout?(re&&_.error(re),ie==null||ie.dispose()):re||!ie?J.reject(re):J.resolve(ie)}),J.promise}function c(_,C){const j=new y(C);return _.then(G=>{j.didTimeout||j.resolve(G)},G=>{j.didTimeout||j.reject(G)}),j.promise}async function l(_,C,j,G){const K=k(_,C);_.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let V;try{V=await o(_.logService,_.socketFactory,_.host,_.port,`reconnectionToken=${_.reconnectionToken}&reconnection=${_.reconnectionProtocol?"true":"false"}`,G)}catch(se){throw _.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),_.logService.error(se),se}_.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let J,re;_.reconnectionProtocol?(_.reconnectionProtocol.beginAcceptReconnection(V,null),J=_.reconnectionProtocol,re=!1):(J=new p.PersistentProtocol(V,null),re=!0),_.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const ie={type:"auth",auth:_.connectionToken||"00000000000000000000"};J.sendControl(b.VSBuffer.fromString(JSON.stringify(ie)));try{const se=await v(J,w(G,d(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const ce=new Error("Unexpected handshake message");throw ce.code="VSCODE_CONNECTION_ERROR",ce}_.logService.trace(`${K} 4/6. received SignRequest control message.`);const me=await c(_.signService.sign(se.data),G),le={type:"connectionType",commit:_.commit,signedData:me,desiredConnectionType:C};return j&&(le.args=j),_.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(b.VSBuffer.fromString(JSON.stringify(le))),{protocol:J,ownsProtocol:re}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(_.logService.error(`${K} the handshake timed out. Error:`),_.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(_.logService.error(`${K} received error control message when negotiating connection. Error:`),_.logService.error(se)),re&&U(J),se}}async function s(_,C,j,G){const K=Date.now(),V=k(_,C),{protocol:J,ownsProtocol:re}=await l(_,C,j,G),ie=new y(G);return ie.registerDisposable(J.onControlMessage(se=>{const me=JSON.parse(se.toString()),le=W(me);le?(_.logService.error(`${V} received error control message when negotiating connection. Error:`),_.logService.error(le),re&&U(J),ie.reject(le)):(_.reconnectionProtocol&&_.reconnectionProtocol.endAcceptReconnection(),_.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${F(K)}!`),ie.resolve({protocol:J,firstMessage:me}))})),ie.promise}async function t(_,C){const{protocol:j}=await s(_,1,void 0,C);return{protocol:j}}async function r(_,C,j){const{protocol:G,firstMessage:K}=await s(_,2,C,j),V=K&&K.debugPort;return{protocol:G,debugPort:V}}async function a(_,C,j){const G=Date.now(),K=k(_,3),{protocol:V}=await l(_,3,C,j);return _.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${F(G)}!`),V}async function h(_,C,j){const{host:G,port:K,connectionToken:V}=await _.addressProvider.getAddress();return{commit:_.commit,host:G,port:K,connectionToken:V,reconnectionToken:C,reconnectionProtocol:j,socketFactory:_.socketFactory,signService:_.signService,logService:_.logService}}async function u(_,C,j){try{const G=(0,R.generateUuid)(),K=await h(_,G,null),{protocol:V}=await t(K,M.CancellationToken.None);return new B(_,C,j,G,V)}catch(G){throw _.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),_.logService.error(G),Q.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(G)),G}}e.connectRemoteAgentManagement=u;async function m(_,C){try{const j=(0,R.generateUuid)(),G=await h(_,j,null),{protocol:K,debugPort:V}=await r(G,C,M.CancellationToken.None);return new z(_,C,j,K,V)}catch(j){throw _.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),_.logService.error(j),Q.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(j)),j}}e.connectRemoteAgentExtensionHost=m;async function I(_,C){const j=await h(_,(0,R.generateUuid)(),null);return await a(j,{port:C},M.CancellationToken.None)}e.connectRemoteAgentTunnel=I;function A(_){return(0,i.createCancelablePromise)(C=>new Promise((j,G)=>{const K=setTimeout(j,_*1e3);C.onCancellationRequested(()=>{clearTimeout(K),j()})}))}var T;(function(_){_[_.ConnectionLost=0]="ConnectionLost",_[_.ReconnectionWait=1]="ReconnectionWait",_[_.ReconnectionRunning=2]="ReconnectionRunning",_[_.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",_[_.ConnectionGain=4]="ConnectionGain"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class N{constructor(C,j){this.reconnectionToken=C,this.millisSinceLastIncomingData=j,this.type=0}}e.ConnectionLostEvent=N;class ${constructor(C,j,G,K){this.reconnectionToken=C,this.millisSinceLastIncomingData=j,this.durationSeconds=G,this.cancellableTimer=K,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=$;class X{constructor(C,j,G){this.reconnectionToken=C,this.millisSinceLastIncomingData=j,this.attempt=G,this.type=2}}e.ReconnectionRunningEvent=X;class ne{constructor(C,j,G){this.reconnectionToken=C,this.millisSinceLastIncomingData=j,this.attempt=G,this.type=4}}e.ConnectionGainEvent=ne;class Y{constructor(C,j,G,K){this.reconnectionToken=C,this.millisSinceLastIncomingData=j,this.attempt=G,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=Y;class Q extends L.Disposable{constructor(C,j,G,K){super();this._connectionType=C,this._onDidStateChange=this._register(new P.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=j,this.reconnectionToken=G,this.protocol=K,this._isReconnecting=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(K.onSocketClose(()=>this._beginReconnecting())),this._register(K.onSocketTimeout(()=>this._beginReconnecting())),Q._instances.push(this),Q._permanentFailure&&this._gotoPermanentFailure(Q._permanentFailureMillisSinceLastIncomingData,Q._permanentFailureAttempt,Q._permanentFailureHandled)}static triggerPermanentFailure(C,j,G){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=C,this._permanentFailureAttempt=j,this._permanentFailureHandled=G,this._instances.forEach(K=>K._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(!Q._permanentFailure){const C=D(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${C} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30],G=Date.now();let K=-1;do{K++;const V=K<j.length?j[K]:j[j.length-1];try{if(V>0){const re=A(V);this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V,re)),this._options.logService.info(`${C} waiting for ${V} seconds before reconnecting...`);try{await re}catch(ie){}}if(Q._permanentFailure){this._options.logService.error(`${C} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K+1)),this._options.logService.info(`${C} resolving connection...`);const J=await h(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${C} connecting to ${J.host}:${J.port}...`),await this._reconnect(J,d(f)),this._options.logService.info(`${C} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${C} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(J),Q.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}if(Date.now()-G>108e5){this._options.logService.error(`${C} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(J),Q.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(J)){this._options.logService.info(`${C} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this._options.logService.info(`${C} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(J);continue}if((0,S.isPromiseCanceledError)(J)){this._options.logService.info(`${C} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(J);continue}if(J instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${C} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(J),Q.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),K+1,n.RemoteAuthorityResolverError.isHandled(J));break}this._options.logService.error(`${C} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(J),Q.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}}while(!Q._permanentFailure)}}_gotoPermanentFailure(C,j,G){this._onDidStateChange.fire(new Y(this.reconnectionToken,C,j,G)),U(this.protocol)}}Q._permanentFailure=!1,Q._permanentFailureMillisSinceLastIncomingData=0,Q._permanentFailureAttempt=0,Q._permanentFailureHandled=!1,Q._instances=[];class B extends Q{constructor(C,j,G,K,V){super(1,C,K,V);this.client=this._register(new p.Client(V,{remoteAuthority:j,clientId:G},C.ipcLogger))}async _reconnect(C,j){await t(C,j)}}e.ManagementPersistentConnection=B;class z extends Q{constructor(C,j,G,K,V){super(2,C,G,K);this._startArguments=j,this.debugPort=V}async _reconnect(C,j){await r(C,this._startArguments,j)}}e.ExtensionHostPersistentConnection=z;function U(_){try{_.acceptDisconnect();const C=_.getSocket();_.dispose(),C.dispose()}catch(C){(0,S.onUnexpectedError)(C)}}function W(_){if(_&&_.type==="error"){const C=new Error(`Connection error: ${_.reason}`);return C.code="VSCODE_CONNECTION_ERROR",C}return null}function O(_,C){for(;_.length<C;)_+=" ";return _}function D(_,C,j){return`[remote-connection][${O(g(_),13)}][${C.substr(0,5)}\u2026][${j?"reconnect":"initial"}]`}function k(_,C){return`${D(C,_.reconnectionToken,!!_.reconnectionProtocol)}[${_.host}:${_.port}]`}function F(_){return`${Date.now()-_} ms`}}),define(Z[71],x([0,1,9]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function R(b){return b.scheme===p.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=R;function L(b){if(!!b){const P=b.indexOf("+");return P<0?b:b.substr(0,P)}}e.getRemoteName=L}),define(Z[54],x([0,1,4,3,5,6]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService");var P;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function n(E){if(!(E.scheme!=="http"&&E.scheme!=="https")){const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!g)return{address:g[1],port:+g[2]}}}e.extractLocalHostUriMetaDataForPortMapping=n,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=S,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=i;function M(E,g){return g?g!==1&&E<1024:!R.isWindows&&E<1024}e.isPortPrivileged=M;let f=class{constructor(g){this.logService=g,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}setTunnelProvider(g,d){return this._tunnelProvider=g,g?(this._canElevate=d.elevation,this._canMakePublic=d.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async g=>{const d=[],w=Array.from(this._tunnels.values());for(let y of w){const v=Array.from(y.values());for(let o of v){const c=await o.value;c&&d.push(c)}}g(d)})}async dispose(){for(const g of this._tunnels.values()){for(const{value:d}of g.values())await d.then(w=>w==null?void 0:w.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,d,w,y,v=!1,o=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${w} on local port ${y}.`),!!g){d||(d="localhost");const c=this.retainOrCreateTunnel(g,d,w,y,v,o);return c?c.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,w);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(l);return(l.tunnelRemoteHost!==d||l.tunnelRemotePort!==w)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,public:g.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemotePort} `);const d=this._tunnels.get(g.tunnelRemoteHost);if(d){const w=d.get(g.tunnelRemotePort);w&&(w.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,w))}}}}async tryDisposeTunnel(g,d,w){if(w.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${d}.`);const y=w.value.then(async v=>{v&&(await v.dispose(!0),this._onTunnelClosed.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(d),y}}async closeTunnel(g,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d} `);const w=this._tunnels.get(g);if(w&&w.has(d)){const y=w.get(d);y.refcount=0,await this.tryDisposeTunnel(g,d,y)}}addTunnelToMap(g,d,w){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(d,{refcount:1,value:w})}async removeEmptyTunnelFromMap(g,d){const w=this._tunnels.get(g);w&&(await w.get(d)||w.delete(d),w.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,d){let w=[g];S(g)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):i(g)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const y=w.map(v=>this._tunnels.get(v));for(const v of y){const o=v==null?void 0:v.get(d);if(o)return o}}canTunnel(g){return!!n(g)}createWithProvider(g,d,w,y,v,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${w} on local port ${y}.`);const l={elevationRequired:v?M(y===void 0?w:y):!1},s={remoteAddress:{host:d,port:w},localAddressPort:y,public:o},t=g.forwardPort(s,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,w,t),t}};f=he([ee(0,b.ILogService)],f),e.AbstractTunnelService=f}),define(Z[39],x([0,1,141,5,46,36,21]),function(H,e,p,R,L,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function n(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=n;function S(f){return f.res.statusCode===204}async function i(f){if(!n(f))throw new Error("Server returned "+f.res.statusCode);return S(f)?null:(await(0,P.streamToBuffer)(f.stream)).toString()}e.asText=i;async function M(f){if(!n(f))throw new Error("Server returned "+f.res.statusCode);if(S(f))return null;const g=(await(0,P.streamToBuffer)(f.stream)).toString();try{return JSON.parse(g)}catch(d){throw d.message+=`:
`+g,d}}e.asJson=M,b.Registry.as(L.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:(0,p.localize)(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,p.localize)(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,p.localize)(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,p.localize)(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,p.localize)(4,null),(0,p.localize)(5,null),(0,p.localize)(6,null)],default:"override",description:(0,p.localize)(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:(0,p.localize)(8,null)}}})}),define(Z[182],x([0,1,183,13]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function L(P){return P.protocol==="http:"?process.env.HTTP_PROXY||process.env.http_proxy||null:P.protocol==="https:"&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}async function b(P,n={}){const S=(0,p.parse)(P),i=n.proxyUrl||L(S);if(!i)return null;const M=(0,p.parse)(i);if(!/^https?:$/.test(M.protocol||""))return null;const f={host:M.hostname||"",port:M.port||(M.protocol==="https"?"443":"80"),auth:M.auth,rejectUnauthorized:(0,R.isBoolean)(n.strictSSL)?n.strictSSL:!0};return S.protocol==="http:"?new(await new Promise((E,g)=>{H(["http-proxy-agent"],E,g)}))(f):new(await new Promise((E,g)=>{H(["https-proxy-agent"],E,g)}))(f)}e.getProxyAgent=b}),define(Z[184],x([0,1,30,21]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(b,P,n){let S=n&&n.get("storage.serviceMachineId",0)||null;if(S)return S;try{const M=(await P.readFile(b.serviceMachineIdResource)).value.toString();S=(0,p.isUUID)(M)?M:null}catch(i){S=null}if(!S){S=(0,p.generateUuid)();try{await P.writeFile(b.serviceMachineIdResource,R.VSBuffer.fromString(S))}catch(i){}}return n&&n.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=L}),define(Z[72],x([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[185],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((L,b)=>H(["vsda"],L,b))}async sign(L){try{const b=await this.vsda(),P=new b.signer;if(P)return P.sign(L)}catch(b){}return L}}e.SignService=p}),define(Z[37],x([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,p.createDecorator)("stateService")}),define(Z[18],x([0,1,11,6,37,4,5,166,3,2,10,13]),function(H,e,p,R,L,b,P,n,S,i,M,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,P.createDecorator)("lifecycleMainService");var E;(function(w){w[w.CLOSE=1]="CLOSE",w[w.QUIT=2]="QUIT",w[w.RELOAD=3]="RELOAD",w[w.LOAD=4]="LOAD"})(E=e.UnloadReason||(e.UnloadReason={}));var g;(function(w){w[w.Starting=1]="Starting",w[w.Ready=2]="Ready",w[w.AfterWindowOpen=3]="AfterWindowOpen"})(g=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class xe extends i.Disposable{constructor(y,v){super();this.logService=y,this.stateService=v,this._onBeforeShutdown=this._register(new b.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new b.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new b.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new b.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new b.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=null,this.pendingQuitPromiseResolve=null,this.pendingWillShutdownPromise=null,this.phaseWhen=new Map,this.handleRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}handleRestarted(){this._wasRestarted=!!this.stateService.getItem(xe.QUIT_FROM_RESTART_MARKER),this._wasRestarted&&this.stateService.removeItem(xe.QUIT_FROM_RESTART_MARKER)}registerListeners(){const y=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),S.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};p.app.addListener("before-quit",y);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!S.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",v),p.app.once("will-quit",o=>{this.logService.trace("Lifecycle#app.on(will-quit)"),o.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",y),p.app.removeListener("window-all-closed",v),p.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const y=[];return this._onWillShutdown.fire({join(v){y.push(v)}}),this.pendingWillShutdownPromise=M.Promises.settled(y).then(()=>{},v=>this.logService.error(v)),this.pendingWillShutdownPromise}set phase(y){if(y<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase!==y){this.logService.trace(`lifecycle (main): phase changed (value: ${y})`),this._phase=y;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}}async when(y){if(!(y<=this._phase)){let v=this.phaseWhen.get(y);v||(v=new M.Barrier,this.phaseWhen.set(y,v)),await v.wait()}}registerWindow(y){const v=new i.DisposableStore;this.windowCounter++,v.add(y.onWillLoad(c=>this._onWillLoadWindow.fire({window:y,workspace:c.workspace})));const o=(0,f.assertIsDefined)(y.win);o.on("close",c=>{const l=y.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${y.id}`),c.preventDefault(),this.unload(y,1).then(s=>{if(s){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(y),y.close()})}),o.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${y.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!S.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(y,v){await this.unload(y,3)||y.reload(v)}async unload(y,v){if(!y.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${y.id}`);const o=this._quitRequested?2:v;let c=await this.onBeforeUnloadWindowInRenderer(y,o);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${y.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(y,o),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${y.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${y.id})`),await this.onWillUnloadWindowInRenderer(y,o),!1))}handleWindowUnloadVeto(y){return y?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(y){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(y),this.pendingQuitPromiseResolve=null,this.pendingQuitPromise=null)}onBeforeUnloadWindowInRenderer(y,v){return new Promise(o=>{const c=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${c}`,s=`vscode:cancel${c}`;p.ipcMain.once(l,()=>{o(!1)}),p.ipcMain.once(s,()=>{o(!0)}),y.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:s,reason:v})})}onBeforeUnloadWindowInMain(y,v){const o=[];return this._onBeforeUnloadWindow.fire({reason:v,window:y,veto(c){o.push(c)}}),(0,n.handleVetos)(o,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(y,v){return new Promise(o=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(l,()=>o()),y.send("vscode:onWillUnload",{replyChannel:l,reason:v})})}quit(y){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - from update: ${y}`),y&&this.stateService.setItem(xe.QUIT_FROM_RESTART_MARKER,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}relaunch(y){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if((y==null?void 0:y.addArgs)&&v.push(...y.addArgs),y==null?void 0:y.removeArgs)for(const c of y.removeArgs){const l=v.indexOf(c);l>=0&&v.splice(l,1)}let o=!1;p.app.once("quit",()=>{if(!o){this.stateService.setItem(xe.QUIT_FROM_RESTART_MARKER,!0);try{if(S.isWindows){const c=process.env.VSCODE_CWD;c&&process.chdir(c)}}catch(c){this.logService.error(c)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:v})}}),this.quit().then(c=>o=c)}async kill(y){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,M.timeout)(1e3),(async()=>{for(const v of p.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let o;v.webContents&&!v.webContents.isDestroyed()?o=new Promise(c=>v.once("closed",c)):o=Promise.resolve(),v.destroy(),await o}})()]),p.app.exit(y)}};d.QUIT_FROM_RESTART_MARKER="quit.from.restart",d=he([ee(0,R.ILogService),ee(1,L.IStateService)],d),e.LifecycleMainService=d}),define(Z[186],x([0,1,5,4,2,18]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,p.createDecorator)("keyboardLayoutMainService");let P=class extends L.Disposable{constructor(i){super();this._onDidChangeKeyboardLayout=this._register(new R.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,i.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const i=await new Promise((M,f)=>{H(["native-keymap"],M,f)});this._keyboardLayoutData=n(i),i.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(i),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=he([ee(0,b.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function n(S){const i=S.getKeyMap(),M=S.getCurrentKeyboardLayout();return{keyboardMapping:i,keyboardLayoutInfo:M}}}),define(Z[187],x([0,1,8,22,52,23,13,6]),function(H,e,p,R,L,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class S{constructor(f,E){this.dbPath=f,this.onError=E,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const f=await this.loadAsync();this._database||(this._database=f)}}loadSync(){try{return this.lastFlushedSerializedDatabase=R.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(f){return f.code!=="ENOENT"&&this.onError(f),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await R.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(f){return f.code!=="ENOENT"&&this.onError(f),{}}}getItem(f,E){const g=this.database[f];return(0,P.isUndefinedOrNull)(g)?E:g}setItem(f,E){if((0,P.isUndefinedOrNull)(E))return this.removeItem(f);(typeof E=="string"||typeof E=="number"||typeof E=="boolean")&&this.database[f]===E||(this.database[f]=E,this.saveSync())}removeItem(f){(0,P.isUndefined)(this.database[f])||(this.database[f]=void 0,this.saveSync())}saveSync(){const f=JSON.stringify(this.database,null,4);if(f!==this.lastFlushedSerializedDatabase)try{(0,b.writeFileSync)(this.dbPath,f),this.lastFlushedSerializedDatabase=f}catch(E){this.onError(E)}}}e.FileStorage=S;let i=class yt{constructor(f,E){this.fileStorage=new S(p.join(f.userDataPath,yt.STATE_FILE),g=>E.error(g))}init(){return this.fileStorage.init()}getItem(f,E){return this.fileStorage.getItem(f,E)}setItem(f,E){this.fileStorage.setItem(f,E)}removeItem(f){this.fileStorage.removeItem(f)}};i.STATE_FILE="storage.json",i=he([ee(0,L.INativeEnvironmentService),ee(1,n.ILogService)],i),e.StateService=i}),define(Z[93],x([0,1,5,4,2,13,84,10]),function(H,e,p,R,L,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=(0,p.createDecorator)("storageService");var i;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(i=e.WillSaveStateReason||(e.WillSaveStateReason={}));var M;(function(w){w[w.GLOBAL=0]="GLOBAL",w[w.WORKSPACE=1]="WORKSPACE"})(M=e.StorageScope||(e.StorageScope={}));var f;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class E extends L.Disposable{constructor(y={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=y,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,n.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,v){v===S?(y===0?this._globalKeyTargets=void 0:y===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:y})):this._onDidChangeValue.fire({scope:y,key:v,target:this.getKeyTargets(y)[v]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,v,o){var c;return(c=this.getStorage(v))===null||c===void 0?void 0:c.get(y,o)}getBoolean(y,v,o){var c;return(c=this.getStorage(v))===null||c===void 0?void 0:c.getBoolean(y,o)}getNumber(y,v,o){var c;return(c=this.getStorage(v))===null||c===void 0?void 0:c.getNumber(y,o)}store(y,v,o,c){if((0,b.isUndefinedOrNull)(v)){this.remove(y,o);return}this.withPausedEmitters(()=>{var l;this.updateKeyTarget(y,o,c),(l=this.getStorage(o))===null||l===void 0||l.set(y,v)})}remove(y,v){this.withPausedEmitters(()=>{var o;this.updateKeyTarget(y,v,void 0),(o=this.getStorage(v))===null||o===void 0||o.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,v){const o=[],c=this.getKeyTargets(y);for(const l of Object.keys(c))c[l]===v&&o.push(l);return o}updateKeyTarget(y,v,o){var c,l;const s=this.getKeyTargets(v);typeof o=="number"?s[y]!==o&&(s[y]=o,(c=this.getStorage(v))===null||c===void 0||c.set(S,JSON.stringify(s))):typeof s[y]=="number"&&(delete s[y],(l=this.getStorage(v))===null||l===void 0||l.set(S,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(y){return y===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(y){const v=this.get(S,y);if(v)try{return JSON.parse(v)}catch(o){}return Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(){var y,v,o,c;this._onWillSaveState.fire({reason:i.NONE}),await n.Promises.settled([(v=(y=this.getStorage(0))===null||y===void 0?void 0:y.whenFlushed())!==null&&v!==void 0?v:Promise.resolve(),(c=(o=this.getStorage(1))===null||o===void 0?void 0:o.whenFlushed())!==null&&c!==void 0?c:Promise.resolve()])}async logStorage(){var y,v,o,c,l,s;const t=(v=(y=this.getStorage(0))===null||y===void 0?void 0:y.items)!==null&&v!==void 0?v:new Map,r=(c=(o=this.getStorage(1))===null||o===void 0?void 0:o.items)!==null&&c!==void 0?c:new Map;return d(t,r,(l=this.getLogDetails(0))!==null&&l!==void 0?l:"",(s=this.getLogDetails(1))!==null&&s!==void 0?s:"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class g extends E{constructor(){super();this.globalStorage=new P.Storage(new P.InMemoryStorageDatabase),this.workspaceStorage=new P.Storage(new P.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.globalStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y)))}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(y){}}e.InMemoryStorageService=g;async function d(w,y,v,o){const c=u=>{try{return JSON.parse(u)}catch(m){return u}},l=new Map,s=new Map;w.forEach((u,m)=>{l.set(m,u),s.set(m,c(u))});const t=new Map,r=new Map;y.forEach((u,m)=>{t.set(m,u),r.set(m,c(u))}),console.group(`Storage: Global (path: ${v})`);let a=[];l.forEach((u,m)=>{a.push({key:m,value:u})}),console.table(a),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${o})`);let h=[];t.forEach((u,m)=>{h.push({key:m,value:u})}),console.table(h),console.groupEnd(),console.log(r)}e.logStorage=d}),define(Z[188],x([0,1,3,51,30,7]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function P(S,i,M,f,E,g,d,w,y){const v=Object.create(null);v["common.machineId"]=g,v.sessionID=(0,L.generateUuid)()+Date.now(),v.commitHash=f,v.version=E,v["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,p.PlatformToString)(p.platform),v["common.nodePlatform"]=R.platform,v["common.nodeArch"]=M,v["common.product"]=y||"desktop";const o=n(d||[]);o&&(v["common.msftInternal"]=o);let c=0;const l=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),p.isLinuxSnap&&(v["common.snap"]="true");try{const s=await S.readFile(b.URI.file(w));v["common.source"]=s.value.toString().slice(0,30)}catch(s){}return v}e.resolveCommonProperties=P;function n(S){const i=R.env.USERDNSDOMAIN;if(!i)return!1;const M=i.toLowerCase();return S.some(f=>M===f)}}),define(Z[31],x([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[189],x([0,1,27,66,69,22,8,43,81,17,3,7,31,64,9,16,23]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(t,r){const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],h=new Map,u=new Map,m=2e4;function I(N,$,X,ne){const Y=$.substring(N.length+1);return new Promise(async Q=>{var B,z,U;let W;try{W=await(0,y.readdir)($,{withFileTypes:!0})}catch(k){Q();return}if(ne.count>=m){ne.count+=W.length,ne.maxReached=!0,Q();return}let O=W.length;if(O===0){Q();return}let D=W;ne.count+W.length>m&&(ne.maxReached=!0,O=m-ne.count,D=W.slice(0,O)),ne.count+=W.length;for(const k of D)if(k.isDirectory()){if(X.includes(k.name)||await I(N,(0,P.join)($,k.name),X,ne),--O==0){Q();return}}else{const F=k.name.lastIndexOf(".");if(F>=0){const _=k.name.substring(F+1);_&&h.set(_,((B=h.get(_))!==null&&B!==void 0?B:0)+1)}for(const _ of a)((z=_.relativePathPattern)===null||z===void 0?void 0:z.test(Y))!==!1&&_.filePattern.test(k.name)&&u.set(_.tag,((U=u.get(_.tag))!==null&&U!==void 0?U:0)+1);if(--O==0){Q();return}}})}const A={count:0,maxReached:!1};await I(t,t,r,A);const T=await l(t);return{configFiles:o(u),fileTypes:o(h),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=v;function o(t){return[...g.Iterable.map(t.entries(),([r,a])=>({name:r,count:a}))].sort((r,a)=>a.count-r.count)}function c(){const t={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},r=p.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=c;function l(t){let r=new Map,a=(0,P.join)(t,".vscode","launch.json");return new Promise((h,u)=>{(0,b.exists)(a,m=>{if(m)(0,b.readFile)(a,(I,A)=>{if(I)return h([]);const T=[],N=(0,n.parse)(A.toString(),T);if(T.length)return console.log(`Unable to parse ${a}`),h([]);if((0,n.getNodeType)(N)==="object"&&N.configurations)for(const $ of N.configurations){const X=$.type;X&&(r.has(X)?r.set(X,r.get(X)+1):r.set(X,1))}return h(o(r))});else return h([])})})}e.collectLaunchConfigs=l;let s=class{constructor(r){this.telemetryService=r}formatMachineInfo(r){const a=[];return a.push(`OS Version:       ${r.os}`),a.push(`CPUs:             ${r.cpus}`),a.push(`Memory (System):  ${r.memory}`),a.push(`VM:               ${r.vmHint}`),a.join(`
`)}formatEnvironment(r){const a=[];a.push(`Version:          ${i.default.nameShort} ${i.default.version} (${i.default.commit||"Commit unknown"}, ${i.default.date||"Date unknown"})`),a.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const h=p.cpus();return h&&h.length>0&&a.push(`CPUs:             ${h[0].model} (${h.length} x ${h[0].speed})`),a.push(`Memory (System):  ${(p.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`),M.isWindows||a.push(`Load (avg):       ${p.loadavg().map(u=>Math.round(u)).join(", ")}`),a.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${r.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(r,a){return Promise.all([(0,S.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async h=>{let[u,m]=h,I=this.formatProcessList(r,u);return a.forEach(A=>{if((0,L.isRemoteDiagnosticError)(A))I+=`
${A.errorMessage}`,m+=`
${A.errorMessage}`;else if(I+=`

Remote: ${A.hostName}`,A.processes&&(I+=`
${this.formatProcessList(r,A.processes)}`),A.workspaceMetadata){m+=`
|  Remote: ${A.hostName}`;for(const T of Object.keys(A.workspaceMetadata)){const N=A.workspaceMetadata[T];let $=`${N.fileCount} files`;N.maxFilesReached&&($=`more than ${$}`),m+=`|    Folder (${T}): ${$}`,m+=this.formatWorkspaceStats(N)}}}),{processInfo:I,workspaceInfo:m}})}async getSystemInfo(r,a){const{memory:h,vmHint:u,os:m,cpus:I}=c(),A={os:m,memory:h,cpus:I,vmHint:u,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:a};return M.isWindows||(A.load=`${p.loadavg().map(T=>Math.round(T)).join(", ")}`),M.isLinux&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(r,a){const h=[];return(0,S.listProcesses)(r.mainPID).then(async u=>(h.push(""),h.push(this.formatEnvironment(r)),h.push(""),h.push(this.formatProcessList(r,u)),r.windows.some(m=>m.folderURIs&&m.folderURIs.length>0&&!m.remoteAuthority)&&(h.push(""),h.push("Workspace Stats: "),h.push(await this.formatWorkspaceMetadata(r))),a.forEach(m=>{if((0,L.isRemoteDiagnosticError)(m))h.push(`
${m.errorMessage}`);else if(h.push(`

`),h.push(`Remote:           ${m.hostName}`),h.push(this.formatMachineInfo(m.machineInfo)),m.processes&&h.push(this.formatProcessList(r,m.processes)),m.workspaceMetadata)for(const I of Object.keys(m.workspaceMetadata)){const A=m.workspaceMetadata[I];let T=`${A.fileCount} files`;A.maxFilesReached&&(T=`more than ${T}`),h.push(`Folder (${I}): ${T}`),h.push(this.formatWorkspaceStats(A))}}),h.push(""),h.push(""),h.join(`
`)))}formatWorkspaceStats(r){const a=[],h=60;let u=0;const m=(N,$)=>{const X=` ${N}(${$})`;u+X.length>h?(a.push(I),I="|                 ",u=I.length):u+=X.length,I+=X};let I="|      File types:";const A=10;let T=r.fileTypes.length>A?A:r.fileTypes.length;for(let N=0;N<T;N++){const $=r.fileTypes[N];m($.name,$.count)}if(a.push(I),r.configFiles.length>=0&&(I="|      Conf files:",u=0,r.configFiles.forEach(N=>{m(N.name,N.count)}),a.push(I)),r.launchConfigFiles.length>0){let N="|      Launch Configs:";r.launchConfigFiles.forEach($=>{N+=$.count>1?` ${$.name}(${$.count})`:` ${$.name}`}),a.push(N)}return a.join(`
`)}expandGPUFeatures(r){const a=Math.max(...Object.keys(r).map(h=>h.length));return Object.keys(r).map(h=>`${h}:  ${" ".repeat(a-h.length)}  ${r[h]}`).join(`
                  `)}formatWorkspaceMetadata(r){const a=[],h=[];return r.windows.forEach(u=>{u.folderURIs.length===0||!!u.remoteAuthority||(a.push(`|  Window (${u.title})`),u.folderURIs.forEach(m=>{const I=f.URI.revive(m);if(I.scheme===d.Schemas.file){const A=I.fsPath;h.push(v(A,["node_modules",".git"]).then(T=>{let N=`${T.fileCount} files`;T.maxFilesReached&&(N=`more than ${N}`),a.push(`|    Folder (${(0,P.basename)(A)}): ${N}`),a.push(this.formatWorkspaceStats(T))}).catch(T=>{a.push(`|      Error: Unable to collect workspace stats for folder ${A} (${T.toString()})`)}))}else a.push(`|    Folder (${I.toString()}): Workspace stats not available.`)}))}),Promise.all(h).then(u=>a.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}formatProcessList(r,a){const h=new Map;r.windows.forEach(m=>h.set(m.pid,m.title));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(r.mainPID,h,u,a,0),u.join(`
`)}formatProcessItem(r,a,h,u,m){const I=m===0;let A;I?A=u.pid===r?`${i.default.applicationName} main`:"remote agent":(A=`${"  ".repeat(m)} ${u.name}`,u.name==="window"&&(A=`${A} (${a.get(u.pid)})`));const T=process.platform==="win32"?u.mem:p.totalmem()*(u.mem/100);h.push(`${u.load.toFixed(0).padStart(5," ")}	${(T/w.ByteSize.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(u.children)&&u.children.forEach(N=>this.formatProcessItem(r,a,h,N,m+1))}async reportWorkspaceStats(r){for(const{uri:a}of r.folders){const h=f.URI.revive(a);if(h.scheme===d.Schemas.file){const u=h.fsPath;try{const m=await v(u,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),m.fileTypes.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:I.name,count:I.count})}),m.launchConfigFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:I.name,count:I.count})}),m.configFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:I.name,count:I.count})})}catch(m){}}}}};s=he([ee(0,E.ITelemetryService)],s),e.DiagnosticsService=s}),define(Z[190],x([0,1,19,158,161,44,31,39,152,52,25,6,16,7,61,93,184,5,15]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var c;(function(D){D[D.None=0]="None",D[D.IncludeVersions=1]="IncludeVersions",D[D.IncludeFiles=2]="IncludeFiles",D[D.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",D[D.IncludeSharedAccounts=8]="IncludeSharedAccounts",D[D.IncludeVersionProperties=16]="IncludeVersionProperties",D[D.ExcludeNonValidated=32]="ExcludeNonValidated",D[D.IncludeInstallationTargets=64]="IncludeInstallationTargets",D[D.IncludeAssetUri=128]="IncludeAssetUri",D[D.IncludeStatistics=256]="IncludeStatistics",D[D.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",D[D.Unpublished=4096]="Unpublished"})(c||(c={}));function l(...D){return String(D.reduce((k,F)=>k|F,0))}var s;(function(D){D[D.Tag=1]="Tag",D[D.ExtensionId=4]="ExtensionId",D[D.Category=5]="Category",D[D.ExtensionName=7]="ExtensionName",D[D.Target=8]="Target",D[D.Featured=9]="Featured",D[D.SearchText=10]="SearchText",D[D.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class u{constructor(k=h){this.state=k}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(k,F=this.state.pageSize){return new u(Object.assign(Object.assign({},this.state),{pageNumber:k,pageSize:F}))}withFilter(k,...F){const _=[...this.state.criteria,...F.length?F.map(C=>({filterType:k,value:C})):[{filterType:k}]];return new u(Object.assign(Object.assign({},this.state),{criteria:_}))}withSortBy(k){return new u(Object.assign(Object.assign({},this.state),{sortBy:k}))}withSortOrder(k){return new u(Object.assign(Object.assign({},this.state),{sortOrder:k}))}withFlags(...k){return new u(Object.assign(Object.assign({},this.state),{flags:k.reduce((F,_)=>F|_,0)}))}withAssetTypes(...k){return new u(Object.assign(Object.assign({},this.state),{assetTypes:k}))}get raw(){const{criteria:k,pageNumber:F,pageSize:_,sortBy:C,sortOrder:j,flags:G,assetTypes:K}=this.state;return{filters:[{criteria:k,pageNumber:F,pageSize:_,sortBy:C,sortOrder:j}],assetTypes:K,flags:G}}get searchText(){const k=this.state.criteria.filter(F=>F.filterType===s.SearchText)[0];return k&&k.value?k.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(k=>String(k.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function m(D,k){const F=(D||[]).filter(_=>_.statisticName===k)[0];return F?F.value:0}function I(D){const k="Microsoft.VisualStudio.Code.Translation.";return D.files.filter(_=>_.assetType.indexOf(k)===0).reduce((_,C)=>{const j=$(D,C.assetType);return j&&_.push([C.assetType.substring(k.length),j]),_},[])}function A(D){if(D.properties){const k=D.properties.filter(C=>C.key===t.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),_=k.filter(C=>F.test(C.value))[0];return _?{uri:_.value,fallbackUri:_.value}:null}return $(D,t.Repository)}function T(D){return{uri:`${D.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${D.fallbackAssetUri}/${t.VSIX}`}}function N(D){const k=$(D,t.Icon);if(k)return k;const F=R.DefaultIconPath;return{uri:F,fallbackUri:F}}function $(D,k){return D.files.filter(_=>_.assetType===k)[0]?{uri:`${D.assetUri}/${k}`,fallbackUri:`${D.fallbackAssetUri}/${k}`}:null}function X(D,k){const F=D.properties?D.properties.filter(C=>C.key===k):[],_=F.length>0&&F[0].value;return _?_.split(",").map(C=>(0,L.adoptToGalleryExtensionId)(C)):[]}function ne(D){const k=D.properties?D.properties.filter(F=>F.key===r.Engine):[];return k.length>0&&k[0].value||""}function Y(D){const k=D.properties?D.properties.filter(_=>_.key===r.LocalizedLanguages):[],F=k.length>0&&k[0].value||"";return F?F.split(","):[]}function Q(D){return D.indexOf("preview")!==-1}function B(D){const k=D.properties?D.properties.find(F=>F.key===r.WebExtension):void 0;return!!k&&k.value==="true"}function z(D){return D.files.some(k=>k.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,o.joinPath)(g.URI.parse(D.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function U(D,k,F,_,C){const j={manifest:$(k,t.Manifest),readme:$(k,t.Details),changelog:$(k,t.Changelog),license:$(k,t.License),repository:A(k),download:T(k),icon:N(k),coreTranslations:I(k)};return{identifier:{id:(0,L.getGalleryExtensionId)(D.publisher.publisherName,D.extensionName),uuid:D.extensionId},name:D.extensionName,version:k.version,date:k.lastUpdated,displayName:D.displayName,publisherId:D.publisher.publisherId,publisher:D.publisher.publisherName,publisherDisplayName:D.publisher.displayName,description:D.shortDescription||"",installCount:m(D.statistics,"install"),rating:m(D.statistics,"averagerating"),ratingCount:m(D.statistics,"ratingcount"),assetUri:g.URI.parse(k.assetUri),webResource:z(k),assetTypes:k.files.map(({assetType:G})=>G),assets:j,properties:{dependencies:X(k,r.Dependency),extensionPack:X(k,r.ExtensionPack),engine:ne(k),localizedLanguages:Y(k),webExtension:B(k)},telemetryData:{index:(_.pageNumber-1)*_.pageSize+F,searchText:_.searchText,querySource:C},preview:Q(D.flags)}}let W=class{constructor(k,F,_,C,j,G,K){this.requestService=k,this.logService=F,this.environmentService=_,this.telemetryService=C,this.fileService=j,this.productService=G;const V=G.extensionsGallery;this.extensionsGalleryUrl=V&&V.serviceUrl,this.extensionsControlUrl=V&&V.controlUrl,this.commonHeadersPromise=O(G.version,this.environmentService,this.fileService,K)}api(k=""){return`${this.extensionsGalleryUrl}${k}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(k,F){const _=[];let{total:C,firstPage:j,getPage:G}=await this.query({names:k,pageSize:k.length},F);_.push(...j);for(let K=1;_.length<C&&(j=await G(K,F),j.length);K++)_.push(...j);return _}async getCompatibleExtension(k,F){const _=await this.getCompatibleExtensionByEngine(k,F);return(_==null?void 0:_.properties.webExtension)?_.webResource?_:null:_}async getCompatibleExtensionByEngine(k,F){const _=(0,R.isIExtensionIdentifier)(k)?null:k;if(_&&_.properties.engine&&(0,S.isEngineValid)(_.properties.engine,this.productService.version))return _;const{id:C,uuid:j}=_?_.identifier:k;let G=new u().withFlags(c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");j?G=G.withFilter(s.ExtensionId,j):G=G.withFilter(s.ExtensionName,C);const{galleryExtensions:K}=await this.queryGallery(G,M.CancellationToken.None),[V]=K;if(!V||!V.versions.length)return null;if(F){const re=V.versions.filter(ie=>ie.version===F)[0];if(re){const ie=U(V,re,0,G);if(ie.properties.engine&&(0,S.isEngineValid)(ie.properties.engine,this.productService.version))return ie}return null}const J=await this.getLastValidExtensionVersion(V,V.versions);return J?U(V,J,0,G):null}async query(k,F){const _=M.CancellationToken.isCancellationToken(k)?{}:k,C=M.CancellationToken.isCancellationToken(k)?k:F;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=_.text||"";const G=(0,b.getOrDefault)(_,se=>se.pageSize,50);let K=new u().withFlags(c.IncludeLatestVersionOnly,c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,G).withFilter(s.Target,"Microsoft.VisualStudio.Code");j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,me,le)=>(K=K.withFilter(s.Category,le||me),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,me,le)=>(K=K.withFilter(s.Tag,le||me),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(s.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),K=K.withFilter(s.SearchText,j)),K=K.withSortBy(0)):_.ids?K=K.withFilter(s.ExtensionId,..._.ids):_.names?K=K.withFilter(s.ExtensionName,..._.names):K=K.withSortBy(4),typeof _.sortBy=="number"&&(K=K.withSortBy(_.sortBy)),typeof _.sortOrder=="number"&&(K=K.withSortOrder(_.sortOrder));const{galleryExtensions:V,total:J}=await this.queryGallery(K,C),re=V.map((se,me)=>U(se,se.versions[0],me,K,_.source)),ie=async(se,me)=>{if(me.isCancellationRequested)throw(0,p.canceled)();const le=K.withPage(se+1),{galleryExtensions:ce}=await this.queryGallery(le,me);return ce.map((ge,Ie)=>U(ge,ge.versions[0],Ie,le,_.source))};return{firstPage:re,total:J,pageSize:K.pageSize,getPage:ie}}async queryGallery(k,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");k=k.withFlags(k.flags,c.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,l(c.Unpublished));const _=await this.commonHeadersPromise,C=JSON.stringify(k.raw),j=Object.assign(Object.assign({},_),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(C.length)}),G=new Date().getTime();let K,V,J=0;try{if(K=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:C,headers:j},F),K.res.statusCode&&K.res.statusCode>=400&&K.res.statusCode<500)return{galleryExtensions:[],total:J};const re=await(0,n.asJson)(K);if(re){const ie=re.results[0],se=ie.extensions,me=ie.resultMetadata&&ie.resultMetadata.filter(le=>le.metadataType==="ResultCount")[0];return J=me&&me.metadataItems.filter(le=>le.name==="TotalCount")[0].count||0,{galleryExtensions:se,total:J}}return{galleryExtensions:[],total:J}}catch(re){throw V=re,re}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},k.telemetryData),{requestBodySize:String(C.length),duration:new Date().getTime()-G,success:!!K&&(0,n.isSuccess)(K),responseBodySize:K==null?void 0:K.res.headers["Content-Length"],statusCode:K?String(K.res.statusCode):void 0,errorCode:V?(0,p.isPromiseCanceledError)(V)?"canceled":(0,p.getErrorMessage)(V).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(J)}))}}async reportStatistic(k,F,_,C){if(!!this.isEnabled()){const j=await this.commonHeadersPromise,G=Object.assign(Object.assign({},j),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${k}/extensions/${F}/${_}/stats?statType=${C}`),headers:G},M.CancellationToken.None)}catch(K){}}}async download(k,F,_){this.logService.trace("ExtensionGalleryService#download",k.identifier.id);const C=(0,L.getGalleryExtensionTelemetryData)(k),j=new Date().getTime(),G=re=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},C),{duration:re})),K=_===1?"install":_===2?"update":"",V=K?{uri:`${k.assets.download.uri}&${K}=true`,fallbackUri:`${k.assets.download.fallbackUri}?${K}=true`}:k.assets.download,J=await this.getAsset(V);await this.fileService.writeFile(F,J.stream),G(new Date().getTime()-j)}async getReadme(k,F){if(k.assets.readme){const _=await this.getAsset(k.assets.readme,{},F);return await(0,n.asText)(_)||""}return""}async getManifest(k,F){if(k.assets.manifest){const _=await this.getAsset(k.assets.manifest,{},F),C=await(0,n.asText)(_);return C?JSON.parse(C):null}return null}async getCoreTranslation(k,F){const _=k.assets.coreTranslations.filter(C=>C[0]===F.toUpperCase())[0];if(_){const C=await this.getAsset(_[1]),j=await(0,n.asText)(C);return j?JSON.parse(j):null}return null}async getChangelog(k,F){if(k.assets.changelog){const _=await this.getAsset(k.assets.changelog,{},F);return await(0,n.asText)(_)||""}return""}async getAllVersions(k,F){let _=new u().withFlags(c.IncludeVersions,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");k.identifier.uuid?_=_.withFilter(s.ExtensionId,k.identifier.uuid):_=_.withFilter(s.ExtensionName,k.identifier.id);const C=[],{galleryExtensions:j}=await this.queryGallery(_,M.CancellationToken.None);return j.length&&(F?await Promise.all(j[0].versions.map(async G=>{let K;try{K=await this.getEngine(G)}catch(V){}K&&(0,S.isEngineValid)(K,this.productService.version)&&C.push({version:G.version,date:G.lastUpdated})})):C.push(...j[0].versions.map(G=>({version:G.version,date:G.lastUpdated})))),C}async getAsset(k,F={},_=M.CancellationToken.None){const C=await this.commonHeadersPromise,j={type:"GET"},G=Object.assign(Object.assign({},C),F.headers||{});F=Object.assign(Object.assign(Object.assign({},F),j),{headers:G});const K=k.uri,V=k.fallbackUri,J=Object.assign(Object.assign({},F),{url:K});try{const re=await this.requestService.request(J,_);if(re.res.statusCode===200)return re;const ie=await(0,n.asText)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${ie}`)}catch(re){if((0,p.isPromiseCanceledError)(re))throw re;const ie=(0,p.getErrorMessage)(re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:K,message:ie});const se=Object.assign(Object.assign({},F),{url:V});return this.requestService.request(se,_)}}async getLastValidExtensionVersion(k,F){const _=this.getLastValidExtensionVersionFromProperties(k,F);return _||this.getLastValidExtensionVersionRecursively(k,F)}getLastValidExtensionVersionFromProperties(k,F){for(const _ of F){const C=ne(_);if(!C)return null;if((0,S.isEngineValid)(C,this.productService.version))return _}return null}async getEngine(k){const F=ne(k);if(F)return F;const _=$(k,t.Manifest);if(!_)throw new Error("Manifest was not found");const C={"Accept-Encoding":"gzip"},j=await this.getAsset(_,{headers:C}),G=await(0,n.asJson)(j);if(G)return G.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(k,F){if(!F.length)return null;const _=F[0],C=await this.getEngine(_);return(0,S.isEngineValid)(C,this.productService.version)?(_.properties=_.properties||[],_.properties.push({key:r.Engine,value:C}),_):this.getLastValidExtensionVersionRecursively(k,F.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const k=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},M.CancellationToken.None);if(k.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,n.asJson)(k),_=new Map;if(F)for(const C of F.malicious){const j=_.get(C)||{id:{id:C},malicious:!0,slow:!1};j.malicious=!0,_.set(C,j)}return[..._.values()]}};W=he([ee(0,n.IRequestService),ee(1,f.ILogService),ee(2,i.IEnvironmentService),ee(3,P.ITelemetryService),ee(4,E.IFileService),ee(5,d.IProductService),ee(6,(0,v.optional)(w.IStorageService))],W),e.ExtensionGalleryService=W;async function O(D,k,F,_){const C={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D}`},j=await(0,y.getServiceMachineId)(k,F,_);return C["X-Market-User-Id"]=j,C}e.resolveMarketplaceHeaders=O}),define(Z[191],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(b){this.appender=b}listen(b,P){throw new Error(`Event not found: ${P}`)}call(b,P,{eventName:n,data:S}){return this.appender.log(n,S),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class R{constructor(b){this.channel=b}log(b,P){return this.channel.call("log",{eventName:b,data:P}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(Z[192],x([0,1,17,142,20,5,24,46,2,44,36]),function(H,e,p,R,L,b,P,n,S,i,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(d,w){this._configurationService=w,this._experimentProperties={},this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(y),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(y=>{const v=/^[a-f0-9]+$/i.test(y["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!v})}))}setExperimentProperty(d,w){this._experimentProperties[d]=w}setEnabled(d){this._enabled=d}_updateUserOptIn(){var d;const w=(d=this._configurationService)===null||d===void 0?void 0:d.getValue(E);this._userOptIn=w?w.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let w=d.sessionID,y=d["common.instanceId"],v=d["common.machineId"],o=d["common.firstSessionDate"],c=d["common.msftInternal"];return{sessionId:w,instanceId:y,machineId:v,firstSessionDate:o,msftInternal:c}}dispose(){this._disposables.dispose()}publicLog(d,w,y){return this.isOptedIn?this._commonProperties.then(v=>{w=(0,i.mixin)(w,v),w=(0,i.mixin)(w,this._experimentProperties),w=(0,i.cloneAndChange)(w,o=>{if(typeof o=="string")return this._cleanupInfo(o,y)}),this._appender.log(d,w)},v=>{console.error(v)}):Promise.resolve(void 0)}publicLog2(d,w,y){return this.publicLog(d,w,y)}publicLogError(d,w){return this.sendErrorTelemetry?this.publicLog(d,w,!0):Promise.resolve(void 0)}publicLogError2(d,w){return this.publicLogError(d,w)}_cleanupInfo(d,w){let y=d;if(w){const v=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(d);if(!t)break;v.push([t.index,s.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(y="";;){const s=c.exec(d);if(!s)break;!o.test(s[0])&&v.every(([t,r])=>s.index<t||s.index>=r)&&(y+=d.substring(l,s.index)+"<REDACTED: user-file-path>",l=c.lastIndex)}l<d.length&&(y+=d.substr(l))}for(let v of this._cleanupPatterns)y=y.replace(v,"");return y}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=he([ee(1,(0,b.optional)(P.IConfigurationService))],f),e.TelemetryService=f;const E="telemetry";M.Registry.as(n.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,R.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,R.localize)(2,null,p.default.privacyStatementUrl):(0,R.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Z[94],x([0,1,24,44,13,10]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,w){return Promise.resolve(void 0)}publicLog2(d,w){return this.publicLog(d,w)}publicLogError(d,w){return Promise.resolve(void 0)}publicLogError2(d,w){return this.publicLogError(d,w)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class P{async publicLog(w,y,v){}async publicLogError(w,y,v){}}e.NullEndpointTelemetryService=P;function n(...d){return{log:(w,y)=>d.forEach(v=>v.log(w,y)),flush:()=>b.Promises.settled(d.map(w=>w.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(d,w){return w.onDidChangeConfiguration(y=>{y.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,p.ConfigurationTargetToString)(y.source),configurationKeys:E(y.sourceConfig)})})}e.configurationTelemetry=S;function i(d){const w=Object.create(null),y=Object.create(null),v=Object.create(null);f(d,v);for(let o in v){o=o.length>150?o.substr(o.length-149):o;const c=v[o];typeof c=="number"?y[o]=c:typeof c=="boolean"?y[o]=c?1:0:typeof c=="string"?w[o]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(w[o]=c)}return{properties:w,measurements:y}}e.validateTelemetryData=i;function M(d){if(!d)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(v=>{d.indexOf(`${v}+`)===0&&(w=v)}),w}e.cleanRemoteAuthority=M;function f(d,w,y=0,v){if(!!d)for(let o of Object.getOwnPropertyNames(d)){const c=d[o],l=v?v+o:o;Array.isArray(c)?w[l]=(0,R.safeStringify)(c):c instanceof Date?w[l]=c.toISOString():(0,L.isObject)(c)?y<2?f(c,w,y+1,l+"."):w[l]=(0,R.safeStringify)(c):w[l]=c}}function E(d){if(!d)return[];const w=[];return g(w,"",d),w}function g(d,w,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(v=>g(d,w?`${w}.${v}`:v,y[v])):d.push(w)}}),define(Z[193],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Z[194],x([0,1,5,2,36,4,193,104]),function(H,e,p,R,L,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,p.createDecorator)("themeService");var S;(function(y){function v(o){return o&&typeof o=="object"&&typeof o.id=="string"}y.isThemeColor=v})(S=e.ThemeColor||(e.ThemeColor={}));function i(y){return{id:y}}e.themeColorFromId=i;var M;(function(y){function v(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}y.isThemeIcon=v;const o=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function c(t){const r=o.exec(t);if(!!r){let[,a]=r;return{id:a}}}y.fromString=c;function l(t,r){let a=t.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),r&&(a=`${a}~${r}`),{id:a}}y.modify=l;function s(t,r){var a,h;return t.id===r.id&&((a=t.color)===null||a===void 0?void 0:a.id)===((h=r.color)===null||h===void 0?void 0:h.id)}y.isEqual=s,y.asClassNameArray=n.CSSIcon.asClassNameArray,y.asClassName=n.CSSIcon.asClassName,y.asCSSSelector=n.CSSIcon.asCSSSelector})(M=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function f(y){switch(y){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=f,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new b.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,R.toDisposable)(()=>{const o=this.themingParticipants.indexOf(v);this.themingParticipants.splice(o,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new E;L.Registry.add(e.Extensions.ThemingContribution,g);function d(y){return g.onColorThemeChange(y)}e.registerThemingParticipant=d;class w extends R.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(o=>this.onThemeChange(o)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,o){let c=this.theme.getColor(v);return c&&o&&(c=o(c,this.theme)),c?c.toString():null}}e.Themable=w}),define(Z[73],x([0,1,3,11,37,5]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const P="#FFFFFF",n="#1E1E1E",S="#000000",i="theme",M="themeBackground";e.IThemeMainService=(0,b.createDecorator)("themeMainService");let f=class{constructor(g){this.stateService=g,R.ipcMain.on("vscode:changeColorTheme",(d,w,y)=>{typeof y=="string"&&this.storeBackgroundColor(JSON.parse(y))})}storeBackgroundColor(g){this.stateService.setItem(i,g.baseTheme),this.stateService.setItem(M,g.background)}getBackgroundColor(){if((p.isWindows||p.isMacintosh)&&R.nativeTheme.shouldUseInvertedColorScheme)return S;let g=this.stateService.getItem(M,null);if(!g){let d;(p.isWindows||p.isMacintosh)&&R.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateService.getItem(i,"vs-dark").split(" ")[0],g=d==="hc-black"?S:d==="vs"?P:n}return p.isMacintosh&&g.toUpperCase()===n&&(g="#171717"),g}};f=he([ee(0,L.IStateService)],f),e.ThemeMainService=f}),define(Z[40],x([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var R;(function(b){b.Uninitialized="uninitialized",b.Idle="idle",b.CheckingForUpdates="checking for updates",b.AvailableForDownload="available for download",b.Downloading="downloading",b.Downloaded="downloaded",b.Updating="updating",b.Ready="ready"})(R=e.StateType||(e.StateType={}));var L;(function(b){b[b.Setup=0]="Setup",b[b.Archive=1]="Archive",b[b.Snap=2]="Snap"})(L=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(b,P)=>({type:"idle",updateType:b,error:P}),CheckingForUpdates:b=>({type:"checking for updates",context:b}),AvailableForDownload:b=>({type:"available for download",update:b}),Downloading:b=>({type:"downloading",update:b}),Downloaded:b=>({type:"downloaded",update:b}),Updating:b=>({type:"updating",update:b}),Ready:b=>({type:"ready",update:b})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(Z[195],x([0,1,36,46,143,3]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.Registry.as(R.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:b.isWindows&&!b.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[196],x([0,1,4,40]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class L{constructor(n){this.service=n}listen(n,S){switch(S){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${S}`)}call(n,S,i){switch(S){case"checkForUpdates":return this.service.checkForUpdates(i);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${S}`)}}e.UpdateChannel=L;class b{constructor(n){this.channel=n,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=R.State.Uninitialized,this.channel.listen("onStateChange")(S=>this.state=S),this.channel.call("_getInitialState").then(S=>this.state=S)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=b}),define(Z[95],x([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(Z[197],x([0,1,7]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class R{constructor(n){this.handler=n}listen(n,S){throw new Error(`Event not found: ${S}`)}call(n,S,i){switch(S){case"handleURL":return this.handler.handleURL(p.URI.revive(i[0]),i[1])}throw new Error(`Call not found: ${S}`)}}e.URLHandlerChannel=R;class L{constructor(n){this.channel=n}handleURL(n,S){return this.channel.call("handleURL",[n.toJSON(),S])}}e.URLHandlerChannelClient=L;class b{constructor(n){this.next=n}async routeCall(n,S,i,M){if(S!=="handleURL")throw new Error(`Call not found: ${S}`);if(i){const f=p.URI.revive(i);if(f&&f.query){const E=/\bwindowId=(\d+)/.exec(f.query);if(E){const g=E[1],d=new RegExp(`window:${g}`),w=n.connections.find(y=>d.test(y.ctx));if(w)return w}}}return this.next.routeCall(n,S,i,M)}routeEvent(n,S){throw new Error(`Event not found: ${S}`)}}e.URLHandlerRouter=b}),define(Z[198],x([0,1,7,10,2,17]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class P extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(i,M){const f=[...this.handlers.values()];return(0,R.first)(f.map(E=>()=>E.handleURL(i,M)),void 0,!1).then(E=>E||!1)}registerHandler(i){return this.handlers.add(i),(0,L.toDisposable)(()=>this.handlers.delete(i))}}e.AbstractURLService=P;class n extends P{create(i){let{authority:M,path:f,query:E,fragment:g}=i||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return M&&f&&f.indexOf("/")!==0&&(f=`/${f}`),p.URI.from({scheme:b.default.urlProtocol,authority:M,path:f,query:E,fragment:g})}}e.NativeURLService=n}),define(Z[199],x([0,1,4,17,11,7,2,3,10]),function(H,e,p,R,L,b,P,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function i(f){try{return b.URI.parse(f)}catch(E){return null}}class M{constructor(E,g,d,w){if(this.urlService=g,this.uris=[],this.retryCount=0,this.flushDisposable=P.Disposable.None,this.disposables=new P.DisposableStore,this.uris=E,n.isWindows){const o=w.isBuilt?[]:[`"${w.appRoot}"`];o.push("--open-url","--"),L.app.setAsDefaultProtocolClient(R.default.urlProtocol,process.execPath,o)}const y=p.Event.map(p.Event.fromNodeEventEmitter(L.app,"open-url",(o,c)=>({event:o,url:c})),({event:o,url:c})=>(o.preventDefault(),c));this.disposables.add(y(o=>{const c=i(o);!c||this.urlService.open(c,{originalUrl:o})})),d.getWindows().filter(o=>o.isReady).length>0?this.flush():p.Event.once(d.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(!(this.retryCount++>10)){const E=[];for(const g of this.uris)await this.urlService.open(g.uri,{originalUrl:g.url})||E.push(g);E.length!==0&&(this.uris=E,this.flushDisposable=(0,S.disposableTimeout)(()=>this.flush(),500))}}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=M}),define(Z[200],x([0,1,107,8]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWebviewContentMimeType=void 0;const L=new Map([[".svg","image/svg+xml"],[".txt","text/plain"],[".css","text/css"],[".js","application/javascript"],[".json","application/json"],[".html","text/html"],[".htm","text/html"],[".xhtml","application/xhtml+xml"],[".oft","font/otf"],[".xml","application/xml"]]);function b(P){const n=(0,R.extname)(P.fsPath).toLowerCase();return L.get(n)||(0,p.getMediaMime)(P.fsPath)||p.MIME_UNKNOWN}e.getWebviewContentMimeType=b}),define(Z[74],x([0,1,29,9,8,7,16,200]),function(H,e,p,R,L,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.loadLocalResource=e.readFileStream=e.WebviewFileReadResponse=e.WebviewResourceResponse=e.webviewPartitionId=void 0,e.webviewPartitionId="webview";var S;(function(w){let y;(function(c){c[c.Success=0]="Success",c[c.Failed=1]="Failed",c[c.AccessDenied=2]="AccessDenied",c[c.NotModified=3]="NotModified"})(y=w.Type||(w.Type={}));class v{constructor(l,s,t){this.stream=l,this.etag=s,this.mimeType=t,this.type=y.Success}}w.StreamSuccess=v,w.Failed={type:y.Failed},w.AccessDenied={type:y.AccessDenied};class o{constructor(l){this.mimeType=l,this.type=y.NotModified}}w.NotModified=o})(S=e.WebviewResourceResponse||(e.WebviewResourceResponse={}));var i;(function(w){let y;(function(o){o[o.Success=0]="Success",o[o.NotModified=1]="NotModified"})(y=w.Type||(w.Type={}));class v{constructor(c,l){this.stream=c,this.etag=l,this.type=y.Success}}w.StreamSuccess=v,w.NotModified={type:y.NotModified}})(i=e.WebviewFileReadResponse||(e.WebviewFileReadResponse={}));async function M(w,y,v){try{const o=await w.readFileStream(y,{etag:v});return new i.StreamSuccess(o.value,o.etag)}catch(o){if(o instanceof P.FileOperationError&&o.fileOperationResult===2)return i.NotModified;throw o}}e.readFileStream=M;async function f(w,y,v,o,c,l,s){l.debug(`loadLocalResource - being. requestUri=${w}`);let t=E(w,v.roots);if(l.debug(`loadLocalResource - found resource to load. requestUri=${w}, resourceToLoad=${t}`),!t)return S.AccessDenied;const r=(0,n.getWebviewContentMimeType)(w);if(v.rewriteUri&&(t=v.rewriteUri(t)),t.scheme===R.Schemas.http||t.scheme===R.Schemas.https){const a={};y&&(a["If-None-Match"]=y);const h=await c.request({url:t.toString(!0),headers:a},s);switch(l.debug(`loadLocalResource - Loaded over http(s). requestUri=${w}, response=${h.res.statusCode}`),h.res.statusCode){case 200:return new S.StreamSuccess(h.stream,h.res.headers.etag,r);case 304:return new S.NotModified(r);default:return S.Failed}}try{const a=await o.readFileStream(t,y);switch(l.debug(`loadLocalResource - Loaded using fileReader. requestUri=${w}`),a.type){case i.Type.Success:return new S.StreamSuccess(a.stream,a.etag,r);case i.Type.NotModified:return new S.NotModified(r);default:return l.error("loadLocalResource - Unknown file read response"),S.Failed}}catch(a){return l.debug(`loadLocalResource - Error using fileReader. requestUri=${w}`),console.log(a),S.Failed}}e.loadLocalResource=f;function E(w,y){const v=g(w);for(const o of y)if(d(o,v))return v}function g(w){return w.scheme===R.Schemas.vscodeWebviewResource?b.URI.parse(encodeURIComponent(w.path).replace(/%2F/gi,"/").replace(/^\/([a-z0-9\-]+)(\/{1,2})/i,(v,o,c)=>c.length===1?`${o}:///`:`${o}://`)).with({query:w.query,fragment:w.fragment}):w}function d(w,y){let v=w.fsPath+(w.fsPath.endsWith(L.sep)?"":L.sep),o=y.fsPath;return(0,p.isUNC)(w.fsPath)&&(0,p.isUNC)(y.fsPath)&&(v=v.toLowerCase(),o=o.toLowerCase()),o.startsWith(v)}}),define(Z[201],x([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(Z[202],x([0,1,9,7,54]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewPortMappingManager=void 0;class b{constructor(n,S,i){this._getExtensionLocation=n,this._getMappings=S,this.tunnelService=i,this._tunnels=new Map}async getRedirect(n,S){const i=R.URI.parse(S),M=(0,L.extractLocalHostUriMetaDataForPortMapping)(i);if(!!M){for(const f of this._getMappings())if(f.webviewPort===M.port){const E=this._getExtensionLocation();if(E&&E.scheme===p.Schemas.vscodeRemote){const g=n&&await this.getOrCreateTunnel(n,f.extensionHostPort);if(g)return g.tunnelLocalPort===f.webviewPort?void 0:encodeURI(i.with({authority:`127.0.0.1:${g.tunnelLocalPort}`}).toString(!0))}if(f.webviewPort!==f.extensionHostPort)return encodeURI(i.with({authority:`${M.address}:${f.extensionHostPort}`}).toString(!0))}}}async dispose(){for(const n of this._tunnels.values())await n.dispose();this._tunnels.clear()}async getOrCreateTunnel(n,S){const i=this._tunnels.get(S);if(i)return i;const M=await this.tunnelService.openTunnel({getAddress:async()=>n},void 0,S);return M&&this._tunnels.set(S,M),M}}e.WebviewPortMappingManager=b}),define(Z[203],x([0,1,11,2,9,7,54,74,202]),function(H,e,p,R,L,b,P,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewPortMappingProvider=void 0;let i=class extends R.Disposable{constructor(f){super();this._tunnelService=f,this._webviewData=new Map,p.session.fromPartition(n.webviewPartitionId).webRequest.onBeforeRequest({urls:["*://localhost:*/*","*://127.0.0.1:*/*","*://0.0.0.0:*/*"]},async(g,d)=>{let w;try{if(g.lastCommittedOrigin)w=b.URI.parse(g.lastCommittedOrigin).authority;else if(typeof g.webContentsId=="number"){const o=p.webContents.fromId(g.webContentsId),c=b.URI.parse(o.getURL());c.scheme===L.Schemas.vscodeWebview&&(w=c.authority)}}catch(o){return d({})}if(!w)return d({});const y=this._webviewData.get(w);if(!y)return d({});const v=await y.manager.getRedirect(y.metadata.resolvedAuthority,g.url);return d(v?{redirectURL:v}:{})})}async registerWebview(f,E){const g=new S.WebviewPortMappingManager(()=>{var d;return(d=this._webviewData.get(f))===null||d===void 0?void 0:d.metadata.extensionLocation},()=>{var d;return((d=this._webviewData.get(f))===null||d===void 0?void 0:d.metadata.mappings)||[]},this._tunnelService);this._webviewData.set(f,{metadata:E,manager:g})}unregisterWebview(f){const E=this._webviewData.get(f);E&&(E.manager.dispose(),this._webviewData.delete(f))}async updateWebviewMetadata(f,E){const g=this._webviewData.get(f);g&&this._webviewData.set(f,Object.assign(Object.assign({},g),E))}};i=he([ee(0,P.ITunnelService)],i),e.WebviewPortMappingProvider=i}),define(Z[62],x([0,1,3]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(i){return!!i.workspaceUri}e.isWorkspaceToOpen=R;function L(i){return!!i.folderUri}e.isFolderToOpen=L;function b(i){return!!i.fileUri}e.isFileToOpen=b;function P(i){const M=n(i),f=i.getValue("window.menuBarVisibility");return f==="default"||M==="native"&&f==="compact"?"classic":f}e.getMenuBarVisibility=P;function n(i){if(p.isWeb)return"custom";const M=i.getValue("window");if(M){if(p.isMacintosh&&M.nativeTabs===!0||p.isMacintosh&&M.nativeFullScreen===!1)return"native";const g=M.titleBarStyle;if(g==="native"||g==="custom")return g}return p.isLinux?"native":"custom"}e.getTitleBarStyle=n;function S(i=0){return Math.pow(1.2,i)}e.zoomLevelToZoomFactor=S}),define(Z[32],x([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var R;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(R=e.OpenContext||(e.OpenContext={}));const L=function(n=1){return{width:1024,height:768,mode:n}};e.defaultWindowState=L;var b;(function(n){n[n.Maximized=0]="Maximized",n[n.Normal=1]="Normal",n[n.Minimized=2]="Minimized",n[n.Fullscreen=3]="Fullscreen"})(b=e.WindowMode||(e.WindowMode={}));var P;(function(n){n[n.UNRESPONSIVE=1]="UNRESPONSIVE",n[n.CRASHED=2]="CRASHED",n[n.LOAD=3]="LOAD"})(P=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(Z[204],x([0,1,11,237,21,25,2,9,57,7,16,6,39,74,32]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;let w=class St extends P.Disposable{constructor(v,o,c,l){super();this.fileService=v,this.logService=o,this.requestService=c,this.windowsMainService=l,this.webviewMetadata=new Map,this.requestIdPool=1,this.pendingResourceReads=new Map;const s=p.session.fromPartition(g.webviewPartitionId),t=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(n.Schemas.vscodeWebview,t),s.protocol.registerFileProtocol(n.Schemas.vscodeWebview,t);const r=this.handleWebviewResourceRequest.bind(this);p.protocol.registerStreamProtocol(n.Schemas.vscodeWebviewResource,r),s.protocol.registerStreamProtocol(n.Schemas.vscodeWebviewResource,r),this._register((0,P.toDisposable)(()=>{p.protocol.unregisterProtocol(n.Schemas.vscodeWebviewResource),s.protocol.unregisterProtocol(n.Schemas.vscodeWebviewResource),p.protocol.unregisterProtocol(n.Schemas.vscodeWebview),s.protocol.unregisterProtocol(n.Schemas.vscodeWebview)}))}streamToNodeReadable(v){return new class extends R.Readable{constructor(){super(...arguments);this.listening=!1}_read(o){this.listening||(this.listening=!0,(0,S.listenStream)(v,{onData:c=>{try{this.push(c.buffer)||v.pause()}catch(l){this.emit(l)}},onError:c=>{this.emit("error",c)},onEnd:()=>{try{this.push(null)}catch(c){this.emit(c)}}})),v.resume()}_destroy(o,c){v.destroy(),c(null)}}}async registerWebview(v,o){this.webviewMetadata.set(v,o)}unregisterWebview(v){this.webviewMetadata.delete(v)}async updateWebviewMetadata(v,o){const c=this.webviewMetadata.get(v);c&&this.webviewMetadata.set(v,Object.assign(Object.assign({},c),o))}async handleWebviewRequest(v,o){try{const c=i.URI.parse(v.url),l=St.validWebviewFilePaths.get(c.path);if(typeof l=="string"){const s=c.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${l}`:`vs/workbench/contrib/webview/browser/pre/${l}`,t=n.FileAccess.asFileUri(s,H);return o(decodeURIComponent(t.fsPath))}}catch(c){}o({error:-10})}async handleWebviewResourceRequest(v,o){try{const c=i.URI.parse(v.url),l=v.headers["If-None-Match"],s=c.authority,t=this.webviewMetadata.get(s);if(t){let r;t.remoteConnectionData&&(r=u=>{var m;if(t.remoteConnectionData&&(u.scheme===n.Schemas.vscodeRemote||((m=t.extensionLocation)===null||m===void 0?void 0:m.scheme)===n.Schemas.vscodeRemote)){let I=t.remoteConnectionData.host;return I&&I.indexOf(":")!==-1&&(I=`[${I}]`),i.URI.parse(`http://${I}:${t.remoteConnectionData.port}`).with({path:"/vscode-remote-resource",query:`tkn=${t.remoteConnectionData.connectionToken}&path=${encodeURIComponent(u.path)}`})}return u});const a={readFileStream:async(u,m)=>{var I;if(u.scheme===n.Schemas.file)return(0,g.readFileStream)(this.fileService,u,m);const A=this.windowsMainService.getWindowById(t.windowId);if(!A)throw new M.FileOperationError("Could not find window for resource",1);const T=this.requestIdPool++,N=new Promise(X=>{this.pendingResourceReads.set(T,{resolve:X})});A.send(`vscode:loadWebviewResource-${s}`,T,c,m);const $=await N;switch($.response){case"access-denied":throw new M.FileOperationError("Could not read file",6);case"not-found":throw new M.FileOperationError("Could not read file",1);case"not-modified":return g.WebviewFileReadResponse.NotModified;default:return new g.WebviewFileReadResponse.StreamSuccess((0,L.bufferToStream)($.response),(I=$.responseDetails)===null||I===void 0?void 0:I.etag)}}},h=await(0,g.loadLocalResource)(c,l,{extensionLocation:t.extensionLocation,roots:t.localResourceRoots,remoteConnectionData:t.remoteConnectionData,rewriteUri:r},a,this.requestService,this.logService,b.CancellationToken.None);switch(h.type){case g.WebviewResourceResponse.Type.Success:{const u=h.etag?{ETag:h.etag,"Cache-Control":"no-cache"}:{},m=v.headers["If-None-Match"];return m&&h.etag===m?o({statusCode:304,data:void 0,headers:Object.assign({"Content-Type":h.mimeType,"Access-Control-Allow-Origin":"*"},u)}):o({statusCode:200,data:this.streamToNodeReadable(h.stream),headers:Object.assign({"Content-Type":h.mimeType,"Access-Control-Allow-Origin":"*"},u)})}case g.WebviewResourceResponse.Type.NotModified:return o({statusCode:304,data:void 0,headers:{"Content-Type":h.mimeType,"Access-Control-Allow-Origin":"*"}});case g.WebviewResourceResponse.Type.AccessDenied:return console.error("Webview: Cannot load resource outside of protocol root"),o({data:void 0,statusCode:401})}}}catch(c){}return o({data:void 0,statusCode:404})}didLoadResource(v,o,c){const l=this.pendingResourceReads.get(v);if(!l)throw new Error("Unknown request");this.pendingResourceReads.delete(v),l.resolve({response:o,responseDetails:c})}};w.validWebviewFilePaths=new Map([["/index.html","index.html"],["/electron-browser/index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"]]),w=he([ee(0,M.IFileService),ee(1,f.ILogService),ee(2,E.IRequestService),ee(3,d.IWindowsMainService)],w),e.WebviewProtocolProvider=w}),define(Z[205],x([0,1,11,2,7,16,6,54,39,74,203,204,32]),function(H,e,p,R,L,b,P,n,S,i,M,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let g=class extends R.Disposable{constructor(w,y,v,o,c){super();this.windowsMainService=c,this.protocolProvider=this._register(new f.WebviewProtocolProvider(w,y,v,c)),this.portMappingProvider=this._register(new M.WebviewPortMappingProvider(o));const l=p.session.fromPartition(i.webviewPartitionId);l.setPermissionRequestHandler((s,t,r)=>r(t==="clipboard-read")),l.setPermissionCheckHandler((s,t)=>t==="clipboard-read")}async registerWebview(w,y,v){const o=v.extensionLocation?L.URI.from(v.extensionLocation):void 0;this.protocolProvider.registerWebview(w,Object.assign(Object.assign({},v),{windowId:y,extensionLocation:o,localResourceRoots:v.localResourceRoots.map(c=>L.URI.from(c))})),this.portMappingProvider.registerWebview(w,{extensionLocation:o,mappings:v.portMappings,resolvedAuthority:v.remoteConnectionData})}async unregisterWebview(w){this.protocolProvider.unregisterWebview(w),this.portMappingProvider.unregisterWebview(w)}async updateWebviewMetadata(w,y){var v;const o=y.extensionLocation?L.URI.from(y.extensionLocation):void 0;this.protocolProvider.updateWebviewMetadata(w,Object.assign(Object.assign({},y),{extensionLocation:o,localResourceRoots:(v=y.localResourceRoots)===null||v===void 0?void 0:v.map(c=>L.URI.from(c))})),this.portMappingProvider.updateWebviewMetadata(w,Object.assign(Object.assign({},y),{extensionLocation:o}))}async setIgnoreMenuShortcuts(w,y){let v;if(typeof w.windowId=="number"){const{windowId:o}=w,c=this.windowsMainService.getWindowById(o);if(!(c==null?void 0:c.win))throw new Error(`Invalid windowId: ${o}`);v=c.win.webContents}else{const{webContentsId:o}=w;if(v=p.webContents.fromId(o),!v)throw new Error(`Invalid webContentsId: ${o}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(y)}async didLoadResource(w,y,v){this.protocolProvider.didLoadResource(w,y,v)}};g=he([ee(0,b.IFileService),ee(1,P.ILogService),ee(2,S.IRequestService),ee(3,n.ITunnelService),ee(4,E.IWindowsMainService)],g),e.WebviewMainService=g}),define(Z[206],x([0,1,4,2,10]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class b extends R.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:S,getActiveWindowId:i}){super();this.disposables=this._register(new R.DisposableStore),p.Event.latch(p.Event.any(n,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>i()),(async()=>{try{const f=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:f}catch(f){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=b}),define(Z[207],x([0,1,7,15,5,35]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,L.createDecorator)("contextService");var P;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function n(E){const g=E;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=n;function S(E){const g=E;return!!(g&&typeof g=="object"&&p.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=S;class i{constructor(g,d,w,y){this._id=g,this._configuration=w,this._ignorePathCasing=y,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=i;class M{constructor(g,d){this.raw=d,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,R.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=M;function f(E){return new M({uri:E,index:0,name:(0,R.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=f}),define(Z[28],x([0,1,5,146,207,7,3,8,15,101,43,9,38,29,71]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(z){return(typeof z=="string"?(0,n.extname)(z):(0,S.extname)(z))===w}e.hasWorkspaceFileExtension=y,e.IWorkspacesService=(0,p.createDecorator)("workspacesService");function v(z){return z.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function o(z){return z.hasOwnProperty("folderUri")}e.isRecentFolder=o;function c(z){return z.hasOwnProperty("fileUri")}e.isRecentFile=c;function l(z){const U=z;return typeof(U==null?void 0:U.id)=="string"&&b.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=l;function s(z){if(z.configuration)return{id:z.id,configPath:z.configuration};if(z.folders.length===1)return{id:z.id,uri:z.folders[0].uri}}e.toWorkspaceIdentifier=s;function t(z){const U=z;return typeof(U==null?void 0:U.id)=="string"&&b.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function r(z){const U=z;if(U==null?void 0:U.uri)return{id:U.id,uri:b.URI.revive(U.uri)};const W=z;if(W==null?void 0:W.configPath)return{id:W.id,configPath:b.URI.revive(W.configPath)};if(z==null?void 0:z.id)return{id:z.id}}e.reviveIdentifier=r;function a(z,U){return S.extUriBiasedIgnorePathCase.isEqualOrParent(z,U.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function h(z){return u(z)||m(z)}e.isStoredWorkspaceFolder=h;function u(z){const U=z;return typeof(U==null?void 0:U.path)=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=u;function m(z){const U=z;return typeof(U==null?void 0:U.uri)=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=m;function I(z,U,W,O,D=!P.isWindows,k){if(z.scheme!==O.scheme)return{name:W,uri:z.toString(!0)};let F=U?void 0:k.relativePath(O,z);if(F!==void 0)F.length===0?F=".":P.isWindows&&z.scheme===f.Schemas.file&&!D&&(F=F.replace(/\//g,"\\"));else if(z.scheme===f.Schemas.file)F=z.fsPath,P.isWindows&&(F=(0,E.normalizeDriveLetter)(F),D&&(F=(0,g.toSlashes)(F)));else{if(!k.isEqualAuthority(z.authority,O.authority))return{name:W,uri:z.toString(!0)};F=z.path}return{name:W,path:F}}e.getStoredWorkspaceFolder=I;function A(z,U,W){let O=[],D=new Set;const k=W.dirname(U);for(let F of z){let _=null;if(u(F))F.path&&(_=W.resolvePath(k,F.path));else if(m(F))try{_=b.URI.parse(F.uri),_.path[0]!=="/"&&(_=_.with({path:"/"+_.path}))}catch(C){console.warn(C)}if(_){let C=W.getComparisonKey(_);if(!D.has(C)){D.add(C);const j=F.name||W.basenameOrAuthority(_);O.push(new L.WorkspaceFolder({uri:_,name:j,index:O.length},F))}}}return O}e.toWorkspaceFolders=A;function T(z,U,W,O,D){let k=N(U,z);const F=D.dirname(U),_=D.dirname(O),C=[],j=$(k.folders);for(const J of k.folders){const re=u(J)?D.resolvePath(F,J.path):b.URI.parse(J.uri);let ie;W?ie=!1:ie=!u(J)||(0,n.isAbsolute)(J.path),C.push(I(re,ie,J.name,_,j,D))}const G={insertSpaces:!1,tabSize:4,eol:P.isLinux||P.isMacintosh?`
`:`\r
`},K=i.setProperty(z,["folders"],C,G);let V=i.applyEdits(z,K);return k.remoteAuthority===(0,d.getRemoteAuthority)(O)&&(V=i.applyEdits(V,i.removeProperty(V,["remoteAuthority"],G))),V}e.rewriteWorkspaceFileForNewLocation=T;function N(z,U){let W=M.parse(U);if(W&&Array.isArray(W.folders))W.folders=W.folders.filter(O=>h(O));else throw new Error(`${z} looks like an invalid workspace file.`);return W}function $(z){return P.isWindows?z.some(U=>u(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=$;function X(z){return z.workspace&&typeof z.workspace=="object"&&typeof z.workspace.id=="string"&&typeof z.workspace.configPath=="string"}function ne(z){return typeof z.folderUri=="string"}function Y(z){return typeof z.fileUri=="string"}function Q(z,U){const W={workspaces:[],files:[]};if(z){const O=function(k,F){for(let _=0;_<k.length;_++)try{F(k[_],_)}catch(C){U.warn(`Error restoring recent entry ${JSON.stringify(k[_])}: ${C.toString()}. Skip entry.`)}},D=z;if(Array.isArray(D.entries))O(D.entries,k=>{const F=k.label,_=k.remoteAuthority;X(k)?W.workspaces.push({label:F,remoteAuthority:_,workspace:{id:k.workspace.id,configPath:b.URI.parse(k.workspace.configPath)}}):ne(k)?W.workspaces.push({label:F,remoteAuthority:_,folderUri:b.URI.parse(k.folderUri)}):Y(k)&&W.files.push({label:F,remoteAuthority:_,fileUri:b.URI.parse(k.fileUri)})});else{const k=z;Array.isArray(k.workspaces3)&&O(k.workspaces3,(F,_)=>{const C=Array.isArray(k.workspaceLabels)&&k.workspaceLabels[_]||void 0;typeof F=="object"&&typeof F.id=="string"&&typeof F.configURIPath=="string"?W.workspaces.push({label:C,workspace:{id:F.id,configPath:b.URI.parse(F.configURIPath)}}):typeof F=="string"&&W.workspaces.push({label:C,folderUri:b.URI.parse(F)})}),Array.isArray(k.files2)&&O(k.files2,(F,_)=>{const C=Array.isArray(k.fileLabels)&&k.fileLabels[_]||void 0;typeof F=="string"&&W.files.push({label:C,fileUri:b.URI.parse(F)})})}}return W}e.restoreRecentlyOpened=Q;function B(z){const U={entries:[]};for(const W of z.workspaces)o(W)?U.entries.push({folderUri:W.folderUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority}):U.entries.push({workspace:{id:W.workspace.id,configPath:W.workspace.configPath.toString()},label:W.label,remoteAuthority:W.remoteAuthority});for(const W of z.files)U.entries.push({fileUri:W.fileUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority});return U}e.toStoreData=B}),define(Z[47],x([0,1,5,28]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService");function L(b){const P=b;return P&&(0,R.isWorkspaceIdentifier)(P.workspace)}e.isWorkspaceBackupInfo=L}),define(Z[48],x([0,1,5,11,10,37,3,8,65,23,13,130,28,38,2,78]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let y=class ht{constructor(o){this.stateService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(o,c){return this.doPick(Object.assign(Object.assign({},o),{pickFolders:!0,pickFiles:!0,title:(0,f.localize)(0,null)}),c)}pickFolder(o,c){return this.doPick(Object.assign(Object.assign({},o),{pickFolders:!0,title:(0,f.localize)(1,null)}),c)}pickFile(o,c){return this.doPick(Object.assign(Object.assign({},o),{pickFiles:!0,title:(0,f.localize)(2,null)}),c)}pickWorkspace(o,c){const l=(0,f.localize)(3,null),s=(0,g.mnemonicButtonLabel)((0,f.localize)(4,null)),t=E.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},o),{pickFiles:!0,title:l,filters:t,buttonLabel:s}),c)}async doPick(o,c){const l={title:o.title,buttonLabel:o.buttonLabel,filters:o.filters};l.defaultPath=o.defaultPath||this.stateService.getItem(ht.workingDirPickerStorageKey),(typeof o.pickFiles=="boolean"||typeof o.pickFolders=="boolean")&&(l.properties=void 0,o.pickFiles&&o.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",o.pickFolders?"openDirectory":"openFile","createDirectory"]),P.isMacintosh&&l.properties.push("treatPackageAsDirectory");const s=c||R.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(l,(0,M.withNullAsUndefined)(s));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateService.setItem(ht.workingDirPickerStorageKey,(0,n.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(o){if(o){let c=this.windowDialogQueues.get(o.id);return c||(c=new L.Queue,this.windowDialogQueues.set(o.id,c)),c}else return this.noWindowDialogueQueue}showMessageBox(o,c){return this.getWindowDialogQueue(c).queue(async()=>c?R.dialog.showMessageBox(c,o):R.dialog.showMessageBox(o))}async showSaveDialog(o,c){const l=this.acquireFileDialogLock(o,c);if(!l)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let s;return c?s=await R.dialog.showSaveDialog(c,o):s=await R.dialog.showSaveDialog(o),s.filePath=this.normalizePath(s.filePath),s})}finally{(0,d.dispose)(l)}}normalizePath(o){return o&&P.isMacintosh&&(o=(0,S.normalizeNFC)(o)),o}normalizePaths(o){return o.map(c=>this.normalizePath(c))}async showOpenDialog(o,c){o.defaultPath&&(await(0,i.exists)(o.defaultPath)||(o.defaultPath=void 0));const l=this.acquireFileDialogLock(o,c);if(!l)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let s;return c?s=await R.dialog.showOpenDialog(c,o):s=await R.dialog.showOpenDialog(o),s.filePaths=this.normalizePaths(s.filePaths),s})}finally{(0,d.dispose)(l)}}acquireFileDialogLock(o,c){if(!c)return d.Disposable.None;let l=this.windowFileDialogLocks.get(c.id);l||(l=new Set,this.windowFileDialogLocks.set(c.id,l));const s=(0,w.hash)(o);if(!l.has(s))return l.add(s),(0,d.toDisposable)(()=>{l==null||l.delete(s),(l==null?void 0:l.size)===0&&this.windowFileDialogLocks.delete(c.id)})}};y.workingDirPickerStorageKey="pickerWorkingDir",y=he([ee(0,b.IStateService)],y),e.DialogMainService=y}),define(Z[208],x([0,1,4,2,28]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class b extends R.Disposable{constructor(n,S){super();this.logService=n,this.storageMainService=S,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,S)=>(n?n.push(S):n=[S],n),b.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const S=new Map,i=new Set;return n.forEach(M=>{const f=this.storageMainService.globalStorage.get(M.key);typeof f=="string"?S.set(M.key,f):i.add(M.key)}),{changed:Array.from(S.entries()),deleted:Array.from(i.values())}}listen(n,S){switch(S){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${S}`)}async call(n,S,i){const M=(0,L.reviveIdentifier)(i.workspace),f=await this.withStorageInitialized(M);switch(S){case"getItems":return Array.from(f.items.entries());case"updateItems":{const E=i;if(E.insert)for(const[g,d]of E.insert)f.set(g,d);E.delete&&E.delete.forEach(g=>f.delete(g));break}case"close":{if(M)return f.close();break}default:throw new Error(`Call not found: ${S}`)}}async withStorageInitialized(n){const S=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await S.init()}catch(i){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${i}`)}return S}}e.StorageDatabaseChannel=b,b.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[209],x([0,1,22,23,4,2,6,120,84,8,93,31,30,28]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class d extends b.Disposable{constructor(o){super();this.logService=o,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new L.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new S.Storage(new S.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const o=await this.doCreate();this.storage.dispose(),this.storage=o,this._register(o.onDidChangeStorage(l=>this._onDidChangeStorage.fire({key:l}))),await this.doInit(o);const c=o.getBoolean(M.IS_NEW_KEY);c===void 0?o.set(M.IS_NEW_KEY,!0):c&&o.set(M.IS_NEW_KEY,!1)}catch(o){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${o}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===P.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this.storage.items}get(o,c){return this.storage.get(o,c)}set(o,c){return this.storage.set(o,c)}delete(o){return this.storage.delete(o)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class w extends d{constructor(o,c,l){super(c);this.options=o,this.environmentService=l}async doCreate(){let o;return this.options.useInMemoryStorage?o=n.SQLiteStorageDatabase.IN_MEMORY_PATH:o=(0,i.join)(this.environmentService.globalStorageHome.fsPath,w.STORAGE_NAME),new S.Storage(new n.SQLiteStorageDatabase(o,{logging:this.createLogginOptions()}))}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(f.instanceStorageKey,void 0)===void 0&&o.set(f.instanceStorageKey,(0,E.generateUuid)()),o.get(f.firstSessionDateStorageKey,void 0)===void 0&&o.set(f.firstSessionDateStorageKey,new Date().toUTCString());const s=o.get(f.currentSessionDateStorageKey,void 0),t=new Date().toUTCString();o.set(f.lastSessionDateStorageKey,typeof s=="undefined"?null:s),o.set(f.currentSessionDateStorageKey,t)}}e.GlobalStorageMain=w,w.STORAGE_NAME="state.vscdb";class y extends d{constructor(o,c,l,s){super(l);this.workspace=o,this.options=c,this.environmentService=s}async doCreate(){const{storageFilePath:o,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new S.Storage(new n.SQLiteStorageDatabase(o,{logging:this.createLogginOptions()}),{hint:c?S.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:n.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,i.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,i.join)(o,y.WORKSPACE_STORAGE_NAME);return await(0,R.exists)(o)?{storageFilePath:c,wasCreated:!1}:(await p.promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let c;if((0,g.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,g.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const l=(0,i.join)(o,y.WORKSPACE_META_NAME);await(0,R.exists)(l)||await(0,R.writeFile)(l,JSON.stringify(c,void 0,2))}catch(l){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.WorkspaceStorageMain=y,y.WORKSPACE_STORAGE_NAME="state.vscdb",y.WORKSPACE_META_NAME="workspace.json"}),define(Z[96],x([0,1,42,2,52,5,18,6,209]),function(H,e,p,R,L,b,P,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,b.createDecorator)("storageMainService");let i=class extends R.Disposable{constructor(f,E,g){super();this.logService=f,this.environmentService=E,this.lifecycleMainService=g,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async f=>{f.workspace&&this.workspaceStorage(f.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(f=>{f.join(this.globalStorage.close());for(const[,E]of this.mapWorkspaceToStorage)f.join(E.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const f=new S.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(f.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),f}createWorkspaceStorage(f){return new S.WorkspaceStorageMain(f,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(f){let E=this.mapWorkspaceToStorage.get(f.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${f.id})`),E=this.createWorkspaceStorage(f),this.mapWorkspaceToStorage.set(f.id,E),(0,p.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${f.id})`),this.mapWorkspaceToStorage.delete(f.id)})),E}};i=he([ee(0,n.ILogService),ee(1,L.IEnvironmentService),ee(2,P.ILifecycleMainService)],i),e.StorageMainService=i}),define(Z[97],x([0,1,7,28,15]),function(H,e,p,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function b(S,i,M){for(const E of S){const g=E.openedWorkspace;if((0,R.isWorkspaceIdentifier)(g)){const d=M(g);if(d){if(d.folders.some(w=>L.extUriBiasedIgnorePathCase.isEqualOrParent(i,w.uri)))return E}else if(L.extUriBiasedIgnorePathCase.isEqualOrParent(i,g.configPath))return E}}const f=S.filter(E=>(0,R.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqualOrParent(i,E.openedWorkspace.uri));if(f.length)return f.sort((E,g)=>-(E.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=b;function P(S,i){for(const M of S)if((0,R.isWorkspaceIdentifier)(M.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqual(M.openedWorkspace.configPath,i)||(0,R.isSingleFolderWorkspaceIdentifier)(M.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqual(M.openedWorkspace.uri,i))return M}e.findWindowOnWorkspaceOrFolder=P;function n(S,i){var M,f;const E=g=>i.some(d=>L.extUriBiasedIgnorePathCase.isEqual(p.URI.file(d),p.URI.file(g)));for(const g of S)if((f=(M=g.config)===null||M===void 0?void 0:M.extensionDevelopmentPath)===null||f===void 0?void 0:f.some(d=>E(d)))return g}e.findWindowOnExtensionDevelopmentPath=n}),define(Z[210],x([0,1,11,2,3,15,7,24,18,6,37,32,28]),function(H,e,p,R,L,b,P,n,S,i,M,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let g=class dt extends R.Disposable{constructor(c,l,s,t,r){super();this.windowsMainService=c,this.stateService=l,this.lifecycleMainService=s,this.logService=t,this.configurationService=r,this._state=d(this.stateService.getItem(dt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),t&&(c.lastActiveWindow=this.toWindowState(t))}const l=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);l&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(l)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const s=y(c);this.stateService.setItem(dt.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(c){if(!this.lifecycleMainService.quitRequested){const l=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(s=>{var t;const r=(0,E.isWorkspaceIdentifier)(c.openedWorkspace)&&((t=s.workspace)===null||t===void 0?void 0:t.id)===c.openedWorkspace.id,a=(0,E.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&s.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(s.folderUri,c.openedWorkspace.uri);(r||a)&&(s.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}}toWindowState(c){return{workspace:(0,E.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,E.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const l=this.doGetNewWindowState(c),s=this.configurationService.getValue("window");let t;return l.hasDefaultState?t=!!((s==null?void 0:s.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(s.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(s==null?void 0:s.restoreFullscreen)),t&&L.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(t=!1)),l.mode===3&&!t&&(l.mode=1),l}doGetNewWindowState(c){const l=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const u=c.workspace;if((0,E.isWorkspaceIdentifier)(u)){const I=this.state.openedWindows.filter(A=>A.workspace&&A.workspace.id===u.id).map(A=>A.uiState);if(I.length)return I[0]}if((0,E.isSingleFolderWorkspaceIdentifier)(u)){const I=this.state.openedWindows.filter(A=>A.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(A.folderUri,u.uri)).map(A=>A.uiState);if(I.length)return I[0]}else if(c.backupPath){const I=this.state.openedWindows.filter(A=>A.backupPath===c.backupPath).map(A=>A.uiState);if(I.length)return I[0]}const m=this.lastClosedState||this.state.lastActiveWindow;if(!l&&m)return m.uiState}let s;const t=p.screen.getAllDisplays();if(t.length===1)s=t[0];else{if(L.isMacintosh){const u=p.screen.getCursorScreenPoint();s=p.screen.getDisplayNearestPoint(u)}!s&&l&&(s=p.screen.getDisplayMatching(l.getBounds())),s||(s=p.screen.getPrimaryDisplay()||t[0])}let r=(0,f.defaultWindowState)();r.x=Math.round(s.bounds.x+s.bounds.width/2-r.width/2),r.y=Math.round(s.bounds.y+s.bounds.height/2-r.height/2);const a=this.configurationService.getValue("window");let h=!0;if(a==null?void 0:a.newWindowDimensions){if(a.newWindowDimensions==="maximized")r.mode=0,h=!1;else if(a.newWindowDimensions==="fullscreen")r.mode=3,h=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&l){const u=l.serializeWindowState();u.mode===3?r.mode=3:r=u,h=r.mode!==3&&a.newWindowDimensions==="offset"}}return h&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const l=this.windowsMainService.getWindows().map(s=>s.getBounds());for(;l.some(s=>s.x===c.x||s.y===c.y);)c.x+=30,c.y+=30;return c}};g.windowsStateStorageKey="windowsState",g=he([ee(0,f.IWindowsMainService),ee(1,M.IStateService),ee(2,S.ILifecycleMainService),ee(3,i.ILogService),ee(4,n.IConfigurationService)],g),e.WindowsStateHandler=g;function d(o){const c={openedWindows:[]},l=o||{openedWindows:[]};return l.lastActiveWindow&&(c.lastActiveWindow=w(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=w(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(c.openedWindows=l.openedWindows.map(s=>w(s))),c}e.restoreWindowsState=d;function w(o){const c={uiState:o.uiState};return o.backupPath&&(c.backupPath=o.backupPath),o.remoteAuthority&&(c.remoteAuthority=o.remoteAuthority),o.folder&&(c.folderUri=P.URI.parse(o.folder)),o.workspaceIdentifier&&(c.workspace={id:o.workspaceIdentifier.id,configPath:P.URI.parse(o.workspaceIdentifier.configURIPath)}),c}function y(o){return{lastActiveWindow:o.lastActiveWindow&&v(o.lastActiveWindow),lastPluginDevelopmentHostWindow:o.lastPluginDevelopmentHostWindow&&v(o.lastPluginDevelopmentHostWindow),openedWindows:o.openedWindows.map(c=>v(c))}}e.getWindowsStateStoreData=y;function v(o){return{workspaceIdentifier:o.workspace&&{id:o.workspace.id,configURIPath:o.workspace.configPath.toString()},folder:o.folderUri&&o.folderUri.toString(),backupPath:o.backupPath,remoteAuthority:o.remoteAuthority,uiState:o.uiState}}}),define(Z[55],x([0,1,58,59,211,4,33,8,27,30,2,21,82,19,3]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(I){this.socket=I}dispose(){this.socket.destroy()}onData(I){const A=T=>I(f.VSBuffer.wrap(T));return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(I){return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(I){return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(I){if(!this.socket.destroyed)try{this.socket.write(I.buffer)}catch(A){if(A.code==="EPIPE")return;(0,g.onUnexpectedError)(A)}}end(){this.socket.end()}drain(){return new Promise((I,A)=>{if(this.socket.bufferSize===0){I();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),I()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=w;var y;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var v;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(v||(v={}));class o extends M.Disposable{constructor(I,A,T,N){super();this._onDidZlibFlush=this._register(new b.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=I,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=A,this._recordInflateBytes=N,A?(this._zlibInflate=L.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",$=>{console.error($),(0,g.onUnexpectedError)($),this._onClose.fire()}),this._zlibInflate.on("data",$=>{this._pendingInflateData.push($)}),T&&(this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=L.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",$=>{console.error($),(0,g.onUnexpectedError)($),this._onClose.fire()}),this._zlibDeflate.on("data",$=>{this._pendingDeflateData.push($)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?f.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):f.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._totalOutgoingDataBytes+=I.byteLength,this._zlibDeflate?(this._zlibDeflate.write(I.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let A=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.length-4),this._isEnded||this._write(f.VSBuffer.wrap(A),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(I,!1)}_write(I,A){let T=2;I.byteLength<126?T+=0:I.byteLength<2**16?T+=2:T+=8;const N=f.VSBuffer.alloc(T);if(A?N.writeUInt8(194,0):N.writeUInt8(130,0),I.byteLength<126)N.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){N.writeUInt8(126,1);let $=1;N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}else{N.writeUInt8(127,1);let $=1;N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(I.byteLength>>>24&255,++$),N.writeUInt8(I.byteLength>>>16&255,++$),N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}this._totalOutgoingWireBytes+=N.byteLength+I.byteLength,this.socket.write(f.VSBuffer.concat([N,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._totalIncomingWireBytes+=I.byteLength,this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),N=(A.readUInt8(0)&128)>>>7,$=A.readUInt8(1),X=($&128)>>>7,ne=$&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=N,this._state.mask=0}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),T=A.readUInt8(1),N=(T&128)>>>7;let $=T&127,X=1;$===126?$=A.readUInt8(++X)*2**8+A.readUInt8(++X):$===127&&($=A.readUInt8(++X)*0+A.readUInt8(++X)*0+A.readUInt8(++X)*0+A.readUInt8(++X)*0+A.readUInt8(++X)*2**24+A.readUInt8(++X)*2**16+A.readUInt8(++X)*2**8+A.readUInt8(++X));let ne=0;N&&(ne=A.readUInt8(++X)*2**24+A.readUInt8(++X)*2**16+A.readUInt8(++X)*2**8+A.readUInt8(++X)),this._state.state=3,this._state.readLen=$,this._state.mask=ne}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);c(A,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(A.buffer)),this._zlibInflate.write(A.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const T=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=T.length,this._onData.fire(f.VSBuffer.wrap(T))})):(this._totalIncomingDataBytes+=A.byteLength,this._onData.fire(A))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await b.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=o;function c(m,I){if(I!==0){let A=m.byteLength>>>2;for(let Y=0;Y<A;Y++){const Q=m.readUInt32BE(Y*4);m.writeUInt32BE(Q^I,Y*4)}let T=A*4,N=m.byteLength-T;const $=I>>>24&255,X=I>>>16&255,ne=I>>>8&255;N>=1&&m.writeUInt8(m.readUInt8(T)^$,T),N>=2&&m.writeUInt8(m.readUInt8(T+1)^X,T+1),N>=3&&m.writeUInt8(m.readUInt8(T+2)^ne,T+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function s(){const m=(0,i.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):I=(0,n.join)((0,S.tmpdir)(),`vscode-ipc-${m}.sock`),r(I),I}e.createRandomIPCHandle=s;function t(m,I,A){const T=(0,p.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${A}-${I}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${A}-${I}.sock`):N=(0,n.join)(m,`${A}-${I}.sock`),r(N),N}e.createStaticIPCHandle=t;function r(m){const I=l[d.platform];typeof I=="number"&&m.length>=I&&console.warn(`WARNING: IPC handle "${m}" is longer than ${I} chars, try a shorter --user-data-dir`)}class a extends P.IPCServer{constructor(I){super(a.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const A=b.Event.fromNodeEventEmitter(I,"connection");return b.Event.map(A,T=>({protocol:new E.Protocol(new w(T)),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function h(m){return new Promise((I,A)=>{const T=(0,R.createServer)();T.on("error",A),T.listen(m,()=>{T.removeListener("error",A),I(new a(T))})})}e.serve=h;function u(m,I){return new Promise((A,T)=>{const N=(0,R.createConnection)(m,()=>{N.removeListener("error",T),A(E.Client.fromSocket(new w(N),I))});N.once("error",T)})}e.connect=u}),define(Z[212],x([0,1,55]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverChannelClient=e.WindowDriverChannel=e.WindowDriverRegistryChannelClient=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class R{constructor(f){this.driver=f}listen(f,E){throw new Error("No event found")}call(f,E,g){switch(E){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(g);case"reloadWindow":return this.driver.reloadWindow(g);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(g[0],g[1]);case"click":return this.driver.click(g[0],g[1],g[2],g[3]);case"doubleClick":return this.driver.doubleClick(g[0],g[1]);case"setValue":return this.driver.setValue(g[0],g[1],g[2]);case"getTitle":return this.driver.getTitle(g[0]);case"isActiveElement":return this.driver.isActiveElement(g[0],g[1]);case"getElements":return this.driver.getElements(g[0],g[1],g[2]);case"getElementXY":return this.driver.getElementXY(g[0],g[1],g[2]);case"typeInEditor":return this.driver.typeInEditor(g[0],g[1],g[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(g[0],g[1]);case"writeInTerminal":return this.driver.writeInTerminal(g[0],g[1],g[2])}throw new Error(`Call not found: ${E}`)}}e.DriverChannel=R;class L{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,E){return this.channel.call("dispatchKeybinding",[f,E])}click(f,E,g,d){return this.channel.call("click",[f,E,g,d])}doubleClick(f,E){return this.channel.call("doubleClick",[f,E])}setValue(f,E,g){return this.channel.call("setValue",[f,E,g])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,E){return this.channel.call("isActiveElement",[f,E])}getElements(f,E,g){return this.channel.call("getElements",[f,E,g])}getElementXY(f,E,g,d){return this.channel.call("getElementXY",[f,E,g,d])}typeInEditor(f,E,g){return this.channel.call("typeInEditor",[f,E,g])}getTerminalBuffer(f,E){return this.channel.call("getTerminalBuffer",[f,E])}writeInTerminal(f,E,g){return this.channel.call("writeInTerminal",[f,E,g])}}e.DriverChannelClient=L;class b{constructor(f){this.registry=f}listen(f,E){throw new Error(`Event not found: ${E}`)}call(f,E,g){switch(E){case"registerWindowDriver":return this.registry.registerWindowDriver(g);case"reloadWindowDriver":return this.registry.reloadWindowDriver(g)}throw new Error(`Call not found: ${E}`)}}e.WindowDriverRegistryChannel=b;class P{constructor(f){this.channel=f}registerWindowDriver(f){return this.channel.call("registerWindowDriver",f)}reloadWindowDriver(f){return this.channel.call("reloadWindowDriver",f)}}e.WindowDriverRegistryChannelClient=P;class n{constructor(f){this.driver=f}listen(f,E){throw new Error(`No event found: ${E}`)}call(f,E,g){switch(E){case"click":return this.driver.click(g[0],g[1],g[2]);case"doubleClick":return this.driver.doubleClick(g);case"setValue":return this.driver.setValue(g[0],g[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(g);case"getElements":return this.driver.getElements(g[0],g[1]);case"getElementXY":return this.driver.getElementXY(g[0],g[1],g[2]);case"typeInEditor":return this.driver.typeInEditor(g[0],g[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(g);case"writeInTerminal":return this.driver.writeInTerminal(g[0],g[1])}throw new Error(`Call not found: ${E}`)}}e.WindowDriverChannel=n;class S{constructor(f){this.channel=f}click(f,E,g){return this.channel.call("click",[f,E,g])}doubleClick(f){return this.channel.call("doubleClick",f)}setValue(f,E){return this.channel.call("setValue",[f,E])}getTitle(){return this.channel.call("getTitle")}isActiveElement(f){return this.channel.call("isActiveElement",f)}getElements(f,E){return this.channel.call("getElements",[f,E])}getElementXY(f,E,g){return this.channel.call("getElementXY",[f,E,g])}typeInEditor(f,E){return this.channel.call("typeInEditor",[f,E])}getTerminalBuffer(f){return this.channel.call("getTerminalBuffer",f)}writeInTerminal(f,E){return this.channel.call("writeInTerminal",[f,E])}}e.WindowDriverChannelClient=S;async function i(M){const f=await(0,p.connect)(M,"driverClient"),E=f.getChannel("driver"),g=new L(E);return{client:f,driver:g}}e.connect=i}),define(Z[26],x([0,1,8,50,5,52,175,55,17]),function(H,e,p,R,L,b,P,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,L.refineServiceDecorator)(b.IEnvironmentService);class i extends P.NativeEnvironmentService{get cachedLanguagesPath(){return(0,p.join)(this.userDataPath,"clp")}get backupHome(){return(0,p.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,p.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",S.default.version)}get sandbox(){return!!this._args.__sandbox}get driverVerbose(){return!!this._args["driver-verbose"]}get disableUpdates(){return!!this._args["disable-updates"]}get disableKeytar(){return!!this._args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}}he([R.memoize],i.prototype,"cachedLanguagesPath",null),he([R.memoize],i.prototype,"backupHome",null),he([R.memoize],i.prototype,"backupWorkspacesPath",null),he([R.memoize],i.prototype,"mainIPCHandle",null),he([R.memoize],i.prototype,"sandbox",null),he([R.memoize],i.prototype,"driverVerbose",null),he([R.memoize],i.prototype,"disableUpdates",null),he([R.memoize],i.prototype,"disableKeytar",null),he([R.memoize],i.prototype,"nodeCachedDataDir",null),e.EnvironmentMainService=i}),define(Z[213],x([0,1,22,58,8,3,23,47,26,24,16,6,28,7,29,9,15]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(c,l,s){this.configurationService=l,this.logService=s,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=y.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>(0,d.isEqual)(t,r,!b.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await p.promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){c=Object.create(null)}c.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos));let l=[];try{Array.isArray(c.rootURIWorkspaces)&&(l=c.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:g.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(l);let s=[];try{Array.isArray(c.folderURIWorkspaces)&&(s=c.folderURIWorkspaces.map(t=>g.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(s),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==M.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===M.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var c;const l=this.configurationService.getValue();return((c=l==null?void 0:l.files)===null||c===void 0?void 0:c.hotExit)||M.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,l){this.workspaces.some(t=>c.workspace.id===t.workspace.id)||(this.workspaces.push(c),this.saveSync());const s=this.getBackupPath(c.workspace.id);return l&&this.moveBackupFolderSync(s,l),s}moveBackupFolderSync(c,l){if(p.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),p.existsSync(l))try{p.renameSync(l,c)}catch(s){this.logService.error(`Backup: Could not move backup folder to new location: ${s.toString()}`)}}unregisterWorkspaceBackupSync(c){const l=c.id,s=this.workspaces.findIndex(t=>t.workspace.id===l);s!==-1&&(this.workspaces.splice(s,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(l=>this.backupUriComparer.isEqual(c,l))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const l=this.folders.findIndex(s=>this.backupUriComparer.isEqual(c,s));l!==-1&&(this.folders.splice(l,1),this.saveSync())}registerEmptyWindowBackupSync(c,l){const s=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,s))||(this.emptyWindows.push({backupFolder:s,remoteAuthority:l}),this.saveSync()),this.getBackupPath(s)}unregisterEmptyWindowBackupSync(c){const l=this.emptyWindows.findIndex(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,c));l!==-1&&(this.emptyWindows.splice(l,1),this.saveSync())}getBackupPath(c){return(0,L.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const l=new Set,s=[];for(let t of c){const r=t.workspace;if(!(0,E.isWorkspaceIdentifier)(r))return[];if(!l.has(r.id)){l.add(r.id);const a=this.getBackupPath(r.id);await this.doHasBackups(a)?r.configPath.scheme!==w.Schemas.file||await(0,P.exists)(r.configPath.fsPath)?s.push(t):await this.convertToEmptyWindowBackup(a):await this.deleteStaleBackup(a)}}return s}async validateFolders(c){if(!Array.isArray(c))return[];const l=[],s=new Set;for(let t of c){const r=this.backupUriComparer.getComparisonKey(t);if(!s.has(r)){s.add(r);const a=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(a)?t.scheme!==w.Schemas.file||await(0,P.exists)(t.fsPath)?l.push(t):await this.convertToEmptyWindowBackup(a):await this.deleteStaleBackup(a)}}return l}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const l=[],s=new Set;for(let t of c){const r=t.backupFolder;if(typeof r!="string")return[];if(!s.has(r)){s.add(r);const a=this.getBackupPath(r);await this.doHasBackups(a)?l.push(t):await this.deleteStaleBackup(a)}}return l}async deleteStaleBackup(c){try{await(0,P.exists)(c)&&await(0,P.rimraf)(c,P.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}async convertToEmptyWindowBackup(c){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const s=this.getBackupPath(l);try{await p.promises.rename(c,s)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}convertToEmptyWindowBackupSync(c){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const s=this.getBackupPath(l);try{p.renameSync(c,s)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}async getDirtyWorkspaces(){const c=[];for(const l of this.workspaces)await this.hasBackups(l)&&c.push(l.workspace);for(const l of this.folders)await this.hasBackups(l)&&c.push(l);return c}hasBackups(c){let l;return g.URI.isUri(c)?l=this.getBackupPath(this.getFolderHash(c)):(0,n.isWorkspaceBackupInfo)(c)?l=this.getBackupPath(c.workspace.id):l=c.backupFolder,this.doHasBackups(l)}async doHasBackups(c){try{const l=await(0,P.readdir)(c);for(const s of l)try{if((await(0,P.readdir)((0,L.join)(c,s))).length>0)return!0}catch(t){}}catch(l){}return!1}saveSync(){try{(0,P.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await(0,P.writeFile)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderURIWorkspaces:this.folders.map(c=>c.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){let l;return c.scheme===w.Schemas.file?l=b.isLinux?c.fsPath:c.fsPath.toLowerCase():l=c.toString().toLowerCase(),(0,R.createHash)("md5").update(l).digest("hex")}};v=he([ee(0,S.IEnvironmentMainService),ee(1,i.IConfigurationService),ee(2,f.ILogService)],v),e.BackupMainService=v}),define(Z[41],x([0,1,4,32,11,18,3,26,48,23,7,31,5,27,66,6,8,17,50,2]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y,v,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let l=class tt extends c.Disposable{constructor(t,r,a,h,u,m,I){super();this.sharedProcess=t,this.windowsMainService=r,this.dialogMainService=a,this.lifecycleMainService=h,this.environmentMainService=u,this.telemetryService=m,this.logService=I,this.onDidOpenWindow=p.Event.map(this.windowsMainService.onDidOpenWindow,A=>A.id),this.onDidMaximizeWindow=p.Event.filter(p.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(A,T)=>T.id),A=>!!this.windowsMainService.getWindowById(A)),this.onDidUnmaximizeWindow=p.Event.filter(p.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(A,T)=>T.id),A=>!!this.windowsMainService.getWindowById(A)),this.onDidBlurWindow=p.Event.filter(p.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(A,T)=>T.id),A=>!!this.windowsMainService.getWindowById(A)),this.onDidFocusWindow=p.Event.any(p.Event.map(p.Event.filter(p.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),A=>!!A),A=>A.id),p.Event.filter(p.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(A,T)=>T.id),A=>!!this.windowsMainService.getWindowById(A))),this.onDidResumeOS=p.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new p.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new p.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=p.Event.debounce(p.Event.any(p.Event.filter(p.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(A,T,N)=>N),A=>!(Array.isArray(A)&&A.length===1&&A[0]==="workArea")),p.Event.fromNodeEventEmitter(L.screen,"display-added"),p.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(r=>{var a,h;return{id:r.id,workspace:r.openedWorkspace,title:(h=(a=r.win)===null||a===void 0?void 0:a.getTitle())!==null&&h!==void 0?h:"",filename:r.getRepresentedFilename(),dirty:r.isDocumentEdited()}})}async getWindowCount(t){return this.windowsMainService.getWindowCount()}async getActiveWindowId(t){const r=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(r)return r.id}openWindow(t,r,a){return Array.isArray(r)?this.doOpenWindow(t,r,a):this.doOpenEmptyWindow(t,r)}async doOpenWindow(t,r,a=Object.create(null)){r.length>0&&this.windowsMainService.open({context:5,contextWindowId:t,urisToOpen:r,cli:this.environmentMainService.args,forceNewWindow:a.forceNewWindow,forceReuseWindow:a.forceReuseWindow,preferNewWindow:a.preferNewWindow,diffMode:a.diffMode,addMode:a.addMode,gotoLineMode:a.gotoLineMode,noRecentEntry:a.noRecentEntry,waitMarkerFileURI:a.waitMarkerFileURI,remoteAuthority:a.remoteAuthority||void 0})}async doOpenEmptyWindow(t,r){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:t},r)}async toggleFullScreen(t){const r=this.windowById(t);r&&r.toggleFullScreen()}async handleTitleDoubleClick(t){const r=this.windowById(t);r&&r.handleTitleDoubleClick()}async isMaximized(t){const r=this.windowById(t);return(r==null?void 0:r.win)?r.win.isMaximized():!1}async maximizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.maximize()}async unmaximizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.unmaximize()}async minimizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.minimize()}async focusWindow(t,r){var a;r&&typeof r.windowId=="number"&&(t=r.windowId);const h=this.windowById(t);h&&h.focus({force:(a=r==null?void 0:r.force)!==null&&a!==void 0?a:!1})}async setMinimumSize(t,r,a){const h=this.windowById(t);if(h==null?void 0:h.win){const[u,m]=h.win.getSize(),[I,A]=h.win.getMinimumSize(),[T,N]=[r!=null?r:I,a!=null?a:A],[$,X]=[Math.max(u,T),Math.max(m,N)];(I!==T||A!==N)&&h.win.setMinimumSize(T,N),(u!==$||m!==X)&&h.win.setSize($,X)}}async showMessageBox(t,r){return this.dialogMainService.showMessageBox(r,this.toBrowserWindow(t))}async showSaveDialog(t,r){return this.dialogMainService.showSaveDialog(r,this.toBrowserWindow(t))}async showOpenDialog(t,r){return this.dialogMainService.showOpenDialog(r,this.toBrowserWindow(t))}toBrowserWindow(t){const r=this.windowById(t);if(r==null?void 0:r.win)return r.win}async pickFileFolderAndOpen(t,r){const a=await this.dialogMainService.pickFileFolder(r);a&&(this.sendPickerTelemetry(a,r.telemetryEventName||"openFileFolder",r.telemetryExtraData),this.doOpenPicked(await Promise.all(a.map(async h=>await i.SymlinkSupport.existsDirectory(h)?{folderUri:M.URI.file(h)}:{fileUri:M.URI.file(h)})),r,t))}async pickFolderAndOpen(t,r){const a=await this.dialogMainService.pickFolder(r);a&&(this.sendPickerTelemetry(a,r.telemetryEventName||"openFolder",r.telemetryExtraData),this.doOpenPicked(a.map(h=>({folderUri:M.URI.file(h)})),r,t))}async pickFileAndOpen(t,r){const a=await this.dialogMainService.pickFile(r);a&&(this.sendPickerTelemetry(a,r.telemetryEventName||"openFile",r.telemetryExtraData),this.doOpenPicked(a.map(h=>({fileUri:M.URI.file(h)})),r,t))}async pickWorkspaceAndOpen(t,r){const a=await this.dialogMainService.pickWorkspace(r);a&&(this.sendPickerTelemetry(a,r.telemetryEventName||"openWorkspace",r.telemetryExtraData),this.doOpenPicked(a.map(h=>({workspaceUri:M.URI.file(h)})),r,t))}doOpenPicked(t,r,a){this.windowsMainService.open({context:3,contextWindowId:a,cli:this.environmentMainService.args,urisToOpen:t,forceNewWindow:r.forceNewWindow})}sendPickerTelemetry(t,r,a){const h=t?t.length:0;this.telemetryService.publicLog(r,Object.assign(Object.assign({},a),{outcome:h?"success":"canceled",numberOfPaths:h}))}async showItemInFolder(t,r){L.shell.showItemInFolder(r)}async setRepresentedFilename(t,r){const a=this.windowById(t);a&&a.setRepresentedFilename(r)}async setDocumentEdited(t,r){const a=this.windowById(t);a&&a.setDocumentEdited(r)}async openExternal(t,r){return P.isLinuxSnap?this.safeSnapOpenExternal(r):L.shell.openExternal(r),!0}safeSnapOpenExternal(t){const r=process.env.GDK_PIXBUF_MODULE_FILE,a=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(t),process.env.GDK_PIXBUF_MODULE_FILE=r,process.env.GDK_PIXBUF_MODULEDIR=a}async moveItemToTrash(t,r){return L.shell.moveItemToTrash(r)}async isAdmin(){let t;return P.isWindows?t=(await new Promise((r,a)=>{H(["native-is-elevated"],r,a)}))():t=process.getuid()===0,t}async writeElevated(t,r,a,h){const u=await new Promise((m,I)=>{H(["sudo-prompt"],m,I)});return new Promise((m,I)=>{const A=[`"${this.cliPath}"`];(h==null?void 0:h.overwriteReadonly)&&A.push("--file-chmod"),A.push("--file-write",`"${r.fsPath}"`,`"${a.fsPath}"`);const T={name:v.default.nameLong.replace("-",""),icns:P.isMacintosh&&this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(this.environmentMainService.appRoot),`${v.default.nameShort}.icns`):void 0};u.exec(A.join(" "),T,(N,$,X)=>{$&&this.logService.trace(`[sudo-prompt] received stdout: ${$}`),X&&this.logService.trace(`[sudo-prompt] received stderr: ${X}`),N?I(N):m(void 0)})})}get cliPath(){return P.isWindows?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${v.default.applicationName}.cmd`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):P.isLinux?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${v.default.applicationName}`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,y.join)(this.environmentMainService.appRoot,"bin","code"):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,g.totalmem)(),freemem:(0,g.freemem)(),loadavg:(0,g.loadavg)()}}async getOSProperties(){return{arch:(0,g.arch)(),platform:(0,g.platform)(),release:(0,g.release)(),type:(0,g.type)(),cpus:(0,g.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}async killProcess(t,r,a){process.kill(r,a)}async readClipboardText(t,r){return L.clipboard.readText(r)}async writeClipboardText(t,r,a){return L.clipboard.writeText(r,a)}async readClipboardFindText(t){return L.clipboard.readFindText()}async writeClipboardFindText(t,r){return L.clipboard.writeFindText(r)}async writeClipboardBuffer(t,r,a,h){return L.clipboard.writeBuffer(r,Buffer.from(a),h)}async readClipboardBuffer(t,r){return L.clipboard.readBuffer(r)}async hasClipboard(t,r,a){return L.clipboard.has(r,a)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(t,r){const a=this.windowById(t);a&&a.updateTouchBar(r)}async notifyReady(t){const r=this.windowById(t);r&&r.setReady()}async relaunch(t,r){return this.lifecycleMainService.relaunch(r)}async reload(t,r){const a=this.windowById(t);if(a)return this.lifecycleMainService.reload(a,(r==null?void 0:r.disableExtensions)!==void 0?{_:[],"disable-extensions":r==null?void 0:r.disableExtensions}:void 0)}async closeWindow(t){this.closeWindowById(t,t)}async closeWindowById(t,r){const a=this.windowById(r);if(a==null?void 0:a.win)return a.win.close()}async quit(t){const r=this.windowsMainService.getLastActiveWindow();(r==null?void 0:r.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&r.win?r.win.close():setTimeout(()=>{this.lifecycleMainService.quit()},10)}async exit(t,r){await this.lifecycleMainService.kill(r)}async resolveProxy(t,r){var a,h;const u=this.windowById(t),m=(h=(a=u==null?void 0:u.win)===null||a===void 0?void 0:a.webContents)===null||h===void 0?void 0:h.session;if(m)return m.resolveProxy(r)}async openDevTools(t,r){const a=this.windowById(t);(a==null?void 0:a.win)&&a.win.webContents.openDevTools(r)}async toggleDevTools(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.webContents.toggleDevTools()}async sendInputEvent(t,r){const a=this.windowById(t);(a==null?void 0:a.win)&&(r.type==="mouseDown"||r.type==="mouseUp")&&a.win.webContents.sendInputEvent(r)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(t,r,a,h){if(!!P.isWindows){const u=await new Promise((m,I)=>{H(["vscode-windows-registry"],m,I)});try{return u.GetStringRegKey(r,a,h)}catch(m){return}}}async getPassword(t,r,a){const h=await this.withKeytar(),u=await h.getPassword(r,a);if(u)try{let{content:m,hasNextChunk:I}=JSON.parse(u);if(!m||!I)return u;let A=1;for(;I;){const T=await h.getPassword(r,`${a}-${A}`),N=JSON.parse(T);m+=N.content,I=N.hasNextChunk}return m}catch(m){return u}return u}async setPassword(t,r,a,h){const u=await this.withKeytar();if(P.isWindows&&h.length>tt.MAX_PASSWORD_LENGTH){let m=0,I=0,A=!0;for(;A;){const T=h.substring(m,m+tt.PASSWORD_CHUNK_SIZE);m+=tt.PASSWORD_CHUNK_SIZE,A=h.length-m>0;const N={content:T,hasNextChunk:A};await u.setPassword(r,I?`${a}-${I}`:a,JSON.stringify(N)),I++}}else await u.setPassword(r,a,h);this._onDidChangePassword.fire({service:r,account:a})}async deletePassword(t,r,a){const u=await(await this.withKeytar()).deletePassword(r,a);return u&&this._onDidChangePassword.fire({service:r,account:a}),u}async findPassword(t,r){return(await this.withKeytar()).findPassword(r)}async findCredentials(t,r){return(await this.withKeytar()).findCredentials(r)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((t,r)=>{H(["keytar"],t,r)})}windowById(t){if(typeof t=="number")return this.windowsMainService.getWindowById(t)}};l.MAX_PASSWORD_LENGTH=2500,l.PASSWORD_CHUNK_SIZE=l.MAX_PASSWORD_LENGTH-100,he([o.memoize],l.prototype,"cliPath",null),l=he([ee(1,R.IWindowsMainService),ee(2,S.IDialogMainService),ee(3,b.ILifecycleMainService),ee(4,n.IEnvironmentMainService),ee(5,f.ITelemetryService),ee(6,w.ILogService)],l),e.NativeHostMainService=l}),define(Z[214],x([0,1,2,4,78,11,6,32,41,87,30,17,25]),function(H,e,p,R,L,b,P,n,S,i,M,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var g;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(g||(g={}));let d=class it extends p.Disposable{constructor(y,v,o,c){super();this.logService=y,this.windowsMainService=v,this.nativeHostMainService=o,this.encryptionMainService=c,this.pendingProxyResolve=void 0,this.state=g.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const y=R.Event.fromNodeEventEmitter(b.app,"login",(v,o,c,l,s)=>({event:v,webContents:o,req:c,authInfo:l,callback:s}));this._register(y(this.onLogin,this))}async onLogin({event:y,authInfo:v,req:o,callback:c}){if(!!v.isProxy){if(!this.pendingProxyResolve&&this.state===g.LoginDialogShown&&o.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let l;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{l=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(l==null?void 0:l.username,l==null?void 0:l.password)}}async resolveProxyCredentials(y){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(y);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(y){var v,o,c,l;this.logService.trace("auth#doResolveProxyCredentials - enter",y);const s=String((0,L.hash)({scheme:y.scheme,host:y.host,port:y.port}));let t,r;try{const m=await this.nativeHostMainService.getPassword(void 0,it.PROXY_CREDENTIALS_SERVICE_KEY,s);if(m){const I=JSON.parse(await this.encryptionMainService.decrypt(m));t=I.username,r=I.password}}catch(m){this.logService.error(m)}if(this.state!==g.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=g.StoredCredentialsUsed,{username:t,password:r};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const h={authInfo:y,username:(o=(v=this.sessionCredentials)===null||v===void 0?void 0:v.username)!==null&&o!==void 0?o:t,password:(l=(c=this.sessionCredentials)===null||c===void 0?void 0:c.password)!==null&&l!==void 0?l:r,replyChannel:`vscode:proxyAuthResponse:${(0,M.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",E.CancellationToken.None,h),this.state=g.LoginDialogShown;const u=await new Promise(m=>{var I;const A=async(T,N,$)=>{var X;if(N===h.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),(X=a.win)===null||X===void 0||X.webContents.off("ipc-message",A),$){const ne={username:$.username,password:$.password};try{if($.remember){const Y=await this.encryptionMainService.encrypt(JSON.stringify(ne));await this.nativeHostMainService.setPassword(void 0,it.PROXY_CREDENTIALS_SERVICE_KEY,s,Y)}else await this.nativeHostMainService.deletePassword(void 0,it.PROXY_CREDENTIALS_SERVICE_KEY,s)}catch(Y){this.logService.error(Y)}m({username:ne.username,password:ne.password})}else m(void 0)};(I=a.win)===null||I===void 0||I.webContents.on("ipc-message",A)});return this.sessionCredentials=u,u}};d.PROXY_CREDENTIALS_SERVICE_KEY=`${f.default.urlProtocol}.proxy-credentials`,d=he([ee(0,P.ILogService),ee(1,n.IWindowsMainService),ee(2,S.INativeHostMainService),ee(3,i.IEncryptionMainService)],d),e.ProxyAuthHandler=d}),define(Z[215],x([0,1,212,32,55,2,33,56,165,3,4,77,102,10,18,41]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function y(c){return c<21}let v=class{constructor(l,s,t,r,a){this.windowServer=l,this.options=s,this.windowsMainService=t,this.lifecycleMainService=r,this.nativeHostMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new M.Emitter}async registerWindowDriver(l){return this.registeredWindowIds.add(l),this.reloadingWindowIds.delete(l),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(l){this.reloadingWindowIds.add(l)}async getWindowIds(){return this.windowsMainService.getWindows().map(l=>l.id).filter(l=>this.registeredWindowIds.has(l)&&!this.reloadingWindowIds.has(l))}async capturePage(l){await this.whenUnfrozen(l);const s=this.windowsMainService.getWindowById(l);if(!(s==null?void 0:s.win))throw new Error("Invalid window");return(await s.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(l){await this.whenUnfrozen(l);const s=this.windowsMainService.getWindowById(l);if(!s)throw new Error("Invalid window");this.reloadingWindowIds.add(l),this.lifecycleMainService.reload(s)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(l,s){await this.whenUnfrozen(l);const t=E.KeybindingParser.parseUserBinding(s);for(let r of t)await this._dispatchKeybinding(l,r)}async _dispatchKeybinding(l,s){if(s instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const t=this.windowsMainService.getWindowById(l);if(!(t==null?void 0:t.win))throw new Error("Invalid window");const r=t.win.webContents,a=new n.SimpleKeybinding(!1,!1,!1,!1,s.keyCode),u=new S.USLayoutResolvedKeybinding(a.toChord(),i.OS).getElectronAccelerator(),m=[];s.ctrlKey&&m.push("ctrl"),s.metaKey&&m.push("meta"),s.shiftKey&&m.push("shift"),s.altKey&&m.push("alt"),r.sendInputEvent({type:"keyDown",keyCode:u,modifiers:m}),y(s.keyCode)||r.sendInputEvent({type:"char",keyCode:u,modifiers:m}),r.sendInputEvent({type:"keyUp",keyCode:u,modifiers:m}),await(0,g.timeout)(100)}async click(l,s,t,r){await(await this.getWindowDriver(l)).click(s,t,r)}async doubleClick(l,s){await(await this.getWindowDriver(l)).doubleClick(s)}async setValue(l,s,t){await(await this.getWindowDriver(l)).setValue(s,t)}async getTitle(l){return await(await this.getWindowDriver(l)).getTitle()}async isActiveElement(l,s){return await(await this.getWindowDriver(l)).isActiveElement(s)}async getElements(l,s,t){return await(await this.getWindowDriver(l)).getElements(s,t)}async getElementXY(l,s,t,r){return await(await this.getWindowDriver(l)).getElementXY(s,t,r)}async typeInEditor(l,s,t){await(await this.getWindowDriver(l)).typeInEditor(s,t)}async getTerminalBuffer(l,s){return await(await this.getWindowDriver(l)).getTerminalBuffer(s)}async writeInTerminal(l,s,t){await(await this.getWindowDriver(l)).writeInTerminal(s,t)}async getWindowDriver(l){await this.whenUnfrozen(l);const s=`window:${l}`,t=new P.StaticRouter(a=>a===s),r=this.windowServer.getChannel("windowDriver",t);return new p.WindowDriverChannelClient(r)}async whenUnfrozen(l){for(;this.reloadingWindowIds.has(l);)await M.Event.toPromise(this.onDidReloadingChange.event)}};v=he([ee(2,R.IWindowsMainService),ee(3,d.ILifecycleMainService),ee(4,w.INativeHostMainService)],v),e.Driver=v;async function o(c,l,s,t){const r=s.driverVerbose,a=t.createInstance(v,c,{verbose:r}),h=new p.WindowDriverRegistryChannel(a);c.registerChannel("windowDriverRegistry",h);const u=await(0,L.serve)(l),m=new p.DriverChannel(a);return u.registerChannel("driver",m),(0,b.combinedDisposable)(u,c)}e.serve=o}),define(Z[216],x([0,1,59,55]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,b,P,n){const S=M=>n(M,void 0),i=p.createConnection({host:L,port:b},()=>{i.removeListener("error",S);const M=Buffer.alloc(16);for(let d=0;d<16;d++)M[d]=Math.round(Math.random()*256);const f=M.toString("base64");let E=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${b}/?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];i.write(E.join(`\r
`)+`\r
\r
`);const g=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(i.off("data",g),n(void 0,new R.NodeSocket(i)))};i.on("data",g)});i.once("error",S)}}}),define(Z[217],x([0,1,59,10,2,111,6,61,181,54,216,72]),function(H,e,p,R,L,b,P,n,S,i,M,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function E(y,v,o,c){return new g(y,v,o,c).waitForReady()}class g extends L.Disposable{constructor(v,o,c,l){super();this.suggestedLocalPort=l,this.public=!1,this._socketsDispose=new Map,this._options=v,this._server=p.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(o=>{o()})}async waitForReady(){var v;let o=await(0,b.findFreePortFaster)((v=this.suggestedLocalPort)!==null&&v!==void 0?v:this.tunnelRemotePort,2,1e3),c=null;return c=this._server.listen(o).address(),c||(o=0,c=this._server.listen(o).address()),this.tunnelLocalPort=c.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(v){v.pause();const o=await(0,S.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),c=o.getSocket().socket,l=o.readEntireBuffer();o.dispose(),l.byteLength>0&&v.write(l.buffer),v.on("end",()=>{this._socketsDispose.delete(v.localAddress),c.end()}),v.on("close",()=>c.end()),v.on("error",()=>{this._socketsDispose.delete(v.localAddress),c.destroy()}),c.on("end",()=>v.end()),c.on("close",()=>v.end()),c.on("error",()=>{v.destroy()}),v.pipe(c),c.pipe(v),this._socketsDispose.set(v.localAddress,()=>{v.end(),c.end()})}}let d=class extends i.AbstractTunnelService{constructor(v,o,c,l){super(o);this.socketFactory=v,this.signService=c,this.productService=l}retainOrCreateTunnel(v,o,c,l,s,t){const r=this.getTunnelFromMap(o,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,o,c,l,s,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${c} on local port ${l}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:v,signService:this.signService,logService:this.logService,ipcLogger:null},h=E(a,o,c,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(o,c,h),h}}};d=he([ee(1,P.ILogService),ee(2,f.ISignService),ee(3,n.IProductService)],d),e.BaseTunnelService=d;let w=class extends d{constructor(v,o,c){super(M.nodeSocketFactory,v,o,c)}};w=he([ee(0,P.ILogService),ee(1,f.ISignService),ee(2,n.IProductService)],w),e.TunnelService=w}),define(Z[218],x([0,1,211,183,2,13,19,182,24,6,21]),function(H,e,p,R,L,b,P,n,S,i,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let f=class extends L.Disposable{constructor(g,d){super();this.logService=d,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,d){this.logService.trace("RequestService#request",g.url);const{proxyUrl:w,strictSSL:y}=this,v=g.agent?g.agent:await(0,n.getProxyAgent)(g.url||"",{proxyUrl:w,strictSSL:y});return g.agent=v,g.strictSSL=y,this.authorization&&(g.headers=Object.assign(Object.assign({},g.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(g,d)}async getNodeRequest(g){return((0,R.parse)(g.url).protocol==="https:"?await new Promise((y,v)=>{H(["https"],y,v)}):await new Promise((y,v)=>{H(["http"],y,v)})).request}_request(g,d){return new Promise(async(w,y)=>{let v;const o=(0,R.parse)(g.url),c=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),l={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,b.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(l.auth=g.user+":"+g.password),v=c(l,s=>{const t=(0,b.isNumber)(g.followRedirects)?g.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&t>0&&s.headers.location)this._request(Object.assign(Object.assign({},g),{url:s.headers.location,followRedirects:t-1}),d).then(w,y);else{let r=s;s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,p.createGunzip)())),w({res:s,stream:(0,M.streamToBufferReadableStream)(r)})}}),v.on("error",y),g.timeout&&v.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&v.write(g.data),v.end(),d.onCancellationRequested(()=>{v.abort(),y((0,P.canceled)())})})}async resolveProxy(g){}};f=he([ee(0,S.IConfigurationService),ee(1,i.ILogService)],f),e.RequestService=f}),define(Z[219],x([0,1,218,11]),function(H,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function L(P){return R.net.request}class b extends p.RequestService{request(n,S){return super.request(Object.assign(Object.assign({},n||{}),{getRawRequest:L}),S)}}e.RequestMainService=b}),define(Z[220],x([0,1,11,26,10,6,18,73,9,3,2,83,13,4,88]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let w=class extends M.Disposable{constructor(v,o,c,l,s,t){super();this.machineId=v,this.userEnv=o,this.environmentMainService=c,this.lifecycleMainService=l,this.logService=s,this.themeMainService=t,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new g.Emitter),this.onDidError=g.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),p.ipcMain.on("vscode:createSharedProcessMessageChannel",async(v,o)=>this.onWindowConnection(v,o))}async onWindowConnection(v,o){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const c=await this.connect();if(v.sender.isDestroyed())return c.close();v.sender.postMessage("vscode:createSharedProcessMessageChannelResult",o,[c])}onWillShutdown(){const v=this.window;!v||(!v.isDestroyed()&&!v.webContents.isDestroyed()&&v.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(v.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{v.close()}catch(o){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(v=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),v()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.userEnv=Object.assign(Object.assign({},this.userEnv),await(0,d.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env)),this.createWindow(),this.registerWindowListeners(),await new Promise(v=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),v()}))})()),this._whenIpcReady}createWindow(){this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}});const v={machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel()};this.window.loadURL(S.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",H).with({query:`config=${encodeURIComponent(JSON.stringify(v))}`}).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=v=>{var o;this.logService.trace("SharedProcess#close prevented"),v.preventDefault(),((o=this.window)===null||o===void 0?void 0:o.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(v,o)=>this._onDidError.fire({type:2,details:o})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(v,o,c)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${c}`})))}async connect(){await this.whenIpcReady;const v=(0,E.assertIsDefined)(this.window);return(0,f.connect)(v)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}};w=he([ee(2,R.IEnvironmentMainService),ee(3,P.ILifecycleMainService),ee(4,b.ILogService),ee(5,n.IThemeMainService)],w),e.SharedProcess=w}),define(Z[75],x([0,1,4,10,24,18,17,40,26,6,39,25]),function(H,e,p,R,L,b,P,n,S,i,M,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(d,w){return`${P.default.updateUrl}/api/update/${d}/${w}/${P.default.commit}`}e.createUpdateURL=E;let g=class{constructor(w,y,v,o,c){this.lifecycleMainService=w,this.configurationService=y,this.environmentMainService=v,this.requestService=o,this.logService=c,this._state=n.State.Uninitialized,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}initialize(){if(!!this.environmentMainService.isBuilt){if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!P.default.updateUrl||!P.default.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const w=(0,L.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),y=this.getProductQuality(w);if(!y){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(y),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),w==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(null),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}}getProductQuality(w){return w==="none"?void 0:P.default.quality}scheduleCheckForUpdates(w=60*60*1e3){return(0,R.timeout)(w).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(w){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},f.CancellationToken.None).then(w=>w.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};g=he([ee(0,b.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,S.IEnvironmentMainService),ee(3,M.IRequestService),ee(4,i.ILogService)],g),e.AbstractUpdateService=g}),define(Z[221],x([0,1,11,2,4,50,24,18,40,31,26,6,75,39,17]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends E.AbstractUpdateService{constructor(v,o,c,l,s,t){super(v,o,l,s,t);this.telemetryService=c,this.disposables=new R.DisposableStore}get onRawError(){return L.Event.fromNodeEventEmitter(p.autoUpdater,"error",(v,o)=>o)}get onRawUpdateNotAvailable(){return L.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return L.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(v,o,c)=>({url:o,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return L.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(v,o,c,l)=>({releaseNotes:o,version:c,productVersion:c,date:l}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const c=(this.state.type==="checking for updates"?!!this.state.context:!0)?v:void 0;this.setState(S.State.Idle(1,c))}buildUpdateFeedUrl(v){let o;d.default.darwinUniversalAssetId?o=d.default.darwinUniversalAssetId:o=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,E.createUpdateURL)(o,v);try{p.autoUpdater.setFeedURL({url:c})}catch(l){this.logService.error("Failed to set update feed URL",l);return}return c}doCheckForUpdates(v){this.setState(S.State.CheckingForUpdates(v)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(S.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(S.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!this.state.context}),this.setState(S.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([b.memoize],w.prototype,"onRawError",null),he([b.memoize],w.prototype,"onRawUpdateNotAvailable",null),he([b.memoize],w.prototype,"onRawUpdateAvailable",null),he([b.memoize],w.prototype,"onRawUpdateDownloaded",null),w=he([ee(0,n.ILifecycleMainService),ee(1,P.IConfigurationService),ee(2,i.ITelemetryService),ee(3,M.IEnvironmentMainService),ee(4,g.IRequestService),ee(5,f.ILogService)],w),e.DarwinUpdateService=w}),define(Z[222],x([0,1,17,24,18,40,31,26,6,75,39,25,41]),function(H,e,p,R,L,b,P,n,S,i,M,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends i.AbstractUpdateService{constructor(w,y,v,o,c,l,s){super(w,y,o,c,l);this.telemetryService=v,this.nativeHostMainService=s}buildUpdateFeedUrl(w){return(0,i.createUpdateURL)(`linux-${process.arch}`,w)}doCheckForUpdates(w){!this.url||(this.setState(b.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},f.CancellationToken.None).then(M.asJson).then(y=>{!y||!y.url||!y.version||!y.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(y))}).then(void 0,y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const v=w?y.message||y:void 0;this.setState(b.State.Idle(1,v))}))}async doDownloadUpdate(w){p.default.downloadUrl&&p.default.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,p.default.downloadUrl):w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(b.State.Idle(1))}};g=he([ee(0,L.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,P.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,M.IRequestService),ee(5,S.ILogService),ee(6,E.INativeHostMainService)],g),e.LinuxUpdateService=g}),define(Z[223],x([0,1,4,10,18,40,26,6,8,22,45,31]),function(H,e,p,R,L,b,P,n,S,i,M,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{constructor(w,y,v){if(this.lifecycleMainService=w,this.logService=v,this._state=b.State.Uninitialized,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,y.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,o=>this.logService.error(o))}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}scheduleCheckForUpdates(w=60*60*1e3){return(0,R.timeout)(w).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(w){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};E=he([ee(0,L.ILifecycleMainService),ee(1,P.IEnvironmentMainService),ee(2,n.ILogService)],E);let g=class extends E{constructor(w,y,v,o,c,l){super(v,o,c);this.snap=w,this.snapRevision=y,this.telemetryService=l;const s=(0,i.watch)(S.dirname(this.snap)),t=p.Event.fromNodeEventEmitter(s,"change",(u,m)=>m),r=p.Event.filter(t,u=>u==="current"),h=p.Event.debounce(r,(u,m)=>m,2e3)(this.checkForUpdates,this);v.onWillShutdown(()=>{h.dispose(),s.close()})}doCheckForUpdates(w){this.setState(b.State.CheckingForUpdates(w)),this.isUpdateAvailable().then(y=>{y?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(b.State.Idle(2)))},y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(b.State.Idle(2,y.message||y))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,M.spawn)("sleep 3 && "+S.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const w=await new Promise((v,o)=>(0,i.realpath)(`${S.dirname(this.snap)}/current`,(c,l)=>c?o(c):v(l))),y=S.basename(w);return this.snapRevision!==y}isLatestVersion(){return this.isUpdateAvailable().then(void 0,w=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=he([ee(2,L.ILifecycleMainService),ee(3,P.IEnvironmentMainService),ee(4,n.ILogService),ee(5,f.ITelemetryService)],g),e.SnapUpdateService=g}),define(Z[224],x([0,1,22,8,23,50,24,18,17,40,31,26,6,75,39,108,27,45,25,10,16,7,41]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y,v,o,c,l,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(m,I=1e3){for(;!m();)await(0,c.timeout)(I)}let a;function h(){return typeof a=="undefined"&&(a=p.existsSync(R.join(R.dirname(process.execPath),"unins000.exe"))?0:1),a}let u=class extends g.AbstractUpdateService{constructor(I,A,T,N,$,X,ne,Y){super(I,A,N,$,X);this.telemetryService=T,this.fileService=ne,this.nativeHostMainService=Y}get cachePath(){const I=R.join((0,y.tmpdir)(),`vscode-update-${S.default.target}-${process.arch}`);return p.promises.mkdir(I,{recursive:!0}).then(()=>I)}initialize(){super.initialize(),h()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:S.default.target})}buildUpdateFeedUrl(I){let A="win32";return process.arch!=="ia32"&&(A+=`-${process.arch}`),h()===1?A+="-archive":S.default.target==="user"&&(A+="-user"),(0,g.createUpdateURL)(A,I)}doCheckForUpdates(I){!this.url||(this.setState(i.State.CheckingForUpdates(I)),this.requestService.request({url:this.url},o.CancellationToken.None).then(d.asJson).then(A=>{const T=h();return!A||!A.url||!A.version||!A.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!I}),this.setState(i.State.Idle(T)),Promise.resolve(null)):T===1?(this.setState(i.State.AvailableForDownload(A)),Promise.resolve(null)):(this.setState(i.State.Downloading(A)),this.cleanup(A.version).then(()=>this.getUpdatePackagePath(A.version).then(N=>L.exists(N).then($=>{if($)return Promise.resolve(N);const X=A.url,ne=A.hash,Y=`${N}.tmp`;return this.requestService.request({url:X},o.CancellationToken.None).then(Q=>this.fileService.writeFile(s.URI.file(Y),Q.stream)).then(ne?()=>(0,w.checksum)(Y,A.hash):()=>{}).then(()=>p.promises.rename(Y,N)).then(()=>N)})).then(N=>{const $=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:N},$&&A.supportsFastUpdate?S.default.target==="user"?this.doApplyUpdate():this.setState(i.State.Downloaded(A)):this.setState(i.State.Ready(A))})))}).then(void 0,A=>{this.logService.error(A),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!I});const T=I?A.message||A:void 0;this.setState(i.State.Idle(h(),T))}))}async doDownloadUpdate(I){I.update.url&&this.nativeHostMainService.openExternal(void 0,I.update.url),this.setState(i.State.Idle(h()))}async getUpdatePackagePath(I){const A=await this.cachePath;return R.join(A,`CodeSetup-${S.default.quality}-${I}.exe`)}async cleanup(I=null){const A=I?X=>!new RegExp(`${S.default.quality}-${I}\\.exe$`).test(X):()=>!0,T=await this.cachePath,$=(await L.readdir(T)).filter(A).map(async X=>{try{await p.promises.unlink(R.join(T,X))}catch(ne){}});await Promise.all($)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const I=this.state.update;this.setState(i.State.Updating(I));const A=await this.cachePath;this.availableUpdate.updateFilePath=R.join(A,`CodeSetup-${S.default.quality}-${I.version}.flag`),await L.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(i.State.Idle(h()))});const N=`${S.default.win32MutexName}-ready`,$=await new Promise((X,ne)=>{H(["windows-mutex"],X,ne)});r(()=>$.isActive(N)).then(()=>this.setState(i.State.Ready(I)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?p.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return h()}};he([b.memoize],u.prototype,"cachePath",null),u=he([ee(0,n.ILifecycleMainService),ee(1,P.IConfigurationService),ee(2,M.ITelemetryService),ee(3,f.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,E.ILogService),ee(6,l.IFileService),ee(7,t.INativeHostMainService)],u),e.Win32UpdateService=u}),define(Z[49],x([0,1,28,26,8,23,22,3,4,6,58,43,9,2,15,5,148,17,11,13,47,48,97]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y,v,o,c,l,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let r=class extends g.Disposable{constructor(m,I,A,T){super();this.environmentMainService=m,this.logService=I,this.backupMainService=A,this.dialogMainService=T,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new S.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new S.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(m){if(!this.isWorkspacePath(m)||m.scheme!==E.Schemas.file)return null;let I;try{I=(0,P.readFileSync)(m.fsPath,"utf8")}catch(A){return null}return this.doResolveWorkspace(m,I)}isWorkspacePath(m){return(0,p.isUntitledWorkspace)(m,this.environmentMainService)||(0,p.hasWorkspaceFileExtension)(m)}doResolveWorkspace(m,I){try{const A=this.doParseStoredWorkspace(m,I),T=a(m);return{id:T.id,configPath:T.configPath,folders:(0,p.toWorkspaceFolders)(A.folders,T.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:A.remoteAuthority}}catch(A){this.logService.warn(A.toString())}return null}doParseStoredWorkspace(m,I){const A=(0,f.parse)(I);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(T=>(0,p.isStoredWorkspaceFolder)(T));else throw new Error(`${m.toString(!0)} looks like an invalid workspace file.`);return A}async createUntitledWorkspace(m,I){const{workspace:A,storedWorkspace:T}=this.newUntitledWorkspace(m,I),N=A.configPath.fsPath;return await P.promises.mkdir((0,L.dirname)(N),{recursive:!0}),await(0,b.writeFile)(N,JSON.stringify(T,null,"	")),A}createUntitledWorkspaceSync(m,I){const{workspace:A,storedWorkspace:T}=this.newUntitledWorkspace(m,I),N=A.configPath.fsPath;return(0,P.mkdirSync)((0,L.dirname)(N),{recursive:!0}),(0,b.writeFileSync)(N,JSON.stringify(T,null,"	")),A}newUntitledWorkspace(m=[],I){const A=(Date.now()+Math.round(Math.random()*1e3)).toString(),T=(0,d.joinPath)(this.untitledWorkspacesHome,A),N=(0,d.joinPath)(T,p.UNTITLED_WORKSPACE_NAME),$=[];for(const X of m)$.push((0,p.getStoredWorkspaceFolder)(X.uri,!0,X.name,T,!n.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:a(N),storedWorkspace:{folders:$,remoteAuthority:I}}}async getWorkspaceIdentifier(m){return a(m)}isUntitledWorkspace(m){return(0,p.isUntitledWorkspace)(m.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(m){!this.isUntitledWorkspace(m)||(this.doDeleteUntitledWorkspaceSync(m),this._onDidDeleteUntitledWorkspace.fire(m))}async deleteUntitledWorkspace(m){this.deleteUntitledWorkspaceSync(m)}doDeleteUntitledWorkspaceSync(m){const I=(0,d.originalFSPath)(m.configPath);try{(0,b.rimrafSync)((0,L.dirname)(I));const A=(0,L.join)(this.environmentMainService.workspaceStorageHome.fsPath,m.id);(0,P.existsSync)(A)&&(0,b.writeFileSync)((0,L.join)(A,"obsolete"),"")}catch(A){this.logService.warn(`Unable to delete untitled workspace ${I} (${A}).`)}}getUntitledWorkspacesSync(){const m=[];try{const I=(0,b.readdirSync)(this.untitledWorkspacesHome.fsPath).map(A=>(0,d.joinPath)(this.untitledWorkspacesHome,A,p.UNTITLED_WORKSPACE_NAME));for(const A of I){const T=a(A),N=this.resolveLocalWorkspaceSync(A);N?m.push({workspace:T,remoteAuthority:N.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(T)}}catch(I){I.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${I}).`)}return m}async enterWorkspace(m,I,A){if(!m||!m.win||!m.isReady||!await this.isValidTargetWorkspacePath(m,I,A))return null;const N=this.doEnterWorkspace(m,a(A));return N?(this._onDidEnterWorkspace.fire({window:m,workspace:N.workspace}),N):null}async isValidTargetWorkspacePath(m,I,A){if(!A)return!0;if((0,p.isWorkspaceIdentifier)(m.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(m.openedWorkspace.configPath,A))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(I,A)){const T={title:v.default.nameLong,type:"info",buttons:[(0,y.localize)(0,null)],message:(0,y.localize)(1,null,(0,d.basename)(A)),detail:(0,y.localize)(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(T,(0,c.withNullAsUndefined)(o.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(m,I){if(!m.config)return null;m.focus();let A;return m.config.extensionDevelopmentPath||(A=this.backupMainService.registerWorkspaceBackupSync({workspace:I,remoteAuthority:m.remoteAuthority},m.config.backupPath)),(0,p.isWorkspaceIdentifier)(m.openedWorkspace)&&this.isUntitledWorkspace(m.openedWorkspace)&&this.deleteUntitledWorkspaceSync(m.openedWorkspace),m.config.workspace=I,m.config.backupPath=A,{workspace:I,backupPath:A}}};r=he([ee(0,R.IEnvironmentMainService),ee(1,i.ILogService),ee(2,l.IBackupMainService),ee(3,s.IDialogMainService)],r),e.WorkspacesManagementMainService=r;function a(u){function m(){let I=u.scheme===E.Schemas.file?(0,d.originalFSPath)(u):u.toString();return n.isLinux||(I=I.toLowerCase()),(0,M.createHash)("md5").update(I).digest("hex")}return{id:m(),configPath:u}}e.getWorkspaceIdentifier=a;function h(u,m){function I(){if(u.scheme!==E.Schemas.file)return(0,M.createHash)("md5").update(u.toString()).digest("hex");if(!m)try{m=(0,P.statSync)(u.fsPath)}catch(N){return}let T;return n.isLinux?T=m.ino:n.isMacintosh?T=m.birthtime.getTime():n.isWindows&&(typeof m.birthtimeMs=="number"?T=Math.floor(m.birthtimeMs):T=m.birthtime.getTime()),(0,M.createHash)("md5").update(u.fsPath).update(T?String(T):"").digest("hex")}const A=I();if(typeof A=="string")return{id:A,uri:u}}e.getSingleFolderWorkspaceIdentifier=h}),define(Z[98],x([0,1,6,95,3,5,32,23,49,24,7,11,34,53,25,28,13]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let v=class{constructor(c,l,s,t,r){this.logService=c,this.windowsMainService=l,this.urlService=s,this.workspacesManagementMainService=t,this.configurationService=r}async start(c,l){this.logService.trace("Received data from other instance: ",c,l),L.isMacintosh&&f.app.focus({steal:!0});const s=this.parseOpenUrl(c);if(s.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:r,url:a}of s)this.urlService.open(r,{originalUrl:a})})}else return this.startOpenWindow(c,l)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,E.coalesce)(c._urls.map(l=>{try{return{uri:M.URI.parse(l),url:l}}catch(s){return null}})):[]}async startOpenWindow(c,l){const s=(0,g.isLaunchedFromCli)(l)?0:4;let t=[];const r=c.wait&&c.waitMarkerFilePath?M.URI.file(c.waitMarkerFilePath):void 0,a=c.remote||void 0;if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,{context:s,cli:c,userEnv:l,waitMarkerFileURI:r,remoteAuthority:a});else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let h=!1;if(c["new-window"]||c["unity-launch"])h=!0;else if(c["reuse-window"])h=!1;else{const u=this.configurationService.getValue("window");switch((u==null?void 0:u.openWithoutArgumentsInNewWindow)||"default"){case"on":h=!0;break;case"off":h=!1;break;default:h=!L.isMacintosh}}if(h)t=this.windowsMainService.open({context:s,cli:c,userEnv:l,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:r,remoteAuthority:a});else{const u=this.windowsMainService.getLastActiveWindow();u?(u.focus(),t=[u]):t=this.windowsMainService.open({context:s,cli:c,forceEmpty:!0,remoteAuthority:a})}}else t=this.windowsMainService.open({context:s,cli:c,userEnv:l,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],waitMarkerFileURI:r,gotoLineMode:c.goto,remoteAuthority:a});if(r&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,n.whenDeleted)(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return f.BrowserWindow.getAllWindows().forEach(l=>{const s=this.windowsMainService.getWindowById(l.id);s?c.push(this.codeWindowToInfo(s)):c.push(this.browserWindowToInfo(l))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!f.app.accessibilitySupportEnabled,gpuFeatureStatus:f.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const l=this.windowsMainService.getWindows();return(await Promise.all(l.map(t=>new Promise(r=>{const a=t.remoteAuthority;if(a){const h=`vscode:getDiagnosticInfoResponse${t.id}`,u={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:h,args:u}),f.ipcMain.once(h,(m,I)=>{I||r({hostName:a,errorMessage:`Unable to resolve connection to '${a}'.`}),r(I)}),setTimeout(()=>{r({hostName:a,errorMessage:`Fetching remote diagnostics for '${a}' timed out.`})},5e3)}else r(void 0)})))).filter(t=>!!t)}getFolderURIs(c){const l=[],s=c.openedWorkspace;if((0,w.isSingleFolderWorkspaceIdentifier)(s))l.push(s.uri);else if((0,w.isWorkspaceIdentifier)(s)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(s.configPath);t&&t.folders.forEach(a=>{l.push(a.uri)})}return l}codeWindowToInfo(c){const l=this.getFolderURIs(c),s=(0,y.assertIsDefined)(c.win);return this.browserWindowToInfo(s,l,c.remoteAuthority)}browserWindowToInfo(c,l=[],s){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:l,remoteAuthority:s}}};v=he([ee(0,p.ILogService),ee(1,P.IWindowsMainService),ee(2,R.IURLService),ee(3,S.IWorkspacesManagementMainService),ee(4,i.IConfigurationService)],v),e.LaunchMainService=v}),define(Z[225],x([0,1,139,27,17,60,11,98,69,26,3,6,81,48,5,62,9,41]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0;const o="#1E1E1E";e.IIssueMainService=(0,d.createDecorator)("issueMainService");let c=class{constructor(t,r,a,h,u,m,I,A){this.machineId=t,this.userEnv=r,this.environmentMainService=a,this.launchMainService=h,this.logService=u,this.diagnosticsService=m,this.dialogMainService=I,this.nativeHostMainService=A,this._issueWindow=null,this._issueParentWindow=null,this._processExplorerWindow=null,this._processExplorerParentWindow=null,this.registerListeners()}registerListeners(){P.ipcMain.on("vscode:issueSystemInfoRequest",async t=>{Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]).then(r=>{const[a,h]=r;this.diagnosticsService.getSystemInfo(a,h).then(u=>{this.safeSend(t,"vscode:issueSystemInfoResponse",u)})})}),P.ipcMain.on("vscode:listProcesses",async t=>{const r=[];try{const a=await this.launchMainService.getMainProcessId();r.push({name:(0,p.localize)(0,null),rootProcess:await(0,E.listProcesses)(a)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(h=>{(0,S.isRemoteDiagnosticError)(h)?r.push({name:h.hostName,rootProcess:h}):h.processes&&r.push({name:h.hostName,rootProcess:h.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(t,"vscode:listProcessesResponse",r)}),P.ipcMain.on("vscode:issueReporterClipboard",t=>{const r={message:(0,p.localize)(1,null),type:"warning",buttons:[(0,p.localize)(2,null),(0,p.localize)(3,null)]};this._issueWindow&&this.dialogMainService.showMessageBox(r,this._issueWindow).then(a=>{this.safeSend(t,"vscode:issueReporterClipboardResponse",a.response===0)})}),P.ipcMain.on("vscode:issuePerformanceInfoRequest",t=>{this.getPerformanceInfo().then(r=>{this.safeSend(t,"vscode:issuePerformanceInfoResponse",r)})}),P.ipcMain.on("vscode:issueReporterConfirmClose",()=>{const t={message:(0,p.localize)(4,null),type:"warning",buttons:[(0,p.localize)(5,null),(0,p.localize)(6,null)]};this._issueWindow&&this.dialogMainService.showMessageBox(t,this._issueWindow).then(r=>{r.response===0&&this._issueWindow&&(this._issueWindow.destroy(),this._issueWindow=null)})}),P.ipcMain.on("vscode:workbenchCommand",(t,r)=>{const{id:a,from:h,args:u}=r;let m;switch(h){case"issueReporter":m=this._issueParentWindow;break;case"processExplorer":m=this._processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${h}`)}m&&m.webContents.send("vscode:runAction",{id:a,from:h,args:u})}),P.ipcMain.on("vscode:openExternal",(t,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),P.ipcMain.on("vscode:closeIssueReporter",t=>{this._issueWindow&&this._issueWindow.close()}),P.ipcMain.on("vscode:closeProcessExplorer",t=>{this._processExplorerWindow&&this._processExplorerWindow.close()}),P.ipcMain.on("vscode:windowsInfoRequest",t=>{this.launchMainService.getMainProcessInfo().then(r=>{this.safeSend(t,"vscode:windowsInfoResponse",r.windows)})})}safeSend(t,r,...a){t.sender.isDestroyed()||t.sender.send(r,...a)}async openReporter(t){if(!this._issueWindow&&(this._issueParentWindow=P.BrowserWindow.getFocusedWindow(),this._issueParentWindow)){const r=this.getWindowPosition(this._issueParentWindow,700,800);this._issueWindow=new P.BrowserWindow({fullscreen:!1,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:(0,p.localize)(7,null),backgroundColor:t.styles.backgroundColor||o,webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,v8CacheOptions:"bypassHeatCheck",enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,w.zoomLevelToZoomFactor)(t.zoomLevel),sandbox:!0,contextIsolation:!0}}),this._issueWindow.setMenuBarVisibility(!1);const a={};this.logService.trace("issueService#openReporter: opening issue reporter"),this._issueWindow.loadURL(this.getIssueReporterPath(t,a)),this._issueWindow.on("close",()=>this._issueWindow=null),this._issueParentWindow.on("closed",()=>{this._issueWindow&&(this._issueWindow.close(),this._issueWindow=null)})}this._issueWindow&&this._issueWindow.focus()}async openProcessExplorer(t){if(!this._processExplorerWindow&&(this._processExplorerParentWindow=P.BrowserWindow.getFocusedWindow(),this._processExplorerParentWindow)){const r=this.getWindowPosition(this._processExplorerParentWindow,800,500);this._processExplorerWindow=new P.BrowserWindow({skipTaskbar:!0,resizable:!0,fullscreen:!1,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,backgroundColor:t.styles.backgroundColor,title:(0,p.localize)(8,null),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,v8CacheOptions:"bypassHeatCheck",enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,w.zoomLevelToZoomFactor)(t.zoomLevel),sandbox:!0,contextIsolation:!0}}),this._processExplorerWindow.setMenuBarVisibility(!1);const a={appRoot:this.environmentMainService.appRoot,windowId:this._processExplorerWindow.id,userEnv:this.userEnv,machineId:this.machineId,data:t};this._processExplorerWindow.loadURL(l("vs/code/electron-sandbox/processExplorer/processExplorer.html",a)),this._processExplorerWindow.on("close",()=>this._processExplorerWindow=null),this._processExplorerParentWindow.on("close",()=>{this._processExplorerWindow&&(this._processExplorerWindow.close(),this._processExplorerWindow=null)})}this._processExplorerWindow&&this._processExplorerWindow.focus()}async getSystemStatus(){return Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]).then(t=>{const[r,a]=t;return this.diagnosticsService.getDiagnostics(r,a)})}getWindowPosition(t,r,a){let h;const u=P.screen.getAllDisplays();if(u.length===1)h=u[0];else{if(M.isMacintosh){const A=P.screen.getCursorScreenPoint();h=P.screen.getDisplayNearestPoint(A)}!h&&t&&(h=P.screen.getDisplayMatching(t.getBounds())),h||(h=P.screen.getPrimaryDisplay()||u[0])}const m={width:r,height:a},I=h.bounds;return m.x=I.x+I.width/2-m.width/2,m.y=I.y+I.height/2-m.height/2,I.width>0&&I.height>0&&(m.x<I.x&&(m.x=I.x),m.y<I.y&&(m.y=I.y),m.x>I.x+I.width&&(m.x=I.x),m.y>I.y+I.height&&(m.y=I.y),m.width>I.width&&(m.width=I.width),m.height>I.height&&(m.height=I.height)),m}getPerformanceInfo(){return new Promise(async(t,r)=>{Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]).then(a=>{const[h,u]=a;this.diagnosticsService.getPerformanceInfo(h,u).then(m=>{t(m)}).catch(m=>{this.logService.warn("issueService#getPerformanceInfo ",m.message),r(m)})})})}getIssueReporterPath(t,r){if(!this._issueWindow)throw new Error("Issue window has been disposed");const a={appRoot:this.environmentMainService.appRoot,windowId:this._issueWindow.id,machineId:this.machineId,userEnv:this.userEnv,data:t,features:r,disableExtensions:this.environmentMainService.disableExtensions,os:{type:R.type(),arch:R.arch(),release:R.release()},product:{nameShort:L.default.nameShort,version:L.default.darwinUniversalAssetId?`${L.default.version} (Universal)`:L.default.version,commit:L.default.commit,date:L.default.date,reportIssueUrl:L.default.reportIssueUrl,reportMarketplaceIssueUrl:L.default.reportMarketplaceIssueUrl}};return l("vs/code/electron-sandbox/issue/issueReporter.html",a)}};c=he([ee(2,i.IEnvironmentMainService),ee(3,n.ILaunchMainService),ee(4,f.ILogService),ee(5,S.IDiagnosticsService),ee(6,g.IDialogMainService),ee(7,v.INativeHostMainService)],c),e.IssueMainService=c;function l(s,t){const r=(0,b.parseArgs)(process.argv,b.OPTIONS),a=Object.assign(r,t);for(const h of Object.keys(a)){const u=h;(a[u]===void 0||a[u]===null||a[u]==="")&&delete a[u]}return y.FileAccess.asBrowserUri(s,H,!0).with({query:`config=${encodeURIComponent(JSON.stringify(a))}`}).toString(!0)}}),define(Z[226],x([0,1,27,8,144,169,4,7,11,26,6,24,60,17,62,2,3,32,28,49,47,190,73,31,48,38,194,18,96,16,9,53,25,41]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y,v,o,c,l,s,t,r,a,h,u,m,I,A,T,N,$,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ne;(function(Q){Q[Q.NONE=0]="NONE",Q[Q.LOADING=1]="LOADING",Q[Q.NAVIGATING=2]="NAVIGATING",Q[Q.READY=3]="READY"})(ne||(ne={}));let Y=class ft extends w.Disposable{constructor(B,z,U,W,O,D,k,F,_,C,j,G,K){super();this.logService=z,this.environmentMainService=U,this.fileService=W,this.configurationService=D,this.themeMainService=k,this.workspacesManagementMainService=F,this.backupMainService=_,this.telemetryService=C,this.dialogMainService=j,this.lifecycleMainService=G,this.nativeHostMainService=K,this._onWillLoad=this._register(new P.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new P.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new P.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new P.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this._readyState=0,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0;{const[V,J]=this.restoreWindowState(B.state);this.windowState=V,this.logService.trace("window#ctor: using window state",V);const re=this.windowState.mode===0||this.windowState.mode===3,ie=this.configurationService.getValue("window"),se={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:d.WindowMinimumSize.WIDTH,minHeight:d.WindowMinimumSize.HEIGHT,show:!re,title:g.default.nameLong,webPreferences:Object.assign({preload:T.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,v8CacheOptions:y.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:(0,d.zoomLevelToZoomFactor)(ie==null?void 0:ie.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0,contextIsolation:!0}:{nodeIntegration:!0})};y.browserCodeLoadingCacheStrategy&&this.logService.info(`window#ctor: using vscode-file protocol and V8 cache options: ${y.browserCodeLoadingCacheStrategy}`),y.isLinux?se.icon=(0,R.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):y.isWindows&&!this.environmentMainService.isBuilt&&(se.icon=(0,R.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.useNativeFullScreen()&&(se.fullscreenable=!1),y.isMacintosh&&(se.acceptFirstMouse=!0,(ie==null?void 0:ie.clickThroughInactive)===!1&&(se.acceptFirstMouse=!1));const me=y.isMacintosh&&(ie==null?void 0:ie.nativeTabs)===!0;me&&(se.tabbingIdentifier=g.default.nameShort);const le=(0,d.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(se.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,y.isMacintosh||(se.frame=!1)),this._win=new S.BrowserWindow(se),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),y.isMacintosh&&le&&this._win.setSheetOffset(22),y.isMacintosh&&J&&(!me||S.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ce=>typeof ce=="number")){const ce=this.windowState;this._win.setBounds({width:ce.width,height:ce.height,x:ce.x,y:ce.y})}re&&(this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show()),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,s.resolveMarketplaceHeaders)(g.default.version,this.environmentMainService,this.fileService,{get:V=>O.globalStorage.get(V),store:(V,J)=>O.globalStorage.set(V,J)}),this.registerListeners()}get config(){return this.currentConfig}get id(){return this._id}get win(){return this._win}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionDevelopmentPath)}get isExtensionTestHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var B;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((B=this.currentConfig)===null||B===void 0?void 0:B.debugId)}setRepresentedFilename(B){y.isMacintosh?this._win.setRepresentedFilename(B):this.representedFilename=B}getRepresentedFilename(){return y.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(B){y.isMacintosh&&this._win.setDocumentEdited(B),this.documentEdited=B}isDocumentEdited(){return y.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(B){y.isMacintosh&&(B==null?void 0:B.force)&&S.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.backupPath}get openedWorkspace(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.workspace}get remoteAuthority(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.remoteAuthority}setReady(){for(this._readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(B=>{if(this.isReady)return B(this);this.whenReadyCallbacks.push(B)})}get isReady(){return this._readyState===3}get whenClosedOrLoaded(){return new Promise(B=>{function z(){U.dispose(),W.dispose(),B()}const U=this.onDidClose(()=>z()),W=this.onWillLoad(()=>z())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(U,W)=>this.onWindowError(2,W)),this._win.webContents.on("did-fail-load",(U,W,O)=>this.onWindowError(3,O)),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const B=new Set([T.Schemas.file,T.Schemas.vscodeFileResource,T.Schemas.vscodeRemoteResource,"devtools"]);this._win.webContents.session.webRequest.onBeforeRequest((U,W)=>{const O=n.URI.parse(U.url);return O&&O.path.endsWith(".svg")&&!(B.has(O.scheme)||O.path.includes(T.Schemas.vscodeRemoteResource))?W({cancel:!0}):W({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((U,W)=>{const O=U.responseHeaders,D=O["content-type"]||O["Content-Type"];if(D&&Array.isArray(D)){const k=n.URI.parse(U.url);if(k&&k.path.endsWith(".svg")&&B.has(k.scheme))return O["Content-Type"]=["image/svg+xml"],W({cancel:!1,responseHeaders:O});if(!k.path.includes(T.Schemas.vscodeRemoteResource)&&D.some(F=>F.toLowerCase().includes("image/svg")))return W({cancel:!0})}return W({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this._readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),y.isMacintosh&&this._register(this.nativeHostMainService.onDidChangeDisplay(()=>{!this._win||!this.useNativeFullScreen()&&this.isFullScreen&&(this.setFullScreen(!1),this.setFullScreen(!0))})),this._win.on("maximize",U=>{this.currentConfig&&(this.currentConfig.maximized=!0),S.app.emit("browser-window-maximize",U,this._win)}),this._win.on("unmaximize",U=>{this.currentConfig&&(this.currentConfig.maximized=!1),S.app.emit("browser-window-unmaximize",U,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",$.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",$.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(U=>this.onDidDeleteUntitledWorkspace(U)));const z=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:z},async(U,W)=>{const O=await this.marketplaceHeadersPromise;W({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,O)})})}async onWindowError(B,z){switch(B){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof z=="string"?z:z==null?void 0:z.reason})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof z=="string"?z:z==null?void 0:z.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:B,reason:z&&typeof z!="string"?z.reason:void 0}),B===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const U=await this.dialogMainService.showMessageBox({title:g.default.nameLong,type:"warning",buttons:[(0,h.mnemonicButtonLabel)((0,L.localize)(0,null)),(0,h.mnemonicButtonLabel)((0,L.localize)(1,null)),(0,h.mnemonicButtonLabel)((0,L.localize)(2,null))],message:(0,L.localize)(3,null),detail:(0,L.localize)(4,null),noLink:!0},this._win);if(!this._win)return;U.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):U.response===2&&this.destroyWindow()}else if(B===2){let U;typeof z=="string"||!z?U=(0,L.localize)(5,null):U=(0,L.localize)(6,null,z.reason);const W=await this.dialogMainService.showMessageBox({title:g.default.nameLong,type:"warning",buttons:[(0,h.mnemonicButtonLabel)((0,L.localize)(7,null)),(0,h.mnemonicButtonLabel)((0,L.localize)(8,null))],message:U,detail:(0,L.localize)(9,null),noLink:!0},this._win);if(!this._win)return;W.response===0?this.reload():W.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(B){var z;((z=this.openedWorkspace)===null||z===void 0?void 0:z.id)===B.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const B=this.getMenuBarVisibility();B!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=B,this.setMenuBarVisibility(B));let z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(z==null?void 0:z.endsWith("/"))&&(z=z.substr(0,z.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.currentHttpProxy||U!==this.currentNoProxy)){this.currentHttpProxy=z,this.currentNoProxy=U;const W=z||"",O=U?`${U},<local>`:"<local>";this.logService.trace(`Setting proxy to '${W}', bypassing '${O}'`),this._win.webContents.session.setProxy({proxyRules:W,proxyBypassRules:O,pacScript:""})}}addTabbedWindow(B){y.isMacintosh&&B.win&&this._win.addTabbedWindow(B.win)}load(B,{isReload:z,disableExtensions:U}=Object.create(null)){var W,O;const D=(O=(W=this.currentConfig)!==null&&W!==void 0?W:this.pendingLoadConfig)===null||O===void 0?void 0:O.userEnv;D&&(0,N.isLaunchedFromCli)(D)&&!(0,N.isLaunchedFromCli)(B.userEnv)&&(B.userEnv=Object.assign(Object.assign({},D),B.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(B.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),this._readyState===0?this.currentConfig=B:(this.pendingLoadConfig=B,this._readyState=2);const k=Object.assign({},B);U!==void 0&&(k["disable-extensions"]=U),this.isDocumentEdited()&&(!z||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),z||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(g.default.nameLong)),(0,b.mark)("code/willOpenNewWindow"),this._win.loadURL(this.getUrl(k)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:k.workspace})}async reload(B){const z=Object.assign({},this.currentConfig);z.workspace=await this.validateWorkspace(z),delete z.filesToOpenOrCreate,delete z.filesToDiff,delete z.filesToWait,this.isExtensionDevelopmentHost&&B&&(z.verbose=B.verbose,z.debugId=B.debugId,z["inspect-extensions"]=B["inspect-extensions"],z["inspect-brk-extensions"]=B["inspect-brk-extensions"],z["extensions-dir"]=B["extensions-dir"]),z.isInitialStartup=!1,this.load(z,{isReload:!0,disableExtensions:B==null?void 0:B["disable-extensions"]})}async validateWorkspace(B){if((0,o.isWorkspaceIdentifier)(B.workspace)){const z=B.workspace.configPath;if(z.scheme===T.Schemas.file&&!await this.fileService.exists(z))return}else if((0,o.isSingleFolderWorkspaceIdentifier)(B.workspace)){const z=B.workspace.uri;if(z.scheme===T.Schemas.file&&!await this.fileService.exists(z))return}return B.workspace}getUrl(B){var z;B.windowId=this._win.id,B.sessionId=`window:${this._win.id}`,B.logLevel=this.logService.getLevel(),B.logsPath=this.environmentMainService.logsPath;const U=this.configurationService.getValue("window"),W=U==null?void 0:U.zoomLevel;typeof W=="number"&&(B.zoomLevel=W),B.fullscreen=this.isFullScreen,B.colorScheme={dark:S.nativeTheme.shouldUseDarkColors,highContrast:S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors},B.autoDetectHighContrast=(z=U==null?void 0:U.autoDetectHighContrast)!==null&&z!==void 0?z:!0,B.accessibilitySupport=S.app.accessibilitySupportEnabled,B.maximized=this._win.isMaximized(),B.perfMarks=(0,b.getMarks)(),B.partsSplashPath=(0,R.join)(this.environmentMainService.userDataPath,"rapid_render.json"),B.os={release:(0,p.release)()};const O=(0,E.parseArgs)(process.argv,E.OPTIONS),D=Object.assign(O,B);for(const F in D){const _=D[F];(_==null||_===""||_===!1)&&delete D[F]}let k=this.doGetUrl(D);return k.length>ft.MAX_URL_LENGTH&&(this.logService.warn("Application URL exceeds maximum of 2MB and was shortened."),k=this.doGetUrl(Object.assign(Object.assign({},D),{userEnv:void 0})),k.length>ft.MAX_URL_LENGTH&&this.logService.error("Application URL exceeds maximum of 2MB and cannot be loaded.")),k}doGetUrl(B){let z;return this.environmentMainService.sandbox?z="vs/code/electron-sandbox/workbench/workbench.html":z="vs/code/electron-browser/workbench/workbench.html",T.FileAccess.asBrowserUri(z,H).with({query:`config=${encodeURIComponent(JSON.stringify(B))}`}).toString(!0)}serializeWindowState(){if(!this._win)return(0,v.defaultWindowState)();if(this.isFullScreen){let U;try{U=S.screen.getDisplayMatching(this.getBounds())}catch(D){}const W=(0,v.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.windowState.width||W.width,height:this.windowState.height||W.height,x:this.windowState.x||0,y:this.windowState.y||0}}const B=Object.create(null);let z;if(!y.isMacintosh&&this._win.isMaximized()?z=0:z=1,z===0?B.mode=0:B.mode=1,z===1||z===0){let U;z===1?U=this.getBounds():U=this._win.getNormalBounds(),B.x=U.x,B.y=U.y,B.width=U.width,B.height=U.height}return B}restoreWindowState(B){let z=!1;if(B)try{const U=S.screen.getAllDisplays();z=U.length>1,B=this.validateWindowState(B,U)}catch(U){this.logService.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return[B||(0,v.defaultWindowState)(),z]}validateWindowState(B,z){var U,W;if(this.logService.trace(`window#validateWindowState: validating window state on ${z.length} display(s)`,B),typeof B.x!="number"||typeof B.y!="number"||typeof B.width!="number"||typeof B.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(B.width<=0||B.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(z.length===1){const F=this.getWorkingArea(z[0]);if(F){this.logService.trace("window#validateWindowState: 1 monitor working area",F);function O(){!B||typeof B.x!="number"||typeof B.y!="number"||!F||(B.x<F.x&&(B.x=F.x),B.y<F.y&&(B.y=F.y))}O(),B.width>F.width&&(B.width=F.width),B.height>F.height&&(B.height=F.height),B.x>F.x+F.width-128&&(B.x=F.x+F.width-B.width),B.y>F.y+F.height-128&&(B.y=F.y+F.height-B.height),O()}return B}if(B.display&&B.mode===3){const F=z.find(_=>_.id===B.display);if(F&&typeof((U=F.bounds)===null||U===void 0?void 0:U.x)=="number"&&typeof((W=F.bounds)===null||W===void 0?void 0:W.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const _=(0,v.defaultWindowState)(3);return _.x=F.bounds.x,_.y=F.bounds.y,_}}let D,k;try{D=S.screen.getDisplayMatching({x:B.x,y:B.y,width:B.width,height:B.height}),k=this.getWorkingArea(D)}catch(F){}if(D&&k&&B.x+B.width>k.x&&B.y+B.height>k.y&&B.x<k.x+k.width&&B.y<k.y+k.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",k),B}getWorkingArea(B){if(B.workArea.width>0&&B.workArea.height>0)return B.workArea;if(B.bounds.width>0&&B.bounds.height>0)return B.bounds}getBounds(){const[B,z]=this._win.getPosition(),[U,W]=this._win.getSize();return{x:B,y:z,width:U,height:W}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(B){this.useNativeFullScreen()?this.setNativeFullScreen(B):this.setSimpleFullScreen(B),this.sendWhenReady(B?"vscode:enterFullScreen":"vscode:leaveFullScreen",$.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(B){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(B)}setSimpleFullScreen(B){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(B),this._win.webContents.focus()}useNativeFullScreen(){const B=this.configurationService.getValue("window");return!B||typeof B.nativeFullScreen!="boolean"||B.nativeTabs?!0:B.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let B=(0,d.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(B)<0&&(B="classic"),B}setMenuBarVisibility(B,z=!0){y.isMacintosh||(B==="toggle"&&z&&this.send("vscode:showInfoMessage",(0,L.localize)(10,null)),B==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(B)}):this.doSetMenuBarVisibility(B))}doSetMenuBarVisibility(B){const z=this.isFullScreen;switch(B){case"classic":this._win.setMenuBarVisibility(!z),this._win.autoHideMenuBar=z;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(y.isMacintosh)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(B,z,...U){this.isReady?this.send(B,...U):this.ready().then(()=>{z.isCancellationRequested||this.send(B,...U)})}send(B,...z){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${B} for window that is destroyed`);return}this._win.webContents.send(B,...z)}}updateTouchBar(B){!y.isMacintosh||this.touchBarGroups.forEach((z,U)=>{const W=B[U];z.segments=this.createTouchBarGroupSegments(W)})}createTouchBar(){if(!!y.isMacintosh){for(let B=0;B<10;B++){const z=this.createTouchBarGroup();this.touchBarGroups.push(z)}this._win.setTouchBar(new S.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(B=[]){const z=this.createTouchBarGroupSegments(B),U=new S.TouchBar.TouchBarSegmentedControl({segments:z,mode:"buttons",segmentStyle:"automatic",change:W=>{this.sendWhenReady("vscode:runAction",$.CancellationToken.None,{id:U.segments[W].id,from:"touchbar"})}});return U}createTouchBarGroupSegments(B=[]){return B.map(U=>{var W,O;let D;U.icon&&!u.ThemeIcon.isThemeIcon(U.icon)&&((O=(W=U.icon)===null||W===void 0?void 0:W.dark)===null||O===void 0?void 0:O.scheme)===T.Schemas.file&&(D=S.nativeImage.createFromPath(n.URI.revive(U.icon.dark).fsPath),D.isEmpty()&&(D=void 0));let k;return typeof U.title=="string"?k=U.title:k=U.title.value,{id:U.id,label:D?void 0:k,icon:D}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};Y.MAX_URL_LENGTH=2*A.ByteSize.MB,Y=he([ee(1,M.ILogService),ee(2,i.IEnvironmentMainService),ee(3,A.IFileService),ee(4,I.IStorageMainService),ee(5,f.IConfigurationService),ee(6,t.IThemeMainService),ee(7,c.IWorkspacesManagementMainService),ee(8,l.IBackupMainService),ee(9,r.ITelemetryService),ee(10,a.IDialogMainService),ee(11,m.ILifecycleMainService),ee(12,X.INativeHostMainService)],Y),e.CodeWindow=Y}),define(Z[63],x([0,1,147,34,37,11,6,38,4,3,28,49,10,15,7,9,26,23,18,5,2]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y,v,o,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,c.createDecorator)("workspacesHistoryMainService");let s=class ze extends l.Disposable{constructor(I,A,T,N,$){super();this.stateService=I,this.logService=A,this.workspacesManagementMainService=T,this.environmentMainService=N,this.lifecycleMainService=$,this._onDidChangeRecentlyOpened=this._register(new S.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new E.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(I=>this.addRecentlyOpened([{workspace:I.workspace}])))}handleWindowsJumpList(){!i.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(I){const A=[],T=[];for(let N of I)if((0,M.isRecentWorkspace)(N))!this.workspacesManagementMainService.isUntitledWorkspace(N.workspace)&&a(A,N.workspace)===-1&&A.push(N);else if((0,M.isRecentFolder)(N))h(A,N.folderUri)===-1&&A.push(N);else{const $=u(T,N.fileUri)>=0,X=N.fileUri.scheme===w.Schemas.file&&ze.COMMON_FILES_FILTER.indexOf((0,g.basename)(N.fileUri))>=0;!$&&!X&&(T.push(N),i.isWindows&&N.fileUri.scheme===w.Schemas.file&&b.app.addRecentDocument(N.fileUri.fsPath))}this.addEntriesFromStorage(A,T),A.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(A.length=ze.MAX_TOTAL_RECENT_ENTRIES),T.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(T.length=ze.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:A,files:T}),this._onDidChangeRecentlyOpened.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(I){const A=X=>{const ne=r(X);for(const Y of I)if(g.extUriBiasedIgnorePathCase.isEqual(Y,ne))return!1;return!0},T=this.getRecentlyOpened(),N=T.workspaces.filter(A),$=T.files.filter(A);(N.length!==T.workspaces.length||$.length!==T.files.length)&&(this.saveRecentlyOpened({files:$,workspaces:N}),this._onDidChangeRecentlyOpened.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!!i.isMacintosh){b.app.clearRecentDocuments();const I=this.getRecentlyOpened(),A=[];let T=0;for(let $=0;$<I.workspaces.length&&T<ze.MAX_MACOS_DOCK_RECENT_WORKSPACES;$++){const X=r(I.workspaces[$]);if(X.scheme===w.Schemas.file){const ne=(0,g.originalFSPath)(X);await(0,v.exists)(ne)&&(A.push(ne),T++)}}const N=[];for(let $=0;$<I.files.length&&T<ze.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;$++){const X=r(I.files[$]);if(X.scheme===w.Schemas.file){const ne=(0,g.originalFSPath)(X);if(ze.COMMON_FILES_FILTER.includes((0,g.basename)(X))||A.includes(ne))continue;await(0,v.exists)(ne)&&(N.push(ne),T++)}}N.reverse().forEach($=>b.app.addRecentDocument($)),A.reverse().forEach($=>b.app.addRecentDocument($))}}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),b.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(I){var A,T;const N=[],$=[],X=(A=I==null?void 0:I.config)===null||A===void 0?void 0:A.workspace;(0,M.isWorkspaceIdentifier)(X)&&!this.workspacesManagementMainService.isUntitledWorkspace(X)?N.push({workspace:X}):(0,M.isSingleFolderWorkspaceIdentifier)(X)&&N.push({folderUri:X.uri});const ne=(T=I==null?void 0:I.config)===null||T===void 0?void 0:T.filesToOpenOrCreate;if(ne)for(let Y of ne){const Q=Y.fileUri;Q&&u($,Q)===-1&&$.push({fileUri:Q})}return this.addEntriesFromStorage(N,$),{workspaces:N,files:$}}addEntriesFromStorage(I,A){let T=this.getRecentlyOpenedFromStorage();for(let N of T.workspaces){let $=(0,M.isRecentFolder)(N)?h(I,N.folderUri):a(I,N.workspace);$>=0?I[$].label=I[$].label||N.label:I.push(N)}for(let N of T.files){let $=u(A,N.fileUri);$>=0?A[$].label=A[$].label||N.label:A.push(N)}}getRecentlyOpenedFromStorage(){const I=this.stateService.getItem(ze.recentlyOpenedStorageKey);return(0,M.restoreRecentlyOpened)(I,this.logService)}saveRecentlyOpened(I){const A=(0,M.toStoreData)(I);this.stateService.setItem(ze.recentlyOpenedStorageKey,A)}updateWindowsJumpList(){if(!!i.isWindows){const I=[];if(I.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(0,null),description:(0,p.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let A=[];for(let $ of b.app.getJumpListSettings().removedItems){const X=$.args;if(X){const ne=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(X);ne&&A.push(d.URI.parse(ne[2]))}}this.removeRecentlyOpened(A);let T=!1;const N=(0,R.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map($=>{const X=(0,M.isRecentWorkspace)($)?$.workspace:$.folderUri,{title:ne,description:Y}=this.getWindowsJumpListLabel(X,$.label);let Q;return d.URI.isUri(X)?Q=`--folder-uri "${X.toString()}"`:(T=!0,Q=`--file-uri "${X.configPath.toString()}"`),{type:"task",title:ne.substr(0,255),description:Y.substr(0,255),program:process.execPath,args:Q,iconPath:"explorer.exe",iconIndex:0}}));N.length>0&&I.push({type:"custom",name:T?(0,p.localize)(2,null):(0,p.localize)(3,null),items:N})}I.push({type:"recent"});try{b.app.setJumpList(I)}catch(A){this.logService.warn("updateWindowsJumpList#setJumpList",A)}}}getWindowsJumpListLabel(I,A){if(A)return{title:(0,n.splitName)(A).name,description:A};if(d.URI.isUri(I))return{title:(0,g.basename)(I),description:t(I)};if(g.extUriBiasedIgnorePathCase.isEqualOrParent(I.configPath,this.environmentMainService.userHome))return{title:(0,p.localize)(4,null),description:""};let T=(0,g.basename)(I.configPath);return T.endsWith(M.WORKSPACE_EXTENSION)&&(T=T.substr(0,T.length-M.WORKSPACE_EXTENSION.length-1)),{title:(0,p.localize)(5,null,T),description:t(I.configPath)}}};s.MAX_TOTAL_RECENT_ENTRIES=100,s.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,s.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,s.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],s.recentlyOpenedStorageKey="openedPathsList",s=he([ee(0,L.IStateService),ee(1,P.ILogService),ee(2,f.IWorkspacesManagementMainService),ee(3,y.IEnvironmentMainService),ee(4,o.ILifecycleMainService)],s),e.WorkspacesHistoryMainService=s;function t(m){return m.scheme==="file"?(0,n.normalizeDriveLetter)(m.fsPath):m.toString()}function r(m){return(0,M.isRecentFolder)(m)?m.folderUri:(0,M.isRecentFile)(m)?m.fileUri:m.workspace.configPath}function a(m,I){return m.findIndex(A=>(0,M.isRecentWorkspace)(A)&&A.workspace.id===I.id)}function h(m,I){return m.findIndex(A=>(0,M.isRecentFolder)(A)&&g.extUriBiasedIgnorePathCase.isEqual(A.folderUri,I))}function u(m,I){return m.findIndex(A=>g.extUriBiasedIgnorePathCase.isEqual(A.fileUri,I))}}),define(Z[227],x([0,1,140,3,26,11,62,24,31,40,17,10,6,38,32,63,174,7,37,18,41,25]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y,v,o,c,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class gt{constructor(u,m,I,A,T,N,$,X,ne,Y){this.updateService=u,this.configurationService=m,this.windowsMainService=I,this.environmentMainService=A,this.telemetryService=T,this.workspacesHistoryMainService=N,this.stateService=$,this.lifecycleMainService=X,this.logService=ne,this.nativeHostMainService=Y,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new f.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new f.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(R.isMacintosh||(0,P.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const u=this.stateService.getItem(gt.lastKnownMenubarStorageKey);u&&(u.menus&&(this.menubarMenus=u.menus),u.keybindings&&(this.keybindings=u.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(N,$,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:$==null?void 0:$.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(N,$,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:$==null?void 0:$.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(N,$,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(N,$,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const u=M.default.twitterUrl;u&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(u,"openTwitterUrl"));const m=M.default.requestFeatureUrl;m&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(m,"openUserVoiceUrl"));const I=M.default.reportIssueUrl;I&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(I,"openReportIssues"));const A=M.default.licenseUrl;A&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(R.language){const N=A.indexOf("?")>0?"&":"?";this.openUrl(`${A}${N}lang=${R.language}`,"openLicenseUrl")}else this.openUrl(A,"openLicenseUrl")});const T=M.default.privacyStatementUrl;T&&A&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(R.language){const N=A.indexOf("?")>0?"&":"?";this.openUrl(`${T}${N}lang=${R.language}`,"openPrivacyStatement")}else this.openUrl(T,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(u=>this.onDidChangeWindowsCount(u)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let u=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof u!="boolean"&&(u=!0),u}get currentEnableNativeTabs(){if(!R.isMacintosh)return!1;let u=this.configurationService.getValue("window.nativeTabs");return typeof u!="boolean"&&(u=!1),u}updateMenu(u,m){this.menubarMenus=u.menus,this.keybindings=u.keybindings,this.stateService.setItem(gt.lastKnownMenubarStorageKey,u),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(u){!R.isMacintosh||(u.oldCount===0&&u.newCount>0||u.oldCount>0&&u.newCount===0)&&(this.closedLastWindow=u.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!R.isMacintosh||(this.noActiveWindow=!b.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const u=b.Menu.getApplicationMenu();if(u&&this.oldMenus.push(u),Object.keys(this.menubarMenus).length===0){b.Menu.setApplicationMenu(R.isMacintosh?new b.Menu:null);return}const m=new b.Menu;let I;if(R.isMacintosh){const C=new b.Menu;I=new b.MenuItem({label:M.default.nameShort,submenu:C}),this.setMacApplicationMenu(C),m.append(I)}if(R.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const C=new b.Menu;C.append(new b.MenuItem({label:this.mnemonicLabel(p.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),b.app.dock.setMenu(C)}const A=new b.Menu,T=new b.MenuItem({label:this.mnemonicLabel(p.localize(1,null)),submenu:A});this.setMenuById(A,"File"),m.append(T);const N=new b.Menu,$=new b.MenuItem({label:this.mnemonicLabel(p.localize(2,null)),submenu:N});this.setMenuById(N,"Edit"),m.append($);const X=new b.Menu,ne=new b.MenuItem({label:this.mnemonicLabel(p.localize(3,null)),submenu:X});this.setMenuById(X,"Selection"),m.append(ne);const Y=new b.Menu,Q=new b.MenuItem({label:this.mnemonicLabel(p.localize(4,null)),submenu:Y});this.setMenuById(Y,"View"),m.append(Q);const B=new b.Menu,z=new b.MenuItem({label:this.mnemonicLabel(p.localize(5,null)),submenu:B});this.setMenuById(B,"Go"),m.append(z);const U=new b.Menu,W=new b.MenuItem({label:this.mnemonicLabel(p.localize(6,null)),submenu:U});this.setMenuById(U,"Run"),m.append(W);const O=new b.Menu,D=new b.MenuItem({label:this.mnemonicLabel(p.localize(7,null)),submenu:O});this.setMenuById(O,"Terminal"),m.append(D);let k;if(this.shouldDrawMenu("Window")){const C=new b.Menu;k=new b.MenuItem({label:this.mnemonicLabel(p.localize(8,null)),submenu:C,role:"window"}),this.setMacWindowMenu(C)}k&&m.append(k);const F=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(p.localize(9,null)),submenu:F,role:"help"});this.setMenuById(F,"Help"),m.append(_),m.items&&m.items.length>0?b.Menu.setApplicationMenu(m):b.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(u){const m=this.createMenuItem(p.localize(10,null,M.default.nameLong),"workbench.action.showAboutDialog"),I=this.getUpdateMenuItems();let A;if(this.shouldDrawMenu("Preferences")){const B=new b.Menu;this.setMenuById(B,"Preferences"),A=new b.MenuItem({label:this.mnemonicLabel(p.localize(11,null)),submenu:B})}const T=new b.Menu,N=new b.MenuItem({label:p.localize(12,null),role:"services",submenu:T}),$=new b.MenuItem({label:p.localize(13,null,M.default.nameLong),role:"hide",accelerator:"Command+H"}),X=new b.MenuItem({label:p.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ne=new b.MenuItem({label:p.localize(15,null),role:"unhide"}),Y=new b.MenuItem(this.likeAction("workbench.action.quit",{label:p.localize(16,null,M.default.nameLong),click:()=>{const B=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!b.BrowserWindow.getFocusedWindow()||(B==null?void 0:B.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),Q=[m];Q.push(...I),A&&Q.push(a(),A),Q.push(a(),N,a(),$,X,ne,a(),Y),Q.forEach(B=>u.append(B))}shouldDrawMenu(u){if(!R.isMacintosh&&(0,P.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(u){case"File":case"Help":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[u];case"Window":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[u]}}setMenu(u,m){m.forEach(I=>{if((0,y.isMenubarMenuItemSeparator)(I))u.append(a());else if((0,y.isMenubarMenuItemSubmenu)(I)){const A=new b.Menu,T=new b.MenuItem({label:this.mnemonicLabel(I.label),submenu:A});this.setMenu(A,I.submenu.items),u.append(T)}else(0,y.isMenubarMenuItemRecentAction)(I)?u.append(this.createOpenRecentMenuItem(I)):(0,y.isMenubarMenuItemAction)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(u),R.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[I.id]?u.append(new b.MenuItem(this.likeAction(I.id,{label:this.mnemonicLabel(I.label),click:this.fallbackMenuHandlers[I.id]}))):u.append(this.createMenuItem(I.label,I.id,!1,I.checked)):u.append(this.createMenuItem(I.label,I.id,I.enabled!==!1,!!I.checked)):u.append(this.createMenuItem(I.label,I.id,I.enabled!==!1,!!I.checked)))})}setMenuById(u,m){this.menubarMenus&&this.menubarMenus[m]&&this.setMenu(u,this.menubarMenus[m].items)}insertCheckForUpdatesItems(u){const m=this.getUpdateMenuItems();m.length&&(m.forEach(I=>u.append(I)),u.append(a()))}createOpenRecentMenuItem(u){const m=v.URI.revive(u.uri),I=u.id,A=I==="openRecentFile"?{fileUri:m}:I==="openRecentWorkspace"?{workspaceUri:m}:{folderUri:m};return new b.MenuItem(this.likeAction(I,{label:u.label,click:(T,N,$)=>{const X=this.isOptionClick($);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[A],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:u.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([m])}},!1))}isOptionClick(u){return!!(u&&(!R.isMacintosh&&(u.ctrlKey||u.shiftKey)||R.isMacintosh&&(u.metaKey||u.altKey)))}createRoleMenuItem(u,m,I){const A={label:this.mnemonicLabel(u),role:I,enabled:!0};return new b.MenuItem(this.withKeybinding(m,A))}setMacWindowMenu(u){const m=new b.MenuItem({label:p.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),I=new b.MenuItem({label:p.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),A=new b.MenuItem({label:p.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),T=this.createMenuItem(p.localize(20,null),"workbench.action.switchWindow"),N=[];this.currentEnableNativeTabs&&(N.push(a()),N.push(this.createMenuItem(p.localize(21,null),"workbench.action.newWindowTab")),N.push(this.createRoleMenuItem(p.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),N.push(this.createRoleMenuItem(p.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),N.push(this.createRoleMenuItem(p.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),N.push(this.createRoleMenuItem(p.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[m,I,a(),T,...N,a(),A].forEach($=>u.append($))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new b.MenuItem({label:this.mnemonicLabel(p.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate");const m=this.windowsMainService.getLastActiveWindow(),I=m&&`window:${m.id}`;this.updateService.checkForUpdates(I)},0)})];case"checking for updates":return[new b.MenuItem({label:p.localize(27,null),enabled:!1})];case"available for download":return[new b.MenuItem({label:this.mnemonicLabel(p.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new b.MenuItem({label:p.localize(29,null),enabled:!1})];case"downloaded":return[new b.MenuItem({label:this.mnemonicLabel(p.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new b.MenuItem({label:p.localize(31,null),enabled:!1})];case"ready":return[new b.MenuItem({label:this.mnemonicLabel(p.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(u,m,I,A){const T=this.mnemonicLabel(u),N=typeof m=="function"?m:(Q,B,z)=>{const U=Q?Q.userSettingsLabel:null;let W=m;Array.isArray(m)&&(W=this.isOptionClick(z)?m[1]:m[0]),U&&z.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:U}):this.runActionInRenderer({type:"commandId",commandId:W})},$=typeof I=="boolean"?I:this.windowsMainService.getWindowCount()>0,X=typeof A=="boolean"?A:!1,ne={label:T,click:N,enabled:$};X&&(ne.type="checkbox",ne.checked=X);let Y;return typeof m=="string"?Y=m:Array.isArray(m)&&(Y=m[0]),R.isMacintosh&&(Y==="editor.action.clipboardCutAction"?ne.role="cut":Y==="editor.action.clipboardCopyAction"?ne.role="copy":Y==="editor.action.clipboardPasteAction"&&(ne.role="paste"),Y==="undo"?ne.click=this.makeContextAwareClickHandler(N,{inDevTools:Q=>Q.undo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("undo:")}):Y==="redo"?ne.click=this.makeContextAwareClickHandler(N,{inDevTools:Q=>Q.redo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("redo:")}):Y==="editor.action.selectAll"&&(ne.click=this.makeContextAwareClickHandler(N,{inDevTools:Q=>Q.selectAll(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("selectAll:")}))),new b.MenuItem(this.withKeybinding(Y,ne))}makeContextAwareClickHandler(u,m){return(I,A,T)=>{const N=b.BrowserWindow.getFocusedWindow();if(!N)return m.inNoWindow();if(N.webContents.isDevToolsFocused()&&N.webContents.devToolsWebContents)return m.inDevTools(N.webContents.devToolsWebContents);u(I,A||N,T)}}runActionInRenderer(u){let m=b.BrowserWindow.getFocusedWindow();if(!m){const A=this.windowsMainService.getLastActiveWindow();(A==null?void 0:A.isMinimized())&&(m=A.win)}const I=m?this.windowsMainService.getWindowById(m.id):void 0;if(I){if(this.logService.trace("menubar#runActionInRenderer",u),R.isMacintosh&&!this.environmentMainService.isBuilt&&!I.isReady&&(u.type==="commandId"&&u.commandId==="workbench.action.toggleDevTools"||u.type!=="commandId"&&u.userSettingsLabel==="alt+cmd+i"))return;if(u.type==="commandId"){const A={id:u.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,A)}else{const A={userSettingsLabel:u.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,A)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",u)}withKeybinding(u,m){const I=typeof u=="string"?this.keybindings[u]:void 0;if(I==null?void 0:I.label){if(I.isNative!==!1)m.accelerator=I.label,m.userSettingsLabel=I.userSettingsLabel;else if(typeof m.label=="string"){const A=m.label.indexOf("[");A>=0?m.label=`${m.label.substr(0,A)} [${I.label}]`:m.label=`${m.label} [${I.label}]`}}else m.accelerator=void 0;return m}likeAction(u,m,I=!m.accelerator){I&&(m=this.withKeybinding(u,m));const A=m.click;return m.click=(T,N,$)=>{this.reportMenuActionTelemetry(u),A&&A(T,N,$)},m}openUrl(u,m){this.nativeHostMainService.openExternal(void 0,u),this.reportMenuActionTelemetry(m)}reportMenuActionTelemetry(u){this.telemetryService.publicLog2("workbenchActionExecuted",{id:u,from:t})}mnemonicLabel(u){return(0,g.mnemonicMenuLabel)(u,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=he([ee(0,i.IUpdateService),ee(1,n.IConfigurationService),ee(2,d.IWindowsMainService),ee(3,L.IEnvironmentMainService),ee(4,S.ITelemetryService),ee(5,w.IWorkspacesHistoryMainService),ee(6,o.IStateService),ee(7,c.ILifecycleMainService),ee(8,E.ILogService),ee(9,l.INativeHostMainService)],r),e.Menubar=r;function a(){return new b.MenuItem({type:"separator"})}}),define(Z[228],x([0,1,227,6,5,18]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,L.createDecorator)("menubarMainService");let P=class{constructor(S,i,M){this.instantiationService=S,this.lifecycleMainService=i,this.logService=M,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(p.Menubar)}async updateMenubar(S,i){this.logService.trace("menubarService#updateMenubar",S),(await this.menubar).updateMenu(i,S)}};P=he([ee(0,L.IInstantiationService),ee(1,b.ILifecycleMainService),ee(2,R.ILogService)],P),e.MenubarMainService=P}),define(Z[229],x([0,1,22,8,145,34,47,26,37,226,11,18,24,6,62,97,4,17,63,3,28,5,9,7,15,71,210,49,42,2,48,13,29,38,25,16]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y,v,o,c,l,s,t,r,a,h,u,m,I,A,T,N,$,X,ne,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function Q(U){return(0,l.isWorkspaceIdentifier)(U==null?void 0:U.workspace)}function B(U){return(0,l.isSingleFolderWorkspaceIdentifier)(U==null?void 0:U.workspace)}let z=class Qe extends A.Disposable{constructor(W,O,D,k,F,_,C,j,G,K,V,J,re){super();this.machineId=W,this.initialUserEnv=O,this.logService=D,this.stateService=k,this.environmentMainService=F,this.lifecycleMainService=_,this.backupMainService=C,this.configurationService=j,this.workspacesHistoryMainService=G,this.workspacesManagementMainService=K,this.instantiationService=V,this.dialogMainService=J,this.fileService=re,this._onDidOpenWindow=this._register(new y.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new y.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new y.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new y.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new u.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.lifecycleMainService.when(2).then(()=>this.registerListeners())}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(W=>this._onDidSignalReadyWindow.fire(W.window)))}openEmptyWindow(W,O){let D=this.environmentMainService.args;const k=(O==null?void 0:O.remoteAuthority)||void 0,F=!0,_=O==null?void 0:O.forceReuseWindow,C=!_;return this.open(Object.assign(Object.assign({},W),{cli:D,forceEmpty:F,forceNewWindow:C,forceReuseWindow:_,remoteAuthority:k}))}open(W){this.logService.trace("windowsManager#open"),W.addMode&&(W.initialStartup||!this.getLastActiveWindow())&&(W.addMode=!1);const O=[],D=[],k=[],F=[],_=[];let C,j=0;const G=this.getPathsToOpen(W);this.logService.trace("windowsManager#open pathsToOpen",G);for(const ie of G)B(ie)?W.addMode?O.push(ie):D.push(ie):Q(ie)?k.push(ie):ie.fileUri?(C||(C={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ie.remoteAuthority}),C.filesToOpenOrCreate.push(ie)):ie.backupPath?_.push({backupFolder:(0,R.basename)(ie.backupPath),remoteAuthority:ie.remoteAuthority}):j++;W.diffMode&&(C==null?void 0:C.filesToOpenOrCreate.length)===2&&(C.filesToDiff=C.filesToOpenOrCreate,C.filesToOpenOrCreate=[]),C&&W.waitMarkerFileURI&&(C.filesToWait={paths:[...C.filesToDiff,...C.filesToOpenOrCreate],waitMarkerFileUri:W.waitMarkerFileURI}),W.initialStartup?(F.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),k.push(...F),_.push(...this.backupMainService.getEmptyWindowBackupPaths())):_.length=0;const{windows:K,filesOpenedInWindow:V}=this.doOpen(W,k,D,_,j,C,O);if(this.logService.trace(`windowsManager#open used window count ${K.length} (workspacesToOpen: ${k.length}, foldersToOpen: ${D.length}, emptyToRestore: ${_.length}, emptyToOpen: ${j})`),K.length>1)if(V)V.focus();else{const ie=this.windowsStateHandler.state.lastActiveWindow&&!W.forceEmpty&&!W.cli._.length&&!W.cli["file-uri"]&&!W.cli["folder-uri"]&&!(W.urisToOpen&&W.urisToOpen.length);let se=!0,me=!0;if(ie){const le=K.filter(ce=>this.windowsStateHandler.state.lastActiveWindow&&ce.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);le.length&&(le[0].focus(),se=!1,me=!1)}if(se)for(let le=K.length-1;le>=0;le--){const ce=K[le];if(!(ce.openedWorkspace&&F.some(ge=>ce.openedWorkspace&&ge.workspace.id===ce.openedWorkspace.id)||ce.backupPath&&_.some(ge=>ce.backupPath&&ge.backupFolder===(0,R.basename)(ce.backupPath)))){ce.focus(),me=!1;break}}me&&K[K.length-1].focus()}const J=C&&C.filesToDiff.length>0;if(!K.some(ie=>ie.isExtensionDevelopmentHost)&&!J&&!W.noRecentEntry){const ie=[];for(const se of G)Q(se)?ie.push({label:se.label,workspace:se.workspace,remoteAuthority:se.remoteAuthority}):B(se)?ie.push({label:se.label,folderUri:se.workspace.uri,remoteAuthority:se.remoteAuthority}):se.fileUri&&ie.push({label:se.label,fileUri:se.fileUri,remoteAuthority:se.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ie)}const re=W.waitMarkerFileURI;return W.context===0&&re&&K.length===1&&K[0]&&K[0].whenClosedOrLoaded.then(()=>this.fileService.del(re),()=>{}),K}doOpen(W,O,D,k,F,_,C){const j=[];let G;function K(le,ce){j.push(le),ce&&(G=le,_=void 0)}let{openFolderInNewWindow:V,openFilesInNewWindow:J}=this.shouldOpenNewWindow(W);if(!W.initialStartup&&C.length>0){const le=C[0].remoteAuthority,ce=this.getLastActiveWindowForAuthority(le);ce&&K(this.doAddFoldersToExistingWindow(ce,C.map(ge=>ge.workspace.uri)))}const re=D.length+O.length+k.length;if(_&&re===0){const le=_.filesToOpenOrCreate[0]||_.filesToDiff[0],ce=this.getWindows().filter(Ie=>_&&Ie.remoteAuthority===_.remoteAuthority);let ge;(le==null?void 0:le.fileUri)&&!J&&((W.context===4||W.context===0||W.context===1)&&(ge=(0,w.findWindowOnFile)(ce,le.fileUri,Ie=>Ie.configPath.scheme===t.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Ie.configPath):null)),ge||(ge=this.doGetLastActiveWindow(ce))),ge?(0,l.isWorkspaceIdentifier)(ge.openedWorkspace)?O.push({workspace:ge.openedWorkspace,remoteAuthority:ge.remoteAuthority}):(0,l.isSingleFolderWorkspaceIdentifier)(ge.openedWorkspace)?D.push({workspace:ge.openedWorkspace,remoteAuthority:ge.remoteAuthority}):K(this.doOpenFilesInExistingWindow(W,ge,_),!0):K(this.openInBrowserWindow({userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,filesToOpen:_,forceNewWindow:!0,remoteAuthority:_.remoteAuthority,forceNewTabbedWindow:W.forceNewTabbedWindow}),!0)}const ie=(0,b.distinct)(O,le=>le.workspace.id);if(ie.length>0){const le=(0,b.coalesce)(ie.map(ce=>(0,w.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce.workspace.configPath)));if(le.length>0){const ce=le[0],ge=(_==null?void 0:_.remoteAuthority)===ce.remoteAuthority?_:void 0;K(this.doOpenFilesInExistingWindow(W,ce,ge),!!ge),V=!0}ie.forEach(ce=>{if(!le.some(Re=>Re.openedWorkspace&&Re.openedWorkspace.id===ce.workspace.id)){const ge=ce.remoteAuthority,Ie=(_==null?void 0:_.remoteAuthority)===ge?_:void 0;K(this.doOpenFolderOrWorkspace(W,ce,V,Ie),!!Ie),V=!0}})}const se=(0,b.distinct)(D,le=>a.extUriBiasedIgnorePathCase.getComparisonKey(le.workspace.uri));if(se.length>0){const le=(0,b.coalesce)(se.map(ce=>(0,w.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce.workspace.uri)));if(le.length>0){const ce=le[0],ge=(_==null?void 0:_.remoteAuthority)===ce.remoteAuthority?_:void 0;K(this.doOpenFilesInExistingWindow(W,ce,ge),!!ge),V=!0}se.forEach(ce=>{if(!le.some(Re=>(0,l.isSingleFolderWorkspaceIdentifier)(Re.openedWorkspace)&&a.extUriBiasedIgnorePathCase.isEqual(Re.openedWorkspace.uri,ce.workspace.uri))){const ge=ce.remoteAuthority,Ie=(_==null?void 0:_.remoteAuthority)===ge?_:void 0;K(this.doOpenFolderOrWorkspace(W,ce,V,Ie),!!Ie),V=!0}})}const me=(0,b.distinct)(k,le=>le.backupFolder);if(me.length>0&&me.forEach(le=>{const ce=le.remoteAuthority,ge=(_==null?void 0:_.remoteAuthority)===ce?_:void 0;K(this.openInBrowserWindow({userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,filesToOpen:ge,remoteAuthority:ce,forceNewWindow:!0,forceNewTabbedWindow:W.forceNewTabbedWindow,emptyWindowBackupInfo:le}),!!ge),V=!0}),j.length===0||_){_&&!F&&F++;const le=_?_.remoteAuthority:W.remoteAuthority;for(let ce=0;ce<F;ce++)K(this.doOpenEmpty(W,V,le,_),!!_),V=!0}return{windows:(0,b.distinct)(j),filesOpenedInWindow:G}}doOpenFilesInExistingWindow(W,O,D){var k;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),O.focus();const F={filesToOpenOrCreate:D==null?void 0:D.filesToOpenOrCreate,filesToDiff:D==null?void 0:D.filesToDiff,filesToWait:D==null?void 0:D.filesToWait,termProgram:(k=W==null?void 0:W.userEnv)===null||k===void 0?void 0:k.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",ne.CancellationToken.None,F),O}doAddFoldersToExistingWindow(W,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),W.focus();const D={foldersToAdd:O};return W.sendWhenReady("vscode:addFolders",ne.CancellationToken.None,D),W}doOpenEmpty(W,O,D,k,F){return!O&&!F&&typeof W.contextWindowId=="number"&&(F=this.getWindowById(W.contextWindowId)),this.openInBrowserWindow({userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,remoteAuthority:D,forceNewWindow:O,forceNewTabbedWindow:W.forceNewTabbedWindow,filesToOpen:k,windowToUse:F})}doOpenFolderOrWorkspace(W,O,D,k,F){return!D&&!F&&typeof W.contextWindowId=="number"&&(F=this.getWindowById(W.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:D,forceNewTabbedWindow:W.forceNewTabbedWindow,filesToOpen:k,windowToUse:F})}getPathsToOpen(W){var O;let D,k=!1,F=!1;if(W.urisToOpen&&W.urisToOpen.length>0?(D=this.doExtractPathsFromAPI(W),k=!0):W.forceEmpty?D=[Object.create(null)]:W.cli._.length||W.cli["folder-uri"]||W.cli["file-uri"]?(D=this.doExtractPathsFromCLI(W.cli),D.length===0&&D.push(Object.create(null)),k=!0):(D=this.doGetPathsFromLastSession(),D.length===0&&D.push(Object.create(null)),F=!0),!W.addMode&&k){const _=D.filter(C=>B(C));if(_.length>1){const C=_[0].remoteAuthority;if(_.every(j=>j.remoteAuthority===C)){const j=this.workspacesManagementMainService.createUntitledWorkspaceSync(_.map(G=>({uri:G.workspace.uri})));D.push({workspace:j,remoteAuthority:C}),D=D.filter(G=>!B(G))}}}return W.initialStartup&&!F&&((O=this.configurationService.getValue("window"))===null||O===void 0?void 0:O.restoreWindows)==="preserve"&&D.unshift(...this.doGetPathsFromLastSession().filter(_=>Q(_)||B(_)||_.backupPath)),D}doExtractPathsFromAPI(W){const O=[],D={gotoLineMode:W.gotoLineMode,remoteAuthority:W.remoteAuthority};for(const k of(0,b.coalesce)(W.urisToOpen||[])){const F=this.resolveOpenable(k,D);if(F)F.label=k.label,O.push(F);else{const _=this.resourceFromOpenable(k),C={title:v.default.nameLong,type:"info",buttons:[(0,L.localize)(0,null)],message:_.scheme===t.Schemas.file?(0,L.localize)(1,null):(0,L.localize)(2,null),detail:_.scheme===t.Schemas.file?(0,L.localize)(3,null,(0,X.getPathLabel)(_.fsPath,this.environmentMainService)):(0,L.localize)(4,null,_.toString()),noLink:!0};this.dialogMainService.showMessageBox(C,(0,N.withNullAsUndefined)(M.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(W){const O=[],D={ignoreFileNotFound:!0,gotoLineMode:W.goto,remoteAuthority:W.remote||void 0,forceOpenWorkspaceAsFile:!1},k=W["folder-uri"];if(k)for(const C of k){const j=this.cliArgToUri(C);if(j){const G=this.resolveOpenable({folderUri:j},D);G&&O.push(G)}}const F=W["file-uri"];if(F)for(const C of F){const j=this.cliArgToUri(C);if(j){const G=this.resolveOpenable((0,l.hasWorkspaceFileExtension)(C)?{workspaceUri:j}:{fileUri:j},D);G&&O.push(G)}}const _=W._;for(const C of _){const j=W.remote?this.doResolvePathRemote(C,W.remote):this.doResolveFilePath(C,D);j&&O.push(j)}return O}cliArgToUri(W){try{const O=r.URI.parse(W);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${W}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${W}, ${O.message}`)}}doGetPathsFromLastSession(){const W=this.getRestoreWindowsSetting();switch(W){case"none":return[];case"one":case"all":case"preserve":case"folders":const O=[];W!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const D=[];for(const k of O)if(k.workspace){const F=this.resolveOpenable({workspaceUri:k.workspace.configPath},{remoteAuthority:k.remoteAuthority});Q(F)&&D.push(F)}else if(k.folderUri){const F=this.resolveOpenable({folderUri:k.folderUri},{remoteAuthority:k.remoteAuthority});B(F)&&D.push(F)}else W!=="folders"&&k.backupPath&&D.push({backupPath:k.backupPath,remoteAuthority:k.remoteAuthority});return D}}getRestoreWindowsSetting(){let W;if(this.lifecycleMainService.wasRestarted)W="all";else{const O=this.configurationService.getValue("window");W=(O==null?void 0:O.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(W)||(W="all")}return W}resolveOpenable(W,O={}){let D=this.resourceFromOpenable(W);return D.scheme===t.Schemas.file?((0,d.isFileToOpen)(W)&&(O=Object.assign(Object.assign({},O),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(D.fsPath,O)):this.doResolveRemoteOpenable(W,O)}doResolveRemoteOpenable(W,O){let D=this.resourceFromOpenable(W);const k=(0,h.getRemoteAuthority)(D)||O.remoteAuthority;if(D=(0,a.removeTrailingPathSeparator)((0,a.normalizePath)(D)),(0,d.isFileToOpen)(W)){if(O.gotoLineMode){const{path:F,line:_,column:C}=(0,$.parseLineAndColumnAware)(D.path);return{fileUri:D.with({path:F}),lineNumber:_,columnNumber:C,remoteAuthority:k}}return{fileUri:D,remoteAuthority:k}}else if((0,d.isWorkspaceToOpen)(W))return{workspace:(0,m.getWorkspaceIdentifier)(D),remoteAuthority:k};return{workspace:(0,m.getSingleFolderWorkspaceIdentifier)(D),remoteAuthority:k}}resourceFromOpenable(W){return(0,d.isWorkspaceToOpen)(W)?W.workspaceUri:(0,d.isFolderToOpen)(W)?W.folderUri:W.fileUri}doResolveFilePath(W,O){let D,k;if(O.gotoLineMode){const F=(0,$.parseLineAndColumnAware)(W);D=F.line,k=F.column,W=F.path}W=(0,$.sanitizeFilePath)((0,R.normalize)(W),process.env.VSCODE_CWD||process.cwd());try{const F=(0,p.statSync)(W);if(F.isFile()){if(!O.forceOpenWorkspaceAsFile){const _=this.workspacesManagementMainService.resolveLocalWorkspaceSync(r.URI.file(W));if(_)return{workspace:{id:_.id,configPath:_.configPath},remoteAuthority:_.remoteAuthority,exists:!0}}return{fileUri:r.URI.file(W),lineNumber:D,columnNumber:k,exists:!0}}else if(F.isDirectory())return{workspace:(0,m.getSingleFolderWorkspaceIdentifier)(r.URI.file(W),F),exists:!0}}catch(F){const _=r.URI.file(W);if(this.workspacesHistoryMainService.removeRecentlyOpened([_]),O.ignoreFileNotFound)return{fileUri:_,exists:!1}}}doResolvePathRemote(W,O,D){const k=W.charCodeAt(0);k!==47&&((0,$.isWindowsDriveLetter)(k)&&W.charCodeAt(W.charCodeAt(1))===58&&(W=(0,$.toSlashes)(W)),W=`/${W}`);const F=r.URI.from({scheme:t.Schemas.vscodeRemote,authority:O,path:W});if(W.charCodeAt(W.length-1)!==47){if((0,l.hasWorkspaceFileExtension)(W))return D?{fileUri:F,remoteAuthority:O}:{workspace:(0,m.getWorkspaceIdentifier)(F),remoteAuthority:O};if(R.posix.basename(W).indexOf(".")!==-1)return{fileUri:F,remoteAuthority:O}}return{workspace:(0,m.getSingleFolderWorkspaceIdentifier)(F),remoteAuthority:O}}shouldOpenNewWindow(W){const O=this.configurationService.getValue("window"),D=(O==null?void 0:O.openFoldersInNewWindow)||"default",k=(O==null?void 0:O.openFilesInNewWindow)||"off";let F=(W.preferNewWindow||W.forceNewWindow)&&!W.forceReuseWindow;!W.forceNewWindow&&!W.forceReuseWindow&&(D==="on"||D==="off")&&(F=D==="on");let _=!1;return W.forceNewWindow||W.forceReuseWindow?_=!!W.forceNewWindow&&!W.forceReuseWindow:(c.isMacintosh?W.context===1&&(_=!0):W.context!==3&&W.context!==2&&!(W.userEnv&&W.userEnv.TERM_PROGRAM==="vscode")&&(_=!0),!W.cli.extensionDevelopmentPath&&(k==="on"||k==="off")&&(_=k==="on")),{openFolderInNewWindow:!!F,openFilesInNewWindow:_}}openExtensionDevelopmentHostWindow(W,O){const D=(0,w.findWindowOnExtensionDevelopmentPath)(this.getWindows(),W);if(D)return this.lifecycleMainService.reload(D,O.cli),D.focus(),[D];let k=O.cli["folder-uri"]||[],F=O.cli["file-uri"]||[],_=O.cli._;if(!_.length&&!k.length&&!F.length&&!O.cli.extensionTestsPath){const K=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,V=K&&(K.workspace||K.folderUri);V&&(r.URI.isUri(V)?V.scheme===t.Schemas.file?_=[V.fsPath]:k=[V.toString()]:V.configPath.scheme===t.Schemas.file?_=[(0,a.originalFSPath)(V.configPath)]:F=[V.configPath.toString()])}let C=O.remoteAuthority;for(const K of W)if(K.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const V=r.URI.parse(K),J=(0,h.getRemoteAuthority)(V);J&&(C?J!==C&&this.logService.error("more than one extension development path authority"):C=J)}_=_.filter(K=>{const V=r.URI.file(K);return(0,w.findWindowOnWorkspaceOrFolder)(this.getWindows(),V)?!1:(0,h.getRemoteAuthority)(V)===C}),k=k.filter(K=>{const V=this.cliArgToUri(K);return V&&!!(0,w.findWindowOnWorkspaceOrFolder)(this.getWindows(),V)?!1:V?(0,h.getRemoteAuthority)(V)===C:!1}),F=F.filter(K=>{const V=this.cliArgToUri(K);return V&&!!(0,w.findWindowOnWorkspaceOrFolder)(this.getWindows(),V)?!1:V?(0,h.getRemoteAuthority)(V)===C:!1}),O.cli._=_,O.cli["folder-uri"]=k,O.cli["file-uri"]=F;const j=!_.length&&!k.length&&!F.length,G={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:j,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:C};return this.open(G)}openInBrowserWindow(W){var O;const D=Object.assign({},W.cli);D.appRoot=this.environmentMainService.appRoot,D.machineId=this.machineId,D.nodeCachedDataDir=this.environmentMainService.nodeCachedDataDir,D.mainPid=process.pid,D.execPath=process.execPath,D.userEnv=Object.assign(Object.assign({},this.initialUserEnv),W.userEnv),D.isInitialStartup=W.initialStartup,D.workspace=W.workspace,D.remoteAuthority=W.remoteAuthority;const k=W.filesToOpen;k&&(D.filesToOpenOrCreate=k.filesToOpenOrCreate,D.filesToDiff=k.filesToDiff,D.filesToWait=k.filesToWait),W.emptyWindowBackupInfo&&(D.backupPath=(0,R.join)(this.environmentMainService.backupHome,W.emptyWindowBackupInfo.backupFolder));let F;if(!W.forceNewWindow&&!W.forceNewTabbedWindow&&(F=W.windowToUse||this.getLastActiveWindow(),F&&F.focus()),F){const _=F.config;!D.extensionDevelopmentPath&&_&&!!_.extensionDevelopmentPath&&(D.extensionDevelopmentPath=_.extensionDevelopmentPath,D.verbose=_.verbose,D["inspect-brk-extensions"]=_["inspect-brk-extensions"],D.debugId=_.debugId,D["inspect-extensions"]=_["inspect-extensions"],D["extensions-dir"]=_["extensions-dir"])}else{const _=this.windowsStateHandler.getNewWindowState(D),C=F=this.instantiationService.createInstance(i.CodeWindow,{state:_,extensionDevelopmentPath:D.extensionDevelopmentPath,isExtensionTestHost:!!D.extensionTestsPath});if(W.forceNewTabbedWindow){const G=this.getLastActiveWindow();G&&G.addTabbedWindow(C)}Qe.WINDOWS.push(C),this._onDidOpenWindow.fire(C),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,I.once)(C.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(C)),(0,I.once)(C.onDidClose)(()=>this.onWindowClosed(C)),(0,I.once)(C.onDidDestroy)(()=>this._onDidDestroyWindow.fire(C));const j=(0,N.assertIsDefined)((O=C.win)===null||O===void 0?void 0:O.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.lifecycleMainService.reload(C)),this.lifecycleMainService.registerWindow(C)}return F.isReady?this.lifecycleMainService.unload(F,4).then(_=>{_||this.doOpenInBrowserWindow(F,D,W)}):this.doOpenInBrowserWindow(F,D,W),F}doOpenInBrowserWindow(W,O,D){if(!O.extensionDevelopmentPath)if((0,l.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,l.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync(O.workspace.uri);else{const k=D.emptyWindowBackupInfo&&D.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(k,O.remoteAuthority)}W.load(O)}onWindowClosed(W){const O=Qe.WINDOWS.indexOf(W);Qe.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const W=M.BrowserWindow.getFocusedWindow();if(W)return this.getWindowById(W.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(W){return this.doGetLastActiveWindow(this.getWindows().filter(O=>O.remoteAuthority===W))}doGetLastActiveWindow(W){const O=Math.max.apply(Math,W.map(D=>D.lastFocusTime));return W.find(D=>D.lastFocusTime===O)}sendToFocused(W,...O){const D=this.getFocusedWindow()||this.getLastActiveWindow();D&&D.sendWhenReady(W,ne.CancellationToken.None,...O)}sendToAll(W,O,D){for(const k of this.getWindows())D&&D.indexOf(k.id)>=0||k.sendWhenReady(W,ne.CancellationToken.None,O)}getWindows(){return Qe.WINDOWS}getWindowCount(){return Qe.WINDOWS.length}getWindowById(W){const O=this.getWindows().filter(D=>D.id===W);return(0,b.firstOrDefault)(O)}getWindowByWebContents(W){const O=M.BrowserWindow.fromWebContents(W);if(!!O)return this.getWindowById(O.id)}};z.WINDOWS=[],z=he([ee(2,g.ILogService),ee(3,S.IStateService),ee(4,n.IEnvironmentMainService),ee(5,f.ILifecycleMainService),ee(6,P.IBackupMainService),ee(7,E.IConfigurationService),ee(8,o.IWorkspacesHistoryMainService),ee(9,m.IWorkspacesManagementMainService),ee(10,s.IInstantiationService),ee(11,T.IDialogMainService),ee(12,Y.IFileService)],z),e.WindowsMainService=z}),define(Z[230],x([0,1,49,32,63,47]),function(H,e,p,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let P=class{constructor(S,i,M,f){this.workspacesManagementMainService=S,this.windowsMainService=i,this.workspacesHistoryMainService=M,this.backupMainService=f,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(S,i){const M=this.windowsMainService.getWindowById(S);return M?this.workspacesManagementMainService.enterWorkspace(M,this.windowsMainService.getWindows(),i):null}createUntitledWorkspace(S,i,M){return this.workspacesManagementMainService.createUntitledWorkspace(i,M)}deleteUntitledWorkspace(S,i){return this.workspacesManagementMainService.deleteUntitledWorkspace(i)}getWorkspaceIdentifier(S,i){return this.workspacesManagementMainService.getWorkspaceIdentifier(i)}async getRecentlyOpened(S){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(S))}async addRecentlyOpened(S,i){return this.workspacesHistoryMainService.addRecentlyOpened(i)}async removeRecentlyOpened(S,i){return this.workspacesHistoryMainService.removeRecentlyOpened(i)}async clearRecentlyOpened(S){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};P=he([ee(0,p.IWorkspacesManagementMainService),ee(1,R.IWindowsMainService),ee(2,L.IWorkspacesHistoryMainService),ee(3,b.IBackupMainService)],P),e.WorkspacesMainService=P}),define(Z[231],x([0,1,27,22,11,3,229,18,88,40,196,33,119,83,220,98,5,70,68,6,37,26,24,95,197,31,94,191,192,188,17,214,167,2,32,7,28,230,66,224,222,221,225,172,19,199,215,228,116,8,15,128,9,223,96,208,213,47,63,198,49,69,150,41,48,13,38,205,201,16,43,30,21,87,206,186,53,29,25,159,176,42,71,72]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y,v,o,c,l,s,t,r,a,h,u,m,I,A,T,N,$,X,ne,Y,Q,B,z,U,W,O,D,k,F,_,C,j,G,K,V,J,re,ie,se,me,le,ce,ge,Ie,Re,We,He,qe,Ge,nt,Je,rt,Ve,st,Ue,ot,q,te,oe,ae,de,ve,Se,ke,Te,Fe,Ne,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let at=class extends X.Disposable{constructor(fe,we,Pe,ue,ye,pe,Ee,be,De){super();this.mainProcessNodeIpcServer=fe,this.userEnv=we,this.mainInstantiationService=Pe,this.logService=ue,this.environmentMainService=ye,this.lifecycleMainService=pe,this.configurationService=Ee,this.stateService=be,this.fileService=De,this.registerListeners()}registerListeners(){(0,F.setUnexpectedErrorHandler)(ue=>this.onUnexpectedError(ue)),process.on("uncaughtException",ue=>this.onUnexpectedError(ue)),process.on("unhandledRejection",ue=>(0,F.onUnexpectedError)(ue)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,G.registerContextMenuListener)(),L.app.on("accessibility-support-changed",(ue,ye)=>{var pe;(pe=this.windowsMainService)===null||pe===void 0||pe.sendToAll("vscode:accessibilitySupportChanged",ye)}),L.app.on("activate",(ue,ye)=>{var pe;this.logService.trace("app#activate"),ye||(pe=this.windowsMainService)===null||pe===void 0||pe.openEmptyWindow({context:1})}),L.app.on("remote-require",(ue,ye,pe)=>{this.logService.trace("app#on(remote-require): prevented"),ue.preventDefault()}),L.app.on("remote-get-global",(ue,ye,pe)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${pe}`),ue.preventDefault()}),L.app.on("remote-get-builtin",(ue,ye,pe)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${pe}`),pe!=="clipboard"&&ue.preventDefault()}),L.app.on("remote-get-current-window",ue=>{this.logService.trace("app#on(remote-get-current-window): prevented"),ue.preventDefault()}),L.app.on("remote-get-current-web-contents",ue=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),ue.preventDefault())}),L.app.on("web-contents-created",(ue,ye)=>{ye.on("will-attach-webview",(Ee,be,De)=>{const Me=_e=>{if(!_e)return!1;const Ce=Y.URI.parse(_e);if(Ce.scheme===re.Schemas.vscodeWebview)return Ce.path==="/index.html"||Ce.path==="/electron-browser/index.html";const $e=Ce.fsPath.toLowerCase(),je=Y.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return $e.startsWith(je+K.sep)};delete be.preload,be.nodeIntegration=!1,!(Me(De.src)&&Me(be.preloadURL))&&(delete be.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Ee.preventDefault())}),ye.on("will-navigate",Ee=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ee.preventDefault()}),ye.on("new-window",(Ee,be)=>{var De;Ee.preventDefault(),(De=this.nativeHostMainService)===null||De===void 0||De.openExternal(void 0,be)});const pe="about:blank?webviewFrame";L.session.defaultSession.setPermissionRequestHandler((Ee,be,De,Me)=>Me.requestingUrl===pe?De(be==="clipboard-read"):De(!1)),L.session.defaultSession.setPermissionCheckHandler((Ee,be,De,Me)=>Me.requestingUrl===pe?be==="clipboard-read":!1)});let fe=[],we=null;L.app.on("open-file",(ue,ye)=>{this.logService.trace("app#open-file: ",ye),ue.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(ye)),we!==null&&(clearTimeout(we),we=null),we=setTimeout(()=>{var pe;(pe=this.windowsMainService)===null||pe===void 0||pe.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],we=null},100)}),L.app.on("new-window-for-tab",()=>{var ue;(ue=this.windowsMainService)===null||ue===void 0||ue.openEmptyWindow({context:4})});let Pe=!1;L.ipcMain.on("vscode:fetchShellEnv",async ue=>{var ye;const pe=ue.sender;let Ee=!1;function be(Be){clearTimeout(Me),clearTimeout(Ce),Ee||(Ee=!0,pe.isDestroyed()||pe.send("vscode:acceptShellEnv",Be))}const De=new Se.CancellationTokenSource,Me=setTimeout(()=>{var Be;Pe||((Be=this.windowsMainService)===null||Be===void 0||Be.sendToFocused("vscode:showShellEnvSlowWarning",De.token),Pe=!0)},3e3),_e=(ye=this.windowsMainService)===null||ye===void 0?void 0:ye.getWindowByWebContents(ue.sender),Ce=setTimeout(()=>{De.dispose(!0),_e==null||_e.sendWhenReady("vscode:showShellEnvTimeoutError",Se.CancellationToken.None),be({})},1e4);let $e,je;(_e==null?void 0:_e.config)?($e=_e.config,je=Object.assign(Object.assign({},process.env),_e.config.userEnv)):($e=this.environmentMainService.args,je=process.env);const Ae=await(0,S.resolveShellEnv)(this.logService,$e,je);be(Ae)}),L.ipcMain.handle("vscode:writeNlsFile",async(ue,ye,pe)=>{const Ee=this.validateNlsPath([ye]);if(!Ee||typeof pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ee,q.VSBuffer.fromString(pe))}),L.ipcMain.handle("vscode:readNlsFile",async(ue,...ye)=>{const pe=this.validateNlsPath(ye);if(!pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(pe)).value.toString()}),L.ipcMain.on("vscode:toggleDevTools",ue=>ue.sender.toggleDevTools()),L.ipcMain.on("vscode:openDevTools",ue=>ue.sender.openDevTools()),L.ipcMain.on("vscode:reloadWindow",ue=>ue.sender.reload())}validateNlsPath(fe){let we;for(const Pe of fe)typeof Pe=="string"&&(typeof we!="string"?we=Pe:we=(0,K.join)(we,Pe));if(!(typeof we!="string"||!(0,K.isAbsolute)(we)||!(0,ve.isEqualOrParent)(we,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return Y.URI.file(we)}onUnexpectedError(fe){var we;if(fe){const Pe={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};(we=this.windowsMainService)===null||we===void 0||we.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const fe=T.default.win32AppUserModelId;b.isWindows&&fe&&L.app.setAppUserModelId(fe);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!L.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&L.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Me){this.logService.error(Me)}const we=this._register(this.mainInstantiationService.createInstance($.FileProtocolHandler)),Pe=new E.Server;this.logService.trace("Resolving machine identifier...");const ue=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ue}`);const{sharedProcess:ye,sharedProcessReady:pe,sharedProcessClient:Ee}=this.setupSharedProcess(ue),be=await this.initServices(ue,ye,pe);if(this.environmentMainService.driverHandle){const Me=await(0,C.serve)(Pe,this.environmentMainService.driverHandle,this.environmentMainService,be);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Me)}this._register(be.createInstance(N.ProxyAuthHandler)),be.invokeFunction(Me=>this.initChannels(Me,Pe,Ee));const De=be.invokeFunction(Me=>this.openFirstWindow(Me,Pe,we));be.invokeFunction(Me=>this.afterWindowOpen(Me,ye)),this.environmentMainService.args.trace&&be.invokeFunction(Me=>this.stopTracingEventually(Me,De))}async resolveMachineId(){let fe=this.stateService.getItem(h.machineIdKey);return(!fe||b.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,z.getMachineId)(),this.stateService.setItem(h.machineIdKey,fe)),fe}setupSharedProcess(fe){const we=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,fe,this.userEnv)),Pe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ye=await we.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new g.Client(ye,"main")})(),ue=(async()=>(await we.whenReady(),Pe))();return{sharedProcess:we,sharedProcessReady:ue,sharedProcessClient:Pe}}async initServices(fe,we,Pe){const ue=new v.ServiceCollection;switch(process.platform){case"win32":ue.set(i.IUpdateService,new o.SyncDescriptor(U.Win32UpdateService));break;case"linux":b.isLinuxSnap?ue.set(i.IUpdateService,new o.SyncDescriptor(ie.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ue.set(i.IUpdateService,new o.SyncDescriptor(W.LinuxUpdateService));break;case"darwin":ue.set(i.IUpdateService,new o.SyncDescriptor(O.DarwinUpdateService));break}ue.set(ne.IWindowsMainService,new o.SyncDescriptor(P.WindowsMainService,[fe,this.userEnv])),ue.set(Ge.IDialogMainService,new o.SyncDescriptor(Ge.DialogMainService)),ue.set(w.ILaunchMainService,new o.SyncDescriptor(w.LaunchMainService)),ue.set(We.IDiagnosticsService,f.ProxyChannel.toService((0,f.getDelayedChannel)(Pe.then(pe=>pe.getChannel("diagnostics"))))),ue.set(D.IIssueMainService,new o.SyncDescriptor(D.IssueMainService,[fe,this.userEnv])),ue.set(te.IEncryptionMainService,new o.SyncDescriptor(te.EncryptionMainService,[fe])),ue.set(ae.IKeyboardLayoutMainService,new o.SyncDescriptor(ae.KeyboardLayoutMainService)),ue.set(qe.INativeHostMainService,new o.SyncDescriptor(qe.NativeHostMainService,[we])),ue.set(Ve.IWebviewManagerService,new o.SyncDescriptor(rt.WebviewMainService)),ue.set(Q.IWorkspacesService,new o.SyncDescriptor(B.WorkspacesMainService)),ue.set(Re.IWorkspacesManagementMainService,new o.SyncDescriptor(Re.WorkspacesManagementMainService)),ue.set(ge.IWorkspacesHistoryMainService,new o.SyncDescriptor(ge.WorkspacesHistoryMainService)),ue.set(j.IMenubarMainService,new o.SyncDescriptor(j.MenubarMainService)),ue.set(ke.IExtensionUrlTrustService,new o.SyncDescriptor(Te.ExtensionUrlTrustService)),ue.set(se.IStorageMainService,new o.SyncDescriptor(se.StorageMainService));const ye=new le.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ue.set(ce.IBackupMainService,ye),ue.set(r.IURLService,new o.SyncDescriptor(Ie.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!T.default.enableTelemetry){const pe=(0,f.getDelayedChannel)(Pe.then(_e=>_e.getChannel("telemetryAppender"))),Ee=new m.TelemetryAppenderClient(pe),be=(0,A.resolveCommonProperties)(this.fileService,(0,p.release)(),process.arch,T.default.commit,T.default.version,fe,T.default.msftInternalDomains,this.environmentMainService.installSourcePath),De=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Me={appender:Ee,commonProperties:be,piiPaths:De,sendErrorTelemetry:!0};ue.set(h.ITelemetryService,new o.SyncDescriptor(I.TelemetryService,[Me]))}else ue.set(h.ITelemetryService,u.NullTelemetryService);return await ye.initialize(),this.mainInstantiationService.createChild(ue)}initChannels(fe,we,Pe){const ue=f.ProxyChannel.fromService(fe.get(w.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ue);const ye=new M.UpdateChannel(fe.get(i.IUpdateService));we.registerChannel("update",ye);const pe=f.ProxyChannel.fromService(fe.get(D.IIssueMainService));we.registerChannel("issue",pe);const Ee=f.ProxyChannel.fromService(fe.get(te.IEncryptionMainService));we.registerChannel("encryption",Ee);const be=f.ProxyChannel.fromService(fe.get(bt.ISignService));we.registerChannel("sign",be);const De=f.ProxyChannel.fromService(fe.get(ae.IKeyboardLayoutMainService));we.registerChannel("keyboardLayout",De),this.nativeHostMainService=fe.get(qe.INativeHostMainService);const Me=f.ProxyChannel.fromService(this.nativeHostMainService);we.registerChannel("nativeHost",Me),Pe.then(Ke=>Ke.registerChannel("nativeHost",Me));const _e=f.ProxyChannel.fromService(fe.get(Q.IWorkspacesService));we.registerChannel("workspaces",_e);const Ce=f.ProxyChannel.fromService(fe.get(j.IMenubarMainService));we.registerChannel("menubar",Ce);const $e=f.ProxyChannel.fromService(fe.get(r.IURLService));we.registerChannel("url",$e);const je=f.ProxyChannel.fromService(fe.get(ke.IExtensionUrlTrustService));we.registerChannel("extensionUrlTrust",je);const Ae=f.ProxyChannel.fromService(fe.get(Ve.IWebviewManagerService));we.registerChannel("webview",Ae);const Be=this._register(new me.StorageDatabaseChannel(this.logService,fe.get(se.IStorageMainService)));we.registerChannel("storage",Be),Pe.then(Ke=>Ke.registerChannel("storage",Be));const Xe=new k.LogLevelChannel(fe.get(c.ILogService));we.registerChannel("logLevel",Xe),Pe.then(Ke=>Ke.registerChannel("logLevel",Xe));const Ze=new k.LoggerChannel(fe.get(c.ILoggerService));we.registerChannel("logger",Ze);const et=new He.ElectronExtensionHostDebugBroadcastChannel(fe.get(ne.IWindowsMainService));we.registerChannel("extensionhostdebugservice",et)}openFirstWindow(fe,we,Pe){const ue=this.windowsMainService=fe.get(ne.IWindowsMainService),ye=fe.get(r.IURLService),pe=fe.get(qe.INativeHostMainService);this.lifecycleMainService.phase=2,Pe.injectWindowsMainService(this.windowsMainService);const Ee=[],be=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:Y.URI.parse(Oe),url:Oe}}catch(Ye){return null}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Ye=this.getWindowOpenableFromProtocolLink(Oe.uri);return Ye?(Ee.push(Ye),!1):!0}),De=this,Me=this.environmentMainService;ye.registerHandler({async handleURL(Oe,Ye){if(De.shouldBlockURI(Oe))return!0;const pt=De.getWindowOpenableFromProtocolLink(Oe);if(pt){const[ut]=ue.open({context:5,cli:Object.assign({},Me.args),urisToOpen:[pt],gotoLineMode:!0});return ut.focus(),!0}if(b.isMacintosh&&ue.getWindowCount()===0){const[ut]=ue.open({context:5,cli:Object.assign({},Me.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ne.getRemoteAuthority)(Oe)});return await ut.ready(),ye.open(Oe,Ye)}return!1}});const _e=this._register(new oe.ActiveWindowManager({onDidOpenWindow:pe.onDidOpenWindow,onDidFocusWindow:pe.onDidFocusWindow,getActiveWindowId:()=>pe.getActiveWindowId(-1)})),Ce=new f.StaticRouter(Oe=>_e.getActiveClientId().then(Ye=>Oe===Ye)),$e=new a.URLHandlerRouter(Ce),je=we.getChannel("urlHandler",$e);ye.registerHandler(new a.URLHandlerChannelClient(je)),this._register(new _.ElectronURLListener(be,ye,ue,this.environmentMainService));const Ae=this.environmentMainService.args,Be=global.macOpenFiles,Xe=(0,de.isLaunchedFromCli)(process.env)?0:4,Ze=Ae._.length,et=!!Ae["folder-uri"],Ke=!!Ae["file-uri"],lt=Ae["skip-add-to-recently-opened"]===!0,ct=Ae.wait&&Ae.waitMarkerFilePath?Y.URI.file(Ae.waitMarkerFilePath):void 0,wt=Ae.remote||void 0;return Ee.length>0?ue.open({context:Xe,cli:Ae,urisToOpen:Ee,gotoLineMode:!0,initialStartup:!0}):Ae["new-window"]&&!Ze&&!et&&!Ke?ue.open({context:Xe,cli:Ae,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:lt,waitMarkerFileURI:ct,initialStartup:!0,remoteAuthority:wt}):Be.length&&!Ze&&!et&&!Ke?ue.open({context:1,cli:Ae,urisToOpen:Be.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:lt,waitMarkerFileURI:ct,initialStartup:!0}):ue.open({context:Xe,cli:Ae,forceNewWindow:Ae["new-window"]||!Ze&&Ae["unity-launch"],diffMode:Ae.diff,noRecentEntry:lt,waitMarkerFileURI:ct,gotoLineMode:Ae.goto,initialStartup:!0,remoteAuthority:wt})}shouldBlockURI(fe){return!!(fe.authority===re.Schemas.file&&b.isWindows&&L.dialog.showMessageBoxSync({title:T.default.nameLong,type:"question",buttons:[(0,Je.mnemonicButtonLabel)((0,J.localize)(0,null)),(0,Je.mnemonicButtonLabel)((0,J.localize)(1,null))],cancelId:1,message:(0,J.localize)(2,null,(0,Je.getPathLabel)(fe.fsPath,this.environmentMainService),T.default.nameShort),detail:(0,J.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===re.Schemas.file)return{fileUri:Y.URI.file(fe.fsPath)};if(fe.authority===re.Schemas.vscodeRemote){const we=fe.path.indexOf(K.posix.sep,1);if(we!==-1){const Pe=fe.path.substring(1,we),ue=fe.path.substring(we),ye=Y.URI.from({scheme:re.Schemas.vscodeRemote,authority:Pe,path:ue,query:fe.query,fragment:fe.fragment});return(0,Q.hasWorkspaceFileExtension)(ue)?{workspaceUri:ye}:{folderUri:ye}}}}}getWindowOpenableFromPathSync(fe){try{if((0,R.statSync)(fe).isDirectory())return{folderUri:Y.URI.file(fe)};if((0,Q.hasWorkspaceFileExtension)(fe))return{workspaceUri:Y.URI.file(fe)}}catch(we){}return{fileUri:Y.URI.file(fe)}}async afterWindowOpen(fe,we){var Pe;this.lifecycleMainService.phase=3;const ue=fe.get(h.ITelemetryService);this._register(we.onDidError(({type:Ee,details:be})=>{let De;typeof be=="string"?De=be:De=`SharedProcess: crashed (detail: ${be.reason})`,(0,F.onUnexpectedError)(new Error(De)),ue.publicLog2("sharedprocesserror",{type:Ee,reason:typeof be!="string"?be.reason:void 0})}));const ye=T.default.win32MutexName;if(b.isWindows&&ye)try{const Ee=H.__$__nodeRequire("windows-mutex").Mutex,be=new Ee(ye);(0,Fe.once)(this.lifecycleMainService.onWillShutdown)(()=>be.release())}catch(Ee){this.logService.error(Ee)}L.protocol.registerHttpProtocol(re.Schemas.vscodeRemoteResource,(Ee,be)=>{be({url:Ee.url.replace(/^vscode-remote-resource:/,"http:"),method:Ee.method})});const pe=fe.get(i.IUpdateService);(pe instanceof U.Win32UpdateService||pe instanceof W.LinuxUpdateService||pe instanceof O.DarwinUpdateService)&&pe.initialize(),(0,S.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const be=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,Ue.stripComments)(be))["enable-crash-reporter"]===void 0){const Me=(Pe=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&Pe!==void 0?Pe:!0,_e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,ot.generateUuid)()}"`,"}"],Ce=be.substring(0,be.length-2).concat(`,
`,_e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,q.VSBuffer.fromString(Ce))}}catch(Ee){this.logService.error(Ee)}}stopTracingEventually(fe,we){this.logService.info("Tracing: waiting for windows to get ready...");const Pe=fe.get(Ge.IDialogMainService);let ue=!1;const ye=async Ee=>{if(!ue){ue=!0;const be=await L.contentTracing.stopRecording((0,V.joinPath)(this.environmentMainService.userHome,`${T.default.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Ee?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${be}`):Pe.showMessageBox({type:"info",message:(0,J.localize)(4,null),detail:(0,J.localize)(5,null,be),buttons:[(0,J.localize)(6,null)]},(0,nt.withNullAsUndefined)(L.BrowserWindow.getFocusedWindow()))}},pe=setTimeout(()=>ye(!0),3e4);Promise.all(we.map(Ee=>Ee.ready())).then(()=>{clearTimeout(pe),ye(!1)})}};at=he([ee(2,y.IInstantiationService),ee(3,c.ILogService),ee(4,s.IEnvironmentMainService),ee(5,n.ILifecycleMainService),ee(6,t.IConfigurationService),ee(7,l.IStateService),ee(8,st.IFileService)],at),e.CodeApplication=at}),define(Z[238],x([0,1,11,22,12,3,17,53,151,18,33,55,163,70,68,6,187,37,24,179,39,219,231,38,92,91,19,73,42,72,185,189,168,170,9,16,54,217,61,29,20,8,34,26,67,94,173,195]),function(H,e,p,R,L,b,P,n,S,i,M,f,E,g,d,w,y,v,o,c,l,s,t,r,a,h,u,m,I,A,T,N,$,X,ne,Y,Q,B,z,U,W,O,D,k,F,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class j{main(){try{this.startup()}catch(V){console.error(V.message),p.app.exit(1)}}async startup(){(0,u.setUnexpectedErrorHandler)(ce=>console.error(ce));const V=this.resolveArgs(),[J,re,ie,se,me,le]=this.createServices(V);try{try{await this.initServices(ie,se,me)}catch(ce){throw this.handleStartupDataDirError(ie,ce),ce}await J.invokeFunction(async ce=>{const ge=ce.get(w.ILogService),Ie=ce.get(i.ILifecycleMainService),Re=ce.get(Y.IFileService),We=await this.doStartup(V,ge,ie,Ie,J,!0);return le.logger=new a.SpdLogLogger("main",(0,O.join)(ie.logsPath,"main.log"),!0,le.getLevel()),(0,I.once)(Ie.onWillShutdown)(()=>{Re.dispose(),se.dispose()}),J.createInstance(t.CodeApplication,We,re).startup()})}catch(ce){J.invokeFunction(this.quit,ce)}}createServices(V){const J=new g.ServiceCollection,re=new k.EnvironmentMainService(V),ie=this.patchEnvironment(re);J.set(k.IEnvironmentMainService,re);const se=new h.BufferLogService,me=new w.MultiplexLogService([new w.ConsoleMainLogger((0,w.getLogLevel)(re)),se]);process.once("exit",()=>me.dispose()),J.set(w.ILogService,me);const le=new $.FileService(me);J.set(Y.IFileService,le);const ce=new X.DiskFileSystemProvider(me);le.registerProvider(ne.Schemas.file,ce),J.set(w.ILoggerService,new C.LoggerService(me,le));const ge=new c.ConfigurationService(re.settingsResource,le);J.set(o.IConfigurationService,ge),J.set(i.ILifecycleMainService,new d.SyncDescriptor(i.LifecycleMainService));const Ie=new y.StateService(re,me);return J.set(v.IStateService,Ie),J.set(l.IRequestService,new d.SyncDescriptor(s.RequestMainService)),J.set(m.IThemeMainService,new d.SyncDescriptor(m.ThemeMainService)),J.set(A.ISignService,new d.SyncDescriptor(T.SignService)),J.set(z.IProductService,Object.assign({_serviceBrand:void 0},P.default)),J.set(Q.ITunnelService,new d.SyncDescriptor(B.TunnelService)),[new E.InstantiationService(J,!0),ie,re,ge,Ie,se]}patchEnvironment(V){const J={VSCODE_IPC_HOOK:V.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(re=>{const ie=process.env[re];typeof ie=="string"&&(J[re]=ie)}),Object.assign(process.env,J),J}initServices(V,J,re){const ie=Promise.all([V.extensionsPath,V.nodeCachedDataDir,V.logsPath,V.globalStorageHome.fsPath,V.workspaceStorageHome.fsPath,V.backupHome].map(le=>le?R.promises.mkdir(le,{recursive:!0}):void 0)),se=J.initialize(),me=re.init();return Promise.all([ie,se,me])}async doStartup(V,J,re,ie,se,me){let le;try{le=await(0,f.serve)(re.mainIPCHandle),(0,I.once)(ie.onWillShutdown)(()=>le.dispose())}catch(ce){if(ce.code!=="EADDRINUSE")throw this.handleStartupDataDirError(re,ce),ce;let ge;try{ge=await(0,f.connect)(re.mainIPCHandle,"main")}catch(We){if(!me||b.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.showStartupWarningDialog((0,L.localize)(0,null,P.default.nameShort),(0,L.localize)(1,null)),We;try{(0,R.unlinkSync)(re.mainIPCHandle)}catch(He){throw J.warn("Could not delete obsolete instance handle",He),He}return this.doStartup(V,J,re,ie,se,!1)}if(re.extensionTestsLocationURI&&!re.debugExtensionHost.break){const We="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw J.error(We),ge.dispose(),new Error(We)}let Ie;!V.wait&&!V.status&&(Ie=setTimeout(()=>{this.showStartupWarningDialog((0,L.localize)(2,null,P.default.nameShort),(0,L.localize)(3,null))},1e4));const Re=M.ProxyChannel.toService(ge.getChannel("launch"),{disableMarshalling:!0});if(V.status)return se.invokeFunction(async()=>{const We=new N.DiagnosticsService(_.NullTelemetryService),He=await Re.getMainProcessInfo(),qe=await Re.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ge=await We.getDiagnostics(He,qe);throw console.log(Ge),new u.ExpectedError});throw b.isWindows&&await this.windowsAllowSetForegroundWindow(Re,J),J.trace("Sending env to running instance..."),await Re.start(V,process.env),ge.dispose(),Ie&&clearTimeout(Ie),new u.ExpectedError("Sent env to running instance. Terminating...")}if(V.status)throw J.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new u.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),le}handleStartupDataDirError(V,J){if(J.code==="EACCES"||J.code==="EPERM"){const re=(0,D.coalesce)([V.userDataPath,V.extensionsPath,f.XDG_RUNTIME_DIR]).map(ie=>(0,r.getPathLabel)(ie,V));this.showStartupWarningDialog((0,L.localize)(4,null),(0,L.localize)(5,null,(0,F.toErrorMessage)(J),re.join(`
`)))}}showStartupWarningDialog(V,J){p.dialog.showMessageBoxSync({title:P.default.nameLong,type:"warning",buttons:[(0,r.mnemonicButtonLabel)((0,L.localize)(6,null))],message:V,detail:J,noLink:!0})}async windowsAllowSetForegroundWindow(V,J){if(b.isWindows){const re=await V.getMainProcessId();J.trace("Sending some foreground love to the running instance:",re);try{(await new Promise((ie,se)=>{H(["windows-foreground-love"],ie,se)})).allowSetForegroundWindow(re)}catch(ie){J.error(ie)}}}quit(V,J){const re=V.get(w.ILogService),ie=V.get(i.ILifecycleMainService);let se=0;J&&(J.isExpected?J.message&&re.trace(J.message):(se=1,J.stack?re.error(J.stack):re.error(`Startup error: ${J.toString()}`))),ie.kill(se)}resolveArgs(){const V=this.validatePaths((0,n.parseMainProcessArgv)(process.argv));if(V.wait&&!V.waitMarkerFilePath){const J=(0,S.createWaitMarkerFile)(V.verbose);J&&((0,n.addArg)(process.argv,"--waitMarkerFilePath",J),V.waitMarkerFilePath=J)}return V}validatePaths(V){if(V["open-url"]&&(V._urls=V._,V._=[]),!V.remote){const J=this.doValidatePaths(V._,V.goto);V._=J}return V}doValidatePaths(V,J){const re=process.env.VSCODE_CWD||process.cwd(),ie=V.map(le=>{let ce=String(le),ge;J&&(ge=(0,U.parseLineAndColumnAware)(ce),ce=ge.path),ce&&(ce=this.preparePath(re,ce));const Ie=(0,U.sanitizeFilePath)(ce,re),Re=(0,O.basename)(Ie);return Re&&!(0,U.isValidBasename)(Re)?null:J&&ge?(ge.path=Ie,this.toPath(ge)):Ie}),se=b.isWindows||b.isMacintosh,me=(0,D.distinct)(ie,le=>le&&se?le.toLowerCase():le||"");return(0,D.coalesce)(me)}preparePath(V,J){return b.isWindows&&(J=(0,W.rtrim)(J,'"')),J=(0,W.trim)((0,W.trim)(J," "),"	"),b.isWindows&&(J=(0,O.resolve)(V,J),J=(0,W.rtrim)(J,".")),J}toPath(V){const J=[V.path];return typeof V.line=="number"&&J.push(String(V.line)),typeof V.column=="number"&&J.push(String(V.column)),J.join(":")}}new j().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/06b54543d660353a04cdab6554d1f27266a537fd/core/vs/code/electron-main/main.js.map
