/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/network","vs/base/common/uri","vs/base/common/event","vs/base/node/pfs","vs/platform/log/common/log","fs","vs/base/common/errors","vs/base/common/buffer","vs/base/common/platform","vs/base/common/strings","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/platform/extensionManagement/common/extensionManagement","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/configuration/common/configurationRegistry","vs/base/common/errorMessage","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","child_process","vs/platform/extensions/common/extensions","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/base/common/uuid","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/map","vs/base/node/decoder","os","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/userDataPath","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/environment/node/environmentService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/base/common/normalization","vs/base/common/performance","vs/base/common/iterator","util","crypto","vs/base/common/process","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Z=function(x){for(var t=[],y=0,A=x.length;y<A;y++)t[y]=Y[x[y]];return t};define(Y[54],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function y(A,C){if(!A)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}t.ok=y}),define(Y[55],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0;function y(f){return(h,I,u)=>{let R=null,P=null;if(typeof u.value=="function"?(R="value",P=u.value):typeof u.get=="function"&&(R="get",P=u.get),!P)throw new Error("not supported");u[R]=f(P,I)}}t.createDecorator=y;let A=0;function C(){const f=`$memoize${A++}`;let h;const I=function(R,P,l){let D=null,p=null;if(typeof l.value=="function"?(D="value",p=l.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(D="get",p=l.get),!p)throw new Error("not supported");const g=`${f}:${P}`;l[D]=function(...v){return h=this,this.hasOwnProperty(g)||Object.defineProperty(this,g,{configurable:!0,enumerable:!1,writable:!0,value:p.apply(this,v)}),this[g]}};return I.clear=()=>{typeof h!="undefined"&&Object.getOwnPropertyNames(h).forEach(u=>{u.indexOf(f)===0&&delete h[u]})},I}t.createMemoizer=C;function E(f,h,I){return C()(f,h,I)}t.memoize=E;function k(f,h,I){return y((u,R)=>{const P=`$debounce$${R}`,l=`$debounce$result$${R}`;return function(...D){this[l]||(this[l]=I?I():void 0),clearTimeout(this[P]),h&&(this[l]=h(this[l],...D),D=[this[l]]),this[P]=setTimeout(()=>{u.apply(this,D),this[l]=I?I():void 0},f)}})}t.debounce=k;function T(f,h,I){return y((u,R)=>{const P=`$throttle$timer$${R}`,l=`$throttle$result$${R}`,D=`$throttle$lastRun$${R}`,p=`$throttle$pending$${R}`;return function(...g){if(this[l]||(this[l]=I?I():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),h&&(this[l]=h(this[l],...g)),!this[p]){const v=this[D]+f;v<=Date.now()?(this[D]=Date.now(),u.apply(this,[this[l]]),this[l]=I?I():void 0):(this[p]=!0,this[P]=setTimeout(()=>{this[p]=!1,this[D]=Date.now(),u.apply(this,[this[l]]),this[l]=I?I():void 0},v-Date.now()))}}})}t.throttle=T}),define(Y[21],Z([0,1,15]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function A(W,O=0){return W[W.length-(1+O)]}t.tail=A;function C(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}t.tail2=C;function E(W,O,S=(d,c)=>d===c){if(W===O)return!0;if(!W||!O||W.length!==O.length)return!1;for(let d=0,c=W.length;d<c;d++)if(!S(W[d],O[d]))return!1;return!0}t.equals=E;function k(W,O,S){let d=0,c=W.length-1;for(;d<=c;){const b=(d+c)/2|0,L=S(W[b],O);if(L<0)d=b+1;else if(L>0)c=b-1;else return b}return-(d+1)}t.binarySearch=k;function T(W,O){let S=0,d=W.length;if(d===0)return 0;for(;S<d;){const c=Math.floor((S+d)/2);O(W[c])?d=c:S=c+1}return S}t.findFirstInSorted=T;function f(W,O,S){if(W=W|0,W>=O.length)throw new TypeError("invalid index");let d=O[Math.floor(O.length*Math.random())],c=[],b=[],L=[];for(let N of O){const U=S(N,d);U<0?c.push(N):U>0?b.push(N):L.push(N)}return W<c.length?f(W,c,S):W<c.length+L.length?L[0]:f(W-(c.length+L.length),b,S)}t.quickSelect=f;function h(W,O){const S=[];let d;for(const c of W.slice(0).sort(O))!d||O(d[0],c)!==0?(d=[c],S.push(d)):d.push(c);return S}t.groupBy=h;function I(W,O,S){const d=[];function c(N,U,$){if(!(U===0&&$.length===0)){const _=d[d.length-1];_&&_.start+_.deleteCount===N?(_.deleteCount+=U,_.toInsert.push(...$)):d.push({start:N,deleteCount:U,toInsert:$})}}let b=0,L=0;for(;;){if(b===W.length){c(b,0,O.slice(L));break}if(L===O.length){c(b,W.length-b,[]);break}const N=W[b],U=O[L],$=S(N,U);$===0?(b+=1,L+=1):$<0?(c(b,1,[]),b+=1):$>0&&(c(b,0,[U]),L+=1)}return d}t.sortedDiff=I;function u(W,O,S){const d=I(W,O,S),c=[],b=[];for(const L of d)c.push(...W.slice(L.start,L.start+L.deleteCount)),b.push(...L.toInsert);return{removed:c,added:b}}t.delta=u;function R(W,O,S){if(S===0)return[];const d=W.slice(0,S).sort(O);return l(W,O,d,S,W.length),d}t.top=R;function P(W,O,S,d,c){return S===0?Promise.resolve([]):new Promise((b,L)=>{(async()=>{const N=W.length,U=W.slice(0,S).sort(O);for(let $=S,_=Math.min(S+d,N);$<N;$=_,_=Math.min(_+d,N)){if($>S&&await new Promise(q=>setTimeout(q)),c&&c.isCancellationRequested)throw(0,y.canceled)();l(W,O,U,$,_)}return U})().then(b,L)})}t.topAsync=P;function l(W,O,S,d,c){for(const b=S.length;d<c;d++){const L=W[d];if(O(L,S[b-1])<0){S.pop();const N=T(S,U=>O(L,U)<0);S.splice(N,0,L)}}}function D(W){return W.filter(O=>!!O)}t.coalesce=D;function p(W){let O=0;for(let S=0;S<W.length;S++)W[S]&&(W[O]=W[S],O+=1);W.length=O}t.coalesceInPlace=p;function g(W,O,S){W.splice(S,0,W.splice(O,1)[0])}t.move=g;function v(W){return!Array.isArray(W)||W.length===0}t.isFalsyOrEmpty=v;function w(W){return Array.isArray(W)&&W.length>0}t.isNonEmptyArray=w;function o(W,O){if(!O)return W.filter((d,c)=>W.indexOf(d)===c);const S=Object.create(null);return W.filter(d=>{const c=O(d);return S[c]?!1:(S[c]=!0,!0)})}t.distinct=o;function i(W){const O=new Set;return W.filter(S=>O.has(S)?!1:(O.add(S),!0))}t.distinctES6=i;function e(W){const O=Object.create(null);return S=>{const d=W(S);return O[d]?!1:(O[d]=!0,!0)}}t.uniqueFilter=e;function n(W,O){for(let S=W.length-1;S>=0;S--){const d=W[S];if(O(d))return S}return-1}t.lastIndex=n;function s(W,O){return W.length>0?W[0]:O}t.firstOrDefault=s;function a(W,O,S=(d,c)=>d===c){let d=0;for(let c=0,b=Math.min(W.length,O.length);c<b&&S(W[c],O[c]);c++)d++;return d}t.commonPrefixLength=a;function r(W){return[].concat(...W)}t.flatten=r;function m(W,O){let S=typeof O=="number"?W:0;typeof O=="number"?S=W:(S=0,O=W);const d=[];if(S<=O)for(let c=S;c<O;c++)d.push(c);else for(let c=S;c>O;c--)d.push(c);return d}t.range=m;function j(W,O,S){return W.reduce((d,c)=>(d[O(c)]=S?S(c):c,d),Object.create(null))}t.index=j;function M(W,O){return W.push(O),()=>F(W,O)}t.insert=M;function F(W,O){const S=W.indexOf(O);if(S>-1)return W.splice(S,1),O}t.remove=F;function z(W,O,S){const d=W.slice(0,O),c=W.slice(O);return d.concat(S,c)}t.arrayInsert=z;function B(W,O){let S;if(typeof O=="number"){let d=O;S=()=>{const c=Math.sin(d++)*179426549;return c-Math.floor(c)}}else S=Math.random;for(let d=W.length-1;d>0;d-=1){const c=Math.floor(S()*(d+1)),b=W[d];W[d]=W[c],W[c]=b}}t.shuffle=B;function H(W,O){const S=W.indexOf(O);S>-1&&(W.splice(S,1),W.unshift(O))}t.pushToStart=H;function X(W,O){const S=W.indexOf(O);S>-1&&(W.splice(S,1),W.push(O))}t.pushToEnd=X;function se(W,O){return Array.isArray(W)?W.map(O):O(W)}t.mapArrayOrNot=se;function re(W){return Array.isArray(W)?W:[W]}t.asArray=re;function ee(W){return W[Math.floor(Math.random()*W.length)]}t.getRandomElement=ee;function le(W,O){for(const S of W){const d=O(S);if(d!==void 0)return d}}t.mapFind=le}),define(Y[56],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var y;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(y=t.ScanError||(t.ScanError={}));var A;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(A=t.SyntaxKind||(t.SyntaxKind={}));var C;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(C=t.ParseErrorCode||(t.ParseErrorCode={}));var E;(function(e){e.DEFAULT={allowTrailingComma:!0}})(E=t.ParseOptions||(t.ParseOptions={}));function k(e,n=!1){let s=0,a=e.length,r="",m=0,j=16,M=0;function F(ee){let le=0,W=0;for(;le<ee;){const O=e.charCodeAt(s);if(O>=48&&O<=57)W=W*16+O-48;else if(O>=65&&O<=70)W=W*16+O-65+10;else if(O>=97&&O<=102)W=W*16+O-97+10;else break;s++,le++}return le<ee&&(W=-1),W}function z(ee){s=ee,r="",m=0,j=16,M=0}function B(){const ee=s;if(e.charCodeAt(s)===48)s++;else for(s++;s<e.length&&h(e.charCodeAt(s));)s++;if(s<e.length&&e.charCodeAt(s)===46)if(s++,s<e.length&&h(e.charCodeAt(s)))for(s++;s<e.length&&h(e.charCodeAt(s));)s++;else return M=3,e.substring(ee,s);let le=s;if(s<e.length&&(e.charCodeAt(s)===69||e.charCodeAt(s)===101))if(s++,(s<e.length&&e.charCodeAt(s)===43||e.charCodeAt(s)===45)&&s++,s<e.length&&h(e.charCodeAt(s))){for(s++;s<e.length&&h(e.charCodeAt(s));)s++;le=s}else M=3;return e.substring(ee,le)}function H(){let ee="",le=s;for(;;){if(s>=a){ee+=e.substring(le,s),M=2;break}const W=e.charCodeAt(s);if(W===34){ee+=e.substring(le,s),s++;break}if(W===92){if(ee+=e.substring(le,s),s++,s>=a){M=2;break}switch(e.charCodeAt(s++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const S=F(4);S>=0?ee+=String.fromCharCode(S):M=4;break;default:M=5}le=s;continue}if(W>=0&&W<=31)if(f(W)){ee+=e.substring(le,s),M=2;break}else M=6;s++}return ee}function X(){if(r="",M=0,m=s,s>=a)return m=a,j=17;let ee=e.charCodeAt(s);if(T(ee)){do s++,r+=String.fromCharCode(ee),ee=e.charCodeAt(s);while(T(ee));return j=15}if(f(ee))return s++,r+=String.fromCharCode(ee),ee===13&&e.charCodeAt(s)===10&&(s++,r+=`
`),j=14;switch(ee){case 123:return s++,j=1;case 125:return s++,j=2;case 91:return s++,j=3;case 93:return s++,j=4;case 58:return s++,j=6;case 44:return s++,j=5;case 34:return s++,r=H(),j=10;case 47:const le=s-1;if(e.charCodeAt(s+1)===47){for(s+=2;s<a&&!f(e.charCodeAt(s));)s++;return r=e.substring(le,s),j=12}if(e.charCodeAt(s+1)===42){s+=2;const W=a-1;let O=!1;for(;s<W;){if(e.charCodeAt(s)===42&&e.charCodeAt(s+1)===47){s+=2,O=!0;break}s++}return O||(s++,M=1),r=e.substring(le,s),j=13}return r+=String.fromCharCode(ee),s++,j=16;case 45:if(r+=String.fromCharCode(ee),s++,s===a||!h(e.charCodeAt(s)))return j=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=B(),j=11;default:for(;s<a&&se(ee);)s++,ee=e.charCodeAt(s);if(m!==s){switch(r=e.substring(m,s),r){case"true":return j=8;case"false":return j=9;case"null":return j=7}return j=16}return r+=String.fromCharCode(ee),s++,j=16}}function se(ee){if(T(ee)||f(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ee;do ee=X();while(ee>=12&&ee<=15);return ee}return{setPosition:z,getPosition:()=>s,scan:n?re:X,getToken:()=>j,getTokenValue:()=>r,getTokenOffset:()=>m,getTokenLength:()=>s-m,getTokenError:()=>M}}t.createScanner=k;function T(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function f(e){return e===10||e===13||e===8232||e===8233}function h(e){return e>=48&&e<=57}var I;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(I||(I={}));function u(e,n){const s=[],a=new Object;let r;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let j=!1;function M(F,z,B,H){m.value=F,m.offset=z,m.length=B,m.type=H,m.colonOffset=void 0,r=m}try{w(e,{onObjectBegin:(F,z)=>{if(n<=F)throw a;r=void 0,j=n>F,s.push("")},onObjectProperty:(F,z,B)=>{if(n<z||(M(F,z,B,"property"),s[s.length-1]=F,n<=z+B))throw a},onObjectEnd:(F,z)=>{if(n<=F)throw a;r=void 0,s.pop()},onArrayBegin:(F,z)=>{if(n<=F)throw a;r=void 0,s.push(0)},onArrayEnd:(F,z)=>{if(n<=F)throw a;r=void 0,s.pop()},onLiteralValue:(F,z,B)=>{if(n<z||(M(F,z,B,i(F)),n<=z+B))throw a},onSeparator:(F,z,B)=>{if(n<=z)throw a;if(F===":"&&r&&r.type==="property")r.colonOffset=z,j=!1,r=void 0;else if(F===","){const H=s[s.length-1];typeof H=="number"?s[s.length-1]=H+1:(j=!0,s[s.length-1]=""),r=void 0}}})}catch(F){if(F!==a)throw F}return{path:s,previousNode:r,isAtPropertyKey:j,matches:F=>{let z=0;for(let B=0;z<F.length&&B<s.length;B++)if(F[z]===s[B]||F[z]==="*")z++;else if(F[z]!=="**")return!1;return z===F.length}}}t.getLocation=u;function R(e,n=[],s=E.DEFAULT){let a=null,r=[];const m=[];function j(F){Array.isArray(r)?r.push(F):a!==null&&(r[a]=F)}return w(e,{onObjectBegin:()=>{const F={};j(F),m.push(r),r=F,a=null},onObjectProperty:F=>{a=F},onObjectEnd:()=>{r=m.pop()},onArrayBegin:()=>{const F=[];j(F),m.push(r),r=F,a=null},onArrayEnd:()=>{r=m.pop()},onLiteralValue:j,onError:(F,z,B)=>{n.push({error:F,offset:z,length:B})}},s),r[0]}t.parse=R;function P(e,n=[],s=E.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(F){a.type==="property"&&(a.length=F-a.offset,a=a.parent)}function m(F){return a.children.push(F),F}w(e,{onObjectBegin:F=>{a=m({type:"object",offset:F,length:-1,parent:a,children:[]})},onObjectProperty:(F,z,B)=>{a=m({type:"property",offset:z,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:F,offset:z,length:B,parent:a})},onObjectEnd:(F,z)=>{a.length=F+z-a.offset,a=a.parent,r(F+z)},onArrayBegin:(F,z)=>{a=m({type:"array",offset:F,length:-1,parent:a,children:[]})},onArrayEnd:(F,z)=>{a.length=F+z-a.offset,a=a.parent,r(F+z)},onLiteralValue:(F,z,B)=>{m({type:i(F),offset:z,length:B,parent:a,value:F}),r(z+B)},onSeparator:(F,z,B)=>{a.type==="property"&&(F===":"?a.colonOffset=z:F===","&&r(z))},onError:(F,z,B)=>{n.push({error:F,offset:z,length:B})}},s);const M=a.children[0];return M&&delete M.parent,M}t.parseTree=P;function l(e,n){if(!!e){let s=e;for(let a of n)if(typeof a=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const m of s.children)if(Array.isArray(m.children)&&m.children[0].value===a){s=m.children[1],r=!0;break}if(!r)return}else{const r=a;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}}t.findNodeAtLocation=l;function D(e){if(!e.parent||!e.parent.children)return[];const n=D(e.parent);if(e.parent.type==="property"){const s=e.parent.children[0].value;n.push(s)}else if(e.parent.type==="array"){const s=e.parent.children.indexOf(e);s!==-1&&n.push(s)}return n}t.getNodePath=D;function p(e){switch(e.type){case"array":return e.children.map(p);case"object":const n=Object.create(null);for(let s of e.children){const a=s.children[1];a&&(n[s.children[0].value]=p(a))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=p;function g(e,n,s=!1){return n>=e.offset&&n<e.offset+e.length||s&&n===e.offset+e.length}t.contains=g;function v(e,n,s=!1){if(g(e,n,s)){const a=e.children;if(Array.isArray(a))for(let r=0;r<a.length&&a[r].offset<=n;r++){const m=v(a[r],n,s);if(m)return m}return e}}t.findNodeAtOffset=v;function w(e,n,s=E.DEFAULT){const a=k(e,!1);function r(U){return U?()=>U(a.getTokenOffset(),a.getTokenLength()):()=>!0}function m(U){return U?$=>U($,a.getTokenOffset(),a.getTokenLength()):()=>!0}const j=r(n.onObjectBegin),M=m(n.onObjectProperty),F=r(n.onObjectEnd),z=r(n.onArrayBegin),B=r(n.onArrayEnd),H=m(n.onLiteralValue),X=m(n.onSeparator),se=r(n.onComment),re=m(n.onError),ee=s&&s.disallowComments,le=s&&s.allowTrailingComma;function W(){for(;;){const U=a.scan();switch(a.getTokenError()){case 4:O(14);break;case 5:O(15);break;case 3:O(13);break;case 1:ee||O(11);break;case 2:O(12);break;case 6:O(16);break}switch(U){case 12:case 13:ee?O(10):se();break;case 16:O(1);break;case 15:case 14:break;default:return U}}}function O(U,$=[],_=[]){if(re(U),$.length+_.length>0){let q=a.getToken();for(;q!==17;){if($.indexOf(q)!==-1){W();break}else if(_.indexOf(q)!==-1)break;q=W()}}}function S(U){const $=a.getTokenValue();return U?H($):M($),W(),!0}function d(){switch(a.getToken()){case 11:let U=0;try{U=JSON.parse(a.getTokenValue()),typeof U!="number"&&(O(2),U=0)}catch($){O(2)}H(U);break;case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return W(),!0}function c(){return a.getToken()!==10?(O(3,[],[2,5]),!1):(S(!1),a.getToken()===6?(X(":"),W(),N()||O(4,[],[2,5])):O(5,[],[2,5]),!0)}function b(){j(),W();let U=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(U||O(4,[],[]),X(","),W(),a.getToken()===2&&le)break}else U&&O(6,[],[]);c()||O(4,[],[2,5]),U=!0}return F(),a.getToken()!==2?O(7,[2],[]):W(),!0}function L(){z(),W();let U=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(U||O(4,[],[]),X(","),W(),a.getToken()===4&&le)break}else U&&O(6,[],[]);N()||O(4,[],[4,5]),U=!0}return B(),a.getToken()!==4?O(8,[4],[]):W(),!0}function N(){switch(a.getToken()){case 3:return L();case 1:return b();case 10:return S(!0);default:return d()}}return W(),a.getToken()===17?s.allowEmptyContent?!0:(O(4,[],[]),!1):N()?(a.getToken()!==17&&O(9,[],[]),!0):(O(4,[],[]),!1)}t.visit=w;function o(e,n){let s=k(e),a=[],r,m=0,j;do switch(j=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:m!==j&&a.push(e.substring(m,j)),n!==void 0&&a.push(s.getTokenValue().replace(/[^\r\n]/g,n)),m=s.getPosition();break}while(r!==17);return a.join("")}t.stripComments=o;function i(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=i});"use strict";(function(){function x(C){const E=[];typeof C=="number"&&E.push("code/timeOrigin",C);function k(f){E.push(f,Date.now())}function T(){const f=[];for(let h=0;h<E.length;h+=2)f.push({name:E[h],startTime:E[h+1]});return f}return{mark:k,getMarks:T}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const E=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const k of performance.getEntriesByType("mark"))E.push({name:k.name,startTime:Math.round(C+k.startTime)});return E}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=t()),C.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=y(A))})(),function(x,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var y=t();for(var A in y)(typeof exports=="object"?exports:x)[A]=y[A]}}(typeof self!="undefined"?self:this,function(){return function(x){var t={};function y(A){if(t[A])return t[A].exports;var C=t[A]={i:A,l:!1,exports:{}};return x[A].call(C.exports,C,C.exports,y),C.l=!0,C.exports}return y.m=x,y.c=t,y.d=function(A,C,E){y.o(A,C)||Object.defineProperty(A,C,{enumerable:!0,get:E})},y.r=function(A){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},y.t=function(A,C){if(1&C&&(A=y(A)),8&C||4&C&&typeof A=="object"&&A&&A.__esModule)return A;var E=Object.create(null);if(y.r(E),Object.defineProperty(E,"default",{enumerable:!0,value:A}),2&C&&typeof A!="string")for(var k in A)y.d(E,k,function(T){return A[T]}.bind(null,k));return E},y.n=function(A){var C=A&&A.__esModule?function(){return A.default}:function(){return A};return y.d(C,"a",C),C},y.o=function(A,C){return Object.prototype.hasOwnProperty.call(A,C)},y.p="",y(y.s=0)}([function(x,t,y){(function(A){var C;t=x.exports=_,C=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var E=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,T=t.re=[],f=t.src=[],h=0,I=h++;f[I]="0|[1-9]\\d*";var u=h++;f[u]="[0-9]+";var R=h++;f[R]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=h++;f[P]="("+f[I]+")\\.("+f[I]+")\\.("+f[I]+")";var l=h++;f[l]="("+f[u]+")\\.("+f[u]+")\\.("+f[u]+")";var D=h++;f[D]="(?:"+f[I]+"|"+f[R]+")";var p=h++;f[p]="(?:"+f[u]+"|"+f[R]+")";var g=h++;f[g]="(?:-("+f[D]+"(?:\\."+f[D]+")*))";var v=h++;f[v]="(?:-?("+f[p]+"(?:\\."+f[p]+")*))";var w=h++;f[w]="[0-9A-Za-z-]+";var o=h++;f[o]="(?:\\+("+f[w]+"(?:\\."+f[w]+")*))";var i=h++,e="v?"+f[P]+f[g]+"?"+f[o]+"?";f[i]="^"+e+"$";var n="[v=\\s]*"+f[l]+f[v]+"?"+f[o]+"?",s=h++;f[s]="^"+n+"$";var a=h++;f[a]="((?:<|>)?=?)";var r=h++;f[r]=f[u]+"|x|X|\\*";var m=h++;f[m]=f[I]+"|x|X|\\*";var j=h++;f[j]="[v=\\s]*("+f[m]+")(?:\\.("+f[m]+")(?:\\.("+f[m]+")(?:"+f[g]+")?"+f[o]+"?)?)?";var M=h++;f[M]="[v=\\s]*("+f[r]+")(?:\\.("+f[r]+")(?:\\.("+f[r]+")(?:"+f[v]+")?"+f[o]+"?)?)?";var F=h++;f[F]="^"+f[a]+"\\s*"+f[j]+"$";var z=h++;f[z]="^"+f[a]+"\\s*"+f[M]+"$";var B=h++;f[B]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=h++;f[H]="(?:~>?)";var X=h++;f[X]="(\\s*)"+f[H]+"\\s+",T[X]=new RegExp(f[X],"g");var se=h++;f[se]="^"+f[H]+f[j]+"$";var re=h++;f[re]="^"+f[H]+f[M]+"$";var ee=h++;f[ee]="(?:\\^)";var le=h++;f[le]="(\\s*)"+f[ee]+"\\s+",T[le]=new RegExp(f[le],"g");var W=h++;f[W]="^"+f[ee]+f[j]+"$";var O=h++;f[O]="^"+f[ee]+f[M]+"$";var S=h++;f[S]="^"+f[a]+"\\s*("+n+")$|^$";var d=h++;f[d]="^"+f[a]+"\\s*("+e+")$|^$";var c=h++;f[c]="(\\s*)"+f[a]+"\\s*("+n+"|"+f[j]+")",T[c]=new RegExp(f[c],"g");var b=h++;f[b]="^\\s*("+f[j]+")\\s+-\\s+("+f[j]+")\\s*$";var L=h++;f[L]="^\\s*("+f[M]+")\\s+-\\s+("+f[M]+")\\s*$";var N=h++;f[N]="(<|>)?=?\\s*\\*";for(var U=0;U<35;U++)C(U,f[U]),T[U]||(T[U]=new RegExp(f[U]));function $(V,G){if(V instanceof _)return V;if(typeof V!="string"||V.length>E||!(G?T[s]:T[i]).test(V))return null;try{return new _(V,G)}catch(K){return null}}function _(V,G){if(V instanceof _){if(V.loose===G)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>E)throw new TypeError("version is longer than "+E+" characters");if(!(this instanceof _))return new _(V,G);C("SemVer",V,G),this.loose=G;var K=V.trim().match(G?T[s]:T[i]);if(!K)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(ie){if(/^[0-9]+$/.test(ie)){var oe=+ie;if(oe>=0&&oe<k)return oe}return ie}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=$,t.valid=function(V,G){var K=$(V,G);return K?K.version:null},t.clean=function(V,G){var K=$(V.trim().replace(/^[=v]+/,""),G);return K?K.version:null},t.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(V){return C("SemVer.compare",this.version,this.loose,V),V instanceof _||(V=new _(V,this.loose)),this.compareMain(V)||this.comparePre(V)},_.prototype.compareMain=function(V){return V instanceof _||(V=new _(V,this.loose)),J(this.major,V.major)||J(this.minor,V.minor)||J(this.patch,V.patch)},_.prototype.comparePre=function(V){if(V instanceof _||(V=new _(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var G=0;do{var K=this.prerelease[G],ie=V.prerelease[G];if(C("prerelease compare",G,K,ie),K===void 0&&ie===void 0)return 0;if(ie===void 0)return 1;if(K===void 0)return-1;if(K!==ie)return J(K,ie)}while(++G)},_.prototype.inc=function(V,G){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},t.inc=function(V,G,K,ie){typeof K=="string"&&(ie=K,K=void 0);try{return new _(V,K).inc(G,ie).version}catch(oe){return null}},t.diff=function(V,G){if(de(V,G))return null;var K=$(V),ie=$(G);if(K.prerelease.length||ie.prerelease.length){for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==ie[oe])return"pre"+oe;return"prerelease"}for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==ie[oe])return oe},t.compareIdentifiers=J;var q=/^[0-9]+$/;function J(V,G){var K=q.test(V),ie=q.test(G);return K&&ie&&(V=+V,G=+G),K&&!ie?-1:ie&&!K?1:V<G?-1:V>G?1:0}function Q(V,G,K){return new _(V,K).compare(new _(G,K))}function te(V,G,K){return Q(V,G,K)>0}function ne(V,G,K){return Q(V,G,K)<0}function de(V,G,K){return Q(V,G,K)===0}function me(V,G,K){return Q(V,G,K)!==0}function Ie(V,G,K){return Q(V,G,K)>=0}function Le(V,G,K){return Q(V,G,K)<=0}function Te(V,G,K,ie){var oe;switch(G){case"===":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),oe=V===K;break;case"!==":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),oe=V!==K;break;case"":case"=":case"==":oe=de(V,K,ie);break;case"!=":oe=me(V,K,ie);break;case">":oe=te(V,K,ie);break;case">=":oe=Ie(V,K,ie);break;case"<":oe=ne(V,K,ie);break;case"<=":oe=Le(V,K,ie);break;default:throw new TypeError("Invalid operator: "+G)}return oe}function Pe(V,G){if(V instanceof Pe){if(V.loose===G)return V;V=V.value}if(!(this instanceof Pe))return new Pe(V,G);C("comparator",V,G),this.loose=G,this.parse(V),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}t.rcompareIdentifiers=function(V,G){return J(G,V)},t.major=function(V,G){return new _(V,G).major},t.minor=function(V,G){return new _(V,G).minor},t.patch=function(V,G){return new _(V,G).patch},t.compare=Q,t.compareLoose=function(V,G){return Q(V,G,!0)},t.rcompare=function(V,G,K){return Q(G,V,K)},t.sort=function(V,G){return V.sort(function(K,ie){return t.compare(K,ie,G)})},t.rsort=function(V,G){return V.sort(function(K,ie){return t.rcompare(K,ie,G)})},t.gt=te,t.lt=ne,t.eq=de,t.neq=me,t.gte=Ie,t.lte=Le,t.cmp=Te,t.Comparator=Pe;var Ae={};function ve(V,G){if(V instanceof ve)return V.loose===G?V:new ve(V.raw,G);if(V instanceof Pe)return new ve(V.value,G);if(!(this instanceof ve))return new ve(V,G);if(this.loose=G,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Oe(V){return!V||V.toLowerCase()==="x"||V==="*"}function Be(V,G,K,ie,oe,we,he,Re,ye,De,ke,Ee,Se){return((G=Oe(K)?"":Oe(ie)?">="+K+".0.0":Oe(oe)?">="+K+"."+ie+".0":">="+G)+" "+(Re=Oe(ye)?"":Oe(De)?"<"+(+ye+1)+".0.0":Oe(ke)?"<"+ye+"."+(+De+1)+".0":Ee?"<="+ye+"."+De+"."+ke+"-"+Ee:"<="+Re)).trim()}function _e(V,G){for(var K=0;K<V.length;K++)if(!V[K].test(G))return!1;if(G.prerelease.length){for(K=0;K<V.length;K++)if(C(V[K].semver),V[K].semver!==Ae&&V[K].semver.prerelease.length>0){var ie=V[K].semver;if(ie.major===G.major&&ie.minor===G.minor&&ie.patch===G.patch)return!0}return!1}return!0}function je(V,G,K){try{G=new ve(G,K)}catch(ie){return!1}return G.test(V)}function ze(V,G,K,ie){var oe,we,he,Re,ye;switch(V=new _(V,ie),G=new ve(G,ie),K){case">":oe=te,we=Le,he=ne,Re=">",ye=">=";break;case"<":oe=ne,we=Ie,he=te,Re="<",ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(V,G,ie))return!1;for(var De=0;De<G.set.length;++De){var ke=G.set[De],Ee=null,Se=null;if(ke.forEach(function(Ce){Ce.semver===Ae&&(Ce=new Pe(">=0.0.0")),Ee=Ee||Ce,Se=Se||Ce,oe(Ce.semver,Ee.semver,ie)?Ee=Ce:he(Ce.semver,Se.semver,ie)&&(Se=Ce)}),Ee.operator===Re||Ee.operator===ye||(!Se.operator||Se.operator===Re)&&we(V,Se.semver)||Se.operator===ye&&he(V,Se.semver))return!1}return!0}Pe.prototype.parse=function(V){var G=this.loose?T[S]:T[d],K=V.match(G);if(!K)throw new TypeError("Invalid comparator: "+V);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new _(K[2],this.loose):this.semver=Ae},Pe.prototype.toString=function(){return this.value},Pe.prototype.test=function(V){return C("Comparator.test",V,this.loose),this.semver===Ae||(typeof V=="string"&&(V=new _(V,this.loose)),Te(V,this.operator,this.semver,this.loose))},Pe.prototype.intersects=function(V,G){if(!(V instanceof Pe))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ve(V.value,G),je(this.value,K,G);if(V.operator==="")return K=new ve(this.value,G),je(V.semver,K,G);var ie=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),we=this.semver.version===V.semver.version,he=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Re=Te(this.semver,"<",V.semver,G)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),ye=Te(this.semver,">",V.semver,G)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return ie||oe||we&&he||Re||ye},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(V){var G=this.loose;V=V.trim(),C("range",V,G);var K=G?T[L]:T[b];V=V.replace(K,Be),C("hyphen replace",V),V=V.replace(T[c],"$1$2$3"),C("comparator trim",V,T[c]),V=(V=(V=V.replace(T[X],"$1~")).replace(T[le],"$1^")).split(/\s+/).join(" ");var ie=G?T[S]:T[d],oe=V.split(" ").map(function(we){return function(he,Re){return C("comp",he),he=function(ye,De){return ye.trim().split(/\s+/).map(function(ke){return function(Ee,Se){C("caret",Ee,Se);var Ce=Se?T[O]:T[W];return Ee.replace(Ce,function(Fe,ae,ue,ge,pe){var be;return C("caret",Ee,Fe,ae,ue,ge,pe),Oe(ae)?be="":Oe(ue)?be=">="+ae+".0.0 <"+(+ae+1)+".0.0":Oe(ge)?be=ae==="0"?">="+ae+"."+ue+".0 <"+ae+"."+(+ue+1)+".0":">="+ae+"."+ue+".0 <"+(+ae+1)+".0.0":pe?(C("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),be=ae==="0"?ue==="0"?">="+ae+"."+ue+"."+ge+pe+" <"+ae+"."+ue+"."+(+ge+1):">="+ae+"."+ue+"."+ge+pe+" <"+ae+"."+(+ue+1)+".0":">="+ae+"."+ue+"."+ge+pe+" <"+(+ae+1)+".0.0"):(C("no pr"),be=ae==="0"?ue==="0"?">="+ae+"."+ue+"."+ge+" <"+ae+"."+ue+"."+(+ge+1):">="+ae+"."+ue+"."+ge+" <"+ae+"."+(+ue+1)+".0":">="+ae+"."+ue+"."+ge+" <"+(+ae+1)+".0.0"),C("caret return",be),be})}(ke,De)}).join(" ")}(he,Re),C("caret",he),he=function(ye,De){return ye.trim().split(/\s+/).map(function(ke){return function(Ee,Se){var Ce=Se?T[re]:T[se];return Ee.replace(Ce,function(Fe,ae,ue,ge,pe){var be;return C("tilde",Ee,Fe,ae,ue,ge,pe),Oe(ae)?be="":Oe(ue)?be=">="+ae+".0.0 <"+(+ae+1)+".0.0":Oe(ge)?be=">="+ae+"."+ue+".0 <"+ae+"."+(+ue+1)+".0":pe?(C("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),be=">="+ae+"."+ue+"."+ge+pe+" <"+ae+"."+(+ue+1)+".0"):be=">="+ae+"."+ue+"."+ge+" <"+ae+"."+(+ue+1)+".0",C("tilde return",be),be})}(ke,De)}).join(" ")}(he,Re),C("tildes",he),he=function(ye,De){return C("replaceXRanges",ye,De),ye.split(/\s+/).map(function(ke){return function(Ee,Se){Ee=Ee.trim();var Ce=Se?T[z]:T[F];return Ee.replace(Ce,function(Fe,ae,ue,ge,pe,be){C("xRange",Ee,Fe,ae,ue,ge,pe,be);var Ue=Oe(ue),Me=Ue||Oe(ge),Ne=Me||Oe(pe);return ae==="="&&Ne&&(ae=""),Ue?Fe=ae===">"||ae==="<"?"<0.0.0":"*":ae&&Ne?(Me&&(ge=0),Ne&&(pe=0),ae===">"?(ae=">=",Me?(ue=+ue+1,ge=0,pe=0):Ne&&(ge=+ge+1,pe=0)):ae==="<="&&(ae="<",Me?ue=+ue+1:ge=+ge+1),Fe=ae+ue+"."+ge+"."+pe):Me?Fe=">="+ue+".0.0 <"+(+ue+1)+".0.0":Ne&&(Fe=">="+ue+"."+ge+".0 <"+ue+"."+(+ge+1)+".0"),C("xRange return",Fe),Fe})}(ke,De)}).join(" ")}(he,Re),C("xrange",he),he=function(ye,De){return C("replaceStars",ye,De),ye.trim().replace(T[N],"")}(he,Re),C("stars",he),he}(we,G)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(we){return!!we.match(ie)})),oe=oe.map(function(we){return new Pe(we,G)})},ve.prototype.intersects=function(V,G){if(!(V instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(ie){return V.set.some(function(oe){return oe.every(function(we){return ie.intersects(we,G)})})})})},t.toComparators=function(V,G){return new ve(V,G).set.map(function(K){return K.map(function(ie){return ie.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new _(V,this.loose));for(var G=0;G<this.set.length;G++)if(_e(this.set[G],V))return!0;return!1},t.satisfies=je,t.maxSatisfying=function(V,G,K){var ie=null,oe=null;try{var we=new ve(G,K)}catch(he){return null}return V.forEach(function(he){we.test(he)&&(ie&&oe.compare(he)!==-1||(oe=new _(ie=he,K)))}),ie},t.minSatisfying=function(V,G,K){var ie=null,oe=null;try{var we=new ve(G,K)}catch(he){return null}return V.forEach(function(he){we.test(he)&&(ie&&oe.compare(he)!==1||(oe=new _(ie=he,K)))}),ie},t.validRange=function(V,G){try{return new ve(V,G).range||"*"}catch(K){return null}},t.ltr=function(V,G,K){return ze(V,G,"<",K)},t.gtr=function(V,G,K){return ze(V,G,">",K)},t.outside=ze,t.prerelease=function(V,G){var K=$(V,G);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(V,G,K){return V=new ve(V,K),G=new ve(G,K),V.intersects(G)},t.coerce=function(V){if(V instanceof _)return V;if(typeof V!="string")return null;var G=V.match(T[B]);return G==null?null:$((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,y(1))},function(x,t){var y,A,C=x.exports={};function E(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function T(p){if(y===setTimeout)return setTimeout(p,0);if((y===E||!y)&&setTimeout)return y=setTimeout,setTimeout(p,0);try{return y(p,0)}catch(g){try{return y.call(null,p,0)}catch(v){return y.call(this,p,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:E}catch(p){y=E}try{A=typeof clearTimeout=="function"?clearTimeout:k}catch(p){A=k}})();var f,h=[],I=!1,u=-1;function R(){I&&f&&(I=!1,f.length?h=f.concat(h):u=-1,h.length&&P())}function P(){if(!I){var p=T(R);I=!0;for(var g=h.length;g;){for(f=h,h=[];++u<g;)f&&f[u].run();u=-1,g=h.length}f=null,I=!1,function(v){if(A===clearTimeout)return clearTimeout(v);if((A===k||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(v);try{A(v)}catch(w){try{return A.call(null,v)}catch(o){return A.call(this,v)}}}(p)}}function l(p,g){this.fun=p,this.array=g}function D(){}C.nextTick=function(p){var g=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)g[v-1]=arguments[v];h.push(new l(p,g)),h.length!==1||I||T(P)},l.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=D,C.addListener=D,C.once=D,C.off=D,C.removeListener=D,C.removeAllListeners=D,C.emit=D,C.prependListener=D,C.prependOnceListener=D,C.listeners=function(p){return[]},C.binding=function(p){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(p){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Y[31],Z([0,1,15,2]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.transform=t.toReadable=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function C(p){const g=p;return g&&[g.on,g.pause,g.resume,g.destroy].every(v=>typeof v=="function")}t.isReadableStream=C;function E(p){const g=p;return g&&C(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean"}t.isReadableBufferedStream=E;function k(p,g){return new T(p,g)}t.newWriteableStream=k;class T{constructor(g,v){this.reducer=g,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){var v;if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof((v=this.options)===null||v===void 0?void 0:v.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(w=>this.pendingWritePromises.push(w))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(v=>v(g))}emitError(g){this.listeners.error.length===0?(0,y.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(v=>v(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,v){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(g,v){if(!this.state.destroyed){let w;switch(g){case"data":w=this.listeners.data;break;case"end":w=this.listeners.end;break;case"error":w=this.listeners.error;break}if(w){const o=w.indexOf(v);o>=0&&w.splice(o,1)}}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(w=>w())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(p,g){const v=[];let w;for(;(w=p.read())!==null;)v.push(w);return g(v)}t.consumeReadable=f;function h(p,g,v){const w=[];let o;for(;(o=p.read())!==null&&w.length<v;)w.push(o);return o===null&&w.length>0?g(w):{read:()=>{if(w.length>0)return w.shift();if(typeof o!="undefined"){const i=o;return o=void 0,i}return p.read()}}}t.peekReadable=h;function I(p,g){return new Promise((v,w)=>{const o=[];u(p,{onData:i=>{g&&o.push(i)},onError:i=>{g?w(i):v(void 0)},onEnd:()=>{v(g?g(o):void 0)}})})}t.consumeStream=I;function u(p,g){p.on("error",v=>g.onError(v)),p.on("end",()=>g.onEnd()),p.on("data",v=>g.onData(v))}t.listenStream=u;function R(p,g){return new Promise((v,w)=>{const o=new A.DisposableStore,i=[],e=a=>{if(i.push(a),i.length>g)return o.dispose(),p.pause(),v({stream:p,buffer:i,ended:!1})},n=a=>w(a),s=()=>v({stream:p,buffer:i,ended:!0});o.add((0,A.toDisposable)(()=>p.removeListener("error",n))),p.on("error",n),o.add((0,A.toDisposable)(()=>p.removeListener("end",s))),p.on("end",s),o.add((0,A.toDisposable)(()=>p.removeListener("data",e))),p.on("data",e)})}t.peekStream=R;function P(p,g){const v=k(g);return v.end(p),v}t.toStream=P;function l(p){let g=!1;return{read:()=>g?null:(g=!0,p)}}t.toReadable=l;function D(p,g,v){const w=k(v);return u(p,{onData:o=>w.write(g.data(o)),onError:o=>w.error(g.error?g.error(o):o),onEnd:()=>w.end()}),w}t.transform=D}),define(Y[16],Z([0,1,18,31]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const C=typeof Buffer!="undefined",E=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let T,f;class h{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return C?new h(Buffer.allocUnsafe(r)):new h(new Uint8Array(r))}static wrap(r){return C&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new h(r)}static fromString(r,m){return!((m==null?void 0:m.dontUseNodeBuffer)||!1)&&C?new h(Buffer.from(r)):E?(T||(T=new TextEncoder),new h(T.encode(r))):new h(y.encodeUTF8(r))}static concat(r,m){if(typeof m=="undefined"){m=0;for(let F=0,z=r.length;F<z;F++)m+=r[F].byteLength}const j=h.alloc(m);let M=0;for(let F=0,z=r.length;F<z;F++){const B=r[F];j.set(B,M),M+=B.byteLength}return j}toString(){return C?this.buffer.toString():k?(f||(f=new TextDecoder),f.decode(this.buffer)):y.decodeUTF8(this.buffer)}slice(r,m){return new h(this.buffer.subarray(r,m))}set(r,m){r instanceof h?this.buffer.set(r.buffer,m):this.buffer.set(r,m)}readUInt32BE(r){return R(this.buffer,r)}writeUInt32BE(r,m){P(this.buffer,r,m)}readUInt32LE(r){return l(this.buffer,r)}writeUInt32LE(r,m){D(this.buffer,r,m)}readUInt8(r){return p(this.buffer,r)}writeUInt8(r,m){g(this.buffer,r,m)}}t.VSBuffer=h;function I(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0}t.readUInt16LE=I;function u(a,r,m){a[m+0]=r&255,r=r>>>8,a[m+1]=r&255}t.writeUInt16LE=u;function R(a,r){return a[r]*2**24+a[r+1]*2**16+a[r+2]*2**8+a[r+3]}t.readUInt32BE=R;function P(a,r,m){a[m+3]=r,r=r>>>8,a[m+2]=r,r=r>>>8,a[m+1]=r,r=r>>>8,a[m]=r}t.writeUInt32BE=P;function l(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0|a[r+2]<<16>>>0|a[r+3]<<24>>>0}t.readUInt32LE=l;function D(a,r,m){a[m+0]=r&255,r=r>>>8,a[m+1]=r&255,r=r>>>8,a[m+2]=r&255,r=r>>>8,a[m+3]=r&255}t.writeUInt32LE=D;function p(a,r){return a[r]}t.readUInt8=p;function g(a,r,m){a[m]=r}t.writeUInt8=g;function v(a){return A.consumeReadable(a,r=>h.concat(r))}t.readableToBuffer=v;function w(a){return A.toReadable(a)}t.bufferToReadable=w;function o(a){return A.consumeStream(a,r=>h.concat(r))}t.streamToBuffer=o;async function i(a){return a.ended?h.concat(a.buffer):h.concat([...a.buffer,await o(a.stream)])}t.bufferedStreamToBuffer=i;function e(a){return A.toStream(a,r=>h.concat(r))}t.bufferToStream=e;function n(a){return A.transform(a,{data:r=>typeof r=="string"?h.fromString(r):h.wrap(r)},r=>h.concat(r))}t.streamToBufferReadableStream=n;function s(a){return A.newWriteableStream(r=>h.concat(r),a)}t.newWriteableBufferStream=s}),define(Y[19],Z([0,1,8]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function A(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const D=Array.isArray(l)?[]:{};return Object.keys(l).forEach(p=>{l[p]&&typeof l[p]=="object"?D[p]=A(l[p]):D[p]=l[p]}),D}t.deepClone=A;function C(l){if(!l||typeof l!="object")return l;const D=[l];for(;D.length>0;){const p=D.shift();Object.freeze(p);for(const g in p)if(E.call(p,g)){const v=p[g];typeof v=="object"&&!Object.isFrozen(v)&&D.push(v)}}return l}t.deepFreeze=C;const E=Object.prototype.hasOwnProperty;function k(l,D){return T(l,D,new Set)}t.cloneAndChange=k;function T(l,D,p){if((0,y.isUndefinedOrNull)(l))return l;const g=D(l);if(typeof g!="undefined")return g;if((0,y.isArray)(l)){const v=[];for(const w of l)v.push(T(w,D,p));return v}if((0,y.isObject)(l)){if(p.has(l))throw new Error("Cannot clone recursive data-structure");p.add(l);const v={};for(let w in l)E.call(l,w)&&(v[w]=T(l[w],D,p));return p.delete(l),v}return l}function f(l,D,p=!0){return(0,y.isObject)(l)?((0,y.isObject)(D)&&Object.keys(D).forEach(g=>{g in l?p&&((0,y.isObject)(l[g])&&(0,y.isObject)(D[g])?f(l[g],D[g],p):l[g]=D[g]):l[g]=D[g]}),l):D}t.mixin=f;function h(l,D){if(l===D)return!0;if(l==null||D===null||D===void 0||typeof l!=typeof D||typeof l!="object"||Array.isArray(l)!==Array.isArray(D))return!1;let p,g;if(Array.isArray(l)){if(l.length!==D.length)return!1;for(p=0;p<l.length;p++)if(!h(l[p],D[p]))return!1}else{const v=[];for(g in l)v.push(g);v.sort();const w=[];for(g in D)w.push(g);if(w.sort(),!h(v,w))return!1;for(p=0;p<v.length;p++)if(!h(l[v[p]],D[v[p]]))return!1}return!0}t.equals=h;function I(l){const D=new Set;return JSON.stringify(l,(p,g)=>{if((0,y.isObject)(g)||Array.isArray(g)){if(D.has(g))return"[Circular]";D.add(g)}return g})}t.safeStringify=I;function u(l,D,p){const g=D(l);return typeof g=="undefined"?p:g}t.getOrDefault=u;function R(l,D){const p=Object.create(null);return!l||!D||Object.keys(D).forEach(v=>{const w=l[v],o=D[v];h(w,o)||(p[v]=o)}),p}t.distinct=R;function P(l,D){const p=D.toLowerCase(),g=Object.keys(l).find(v=>v.toLowerCase()===p);return g?l[g]:l[D]}t.getCaseInsensitive=P}),define(Y[57],Z([0,1,10]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function A(h){const I=h;return I&&typeof I.type=="string"&&typeof I.severity=="string"}t.isRemoteConsoleLog=A;function C(h){const I=[];let u;try{const R=JSON.parse(h.arguments),P=R[R.length-1];P&&P.__$stack&&(R.pop(),u=P.__$stack),I.push(...R)}catch(R){I.push("Unable to log remote console arguments",h.arguments)}return{args:I,stack:u}}t.parse=C;function E(h){if(typeof h!="string")return E(C(h).stack);const I=h;if(I){const u=k(I),R=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(R&&R.length===4)return{uri:y.URI.file(R[1]),line:Number(R[2]),column:Number(R[3])}}}t.getFirstFrame=E;function k(h){if(!h)return h;const I=h.indexOf(`
`);return I===-1?h:h.substring(0,I)}function T(h,I){const{args:u,stack:R}=C(h),P=typeof u[0]=="string"&&u.length===1;let l=k(R);l&&(l=`(${l.trim()})`);let D=[];if(typeof u[0]=="string"?l&&P?D=[`%c[${I}] %c${u[0]} %c${l}`,f("blue"),f(""),f("grey")]:D=[`%c[${I}] %c${u[0]}`,f("blue"),f(""),...u.slice(1)]:D=[`%c[${I}]%`,f("blue"),...u],l&&!P&&D.push(l),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,D)}t.log=T;function f(h){return`color: ${h}`}}),define(Y[58],Z([0,1,16,18,10]),function(x,t,y,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function E(h){return JSON.stringify(h,T)}t.stringify=E;function k(h){let I=JSON.parse(h);return I=f(I),I}t.parse=k;function T(h,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,A.regExpFlags)(I)}:I}function f(h,I=0){if(!h||I>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return C.URI.revive(h);case 2:return new RegExp(h.source,h.flags)}if(h instanceof y.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let u=0;u<h.length;++u)h[u]=f(h[u],I+1);else for(const u in h)Object.hasOwnProperty.call(h,u)&&(h[u]=f(h[u],I+1))}return h}t.revive=f}),define(Y[59],Z([0,1,18,32,3,43,4]),function(x,t,y,A,C,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function T(){return Object.create(null)}t.getEmptyExpression=T;const f="**",h="/",I="[/\\\\]",u="[^/\\\\]",R=/\//g;function P(c){switch(c){case 0:return"";case 1:return`${u}*?`;default:return`(?:${I}|${u}+${I}|${I}${u}+)*?`}}function l(c,b){if(!c)return[];const L=[];let N=!1,U=!1,$="";for(const _ of c){switch(_){case b:if(!N&&!U){L.push($),$="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":U=!0;break;case"]":U=!1;break}$+=_}return $&&L.push($),L}t.splitGlobAware=l;function D(c){if(!c)return"";let b="";const L=l(c,h);if(L.every(N=>N===f))b=".*";else{let N=!1;L.forEach((U,$)=>{if(U===f){N||(b+=P(2),N=!0);return}let _=!1,q="",J=!1,Q="";for(const te of U){if(te!=="}"&&_){q+=te;continue}if(J&&(te!=="]"||!Q)){let ne;te==="-"?ne=te:(te==="^"||te==="!")&&!Q?ne="^":te===h?ne="":ne=y.escapeRegExpCharacters(te),Q+=ne;continue}switch(te){case"{":_=!0;continue;case"[":J=!0;continue;case"}":b+=`(?:${l(q,",").map(me=>D(me)).join("|")})`,_=!1,q="";break;case"]":b+="["+Q+"]",J=!1,Q="";break;case"?":b+=u;continue;case"*":b+=P(1);continue;default:b+=y.escapeRegExpCharacters(te)}}$<L.length-1&&(L[$+1]!==f||$+2<L.length)&&(b+=I),N=!1})}return b}const p=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,w=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new E.LRUCache(1e4),n=function(){return!1},s=function(){return null};function a(c,b){if(!c)return s;let L;typeof c!="string"?L=c.pattern:L=c,L=L.trim();const N=`${L}_${!!b.trimForExclusions}`;let U=e.get(N);if(U)return r(U,c);let $;if(p.test(L)){const _=L.substr(4);U=function(q,J){return typeof q=="string"&&q.endsWith(_)?L:null}}else($=g.exec(m(L,b)))?U=j($[1],L):(b.trimForExclusions?w:v).test(L)?U=M(L,b):($=o.exec(m(L,b)))?U=F($[1].substr(1),L,!0):($=i.exec(m(L,b)))?U=F($[1],L,!1):U=z(L);return e.set(N,U),r(U,c)}function r(c,b){return typeof b=="string"?c:function(L,N){return A.isEqualOrParent(L,b.base)?c(C.relative(b.base,L),N):null}}function m(c,b){return b.trimForExclusions&&c.endsWith("/**")?c.substr(0,c.length-2):c}function j(c,b){const L=`/${c}`,N=`\\${c}`,U=function(_,q){return typeof _!="string"?null:q?q===c?b:null:_===c||_.endsWith(L)||_.endsWith(N)?b:null},$=[c];return U.basenames=$,U.patterns=[b],U.allBasenames=$,U}function M(c,b){const L=d(c.slice(1,-1).split(",").map(q=>a(q,b)).filter(q=>q!==s),c),N=L.length;if(!N)return s;if(N===1)return L[0];const U=function(q,J){for(let Q=0,te=L.length;Q<te;Q++)if(L[Q](q,J))return c;return null},$=L.find(q=>!!q.allBasenames);$&&(U.allBasenames=$.allBasenames);const _=L.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return _.length&&(U.allPaths=_),U}function F(c,b,L){const N=C.sep===C.posix.sep,U=N?c:c.replace(R,C.sep),$=C.sep+U,_=C.posix.sep+c,q=L?function(J,Q){return typeof J=="string"&&(J===U||J.endsWith($)||!N&&(J===c||J.endsWith(_)))?b:null}:function(J,Q){return typeof J=="string"&&(J===U||!N&&J===c)?b:null};return q.allPaths=[(L?"*/":"./")+c],q}function z(c){try{const b=new RegExp(`^${D(c)}$`);return function(L){return b.lastIndex=0,typeof L=="string"&&b.test(L)?c:null}}catch(b){return s}}function B(c,b,L){return!c||typeof b!="string"?!1:H(c)(b,void 0,L)}t.match=B;function H(c,b={}){if(!c)return n;if(typeof c=="string"||ee(c)){const L=a(c,b);if(L===s)return n;const N=function(U,$){return!!L(U,$)};return L.allBasenames&&(N.allBasenames=L.allBasenames),L.allPaths&&(N.allPaths=L.allPaths),N}return O(c,b)}t.parse=H;function X(c){if(!!c){let b;return L=>(b||(b=(c()||Promise.resolve([])).then(N=>N?re(N):{})),b.then(N=>!!N[L]))}}t.hasSiblingPromiseFn=X;function se(c){if(!!c){let b;return L=>{if(!b){const N=c();b=N?re(N):{}}return!!b[L]}}}t.hasSiblingFn=se;function re(c){const b={};for(const L of c)b[L]=!0;return b}function ee(c){const b=c;return b&&typeof b.base=="string"&&typeof b.pattern=="string"}t.isRelativePattern=ee;function le(c){return c.allBasenames||[]}t.getBasenameTerms=le;function W(c){return c.allPaths||[]}t.getPathTerms=W;function O(c,b){const L=d(Object.getOwnPropertyNames(c).map(q=>S(q,c[q],b)).filter(q=>q!==s)),N=L.length;if(!N)return s;if(!L.some(q=>!!q.requiresSiblings)){if(N===1)return L[0];const q=function(te,ne){for(let de=0,me=L.length;de<me;de++){const Ie=L[de](te,ne);if(Ie)return Ie}return null},J=L.find(te=>!!te.allBasenames);J&&(q.allBasenames=J.allBasenames);const Q=L.reduce((te,ne)=>ne.allPaths?te.concat(ne.allPaths):te,[]);return Q.length&&(q.allPaths=Q),q}const U=function(q,J,Q){let te;for(let ne=0,de=L.length;ne<de;ne++){const me=L[ne];me.requiresSiblings&&Q&&(J||(J=C.basename(q)),te||(te=J.substr(0,J.length-C.extname(q).length)));const Ie=me(q,J,te,Q);if(Ie)return Ie}return null},$=L.find(q=>!!q.allBasenames);$&&(U.allBasenames=$.allBasenames);const _=L.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return _.length&&(U.allPaths=_),U}function S(c,b,L){if(b===!1)return s;const N=a(c,L);if(N===s)return s;if(typeof b=="boolean")return N;if(b){const U=b.when;if(typeof U=="string"){const $=(_,q,J,Q)=>{if(!Q||!N(_,q))return null;const te=U.replace("$(basename)",J),ne=Q(te);return(0,k.isThenable)(ne)?ne.then(de=>de?c:null):ne?c:null};return $.requiresSiblings=!0,$}}return N}function d(c,b){const L=c.filter(q=>!!q.basenames);if(L.length<2)return c;const N=L.reduce((q,J)=>{const Q=J.basenames;return Q?q.concat(Q):q},[]);let U;if(b){U=[];for(let q=0,J=N.length;q<J;q++)U.push(b)}else U=L.reduce((q,J)=>{const Q=J.patterns;return Q?q.concat(Q):q},[]);const $=function(q,J){if(typeof q!="string")return null;if(!J){let te;for(te=q.length;te>0;te--){const ne=q.charCodeAt(te-1);if(ne===47||ne===92)break}J=q.substr(te)}const Q=N.indexOf(J);return Q!==-1?U[Q]:null};$.basenames=N,$.patterns=U,$.allBasenames=N;const _=c.filter(q=>!q.basenames);return _.push($),_}}),define(Y[60],Z([0,1,10,3,18,9,17,20,32]),function(x,t,y,A,C,E,k,T,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function h(a,r,m){if(typeof a=="string"&&(a=y.URI.file(a)),m){const M=m.getWorkspaceFolder(a);if(M){const F=m.getWorkspace().folders.length>1;let z;if((0,T.isEqual)(M.uri,a)?z="":z=(0,T.relativePath)(M.uri,a),F){const B=M.name?M.name:(0,T.basename)(M.uri);z=z?B+" \u2022 "+z:B}return z}}if(a.scheme!==E.Schemas.file&&a.scheme!==E.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(a.fsPath))return(0,A.normalize)(u(a.fsPath));let j=(0,A.normalize)(a.fsPath);return!k.isWindows&&(r==null?void 0:r.userHome)&&(j=P(j,r.userHome.fsPath)),j}t.getPathLabel=h;function I(a){if(!!a){typeof a=="string"&&(a=y.URI.file(a));const r=(0,T.basename)(a)||(a.scheme===E.Schemas.file?a.fsPath:a.path);return k.isWindows&&(0,f.isRootOrDriveLetter)(r)?u(r):r}}t.getBaseLabel=I;function u(a){return(0,f.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}t.normalizeDriveLetter=u;let R=Object.create(null);function P(a,r){if(k.isWindows||!a||!r)return a;let m=R.original===r?R.normalized:void 0;return m||(m=`${(0,C.rtrim)(r,A.posix.sep)}${A.posix.sep}`,R={original:r,normalized:m}),(k.isLinux?a.startsWith(m):(0,C.startsWithIgnoreCase)(a,m))&&(a=`~/${a.substr(m.length)}`),a}t.tildify=P;function l(a,r){return a.replace(/^~($|\/|\\)/,`${r}$1`)}t.untildify=l;const D="\u2026",p="\\\\",g="~";function v(a,r=A.sep){const m=new Array(a.length);let j=!1;for(let M=0;M<a.length;M++){let F=a[M];if(F===""){m[M]=`.${r}`;continue}if(!F){m[M]=F;continue}j=!0;let z="";F.indexOf(p)===0?(z=F.substr(0,F.indexOf(p)+p.length),F=F.substr(F.indexOf(p)+p.length)):F.indexOf(r)===0?(z=F.substr(0,F.indexOf(r)+r.length),F=F.substr(F.indexOf(r)+r.length)):F.indexOf(g)===0&&(z=F.substr(0,F.indexOf(g)+g.length),F=F.substr(F.indexOf(g)+g.length));const B=F.split(r);for(let H=1;j&&H<=B.length;H++)for(let X=B.length-H;j&&X>=0;X--){j=!1;let se=B.slice(X,X+H).join(r);for(let re=0;!j&&re<a.length;re++)if(re!==M&&a[re]&&a[re].indexOf(se)>-1){const ee=X+H===B.length,le=X>0&&a[re].indexOf(r)>-1?r+se:se,W=a[re].endsWith(le);j=!ee||W}if(!j){let re="";(B[0].endsWith(":")||z!=="")&&(X===1&&(X=0,H++,se=B[0]+r+se),X>0&&(re=B[0]+r),re=z+re),X>0&&(re=re+D+r),re=re+se,X+H<B.length&&(re=re+r+D),m[M]=re}}j&&(m[M]=F)}return m}t.shorten=v;var w;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function o(a,r=Object.create(null)){const m=[];let j=!1,M="";for(const F of a)if(F==="$"||j&&F==="{")M&&m.push({value:M,type:w.TEXT}),M="",j=!0;else if(F==="}"&&j){const z=r[M];if(typeof z=="string")z.length&&m.push({value:z,type:w.VARIABLE});else if(z){const B=m[m.length-1];(!B||B.type!==w.SEPARATOR)&&m.push({value:z.label,type:w.SEPARATOR})}M="",j=!1}else M+=F;return M&&!j&&m.push({value:M,type:w.TEXT}),m.filter((F,z)=>{if(F.type===w.SEPARATOR){const B=m[z-1],H=m[z+1];return[B,H].every(X=>X&&(X.type===w.VARIABLE||X.type===w.TEXT)&&X.value.length>0)}return!0}).map(F=>F.value).join("")}t.template=o;function i(a,r){return k.isMacintosh||r?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):a.replace(/&&|&/g,m=>m==="&"?"&&":"&")}t.mnemonicMenuLabel=i;function e(a,r){return k.isMacintosh||r?a.replace(/\(&&\w\)|&&/g,""):k.isWindows?a.replace(/&&|&/g,m=>m==="&"?"&&":"&"):a.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function n(a){return a.replace(/&/g,"&&")}t.unmnemonicLabel=n;function s(a){const r=a.indexOf("/")!==-1?A.posix:A.win32,m=r.basename(a),j=r.dirname(a);return m.length?{name:m,parentPath:j}:{name:j,parentPath:""}}t.splitName=s}),define(Y[44],Z([0,1,119]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class A{constructor(E="utf8"){this.stringDecoder=new y.StringDecoder(E),this.remaining=null}write(E){const k=[],T=this.remaining?this.remaining+this.stringDecoder.write(E):this.stringDecoder.write(E);if(T.length<1)return k;let f=0,h,I=f;for(;I<T.length;)if(h=T.charCodeAt(I),h===13||h===10){if(k.push(T.substring(f,I)),I++,I<T.length){const u=h;h=T.charCodeAt(I),(u===13&&h===10||u===10&&h===13)&&I++}f=I}else I++;return this.remaining=f<T.length?T.substr(f):null,k}end(){return this.remaining}}t.LineDecoder=A}),define(Y[61],Z([0,1,14,18,3,12]),function(x,t,y,A,C,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function k(I){const u=(0,C.dirname)(I);if(I===u)return I;const R=((0,C.basename)(I)||I).toLowerCase();try{const l=(0,E.readdirSync)(u).filter(D=>D.toLowerCase()===R);if(l.length===1){const D=k(u);if(D)return(0,C.join)(D,l[0])}else if(l.length>1){const D=l.indexOf(R);if(D>=0){const p=k(u);if(p)return(0,C.join)(p,l[D])}}}catch(P){}return null}t.realcaseSync=k;async function T(I){try{return await y.promises.realpath(I)}catch(u){const R=h(I);return await y.promises.access(R,y.constants.R_OK),R}}t.realpath=T;function f(I){try{return y.realpathSync(I)}catch(u){const R=h(I);return y.accessSync(R,y.constants.R_OK),R}}t.realpathSync=f;function h(I){return(0,A.rtrim)((0,C.normalize)(I),C.sep)}}),function(){"use strict";function x(t,y,A){function C(){let E=process.env.VSCODE_APPDATA;if(!E)switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=t.join(k,"AppData","Roaming")}break;case"darwin":E=t.join(y.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||t.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(E,A)}return{getDefaultUserDataPath:C}}if(typeof define=="function")define(Y[62],Z([0,120,45,9,20]),function(t,y,A,C,E){const k=E.dirname(C.FileAccess.asFileUri("",t)),T=t.__$__nodeRequire(E.joinPath(k,"package.json").fsPath);return x(y,A,T.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../package.json"),y=require("path"),A=require("os");module.exports=x(y,A,t.name)}else throw new Error("Unknown context")}(),define(Y[63],Z([0,1,3,14,17,121,2,12]),function(x,t,y,A,C,E,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function f(u,R,P){return I({path:u,isDirectory:!1},R,P)}t.watchFile=f;function h(u,R,P){return I({path:u,isDirectory:!0},R,P)}t.watchFolder=h,t.CHANGE_BUFFER_DELAY=100;function I(u,R,P){const l=(0,y.basename)(u.path),D=new Map;let p=!1,g=[(0,k.toDisposable)(()=>{D.forEach(v=>(0,k.dispose)(v)),D.clear()})];try{const v=(0,A.watch)(u.path);g.push((0,k.toDisposable)(()=>{v.removeAllListeners(),v.close()}));const w=new Set;u.isDirectory&&(0,T.readdir)(u.path).then(o=>o.forEach(i=>w.add(i))),v.on("error",(o,i)=>{p||P(`Failed to watch ${u.path} for changes using fs.watch() (${o}, ${i})`)}),v.on("change",(o,i)=>{if(!p){let e="";if(i&&(e=i.toString(),C.isMacintosh&&(e=(0,E.normalizeNFC)(e))),!(!e||o!=="change"&&o!=="rename")){const n=u.isDirectory?(0,y.join)(u.path,e):u.path;if(u.isDirectory)if(o==="rename"){const s=D.get(n);s&&(0,k.dispose)(s);const a=setTimeout(async()=>{D.delete(n);const r=await(0,T.exists)(n);if(!p){let m;r?w.has(e)?m="changed":(m="added",w.add(e)):(w.delete(e),m="deleted"),R(m,n)}},t.CHANGE_BUFFER_DELAY);D.set(n,(0,k.toDisposable)(()=>clearTimeout(a)))}else{let s;w.has(e)?s="changed":(s="added",w.add(e)),R(s,n)}else if(o==="rename"||e!==l){const s=setTimeout(async()=>{const a=await(0,T.exists)(n);p||(a?(R("changed",n),g=[I(u,R,P)]):R("deleted",n))},t.CHANGE_BUFFER_DELAY);(0,k.dispose)(g),g=[(0,k.toDisposable)(()=>clearTimeout(s))]}else R("changed",n)}}})}catch(v){(0,T.exists)(u.path).then(w=>{w&&!p&&P(`Failed to watch ${u.path} for changes using fs.watch() (${v.toString()})`)})}return(0,k.toDisposable)(()=>{p=!0,g=(0,k.dispose)(g)})}}),define(Y[33],Z([0,1,11,2,4,28,15,16,21,8,58,18]),function(x,t,y,A,C,E,k,T,f,h,I,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var R;(function(S){S[S.Promise=100]="Promise",S[S.PromiseCancel=101]="PromiseCancel",S[S.EventListen=102]="EventListen",S[S.EventDispose=103]="EventDispose"})(R=t.RequestType||(t.RequestType={}));function P(S){switch(S){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(S){S[S.Initialize=200]="Initialize",S[S.PromiseSuccess=201]="PromiseSuccess",S[S.PromiseError=202]="PromiseError",S[S.PromiseErrorObj=203]="PromiseErrorObj",S[S.EventFire=204]="EventFire"})(l=t.ResponseType||(t.ResponseType={}));function D(S){switch(S){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(S){S[S.Uninitialized=0]="Uninitialized",S[S.Idle=1]="Idle"})(p||(p={}));class g{constructor(d){this.buffer=d,this.pos=0}read(d){const c=this.buffer.slice(this.pos,this.pos+d);return this.pos+=c.byteLength,c}}class v{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(d){this.buffers.push(d)}}var w;(function(S){S[S.Undefined=0]="Undefined",S[S.String=1]="String",S[S.Buffer=2]="Buffer",S[S.VSBuffer=3]="VSBuffer",S[S.Array=4]="Array",S[S.Object=5]="Object"})(w||(w={}));function o(S){const d=T.VSBuffer.alloc(4);return d.writeUInt32BE(S,0),d}function i(S){return S.read(4).readUInt32BE(0)}function e(S){const d=T.VSBuffer.alloc(1);return d.writeUInt8(S,0),d}const n={Undefined:e(w.Undefined),String:e(w.String),Buffer:e(w.Buffer),VSBuffer:e(w.VSBuffer),Array:e(w.Array),Object:e(w.Object)},s=typeof Buffer!="undefined";function a(S,d){if(typeof d=="undefined")S.write(n.Undefined);else if(typeof d=="string"){const c=T.VSBuffer.fromString(d);S.write(n.String),S.write(o(c.byteLength)),S.write(c)}else if(s&&Buffer.isBuffer(d)){const c=T.VSBuffer.wrap(d);S.write(n.Buffer),S.write(o(c.byteLength)),S.write(c)}else if(d instanceof T.VSBuffer)S.write(n.VSBuffer),S.write(o(d.byteLength)),S.write(d);else if(Array.isArray(d)){S.write(n.Array),S.write(o(d.length));for(const c of d)a(S,c)}else{const c=T.VSBuffer.fromString(JSON.stringify(d));S.write(n.Object),S.write(o(c.byteLength)),S.write(c)}}function r(S){switch(S.read(1).readUInt8(0)){case w.Undefined:return;case w.String:return S.read(i(S)).toString();case w.Buffer:return S.read(i(S)).buffer;case w.VSBuffer:return S.read(i(S));case w.Array:{const c=i(S),b=[];for(let L=0;L<c;L++)b.push(r(S));return b}case w.Object:return JSON.parse(S.read(i(S)).toString())}}class m{constructor(d,c,b=null,L=1e3){this.protocol=d,this.ctx=c,this.logger=b,this.timeoutDelay=L,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(d,c){this.channels.set(d,c),setTimeout(()=>this.flushPendingRequests(d),0)}sendResponse(d){switch(d.type){case 200:{const c=this.send([d.type]);this.logger&&this.logger.logOutgoing(c,0,1,D(d.type));return}case 201:case 202:case 204:case 203:{const c=this.send([d.type,d.id],d.data);this.logger&&this.logger.logOutgoing(c,d.id,1,D(d.type),d.data);return}}}send(d,c=void 0){const b=new v;return a(b,d),a(b,c),this.sendBuffer(b.buffer)}sendBuffer(d){try{return this.protocol.send(d),d.byteLength}catch(c){return 0}}onRawMessage(d){const c=new g(d),b=r(c),L=r(c),N=b[0];switch(N){case 100:return this.logger&&this.logger.logIncoming(d.byteLength,b[1],1,`${P(N)}: ${b[2]}.${b[3]}`,L),this.onPromise({type:N,id:b[1],channelName:b[2],name:b[3],arg:L});case 102:return this.logger&&this.logger.logIncoming(d.byteLength,b[1],1,`${P(N)}: ${b[2]}.${b[3]}`,L),this.onEventListen({type:N,id:b[1],channelName:b[2],name:b[3],arg:L});case 101:return this.logger&&this.logger.logIncoming(d.byteLength,b[1],1,`${P(N)}`),this.disposeActiveRequest({type:N,id:b[1]});case 103:return this.logger&&this.logger.logIncoming(d.byteLength,b[1],1,`${P(N)}`),this.disposeActiveRequest({type:N,id:b[1]})}}onPromise(d){const c=this.channels.get(d.channelName);if(!c){this.collectPendingRequest(d);return}const b=new E.CancellationTokenSource;let L;try{L=c.call(this.ctx,d.name,d.arg,b.token)}catch($){L=Promise.reject($)}const N=d.id;L.then($=>{this.sendResponse({id:N,data:$,type:201}),this.activeRequests.delete(d.id)},$=>{$ instanceof Error?this.sendResponse({id:N,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.sendResponse({id:N,data:$,type:203}),this.activeRequests.delete(d.id)});const U=(0,A.toDisposable)(()=>b.cancel());this.activeRequests.set(d.id,U)}onEventListen(d){const c=this.channels.get(d.channelName);if(!c){this.collectPendingRequest(d);return}const b=d.id,N=c.listen(this.ctx,d.name,d.arg)(U=>this.sendResponse({id:b,data:U,type:204}));this.activeRequests.set(d.id,N)}disposeActiveRequest(d){const c=this.activeRequests.get(d.id);c&&(c.dispose(),this.activeRequests.delete(d.id))}collectPendingRequest(d){let c=this.pendingRequests.get(d.channelName);c||(c=[],this.pendingRequests.set(d.channelName,c));const b=setTimeout(()=>{console.error(`Unknown channel: ${d.channelName}`),d.type===100&&this.sendResponse({id:d.id,data:{name:"Unknown channel",message:`Channel name '${d.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);c.push({request:d,timeoutTimer:b})}flushPendingRequests(d){const c=this.pendingRequests.get(d);if(c){for(const b of c)switch(clearTimeout(b.timeoutTimer),b.request.type){case 100:this.onPromise(b.request);break;case 102:this.onEventListen(b.request);break}this.pendingRequests.delete(d)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(d=>d.dispose()),this.activeRequests.clear()}}t.ChannelServer=m;var j;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(j=t.RequestInitiator||(t.RequestInitiator={}));class M{constructor(d,c=null){this.protocol=d,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(b=>this.onBuffer(b)),this.logger=c}getChannel(d){const c=this;return{call(b,L,N){return c.isDisposed?Promise.reject(k.canceled()):c.requestPromise(d,b,L,N)},listen(b,L){return c.isDisposed?Promise.reject(k.canceled()):c.requestEvent(d,b,L)}}}requestPromise(d,c,b,L=E.CancellationToken.None){const N=this.lastRequestId++,$={id:N,type:100,channelName:d,name:c,arg:b};if(L.isCancellationRequested)return Promise.reject(k.canceled());let _;return new Promise((J,Q)=>{if(L.isCancellationRequested)return Q(k.canceled());const te=()=>{const Ie=Le=>{switch(Le.type){case 201:this.handlers.delete(N),J(Le.data);break;case 202:this.handlers.delete(N);const Te=new Error(Le.data.message);Te.stack=Le.data.stack,Te.name=Le.data.name,Q(Te);break;case 203:this.handlers.delete(N),Q(Le.data);break}};this.handlers.set(N,Ie),this.sendRequest($)};let ne=null;this.state===p.Idle?te():(ne=(0,C.createCancelablePromise)(Ie=>this.whenInitialized()),ne.then(()=>{ne=null,te()}));const de=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:N,type:101}),Q(k.canceled())},me=L.onCancellationRequested(de);_=(0,A.combinedDisposable)((0,A.toDisposable)(de),me),this.activeRequests.add(_)}).finally(()=>{this.activeRequests.delete(_)})}requestEvent(d,c,b){const L=this.lastRequestId++,U={id:L,type:102,channelName:d,name:c,arg:b};let $=null;const _=new y.Emitter({onFirstListenerAdd:()=>{$=(0,C.createCancelablePromise)(J=>this.whenInitialized()),$.then(()=>{$=null,this.activeRequests.add(_),this.sendRequest(U)})},onLastListenerRemove:()=>{$?($.cancel(),$=null):(this.activeRequests.delete(_),this.sendRequest({id:L,type:103}))}}),q=J=>_.fire(J.data);return this.handlers.set(L,q),_.event}sendRequest(d){switch(d.type){case 100:case 102:{const c=this.send([d.type,d.id,d.channelName,d.name],d.arg);this.logger&&this.logger.logOutgoing(c,d.id,0,`${P(d.type)}: ${d.channelName}.${d.name}`,d.arg);return}case 101:case 103:{const c=this.send([d.type,d.id]);this.logger&&this.logger.logOutgoing(c,d.id,0,P(d.type));return}}}send(d,c=void 0){const b=new v;return a(b,d),a(b,c),this.sendBuffer(b.buffer)}sendBuffer(d){try{return this.protocol.send(d),d.byteLength}catch(c){return 0}}onBuffer(d){const c=new g(d),b=r(c),L=r(c),N=b[0];switch(N){case 200:return this.logger&&this.logger.logIncoming(d.byteLength,0,0,D(N)),this.onResponse({type:b[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(d.byteLength,b[1],0,D(N),L),this.onResponse({type:b[0],id:b[1],data:L})}}onResponse(d){if(d.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const c=this.handlers.get(d.id);c&&c(d)}whenInitialized(){return this.state===p.Idle?Promise.resolve():y.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(d=>d.dispose()),this.activeRequests.clear()}}t.ChannelClient=M;class F{constructor(d){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,d(({protocol:c,onDidClientDisconnect:b})=>{y.Event.once(c.onMessage)(N=>{const U=new g(N),$=r(U),_=new m(c,$),q=new M(c);this.channels.forEach((Q,te)=>_.registerChannel(te,Q));const J={channelServer:_,channelClient:q,ctx:$};this._connections.add(J),this._onDidAddConnection.fire(J),b(()=>{_.dispose(),q.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const d=[];return this._connections.forEach(c=>d.push(c)),d}getChannel(d,c){const b=this;return{call(L,N,U){let $;if((0,h.isFunction)(c)){let q=(0,f.getRandomElement)(b.connections.filter(c));$=q?Promise.resolve(q):y.Event.toPromise(y.Event.filter(b.onDidAddConnection,c))}else $=c.routeCall(b,L,N);const _=$.then(q=>q.channelClient.getChannel(d));return B(_).call(L,N,U)},listen(L,N){if((0,h.isFunction)(c))return b.getMulticastEvent(d,c,L,N);const U=c.routeEvent(b,L,N).then($=>$.channelClient.getChannel(d));return B(U).listen(L,N)}}}getMulticastEvent(d,c,b,L){const N=this;let U=new A.DisposableStore;const $=new y.Emitter({onFirstListenerAdd:()=>{U=new A.DisposableStore;const _=new y.EventMultiplexer,q=new Map,J=te=>{const de=te.channelClient.getChannel(d).listen(b,L),me=_.add(de);q.set(te,me)},Q=te=>{const ne=q.get(te);!ne||(ne.dispose(),q.delete(te))};N.connections.filter(c).forEach(J),y.Event.filter(N.onDidAddConnection,c)(J,void 0,U),N.onDidRemoveConnection(Q,void 0,U),_.event($.fire,$,U),U.add(_)},onLastListenerRemove:()=>{U.dispose()}});return $.event}registerChannel(d,c){this.channels.set(d,c),this._connections.forEach(b=>{b.channelServer.registerChannel(d,c)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=F;class z{constructor(d,c,b=null){const L=new v;a(L,c),d.send(L.buffer),this.channelClient=new M(d,b),this.channelServer=new m(d,c,b)}getChannel(d){return this.channelClient.getChannel(d)}registerChannel(d,c){this.channelServer.registerChannel(d,c)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=z;function B(S){return{call(d,c,b){return S.then(L=>L.call(d,c,b))},listen(d,c){const b=new y.Relay;return S.then(L=>b.input=L.listen(d,c)),b.event}}}t.getDelayedChannel=B;function H(S){let d=!1;return{call(c,b,L){return d?S.call(c,b,L):(0,C.timeout)(0).then(()=>d=!0).then(()=>S.call(c,b,L))},listen(c,b){if(d)return S.listen(c,b);const L=new y.Relay;return(0,C.timeout)(0).then(()=>d=!0).then(()=>L.input=S.listen(c,b)),L.event}}}t.getNextTickChannel=H;class X{constructor(d){this.fn=d}routeCall(d){return this.route(d)}routeEvent(d){return this.route(d)}async route(d){for(const c of d.connections)if(await Promise.resolve(this.fn(c.ctx)))return Promise.resolve(c);return await y.Event.toPromise(d.onDidAddConnection),await this.route(d)}}t.StaticRouter=X;var se;(function(S){function d(L,N){const U=L,$=N&&N.disableMarshalling,_=new Map;for(const q in U)b(q)&&_.set(q,y.Event.buffer(U[q],!0));return new class{listen(q,J){const Q=_.get(J);if(Q)return Q;throw new Error(`Event not found: ${J}`)}call(q,J,Q){const te=U[J];if(typeof te=="function"){if(!$&&Array.isArray(Q))for(let ne=0;ne<Q.length;ne++)Q[ne]=(0,I.revive)(Q[ne]);return te.apply(U,Q)}throw new Error(`Method not found: ${J}`)}}}S.fromService=d;function c(L,N){const U=N&&N.disableMarshalling;return new Proxy({},{get($,_){var q;if(typeof _=="string")return((q=N==null?void 0:N.properties)===null||q===void 0?void 0:q.has(_))?N.properties.get(_):b(_)?L.listen(_):async function(...J){let Q;N&&!(0,h.isUndefinedOrNull)(N.context)?Q=[N.context,...J]:Q=J;const te=await L.call(_,Q);return U?te:(0,I.revive)(te)};throw new Error(`Property not found: ${String(_)}`)}})}S.toService=c;function b(L){return L[0]==="o"&&L[1]==="n"&&u.isUpperAsciiLetter(L.charCodeAt(2))}})(se=t.ProxyChannel||(t.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ee(S){if(Array.isArray(S))return S;if(S&&typeof S=="object"&&typeof S.toString=="function"){let d=S.toString();if(d!=="[object Object]")return d}return S}function le(S){return Array.isArray(S)?S.map(ee):ee(S)}function W(S,d,c,b,L,N,U){U=le(U);const $=re[L],_=$[b%$.length];let q=[`%c[${S}]%c[${String(d).padStart(7," ")}]%c[len: ${String(c).padStart(5," ")}]%c${String(b).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(N)?(q=q.concat(U),q.push(")")):q.push(U),console.log.apply(console,q)}t.logWithColors=W;class O{constructor(d,c){this._outgoingPrefix=d,this._incomingPrefix=c,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(d,c,b,L,N){this._totalOutgoing+=d,W(this._outgoingPrefix,this._totalOutgoing,d,c,b,L,N)}logIncoming(d,c,b,L,N){this._totalIncoming+=d,W(this._incomingPrefix,this._totalIncoming,d,c,b,L,N)}}t.IPCLogger=O}),define(Y[64],Z([0,1,2,11,4,8]),function(x,t,y,A,C,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var k;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=t.StorageHint||(t.StorageHint={}));var T;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(T||(T={}));class f extends y.Disposable{constructor(u,R=Object.create(null)){super();this.database=u,this.options=R,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=T.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(u=>this.onDidChangeItemsExternal(u)))}onDidChangeItemsExternal(u){var R,P;(R=u.changed)===null||R===void 0||R.forEach((l,D)=>this.accept(D,l)),(P=u.deleted)===null||P===void 0||P.forEach(l=>this.accept(l,void 0))}accept(u,R){if(this.state!==T.Closed){let P=!1;(0,E.isUndefinedOrNull)(R)?P=this.cache.delete(u):this.cache.get(u)!==R&&(this.cache.set(u,R),P=!0),P&&this._onDidChangeStorage.fire(u)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===T.None&&(this.state=T.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(u,R){const P=this.cache.get(u);return(0,E.isUndefinedOrNull)(P)?R:P}getBoolean(u,R){const P=this.get(u);return(0,E.isUndefinedOrNull)(P)?R:P==="true"}getNumber(u,R){const P=this.get(u);return(0,E.isUndefinedOrNull)(P)?R:parseInt(P,10)}async set(u,R){if(this.state!==T.Closed){if((0,E.isUndefinedOrNull)(R))return this.delete(u);const P=String(R);if(this.cache.get(u)!==P)return this.cache.set(u,P),this.pendingInserts.set(u,P),this.pendingDeletes.delete(u),this._onDidChangeStorage.fire(u),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(u){if(this.state!==T.Closed&&!!this.cache.delete(u))return this.pendingDeletes.has(u)||this.pendingDeletes.add(u),this.pendingInserts.delete(u),this._onDidChangeStorage.fire(u),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=T.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(u){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const u={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(u).finally(()=>{var R;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(R=this.whenFlushedCallbacks.pop())===null||R===void 0||R()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(u=>this.whenFlushedCallbacks.push(u))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class h{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(u){u.insert&&u.insert.forEach((R,P)=>this.items.set(P,R)),u.delete&&u.delete.forEach(R=>this.items.delete(R))}async close(){}}t.InMemoryStorageDatabase=h}),define(Y[65],Z([5,6]),function(x,t){return x.create("vs/base/common/date",t)}),define(Y[66],Z([0,1,65]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const A=60,C=A*60,E=C*24,k=E*7,T=E*30,f=E*365;function h(u,R){typeof u!="number"&&(u=u.getTime());const P=Math.round((new Date().getTime()-u)/1e3);if(P<-30)return(0,y.localize)(0,null,h(new Date().getTime()+P*1e3,!1));if(P<30)return(0,y.localize)(1,null);let l;return P<A?(l=P,R?l===1?(0,y.localize)(2,null,l):(0,y.localize)(3,null,l):l===1?(0,y.localize)(4,null,l):(0,y.localize)(5,null,l)):P<C?(l=Math.floor(P/A),R?l===1?(0,y.localize)(6,null,l):(0,y.localize)(7,null,l):l===1?(0,y.localize)(8,null,l):(0,y.localize)(9,null,l)):P<E?(l=Math.floor(P/C),R?l===1?(0,y.localize)(10,null,l):(0,y.localize)(11,null,l):l===1?(0,y.localize)(12,null,l):(0,y.localize)(13,null,l)):P<k?(l=Math.floor(P/E),R?l===1?(0,y.localize)(14,null,l):(0,y.localize)(15,null,l):l===1?(0,y.localize)(16,null,l):(0,y.localize)(17,null,l)):P<T?(l=Math.floor(P/k),R?l===1?(0,y.localize)(18,null,l):(0,y.localize)(19,null,l):l===1?(0,y.localize)(20,null,l):(0,y.localize)(21,null,l)):P<f?(l=Math.floor(P/T),R?l===1?(0,y.localize)(22,null,l):(0,y.localize)(23,null,l):l===1?(0,y.localize)(24,null,l):(0,y.localize)(25,null,l)):(l=Math.floor(P/f),R?l===1?(0,y.localize)(26,null,l):(0,y.localize)(27,null,l):l===1?(0,y.localize)(28,null,l):(0,y.localize)(29,null,l))}t.fromNow=h;function I(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=I}),define(Y[67],Z([5,6]),function(x,t){return x.create("vs/base/common/errorMessage",t)}),define(Y[30],Z([0,1,67,8,21]),function(x,t,y,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function E(h,I){return I&&(h.stack||h.stacktrace)?y.localize(0,null,T(h),k(h.stack)||k(h.stacktrace)):T(h)}function k(h){return Array.isArray(h)?h.join(`
`):h}function T(h){return typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?y.localize(1,null,h.message):h.message||y.localize(2,null)}function f(h=null,I=!1){if(!h)return y.localize(3,null);if(Array.isArray(h)){const u=C.coalesce(h),R=f(u[0],I);return u.length>1?y.localize(4,null,R,u.length):R}if(A.isString(h))return h;if(h.detail){const u=h.detail;if(u.error)return E(u.error,I);if(u.exception)return E(u.exception,I)}return h.stack?E(h,I):h.message?h.message:y.localize(5,null)}t.toErrorMessage=f}),define(Y[68],Z([5,6]),function(x,t){return x.create("vs/base/node/processes",t)}),define(Y[69],Z([0,1,3,14,12,34,68,8,19,32,17,44,9]),function(x,t,y,A,C,E,k,T,f,h,I,u,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function P(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(o,i){if(I.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};i&&(e.cwd=i);const n=E.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(s=>{n.once("error",a=>{s({success:!1,error:a})}),n.once("exit",(a,r)=>{s(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?P(e.status):1})}else if(I.isLinux||I.isMacintosh)try{const e=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(n=>{E.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(s,a,r)=>{n(s?{success:!1,error:s}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function D(o=process.env){return o.comspec||"cmd.exe"}t.getWindowsShell=D;class p{constructor(i,e,n,s){if(e!==void 0&&n!==void 0&&s!==void 0)this.cmd=i,this.args=e,this.shell=n,this.options=s;else{const a=i;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(process.env).forEach(r=>{a[r]=process.env[r]}),Object.keys(this.options.env).forEach(r=>{a[r]=this.options.env[r]}),this.options.env=a}}getSanitizedCommand(){let i=this.cmd.toLowerCase();const e=i.lastIndexOf(y.sep);return e!==-1&&(i=i.substring(e+1)),p.WellKnowCommands[i]?i:"other"}start(i){return I.isWindows&&(this.options&&this.options.cwd&&h.isUNC(this.options.cwd)||!this.options&&h.isUNC(process.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(e=>{let n,s;const a=new Promise((r,m)=>{n=r,s=m});if(e){let r=this.cmd;this.args&&(r=r+" "+this.args.join(" ")),this.childProcess=E.exec(r,this.options,(m,j,M)=>{this.childProcess=null;const F=m;F&&F.killed?s({killed:this.terminateRequested,stdout:j.toString(),stderr:M.toString()}):this.handleExec(n,i,m,j,M)})}else{let r=null;const m=j=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(j,n,i,s);const M={terminated:this.terminateRequested};T.isNumber(j)&&(M.cmdCode=j),n(M)};if(this.shell&&I.isWindows){const j=f.deepClone(this.options);j.windowsVerbatimArguments=!0,j.detached=!1;let M=!1,F=!1;const z=[];let B=this.ensureQuotes(this.cmd);z.push(B.value),M=B.quoted,this.args&&this.args.forEach(X=>{B=this.ensureQuotes(X),z.push(B.value),F=F&&B.quoted});const H=["/s","/c"];M?F?H.push('"'+z.join(" ")+'"'):z.length>1?H.push('"'+z[0]+'" '+z.slice(1).join(" ")):H.push('"'+z[0]+'"'):H.push(z.join(" ")),r=E.spawn(D(),H,j)}else this.cmd&&(r=E.spawn(this.cmd,this.args,this.options));r&&(this.childProcess=r,this.childProcessPromise=Promise.resolve(r),this.pidResolve&&(this.pidResolve(T.isNumber(r.pid)?r.pid:-1),this.pidResolve=void 0),r.on("error",j=>{this.childProcess=null,s({terminated:this.terminateRequested,error:j})}),r.pid&&(this.childProcess.on("close",m),this.handleSpawn(r,n,i,s,!0)))}return a})}handleClose(i,e,n,s){}ensureQuotes(i){return p.regexp.test(i)?{value:'"'+i+'"',quoted:!0}:{value:i,quoted:i.length>0&&i[0]==='"'&&i[i.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(i=>i.pid,i=>-1):new Promise(i=>{this.pidResolve=i})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(i=>(this.terminateRequested=!0,l(i,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),i=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(i=>{if(!this.shell||!I.isWindows)return i(!1);const e=E.spawn(D(),["/s","/c"]);e.on("error",n=>i(!0)),e.on("exit",n=>i(!1))})}}t.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class g extends p{constructor(i,e,n,s){super(i,e,n,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(i,e,n,s,a){[s,a].forEach((r,m)=>{const j=new u.LineDecoder;j.write(r).forEach(z=>{e({line:z,source:m===0?0:1})});const F=j.end();F&&e({line:F,source:m===0?0:1})}),i({terminated:this.terminateRequested,error:n})}handleSpawn(i,e,n,s,a){const r=new u.LineDecoder,m=new u.LineDecoder;i.stdout.on("data",j=>{r.write(j).forEach(F=>n({line:F,source:0}))}),i.stderr.on("data",j=>{m.write(j).forEach(F=>n({line:F,source:1}))}),this.stdoutLineDecoder=r,this.stderrLineDecoder=m}handleClose(i,e,n,s){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&n({line:a,source:0});const r=this.stderrLineDecoder?this.stderrLineDecoder.end():null;r&&n({line:r,source:1})}}t.LineProcess=g;function v(o){let i=[],e=!1;const n=function(s){if(e){i.push(s);return}(!o.send(s,r=>{if(r&&console.error(r),e=!1,i.length>0){const m=i.slice(0);i=[],m.forEach(j=>n(j))}})||I.isWindows)&&(e=!0)};return{send:n}}t.createQueuedSender=v;var w;(function(o){async function i(e,n,s){if(y.isAbsolute(e))return e;if(n===void 0&&(n=process.cwd()),y.dirname(e)!=="."||(s===void 0&&T.isString(process.env.PATH)&&(s=process.env.PATH.split(y.delimiter)),s===void 0||s.length===0))return y.join(n,e);async function r(m){return await C.exists(m)?!(await A.promises.stat(m)).isDirectory():!1}for(let m of s){let j;if(y.isAbsolute(m)?j=y.join(m,e):j=y.join(n,m,e),await r(j))return j;let M=j+".com";if(await r(M)||(M=j+".exe",await r(M)))return M}return y.join(n,e)}o.findExecutable=i})(w=t.win32||(t.win32={}))}),define(Y[46],Z([0,1,34,2,4,19,11,69,33,57,28,15,16,17]),function(x,t,y,A,C,E,k,T,f,h,I,u,R,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class l extends f.ChannelServer{constructor(g){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(w){}},onMessage:k.Event.fromNodeEventEmitter(process,"message",v=>R.VSBuffer.wrap(Buffer.from(v,"base64")))},g);process.once("disconnect",()=>this.dispose())}}t.Server=l;class D{constructor(g,v){this.modulePath=g,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new k.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new C.Delayer(w),this.child=null,this._client=null}getChannel(g){const v=this;return{call(w,o,i){return v.requestPromise(g,w,o,i)},listen(w,o){return v.requestEvent(g,w,o)}}}requestPromise(g,v,w,o=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(u.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(g),e=(0,C.createCancelablePromise)(a=>i.call(v,w,a)),n=o.onCancellationRequested(()=>e.cancel()),s=(0,A.toDisposable)(()=>e.cancel());return this.activeRequests.add(s),e.finally(()=>{n.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(g,v,w){if(!this.disposeDelayer)return k.Event.None;this.disposeDelayer.cancel();let o;const i=new k.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(g).listen(v,w)(i.fire,i),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env=Object.assign(Object.assign({},(0,E.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(v.env=Object.assign(Object.assign({},v.env),this.options.env)),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),P.isMacintosh&&v.env&&delete v.env.DYLD_LIBRARY_PATH,this.child=(0,y.fork)(this.modulePath,g,v);const w=new k.Emitter;k.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,h.isRemoteConsoleLog)(r)){(0,h.log)(r,`IPC Library: ${this.options.serverName}`);return}w.fire(R.VSBuffer.wrap(Buffer.from(r,"base64")))});const i=this.options.useQueue?(0,T.createQueuedSender)(this.child):this.child,e=r=>this.child&&this.child.connected&&i.send(r.buffer.toString("base64")),n=w.event,s={send:e,onMessage:n};this._client=new f.ChannelClient(s);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,m)=>{process.removeListener("exit",a),this.activeRequests.forEach(j=>(0,A.dispose)(j)),this.activeRequests.clear(),r!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:m})})}return this._client}getCachedChannel(g){let v=this.channels.get(g);return v||(v=this.client.getChannel(g),this.channels.set(g,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=D}),define(Y[70],Z([5,6]),function(x,t){return x.create("vs/base/node/zip",t)}),define(Y[71],Z([5,6]),function(x,t){return x.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Y[72],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Y[73],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Y[74],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Y[75],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Y[76],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Y[77],Z([5,6]),function(x,t){return x.create("vs/platform/extensions/common/extensionValidator",t)}),define(Y[78],Z([5,6]),function(x,t){return x.create("vs/platform/files/common/fileService",t)}),define(Y[79],Z([5,6]),function(x,t){return x.create("vs/platform/files/common/io",t)}),define(Y[80],Z([5,6]),function(x,t){return x.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Y[81],Z([5,6]),function(x,t){return x.create("vs/platform/request/common/request",t)}),define(Y[82],Z([5,6]),function(x,t){return x.create("vs/platform/telemetry/common/telemetryService",t)}),define(Y[83],Z([0,1,19]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const A=/^%([\w\d.-]+)%$/i;function C(E,k){const T=f=>{if(typeof f=="string"){const h=A.exec(f);if(!!h)return k[h[1]]||f}};return(0,y.cloneAndChange)(E,T)}t.localizeManifest=C}),define(Y[47],Z([0,1,77]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function C(u){return u=u.trim(),u==="*"||A.test(u)}t.isValidVersionStr=C;function E(u){if(!C(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let R=u.match(A);return R?{hasCaret:R[1]==="^",hasGreaterEquals:R[1]===">=",majorBase:R[2]==="x"?0:parseInt(R[2],10),majorMustEqual:R[2]!=="x",minorBase:R[4]==="x"?0:parseInt(R[4],10),minorMustEqual:R[4]!=="x",patchBase:R[6]==="x"?0:parseInt(R[6],10),patchMustEqual:R[6]!=="x",preRelease:R[8]||null}:null}t.parseVersion=E;function k(u){if(!u)return null;let R=u.majorBase,P=u.majorMustEqual,l=u.minorBase,D=u.minorMustEqual,p=u.patchBase,g=u.patchMustEqual;return u.hasCaret&&(R===0||(D=!1),g=!1),{majorBase:R,majorMustEqual:P,minorBase:l,minorMustEqual:D,patchBase:p,patchMustEqual:g,isMinimum:u.hasGreaterEquals}}t.normalizeVersion=k;function T(u,R){let P;typeof u=="string"?P=k(E(u)):P=u;let l;if(typeof R=="string"?l=k(E(R)):l=R,!P||!l)return!1;let D=P.majorBase,p=P.minorBase,g=P.patchBase,v=l.majorBase,w=l.minorBase,o=l.patchBase,i=l.majorMustEqual,e=l.minorMustEqual,n=l.patchMustEqual;return l.isMinimum?D>v?!0:D<v?!1:p>w?!0:p<w?!1:g>=o:(D===1&&v===0&&(!i||!e||!n)&&(v=1,w=0,o=0,i=!0,e=!1,n=!1),D<v?!1:D>v?!i:p<w?!1:p>w?!e:g<o?!1:g>o?!n:!0)}t.isValidVersion=T;function f(u,R,P){return R.isBuiltin||typeof R.main=="undefined"?!0:I(u,R.engines.vscode,P)}t.isValidExtensionVersion=f;function h(u,R){return u==="*"||I(R,u)}t.isEngineValid=h;function I(u,R,P=[]){let l=k(E(R));if(!l)return P.push(y.localize(0,null,R)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return P.push(y.localize(1,null,R)),!1}else if(!l.majorMustEqual)return P.push(y.localize(2,null,R)),!1;return T(u,l)?!0:(P.push(y.localize(3,null,u,R)),!1)}t.isVersionValid=I}),define(Y[84],Z([0,1,33,46,2,9]),function(x,t,y,A,C,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class k extends C.Disposable{constructor(f,h,I,u){super();this.folders=f,this.onDidFilesChange=h,this.onLogMessage=I,this.verboseLogging=u,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new A.Client(E.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService((0,y.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(h=>!this.isDisposed&&this.onDidFilesChange(h))),this._register(this.service.onDidLogMessage(h=>this.onLogMessage(h))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=k,k.MAX_RESTARTS=5}),define(Y[85],Z([0,1,33,46,2,9]),function(x,t,y,A,C,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class k extends C.Disposable{constructor(f,h,I,u,R={}){super();this.folders=f,this.onDidFilesChange=h,this.onLogMessage=I,this.verboseLogging=u,this.watcherOptions=R,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new A.Client(E.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService((0,y.getNextTickChannel)(f.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(h=>!this.isDisposed&&this.onDidFilesChange(h))),this._register(this.service.onDidLogMessage(h=>this.onLogMessage(h))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=k,k.MAX_RESTARTS=5}),define(Y[86],Z([0,1,34,44,59,9]),function(x,t,y,A,C,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(f,h,I,u,R){this.watchedFolder=f,this.eventCallback=I,this.logCallback=u,this.verboseLogging=R,this.restartCounter=0,Array.isArray(h)?this.ignored=h.map(P=>C.parse(P)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=y.spawn(E.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",x).fsPath,f);const h=new A.LineDecoder;this.handle.stdout.on("data",I=>{const u=[];h.write(I).forEach(R=>{const P=R.split("|");if(P.length===2){const l=Number(P[0]),D=P[1];if(l>=0&&l<3){if(this.ignored&&this.ignored.some(p=>p(D))){this.verboseLogging&&this.log(D);return}u.push({type:k.changeTypeMap[l],path:D})}else this.log(P[1])}}),u.length>0&&this.eventCallback(u)}),this.handle.on("error",I=>this.onError(I)),this.handle.stderr.on("data",I=>this.onError(I)),this.handle.on("exit",(I,u)=>this.onExit(I,u))}onError(f){this.error("process error: "+f.toString())}onExit(f,h){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${h})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(Y[87],Z([0,1,86,3,18]),function(x,t,y,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class E{constructor(T,f,h,I){this.onDidFilesChange=f,this.onLogMessage=h,this.verboseLogging=I,this.service=void 0,this.folder=T[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=(0,C.rtrim)(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new y.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,T=>this.onFileEvents(T),T=>this.onLogMessage(T),this.verboseLogging)}setVerboseLogging(T){this.verboseLogging=T,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(T){this.isDisposed||T.length>0&&this.onDidFilesChange(T)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=E}),define(Y[48],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class y{constructor(E,k=[],T=!1){this.ctor=E,this.staticArguments=k,this.supportsDelayedInstantiation=T}}t.SyncDescriptor=y;const A=(C,...E)=>new y(C,E);t.createSyncDescriptor=A}),define(Y[88],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class y{constructor(E){this.incoming=new Map,this.outgoing=new Map,this.data=E}}t.Node=y;class A{constructor(E){this._hashFn=E,this._nodes=new Map}roots(){const E=[];for(let k of this._nodes.values())k.outgoing.size===0&&E.push(k);return E}insertEdge(E,k){const T=this.lookupOrInsertNode(E),f=this.lookupOrInsertNode(k);T.outgoing.set(this._hashFn(k),f),f.incoming.set(this._hashFn(E),T)}removeNode(E){const k=this._hashFn(E);this._nodes.delete(k);for(let T of this._nodes.values())T.outgoing.delete(k),T.incoming.delete(k)}lookupOrInsertNode(E){const k=this._hashFn(E);let T=this._nodes.get(k);return T||(T=new y(E),this._nodes.set(k,T)),T}lookup(E){return this._nodes.get(this._hashFn(E))}isEmpty(){return this._nodes.size===0}toString(){let E=[];for(let[k,T]of this._nodes)E.push(`${k}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return E.join(`
`)}}t.Graph=A}),define(Y[89],Z([0,1,7]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,y.createDecorator)("downloadService")}),define(Y[22],Z([0,1,7]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,y.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,y.refineServiceDecorator)(t.IEnvironmentService)}),define(Y[24],Z([0,1,72,7,9]),function(x,t,y,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function E(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}t.isIExtensionIdentifier=E;var k;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=5]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(k=t.SortBy||(t.SortBy={}));var T;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(T=t.SortOrder||(t.SortOrder={}));var f;(function(u){u.Uninstall="uninstall"})(f=t.StatisticType||(t.StatisticType={}));var h;(function(u){u[u.None=0]="None",u[u.Install=1]="Install",u[u.Update=2]="Update"})(h=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class I extends Error{constructor(R,P){super(R);this.code=P}}t.ExtensionManagementError=I,t.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),t.ExtensionsLabel=(0,y.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,y.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,A.createDecorator)("IExtensionManagementCLIService")}),define(Y[35],Z([0,1,18,7]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function C(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}t.isIExtensionIdentifier=C,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(E=t.ExtensionType||(t.ExtensionType={}));class k{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,u){if(typeof I=="undefined"||I===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof I=="string"||typeof u=="string"){let R=typeof I=="string"?I:I.value,P=typeof u=="string"?u:u.value;return y.equalsIgnoreCase(R,P)}return I._lower===u._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}t.ExtensionIdentifier=k;function T(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}t.isLanguagePackExtension=T;function f(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=f,t.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[26],Z([0,1,18,35]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function C(P,l){return P.uuid&&l.uuid?P.uuid===l.uuid:P.id===l.id?!0:(0,y.compareIgnoreCase)(P.id,l.id)===0}t.areSameExtensions=C;class E{constructor(l,D){this.version=D,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof E?C(this,l)&&this.version===l.version:!1}}t.ExtensionIdentifierWithVersion=E;function k(P,l){return`${P}.${l}`}t.getExtensionId=k;function T(P){return P.toLocaleLowerCase()}t.adoptToGalleryExtensionId=T;function f(P,l){return T(k(P,l))}t.getGalleryExtensionId=f;function h(P,l){const D=[],p=g=>{for(const v of D)if(v.some(w=>C(l(w),l(g))))return v;return null};for(const g of P){const v=p(g);v?v.push(g):D.push([g])}return D}t.groupByExtension=h;function I(P){return{id:P.identifier.id,name:P.manifest.name,galleryId:null,publisherId:P.publisherId,publisherName:P.manifest.publisher,publisherDisplayName:P.publisherDisplayName,dependencies:P.manifest.extensionDependencies&&P.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=I;function u(P){return Object.assign({id:P.identifier.id,name:P.name,galleryId:P.identifier.uuid,publisherId:P.publisherId,publisherName:P.publisher,publisherDisplayName:P.publisherDisplayName,dependencies:!!(P.properties.dependencies&&P.properties.dependencies.length>0)},P.telemetryData)}t.getGalleryExtensionTelemetryData=u,t.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function R(P){const l=new Set;for(const D of P)D.malicious&&l.add(D.id.id);return l}t.getMaliciousExtensionsSet=R}),define(Y[90],Z([0,1,2,3,35,12]),function(x,t,y,A,C,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class k extends y.Disposable{constructor(f,h){super();this.environmentService=f,this.extensionsManifestCache=(0,A.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(h.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(h.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtension(f){f.error||this.invalidate()}onDidUnInstallExtension(f){f.error||this.invalidate()}invalidate(){E.rimraf(this.extensionsManifestCache,E.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=k}),define(Y[49],Z([0,1,79,16,23,15]),function(x,t,y,A,C,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function k(I,u,R,P,l,D){let p;try{await T(I,u,R,P,l,D)}catch(g){p=g}finally{p&&l.errorTransformer&&(p=l.errorTransformer(p)),typeof p!="undefined"&&R.error(p),R.end()}}t.readFileIntoStream=k;async function T(I,u,R,P,l,D){f(D);const p=await I.open(u,{create:!1});try{f(D);let g=0,v=0,w=l&&typeof l.length=="number"?l.length:void 0,o=A.VSBuffer.alloc(Math.min(l.bufferSize,typeof w=="number"?w:l.bufferSize)),i=l&&typeof l.position=="number"?l.position:0,e=0;do v=await I.read(p,i,o.buffer,e,o.byteLength-e),i+=v,e+=v,g+=v,typeof w=="number"&&(w-=v),e===o.byteLength&&(await R.write(P(o)),o=A.VSBuffer.alloc(Math.min(l.bufferSize,typeof w=="number"?w:l.bufferSize)),e=0);while(v>0&&(typeof w!="number"||w>0)&&f(D)&&h(g,l));if(e>0){let n=e;typeof w=="number"&&(n=Math.min(e,w)),R.write(P(o.slice(0,n)))}}catch(g){throw(0,C.ensureFileSystemProviderError)(g)}finally{await I.close(p)}}function f(I){if(I.isCancellationRequested)throw(0,E.canceled)();return!0}function h(I,u){if(u==null?void 0:u.limits){if(typeof u.limits.memory=="number"&&I>u.limits.memory)throw(0,C.createFileSystemProviderError)((0,y.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof u.limits.size=="number"&&I>u.limits.size)throw(0,C.createFileSystemProviderError)((0,y.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[50],Z([0,1,10,23,17]),function(x,t,y,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function E(f){return f.map(h=>({type:h.type,resource:y.URI.file(h.path)}))}t.toFileChanges=E;function k(f){const h=new T;for(const I of f)h.processEvent(I);return h.normalize()}t.normalizeFileChanges=k;class T{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(h){const I=this.mapPathToChange.get(h.path);if(I){const u=I.type,R=h.type;u===1&&R===2?(this.mapPathToChange.delete(h.path),this.normalized.splice(this.normalized.indexOf(I),1)):u===2&&R===1?I.type=0:u===1&&R===0||(I.type=R)}else this.normalized.push(h),this.mapPathToChange.set(h.path,h)}normalize(){const h=[],I=[];return this.normalized.filter(u=>u.type!==2?(h.push(u),!1):!0).sort((u,R)=>u.path.length-R.path.length).filter(u=>I.some(R=>(0,A.isParent)(u.path,R,!C.isLinux))?!1:(I.push(u.path),!0)).concat(h)}}}),define(Y[91],Z([0,1,50,2,12,61,63,4,3]),function(x,t,y,A,C,E,k,T,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class h extends A.Disposable{constructor(u,R,P,l){super();this.path=u,this.onDidFilesChange=R,this.onLogMessage=P,this.verboseLogging=l,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(k.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(u){this.verboseLogging=u}async startWatching(){try{const{stat:u,symbolicLink:R}=await C.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let P=this.path;if(R)try{P=await(0,E.realpath)(P)}catch(l){if(this.onError(l),R.dangling)return}u.isDirectory()?this._register((0,k.watchFolder)(P,(l,D)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,f.join)(this.path,(0,f.basename)(D))})},l=>this.onError(l))):this._register((0,k.watchFile)(P,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(u){u.code!=="ENOENT"&&this.onError(u)}}onFileChange(u){this.fileChangesBuffer.push(u),this.verboseLogging&&this.onVerbose(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`),this.fileChangesDelayer.trigger(async()=>{const R=this.fileChangesBuffer;this.fileChangesBuffer=[];const P=(0,y.normalizeFileChanges)(R);this.verboseLogging&&P.forEach(l=>{this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`)}),P.length>0&&this.onDidFilesChange(P)})}onError(u){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${u}`})}onVerbose(u){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=h}),define(Y[51],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class y{constructor(...C){this._entries=new Map;for(let[E,k]of C)this.set(E,k)}set(C,E){const k=this._entries.get(C);return this._entries.set(C,E),k}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}t.ServiceCollection=y}),define(Y[92],Z([0,1,15,88,48,7,51,4]),function(x,t,y,A,C,E,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const f=!1;class h extends Error{constructor(l){super("cyclic dependency between services");this.message=l.toString()}}class I{constructor(l=new k.ServiceCollection,D=!1,p){this._activeInstantiations=new Set,this._services=l,this._strict=D,this._parent=p,this._services.set(E.IInstantiationService,this)}createChild(l){return new I(l,this._strict,this)}invokeFunction(l,...D){let p=R.traceInvocation(l),g=!1;try{return l({get:(w,o)=>{if(g)throw(0,y.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(w,p);if(!i&&o!==E.optional)throw new Error(`[invokeFunction] unknown service '${w}'`);return i}},...D)}finally{g=!0,p.stop()}}createInstance(l,...D){let p,g;return l instanceof C.SyncDescriptor?(p=R.traceCreation(l.ctor),g=this._createInstance(l.ctor,l.staticArguments.concat(D),p)):(p=R.traceCreation(l),g=this._createInstance(l,D,p)),p.stop(),g}_createInstance(l,D=[],p){let g=E._util.getServiceDependencies(l).sort((o,i)=>o.index-i.index),v=[];for(const o of g){let i=this._getOrCreateServiceInstance(o.id,p);if(!i&&this._strict&&!o.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${o.id}.`);v.push(i)}let w=g.length>0?g[0].index:D.length;if(D.length!==w){console.warn(`[createInstance] First service dependency of ${l.name} at position ${w+1} conflicts with ${D.length} static arguments`);let o=w-D.length;o>0?D=D.concat(new Array(o)):D=D.slice(0,w)}return new l(...[...D,...v])}_setServiceInstance(l,D){if(this._services.get(l)instanceof C.SyncDescriptor)this._services.set(l,D);else if(this._parent)this._parent._setServiceInstance(l,D);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let D=this._services.get(l);return!D&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):D}_getOrCreateServiceInstance(l,D){let p=this._getServiceInstanceOrDescriptor(l);return p instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,p,D.branch(l,!0)):(D.branch(l,!1),p)}_safeCreateAndCacheServiceInstance(l,D,p){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,D,p)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,D,p){const g=new A.Graph(o=>o.id.toString());let v=0;const w=[{id:l,desc:D,_trace:p}];for(;w.length;){const o=w.pop();if(g.lookupOrInsertNode(o),v++>1e3)throw new h(g);for(let i of E._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(i.id);if(!e&&!i.optional&&console.warn(`[createInstance] ${l} depends on ${i.id} which is NOT registered.`),e instanceof C.SyncDescriptor){const n={id:i.id,desc:e,_trace:o._trace.branch(i.id,!0)};g.insertEdge(o,n),w.push(n)}}}for(;;){const o=g.roots();if(o.length===0){if(!g.isEmpty())throw new h(g);break}for(const{data:i}of o){if(this._getServiceInstanceOrDescriptor(i.id)instanceof C.SyncDescriptor){const n=this._createServiceInstanceWithOwner(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this._setServiceInstance(i.id,n)}g.removeNode(i)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,D,p=[],g,v){if(this._services.get(l)instanceof C.SyncDescriptor)return this._createServiceInstance(D,p,g,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,D,p,g,v);throw new Error(`illegalState - creating UNKNOWN service instance ${D.name}`)}_createServiceInstance(l,D=[],p,g){if(p){const v=new T.IdleValue(()=>this._createInstance(l,D,g));return new Proxy(Object.create(null),{get(w,o){if(o in w)return w[o];let i=v.value,e=i[o];return typeof e!="function"||(e=e.bind(i),w[o]=e),e},set(w,o,i){return v.value[o]=i,!0}})}else return this._createInstance(l,D,g)}}t.InstantiationService=I;var u;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(u||(u={}));class R{constructor(l,D){this.type=l,this.name=D,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return f?new R(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):R._None}static traceCreation(l){return f?new R(0,l.name):R._None}branch(l,D){let p=new R(2,l.toString());return this._dep.push([l,D,p]),p}stop(){let l=Date.now()-this._start;R._totals+=l;let D=!1;function p(v,w){let o=[],i=new Array(v+1).join("	");for(const[e,n,s]of w._dep)if(n&&s){D=!0,o.push(`${i}CREATES -> ${e}`);let a=p(v+1,s);a&&o.push(a)}else o.push(`${i}uses -> ${e}`);return o.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${R._totals.toFixed(2)}ms)`];(l>2||D)&&console.log(g.join(`
`))}}R._None=new class extends R{constructor(){super(-1,null)}stop(){}branch(){return this}},R._totals=0}),define(Y[36],Z([0,1,7]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,y.createDecorator)("localizationsService");function A(C){if(typeof C.languageId!="string"||!Array.isArray(C.translations)||C.translations.length===0)return!1;for(const E of C.translations)if(typeof E.id!="string"||typeof E.path!="string")return!1;return!(C.languageName&&typeof C.languageName!="string"||C.localizedLanguageName&&typeof C.localizedLanguageName!="string")}t.isValidLocalization=A});var ce=this&&this.__decorate||function(x,t,y,A){var C=arguments.length,E=C<3?t:A===null?A=Object.getOwnPropertyDescriptor(t,y):A,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")E=Reflect.decorate(x,t,y,A);else for(var T=x.length-1;T>=0;T--)(k=x[T])&&(E=(C<3?k(E):C>3?k(t,y,E):k(t,y))||E);return C>3&&E&&Object.defineProperty(t,y,E),E},fe=this&&this.__param||function(x,t){return function(y,A){t(y,A,x)}};define(Y[93],Z([0,1,73,15,10,37,24,26,35,60,28,9,36]),function(x,t,y,A,C,E,k,T,f,h,I,u,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const P=w=>(0,y.localize)(0,null,w),l=(0,y.localize)(1,null,"ms-dotnettools.csharp");function D(w,o){return o?`${w.publisher}.${w.name}@${w.version}`:`${w.publisher}.${w.name}`}const p=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function g(w){const o=p.exec(w);return o&&o[1]?[(0,T.adoptToGalleryExtensionId)(o[1]),o[2]]:[(0,T.adoptToGalleryExtensionId)(w),void 0]}t.getIdAndVersion=g;let v=class{constructor(o,i,e){this.extensionManagementService=o,this.extensionGalleryService=i,this.localizationsService=e}get location(){}async listExtensions(o,i,e=console){let n=await this.extensionManagementService.getInstalled(1);const s=f.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(i&&i!==""){if(s.indexOf(i.toLowerCase())<0){e.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}n=n.filter(r=>r.manifest.categories?r.manifest.categories.map(j=>j.toLowerCase()).indexOf(i.toLowerCase())>-1:!1)}else if(i===""){e.log("Possible Categories: "),s.forEach(r=>{e.log(r)});return}this.location&&e.log((0,y.localize)(2,null,this.location)),n=n.sort((r,m)=>r.identifier.id.localeCompare(m.identifier.id));let a;for(let r of n)a!==r.identifier.id&&(a=r.identifier.id,e.log(D(r.manifest,o)))}async installExtensions(o,i,e,n,s=console){const a=[],r=[];o.length&&s.log(this.location?(0,y.localize)(3,null,this.location):(0,y.localize)(4,null));const m=await this.extensionManagementService.getInstalled(1),j=(z,B)=>{const H=m.find(X=>(0,T.areSameExtensions)(X.identifier,{id:z}));if(H){if(!B&&!n)return s.log((0,y.localize)(5,null,z,H.manifest.version,z)),!1;if(B&&H.manifest.version===B)return s.log((0,y.localize)(6,null,`${z}@${B}`)),!1}return!0},M=[],F=[];for(const z of o)if(z instanceof C.URI)M.push(z);else{const[B,H]=g(z);j(B,H)&&F.push({id:B,version:H,installOptions:{isBuiltin:!1,isMachineScoped:e}})}for(const z of i){const[B,H]=g(z);j(B,H)&&F.push({id:B,version:H,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(M.length&&await Promise.all(M.map(async z=>{try{const B=await this.installVSIX(z,n,s);B&&r.push(B)}catch(B){s.error(B.message||B.stack||B),a.push(z.toString())}})),F.length){const z=await this.getGalleryExtensions(F);await Promise.all(F.map(async B=>{const H=z.get(B.id.toLowerCase());if(H)try{const X=await this.installFromGallery(B,H,m,n,s);X&&r.push(X)}catch(X){s.error(X.message||X.stack||X),a.push(B.id)}else s.error(`${P(B.version?`${B.id}@${B.version}`:B.id)}
${l}`),a.push(B.id)}))}if(r.some(z=>(0,f.isLanguagePackExtension)(z))&&await this.updateLocalizationsCache(),a.length)throw new Error((0,y.localize)(7,null,a.join(", ")))}async installVSIX(o,i,e){const n=await this.extensionManagementService.getManifest(o);if(!n)throw new Error("Invalid vsix");if(await this.validateVSIX(n,i,e))try{return await this.extensionManagementService.install(o),e.log((0,y.localize)(8,null,(0,h.getBaseLabel)(o))),n}catch(a){if((0,A.isPromiseCanceledError)(a))return e.log((0,y.localize)(9,null,(0,h.getBaseLabel)(o))),null;throw a}return null}async getGalleryExtensions(o){const i=o.filter(({version:s})=>s===void 0).map(({id:s})=>s),e=o.filter(({version:s})=>s!==void 0),n=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(i,I.CancellationToken.None)).forEach(a=>n.set(a.identifier.id.toLowerCase(),a))})(),Promise.all(e.map(async({id:s,version:a})=>{const r=await this.extensionGalleryService.getCompatibleExtension({id:s},a);r&&n.set(r.identifier.id.toLowerCase(),r)}))]),n}async installFromGallery({id:o,version:i,installOptions:e},n,s,a,r){const m=await this.extensionGalleryService.getManifest(n,I.CancellationToken.None);if(m&&!this.validateExtensionKind(m,r))return null;const j=s.find(M=>(0,T.areSameExtensions)(M.identifier,n.identifier));if(j){if(n.version===j.manifest.version)return r.log((0,y.localize)(10,null,i?`${o}@${i}`:o)),null;r.log((0,y.localize)(11,null,o,n.version))}try{return e.isBuiltin?r.log((0,y.localize)(12,null,o,n.version)):r.log((0,y.localize)(13,null,o,n.version)),await this.extensionManagementService.installFromGallery(n,e),r.log((0,y.localize)(14,null,o,n.version)),m}catch(M){if((0,A.isPromiseCanceledError)(M))return r.log((0,y.localize)(15,null,o)),null;throw M}}validateExtensionKind(o,i){return!0}async validateVSIX(o,i,e){const n={id:(0,T.getGalleryExtensionId)(o.publisher,o.name)},a=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,T.areSameExtensions)(n,r.identifier)&&(0,E.gt)(r.manifest.version,o.version));return a&&!i?(e.log((0,y.localize)(16,null,a.identifier.id,a.manifest.version,o.version)),!1):this.validateExtensionKind(o,e)}async uninstallExtensions(o,i,e=console){const n=async a=>{if(a instanceof C.URI){const r=await this.extensionManagementService.getManifest(a);return D(r)}return a},s=[];for(const a of o){const r=await n(a),j=(await this.extensionManagementService.getInstalled()).filter(M=>(0,T.areSameExtensions)(M.identifier,{id:r}));if(!j.length)throw new Error(`${this.notInstalled(r)}
${l}`);if(j.some(M=>M.type===0)){e.log((0,y.localize)(17,null,r));return}if(!i&&j.some(M=>M.isBuiltin)){e.log((0,y.localize)(18,null,r));return}e.log((0,y.localize)(19,null,r));for(const M of j)await this.extensionManagementService.uninstall(M),s.push(M);this.location?e.log((0,y.localize)(20,null,r,this.location)):e.log((0,y.localize)(21,null,r))}s.some(a=>(0,f.isLanguagePackExtension)(a.manifest))&&await this.updateLocalizationsCache()}async locateExtension(o,i=console){const e=await this.extensionManagementService.getInstalled();o.forEach(n=>{e.forEach(s=>{if(s.identifier.id===n&&s.location.scheme===u.Schemas.file){i.log(s.location.fsPath);return}})})}updateLocalizationsCache(){return this.localizationsService.update()}notInstalled(o){return this.location?(0,y.localize)(22,null,o,this.location):(0,y.localize)(23,null,o)}};v=ce([fe(0,k.IExtensionManagementService),fe(1,k.IExtensionGalleryService),fe(2,R.ILocalizationsService)],v),t.ExtensionManagementCLIService=v}),define(Y[13],Z([0,1,7,2,17,11,30]),function(x,t,y,A,C,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,y.createDecorator)("logService"),t.ILoggerService=(0,y.createDecorator)("loggerService");function T(){return new Date().toISOString()}var f;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(f=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=f.Info;class h extends A.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new E.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=h;class I extends h{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...e){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([i,...e]))}debug(i,...e){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([i,...e]))}info(i,...e){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([i,...e]))}warn(i,...e){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([i,...e]))}error(i,...e){if(this.checkLogLevel(f.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(f.Error,this.format(n))}else this.log(f.Error,this.format([i,...e]))}critical(i,...e){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([i,...e]))}flush(){}format(i){let e="";for(let n=0;n<i.length;n++){let s=i[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(a){}e+=(n>0?" ":"")+s}return e}}t.AbstractMessageLogger=I;class u extends h{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!C.isWindows}trace(i,...e){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,i,...e):console.log(`[main ${T()}]`,i,...e))}debug(i,...e){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,i,...e):console.log(`[main ${T()}]`,i,...e))}info(i,...e){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,i,...e):console.log(`[main ${T()}]`,i,...e))}warn(i,...e){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,i,...e):console.warn(`[main ${T()}]`,i,...e))}error(i,...e){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,i,...e):console.error(`[main ${T()}]`,i,...e))}critical(i,...e){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,i,...e):console.error(`[main ${T()}]`,i,...e))}dispose(){}flush(){}}t.ConsoleMainLogger=u;class R extends h{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...e){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...e)}debug(i,...e){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...e)}info(i,...e){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...e)}warn(i,...e){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...e)}error(i,...e){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...e)}critical(i,...e){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...e)}dispose(){}flush(){}}t.ConsoleLogger=R;class P extends h{constructor(i,e=t.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(e)}trace(i,...e){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...e])}debug(i,...e){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...e])}info(i,...e){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...e])}warn(i,...e){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...e])}error(i,...e){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...e])}critical(i,...e){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...e])}extractMessage(i){return typeof i=="string"?i:(0,k.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}t.AdapterLogger=P;class l extends h{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const e of this.logServices)e.setLevel(i);super.setLevel(i)}trace(i,...e){for(const n of this.logServices)n.trace(i,...e)}debug(i,...e){for(const n of this.logServices)n.debug(i,...e)}info(i,...e){for(const n of this.logServices)n.info(i,...e)}warn(i,...e){for(const n of this.logServices)n.warn(i,...e)}error(i,...e){for(const n of this.logServices)n.error(i,...e)}critical(i,...e){for(const n of this.logServices)n.critical(i,...e)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}t.MultiplexLogService=l;class D extends A.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...e){this.logger.trace(i,...e)}debug(i,...e){this.logger.debug(i,...e)}info(i,...e){this.logger.info(i,...e)}warn(i,...e){this.logger.warn(i,...e)}error(i,...e){this.logger.error(i,...e)}critical(i,...e){this.logger.critical(i,...e)}flush(){this.logger.flush()}}t.LogService=D;class p{constructor(){this.onDidChangeLogLevel=new E.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...e){}debug(i,...e){}info(i,...e){}warn(i,...e){}error(i,...e){}critical(i,...e){}dispose(){}flush(){}}t.NullLogService=p;function g(o){if(o.verbose)return f.Trace;if(typeof o.logLevel=="string"){const i=v(o.logLevel.toLowerCase());if(i!==void 0)return i}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=g;function v(o){switch(o){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}t.parseLogLevel=v;function w(o){switch(o){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}t.LogLevelToString=w}),define(Y[94],Z([0,1,14,2,23,24,22,10,20,26,13,38,37,17,4]),function(x,t,y,A,C,E,k,T,f,h,I,u,R,P,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends A.Disposable{constructor(v,w,o,i){super();this.fileService=w,this.extensionGalleryService=o,this.logService=i,this.extensionsDownloadDir=T.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,w){await this.cleanUpPromise;const o=this.getName(v),i=(0,f.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(i)){const e=(0,f.joinPath)(this.extensionsDownloadDir,`.${o}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(v,e,w),await this.rename(e,i,Date.now()+2*60*1e3)}return i}async delete(v){}async rename(v,w,o){try{await y.promises.rename(v.fsPath,w.fsPath)}catch(i){if(P.isWindows&&i&&i.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${v} to ${w} with 'EPERM' error. Trying again...`),this.rename(v,w,o);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const w=[],o=[];for(const n of v.children){const s=this.parse(n.name);s&&o.push([s,n])}const i=(0,h.groupByExtension)(o,([n])=>n),e=[];for(const n of i)n.sort((s,a)=>R.rcompare(s[0].version,a[0].version)),w.push(...n.slice(1).map(s=>s[1].resource)),e.push(n[0][1]);e.sort((n,s)=>n.mtime-s.mtime),w.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(n=>n.resource)),await l.Promises.settled(w.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?new h.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase():(0,u.generateUuid)()}parse(v){const w=D.exec(v);return w&&w[1]&&w[2]?new h.ExtensionIdentifierWithVersion({id:w[1]},w[2]):null}};p=ce([fe(0,k.INativeEnvironmentService),fe(1,C.IFileService),fe(2,E.IExtensionGalleryService),fe(3,I.ILogService)],p),t.ExtensionsDownloader=p}),define(Y[95],Z([0,1,2,13,34,30,3,4,11,9,12,22]),function(x,t,y,A,C,E,k,T,f,h,I,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let R=class extends y.Disposable{constructor(l,D){super();this.environmentService=l,this.logService=D,this.processesLimiter=new T.Limiter(5)}async postUninstall(l){const D=this.parseScript(l,"uninstall");return D&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(D.script,"uninstall",D.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),p=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${p}`)))),(0,I.rimraf)(this.getExtensionStoragePath(l)).then(void 0,p=>this.logService.error("Error while removing extension storage path",p))}parseScript(l,D){const p=`vscode:${D}`;if(l.location.scheme===h.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[p]=="string"){const g=l.manifest.scripts[p].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${p} should be a node script`),null):{script:(0,k.join)(l.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(l,D,p,g,v){return new Promise((w,o)=>{const i=this.start(l,D,p,v);let e;const n=s=>{e&&(clearTimeout(e),e=null),s?o(s):w(void 0)};i.on("error",s=>{n((0,E.toErrorMessage)(s)||"Unknown")}),i.on("exit",(s,a)=>{n(s?`post-${D} process exited with code ${s}`:void 0)}),g&&(e=setTimeout(()=>{e=null,i.kill(),o("timed out")},5e3))})}start(l,D,p,g){const v={silent:!0,execArgv:void 0},w=(0,C.fork)(l,[`--type=extension-post-${D}`,...p],v);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const o=f.Event.fromNodeEventEmitter(w.stdout,"data"),i=f.Event.fromNodeEventEmitter(w.stderr,"data");o(s=>this.logService.info(g.identifier.id,g.manifest.version,`post-${D}`,s)),i(s=>this.logService.error(g.identifier.id,g.manifest.version,`post-${D}`,s));const e=f.Event.any(f.Event.map(o,s=>({data:`%c${s}`,format:[""]})),f.Event.map(i,s=>({data:`%c${s}`,format:["color: red"]})));return f.Event.debounce(e,(s,a)=>s?{data:s.data+a.data,format:[...s.format,...a.format]}:{data:a.data,format:a.format},100)(s=>{console.group(g.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),w}getExtensionStoragePath(l){return(0,k.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};R=ce([fe(0,u.IEnvironmentService),fe(1,A.ILogService)],R),t.ExtensionsLifecycle=R}),define(Y[96],Z([0,1,78,122,2,23,11,20,43,21,13,16,31,4,28,9,49,123]),function(x,t,y,A,C,E,k,T,f,h,I,u,R,P,l,D,p,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let v=class extends C.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new P.ResourceQueue)}registerProvider(o,i){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,A.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:i});const e=new C.DisposableStore;return e.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new E.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),e.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:o}))),typeof i.onDidErrorOccur=="function"&&e.add(i.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,C.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:i}),this.provider.delete(o),(0,C.dispose)(e)})}async activateProvider(o){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){i.push(e)}}),!this.provider.has(o)&&await P.Promises.settled(i)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,i){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&i)}listCapabilities(){return g.Iterable.map(this.provider,([o,i])=>({scheme:o,capabilities:i.capabilities}))}async withProvider(o){if(!(0,T.isAbsolutePath)(o))throw new E.FileOperationError((0,y.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const i=this.provider.get(o.scheme);if(!i){const e=new Error;throw e.name="ENOPRO",e.message=(0,y.localize)(1,null,o.toString()),e}return i}async withReadProvider(o){const i=await this.withProvider(o);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i)||(0,E.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const i=await this.withProvider(o);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,i){try{return await this.doResolveFile(o,i)}catch(e){throw(0,E.toFileSystemProviderErrorCode)(e)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,y.localize)(2,null,this.resourceForError(o)),1):(0,E.ensureFileSystemProviderError)(e)}}async doResolveFile(o,i){const e=await this.withProvider(o),n=this.isPathCaseSensitive(e),s=i==null?void 0:i.resolveTo,a=i==null?void 0:i.resolveSingleChildDescendants,r=i==null?void 0:i.resolveMetadata,m=await e.stat(o);let j;return this.toFileStat(e,o,m,void 0,!!r,(M,F)=>(j||(j=f.TernarySearchTree.forUris(()=>!n),j.set(o,!0),(0,h.isNonEmptyArray)(s)&&s.forEach(z=>j.set(z,!0))),Boolean(j.findSuperstr(M.resource)||j.get(M.resource))?!0:M.isDirectory&&a?F===1:!1))}async toFileStat(o,i,e,n,s,a){const{providerExtUri:r}=this.getExtUri(o),m={resource:i,name:r.basename(i),isFile:(e.type&E.FileType.File)!=0,isDirectory:(e.type&E.FileType.Directory)!=0,isSymbolicLink:(e.type&E.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,etag:(0,E.etag)({mtime:e.mtime,size:e.size})};if(m.isDirectory&&a(m,n)){try{const j=await o.readdir(i),M=await P.Promises.settled(j.map(async([F,z])=>{try{const B=r.joinPath(i,F),H=s?await o.stat(B):{type:z};return await this.toFileStat(o,B,H,j.length,s,a)}catch(B){return this.logService.trace(B),null}}));m.children=(0,h.coalesce)(M)}catch(j){this.logService.trace(j),m.children=[]}return m}return m}async resolveAll(o){return P.Promises.settled(o.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const i=await this.withProvider(o);try{return!!await i.stat(o)}catch(e){return!1}}async canCreateFile(o,i){try{await this.doValidateCreateFile(o,i)}catch(e){return e}return!0}async doValidateCreateFile(o,i){if(!(i==null?void 0:i.overwrite)&&await this.exists(o))throw new E.FileOperationError((0,y.localize)(3,null,this.resourceForError(o)),3,i)}async createFile(o,i=u.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const n=await this.writeFile(o,i);return this._onDidRunOperation.fire(new E.FileOperationEvent(o,0,n)),n}async writeFile(o,i,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(n);try{await this.validateWriteFile(n,o,e)||await this.mkdirp(n,s.dirname(o));let r;if((0,E.hasReadWriteCapability)(n)&&!(i instanceof u.VSBuffer))if((0,R.isReadableStream)(i)){const m=await(0,R.peekStream)(i,3);m.ended?r=u.VSBuffer.concat(m.buffer):r=m}else r=(0,R.peekReadable)(i,m=>u.VSBuffer.concat(m),3);else r=i;!(0,E.hasOpenReadWriteCloseCapability)(n)||(0,E.hasReadWriteCapability)(n)&&r instanceof u.VSBuffer?await this.doWriteUnbuffered(n,o,r):await this.doWriteBuffered(n,o,r instanceof u.VSBuffer?(0,u.bufferToReadable)(r):r)}catch(a){throw new E.FileOperationError((0,y.localize)(4,null,this.resourceForError(o),(0,E.ensureFileSystemProviderError)(a).toString()),(0,E.toFileOperationResult)(a),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,i,e){let n;try{n=await o.stat(i)}catch(s){return}if((n.type&E.FileType.Directory)!=0)throw new E.FileOperationError((0,y.localize)(5,null,this.resourceForError(i)),0,e);if(e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==E.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,E.etag)({mtime:e.mtime,size:n.size}))throw new E.FileOperationError((0,y.localize)(6,null),3,e);return n}async readFile(o,i){const e=await this.withReadProvider(o);return(i==null?void 0:i.atomic)?this.doReadFileAtomic(e,o,i):this.doReadFile(e,o,i)}async doReadFileAtomic(o,i,e){return new Promise((n,s)=>{this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,i,e);n(a)}catch(a){s(a)}})})}async doReadFile(o,i,e){const n=await this.doReadFileStream(o,i,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},n),{value:await(0,u.streamToBuffer)(n.value)})}async readFileStream(o,i){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,i)}async doReadFileStream(o,i,e){const n=new l.CancellationTokenSource,s=this.validateReadFile(i,e).then(r=>r,r=>{throw n.cancel(),r});let a;try{e&&typeof e.etag=="string"&&e.etag!==E.ETAG_DISABLED&&await s,!((0,E.hasOpenReadWriteCloseCapability)(o)||(0,E.hasFileReadStreamCapability)(o))||(0,E.hasReadWriteCapability)(o)&&(e==null?void 0:e.preferUnbuffered)?a=this.readFileUnbuffered(o,i,e):(0,E.hasFileReadStreamCapability)(o)?a=this.readFileStreamed(o,i,n.token,e):a=this.readFileBuffered(o,i,n.token,e);const r=await s;return Object.assign(Object.assign({},r),{value:a})}catch(r){throw a&&await(0,R.consumeStream)(a),new E.FileOperationError((0,y.localize)(7,null,this.resourceForError(i),(0,E.ensureFileSystemProviderError)(r).toString()),(0,E.toFileOperationResult)(r),e)}}readFileStreamed(o,i,e,n=Object.create(null)){const s=o.readFileStream(i,n,e);return(0,R.transform)(s,{data:a=>a instanceof u.VSBuffer?a:u.VSBuffer.wrap(a),error:a=>new E.FileOperationError((0,y.localize)(8,null,this.resourceForError(i),(0,E.ensureFileSystemProviderError)(a).toString()),(0,E.toFileOperationResult)(a),n)},a=>u.VSBuffer.concat(a))}readFileBuffered(o,i,e,n=Object.create(null)){const s=(0,u.newWriteableBufferStream)();return(0,p.readFileIntoStream)(o,i,s,a=>a,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new E.FileOperationError((0,y.localize)(9,null,this.resourceForError(i),(0,E.ensureFileSystemProviderError)(a).toString()),(0,E.toFileOperationResult)(a),n)}),e),s}readFileUnbuffered(o,i,e){const n=(0,R.newWriteableStream)(s=>u.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(i);e&&typeof e.position=="number"&&(s=s.slice(e.position)),e&&typeof e.length=="number"&&(s=s.slice(0,e.length)),this.validateReadFileLimits(i,s.byteLength,e),n.end(u.VSBuffer.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async validateReadFile(o,i){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new E.FileOperationError((0,y.localize)(10,null,this.resourceForError(o)),0,i);if(i&&typeof i.etag=="string"&&i.etag!==E.ETAG_DISABLED&&i.etag===e.etag)throw new E.FileOperationError((0,y.localize)(11,null),2,i);return this.validateReadFileLimits(o,e.size,i),e}validateReadFileLimits(o,i,e){if(e==null?void 0:e.limits){let n;if(typeof e.limits.memory=="number"&&i>e.limits.memory&&(n=9),typeof e.limits.size=="number"&&i>e.limits.size&&(n=7),typeof n=="number")throw new E.FileOperationError((0,y.localize)(12,null,this.resourceForError(o)),n)}}async canMove(o,i,e){return this.doCanMoveCopy(o,i,"move",e)}async canCopy(o,i,e){return this.doCanMoveCopy(o,i,"copy",e)}async doCanMoveCopy(o,i,e,n){if(o.toString()!==i.toString())try{const s=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(s,o,a,i,e,n)}catch(s){return s}return!0}async move(o,i,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(n,o,s,i,"move",!!e),r=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,a==="move"?2:3,r)),r}async copy(o,i,e){const n=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(n,o,s,i,"copy",!!e),r=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,a==="copy"?3:2,r)),r}async doMoveCopy(o,i,e,n,s,a){if(i.toString()===n.toString())return s;const{exists:r,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(o,i,e,n,s,a);if(r&&!m&&a&&await this.del(n,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(n)),s==="copy"){if(o===e&&(0,E.hasFileFolderCopyCapability)(o))await o.copy(i,n,{overwrite:a});else{const j=await this.resolve(i);j.isDirectory?await this.doCopyFolder(o,j,e,n):await this.doCopyFile(o,i,e,n)}return s}else return o===e?(await o.rename(i,n,{overwrite:a}),s):(await this.doMoveCopy(o,i,e,n,"copy",a),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(o,i,e,n){if((0,E.hasOpenReadWriteCloseCapability)(o)&&(0,E.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,i,e,n);if((0,E.hasOpenReadWriteCloseCapability)(o)&&(0,E.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,i,e,n);if((0,E.hasReadWriteCapability)(o)&&(0,E.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,i,e,n);if((0,E.hasReadWriteCapability)(o)&&(0,E.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,i,e,n)}async doCopyFolder(o,i,e,n){await e.mkdir(n),Array.isArray(i.children)&&await P.Promises.settled(i.children.map(async s=>{const a=this.getExtUri(e).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),e,a):this.doCopyFile(o,s.resource,e,a)}))}async doValidateMoveCopy(o,i,e,n,s,a){let r=!1;if(o===e){const{providerExtUri:j,isPathCaseSensitive:M}=this.getExtUri(o);if(M||(r=j.isEqual(i,n)),r&&s==="copy")throw new Error((0,y.localize)(13,null,this.resourceForError(i),this.resourceForError(n)));if(!r&&j.isEqualOrParent(n,i))throw new Error((0,y.localize)(14,null,this.resourceForError(i),this.resourceForError(n)))}const m=await this.exists(n);if(m&&!r){if(!a)throw new E.FileOperationError((0,y.localize)(15,null,this.resourceForError(i),this.resourceForError(n)),4);if(o===e){const{providerExtUri:j}=this.getExtUri(o);if(j.isEqualOrParent(i,n))throw new Error((0,y.localize)(16,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:m,isSameResourceWithDifferentPathCase:r}}getExtUri(o){const i=this.isPathCaseSensitive(o);return{providerExtUri:i?T.extUri:T.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(i,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,0,e)),e}async mkdirp(o,i){const e=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(i,n.dirname(i));)try{if(((await o.stat(i)).type&E.FileType.Directory)==0)throw new Error((0,y.localize)(17,null,this.resourceForError(i)));break}catch(s){if((0,E.toFileSystemProviderErrorCode)(s)!==E.FileSystemProviderErrorCode.FileNotFound)throw s;e.push(n.basename(i)),i=n.dirname(i)}for(let s=e.length-1;s>=0;s--){i=n.joinPath(i,e[s]);try{await o.mkdir(i)}catch(a){if((0,E.toFileSystemProviderErrorCode)(a)!==E.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,i){try{await this.doValidateDelete(o,i)}catch(e){return e}return!0}async doValidateDelete(o,i){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(i==null?void 0:i.useTrash)&&!(e.capabilities&4096))throw new Error((0,y.localize)(18,null,this.resourceForError(o)));const s=await this.exists(o);if(!s)throw new E.FileOperationError((0,y.localize)(19,null,this.resourceForError(o)),1);if(!!!(i==null?void 0:i.recursive)&&s){const r=await this.resolve(o);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,y.localize)(20,null,this.resourceForError(o)))}return e}async del(o,i){const e=await this.doValidateDelete(o,i),n=!!(i==null?void 0:i.useTrash),s=!!(i==null?void 0:i.recursive);await e.delete(o,{recursive:s,useTrash:n}),this._onDidRunOperation.fire(new E.FileOperationEvent(o,1))}watch(o,i={recursive:!1,excludes:[]}){let e=!1,n=()=>{e=!0};return this.doWatch(o,i).then(s=>{e?(0,C.dispose)(s):n=()=>(0,C.dispose)(s)},s=>this.logService.error(s)),(0,C.toDisposable)(()=>n())}async doWatch(o,i){const e=await this.withProvider(o),n=this.toWatchKey(e,o,i),s=this.activeWatchers.get(n)||{count:0,disposable:e.watch(o,i)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,s),s.count+=1,(0,C.toDisposable)(()=>{s.count--,s.count===0&&((0,C.dispose)(s.disposable),this.activeWatchers.delete(n))})}toWatchKey(o,i,e){const{providerExtUri:n}=this.getExtUri(o);return[n.getComparisonKey(i),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>(0,C.dispose)(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,i,e){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(i,{create:!0});try{(0,R.isReadableStream)(e)||(0,R.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(o,n,e):await this.doWriteReadableBufferedQueued(o,n,e)}catch(s){throw(0,E.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,i,e){let n=0,s;if((0,R.isReadableBufferedStream)(e)){if(e.buffer.length>0){const a=u.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,i,a,a.byteLength,n,0),n+=a.byteLength}if(e.ended)return;s=e.stream}else s=e;return new Promise(async(a,r)=>{(0,R.listenStream)(s,{onData:async m=>{s.pause();try{await this.doWriteBuffer(o,i,m,m.byteLength,n,0)}catch(j){return r(j)}n+=m.byteLength,setTimeout(()=>s.resume())},onError:m=>r(m),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,i,e){let n=0,s;for(;(s=e.read())!==null;)await this.doWriteBuffer(o,i,s,s.byteLength,n,0),n+=s.byteLength}async doWriteBuffer(o,i,e,n,s,a){let r=0;for(;r<n;)r+=await o.write(i,s+r,e.buffer,a+r,n-r)}async doWriteUnbuffered(o,i,e){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,i,e))}async doWriteUnbufferedQueued(o,i,e){let n;e instanceof u.VSBuffer?n=e:(0,R.isReadableStream)(e)?n=await(0,u.streamToBuffer)(e):(0,R.isReadableBufferedStream)(e)?n=await(0,u.bufferedStreamToBuffer)(e):n=(0,u.readableToBuffer)(e),await o.writeFile(i,n.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(o,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,i,e,n))}async doPipeBufferedQueued(o,i,e,n){let s,a;try{s=await o.open(i,{create:!1}),a=await e.open(n,{create:!0});const r=u.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,j=0,M=0;do M=await o.read(s,m,r.buffer,j,r.byteLength-j),await this.doWriteBuffer(e,a,r,M,m,j),m+=M,j+=M,j===r.byteLength&&(j=0);while(M>0)}catch(r){throw(0,E.ensureFileSystemProviderError)(r)}finally{await P.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof a=="number"?e.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,i,e,n))}async doPipeUnbufferedQueued(o,i,e,n){return e.writeFile(n,await o.readFile(i),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(o,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,i,e,n))}async doPipeUnbufferedToBufferedQueued(o,i,e,n){const s=await e.open(n,{create:!0});try{const a=await o.readFile(i);await this.doWriteBuffer(e,s,u.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,E.ensureFileSystemProviderError)(a)}finally{await e.close(s)}}async doPipeBufferedToUnbuffered(o,i,e,n){const s=await(0,u.streamToBuffer)(this.readFileBuffered(o,i,l.CancellationToken.None));await this.doWriteUnbuffered(e,n,s)}throwIfFileSystemIsReadonly(o,i){if(o.capabilities&2048)throw new E.FileOperationError((0,y.localize)(21,null,this.resourceForError(i)),6);return o}resourceForError(o){return o.scheme===D.Schemas.file?o.fsPath:o.toString(!0)}};v=ce([fe(0,I.ILogService)],v),t.FileService=v}),define(Y[97],Z([0,1,14,124,2,23,11,17,12,3,20,32,4,13,80,50,85,87,84,91,31,49,21,16]),function(x,t,y,A,C,E,k,T,f,h,I,u,R,P,l,D,p,g,v,w,o,i,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class s extends C.Disposable{constructor(r,m){var j;super();this.logService=r,this.options=m,this.BUFFER_SIZE=((j=this.options)===null||j===void 0?void 0:j.bufferSize)||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8,T.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:m,symbolicLink:j}=await f.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(m,j),ctime:m.birthtime.getTime(),mtime:m.mtime.getTime(),size:m.size}}catch(m){throw this.toFileSystemProviderError(m)}}async readdir(r){try{const m=await(0,f.readdir)(this.toFilePath(r),{withFileTypes:!0}),j=[];return await Promise.all(m.map(async M=>{try{let F;M.isSymbolicLink()?F=(await this.stat((0,I.joinPath)(r,M.name))).type:F=this.toType(M),j.push([M.name,F])}catch(F){this.logService.trace(F)}})),j}catch(m){throw this.toFileSystemProviderError(m)}}toType(r,m){let j;return(m==null?void 0:m.dangling)?j=E.FileType.Unknown:r.isFile()?j=E.FileType.File:r.isDirectory()?j=E.FileType.Directory:j=E.FileType.Unknown,m&&(j|=E.FileType.SymbolicLink),j}async readFile(r){try{const m=this.toFilePath(r);return await y.promises.readFile(m)}catch(m){throw this.toFileSystemProviderError(m)}}readFileStream(r,m,j){const M=(0,o.newWriteableStream)(F=>n.VSBuffer.concat(F.map(z=>n.VSBuffer.wrap(z))).buffer);return(0,i.readFileIntoStream)(this,r,M,F=>F.buffer,Object.assign(Object.assign({},m),{bufferSize:this.BUFFER_SIZE}),j),M}async writeFile(r,m,j){let M;try{const F=this.toFilePath(r);if(!j.create||!j.overwrite){if(await(0,f.exists)(F)){if(!j.overwrite)throw(0,E.createFileSystemProviderError)((0,l.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!j.create)throw(0,E.createFileSystemProviderError)((0,l.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}M=await this.open(r,{create:!0}),await this.write(M,0,m,0,m.byteLength)}catch(F){throw this.toFileSystemProviderError(F)}finally{typeof M=="number"&&await this.close(M)}}async open(r,m){try{const j=this.toFilePath(r);let M;if(m.create){if(T.isWindows)try{await y.promises.truncate(j,0),M="r+"}catch(z){z.code!=="ENOENT"&&this.logService.trace(z)}M||(M="w")}else M="r";const F=await(0,A.promisify)(y.open)(j,M);return this.mapHandleToPos.set(F,0),m.create&&this.writeHandles.add(F),F}catch(j){throw this.toFileSystemProviderError(j)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await(0,A.promisify)(y.fdatasync)(r)}catch(m){this.canFlush=!1,this.logService.error(m)}return await(0,A.promisify)(y.close)(r)}catch(m){throw this.toFileSystemProviderError(m)}}async read(r,m,j,M,F){const z=this.normalizePos(r,m);let B=null;try{const H=await(0,A.promisify)(y.read)(r,j,M,F,z);return typeof H=="number"?B=H:B=H.bytesRead,B}catch(H){throw this.toFileSystemProviderError(H)}finally{this.updatePos(r,z,B)}}normalizePos(r,m){return m===this.mapHandleToPos.get(r)?null:m}updatePos(r,m,j){const M=this.mapHandleToPos.get(r);typeof M=="number"&&(typeof m=="number"||(typeof j=="number"?this.mapHandleToPos.set(r,M+j):this.mapHandleToPos.delete(r)))}async write(r,m,j,M,F){return(0,R.retry)(()=>this.doWrite(r,m,j,M,F),100,3)}async doWrite(r,m,j,M,F){const z=this.normalizePos(r,m);let B=null;try{const H=await(0,A.promisify)(y.write)(r,j,M,F,z);return typeof H=="number"?B=H:B=H.bytesWritten,B}catch(H){throw this.toFileSystemProviderError(H)}finally{this.updatePos(r,z,B)}}async mkdir(r){try{await y.promises.mkdir(this.toFilePath(r))}catch(m){throw this.toFileSystemProviderError(m)}}async delete(r,m){try{const j=this.toFilePath(r);await this.doDelete(j,m)}catch(j){throw this.toFileSystemProviderError(j)}}async doDelete(r,m){m.recursive?await(0,f.rimraf)(r,f.RimRafMode.MOVE):await y.promises.unlink(r)}async rename(r,m,j){const M=this.toFilePath(r),F=this.toFilePath(m);if(M!==F)try{await this.validateTargetDeleted(r,m,"move",j.overwrite),await(0,f.move)(M,F)}catch(z){throw(z.code==="EINVAL"||z.code==="EBUSY"||z.code==="ENAMETOOLONG")&&(z=new Error((0,l.localize)(2,null,(0,h.basename)(M),(0,h.basename)((0,h.dirname)(F)),z.toString()))),this.toFileSystemProviderError(z)}}async copy(r,m,j){const M=this.toFilePath(r),F=this.toFilePath(m);if(M!==F)try{await this.validateTargetDeleted(r,m,"copy",j.overwrite),await(0,f.copy)(M,F,{preserveSymlinks:!0})}catch(z){throw(z.code==="EINVAL"||z.code==="EBUSY"||z.code==="ENAMETOOLONG")&&(z=new Error((0,l.localize)(3,null,(0,h.basename)(M),(0,h.basename)((0,h.dirname)(F)),z.toString()))),this.toFileSystemProviderError(z)}}async validateTargetDeleted(r,m,j,M){const F=this.toFilePath(r),z=this.toFilePath(m);let B=!1;if(!!(this.capabilities&1024)||(B=(0,u.isEqual)(F,z,!0)),B&&j==="copy")throw(0,E.createFileSystemProviderError)((0,l.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!B&&await(0,f.exists)(z)){if(!M)throw(0,E.createFileSystemProviderError)((0,l.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(m,{recursive:!0,useTrash:!1})}}watch(r,m){return m.recursive?this.watchRecursive(r,m.excludes):this.watchNonRecursive(r)}watchRecursive(r,m){const j={path:this.toFilePath(r),excludes:m},M=(0,e.insert)(this.recursiveFoldersToWatch,j);return this.refreshRecursiveWatchers(),(0,C.toDisposable)(()=>{M(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var r,m,j;if(this.recursiveWatcher instanceof v.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,C.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let M,F;((m=(r=this.options)===null||r===void 0?void 0:r.watcher)===null||m===void 0?void 0:m.usePolling)?(M=p.FileWatcher,F=(j=this.options)===null||j===void 0?void 0:j.watcher):this.recursiveFoldersToWatch.length===1?T.isWindows?M=g.FileWatcher:M=p.FileWatcher:M=v.FileWatcher,this.recursiveWatcher=new M(this.recursiveFoldersToWatch,z=>this._onDidChangeFile.fire((0,D.toFileChanges)(z)),z=>{z.type==="error"&&this._onDidWatchErrorOccur.fire(z.message),this.logService[z.type](z.message)},this.logService.getLevel()===P.LogLevel.Trace,F),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))}}watchNonRecursive(r){const m=new w.FileWatcher(this.toFilePath(r),M=>this._onDidChangeFile.fire((0,D.toFileChanges)(M)),M=>{M.type==="error"&&this._onDidWatchErrorOccur.fire(M.message),this.logService[M.type](M.message)},this.logService.getLevel()===P.LogLevel.Trace),j=this.logService.onDidChangeLogLevel(()=>{m.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)});return(0,C.combinedDisposable)(m,j)}toFilePath(r){return(0,h.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof E.FileSystemProviderError)return r;let m;switch(r.code){case"ENOENT":m=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":m=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":m=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":m=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":m=E.FileSystemProviderErrorCode.NoPermissions;break;default:m=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(r,m)}dispose(){super.dispose(),(0,C.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,C.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=s}),define(Y[98],Z([0,1,12,14,125,24,2,22,4,26,13,36,21,11,9,3]),function(x,t,y,A,C,E,k,T,f,h,I,u,R,P,l,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let p=class extends k.Disposable{constructor(w,o,i){super();this.extensionManagementService=w,this.logService=i,this._onDidLanguagesChange=this._register(new P.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new g(o,i)),this._register(w.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(w.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(w=>{const o=["en",...Object.keys(w)];return(0,R.distinct)(o)})}onDidInstallExtension(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",w.identifier.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(w){this.cache.getLanguagePacks().then(o=>{Object.keys(o).some(i=>o[i]&&o[i].extensions.some(e=>(0,h.areSameExtensions)(e.extensionIdentifier,w)))&&(this.logService.debug("Removing language packs from the extension",w.id),this.update().then(i=>{i&&this._onDidLanguagesChange.fire()}))})}async update(){const[w,o]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(o);return!(0,R.equals)(Object.keys(w),Object.keys(i))}};p=ce([fe(0,E.IExtensionManagementService),fe(1,T.INativeEnvironmentService),fe(2,I.ILogService)],p),t.LocalizationsService=p;let g=class extends k.Disposable{constructor(w,o){super();this.logService=o,this.languagePacks={},this.languagePacksFilePath=(0,D.join)(w.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new f.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(w){return this.withLanguagePacks(o=>{Object.keys(o).forEach(i=>delete o[i]),this.createLanguagePacksFromExtensions(o,...w)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(w,...o){for(const i of o)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(w,i);Object.keys(w).forEach(i=>this.updateHash(w[i]))}createLanguagePacksFromExtension(w,o){const i=o.identifier,e=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const n of e)if(o.location.scheme===l.Schemas.file&&(0,u.isValidLocalization)(n)){let s=w[n.languageId];s||(s={hash:"",extensions:[],translations:{}},w[n.languageId]=s);let a=s.extensions.filter(r=>(0,h.areSameExtensions)(r.extensionIdentifier,i))[0];a?a.version=o.manifest.version:s.extensions.push({extensionIdentifier:i,version:o.manifest.version});for(const r of n.translations)s.translations[r.id]=(0,D.join)(o.location.fsPath,r.path)}}updateHash(w){if(w){const o=(0,C.createHash)("md5");for(const i of w.extensions)o.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);w.hash=o.digest("hex")}}withLanguagePacks(w=()=>null){return this.languagePacksFileLimiter.queue(()=>{let o=null;return A.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch(e){return{}}}).then(i=>(o=w(i),i)).then(i=>{for(const n of Object.keys(i))i[n]||delete i[n];this.languagePacks=i,this.initializedCache=!0;const e=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",e),(0,y.writeFile)(this.languagePacksFilePath,e)}).then(()=>o,i=>this.logService.error(i))})}};g=ce([fe(0,T.INativeEnvironmentService),fe(1,I.ILogService)],g)}),define(Y[99],Z([0,1,13,23]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function C(f,h,I,u){try{const R=await new Promise((P,l)=>{x(["spdlog"],P,l)});return R.setAsyncMode(8192,500),R.createRotatingLoggerAsync(f,h,I,u)}catch(R){console.error(R)}return null}function E(f,h,I,u){return x.__$__nodeRequire("spdlog").createRotatingLogger(f,h,I,u)}t.createRotatingLogger=E;function k(f,h,I){switch(h){case y.LogLevel.Trace:f.trace(I);break;case y.LogLevel.Debug:f.debug(I);break;case y.LogLevel.Info:f.info(I);break;case y.LogLevel.Warning:f.warn(I);break;case y.LogLevel.Error:f.error(I);break;case y.LogLevel.Critical:f.critical(I);break;default:throw new Error("Invalid log level")}}class T extends y.AbstractMessageLogger{constructor(h,I,u,R){super();this.name=h,this.filepath=I,this.rotating=u,this.buffer=[],this.setLevel(R),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(P=>{this._logger&&this._logger.setLevel(P)}))}_createSpdLogLogger(){const h=this.rotating?6:1,I=30/h*A.ByteSize.MB;return C(this.name,this.filepath,I,h).then(u=>{if(u){this._logger=u,this._logger.setLevel(this.getLevel());for(const{level:R,message:P}of this.buffer)k(this._logger,R,P);this.buffer=[]}})}log(h,I){this._logger?k(this._logger,h,I):this.getLevel()<=h&&this.buffer.push({level:h,message:I})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=T}),define(Y[100],Z([0,1,45,39,62,3,20,55,66,9,10]),function(x,t,y,A,C,E,k,T,f,h,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseUserDataDir=t.parsePathArg=t.parseSearchPort=t.parseExtensionHostPort=t.NativeEnvironmentService=void 0;class u{constructor(v){if(this._args=v,!v.logsPath){const w=(0,f.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");v.logsPath=(0,E.join)(this.userDataPath,"logs",w)}this.logsPath=v.logsPath}get args(){return this._args}get appRoot(){return(0,E.dirname)(h.FileAccess.asFileUri("",x).fsPath)}get userHome(){return I.URI.file((0,y.homedir)())}get userDataPath(){const v=process.env.VSCODE_PORTABLE;return v?(0,E.join)(v,"user-data"):p(this._args,process)}get appSettingsHome(){return I.URI.file((0,E.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file((0,y.tmpdir)())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return I.URI.file((0,E.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(I.URI.file((0,E.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return I.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return I.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=process.env.VSCODE_PORTABLE;return v?I.URI.file((0,E.join)(v,"argv.json")):(0,k.joinPath)(this.userHome,A.default.dataFolderName,"argv.json")}get snippetsHome(){return(0,k.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,E.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,E.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=D(this._args["builtin-extensions-dir"],process);return v||(0,E.normalize)((0,E.join)(h.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const v=D(this._args["extensions-download-dir"],process);return v||(0,E.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const v=D(this._args["extensions-dir"],process);if(v)return v;const w=process.env.VSCODE_EXTENSIONS;if(w)return w;const o=process.env.VSCODE_PORTABLE;return o?(0,E.join)(o,"extensions"):(0,k.joinPath)(this.userHome,A.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this._args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(w=>/^[^:/?#]+?:\/\//.test(w)?I.URI.parse(w):I.URI.file((0,E.normalize)(w)))}get extensionTestsLocationURI(){const v=this._args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?I.URI.parse(v):I.URI.file((0,E.normalize)(v))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const v=this._args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return R(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get serviceMachineIdResource(){return(0,k.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return I.URI.file((0,E.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}ce([T.memoize],u.prototype,"appRoot",null),ce([T.memoize],u.prototype,"userHome",null),ce([T.memoize],u.prototype,"userDataPath",null),ce([T.memoize],u.prototype,"appSettingsHome",null),ce([T.memoize],u.prototype,"tmpDir",null),ce([T.memoize],u.prototype,"userRoamingDataHome",null),ce([T.memoize],u.prototype,"settingsResource",null),ce([T.memoize],u.prototype,"userDataSyncHome",null),ce([T.memoize],u.prototype,"userDataSyncLogResource",null),ce([T.memoize],u.prototype,"sync",null),ce([T.memoize],u.prototype,"machineSettingsResource",null),ce([T.memoize],u.prototype,"globalStorageHome",null),ce([T.memoize],u.prototype,"workspaceStorageHome",null),ce([T.memoize],u.prototype,"keybindingsResource",null),ce([T.memoize],u.prototype,"keyboardLayoutResource",null),ce([T.memoize],u.prototype,"argvResource",null),ce([T.memoize],u.prototype,"snippetsHome",null),ce([T.memoize],u.prototype,"isExtensionDevelopment",null),ce([T.memoize],u.prototype,"untitledWorkspacesHome",null),ce([T.memoize],u.prototype,"installSourcePath",null),ce([T.memoize],u.prototype,"builtinExtensionsPath",null),ce([T.memoize],u.prototype,"extensionsPath",null),ce([T.memoize],u.prototype,"extensionDevelopmentLocationURI",null),ce([T.memoize],u.prototype,"extensionTestsLocationURI",null),ce([T.memoize],u.prototype,"debugExtensionHost",null),ce([T.memoize],u.prototype,"serviceMachineIdResource",null),ce([T.memoize],u.prototype,"telemetryLogResource",null),t.NativeEnvironmentService=u;function R(g,v){return l(g["inspect-extensions"],g["inspect-brk-extensions"],5870,v,g.debugId)}t.parseExtensionHostPort=R;function P(g,v){return l(g["inspect-search"],g["inspect-brk-search"],5876,v)}t.parseSearchPort=P;function l(g,v,w,o,i){const n=Number(v||g)||(o?null:w),s=n?Boolean(!!v):!1;return{port:n,break:s,debugId:i}}function D(g,v){if(!!g){const w=(0,E.resolve)(g);return(0,E.normalize)(g)===w?w:(0,E.resolve)(v.env.VSCODE_CWD||v.cwd(),g)}}t.parsePathArg=D;function p(g,v){return D(g["user-data-dir"],v)||(0,E.resolve)((0,C.getDefaultUserDataPath)())}t.parseUserDataDir=p}),define(Y[40],Z([0,1,7]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,y.createDecorator)("productService")}),define(Y[25],Z([0,1,8,54]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class C{constructor(){this.data=new Map}add(k,T){A.ok(y.isString(k)),A.ok(y.isObject(T)),A.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,T)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}t.Registry=new C}),define(Y[101],Z([0,1,25,11]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function C(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class E{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,h){this.schemasById[C(f)]=h,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new E;y.Registry.add(t.Extensions.JSONContribution,k)}),define(Y[29],Z([0,1,71,11,25,8,101]),function(x,t,y,A,C,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var T;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const f=C.Registry.as(k.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:y.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(g,v=!0){this.registerConfigurations([g],v)}registerConfigurations(g,v=!0){const w=[];g.forEach(o=>{w.push(...this.validateAndRegisterProperties(o,v)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}deregisterConfigurations(g){const v=[],w=o=>{if(o.properties)for(const i in o.properties)v.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,o.properties[i]);o.allOf&&o.allOf.forEach(i=>w(i))};for(const o of g){w(o);const i=this.configurationContributors.indexOf(o);i!==-1&&this.configurationContributors.splice(i,1)}f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}registerDefaultConfigurations(g){const v=[],w=[];for(const o of g)for(const i in o)if(v.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]=Object.assign(Object.assign({},this.defaultValues[i]||{}),o[i]);const e={type:"object",default:this.defaultValues[i],description:y.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};w.push(u(i)),this.configurationProperties[i]=e,this.defaultLanguageConfigurationOverridesNode.properties[i]=e}else{this.defaultValues[i]=o[i];const e=this.configurationProperties[i];e&&(this.updatePropertyDefaultValue(i,e),this.updateSchema(i,e))}this.registerOverrideIdentifiers(w),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterDefaultConfigurations(g){const v=[];for(const w of g)for(const o in w)if(v.push(o),delete this.defaultValues[o],t.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const i=this.configurationProperties[o];i&&(this.updatePropertyDefaultValue(o,i),this.updateSchema(o,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const v of g)this.overrideIdentifiers.add(v);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(g,v=!0,w=3){w=E.isUndefinedOrNull(g.scope)?w:g.scope;let o=[],i=g.properties;if(i)for(let n in i){if(v&&l(n)){delete i[n];continue}const s=i[n];if(this.updatePropertyDefaultValue(n,s),t.OVERRIDE_PROPERTY_PATTERN.test(n)?s.scope=void 0:s.scope=E.isUndefinedOrNull(s.scope)?w:s.scope,i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),o.push(n)}let e=g.allOf;if(e)for(let n of e)o.push(...this.validateAndRegisterProperties(n,v,w));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(g){const v=w=>{let o=w.properties;if(o)for(const e in o)this.updateSchema(e,o[e]);let i=w.allOf;i&&i.forEach(v)};v(g)}updateSchema(g,v){switch(t.allSettings.properties[g]=v,v.scope){case 1:t.applicationSettings.properties[g]=v;break;case 2:t.machineSettings.properties[g]=v;break;case 6:t.machineOverridableSettings.properties[g]=v;break;case 3:t.windowSettings.properties[g]=v;break;case 4:t.resourceSettings.properties[g]=v;break;case 5:t.resourceSettings.properties[g]=v,this.resourceLanguageSettingsSchema.properties[g]=v;break}}removeFromSchema(g,v){switch(delete t.allSettings.properties[g],v.scope){case 1:delete t.applicationSettings.properties[g];break;case 2:delete t.machineSettings.properties[g];break;case 6:delete t.machineOverridableSettings.properties[g];break;case 3:delete t.windowSettings.properties[g];break;case 4:case 5:delete t.resourceSettings.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const v=`[${g}]`,w={type:"object",description:y.localize(2,null),errorMessage:y.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(v,w),t.allSettings.properties[v]=w,t.applicationSettings.properties[v]=w,t.machineSettings.properties[v]=w,t.machineOverridableSettings.properties[v]=w,t.windowSettings.properties[v]=w,t.resourceSettings.properties[v]=w}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,v){let w=this.defaultValues[g];E.isUndefined(w)&&(w=v.default),E.isUndefined(w)&&(w=R(v.type)),v.default=w}}const I="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function u(p){return p.substring(1,p.length-1)}t.overrideIdentifierFromKey=u;function R(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=R;const P=new h;C.Registry.add(t.Extensions.Configuration,P);function l(p){return p.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(p)?y.localize(5,null,p):P.getConfigurationProperties()[p]!==void 0?y.localize(6,null,p):null:y.localize(4,null)}t.validateProperty=l;function D(){const p=[],g=P.getConfigurationProperties();for(const v of Object.keys(g))p.push([v,g[v].scope]);return p.push(["launch",4]),p.push(["task",4]),p}t.getScopes=D}),define(Y[27],Z([0,1,19,8,10,25,7,29]),function(x,t,y,A,C,E,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,k.createDecorator)("configurationService");function f(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof C.URI)}t.isConfigurationOverrides=f;var h;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(h=t.ConfigurationTarget||(t.ConfigurationTarget={}));function I(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=I;function u(n,s){const a=s?n?s.keys.filter(B=>n.keys.indexOf(B)===-1):[...s.keys]:[],r=n?s?n.keys.filter(B=>s.keys.indexOf(B)===-1):[...n.keys]:[],m=[];if(s&&n){for(const B of n.keys)if(s.keys.indexOf(B)!==-1){const H=g(n.contents,B),X=g(s.contents,B);y.equals(H,X)||m.push(B)}}const j=[],M=B=>{const H={};for(const X of B)for(const se of X.identifiers)H[i(se)]=X;return H},F=s?M(s.overrides):{},z=n?M(n.overrides):{};if(Object.keys(F).length)for(const B of a){const H=F[B];H&&j.push([(0,T.overrideIdentifierFromKey)(B),H.keys])}if(Object.keys(z).length)for(const B of r){const H=z[B];H&&j.push([(0,T.overrideIdentifierFromKey)(B),H.keys])}if(Object.keys(F).length&&Object.keys(z).length)for(const B of m){const H=z[B],X=F[B];if(H&&X){const se=u({contents:H.contents,keys:H.keys,overrides:[]},{contents:X.contents,keys:X.keys,overrides:[]});j.push([(0,T.overrideIdentifierFromKey)(B),[...se.added,...se.removed,...se.updated]])}}return{added:a,removed:r,updated:m,overrides:j}}t.compare=u;function R(n,s){const a=[];for(const r of Object.keys(n))if(T.OVERRIDE_PROPERTY_PATTERN.test(r)){const m={};for(const j in n[r])m[j]=n[r][j];a.push({identifiers:[(0,T.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(m),contents:P(m,s)})}return a}t.toOverrides=R;function P(n,s){const a=Object.create(null);for(let r in n)l(a,r,n[r],s);return a}t.toValuesTree=P;function l(n,s,a,r){const m=s.split("."),j=m.pop();let M=n;for(let F=0;F<m.length;F++){let z=m[F],B=M[z];switch(typeof B){case"undefined":B=M[z]=Object.create(null);break;case"object":break;default:r(`Ignoring ${s} as ${m.slice(0,F+1).join(".")} is ${JSON.stringify(B)}`);return}M=B}if(typeof M=="object"&&M!==null)try{M[j]=a}catch(F){r(`Ignoring ${s} as ${m.join(".")} is ${JSON.stringify(M)}`)}else r(`Ignoring ${s} as ${m.join(".")} is ${JSON.stringify(M)}`)}t.addToValueTree=l;function D(n,s){const a=s.split(".");p(n,a)}t.removeFromValueTree=D;function p(n,s){const a=s.shift();if(s.length===0){delete n[a];return}if(Object.keys(n).indexOf(a)!==-1){const r=n[a];typeof r=="object"&&!Array.isArray(r)&&(p(r,s),Object.keys(r).length===0&&delete n[a])}}function g(n,s,a){function r(M,F){let z=M;for(const B of F){if(typeof z!="object"||z===null)return;z=z[B]}return z}const m=s.split("."),j=r(n,m);return typeof j=="undefined"?a:j}t.getConfigurationValue=g;function v(n,s,a){Object.keys(s).forEach(r=>{r!=="__proto__"&&(r in n?A.isObject(n[r])&&A.isObject(s[r])?v(n[r],s[r],a):a&&(n[r]=s[r]):n[r]=s[r])})}t.merge=v;function w(){const n=E.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}t.getConfigurationKeys=w;function o(){const n=Object.create(null),s=E.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let a in s){let r=s[a].default;l(n,a,r,m=>console.error(`Conflict in default settings: ${m}`))}return n}t.getDefaultValues=o;function i(n){return`[${n}]`}t.keyFromOverrideIdentifier=i;function e(n,s,a){const r=n.inspect(s),m=n.inspect(a);return typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:r.defaultValue}t.getMigratedSettingValue=e}),define(Y[102],Z([0,1,56,43,21,8,19,10,29,27,25,2,11]),function(x,t,y,A,C,E,k,T,f,h,I,u,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class P{constructor(e={},n=[],s=[]){this._contents=e,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,h.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const s=this.getContentsForOverrideIdentifer(n);return s?e?(0,h.getConfigurationValue)(s,e):s:void 0}getKeysForOverrideIdentifier(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.keys;return[]}override(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const a of C.distinct([...Object.keys(this.contents),...Object.keys(n)])){let r=this.contents[a],m=n[a];m&&(typeof r=="object"&&typeof m=="object"?(r=k.deepClone(r),this.mergeContents(r,m)):r=m),s[a]=r}return new P(s,this.keys,this.overrides)}merge(...e){const n=k.deepClone(this.contents),s=k.deepClone(this.overrides),a=[...this.keys];for(const r of e){this.mergeContents(n,r.contents);for(const m of r.overrides){const[j]=s.filter(M=>C.equals(M.identifiers,m.identifiers));j?this.mergeContents(j.contents,m.contents):s.push(k.deepClone(m))}for(const m of r.keys)a.indexOf(m)===-1&&a.push(m)}return new P(n,a,s)}freeze(){return this.isFrozen=!0,this}mergeContents(e,n){for(const s of Object.keys(n)){if(s in e&&E.isObject(e[s])&&E.isObject(n[s])){this.mergeContents(e[s],n[s]);continue}e[s]=k.deepClone(n[s])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?k.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,h.addToValueTree)(this.contents,e,n,s=>{throw new Error(s)})}removeValue(e){this.removeKey(e)&&(0,h.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let s=0;s<n;s++)e.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}t.ConfigurationModel=P;class l extends P{constructor(){const e=(0,h.getDefaultValues)(),n=(0,h.getConfigurationKeys)(),s=[];for(const a of Object.keys(e))f.OVERRIDE_PROPERTY_PATTERN.test(a)&&s.push({identifiers:[(0,f.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(e[a]),contents:(0,h.toValuesTree)(e[a],r=>console.error(`Conflict in default settings file: ${r}`))});super(e,n,s)}}t.DefaultConfigurationModel=l;class D{constructor(e,n){this._name=e,this._scopes=n,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new P}get errors(){return this._parseErrors}parseContent(e){if(!E.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n)}}parseRaw(e){this._raw=e;const n=this.doParseRaw(e);this._configurationModel=new P(n.contents,n.keys,n.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(e){let n={},s=null,a=[],r=[],m=[];function j(F){Array.isArray(a)?a.push(F):s&&(a[s]=F)}let M={onObjectBegin:()=>{let F={};j(F),r.push(a),a=F,s=null},onObjectProperty:F=>{s=F},onObjectEnd:()=>{a=r.pop()},onArrayBegin:()=>{let F=[];j(F),r.push(a),a=F,s=null},onArrayEnd:()=>{a=r.pop()},onLiteralValue:j,onError:(F,z,B)=>{m.push({error:F,offset:z,length:B})}};if(e)try{y.visit(e,M),n=a[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return n}doParseRaw(e){if(this._scopes){const r=I.Registry.as(f.Extensions.Configuration).getConfigurationProperties();e=this.filterByScope(e,r,!0,this._scopes)}const n=(0,h.toValuesTree)(e,r=>console.error(`Conflict in settings file ${this._name}: ${r}`)),s=Object.keys(e),a=(0,h.toOverrides)(e,r=>console.error(`Conflict in settings file ${this._name}: ${r}`));return{contents:n,keys:s,overrides:a}}filterByScope(e,n,s,a){const r={};for(let m in e)if(f.OVERRIDE_PROPERTY_PATTERN.test(m)&&s)r[m]=this.filterByScope(e[m],n,!1,a);else{const j=this.getScope(m,n);(j===void 0||a.indexOf(j)!==-1)&&(r[m]=e[m])}return r}getScope(e,n){const s=n[e];return s?typeof s.scope!="undefined"?s.scope:3:void 0}}t.ConfigurationModelParser=D;class p extends u.Disposable{constructor(e,n,s,a){super();this.userSettingsResource=e,this.scopes=n,this.fileService=a,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new D(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(R.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(e.value.toString()||"{}"),this.parser.configurationModel}catch(e){return new P}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}t.UserSettings=p;class g{constructor(e,n,s=new P,a=new P,r=new A.ResourceMap,m=new P,j=new A.ResourceMap,M=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=r,this._memoryConfiguration=m,this._memoryConfigurationByResource=j,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(e,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(e)}updateValue(e,n,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new P,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(e):a.setValue(e,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,s){const a=this.getConsolidateConfigurationModel(n,s),r=this.getFolderConfigurationModelForResource(n.resource,s),m=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,j=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),M=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),F=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),z=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),B=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,H=r?n.overrideIdentifier?r.freeze().override(n.overrideIdentifier).getValue(e):r.freeze().getValue(e):void 0,X=n.overrideIdentifier?m.override(n.overrideIdentifier).getValue(e):m.getValue(e),se=a.getValue(e),re=C.distinct(C.flatten(a.overrides.map(ee=>ee.identifiers))).filter(ee=>a.getOverrideValue(e,ee)!==void 0);return{defaultValue:j,userValue:M,userLocalValue:F,userRemoteValue:z,workspaceValue:B,workspaceFolderValue:H,memoryValue:X,value:se,default:j!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:z!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:H!==void 0?{value:r==null?void 0:r.freeze().getValue(e),override:n.overrideIdentifier?r==null?void 0:r.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:X!==void 0?{value:m.getValue(e),override:n.overrideIdentifier?m.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:re.length?re:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const s=n.filter(a=>f.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const r=(0,f.overrideIdentifierFromKey)(a),m=this._defaultConfiguration.getKeysForOverrideIdentifier(r),j=e.getKeysForOverrideIdentifier(r),M=[...j.filter(F=>m.indexOf(F)===-1),...m.filter(F=>j.indexOf(F)===-1),...m.filter(F=>!k.equals(this._defaultConfiguration.override(r).getValue(F),e.override(r).getValue(F)))];return[r,M]});return this.updateDefaultConfiguration(e),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:s,removed:a,overrides:r}=(0,h.compare)(this.localUserConfiguration,e),m=[...n,...s,...a];return m.length&&this.updateLocalUserConfiguration(e),{keys:m,overrides:r}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:s,removed:a,overrides:r}=(0,h.compare)(this.remoteUserConfiguration,e);let m=[...n,...s,...a];return m.length&&this.updateRemoteUserConfiguration(e),{keys:m,overrides:r}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:s,removed:a,overrides:r}=(0,h.compare)(this.workspaceConfiguration,e);let m=[...n,...s,...a];return m.length&&this.updateWorkspaceConfiguration(e),{keys:m,overrides:r}}compareAndUpdateFolderConfiguration(e,n){const s=this.folderConfigurations.get(e),{added:a,updated:r,removed:m,overrides:j}=(0,h.compare)(s,n);let M=[...a,...r,...m];return(M.length||!s)&&this.updateFolderConfiguration(e,n),{keys:M,overrides:j}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:s,updated:a,removed:r,overrides:m}=(0,h.compare)(n,void 0);return{keys:[...s,...a,...r],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let s=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?s.override(e.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:e},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const a=n.getFolder(e);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const r=this._memoryConfigurationByResource.get(e);r&&(s=s.merge(r))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(e);a?(n=s.merge(a),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=s}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const s=n.getFolder(e);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:s,overrides:a,keys:r}=this._folderConfigurations.get(n);return e.push([n,{contents:s,overrides:a,keys:r}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>e.add(s))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(e).forEach(a=>n.add(a))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),s=this.parseConfigurationModel(e.user),a=this.parseConfigurationModel(e.workspace),r=e.folders.reduce((m,j)=>(m.set(T.URI.revive(j[0]),this.parseConfigurationModel(j[1])),m),new A.ResourceMap);return new g(n,s,new P,a,r,new P,new A.ResourceMap,!1)}static parseConfigurationModel(e){return new P(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=g;function v(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const e=new Set,n=new Map;for(const a of i)a.keys.forEach(r=>e.add(r)),a.overrides.forEach(([r,m])=>{const j=(0,A.getOrSet)(n,r,new Set);m.forEach(M=>j.add(M))});const s=[];return n.forEach((a,r)=>s.push([r,[...a.values()]])),{keys:[...e.values()],overrides:s}}t.mergeChanges=v;class w{constructor(e,n,s,a){this.change=e,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const r=new Set;e.keys.forEach(j=>r.add(j)),e.overrides.forEach(([,j])=>j.forEach(M=>r.add(M))),this.affectedKeys=[...r.values()];const m=new P;this.affectedKeys.forEach(j=>m.setValue(j,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const a=this.previousConfiguration?this.previousConfiguration.getValue(e,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,r=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!k.equals(a,r)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let s=(0,h.toValuesTree)({[n]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(e=e[a],!e)return!1;s=s[a]}return!0}}t.ConfigurationChangeEvent=w;class o extends w{constructor(e,n,s,a){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=s,this.sourceConfig=a}}t.AllKeysConfigurationChangeEvent=o}),define(Y[103],Z([0,1,25,29,2,27,102,11,4,20]),function(x,t,y,A,C,E,k,T,f,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class I extends C.Disposable{constructor(R,P){super();this.settingsResource=R,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new k.UserSettings(this.settingsResource,void 0,h.extUriBiasedIgnorePathCase,P)),this.configuration=new k.Configuration(new k.DefaultConfigurationModel,new k.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new f.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(y.Registry.as(A.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const R=await this.userConfiguration.loadConfiguration();this.configuration=new k.Configuration(new k.DefaultConfigurationModel,R)}getConfigurationData(){return this.configuration.toData()}getValue(R,P){const l=typeof R=="string"?R:void 0,D=(0,E.isConfigurationOverrides)(R)?R:(0,E.isConfigurationOverrides)(P)?P:{};return this.configuration.getValue(l,D,void 0)}updateValue(R,P,l,D){return Promise.reject(new Error("not supported"))}inspect(R){return this.configuration.inspect(R,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const R=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(R)}onDidChangeUserConfiguration(R){const P=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(R);this.trigger(l,P,1)}onDidDefaultConfigurationChange(R){const P=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new k.DefaultConfigurationModel,R);this.trigger(l,P,6)}trigger(R,P,l){const D=new k.ConfigurationChangeEvent(R,{data:P},this.configuration);D.source=l,D.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(D)}getTargetConfiguration(R){switch(R){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=I}),define(Y[52],Z([0,1,81,7,29,25,16]),function(x,t,y,A,C,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,A.createDecorator)("requestService");function T(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=T;function f(u){return u.res.statusCode===204}async function h(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);return f(u)?null:(await(0,k.streamToBuffer)(u.stream)).toString()}t.asText=h;async function I(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);if(f(u))return null;const P=(await(0,k.streamToBuffer)(u.stream)).toString();try{return JSON.parse(P)}catch(l){throw l.message+=`:
`+P,l}}t.asJson=I,E.Registry.as(C.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:(0,y.localize)(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,y.localize)(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,y.localize)(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,y.localize)(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,y.localize)(4,null),(0,y.localize)(5,null),(0,y.localize)(6,null)],default:"override",description:(0,y.localize)(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:(0,y.localize)(8,null)}}})}),define(Y[104],Z([0,1,105,8]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function C(k){return k.protocol==="http:"?process.env.HTTP_PROXY||process.env.http_proxy||null:k.protocol==="https:"&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}async function E(k,T={}){const f=(0,y.parse)(k),h=T.proxyUrl||C(f);if(!h)return null;const I=(0,y.parse)(h);if(!/^https?:$/.test(I.protocol||""))return null;const u={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,A.isBoolean)(T.strictSSL)?T.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((R,P)=>{x(["http-proxy-agent"],R,P)}))(u):new(await new Promise((R,P)=>{x(["https-proxy-agent"],R,P)}))(u)}t.getProxyAgent=E}),define(Y[106],Z([0,1,38,16]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function C(E,k,T){let f=T&&T.get("storage.serviceMachineId",0)||null;if(f)return f;try{const I=(await k.readFile(E.serviceMachineIdResource)).value.toString();f=(0,y.isUUID)(I)?I:null}catch(h){f=null}if(!f){f=(0,y.generateUuid)();try{await k.writeFile(E.serviceMachineIdResource,A.VSBuffer.fromString(f))}catch(h){}}return T&&T.store("storage.serviceMachineId",f,0,1),f}t.getServiceMachineId=C}),define(Y[107],Z([0,1,7]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=(0,y.createDecorator)("stateService")}),define(Y[108],Z([0,1,3,14,22,12,8,13]),function(x,t,y,A,C,E,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class f{constructor(u,R){this.dbPath=u,this.onError=R,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const u=await this.loadAsync();this._database||(this._database=u)}}loadSync(){try{return this.lastFlushedSerializedDatabase=A.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(u){return u.code!=="ENOENT"&&this.onError(u),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await A.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(u){return u.code!=="ENOENT"&&this.onError(u),{}}}getItem(u,R){const P=this.database[u];return(0,k.isUndefinedOrNull)(P)?R:P}setItem(u,R){if((0,k.isUndefinedOrNull)(R))return this.removeItem(u);(typeof R=="string"||typeof R=="number"||typeof R=="boolean")&&this.database[u]===R||(this.database[u]=R,this.saveSync())}removeItem(u){(0,k.isUndefined)(this.database[u])||(this.database[u]=void 0,this.saveSync())}saveSync(){const u=JSON.stringify(this.database,null,4);if(u!==this.lastFlushedSerializedDatabase)try{(0,E.writeFileSync)(this.dbPath,u),this.lastFlushedSerializedDatabase=u}catch(R){this.onError(R)}}}t.FileStorage=f;let h=class Ve{constructor(u,R){this.fileStorage=new f(y.join(u.userDataPath,Ve.STATE_FILE),P=>R.error(P))}init(){return this.fileStorage.init()}getItem(u,R){return this.fileStorage.getItem(u,R)}setItem(u,R){this.fileStorage.setItem(u,R)}removeItem(u){this.fileStorage.removeItem(u)}};h.STATE_FILE="storage.json",h=ce([fe(0,C.INativeEnvironmentService),fe(1,T.ILogService)],h),t.StateService=h}),define(Y[109],Z([0,1,7,11,2,8,64,4]),function(x,t,y,A,C,E,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";t.IStorageService=(0,y.createDecorator)("storageService");var h;(function(D){D[D.NONE=0]="NONE",D[D.SHUTDOWN=1]="SHUTDOWN"})(h=t.WillSaveStateReason||(t.WillSaveStateReason={}));var I;(function(D){D[D.GLOBAL=0]="GLOBAL",D[D.WORKSPACE=1]="WORKSPACE"})(I=t.StorageScope||(t.StorageScope={}));var u;(function(D){D[D.USER=0]="USER",D[D.MACHINE=1]="MACHINE"})(u=t.StorageTarget||(t.StorageTarget={}));class R extends C.Disposable{constructor(p={flushInterval:R.DEFAULT_FLUSH_INTERVAL}){super();this.options=p,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new C.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,C.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(p,g){g===f?(p===0?this._globalKeyTargets=void 0:p===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:p})):this._onDidChangeValue.fire({scope:p,key:g,target:this.getKeyTargets(p)[g]})}emitWillSaveState(p){this._onWillSaveState.fire({reason:p})}get(p,g,v){var w;return(w=this.getStorage(g))===null||w===void 0?void 0:w.get(p,v)}getBoolean(p,g,v){var w;return(w=this.getStorage(g))===null||w===void 0?void 0:w.getBoolean(p,v)}getNumber(p,g,v){var w;return(w=this.getStorage(g))===null||w===void 0?void 0:w.getNumber(p,v)}store(p,g,v,w){if((0,E.isUndefinedOrNull)(g)){this.remove(p,v);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(p,v,w),(o=this.getStorage(v))===null||o===void 0||o.set(p,g)})}remove(p,g){this.withPausedEmitters(()=>{var v;this.updateKeyTarget(p,g,void 0),(v=this.getStorage(g))===null||v===void 0||v.delete(p)})}withPausedEmitters(p){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{p()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(p,g){const v=[],w=this.getKeyTargets(p);for(const o of Object.keys(w))w[o]===g&&v.push(o);return v}updateKeyTarget(p,g,v){var w,o;const i=this.getKeyTargets(g);typeof v=="number"?i[p]!==v&&(i[p]=v,(w=this.getStorage(g))===null||w===void 0||w.set(f,JSON.stringify(i))):typeof i[p]=="number"&&(delete i[p],(o=this.getStorage(g))===null||o===void 0||o.set(f,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(p){return p===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(p){const g=this.get(f,p);if(g)try{return JSON.parse(g)}catch(v){}return Object.create(null)}isNew(p){return this.getBoolean(t.IS_NEW_KEY,p)===!0}async flush(){var p,g,v,w;this._onWillSaveState.fire({reason:h.NONE}),await T.Promises.settled([(g=(p=this.getStorage(0))===null||p===void 0?void 0:p.whenFlushed())!==null&&g!==void 0?g:Promise.resolve(),(w=(v=this.getStorage(1))===null||v===void 0?void 0:v.whenFlushed())!==null&&w!==void 0?w:Promise.resolve()])}async logStorage(){var p,g,v,w,o,i;const e=(g=(p=this.getStorage(0))===null||p===void 0?void 0:p.items)!==null&&g!==void 0?g:new Map,n=(w=(v=this.getStorage(1))===null||v===void 0?void 0:v.items)!==null&&w!==void 0?w:new Map;return l(e,n,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(i=this.getLogDetails(1))!==null&&i!==void 0?i:"")}}t.AbstractStorageService=R,R.DEFAULT_FLUSH_INTERVAL=60*1e3;class P extends R{constructor(){super();this.globalStorage=new k.Storage(new k.InMemoryStorageDatabase),this.workspaceStorage=new k.Storage(new k.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(p=>this.emitDidChangeValue(1,p))),this._register(this.globalStorage.onDidChangeStorage(p=>this.emitDidChangeValue(0,p)))}getStorage(p){return p===0?this.globalStorage:this.workspaceStorage}getLogDetails(p){return p===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(p){}}t.InMemoryStorageService=P;async function l(D,p,g,v){const w=r=>{try{return JSON.parse(r)}catch(m){return r}},o=new Map,i=new Map;D.forEach((r,m)=>{o.set(m,r),i.set(m,w(r))});const e=new Map,n=new Map;p.forEach((r,m)=>{e.set(m,r),n.set(m,w(r))}),console.group(`Storage: Global (path: ${g})`);let s=[];o.forEach((r,m)=>{s.push({key:m,value:r})}),console.table(s),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${v})`);let a=[];e.forEach((r,m)=>{a.push({key:m,value:r})}),console.table(a),console.groupEnd(),console.log(n)}t.logStorage=l}),define(Y[110],Z([0,1,17,126,38,10]),function(x,t,y,A,C,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0;async function k(f,h,I,u,R,P,l,D,p){const g=Object.create(null);g["common.machineId"]=P,g.sessionID=(0,C.generateUuid)()+Date.now(),g.commitHash=u,g.version=R,g["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,y.PlatformToString)(y.platform),g["common.nodePlatform"]=A.platform,g["common.nodeArch"]=I,g["common.product"]=p||"desktop";const v=T(l||[]);v&&(g["common.msftInternal"]=v);let w=0;const o=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>w++,enumerable:!0}}),y.isLinuxSnap&&(g["common.snap"]="true");try{const i=await f.readFile(E.URI.file(D));g["common.source"]=i.value.toString().slice(0,30)}catch(i){}return g}t.resolveCommonProperties=k;function T(f){const h=A.env.USERDNSDOMAIN;if(!h)return!1;const I=h.toLowerCase();return f.some(u=>I===u)}}),define(Y[41],Z([0,1,7]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,y.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,y.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Y[111],Z([0,1,15,24,26,19,41,52,47,22,28,13,23,10,40,109,106,7,20]),function(x,t,y,A,C,E,k,T,f,h,I,u,R,P,l,D,p,g,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var w;(function(d){d[d.None=0]="None",d[d.IncludeVersions=1]="IncludeVersions",d[d.IncludeFiles=2]="IncludeFiles",d[d.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",d[d.IncludeSharedAccounts=8]="IncludeSharedAccounts",d[d.IncludeVersionProperties=16]="IncludeVersionProperties",d[d.ExcludeNonValidated=32]="ExcludeNonValidated",d[d.IncludeInstallationTargets=64]="IncludeInstallationTargets",d[d.IncludeAssetUri=128]="IncludeAssetUri",d[d.IncludeStatistics=256]="IncludeStatistics",d[d.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",d[d.Unpublished=4096]="Unpublished"})(w||(w={}));function o(...d){return String(d.reduce((c,b)=>c|b,0))}var i;(function(d){d[d.Tag=1]="Tag",d[d.ExtensionId=4]="ExtensionId",d[d.Category=5]="Category",d[d.ExtensionName=7]="ExtensionName",d[d.Target=8]="Target",d[d.Featured=9]="Featured",d[d.SearchText=10]="SearchText",d[d.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:w.None,criteria:[],assetTypes:[]};class r{constructor(c=a){this.state=c}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(c,b=this.state.pageSize){return new r(Object.assign(Object.assign({},this.state),{pageNumber:c,pageSize:b}))}withFilter(c,...b){const L=[...this.state.criteria,...b.length?b.map(N=>({filterType:c,value:N})):[{filterType:c}]];return new r(Object.assign(Object.assign({},this.state),{criteria:L}))}withSortBy(c){return new r(Object.assign(Object.assign({},this.state),{sortBy:c}))}withSortOrder(c){return new r(Object.assign(Object.assign({},this.state),{sortOrder:c}))}withFlags(...c){return new r(Object.assign(Object.assign({},this.state),{flags:c.reduce((b,L)=>b|L,0)}))}withAssetTypes(...c){return new r(Object.assign(Object.assign({},this.state),{assetTypes:c}))}get raw(){const{criteria:c,pageNumber:b,pageSize:L,sortBy:N,sortOrder:U,flags:$,assetTypes:_}=this.state;return{filters:[{criteria:c,pageNumber:b,pageSize:L,sortBy:N,sortOrder:U}],assetTypes:_,flags:$}}get searchText(){const c=this.state.criteria.filter(b=>b.filterType===i.SearchText)[0];return c&&c.value?c.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(c=>String(c.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function m(d,c){const b=(d||[]).filter(L=>L.statisticName===c)[0];return b?b.value:0}function j(d){const c="Microsoft.VisualStudio.Code.Translation.";return d.files.filter(L=>L.assetType.indexOf(c)===0).reduce((L,N)=>{const U=B(d,N.assetType);return U&&L.push([N.assetType.substring(c.length),U]),L},[])}function M(d){if(d.properties){const c=d.properties.filter(N=>N.key===e.Repository),b=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),L=c.filter(N=>b.test(N.value))[0];return L?{uri:L.value,fallbackUri:L.value}:null}return B(d,e.Repository)}function F(d){return{uri:`${d.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${d.fallbackAssetUri}/${e.VSIX}`}}function z(d){const c=B(d,e.Icon);if(c)return c;const b=A.DefaultIconPath;return{uri:b,fallbackUri:b}}function B(d,c){return d.files.filter(L=>L.assetType===c)[0]?{uri:`${d.assetUri}/${c}`,fallbackUri:`${d.fallbackAssetUri}/${c}`}:null}function H(d,c){const b=d.properties?d.properties.filter(N=>N.key===c):[],L=b.length>0&&b[0].value;return L?L.split(",").map(N=>(0,C.adoptToGalleryExtensionId)(N)):[]}function X(d){const c=d.properties?d.properties.filter(b=>b.key===n.Engine):[];return c.length>0&&c[0].value||""}function se(d){const c=d.properties?d.properties.filter(L=>L.key===n.LocalizedLanguages):[],b=c.length>0&&c[0].value||"";return b?b.split(","):[]}function re(d){return d.indexOf("preview")!==-1}function ee(d){const c=d.properties?d.properties.find(b=>b.key===n.WebExtension):void 0;return!!c&&c.value==="true"}function le(d){return d.files.some(c=>c.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,v.joinPath)(P.URI.parse(d.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function W(d,c,b,L,N){const U={manifest:B(c,e.Manifest),readme:B(c,e.Details),changelog:B(c,e.Changelog),license:B(c,e.License),repository:M(c),download:F(c),icon:z(c),coreTranslations:j(c)};return{identifier:{id:(0,C.getGalleryExtensionId)(d.publisher.publisherName,d.extensionName),uuid:d.extensionId},name:d.extensionName,version:c.version,date:c.lastUpdated,displayName:d.displayName,publisherId:d.publisher.publisherId,publisher:d.publisher.publisherName,publisherDisplayName:d.publisher.displayName,description:d.shortDescription||"",installCount:m(d.statistics,"install"),rating:m(d.statistics,"averagerating"),ratingCount:m(d.statistics,"ratingcount"),assetUri:P.URI.parse(c.assetUri),webResource:le(c),assetTypes:c.files.map(({assetType:$})=>$),assets:U,properties:{dependencies:H(c,n.Dependency),extensionPack:H(c,n.ExtensionPack),engine:X(c),localizedLanguages:se(c),webExtension:ee(c)},telemetryData:{index:(L.pageNumber-1)*L.pageSize+b,searchText:L.searchText,querySource:N},preview:re(d.flags)}}let O=class{constructor(c,b,L,N,U,$,_){this.requestService=c,this.logService=b,this.environmentService=L,this.telemetryService=N,this.fileService=U,this.productService=$;const q=$.extensionsGallery;this.extensionsGalleryUrl=q&&q.serviceUrl,this.extensionsControlUrl=q&&q.controlUrl,this.commonHeadersPromise=S($.version,this.environmentService,this.fileService,_)}api(c=""){return`${this.extensionsGalleryUrl}${c}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(c,b){const L=[];let{total:N,firstPage:U,getPage:$}=await this.query({names:c,pageSize:c.length},b);L.push(...U);for(let _=1;L.length<N&&(U=await $(_,b),U.length);_++)L.push(...U);return L}async getCompatibleExtension(c,b){const L=await this.getCompatibleExtensionByEngine(c,b);return(L==null?void 0:L.properties.webExtension)?L.webResource?L:null:L}async getCompatibleExtensionByEngine(c,b){const L=(0,A.isIExtensionIdentifier)(c)?null:c;if(L&&L.properties.engine&&(0,f.isEngineValid)(L.properties.engine,this.productService.version))return L;const{id:N,uuid:U}=L?L.identifier:c;let $=new r().withFlags(w.IncludeAssetUri,w.IncludeStatistics,w.IncludeFiles,w.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");U?$=$.withFilter(i.ExtensionId,U):$=$.withFilter(i.ExtensionName,N);const{galleryExtensions:_}=await this.queryGallery($,I.CancellationToken.None),[q]=_;if(!q||!q.versions.length)return null;if(b){const Q=q.versions.filter(te=>te.version===b)[0];if(Q){const te=W(q,Q,0,$);if(te.properties.engine&&(0,f.isEngineValid)(te.properties.engine,this.productService.version))return te}return null}const J=await this.getLastValidExtensionVersion(q,q.versions);return J?W(q,J,0,$):null}async query(c,b){const L=I.CancellationToken.isCancellationToken(c)?{}:c,N=I.CancellationToken.isCancellationToken(c)?c:b;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let U=L.text||"";const $=(0,E.getOrDefault)(L,ne=>ne.pageSize,50);let _=new r().withFlags(w.IncludeLatestVersionOnly,w.IncludeAssetUri,w.IncludeStatistics,w.IncludeFiles,w.IncludeVersionProperties).withPage(1,$).withFilter(i.Target,"Microsoft.VisualStudio.Code");U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,de,me)=>(_=_.withFilter(i.Category,me||de),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,de,me)=>(_=_.withFilter(i.Tag,me||de),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(i.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),_=_.withFilter(i.SearchText,U)),_=_.withSortBy(0)):L.ids?_=_.withFilter(i.ExtensionId,...L.ids):L.names?_=_.withFilter(i.ExtensionName,...L.names):_=_.withSortBy(4),typeof L.sortBy=="number"&&(_=_.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(_=_.withSortOrder(L.sortOrder));const{galleryExtensions:q,total:J}=await this.queryGallery(_,N),Q=q.map((ne,de)=>W(ne,ne.versions[0],de,_,L.source)),te=async(ne,de)=>{if(de.isCancellationRequested)throw(0,y.canceled)();const me=_.withPage(ne+1),{galleryExtensions:Ie}=await this.queryGallery(me,de);return Ie.map((Le,Te)=>W(Le,Le.versions[0],Te,me,L.source))};return{firstPage:Q,total:J,pageSize:_.pageSize,getPage:te}}async queryGallery(c,b){if(!this.isEnabled())throw new Error("No extension gallery service configured.");c=c.withFlags(c.flags,w.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,o(w.Unpublished));const L=await this.commonHeadersPromise,N=JSON.stringify(c.raw),U=Object.assign(Object.assign({},L),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(N.length)}),$=new Date().getTime();let _,q,J=0;try{if(_=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:N,headers:U},b),_.res.statusCode&&_.res.statusCode>=400&&_.res.statusCode<500)return{galleryExtensions:[],total:J};const Q=await(0,T.asJson)(_);if(Q){const te=Q.results[0],ne=te.extensions,de=te.resultMetadata&&te.resultMetadata.filter(me=>me.metadataType==="ResultCount")[0];return J=de&&de.metadataItems.filter(me=>me.name==="TotalCount")[0].count||0,{galleryExtensions:ne,total:J}}return{galleryExtensions:[],total:J}}catch(Q){throw q=Q,Q}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},c.telemetryData),{requestBodySize:String(N.length),duration:new Date().getTime()-$,success:!!_&&(0,T.isSuccess)(_),responseBodySize:_==null?void 0:_.res.headers["Content-Length"],statusCode:_?String(_.res.statusCode):void 0,errorCode:q?(0,y.isPromiseCanceledError)(q)?"canceled":(0,y.getErrorMessage)(q).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(J)}))}}async reportStatistic(c,b,L,N){if(!!this.isEnabled()){const U=await this.commonHeadersPromise,$=Object.assign(Object.assign({},U),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${c}/extensions/${b}/${L}/stats?statType=${N}`),headers:$},I.CancellationToken.None)}catch(_){}}}async download(c,b,L){this.logService.trace("ExtensionGalleryService#download",c.identifier.id);const N=(0,C.getGalleryExtensionTelemetryData)(c),U=new Date().getTime(),$=Q=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},N),{duration:Q})),_=L===1?"install":L===2?"update":"",q=_?{uri:`${c.assets.download.uri}&${_}=true`,fallbackUri:`${c.assets.download.fallbackUri}?${_}=true`}:c.assets.download,J=await this.getAsset(q);await this.fileService.writeFile(b,J.stream),$(new Date().getTime()-U)}async getReadme(c,b){if(c.assets.readme){const L=await this.getAsset(c.assets.readme,{},b);return await(0,T.asText)(L)||""}return""}async getManifest(c,b){if(c.assets.manifest){const L=await this.getAsset(c.assets.manifest,{},b),N=await(0,T.asText)(L);return N?JSON.parse(N):null}return null}async getCoreTranslation(c,b){const L=c.assets.coreTranslations.filter(N=>N[0]===b.toUpperCase())[0];if(L){const N=await this.getAsset(L[1]),U=await(0,T.asText)(N);return U?JSON.parse(U):null}return null}async getChangelog(c,b){if(c.assets.changelog){const L=await this.getAsset(c.assets.changelog,{},b);return await(0,T.asText)(L)||""}return""}async getAllVersions(c,b){let L=new r().withFlags(w.IncludeVersions,w.IncludeFiles,w.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");c.identifier.uuid?L=L.withFilter(i.ExtensionId,c.identifier.uuid):L=L.withFilter(i.ExtensionName,c.identifier.id);const N=[],{galleryExtensions:U}=await this.queryGallery(L,I.CancellationToken.None);return U.length&&(b?await Promise.all(U[0].versions.map(async $=>{let _;try{_=await this.getEngine($)}catch(q){}_&&(0,f.isEngineValid)(_,this.productService.version)&&N.push({version:$.version,date:$.lastUpdated})})):N.push(...U[0].versions.map($=>({version:$.version,date:$.lastUpdated})))),N}async getAsset(c,b={},L=I.CancellationToken.None){const N=await this.commonHeadersPromise,U={type:"GET"},$=Object.assign(Object.assign({},N),b.headers||{});b=Object.assign(Object.assign(Object.assign({},b),U),{headers:$});const _=c.uri,q=c.fallbackUri,J=Object.assign(Object.assign({},b),{url:_});try{const Q=await this.requestService.request(J,L);if(Q.res.statusCode===200)return Q;const te=await(0,T.asText)(Q);throw new Error(`Expected 200, got back ${Q.res.statusCode} instead.

${te}`)}catch(Q){if((0,y.isPromiseCanceledError)(Q))throw Q;const te=(0,y.getErrorMessage)(Q);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:_,message:te});const ne=Object.assign(Object.assign({},b),{url:q});return this.requestService.request(ne,L)}}async getLastValidExtensionVersion(c,b){const L=this.getLastValidExtensionVersionFromProperties(c,b);return L||this.getLastValidExtensionVersionRecursively(c,b)}getLastValidExtensionVersionFromProperties(c,b){for(const L of b){const N=X(L);if(!N)return null;if((0,f.isEngineValid)(N,this.productService.version))return L}return null}async getEngine(c){const b=X(c);if(b)return b;const L=B(c,e.Manifest);if(!L)throw new Error("Manifest was not found");const N={"Accept-Encoding":"gzip"},U=await this.getAsset(L,{headers:N}),$=await(0,T.asJson)(U);if($)return $.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(c,b){if(!b.length)return null;const L=b[0],N=await this.getEngine(L);return(0,f.isEngineValid)(N,this.productService.version)?(L.properties=L.properties||[],L.properties.push({key:n.Engine,value:N}),L):this.getLastValidExtensionVersionRecursively(c,b.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const c=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(c.res.statusCode!==200)throw new Error("Could not get extensions report.");const b=await(0,T.asJson)(c),L=new Map;if(b)for(const N of b.malicious){const U=L.get(N)||{id:{id:N},malicious:!0,slow:!1};U.malicious=!0,L.set(N,U)}return[...L.values()]}};O=ce([fe(0,T.IRequestService),fe(1,u.ILogService),fe(2,h.IEnvironmentService),fe(3,k.ITelemetryService),fe(4,R.IFileService),fe(5,l.IProductService),fe(6,(0,g.optional)(D.IStorageService))],O),t.ExtensionGalleryService=O;async function S(d,c,b,L){const N={"X-Market-Client-Id":`VSCode ${d}`,"User-Agent":`VSCode ${d}`},U=await(0,p.getServiceMachineId)(c,b,L);return N["X-Market-User-Id"]=U,N}t.resolveMarketplaceHeaders=S}),define(Y[112],Z([0,1,39,82,18,7,27,29,2,19,25]),function(x,t,y,A,C,E,k,T,f,h,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let u=class{constructor(l,D){this._configurationService=D,this._experimentProperties={},this._disposables=new f.DisposableStore,this._cleanupPatterns=[],this._appender=l.appender,this._commonProperties=l.commonProperties||Promise.resolve({}),this._piiPaths=l.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(p),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(p=>{const g=/^[a-f0-9]+$/i.test(p["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!g})}))}setExperimentProperty(l,D){this._experimentProperties[l]=D}setEnabled(l){this._enabled=l}_updateUserOptIn(){var l;const D=(l=this._configurationService)===null||l===void 0?void 0:l.getValue(R);this._userOptIn=D?D.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const l=await this._commonProperties;let D=l.sessionID,p=l["common.instanceId"],g=l["common.machineId"],v=l["common.firstSessionDate"],w=l["common.msftInternal"];return{sessionId:D,instanceId:p,machineId:g,firstSessionDate:v,msftInternal:w}}dispose(){this._disposables.dispose()}publicLog(l,D,p){return this.isOptedIn?this._commonProperties.then(g=>{D=(0,h.mixin)(D,g),D=(0,h.mixin)(D,this._experimentProperties),D=(0,h.cloneAndChange)(D,v=>{if(typeof v=="string")return this._cleanupInfo(v,p)}),this._appender.log(l,D)},g=>{console.error(g)}):Promise.resolve(void 0)}publicLog2(l,D,p){return this.publicLog(l,D,p)}publicLogError(l,D){return this.sendErrorTelemetry?this.publicLog(l,D,!0):Promise.resolve(void 0)}publicLogError2(l,D){return this.publicLogError(l,D)}_cleanupInfo(l,D){let p=l;if(D){const g=[];for(let i of this._cleanupPatterns)for(;;){const e=i.exec(l);if(!e)break;g.push([e.index,i.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(p="";;){const i=w.exec(l);if(!i)break;!v.test(i[0])&&g.every(([e,n])=>i.index<e||i.index>=n)&&(p+=l.substring(o,i.index)+"<REDACTED: user-file-path>",o=w.lastIndex)}o<l.length&&(p+=l.substr(o))}for(let g of this._cleanupPatterns)p=p.replace(g,"");return p}};u.IDLE_START_EVENT_NAME="UserIdleStart",u.IDLE_STOP_EVENT_NAME="UserIdleStop",u=ce([fe(1,(0,E.optional)(k.IConfigurationService))],u),t.TelemetryService=u;const R="telemetry";I.Registry.as(T.Extensions.Configuration).registerConfiguration({id:R,order:110,type:"object",title:(0,A.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,A.localize)(2,null,y.default.privacyStatementUrl):(0,A.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Y[53],Z([0,1,27,19,8,4]),function(x,t,y,A,C,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(l,D){return Promise.resolve(void 0)}publicLog2(l,D){return this.publicLog(l,D)}publicLogError(l,D){return Promise.resolve(void 0)}publicLogError2(l,D){return this.publicLogError(l,D)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class k{async publicLog(D,p,g){}async publicLogError(D,p,g){}}t.NullEndpointTelemetryService=k;function T(...l){return{log:(D,p)=>l.forEach(g=>g.log(D,p)),flush:()=>E.Promises.settled(l.map(D=>D.flush()))}}t.combinedAppender=T,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(l,D){return D.onDidChangeConfiguration(p=>{p.source!==6&&l.publicLog2("updateConfiguration",{configurationSource:(0,y.ConfigurationTargetToString)(p.source),configurationKeys:R(p.sourceConfig)})})}t.configurationTelemetry=f;function h(l){const D=Object.create(null),p=Object.create(null),g=Object.create(null);u(l,g);for(let v in g){v=v.length>150?v.substr(v.length-149):v;const w=g[v];typeof w=="number"?p[v]=w:typeof w=="boolean"?p[v]=w?1:0:typeof w=="string"?D[v]=w.substring(0,1023):typeof w!="undefined"&&w!==null&&(D[v]=w)}return{properties:D,measurements:p}}t.validateTelemetryData=h;function I(l){if(!l)return"none";let D="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(g=>{l.indexOf(`${g}+`)===0&&(D=g)}),D}t.cleanRemoteAuthority=I;function u(l,D,p=0,g){if(!!l)for(let v of Object.getOwnPropertyNames(l)){const w=l[v],o=g?g+v:v;Array.isArray(w)?D[o]=(0,A.safeStringify)(w):w instanceof Date?D[o]=w.toISOString():(0,C.isObject)(w)?p<2?u(w,D,p+1,o+"."):D[o]=(0,A.safeStringify)(w):D[o]=w}}function R(l){if(!l)return[];const D=[];return P(D,"",l),D}function P(l,D,p){p&&typeof p=="object"&&!Array.isArray(p)?Object.keys(p).forEach(g=>P(l,D?`${D}.${g}`:g,p[g])):l.push(D)}}),define(Y[113],Z([0,1,15,19,53]),function(x,t,y,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function E(T){const f=await new Promise((I,u)=>{x(["applicationinsights"],I,u)});let h;return f.defaultClient?(h=new f.TelemetryClient(T),h.channel.setUseDiskRetryCaching(!0)):(f.setup(T).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),h=f.defaultClient),T.indexOf("AIF-")===0&&(h.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),h}class k{constructor(f,h,I){this._eventPrefix=f,this._defaultData=h,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(f){if(!!this._aiClient){if(typeof this._aiClient!="string"){f(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=E(this._aiClient)),this._asyncAIClient.then(h=>{f(h)},h=>{(0,y.onUnexpectedError)(h),console.error(h)})}}log(f,h){!this._aiClient||(h=(0,A.mixin)(h,this._defaultData),h=(0,C.validateTelemetryData)(h),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+f,properties:h.properties,measurements:h.measurements})))}flush(){return this._aiClient?new Promise(f=>{this._withAIClient(h=>{h.flush({callback:()=>{this._aiClient=void 0,f(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=k}),define(Y[114],Z([0,1,12,14,3]),function(x,t,y,A,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;function E(k,T){const f=Object.create(null),h=(u,R)=>{const P=JSON.parse(u);f[R]=P};if(T){const u=(0,y.readdirSync)(T).filter(P=>{try{return(0,A.statSync)((0,C.join)(T,P)).isDirectory()}catch(l){return!1}}),R=[];u.forEach(P=>{(0,y.readdirSync)((0,C.join)(T,P)).filter(D=>D==="telemetry.json").length===1&&R.push(P)}),R.forEach(P=>{const l=(0,A.readFileSync)((0,C.join)(T,P,"telemetry.json")).toString();h(l,P)})}let I=(0,A.readFileSync)((0,C.join)(k,"telemetry-core.json")).toString();return h(I,"vscode-core"),I=(0,A.readFileSync)((0,C.join)(k,"telemetry-extensions.json")).toString(),h(I,"vscode-extensions"),JSON.stringify(f,null,4)}t.buildTelemetryMessage=E}),define(Y[42],Z([0,1,70,3,14,4,12,127,128,8]),function(x,t,y,A,C,E,k,T,f,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class I extends Error{constructor(e,n){let s=n.message;switch(e){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s);this.type=e,this.cause=n}}t.ExtractError=I;function u(i){const e=i.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,s)=>n+s,e&61440)}function R(i){if(i instanceof I)return i;let e;return/end of central directory record signature not found/.test(i.message)&&(e="CorruptZip"),new I(e,i)}function P(i,e,n,s,a,r){const m=A.dirname(e),j=A.join(s,m);if(!j.startsWith(s))return Promise.reject(new Error(y.localize(0,null,e)));const M=A.join(s,e);let F;return r.onCancellationRequested(()=>{F&&F.destroy()}),Promise.resolve(C.promises.mkdir(j,{recursive:!0})).then(()=>new Promise((z,B)=>{if(!r.isCancellationRequested)try{F=(0,C.createWriteStream)(M,{mode:n}),F.once("close",()=>z()),F.once("error",B),i.once("error",B),i.pipe(F)}catch(H){B(H)}}))}function l(i,e,n,s){let a=(0,E.createCancelablePromise)(()=>Promise.resolve()),r=0;return s.onCancellationRequested(()=>{a.cancel(),i.close()}),new Promise((m,j)=>{const M=new E.Sequencer,F=z=>{z.isCancellationRequested||(r++,i.readEntry())};i.once("error",j),i.once("close",()=>a.then(()=>{s.isCancellationRequested||i.entryCount===r?m():j(new I("Incomplete",new Error(y.localize(1,null,r,i.entryCount))))},j)),i.readEntry(),i.on("entry",z=>{if(!s.isCancellationRequested){if(!n.sourcePathRegex.test(z.fileName)){F(s);return}const B=z.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(B)){const se=A.join(e,B);a=(0,E.createCancelablePromise)(re=>C.promises.mkdir(se,{recursive:!0}).then(()=>F(re)).then(void 0,j));return}const H=p(i,z),X=u(z);a=(0,E.createCancelablePromise)(se=>M.queue(()=>H.then(re=>P(re,B,X,e,n,se).then(()=>F(se)))).then(null,j))}})})}function D(i,e=!1){return new Promise((n,s)=>{(0,T.open)(i,e?{lazyEntries:!0}:void 0,(a,r)=>{a?s(R(a)):n((0,h.assertIsDefined)(r))})})}function p(i,e){return new Promise((n,s)=>{i.openReadStream(e,(a,r)=>{a?s(R(a)):n((0,h.assertIsDefined)(r))})})}function g(i,e){return new Promise((n,s)=>{const a=new f.ZipFile;e.forEach(m=>{m.contents?a.addBuffer(typeof m.contents=="string"?Buffer.from(m.contents,"utf8"):m.contents,m.path):m.localPath&&a.addFile(m.localPath,m.path)}),a.end();const r=(0,C.createWriteStream)(i);a.outputStream.pipe(r),a.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>n(i))})}t.zip=g;function v(i,e,n={},s){const a=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=D(i,!0);return n.overwrite&&(r=r.then(m=>(0,k.rimraf)(e).then(()=>m))),r.then(m=>l(m,e,{sourcePathRegex:a},s))}t.extract=v;function w(i,e){return D(i).then(n=>new Promise((s,a)=>{n.on("entry",r=>{r.fileName===e&&p(n,r).then(m=>s(m),m=>a(m))}),n.once("close",()=>a(new Error(y.localize(2,null,e))))}))}function o(i,e){return w(i,e).then(n=>new Promise((s,a)=>{const r=[];n.once("error",a),n.on("data",m=>r.push(m)),n.on("end",()=>s(Buffer.concat(r)))}))}t.buffer=o}),define(Y[115],Z([0,1,42,75]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function C(E){return(0,y.buffer)(E,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(T){throw new Error((0,A.localize)(0,null))}})}t.getManifest=C}),define(Y[116],Z([0,1,14,37,2,12,3,13,24,26,4,10,22,83,76,40,42,17,21,9,23,20]),function(x,t,y,A,C,E,k,T,f,h,I,u,R,P,l,D,p,g,v,w,o,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const e="scanningSystem",n="scanningUser",s="extracting",a="deleting",r="renaming";let m=class extends C.Disposable{constructor(M,F,z,B,H){super();this.beforeRemovingExtension=M,this.fileService=F,this.logService=z,this.environmentService=B,this.productService=H,this._devSystemExtensionsPath=null,this.systemExtensionsPath=B.builtinExtensionsPath,this.extensionsPath=B.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new I.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(M){const F=[];(M===null||M===0)&&F.push(this.scanSystemExtensions().then(null,z=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(z).message,e)))),(M===null||M===1)&&F.push(this.scanUserExtensions(!0).then(null,z=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(z).message,n))));try{const z=await Promise.all(F);return(0,v.flatten)(z)}catch(z){throw this.joinErrors(z)}}async scanUserExtensions(M){this.logService.trace("Started scanning user extensions");let[F,z]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return z=z.filter(B=>!F[new h.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version).key()]),M&&(z=(0,h.groupByExtension)(z,H=>H.identifier).map(H=>H.sort((X,se)=>A.rcompare(X.manifest.version,se.manifest.version))[0])),this.logService.trace("Scanned user extensions:",z.length),z}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(M,F,z){const B=M.key(),H=k.join(this.extensionsPath,`.${B}`),X=k.join(this.extensionsPath,B);try{await E.rimraf(X)}catch(re){try{await E.rimraf(X)}catch(ee){}throw new f.ExtensionManagementError((0,l.localize)(0,null,X,M.id),a)}await this.extractAtLocation(M,F,H,z);try{await this.rename(M,H,X,Date.now()+2*60*1e3),this.logService.info("Renamed to",X)}catch(re){this.logService.info("Rename failed. Deleting from extracted location",H);try{E.rimraf(H)}catch(ee){}throw re}let se=null;try{se=await this.scanExtension(u.URI.file(k.join(this.extensionsPath,B)),1)}catch(re){}if(se)return se;throw new Error((0,l.localize)(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(M,F){this.setMetadata(M,F),F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0;const z=k.join(M.location.fsPath,"package.json"),B=await y.promises.readFile(z,"utf8"),{manifest:H}=await this.parseManifest(B);return H.__metadata=F,await E.writeFile(z,JSON.stringify(H,null,"	")),M}getUninstalledExtensions(){return this.withUninstalledExtensions(M=>M)}async withUninstalledExtensions(M){return this.uninstalledFileLimiter.queue(async()=>{let F;try{F=await y.promises.readFile(this.uninstalledPath,"utf8")}catch(H){if(H.code!=="ENOENT")throw H}let z={};if(F)try{z=JSON.parse(F)}catch(H){}const B=M(z);return Object.keys(z).length?await E.writeFile(this.uninstalledPath,JSON.stringify(z)):await E.rimraf(this.uninstalledPath),B})}async removeExtension(M,F){this.logService.trace(`Deleting ${F} extension from disk`,M.identifier.id,M.location.fsPath),await E.rimraf(M.location.fsPath),this.logService.info("Deleted from disk",M.identifier.id,M.location.fsPath)}async removeUninstalledExtension(M){await this.removeExtension(M,"uninstalled"),await this.withUninstalledExtensions(F=>delete F[new h.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()])}async extractAtLocation(M,F,z,B){this.logService.trace(`Started extracting the extension from ${F} to ${z}`);try{await E.rimraf(z)}catch(H){throw new f.ExtensionManagementError(this.joinErrors(H).message,a)}try{await(0,p.extract)(F,z,{sourcePath:"extension",overwrite:!0},B),this.logService.info(`Extracted extension to ${z}:`,M.id)}catch(H){try{await E.rimraf(z)}catch(X){}throw new f.ExtensionManagementError(H.message,H instanceof p.ExtractError&&H.type?H.type:s)}}async rename(M,F,z,B){try{await y.promises.rename(F,z)}catch(H){if(g.isWindows&&H&&H.code==="EPERM"&&Date.now()<B)return this.logService.info(`Failed renaming ${F} to ${z} with 'EPERM' error. Trying again...`,M.id),this.rename(M,F,z,B);throw new f.ExtensionManagementError(H.message||(0,l.localize)(2,null,F,z),H.code||r)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const M=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return M;const F=this.scanDevSystemExtensions(),[z,B]=await Promise.all([M,F]);return[...z,...B]}async scanExtensionsInDir(M,F){const z=new I.Limiter(10),B=await this.fileService.resolve(u.URI.file(M));return B.children?(await Promise.all(B.children.filter(X=>X.isDirectory).map(X=>z.queue(()=>this.scanExtension(X.resource,F))))).filter(X=>X&&X.identifier):[]}async scanExtension(M,F){var z,B;if(F===1&&(0,i.basename)(M).indexOf(".")===0)return null;try{const H=await this.fileService.resolve(M);if(H.children){const{manifest:X,metadata:se}=await this.readManifest(M.fsPath),re=(z=H.children.find(({name:O})=>/^readme(\.txt|\.md|)$/i.test(O)))===null||z===void 0?void 0:z.resource,ee=(B=H.children.find(({name:O})=>/^changelog(\.txt|\.md|)$/i.test(O)))===null||B===void 0?void 0:B.resource,le={id:(0,h.getGalleryExtensionId)(X.publisher,X.name)},W={type:F,identifier:le,manifest:X,location:M,readmeUrl:re,changelogUrl:ee,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:F===0};return se&&this.setMetadata(W,se),W}}catch(H){F!==0&&this.logService.trace(H)}return null}async scanDefaultSystemExtensions(){const M=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",M.length),M}async scanDevSystemExtensions(){const M=this.getDevSystemExtensionsList();if(M.length){const F=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",F.length),F.filter(z=>M.some(B=>(0,h.areSameExtensions)(z.identifier,{id:B})))}else return[]}setMetadata(M,F){M.publisherDisplayName=F.publisherDisplayName||null,M.publisherId=F.publisherId||null,M.identifier.uuid=F.id,M.isMachineScoped=!!F.isMachineScoped,M.isBuiltin=M.type===0||!!F.isBuiltin}async removeUninstalledExtensions(){const M=await this.getUninstalledExtensions(),F=await this.scanAllUserExtensions(),z=new Set;for(const X of F)M[new h.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).key()]||z.add(X.identifier.id.toLowerCase());const B=(0,h.groupByExtension)(F,X=>X.identifier);await I.Promises.settled(B.map(async X=>{const se=X.sort((re,ee)=>A.rcompare(re.manifest.version,ee.manifest.version))[0];z.has(se.identifier.id.toLowerCase())||await this.beforeRemovingExtension(se)}));const H=F.filter(X=>M[new h.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).key()]);await I.Promises.settled(H.map(X=>this.removeUninstalledExtension(X)))}async removeOutdatedExtensions(){const M=await this.scanAllUserExtensions(),F=[],z=(0,h.groupByExtension)(M,B=>B.identifier);F.push(...(0,v.flatten)(z.map(B=>B.sort((H,X)=>A.rcompare(H.manifest.version,X.manifest.version)).slice(1)))),await I.Promises.settled(F.map(B=>this.removeExtension(B,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(M=>M.name)}joinErrors(M){const F=Array.isArray(M)?M:[M];return F.length===1?F[0]instanceof Error?F[0]:new Error(F[0]):F.reduce((z,B)=>new Error(`${z.message}${z.message?",":""}${B instanceof Error?B.message:B}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(w.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(M){const F=[y.promises.readFile(k.join(M,"package.json"),"utf8").then(X=>this.parseManifest(X)),y.promises.readFile(k.join(M,"package.nls.json"),"utf8").then(void 0,X=>X.code!=="ENOENT"?Promise.reject(X):"{}").then(X=>JSON.parse(X))],[{manifest:z,metadata:B},H]=await Promise.all(F);return{manifest:(0,P.localizeManifest)(z,H),metadata:B}}parseManifest(M){return new Promise((F,z)=>{try{const B=JSON.parse(M),H=B.__metadata||null;F({manifest:B,metadata:H})}catch(B){z(new Error((0,l.localize)(3,null)))}})}};m=ce([fe(1,o.IFileService),fe(2,T.ILogService),fe(3,R.INativeEnvironmentService),fe(4,D.IProductService)],m),t.ExtensionsScanner=m}),define(Y[117],Z([0,1,14,74,3,12,2,21,42,24,26,22,4,11,37,10,39,17,13,90,30,41,47,20,38,89,7,9,28,115,94,116,95]),function(x,t,y,A,C,E,k,T,f,h,I,u,R,P,l,D,p,g,v,w,o,i,e,n,s,a,r,m,j,M,F,z,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const H="unsetUninstalled",X="downloading",se="validating",re="local",ee="unknown";let le=class extends k.Disposable{constructor(O,S,d,c,b,L){super();this.environmentService=O,this.galleryService=S,this.logService=d,this.downloadService=c,this.telemetryService=b,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new P.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new P.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new P.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new P.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const N=this._register(L.createInstance(B.ExtensionsLifecycle));this.extensionsScanner=this._register(L.createInstance(z.ExtensionsScanner,U=>N.postUninstall(U))),this.manifestCache=this._register(new w.ExtensionsManifestCache(O,this)),this.extensionsDownloader=this._register(L.createInstance(F.ExtensionsDownloader)),this._register((0,k.toDisposable)(()=>{this.installingExtensions.forEach(U=>U.cancel()),this.uninstallingExtensions.forEach(U=>U.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(O){this.logService.trace("ExtensionManagementService#zip",O.identifier.id);const S=await this.collectFiles(O),d=await(0,f.zip)((0,n.joinPath)(this.environmentService.tmpDir,(0,s.generateUuid)()).fsPath,S);return D.URI.file(d)}async unzip(O){return this.logService.trace("ExtensionManagementService#unzip",O.toString()),(await this.install(O)).identifier}async getManifest(O){const S=await this.downloadVsix(O),d=C.resolve(S.fsPath);return(0,M.getManifest)(d)}async collectFiles(O){const S=async c=>{let b=await E.readdir(c);b=b.map(U=>C.join(c,U));const L=await Promise.all(b.map(U=>y.promises.stat(U)));let N=Promise.resolve([]);return L.forEach((U,$)=>{const _=b[$];U.isFile()&&(N=N.then(q=>[...q,_])),U.isDirectory()&&(N=N.then(q=>S(_).then(J=>[...q,...J])))}),N};return(await S(O.location.fsPath)).map(c=>({path:`extension/${C.relative(O.location.fsPath,c)}`,localPath:c}))}async install(O,S={}){return this.logService.trace("ExtensionManagementService#install",O.toString()),(0,R.createCancelablePromise)(async d=>{const c=await this.downloadVsix(O),b=C.resolve(c.fsPath),L=await(0,M.getManifest)(b),N={id:(0,I.getGalleryExtensionId)(L.publisher,L.name)};let U=1;if(L.engines&&L.engines.vscode&&!(0,e.isEngineValid)(L.engines.vscode,p.default.version))throw new Error(A.localize(0,null,N.id,p.default.version));const $=new I.ExtensionIdentifierWithVersion(N,L.version),q=(await this.getInstalled(1)).find(Q=>(0,I.areSameExtensions)(N,Q.identifier));if(q)if(S.isMachineScoped=S.isMachineScoped||q.isMachineScoped,S.isBuiltin=S.isBuiltin||q.isBuiltin,U=2,$.equals(new I.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version)))try{await this.extensionsScanner.removeExtension(q,"existing")}catch(Q){throw new Error(A.localize(1,null,L.displayName||L.name))}else l.gt(q.manifest.version,L.version)&&await this.uninstallExtension(q);else{const Q=await this.unsetUninstalledAndGetLocal($);if(Q)try{await this.extensionsScanner.removeExtension(Q,"existing")}catch(te){throw new Error(A.localize(2,null,L.displayName||L.name))}}this.logService.info("Installing the extension:",N.id),this._onInstallExtension.fire({identifier:N,zipPath:b});let J;try{J=await this.getGalleryMetadata((0,I.getGalleryExtensionId)(L.publisher,L.name))}catch(Q){}try{const Q=await this.installFromZipPath($,b,Object.assign(Object.assign({},J||{}),S),S,U,d);return this.logService.info("Successfully installed the extension:",N.id),Q}catch(Q){throw this.logService.error("Failed to install the extension:",N.id,Q.message),Q}})}async downloadVsix(O){if(O.scheme===m.Schemas.file)return O;if(!this.downloadService)throw new Error("Download service is not available");const S=(0,n.joinPath)(this.environmentService.tmpDir,(0,s.generateUuid)());return await this.downloadService.download(O,S),S}async installFromZipPath(O,S,d,c,b,L){try{const N=await this.installExtension({zipPath:S,identifierWithVersion:O,metadata:d},L);try{await this.installDependenciesAndPackExtensions(N,void 0,c)}catch(U){(0,T.isNonEmptyArray)(N.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",N.identifier.id,U.message),(0,T.isNonEmptyArray)(N.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",N.identifier.id,U.message)}return this._onDidInstallExtension.fire({identifier:O,zipPath:S,local:N,operation:b}),N}catch(N){throw this._onDidInstallExtension.fire({identifier:O,zipPath:S,operation:b,error:N}),N}}async canInstall(O){return!0}async installFromGallery(O,S={}){if(!this.galleryService.isEnabled())throw new Error(A.localize(3,null));try{O=await this.checkAndGetCompatibleVersion(O)}catch(b){const L=b&&b.code?b.code:ee;throw this.logService.error("Failed to install extension:",O.identifier.id,b?b.message:L),this.reportTelemetry(this.getTelemetryEvent(1),(0,I.getGalleryExtensionTelemetryData)(O),void 0,b),b instanceof Error&&(b.name=L),b}const d=new I.ExtensionIdentifierWithVersion(O.identifier,O.version).key();let c=this.installingExtensions.get(d);return c||(c=(0,R.createCancelablePromise)(b=>this.doInstallFromGallery(O,S,b)),this.installingExtensions.set(d,c),c.finally(()=>this.installingExtensions.delete(d))),c}async doInstallFromGallery(O,S,d){const c=new Date().getTime();let b=1;this.logService.info("Installing extension:",O.identifier.id),this._onInstallExtension.fire({identifier:O.identifier,gallery:O});try{const N=(await this.getInstalled(1)).find(_=>(0,I.areSameExtensions)(_.identifier,O.identifier));N&&(b=2);const U=await this.downloadInstallableExtension(O,b);U.metadata.isMachineScoped=S.isMachineScoped||(N==null?void 0:N.isMachineScoped),U.metadata.isBuiltin=S.isBuiltin||(N==null?void 0:N.isBuiltin);const $=await this.installExtension(U,d);try{await this.extensionsDownloader.delete(D.URI.file(U.zipPath))}catch(_){}if(!S.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions($,N,S)}catch(_){try{await this.uninstall($)}catch(q){}throw _}return N&&l.neq(N.manifest.version,O.version)&&await this.setUninstalled(N),this.logService.info("Extensions installed successfully:",O.identifier.id),this._onDidInstallExtension.fire({identifier:O.identifier,gallery:O,local:$,operation:b}),this.reportTelemetry(this.getTelemetryEvent(b),(0,I.getGalleryExtensionTelemetryData)(O),new Date().getTime()-c,void 0),$}catch(L){const N=L&&L.code?L.code:ee;throw this.logService.error("Failed to install extension:",O.identifier.id,L?L.message:N),this._onDidInstallExtension.fire({identifier:O.identifier,gallery:O,operation:b,error:N}),this.reportTelemetry(this.getTelemetryEvent(b),(0,I.getGalleryExtensionTelemetryData)(O),new Date().getTime()-c,L),L instanceof Error&&(L.name=N),L}}async checkAndGetCompatibleVersion(O){if(await this.isMalicious(O))throw new h.ExtensionManagementError(A.localize(4,null),h.INSTALL_ERROR_MALICIOUS);const S=await this.galleryService.getCompatibleExtension(O);if(!S)throw new h.ExtensionManagementError(A.localize(5,null,O.identifier.id,p.default.version),h.INSTALL_ERROR_INCOMPATIBLE);return S}async reinstallFromGallery(O){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",O.identifier.id),!this.galleryService.isEnabled())throw new Error(A.localize(6,null));const S=await this.findGalleryExtension(O);if(!S)throw new Error(A.localize(7,null));await this.setUninstalled(O);try{await this.extensionsScanner.removeUninstalledExtension(O)}catch(d){throw new Error(A.localize(8,null,(0,o.toErrorMessage)(d)))}await this.installFromGallery(S)}getTelemetryEvent(O){return O===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(O){const S=await this.getExtensionsReport();return(0,I.getMaliciousExtensionsSet)(S).has(O.identifier.id)}async downloadInstallableExtension(O,S){const d={id:O.identifier.uuid,publisherId:O.publisherId,publisherDisplayName:O.publisherDisplayName};let c;try{this.logService.trace("Started downloading extension:",O.identifier.id);const b=await this.extensionsDownloader.downloadExtension(O,S);this.logService.info("Downloaded extension:",O.identifier.id,c),c=b.fsPath}catch(b){throw new h.ExtensionManagementError(this.joinErrors(b).message,X)}try{const b=await(0,M.getManifest)(c);return{zipPath:c,identifierWithVersion:new I.ExtensionIdentifierWithVersion(O.identifier,b.version),metadata:d}}catch(b){throw new h.ExtensionManagementError(this.joinErrors(b).message,se)}}async installExtension(O,S){try{const d=await this.unsetUninstalledAndGetLocal(O.identifierWithVersion);if(d)return O.metadata?this.extensionsScanner.saveMetadataForLocalExtension(d,O.metadata):d}catch(d){throw g.isMacintosh?new h.ExtensionManagementError(A.localize(9,null),H):new h.ExtensionManagementError(A.localize(10,null),H)}return this.extractAndInstall(O,S)}async unsetUninstalledAndGetLocal(O){return await this.isUninstalled(O)?(this.logService.trace("Removing the extension from uninstalled list:",O.id),await this.unsetUninstalled(O),this.logService.info("Removed the extension from uninstalled list:",O.id),(await this.getInstalled(1)).find(c=>new I.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).equals(O))||null):null}async extractAndInstall({zipPath:O,identifierWithVersion:S,metadata:d},c){let b=await this.extensionsScanner.extractUserExtension(S,O,c);return this.logService.info("Installation completed.",S.id),d&&(b=await this.extensionsScanner.saveMetadataForLocalExtension(b,d)),b}async installDependenciesAndPackExtensions(O,S,d){if(!!this.galleryService.isEnabled()){const c=O.manifest.extensionDependencies||[];if(O.manifest.extensionPack)for(const b of O.manifest.extensionPack)S&&S.manifest.extensionPack&&S.manifest.extensionPack.some(L=>(0,I.areSameExtensions)({id:L},{id:b}))||c.every(L=>!(0,I.areSameExtensions)({id:L},{id:b}))&&c.push(b);if(c.length){const b=await this.getInstalled(),L=c.filter(N=>b.every(({identifier:U})=>!(0,I.areSameExtensions)(U,{id:N})));if(L.length){const U=(await this.galleryService.query({names:L,pageSize:c.length},j.CancellationToken.None)).firstPage;try{await R.Promises.settled(U.map($=>this.installFromGallery($,d)))}catch($){try{await this.rollback(U)}catch(_){}throw $}}}}}async rollback(O){const d=(await this.getInstalled(1)).filter(c=>O.some(b=>new I.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).equals(new I.ExtensionIdentifierWithVersion(b.identifier,b.version))));await R.Promises.settled(d.map(c=>this.uninstall(c)))}async uninstall(O,S={}){this.logService.trace("ExtensionManagementService#uninstall",O.identifier.id);const d=await this.getInstalled(1),c=d.find(b=>(0,I.areSameExtensions)(b.identifier,O.identifier));if(!c)throw new Error(A.localize(11,null,O.manifest.displayName||O.manifest.name));try{await this.checkForDependenciesAndUninstall(c,d,S)}catch(b){throw this.joinErrors(b)}}async updateMetadata(O,S){return this.logService.trace("ExtensionManagementService#updateMetadata",O.identifier.id),O=await this.extensionsScanner.saveMetadataForLocalExtension(O,Object.assign(Object.assign({},O.manifest.__metadata||{}),S)),this.manifestCache.invalidate(),O}async updateExtensionScope(O,S){return this.logService.trace("ExtensionManagementService#updateExtensionScope",O.identifier.id),O=await this.extensionsScanner.saveMetadataForLocalExtension(O,Object.assign(Object.assign({},O.manifest.__metadata||{}),{isMachineScoped:S})),this.manifestCache.invalidate(),O}async getGalleryMetadata(O){const S=await this.findGalleryExtensionByName(O);return S?{id:S.identifier.uuid,publisherDisplayName:S.publisherDisplayName,publisherId:S.publisherId}:void 0}async findGalleryExtension(O){if(O.identifier.uuid){const S=await this.findGalleryExtensionById(O.identifier.uuid);return S||this.findGalleryExtensionByName(O.identifier.id)}return this.findGalleryExtensionByName(O.identifier.id)}async findGalleryExtensionById(O){return(await this.galleryService.query({ids:[O],pageSize:1},j.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(O){return(await this.galleryService.query({names:[O],pageSize:1},j.CancellationToken.None)).firstPage[0]}joinErrors(O){const S=Array.isArray(O)?O:[O];return S.length===1?S[0]instanceof Error?S[0]:new Error(S[0]):S.reduce((d,c)=>new Error(`${d.message}${d.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}async checkForDependenciesAndUninstall(O,S,d){try{await this.preUninstallExtension(O);const c=d.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(O,S);await this.uninstallExtensions(O,c,S,d)}catch(c){throw await this.postUninstallExtension(O,new h.ExtensionManagementError(c instanceof Error?c.message:c,re)),c}await this.postUninstallExtension(O)}async uninstallExtensions(O,S,d,c){const b=[O,...S];if(!c.donotCheckDependents)for(const L of b)this.checkForDependents(L,b,d,O);await R.Promises.settled([this.uninstallExtension(O),...S.map(L=>this.doUninstall(L))])}checkForDependents(O,S,d,c){const b=this.getDependents(O,d);if(b.length){const L=b.filter(N=>S.indexOf(N)===-1);if(L.length)throw new Error(this.getDependentsErrorMessage(O,L,c))}}getDependentsErrorMessage(O,S,d){return d===O?S.length===1?A.localize(12,null,d.manifest.displayName||d.manifest.name,S[0].manifest.displayName||S[0].manifest.name):S.length===2?A.localize(13,null,d.manifest.displayName||d.manifest.name,S[0].manifest.displayName||S[0].manifest.name,S[1].manifest.displayName||S[1].manifest.name):A.localize(14,null,d.manifest.displayName||d.manifest.name,S[0].manifest.displayName||S[0].manifest.name,S[1].manifest.displayName||S[1].manifest.name):S.length===1?A.localize(15,null,d.manifest.displayName||d.manifest.name,O.manifest.displayName||O.manifest.name,S[0].manifest.displayName||S[0].manifest.name):S.length===2?A.localize(16,null,d.manifest.displayName||d.manifest.name,O.manifest.displayName||O.manifest.name,S[0].manifest.displayName||S[0].manifest.name,S[1].manifest.displayName||S[1].manifest.name):A.localize(17,null,d.manifest.displayName||d.manifest.name,O.manifest.displayName||O.manifest.name,S[0].manifest.displayName||S[0].manifest.name,S[1].manifest.displayName||S[1].manifest.name)}getAllPackExtensionsToUninstall(O,S,d=[]){if(d.indexOf(O)!==-1)return[];d.push(O);const c=O.manifest.extensionPack?O.manifest.extensionPack:[];if(c.length){const b=S.filter(N=>!N.isBuiltin&&c.some(U=>(0,I.areSameExtensions)({id:U},N.identifier))),L=[];for(const N of b)L.push(...this.getAllPackExtensionsToUninstall(N,S,d));return[...b,...L]}return[]}getDependents(O,S){return S.filter(d=>d.manifest.extensionDependencies&&d.manifest.extensionDependencies.some(c=>(0,I.areSameExtensions)({id:c},O.identifier)))}async doUninstall(O){try{await this.preUninstallExtension(O),await this.uninstallExtension(O)}catch(S){throw await this.postUninstallExtension(O,new h.ExtensionManagementError(S instanceof Error?S.message:S,re)),S}await this.postUninstallExtension(O)}async preUninstallExtension(O){if(!await E.exists(O.location.fsPath))throw new Error(A.localize(18,null));this.logService.info("Uninstalling extension:",O.identifier.id),this._onUninstallExtension.fire(O.identifier)}async uninstallExtension(O){let S=this.uninstallingExtensions.get(O.identifier.id);return S||(S=(0,R.createCancelablePromise)(async()=>{const d=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...d.filter(c=>(0,I.areSameExtensions)(c.identifier,O.identifier)))}),this.uninstallingExtensions.set(O.identifier.id,S),S.finally(()=>this.uninstallingExtensions.delete(O.identifier.id))),S}async postUninstallExtension(O,S){if(S)this.logService.error("Failed to uninstall extension:",O.identifier.id,S.message);else if(this.logService.info("Successfully uninstalled extension:",O.identifier.id),O.identifier.uuid)try{await this.galleryService.reportStatistic(O.manifest.publisher,O.manifest.name,O.manifest.version,"uninstall")}catch(c){}this.reportTelemetry("extensionGallery:uninstall",(0,I.getLocalExtensionTelemetryData)(O),void 0,S);const d=S?S instanceof h.ExtensionManagementError?S.code:ee:void 0;this._onDidUninstallExtension.fire({identifier:O.identifier,error:d})}getInstalled(O=null){return this.extensionsScanner.scanExtensions(O)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(O){return(await this.filterUninstalled(O)).length===1}filterUninstalled(...O){return this.extensionsScanner.withUninstalledExtensions(S=>{const d=[];for(const c of O)S[c.key()]&&d.push(c.key());return d})}setUninstalled(...O){const S=O.map(d=>new I.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version));return this.extensionsScanner.withUninstalledExtensions(d=>(S.forEach(c=>d[c.key()]=!0),d))}unsetUninstalled(O){return this.extensionsScanner.withUninstalledExtensions(S=>delete S[O.key()])}getExtensionsReport(){const O=new Date().getTime();return(!this.reportedExtensions||O-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=O),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const O=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${O.length} reported extensions from service`),O}catch(O){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(O,S,d,c){const b=c?c instanceof h.ExtensionManagementError?c.code:ee:void 0;this.telemetryService.publicLogError(O,Object.assign(Object.assign({},S),{success:!c,duration:d,errorcode:b}))}};le=ce([fe(0,u.INativeEnvironmentService),fe(1,h.IExtensionGalleryService),fe(2,v.ILogService),fe(3,(0,r.optional)(a.IDownloadService)),fe(4,i.ITelemetryService),fe(5,r.IInstantiationService)],le),t.ExtensionManagementService=le}),define(Y[118],Z([0,1,129,105,2,8,15,104,27,13,16]),function(x,t,y,A,C,E,k,T,f,h,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let u=class extends C.Disposable{constructor(P,l){super();this.logService=l,this.configure(P.getValue()),this._register(P.onDidChangeConfiguration(()=>this.configure(P.getValue()),this))}configure(P){this.proxyUrl=P.http&&P.http.proxy,this.strictSSL=!!(P.http&&P.http.proxyStrictSSL),this.authorization=P.http&&P.http.proxyAuthorization}async request(P,l){this.logService.trace("RequestService#request",P.url);const{proxyUrl:D,strictSSL:p}=this,g=P.agent?P.agent:await(0,T.getProxyAgent)(P.url||"",{proxyUrl:D,strictSSL:p});return P.agent=g,P.strictSSL=p,this.authorization&&(P.headers=Object.assign(Object.assign({},P.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(P,l)}async getNodeRequest(P){return((0,A.parse)(P.url).protocol==="https:"?await new Promise((p,g)=>{x(["https"],p,g)}):await new Promise((p,g)=>{x(["http"],p,g)})).request}_request(P,l){return new Promise(async(D,p)=>{let g;const v=(0,A.parse)(P.url),w=P.getRawRequest?P.getRawRequest(P):await this.getNodeRequest(P),o={hostname:v.hostname,port:v.port?parseInt(v.port):v.protocol==="https:"?443:80,protocol:v.protocol,path:v.path,method:P.type||"GET",headers:P.headers,agent:P.agent,rejectUnauthorized:(0,E.isBoolean)(P.strictSSL)?P.strictSSL:!0};P.user&&P.password&&(o.auth=P.user+":"+P.password),g=w(o,i=>{const e=(0,E.isNumber)(P.followRedirects)?P.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&e>0&&i.headers.location)this._request(Object.assign(Object.assign({},P),{url:i.headers.location,followRedirects:e-1}),l).then(D,p);else{let n=i;i.headers["content-encoding"]==="gzip"&&(n=i.pipe((0,y.createGunzip)())),D({res:i,stream:(0,I.streamToBufferReadableStream)(n)})}}),g.on("error",p),P.timeout&&g.setTimeout(P.timeout),P.data&&typeof P.data=="string"&&g.write(P.data),g.end(),l.onCancellationRequested(()=>{g.abort(),p((0,k.canceled)())})})}async resolveProxy(P){}};u=ce([fe(0,f.IConfigurationService),fe(1,h.ILogService)],u),t.RequestService=u}),define(Y[130],Z([0,1,45,14,131,3,4,39,51,48,92,22,100,24,117,111,41,53,112,110,52,118,27,103,113,107,108,13,9,99,114,96,23,97,2,40,93,10,98,36,15,30,16]),function(x,t,y,A,C,E,k,T,f,h,I,u,R,P,l,D,p,g,v,w,o,i,e,n,s,a,r,m,j,M,F,z,B,H,X,se,re,ee,le,W,O,S,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class c extends X.Disposable{constructor(N){super();this.argv=N,(0,C.gracefulify)(A),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[N,U]=await this.initServices();return N.invokeFunction(async $=>{const _=$.get(m.ILogService),q=$.get(B.IFileService),J=$.get(u.INativeEnvironmentService),Q=$.get(P.IExtensionManagementCLIService);return _.info("CLI main",this.argv),this.registerErrorHandler(_),await this.doRun(J,Q,q),(0,k.raceTimeout)((0,g.combinedAppender)(...U).flush(),1e3)})}async initServices(){const N=new f.ServiceCollection,U=new R.NativeEnvironmentService(this.argv);N.set(u.INativeEnvironmentService,U),await Promise.all([U.appSettingsHome.fsPath,U.extensionsPath].map(Ae=>Ae?A.promises.mkdir(Ae,{recursive:!0}):void 0));const $=(0,m.getLogLevel)(U),_=[];_.push(new M.SpdLogLogger("cli",(0,E.join)(U.logsPath,"cli.log"),!0,$)),$===m.LogLevel.Trace&&_.push(new m.ConsoleLogger($));const q=this._register(new m.MultiplexLogService(_));N.set(m.ILogService,q);const J=this._register(new z.FileService(q));N.set(B.IFileService,J);const Q=this._register(new H.DiskFileSystemProvider(q));J.registerProvider(j.Schemas.file,Q);const te=this._register(new n.ConfigurationService(U.settingsResource,J));N.set(e.IConfigurationService,te),await te.initialize();const ne=new r.StateService(U,q);N.set(a.IStateService,ne),N.set(se.IProductService,Object.assign({_serviceBrand:void 0},T.default));const{appRoot:de,extensionsPath:me,extensionDevelopmentLocationURI:Ie,isBuilt:Le,installSourcePath:Te}=U;N.set(o.IRequestService,new h.SyncDescriptor(i.RequestService)),N.set(P.IExtensionManagementService,new h.SyncDescriptor(l.ExtensionManagementService)),N.set(P.IExtensionGalleryService,new h.SyncDescriptor(D.ExtensionGalleryService)),N.set(P.IExtensionManagementCLIService,new h.SyncDescriptor(re.ExtensionManagementCLIService)),N.set(W.ILocalizationsService,new h.SyncDescriptor(le.LocalizationsService));const Pe=[];if(Le&&!Ie&&!U.disableTelemetry&&T.default.enableTelemetry){T.default.aiConfig&&T.default.aiConfig.asimovKey&&Pe.push(new s.AppInsightsAppender("monacoworkbench",null,T.default.aiConfig.asimovKey));const Ae={appender:(0,g.combinedAppender)(...Pe),sendErrorTelemetry:!1,commonProperties:(0,w.resolveCommonProperties)(J,(0,y.release)(),process.arch,T.default.commit,T.default.version,ne.getItem("telemetry.machineId"),T.default.msftInternalDomains,Te),piiPaths:[de,me]};N.set(p.ITelemetryService,new h.SyncDescriptor(v.TelemetryService,[Ae]))}else N.set(p.ITelemetryService,g.NullTelemetryService);return[new I.InstantiationService(N),Pe]}registerErrorHandler(N){(0,O.setUnexpectedErrorHandler)(U=>{const $=(0,S.toErrorMessage)(U,!0);!$||N.error(`[uncaught exception in CLI]: ${$}`)})}async doRun(N,U,$){if(this.argv["install-source"])return this.setInstallSource(N,$,this.argv["install-source"]);if(this.argv["list-extensions"])return U.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return U.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return U.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return U.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log((0,F.buildTelemetryMessage)(N.appRoot,N.extensionsPath))}asExtensionIdOrVSIX(N){return N.map(U=>/\.vsix$/i.test(U)?ee.URI.file((0,E.isAbsolute)(U)?U:(0,E.join)(process.cwd(),U)):U)}async setInstallSource(N,U,$){await U.writeFile(ee.URI.file(N.installSourcePath),d.VSBuffer.fromString($.slice(0,30)))}}async function b(L){const N=new c(L);try{await N.run()}finally{N.dispose()}}t.main=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/06b54543d660353a04cdab6554d1f27266a537fd/core/vs/code/node/cliProcessMain.js.map
