/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/base/common/path","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/platform","vs/base/common/network","vs/base/common/arrays","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/node/pfs","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","vs/workbench/api/common/extHostDocumentsAndEditors","child_process","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","vs/base/common/codicons","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/linkedList","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/severity","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/base/node/extpath","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/contrib/terminal/common/terminal","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminal","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminal","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(Z){for(var e=[],p=0,D=Z.length;p<D;p++)e[p]=ge[Z[p]];return e};define(ge[52],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(D,R){if(!D)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=p}),define(ge[53],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function D(T){const k=[];for(let E in T)p.call(T,E)&&k.push(T[E]);return k}e.values=D;function R(T,k){for(let E in T)if(p.call(T,E)&&k({key:E,value:T[E]},function(){delete T[E]})===!1)return}e.forEach=R;function I(T,k){const E=Object.create(null);for(const f of T){const l=k(f);let m=E[l];m||(m=E[l]=[]),m.push(f)}return E}e.groupBy=I;function C(T){const k=Object.create(null);return T&&T.forEach((E,f)=>{k[f]=E}),k}e.fromMap=C;function P(T,k){const E=[],f=[];for(let l of T)k.has(l)||E.push(l);for(let l of k)T.has(l)||f.push(l);return{removed:E,added:f}}e.diffSets=P;function S(T,k){const E=[],f=[];for(let[l,m]of T)k.has(l)||E.push(m);for(let[l,m]of k)T.has(l)||f.push(m);return{removed:E,added:f}}e.diffMaps=S;class i{constructor(){this.map=new Map}add(k,E){let f=this.map.get(k);f||(f=new Set,this.map.set(k,f)),f.add(E)}delete(k,E){const f=this.map.get(k);!f||(f.delete(E),f.size===0&&this.map.delete(k))}forEach(k,E){const f=this.map.get(k);!f||f.forEach(E)}}e.SetMap=i}),define(ge[54],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function p(S){return(i,T,k)=>{let E=null,f=null;if(typeof k.value=="function"?(E="value",f=k.value):typeof k.get=="function"&&(E="get",f=k.get),!f)throw new Error("not supported");k[E]=S(f,T)}}e.createDecorator=p;let D=0;function R(){const S=`$memoize${D++}`;let i;const T=function(E,f,l){let m=null,y=null;if(typeof l.value=="function"?(m="value",y=l.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(m="get",y=l.get),!y)throw new Error("not supported");const g=`${S}:${f}`;l[m]=function(...v){return i=this,this.hasOwnProperty(g)||Object.defineProperty(this,g,{configurable:!0,enumerable:!1,writable:!0,value:y.apply(this,v)}),this[g]}};return T.clear=()=>{typeof i!="undefined"&&Object.getOwnPropertyNames(i).forEach(k=>{k.indexOf(S)===0&&delete i[k]})},T}e.createMemoizer=R;function I(S,i,T){return R()(S,i,T)}e.memoize=I;function C(S,i,T){return p((k,E)=>{const f=`$debounce$${E}`,l=`$debounce$result$${E}`;return function(...m){this[l]||(this[l]=T?T():void 0),clearTimeout(this[f]),i&&(this[l]=i(this[l],...m),m=[this[l]]),this[f]=setTimeout(()=>{k.apply(this,m),this[l]=T?T():void 0},S)}})}e.debounce=C;function P(S,i,T){return p((k,E)=>{const f=`$throttle$timer$${E}`,l=`$throttle$result$${E}`,m=`$throttle$lastRun$${E}`,y=`$throttle$pending$${E}`;return function(...g){if(this[l]||(this[l]=T?T():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),i&&(this[l]=i(this[l],...g)),!this[y]){const v=this[m]+S;v<=Date.now()?(this[m]=Date.now(),k.apply(this,[this[l]]),this[l]=T?T():void 0):(this[y]=!0,this[f]=setTimeout(()=>{this[y]=!1,this[m]=Date.now(),k.apply(this,[this[l]]),this[l]=T?T():void 0},v-Date.now()))}}})}e.throttle=P}),define(ge[18],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function D(o){e.errorHandler.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=D;function R(o){S(o)||e.errorHandler.onUnexpectedError(o)}e.onUnexpectedError=R;function I(o){S(o)||e.errorHandler.onUnexpectedExternalError(o)}e.onUnexpectedExternalError=I;function C(o){if(o instanceof Error){let{name:t,message:r}=o;const s=o.stacktrace||o.stack;return{$isError:!0,name:t,message:r,stack:s}}return o}e.transformErrorForSerialization=C;const P="Canceled";function S(o){return o instanceof Error&&o.name===P&&o.message===P}e.isPromiseCanceledError=S;class i extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=i;function T(){const o=new Error(P);return o.name=o.message,o}e.canceled=T;function k(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.illegalArgument=k;function E(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.illegalState=E;function f(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function l(o){const t=new Error(`${o} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function m(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.getErrorMessage=m;class y extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=y;class g extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=g;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;function d(o){const t=o;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function u(o,t=Object.create(null)){const r=new Error(o);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=u}),define(ge[12],pe([0,1,18]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function D(M,U=0){return M[M.length-(1+U)]}e.tail=D;function R(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.tail2=R;function I(M,U,F=(N,O)=>N===O){if(M===U)return!0;if(!M||!U||M.length!==U.length)return!1;for(let N=0,O=M.length;N<O;N++)if(!F(M[N],U[N]))return!1;return!0}e.equals=I;function C(M,U,F){let N=0,O=M.length-1;for(;N<=O;){const V=(N+O)/2|0,q=F(M[V],U);if(q<0)N=V+1;else if(q>0)O=V-1;else return V}return-(N+1)}e.binarySearch=C;function P(M,U){let F=0,N=M.length;if(N===0)return 0;for(;F<N;){const O=Math.floor((F+N)/2);U(M[O])?N=O:F=O+1}return F}e.findFirstInSorted=P;function S(M,U,F){if(M=M|0,M>=U.length)throw new TypeError("invalid index");let N=U[Math.floor(U.length*Math.random())],O=[],V=[],q=[];for(let Y of U){const fe=F(Y,N);fe<0?O.push(Y):fe>0?V.push(Y):q.push(Y)}return M<O.length?S(M,O,F):M<O.length+q.length?q[0]:S(M-(O.length+q.length),V,F)}e.quickSelect=S;function i(M,U){const F=[];let N;for(const O of M.slice(0).sort(U))!N||U(N[0],O)!==0?(N=[O],F.push(N)):N.push(O);return F}e.groupBy=i;function T(M,U,F){const N=[];function O(Y,fe,_e){if(!(fe===0&&_e.length===0)){const Le=N[N.length-1];Le&&Le.start+Le.deleteCount===Y?(Le.deleteCount+=fe,Le.toInsert.push(..._e)):N.push({start:Y,deleteCount:fe,toInsert:_e})}}let V=0,q=0;for(;;){if(V===M.length){O(V,0,U.slice(q));break}if(q===U.length){O(V,M.length-V,[]);break}const Y=M[V],fe=U[q],_e=F(Y,fe);_e===0?(V+=1,q+=1):_e<0?(O(V,1,[]),V+=1):_e>0&&(O(V,0,[fe]),q+=1)}return N}e.sortedDiff=T;function k(M,U,F){const N=T(M,U,F),O=[],V=[];for(const q of N)O.push(...M.slice(q.start,q.start+q.deleteCount)),V.push(...q.toInsert);return{removed:O,added:V}}e.delta=k;function E(M,U,F){if(F===0)return[];const N=M.slice(0,F).sort(U);return l(M,U,N,F,M.length),N}e.top=E;function f(M,U,F,N,O){return F===0?Promise.resolve([]):new Promise((V,q)=>{(async()=>{const Y=M.length,fe=M.slice(0,F).sort(U);for(let _e=F,Le=Math.min(F+N,Y);_e<Y;_e=Le,Le=Math.min(Le+N,Y)){if(_e>F&&await new Promise(Ie=>setTimeout(Ie)),O&&O.isCancellationRequested)throw(0,p.canceled)();l(M,U,fe,_e,Le)}return fe})().then(V,q)})}e.topAsync=f;function l(M,U,F,N,O){for(const V=F.length;N<O;N++){const q=M[N];if(U(q,F[V-1])<0){F.pop();const Y=P(F,fe=>U(q,fe)<0);F.splice(Y,0,q)}}}function m(M){return M.filter(U=>!!U)}e.coalesce=m;function y(M){let U=0;for(let F=0;F<M.length;F++)M[F]&&(M[U]=M[F],U+=1);M.length=U}e.coalesceInPlace=y;function g(M,U,F){M.splice(F,0,M.splice(U,1)[0])}e.move=g;function v(M){return!Array.isArray(M)||M.length===0}e.isFalsyOrEmpty=v;function d(M){return Array.isArray(M)&&M.length>0}e.isNonEmptyArray=d;function u(M,U){if(!U)return M.filter((N,O)=>M.indexOf(N)===O);const F=Object.create(null);return M.filter(N=>{const O=U(N);return F[O]?!1:(F[O]=!0,!0)})}e.distinct=u;function o(M){const U=new Set;return M.filter(F=>U.has(F)?!1:(U.add(F),!0))}e.distinctES6=o;function t(M){const U=Object.create(null);return F=>{const N=M(F);return U[N]?!1:(U[N]=!0,!0)}}e.uniqueFilter=t;function r(M,U){for(let F=M.length-1;F>=0;F--){const N=M[F];if(U(N))return F}return-1}e.lastIndex=r;function s(M,U){return M.length>0?M[0]:U}e.firstOrDefault=s;function a(M,U,F=(N,O)=>N===O){let N=0;for(let O=0,V=Math.min(M.length,U.length);O<V&&F(M[O],U[O]);O++)N++;return N}e.commonPrefixLength=a;function n(M){return[].concat(...M)}e.flatten=n;function c(M,U){let F=typeof U=="number"?M:0;typeof U=="number"?F=M:(F=0,U=M);const N=[];if(F<=U)for(let O=F;O<U;O++)N.push(O);else for(let O=F;O>U;O--)N.push(O);return N}e.range=c;function b(M,U,F){return M.reduce((N,O)=>(N[U(O)]=F?F(O):O,N),Object.create(null))}e.index=b;function w(M,U){return M.push(U),()=>h(M,U)}e.insert=w;function h(M,U){const F=M.indexOf(U);if(F>-1)return M.splice(F,1),U}e.remove=h;function _(M,U,F){const N=M.slice(0,U),O=M.slice(U);return N.concat(F,O)}e.arrayInsert=_;function A(M,U){let F;if(typeof U=="number"){let N=U;F=()=>{const O=Math.sin(N++)*179426549;return O-Math.floor(O)}}else F=Math.random;for(let N=M.length-1;N>0;N-=1){const O=Math.floor(F()*(N+1)),V=M[N];M[N]=M[O],M[O]=V}}e.shuffle=A;function L(M,U){const F=M.indexOf(U);F>-1&&(M.splice(F,1),M.unshift(U))}e.pushToStart=L;function W(M,U){const F=M.indexOf(U);F>-1&&(M.splice(F,1),M.push(U))}e.pushToEnd=W;function j(M,U){return Array.isArray(M)?M.map(U):U(M)}e.mapArrayOrNot=j;function K(M){return Array.isArray(M)?M:[M]}e.asArray=K;function H(M){return M[Math.floor(Math.random()*M.length)]}e.getRandomElement=H;function $(M,U){for(const F of M){const N=U(F);if(N!==void 0)return N}}e.mapFind=$}),define(ge[69],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(D){const R=this;let I=!1,C;return function(){return I||(I=!0,C=D.apply(R,arguments)),C}}e.once=p}),define(ge[70],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class p{constructor(R){this._prefix=R,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=p,e.defaultGenerator=new p("id#")}),define(ge[71],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(D){function R(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}D.is=R;const I=Object.freeze([]);function C(){return I}D.empty=C;function*P(o){yield o}D.single=P;function S(o){return o||I}D.from=S;function i(o){return!o||o[Symbol.iterator]().next().done===!0}D.isEmpty=i;function T(o){return o[Symbol.iterator]().next().value}D.first=T;function k(o,t){for(const r of o)if(t(r))return!0;return!1}D.some=k;function E(o,t){for(const r of o)if(t(r))return r}D.find=E;function*f(o,t){for(const r of o)t(r)&&(yield r)}D.filter=f;function*l(o,t){for(const r of o)yield t(r)}D.map=l;function*m(...o){for(const t of o)for(const r of t)yield r}D.concat=m;function*y(o){for(const t of o)for(const r of t)yield r}D.concatNested=y;function g(o,t,r){let s=r;for(const a of o)s=t(s,a);return s}D.reduce=g;function*v(o,t,r=o.length){for(t<0&&(t+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);t<r;t++)yield o[t]}D.slice=v;function d(o,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,o];const s=o[Symbol.iterator]();for(let a=0;a<t;a++){const n=s.next();if(n.done)return[r,D.empty()];r.push(n.value)}return[r,{[Symbol.iterator](){return s}}]}D.consume=d;function u(o,t,r=(s,a)=>s===a){const s=o[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const n=s.next(),c=a.next();if(n.done!==c.done)return!1;if(n.done)return!0;if(!r(n.value,c.value))return!1}}D.equals=u})(p=e.Iterable||(e.Iterable={}))}),define(ge[55],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function C(t,r=!1){let s=0,a=t.length,n="",c=0,b=16,w=0;function h(H){let $=0,M=0;for(;$<H;){const U=t.charCodeAt(s);if(U>=48&&U<=57)M=M*16+U-48;else if(U>=65&&U<=70)M=M*16+U-65+10;else if(U>=97&&U<=102)M=M*16+U-97+10;else break;s++,$++}return $<H&&(M=-1),M}function _(H){s=H,n="",c=0,b=16,w=0}function A(){const H=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&i(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&i(t.charCodeAt(s)))for(s++;s<t.length&&i(t.charCodeAt(s));)s++;else return w=3,t.substring(H,s);let $=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&i(t.charCodeAt(s))){for(s++;s<t.length&&i(t.charCodeAt(s));)s++;$=s}else w=3;return t.substring(H,$)}function L(){let H="",$=s;for(;;){if(s>=a){H+=t.substring($,s),w=2;break}const M=t.charCodeAt(s);if(M===34){H+=t.substring($,s),s++;break}if(M===92){if(H+=t.substring($,s),s++,s>=a){w=2;break}switch(t.charCodeAt(s++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:const F=h(4);F>=0?H+=String.fromCharCode(F):w=4;break;default:w=5}$=s;continue}if(M>=0&&M<=31)if(S(M)){H+=t.substring($,s),w=2;break}else w=6;s++}return H}function W(){if(n="",w=0,c=s,s>=a)return c=a,b=17;let H=t.charCodeAt(s);if(P(H)){do s++,n+=String.fromCharCode(H),H=t.charCodeAt(s);while(P(H));return b=15}if(S(H))return s++,n+=String.fromCharCode(H),H===13&&t.charCodeAt(s)===10&&(s++,n+=`
`),b=14;switch(H){case 123:return s++,b=1;case 125:return s++,b=2;case 91:return s++,b=3;case 93:return s++,b=4;case 58:return s++,b=6;case 44:return s++,b=5;case 34:return s++,n=L(),b=10;case 47:const $=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<a&&!S(t.charCodeAt(s));)s++;return n=t.substring($,s),b=12}if(t.charCodeAt(s+1)===42){s+=2;const M=a-1;let U=!1;for(;s<M;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,w=1),n=t.substring($,s),b=13}return n+=String.fromCharCode(H),s++,b=16;case 45:if(n+=String.fromCharCode(H),s++,s===a||!i(t.charCodeAt(s)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=A(),b=11;default:for(;s<a&&j(H);)s++,H=t.charCodeAt(s);if(c!==s){switch(n=t.substring(c,s),n){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return n+=String.fromCharCode(H),s++,b=16}}function j(H){if(P(H)||S(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let H;do H=W();while(H>=12&&H<=15);return H}return{setPosition:_,getPosition:()=>s,scan:r?K:W,getToken:()=>b,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>s-c,getTokenError:()=>w}}e.createScanner=C;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function i(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,r){const s=[],a=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function w(h,_,A,L){c.value=h,c.offset=_,c.length=A,c.type=L,c.colonOffset=void 0,n=c}try{d(t,{onObjectBegin:(h,_)=>{if(r<=h)throw a;n=void 0,b=r>h,s.push("")},onObjectProperty:(h,_,A)=>{if(r<_||(w(h,_,A,"property"),s[s.length-1]=h,r<=_+A))throw a},onObjectEnd:(h,_)=>{if(r<=h)throw a;n=void 0,s.pop()},onArrayBegin:(h,_)=>{if(r<=h)throw a;n=void 0,s.push(0)},onArrayEnd:(h,_)=>{if(r<=h)throw a;n=void 0,s.pop()},onLiteralValue:(h,_,A)=>{if(r<_||(w(h,_,A,o(h)),r<=_+A))throw a},onSeparator:(h,_,A)=>{if(r<=_)throw a;if(h===":"&&n&&n.type==="property")n.colonOffset=_,b=!1,n=void 0;else if(h===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(b=!0,s[s.length-1]=""),n=void 0}}})}catch(h){if(h!==a)throw h}return{path:s,previousNode:n,isAtPropertyKey:b,matches:h=>{let _=0;for(let A=0;_<h.length&&A<s.length;A++)if(h[_]===s[A]||h[_]==="*")_++;else if(h[_]!=="**")return!1;return _===h.length}}}e.getLocation=k;function E(t,r=[],s=I.DEFAULT){let a=null,n=[];const c=[];function b(h){Array.isArray(n)?n.push(h):a!==null&&(n[a]=h)}return d(t,{onObjectBegin:()=>{const h={};b(h),c.push(n),n=h,a=null},onObjectProperty:h=>{a=h},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const h=[];b(h),c.push(n),n=h,a=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:b,onError:(h,_,A)=>{r.push({error:h,offset:_,length:A})}},s),n[0]}e.parse=E;function f(t,r=[],s=I.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(h){a.type==="property"&&(a.length=h-a.offset,a=a.parent)}function c(h){return a.children.push(h),h}d(t,{onObjectBegin:h=>{a=c({type:"object",offset:h,length:-1,parent:a,children:[]})},onObjectProperty:(h,_,A)=>{a=c({type:"property",offset:_,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:h,offset:_,length:A,parent:a})},onObjectEnd:(h,_)=>{a.length=h+_-a.offset,a=a.parent,n(h+_)},onArrayBegin:(h,_)=>{a=c({type:"array",offset:h,length:-1,parent:a,children:[]})},onArrayEnd:(h,_)=>{a.length=h+_-a.offset,a=a.parent,n(h+_)},onLiteralValue:(h,_,A)=>{c({type:o(h),offset:_,length:A,parent:a,value:h}),n(_+A)},onSeparator:(h,_,A)=>{a.type==="property"&&(h===":"?a.colonOffset=_:h===","&&n(_))},onError:(h,_,A)=>{r.push({error:h,offset:_,length:A})}},s);const w=a.children[0];return w&&delete w.parent,w}e.parseTree=f;function l(t,r){if(!!t){let s=t;for(let a of r)if(typeof a=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const c of s.children)if(Array.isArray(c.children)&&c.children[0].value===a){s=c.children[1],n=!0;break}if(!n)return}else{const n=a;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}}e.findNodeAtLocation=l;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=m;function y(t){switch(t.type){case"array":return t.children.map(y);case"object":const r=Object.create(null);for(let s of t.children){const a=s.children[1];a&&(r[s.children[0].value]=y(a))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=y;function g(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=g;function v(t,r,s=!1){if(g(t,r,s)){const a=t.children;if(Array.isArray(a))for(let n=0;n<a.length&&a[n].offset<=r;n++){const c=v(a[n],r,s);if(c)return c}return t}}e.findNodeAtOffset=v;function d(t,r,s=I.DEFAULT){const a=C(t,!1);function n(fe){return fe?()=>fe(a.getTokenOffset(),a.getTokenLength()):()=>!0}function c(fe){return fe?_e=>fe(_e,a.getTokenOffset(),a.getTokenLength()):()=>!0}const b=n(r.onObjectBegin),w=c(r.onObjectProperty),h=n(r.onObjectEnd),_=n(r.onArrayBegin),A=n(r.onArrayEnd),L=c(r.onLiteralValue),W=c(r.onSeparator),j=n(r.onComment),K=c(r.onError),H=s&&s.disallowComments,$=s&&s.allowTrailingComma;function M(){for(;;){const fe=a.scan();switch(a.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:H||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(fe){case 12:case 13:H?U(10):j();break;case 16:U(1);break;case 15:case 14:break;default:return fe}}}function U(fe,_e=[],Le=[]){if(K(fe),_e.length+Le.length>0){let Ie=a.getToken();for(;Ie!==17;){if(_e.indexOf(Ie)!==-1){M();break}else if(Le.indexOf(Ie)!==-1)break;Ie=M()}}}function F(fe){const _e=a.getTokenValue();return fe?L(_e):w(_e),M(),!0}function N(){switch(a.getToken()){case 11:let fe=0;try{fe=JSON.parse(a.getTokenValue()),typeof fe!="number"&&(U(2),fe=0)}catch(_e){U(2)}L(fe);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return M(),!0}function O(){return a.getToken()!==10?(U(3,[],[2,5]),!1):(F(!1),a.getToken()===6?(W(":"),M(),Y()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function V(){b(),M();let fe=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(fe||U(4,[],[]),W(","),M(),a.getToken()===2&&$)break}else fe&&U(6,[],[]);O()||U(4,[],[2,5]),fe=!0}return h(),a.getToken()!==2?U(7,[2],[]):M(),!0}function q(){_(),M();let fe=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(fe||U(4,[],[]),W(","),M(),a.getToken()===4&&$)break}else fe&&U(6,[],[]);Y()||U(4,[],[4,5]),fe=!0}return A(),a.getToken()!==4?U(8,[4],[]):M(),!0}function Y(){switch(a.getToken()){case 3:return q();case 1:return V();case 10:return F(!0);default:return N()}}return M(),a.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):Y()?(a.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=d;function u(t,r){let s=C(t),a=[],n,c=0,b;do switch(b=s.getPosition(),n=s.scan(),n){case 12:case 13:case 17:c!==b&&a.push(t.substring(c,b)),r!==void 0&&a.push(s.getTokenValue().replace(/[^\r\n]/g,r)),c=s.getPosition();break}while(n!==17);return a.join("")}e.stripComments=u;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(ge[129],pe([0,1,55]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function D(S,i,T){let k,E,f,l,m;if(i){for(l=i.offset,m=l+i.length,f=l;f>0&&!P(S,f-1);)f--;let c=m;for(;c<S.length&&!P(S,c);)c++;E=S.substring(f,c),k=I(E,T)}else E=S,k=0,f=0,l=0,m=S.length;const y=C(T,S);let g=!1,v=0,d;T.insertSpaces?d=R(" ",T.tabSize||4):d="	";const u=(0,p.createScanner)(E,!1);let o=!1;function t(){return y+R(d,k+v)}function r(){let c=u.scan();for(g=!1;c===15||c===14;)g=g||c===14,c=u.scan();return o=c===16||u.getTokenError()!==0,c}const s=[];function a(c,b,w){!o&&b<m&&w>l&&S.substring(b,w)!==c&&s.push({offset:b,length:w-b,content:c})}let n=r();if(n!==17){const c=u.getTokenOffset()+f,b=R(d,k);a(b,f,c)}for(;n!==17;){let c=u.getTokenOffset()+u.getTokenLength()+f,b=r(),w="";for(;!g&&(b===12||b===13);){const _=u.getTokenOffset()+f;a(" ",c,_),c=u.getTokenOffset()+u.getTokenLength()+f,w=b===12?t():"",b=r()}if(b===2)n!==1&&(v--,w=t());else if(b===4)n!==3&&(v--,w=t());else{switch(n){case 3:case 1:v++,w=t();break;case 5:case 12:w=t();break;case 13:g?w=t():w=" ";break;case 6:w=" ";break;case 10:if(b===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?w=" ":b!==5&&b!==17&&(o=!0);break;case 16:o=!0;break}g&&(b===12||b===13)&&(w=t())}const h=u.getTokenOffset()+f;a(w,c,h),n=b}return s}e.format=D;function R(S,i){let T="";for(let k=0;k<i;k++)T+=S;return T}function I(S,i){let T=0,k=0;const E=i.tabSize||4;for(;T<S.length;){const f=S.charAt(T);if(f===" ")k++;else if(f==="	")k+=E;else break;T++}return Math.floor(k/E)}function C(S,i){for(let T=0;T<i.length;T++){const k=i.charAt(T);if(k==="\r")return T+1<i.length&&i.charAt(T+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=C;function P(S,i){return`\r
`.indexOf(S.charAt(i))!==-1}e.isEOL=P}),define(ge[130],pe([0,1,55,129]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(i,T,k){return I(i,T,void 0,k)}e.removeProperty=R;function I(i,T,k,E,f){const l=T.slice(),m=[],y=(0,p.parseTree)(i,m);let g,v;for(;l.length>0&&(v=l.pop(),g=(0,p.findNodeAtLocation)(y,l),g===void 0&&k!==void 0);)typeof v=="string"?k={[v]:k}:k=[k];if(g)if(g.type==="object"&&typeof v=="string"&&Array.isArray(g.children)){const d=(0,p.findNodeAtLocation)(g,[v]);if(d!==void 0)if(k===void 0){if(!d.parent)throw new Error("Malformed AST");const u=g.children.indexOf(d.parent);let o,t=d.parent.offset+d.parent.length;if(u>0){const r=g.children[u-1];o=r.offset+r.length}else o=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return C(i,{offset:o,length:t-o,content:""},E)}else return C(i,{offset:d.offset,length:d.length,content:JSON.stringify(k)},E);else{if(k===void 0)return[];const u=`${JSON.stringify(v)}: ${JSON.stringify(k)}`,o=f?f(g.children.map(r=>r.children[0].value)):g.children.length;let t;if(o>0){const r=g.children[o-1];t={offset:r.offset+r.length,length:0,content:","+u}}else g.children.length===0?t={offset:g.offset+1,length:0,content:u}:t={offset:g.offset+1,length:0,content:u+","};return C(i,t,E)}}else if(g.type==="array"&&typeof v=="number"&&Array.isArray(g.children))if(k!==void 0){const d=`${JSON.stringify(k)}`;let u;if(g.children.length===0||v===0)u={offset:g.offset+1,length:0,content:g.children.length===0?d:d+","};else{const o=v===-1||v>g.children.length?g.children.length:v,t=g.children[o-1];u={offset:t.offset+t.length,length:0,content:","+d}}return C(i,u,E)}else{const d=v,u=g.children[d];let o;if(g.children.length===1)o={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===d){const t=g.children[d-1],r=t.offset+t.length,s=g.offset+g.length;o={offset:r,length:s-2-r,content:""}}else o={offset:u.offset,length:g.children[d+1].offset-u.offset,content:""};return C(i,o,E)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${g.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return C(i,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(k)},E)}}e.setProperty=I;function C(i,T,k){let E=P(i,T),f=T.offset,l=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;f>0&&!(0,D.isEOL)(E,f-1);)f--;for(;l<E.length&&!(0,D.isEOL)(E,l);)l++}const m=(0,D.format)(E,{offset:f,length:l-f},k);for(let g=m.length-1;g>=0;g--){const v=m[g];E=P(E,v),f=Math.min(f,v.offset),l=Math.max(l,v.offset+v.length),l+=v.content.length-v.length}const y=i.length-(E.length-l)-f;return[{offset:f,length:y,content:E.substring(f,l)}]}e.withFormatting=C;function P(i,T){return i.substring(0,T.offset)+T.content+i.substring(T.offset+T.length)}e.applyEdit=P;function S(i,T){let k=T.slice(0).sort((f,l)=>{const m=f.offset-l.offset;return m===0?f.length-l.length:m}),E=i.length;for(let f=k.length-1;f>=0;f--){let l=k[f];if(l.offset+l.length<=E)i=P(i,l);else throw new Error("Overlapping edit");E=l.offset}return i}e.applyEdits=S}),define(ge[131],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new p(()=>R(this.getValue()))}}e.Lazy=p}),define(ge[6],pe([0,1,69,71]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const R=!1;let I=null;function C(d){I=d}if(e.setDisposableTracker=C,R){const d="__is_disposable_tracked__";I=new class{trackDisposable(u){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[d]||console.log(o)},3e3)}markTracked(u){if(u&&u!==m.None)try{u[d]=!0}catch(o){}}}}function P(d){!I||I.markTracked(d)}function S(d){return I&&I.trackDisposable(d),d}e.trackDisposable=S;class i extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=i;function T(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=T;function k(d){if(D.Iterable.is(d)){let u=[];for(const o of d)if(o){P(o);try{o.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new i(u);return Array.isArray(d)?[]:d}else if(d)return P(d),d.dispose(),d}e.dispose=k;function E(...d){return d.forEach(P),f(()=>k(d))}e.combinedDisposable=E;function f(d){const u=S({dispose:()=>{P(u),d()}});return u}e.toDisposable=f;class l{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{k(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return P(u),this._isDisposed?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new l,S(this)}dispose(){P(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var o;this._isDisposed||u===this._value||((o=this._value)===null||o===void 0||o.dispose(),u&&P(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,P(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=y;class g{constructor(){this.references=new Map}acquire(u,...o){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...o)},this.references.set(u,t));const{object:r}=t,s=(0,p.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:r,dispose:s}}}e.ReferenceCollection=g;class v{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=v}),define(ge[56],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(I){this.element=I,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class D{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(I){return this._insert(I,!1)}push(I){return this._insert(I,!0)}_insert(I,C){const P=new p(I);if(this._first===p.Undefined)this._first=P,this._last=P;else if(C){const i=this._last;this._last=P,P.prev=i,i.next=P}else{const i=this._first;this._first=P,P.next=i,i.prev=P}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(P))}}shift(){if(this._first!==p.Undefined){const I=this._first.element;return this._remove(this._first),I}}pop(){if(this._last!==p.Undefined){const I=this._last.element;return this._remove(this._last),I}}_remove(I){if(I.prev!==p.Undefined&&I.next!==p.Undefined){const C=I.prev;C.next=I.next,I.next.prev=C}else I.prev===p.Undefined&&I.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):I.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):I.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let I=this._first;for(;I!==p.Undefined;)yield I.element,I=I.next}}e.LinkedList=D}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(G,oe){for(var ue=0;ue<oe.length;ue++){var J=oe[ue];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(G,J.key,J)}}function e(G,oe,ue){return oe&&Z(G.prototype,oe),ue&&Z(G,ue),G}function p(G,oe){if(!!G){if(typeof G=="string")return D(G,oe);var ue=Object.prototype.toString.call(G).slice(8,-1);if(ue==="Object"&&G.constructor&&(ue=G.constructor.name),ue==="Map"||ue==="Set")return Array.from(G);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return D(G,oe)}}function D(G,oe){(oe==null||oe>G.length)&&(oe=G.length);for(var ue=0,J=new Array(oe);ue<oe;ue++)J[ue]=G[ue];return J}function R(G,oe){var ue;if(typeof Symbol=="undefined"||G[Symbol.iterator]==null){if(Array.isArray(G)||(ue=p(G))||oe&&G&&typeof G.length=="number"){ue&&(G=ue);var J=0;return function(){return J>=G.length?{done:!0}:{done:!1,value:G[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ue=G[Symbol.iterator](),ue.next.bind(ue)}function I(G){var oe={exports:{}};return G(oe,oe.exports),oe.exports}var C=I(function(G){function oe(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ue(J){G.exports.defaults=J}G.exports={defaults:oe(),getDefaults:oe,changeDefaults:ue}}),P=/[&<>"']/,S=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(oe){return k[oe]};function f(G,oe){if(oe){if(P.test(G))return G.replace(S,E)}else if(i.test(G))return G.replace(T,E);return G}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(G){return G.replace(l,function(oe,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var y=/(^|[^\[])\^/g;function g(G,oe){G=G.source||G,oe=oe||"";var ue={replace:function(ne,le){return le=le.source||le,le=le.replace(y,"$1"),G=G.replace(ne,le),ue},getRegex:function(){return new RegExp(G,oe)}};return ue}var v=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(G,oe,ue){if(G){var J;try{J=decodeURIComponent(m(ue)).replace(v,"").toLowerCase()}catch(ne){return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}oe&&!d.test(ue)&&(ue=a(oe,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch(ne){return null}return ue}var o={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(G,oe){o[" "+G]||(t.test(G)?o[" "+G]=G+"/":o[" "+G]=w(G,"/",!0)),G=o[" "+G];var ue=G.indexOf(":")===-1;return oe.substring(0,2)==="//"?ue?oe:G.replace(r,"$1")+oe:oe.charAt(0)==="/"?ue?oe:G.replace(s,"$1")+oe:G+oe}var n={exec:function(){}};function c(G){for(var oe=1,ue,J;oe<arguments.length;oe++){ue=arguments[oe];for(J in ue)Object.prototype.hasOwnProperty.call(ue,J)&&(G[J]=ue[J])}return G}function b(G,oe){var ue=G.replace(/\|/g,function(le,me,Ee){for(var He=!1,Be=me;--Be>=0&&Ee[Be]==="\\";)He=!He;return He?"|":" |"}),J=ue.split(/ \|/),ne=0;if(J.length>oe)J.splice(oe);else for(;J.length<oe;)J.push("");for(;ne<J.length;ne++)J[ne]=J[ne].trim().replace(/\\\|/g,"|");return J}function w(G,oe,ue){var J=G.length;if(J===0)return"";for(var ne=0;ne<J;){var le=G.charAt(J-ne-1);if(le===oe&&!ue)ne++;else if(le!==oe&&ue)ne++;else break}return G.substr(0,J-ne)}function h(G,oe){if(G.indexOf(oe[1])===-1)return-1;for(var ue=G.length,J=0,ne=0;ne<ue;ne++)if(G[ne]==="\\")ne++;else if(G[ne]===oe[0])J++;else if(G[ne]===oe[1]&&(J--,J<0))return ne;return-1}function _(G){G&&G.sanitize&&!G.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(G,oe){if(oe<1)return"";for(var ue="";oe>1;)oe&1&&(ue+=G),oe>>=1,G+=G;return ue+G}var L={escape:f,unescape:m,edit:g,cleanUrl:u,resolveUrl:a,noopTest:n,merge:c,splitCells:b,rtrim:w,findClosingBracket:h,checkSanitizeDeprecation:_,repeatString:A},W=C.defaults,j=L.rtrim,K=L.splitCells,H=L.escape,$=L.findClosingBracket;function M(G,oe,ue){var J=oe.href,ne=oe.title?H(oe.title):null,le=G[1].replace(/\\([\[\]])/g,"$1");return G[0].charAt(0)!=="!"?{type:"link",raw:ue,href:J,title:ne,text:le}:{type:"image",raw:ue,href:J,title:ne,text:H(le)}}function U(G,oe){var ue=G.match(/^(\s+)(?:```)/);if(ue===null)return oe;var J=ue[1];return oe.split(`
`).map(function(ne){var le=ne.match(/^\s+/);if(le===null)return ne;var me=le[0];return me.length>=J.length?ne.slice(J.length):ne}).join(`
`)}var F=function(){function G(ue){this.options=ue||W}var oe=G.prototype;return oe.space=function(J){var ne=this.rules.block.newline.exec(J);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},oe.code=function(J){var ne=this.rules.block.code.exec(J);if(ne){var le=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?le:j(le,`
`)}}},oe.fences=function(J){var ne=this.rules.block.fences.exec(J);if(ne){var le=ne[0],me=U(le,ne[3]||"");return{type:"code",raw:le,lang:ne[2]?ne[2].trim():ne[2],text:me}}},oe.heading=function(J){var ne=this.rules.block.heading.exec(J);if(ne){var le=ne[2].trim();if(/#$/.test(le)){var me=j(le,"#");(this.options.pedantic||!me||/ $/.test(me))&&(le=me.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:le}}},oe.nptable=function(J){var ne=this.rules.block.nptable.exec(J);if(ne){var le={type:"table",header:K(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[],raw:ne[0]};if(le.header.length===le.align.length){var me=le.align.length,Ee;for(Ee=0;Ee<me;Ee++)/^ *-+: *$/.test(le.align[Ee])?le.align[Ee]="right":/^ *:-+: *$/.test(le.align[Ee])?le.align[Ee]="center":/^ *:-+ *$/.test(le.align[Ee])?le.align[Ee]="left":le.align[Ee]=null;for(me=le.cells.length,Ee=0;Ee<me;Ee++)le.cells[Ee]=K(le.cells[Ee],le.header.length);return le}}},oe.hr=function(J){var ne=this.rules.block.hr.exec(J);if(ne)return{type:"hr",raw:ne[0]}},oe.blockquote=function(J){var ne=this.rules.block.blockquote.exec(J);if(ne){var le=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],text:le}}},oe.list=function(J){var ne=this.rules.block.list.exec(J);if(ne){var le=ne[0],me=ne[2],Ee=me.length>1,He={type:"list",raw:le,ordered:Ee,start:Ee?+me.slice(0,-1):"",loose:!1,items:[]},Be=ne[0].match(this.rules.block.item),qe=!1,Xe,Ze,ut,st,be,he,ce,ee,Te=Be.length;ut=this.rules.block.listItemStart.exec(Be[0]);for(var Re=0;Re<Te;Re++){if(Xe=Be[Re],le=Xe,Re!==Te-1){if(st=this.rules.block.listItemStart.exec(Be[Re+1]),this.options.pedantic?st[1].length>ut[1].length:st[1].length>ut[0].length||st[1].length>3){Be.splice(Re,2,Be[Re]+`
`+Be[Re+1]),Re--,Te--;continue}else(!this.options.pedantic||this.options.smartLists?st[2][st[2].length-1]!==me[me.length-1]:Ee===(st[2].length===1))&&(be=Be.slice(Re+1).join(`
`),He.raw=He.raw.substring(0,He.raw.length-be.length),Re=Te-1);ut=st}Ze=Xe.length,Xe=Xe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Xe.indexOf(`
 `)&&(Ze-=Xe.length,Xe=this.options.pedantic?Xe.replace(/^ {1,4}/gm,""):Xe.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),he=qe||/\n\n(?!\s*$)/.test(Xe),Re!==Te-1&&(qe=Xe.charAt(Xe.length-1)===`
`,he||(he=qe)),he&&(He.loose=!0),this.options.gfm&&(ce=/^\[[ xX]\] /.test(Xe),ee=void 0,ce&&(ee=Xe[1]!==" ",Xe=Xe.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:le,task:ce,checked:ee,loose:he,text:Xe})}return He}},oe.html=function(J){var ne=this.rules.block.html.exec(J);if(ne)return{type:this.options.sanitize?"paragraph":"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):H(ne[0]):ne[0]}},oe.def=function(J){var ne=this.rules.block.def.exec(J);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var le=ne[1].toLowerCase().replace(/\s+/g," ");return{tag:le,raw:ne[0],href:ne[2],title:ne[3]}}},oe.table=function(J){var ne=this.rules.block.table.exec(J);if(ne){var le={type:"table",header:K(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ne[0];var me=le.align.length,Ee;for(Ee=0;Ee<me;Ee++)/^ *-+: *$/.test(le.align[Ee])?le.align[Ee]="right":/^ *:-+: *$/.test(le.align[Ee])?le.align[Ee]="center":/^ *:-+ *$/.test(le.align[Ee])?le.align[Ee]="left":le.align[Ee]=null;for(me=le.cells.length,Ee=0;Ee<me;Ee++)le.cells[Ee]=K(le.cells[Ee].replace(/^ *\| *| *\| *$/g,""),le.header.length);return le}}},oe.lheading=function(J){var ne=this.rules.block.lheading.exec(J);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1]}},oe.paragraph=function(J){var ne=this.rules.block.paragraph.exec(J);if(ne)return{type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1]}},oe.text=function(J){var ne=this.rules.block.text.exec(J);if(ne)return{type:"text",raw:ne[0],text:ne[0]}},oe.escape=function(J){var ne=this.rules.inline.escape.exec(J);if(ne)return{type:"escape",raw:ne[0],text:H(ne[1])}},oe.tag=function(J,ne,le){var me=this.rules.inline.tag.exec(J);if(me)return!ne&&/^<a /i.test(me[0])?ne=!0:ne&&/^<\/a>/i.test(me[0])&&(ne=!1),!le&&/^<(pre|code|kbd|script)(\s|>)/i.test(me[0])?le=!0:le&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(me[0])&&(le=!1),{type:this.options.sanitize?"text":"html",raw:me[0],inLink:ne,inRawBlock:le,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):H(me[0]):me[0]}},oe.link=function(J){var ne=this.rules.inline.link.exec(J);if(ne){var le=ne[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var me=j(le.slice(0,-1),"\\");if((le.length-me.length)%2==0)return}else{var Ee=$(ne[2],"()");if(Ee>-1){var He=ne[0].indexOf("!")===0?5:4,Be=He+ne[1].length+Ee;ne[2]=ne[2].substring(0,Ee),ne[0]=ne[0].substring(0,Be).trim(),ne[3]=""}}var qe=ne[2],Xe="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(qe);Ze&&(qe=Ze[1],Xe=Ze[3])}else Xe=ne[3]?ne[3].slice(1,-1):"";return qe=qe.trim(),/^</.test(qe)&&(this.options.pedantic&&!/>$/.test(le)?qe=qe.slice(1):qe=qe.slice(1,-1)),M(ne,{href:qe&&qe.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},ne[0])}},oe.reflink=function(J,ne){var le;if((le=this.rules.inline.reflink.exec(J))||(le=this.rules.inline.nolink.exec(J))){var me=(le[2]||le[1]).replace(/\s+/g," ");if(me=ne[me.toLowerCase()],!me||!me.href){var Ee=le[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return M(le,me,le[0])}},oe.emStrong=function(J,ne,le){le===void 0&&(le="");var me=this.rules.inline.emStrong.lDelim.exec(J);if(!!me&&!(me[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=me[1]||me[2]||"";if(!Ee||Ee&&(le===""||this.rules.inline.punctuation.exec(le))){var He=me[0].length-1,Be,qe,Xe=He,Ze=0,ut=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ut.lastIndex=0,ne=ne.slice(-1*J.length+He);(me=ut.exec(ne))!=null;)if(Be=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Be){if(qe=Be.length,me[3]||me[4]){Xe+=qe;continue}else if((me[5]||me[6])&&He%3&&!((He+qe)%3)){Ze+=qe;continue}if(Xe-=qe,!(Xe>0)){if(Xe+Ze-qe<=0&&!ne.slice(ut.lastIndex).match(ut)&&(qe=Math.min(qe,qe+Xe+Ze)),Math.min(He,qe)%2)return{type:"em",raw:J.slice(0,He+me.index+qe+1),text:J.slice(1,He+me.index+qe)};if(Math.min(He,qe)%2==0)return{type:"strong",raw:J.slice(0,He+me.index+qe+1),text:J.slice(2,He+me.index+qe-1)}}}}}},oe.codespan=function(J){var ne=this.rules.inline.code.exec(J);if(ne){var le=ne[2].replace(/\n/g," "),me=/[^ ]/.test(le),Ee=/^ /.test(le)&&/ $/.test(le);return me&&Ee&&(le=le.substring(1,le.length-1)),le=H(le,!0),{type:"codespan",raw:ne[0],text:le}}},oe.br=function(J){var ne=this.rules.inline.br.exec(J);if(ne)return{type:"br",raw:ne[0]}},oe.del=function(J){var ne=this.rules.inline.del.exec(J);if(ne)return{type:"del",raw:ne[0],text:ne[2]}},oe.autolink=function(J,ne){var le=this.rules.inline.autolink.exec(J);if(le){var me,Ee;return le[2]==="@"?(me=H(this.options.mangle?ne(le[1]):le[1]),Ee="mailto:"+me):(me=H(le[1]),Ee=me),{type:"link",raw:le[0],text:me,href:Ee,tokens:[{type:"text",raw:me,text:me}]}}},oe.url=function(J,ne){var le;if(le=this.rules.inline.url.exec(J)){var me,Ee;if(le[2]==="@")me=H(this.options.mangle?ne(le[0]):le[0]),Ee="mailto:"+me;else{var He;do He=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(He!==le[0]);me=H(le[0]),le[1]==="www."?Ee="http://"+me:Ee=me}return{type:"link",raw:le[0],text:me,href:Ee,tokens:[{type:"text",raw:me,text:me}]}}},oe.inlineText=function(J,ne,le){var me=this.rules.inline.text.exec(J);if(me){var Ee;return ne?Ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):H(me[0]):me[0]:Ee=H(this.options.smartypants?le(me[0]):me[0]),{type:"text",raw:me[0],text:Ee}}},G}(),N=L.noopTest,O=L.edit,V=L.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=O(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=O(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=O(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=O(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=O(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=O(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=O(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=V({},q),q.gfm=V({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=O(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=O(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=V({},q.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:O(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Y={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Y._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Y.punctuation=O(Y.punctuation).replace(/punctuation/g,Y._punctuation).getRegex(),Y.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Y.escapedEmSt=/\\\*|\\_/g,Y._comment=O(q._comment).replace("(?:-->|$)","-->").getRegex(),Y.emStrong.lDelim=O(Y.emStrong.lDelim).replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimAst=O(Y.emStrong.rDelimAst,"g").replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimUnd=O(Y.emStrong.rDelimUnd,"g").replace(/punct/g,Y._punctuation).getRegex(),Y._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Y._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Y._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Y.autolink=O(Y.autolink).replace("scheme",Y._scheme).replace("email",Y._email).getRegex(),Y._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Y.tag=O(Y.tag).replace("comment",Y._comment).replace("attribute",Y._attribute).getRegex(),Y._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Y._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Y._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Y.link=O(Y.link).replace("label",Y._label).replace("href",Y._href).replace("title",Y._title).getRegex(),Y.reflink=O(Y.reflink).replace("label",Y._label).getRegex(),Y.reflinkSearch=O(Y.reflinkSearch,"g").replace("reflink",Y.reflink).replace("nolink",Y.nolink).getRegex(),Y.normal=V({},Y),Y.pedantic=V({},Y.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",Y._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Y._label).getRegex()}),Y.gfm=V({},Y.normal,{escape:O(Y.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Y.gfm.url=O(Y.gfm.url,"i").replace("email",Y.gfm._extended_email).getRegex(),Y.breaks=V({},Y.gfm,{br:O(Y.br).replace("{2,}","*").getRegex(),text:O(Y.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:q,inline:Y},_e=C.defaults,Le=fe.block,Ie=fe.inline,Fe=L.repeatString;function z(G){return G.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Q(G){var oe="",ue,J,ne=G.length;for(ue=0;ue<ne;ue++)J=G.charCodeAt(ue),Math.random()>.5&&(J="x"+J.toString(16)),oe+="&#"+J+";";return oe}var te=function(){function G(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||_e,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var J={block:Le.normal,inline:Ie.normal};this.options.pedantic?(J.block=Le.pedantic,J.inline=Ie.pedantic):this.options.gfm&&(J.block=Le.gfm,this.options.breaks?J.inline=Ie.breaks:J.inline=Ie.gfm),this.tokenizer.rules=J}G.lex=function(J,ne){var le=new G(ne);return le.lex(J)},G.lexInline=function(J,ne){var le=new G(ne);return le.inlineTokens(J)};var oe=G.prototype;return oe.lex=function(J){return J=J.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(J,this.tokens,!0),this.inline(this.tokens),this.tokens},oe.blockTokens=function(J,ne,le){ne===void 0&&(ne=[]),le===void 0&&(le=!0),this.options.pedantic&&(J=J.replace(/^ +$/gm,""));for(var me,Ee,He,Be;J;){if(me=this.tokenizer.space(J)){J=J.substring(me.raw.length),me.type&&ne.push(me);continue}if(me=this.tokenizer.code(J)){J=J.substring(me.raw.length),Be=ne[ne.length-1],Be&&Be.type==="paragraph"?(Be.raw+=`
`+me.raw,Be.text+=`
`+me.text):ne.push(me);continue}if(me=this.tokenizer.fences(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.heading(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.nptable(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.hr(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.blockquote(J)){J=J.substring(me.raw.length),me.tokens=this.blockTokens(me.text,[],le),ne.push(me);continue}if(me=this.tokenizer.list(J)){for(J=J.substring(me.raw.length),He=me.items.length,Ee=0;Ee<He;Ee++)me.items[Ee].tokens=this.blockTokens(me.items[Ee].text,[],!1);ne.push(me);continue}if(me=this.tokenizer.html(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(le&&(me=this.tokenizer.def(J))){J=J.substring(me.raw.length),this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.lheading(J)){J=J.substring(me.raw.length),ne.push(me);continue}if(le&&(me=this.tokenizer.paragraph(J))){J=J.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.text(J)){J=J.substring(me.raw.length),Be=ne[ne.length-1],Be&&Be.type==="text"?(Be.raw+=`
`+me.raw,Be.text+=`
`+me.text):ne.push(me);continue}if(J){var qe="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(qe);break}else throw new Error(qe)}}return ne},oe.inline=function(J){var ne,le,me,Ee,He,Be,qe=J.length;for(ne=0;ne<qe;ne++)switch(Be=J[ne],Be.type){case"paragraph":case"text":case"heading":{Be.tokens=[],this.inlineTokens(Be.text,Be.tokens);break}case"table":{for(Be.tokens={header:[],cells:[]},Ee=Be.header.length,le=0;le<Ee;le++)Be.tokens.header[le]=[],this.inlineTokens(Be.header[le],Be.tokens.header[le]);for(Ee=Be.cells.length,le=0;le<Ee;le++)for(He=Be.cells[le],Be.tokens.cells[le]=[],me=0;me<He.length;me++)Be.tokens.cells[le][me]=[],this.inlineTokens(He[me],Be.tokens.cells[le][me]);break}case"blockquote":{this.inline(Be.tokens);break}case"list":{for(Ee=Be.items.length,le=0;le<Ee;le++)this.inline(Be.items[le].tokens);break}}return J},oe.inlineTokens=function(J,ne,le,me){ne===void 0&&(ne=[]),le===void 0&&(le=!1),me===void 0&&(me=!1);var Ee,He,Be=J,qe,Xe,Ze;if(this.tokens.links){var ut=Object.keys(this.tokens.links);if(ut.length>0)for(;(qe=this.tokenizer.rules.inline.reflinkSearch.exec(Be))!=null;)ut.includes(qe[0].slice(qe[0].lastIndexOf("[")+1,-1))&&(Be=Be.slice(0,qe.index)+"["+Fe("a",qe[0].length-2)+"]"+Be.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(qe=this.tokenizer.rules.inline.blockSkip.exec(Be))!=null;)Be=Be.slice(0,qe.index)+"["+Fe("a",qe[0].length-2)+"]"+Be.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(qe=this.tokenizer.rules.inline.escapedEmSt.exec(Be))!=null;)Be=Be.slice(0,qe.index)+"++"+Be.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;){if(Xe||(Ze=""),Xe=!1,Ee=this.tokenizer.escape(J)){J=J.substring(Ee.raw.length),ne.push(Ee);continue}if(Ee=this.tokenizer.tag(J,le,me)){J=J.substring(Ee.raw.length),le=Ee.inLink,me=Ee.inRawBlock;var st=ne[ne.length-1];st&&Ee.type==="text"&&st.type==="text"?(st.raw+=Ee.raw,st.text+=Ee.text):ne.push(Ee);continue}if(Ee=this.tokenizer.link(J)){J=J.substring(Ee.raw.length),Ee.type==="link"&&(Ee.tokens=this.inlineTokens(Ee.text,[],!0,me)),ne.push(Ee);continue}if(Ee=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(Ee.raw.length);var be=ne[ne.length-1];Ee.type==="link"?(Ee.tokens=this.inlineTokens(Ee.text,[],!0,me),ne.push(Ee)):be&&Ee.type==="text"&&be.type==="text"?(be.raw+=Ee.raw,be.text+=Ee.text):ne.push(Ee);continue}if(Ee=this.tokenizer.emStrong(J,Be,Ze)){J=J.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],le,me),ne.push(Ee);continue}if(Ee=this.tokenizer.codespan(J)){J=J.substring(Ee.raw.length),ne.push(Ee);continue}if(Ee=this.tokenizer.br(J)){J=J.substring(Ee.raw.length),ne.push(Ee);continue}if(Ee=this.tokenizer.del(J)){J=J.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],le,me),ne.push(Ee);continue}if(Ee=this.tokenizer.autolink(J,Q)){J=J.substring(Ee.raw.length),ne.push(Ee);continue}if(!le&&(Ee=this.tokenizer.url(J,Q))){J=J.substring(Ee.raw.length),ne.push(Ee);continue}if(Ee=this.tokenizer.inlineText(J,me,z)){J=J.substring(Ee.raw.length),Ee.raw.slice(-1)!=="_"&&(Ze=Ee.raw.slice(-1)),Xe=!0,He=ne[ne.length-1],He&&He.type==="text"?(He.raw+=Ee.raw,He.text+=Ee.text):ne.push(Ee);continue}if(J){var he="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return ne},e(G,null,[{key:"rules",get:function(){return{block:Le,inline:Ie}}}]),G}(),ae=C.defaults,ve=L.cleanUrl,De=L.escape,Me=function(){function G(ue){this.options=ue||ae}var oe=G.prototype;return oe.code=function(J,ne,le){var me=(ne||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(J,me);Ee!=null&&Ee!==J&&(le=!0,J=Ee)}return J=J.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+De(me,!0)+'">'+(le?J:De(J,!0))+`</code></pre>
`:"<pre><code>"+(le?J:De(J,!0))+`</code></pre>
`},oe.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},oe.html=function(J){return J},oe.heading=function(J,ne,le,me){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+me.slug(le)+'">'+J+"</h"+ne+`>
`:"<h"+ne+">"+J+"</h"+ne+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(J,ne,le){var me=ne?"ol":"ul",Ee=ne&&le!==1?' start="'+le+'"':"";return"<"+me+Ee+`>
`+J+"</"+me+`>
`},oe.listitem=function(J){return"<li>"+J+`</li>
`},oe.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(J){return"<p>"+J+`</p>
`},oe.table=function(J,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+ne+`</table>
`},oe.tablerow=function(J){return`<tr>
`+J+`</tr>
`},oe.tablecell=function(J,ne){var le=ne.header?"th":"td",me=ne.align?"<"+le+' align="'+ne.align+'">':"<"+le+">";return me+J+"</"+le+`>
`},oe.strong=function(J){return"<strong>"+J+"</strong>"},oe.em=function(J){return"<em>"+J+"</em>"},oe.codespan=function(J){return"<code>"+J+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(J){return"<del>"+J+"</del>"},oe.link=function(J,ne,le){if(J=ve(this.options.sanitize,this.options.baseUrl,J),J===null)return le;var me='<a href="'+De(J)+'"';return ne&&(me+=' title="'+ne+'"'),me+=">"+le+"</a>",me},oe.image=function(J,ne,le){if(J=ve(this.options.sanitize,this.options.baseUrl,J),J===null)return le;var me='<img src="'+J+'" alt="'+le+'"';return ne&&(me+=' title="'+ne+'"'),me+=this.options.xhtml?"/>":">",me},oe.text=function(J){return J},G}(),we=function(){function G(){}var oe=G.prototype;return oe.strong=function(J){return J},oe.em=function(J){return J},oe.codespan=function(J){return J},oe.del=function(J){return J},oe.html=function(J){return J},oe.text=function(J){return J},oe.link=function(J,ne,le){return""+le},oe.image=function(J,ne,le){return""+le},oe.br=function(){return""},G}(),ke=function(){function G(){this.seen={}}var oe=G.prototype;return oe.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(J,ne){var le=J,me=0;if(this.seen.hasOwnProperty(le)){me=this.seen[J];do me++,le=J+"-"+me;while(this.seen.hasOwnProperty(le))}return ne||(this.seen[J]=me,this.seen[le]=0),le},oe.slug=function(J,ne){ne===void 0&&(ne={});var le=this.serialize(J);return this.getNextSafeSlug(le,ne.dryrun)},G}(),Ae=C.defaults,xe=L.unescape,ye=function(){function G(ue){this.options=ue||Ae,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new ke}G.parse=function(J,ne){var le=new G(ne);return le.parse(J)},G.parseInline=function(J,ne){var le=new G(ne);return le.parseInline(J)};var oe=G.prototype;return oe.parse=function(J,ne){ne===void 0&&(ne=!0);var le="",me,Ee,He,Be,qe,Xe,Ze,ut,st,be,he,ce,ee,Te,Re,et,Ke,rt,lt=J.length;for(me=0;me<lt;me++)switch(be=J[me],be.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(be.tokens),be.depth,xe(this.parseInline(be.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(be.text,be.lang,be.escaped);continue}case"table":{for(ut="",Ze="",Be=be.header.length,Ee=0;Ee<Be;Ee++)Ze+=this.renderer.tablecell(this.parseInline(be.tokens.header[Ee]),{header:!0,align:be.align[Ee]});for(ut+=this.renderer.tablerow(Ze),st="",Be=be.cells.length,Ee=0;Ee<Be;Ee++){for(Xe=be.tokens.cells[Ee],Ze="",qe=Xe.length,He=0;He<qe;He++)Ze+=this.renderer.tablecell(this.parseInline(Xe[He]),{header:!1,align:be.align[He]});st+=this.renderer.tablerow(Ze)}le+=this.renderer.table(ut,st);continue}case"blockquote":{st=this.parse(be.tokens),le+=this.renderer.blockquote(st);continue}case"list":{for(he=be.ordered,ce=be.start,ee=be.loose,Be=be.items.length,st="",Ee=0;Ee<Be;Ee++)Re=be.items[Ee],et=Re.checked,Ke=Re.task,Te="",Re.task&&(rt=this.renderer.checkbox(et),ee?Re.tokens.length>0&&Re.tokens[0].type==="text"?(Re.tokens[0].text=rt+" "+Re.tokens[0].text,Re.tokens[0].tokens&&Re.tokens[0].tokens.length>0&&Re.tokens[0].tokens[0].type==="text"&&(Re.tokens[0].tokens[0].text=rt+" "+Re.tokens[0].tokens[0].text)):Re.tokens.unshift({type:"text",text:rt}):Te+=rt),Te+=this.parse(Re.tokens,ee),st+=this.renderer.listitem(Te,Ke,et);le+=this.renderer.list(st,he,ce);continue}case"html":{le+=this.renderer.html(be.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(be.tokens));continue}case"text":{for(st=be.tokens?this.parseInline(be.tokens):be.text;me+1<lt&&J[me+1].type==="text";)be=J[++me],st+=`
`+(be.tokens?this.parseInline(be.tokens):be.text);le+=ne?this.renderer.paragraph(st):st;continue}default:{var Ye='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}return le},oe.parseInline=function(J,ne){ne=ne||this.renderer;var le="",me,Ee,He=J.length;for(me=0;me<He;me++)switch(Ee=J[me],Ee.type){case"escape":{le+=ne.text(Ee.text);break}case"html":{le+=ne.html(Ee.text);break}case"link":{le+=ne.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,ne));break}case"image":{le+=ne.image(Ee.href,Ee.title,Ee.text);break}case"strong":{le+=ne.strong(this.parseInline(Ee.tokens,ne));break}case"em":{le+=ne.em(this.parseInline(Ee.tokens,ne));break}case"codespan":{le+=ne.codespan(Ee.text);break}case"br":{le+=ne.br();break}case"del":{le+=ne.del(this.parseInline(Ee.tokens,ne));break}case"text":{le+=ne.text(Ee.text);break}default:{var Be='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}return le},G}(),Ge=L.merge,X=L.checkSanitizeDeprecation,ie=L.escape,Se=C.getDefaults,Ne=C.changeDefaults,ze=C.defaults;function We(G,oe,ue){if(typeof G=="undefined"||G===null)throw new Error("marked(): input parameter is undefined or null");if(typeof G!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(G)+", string expected");if(typeof oe=="function"&&(ue=oe,oe=null),oe=Ge({},We.defaults,oe||{}),X(oe),ue){var J=oe.highlight,ne;try{ne=te.lex(G,oe)}catch(He){return ue(He)}var le=function(Be){var qe;if(!Be)try{qe=ye.parse(ne,oe)}catch(Xe){Be=Xe}return oe.highlight=J,Be?ue(Be):ue(null,qe)};if(!J||J.length<3||(delete oe.highlight,!ne.length))return le();var me=0;We.walkTokens(ne,function(He){He.type==="code"&&(me++,setTimeout(function(){J(He.text,He.lang,function(Be,qe){if(Be)return le(Be);qe!=null&&qe!==He.text&&(He.text=qe,He.escaped=!0),me--,me===0&&le()})},0))}),me===0&&le();return}try{var Ee=te.lex(G,oe);return oe.walkTokens&&We.walkTokens(Ee,oe.walkTokens),ye.parse(Ee,oe)}catch(He){if(He.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+ie(He.message+"",!0)+"</pre>";throw He}}We.options=We.setOptions=function(G){return Ge(We.defaults,G),Ne(We.defaults),We},We.getDefaults=Se,We.defaults=ze,We.use=function(G){var oe=Ge({},G);if(G.renderer&&function(){var J=We.defaults.renderer||new Me,ne=function(Ee){var He=J[Ee];J[Ee]=function(){for(var Be=arguments.length,qe=new Array(Be),Xe=0;Xe<Be;Xe++)qe[Xe]=arguments[Xe];var Ze=G.renderer[Ee].apply(J,qe);return Ze===!1&&(Ze=He.apply(J,qe)),Ze}};for(var le in G.renderer)ne(le);oe.renderer=J}(),G.tokenizer&&function(){var J=We.defaults.tokenizer||new F,ne=function(Ee){var He=J[Ee];J[Ee]=function(){for(var Be=arguments.length,qe=new Array(Be),Xe=0;Xe<Be;Xe++)qe[Xe]=arguments[Xe];var Ze=G.tokenizer[Ee].apply(J,qe);return Ze===!1&&(Ze=He.apply(J,qe)),Ze}};for(var le in G.tokenizer)ne(le);oe.tokenizer=J}(),G.walkTokens){var ue=We.defaults.walkTokens;oe.walkTokens=function(J){G.walkTokens(J),ue&&ue(J)}}We.setOptions(oe)},We.walkTokens=function(G,oe){for(var ue=R(G),J;!(J=ue()).done;){var ne=J.value;switch(oe(ne),ne.type){case"table":{for(var le=R(ne.tokens.header),me;!(me=le()).done;){var Ee=me.value;We.walkTokens(Ee,oe)}for(var He=R(ne.tokens.cells),Be;!(Be=He()).done;)for(var qe=Be.value,Xe=R(qe),Ze;!(Ze=Xe()).done;){var ut=Ze.value;We.walkTokens(ut,oe)}break}case"list":{We.walkTokens(ne.items,oe);break}default:ne.tokens&&We.walkTokens(ne.tokens,oe)}}},We.parseInline=function(G,oe){if(typeof G=="undefined"||G===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof G!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(G)+", string expected");oe=Ge({},We.defaults,oe||{}),X(oe);try{var ue=te.lexInline(G,oe);return oe.walkTokens&&We.walkTokens(ue,oe.walkTokens),ye.parseInline(ue,oe)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+ie(J.message+"",!0)+"</pre>";throw J}},We.Parser=ye,We.parser=ye.parse,We.Renderer=Me,We.TextRenderer=we,We.Lexer=te,We.lexer=te.lex,We.Tokenizer=F,We.Slugger=ke,We.parse=We;var Je=We;return Je}),define(ge[72],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function p(C,P,S){return Math.min(Math.max(C,P),S)}e.clamp=p;function D(C,P){return(P+C%P)%P}e.rot=D;class R{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=R;class I{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=I});"use strict";(function(){function Z(R){const I=[];typeof R=="number"&&I.push("code/timeOrigin",R);function C(S){I.push(S,Date.now())}function P(){const S=[];for(let i=0;i<I.length;i+=2)S.push({name:I[i],startTime:I[i+1]});return S}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const C of performance.getEntriesByType("mark"))I.push({name:C.name,startTime:Math.round(R+C.startTime)});return I}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function p(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=p(D))})(),define(ge[10],pe([0,1]),function(Z,e){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const D="en";let R=!1,I=!1,C=!1,P=!1,S=!1,i=!1,T=!1,k,E=D,f,l;const m=typeof self=="object"?self:typeof global=="object"?global:{};let y;typeof process!="undefined"?y=process:typeof m.vscode!="undefined"&&(y=m.vscode.process);const g=typeof((p=y==null?void 0:y.versions)===null||p===void 0?void 0:p.electron)=="string"&&y.type==="renderer";if(e.isElectronSandboxed=g&&(y==null?void 0:y.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const n=y==null?void 0:y.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof n=="string")return n==="none"||n==="code"||n==="bypassHeatCheck"||n==="bypassHeatCheckAndEagerCompile"?n:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!g)l=navigator.userAgent,R=l.indexOf("Windows")>=0,I=l.indexOf("Macintosh")>=0,T=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=l.indexOf("Linux")>=0,i=!0,k=navigator.language,E=k;else if(typeof y=="object"){R=y.platform==="win32",I=y.platform==="darwin",C=y.platform==="linux",P=C&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,k=D,E=D;const n=y.env.VSCODE_NLS_CONFIG;if(n)try{const c=JSON.parse(n),b=c.availableLanguages["*"];k=c.locale,E=b||D,f=c._translationsConfigFile}catch(c){}S=!0}else console.error("Unable to resolve platform.");var v;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function d(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=d;let u=0;I?u=1:R?u=3:C&&(u=2),e.isWindows=R,e.isMacintosh=I,e.isLinux=C,e.isLinuxSnap=P,e.isNative=S,e.isWeb=i,e.isIOS=T,e.platform=u,e.userAgent=l,e.language=E;var o;(function(n){function c(){return e.language}n.value=c;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=b;function w(){return e.language==="en"}n.isDefault=w})(o=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=f,e.globals=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let b=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeSetImmediateId)for(let _=0,A=b.length;_<A;_++){const L=b[_];if(L.id===h.data.vscodeSetImmediateId){b.splice(_,1),L.callback();return}}});let w=0;return h=>{const _=++w;b.push({id:_,callback:h}),e.globals.postMessage({vscodeSetImmediateId:_},"*")}}if(y&&typeof y.nextTick=="function")return y.nextTick.bind(y);const c=Promise.resolve();return b=>c.then(b)}();var t;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||T?2:R?1:3;let r=!0,s=!1;function a(){if(!s){s=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,r=new Uint16Array(n.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=a}),define(ge[36],pe([0,1,10]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let D;typeof process!="undefined"?D=process:typeof p.globals.vscode!="undefined"?D={get platform(){return p.globals.vscode.process.platform},get env(){return p.globals.vscode.process.env},nextTick(R){return(0,p.setImmediate)(R)},cwd(){return p.globals.vscode.process.env.VSCODE_CWD||p.globals.vscode.process.execPath.substr(0,p.globals.vscode.process.execPath.lastIndexOf(p.globals.vscode.process.platform==="win32"?"\\":"/"))}}:D={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(R){return(0,p.setImmediate)(R)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.nextTick=D.nextTick}),define(ge[7],pe([0,1,36]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,R=97,I=90,C=122,P=46,S=47,i=92,T=58,k=63;class E extends Error{constructor(u,o,t){let r;typeof o=="string"&&o.indexOf("not ")===0?(r="must not be",o=o.replace(/^not /,"")):r="must be";const s=u.indexOf(".")!==-1?"property":"argument";let a=`The "${u}" ${s} ${r} of type ${o}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function f(d,u){if(typeof d!="string")throw new E(u,"string",d)}function l(d){return d===S||d===i}function m(d){return d===S}function y(d){return d>=D&&d<=I||d>=R&&d<=C}function g(d,u,o,t){let r="",s=0,a=-1,n=0,c=0;for(let b=0;b<=d.length;++b){if(b<d.length)c=d.charCodeAt(b);else{if(t(c))break;c=S}if(t(c)){if(!(a===b-1||n===1))if(n===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const w=r.lastIndexOf(o);w===-1?(r="",s=0):(r=r.slice(0,w),s=r.length-1-r.lastIndexOf(o)),a=b,n=0;continue}else if(r.length!==0){r="",s=0,a=b,n=0;continue}}u&&(r+=r.length>0?`${o}..`:"..",s=2)}else r.length>0?r+=`${o}${d.slice(a+1,b)}`:r=d.slice(a+1,b),s=b-a-1;a=b,n=0}else c===P&&n!==-1?++n:n=-1}return r}function v(d,u){if(u===null||typeof u!="object")throw new E("pathObject","Object",u);const o=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return o?o===u.root?`${o}${t}`:`${o}${d}${t}`:t}e.win32={resolve(...d){let u="",o="",t=!1;for(let r=d.length-1;r>=-1;r--){let s;if(r>=0){if(s=d[r],f(s,"path"),s.length===0)continue}else u.length===0?s=p.cwd():(s=p.env[`=${u}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==u.toLowerCase()&&s.charCodeAt(2)===i)&&(s=`${u}\\`));const a=s.length;let n=0,c="",b=!1;const w=s.charCodeAt(0);if(a===1)l(w)&&(n=1,b=!0);else if(l(w))if(b=!0,l(s.charCodeAt(1))){let h=2,_=h;for(;h<a&&!l(s.charCodeAt(h));)h++;if(h<a&&h!==_){const A=s.slice(_,h);for(_=h;h<a&&l(s.charCodeAt(h));)h++;if(h<a&&h!==_){for(_=h;h<a&&!l(s.charCodeAt(h));)h++;(h===a||h!==_)&&(c=`\\\\${A}\\${s.slice(_,h)}`,n=h)}}}else n=1;else y(w)&&s.charCodeAt(1)===T&&(c=s.slice(0,2),n=2,a>2&&l(s.charCodeAt(2))&&(b=!0,n=3));if(c.length>0)if(u.length>0){if(c.toLowerCase()!==u.toLowerCase())continue}else u=c;if(t){if(u.length>0)break}else if(o=`${s.slice(n)}\\${o}`,t=b,b&&u.length>0)break}return o=g(o,!t,"\\",l),t?`${u}\\${o}`:`${u}${o}`||"."},normalize(d){f(d,"path");const u=d.length;if(u===0)return".";let o=0,t,r=!1;const s=d.charCodeAt(0);if(u===1)return m(s)?"\\":d;if(l(s))if(r=!0,l(d.charCodeAt(1))){let n=2,c=n;for(;n<u&&!l(d.charCodeAt(n));)n++;if(n<u&&n!==c){const b=d.slice(c,n);for(c=n;n<u&&l(d.charCodeAt(n));)n++;if(n<u&&n!==c){for(c=n;n<u&&!l(d.charCodeAt(n));)n++;if(n===u)return`\\\\${b}\\${d.slice(c)}\\`;n!==c&&(t=`\\\\${b}\\${d.slice(c,n)}`,o=n)}}}else o=1;else y(s)&&d.charCodeAt(1)===T&&(t=d.slice(0,2),o=2,u>2&&l(d.charCodeAt(2))&&(r=!0,o=3));let a=o<u?g(d.slice(o),!r,"\\",l):"";return a.length===0&&!r&&(a="."),a.length>0&&l(d.charCodeAt(u-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(d){f(d,"path");const u=d.length;if(u===0)return!1;const o=d.charCodeAt(0);return l(o)||u>2&&y(o)&&d.charCodeAt(1)===T&&l(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let u,o;for(let s=0;s<d.length;++s){const a=d[s];f(a,"path"),a.length>0&&(u===void 0?u=o=a:u+=`\\${a}`)}if(u===void 0)return".";let t=!0,r=0;if(typeof o=="string"&&l(o.charCodeAt(0))){++r;const s=o.length;s>1&&l(o.charCodeAt(1))&&(++r,s>2&&(l(o.charCodeAt(2))?++r:t=!1))}if(t){for(;r<u.length&&l(u.charCodeAt(r));)r++;r>=2&&(u=`\\${u.slice(r)}`)}return e.win32.normalize(u)},relative(d,u){if(f(d,"from"),f(u,"to"),d===u)return"";const o=e.win32.resolve(d),t=e.win32.resolve(u);if(o===t||(d=o.toLowerCase(),u=t.toLowerCase(),d===u))return"";let r=0;for(;r<d.length&&d.charCodeAt(r)===i;)r++;let s=d.length;for(;s-1>r&&d.charCodeAt(s-1)===i;)s--;const a=s-r;let n=0;for(;n<u.length&&u.charCodeAt(n)===i;)n++;let c=u.length;for(;c-1>n&&u.charCodeAt(c-1)===i;)c--;const b=c-n,w=a<b?a:b;let h=-1,_=0;for(;_<w;_++){const L=d.charCodeAt(r+_);if(L!==u.charCodeAt(n+_))break;L===i&&(h=_)}if(_!==w){if(h===-1)return t}else{if(b>w){if(u.charCodeAt(n+_)===i)return t.slice(n+_+1);if(_===2)return t.slice(n+_)}a>w&&(d.charCodeAt(r+_)===i?h=_:_===2&&(h=3)),h===-1&&(h=0)}let A="";for(_=r+h+1;_<=s;++_)(_===s||d.charCodeAt(_)===i)&&(A+=A.length===0?"..":"\\..");return n+=h,A.length>0?`${A}${t.slice(n,c)}`:(t.charCodeAt(n)===i&&++n,t.slice(n,c))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const u=e.win32.resolve(d);if(u.length<=2)return d;if(u.charCodeAt(0)===i){if(u.charCodeAt(1)===i){const o=u.charCodeAt(2);if(o!==k&&o!==P)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(y(u.charCodeAt(0))&&u.charCodeAt(1)===T&&u.charCodeAt(2)===i)return`\\\\?\\${u}`;return d},dirname(d){f(d,"path");const u=d.length;if(u===0)return".";let o=-1,t=0;const r=d.charCodeAt(0);if(u===1)return l(r)?d:".";if(l(r)){if(o=t=1,l(d.charCodeAt(1))){let n=2,c=n;for(;n<u&&!l(d.charCodeAt(n));)n++;if(n<u&&n!==c){for(c=n;n<u&&l(d.charCodeAt(n));)n++;if(n<u&&n!==c){for(c=n;n<u&&!l(d.charCodeAt(n));)n++;if(n===u)return d;n!==c&&(o=t=n+1)}}}}else y(r)&&d.charCodeAt(1)===T&&(o=u>2&&l(d.charCodeAt(2))?3:2,t=o);let s=-1,a=!0;for(let n=u-1;n>=t;--n)if(l(d.charCodeAt(n))){if(!a){s=n;break}}else a=!1;if(s===-1){if(o===-1)return".";s=o}return d.slice(0,s)},basename(d,u){u!==void 0&&f(u,"ext"),f(d,"path");let o=0,t=-1,r=!0,s;if(d.length>=2&&y(d.charCodeAt(0))&&d.charCodeAt(1)===T&&(o=2),u!==void 0&&u.length>0&&u.length<=d.length){if(u===d)return"";let a=u.length-1,n=-1;for(s=d.length-1;s>=o;--s){const c=d.charCodeAt(s);if(l(c)){if(!r){o=s+1;break}}else n===-1&&(r=!1,n=s+1),a>=0&&(c===u.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=n))}return o===t?t=n:t===-1&&(t=d.length),d.slice(o,t)}for(s=d.length-1;s>=o;--s)if(l(d.charCodeAt(s))){if(!r){o=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":d.slice(o,t)},extname(d){f(d,"path");let u=0,o=-1,t=0,r=-1,s=!0,a=0;d.length>=2&&d.charCodeAt(1)===T&&y(d.charCodeAt(0))&&(u=t=2);for(let n=d.length-1;n>=u;--n){const c=d.charCodeAt(n);if(l(c)){if(!s){t=n+1;break}continue}r===-1&&(s=!1,r=n+1),c===P?o===-1?o=n:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||r===-1||a===0||a===1&&o===r-1&&o===t+1?"":d.slice(o,r)},format:v.bind(null,"\\"),parse(d){f(d,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return u;const o=d.length;let t=0,r=d.charCodeAt(0);if(o===1)return l(r)?(u.root=u.dir=d,u):(u.base=u.name=d,u);if(l(r)){if(t=1,l(d.charCodeAt(1))){let h=2,_=h;for(;h<o&&!l(d.charCodeAt(h));)h++;if(h<o&&h!==_){for(_=h;h<o&&l(d.charCodeAt(h));)h++;if(h<o&&h!==_){for(_=h;h<o&&!l(d.charCodeAt(h));)h++;h===o?t=h:h!==_&&(t=h+1)}}}}else if(y(r)&&d.charCodeAt(1)===T){if(o<=2)return u.root=u.dir=d,u;if(t=2,l(d.charCodeAt(2))){if(o===3)return u.root=u.dir=d,u;t=3}}t>0&&(u.root=d.slice(0,t));let s=-1,a=t,n=-1,c=!0,b=d.length-1,w=0;for(;b>=t;--b){if(r=d.charCodeAt(b),l(r)){if(!c){a=b+1;break}continue}n===-1&&(c=!1,n=b+1),r===P?s===-1?s=b:w!==1&&(w=1):s!==-1&&(w=-1)}return n!==-1&&(s===-1||w===0||w===1&&s===n-1&&s===a+1?u.base=u.name=d.slice(a,n):(u.name=d.slice(a,s),u.base=d.slice(a,n),u.ext=d.slice(s,n))),a>0&&a!==t?u.dir=d.slice(0,a-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let u="",o=!1;for(let t=d.length-1;t>=-1&&!o;t--){const r=t>=0?d[t]:p.cwd();f(r,"path"),r.length!==0&&(u=`${r}/${u}`,o=r.charCodeAt(0)===S)}return u=g(u,!o,"/",m),o?`/${u}`:u.length>0?u:"."},normalize(d){if(f(d,"path"),d.length===0)return".";const u=d.charCodeAt(0)===S,o=d.charCodeAt(d.length-1)===S;return d=g(d,!u,"/",m),d.length===0?u?"/":o?"./":".":(o&&(d+="/"),u?`/${d}`:d)},isAbsolute(d){return f(d,"path"),d.length>0&&d.charCodeAt(0)===S},join(...d){if(d.length===0)return".";let u;for(let o=0;o<d.length;++o){const t=d[o];f(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(d,u){if(f(d,"from"),f(u,"to"),d===u||(d=e.posix.resolve(d),u=e.posix.resolve(u),d===u))return"";const o=1,t=d.length,r=t-o,s=1,a=u.length-s,n=r<a?r:a;let c=-1,b=0;for(;b<n;b++){const h=d.charCodeAt(o+b);if(h!==u.charCodeAt(s+b))break;h===S&&(c=b)}if(b===n)if(a>n){if(u.charCodeAt(s+b)===S)return u.slice(s+b+1);if(b===0)return u.slice(s+b)}else r>n&&(d.charCodeAt(o+b)===S?c=b:b===0&&(c=0));let w="";for(b=o+c+1;b<=t;++b)(b===t||d.charCodeAt(b)===S)&&(w+=w.length===0?"..":"/..");return`${w}${u.slice(s+c)}`},toNamespacedPath(d){return d},dirname(d){if(f(d,"path"),d.length===0)return".";const u=d.charCodeAt(0)===S;let o=-1,t=!0;for(let r=d.length-1;r>=1;--r)if(d.charCodeAt(r)===S){if(!t){o=r;break}}else t=!1;return o===-1?u?"/":".":u&&o===1?"//":d.slice(0,o)},basename(d,u){u!==void 0&&f(u,"ext"),f(d,"path");let o=0,t=-1,r=!0,s;if(u!==void 0&&u.length>0&&u.length<=d.length){if(u===d)return"";let a=u.length-1,n=-1;for(s=d.length-1;s>=0;--s){const c=d.charCodeAt(s);if(c===S){if(!r){o=s+1;break}}else n===-1&&(r=!1,n=s+1),a>=0&&(c===u.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=n))}return o===t?t=n:t===-1&&(t=d.length),d.slice(o,t)}for(s=d.length-1;s>=0;--s)if(d.charCodeAt(s)===S){if(!r){o=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":d.slice(o,t)},extname(d){f(d,"path");let u=-1,o=0,t=-1,r=!0,s=0;for(let a=d.length-1;a>=0;--a){const n=d.charCodeAt(a);if(n===S){if(!r){o=a+1;break}continue}t===-1&&(r=!1,t=a+1),n===P?u===-1?u=a:s!==1&&(s=1):u!==-1&&(s=-1)}return u===-1||t===-1||s===0||s===1&&u===t-1&&u===o+1?"":d.slice(u,t)},format:v.bind(null,"/"),parse(d){f(d,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return u;const o=d.charCodeAt(0)===S;let t;o?(u.root="/",t=1):t=0;let r=-1,s=0,a=-1,n=!0,c=d.length-1,b=0;for(;c>=t;--c){const w=d.charCodeAt(c);if(w===S){if(!n){s=c+1;break}continue}a===-1&&(n=!1,a=c+1),w===P?r===-1?r=c:b!==1&&(b=1):r!==-1&&(b=-1)}if(a!==-1){const w=s===0&&o?1:s;r===-1||b===0||b===1&&r===a-1&&r===s+1?u.base=u.name=d.slice(w,a):(u.name=d.slice(w,r),u.base=d.slice(w,a),u.ext=d.slice(r,a))}return s>0?u.dir=d.slice(0,s-1):o&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[132],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var D;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(I,...C){const P=C.reduce((T,k)=>(T[k]=!0,T),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(T=>!P[T]).forEach(T=>{for(let k=0;k<S.length;k++)if(T.search(S[k])!==-1){delete I[T];break}})}e.sanitizeProcessEnvironment=R}),define(ge[46],pe([0,1,10]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=p.globals.performance&&typeof p.globals.performance.now=="function";class R{constructor(C){this._highResolution=D&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new R(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=R}),define(ge[3],pe([0,1,18,69,6,56,46]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(g){g.None=()=>R.Disposable.None;function v(K){return(H,$=null,M)=>{let U=!1,F;return F=K(N=>{if(!U)return F?F.dispose():U=!0,H.call($,N)},null,M),U&&F.dispose(),F}}g.once=v;function d(K,H){return a(($,M=null,U)=>K(F=>$.call(M,H(F)),null,U))}g.map=d;function u(K,H){return a(($,M=null,U)=>K(F=>{H(F),$.call(M,F)},null,U))}g.forEach=u;function o(K,H){return a(($,M=null,U)=>K(F=>H(F)&&$.call(M,F),null,U))}g.filter=o;function t(K){return K}g.signal=t;function r(...K){return(H,$=null,M)=>(0,R.combinedDisposable)(...K.map(U=>U(F=>H.call($,F),null,M)))}g.any=r;function s(K,H,$){let M=$;return d(K,U=>(M=H(M,U),M))}g.reduce=s;function a(K){let H;const $=new E({onFirstListenerAdd(){H=K($.fire,$)},onLastListenerRemove(){H.dispose()}});return $.event}g.snapshot=a;function n(K,H,$=100,M=!1,U){let F,N,O,V=0;const q=new E({leakWarningThreshold:U,onFirstListenerAdd(){F=K(Y=>{V++,N=H(N,Y),M&&!O&&(q.fire(N),N=void 0),clearTimeout(O),O=setTimeout(()=>{const fe=N;N=void 0,O=void 0,(!M||V>1)&&q.fire(fe),V=0},$)})},onLastListenerRemove(){F.dispose()}});return q.event}g.debounce=n;function c(K){const H=new Date().getTime();return d(v(K),$=>new Date().getTime()-H)}g.stopwatch=c;function b(K){let H=!0,$;return o(K,M=>{const U=H||M!==$;return H=!1,$=M,U})}g.latch=b;function w(K,H=!1,$=[]){let M=$.slice(),U=K(O=>{M?M.push(O):N.fire(O)});const F=()=>{M&&M.forEach(O=>N.fire(O)),M=null},N=new E({onFirstListenerAdd(){U||(U=K(O=>N.fire(O)))},onFirstListenerDidAdd(){M&&(H?setTimeout(F):F())},onLastListenerRemove(){U&&U.dispose(),U=null}});return N.event}g.buffer=w;class h{constructor(H){this.event=H}map(H){return new h(d(this.event,H))}forEach(H){return new h(u(this.event,H))}filter(H){return new h(o(this.event,H))}reduce(H,$){return new h(s(this.event,H,$))}latch(){return new h(b(this.event))}debounce(H,$=100,M=!1,U){return new h(n(this.event,H,$,M,U))}on(H,$,M){return this.event(H,$,M)}once(H,$,M){return v(this.event)(H,$,M)}}function _(K){return new h(K)}g.chain=_;function A(K,H,$=M=>M){const M=(...O)=>N.fire($(...O)),U=()=>K.on(H,M),F=()=>K.removeListener(H,M),N=new E({onFirstListenerAdd:U,onLastListenerRemove:F});return N.event}g.fromNodeEventEmitter=A;function L(K,H,$=M=>M){const M=(...O)=>N.fire($(...O)),U=()=>K.addEventListener(H,M),F=()=>K.removeEventListener(H,M),N=new E({onFirstListenerAdd:U,onLastListenerRemove:F});return N.event}g.fromDOMEventEmitter=L;function W(K){const H=new E;let $=!1;return K.then(void 0,()=>null).then(()=>{$?H.fire(void 0):setTimeout(()=>H.fire(void 0),0)}),$=!0,H.event}g.fromPromise=W;function j(K){return new Promise(H=>v(K)(H))}g.toPromise=j})(P=e.Event||(e.Event={}));class S{constructor(v){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${v}_${S._idPool++}`}start(v){this._stopWatch=new C.StopWatch(!0),this._listenerCount=v}stop(){if(this._stopWatch){const v=this._stopWatch.elapsed();this._elapsedOverall+=v,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${v.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let i=-1;function T(g){const v=i;return i=g,{dispose(){i=v}}}e.setGlobalLeakWarningThreshold=T;class k{constructor(v,d=Math.random().toString(18).slice(2,5)){this.customThreshold=v,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(v){let d=i;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),!(d<=0||v<d)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),o=this._stacks.get(u)||0;if(this._stacks.set(u,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let t,r=0;for(const[s,a]of this._stacks)(!t||r<a)&&(t=s,r=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class E{constructor(v){var d;this._disposed=!1,this._options=v,this._leakageMon=i>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((d=this._options)===null||d===void 0?void 0:d._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(v,d,u)=>{var o;this._listeners||(this._listeners=new I.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(d?[v,d]:v);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,v,d);const s=(o=this._leakageMon)===null||o===void 0?void 0:o.check(this._listeners.size);let a;return a={dispose:()=>{s&&s(),a.dispose=E._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof R.DisposableStore?u.add(a):Array.isArray(u)&&u.push(a),a}),this._event}fire(v){var d,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new I.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,v]);for((d=this._perfMon)===null||d===void 0||d.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,t]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,t):o[0].call(o[1],t)}catch(r){(0,p.onUnexpectedError)(r)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var v,d,u;(v=this._listeners)===null||v===void 0||v.clear(),(d=this._deliveryQueue)===null||d===void 0||d.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=E,E._noop=function(){};class f extends E{constructor(v){super(v);this._isPaused=0,this._eventQueue=new I.LinkedList,this._mergeFn=v==null?void 0:v.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const v=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(v))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(v){this._listeners&&(this._isPaused!==0?this._eventQueue.push(v):super.fire(v))}}e.PauseableEmitter=f;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(v){const d={event:v,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const u=()=>{this.hasListeners&&this.unhook(d);const o=this.events.indexOf(d);this.events.splice(o,1)};return(0,R.toDisposable)((0,D.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(v=>this.hook(v))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(v=>this.unhook(v))}hook(v){v.listener=v.event(d=>this.emitter.fire(d))}unhook(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=l;class m{constructor(){this.buffers=[]}wrapEvent(v){return(d,u,o)=>v(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>d.call(u,t)):d.call(u,t)},void 0,o)}bufferEvents(v){const d=[];this.buffers.push(d);const u=v();return this.buffers.pop(),d.forEach(o=>o()),u}}e.EventBufferer=m;class y{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(v){this.inputEvent=v,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=v(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=y}),define(ge[21],pe([0,1,3]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const D=Object.freeze(function(P,S){const i=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(i)}}});var R;(function(P){function S(i){return i===P.None||i===P.Cancelled||i instanceof I?!0:!i||typeof i!="object"?!1:typeof i.isCancellationRequested=="boolean"&&typeof i.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(R=e.CancellationToken||(e.CancellationToken={}));class I{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new I),this._token}cancel(){this._token?this._token instanceof I&&this._token.cancel():this._token=R.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof I&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=C}),define(ge[47],pe([0,1,3]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class D{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(T){const k=this._icons.get(T.id);k?T.description?k.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new D;e.iconRegistry=R;function I(i,T){return new C(i,T)}e.registerCodicon=I;class C{constructor(T,k,E){this.id=T,this.definition=k,this.description=E,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function P(i,T){const k=["codicon","codicon-"+i];return T&&k.push("codicon-modifier-"+T),k}e.getClassNamesArray=P;var S;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function k(l){if(l instanceof C)return["codicon","codicon-"+l.id];const m=T.exec(l.id);if(!m)return k(C.error);let[,y,g]=m;const v=["codicon","codicon-"+y];return g&&v.push("codicon-modifier-"+g.substr(1)),v}i.asClassNameArray=k;function E(l){return k(l).join(" ")}i.asClassName=E;function f(l){return"."+k(l).join(".")}i.asCSSSelector=f})(S=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personAdd=new i("person-add",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnknown=new i("workspace-unknown",{fontCharacter:"\\ebc3"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(ge[91],pe([0,1,18,6]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(y){const g=y;return g&&[g.on,g.pause,g.resume,g.destroy].every(v=>typeof v=="function")}e.isReadableStream=R;function I(y){const g=y;return g&&R(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean"}e.isReadableBufferedStream=I;function C(y,g){return new P(y,g)}e.newWriteableStream=C;class P{constructor(g,v){this.reducer=g,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){var v;if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof((v=this.options)===null||v===void 0?void 0:v.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(d=>this.pendingWritePromises.push(d))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(v=>v(g))}emitError(g){this.listeners.error.length===0?(0,p.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(v=>v(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,v){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(g,v){if(!this.state.destroyed){let d;switch(g){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const u=d.indexOf(v);u>=0&&d.splice(u,1)}}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(y,g){const v=[];let d;for(;(d=y.read())!==null;)v.push(d);return g(v)}e.consumeReadable=S;function i(y,g,v){const d=[];let u;for(;(u=y.read())!==null&&d.length<v;)d.push(u);return u===null&&d.length>0?g(d):{read:()=>{if(d.length>0)return d.shift();if(typeof u!="undefined"){const o=u;return u=void 0,o}return y.read()}}}e.peekReadable=i;function T(y,g){return new Promise((v,d)=>{const u=[];k(y,{onData:o=>{g&&u.push(o)},onError:o=>{g?d(o):v(void 0)},onEnd:()=>{v(g?g(u):void 0)}})})}e.consumeStream=T;function k(y,g){y.on("error",v=>g.onError(v)),y.on("end",()=>g.onEnd()),y.on("data",v=>g.onData(v))}e.listenStream=k;function E(y,g){return new Promise((v,d)=>{const u=new D.DisposableStore,o=[],t=a=>{if(o.push(a),o.length>g)return u.dispose(),y.pause(),v({stream:y,buffer:o,ended:!1})},r=a=>d(a),s=()=>v({stream:y,buffer:o,ended:!0});u.add((0,D.toDisposable)(()=>y.removeListener("error",r))),y.on("error",r),u.add((0,D.toDisposable)(()=>y.removeListener("end",s))),y.on("end",s),u.add((0,D.toDisposable)(()=>y.removeListener("data",t))),y.on("data",t)})}e.peekStream=E;function f(y,g){const v=C(g);return v.end(y),v}e.toStream=f;function l(y){let g=!1;return{read:()=>g?null:(g=!0,y)}}e.toReadable=l;function m(y,g,v){const d=C(v);return k(y,{onData:u=>d.write(g.data(u)),onError:u=>d.error(g.error?g.error(u):u),onEnd:()=>d.end()}),d}e.transform=m}),define(ge[9],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function p(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=p;const D=/{(\d+)}/g;function R(G,...oe){return oe.length===0?G:G.replace(D,function(ue,J){const ne=parseInt(J,10);return isNaN(ne)||ne<0||ne>=oe.length?ue:oe[ne]})}e.format=R;function I(G){return G.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=I;function C(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function P(G,oe){let ue=0;const J=oe.charCodeAt(0);for(let ne=G.length-1;ne>=0;ne--)G.charCodeAt(ne)===J&&ue++;return ue}e.count=P;function S(G,oe,ue="\u2026"){return G.length<=oe?G:`${G.substr(0,oe)}${ue}`}e.truncate=S;function i(G,oe=" "){const ue=T(G,oe);return k(ue,oe)}e.trim=i;function T(G,oe){if(!G||!oe)return G;const ue=oe.length;if(ue===0||G.length===0)return G;let J=0;for(;G.indexOf(oe,J)===J;)J=J+ue;return G.substring(J)}e.ltrim=T;function k(G,oe){if(!G||!oe)return G;const ue=oe.length,J=G.length;if(ue===0||J===0)return G;let ne=J,le=-1;for(;le=G.lastIndexOf(oe,ne-1),!(le===-1||le+ue!==ne);){if(le===0)return"";ne=le}return G.substring(0,ne)}e.rtrim=k;function E(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=E;function f(G){return G.replace(/\*/g,"")}e.stripWildcards=f;function l(G,oe,ue={}){if(!G)throw new Error("Cannot create regex from empty string");oe||(G=C(G)),ue.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let J="";return ue.global&&(J+="g"),ue.matchCase||(J+="i"),ue.multiline&&(J+="m"),ue.unicode&&(J+="u"),new RegExp(G,J)}e.createRegExp=l;function m(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function y(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=y;function g(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=g;function v(G){return G.split(/\r\n|\r|\n/)}e.splitLines=v;function d(G){for(let oe=0,ue=G.length;oe<ue;oe++){const J=G.charCodeAt(oe);if(J!==32&&J!==9)return oe}return-1}e.firstNonWhitespaceIndex=d;function u(G,oe=0,ue=G.length){for(let J=oe;J<ue;J++){const ne=G.charCodeAt(J);if(ne!==32&&ne!==9)return G.substring(oe,J)}return G.substring(oe,ue)}e.getLeadingWhitespace=u;function o(G,oe=G.length-1){for(let ue=oe;ue>=0;ue--){const J=G.charCodeAt(ue);if(J!==32&&J!==9)return ue}return-1}e.lastNonWhitespaceIndex=o;function t(G,oe){return G<oe?-1:G>oe?1:0}e.compare=t;function r(G,oe,ue=0,J=G.length,ne=0,le=oe.length){for(;ue<J&&ne<le;ue++,ne++){let He=G.charCodeAt(ue),Be=oe.charCodeAt(ne);if(He<Be)return-1;if(He>Be)return 1}const me=J-ue,Ee=le-ne;return me<Ee?-1:me>Ee?1:0}e.compareSubstring=r;function s(G,oe){return a(G,oe,0,G.length,0,oe.length)}e.compareIgnoreCase=s;function a(G,oe,ue=0,J=G.length,ne=0,le=oe.length){for(;ue<J&&ne<le;ue++,ne++){let He=G.charCodeAt(ue),Be=oe.charCodeAt(ne);if(He!==Be){const qe=He-Be;if(!(qe===32&&c(Be))&&!(qe===-32&&c(He)))return n(He)&&n(Be)?qe:r(G.toLowerCase(),oe.toLowerCase(),ue,J,ne,le)}}const me=J-ue,Ee=le-ne;return me<Ee?-1:me>Ee?1:0}e.compareSubstringIgnoreCase=a;function n(G){return G>=97&&G<=122}e.isLowerAsciiLetter=n;function c(G){return G>=65&&G<=90}e.isUpperAsciiLetter=c;function b(G){return n(G)||c(G)}function w(G,oe){return G.length===oe.length&&h(G,oe)}e.equalsIgnoreCase=w;function h(G,oe,ue=G.length){for(let J=0;J<ue;J++){const ne=G.charCodeAt(J),le=oe.charCodeAt(J);if(ne!==le){if(b(ne)&&b(le)){const me=Math.abs(ne-le);if(me!==0&&me!==32)return!1}else if(String.fromCharCode(ne).toLowerCase()!==String.fromCharCode(le).toLowerCase())return!1}}return!0}function _(G,oe){const ue=oe.length;return oe.length>G.length?!1:h(G,oe,ue)}e.startsWithIgnoreCase=_;function A(G,oe){let ue,J=Math.min(G.length,oe.length);for(ue=0;ue<J;ue++)if(G.charCodeAt(ue)!==oe.charCodeAt(ue))return ue;return J}e.commonPrefixLength=A;function L(G,oe){let ue,J=Math.min(G.length,oe.length);const ne=G.length-1,le=oe.length-1;for(ue=0;ue<J;ue++)if(G.charCodeAt(ne-ue)!==oe.charCodeAt(le-ue))return ue;return J}e.commonSuffixLength=L;function W(G){return 55296<=G&&G<=56319}e.isHighSurrogate=W;function j(G){return 56320<=G&&G<=57343}e.isLowSurrogate=j;function K(G,oe){return(G-55296<<10)+(oe-56320)+65536}e.computeCodePoint=K;function H(G,oe,ue){const J=G.charCodeAt(ue);if(W(J)&&ue+1<oe){const ne=G.charCodeAt(ue+1);if(j(ne))return K(J,ne)}return J}e.getNextCodePoint=H;function $(G,oe){const ue=G.charCodeAt(oe-1);if(j(ue)&&oe>1){const J=G.charCodeAt(oe-2);if(W(J))return K(J,ue)}return ue}function M(G,oe){const ue=We.getInstance(),J=oe,ne=G.length,le=H(G,ne,oe);oe+=le>=65536?2:1;let me=ue.getGraphemeBreakType(le);for(;oe<ne;){const Ee=H(G,ne,oe),He=ue.getGraphemeBreakType(Ee);if(Ne(me,He))break;oe+=Ee>=65536?2:1,me=He}return oe-J}e.nextCharLength=M;function U(G,oe){const ue=We.getInstance(),J=oe,ne=$(G,oe);oe-=ne>=65536?2:1;let le=ue.getGraphemeBreakType(ne);for(;oe>0;){const me=$(G,oe),Ee=ue.getGraphemeBreakType(me);if(Ne(Ee,le))break;oe-=me>=65536?2:1,le=Ee}return J-oe}e.prevCharLength=U;function F(G,oe){const ue=We.getInstance(),J=G.length,ne=oe,le=H(G,J,oe),me=ue.getGraphemeBreakType(le);oe+=le>=65536?2:1;let Ee=me;for(;oe<J;){const Be=H(G,J,oe),qe=ue.getGraphemeBreakType(Be);if(Ne(Ee,qe))break;oe+=Be>=65536?2:1,Ee=qe}const He=oe;for(oe=ne,Ee=me;oe>0;){const Be=$(G,oe),qe=ue.getGraphemeBreakType(Be);if(Ne(qe,Ee))break;oe-=Be>=65536?2:1,Ee=qe}return[oe,He]}function N(G,oe){return oe>0&&j(G.charCodeAt(oe))?F(G,oe-1):F(G,oe)}e.getCharContainingOffset=N;function O(G){const oe=G.length;let ue=0,J=0;for(;J<oe;){const me=H(G,oe,J);J+=me>=65536?2:1,me<128?ue+=1:me<2048?ue+=2:me<65536?ue+=3:ue+=4}const ne=new Uint8Array(ue);J=0;let le=0;for(;J<oe;){const me=H(G,oe,J);J+=me>=65536?2:1,me<128?ne[le++]=me:me<2048?(ne[le++]=192|(me&1984)>>>6,ne[le++]=128|(me&63)>>>0):me<65536?(ne[le++]=224|(me&61440)>>>12,ne[le++]=128|(me&4032)>>>6,ne[le++]=128|(me&63)>>>0):(ne[le++]=240|(me&1835008)>>>18,ne[le++]=128|(me&258048)>>>12,ne[le++]=128|(me&4032)>>>6,ne[le++]=128|(me&63)>>>0)}return ne}e.encodeUTF8=O;function V(G){const oe=G.byteLength,ue=[];let J=0;for(;J<oe;){const ne=G[J];let le;if(ne>=240&&J+3<oe?le=(G[J++]&7)<<18>>>0|(G[J++]&63)<<12>>>0|(G[J++]&63)<<6>>>0|(G[J++]&63)<<0>>>0:ne>=224&&J+2<oe?le=(G[J++]&15)<<12>>>0|(G[J++]&63)<<6>>>0|(G[J++]&63)<<0>>>0:ne>=192&&J+1<oe?le=(G[J++]&31)<<6>>>0|(G[J++]&63)<<0>>>0:le=G[J++],le>=0&&le<=55295||le>=57344&&le<=65535)ue.push(String.fromCharCode(le));else if(le>=65536&&le<=1114111){const me=le-65536,Ee=55296+((me&1047552)>>>10),He=56320+((me&1023)>>>0);ue.push(String.fromCharCode(Ee)),ue.push(String.fromCharCode(He))}else ue.push(String.fromCharCode(65533))}return ue.join("")}e.decodeUTF8=V;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(G){return q.test(G)}e.containsRTL=Y;const fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function _e(G){return fe.test(G)}e.containsEmoji=_e;const Le=/^[\t\n\r\x20-\x7E]*$/;function Ie(G){return Le.test(G)}e.isBasicASCII=Ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Fe(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=Fe;function z(G){for(let oe=0,ue=G.length;oe<ue;oe++)if(Q(G.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=z;function Q(G){return G=+G,G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=Q;function te(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129003||G>=129280&&G<=129535||G>=129648&&G<=129750}e.isEmojiImprecise=te;function ae(G,oe){if(G.length<oe)return G;const ue=/\b/g;let J=0;for(;ue.test(G)&&!(G.length-ue.lastIndex<oe);)J=ue.lastIndex,ue.lastIndex+=1;return G.substring(J).replace(/^\s/,"")}e.lcut=ae;const ve=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Me=/\x1b\[0?m/g;function we(G){return G&&(G=G.replace(ve,""),G=G.replace(De,""),G=G.replace(Me,"")),G}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Ae(G){return ke(G)?G.substr(1):G}e.stripUTF8BOM=Ae;function xe(G,oe){if(!G||!oe||G.length<oe.length)return!1;const ue=oe.length,J=G.toLowerCase();let ne=0,le=-1;for(;ne<ue;){const me=J.indexOf(oe[ne],le+1);if(me<0)return!1;le=me,ne++}return!0}e.fuzzyContains=xe;function ye(G,oe=!1){return G?(oe&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=ye;function Ge(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=Ge;function X(G,oe=1){if(oe===0)return"";let ue=-1;do ue=G.indexOf(`
`,ue+1),oe--;while(oe>0&&ue>=0);return ue===-1?G:(G[ue-1]==="\r"&&ue--,G.substr(0,ue))}e.getNLines=X;function ie(G){const oe=90-65+1;return G=G%(2*oe),G<oe?String.fromCharCode(97+G):String.fromCharCode(65+G-oe)}e.singleLetterHash=ie;function Se(G){return We.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=Se;function Ne(G,oe){return G===0?oe!==5&&oe!==7:G===2&&oe===3?!1:G===4||G===2||G===3||oe===4||oe===2||oe===3?!0:!(G===8&&(oe===8||oe===9||oe===11||oe===12)||(G===11||G===9)&&(oe===9||oe===10)||(G===12||G===10)&&oe===10||oe===5||oe===13||oe===7||G===1||G===13&&oe===14||G===6&&oe===6)}e.breakBetweenGraphemeBreakType=Ne;var ze;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{constructor(){this._data=Je()}static getInstance(){return We._INSTANCE||(We._INSTANCE=new We),We._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ue=this._data,J=ue.length/3;let ne=1;for(;ne<=J;)if(oe<ue[3*ne])ne=2*ne;else if(oe>ue[3*ne+1])ne=2*ne+1;else return ue[3*ne+2];return 0}}We._INSTANCE=null;function Je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ge[26],pe([0,1,9,91]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined",I=typeof TextEncoder!="undefined",C=typeof TextDecoder!="undefined";let P,S;class i{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return R?new i(Buffer.allocUnsafe(n)):new i(new Uint8Array(n))}static wrap(n){return R&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new i(n)}static fromString(n,c){return!((c==null?void 0:c.dontUseNodeBuffer)||!1)&&R?new i(Buffer.from(n)):I?(P||(P=new TextEncoder),new i(P.encode(n))):new i(p.encodeUTF8(n))}static concat(n,c){if(typeof c=="undefined"){c=0;for(let h=0,_=n.length;h<_;h++)c+=n[h].byteLength}const b=i.alloc(c);let w=0;for(let h=0,_=n.length;h<_;h++){const A=n[h];b.set(A,w),w+=A.byteLength}return b}toString(){return R?this.buffer.toString():C?(S||(S=new TextDecoder),S.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(n,c){return new i(this.buffer.subarray(n,c))}set(n,c){n instanceof i?this.buffer.set(n.buffer,c):this.buffer.set(n,c)}readUInt32BE(n){return E(this.buffer,n)}writeUInt32BE(n,c){f(this.buffer,n,c)}readUInt32LE(n){return l(this.buffer,n)}writeUInt32LE(n,c){m(this.buffer,n,c)}readUInt8(n){return y(this.buffer,n)}writeUInt8(n,c){g(this.buffer,n,c)}}e.VSBuffer=i;function T(a,n){return a[n+0]<<0>>>0|a[n+1]<<8>>>0}e.readUInt16LE=T;function k(a,n,c){a[c+0]=n&255,n=n>>>8,a[c+1]=n&255}e.writeUInt16LE=k;function E(a,n){return a[n]*2**24+a[n+1]*2**16+a[n+2]*2**8+a[n+3]}e.readUInt32BE=E;function f(a,n,c){a[c+3]=n,n=n>>>8,a[c+2]=n,n=n>>>8,a[c+1]=n,n=n>>>8,a[c]=n}e.writeUInt32BE=f;function l(a,n){return a[n+0]<<0>>>0|a[n+1]<<8>>>0|a[n+2]<<16>>>0|a[n+3]<<24>>>0}e.readUInt32LE=l;function m(a,n,c){a[c+0]=n&255,n=n>>>8,a[c+1]=n&255,n=n>>>8,a[c+2]=n&255,n=n>>>8,a[c+3]=n&255}e.writeUInt32LE=m;function y(a,n){return a[n]}e.readUInt8=y;function g(a,n,c){a[c]=n}e.writeUInt8=g;function v(a){return D.consumeReadable(a,n=>i.concat(n))}e.readableToBuffer=v;function d(a){return D.toReadable(a)}e.bufferToReadable=d;function u(a){return D.consumeStream(a,n=>i.concat(n))}e.streamToBuffer=u;async function o(a){return a.ended?i.concat(a.buffer):i.concat([...a.buffer,await u(a.stream)])}e.bufferedStreamToBuffer=o;function t(a){return D.toStream(a,n=>i.concat(n))}e.bufferToStream=t;function r(a){return D.transform(a,{data:n=>typeof n=="string"?i.fromString(n):i.wrap(n)},n=>i.concat(n))}e.streamToBufferReadableStream=r;function s(a){return D.newWriteableStream(n=>i.concat(n),a)}e.newWriteableBufferStream=s}),define(ge[73],pe([0,1,9]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function D(g){return R(g,0)}e.hash=D;function R(g,v){switch(typeof g){case"object":return g===null?I(349,v):Array.isArray(g)?S(g,v):i(g,v);case"string":return P(g,v);case"boolean":return C(g,v);case"number":return I(g,v);case"undefined":return I(937,v);default:return I(617,v)}}e.doHash=R;function I(g,v){return(v<<5)-v+g|0}function C(g,v){return I(g?433:863,v)}function P(g,v){v=I(149417,v);for(let d=0,u=g.length;d<u;d++)v=I(g.charCodeAt(d),v);return v}e.stringHash=P;function S(g,v){return v=I(104579,v),g.reduce((d,u)=>R(u,d),v)}function i(g,v){return v=I(181387,v),Object.keys(g).sort().reduce((d,u)=>(d=P(u,d),R(g[u],d)),v)}class T{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=R(v,this._value),this._value}}e.Hasher=T;var k;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function E(g,v,d=32){const u=d-v,o=~((1<<u)-1);return(g<<v|(o&g)>>>u)>>>0}function f(g,v=0,d=g.byteLength,u=0){for(let o=0;o<d;o++)g[v+o]=u}function l(g,v,d="0"){for(;g.length<v;)g=d+g;return g}function m(g,v=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(d=>d.toString(16).padStart(2,"0")).join(""):l((g>>>0).toString(16),v/4)}e.toHexString=m;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const d=v.length;if(d!==0){const u=this._buff;let o=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=v.charCodeAt(0),s=0);;){let a=r;if(p.isHighSurrogate(r))if(s+1<d){const n=v.charCodeAt(s+1);p.isLowSurrogate(n)?(s++,a=p.computeCodePoint(r,n)):a=65533}else{t=r;break}else p.isLowSurrogate(r)&&(a=65533);if(o=this._push(u,o,a),s++,s<d)r=v.charCodeAt(s);else break}this._buffLen=o,this._leftoverHighSurrogate=t}}_push(v,d,u){return u<128?v[d++]=u:u<2048?(v[d++]=192|(u&1984)>>>6,v[d++]=128|(u&63)>>>0):u<65536?(v[d++]=224|(u&61440)>>>12,v[d++]=128|(u&4032)>>>6,v[d++]=128|(u&63)>>>0):(v[d++]=240|(u&1835008)>>>18,v[d++]=128|(u&258048)>>>12,v[d++]=128|(u&4032)>>>6,v[d++]=128|(u&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=y._bigBlock32,d=this._buffDV;for(let b=0;b<64;b+=4)v.setUint32(b,d.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)v.setUint32(b,E(v.getUint32(b-12,!1)^v.getUint32(b-32,!1)^v.getUint32(b-56,!1)^v.getUint32(b-64,!1),1),!1);let u=this._h0,o=this._h1,t=this._h2,r=this._h3,s=this._h4,a,n,c;for(let b=0;b<80;b++)b<20?(a=o&t|~o&r,n=1518500249):b<40?(a=o^t^r,n=1859775393):b<60?(a=o&t|o&r|t&r,n=2400959708):(a=o^t^r,n=3395469782),c=E(u,5)+a+s+n+v.getUint32(b*4,!1)&4294967295,s=r,r=t,t=E(o,30),o=u,u=c;this._h0=this._h0+u&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[74],pe([0,1,9]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const I="error",C="warning",P="warn",S="info";function i(T){return T?p.equalsIgnoreCase(I,T)?R.Error:p.equalsIgnoreCase(C,T)||p.equalsIgnoreCase(P,T)?R.Warning:p.equalsIgnoreCase(S,T)?R.Info:R.Ignore:R.Ignore}R.fromValue=i}(D||(D={})),e.default=D}),define(ge[15],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(n){return Array.isArray(n)}e.isArray=p;function D(n){return typeof n=="string"}e.isString=D;function R(n){return Array.isArray(n)&&n.every(c=>D(c))}e.isStringArray=R;function I(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=I;function C(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=C;function P(n){return n===!0||n===!1}e.isBoolean=P;function S(n){return typeof n=="undefined"}e.isUndefined=S;function i(n){return!T(n)}e.isDefined=i;function T(n){return S(n)||n===null}e.isUndefinedOrNull=T;function k(n,c){if(!n)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}e.assertType=k;function E(n){if(T(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=E;function f(...n){const c=[];for(let b=0;b<n.length;b++){const w=n[b];if(T(w))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);c.push(w)}return c}e.assertAllDefined=f;const l=Object.prototype.hasOwnProperty;function m(n){if(!I(n))return!1;for(let c in n)if(l.call(n,c))return!1;return!0}e.isEmptyObject=m;function y(n){return typeof n=="function"}e.isFunction=y;function g(...n){return n.length>0&&n.every(y)}e.areFunctions=g;function v(n,c){const b=Math.min(n.length,c.length);for(let w=0;w<b;w++)d(n[w],c[w])}e.validateConstraints=v;function d(n,c){if(D(c)){if(typeof n!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(y(c)){try{if(n instanceof c)return}catch(b){}if(!T(n)&&n.constructor===c||c.length===1&&c.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function u(n){let c=[],b=Object.getPrototypeOf(n);for(;Object.prototype!==b;)c=c.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return c}e.getAllPropertyNames=u;function o(n){const c=[];for(const b of u(n))typeof n[b]=="function"&&c.push(b);return c}e.getAllMethodNames=o;function t(n,c){const b=h=>function(){const _=Array.prototype.slice.call(arguments,0);return c(h,_)};let w={};for(const h of n)w[h]=b(h);return w}e.createProxyObject=t;function r(n){return n===null?void 0:n}e.withNullAsUndefined=r;function s(n){return typeof n=="undefined"?null:n}e.withUndefinedAsNull=s;function a(n){return class{constructor(){return new Proxy({},{get(c,b){if(c[b])return c[b];throw new Error(`Not Implemented: ${n}->${String(b)}`)}})}}}e.NotImplementedProxy=a}),define(ge[30],pe([0,1,10,9,7,15]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function C(r){return r===47||r===92}e.isPathSeparator=C;function P(r){return r.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function S(r,s=R.posix.sep){if(!r)return"";const a=r.length,n=r.charCodeAt(0);if(C(n)){if(C(r.charCodeAt(1))&&!C(r.charCodeAt(2))){let b=3;const w=b;for(;b<a&&!C(r.charCodeAt(b));b++);if(w!==b&&!C(r.charCodeAt(b+1))){for(b+=1;b<a;b++)if(C(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,s)}}return s}else if(y(n)&&r.charCodeAt(1)===58)return C(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let c=r.indexOf("://");if(c!==-1){for(c+=3;c<a;c++)if(C(r.charCodeAt(c)))return r.slice(0,c+1)}return""}e.getRoot=S;function i(r){if(!p.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let a=2;const n=a;for(;a<r.length&&(s=r.charCodeAt(a),s!==92);a++);return!(n===a||(s=r.charCodeAt(a+1),isNaN(s)||s===92))}e.isUNC=i;const T=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,s=p.isWindows){const a=s?T:k;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||s&&E.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function l(r,s,a){const n=r===s;return!a||n?n:!r||!s?!1:(0,D.equalsIgnoreCase)(r,s)}e.isEqual=l;function m(r,s,a,n=R.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let b=s.length;return s.charAt(s.length-1)===n&&b--,r.charAt(b)===n}return s.charAt(s.length-1)!==n&&(s+=n),r.indexOf(s)===0}e.isEqualOrParent=m;function y(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=y;function g(r,s){return p.isWindows&&r.endsWith(":")&&(r+=R.sep),(0,R.isAbsolute)(r)||(r=(0,R.join)(s,r)),r=(0,R.normalize)(r),p.isWindows?(r=(0,D.rtrim)(r,R.sep),r.endsWith(":")&&(r+=R.sep)):(r=(0,D.rtrim)(r,R.sep),r||(r=R.sep)),r}e.sanitizeFilePath=g;function v(r){const s=(0,R.normalize)(r);return p.isWindows?r.length>3?!1:d(s)&&(r.length===2||s.charCodeAt(2)===92):s===R.posix.sep}e.isRootOrDriveLetter=v;function d(r){return p.isWindows?y(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function u(r){return d(r)?r[0]:void 0}e.getDriveLetter=u;function o(r,s,a){return s.length>r.length?-1:r===s?0:(a&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=o;function t(r){const s=r.split(":");let a,n,c;if(s.forEach(b=>{const w=Number(b);(0,I.isNumber)(w)?n===void 0?n=w:c===void 0&&(c=w):a=a?[a,b].join(":"):b}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:n!==void 0?n:void 0,column:c!==void 0?c:n!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ge[22],pe([0,1,15]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const m=Array.isArray(l)?[]:{};return Object.keys(l).forEach(y=>{l[y]&&typeof l[y]=="object"?m[y]=D(l[y]):m[y]=l[y]}),m}e.deepClone=D;function R(l){if(!l||typeof l!="object")return l;const m=[l];for(;m.length>0;){const y=m.shift();Object.freeze(y);for(const g in y)if(I.call(y,g)){const v=y[g];typeof v=="object"&&!Object.isFrozen(v)&&m.push(v)}}return l}e.deepFreeze=R;const I=Object.prototype.hasOwnProperty;function C(l,m){return P(l,m,new Set)}e.cloneAndChange=C;function P(l,m,y){if((0,p.isUndefinedOrNull)(l))return l;const g=m(l);if(typeof g!="undefined")return g;if((0,p.isArray)(l)){const v=[];for(const d of l)v.push(P(d,m,y));return v}if((0,p.isObject)(l)){if(y.has(l))throw new Error("Cannot clone recursive data-structure");y.add(l);const v={};for(let d in l)I.call(l,d)&&(v[d]=P(l[d],m,y));return y.delete(l),v}return l}function S(l,m,y=!0){return(0,p.isObject)(l)?((0,p.isObject)(m)&&Object.keys(m).forEach(g=>{g in l?y&&((0,p.isObject)(l[g])&&(0,p.isObject)(m[g])?S(l[g],m[g],y):l[g]=m[g]):l[g]=m[g]}),l):m}e.mixin=S;function i(l,m){if(l===m)return!0;if(l==null||m===null||m===void 0||typeof l!=typeof m||typeof l!="object"||Array.isArray(l)!==Array.isArray(m))return!1;let y,g;if(Array.isArray(l)){if(l.length!==m.length)return!1;for(y=0;y<l.length;y++)if(!i(l[y],m[y]))return!1}else{const v=[];for(g in l)v.push(g);v.sort();const d=[];for(g in m)d.push(g);if(d.sort(),!i(v,d))return!1;for(y=0;y<v.length;y++)if(!i(l[v[y]],m[v[y]]))return!1}return!0}e.equals=i;function T(l){const m=new Set;return JSON.stringify(l,(y,g)=>{if((0,p.isObject)(g)||Array.isArray(g)){if(m.has(g))return"[Circular]";m.add(g)}return g})}e.safeStringify=T;function k(l,m,y){const g=m(l);return typeof g=="undefined"?y:g}e.getOrDefault=k;function E(l,m){const y=Object.create(null);return!l||!m||Object.keys(m).forEach(v=>{const d=l[v],u=m[v];i(d,u)||(y[v]=u)}),y}e.distinct=E;function f(l,m){const y=m.toLowerCase(),g=Object.keys(l).find(v=>v.toLowerCase()===y);return g?l[g]:l[m]}e.getCaseInsensitive=f}),define(ge[92],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var p;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p=e.Constants||(e.Constants={}));function D(I){return I<0?0:I>255?255:I|0}e.toUint8=D;function R(I){return I<0?0:I>4294967295?4294967295:I|0}e.toUint32=R}),define(ge[2],pe([0,1,10,7]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,I=/^\//,C=/^\/\//;function P(s,a){if(!s.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!R.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!I.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,a){return!s&&!a?"file":s}function i(s,a){switch(s){case"https":case"http":case"file":a?a[0]!==k&&(a=k+a):a=k;break}return a}const T="",k="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(a,n,c,b,w,h=!1){typeof a=="object"?(this.scheme=a.scheme||T,this.authority=a.authority||T,this.path=a.path||T,this.query=a.query||T,this.fragment=a.fragment||T):(this.scheme=S(a,h),this.authority=n||T,this.path=i(this.scheme,c||T),this.query=b||T,this.fragment=w||T,P(this,h))}static isUri(a){return a instanceof f?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return d(this,!1)}with(a){if(!a)return this;let{scheme:n,authority:c,path:b,query:w,fragment:h}=a;return n===void 0?n=this.scheme:n===null&&(n=T),c===void 0?c=this.authority:c===null&&(c=T),b===void 0?b=this.path:b===null&&(b=T),w===void 0?w=this.query:w===null&&(w=T),h===void 0?h=this.fragment:h===null&&(h=T),n===this.scheme&&c===this.authority&&b===this.path&&w===this.query&&h===this.fragment?this:new m(n,c,b,w,h)}static parse(a,n=!1){const c=E.exec(a);return c?new m(c[2]||T,r(c[4]||T),r(c[5]||T),r(c[7]||T),r(c[9]||T),n):new m(T,T,T,T,T)}static file(a){let n=T;if(p.isWindows&&(a=a.replace(/\\/g,k)),a[0]===k&&a[1]===k){const c=a.indexOf(k,2);c===-1?(n=a.substring(2),a=k):(n=a.substring(2,c),a=a.substring(c)||k)}return new m("file",n,a,T,T)}static from(a){return new m(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...n){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return p.isWindows&&a.scheme==="file"?c=f.file(D.win32.join(d(a,!0),...n)).path:c=D.posix.join(a.path,...n),a.with({path:c})}toString(a=!1){return u(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof f)return a;{const n=new m(a);return n._formatted=a.external,n._fsPath=a._sep===l?a.fsPath:null,n}}else return a}}e.URI=f;const l=p.isWindows?1:void 0;class m extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(a=!1){return a?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=l),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(s,a){let n,c=-1;for(let b=0;b<s.length;b++){const w=s.charCodeAt(b);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||a&&w===47)c!==-1&&(n+=encodeURIComponent(s.substring(c,b)),c=-1),n!==void 0&&(n+=s.charAt(b));else{n===void 0&&(n=s.substr(0,b));const h=y[w];h!==void 0?(c!==-1&&(n+=encodeURIComponent(s.substring(c,b)),c=-1),n+=h):c===-1&&(c=b)}}return c!==-1&&(n+=encodeURIComponent(s.substring(c))),n!==void 0?n:s}function v(s){let a;for(let n=0;n<s.length;n++){const c=s.charCodeAt(n);c===35||c===63?(a===void 0&&(a=s.substr(0,n)),a+=y[c]):a!==void 0&&(a+=s[n])}return a!==void 0?a:s}function d(s,a){let n;return s.authority&&s.path.length>1&&s.scheme==="file"?n=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?a?n=s.path.substr(1):n=s.path[1].toLowerCase()+s.path.substr(2):n=s.path,p.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=d;function u(s,a){const n=a?v:g;let c="",{scheme:b,authority:w,path:h,query:_,fragment:A}=s;if(b&&(c+=b,c+=":"),(w||b==="file")&&(c+=k,c+=k),w){let L=w.indexOf("@");if(L!==-1){const W=w.substr(0,L);w=w.substr(L+1),L=W.indexOf(":"),L===-1?c+=n(W,!1):(c+=n(W.substr(0,L),!1),c+=":",c+=n(W.substr(L+1),!1)),c+="@"}w=w.toLowerCase(),L=w.indexOf(":"),L===-1?c+=n(w,!1):(c+=n(w.substr(0,L),!1),c+=w.substr(L))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const L=h.charCodeAt(1);L>=65&&L<=90&&(h=`/${String.fromCharCode(L+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const L=h.charCodeAt(0);L>=65&&L<=90&&(h=`${String.fromCharCode(L+32)}:${h.substr(2)}`)}c+=n(h,!0)}return _&&(c+="?",c+=n(_,!1)),A&&(c+="#",c+=a?A:g(A,!1)),c}function o(s){try{return decodeURIComponent(s)}catch(a){return s.length>3?s.substr(0,3)+o(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,a=>o(a)):s}}),define(ge[23],pe([0,1,2,9]),function(Z,e,p,D){"use strict";var R,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(u,o,t){let r=u.get(o);return r===void 0&&(r=t,u.set(o,r)),r}e.getOrSet=C;function P(u){const o=[];return u.forEach((t,r)=>{o.push(`${r} => ${t}`)}),`Map(${u.size}) {${o.join(", ")}}`}e.mapToString=P;function S(u){const o=[];return u.forEach(t=>{o.push(t)}),`Set(${u.size}) {${o.join(", ")}}`}e.setToString=S;class i{constructor(){this._value="",this._pos=0}reset(o){return this._value=o,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(o){const t=o.charCodeAt(0),r=this._value.charCodeAt(this._pos);return t-r}value(){return this._value[this._pos]}}e.StringIterator=i;class T{constructor(o=!0){this._caseSensitive=o}reset(o){return this._value=o,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(o)this._from++;else break;else o=!1;return this}cmp(o){return this._caseSensitive?(0,D.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class k{constructor(o=!0,t=!0){this._splitOnBackslash=o,this._caseSensitive=t}reset(o){return this._value=o.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(o)this._from++;else break;else o=!1}return this}cmp(o){return this._caseSensitive?(0,D.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var E;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(E||(E={}));class f{constructor(o){this._ignorePathCasing=o,this._states=[],this._stateIdx=0}reset(o){return this._value=o,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(o)),this._pathIterator.reset(o.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(o){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(o,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(o,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(o);if(this._states[this._stateIdx]===4)return(0,D.compare)(o,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(o,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class l{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class m{constructor(o){this._iter=o}static forUris(o=()=>!1){return new m(new f(o))}static forPaths(){return new m(new k)}static forStrings(){return new m(new i)}static forConfigKeys(){return new m(new T)}clear(){this._root=void 0}set(o,t){const r=this._iter.reset(o);let s;for(this._root||(this._root=new l,this._root.segment=r.value()),s=this._root;;){const n=r.cmp(s.segment);if(n>0)s.left||(s.left=new l,s.left.segment=r.value()),s=s.left;else if(n<0)s.right||(s.right=new l,s.right.segment=r.value()),s=s.right;else if(r.hasNext())r.next(),s.mid||(s.mid=new l,s.mid.segment=r.value()),s=s.mid;else break}const a=s.value;return s.value=t,s.key=o,a}get(o){var t;return(t=this._getNode(o))===null||t===void 0?void 0:t.value}_getNode(o){const t=this._iter.reset(o);let r=this._root;for(;r;){const s=t.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else break}return r}has(o){const t=this._getNode(o);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(o){return this._delete(o,!1)}deleteSuperstr(o){return this._delete(o,!0)}_delete(o,t){const r=this._iter.reset(o),s=[];let a=this._root;for(;a;){const n=r.cmp(a.segment);if(n>0)s.push([1,a]),a=a.left;else if(n<0)s.push([-1,a]),a=a.right;else if(r.hasNext())r.next(),s.push([0,a]),a=a.mid;else{for(t?(a.left=void 0,a.mid=void 0,a.right=void 0):a.value=void 0;s.length>0&&a.isEmpty();){let[c,b]=s.pop();switch(c){case 1:b.left=void 0;break;case 0:b.mid=void 0;break;case-1:b.right=void 0;break}a=b}break}}}findSubstr(o){const t=this._iter.reset(o);let r=this._root,s;for(;r;){const a=t.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(t.hasNext())t.next(),s=r.value||s,r=r.mid;else break}return r&&r.value||s}findSuperstr(o){const t=this._iter.reset(o);let r=this._root;for(;r;){const s=t.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(o){for(const[t,r]of this)o(r,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(o){o&&(yield*this._entries(o.left),o.value&&(yield[o.key,o.value]),yield*this._entries(o.mid),yield*this._entries(o.right))}}e.TernarySearchTree=m;class y{constructor(o,t){this[R]="ResourceMap",o instanceof y?(this.map=new Map(o.map),this.toKey=t!=null?t:y.defaultToKey):(this.map=new Map,this.toKey=o!=null?o:y.defaultToKey)}set(o,t){return this.map.set(this.toKey(o),t),this}get(o){return this.map.get(this.toKey(o))}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,t){typeof t!="undefined"&&(o=o.bind(t));for(let[r,s]of this.map)o(s,p.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let o of this.map.keys())yield p.URI.parse(o)}*entries(){for(let o of this.map.entries())yield[p.URI.parse(o[0]),o[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let o of this.map)yield[p.URI.parse(o[0]),o[1]]}}e.ResourceMap=y,y.defaultToKey=u=>u.toString();var g;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class v{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var o;return(o=this._head)===null||o===void 0?void 0:o.value}get last(){var o;return(o=this._tail)===null||o===void 0?void 0:o.value}has(o){return this._map.has(o)}get(o,t=0){const r=this._map.get(o);if(!!r)return t!==0&&this.touch(r,t),r.value}set(o,t,r=0){let s=this._map.get(o);if(s)s.value=t,r!==0&&this.touch(s,r);else{switch(s={key:o,value:t,next:void 0,previous:void 0},r){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(o,s),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const t=this._map.get(o);if(!!t)return this._map.delete(o),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}}forEach(o,t){const r=this._state;let s=this._head;for(;s;){if(t?o.bind(t)(s.value,s.key,this):o(s.value,s.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const o=this,t=this._state;let r=this._head;const s={[Symbol.iterator](){return s},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const a={value:r.key,done:!1};return r=r.next,a}else return{value:void 0,done:!0}}};return s}values(){const o=this,t=this._state;let r=this._head;const s={[Symbol.iterator](){return s},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const a={value:r.value,done:!1};return r=r.next,a}else return{value:void 0,done:!0}}};return s}entries(){const o=this,t=this._state;let r=this._head;const s={[Symbol.iterator](){return s},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const a={value:[r.key,r.value],done:!1};return r=r.next,a}else return{value:void 0,done:!0}}};return s}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(!(o>=this.size)){if(o===0){this.clear();return}let t=this._head,r=this.size;for(;t&&r>o;)this._map.delete(t.key),t=t.next,r--;this._head=t,this._size=r,t&&(t.previous=void 0),this._state++}}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const t=o.next,r=o.previous;if(!t||!r)throw new Error("Invalid list");t.previous=r,r.next=t}o.next=void 0,o.previous=void 0,this._state++}touch(o,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(o===this._head)return;const r=o.next,s=o.previous;o===this._tail?(s.next=void 0,this._tail=s):(r.previous=s,s.next=r),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(t===2){if(o===this._tail)return;const r=o.next,s=o.previous;o===this._head?(r.previous=void 0,this._head=r):(r.previous=s,s.next=r),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((t,r)=>{o.push([r,t])}),o}fromJSON(o){this.clear();for(const[t,r]of o)this.set(t,r)}}e.LinkedMap=v;class d extends v{constructor(o,t=1){super();this._limit=o,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,t=2){return super.get(o,t)}peek(o){return super.get(o,0)}set(o,t){return super.set(o,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d}),define(ge[93],pe([0,1,23,9]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function R(...we){return function(ke,Ae){for(let xe=0,ye=we.length;xe<ye;xe++){const Ge=we[xe](ke,Ae);if(Ge)return Ge}return null}}e.or=R,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(we,ke,Ae){if(!Ae||Ae.length<ke.length)return null;let xe;return we?xe=D.startsWithIgnoreCase(Ae,ke):xe=Ae.indexOf(ke)===0,xe?ke.length>0?[{start:0,end:ke.length}]:[]:null}function C(we,ke){const Ae=ke.toLowerCase().indexOf(we.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+we.length}]}e.matchesContiguousSubString=C;function P(we,ke){return S(we.toLowerCase(),ke.toLowerCase(),0,0)}e.matchesSubString=P;function S(we,ke,Ae,xe){if(Ae===we.length)return[];if(xe===ke.length)return null;if(we[Ae]===ke[xe]){let ye=null;return(ye=S(we,ke,Ae+1,xe+1))?g({start:xe,end:xe+1},ye):null}return S(we,ke,Ae,xe+1)}function i(we){return 97<=we&&we<=122}function T(we){return 65<=we&&we<=90}e.isUpper=T;function k(we){return 48<=we&&we<=57}function E(we){return we===32||we===9||we===10||we===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(we=>f.add(we.charCodeAt(0)));function l(we){return E(we)||f.has(we)}function m(we,ke){return we===ke||l(we)&&l(ke)}function y(we){return i(we)||T(we)||k(we)}function g(we,ke){return ke.length===0?ke=[we]:we.end===ke[0].start?ke[0].start=we.start:ke.unshift(we),ke}function v(we,ke){for(let Ae=ke;Ae<we.length;Ae++){const xe=we.charCodeAt(Ae);if(T(xe)||k(xe)||Ae>0&&!y(we.charCodeAt(Ae-1)))return Ae}return we.length}function d(we,ke,Ae,xe){if(Ae===we.length)return[];if(xe===ke.length)return null;if(we[Ae]!==ke[xe].toLowerCase())return null;{let ye=null,Ge=xe+1;for(ye=d(we,ke,Ae+1,xe+1);!ye&&(Ge=v(ke,Ge))<ke.length;)ye=d(we,ke,Ae+1,Ge),Ge++;return ye===null?null:g({start:xe,end:xe+1},ye)}}function u(we){let ke=0,Ae=0,xe=0,ye=0,Ge=0;for(let ze=0;ze<we.length;ze++)Ge=we.charCodeAt(ze),T(Ge)&&ke++,i(Ge)&&Ae++,y(Ge)&&xe++,k(Ge)&&ye++;const X=ke/we.length,ie=Ae/we.length,Se=xe/we.length,Ne=ye/we.length;return{upperPercent:X,lowerPercent:ie,alphaPercent:Se,numericPercent:Ne}}function o(we){const{upperPercent:ke,lowerPercent:Ae}=we;return Ae===0&&ke>.6}function t(we){const{upperPercent:ke,lowerPercent:Ae,alphaPercent:xe,numericPercent:ye}=we;return Ae>.2&&ke<.8&&xe>.6&&ye<.2}function r(we){let ke=0,Ae=0,xe=0,ye=0;for(let Ge=0;Ge<we.length;Ge++)xe=we.charCodeAt(Ge),T(xe)&&ke++,i(xe)&&Ae++,E(xe)&&ye++;return(ke===0||Ae===0)&&ye===0?we.length<=30:ke<=5}function s(we,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!r(we)||ke.length>60)return null;const Ae=u(ke);if(!t(Ae)){if(!o(Ae))return null;ke=ke.toLowerCase()}let xe=null,ye=0;for(we=we.toLowerCase();ye<ke.length&&(xe=d(we,ke,0,ye))===null;)ye=v(ke,ye+1);return xe}e.matchesCamelCase=s;function a(we,ke,Ae=!1){if(!ke||ke.length===0)return null;let xe=null,ye=0;for(we=we.toLowerCase(),ke=ke.toLowerCase();ye<ke.length&&(xe=n(we,ke,0,ye,Ae))===null;)ye=c(ke,ye+1);return xe}e.matchesWords=a;function n(we,ke,Ae,xe,ye){if(Ae===we.length)return[];if(xe===ke.length)return null;if(m(we.charCodeAt(Ae),ke.charCodeAt(xe))){let Ge=null,X=xe+1;if(Ge=n(we,ke,Ae+1,xe+1,ye),!ye)for(;!Ge&&(X=c(ke,X))<ke.length;)Ge=n(we,ke,Ae+1,X,ye),X++;return Ge===null?null:g({start:xe,end:xe+1},Ge)}else return null}function c(we,ke){for(let Ae=ke;Ae<we.length;Ae++)if(l(we.charCodeAt(Ae))||Ae>0&&l(we.charCodeAt(Ae-1)))return Ae;return we.length}const b=R(e.matchesPrefix,s,C),w=R(e.matchesPrefix,s,P),h=new p.LRUCache(1e4);function _(we,ke,Ae=!1){if(typeof we!="string"||typeof ke!="string")return null;let xe=h.get(we);xe||(xe=new RegExp(D.convertSimple2RegExpPattern(we),"i"),h.set(we,xe));const ye=xe.exec(ke);return ye?[{start:ye.index,end:ye.index+ye[0].length}]:Ae?w(we,ke):b(we,ke)}e.matchesFuzzy=_;function A(we,ke){const Ae=z(we,we.toLowerCase(),0,ke,ke.toLowerCase(),0,!0);return Ae?W(Ae):null}e.matchesFuzzy2=A;function L(we,ke,Ae,xe,ye,Ge){const X=Math.min(13,we.length);for(;Ae<X;Ae++){const ie=z(we,ke,Ae,xe,ye,Ge,!1);if(ie)return ie}return[0,Ge]}e.anyScore=L;function W(we){if(typeof we=="undefined")return[];const ke=[],Ae=we[1];for(let xe=we.length-1;xe>1;xe--){const ye=we[xe]+Ae,Ge=ke[ke.length-1];Ge&&Ge.end===ye?Ge.end=ye+1:ke.push({start:ye,end:ye+1})}return ke}e.createMatches=W;const j=128;function K(){const we=[],ke=[];for(let Ae=0;Ae<=j;Ae++)ke[Ae]=0;for(let Ae=0;Ae<=j;Ae++)we.push(ke.slice(0));return we}function H(we){const ke=[];for(let Ae=0;Ae<=we;Ae++)ke[Ae]=0;return ke}const $=H(2*j),M=H(2*j),U=K(),F=K(),N=K(),O=!1;function V(we,ke,Ae,xe,ye){function Ge(ie,Se,Ne=" "){for(;ie.length<Se;)ie=Ne+ie;return ie}let X=` |   |${xe.split("").map(ie=>Ge(ie,3)).join("|")}
`;for(let ie=0;ie<=Ae;ie++)ie===0?X+=" |":X+=`${ke[ie-1]}|`,X+=we[ie].slice(0,ye+1).map(Se=>Ge(Se.toString(),3)).join("|")+`
`;return X}function q(we,ke,Ae,xe){we=we.substr(ke),Ae=Ae.substr(xe),console.log(V(F,we,we.length,Ae,Ae.length)),console.log(V(N,we,we.length,Ae,Ae.length)),console.log(V(U,we,we.length,Ae,Ae.length))}function Y(we,ke){if(ke<0||ke>=we.length)return!1;const Ae=we.codePointAt(ke);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!D.isEmojiImprecise(Ae)}}function fe(we,ke){if(ke<0||ke>=we.length)return!1;switch(we.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function _e(we,ke,Ae){return ke[we]!==Ae[we]}function Le(we,ke,Ae,xe,ye,Ge,X=!1){for(;ke<Ae&&ye<Ge;)we[ke]===xe[ye]&&(X&&($[ke]=ye),ke+=1),ye+=1;return ke===Ae}e.isPatternInWord=Le;var Ie;(function(we){we[we.Diag=1]="Diag",we[we.Left=2]="Left",we[we.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Fe;(function(we){we.Default=[-100,0];function ke(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}we.isDefault=ke})(Fe=e.FuzzyScore||(e.FuzzyScore={}));function z(we,ke,Ae,xe,ye,Ge,X){const ie=we.length>j?j:we.length,Se=xe.length>j?j:xe.length;if(!(Ae>=ie||Ge>=Se||ie-Ae>Se-Ge)&&!!Le(ke,Ae,ie,ye,Ge,Se,!0)){Q(ie,Se,Ae,Ge,ke,ye);let Ne=1,ze=1,We=Ae,Je=Ge;const G=[!1];for(Ne=1,We=Ae;We<ie;Ne++,We++){const le=$[We],me=M[We],Ee=We+1<ie?M[We+1]:Se;for(ze=le-Ge+1,Je=le;Je<Ee;ze++,Je++){let He=Number.MIN_SAFE_INTEGER,Be=!1;Je<=me&&(He=te(we,ke,We,Ae,xe,ye,Je,Se,Ge,U[Ne-1][ze-1]===0,G));let qe=0;He!==Number.MAX_SAFE_INTEGER&&(Be=!0,qe=He+F[Ne-1][ze-1]);const Xe=Je>le,Ze=Xe?F[Ne][ze-1]+(U[Ne][ze-1]>0?-5:0):0,ut=Je>le+1&&U[Ne][ze-1]>0,st=ut?F[Ne][ze-2]+(U[Ne][ze-2]>0?-5:0):0;if(ut&&(!Xe||st>=Ze)&&(!Be||st>=qe))F[Ne][ze]=st,N[Ne][ze]=3,U[Ne][ze]=0;else if(Xe&&(!Be||Ze>=qe))F[Ne][ze]=Ze,N[Ne][ze]=2,U[Ne][ze]=0;else if(Be)F[Ne][ze]=qe,N[Ne][ze]=1,U[Ne][ze]=U[Ne-1][ze-1]+1;else throw new Error("not possible")}}if(O&&q(we,Ae,xe,Ge),!(!G[0]&&!X)){Ne--,ze--;const oe=[F[Ne][ze],Ge];let ue=0,J=0;for(;Ne>=1;){let le=ze;do{const me=N[Ne][le];if(me===3)le=le-2;else if(me===2)le=le-1;else break}while(le>=1);ue>1&&ke[Ae+Ne-1]===ye[Ge+ze-1]&&!_e(le+Ge-1,xe,ye)&&ue+1>U[Ne][le]&&(le=ze),le===ze?ue++:ue=1,J||(J=le),Ne--,ze=le-1,oe.push(ze)}Se===ie&&(oe[0]+=2);const ne=J-ie;return oe[0]-=ne,oe}}}e.fuzzyScore=z;function Q(we,ke,Ae,xe,ye,Ge){let X=we-1,ie=ke-1;for(;X>=Ae&&ie>=xe;)ye[X]===Ge[ie]&&(M[X]=ie,X--),ie--}function te(we,ke,Ae,xe,ye,Ge,X,ie,Se,Ne,ze){if(ke[Ae]!==Ge[X])return Number.MIN_SAFE_INTEGER;let We=1,Je=!1;return X===Ae-xe?We=we[Ae]===ye[X]?7:5:_e(X,ye,Ge)&&(X===0||!_e(X-1,ye,Ge))?(We=we[Ae]===ye[X]?7:5,Je=!0):Y(Ge,X)&&(X===0||!Y(Ge,X-1))?We=5:(Y(Ge,X-1)||fe(Ge,X-1))&&(We=5,Je=!0),We>1&&Ae===xe&&(ze[0]=!0),Je||(Je=_e(X,ye,Ge)||Y(Ge,X-1)||fe(Ge,X-1)),Ae===xe?X>Se&&(We-=Je?3:5):Ne?We+=Je?2:0:We+=Je?0:1,X+1===ie&&(We-=Je?3:5),We}function ae(we,ke,Ae,xe,ye,Ge,X){return De(we,ke,Ae,xe,ye,Ge,!0,X)}e.fuzzyScoreGracefulAggressive=ae;function ve(we,ke,Ae,xe,ye,Ge,X){return De(we,ke,Ae,xe,ye,Ge,!1,X)}e.fuzzyScoreGraceful=ve;function De(we,ke,Ae,xe,ye,Ge,X,ie){let Se=z(we,ke,Ae,xe,ye,Ge,ie);if(Se&&!X)return Se;if(we.length>=3){const Ne=Math.min(7,we.length-1);for(let ze=Ae+1;ze<Ne;ze++){const We=Me(we,ze);if(We){const Je=z(We,We.toLowerCase(),Ae,xe,ye,Ge,ie);Je&&(Je[0]-=3,(!Se||Je[0]>Se[0])&&(Se=Je))}}}return Se}function Me(we,ke){if(!(ke+1>=we.length)){const Ae=we[ke],xe=we[ke+1];if(Ae!==xe)return we.slice(0,ke)+xe+Ae+we.slice(ke+2)}}}),define(ge[133],pe([0,1,47,93,9]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const I=new RegExp(`\\$\\(${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(`(\\\\)?${I.source}`,"g");function P(m){return m.replace(C,(y,g)=>g?y:`\\${y}`)}e.escapeIcons=P;const S=new RegExp(`\\\\${I.source}`,"g");function i(m){return m.replace(S,y=>`\\${y}`)}e.markdownEscapeEscapedIcons=i;const T=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function k(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(T,(y,g,v,d)=>v?y:g||d||"")}e.stripIcons=k;function E(m){const y=m.indexOf(e.iconStartMarker);return y===-1?{text:m}:f(m,y)}e.parseLabelWithIcons=E;function f(m,y){const g=[];let v="";function d(c){if(c){v+=c;for(const b of c)g.push(t)}}let u=-1,o="",t=0,r,s,a=y;const n=m.length;for(d(m.substr(0,y));a<n;)r=m[a],s=m[a+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(u=a,d(o),o=e.iconStartMarker,a++):r===")"&&u!==-1?(t+=a-u+1,u=-1,o=""):u!==-1?/^[a-z0-9\-]$/i.test(r)?o+=r:(d(o),u=-1,o=""):d(r),a++;return d(o),{text:v,iconOffsets:g}}function l(m,y,g=!1){const{text:v,iconOffsets:d}=y;if(!d||d.length===0)return(0,D.matchesFuzzy)(m,v,g);const u=(0,R.ltrim)(v," "),o=v.length-u.length,t=(0,D.matchesFuzzy)(m,u,g);if(t)for(const r of t){const s=d[r.start+o]+o;r.start+=s,r.end+=s}return t}e.matchesFuzzyIconAware=l}),define(ge[94],pe([0,1,12,133,18]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(m="",y=!1){var g,v;if(this.value=m,typeof this.value!="string")throw(0,R.illegalArgument)("value");typeof y=="boolean"?(this.isTrusted=y,this.supportThemeIcons=!1):(this.isTrusted=(g=y.isTrusted)!==null&&g!==void 0?g:void 0,this.supportThemeIcons=(v=y.supportThemeIcons)!==null&&v!==void 0?v:!1)}appendText(m,y=0){return this.value+=k(this.supportThemeIcons?(0,D.escapeIcons)(m):m).replace(/([ \t]+)/g,(g,v)=>"&nbsp;".repeat(v.length)).replace(/^>/gm,"\\>").replace(/\n/g,y===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,y){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=y,this.value+="\n```\n",this}}e.MarkdownString=C;function P(l){return S(l)?!l.value:Array.isArray(l)?l.every(P):!0}e.isEmptyMarkdownString=P;function S(l){return l instanceof C?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=S;function i(l,m){return!l&&!m?!0:!l||!m?!1:Array.isArray(l)&&Array.isArray(m)?(0,p.equals)(l,m,T):S(l)&&S(m)?T(l,m):!1}e.markedStringsEquals=i;function T(l,m){return l===m?!0:!l||!m?!1:l.value===m.value&&l.isTrusted===m.isTrusted&&l.supportThemeIcons===m.supportThemeIcons}function k(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function E(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=E;function f(l){const m=[],y=l.split("|").map(v=>v.trim());l=y[0];const g=y[1];if(g){const v=/height=(\d+)/.exec(g),d=/width=(\d+)/.exec(g),u=v?v[1]:"",o=d?d[1]:"",t=isFinite(parseInt(o)),r=isFinite(parseInt(u));t&&m.push(`width="${o}"`),r&&m.push(`height="${u}"`)}return{href:l,dimensions:m}}e.parseHrefAndDimensions=f}),define(ge[57],pe([0,1,26,9,2]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function I(i){return JSON.stringify(i,P)}e.stringify=I;function C(i){let T=JSON.parse(i);return T=S(T),T}e.parse=C;function P(i,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,D.regExpFlags)(T)}:T}function S(i,T=0){if(!i||T>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return R.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof p.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let k=0;k<i.length;++k)i[k]=S(i[k],T+1);else for(const k in i)Object.hasOwnProperty.call(i,k)&&(i[k]=S(i[k],T+1))}return i}e.revive=S}),define(ge[11],pe([0,1,2,10]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.vscodeWebviewResource="vscode-webview-resource",P.extension="extension",P.vscodeFileResource="vscode-file"})(R=e.Schemas||(e.Schemas={}));class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,i,T){this._hosts[S]=i,this._ports[S]=T}setConnectionToken(S,i){this._connectionTokens[S]=i}rewrite(S){if(this._delegate)return this._delegate(S);const i=S.authority;let T=this._hosts[i];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const k=this._ports[i],E=this._connectionTokens[i];let f=`path=${encodeURIComponent(S.path)}`;return typeof E=="string"&&(f+=`&tkn=${encodeURIComponent(E)}`),p.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${T}:${k}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new I;class C{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,i,T){const k=this.toUri(S,i);return k.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(k):D.isNative&&(T||D.isPreferringBrowserCodeLoad)&&k.scheme===R.file?k.with({scheme:R.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(S,i){const T=this.toUri(S,i);return T.scheme===R.vscodeFileResource?T.with({scheme:R.file,authority:T.authority!==this.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(S,i){return p.URI.isUri(S)?S:p.URI.parse(i.toUrl(S))}}e.FileAccess=new C}),define(ge[75],pe([0,1,23]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const D=new p.LRUCache(1e4);function R(i){return S(i,"NFC",D)}e.normalizeNFC=R;const I=new p.LRUCache(1e4);function C(i){return S(i,"NFD",I)}e.normalizeNFD=C;const P=/[^\u0000-\u0080]/;function S(i,T,k){if(!e.canNormalize||!i)return i;const E=k.get(i);if(E)return E;let f;return P.test(i)?f=i.normalize(T):f=i,k.set(i,f),f}e.removeAccents=function(){if(e.canNormalize){const i=/[\u0300-\u036f]/g;return function(T){return C(T).replace(i,"")}}else return function(i){return i}}()}),define(ge[24],pe([0,1,30,7,2,9,11,10]),function(Z,e,p,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(f){return(0,R.uriToFsPath)(f,!0)}e.originalFSPath=S;class i{constructor(l){this._ignorePathCasing=l}compare(l,m,y=!1){return l===m?0:(0,I.compare)(this.getComparisonKey(l,y),this.getComparisonKey(m,y))}isEqual(l,m,y=!1){return l===m?!0:!l||!m?!1:this.getComparisonKey(l,y)===this.getComparisonKey(m,y)}getComparisonKey(l,m=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,m,y=!1){if(l.scheme===m.scheme){if(l.scheme===C.Schemas.file)return p.isEqualOrParent(S(l),S(m),this._ignorePathCasing(l))&&l.query===m.query&&(y||l.fragment===m.fragment);if((0,e.isEqualAuthority)(l.authority,m.authority))return p.isEqualOrParent(l.path,m.path,this._ignorePathCasing(l),"/")&&l.query===m.query&&(y||l.fragment===m.fragment)}return!1}joinPath(l,...m){return R.URI.joinPath(l,...m)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return D.posix.basename(l.path)}extname(l){return D.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let m;return l.scheme===C.Schemas.file?m=R.URI.file(D.dirname(S(l))).path:(m=D.posix.dirname(l.path),l.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),m="/")),l.with({path:m})}normalizePath(l){if(!l.path.length)return l;let m;return l.scheme===C.Schemas.file?m=R.URI.file(D.normalize(S(l))).path:m=D.posix.normalize(l.path),l.with({path:m})}relativePath(l,m){if(!(l.scheme!==m.scheme||!(0,e.isEqualAuthority)(l.authority,m.authority))){if(l.scheme===C.Schemas.file){const v=D.relative(S(l),S(m));return P.isWindows?p.toSlashes(v):v}let y=l.path||"/",g=m.path||"/";if(this._ignorePathCasing(l)){let v=0;for(const d=Math.min(y.length,g.length);v<d&&!(y.charCodeAt(v)!==g.charCodeAt(v)&&y.charAt(v).toLowerCase()!==g.charAt(v).toLowerCase());v++);y=g.substr(0,v)+y.substr(v)}return D.posix.relative(y,g)}}resolvePath(l,m){if(l.scheme===C.Schemas.file){const y=R.URI.file(D.resolve(S(l),m));return l.with({authority:y.authority,path:y.path})}return m.indexOf("/")===-1&&(m=p.toSlashes(m),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m)),l.with({path:D.posix.resolve(l.path,m)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,m){return l===m||(0,I.equalsIgnoreCase)(l,m)}hasTrailingPathSeparator(l,m=D.sep){if(l.scheme===C.Schemas.file){const y=S(l);return y.length>p.getRoot(y).length&&y[y.length-1]===m}else{const y=l.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,m=D.sep){return(0,e.hasTrailingPathSeparator)(l,m)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,m=D.sep){let y=!1;if(l.scheme===C.Schemas.file){const g=S(l);y=g!==void 0&&g.length===p.getRoot(g).length&&g[g.length-1]===m}else{m="/";const g=l.path;y=g.length===1&&g.charCodeAt(g.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(l,m)?l.with({path:l.path+"/"}):l}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(f=>f.scheme===C.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new i(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(f,l){const m=[];for(let y=0;y<f.length;y++){const g=l(f[y]);f.some((v,d)=>d===y?!1:(0,e.isEqualOrParent)(g,l(v)))||m.push(f[y])}return m}e.distinctParents=T;var k;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function l(m){const y=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(d=>{const[u,o]=d.split(":");u&&o&&y.set(u,o)});const v=m.path.substring(0,m.path.indexOf(";"));return v&&y.set(f.META_DATA_MIME,v),y}f.parseMetaData=l})(k=e.DataUri||(e.DataUri={}));function E(f,l,m){if(l){let y=f.path;return y&&y[0]!==D.posix.sep&&(y=D.posix.sep+y),f.with({scheme:m,authority:l,path:y})}return f.with({scheme:m})}e.toLocalResource=E}),define(ge[19],pe([0,1,21,18,3,6,56,24]),function(Z,e,p,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(F){return!!F&&typeof F.then=="function"}e.isThenable=S;function i(F){const N=new p.CancellationTokenSource,O=F(N.token),V=new Promise((q,Y)=>{N.token.onCancellationRequested(()=>{Y((0,D.canceled)())}),Promise.resolve(O).then(fe=>{N.dispose(),q(fe)},fe=>{N.dispose(),Y(fe)})});return new class{cancel(){N.cancel()}then(q,Y){return V.then(q,Y)}catch(q){return this.then(void 0,q)}finally(q){return V.finally(q)}}}e.createCancelablePromise=i;function T(F,N,O){return Promise.race([F,new Promise(V=>N.onCancellationRequested(()=>V(O)))])}e.raceCancellation=T;async function k(F){let N=-1;const O=F.map((q,Y)=>q.then(fe=>(N=Y,fe))),V=await Promise.race(O);return F.forEach((q,Y)=>{Y!==N&&q.cancel()}),V}e.raceCancellablePromises=k;function E(F,N,O){let V;const q=setTimeout(()=>{V==null||V(void 0),O==null||O()},N);return Promise.race([F.finally(()=>clearTimeout(q)),new Promise(Y=>V=Y)])}e.raceTimeout=E;function f(F){return new Promise((N,O)=>{const V=F();S(V)?V.then(N,O):N(V)})}e.asPromise=f;class l{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(O,O).then(V)})}return new Promise((O,V)=>{this.queuedPromise.then(O,V)})}return this.activePromise=N(),new Promise((O,V)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,V(q)})})}}e.Throttler=l;class m{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=m;class y{constructor(){this.promiseMap=new Map}queue(N,O){var V;const Y=((V=this.promiseMap.get(N))!==null&&V!==void 0?V:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(N)===Y&&this.promiseMap.delete(N)});return this.promiseMap.set(N,Y),Y}}e.SequencerByKey=y;class g{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,O=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,q)=>{this.doResolve=V,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,D.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=g;class v{constructor(N){this.delayer=new g(N),this.throttler=new l}trigger(N,O){return this.delayer.trigger(()=>this.throttler.queue(N),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class d{constructor(){this._isOpen=!1,this._promise=new Promise((N,O)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class u extends d{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function o(F,N){return N?new Promise((O,V)=>{const q=setTimeout(O,F);N.onCancellationRequested(()=>{clearTimeout(q),V((0,D.canceled)())})}):i(O=>o(F,O))}e.timeout=o;function t(F,N=0){const O=setTimeout(F,N);return(0,I.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function r(F){return F.then(void 0,N=>{})}e.ignoreErrors=r;function s(F){const N=[];let O=0;const V=F.length;function q(){return O<V?F[O++]():null}function Y(fe){fe!=null&&N.push(fe);const _e=q();return _e?_e.then(Y):Promise.resolve(N)}return Promise.resolve(null).then(Y)}e.sequence=s;function a(F,N=V=>!!V,O=null){let V=0;const q=F.length,Y=()=>{if(V>=q)return Promise.resolve(O);const fe=F[V++];return Promise.resolve(fe()).then(Le=>N(Le)?Promise.resolve(Le):Y())};return Y()}e.first=a;function n(F,N=V=>!!V,O=null){if(F.length===0)return Promise.resolve(O);let V=F.length;const q=()=>{var Y,fe;V=-1;for(const _e of F)(fe=(Y=_e).cancel)===null||fe===void 0||fe.call(Y)};return new Promise((Y,fe)=>{for(const _e of F)_e.then(Le=>{--V>=0&&N(Le)?(q(),Y(Le)):V===0&&Y(O)}).catch(Le=>{--V>=0&&(q(),fe(Le))})})}e.firstParallel=n;class c{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((O,V)=>{this.outstandingPromises.push({factory:N,c:O,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const O=N.factory();O.then(N.c,N.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class b extends c{constructor(){super(1)}}e.Queue=b;class w{constructor(){this.queues=new Map}queueFor(N,O=P.extUri){const V=O.getComparisonKey(N);let q=this.queues.get(V);return q||(q=new b,R.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(V)}),this.queues.set(V,q)),q}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=w;class h{constructor(N,O){this._token=-1,typeof N=="function"&&typeof O=="number"&&this.setIfNotSet(N,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},O)}setIfNotSet(N,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},O))}}e.TimeoutTimer=h;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setInterval(()=>{N()},O)}}e.IntervalTimer=_;class A{constructor(N,O){this.timeoutToken=-1,this.runner=N,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class L extends A{constructor(N,O){super(N,O);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const F=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const O=setTimeout(()=>N(F));let V=!1;return{dispose(){V||(V=!0,clearTimeout(O))}}}}else e.runWhenIdle=(F,N)=>{const O=requestIdleCallback(F,typeof N=="number"?{timeout:N}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(O))}}}}();class W{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=W;async function j(F,N,O){let V;for(let q=0;q<O;q++)try{return await F()}catch(Y){V=Y,await o(N)}throw V}e.retry=j;class K{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var N;(N=this._pending)===null||N===void 0||N.cancel()}setPending(N,O,V){return this._pending={taskId:N,cancel:()=>V==null?void 0:V(),promise:O},O.then(()=>this.donePending(N),()=>this.donePending(N)),O}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let O,V;const q=new Promise((Y,fe)=>{O=Y,V=fe});this._next={run:N,promise:q,promiseResolve:O,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=K;class H{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,O)=>{this.completeCallback=N,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(O=>{this.completeCallback(N),this.resolved=!0,O()})}error(N){return new Promise(O=>{this.errorCallback(N),this.rejected=!0,O()})}cancel(){new Promise(N=>{this.errorCallback((0,D.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=$;class M extends R.Emitter{async fireAsync(N,O,V){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,N]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[q,Y]=this._asyncDeliveryQueue.shift(),fe=[],_e=Object.assign(Object.assign({},Y),{waitUntil:Le=>{if(Object.isFrozen(fe))throw new Error("waitUntil can NOT be called asynchronous");V&&(Le=V(Le,typeof q=="function"?q:q[0])),fe.push(Le)}});try{typeof q=="function"?q.call(void 0,_e):q[0].call(q[1],_e)}catch(Le){(0,D.onUnexpectedError)(Le);continue}Object.freeze(fe),await U.settled(fe).catch(Le=>(0,D.onUnexpectedError)(Le))}}}}e.AsyncEmitter=M;var U;(function(F){async function N(Y){return typeof Promise.allSettled=="function"?O(Y):V(Y)}F.allSettled=N;async function O(Y){return Promise.allSettled(Y)}async function V(Y){return Promise.all(Y.map(fe=>fe.then(_e=>({status:"fulfilled",value:_e}),_e=>({status:"rejected",reason:_e}))))}async function q(Y){let fe;const _e=await Promise.all(Y.map(Le=>Le.then(Ie=>Ie,Ie=>{fe||(fe=Ie)})));if(typeof fe!="undefined")throw fe;return _e}F.settled=q})(U=e.Promises||(e.Promises={}))}),define(ge[95],pe([0,1,7,19]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const R=new D.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),I=new D.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new D.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(u,o,t=!1){const r=u||"",s=o||"",a=R.value.collator.compare(r,s);return R.value.collatorIsNumeric&&a===0&&r!==s?r<s?-1:1:a}e.compareFileNames=P;function S(u,o){const t=I.value.collator;return u=u||"",o=o||"",m(t,u,o)}e.compareFileNamesDefault=S;function i(u,o,t=!1){t||(u=u&&u.toLowerCase(),o=o&&o.toLowerCase());const[r,s]=f(u),[a,n]=f(o);return r!==a?r<a?-1:1:s===n?0:s<n?-1:1}e.noIntlCompareFileNames=i;function T(u,o){const[t,r]=f(u),[s,a]=f(o);let n=R.value.collator.compare(r,a);if(n===0){if(R.value.collatorIsNumeric&&r!==a)return r<a?-1:1;if(n=R.value.collator.compare(t,s),R.value.collatorIsNumeric&&n===0&&t!==s)return t<s?-1:1}return n}e.compareFileExtensions=T;function k(u,o){u=u||"",o=o||"";const t=l(u),r=l(o),s=I.value.collator,a=C.value.collator;let n;return n=m(a,t,r),n!==0?n:m(s,u,o)}e.compareFileExtensionsDefault=k;const E=/^(.*?)(\.([^.]*))?$/;function f(u,o=!1){const t=u?E.exec(u):[];let r=[t&&t[1]||"",t&&t[3]||""];return o&&(!r[0]&&r[1]||r[0]&&r[0].charAt(0)===".")&&(r=[r[0]+"."+r[1],""]),r}function l(u){const o=u?E.exec(u):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function m(u,o,t){let r=u.compare(o,t);return r!==0?r:o.length!==t.length?o.length<t.length?-1:1:0}function y(u,o,t=!1){return t||(u=u&&u.toLowerCase(),o=o&&o.toLowerCase()),u===o?0:u<o?-1:1}function g(u,o,t=!1){const r=u.split(p.sep),s=o.split(p.sep),a=r.length-1,n=s.length-1;let c,b;for(let w=0;;w++){if(c=a===w,b=n===w,c&&b)return P(r[w],s[w],t);if(c)return-1;if(b)return 1;const h=y(r[w],s[w],t);if(h!==0)return h}}e.comparePaths=g;function v(u,o,t){const r=u.toLowerCase(),s=o.toLowerCase(),a=d(u,o,t);if(a)return a;const n=r.endsWith(t),c=s.endsWith(t);if(n!==c)return n?-1:1;const b=P(r,s);return b!==0?b:r.localeCompare(s)}e.compareAnything=v;function d(u,o,t){const r=u.toLowerCase(),s=o.toLowerCase(),a=r.startsWith(t),n=s.startsWith(t);if(a!==n)return a?-1:1;if(a&&n){if(r.length<s.length)return-1;if(r.length>s.length)return 1}return 0}e.compareByPrefix=d}),define(ge[96],pe([0,1,95,93,7,10,9]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,S=[P,[]];function i(H,$,M,U){if(!H||!$)return S;const F=H.length,N=$.length;if(F<N)return S;const O=H.toLowerCase();return!U&&!O.includes(M)?S:T($,M,N,H,O,F)}e.scoreFuzzy=i;function T(H,$,M,U,F,N){const O=[],V=[];for(let _e=0;_e<M;_e++){const Le=_e*N,Ie=Le-N,Fe=_e>0,z=H[_e],Q=$[_e];for(let te=0;te<N;te++){const ae=te>0,ve=Le+te,De=ve-1,Me=Ie+te-1,we=ae?O[De]:0,ke=Fe&&ae?O[Me]:0,Ae=Fe&&ae?V[Me]:0;let xe;!ke&&Fe?xe=0:xe=k(z,Q,U,F,te,Ae),xe&&ke+xe>=we?(V[ve]=Ae+1,O[ve]=ke+xe):(V[ve]=P,O[ve]=we)}}const q=[];let Y=M-1,fe=N-1;for(;Y>=0&&fe>=0;){const _e=Y*N+fe;V[_e]===P||(q.push(fe),Y--),fe--}return[O[M*N-1],q.reverse()]}function k(H,$,M,U,F,N){let O=0;if(!E($,U[F]))return O;if(O+=1,N>0&&(O+=N*5),H===M[F]&&(O+=1),F===0)O+=8;else{const V=f(M.charCodeAt(F-1));V?O+=V:(0,D.isUpper)(M.charCodeAt(F))&&(O+=2)}return O}function E(H,$){return H===$?!0:H==="/"||H==="\\"?$==="/"||$==="\\":!1}function f(H){switch(H){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function m(H,$,M=0,U=0){const F=$;return F.values&&F.values.length>1?y(H,F.values,M,U):g(H,$,M,U)}e.scoreFuzzy2=m;function y(H,$,M,U){let F=0;const N=[];for(const O of $){const[V,q]=g(H,O,M,U);if(typeof V!="number")return l;F+=V,N.push(...q)}return[F,c(N)]}function g(H,$,M,U){const F=(0,D.fuzzyScore)($.original,$.originalLowercase,M,H,H.toLowerCase(),U,!0);return F?[F[0],(0,D.createMatches)(F)]:l}const v=Object.freeze({score:0}),d=1<<18,u=1<<17,o=1<<16;function t(H,$,M,U,F){if(!H||!$.normalized)return v;const N=U.getItemLabel(H);if(!N)return v;const O=U.getItemDescription(H);let V;O?V=`${N}${O}${$.normalized}${Array.isArray($.values)?$.values.length:""}${M}`:V=`${N}${$.normalized}${Array.isArray($.values)?$.values.length:""}${M}`;const q=F[V];if(q)return q;const Y=r(N,O,U.getItemPath(H),$,M);return F[V]=Y,Y}e.scoreItemFuzzy=t;function r(H,$,M,U,F){const N=!M||!U.containsPathSeparator;return M&&(I.isLinux?U.pathNormalized===M:(0,C.equalsIgnoreCase)(U.pathNormalized,M))?{score:d,labelMatch:[{start:0,end:H.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:U.values&&U.values.length>1?s(H,$,M,U.values,N,F):a(H,$,M,U,N,F)}function s(H,$,M,U,F,N){let O=0;const V=[],q=[];for(const Y of U){const{score:fe,labelMatch:_e,descriptionMatch:Le}=a(H,$,M,Y,F,N);if(fe===P)return v;O+=fe,_e&&V.push(..._e),Le&&q.push(...Le)}return{score:O,labelMatch:c(V),descriptionMatch:c(q)}}function a(H,$,M,U,F,N){if(F||!$){const[O,V]=i(H,U.normalized,U.normalizedLowercase,N);if(O){const q=(0,D.matchesPrefix)(U.normalized,H);let Y;return q?(Y=u,Y+=Math.round(U.normalized.length/H.length*100)):Y=o,{score:Y+O,labelMatch:q||n(V)}}}if($){let O=$;M&&(O=`${$}${R.sep}`);const V=O.length,q=`${O}${H}`,[Y,fe]=i(q,U.normalized,U.normalizedLowercase,N);if(Y){const _e=n(fe),Le=[],Ie=[];return _e.forEach(Fe=>{Fe.start<V&&Fe.end>V?(Le.push({start:0,end:Fe.end-V}),Ie.push({start:Fe.start,end:V})):Fe.start>=V?Le.push({start:Fe.start-V,end:Fe.end-V}):Ie.push(Fe)}),{score:Y,labelMatch:Le,descriptionMatch:Ie}}}return v}function n(H){const $=[];if(!H)return $;let M;for(const U of H)M&&M.end===U?M.end+=1:(M={start:U,end:U+1},$.push(M));return $}function c(H){const $=H.sort((F,N)=>F.start-N.start),M=[];let U;for(const F of $)!U||!b(U,F)?(U=F,M.push(F)):(U.start=Math.min(U.start,F.start),U.end=Math.max(U.end,F.end));return M}function b(H,$){return!(H.end<$.start||$.end<H.start)}function w(H,$,M,U,F,N){const O=t(H,M,U,F,N),V=t($,M,U,F,N),q=O.score,Y=V.score;if((q===d||Y===d)&&q!==Y)return q===d?-1:1;if(q>o||Y>o){if(q!==Y)return q>Y?-1:1;if(q<u&&Y<u){const Q=_(O.labelMatch,V.labelMatch);if(Q!==0)return Q}const Fe=F.getItemLabel(H)||"",z=F.getItemLabel($)||"";if(Fe.length!==z.length)return Fe.length-z.length}if(q!==Y)return q>Y?-1:1;const fe=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,_e=Array.isArray(V.labelMatch)&&V.labelMatch.length>0;if(fe&&!_e)return-1;if(_e&&!fe)return 1;const Le=h(H,O,F),Ie=h($,V,F);return Le&&Ie&&Le!==Ie?Ie>Le?-1:1:A(H,$,M,F)}e.compareItemsByFuzzyScore=w;function h(H,$,M){let U=-1,F=-1;if($.descriptionMatch&&$.descriptionMatch.length?U=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(U=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(F=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const N=M.getItemDescription(H);N&&(F+=N.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(F=$.descriptionMatch[$.descriptionMatch.length-1].end);return F-U}function _(H,$){if(!H&&!$||(!H||!H.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!H||!H.length)return 1;const M=H[0].start,F=H[H.length-1].end-M,N=$[0].start,V=$[$.length-1].end-N;return F===V?0:V<F?1:-1}function A(H,$,M,U){const F=U.getItemLabel(H)||"",N=U.getItemLabel($)||"",O=U.getItemDescription(H),V=U.getItemDescription($),q=F.length+(O?O.length:0),Y=N.length+(V?V.length:0);if(q!==Y)return q-Y;const fe=U.getItemPath(H),_e=U.getItemPath($);return fe&&_e&&fe.length!==_e.length?fe.length-_e.length:F!==N?(0,p.compareAnything)(F,N,M.normalized):O&&V&&O!==V?(0,p.compareAnything)(O,V,M.normalized):fe&&_e&&fe!==_e?(0,p.compareAnything)(fe,_e,M.normalized):0}const L=" ";function W(H){typeof H!="string"&&(H="");const $=H.toLowerCase(),{pathNormalized:M,normalized:U,normalizedLowercase:F}=j(H),N=M.indexOf(R.sep)>=0;let O;const V=H.split(L);if(V.length>1)for(const q of V){const{pathNormalized:Y,normalized:fe,normalizedLowercase:_e}=j(q);fe&&(O||(O=[]),O.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:Y,normalized:fe,normalizedLowercase:_e}))}return{original:H,originalLowercase:$,pathNormalized:M,normalized:U,normalizedLowercase:F,values:O,containsPathSeparator:N}}e.prepareQuery=W;function j(H){let $;I.isWindows?$=H.replace(/\//g,R.sep):$=H.replace(/\\/g,R.sep);const M=(0,C.stripWildcards)($).replace(/\s/g,"");return{pathNormalized:$,normalized:M,normalizedLowercase:M.toLowerCase()}}function K(H){return Array.isArray(H)?W(H.map($=>$.original).join(L)):W(H.original)}e.pieceToQuery=K}),define(ge[33],pe([0,1,9,30,7,23,19]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const S="**",i="/",T="[/\\\\]",k="[^/\\\\]",E=/\//g;function f(O){switch(O){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}|${T}${k}+)*?`}}function l(O,V){if(!O)return[];const q=[];let Y=!1,fe=!1,_e="";for(const Le of O){switch(Le){case V:if(!Y&&!fe){q.push(_e),_e="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}_e+=Le}return _e&&q.push(_e),q}e.splitGlobAware=l;function m(O){if(!O)return"";let V="";const q=l(O,i);if(q.every(Y=>Y===S))V=".*";else{let Y=!1;q.forEach((fe,_e)=>{if(fe===S){Y||(V+=f(2),Y=!0);return}let Le=!1,Ie="",Fe=!1,z="";for(const Q of fe){if(Q!=="}"&&Le){Ie+=Q;continue}if(Fe&&(Q!=="]"||!z)){let te;Q==="-"?te=Q:(Q==="^"||Q==="!")&&!z?te="^":Q===i?te="":te=p.escapeRegExpCharacters(Q),z+=te;continue}switch(Q){case"{":Le=!0;continue;case"[":Fe=!0;continue;case"}":V+=`(?:${l(Ie,",").map(ve=>m(ve)).join("|")})`,Le=!1,Ie="";break;case"]":V+="["+z+"]",Fe=!1,z="";break;case"?":V+=k;continue;case"*":V+=f(1);continue;default:V+=p.escapeRegExpCharacters(Q)}}_e<q.length-1&&(q[_e+1]!==S||_e+2<q.length)&&(V+=T),Y=!1})}return V}const y=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),r=function(){return!1},s=function(){return null};function a(O,V){if(!O)return s;let q;typeof O!="string"?q=O.pattern:q=O,q=q.trim();const Y=`${q}_${!!V.trimForExclusions}`;let fe=t.get(Y);if(fe)return n(fe,O);let _e;if(y.test(q)){const Le=q.substr(4);fe=function(Ie,Fe){return typeof Ie=="string"&&Ie.endsWith(Le)?q:null}}else(_e=g.exec(c(q,V)))?fe=b(_e[1],q):(V.trimForExclusions?d:v).test(q)?fe=w(q,V):(_e=u.exec(c(q,V)))?fe=h(_e[1].substr(1),q,!0):(_e=o.exec(c(q,V)))?fe=h(_e[1],q,!1):fe=_(q);return t.set(Y,fe),n(fe,O)}function n(O,V){return typeof V=="string"?O:function(q,Y){return D.isEqualOrParent(q,V.base)?O(R.relative(V.base,q),Y):null}}function c(O,V){return V.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function b(O,V){const q=`/${O}`,Y=`\\${O}`,fe=function(Le,Ie){return typeof Le!="string"?null:Ie?Ie===O?V:null:Le===O||Le.endsWith(q)||Le.endsWith(Y)?V:null},_e=[O];return fe.basenames=_e,fe.patterns=[V],fe.allBasenames=_e,fe}function w(O,V){const q=N(O.slice(1,-1).split(",").map(Ie=>a(Ie,V)).filter(Ie=>Ie!==s),O),Y=q.length;if(!Y)return s;if(Y===1)return q[0];const fe=function(Ie,Fe){for(let z=0,Q=q.length;z<Q;z++)if(q[z](Ie,Fe))return O;return null},_e=q.find(Ie=>!!Ie.allBasenames);_e&&(fe.allBasenames=_e.allBasenames);const Le=q.reduce((Ie,Fe)=>Fe.allPaths?Ie.concat(Fe.allPaths):Ie,[]);return Le.length&&(fe.allPaths=Le),fe}function h(O,V,q){const Y=R.sep===R.posix.sep,fe=Y?O:O.replace(E,R.sep),_e=R.sep+fe,Le=R.posix.sep+O,Ie=q?function(Fe,z){return typeof Fe=="string"&&(Fe===fe||Fe.endsWith(_e)||!Y&&(Fe===O||Fe.endsWith(Le)))?V:null}:function(Fe,z){return typeof Fe=="string"&&(Fe===fe||!Y&&Fe===O)?V:null};return Ie.allPaths=[(q?"*/":"./")+O],Ie}function _(O){try{const V=new RegExp(`^${m(O)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?O:null}}catch(V){return s}}function A(O,V,q){return!O||typeof V!="string"?!1:L(O)(V,void 0,q)}e.match=A;function L(O,V={}){if(!O)return r;if(typeof O=="string"||H(O)){const q=a(O,V);if(q===s)return r;const Y=function(fe,_e){return!!q(fe,_e)};return q.allBasenames&&(Y.allBasenames=q.allBasenames),q.allPaths&&(Y.allPaths=q.allPaths),Y}return U(O,V)}e.parse=L;function W(O){if(!!O){let V;return q=>(V||(V=(O()||Promise.resolve([])).then(Y=>Y?K(Y):{})),V.then(Y=>!!Y[q]))}}e.hasSiblingPromiseFn=W;function j(O){if(!!O){let V;return q=>{if(!V){const Y=O();V=Y?K(Y):{}}return!!V[q]}}}e.hasSiblingFn=j;function K(O){const V={};for(const q of O)V[q]=!0;return V}function H(O){const V=O;return V&&typeof V.base=="string"&&typeof V.pattern=="string"}e.isRelativePattern=H;function $(O){return O.allBasenames||[]}e.getBasenameTerms=$;function M(O){return O.allPaths||[]}e.getPathTerms=M;function U(O,V){const q=N(Object.getOwnPropertyNames(O).map(Ie=>F(Ie,O[Ie],V)).filter(Ie=>Ie!==s)),Y=q.length;if(!Y)return s;if(!q.some(Ie=>!!Ie.requiresSiblings)){if(Y===1)return q[0];const Ie=function(Q,te){for(let ae=0,ve=q.length;ae<ve;ae++){const De=q[ae](Q,te);if(De)return De}return null},Fe=q.find(Q=>!!Q.allBasenames);Fe&&(Ie.allBasenames=Fe.allBasenames);const z=q.reduce((Q,te)=>te.allPaths?Q.concat(te.allPaths):Q,[]);return z.length&&(Ie.allPaths=z),Ie}const fe=function(Ie,Fe,z){let Q;for(let te=0,ae=q.length;te<ae;te++){const ve=q[te];ve.requiresSiblings&&z&&(Fe||(Fe=R.basename(Ie)),Q||(Q=Fe.substr(0,Fe.length-R.extname(Ie).length)));const De=ve(Ie,Fe,Q,z);if(De)return De}return null},_e=q.find(Ie=>!!Ie.allBasenames);_e&&(fe.allBasenames=_e.allBasenames);const Le=q.reduce((Ie,Fe)=>Fe.allPaths?Ie.concat(Fe.allPaths):Ie,[]);return Le.length&&(fe.allPaths=Le),fe}function F(O,V,q){if(V===!1)return s;const Y=a(O,q);if(Y===s)return s;if(typeof V=="boolean")return Y;if(V){const fe=V.when;if(typeof fe=="string"){const _e=(Le,Ie,Fe,z)=>{if(!z||!Y(Le,Ie))return null;const Q=fe.replace("$(basename)",Fe),te=z(Q);return(0,C.isThenable)(te)?te.then(ae=>ae?O:null):te?O:null};return _e.requiresSiblings=!0,_e}}return Y}function N(O,V){const q=O.filter(Ie=>!!Ie.basenames);if(q.length<2)return O;const Y=q.reduce((Ie,Fe)=>{const z=Fe.basenames;return z?Ie.concat(z):Ie},[]);let fe;if(V){fe=[];for(let Ie=0,Fe=Y.length;Ie<Fe;Ie++)fe.push(V)}else fe=q.reduce((Ie,Fe)=>{const z=Fe.patterns;return z?Ie.concat(z):Ie},[]);const _e=function(Ie,Fe){if(typeof Ie!="string")return null;if(!Fe){let Q;for(Q=Ie.length;Q>0;Q--){const te=Ie.charCodeAt(Q-1);if(te===47||te===92)break}Fe=Ie.substr(Q)}const z=Y.indexOf(Fe);return z!==-1?fe[z]:null};_e.basenames=Y,_e.patterns=fe,_e.allBasenames=Y;const Le=O.filter(Ie=>!Ie.basenames);return Le.push(_e),Le}}),define(ge[76],pe([0,1,2,7,9,11,10,24,30]),function(Z,e,p,D,R,I,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function i(a,n,c){if(typeof a=="string"&&(a=p.URI.file(a)),c){const w=c.getWorkspaceFolder(a);if(w){const h=c.getWorkspace().folders.length>1;let _;if((0,P.isEqual)(w.uri,a)?_="":_=(0,P.relativePath)(w.uri,a),h){const A=w.name?w.name:(0,P.basename)(w.uri);_=_?A+" \u2022 "+_:A}return _}}if(a.scheme!==I.Schemas.file&&a.scheme!==I.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,S.hasDriveLetter)(a.fsPath))return(0,D.normalize)(k(a.fsPath));let b=(0,D.normalize)(a.fsPath);return!C.isWindows&&(n==null?void 0:n.userHome)&&(b=f(b,n.userHome.fsPath)),b}e.getPathLabel=i;function T(a){if(!!a){typeof a=="string"&&(a=p.URI.file(a));const n=(0,P.basename)(a)||(a.scheme===I.Schemas.file?a.fsPath:a.path);return C.isWindows&&(0,S.isRootOrDriveLetter)(n)?k(n):n}}e.getBaseLabel=T;function k(a){return(0,S.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=k;let E=Object.create(null);function f(a,n){if(C.isWindows||!a||!n)return a;let c=E.original===n?E.normalized:void 0;return c||(c=`${(0,R.rtrim)(n,D.posix.sep)}${D.posix.sep}`,E={original:n,normalized:c}),(C.isLinux?a.startsWith(c):(0,R.startsWithIgnoreCase)(a,c))&&(a=`~/${a.substr(c.length)}`),a}e.tildify=f;function l(a,n){return a.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=l;const m="\u2026",y="\\\\",g="~";function v(a,n=D.sep){const c=new Array(a.length);let b=!1;for(let w=0;w<a.length;w++){let h=a[w];if(h===""){c[w]=`.${n}`;continue}if(!h){c[w]=h;continue}b=!0;let _="";h.indexOf(y)===0?(_=h.substr(0,h.indexOf(y)+y.length),h=h.substr(h.indexOf(y)+y.length)):h.indexOf(n)===0?(_=h.substr(0,h.indexOf(n)+n.length),h=h.substr(h.indexOf(n)+n.length)):h.indexOf(g)===0&&(_=h.substr(0,h.indexOf(g)+g.length),h=h.substr(h.indexOf(g)+g.length));const A=h.split(n);for(let L=1;b&&L<=A.length;L++)for(let W=A.length-L;b&&W>=0;W--){b=!1;let j=A.slice(W,W+L).join(n);for(let K=0;!b&&K<a.length;K++)if(K!==w&&a[K]&&a[K].indexOf(j)>-1){const H=W+L===A.length,$=W>0&&a[K].indexOf(n)>-1?n+j:j,M=a[K].endsWith($);b=!H||M}if(!b){let K="";(A[0].endsWith(":")||_!=="")&&(W===1&&(W=0,L++,j=A[0]+n+j),W>0&&(K=A[0]+n),K=_+K),W>0&&(K=K+m+n),K=K+j,W+L<A.length&&(K=K+n+m),c[w]=K}}b&&(c[w]=h)}return c}e.shorten=v;var d;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function u(a,n=Object.create(null)){const c=[];let b=!1,w="";for(const h of a)if(h==="$"||b&&h==="{")w&&c.push({value:w,type:d.TEXT}),w="",b=!0;else if(h==="}"&&b){const _=n[w];if(typeof _=="string")_.length&&c.push({value:_,type:d.VARIABLE});else if(_){const A=c[c.length-1];(!A||A.type!==d.SEPARATOR)&&c.push({value:_.label,type:d.SEPARATOR})}w="",b=!1}else w+=h;return w&&!b&&c.push({value:w,type:d.TEXT}),c.filter((h,_)=>{if(h.type===d.SEPARATOR){const A=c[_-1],L=c[_+1];return[A,L].every(W=>W&&(W.type===d.VARIABLE||W.type===d.TEXT)&&W.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=u;function o(a,n){return C.isMacintosh||n?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):a.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=o;function t(a,n){return C.isMacintosh||n?a.replace(/\(&&\w\)|&&/g,""):C.isWindows?a.replace(/&&|&/g,c=>c==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(a){const n=a.indexOf("/")!==-1?D.posix:D.win32,c=n.basename(a),b=n.dirname(a);return c.length?{name:c,parentPath:b}:{name:b,parentPath:""}}e.splitName=s}),define(ge[97],pe([0,1,2]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(T){return T.toJSON()}class R{constructor(k){this._uriTransformer=k}transformIncoming(k){const E=this._uriTransformer.transformIncoming(k);return E===k?k:D(p.URI.from(E))}transformOutgoing(k){const E=this._uriTransformer.transformOutgoing(k);return E===k?k:D(p.URI.from(E))}transformOutgoingURI(k){const E=this._uriTransformer.transformOutgoing(k);return E===k?k:p.URI.from(E)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function I(T,k,E){if(!T||E>200)return null;if(typeof T=="object"){if(T instanceof p.URI)return k.transformOutgoing(T);for(let f in T)if(Object.hasOwnProperty.call(T,f)){const l=I(T[f],k,E+1);l!==null&&(T[f]=l)}}return null}function C(T,k){const E=I(T,k,0);return E===null?T:E}e.transformOutgoingURIs=C;function P(T,k,E,f){if(!T||f>200)return null;if(typeof T=="object"){if(T.$mid===1)return E?p.URI.revive(k.transformIncoming(T)):k.transformIncoming(T);for(let l in T)if(Object.hasOwnProperty.call(T,l)){const m=P(T[l],k,E,f+1);m!==null&&(T[l]=m)}}return null}function S(T,k){const E=P(T,k,!1,0);return E===null?T:E}e.transformIncomingURIs=S;function i(T,k){const E=P(T,k,!0,0);return E===null?T:E}e.transformAndReviveIncomingURIs=i}),define(ge[28],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(S){return p.test(S)}e.isUUID=D;const R=new Uint8Array(16),I=[];for(let S=0;S<256;S++)I.push(S.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(S){for(let i=0;i<S.length;i++)S[i]=Math.floor(Math.random()*256);return S};function P(){C(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let S=0,i="";return i+=I[R[S++]],i+=I[R[S++]],i+=I[R[S++]],i+=I[R[S++]],i+="-",i+=I[R[S++]],i+=I[R[S++]],i+="-",i+=I[R[S++]],i+=I[R[S++]],i+="-",i+=I[R[S++]],i+=I[R[S++]],i+="-",i+=I[R[S++]],i+=I[R[S++]],i+=I[R[S++]],i+=I[R[S++]],i+=I[R[S++]],i+=I[R[S++]],i}e.generateUuid=P}),define(ge[134],pe([0,1,98]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class D{constructor(I="utf8"){this.stringDecoder=new p.StringDecoder(I),this.remaining=null}write(I){const C=[],P=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(P.length<1)return C;let S=0,i,T=S;for(;T<P.length;)if(i=P.charCodeAt(T),i===13||i===10){if(C.push(P.substring(S,T)),T++,T<P.length){const k=i;i=P.charCodeAt(T),(k===13&&i===10||k===10&&i===13)&&T++}S=T}else T++;return this.remaining=S<P.length?P.substr(S):null,C}end(){return this.remaining}}e.LineDecoder=D}),define(ge[25],pe([0,1,37,48,7,19,10,30,28,75,24,2]),function(Z,e,p,D,R,I,C,P,S,i,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var E;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function f($,M=E.UNLINK){if((0,P.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return M===E.UNLINK?m($):l($)}e.rimraf=f;async function l($){try{const M=(0,R.join)((0,D.tmpdir)(),(0,S.generateUuid)());try{await p.promises.rename($,M)}catch(U){return m($)}m(M).catch(U=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function m($){return p.promises.rmdir($,{recursive:!0,maxRetries:3})}function y($){if((0,P.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync($,{recursive:!0})}e.rimrafSync=y;async function g($,M){return u(await(M?v($):p.promises.readdir($)))}e.readdir=g;async function v($){try{return await p.promises.readdir($,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const M=[],U=await g($);for(const F of U){let N=!1,O=!1,V=!1;try{const q=await p.promises.lstat((0,R.join)($,F));N=q.isFile(),O=q.isDirectory(),V=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}M.push({name:F,isFile:()=>N,isDirectory:()=>O,isSymbolicLink:()=>V})}return M}function d($){return u(p.readdirSync($))}e.readdirSync=d;function u($){return $.map(M=>typeof M=="string"?C.isMacintosh?(0,i.normalizeNFC)(M):M:(M.name=C.isMacintosh?(0,i.normalizeNFC)(M.name):M.name,M))}async function o($){const M=await g($),U=[];for(const F of M)await r.existsDirectory((0,R.join)($,F))&&U.push(F);return U}e.readDirsInDir=o;function t($,M=1e3){return new Promise(U=>{let F=!1;const N=setInterval(()=>{F||(F=!0,p.access($,O=>{F=!1,O&&(clearInterval(N),U(void 0))}))},M)})}e.whenDeleted=t;var r;(function($){async function M(N){let O;try{if(O=await p.promises.lstat(N),!O.isSymbolicLink())return{stat:O}}catch(V){}try{return{stat:await p.promises.stat(N),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(C.isWindows&&V.code==="EACCES")try{return{stat:await p.promises.stat(await p.promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw q}throw V}}$.stat=M;async function U(N){try{const{stat:O,symbolicLink:V}=await $.stat(N);return O.isFile()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}$.existsFile=U;async function F(N){try{const{stat:O,symbolicLink:V}=await $.stat(N);return O.isDirectory()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}$.existsDirectory=F})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new I.ResourceQueue;function a($,M,U){return s.queueFor(k.URI.file($),T.extUriBiasedIgnorePathCase).queue(()=>{const F=w(U);return new Promise((N,O)=>c($,M,F,V=>V?O(V):N()))})}e.writeFile=a;let n=!0;function c($,M,U,F){if(!n)return p.writeFile($,M,{mode:U.mode,flag:U.flag},F);p.open($,U.flag,U.mode,(N,O)=>{if(N)return F(N);p.writeFile(O,M,V=>{if(V)return p.close(O,()=>F(V));p.fdatasync(O,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),n=!1),p.close(O,Y=>F(Y))))})})}function b($,M,U){const F=w(U);if(!n)return p.writeFileSync($,M,{mode:F.mode,flag:F.flag});const N=p.openSync($,F.flag,F.mode);try{p.writeFileSync(N,M);try{p.fdatasyncSync(N)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),n=!1}}finally{p.closeSync(N)}}e.writeFileSync=b;function w($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function h($,M){if($!==M){async function U(F){try{const N=await p.promises.lstat(F);if(N.isDirectory()||N.isSymbolicLink())return;const O=await p.promises.open(F,"a");try{await O.utimes(N.atime,new Date)}finally{await O.close()}}catch(N){}}try{await p.promises.rename($,M),await U(M)}catch(F){if($.toLowerCase()!==M.toLowerCase()&&F.code==="EXDEV"||$.endsWith("."))await _($,M,{preserveSymlinks:!1}),await f($,E.MOVE),await U(M);else throw F}}}e.move=h;async function _($,M,U){return L($,M,{root:{source:$,target:M},options:U,handledSourcePaths:new Set})}e.copy=_;const A=511;async function L($,M,U){if(!U.handledSourcePaths.has($)){U.handledSourcePaths.add($);const{stat:F,symbolicLink:N}=await r.stat($);if(N){if(U.options.preserveSymlinks)try{return await K($,M,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(N.dangling)return}return F.isDirectory()?W($,M,F.mode&A,U):j($,M,F.mode&A)}}async function W($,M,U,F){await p.promises.mkdir(M,{recursive:!0,mode:U});const N=await g($);for(const O of N)await L((0,R.join)($,O),(0,R.join)(M,O),F)}async function j($,M,U){await p.promises.copyFile($,M),await p.promises.chmod(M,U)}async function K($,M,U){let F=await p.promises.readlink($);(0,P.isEqualOrParent)(F,U.root.source,!C.isLinux)&&(F=(0,R.join)(U.root.target,F.substr(U.root.source.length+1))),await p.promises.symlink(F,M)}async function H($){try{return await p.promises.access($),!0}catch(M){return!1}}e.exists=H}),define(ge[135],pe([0,1,37,9,7,25]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function C(T){const k=(0,R.dirname)(T);if(T===k)return T;const E=((0,R.basename)(T)||T).toLowerCase();try{const l=(0,I.readdirSync)(k).filter(m=>m.toLowerCase()===E);if(l.length===1){const m=C(k);if(m)return(0,R.join)(m,l[0])}else if(l.length>1){const m=l.indexOf(E);if(m>=0){const y=C(k);if(y)return(0,R.join)(y,l[m])}}}catch(f){}return null}e.realcaseSync=C;async function P(T){try{return await p.promises.realpath(T)}catch(k){const E=i(T);return await p.promises.access(E,p.constants.R_OK),E}}e.realpath=P;function S(T){try{return p.realpathSync(T)}catch(k){const E=i(T);return p.accessSync(E,p.constants.R_OK),E}}e.realpathSync=S;function i(T){return(0,D.rtrim)((0,R.normalize)(T),R.sep)}});var vt=this&&this.__await||function(Z){return this instanceof vt?(this.v=Z,this):new vt(Z)},In=this&&this.__asyncGenerator||function(Z,e,p){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var D=p.apply(Z,e||[]),R,I=[];return R={},C("next"),C("throw"),C("return"),R[Symbol.asyncIterator]=function(){return this},R;function C(E){D[E]&&(R[E]=function(f){return new Promise(function(l,m){I.push([E,f,l,m])>1||P(E,f)})})}function P(E,f){try{S(D[E](f))}catch(l){k(I[0][3],l)}}function S(E){E.value instanceof vt?Promise.resolve(E.value.v).then(i,T):k(I[0][2],E)}function i(E){P("next",E)}function T(E){P("throw",E)}function k(E,f){E(f),I.shift(),I.length&&P(I[0][0],I[0][1])}},en=this&&this.__asyncValues||function(Z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Z[Symbol.asyncIterator],p;return e?e.call(Z):(Z=typeof __values=="function"?__values(Z):Z[Symbol.iterator](),p={},D("next"),D("throw"),D("return"),p[Symbol.asyncIterator]=function(){return this},p);function D(I){p[I]=Z[I]&&function(C){return new Promise(function(P,S){C=Z[I](C),R(P,S,C.done,C.value)})}}function R(I,C,P,S){Promise.resolve(S).then(function(i){I({value:i,done:P})},C)}};define(ge[99],pe([0,1,25,48,7,36]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,P=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var i;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(i||(i={}));let T;switch(process.arch){case"ia32":case"x32":T=1;break;case"arm":case"arm64":T=2;break;default:T=0;break}let k;process.env.PROCESSOR_ARCHITEW6432?k=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?k=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?k=1:k=0;class E{constructor(t,r,s){this.exePath=t,this.displayName=r,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await p.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:o=!1}={}){return o?T===0?I.env["ProgramFiles(x86)"]||null:k===0&&I.env.ProgramW6432||null:I.env.ProgramFiles||null}async function l({useAlternateBitness:o=!1,findPreview:t=!1}={}){const r=f({useAlternateBitness:o});if(!r)return null;const s=R.join(r,"PowerShell");if(!await p.SymlinkSupport.existsDirectory(s))return null;let a=-1,n=null;for(const w of await p.readdir(s)){let h=-1;if(t){const A=w.indexOf("-");if(A<0)continue;const L=w.substring(0,A);if(!C.test(L)||w.substring(A+1)!=="preview")continue;h=parseInt(L,10)}else{if(!C.test(w))continue;h=parseInt(w,10)}if(!(h<=a)){const _=R.join(s,w,"pwsh.exe");!await p.SymlinkSupport.existsFile(_)||(n=_,a=h)}}if(!n)return null;const c=r.includes("x86")?" (x86)":"",b=t?" Preview":"";return new E(n,`PowerShell${b}${c}`,!0)}async function m({findPreview:o}={}){if(!I.env.LOCALAPPDATA)return null;const t=R.join(I.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await p.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:r,pwshMsixName:s}=o?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const a of await p.readdir(t))if(r.test(a)){const n=R.join(t,a,"pwsh.exe");return new E(n,s)}return null}function y(){const o=R.join(D.homedir(),".dotnet","tools","pwsh.exe");return new E(o,".NET Core PowerShell Global Tool")}function g(){const o=R.join(I.env.windir,T===1&&k!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(o,"Windows PowerShell",!0)}function v(){return In(this,arguments,function*(){let t=yield vt(l());t&&(yield yield vt(t)),t=yield vt(l({useAlternateBitness:!0})),t&&(yield yield vt(t)),t=yield vt(m()),t&&(yield yield vt(t)),t=y(),t&&(yield yield vt(t)),t=yield vt(l({findPreview:!0})),t&&(yield yield vt(t)),t=yield vt(m({findPreview:!0})),t&&(yield yield vt(t)),t=yield vt(l({useAlternateBitness:!0,findPreview:!0})),t&&(yield yield vt(t)),t=g(),t&&(yield yield vt(t))})}function d(){return In(this,arguments,function*(){var t,r;try{for(var s=en(v()),a;a=yield vt(s.next()),!a.done;){const n=a.value;(yield vt(n.exists()))&&(yield yield vt(n))}}catch(n){t={error:n}}finally{try{a&&!a.done&&(r=s.return)&&(yield vt(r.call(s)))}finally{if(t)throw t.error}}})}e.enumeratePowerShellInstallations=d;async function u(){var o,t;try{for(var r=en(d()),s;s=await r.next(),!s.done;)return s.value}catch(a){o={error:a}}finally{try{s&&!s.done&&(t=r.return)&&await t.call(r)}finally{if(o)throw o.error}}return null}e.getFirstAvailablePowerShellInstallation=u}),define(ge[100],pe([0,1,3,6,19,21,18,26,12,15,57,9]),function(Z,e,p,D,R,I,C,P,S,i,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function f(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(l=e.ResponseType||(e.ResponseType={}));function m(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(y||(y={}));class g{constructor(N){this.buffer=N,this.pos=0}read(N){const O=this.buffer.slice(this.pos,this.pos+N);return this.pos+=O.byteLength,O}}class v{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var d;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(d||(d={}));function u(F){const N=P.VSBuffer.alloc(4);return N.writeUInt32BE(F,0),N}function o(F){return F.read(4).readUInt32BE(0)}function t(F){const N=P.VSBuffer.alloc(1);return N.writeUInt8(F,0),N}const r={Undefined:t(d.Undefined),String:t(d.String),Buffer:t(d.Buffer),VSBuffer:t(d.VSBuffer),Array:t(d.Array),Object:t(d.Object)},s=typeof Buffer!="undefined";function a(F,N){if(typeof N=="undefined")F.write(r.Undefined);else if(typeof N=="string"){const O=P.VSBuffer.fromString(N);F.write(r.String),F.write(u(O.byteLength)),F.write(O)}else if(s&&Buffer.isBuffer(N)){const O=P.VSBuffer.wrap(N);F.write(r.Buffer),F.write(u(O.byteLength)),F.write(O)}else if(N instanceof P.VSBuffer)F.write(r.VSBuffer),F.write(u(N.byteLength)),F.write(N);else if(Array.isArray(N)){F.write(r.Array),F.write(u(N.length));for(const O of N)a(F,O)}else{const O=P.VSBuffer.fromString(JSON.stringify(N));F.write(r.Object),F.write(u(O.byteLength)),F.write(O)}}function n(F){switch(F.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return F.read(o(F)).toString();case d.Buffer:return F.read(o(F)).buffer;case d.VSBuffer:return F.read(o(F));case d.Array:{const O=o(F),V=[];for(let q=0;q<O;q++)V.push(n(F));return V}case d.Object:return JSON.parse(F.read(o(F)).toString())}}class c{constructor(N,O,V=null,q=1e3){this.protocol=N,this.ctx=O,this.logger=V,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Y=>this.onRawMessage(Y)),this.sendResponse({type:200})}registerChannel(N,O){this.channels.set(N,O),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const O=this.send([N.type]);this.logger&&this.logger.logOutgoing(O,0,1,m(N.type));return}case 201:case 202:case 204:case 203:{const O=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(O,N.id,1,m(N.type),N.data);return}}}send(N,O=void 0){const V=new v;return a(V,N),a(V,O),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onRawMessage(N){const O=new g(N),V=n(O),q=n(O),Y=V[0];switch(Y){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${f(Y)}: ${V[2]}.${V[3]}`,q),this.onPromise({type:Y,id:V[1],channelName:V[2],name:V[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${f(Y)}: ${V[2]}.${V[3]}`,q),this.onEventListen({type:Y,id:V[1],channelName:V[2],name:V[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${f(Y)}`),this.disposeActiveRequest({type:Y,id:V[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${f(Y)}`),this.disposeActiveRequest({type:Y,id:V[1]})}}onPromise(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const V=new I.CancellationTokenSource;let q;try{q=O.call(this.ctx,N.name,N.arg,V.token)}catch(_e){q=Promise.reject(_e)}const Y=N.id;q.then(_e=>{this.sendResponse({id:Y,data:_e,type:201}),this.activeRequests.delete(N.id)},_e=>{_e instanceof Error?this.sendResponse({id:Y,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:Y,data:_e,type:203}),this.activeRequests.delete(N.id)});const fe=(0,D.toDisposable)(()=>V.cancel());this.activeRequests.set(N.id,fe)}onEventListen(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const V=N.id,Y=O.listen(this.ctx,N.name,N.arg)(fe=>this.sendResponse({id:V,data:fe,type:204}));this.activeRequests.set(N.id,Y)}disposeActiveRequest(N){const O=this.activeRequests.get(N.id);O&&(O.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let O=this.pendingRequests.get(N.channelName);O||(O=[],this.pendingRequests.set(N.channelName,O));const V=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:N,timeoutTimer:V})}flushPendingRequests(N){const O=this.pendingRequests.get(N);if(O){for(const V of O)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var b;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(N,O=null){this.protocol=N,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=O}getChannel(N){const O=this;return{call(V,q,Y){return O.isDisposed?Promise.reject(C.canceled()):O.requestPromise(N,V,q,Y)},listen(V,q){return O.isDisposed?Promise.reject(C.canceled()):O.requestEvent(N,V,q)}}}requestPromise(N,O,V,q=I.CancellationToken.None){const Y=this.lastRequestId++,_e={id:Y,type:100,channelName:N,name:O,arg:V};if(q.isCancellationRequested)return Promise.reject(C.canceled());let Le;return new Promise((Fe,z)=>{if(q.isCancellationRequested)return z(C.canceled());const Q=()=>{const De=Me=>{switch(Me.type){case 201:this.handlers.delete(Y),Fe(Me.data);break;case 202:this.handlers.delete(Y);const we=new Error(Me.data.message);we.stack=Me.data.stack,we.name=Me.data.name,z(we);break;case 203:this.handlers.delete(Y),z(Me.data);break}};this.handlers.set(Y,De),this.sendRequest(_e)};let te=null;this.state===y.Idle?Q():(te=(0,R.createCancelablePromise)(De=>this.whenInitialized()),te.then(()=>{te=null,Q()}));const ae=()=>{te?(te.cancel(),te=null):this.sendRequest({id:Y,type:101}),z(C.canceled())},ve=q.onCancellationRequested(ae);Le=(0,D.combinedDisposable)((0,D.toDisposable)(ae),ve),this.activeRequests.add(Le)}).finally(()=>{this.activeRequests.delete(Le)})}requestEvent(N,O,V){const q=this.lastRequestId++,fe={id:q,type:102,channelName:N,name:O,arg:V};let _e=null;const Le=new p.Emitter({onFirstListenerAdd:()=>{_e=(0,R.createCancelablePromise)(Fe=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(Le),this.sendRequest(fe)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(Le),this.sendRequest({id:q,type:103}))}}),Ie=Fe=>Le.fire(Fe.data);return this.handlers.set(q,Ie),Le.event}sendRequest(N){switch(N.type){case 100:case 102:{const O=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(O,N.id,0,`${f(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const O=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(O,N.id,0,f(N.type));return}}}send(N,O=void 0){const V=new v;return a(V,N),a(V,O),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onBuffer(N){const O=new g(N),V=n(O),q=n(O),Y=V[0];switch(Y){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,m(Y)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],0,m(Y),q),this.onResponse({type:V[0],id:V[1],data:q})}}onResponse(N){if(N.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(N.id);O&&O(N)}whenInitialized(){return this.state===y.Idle?Promise.resolve():p.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelClient=w;class h{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:O,onDidClientDisconnect:V})=>{p.Event.once(O.onMessage)(Y=>{const fe=new g(Y),_e=n(fe),Le=new c(O,_e),Ie=new w(O);this.channels.forEach((z,Q)=>Le.registerChannel(Q,z));const Fe={channelServer:Le,channelClient:Ie,ctx:_e};this._connections.add(Fe),this._onDidAddConnection.fire(Fe),V(()=>{Le.dispose(),Ie.dispose(),this._connections.delete(Fe),this._onDidRemoveConnection.fire(Fe)})})})}get connections(){const N=[];return this._connections.forEach(O=>N.push(O)),N}getChannel(N,O){const V=this;return{call(q,Y,fe){let _e;if((0,i.isFunction)(O)){let Ie=(0,S.getRandomElement)(V.connections.filter(O));_e=Ie?Promise.resolve(Ie):p.Event.toPromise(p.Event.filter(V.onDidAddConnection,O))}else _e=O.routeCall(V,q,Y);const Le=_e.then(Ie=>Ie.channelClient.getChannel(N));return A(Le).call(q,Y,fe)},listen(q,Y){if((0,i.isFunction)(O))return V.getMulticastEvent(N,O,q,Y);const fe=O.routeEvent(V,q,Y).then(_e=>_e.channelClient.getChannel(N));return A(fe).listen(q,Y)}}}getMulticastEvent(N,O,V,q){const Y=this;let fe=new D.DisposableStore;const _e=new p.Emitter({onFirstListenerAdd:()=>{fe=new D.DisposableStore;const Le=new p.EventMultiplexer,Ie=new Map,Fe=Q=>{const ae=Q.channelClient.getChannel(N).listen(V,q),ve=Le.add(ae);Ie.set(Q,ve)},z=Q=>{const te=Ie.get(Q);!te||(te.dispose(),Ie.delete(Q))};Y.connections.filter(O).forEach(Fe),p.Event.filter(Y.onDidAddConnection,O)(Fe,void 0,fe),Y.onDidRemoveConnection(z,void 0,fe),Le.event(_e.fire,_e,fe),fe.add(Le)},onLastListenerRemove:()=>{fe.dispose()}});return _e.event}registerChannel(N,O){this.channels.set(N,O),this._connections.forEach(V=>{V.channelServer.registerChannel(N,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=h;class _{constructor(N,O,V=null){const q=new v;a(q,O),N.send(q.buffer),this.channelClient=new w(N,V),this.channelServer=new c(N,O,V)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,O){this.channelServer.registerChannel(N,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function A(F){return{call(N,O,V){return F.then(q=>q.call(N,O,V))},listen(N,O){const V=new p.Relay;return F.then(q=>V.input=q.listen(N,O)),V.event}}}e.getDelayedChannel=A;function L(F){let N=!1;return{call(O,V,q){return N?F.call(O,V,q):(0,R.timeout)(0).then(()=>N=!0).then(()=>F.call(O,V,q))},listen(O,V){if(N)return F.listen(O,V);const q=new p.Relay;return(0,R.timeout)(0).then(()=>N=!0).then(()=>q.input=F.listen(O,V)),q.event}}}e.getNextTickChannel=L;class W{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const O of N.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await p.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=W;var j;(function(F){function N(q,Y){const fe=q,_e=Y&&Y.disableMarshalling,Le=new Map;for(const Ie in fe)V(Ie)&&Le.set(Ie,p.Event.buffer(fe[Ie],!0));return new class{listen(Ie,Fe){const z=Le.get(Fe);if(z)return z;throw new Error(`Event not found: ${Fe}`)}call(Ie,Fe,z){const Q=fe[Fe];if(typeof Q=="function"){if(!_e&&Array.isArray(z))for(let te=0;te<z.length;te++)z[te]=(0,T.revive)(z[te]);return Q.apply(fe,z)}throw new Error(`Method not found: ${Fe}`)}}}F.fromService=N;function O(q,Y){const fe=Y&&Y.disableMarshalling;return new Proxy({},{get(_e,Le){var Ie;if(typeof Le=="string")return((Ie=Y==null?void 0:Y.properties)===null||Ie===void 0?void 0:Ie.has(Le))?Y.properties.get(Le):V(Le)?q.listen(Le):async function(...Fe){let z;Y&&!(0,i.isUndefinedOrNull)(Y.context)?z=[Y.context,...Fe]:z=Fe;const Q=await q.call(Le,z);return fe?Q:(0,T.revive)(Q)};throw new Error(`Property not found: ${String(Le)}`)}})}F.toService=O;function V(q){return q[0]==="o"&&q[1]==="n"&&k.isUpperAsciiLetter(q.charCodeAt(2))}})(j=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let N=F.toString();if(N!=="[object Object]")return N}return F}function $(F){return Array.isArray(F)?F.map(H):H(F)}function M(F,N,O,V,q,Y,fe){fe=$(fe);const _e=K[q],Le=_e[V%_e.length];let Ie=[`%c[${F}]%c[${String(N).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${Le}`];/\($/.test(Y)?(Ie=Ie.concat(fe),Ie.push(")")):Ie.push(fe),console.log.apply(console,Ie)}e.logWithColors=M;class U{constructor(N,O){this._outgoingPrefix=N,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,O,V,q,Y){this._totalOutgoing+=N,M(this._outgoingPrefix,this._totalOutgoing,N,O,V,q,Y)}logIncoming(N,O,V,q,Y){this._totalIncoming+=N,M(this._incomingPrefix,this._totalIncoming,N,O,V,q,Y)}}e.IPCLogger=U}),define(ge[101],pe([0,1,3,100,6,26,10,36]),function(Z,e,p,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let S=null;function i(){return S||(S=I.VSBuffer.alloc(0)),S}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return i();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const w=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),w}if(this._chunks[0].byteLength>s){const w=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),w}let n=I.VSBuffer.alloc(s),c=0,b=0;for(;s>0;){const w=this._chunks[b];if(w.byteLength>s){const h=w.slice(0,s);n.set(h,c),c+=s,a&&(this._chunks[b]=w.slice(s),this._totalLength-=s),s-=s}else n.set(w,c),c+=w.byteLength,a?(this._chunks.shift(),this._totalLength-=w.byteLength):b++,s-=w.byteLength}return n}}e.ChunkStream=T;var k;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(k||(k={}));var E;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(s,a,n,c){this.type=s,this.id=a,this.ack=n,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends R.Disposable{constructor(s){super();this._onMessage=this._register(new p.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const n=this._state.messageType,c=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new f(n,c,b,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=I.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._writeSoon(a,s.data)}}_bufferAdd(s,a){const n=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,n}_bufferTake(){const s=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class y extends R.Disposable{constructor(s){super();this._onMessage=new p.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new l(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new f(1,0,0,s))}}e.Protocol=y;class g extends D.IPCClient{constructor(s,a,n=null){super(s,a,n);this.protocol=s}static fromSocket(s,a){return new g(new y(s),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=g;class v{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new p.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=v;class d{constructor(s){this.data=s,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],a=0,n=this._first;for(;n;)s[a++]=n.data,n=n.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new d(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class o{constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<o._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=o._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}load(){const s=Date.now(),a=(1+o._HISTORY_LENGTH)*1e3;let n=0;for(let c=0;c<o._HISTORY_LENGTH;c++)s-this.lastRuns[c]<=a&&n++;return 1-n/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class t{constructor(s,a=null){this._loadEstimator=o.getInstance(),this._onControlMessage=new v,this.onControlMessage=this._onControlMessage.event,this._onMessage=new v,this.onMessage=this._onMessage.event,this._onDidDispose=new v,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new v,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new v,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new l(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new f(5,0,0,i());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const a=new f(4,0,0,i());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new l(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let a=0,n=s.length;a<n;a++)this._socketWriter.write(s[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new f(6,0,0,i())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const a=this._outgoingUnackMsg.toArray();for(let n=0,c=a.length;n<c;n++)this._socketWriter.write(a[n]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new f(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(s){const a=new f(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new f(3,0,this._incomingAckId,i());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(ge[102],pe([0,1,92]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class D{constructor(P){let S=(0,p.toUint8)(P);this._defaultValue=S,this._asciiMap=D._createAsciiMap(S),this._map=new Map}static _createAsciiMap(P){let S=new Uint8Array(256);for(let i=0;i<256;i++)S[i]=P;return S}set(P,S){let i=(0,p.toUint8)(S);P>=0&&P<256?this._asciiMap[P]=i:this._map.set(P,i)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=D;var R;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(R||(R={}));class I{constructor(){this._actual=new D(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=I}),define(ge[136],pe([0,1,102]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var D;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(D=e.WordCharacterClass||(e.WordCharacterClass={}));class R extends p.CharacterClassifier{constructor(P){super(0);for(let S=0,i=P.length;S<i;S++)this.set(P.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=R;function I(C){let P={};return S=>(P.hasOwnProperty(S)||(P[S]=C(S)),P[S])}e.getMapForWordSeparators=I(C=>new R(C))}),define(ge[49],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class p{constructor(R,I){this.lineNumber=R,this.column=I}with(R=this.lineNumber,I=this.column){return R===this.lineNumber&&I===this.column?this:new p(R,I)}delta(R=0,I=0){return this.with(this.lineNumber+R,this.column+I)}equals(R){return p.equals(this,R)}static equals(R,I){return!R&&!I?!0:!!R&&!!I&&R.lineNumber===I.lineNumber&&R.column===I.column}isBefore(R){return p.isBefore(this,R)}static isBefore(R,I){return R.lineNumber<I.lineNumber?!0:I.lineNumber<R.lineNumber?!1:R.column<I.column}isBeforeOrEqual(R){return p.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,I){return R.lineNumber<I.lineNumber?!0:I.lineNumber<R.lineNumber?!1:R.column<=I.column}static compare(R,I){let C=R.lineNumber|0,P=I.lineNumber|0;if(C===P){let S=R.column|0,i=I.column|0;return S-i}return C-P}clone(){return new p(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new p(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}}e.Position=p}),define(ge[43],pe([0,1,49]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class D{constructor(I,C,P,S){I>P||I===P&&C>S?(this.startLineNumber=P,this.startColumn=S,this.endLineNumber=I,this.endColumn=C):(this.startLineNumber=I,this.startColumn=C,this.endLineNumber=P,this.endColumn=S)}isEmpty(){return D.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return D.containsPosition(this,I)}static containsPosition(I,C){return!(C.lineNumber<I.startLineNumber||C.lineNumber>I.endLineNumber||C.lineNumber===I.startLineNumber&&C.column<I.startColumn||C.lineNumber===I.endLineNumber&&C.column>I.endColumn)}containsRange(I){return D.containsRange(this,I)}static containsRange(I,C){return!(C.startLineNumber<I.startLineNumber||C.endLineNumber<I.startLineNumber||C.startLineNumber>I.endLineNumber||C.endLineNumber>I.endLineNumber||C.startLineNumber===I.startLineNumber&&C.startColumn<I.startColumn||C.endLineNumber===I.endLineNumber&&C.endColumn>I.endColumn)}strictContainsRange(I){return D.strictContainsRange(this,I)}static strictContainsRange(I,C){return!(C.startLineNumber<I.startLineNumber||C.endLineNumber<I.startLineNumber||C.startLineNumber>I.endLineNumber||C.endLineNumber>I.endLineNumber||C.startLineNumber===I.startLineNumber&&C.startColumn<=I.startColumn||C.endLineNumber===I.endLineNumber&&C.endColumn>=I.endColumn)}plusRange(I){return D.plusRange(this,I)}static plusRange(I,C){let P,S,i,T;return C.startLineNumber<I.startLineNumber?(P=C.startLineNumber,S=C.startColumn):C.startLineNumber===I.startLineNumber?(P=C.startLineNumber,S=Math.min(C.startColumn,I.startColumn)):(P=I.startLineNumber,S=I.startColumn),C.endLineNumber>I.endLineNumber?(i=C.endLineNumber,T=C.endColumn):C.endLineNumber===I.endLineNumber?(i=C.endLineNumber,T=Math.max(C.endColumn,I.endColumn)):(i=I.endLineNumber,T=I.endColumn),new D(P,S,i,T)}intersectRanges(I){return D.intersectRanges(this,I)}static intersectRanges(I,C){let P=I.startLineNumber,S=I.startColumn,i=I.endLineNumber,T=I.endColumn,k=C.startLineNumber,E=C.startColumn,f=C.endLineNumber,l=C.endColumn;return P<k?(P=k,S=E):P===k&&(S=Math.max(S,E)),i>f?(i=f,T=l):i===f&&(T=Math.min(T,l)),P>i||P===i&&S>T?null:new D(P,S,i,T)}equalsRange(I){return D.equalsRange(this,I)}static equalsRange(I,C){return!!I&&!!C&&I.startLineNumber===C.startLineNumber&&I.startColumn===C.startColumn&&I.endLineNumber===C.endLineNumber&&I.endColumn===C.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(I){return new p.Position(I.endLineNumber,I.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(I){return new p.Position(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,C){return new D(this.startLineNumber,this.startColumn,I,C)}setStartPosition(I,C){return new D(I,C,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(I){return new D(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}static fromPositions(I,C=I){return new D(I.lineNumber,I.column,C.lineNumber,C.column)}static lift(I){return I?new D(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,C){return!(I.endLineNumber<C.startLineNumber||I.endLineNumber===C.startLineNumber&&I.endColumn<C.startColumn||C.endLineNumber<I.startLineNumber||C.endLineNumber===I.startLineNumber&&C.endColumn<I.startColumn)}static areIntersecting(I,C){return!(I.endLineNumber<C.startLineNumber||I.endLineNumber===C.startLineNumber&&I.endColumn<=C.startColumn||C.endLineNumber<I.startLineNumber||C.endLineNumber===I.startLineNumber&&C.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,C){if(I&&C){const i=I.startLineNumber|0,T=C.startLineNumber|0;if(i===T){const k=I.startColumn|0,E=C.startColumn|0;if(k===E){const f=I.endLineNumber|0,l=C.endLineNumber|0;if(f===l){const m=I.endColumn|0,y=C.endColumn|0;return m-y}return f-l}return k-E}return i-T}return(I?1:0)-(C?1:0)}static compareRangesUsingEnds(I,C){return I.endLineNumber===C.endLineNumber?I.endColumn===C.endColumn?I.startLineNumber===C.startLineNumber?I.startColumn-C.startColumn:I.startLineNumber-C.startLineNumber:I.endColumn-C.endColumn:I.endLineNumber-C.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}}e.Range=D}),define(ge[137],pe([0,1,49,43]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var R;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(R=e.SelectionDirection||(e.SelectionDirection={}));class I extends D.Range{constructor(P,S,i,T){super(P,S,i,T);this.selectionStartLineNumber=P,this.selectionStartColumn=S,this.positionLineNumber=i,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return I.selectionsEqual(this,P)}static selectionsEqual(P,S){return P.selectionStartLineNumber===S.selectionStartLineNumber&&P.selectionStartColumn===S.selectionStartColumn&&P.positionLineNumber===S.positionLineNumber&&P.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,S){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,P,S):new I(P,S,this.startLineNumber,this.startColumn)}getPosition(){return new p.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,S){return this.getDirection()===0?new I(P,S,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,P,S)}static fromPositions(P,S=P){return new I(P.lineNumber,P.column,S.lineNumber,S.column)}static liftSelection(P){return new I(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,S){if(P&&!S||!P&&S)return!1;if(!P&&!S)return!0;if(P.length!==S.length)return!1;for(let i=0,T=P.length;i<T;i++)if(!this.selectionsEqual(P[i],S[i]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,S,i,T,k){return k===0?new I(P,S,i,T):new I(i,T,P,S)}}e.Selection=I}),define(ge[103],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var p;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(p=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(R=e.EndOfLinePreference||(e.EndOfLinePreference={}));var I;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(I=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(l){this.tabSize=Math.max(1,l.tabSize|0),this.indentSize=l.tabSize|0,this.insertSpaces=Boolean(l.insertSpaces),this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=Boolean(l.trimAutoWhitespace)}equals(l){return this.tabSize===l.tabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class S{constructor(l,m){this.range=l,this.matches=m}}e.FindMatch=S;var i;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class k{constructor(l,m,y,g,v,d){this.identifier=l,this.range=m,this.text=y,this.forceMoveMarkers=g,this.isAutoWhitespaceEdit=v,this._isTracked=d}}e.ValidAnnotatedEditOperation=k;class E{constructor(l,m,y){this.reverseEdits=l,this.changes=m,this.trimAutoWhitespaceLineNumbers=y}}e.ApplyEditsResult=E}),define(ge[138],pe([0,1,9,136,49,43,103]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class S{constructor(d,u,o,t){this.searchString=d,this.isRegex=u,this.matchCase=o,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=i(this.searchString):d=this.searchString.indexOf(`
`)>=0;let u=null;try{u=p.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let o=!this.isRegex&&!d;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new T(u,this.wordSeparators?(0,D.getMapForWordSeparators)(this.wordSeparators):null,o?this.searchString:null)}}e.SearchParams=S;function i(v){if(!v||v.length===0)return!1;for(let d=0,u=v.length;d<u;d++)if(v.charCodeAt(d)===92){if(d++,d>=u)break;const t=v.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=i;class T{constructor(d,u,o){this.regex=d,this.wordSeparators=u,this.simpleSearch=o}}e.SearchData=T;function k(v,d,u){if(!u)return new C.FindMatch(v,null);let o=[];for(let t=0,r=d.length;t<r;t++)o[t]=d[t];return new C.FindMatch(v,o)}e.createFindMatch=k;class E{constructor(d){let u=[],o=0;for(let t=0,r=d.length;t<r;t++)d.charCodeAt(t)===10&&(u[o++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(d){const u=this._lineFeedsOffsets;let o=0,t=u.length-1;if(t===-1||d<=u[0])return 0;for(;o<t;){const r=o+((t-o)/2>>0);u[r]>=d?t=r-1:u[r+1]>=d?(o=r,t=r):o=r+1}return o+1}}class f{static findMatches(d,u,o,t,r){const s=u.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(d,o,new g(s.wordSeparators,s.regex),t,r):this._doFindMatchesLineByLine(d,o,s,t,r):[]}static _getMultilineMatchRange(d,u,o,t,r,s){let a,n=0;t?(n=t.findLineFeedCountBeforeOffset(r),a=u+r+n):a=u+r;let c;if(t){let _=t.findLineFeedCountBeforeOffset(r+s.length)-n;c=a+s.length+_}else c=a+s.length;const b=d.getPositionAt(a),w=d.getPositionAt(c);return new I.Range(b.lineNumber,b.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(d,u,o,t,r){const s=d.getOffsetAt(u.getStartPosition()),a=d.getValueInRange(u,1),n=d.getEOL()===`\r
`?new E(a):null,c=[];let b=0,w;for(o.reset(0);w=o.next(a);)if(c[b++]=k(this._getMultilineMatchRange(d,s,a,n,w.index,w[0]),w,t),b>=r)return c;return c}static _doFindMatchesLineByLine(d,u,o,t,r){const s=[];let a=0;if(u.startLineNumber===u.endLineNumber){const c=d.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return a=this._findMatchesInLine(o,c,u.startLineNumber,u.startColumn-1,a,s,t,r),s}const n=d.getLineContent(u.startLineNumber).substring(u.startColumn-1);a=this._findMatchesInLine(o,n,u.startLineNumber,u.startColumn-1,a,s,t,r);for(let c=u.startLineNumber+1;c<u.endLineNumber&&a<r;c++)a=this._findMatchesInLine(o,d.getLineContent(c),c,0,a,s,t,r);if(a<r){const c=d.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);a=this._findMatchesInLine(o,c,u.endLineNumber,0,a,s,t,r)}return s}static _findMatchesInLine(d,u,o,t,r,s,a,n){const c=d.wordSeparators;if(!a&&d.simpleSearch){const h=d.simpleSearch,_=h.length,A=u.length;let L=-_;for(;(L=u.indexOf(h,L+_))!==-1;)if((!c||y(c,u,A,L,_))&&(s[r++]=new C.FindMatch(new I.Range(o,L+1+t,o,L+1+_+t),null),r>=n))return r;return r}const b=new g(d.wordSeparators,d.regex);let w;b.reset(0);do if(w=b.next(u),w&&(s[r++]=k(new I.Range(o,w.index+1+t,o,w.index+1+w[0].length+t),w,a),r>=n))return r;while(w);return r}static findNextMatch(d,u,o,t){const r=u.parseSearchRequest();if(!r)return null;const s=new g(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(d,o,s,t):this._doFindNextMatchLineByLine(d,o,s,t)}static _doFindNextMatchMultiline(d,u,o,t){const r=new R.Position(u.lineNumber,1),s=d.getOffsetAt(r),a=d.getLineCount(),n=d.getValueInRange(new I.Range(r.lineNumber,r.column,a,d.getLineMaxColumn(a)),1),c=d.getEOL()===`\r
`?new E(n):null;o.reset(u.column-1);let b=o.next(n);return b?k(this._getMultilineMatchRange(d,s,n,c,b.index,b[0]),b,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(d,new R.Position(1,1),o,t):null}static _doFindNextMatchLineByLine(d,u,o,t){const r=d.getLineCount(),s=u.lineNumber,a=d.getLineContent(s),n=this._findFirstMatchInLine(o,a,s,u.column,t);if(n)return n;for(let c=1;c<=r;c++){const b=(s+c-1)%r,w=d.getLineContent(b+1),h=this._findFirstMatchInLine(o,w,b+1,1,t);if(h)return h}return null}static _findFirstMatchInLine(d,u,o,t,r){d.reset(t-1);const s=d.next(u);return s?k(new I.Range(o,s.index+1,o,s.index+1+s[0].length),s,r):null}static findPreviousMatch(d,u,o,t){const r=u.parseSearchRequest();if(!r)return null;const s=new g(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(d,o,s,t):this._doFindPreviousMatchLineByLine(d,o,s,t)}static _doFindPreviousMatchMultiline(d,u,o,t){const r=this._doFindMatchesMultiline(d,new I.Range(1,1,u.lineNumber,u.column),o,t,10*P);if(r.length>0)return r[r.length-1];const s=d.getLineCount();return u.lineNumber!==s||u.column!==d.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(d,new R.Position(s,d.getLineMaxColumn(s)),o,t):null}static _doFindPreviousMatchLineByLine(d,u,o,t){const r=d.getLineCount(),s=u.lineNumber,a=d.getLineContent(s).substring(0,u.column-1),n=this._findLastMatchInLine(o,a,s,t);if(n)return n;for(let c=1;c<=r;c++){const b=(r+s-c-1)%r,w=d.getLineContent(b+1),h=this._findLastMatchInLine(o,w,b+1,t);if(h)return h}return null}static _findLastMatchInLine(d,u,o,t){let r=null,s;for(d.reset(0);s=d.next(u);)r=k(new I.Range(o,s.index+1,o,s.index+1+s[0].length),s,t);return r}}e.TextModelSearch=f;function l(v,d,u,o,t){if(o===0)return!0;const r=d.charCodeAt(o-1);if(v.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=d.charCodeAt(o);if(v.get(s)!==0)return!0}return!1}function m(v,d,u,o,t){if(o+t===u)return!0;const r=d.charCodeAt(o+t);if(v.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=d.charCodeAt(o+t-1);if(v.get(s)!==0)return!0}return!1}function y(v,d,u,o,t){return l(v,d,u,o,t)&&m(v,d,u,o,t)}e.isValidMatch=y;class g{constructor(d,u){this._wordSeparators=d,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const u=d.length;let o;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(o=this._searchRegex.exec(d),!o))return null;const t=o.index,r=o[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){p.getNextCodePoint(d,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||y(this._wordSeparators,d,u,t,r))return o}while(o);return null}}e.Searcher=g}),define(ge[104],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function p(P=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const i of e.USUAL_WORD_SEPARATORS)P.indexOf(i)>=0||(S+="\\"+i);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=p();function D(P){let S=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)S=P;else{let i="g";P.ignoreCase&&(i+="i"),P.multiline&&(i+="m"),P.unicode&&(i+="u"),S=new RegExp(P.source,i)}return S.lastIndex=0,S}e.ensureValidWordDefinition=D;const R={maxLen:1e3,windowSize:15,timeBudget:150};function I(P,S,i,T,k=R){if(i.length>k.maxLen){let y=P-k.maxLen/2;return y<0?y=0:T+=y,i=i.substring(y,P+k.maxLen/2),I(P,S,i,T,k)}const E=Date.now(),f=P-1-T;let l=-1,m=null;for(let y=1;!(Date.now()-E>=k.timeBudget);y++){const g=f-k.windowSize*y;S.lastIndex=Math.max(0,g);const v=C(S,i,f,l);if(!v&&m||(m=v,g<=0))break;l=g}if(m){let y={word:m[0],startColumn:T+1+m.index,endColumn:T+1+m.index+m[0].length};return S.lastIndex=0,y}return null}e.getWordAtText=I;function C(P,S,i,T){let k;for(;k=P.exec(S);){const E=k.index||0;if(E<=i&&P.lastIndex>=i)return k;if(T>0&&E>T)return null}return null}}),define(ge[139],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var p;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(p=e.IndentAction||(e.IndentAction={}));class D{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let S=0,i=P.notIn.length;S<i;S++)switch(P.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=D;class R{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of P)I(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),I(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),I(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),I(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&I(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=R;function I(C,P,S){C.has(P)?C.get(P).push(S):C.set(P,[S])}}),define(ge[77],pe([0,1,33,7]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function R(I,C,P,S){if(Array.isArray(I)){let i=0;for(const T of I){const k=R(T,C,P,S);if(k===10)return k;k>i&&(i=k)}return i}else{if(typeof I=="string")return S?I==="*"?5:I===P?10:0:0;if(I){const{language:i,pattern:T,scheme:k,hasAccessToAllModels:E}=I;if(!S&&!E)return 0;let f=0;if(k)if(k===C.scheme)f=10;else if(k==="*")f=5;else return 0;if(i)if(i===P)f=10;else if(i==="*")f=Math.max(f,5);else return 0;if(T){let l;if(typeof T=="string"?l=T:l=Object.assign(Object.assign({},T),{base:(0,D.normalize)(T.base)}),l===C.fsPath||(0,p.match)(l,C.fsPath))f=10;else return 0}return f}else return 0}}e.score=R}),define(ge[140],pe([0,1,102]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var D;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(D=e.State||(e.State={}));class R{constructor(l,m,y){const g=new Uint8Array(l*m);for(let v=0,d=l*m;v<d;v++)g[v]=y;this._data=g,this.rows=l,this.cols=m}get(l,m){return this._data[l*this.cols+m]}set(l,m,y){this._data[l*this.cols+m]=y}}e.Uint8Matrix=R;class I{constructor(l){let m=0,y=0;for(let v=0,d=l.length;v<d;v++){let[u,o,t]=l[v];o>m&&(m=o),u>y&&(y=u),t>y&&(y=t)}m++,y++;let g=new R(y,m,0);for(let v=0,d=l.length;v<d;v++){let[u,o,t]=l[v];g.set(u,o,t)}this._states=g,this._maxCharCode=m}nextState(l,m){return m<0||m>=this._maxCharCode?0:this._states.get(l,m)}}e.StateMachine=I;let C=null;function P(){return C===null&&(C=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var S;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let i=null;function T(){if(i===null){i=new p.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<f.length;m++)i.set(f.charCodeAt(m),1);const l=".,;";for(let m=0;m<l.length;m++)i.set(l.charCodeAt(m),2)}return i}class k{static _createLink(l,m,y,g,v){let d=v-1;do{const u=m.charCodeAt(d);if(l.get(u)!==2)break;d--}while(d>g);if(g>0){const u=m.charCodeAt(g-1),o=m.charCodeAt(d);(u===40&&o===41||u===91&&o===93||u===123&&o===125)&&d--}return{range:{startLineNumber:y,startColumn:g+1,endLineNumber:y,endColumn:d+2},url:m.substring(g,d+1)}}static computeLinks(l,m=P()){const y=T();let g=[];for(let v=1,d=l.getLineCount();v<=d;v++){const u=l.getLineContent(v),o=u.length;let t=0,r=0,s=0,a=1,n=!1,c=!1,b=!1,w=!1;for(;t<o;){let h=!1;const _=u.charCodeAt(t);if(a===13){let A;switch(_){case 40:n=!0,A=0;break;case 41:A=n?0:1;break;case 91:b=!0,c=!0,A=0;break;case 93:b=!1,A=c?0:1;break;case 123:w=!0,A=0;break;case 125:A=w?0:1;break;case 39:A=s===34||s===96?0:1;break;case 34:A=s===39||s===96?0:1;break;case 96:A=s===39||s===34?0:1;break;case 42:A=s===42?1:0;break;case 124:A=s===124?1:0;break;case 32:A=b?0:1;break;default:A=y.get(_)}A===1&&(g.push(k._createLink(y,u,v,r,t)),h=!0)}else if(a===12){let A;_===91?(c=!0,A=0):A=y.get(_),A===1?h=!0:a=13}else a=m.nextState(a,_),a===0&&(h=!0);h&&(a=1,n=!1,c=!1,w=!1,r=t+1,s=_),t++}a===13&&g.push(k._createLink(y,u,v,r,o))}return g}}e.LinkComputer=k;function E(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:k.computeLinks(f)}e.computeLinks=E}),define(ge[141],pe([0,1,3,6]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class R{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,P){return this._map.set(C,P),this.fire([C]),(0,D.toDisposable)(()=>{this._map.get(C)===P&&(this._map.delete(C),this.fire([C]))})}registerPromise(C,P){let S=null,i=!1;return this._promises.set(C,P.then(T=>{this._promises.delete(C),!(i||!T)&&(S=this.register(C,T))})),(0,D.toDisposable)(()=>{i=!0,S&&S.dispose()})}getPromise(C){const P=this.get(C);if(P)return Promise.resolve(P);const S=this._promises.get(C);return S?S.then(i=>this.get(C)):null}get(C){return this._map.get(C)||null}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=R}),define(ge[105],pe([0,1,26,10]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var R;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(R||(R={}));function I(k){for(let E=0,f=k.length;E<f;E+=4){const l=k[E+0],m=k[E+1],y=k[E+2],g=k[E+3];k[E+0]=g,k[E+1]=y,k[E+2]=m,k[E+3]=l}}function C(k){const E=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return D.isLittleEndian()||I(E),p.VSBuffer.wrap(E)}function P(k){const E=k.buffer;if(D.isLittleEndian()||I(E),E.byteOffset%4==0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const f=new Uint8Array(E.byteLength);return f.set(E),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function S(k){const E=new Uint32Array(i(k));let f=0;if(E[f++]=k.id,k.type==="full")E[f++]=1,E[f++]=k.data.length,E.set(k.data,f),f+=k.data.length;else{E[f++]=2,E[f++]=k.deltas.length;for(const l of k.deltas)E[f++]=l.start,E[f++]=l.deleteCount,l.data?(E[f++]=l.data.length,E.set(l.data,f),f+=l.data.length):E[f++]=0}return C(E)}e.encodeSemanticTokensDto=S;function i(k){let E=0;if(E+=1+1,k.type==="full")E+=1+k.data.length;else{E+=1,E+=(1+1+1)*k.deltas.length;for(const f of k.deltas)f.data&&(E+=f.data.length)}return E}function T(k){const E=P(k);let f=0;const l=E[f++];if(E[f++]===1){const v=E[f++],d=E.subarray(f,f+v);return f+=v,{id:l,type:"full",data:d}}const y=E[f++];let g=[];for(let v=0;v<y;v++){const d=E[f++],u=E[f++],o=E[f++];let t;o>0&&(t=E.subarray(f,f+o),f+=o),g[v]={start:d,deleteCount:u,data:t}}return{id:l,type:"delta",deltas:g}}e.decodeSemanticTokensDto=T}),define(ge[106],pe([0,1,92]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class D{constructor(C,P){this.index=C,this.remainder=P}}e.PrefixSumIndexOfResult=D;class R{constructor(C){this.values=C,this.prefixSum=new Uint32Array(C.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(C,P){C=(0,p.toUint32)(C);const S=this.values,i=this.prefixSum,T=P.length;return T===0?!1:(this.values=new Uint32Array(S.length+T),this.values.set(S.subarray(0,C),0),this.values.set(S.subarray(C),C+T),this.values.set(P,C),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(i.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(C,P){return C=(0,p.toUint32)(C),P=(0,p.toUint32)(P),this.values[C]===P?!1:(this.values[C]=P,C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),!0)}removeValues(C,P){C=(0,p.toUint32)(C),P=(0,p.toUint32)(P);const S=this.values,i=this.prefixSum;if(C>=S.length)return!1;let T=S.length-C;return P>=T&&(P=T),P===0?!1:(this.values=new Uint32Array(S.length-P),this.values.set(S.subarray(0,C),0),this.values.set(S.subarray(C+P),C),this.prefixSum=new Uint32Array(this.values.length),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(i.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(C){return C<0?0:(C=(0,p.toUint32)(C),this._getAccumulatedValue(C))}_getAccumulatedValue(C){if(C<=this.prefixSumValidIndex[0])return this.prefixSum[C];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),C>=this.values.length&&(C=this.values.length-1);for(let S=P;S<=C;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],C),this.prefixSum[C]}getIndexOf(C){C=Math.floor(C),this.getTotalValue();let P=0,S=this.values.length-1,i=0,T=0,k=0;for(;P<=S;)if(i=P+(S-P)/2|0,T=this.prefixSum[i],k=T-this.values[i],C<k)S=i-1;else if(C>=T)P=i+1;else break;return new D(i,C-k)}}e.PrefixSumComputer=R}),define(ge[142],pe([0,1,9,49,106]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class I{constructor(P,S,i,T){this._uri=P,this._lines=S,this._eol=i,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const S=P.changes;for(const i of S)this._acceptDeleteRange(i.range),this._acceptInsertText(new D.Position(i.range.startLineNumber,i.range.startColumn),i.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,S=this._lines.length,i=new Uint32Array(S);for(let T=0;T<S;T++)i[T]=this._lines[T].length+P;this._lineStarts=new R.PrefixSumComputer(i)}}_setLineText(P,S){this._lines[P]=S,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,S){if(S.length!==0){let i=(0,p.splitLines)(S);if(i.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+i[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}i[i.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+i[0]);let T=new Uint32Array(i.length-1);for(let k=1;k<i.length;k++)this._lines.splice(P.lineNumber+k-1,0,i[k]),T[k-1]=i[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,T)}}}e.MirrorTextModel=I}),define(ge[143],pe([16,17]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(ge[144],pe([0,1,143]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,R=D*60,I=R*24,C=I*7,P=I*30,S=I*365;function i(k,E){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,p.localize)(0,null,i(new Date().getTime()+f*1e3,!1));if(f<30)return(0,p.localize)(1,null);let l;return f<D?(l=f,E?l===1?(0,p.localize)(2,null,l):(0,p.localize)(3,null,l):l===1?(0,p.localize)(4,null,l):(0,p.localize)(5,null,l)):f<R?(l=Math.floor(f/D),E?l===1?(0,p.localize)(6,null,l):(0,p.localize)(7,null,l):l===1?(0,p.localize)(8,null,l):(0,p.localize)(9,null,l)):f<I?(l=Math.floor(f/R),E?l===1?(0,p.localize)(10,null,l):(0,p.localize)(11,null,l):l===1?(0,p.localize)(12,null,l):(0,p.localize)(13,null,l)):f<C?(l=Math.floor(f/I),E?l===1?(0,p.localize)(14,null,l):(0,p.localize)(15,null,l):l===1?(0,p.localize)(16,null,l):(0,p.localize)(17,null,l)):f<P?(l=Math.floor(f/C),E?l===1?(0,p.localize)(18,null,l):(0,p.localize)(19,null,l):l===1?(0,p.localize)(20,null,l):(0,p.localize)(21,null,l)):f<S?(l=Math.floor(f/P),E?l===1?(0,p.localize)(22,null,l):(0,p.localize)(23,null,l):l===1?(0,p.localize)(24,null,l):(0,p.localize)(25,null,l)):(l=Math.floor(f/S),E?l===1?(0,p.localize)(26,null,l):(0,p.localize)(27,null,l):l===1?(0,p.localize)(28,null,l):(0,p.localize)(29,null,l))}e.fromNow=i;function T(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(ge[145],pe([16,17]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(ge[58],pe([0,1,145,15,12]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function I(i,T){return T&&(i.stack||i.stacktrace)?p.localize(0,null,P(i),C(i.stack)||C(i.stacktrace)):P(i)}function C(i){return Array.isArray(i)?i.join(`
`):i}function P(i){return typeof i.code=="string"&&typeof i.errno=="number"&&typeof i.syscall=="string"?p.localize(1,null,i.message):i.message||p.localize(2,null)}function S(i=null,T=!1){if(!i)return p.localize(3,null);if(Array.isArray(i)){const k=R.coalesce(i),E=S(k[0],T);return k.length>1?p.localize(4,null,E,k.length):E}if(D.isString(i))return i;if(i.detail){const k=i.detail;if(k.error)return I(k.error,T);if(k.exception)return I(k.exception,T)}return i.stack?I(i,T):i.message?i.message:p.localize(5,null)}e.toErrorMessage=S}),define(ge[146],pe([16,17]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(ge[78],pe([0,1,7,37,25,39,146,15,22,30,10,134,11]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function f(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(u,o){if(T.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};o&&(t.cwd=o);const r=I.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],t);return new Promise(s=>{r.once("error",a=>{s({success:!1,error:a})}),r.once("exit",(a,n)=>{s(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?f(t.status):1})}else if(T.isLinux||T.isMacintosh)try{const t=E.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(r=>{I.execFile(t,[u.pid.toString()],{encoding:"utf8",shell:!0},(s,a,n)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function m(u=process.env){return u.comspec||"cmd.exe"}e.getWindowsShell=m;class y{constructor(o,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=o,this.args=t,this.shell=r,this.options=s;else{const a=o;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(process.env).forEach(n=>{a[n]=process.env[n]}),Object.keys(this.options.env).forEach(n=>{a[n]=this.options.env[n]}),this.options.env=a}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const t=o.lastIndexOf(p.sep);return t!==-1&&(o=o.substring(t+1)),y.WellKnowCommands[o]?o:"other"}start(o){return T.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(process.cwd()))?Promise.reject(new Error(C.localize(0,null))):this.useExec().then(t=>{let r,s;const a=new Promise((n,c)=>{r=n,s=c});if(t){let n=this.cmd;this.args&&(n=n+" "+this.args.join(" ")),this.childProcess=I.exec(n,this.options,(c,b,w)=>{this.childProcess=null;const h=c;h&&h.killed?s({killed:this.terminateRequested,stdout:b.toString(),stderr:w.toString()}):this.handleExec(r,o,c,b,w)})}else{let n=null;const c=b=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(b,r,o,s);const w={terminated:this.terminateRequested};P.isNumber(b)&&(w.cmdCode=b),r(w)};if(this.shell&&T.isWindows){const b=S.deepClone(this.options);b.windowsVerbatimArguments=!0,b.detached=!1;let w=!1,h=!1;const _=[];let A=this.ensureQuotes(this.cmd);_.push(A.value),w=A.quoted,this.args&&this.args.forEach(W=>{A=this.ensureQuotes(W),_.push(A.value),h=h&&A.quoted});const L=["/s","/c"];w?h?L.push('"'+_.join(" ")+'"'):_.length>1?L.push('"'+_[0]+'" '+_.slice(1).join(" ")):L.push('"'+_[0]+'"'):L.push(_.join(" ")),n=I.spawn(m(),L,b)}else this.cmd&&(n=I.spawn(this.cmd,this.args,this.options));n&&(this.childProcess=n,this.childProcessPromise=Promise.resolve(n),this.pidResolve&&(this.pidResolve(P.isNumber(n.pid)?n.pid:-1),this.pidResolve=void 0),n.on("error",b=>{this.childProcess=null,s({terminated:this.terminateRequested,error:b})}),n.pid&&(this.childProcess.on("close",c),this.handleSpawn(n,r,o,s,!0)))}return a})}handleClose(o,t,r,s){}ensureQuotes(o){return y.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,l(o,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!T.isWindows)return o(!1);const t=I.spawn(m(),["/s","/c"]);t.on("error",r=>o(!0)),t.on("exit",r=>o(!1))})}}e.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class g extends y{constructor(o,t,r,s){super(o,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,t,r,s,a){[s,a].forEach((n,c)=>{const b=new k.LineDecoder;b.write(n).forEach(_=>{t({line:_,source:c===0?0:1})});const h=b.end();h&&t({line:h,source:c===0?0:1})}),o({terminated:this.terminateRequested,error:r})}handleSpawn(o,t,r,s,a){const n=new k.LineDecoder,c=new k.LineDecoder;o.stdout.on("data",b=>{n.write(b).forEach(h=>r({line:h,source:0}))}),o.stderr.on("data",b=>{c.write(b).forEach(h=>r({line:h,source:1}))}),this.stdoutLineDecoder=n,this.stderrLineDecoder=c}handleClose(o,t,r,s){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const n=this.stderrLineDecoder?this.stderrLineDecoder.end():null;n&&r({line:n,source:1})}}e.LineProcess=g;function v(u){let o=[],t=!1;const r=function(s){if(t){o.push(s);return}(!u.send(s,n=>{if(n&&console.error(n),t=!1,o.length>0){const c=o.slice(0);o=[],c.forEach(b=>r(b))}})||T.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=v;var d;(function(u){async function o(t,r,s){if(p.isAbsolute(t))return t;if(r===void 0&&(r=process.cwd()),p.dirname(t)!=="."||(s===void 0&&P.isString(process.env.PATH)&&(s=process.env.PATH.split(p.delimiter)),s===void 0||s.length===0))return p.join(r,t);async function n(c){return await R.exists(c)?!(await D.promises.stat(c)).isDirectory():!1}for(let c of s){let b;if(p.isAbsolute(c)?b=p.join(c,t):b=p.join(r,c,t),await n(b))return b;let w=b+".com";if(await n(w)||(w=b+".exe",await n(w)))return w}return p.join(r,t)}u.findExecutable=o})(d=e.win32||(e.win32={}))}),define(ge[147],pe([0,1,48,10,99,78]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function C(f,l){return f===3?D.isWindows?k():I.getWindowsShell(l):i(f,l)}e.getSystemShell=C;function P(f,l){return f===3?D.isWindows?E(l):I.getWindowsShell(l):i(f,l)}e.getSystemShellSync=P;let S=null;function i(f,l){if(D.isLinux&&f===1||D.isMacintosh&&f===2)return"/bin/bash";if(!S){let m;if(D.isWindows)m="/bin/bash";else{if(m=l.SHELL,!m)try{m=p.userInfo().shell}catch(y){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}S=m}return S}let T=null;async function k(){return T||(T=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),T}function E(f){if(T)return T;const l=D.isWindows&&parseFloat(p.release())>=10,m=f.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${f.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?y:I.getWindowsShell(f)}}),define(ge[148],pe([16,17]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(ge[149],pe([0,1,148,10,104]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=C;class P{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,Se){this._values[ie]=Se}}e.ValidatedEditorOptions=P;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class i{constructor(ie,Se,Ne,ze){this.id=ie,this.name=Se,this.defaultValue=Ne,this.schema=ze}compute(ie,Se,Ne){return Ne}}class T{constructor(ie,Se=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=Se}validate(ie){return this.defaultValue}}class k{constructor(ie,Se,Ne,ze){this.id=ie,this.name=Se,this.defaultValue=Ne,this.schema=ze}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,Se,Ne){return Ne}}function E(X,ie){return typeof X=="undefined"?ie:X==="false"?!1:Boolean(X)}e.boolean=E;class f extends k{constructor(ie,Se,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="boolean",ze.default=Ne),super(ie,Se,Ne,ze)}validate(ie){return E(ie,this.defaultValue)}}class l extends k{constructor(ie,Se,Ne,ze,We,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=Ne,Je.minimum=ze,Je.maximum=We),super(ie,Se,Ne,Je),this.minimum=ze,this.maximum=We}static clampedInt(ie,Se,Ne,ze){if(typeof ie=="undefined")return Se;let We=parseInt(ie,10);return isNaN(We)?Se:(We=Math.max(Ne,We),We=Math.min(ze,We),We|0)}validate(ie){return l.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class m extends k{constructor(ie,Se,Ne,ze,We){typeof We!="undefined"&&(We.type="number",We.default=Ne),super(ie,Se,Ne,We),this.validationFn=ze}static clamp(ie,Se,Ne){return ie<Se?Se:ie>Ne?Ne:ie}static float(ie,Se){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return Se;const Ne=parseFloat(ie);return isNaN(Ne)?Se:Ne}validate(ie){return this.validationFn(m.float(ie,this.defaultValue))}}class y extends k{static string(ie,Se){return typeof ie!="string"?Se:ie}constructor(ie,Se,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.default=Ne),super(ie,Se,Ne,ze)}validate(ie){return y.string(ie,this.defaultValue)}}function g(X,ie,Se){return typeof X!="string"||Se.indexOf(X)===-1?ie:X}e.stringSet=g;class v extends k{constructor(ie,Se,Ne,ze,We=void 0){typeof We!="undefined"&&(We.type="string",We.enum=ze,We.default=Ne),super(ie,Se,Ne,We),this._allowedValues=ze}validate(ie){return g(ie,this.defaultValue,this._allowedValues)}}class d extends i{constructor(ie,Se,Ne,ze,We,Je,G=void 0){typeof G!="undefined"&&(G.type="string",G.enum=We,G.default=ze),super(ie,Se,Ne,G),this._allowedValues=We,this._convert=Je}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function u(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends i{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",description:p.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,Se,Ne){return Ne===0?ie.accessibilitySupport:Ne}}class t extends i{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(16,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:p.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{insertSpace:E(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:E(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(a=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function n(X){switch(X){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=n;function c(X){switch(X){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class b extends T{constructor(){super(121,[60,29])}compute(ie,Se,Ne){const ze=["monaco-editor"];return Se.get(29)&&ze.push(Se.get(29)),ie.extraEditorClassName&&ze.push(ie.extraEditorClassName),Se.get(60)==="default"?ze.push("mouse-default"):Se.get(60)==="copy"&&ze.push("mouse-copy"),Se.get(95)&&ze.push("showUnused"),Se.get(119)&&ze.push("showDeprecated"),ze.join(" ")}}class w extends f{constructor(){super(28,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(ie,Se,Ne){return Ne&&ie.emptySelectionClipboard}}class h extends i{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(31,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:p.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[p.localize(9,null),p.localize(10,null),p.localize(11,null)],description:p.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:p.localize(13,null),included:D.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:p.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:p.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{cursorMoveOnType:E(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:E(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":g(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:E(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:E(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:E(Se.loop,this.defaultValue.loop)}}}class _ extends i{constructor(){super(39,"fontLigatures",_.OFF,{anyOf:[{type:"boolean",description:p.localize(16,null)},{type:"string",description:p.localize(17,null)}],description:p.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?_.OFF:ie==="true"?_.ON:ie:Boolean(ie)?_.ON:_.OFF}}e.EditorFontLigatures=_,_.OFF='"liga" off, "calt" off',_.ON='"liga" on, "calt" on';class A extends T{constructor(){super(38)}compute(ie,Se,Ne){return ie.fontInfo}}class L extends k{constructor(){super(40,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(19,null)})}validate(ie){let Se=m.float(ie,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(Se,6,100)}compute(ie,Se,Ne){return ie.fontInfo.fontSize}}class W extends i{constructor(){super(41,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:p.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(l.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class j extends i{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[p.localize(22,null),p.localize(23,null),p.localize(24,null)]};super(45,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:p.localize(26,null)},Se),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:p.localize(27,null)},Se),"editor.gotoLocation.multipleDeclarations":Object.assign({description:p.localize(28,null)},Se),"editor.gotoLocation.multipleImplementations":Object.assign({description:p.localize(29,null)},Se),"editor.gotoLocation.multipleReferences":Object.assign({description:p.localize(30,null)},Se),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,description:p.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,description:p.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,description:p.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,description:p.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,description:p.localize(35,null)}})}validate(ie){var Se,Ne,ze,We,Je;if(!ie||typeof ie!="object")return this.defaultValue;const G=ie;return{multiple:g(G.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(Se=G.multipleDefinitions)!==null&&Se!==void 0?Se:g(G.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=G.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:g(G.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(ze=G.multipleDeclarations)!==null&&ze!==void 0?ze:g(G.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(We=G.multipleImplementations)!==null&&We!==void 0?We:g(G.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Je=G.multipleReferences)!==null&&Je!==void 0?Je:g(G.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:y.string(G.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:y.string(G.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:y.string(G.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:y.string(G.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:y.string(G.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class K extends i{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(48,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:p.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:p.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:p.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:E(Se.enabled,this.defaultValue.enabled),delay:l.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:E(Se.sticky,this.defaultValue.sticky)}}}var H;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(H=e.RenderMinimap||(e.RenderMinimap={}));class $ extends T{constructor(){super(124,[44,52,33,59,87,54,55,89,111,114,115,116,2])}compute(ie,Se,Ne){return $.computeLayout(Se,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const Se=ie.height/ie.lineHeight,Ne=ie.scrollBeyondLastLine?Se-1:0,ze=(ie.viewLineCount+Ne)/(ie.pixelRatio*ie.height),We=Math.floor(ie.viewLineCount/ze);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:Ne,desiredRatio:ze,minimapLineCount:We}}static _computeMinimapLayout(ie,Se){const Ne=ie.outerWidth,ze=ie.outerHeight,We=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(We*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Je=Se.stableMinimapLayoutInput,G=Je&&ie.outerHeight===Je.outerHeight&&ie.lineHeight===Je.lineHeight&&ie.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Je.pixelRatio&&ie.scrollBeyondLastLine===Je.scrollBeyondLastLine&&ie.minimap.enabled===Je.minimap.enabled&&ie.minimap.side===Je.minimap.side&&ie.minimap.size===Je.minimap.size&&ie.minimap.showSlider===Je.minimap.showSlider&&ie.minimap.renderCharacters===Je.minimap.renderCharacters&&ie.minimap.maxColumn===Je.minimap.maxColumn&&ie.minimap.scale===Je.minimap.scale&&ie.verticalScrollbarWidth===Je.verticalScrollbarWidth&&ie.isViewportWrapping===Je.isViewportWrapping,oe=ie.lineHeight,ue=ie.typicalHalfwidthCharacterWidth,J=ie.scrollBeyondLastLine,ne=ie.minimap.renderCharacters;let le=We>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const me=ie.minimap.maxColumn,Ee=ie.minimap.size,He=ie.minimap.side,Be=ie.verticalScrollbarWidth,qe=ie.viewLineCount,Xe=ie.remainingWidth,Ze=ie.isViewportWrapping,ut=ne?2:3;let st=Math.floor(We*ze);const be=st/We;let he=!1,ce=!1,ee=ut*le,Te=le/We,Re=1;if(Ee==="fill"||Ee==="fit"){const{typicalViewportLineCount:dt,extraLinesBeyondLastLine:at,desiredRatio:Ct,minimapLineCount:gt}=$.computeContainedMinimapLineCount({viewLineCount:qe,scrollBeyondLastLine:J,height:ze,lineHeight:oe,pixelRatio:We});if(qe/gt>1)he=!0,ce=!0,le=1,ee=1,Te=le/We;else{let Et=!1,St=le+1;if(Ee==="fit"){const mt=Math.ceil((qe+at)*ee);Ze&&G&&Xe<=Se.stableFitRemainingWidth?(Et=!0,St=Se.stableFitMaxMinimapScale):(Et=mt>st,Ze&&Et?(Se.stableMinimapLayoutInput=ie,Se.stableFitRemainingWidth=Xe):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0))}if(Ee==="fill"||Et){he=!0;const mt=le;ee=Math.min(oe*We,Math.max(1,Math.floor(1/Ct))),le=Math.min(St,Math.max(1,Math.floor(ee/ut))),le>mt&&(Re=Math.min(2,le/mt)),Te=le/We/Re,st=Math.ceil(Math.max(dt,qe+at)*ee),Ze&&Et&&(Se.stableFitMaxMinimapScale=le)}}}const et=Math.floor(me*Te),Ke=Math.min(et,Math.max(0,Math.floor((Xe-Be-2)*Te/(ue+Te)))+e.MINIMAP_GUTTER_WIDTH);let rt=Math.floor(We*Ke);const lt=rt/We;rt=Math.floor(rt*Re);const Ye=ne?1:2,it=He==="left"?0:Ne-Ke-Be;return{renderMinimap:Ye,minimapLeft:it,minimapWidth:Ke,minimapHeightIsEditorHeight:he,minimapIsSampling:ce,minimapScale:le,minimapLineHeight:ee,minimapCanvasInnerWidth:rt,minimapCanvasInnerHeight:st,minimapCanvasOuterWidth:lt,minimapCanvasOuterHeight:be}}static computeLayout(ie,Se){const Ne=Se.outerWidth|0,ze=Se.outerHeight|0,We=Se.lineHeight|0,Je=Se.lineNumbersDigitCount|0,G=Se.typicalHalfwidthCharacterWidth,oe=Se.maxDigitWidth,ue=Se.pixelRatio,J=Se.viewLineCount,ne=ie.get(116),le=ne==="inherit"?ie.get(115):ne,me=le==="inherit"?ie.get(111):le,Ee=ie.get(114),He=ie.get(2),Be=Se.isDominatedByLongLines,qe=ie.get(44),Xe=ie.get(54).renderType!==0,Ze=ie.get(55),ut=ie.get(89),st=ie.get(59),be=ie.get(87),he=be.verticalScrollbarSize,ce=be.verticalHasArrows,ee=be.arrowSize,Te=be.horizontalScrollbarSize,Re=ie.get(52),et=ie.get(33);let Ke;if(typeof Re=="string"&&/^\d+(\.\d+)?ch$/.test(Re)){const ht=parseFloat(Re.substr(0,Re.length-2));Ke=l.clampedInt(ht*G,0,0,1e3)}else Ke=l.clampedInt(Re,0,0,1e3);et&&(Ke+=16);let rt=0;if(Xe){const ht=Math.max(Je,Ze);rt=Math.round(ht*oe)}let lt=0;qe&&(lt=We);let Ye=0,it=Ye+lt,dt=it+rt,at=dt+Ke;const Ct=Ne-lt-rt-Ke;let gt=!1,kt=!1,Et=-1;He!==2&&(le==="inherit"&&Be?(gt=!0,kt=!0):me==="on"||me==="bounded"?kt=!0:me==="wordWrapColumn"&&(Et=Ee));const St=$._computeMinimapLayout({outerWidth:Ne,outerHeight:ze,lineHeight:We,typicalHalfwidthCharacterWidth:G,pixelRatio:ue,scrollBeyondLastLine:ut,minimap:st,verticalScrollbarWidth:he,viewLineCount:J,remainingWidth:Ct,isViewportWrapping:kt},Se.memory||new S);St.renderMinimap!==0&&St.minimapLeft===0&&(Ye+=St.minimapWidth,it+=St.minimapWidth,dt+=St.minimapWidth,at+=St.minimapWidth);const mt=Ct-St.minimapWidth,Lt=Math.max(1,Math.floor((mt-he-2)/G)),Ft=ce?ee:0;return kt&&(Et=Math.max(1,Lt),me==="bounded"&&(Et=Math.min(Et,Ee))),{width:Ne,height:ze,glyphMarginLeft:Ye,glyphMarginWidth:lt,lineNumbersLeft:it,lineNumbersWidth:rt,decorationsLeft:dt,decorationsWidth:Ke,contentLeft:at,contentWidth:mt,minimap:St,viewportColumn:Lt,isWordWrapMinified:gt,isViewportWrapping:kt,wrappingColumn:Et,verticalScrollbarWidth:he,horizontalScrollbarHeight:Te,overviewRuler:{top:Ft,width:he,height:ze-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=$;class M extends i{constructor(){const ie={enabled:!0};super(51,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:p.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:E(ie.enabled,this.defaultValue.enabled)}}}class U extends i{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(120,"inlineHints",ie,{"editor.inlineHints.enabled":{type:"boolean",default:ie.enabled,description:p.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:ie.fontSize,description:p.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:ie.fontFamily,description:p.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:E(Se.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:y.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class F extends l{constructor(){super(53,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:p.localize(43,null)})}compute(ie,Se,Ne){return ie.fontInfo.lineHeight}}class N extends i{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(59,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:p.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(45,null),p.localize(46,null),p.localize(47,null)],default:ie.size,description:p.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:p.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:p.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:p.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:p.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:E(Se.enabled,this.defaultValue.enabled),size:g(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(Se.side,this.defaultValue.side,["right","left"]),showSlider:g(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:E(Se.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(Se.scale,1,1,3),maxColumn:l.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(X){return X==="ctrlCmd"?D.isMacintosh?"metaKey":"ctrlKey":"altKey"}class V extends i{constructor(){super(69,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{top:l.clampedInt(Se.top,0,0,1e3),bottom:l.clampedInt(Se.bottom,0,0,1e3)}}}class q extends i{constructor(){const ie={enabled:!0,cycle:!1};super(70,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:p.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:p.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:E(Se.enabled,this.defaultValue.enabled),cycle:E(Se.cycle,this.defaultValue.cycle)}}}class Y extends T{constructor(){super(122)}compute(ie,Se,Ne){return ie.pixelRatio}}class fe extends i{constructor(){const ie={other:!0,comments:!1,strings:!1};super(73,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:p.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:p.localize(59,null)},other:{type:"boolean",default:ie.other,description:p.localize(60,null)}}}],default:ie,description:p.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const Se=ie,Ne={other:E(Se.other,this.defaultValue.other),comments:E(Se.comments,this.defaultValue.comments),strings:E(Se.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var _e;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Le extends i{constructor(){super(54,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(62,null),p.localize(63,null),p.localize(64,null),p.localize(65,null)],default:"on",description:p.localize(66,null)})}validate(ie){let Se=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(Se=4,Ne=ie):ie==="interval"?Se=3:ie==="relative"?Se=2:ie==="on"?Se=1:Se=0),{renderType:Se,renderFn:Ne}}}function Ie(X){const ie=X.get(82);return ie==="editable"?X.get(75):ie!=="on"}e.filterValidationDecorations=Ie;class Fe extends i{constructor(){const ie=[],Se={type:"number",description:p.localize(67,null)};super(86,"rulers",ie,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:p.localize(68,null),format:"color-hex"}}}]},default:ie,description:p.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let Se=[];for(let Ne of ie)if(typeof Ne=="number")Se.push({column:l.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const ze=Ne;Se.push({column:l.clampedInt(ze.column,0,0,1e4),color:ze.color})}return Se.sort((Ne,ze)=>Ne.column-ze.column),Se}return this.defaultValue}}function z(X,ie){if(typeof X!="string")return ie;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Q extends i{constructor(){super(87,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie,Ne=l.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=l.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(Se.vertical,this.defaultValue.vertical),horizontal:z(Se.horizontal,this.defaultValue.horizontal),useShadows:E(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:E(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:E(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:E(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:E(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:l.clampedInt(Se.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:l.clampedInt(Se.verticalSliderSize,ze,0,1e3),scrollByPage:E(Se.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends i{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(101,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(70,null),p.localize(71,null)],default:ie.insertMode,description:p.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:p.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:p.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:p.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:p.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:p.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:p.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:p.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(109,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{insertMode:g(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:E(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:E(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:E(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:E(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:E(Se.showIcons,this.defaultValue.showIcons),showStatusBar:E(Se.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:E(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:E(Se.showMethods,this.defaultValue.showMethods),showFunctions:E(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:E(Se.showConstructors,this.defaultValue.showConstructors),showFields:E(Se.showFields,this.defaultValue.showFields),showVariables:E(Se.showVariables,this.defaultValue.showVariables),showClasses:E(Se.showClasses,this.defaultValue.showClasses),showStructs:E(Se.showStructs,this.defaultValue.showStructs),showInterfaces:E(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:E(Se.showModules,this.defaultValue.showModules),showProperties:E(Se.showProperties,this.defaultValue.showProperties),showEvents:E(Se.showEvents,this.defaultValue.showEvents),showOperators:E(Se.showOperators,this.defaultValue.showOperators),showUnits:E(Se.showUnits,this.defaultValue.showUnits),showValues:E(Se.showValues,this.defaultValue.showValues),showConstants:E(Se.showConstants,this.defaultValue.showConstants),showEnums:E(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:E(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:E(Se.showKeywords,this.defaultValue.showKeywords),showWords:E(Se.showWords,this.defaultValue.showWords),showColors:E(Se.showColors,this.defaultValue.showColors),showFiles:E(Se.showFiles,this.defaultValue.showFiles),showReferences:E(Se.showReferences,this.defaultValue.showReferences),showFolders:E(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:E(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:E(Se.showSnippets,this.defaultValue.showSnippets),showUsers:E(Se.showUsers,this.defaultValue.showUsers),showIssues:E(Se.showIssues,this.defaultValue.showIssues)}}}class ae extends i{constructor(){super(97,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(110,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:E(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ve extends T{constructor(){super(123,[75])}compute(ie,Se,Ne){return Se.get(75)?!0:ie.tabFocusMode}}var De;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Me(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class we extends T{constructor(){super(125,[124])}compute(ie,Se,Ne){const ze=Se.get(124);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",xe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:D.isMacintosh?Ae:D.isLinux?xe:ke,fontWeight:"normal",fontSize:D.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ye(X){return e.editorOptionsRegistry[X.id]=X,X}var Ge;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingOvertype=6]="autoClosingOvertype",X[X.autoClosingQuotes=7]="autoClosingQuotes",X[X.autoIndent=8]="autoIndent",X[X.automaticLayout=9]="automaticLayout",X[X.autoSurround=10]="autoSurround",X[X.codeLens=11]="codeLens",X[X.codeLensFontFamily=12]="codeLensFontFamily",X[X.codeLensFontSize=13]="codeLensFontSize",X[X.colorDecorators=14]="colorDecorators",X[X.columnSelection=15]="columnSelection",X[X.comments=16]="comments",X[X.contextmenu=17]="contextmenu",X[X.copyWithSyntaxHighlighting=18]="copyWithSyntaxHighlighting",X[X.cursorBlinking=19]="cursorBlinking",X[X.cursorSmoothCaretAnimation=20]="cursorSmoothCaretAnimation",X[X.cursorStyle=21]="cursorStyle",X[X.cursorSurroundingLines=22]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=23]="cursorSurroundingLinesStyle",X[X.cursorWidth=24]="cursorWidth",X[X.disableLayerHinting=25]="disableLayerHinting",X[X.disableMonospaceOptimizations=26]="disableMonospaceOptimizations",X[X.dragAndDrop=27]="dragAndDrop",X[X.emptySelectionClipboard=28]="emptySelectionClipboard",X[X.extraEditorClassName=29]="extraEditorClassName",X[X.fastScrollSensitivity=30]="fastScrollSensitivity",X[X.find=31]="find",X[X.fixedOverflowWidgets=32]="fixedOverflowWidgets",X[X.folding=33]="folding",X[X.foldingStrategy=34]="foldingStrategy",X[X.foldingHighlight=35]="foldingHighlight",X[X.unfoldOnClickAfterEndOfLine=36]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=37]="fontFamily",X[X.fontInfo=38]="fontInfo",X[X.fontLigatures=39]="fontLigatures",X[X.fontSize=40]="fontSize",X[X.fontWeight=41]="fontWeight",X[X.formatOnPaste=42]="formatOnPaste",X[X.formatOnType=43]="formatOnType",X[X.glyphMargin=44]="glyphMargin",X[X.gotoLocation=45]="gotoLocation",X[X.hideCursorInOverviewRuler=46]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=47]="highlightActiveIndentGuide",X[X.hover=48]="hover",X[X.inDiffEditor=49]="inDiffEditor",X[X.letterSpacing=50]="letterSpacing",X[X.lightbulb=51]="lightbulb",X[X.lineDecorationsWidth=52]="lineDecorationsWidth",X[X.lineHeight=53]="lineHeight",X[X.lineNumbers=54]="lineNumbers",X[X.lineNumbersMinChars=55]="lineNumbersMinChars",X[X.linkedEditing=56]="linkedEditing",X[X.links=57]="links",X[X.matchBrackets=58]="matchBrackets",X[X.minimap=59]="minimap",X[X.mouseStyle=60]="mouseStyle",X[X.mouseWheelScrollSensitivity=61]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=62]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=63]="multiCursorMergeOverlapping",X[X.multiCursorModifier=64]="multiCursorModifier",X[X.multiCursorPaste=65]="multiCursorPaste",X[X.occurrencesHighlight=66]="occurrencesHighlight",X[X.overviewRulerBorder=67]="overviewRulerBorder",X[X.overviewRulerLanes=68]="overviewRulerLanes",X[X.padding=69]="padding",X[X.parameterHints=70]="parameterHints",X[X.peekWidgetDefaultFocus=71]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=72]="definitionLinkOpensInPeek",X[X.quickSuggestions=73]="quickSuggestions",X[X.quickSuggestionsDelay=74]="quickSuggestionsDelay",X[X.readOnly=75]="readOnly",X[X.renameOnType=76]="renameOnType",X[X.renderControlCharacters=77]="renderControlCharacters",X[X.renderIndentGuides=78]="renderIndentGuides",X[X.renderFinalNewline=79]="renderFinalNewline",X[X.renderLineHighlight=80]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=81]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=82]="renderValidationDecorations",X[X.renderWhitespace=83]="renderWhitespace",X[X.revealHorizontalRightPadding=84]="revealHorizontalRightPadding",X[X.roundedSelection=85]="roundedSelection",X[X.rulers=86]="rulers",X[X.scrollbar=87]="scrollbar",X[X.scrollBeyondLastColumn=88]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=89]="scrollBeyondLastLine",X[X.scrollPredominantAxis=90]="scrollPredominantAxis",X[X.selectionClipboard=91]="selectionClipboard",X[X.selectionHighlight=92]="selectionHighlight",X[X.selectOnLineNumbers=93]="selectOnLineNumbers",X[X.showFoldingControls=94]="showFoldingControls",X[X.showUnused=95]="showUnused",X[X.snippetSuggestions=96]="snippetSuggestions",X[X.smartSelect=97]="smartSelect",X[X.smoothScrolling=98]="smoothScrolling",X[X.stickyTabStops=99]="stickyTabStops",X[X.stopRenderingLineAfter=100]="stopRenderingLineAfter",X[X.suggest=101]="suggest",X[X.suggestFontSize=102]="suggestFontSize",X[X.suggestLineHeight=103]="suggestLineHeight",X[X.suggestOnTriggerCharacters=104]="suggestOnTriggerCharacters",X[X.suggestSelection=105]="suggestSelection",X[X.tabCompletion=106]="tabCompletion",X[X.tabIndex=107]="tabIndex",X[X.unusualLineTerminators=108]="unusualLineTerminators",X[X.useTabStops=109]="useTabStops",X[X.wordSeparators=110]="wordSeparators",X[X.wordWrap=111]="wordWrap",X[X.wordWrapBreakAfterCharacters=112]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=113]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=114]="wordWrapColumn",X[X.wordWrapOverride1=115]="wordWrapOverride1",X[X.wordWrapOverride2=116]="wordWrapOverride2",X[X.wrappingIndent=117]="wrappingIndent",X[X.wrappingStrategy=118]="wrappingStrategy",X[X.showDeprecated=119]="showDeprecated",X[X.inlineHints=120]="inlineHints",X[X.editorClassName=121]="editorClassName",X[X.pixelRatio=122]="pixelRatio",X[X.tabFocusMode=123]="tabFocusMode",X[X.layoutInfo=124]="layoutInfo",X[X.wrappingInfo=125]="wrappingInfo"})(Ge=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(111,null)})),acceptSuggestionOnEnter:ye(new v(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(112,null),""],markdownDescription:p.localize(113,null)})),accessibilitySupport:ye(new o),accessibilityPageSize:ye(new l(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(114,null),deprecationMessage:p.localize(115,null)})),ariaLabel:ye(new y(4,"ariaLabel",p.localize(116,null))),autoClosingBrackets:ye(new v(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(117,null),p.localize(118,null),""],description:p.localize(119,null)})),autoClosingOvertype:ye(new v(6,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(120,null),""],description:p.localize(121,null)})),autoClosingQuotes:ye(new v(7,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(122,null),p.localize(123,null),""],description:p.localize(124,null)})),autoIndent:ye(new d(8,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[p.localize(125,null),p.localize(126,null),p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)})),automaticLayout:ye(new f(9,"automaticLayout",!1)),autoSurround:ye(new v(10,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(131,null),p.localize(132,null),p.localize(133,null),""],description:p.localize(134,null)})),stickyTabStops:ye(new f(99,"stickyTabStops",!1,{description:p.localize(135,null)})),codeLens:ye(new f(11,"codeLens",!0,{description:p.localize(136,null)})),codeLensFontFamily:ye(new y(12,"codeLensFontFamily","",{description:p.localize(137,null)})),codeLensFontSize:ye(new l(13,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:p.localize(138,null)})),colorDecorators:ye(new f(14,"colorDecorators",!0,{description:p.localize(139,null)})),columnSelection:ye(new f(15,"columnSelection",!1,{description:p.localize(140,null)})),comments:ye(new t),contextmenu:ye(new f(17,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new f(18,"copyWithSyntaxHighlighting",!0,{description:p.localize(141,null)})),cursorBlinking:ye(new d(19,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:p.localize(142,null)})),cursorSmoothCaretAnimation:ye(new f(20,"cursorSmoothCaretAnimation",!1,{description:p.localize(143,null)})),cursorStyle:ye(new d(21,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:p.localize(144,null)})),cursorSurroundingLines:ye(new l(22,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(145,null)})),cursorSurroundingLinesStyle:ye(new v(23,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(146,null),p.localize(147,null)],description:p.localize(148,null)})),cursorWidth:ye(new l(24,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(149,null)})),disableLayerHinting:ye(new f(25,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new f(26,"disableMonospaceOptimizations",!1)),dragAndDrop:ye(new f(27,"dragAndDrop",!0,{description:p.localize(150,null)})),emptySelectionClipboard:ye(new w),extraEditorClassName:ye(new y(29,"extraEditorClassName","")),fastScrollSensitivity:ye(new m(30,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:p.localize(151,null)})),find:ye(new h),fixedOverflowWidgets:ye(new f(32,"fixedOverflowWidgets",!1)),folding:ye(new f(33,"folding",!0,{description:p.localize(152,null)})),foldingStrategy:ye(new v(34,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(153,null),p.localize(154,null)],description:p.localize(155,null)})),foldingHighlight:ye(new f(35,"foldingHighlight",!0,{description:p.localize(156,null)})),unfoldOnClickAfterEndOfLine:ye(new f(36,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(157,null)})),fontFamily:ye(new y(37,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(158,null)})),fontInfo:ye(new A),fontLigatures2:ye(new _),fontSize:ye(new L),fontWeight:ye(new W),formatOnPaste:ye(new f(42,"formatOnPaste",!1,{description:p.localize(159,null)})),formatOnType:ye(new f(43,"formatOnType",!1,{description:p.localize(160,null)})),glyphMargin:ye(new f(44,"glyphMargin",!0,{description:p.localize(161,null)})),gotoLocation:ye(new j),hideCursorInOverviewRuler:ye(new f(46,"hideCursorInOverviewRuler",!1,{description:p.localize(162,null)})),highlightActiveIndentGuide:ye(new f(47,"highlightActiveIndentGuide",!0,{description:p.localize(163,null)})),hover:ye(new K),inDiffEditor:ye(new f(49,"inDiffEditor",!1)),letterSpacing:ye(new m(50,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>m.clamp(X,-5,20),{description:p.localize(164,null)})),lightbulb:ye(new M),lineDecorationsWidth:ye(new k(52,"lineDecorationsWidth",10)),lineHeight:ye(new F),lineNumbers:ye(new Le),lineNumbersMinChars:ye(new l(55,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new f(56,"linkedEditing",!1,{description:p.localize(165,null)})),links:ye(new f(57,"links",!0,{description:p.localize(166,null)})),matchBrackets:ye(new v(58,"matchBrackets","always",["always","near","never"],{description:p.localize(167,null)})),minimap:ye(new N),mouseStyle:ye(new v(60,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new m(61,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:p.localize(168,null)})),mouseWheelZoom:ye(new f(62,"mouseWheelZoom",!1,{markdownDescription:p.localize(169,null)})),multiCursorMergeOverlapping:ye(new f(63,"multiCursorMergeOverlapping",!0,{description:p.localize(170,null)})),multiCursorModifier:ye(new d(64,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[p.localize(171,null),p.localize(172,null)],markdownDescription:p.localize(173,null)})),multiCursorPaste:ye(new v(65,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(174,null),p.localize(175,null)],markdownDescription:p.localize(176,null)})),occurrencesHighlight:ye(new f(66,"occurrencesHighlight",!0,{description:p.localize(177,null)})),overviewRulerBorder:ye(new f(67,"overviewRulerBorder",!0,{description:p.localize(178,null)})),overviewRulerLanes:ye(new l(68,"overviewRulerLanes",3,0,3)),padding:ye(new V),parameterHints:ye(new q),peekWidgetDefaultFocus:ye(new v(71,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(179,null),p.localize(180,null)],description:p.localize(181,null)})),definitionLinkOpensInPeek:ye(new f(72,"definitionLinkOpensInPeek",!1,{description:p.localize(182,null)})),quickSuggestions:ye(new fe),quickSuggestionsDelay:ye(new l(74,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(183,null)})),readOnly:ye(new f(75,"readOnly",!1)),renameOnType:ye(new f(76,"renameOnType",!1,{description:p.localize(184,null),markdownDeprecationMessage:p.localize(185,null)})),renderControlCharacters:ye(new f(77,"renderControlCharacters",!1,{description:p.localize(186,null)})),renderIndentGuides:ye(new f(78,"renderIndentGuides",!0,{description:p.localize(187,null)})),renderFinalNewline:ye(new f(79,"renderFinalNewline",!0,{description:p.localize(188,null)})),renderLineHighlight:ye(new v(80,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(189,null)],description:p.localize(190,null)})),renderLineHighlightOnlyWhenFocus:ye(new f(81,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(191,null)})),renderValidationDecorations:ye(new v(82,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new v(83,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(192,null),p.localize(193,null),p.localize(194,null),""],description:p.localize(195,null)})),revealHorizontalRightPadding:ye(new l(84,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new f(85,"roundedSelection",!0,{description:p.localize(196,null)})),rulers:ye(new Fe),scrollbar:ye(new Q),scrollBeyondLastColumn:ye(new l(88,"scrollBeyondLastColumn",5,0,1073741824,{description:p.localize(197,null)})),scrollBeyondLastLine:ye(new f(89,"scrollBeyondLastLine",!0,{description:p.localize(198,null)})),scrollPredominantAxis:ye(new f(90,"scrollPredominantAxis",!0,{description:p.localize(199,null)})),selectionClipboard:ye(new f(91,"selectionClipboard",!0,{description:p.localize(200,null),included:D.isLinux})),selectionHighlight:ye(new f(92,"selectionHighlight",!0,{description:p.localize(201,null)})),selectOnLineNumbers:ye(new f(93,"selectOnLineNumbers",!0)),showFoldingControls:ye(new v(94,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[p.localize(202,null),p.localize(203,null)],description:p.localize(204,null)})),showUnused:ye(new f(95,"showUnused",!0,{description:p.localize(205,null)})),showDeprecated:ye(new f(119,"showDeprecated",!0,{description:p.localize(206,null)})),inlineHints:ye(new U),snippetSuggestions:ye(new v(96,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(207,null),p.localize(208,null),p.localize(209,null),p.localize(210,null)],description:p.localize(211,null)})),smartSelect:ye(new ae),smoothScrolling:ye(new f(98,"smoothScrolling",!1,{description:p.localize(212,null)})),stopRenderingLineAfter:ye(new l(100,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new te),suggestFontSize:ye(new l(102,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(213,null)})),suggestLineHeight:ye(new l(103,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(214,null)})),suggestOnTriggerCharacters:ye(new f(104,"suggestOnTriggerCharacters",!0,{description:p.localize(215,null)})),suggestSelection:ye(new v(105,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(216,null),p.localize(217,null),p.localize(218,null)],description:p.localize(219,null)})),tabCompletion:ye(new v(106,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(220,null),p.localize(221,null),p.localize(222,null)],description:p.localize(223,null)})),tabIndex:ye(new l(107,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new v(108,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(224,null),p.localize(225,null),p.localize(226,null)],description:p.localize(227,null)})),useTabStops:ye(new f(109,"useTabStops",!0,{description:p.localize(228,null)})),wordSeparators:ye(new y(110,"wordSeparators",R.USUAL_WORD_SEPARATORS,{description:p.localize(229,null)})),wordWrap:ye(new v(111,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(230,null),p.localize(231,null),p.localize(232,null),p.localize(233,null)],description:p.localize(234,null)})),wordWrapBreakAfterCharacters:ye(new y(112,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new y(113,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new l(114,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(235,null)})),wordWrapOverride1:ye(new v(115,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new v(116,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new d(117,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Me,{enumDescriptions:[p.localize(236,null),p.localize(237,null),p.localize(238,null),p.localize(239,null)],description:p.localize(240,null)})),wrappingStrategy:ye(new v(118,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[p.localize(241,null),p.localize(242,null)],description:p.localize(243,null)})),editorClassName:ye(new b),pixelRatio:ye(new Y),tabFocusMode:ye(new ve),layoutInfo:ye(new $),wrappingInfo:ye(new we)}}),define(ge[150],pe([16,17]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[151],pe([16,17]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[152],pe([16,17]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(ge[153],pe([16,17]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(ge[154],pe([16,17]),function(Z,e){return Z.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[155],pe([16,17]),function(Z,e){return Z.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[156],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ge[157],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[158],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(ge[159],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[160],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[161],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[162],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[163],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[164],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[165],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[166],pe([16,17]),function(Z,e){return Z.create("vs/workbench/common/views",e)}),define(ge[167],pe([16,17]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[168],pe([16,17]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[169],pe([16,17]),function(Z,e){return Z.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(ge[170],pe([16,17]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[171],pe([16,17]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[172],pe([16,17]),function(Z,e){return Z.create("vs/workbench/contrib/terminal/common/terminal",e)}),define(ge[173],pe([16,17]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[174],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var p;(function(C){C[C.ACTIVATE=0]="ACTIVATE",C[C.RESTORE=1]="RESTORE",C[C.PRESERVE=2]="PRESERVE"})(p=e.EditorActivation||(e.EditorActivation={}));var D;(function(C){C[C.PICK=1]="PICK",C[C.DISABLED=2]="DISABLED"})(D=e.EditorOverride||(e.EditorOverride={}));var R;(function(C){C[C.API=0]="API",C[C.USER=1]="USER"})(R=e.EditorOpenContext||(e.EditorOpenContext={}));var I;(function(C){C[C.Center=0]="Center",C[C.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",C[C.NearTop=2]="NearTop",C[C.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(I=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[107],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class p{constructor(I,C=[],P=!1){this.ctor=I,this.staticArguments=C,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=p;const D=(R,...I)=>new p(R,I);e.createSyncDescriptor=D}),define(ge[79],pe([0,1,107]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const D=[];function R(C,P,S){P instanceof p.SyncDescriptor||(P=new p.SyncDescriptor(P,[],S)),D.push([C,P])}e.registerSingleton=R;function I(){return D}e.getSingletonServiceDescriptors=I}),define(ge[175],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}e.Node=p;class D{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let C of this._nodes.values())C.outgoing.size===0&&I.push(C);return I}insertEdge(I,C){const P=this.lookupOrInsertNode(I),S=this.lookupOrInsertNode(C);P.outgoing.set(this._hashFn(C),S),S.incoming.set(this._hashFn(I),P)}removeNode(I){const C=this._hashFn(I);this._nodes.delete(C);for(let P of this._nodes.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(I){const C=this._hashFn(I);let P=this._nodes.get(C);return P||(P=new p(I),this._nodes.set(C,P)),P}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[C,P]of this._nodes)I.push(`${C}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return I.join(`
`)}}e.Graph=D}),define(ge[4],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function S(i){return i[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=S})(p=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function D(P,S,i,T){S[p.DI_TARGET]===S?S[p.DI_DEPENDENCIES].push({id:P,index:i,optional:T}):(S[p.DI_DEPENDENCIES]=[{id:P,index:i,optional:T}],S[p.DI_TARGET]=S)}function R(P){if(p.serviceIds.has(P))return p.serviceIds.get(P);const S=function(i,T,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(S,i,k,!1)};return S.toString=()=>P,p.serviceIds.set(P,S),S}e.createDecorator=R;function I(P){return P}e.refineServiceDecorator=I;function C(P){return function(S,i,T){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");D(P,S,T,!0)}}e.optional=C}),define(ge[176],pe([0,1,4]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,p.createDecorator)("modelService");function D(R){return!R.isTooLargeForSyncing()&&!R.isForSimpleWidget}e.shouldSynchronizeModel=D}),define(ge[177],pe([0,1,3,73,6,23,72,77,176]),function(Z,e,p,D,R,I,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function i(E){return typeof E=="string"?!1:Array.isArray(E)?E.every(i):!!E.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new p.Emitter}get onDidChange(){return this._onDidChange.event}register(f,l){let m={selector:f,provider:l,_score:-1,_time:this._clock++};return this._entries.push(m),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,R.toDisposable)(()=>{if(m){let y=this._entries.indexOf(m);y>=0&&(this._entries.splice(y,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),m=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const l=[];for(let m of this._entries)m._score>0&&l.push(m.provider);return l}ordered(f){const l=[];return this._orderedForEach(f,m=>l.push(m.provider)),l}orderedGroups(f){const l=[];let m,y;return this._orderedForEach(f,g=>{m&&y===g._score?m.push(g.provider):(y=g._score,m=[g.provider],l.push(m))}),l}_orderedForEach(f,l){if(!!f){this._updateScores(f);for(const m of this._entries)m._score>0&&l(m)}}_updateScores(f){let l={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===l.language&&this._lastCandidate.uri===l.uri)){this._lastCandidate=l;for(let m of this._entries)if(m._score=(0,P.score)(m.selector,f.uri,f.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(f)),i(m.selector)&&m._score>0){for(let y of this._entries)y._score=0;m._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(f,l){return f._score<l._score?1:f._score>l._score?-1:f._time<l._time?1:f._time>l._time?-1:0}}e.LanguageFeatureRegistry=T;class k{constructor(f,l,m=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=l,this.max=m,this._cache=new I.LRUCache(50,.7)}_key(f){return f.id+(0,D.hash)(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const l=this._key(f),m=this._cache.get(l);return this._clamp(m==null?void 0:m.value)}update(f,l){const m=this._key(f);let y=this._cache.get(m);return y||(y=new C.MovingAverage,this._cache.set(m,y)),y.update(l),this.get(f)}}e.LanguageFeatureRequestDelays=k}),define(ge[80],pe([0,1,2,43,177,141,47]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class S{constructor(_,A){this.language=_,this.id=A}}e.LanguageIdentifier=S;var i;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(i=e.FontStyle||(e.FontStyle={}));var T;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var k;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var E;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(E=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&1792)>>>8}static getFontStyle(_){return(_&14336)>>>11}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){let A=this.getForeground(_),L="mtk"+A,W=this.getFontStyle(_);return W&1&&(L+=" mtki"),W&2&&(L+=" mtkb"),W&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(_,A){const L=this.getForeground(_),W=this.getFontStyle(_);let j=`color: ${A[L]};`;return W&1&&(j+="font-style: italic;"),W&2&&(j+="font-weight: bold;"),W&4&&(j+="text-decoration: underline;"),j}}e.TokenMetadata=f;var l;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(_){const A=h[_];let L=A&&C.iconRegistry.get(A);return L||(console.info("No codicon found for CompletionItemKind "+_),L=C.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(_,A){let L=h[_];return typeof L=="undefined"&&!A&&(L=9),L}}();var m;(function(h){h[h.Deprecated=1]="Deprecated"})(m=e.CompletionItemTag||(e.CompletionItemTag={}));var y;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(y=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var g;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(h){h[h.Auto=1]="Auto",h[h.Manual=2]="Manual"})(v=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function o(h){return h&&p.URI.isUri(h.uri)&&D.Range.isIRange(h.range)&&(D.Range.isIRange(h.originSelectionRange)||D.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=o;var t;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var r;(function(h){h[h.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var s;(function(h){const _=new Map;_.set("file",0),_.set("module",1),_.set("namespace",2),_.set("package",3),_.set("class",4),_.set("method",5),_.set("property",6),_.set("field",7),_.set("constructor",8),_.set("enum",9),_.set("interface",10),_.set("function",11),_.set("variable",12),_.set("constant",13),_.set("string",14),_.set("number",15),_.set("boolean",16),_.set("array",17),_.set("object",18),_.set("key",19),_.set("null",20),_.set("enum-member",21),_.set("struct",22),_.set("event",23),_.set("operator",24),_.set("type-parameter",25);const A=new Map;A.set(0,"file"),A.set(1,"module"),A.set(2,"namespace"),A.set(3,"package"),A.set(4,"class"),A.set(5,"method"),A.set(6,"property"),A.set(7,"field"),A.set(8,"constructor"),A.set(9,"enum"),A.set(10,"interface"),A.set(11,"function"),A.set(12,"variable"),A.set(13,"constant"),A.set(14,"string"),A.set(15,"number"),A.set(16,"boolean"),A.set(17,"array"),A.set(18,"object"),A.set(19,"key"),A.set(20,"null"),A.set(21,"enum-member"),A.set(22,"struct"),A.set(23,"event"),A.set(24,"operator"),A.set(25,"type-parameter");function L(K){return _.get(K)}h.fromString=L;function W(K){return A.get(K)}h.toString=W;function j(K,H){const $=A.get(K);let M=$&&C.iconRegistry.get("symbol-"+$);return M||(console.info("No codicon found for SymbolKind "+K),M=C.Codicon.symbolProperty),`${H?"inline":"block"} ${M.classNames}`}h.toCssClassName=j})(s=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(_){this.value=_}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var n;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var b;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(b=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new R.LanguageFeatureRegistry,e.RenameProviderRegistry=new R.LanguageFeatureRegistry,e.CompletionProviderRegistry=new R.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new R.LanguageFeatureRegistry,e.HoverProviderRegistry=new R.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new R.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new R.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new R.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new R.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new R.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new R.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.LinkProviderRegistry=new R.LanguageFeatureRegistry,e.ColorProviderRegistry=new R.LanguageFeatureRegistry,e.SelectionRangeRegistry=new R.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.TokenizationRegistry=new I.TokenizationRegistryImpl;var w;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(w=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[178],pe([0,1,6,15,4,3,56,71]),function(Z,e,p,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,R.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new I.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(S,i){if(!S)throw new Error("invalid command");if(typeof S=="string"){if(!i)throw new Error("invalid command");return this.registerCommand({id:S,handler:i})}if(S.description){const l=[];for(let y of S.description.args)l.push(y.constraint);const m=S.handler;S.handler=function(y,...g){return(0,D.validateConstraints)(g,l),m(y,...g)}}const{id:T}=S;let k=this._commands.get(T);k||(k=new C.LinkedList,this._commands.set(T,k));let E=k.unshift(S),f=(0,p.toDisposable)(()=>{E();const l=this._commands.get(T);(l==null?void 0:l.isEmpty())&&this._commands.delete(T)});return this._onDidRegisterCommand.fire(T),f}registerCommandAlias(S,i){return e.CommandsRegistry.registerCommand(S,(T,...k)=>T.get(e.ICommandService).executeCommand(i,...k))}getCommand(S){const i=this._commands.get(S);if(!(!i||i.isEmpty()))return P.Iterable.first(i)}getCommands(){const S=new Map;for(const i of this._commands.keys()){const T=this.getCommand(i);T&&S.set(i,T)}return S}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>p.Disposable.None,onDidExecuteCommand:()=>p.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(ge[59],pe([0,1,9,4,10]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let I=R.userAgent||"";const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",R.isMacintosh),C.set("isLinux",R.isLinux),C.set("isWindows",R.isWindows),C.set("isWeb",R.isWeb),C.set("isMacNative",R.isMacintosh&&!R.isWeb),C.set("isEdge",I.indexOf("Edg/")>=0),C.set("isFirefox",I.indexOf("Firefox")>=0),C.set("isChrome",I.indexOf("Chrome")>=0),C.set("isSafari",I.indexOf("Safari")>=0),C.set("isIPad",I.indexOf("iPad")>=0);const P=Object.prototype.hasOwnProperty;var S;(function(h){h[h.False=0]="False",h[h.True=1]="True",h[h.Defined=2]="Defined",h[h.Not=3]="Not",h[h.Equals=4]="Equals",h[h.NotEquals=5]="NotEquals",h[h.And=6]="And",h[h.Regex=7]="Regex",h[h.NotRegex=8]="NotRegex",h[h.Or=9]="Or",h[h.In=10]="In",h[h.NotIn=11]="NotIn",h[h.Greater=12]="Greater",h[h.GreaterEquals=13]="GreaterEquals",h[h.Smaller=14]="Smaller",h[h.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class i{static false(){return k.INSTANCE}static true(){return E.INSTANCE}static has(_){return f.create(_)}static equals(_,A){return l.create(_,A)}static notEquals(_,A){return g.create(_,A)}static regex(_,A){return r.create(_,A)}static in(_,A){return m.create(_,A)}static not(_){return v.create(_)}static and(..._){return a.create(_)}static or(..._){return n.create(_)}static greater(_,A){return d.create(_,A)}static less(_,A){return o.create(_,A)}static deserialize(_,A=!1){if(!!_)return this._deserializeOrExpression(_,A)}static _deserializeOrExpression(_,A){let L=_.split("||");return n.create(L.map(W=>this._deserializeAndExpression(W,A)))}static _deserializeAndExpression(_,A){let L=_.split("&&");return a.create(L.map(W=>this._deserializeOne(W,A)))}static _deserializeOne(_,A){if(_=_.trim(),_.indexOf("!=")>=0){let L=_.split("!=");return g.create(L[0].trim(),this._deserializeValue(L[1],A))}if(_.indexOf("==")>=0){let L=_.split("==");return l.create(L[0].trim(),this._deserializeValue(L[1],A))}if(_.indexOf("=~")>=0){let L=_.split("=~");return r.create(L[0].trim(),this._deserializeRegexValue(L[1],A))}if(_.indexOf(" in ")>=0){let L=_.split(" in ");return m.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const L=_.split(">=");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const L=_.split(">");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const L=_.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const L=_.split("<");return o.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(_)?v.create(_.substr(1).trim()):f.create(_)}static _deserializeValue(_,A){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let L=/^'([^']*)'$/.exec(_);return L?L[1].trim():_}static _deserializeRegexValue(_,A){if((0,p.isFalsyOrWhitespace)(_)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=_.indexOf("/"),W=_.lastIndexOf("/");if(L===W||L<0){if(A)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let j=_.slice(L+1,W),K=_[W+1]==="i"?"i":"";try{return new RegExp(j,K)}catch(H){if(A)throw new Error(`bad regexp-value '${_}', parse error: ${H}`);return console.warn(`bad regexp-value '${_}', parse error: ${H}`),null}}}e.ContextKeyExpr=i;function T(h,_){return h.cmp(_)}class k{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class E{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class f{constructor(_){this.key=_,this.type=2}static create(_){const A=C.get(_);return typeof A=="boolean"?A?E.INSTANCE:k.INSTANCE:new f(_)}cmp(_){return _.type!==this.type?this.type-_.type:b(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return v.create(this.key)}}e.ContextKeyDefinedExpr=f;class l{constructor(_,A){this.key=_,this.value=A,this.type=4}static create(_,A){if(typeof A=="boolean")return A?f.create(_):v.create(_);const L=C.get(_);return typeof L=="boolean"?A===(L?"true":"false")?E.INSTANCE:k.INSTANCE:new l(_,A)}cmp(_){return _.type!==this.type?this.type-_.type:w(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyEqualsExpr=l;class m{constructor(_,A){this.key=_,this.valueKey=A,this.type=10}static create(_,A){return new m(_,A)}cmp(_){return _.type!==this.type?this.type-_.type:w(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}evaluate(_){const A=_.getValue(this.valueKey),L=_.getValue(this.key);return Array.isArray(A)?A.indexOf(L)>=0:typeof L=="string"&&typeof A=="object"&&A!==null?P.call(A,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return y.create(this)}}e.ContextKeyInExpr=m;class y{constructor(_){this._actual=_,this.type=11}static create(_){return new y(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new y(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=y;class g{constructor(_,A){this.key=_,this.value=A,this.type=5}static create(_,A){if(typeof A=="boolean")return A?v.create(_):f.create(_);const L=C.get(_);return typeof L=="boolean"?A===(L?"true":"false")?k.INSTANCE:E.INSTANCE:new g(_,A)}cmp(_){return _.type!==this.type?this.type-_.type:w(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=g;class v{constructor(_){this.key=_,this.type=3}static create(_){const A=C.get(_);return typeof A=="boolean"?A?k.INSTANCE:E.INSTANCE:new v(_)}cmp(_){return _.type!==this.type?this.type-_.type:b(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=v;class d{constructor(_,A){this.key=_,this.value=A,this.type=12}static create(_,A){return new d(_,A)}cmp(_){return _.type!==this.type?this.type-_.type:w(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class u{constructor(_,A){this.key=_,this.value=A,this.type=13}static create(_,A){return new u(_,A)}cmp(_){return _.type!==this.type?this.type-_.type:w(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class o{constructor(_,A){this.key=_,this.value=A,this.type=14}static create(_,A){return new o(_,A)}cmp(_){return _.type!==this.type?this.type-_.type:w(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=o;class t{constructor(_,A){this.key=_,this.value=A,this.type=15}static create(_,A){return new t(_,A)}cmp(_){return _.type!==this.type?this.type-_.type:w(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(_,A){this.key=_,this.regexp=A,this.type=7}static create(_,A){return new r(_,A)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const A=this.regexp?this.regexp.source:"",L=_.regexp?_.regexp.source:"";return A<L?-1:A>L?1:0}equals(_){if(_.type===this.type){const A=this.regexp?this.regexp.source:"",L=_.regexp?_.regexp.source:"";return this.key===_.key&&A===L}return!1}evaluate(_){let A=_.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=r;class s{constructor(_){this._actual=_,this.type=8}static create(_){return new s(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new s(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class a{constructor(_){this.expr=_,this.type=6}static create(_){return a._normalizeArr(_)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const W=T(this.expr[A],_.expr[A]);if(W!==0)return W}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(_.expr[A]))return!1;return!0}return!1}evaluate(_){for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].evaluate(_))return!1;return!0}static _normalizeArr(_){const A=[];let L=!1;for(const W of _)if(!!W){if(W.type===1){L=!0;continue}if(W.type===0)return k.INSTANCE;if(W.type===6){A.push(...W.expr);continue}A.push(W)}if(A.length===0&&L)return E.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];for(A.sort(T);A.length>1;){const W=A[A.length-1];if(W.type!==9)break;A.pop();const j=A.pop(),K=n.create(W.expr.map(H=>a.create([H,j])));K&&(A.push(K),A.sort(T))}return A.length===1?A[0]:new a(A)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let A of this.expr)_.push(...A.keys());return _}map(_){return new a(this.expr.map(A=>A.map(_)))}negate(){let _=[];for(let A of this.expr)_.push(A.negate());return n.create(_)}}e.ContextKeyAndExpr=a;class n{constructor(_){this.expr=_,this.type=9}static create(_){const A=n._normalizeArr(_);if(A.length!==0)return A.length===1?A[0]:new n(A)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const W=T(this.expr[A],_.expr[A]);if(W!==0)return W}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(_.expr[A]))return!1;return!0}return!1}evaluate(_){for(let A=0,L=this.expr.length;A<L;A++)if(this.expr[A].evaluate(_))return!0;return!1}static _normalizeArr(_){let A=[],L=!1;if(_){for(let W=0,j=_.length;W<j;W++){const K=_[W];if(!!K){if(K.type===0){L=!0;continue}if(K.type===1)return[E.INSTANCE];if(K.type===9){A=A.concat(K.expr);continue}A.push(K)}}if(A.length===0&&L)return[k.INSTANCE];A.sort(T)}return A}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let A of this.expr)_.push(...A.keys());return _}map(_){return new n(this.expr.map(A=>A.map(_)))}negate(){let _=[];for(let L of this.expr)_.push(L.negate());const A=L=>L.type===9?L.expr:[L];for(;_.length>1;){const L=_.shift(),W=_.shift(),j=[];for(const K of A(L))for(const H of A(W))j.push(i.and(K,H));_.unshift(i.or(...j))}return _[0]}}e.ContextKeyOrExpr=n;class c extends f{constructor(_,A,L){super(_);this.key=_,this._defaultValue=A,typeof L=="object"?c._info.push(Object.assign(Object.assign({},L),{key:_})):L!==!0&&c._info.push({key:_,description:L,type:A!=null?typeof A:void 0})}static all(){return c._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return i.not(this.key)}isEqualTo(_){return i.equals(this.key,_)}notEqualsTo(_){return i.notEquals(this.key,_)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(h,_){return h<_?-1:h>_?1:0}function w(h,_,A,L){return h<A?-1:h>A?1:_<L?-1:_>L?1:0}}),define(ge[179],pe([0,1,4]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[180],pe([0,1,151,4,11]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function I(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=I;var C;(function(k){k[k.NoneOrRelevance=0]="NoneOrRelevance",k[k.LastUpdatedDate=1]="LastUpdatedDate",k[k.Title=2]="Title",k[k.PublisherName=3]="PublisherName",k[k.InstallCount=4]="InstallCount",k[k.PublishedDate=5]="PublishedDate",k[k.AverageRating=6]="AverageRating",k[k.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var P;(function(k){k[k.Default=0]="Default",k[k.Ascending=1]="Ascending",k[k.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var S;(function(k){k.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var i;(function(k){k[k.None=0]="None",k[k.Install=1]="Install",k[k.Update=2]="Update"})(i=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class T extends Error{constructor(E,f){super(E);this.code=f}}e.ExtensionManagementError=T,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",Z).toString(!0),e.ExtensionsLabel=(0,p.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,p.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(ge[29],pe([0,1,9,4]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function R(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class C{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,k){if(typeof T=="undefined"||T===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof T=="string"||typeof k=="string"){let E=typeof T=="string"?T:T.value,f=typeof k=="string"?k:k.value;return p.equalsIgnoreCase(E,f)}return T._lower===k._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=C;function P(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function S(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[181],pe([0,1,9,29]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(f,l){return f.uuid&&l.uuid?f.uuid===l.uuid:f.id===l.id?!0:(0,p.compareIgnoreCase)(f.id,l.id)===0}e.areSameExtensions=R;class I{constructor(l,m){this.version=m,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof I?R(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=I;function C(f,l){return`${f}.${l}`}e.getExtensionId=C;function P(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function S(f,l){return P(C(f,l))}e.getGalleryExtensionId=S;function i(f,l){const m=[],y=g=>{for(const v of m)if(v.some(d=>R(l(d),l(g))))return v;return null};for(const g of f){const v=y(g);v?v.push(g):m.push([g])}return m}e.groupByExtension=i;function T(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function k(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function E(f){const l=new Set;for(const m of f)m.malicious&&l.add(m.id.id);return l}e.getMaliciousExtensionsSet=E}),define(ge[44],pe([0,1,152,7,2,4,9,15,23]),function(Z,e,p,D,R,I,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");var i;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var T;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash"})(T=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function k(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=k;function E(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=E;function f(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function l(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=l;var m;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(K,H){super(K);this.code=H}}e.FileSystemProviderError=y;function g(j,K){const H=new y(j.toString(),K);return d(H,K),H}e.createFileSystemProviderError=g;function v(j){return j||g((0,p.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=v;function d(j,K){return j.name=K?`${K} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=d;function u(j){if(!j)return m.Unknown;if(j instanceof y)return j.code;const K=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!K)return m.Unknown;switch(K[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=u;function o(j){if(j instanceof c)return j.fileOperationResult;switch(u(j)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var t;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class r{constructor(K,H,$){this.resource=K,this.operation=H,this.target=$}isOperation(K){return this.operation===K}}e.FileOperationEvent=r;var s;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class a{constructor(K,H){this.ignorePathCasing=H,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=K;for(const $ of K)switch($.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set($.resource,$);break}}contains(K,...H){return this.doContains(K,{includeChildren:!1},...H)}affects(K,...H){return this.doContains(K,{includeChildren:!0},...H)}doContains(K,H,...$){var M,U,F,N,O,V;if(!K)return!1;const q=$.length>0;return!!((!q||$.includes(1))&&(((M=this.added)===null||M===void 0?void 0:M.get(K))||H.includeChildren&&((U=this.added)===null||U===void 0?void 0:U.findSuperstr(K)))||(!q||$.includes(0))&&(((F=this.updated)===null||F===void 0?void 0:F.get(K))||H.includeChildren&&((N=this.updated)===null||N===void 0?void 0:N.findSuperstr(K)))||(!q||$.includes(2))&&(((O=this.deleted)===null||O===void 0?void 0:O.findSubstr(K))||H.includeChildren&&((V=this.deleted)===null||V===void 0?void 0:V.findSuperstr(K))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(K){const H=[],$=K===1?this.added:K===0?this.updated:this.deleted;if($)for(const[,M]of $)H.push(M);return H}filter(K){return new a(this.changes.filter(H=>K(H)),this.ignorePathCasing)}}e.FileChangesEvent=a;function n(j,K,H){return!j||!K||j===K||K.length>j.length?!1:(K.charAt(K.length-1)!==D.sep&&(K+=D.sep),H?(0,C.startsWithIgnoreCase)(j,K):j.indexOf(K)===0)}e.isParent=n;class c extends Error{constructor(K,H,$){super(K);this.fileOperationResult=H,this.options=$}static isFileOperationError(K){return K instanceof Error&&!(0,P.isUndefinedOrNull)(K.fileOperationResult)}}e.FileOperationError=c;var b;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_READ_ONLY=5]="FILE_READ_ONLY",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(b=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var w;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(w=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function h(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=h;async function _(j,K){if(!K.canHandleResource(R.URI.from({scheme:j.scheme})))return new Promise(H=>{const $=K.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===j.scheme&&M.added&&($.dispose(),H())})})}e.whenProviderRegistered=_,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class A{static formatSize(K){return(0,P.isNumber)(K)||(K=0),K<A.KB?(0,p.localize)(1,null,K.toFixed(0)):K<A.MB?(0,p.localize)(2,null,(K/A.KB).toFixed(2)):K<A.GB?(0,p.localize)(3,null,(K/A.MB).toFixed(2)):K<A.TB?(0,p.localize)(4,null,(K/A.GB).toFixed(2)):(0,p.localize)(5,null,(K/A.TB).toFixed(2))}}e.ByteSize=A,A.KB=1024,A.MB=A.KB*A.KB,A.GB=A.MB*A.KB,A.TB=A.GB*A.KB;var L;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(L=e.Arch||(e.Arch={}));function W(j){return{maxFileSize:j===0?300*A.MB:16*A.GB,maxHeapSize:j===0?700*A.MB:2*700*A.MB}}e.getPlatformLimits=W}),define(ge[81],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...R){this._entries=new Map;for(let[I,C]of R)this.set(I,C)}set(R,I){const C=this._entries.get(R);return this._entries.set(R,I),C}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=p}),define(ge[182],pe([0,1,18,175,107,4,81,19]),function(Z,e,p,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class i extends Error{constructor(l){super("cyclic dependency between services");this.message=l.toString()}}class T{constructor(l=new C.ServiceCollection,m=!1,y){this._activeInstantiations=new Set,this._services=l,this._strict=m,this._parent=y,this._services.set(I.IInstantiationService,this)}createChild(l){return new T(l,this._strict,this)}invokeFunction(l,...m){let y=E.traceInvocation(l),g=!1;try{return l({get:(d,u)=>{if(g)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(d,y);if(!o&&u!==I.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return o}},...m)}finally{g=!0,y.stop()}}createInstance(l,...m){let y,g;return l instanceof R.SyncDescriptor?(y=E.traceCreation(l.ctor),g=this._createInstance(l.ctor,l.staticArguments.concat(m),y)):(y=E.traceCreation(l),g=this._createInstance(l,m,y)),y.stop(),g}_createInstance(l,m=[],y){let g=I._util.getServiceDependencies(l).sort((u,o)=>u.index-o.index),v=[];for(const u of g){let o=this._getOrCreateServiceInstance(u.id,y);if(!o&&this._strict&&!u.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${u.id}.`);v.push(o)}let d=g.length>0?g[0].index:m.length;if(m.length!==d){console.warn(`[createInstance] First service dependency of ${l.name} at position ${d+1} conflicts with ${m.length} static arguments`);let u=d-m.length;u>0?m=m.concat(new Array(u)):m=m.slice(0,d)}return new l(...[...m,...v])}_setServiceInstance(l,m){if(this._services.get(l)instanceof R.SyncDescriptor)this._services.set(l,m);else if(this._parent)this._parent._setServiceInstance(l,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let m=this._services.get(l);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):m}_getOrCreateServiceInstance(l,m){let y=this._getServiceInstanceOrDescriptor(l);return y instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,y,m.branch(l,!0)):(m.branch(l,!1),y)}_safeCreateAndCacheServiceInstance(l,m,y){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,m,y)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,m,y){const g=new D.Graph(u=>u.id.toString());let v=0;const d=[{id:l,desc:m,_trace:y}];for(;d.length;){const u=d.pop();if(g.lookupOrInsertNode(u),v++>1e3)throw new i(g);for(let o of I._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${l} depends on ${o.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:o.id,desc:t,_trace:u._trace.branch(o.id,!0)};g.insertEdge(u,r),d.push(r)}}}for(;;){const u=g.roots();if(u.length===0){if(!g.isEmpty())throw new i(g);break}for(const{data:o}of u){if(this._getServiceInstanceOrDescriptor(o.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}g.removeNode(o)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,m,y=[],g,v){if(this._services.get(l)instanceof R.SyncDescriptor)return this._createServiceInstance(m,y,g,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,m,y,g,v);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(l,m=[],y,g){if(y){const v=new P.IdleValue(()=>this._createInstance(l,m,g));return new Proxy(Object.create(null),{get(d,u){if(u in d)return d[u];let o=v.value,t=o[u];return typeof t!="function"||(t=t.bind(o),d[u]=t),t},set(d,u,o){return v.value[u]=o,!0}})}else return this._createInstance(l,m,g)}}e.InstantiationService=T;var k;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(k||(k={}));class E{constructor(l,m){this.type=l,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return S?new E(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(l){return S?new E(0,l.name):E._None}branch(l,m){let y=new E(2,l.toString());return this._dep.push([l,m,y]),y}stop(){let l=Date.now()-this._start;E._totals+=l;let m=!1;function y(v,d){let u=[],o=new Array(v+1).join("	");for(const[t,r,s]of d._dep)if(r&&s){m=!0,u.push(`${o}CREATES -> ${t}`);let a=y(v+1,s);a&&u.push(a)}else u.push(`${o}uses -> ${t}`);return u.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(l>2||m)&&console.log(g.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(ge[13],pe([0,1,4,6,10,3,58]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function P(){return new Date().toISOString()}var S;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class i extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=i;class T extends i{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...t){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([o,...t]))}debug(o,...t){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([o,...t]))}info(o,...t){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([o,...t]))}warn(o,...t){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([o,...t]))}error(o,...t){if(this.checkLogLevel(S.Error))if(o instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=o.stack,this.log(S.Error,this.format(r))}else this.log(S.Error,this.format([o,...t]))}critical(o,...t){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([o,...t]))}flush(){}format(o){let t="";for(let r=0;r<o.length;r++){let s=o[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(a){}t+=(r>0?" ":"")+s}return t}}e.AbstractMessageLogger=T;class k extends i{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!R.isWindows}trace(o,...t){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,o,...t):console.log(`[main ${P()}]`,o,...t))}debug(o,...t){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,o,...t):console.log(`[main ${P()}]`,o,...t))}info(o,...t){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,o,...t):console.log(`[main ${P()}]`,o,...t))}warn(o,...t){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,o,...t):console.warn(`[main ${P()}]`,o,...t))}error(o,...t){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,o,...t):console.error(`[main ${P()}]`,o,...t))}critical(o,...t){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,o,...t):console.error(`[main ${P()}]`,o,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class E extends i{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...t){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",o,...t)}debug(o,...t){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...t)}info(o,...t){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",o,...t)}warn(o,...t){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",o,...t)}error(o,...t){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",o,...t)}critical(o,...t){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...t)}dispose(){}flush(){}}e.ConsoleLogger=E;class f extends i{constructor(o,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(t)}trace(o,...t){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(o),...t])}debug(o,...t){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(o),...t])}info(o,...t){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(o),...t])}warn(o,...t){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(o),...t])}error(o,...t){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(o),...t])}critical(o,...t){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(o),...t])}extractMessage(o){return typeof o=="string"?o:(0,C.toErrorMessage)(o,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class l extends i{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const t of this.logServices)t.setLevel(o);super.setLevel(o)}trace(o,...t){for(const r of this.logServices)r.trace(o,...t)}debug(o,...t){for(const r of this.logServices)r.debug(o,...t)}info(o,...t){for(const r of this.logServices)r.info(o,...t)}warn(o,...t){for(const r of this.logServices)r.warn(o,...t)}error(o,...t){for(const r of this.logServices)r.error(o,...t)}critical(o,...t){for(const r of this.logServices)r.critical(o,...t)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=l;class m extends D.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...t){this.logger.trace(o,...t)}debug(o,...t){this.logger.debug(o,...t)}info(o,...t){this.logger.info(o,...t)}warn(o,...t){this.logger.warn(o,...t)}error(o,...t){this.logger.error(o,...t)}critical(o,...t){this.logger.critical(o,...t)}flush(){this.logger.flush()}}e.LogService=m;class y{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(o){}getLevel(){return S.Info}trace(o,...t){}debug(o,...t){}info(o,...t){}warn(o,...t){}error(o,...t){}critical(o,...t){}dispose(){}flush(){}}e.NullLogService=y;function g(u){if(u.verbose)return S.Trace;if(typeof u.logLevel=="string"){const o=v(u.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function v(u){switch(u){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=v;function d(u){switch(u){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=d}),define(ge[108],pe([0,1,13,44]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function R(S,i,T,k){try{const E=await new Promise((f,l)=>{Z(["spdlog"],f,l)});return E.setAsyncMode(8192,500),E.createRotatingLoggerAsync(S,i,T,k)}catch(E){console.error(E)}return null}function I(S,i,T,k){return Z.__$__nodeRequire("spdlog").createRotatingLogger(S,i,T,k)}e.createRotatingLogger=I;function C(S,i,T){switch(i){case p.LogLevel.Trace:S.trace(T);break;case p.LogLevel.Debug:S.debug(T);break;case p.LogLevel.Info:S.info(T);break;case p.LogLevel.Warning:S.warn(T);break;case p.LogLevel.Error:S.error(T);break;case p.LogLevel.Critical:S.critical(T);break;default:throw new Error("Invalid log level")}}class P extends p.AbstractMessageLogger{constructor(i,T,k,E){super();this.name=i,this.filepath=T,this.rotating=k,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){const i=this.rotating?6:1,T=30/i*D.ByteSize.MB;return R(this.name,this.filepath,T,i).then(k=>{if(k){this._logger=k,this._logger.setLevel(this.getLevel());for(const{level:E,message:f}of this.buffer)C(this._logger,E,f);this.buffer=[]}})}log(i,T){this._logger?C(this._logger,i,T):this.getLevel()<=i&&this.buffer.push({level:i,message:T})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(ge[109],pe([0,1,4,153,74]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function i(l,m){return m-l}S.compare=i;const T=Object.create(null);T[S.Error]=(0,D.localize)(0,null),T[S.Warning]=(0,D.localize)(1,null),T[S.Info]=(0,D.localize)(2,null);function k(l){return T[l]||""}S.toString=k;function E(l){switch(l){case R.default.Error:return S.Error;case R.default.Warning:return S.Warning;case R.default.Info:return S.Info;case R.default.Ignore:return S.Hint}}S.fromSeverity=E;function f(l){switch(l){case S.Error:return R.default.Error;case S.Warning:return R.default.Warning;case S.Info:return R.default.Info;case S.Hint:return R.default.Ignore}}S.toSeverity=f}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(S){const i="";function T(E){return k(E,!0)}S.makeKey=T;function k(E,f){let l=[i];return E.source?l.push(E.source.replace("\xA6","\\\xA6")):l.push(i),E.code?typeof E.code=="string"?l.push(E.code.replace("\xA6","\\\xA6")):l.push(E.code.value.replace("\xA6","\\\xA6")):l.push(i),E.severity!==void 0&&E.severity!==null?l.push(C.toString(E.severity)):l.push(i),E.message&&f?l.push(E.message.replace("\xA6","\\\xA6")):l.push(i),E.startLineNumber!==void 0&&E.startLineNumber!==null?l.push(E.startLineNumber.toString()):l.push(i),E.startColumn!==void 0&&E.startColumn!==null?l.push(E.startColumn.toString()):l.push(i),E.endLineNumber!==void 0&&E.endLineNumber!==null?l.push(E.endLineNumber.toString()):l.push(i),E.endColumn!==void 0&&E.endColumn!==null?l.push(E.endColumn.toString()):l.push(i),l.push(i),l.join("\xA6")}S.makeKeyOptionalMessage=k})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,p.createDecorator)("markerService")}),define(ge[183],pe([0,1,74,4,3]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=p.default,e.INotificationService=(0,D.createDecorator)("notificationService");var I;(function(i){i[i.WORKSPACE=0]="WORKSPACE",i[i.GLOBAL=1]="GLOBAL"})(I=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(i){i[i.OFF=0]="OFF",i[i.SILENT=1]="SILENT",i[i.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new S,this.onDidClose=R.Event.None,this.onDidChangeVisibility=R.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=P;class S{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=S}),define(ge[184],pe([0,1,10,36,11,24]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(p.isWeb||typeof Z=="undefined"||typeof Z.__$__nodeRequire!="function")C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.55.0-dev",nameShort:p.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:p.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser"]});else{const P=(0,I.dirname)(R.FileAccess.asFileUri("",Z));C=Z.__$__nodeRequire((0,I.joinPath)(P,"product.json").fsPath);const S=Z.__$__nodeRequire((0,I.joinPath)(P,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`}),Object.assign(C,{version:S.version})}e.default=C});var je=this&&this.__decorate||function(Z,e,p,D){var R=arguments.length,I=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,p):D,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(Z,e,p,D);else for(var P=Z.length-1;P>=0;P--)(C=Z[P])&&(I=(R<3?C(I):R>3?C(e,p,I):C(e,p))||I);return R>3&&I&&Object.defineProperty(e,p,I),I},Ue=this&&this.__param||function(Z,e){return function(p,D){e(p,D,Z)}};define(ge[110],pe([0,1,4,21,6,19]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,p.createDecorator)("progressService");var C;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let S=class extends R.Disposable{constructor(k,E){super();this.deferred=new I.DeferredPromise,E.withProgress(k,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,R.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};S=je([Ue(1,e.IProgressService)],S),e.UnmanagedProgress=S;class i extends R.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new R.DisposableStore)}start(k){this.stop();const E=++this.currentOperationId,f=new D.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{E===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,R.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,R.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,R.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:E,token:f.token,stop:()=>this.doStop(E),isCurrent:()=>this.currentOperationId===E}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=i,e.IEditorProgressService=(0,p.createDecorator)("editorProgressService")}),define(ge[40],pe([0,1,15,52]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(C,P){D.ok(p.isString(C)),D.ok(p.isObject(P)),D.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,P)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new R}),define(ge[111],pe([0,1,40,3]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class I{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,i){this.schemasById[R(S)]=i,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new I;p.Registry.add(e.Extensions.JSONContribution,C)}),define(ge[82],pe([0,1,150,3,40,15,111]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=R.Registry.as(C.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(g,v=!0){this.registerConfigurations([g],v)}registerConfigurations(g,v=!0){const d=[];g.forEach(u=>{d.push(...this.validateAndRegisterProperties(u,v)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(g){const v=[],d=u=>{if(u.properties)for(const o in u.properties)v.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,u.properties[o]);u.allOf&&u.allOf.forEach(o=>d(o))};for(const u of g){d(u);const o=this.configurationContributors.indexOf(u);o!==-1&&this.configurationContributors.splice(o,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}registerDefaultConfigurations(g){const v=[],d=[];for(const u of g)for(const o in u)if(v.push(o),e.OVERRIDE_PROPERTY_PATTERN.test(o)){this.defaultValues[o]=Object.assign(Object.assign({},this.defaultValues[o]||{}),u[o]);const t={type:"object",default:this.defaultValues[o],description:p.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId};d.push(k(o)),this.configurationProperties[o]=t,this.defaultLanguageConfigurationOverridesNode.properties[o]=t}else{this.defaultValues[o]=u[o];const t=this.configurationProperties[o];t&&(this.updatePropertyDefaultValue(o,t),this.updateSchema(o,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterDefaultConfigurations(g){const v=[];for(const d of g)for(const u in d)if(v.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const o=this.configurationProperties[u];o&&(this.updatePropertyDefaultValue(u,o),this.updateSchema(u,o))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const v of g)this.overrideIdentifiers.add(v);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(g,v=!0,d=3){d=I.isUndefinedOrNull(g.scope)?d:g.scope;let u=[],o=g.properties;if(o)for(let r in o){if(v&&l(r)){delete o[r];continue}const s=o[r];if(this.updatePropertyDefaultValue(r,s),e.OVERRIDE_PROPERTY_PATTERN.test(r)?s.scope=void 0:s.scope=I.isUndefinedOrNull(s.scope)?d:s.scope,o[r].hasOwnProperty("included")&&!o[r].included){this.excludedConfigurationProperties[r]=o[r],delete o[r];continue}else this.configurationProperties[r]=o[r];!o[r].deprecationMessage&&o[r].markdownDeprecationMessage&&(o[r].deprecationMessage=o[r].markdownDeprecationMessage),u.push(r)}let t=g.allOf;if(t)for(let r of t)u.push(...this.validateAndRegisterProperties(r,v,d));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(g){const v=d=>{let u=d.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let o=d.allOf;o&&o.forEach(v)};v(g)}updateSchema(g,v){switch(e.allSettings.properties[g]=v,v.scope){case 1:e.applicationSettings.properties[g]=v;break;case 2:e.machineSettings.properties[g]=v;break;case 6:e.machineOverridableSettings.properties[g]=v;break;case 3:e.windowSettings.properties[g]=v;break;case 4:e.resourceSettings.properties[g]=v;break;case 5:e.resourceSettings.properties[g]=v,this.resourceLanguageSettingsSchema.properties[g]=v;break}}removeFromSchema(g,v){switch(delete e.allSettings.properties[g],v.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const v=`[${g}]`,d={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(v,d),e.allSettings.properties[v]=d,e.applicationSettings.properties[v]=d,e.machineSettings.properties[v]=d,e.machineOverridableSettings.properties[v]=d,e.windowSettings.properties[v]=d,e.resourceSettings.properties[v]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,v){let d=this.defaultValues[g];I.isUndefined(d)&&(d=v.default),I.isUndefined(d)&&(d=E(v.type)),v.default=d}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function k(y){return y.substring(1,y.length-1)}e.overrideIdentifierFromKey=k;function E(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const f=new i;R.Registry.add(e.Extensions.Configuration,f);function l(y){return y.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(y)?p.localize(5,null,y):f.getConfigurationProperties()[y]!==void 0?p.localize(6,null,y):null:p.localize(4,null)}e.validateProperty=l;function m(){const y=[],g=f.getConfigurationProperties();for(const v of Object.keys(g))y.push([v,g[v].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=m}),define(ge[83],pe([0,1,22,15,2,40,4,82]),function(Z,e,p,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function S(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=S;var i;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(i=e.ConfigurationTarget||(e.ConfigurationTarget={}));function T(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=T;function k(r,s){const a=s?r?s.keys.filter(A=>r.keys.indexOf(A)===-1):[...s.keys]:[],n=r?s?r.keys.filter(A=>s.keys.indexOf(A)===-1):[...r.keys]:[],c=[];if(s&&r){for(const A of r.keys)if(s.keys.indexOf(A)!==-1){const L=g(r.contents,A),W=g(s.contents,A);p.equals(L,W)||c.push(A)}}const b=[],w=A=>{const L={};for(const W of A)for(const j of W.identifiers)L[o(j)]=W;return L},h=s?w(s.overrides):{},_=r?w(r.overrides):{};if(Object.keys(h).length)for(const A of a){const L=h[A];L&&b.push([(0,P.overrideIdentifierFromKey)(A),L.keys])}if(Object.keys(_).length)for(const A of n){const L=_[A];L&&b.push([(0,P.overrideIdentifierFromKey)(A),L.keys])}if(Object.keys(h).length&&Object.keys(_).length)for(const A of c){const L=_[A],W=h[A];if(L&&W){const j=k({contents:L.contents,keys:L.keys,overrides:[]},{contents:W.contents,keys:W.keys,overrides:[]});b.push([(0,P.overrideIdentifierFromKey)(A),[...j.added,...j.removed,...j.updated]])}}return{added:a,removed:n,updated:c,overrides:b}}e.compare=k;function E(r,s){const a=[];for(const n of Object.keys(r))if(P.OVERRIDE_PROPERTY_PATTERN.test(n)){const c={};for(const b in r[n])c[b]=r[n][b];a.push({identifiers:[(0,P.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(c),contents:f(c,s)})}return a}e.toOverrides=E;function f(r,s){const a=Object.create(null);for(let n in r)l(a,n,r[n],s);return a}e.toValuesTree=f;function l(r,s,a,n){const c=s.split("."),b=c.pop();let w=r;for(let h=0;h<c.length;h++){let _=c[h],A=w[_];switch(typeof A){case"undefined":A=w[_]=Object.create(null);break;case"object":break;default:n(`Ignoring ${s} as ${c.slice(0,h+1).join(".")} is ${JSON.stringify(A)}`);return}w=A}if(typeof w=="object"&&w!==null)try{w[b]=a}catch(h){n(`Ignoring ${s} as ${c.join(".")} is ${JSON.stringify(w)}`)}else n(`Ignoring ${s} as ${c.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=l;function m(r,s){const a=s.split(".");y(r,a)}e.removeFromValueTree=m;function y(r,s){const a=s.shift();if(s.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const n=r[a];typeof n=="object"&&!Array.isArray(n)&&(y(n,s),Object.keys(n).length===0&&delete r[a])}}function g(r,s,a){function n(w,h){let _=w;for(const A of h){if(typeof _!="object"||_===null)return;_=_[A]}return _}const c=s.split("."),b=n(r,c);return typeof b=="undefined"?a:b}e.getConfigurationValue=g;function v(r,s,a){Object.keys(s).forEach(n=>{n!=="__proto__"&&(n in r?D.isObject(r[n])&&D.isObject(s[n])?v(r[n],s[n],a):a&&(r[n]=s[n]):r[n]=s[n])})}e.merge=v;function d(){const r=I.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=d;function u(){const r=Object.create(null),s=I.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let a in s){let n=s[a].default;l(r,a,n,c=>console.error(`Conflict in default settings: ${c}`))}return r}e.getDefaultValues=u;function o(r){return`[${r}]`}e.keyFromOverrideIdentifier=o;function t(r,s,a){const n=r.inspect(s),c=r.inspect(a);return typeof n.userValue!="undefined"||typeof n.workspaceValue!="undefined"||typeof n.workspaceFolderValue!="undefined"?n.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:n.defaultValue}e.getMigratedSettingValue=t}),define(ge[185],pe([0,1,55,23,12,15,22,2,82,83,40,6,3]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,i.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const a of R.distinct([...Object.keys(this.contents),...Object.keys(r)])){let n=this.contents[a],c=r[a];c&&(typeof n=="object"&&typeof c=="object"?(n=C.deepClone(n),this.mergeContents(n,c)):n=c),s[a]=n}return new f(s,this.keys,this.overrides)}merge(...t){const r=C.deepClone(this.contents),s=C.deepClone(this.overrides),a=[...this.keys];for(const n of t){this.mergeContents(r,n.contents);for(const c of n.overrides){const[b]=s.filter(w=>R.equals(w.identifiers,c.identifiers));b?this.mergeContents(b.contents,c.contents):s.push(C.deepClone(c))}for(const c of n.keys)a.indexOf(c)===-1&&a.push(c)}return new f(r,a,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&I.isObject(t[s])&&I.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=C.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,i.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=f;class l extends f{constructor(){const t=(0,i.getDefaultValues)(),r=(0,i.getConfigurationKeys)(),s=[];for(const a of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(a)&&s.push({identifiers:[(0,S.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,i.toValuesTree)(t[a],n=>console.error(`Conflict in default settings file: ${n}`))});super(t,r,s)}}e.DefaultConfigurationModel=l;class m{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get errors(){return this._parseErrors}parseContent(t){if(!I.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new f(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},s=null,a=[],n=[],c=[];function b(h){Array.isArray(a)?a.push(h):s&&(a[s]=h)}let w={onObjectBegin:()=>{let h={};b(h),n.push(a),a=h,s=null},onObjectProperty:h=>{s=h},onObjectEnd:()=>{a=n.pop()},onArrayBegin:()=>{let h=[];b(h),n.push(a),a=h,s=null},onArrayEnd:()=>{a=n.pop()},onLiteralValue:b,onError:(h,_,A)=>{c.push({error:h,offset:_,length:A})}};if(t)try{p.visit(t,w),r=a[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return r}doParseRaw(t){if(this._scopes){const n=T.Registry.as(S.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,n,!0,this._scopes)}const r=(0,i.toValuesTree)(t,n=>console.error(`Conflict in settings file ${this._name}: ${n}`)),s=Object.keys(t),a=(0,i.toOverrides)(t,n=>console.error(`Conflict in settings file ${this._name}: ${n}`));return{contents:r,keys:s,overrides:a}}filterByScope(t,r,s,a){const n={};for(let c in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(c)&&s)n[c]=this.filterByScope(t[c],r,!1,a);else{const b=this.getScope(c,r);(b===void 0||a.indexOf(b)!==-1)&&(n[c]=t[c])}return n}getScope(t,r){const s=r[t];return s?typeof s.scope!="undefined"?s.scope:3:void 0}}e.ConfigurationModelParser=m;class y extends k.Disposable{constructor(t,r,s,a){super();this.userSettingsResource=t,this.scopes=r,this.fileService=a,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(E.Event.filter(this.fileService.onDidFilesChange,n=>n.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new f}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=y;class g{constructor(t,r,s=new f,a=new f,n=new D.ResourceMap,c=new f,b=new D.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=n,this._memoryConfiguration=c,this._memoryConfigurationByResource=b,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new f,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,r===void 0?a.removeValue(t):a.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const a=this.getConsolidateConfigurationModel(r,s),n=this.getFolderConfigurationModelForResource(r.resource,s),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,b=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),h=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),_=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),A=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=n?r.overrideIdentifier?n.freeze().override(r.overrideIdentifier).getValue(t):n.freeze().getValue(t):void 0,W=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(t):c.getValue(t),j=a.getValue(t),K=R.distinct(R.flatten(a.overrides.map(H=>H.identifiers))).filter(H=>a.getOverrideValue(t,H)!==void 0);return{defaultValue:b,userValue:w,userLocalValue:h,userRemoteValue:_,workspaceValue:A,workspaceFolderValue:L,memoryValue:W,value:j,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:h!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:n==null?void 0:n.freeze().getValue(t),override:r.overrideIdentifier?n==null?void 0:n.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:c.getValue(t),override:r.overrideIdentifier?c.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(a=>S.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const n=(0,S.overrideIdentifierFromKey)(a),c=this._defaultConfiguration.getKeysForOverrideIdentifier(n),b=t.getKeysForOverrideIdentifier(n),w=[...b.filter(h=>c.indexOf(h)===-1),...c.filter(h=>b.indexOf(h)===-1),...c.filter(h=>!C.equals(this._defaultConfiguration.override(n).getValue(h),t.override(n).getValue(h)))];return[n,w]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:a,overrides:n}=(0,i.compare)(this.localUserConfiguration,t),c=[...r,...s,...a];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:n}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:a,overrides:n}=(0,i.compare)(this.remoteUserConfiguration,t);let c=[...r,...s,...a];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:n}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:a,overrides:n}=(0,i.compare)(this.workspaceConfiguration,t);let c=[...r,...s,...a];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:n}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:a,updated:n,removed:c,overrides:b}=(0,i.compare)(s,r);let w=[...a,...n,...c];return(w.length||!s)&&this.updateFolderConfiguration(t,r),{keys:w,overrides:b}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:a,removed:n,overrides:c}=(0,i.compare)(r,void 0);return{keys:[...s,...a,...n],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const a=r.getFolder(t);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const n=this._memoryConfigurationByResource.get(t);n&&(s=s.merge(n))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(r=s.merge(a),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:a,keys:n}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:a,keys:n}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),n=t.folders.reduce((c,b)=>(c.set(P.URI.revive(b[0]),this.parseConfigurationModel(b[1])),c),new D.ResourceMap);return new g(r,s,new f,a,n,new f,new D.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=g;function v(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,r=new Map;for(const a of o)a.keys.forEach(n=>t.add(n)),a.overrides.forEach(([n,c])=>{const b=(0,D.getOrSet)(r,n,new Set);c.forEach(w=>b.add(w))});const s=[];return r.forEach((a,n)=>s.push([n,[...a.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=v;class d{constructor(t,r,s,a){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const n=new Set;t.keys.forEach(b=>n.add(b)),t.overrides.forEach(([,b])=>b.forEach(w=>n.add(w))),this.affectedKeys=[...n.values()];const c=new f;this.affectedKeys.forEach(b=>c.setValue(b,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,n=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!C.equals(a,n)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,i.toValuesTree)({[r]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(t=t[a],!t)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=d;class u extends d{constructor(t,r,s,a){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=u}),define(ge[112],pe([0,1,4]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var D;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(C,P=D.Unknown,S){super(C);this._message=C,this._code=P,this._detail=S,this.isHandled=P===D.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(C){return C instanceof R&&C._code===D.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof R&&C._code===D.NoResolverFound}static isHandled(C){return C instanceof R&&C.isHandled}}e.RemoteAuthorityResolverError=R}),define(ge[113],pe([0,1,11]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function D(I){return I.scheme===p.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=D;function R(I){if(!!I){const C=I.indexOf("+");return C<0?I:I.substr(0,C)}}e.getRemoteName=R}),define(ge[186],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((R,I)=>Z(["vsda"],R,I))}async sign(R){try{const I=await this.vsda(),C=new I.signer;if(C)return C.sign(R)}catch(I){}return R}}e.SignService=p}),define(ge[187],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class p{constructor(R){this._callback=R,this._terminalBufferMap=new Map}dispose(){for(const R of this._terminalBufferMap.values())R.dispose()}startBuffering(R,I,C=5){let P;return P=I(S=>{const i=typeof S=="string"?S:S.data;let T=this._terminalBufferMap.get(R);if(T){T.data.push(i);return}const k=setTimeout(()=>this._flushBuffer(R),C);T={data:[i],timeoutId:k,dispose:()=>{clearTimeout(k),this._flushBuffer(R),P.dispose()}},this._terminalBufferMap.set(R,T)}),P}stopBuffering(R){const I=this._terminalBufferMap.get(R);I&&I.dispose()}_flushBuffer(R){const I=this._terminalBufferMap.get(R);I&&(this._terminalBufferMap.delete(R),this._callback(R,I.data.join("")))}}e.TerminalDataBufferer=p}),define(ge[188],pe([0,1,48,7,25,15,22,10]),function(Z,e,p,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function S(){const T=/(\d+)\.(\d+)\.(\d+)/g.exec(p.release());let k=0;return T&&T.length===4&&(k=parseInt(T[3])),k}e.getWindowsBuildNumber=S;async function i(T,k,E,f=process.env){if(D.isAbsolute(T))return await(0,R.exists)(T)?T:void 0;if(k===void 0&&(k=process.cwd()),D.dirname(T)!=="."){const g=D.join(k,T);return await(0,R.exists)(g)?g:void 0}const m=(0,C.getCaseInsensitive)(f,"PATH");if(E===void 0&&(0,I.isString)(m)&&(E=m.split(D.delimiter)),E===void 0||E.length===0){const g=D.join(k,T);return await(0,R.exists)(g)?g:void 0}for(let g of E){let v;if(D.isAbsolute(g)?v=D.join(g,T):v=D.join(k,g,T),await(0,R.exists)(v))return v;if(P.isWindows){let d=v+".com";if(await(0,R.exists)(d)||(d=v+".exe",await(0,R.exists)(d)))return d}}const y=D.join(k,T);return await(0,R.exists)(y)?y:void 0}e.findExecutable=i}),define(ge[189],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(D){D.DARK="dark",D.LIGHT="light",D.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(ge[190],pe([0,1,4,6,40,3,189,47]),function(Z,e,p,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,p.createDecorator)("themeService");var S;(function(y){function g(v){return v&&typeof v=="object"&&typeof v.id=="string"}y.isThemeColor=g})(S=e.ThemeColor||(e.ThemeColor={}));function i(y){return{id:y}}e.themeColorFromId=i;var T;(function(y){function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}y.isThemeIcon=g;const v=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function d(t){const r=v.exec(t);if(!!r){let[,s]=r;return{id:s}}}y.fromString=d;function u(t,r){let s=t.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),r&&(s=`${s}~${r}`),{id:s}}y.modify=u;function o(t,r){var s,a;return t.id===r.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((a=r.color)===null||a===void 0?void 0:a.id)}y.isEqual=o,y.asClassNameArray=P.CSSIcon.asClassNameArray,y.asClassName=P.CSSIcon.asClassName,y.asCSSSelector=P.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function k(y){switch(y){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,D.toDisposable)(()=>{const v=this.themingParticipants.indexOf(g);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new E;R.Registry.add(e.Extensions.ThemingContribution,f);function l(y){return f.onColorThemeChange(y)}e.registerThemingParticipant=l;class m extends D.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,v){let d=this.theme.getColor(g);return d&&v&&(d=v(d,this.theme)),d?d.toString():null}}e.Themable=m}),define(ge[191],pe([0,1,40,190,3,154,111,19,47]),function(Z,e,p,D,R,I,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class i{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,I.localize)(0,null)},fontCharacter:{type:"string",description:(0,I.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${S.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(g,v,d,u){const o=this.iconsById[g];if(o){if(d&&!o.description){o.description=d,this.iconSchema.properties[g].markdownDescription=`${d} $(${g})`;const s=this.iconReferenceSchema.enum.indexOf(g);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=d),this._onDidChange.fire()}return o}let t={id:g,description:d,defaults:v,deprecationMessage:u};this.iconsById[g]=t;let r={$ref:"#/definitions/icons"};return u&&(r.deprecationMessage=u),d&&(r.markdownDescription=`${d}: $(${g})`),this.iconSchema.properties[g]=r,this.iconReferenceSchema.enum.push(g),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:g}}deregisterIcon(g){delete this.iconsById[g],delete this.iconSchema.properties[g];const v=this.iconReferenceSchema.enum.indexOf(g);v!==-1&&(this.iconReferenceSchema.enum.splice(v,1),this.iconReferenceSchema.enumDescriptions.splice(v,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(g=>this.iconsById[g])}getIcon(g){return this.iconsById[g]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(g,v){const d=this.iconFontsById[g];if(d)return d;let u={id:g,definition:v};return this.iconFontsById[g]=u,this._onDidChange.fire(),u}deregisterIconFont(g){delete this.iconFontsById[g]}getIconFonts(){return Object.keys(this.iconFontsById).map(g=>this.iconFontsById[g])}getIconFont(g){return this.iconFontsById[g]}toString(){const g=(o,t)=>o.id.localeCompare(t.id),v=o=>{for(;D.ThemeIcon.isThemeIcon(o.defaults);)o=this.iconsById[o.defaults.id];return`codicon codicon-${o?o.id:""}`};let d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(o=>this.iconsById[o]);for(const o of u.filter(t=>!!t.description).sort(g))d.push(`|<i class="${v(o)}"></i>|${o.id}|${D.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const o of u.filter(t=>!D.ThemeIcon.isThemeIcon(t.defaults)).sort(g))d.push(`|<i class="${v(o)}"></i>|${o.id}|`);return d.join(`
`)}}const T=new i;p.Registry.add(e.Extensions.IconContribution,T);function k(y,g,v,d){return T.registerIcon(y,g,v,d)}e.registerIcon=k;function E(){return T}e.getIconRegistry=E;function f(){for(const y of S.iconRegistry.all)T.registerIcon(y.id,y.definition,y.description);S.iconRegistry.onDidRegister(y=>T.registerIcon(y.id,y.definition,y.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let l=p.Registry.as(C.Extensions.JSONContribution);l.registerSchema(e.iconsSchemaId,T.getIconSchema());const m=new P.RunOnceScheduler(()=>l.notifySchemaChanged(e.iconsSchemaId),200);T.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.widgetClose=k("widget-close",S.Codicon.close,(0,I.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",S.Codicon.arrowUp,(0,I.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",S.Codicon.arrowDown,(0,I.localize)(4,null)),e.syncing=D.ThemeIcon.modify(S.Codicon.sync,"spin")}),define(ge[60],pe([0,1,2,24,4,23]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");var C;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function P(E){const f=E;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=P;function S(E){const f=E;return!!(f&&typeof f=="object"&&p.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=S;class i{constructor(f,l,m,y){this._id=f,this._configuration=m,this._ignorePathCasing=y,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=i;class T{constructor(f,l){this.raw=l,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,D.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function k(E){return new T({uri:E,index:0,name:(0,D.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=k}),define(ge[114],pe([0,1,4,155,60,2,10,7,24,130,55,11,76,30,113]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y($){return(typeof $=="string"?(0,P.extname)($):(0,S.extname)($))===m}e.hasWorkspaceFileExtension=y,e.IWorkspacesService=(0,p.createDecorator)("workspacesService");function g($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=g;function v($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=v;function d($){return $.hasOwnProperty("fileUri")}e.isRecentFile=d;function u($){const M=$;return typeof(M==null?void 0:M.id)=="string"&&I.URI.isUri(M.uri)}e.isSingleFolderWorkspaceIdentifier=u;function o($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=o;function t($){const M=$;return typeof(M==null?void 0:M.id)=="string"&&I.URI.isUri(M.configPath)}e.isWorkspaceIdentifier=t;function r($){const M=$;if(M==null?void 0:M.uri)return{id:M.id,uri:I.URI.revive(M.uri)};const U=$;if(U==null?void 0:U.configPath)return{id:U.id,configPath:I.URI.revive(U.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=r;function s($,M){return S.extUriBiasedIgnorePathCase.isEqualOrParent($,M.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function a($){return n($)||c($)}e.isStoredWorkspaceFolder=a;function n($){const M=$;return typeof(M==null?void 0:M.path)=="string"&&(!M.name||typeof M.name=="string")}e.isRawFileWorkspaceFolder=n;function c($){const M=$;return typeof(M==null?void 0:M.uri)=="string"&&(!M.name||typeof M.name=="string")}e.isRawUriWorkspaceFolder=c;function b($,M,U,F,N=!C.isWindows,O){if($.scheme!==F.scheme)return{name:U,uri:$.toString(!0)};let V=M?void 0:O.relativePath(F,$);if(V!==void 0)V.length===0?V=".":C.isWindows&&$.scheme===k.Schemas.file&&!N&&(V=V.replace(/\//g,"\\"));else if($.scheme===k.Schemas.file)V=$.fsPath,C.isWindows&&(V=(0,E.normalizeDriveLetter)(V),N&&(V=(0,f.toSlashes)(V)));else{if(!O.isEqualAuthority($.authority,F.authority))return{name:U,uri:$.toString(!0)};V=$.path}return{name:U,path:V}}e.getStoredWorkspaceFolder=b;function w($,M,U){let F=[],N=new Set;const O=U.dirname(M);for(let V of $){let q=null;if(n(V))V.path&&(q=U.resolvePath(O,V.path));else if(c(V))try{q=I.URI.parse(V.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(Y){console.warn(Y)}if(q){let Y=U.getComparisonKey(q);if(!N.has(Y)){N.add(Y);const fe=V.name||U.basenameOrAuthority(q);F.push(new R.WorkspaceFolder({uri:q,name:fe,index:F.length},V))}}}return F}e.toWorkspaceFolders=w;function h($,M,U,F,N){let O=_(M,$);const V=N.dirname(M),q=N.dirname(F),Y=[],fe=A(O.folders);for(const Fe of O.folders){const z=n(Fe)?N.resolvePath(V,Fe.path):I.URI.parse(Fe.uri);let Q;U?Q=!1:Q=!n(Fe)||(0,P.isAbsolute)(Fe.path),Y.push(b(z,Q,Fe.name,q,fe,N))}const _e={insertSpaces:!1,tabSize:4,eol:C.isLinux||C.isMacintosh?`
`:`\r
`},Le=i.setProperty($,["folders"],Y,_e);let Ie=i.applyEdits($,Le);return O.remoteAuthority===(0,l.getRemoteAuthority)(F)&&(Ie=i.applyEdits(Ie,i.removeProperty(Ie,["remoteAuthority"],_e))),Ie}e.rewriteWorkspaceFileForNewLocation=h;function _($,M){let U=T.parse(M);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(F=>a(F));else throw new Error(`${$} looks like an invalid workspace file.`);return U}function A($){return C.isWindows?$.some(M=>n(M)&&M.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function L($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function W($){return typeof $.folderUri=="string"}function j($){return typeof $.fileUri=="string"}function K($,M){const U={workspaces:[],files:[]};if($){const F=function(O,V){for(let q=0;q<O.length;q++)try{V(O[q],q)}catch(Y){M.warn(`Error restoring recent entry ${JSON.stringify(O[q])}: ${Y.toString()}. Skip entry.`)}},N=$;if(Array.isArray(N.entries))F(N.entries,O=>{const V=O.label,q=O.remoteAuthority;L(O)?U.workspaces.push({label:V,remoteAuthority:q,workspace:{id:O.workspace.id,configPath:I.URI.parse(O.workspace.configPath)}}):W(O)?U.workspaces.push({label:V,remoteAuthority:q,folderUri:I.URI.parse(O.folderUri)}):j(O)&&U.files.push({label:V,remoteAuthority:q,fileUri:I.URI.parse(O.fileUri)})});else{const O=$;Array.isArray(O.workspaces3)&&F(O.workspaces3,(V,q)=>{const Y=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[q]||void 0;typeof V=="object"&&typeof V.id=="string"&&typeof V.configURIPath=="string"?U.workspaces.push({label:Y,workspace:{id:V.id,configPath:I.URI.parse(V.configURIPath)}}):typeof V=="string"&&U.workspaces.push({label:Y,folderUri:I.URI.parse(V)})}),Array.isArray(O.files2)&&F(O.files2,(V,q)=>{const Y=Array.isArray(O.fileLabels)&&O.fileLabels[q]||void 0;typeof V=="string"&&U.files.push({label:Y,fileUri:I.URI.parse(V)})})}}return U}e.restoreRecentlyOpened=K;function H($){const M={entries:[]};for(const U of $.workspaces)v(U)?M.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):M.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of $.files)M.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return M}e.toStoreData=H}),define(ge[115],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class p{constructor(R){this.id=R,this._data=new Map,this._idPool=1}add(R){const I=this._idPool++;return this._data.set(I,R),this.logDebugInfo(),I}get(R,I){return this._data.has(R)?this._data.get(R)[I]:void 0}delete(R){this._data.delete(R),this.logDebugInfo()}logDebugInfo(){!p.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=p,p.enableDebugLogging=!1}),define(ge[192],pe([0,1,2,3]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class R{constructor(){this._onDidChangeTabs=new D.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(P=>({name:P.name,group:P.group,resource:p.URI.revive(P.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=R}),define(ge[61],pe([0,1,11,4]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(p.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(C,P){P===null?this._providerInfo.delete(C):this._providerInfo.set(C,P)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,p.createDecorator)("IExtHostInitDataService")}),define(ge[193],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class p{constructor(I,C,P){this._id=I,this._shared=C,this._storage=P,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(S=>(this._value=S,this)),this._storageListener=this._storage.onDidChangeStorage(S=>{S.shared===this._shared&&S.key===this._id&&(this._value=S.value)})}get whenReady(){return this._init}get(I,C){let P=this._value[I];return typeof P=="undefined"&&(P=C),P}update(I,C){return this._value[I]=C,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=p;class D extends p{constructor(I,C){super(I.identifier.value,!0,C);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=D}),define(ge[14],pe([0,1,4]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,p.createDecorator)("IExtHostRpcService");class D{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=D});var tt=this&&this.__classPrivateFieldSet||function(Z,e,p){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,p),p},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[194],pe([0,1,29,3]),function(Z,e,p,D){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class I{constructor(P,S){R.set(this,void 0),this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._id=p.ExtensionIdentifier.toKey(P.identifier),tt(this,R,S),$e(this,R).onDidChangePassword(i=>{i.extensionId===this._id&&this._onDidChange.fire({key:i.key})})}get(P){return $e(this,R).get(this._id,P)}store(P,S){return $e(this,R).store(this._id,P,S)}delete(P){return $e(this,R).delete(this._id,P)}}e.ExtensionSecrets=I,R=new WeakMap}),define(ge[116],pe([0,1,4,3]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class R{constructor(){this._onDidChangeTelemetryEnabled=new D.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(C){this._enabled=C}$onDidChangeTelemetryEnabled(C){this._enabled=C,this._onDidChangeTelemetryEnabled.fire(C)}}e.ExtHostTelemetry=R,e.IExtHostTelemetry=(0,p.createDecorator)("IExtHostTelemetry")}),define(ge[50],pe([0,1,4,3,14]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var I;(function(P){function S(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public}}P.fromApiTunnel=S;function i(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.public}}P.fromServiceTunnel=i})(I=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,p.createDecorator)("IExtHostTunnelService");let C=class{constructor(S){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,i){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,i){return{dispose:()=>{}}}async $providePortAttributes(S,i,T,k,E){return[]}async $forwardPort(S,i){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};C=je([Ue(0,R.IExtHostRpcService)],C),e.ExtHostTunnelService=C});var tt=this&&this.__classPrivateFieldSet||function(Z,e,p){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,p),p},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[8],pe([0,1,12,18,94,23,15,2,28,44,112]),function(Z,e,p,D,R,I,C,P,S,i,T){"use strict";var k,E,f,l,m,y,g,v,d,u,o,t,r,s,a,n;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestState=e.TestItem=e.TestMessageSeverity=e.TestResult=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookRunState=e.NotebookCellRunState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function c(B){function x(){return Reflect.construct(B,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(B,"name")),Object.setPrototypeOf(x,B),Object.setPrototypeOf(x.prototype,B.prototype),x}let b=f=class{constructor(x){k.set(this,void 0),tt(this,k,x)}static from(...x){let se=x;return new f(function(){if(se){for(const Ce of se)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();se=void 0}})}dispose(){typeof $e(this,k)=="function"&&($e(this,k).call(this),tt(this,k,void 0))}};k=new WeakMap,b=f=je([c],b),e.Disposable=b;let w=l=class{constructor(x,se){if(x<0)throw(0,D.illegalArgument)("line must be non-negative");if(se<0)throw(0,D.illegalArgument)("character must be non-negative");this._line=x,this._character=se}static Min(...x){if(x.length===0)throw new TypeError;let se=x[0];for(let Ce=1;Ce<x.length;Ce++){const Ve=x[Ce];Ve.isBefore(se)&&(se=Ve)}return se}static Max(...x){if(x.length===0)throw new TypeError;let se=x[0];for(let Ce=1;Ce<x.length;Ce++){const Ve=x[Ce];Ve.isAfter(se)&&(se=Ve)}return se}static isPosition(x){if(!x)return!1;if(x instanceof l)return!0;let{line:se,character:Ce}=x;return typeof se=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,se=0){if(x===null||se===null)throw(0,D.illegalArgument)();let Ce;return typeof x=="undefined"?Ce=0:typeof x=="number"?Ce=x:(Ce=typeof x.lineDelta=="number"?x.lineDelta:0,se=typeof x.characterDelta=="number"?x.characterDelta:0),Ce===0&&se===0?this:new l(this.line+Ce,this.character+se)}with(x,se=this.character){if(x===null||se===null)throw(0,D.illegalArgument)();let Ce;return typeof x=="undefined"?Ce=this.line:typeof x=="number"?Ce=x:(Ce=typeof x.line=="number"?x.line:this.line,se=typeof x.character=="number"?x.character:this.character),Ce===this.line&&se===this.character?this:new l(Ce,se)}toJSON(){return{line:this.line,character:this.character}}};w=l=je([c],w),e.Position=w;let h=m=class{constructor(x,se,Ce,Ve){let Qe,nt;if(typeof x=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ve=="number"?(Qe=new w(x,se),nt=new w(Ce,Ve)):x instanceof w&&se instanceof w&&(Qe=x,nt=se),!Qe||!nt)throw new Error("Invalid arguments");Qe.isBefore(nt)?(this._start=Qe,this._end=nt):(this._start=nt,this._end=Qe)}static isRange(x){return x instanceof m?!0:x?w.isPosition(x.start)&&w.isPosition(x.end):!1}get start(){return this._start}get end(){return this._end}contains(x){return x instanceof m?this.contains(x._start)&&this.contains(x._end):x instanceof w?!(x.isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const se=w.Max(x.start,this._start),Ce=w.Min(x.end,this._end);if(!se.isAfter(Ce))return new m(se,Ce)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const se=w.Min(x.start,this._start),Ce=w.Max(x.end,this.end);return new m(se,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,se=this.end){if(x===null||se===null)throw(0,D.illegalArgument)();let Ce;return x?w.isPosition(x)?Ce=x:(Ce=x.start||this.start,se=x.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&se.isEqual(this.end)?this:new m(Ce,se)}toJSON(){return[this.start,this.end]}};h=m=je([c],h),e.Range=h;let _=y=class extends h{constructor(x,se,Ce,Ve){let Qe,nt;if(typeof x=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ve=="number"?(Qe=new w(x,se),nt=new w(Ce,Ve)):x instanceof w&&se instanceof w&&(Qe=x,nt=se),!Qe||!nt)throw new Error("Invalid arguments");super(Qe,nt);this._anchor=Qe,this._active=nt}static isSelection(x){return x instanceof y?!0:x?h.isRange(x)&&w.isPosition(x.anchor)&&w.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};_=y=je([c],_),e.Selection=_;class A{constructor(x,se,Ce){if(typeof x!="string"||x.length===0)throw(0,D.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,D.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,D.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(se),this.connectionToken=Ce}}e.ResolvedAuthority=A;class L extends Error{constructor(x,se=T.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(x);this._message=x,this._code=se,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static NotAvailable(x,se){return new L(x,T.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(x){return new L(x,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=L;var W;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var j;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=g=class{constructor(x,se){this._range=x,this._newText=se}static isTextEdit(x){return x instanceof g?!0:x?h.isRange(x)&&typeof x.newText=="string":!1}static replace(x,se){return new g(x,se)}static insert(x,se){return g.replace(new h(x,x),se)}static delete(x){return g.replace(x,"")}static setEndOfLine(x){const se=new g(new h(new w(0,0),new w(0,0)),"");return se.newEol=x,se}get range(){return this._range}set range(x){if(x&&!h.isRange(x))throw(0,D.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,D.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,D.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};K=g=je([c],K),e.TextEdit=K;var H;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellOutput=4]="CellOutput",B[B.CellReplace=5]="CellReplace",B[B.CellOutputItem=6]="CellOutputItem"})(H=e.FileEditType||(e.FileEditType={}));let $=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,se,Ce,Ve){this._edits.push({_type:1,from:x,to:se,options:Ce,metadata:Ve})}createFile(x,se,Ce){this._edits.push({_type:1,from:void 0,to:x,options:se,metadata:Ce})}deleteFile(x,se,Ce){this._edits.push({_type:1,from:x,to:void 0,options:se,metadata:Ce})}replaceNotebookMetadata(x,se,Ce){this._edits.push({_type:3,metadata:Ce,uri:x,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(x,se,Ce,Ve,Qe){(se!==Ce||Ve.length>0)&&this._edits.push({_type:5,uri:x,index:se,count:Ce-se,cells:Ve,metadata:Qe})}replaceNotebookCellOutput(x,se,Ce,Ve){this._editNotebookCellOutput(x,se,!1,Ce,Ve)}appendNotebookCellOutput(x,se,Ce,Ve){this._editNotebookCellOutput(x,se,!0,Ce,Ve)}replaceNotebookCellOutputItems(x,se,Ce,Ve,Qe){this._editNotebookCellOutputItems(x,se,Ce,!1,Ve,Qe)}appendNotebookCellOutputItems(x,se,Ce,Ve,Qe){this._editNotebookCellOutputItems(x,se,Ce,!0,Ve,Qe)}_editNotebookCellOutputItems(x,se,Ce,Ve,Qe,nt){this._edits.push({_type:6,metadata:nt,uri:x,index:se,outputId:Ce,append:Ve,newOutputItems:Qe})}_editNotebookCellOutput(x,se,Ce,Ve,Qe){this._edits.push({_type:4,metadata:Qe,uri:x,index:se,append:Ce,newOutputs:Ve,newMetadata:void 0})}replaceNotebookCellMetadata(x,se,Ce,Ve){this._edits.push({_type:3,metadata:Ve,uri:x,edit:{editType:3,index:se,metadata:Ce}})}replace(x,se,Ce,Ve){this._edits.push({_type:2,uri:x,edit:new K(se,Ce),metadata:Ve})}insert(x,se,Ce,Ve){this.replace(x,new h(se,se),Ce,Ve)}delete(x,se,Ce){this.replace(x,se,"",Ce)}has(x){return this._edits.some(se=>se._type===2&&se.uri.toString()===x.toString())}set(x,se){if(se)for(const Ce of se)Ce&&this._edits.push({_type:2,uri:x,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ve=this._edits[Ce];Ve._type===2&&Ve.uri.toString()===x.toString()&&(this._edits[Ce]=void 0)}(0,p.coalesceInPlace)(this._edits)}}get(x){const se=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===x.toString()&&se.push(Ce.edit);return se}entries(){const x=new I.ResourceMap;for(let se of this._edits)if(se._type===2){let Ce=x.get(se.uri);Ce||(Ce=[se.uri,[]],x.set(se.uri,Ce)),Ce[1].push(se.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};$=je([c],$),e.WorkspaceEdit=$;let M=v=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof v?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=v._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,se=this._tabstop++){if(typeof x=="function"){const Ce=new v;Ce._tabstop=this._tabstop,x(Ce),this._tabstop=Ce._tabstop,x=Ce.value}else x=v._escape(x);return this.value+="${",this.value+=se,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,se=this._tabstop++){const Ce=x.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(x,se){if(typeof se=="function"){const Ce=new v;Ce._tabstop=this._tabstop,se(Ce),this._tabstop=Ce._tabstop,se=Ce.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,se&&(this.value+=":",this.value+=se),this.value+="}",this}};M=v=je([c],M),e.SnippetString=M;var U;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(U=e.DiagnosticTag||(e.DiagnosticTag={}));var F;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(F=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let N=d=class{constructor(x,se){if(this.uri=x,se)if(se instanceof h)this.range=se;else if(se instanceof w)this.range=new h(se,se);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof d?!0:x?h.isRange(x.range)&&P.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};N=d=je([c],N),e.Location=N;let O=class{constructor(x,se){this.location=x,this.message=se}static is(x){return x?typeof x.message=="string"&&x.location&&h.isRange(x.location.range)&&P.URI.isUri(x.location.uri):!1}static isEqual(x,se){return x===se?!0:!x||!se?!1:x.message===se.message&&x.location.range.isEqual(se.location.range)&&x.location.uri.toString()===se.location.uri.toString()}};O=je([c],O),e.DiagnosticRelatedInformation=O;let V=class{constructor(x,se,Ce=F.Error){if(!h.isRange(x))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=x,this.message=se,this.severity=Ce}toJSON(){return{severity:F[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,se){return x===se?!0:!x||!se?!1:x.message===se.message&&x.severity===se.severity&&x.code===se.code&&x.severity===se.severity&&x.source===se.source&&x.range.isEqual(se.range)&&(0,p.equals)(x.tags,se.tags)&&(0,p.equals)(x.relatedInformation,se.relatedInformation,O.isEqual)}};V=je([c],V),e.Diagnostic=V;let q=class{constructor(x,se){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:(0,R.isMarkdownString)(x)?this.contents=[x]:this.contents=[x],this.range=se}};q=je([c],q),e.Hover=q;var Y;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Y=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let fe=class{constructor(x,se=Y.Text){this.range=x,this.kind=se}toJSON(){return{range:this.range,kind:Y[this.kind]}}};fe=je([c],fe),e.DocumentHighlight=fe;var _e;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(_e=e.SymbolKind||(e.SymbolKind={}));var Le;(function(B){B[B.Deprecated=1]="Deprecated"})(Le=e.SymbolTag||(e.SymbolTag={}));let Ie=u=class{constructor(x,se,Ce,Ve,Qe){this.name=x,this.kind=se,this.containerName=Qe,typeof Ce=="string"&&(this.containerName=Ce),Ve instanceof N?this.location=Ve:Ce instanceof h&&(this.location=new N(Ve,Ce)),u.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:_e[this.kind],location:this.location,containerName:this.containerName}}};Ie=u=je([c],Ie),e.SymbolInformation=Ie;let Fe=o=class{constructor(x,se,Ce,Ve,Qe){this.name=x,this.detail=se,this.kind=Ce,this.range=Ve,this.selectionRange=Qe,this.children=[],o.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(o.validate)}};Fe=o=je([c],Fe),e.DocumentSymbol=Fe;var z;(function(B){B[B.Automatic=1]="Automatic",B[B.Manual=2]="Manual"})(z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Q=class{constructor(x,se){this.title=x,this.kind=se}};Q=je([c],Q),e.CodeAction=Q;let te=t=class{constructor(x){this.value=x}append(x){return new t(this.value?this.value+t.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+t.sep)}};te.sep=".",te=t=je([c],te),e.CodeActionKind=te,te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll");let ae=class{constructor(x,se){if(this.range=x,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=je([c],ae),e.SelectionRange=ae;class ve{constructor(x,se,Ce,Ve,Qe,nt){this.kind=x,this.name=se,this.detail=Ce,this.uri=Ve,this.range=Qe,this.selectionRange=nt}}e.CallHierarchyItem=ve;class De{constructor(x,se){this.fromRanges=se,this.from=x}}e.CallHierarchyIncomingCall=De;class Me{constructor(x,se){this.fromRanges=se,this.to=x}}e.CallHierarchyOutgoingCall=Me;let we=class{constructor(x,se){this.range=x,this.command=se}get isResolved(){return!!this.command}};we=je([c],we),e.CodeLens=we;let ke=r=class{constructor(x,se=!1){E.set(this,void 0),tt(this,E,new R.MarkdownString(x,{supportThemeIcons:se}))}static isMarkdownString(x){return x instanceof r?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return $e(this,E).value}set value(x){$e(this,E).value=x}get isTrusted(){return $e(this,E).isTrusted}set isTrusted(x){$e(this,E).isTrusted=x}get supportThemeIcons(){return $e(this,E).supportThemeIcons}appendText(x){return $e(this,E).appendText(x),this}appendMarkdown(x){return $e(this,E).appendMarkdown(x),this}appendCodeblock(x,se){return $e(this,E).appendCodeblock(se!=null?se:"",x),this}};E=new WeakMap,ke=r=je([c],ke),e.MarkdownString=ke;let Ae=class{constructor(x,se){this.label=x,this.documentation=se}};Ae=je([c],Ae),e.ParameterInformation=Ae;let xe=class{constructor(x,se){this.label=x,this.documentation=se,this.parameters=[]}};xe=je([c],xe),e.SignatureInformation=xe;let ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ye=je([c],ye),e.SignatureHelp=ye;var Ge;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(Ge=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var X;(function(B){B[B.Other=0]="Other",B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(X=e.InlineHintKind||(e.InlineHintKind={}));let ie=class{constructor(x,se,Ce){this.text=x,this.range=se,this.kind=Ce}};ie=je([c],ie),e.InlineHint=ie;var Se;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ne;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Ne=e.CompletionItemKind||(e.CompletionItemKind={}));var ze;(function(B){B[B.Deprecated=1]="Deprecated"})(ze=e.CompletionItemTag||(e.CompletionItemTag={}));let We=class{constructor(x,se){this.label=x,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};We=je([c],We),e.CompletionItem=We;let Je=class{constructor(x=[],se=!1){this.items=x,this.isIncomplete=se}};Je=je([c],Je),e.CompletionList=Je;var G;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(G=e.ViewColumn||(e.ViewColumn={}));var oe;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(oe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ue;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(ue=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(J=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ne;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ne=e.TextEditorRevealType||(e.TextEditorRevealType={}));var le;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var me;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(me=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function x(se){switch(se){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=x}(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ee=class{constructor(x,se){if(se&&!P.URI.isUri(se))throw(0,D.illegalArgument)("target");if(!h.isRange(x)||x.isEmpty)throw(0,D.illegalArgument)("range");this.range=x,this.target=se}};Ee=je([c],Ee),e.DocumentLink=Ee;let He=class{constructor(x,se,Ce,Ve){this.red=x,this.green=se,this.blue=Ce,this.alpha=Ve}};He=je([c],He),e.Color=He;let Be=class{constructor(x,se){if(se&&!(se instanceof He))throw(0,D.illegalArgument)("color");if(!h.isRange(x)||x.isEmpty)throw(0,D.illegalArgument)("range");this.range=x,this.color=se}};Be=je([c],Be),e.ColorInformation=Be;let qe=class{constructor(x){if(!x||typeof x!="string")throw(0,D.illegalArgument)("label");this.label=x}};qe=je([c],qe),e.ColorPresentation=qe;var Xe;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Xe=e.ColorFormat||(e.ColorFormat={}));var Ze;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Ze=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ut;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(ut=e.TaskRevealKind||(e.TaskRevealKind={}));var st;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(st=e.TaskPanelKind||(e.TaskPanelKind={}));let be=s=class{constructor(x,se){if(typeof x!="string"||typeof se!="string")throw(0,D.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};be.Clean=new s("clean","Clean"),be.Build=new s("build","Build"),be.Rebuild=new s("rebuild","Rebuild"),be.Test=new s("test","Test"),be=s=je([c],be),e.TaskGroup=be;function he(B){let x="";for(let se=0;se<B.length;se++)x+=B[se].replace(/,/g,",,")+",";return x}let ce=class{constructor(x,se,Ce){if(typeof x!="string")throw(0,D.illegalArgument)("process");this._args=[],this._process=x,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ce):this._options=se)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,D.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let se of this._args)x.push(se);return he(x)}};ce=je([c],ce),e.ProcessExecution=ce;let ee=class{constructor(x,se,Ce){if(this._args=[],Array.isArray(se)){if(!x)throw(0,D.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,D.illegalArgument)("command");this._command=x,this._args=se,this._options=Ce}else{if(typeof x!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=x,this._options=se}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,D.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)x.push(typeof se=="string"?se:se.value);return he(x)}};ee=je([c],ee),e.ShellExecution=ee;var Te;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Te=e.ShellQuoting||(e.ShellQuoting={}));var Re;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Re=e.TaskScope||(e.TaskScope={}));class et{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,S.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=et;let Ke=a=class{constructor(x,se,Ce,Ve,Qe,nt){this.__deprecated=!1,this._definition=this.definition=x;let ot;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ce,this.execution=Ve,ot=Qe,this.__deprecated=!0):se===Re.Global||se===Re.Workspace?(this.target=se,this._name=this.name=Ce,this._source=this.source=Ve,this.execution=Qe,ot=nt):(this.target=se,this._name=this.name=Ce,this._source=this.source=Ve,this.execution=Qe,ot=nt),typeof ot=="string"?(this._problemMatchers=[ot],this._hasDefinedMatchers=!0):Array.isArray(ot)?(this._problemMatchers=ot,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ce?this._definition={type:a.ProcessType,id:this._execution.computeId()}:this._execution instanceof ee?this._definition={type:a.ShellType,id:this._execution.computeId()}:this._execution instanceof et?this._definition={type:a.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:a.EmptyType,id:(0,S.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,D.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,D.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const se=this._definition.type;(a.EmptyType===se||a.ProcessType===se||a.ShellType===se||a.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,D.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};Ke.ExtensionCallbackType="customExecution",Ke.ProcessType="process",Ke.ShellType="shell",Ke.EmptyType="$empty",Ke=a=je([c],Ke),e.Task=Ke;var rt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(rt=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(x,se=Ye.None){this.collapsibleState=se,P.URI.isUri(x)?this.resourceUri=x:this.label=x}};lt=je([c],lt),e.TreeItem=lt;var Ye;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Ye=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let it=class{constructor(x,se){this.id=x,this.color=se}};it=je([c],it),e.ThemeIcon=it,it.File=new it("file"),it.Folder=new it("folder");let dt=class{constructor(x){this.id=x}};dt=je([c],dt),e.ThemeColor=dt;var at;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(at=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(x,se){if(typeof x!="string"&&(!x||!P.URI.isUri(x)&&!P.URI.isUri(x.uri)))throw(0,D.illegalArgument)("base");if(typeof se!="string")throw(0,D.illegalArgument)("pattern");typeof x=="string"?(this.baseFolder=P.URI.file(x),this.base=x):P.URI.isUri(x)?(this.baseFolder=x,this.base=x.fsPath):(this.baseFolder=x.uri,this.base=x.uri.fsPath),this.pattern=se}};Ct=je([c],Ct),e.RelativePattern=Ct;let gt=class{constructor(x,se,Ce,Ve){this.enabled=typeof x=="boolean"?x:!0,typeof se=="string"&&(this.condition=se),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,S.generateUuid)()),this._id}};gt=je([c],gt),e.Breakpoint=gt;let kt=class extends gt{constructor(x,se,Ce,Ve,Qe){super(se,Ce,Ve,Qe);if(x===null)throw(0,D.illegalArgument)("location");this.location=x}};kt=je([c],kt),e.SourceBreakpoint=kt;let Et=class extends gt{constructor(x,se,Ce,Ve,Qe){super(se,Ce,Ve,Qe);this.functionName=x}};Et=je([c],Et),e.FunctionBreakpoint=Et;let St=class extends gt{constructor(x,se,Ce,Ve,Qe,nt,ot){super(Ve,Qe,nt,ot);if(!se)throw(0,D.illegalArgument)("dataId");this.label=x,this.dataId=se,this.canPersist=Ce}};St=je([c],St),e.DataBreakpoint=St;let mt=class{constructor(x,se,Ce){this.command=x,this.args=se||[],this.options=Ce}};mt=je([c],mt),e.DebugAdapterExecutable=mt;let Lt=class{constructor(x,se){this.port=x,this.host=se}};Lt=je([c],Lt),e.DebugAdapterServer=Lt;let Ft=class{constructor(x){this.path=x}};Ft=je([c],Ft),e.DebugAdapterNamedPipeServer=Ft;let ht=class{constructor(x){this.implementation=x}};ht=je([c],ht),e.DebugAdapterInlineImplementation=ht;let yt=class{constructor(x,se){this.range=x,this.expression=se}};yt=je([c],yt),e.EvaluatableExpression=yt;let Bt=class{constructor(x,se){this.range=x,this.text=se}};Bt=je([c],Bt),e.InlineValueText=Bt;let Ht=class{constructor(x,se,Ce=!0){this.range=x,this.variableName=se,this.caseSensitiveLookup=Ce}};Ht=je([c],Ht),e.InlineValueVariableLookup=Ht;let Ot=class{constructor(x,se){this.range=x,this.expression=se}};Ot=je([c],Ot),e.InlineValueEvaluatableExpression=Ot;let ct=class{constructor(x,se){this.frameId=x,this.stoppedLocation=se}};ct=je([c],ct),e.InlineValueContext=ct;var hn;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(hn=e.FileChangeType||(e.FileChangeType={}));let Pt=n=class extends Error{constructor(x,se=i.FileSystemProviderErrorCode.Unknown,Ce){var Ve;super(P.URI.isUri(x)?x.toString(!0):x);this.code=(Ve=Ce==null?void 0:Ce.name)!==null&&Ve!==void 0?Ve:"Unknown",(0,i.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,n.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(x){return new n(x,i.FileSystemProviderErrorCode.FileExists,n.FileExists)}static FileNotFound(x){return new n(x,i.FileSystemProviderErrorCode.FileNotFound,n.FileNotFound)}static FileNotADirectory(x){return new n(x,i.FileSystemProviderErrorCode.FileNotADirectory,n.FileNotADirectory)}static FileIsADirectory(x){return new n(x,i.FileSystemProviderErrorCode.FileIsADirectory,n.FileIsADirectory)}static NoPermissions(x){return new n(x,i.FileSystemProviderErrorCode.NoPermissions,n.NoPermissions)}static Unavailable(x){return new n(x,i.FileSystemProviderErrorCode.Unavailable,n.Unavailable)}};Pt=n=je([c],Pt),e.FileSystemError=Pt;let At=class{constructor(x,se,Ce){this.start=x,this.end=se,this.kind=Ce}};At=je([c],At),e.FoldingRange=At;var tn;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(tn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var nn;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(nn=e.CommentMode||(e.CommentMode={}));class mn{constructor(x,se=[]){this.tokenTypes=x,this.tokenModifiers=se}}e.SemanticTokensLegend=mn;function rn(B){return typeof B=="undefined"||(0,C.isStringArray)(B)}class Tt{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let se=0,Ce=x.tokenTypes.length;se<Ce;se++)this._tokenTypeStrToInt.set(x.tokenTypes[se],se);for(let se=0,Ce=x.tokenModifiers.length;se<Ce;se++)this._tokenModifierStrToInt.set(x.tokenModifiers[se],se)}}push(x,se,Ce,Ve,Qe){if(typeof x=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ve=="number"&&(typeof Qe=="number"||typeof Qe=="undefined"))return typeof Qe=="undefined"&&(Qe=0),this._pushEncoded(x,se,Ce,Ve,Qe);if(h.isRange(x)&&typeof se=="string"&&rn(Ce))return this._push(x,se,Ce);throw(0,D.illegalArgument)()}_push(x,se,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ve=x.start.line,Qe=x.start.character,nt=x.end.character-x.start.character,ot=this._tokenTypeStrToInt.get(se);let pt=0;if(Ce)for(const wt of Ce){if(!this._tokenModifierStrToInt.has(wt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this._tokenModifierStrToInt.get(wt);pt|=1<<_t>>>0}this._pushEncoded(Ve,Qe,nt,ot,pt)}_pushEncoded(x,se,Ce,Ve,Qe){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const pt=this._data.length/5|0;let wt=0,_t=0;for(let bt=0;bt<pt;bt++){let Dt=this._data[5*bt],Jt=this._data[5*bt+1];Dt===0?(Dt=wt,Jt+=_t):Dt+=wt,this._data[5*bt]=Dt,this._data[5*bt+1]=Jt,wt=Dt,_t=Jt}}let nt=x,ot=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(nt-=this._prevLine,nt===0&&(ot-=this._prevChar)),this._data[this._dataLen++]=nt,this._data[this._dataLen++]=ot,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=Qe,this._prevLine=x,this._prevChar=se}static _sortAndDeltaEncode(x){let se=[];const Ce=x.length/5|0;for(let ot=0;ot<Ce;ot++)se[ot]=ot;se.sort((ot,pt)=>{const wt=x[5*ot],_t=x[5*pt];if(wt===_t){const bt=x[5*ot+1],Dt=x[5*pt+1];return bt-Dt}return wt-_t});const Ve=new Uint32Array(x.length);let Qe=0,nt=0;for(let ot=0;ot<Ce;ot++){const pt=5*se[ot],wt=x[pt+0],_t=x[pt+1],bt=x[pt+2],Dt=x[pt+3],Jt=x[pt+4],Pn=wt-Qe,Fn=Pn===0?_t-nt:_t,Zt=5*ot;Ve[Zt+0]=Pn,Ve[Zt+1]=Fn,Ve[Zt+2]=bt,Ve[Zt+3]=Dt,Ve[Zt+4]=Jt,Qe=wt,nt=_t}return Ve}build(x){return this._dataIsSortedAndDeltaEncoded?new zt(new Uint32Array(this._data),x):new zt(Tt._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=Tt;class zt{constructor(x,se){this.resultId=se,this.data=x}}e.SemanticTokens=zt;class Vt{constructor(x,se,Ce){this.start=x,this.deleteCount=se,this.data=Ce}}e.SemanticTokensEdit=Vt;class jt{constructor(x,se){this.resultId=se,this.edits=x}}e.SemanticTokensEdits=jt;var gn;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(gn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var pn;(function(B){B[B.Initial=1]="Initial",B[B.Dynamic=2]="Dynamic"})(pn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let It=class{constructor(){}};It.Back={iconPath:new it("arrow-left")},It=je([c],It),e.QuickInputButtons=It;var vn;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(vn=e.ExtensionKind||(e.ExtensionKind={}));class wn{constructor(x,se,Ce){this.badge=x,this.tooltip=se,this.color=Ce}static validate(x){if(x.badge&&x.badge.length!==1&&x.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=wn;let qt=class{constructor(x){this.kind=x}};qt=je([c],qt),e.ColorTheme=qt;var _n;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast"})(_n=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{constructor(x,se){if(x<0)throw(0,D.illegalArgument)("start must be positive");if(se<x)throw(0,D.illegalArgument)("end cannot be smaller than start");this._start=x,this._end=se}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}}e.NotebookCellRange=Gt;class $t{constructor(x,se,Ce,Ve,Qe,nt,ot,pt,wt,_t,bt){this.editable=x,this.breakpointMargin=se,this.hasExecutionOrder=Ce,this.executionOrder=Ve,this.runState=Qe,this.runStartTime=nt,this.statusMessage=ot,this.lastRunDuration=pt,this.inputCollapsed=wt,this.outputCollapsed=_t,this.custom=bt}with(x){let{editable:se,breakpointMargin:Ce,hasExecutionOrder:Ve,executionOrder:Qe,runState:nt,runStartTime:ot,statusMessage:pt,lastRunDuration:wt,inputCollapsed:_t,outputCollapsed:bt,custom:Dt}=x;return se===void 0?se=this.editable:se===null&&(se=void 0),Ce===void 0?Ce=this.breakpointMargin:Ce===null&&(Ce=void 0),Ve===void 0?Ve=this.hasExecutionOrder:Ve===null&&(Ve=void 0),Qe===void 0?Qe=this.executionOrder:Qe===null&&(Qe=void 0),nt===void 0?nt=this.runState:nt===null&&(nt=void 0),ot===void 0?ot=this.runStartTime:ot===null&&(ot=void 0),pt===void 0?pt=this.statusMessage:pt===null&&(pt=void 0),wt===void 0?wt=this.lastRunDuration:wt===null&&(wt=void 0),_t===void 0?_t=this.inputCollapsed:_t===null&&(_t=void 0),bt===void 0?bt=this.outputCollapsed:bt===null&&(bt=void 0),Dt===void 0?Dt=this.custom:Dt===null&&(Dt=void 0),se===this.editable&&Ce===this.breakpointMargin&&Ve===this.hasExecutionOrder&&Qe===this.executionOrder&&nt===this.runState&&ot===this.runStartTime&&pt===this.statusMessage&&wt===this.lastRunDuration&&_t===this.inputCollapsed&&bt===this.outputCollapsed&&Dt===this.custom?this:new $t(se,Ce,Ve,Qe,nt,ot,pt,wt,_t,bt,Dt)}}e.NotebookCellMetadata=$t;class Mt{constructor(x=!0,se=!0,Ce=!0,Ve={},Qe=sn.Idle,nt=!0){this.editable=x,this.cellEditable=se,this.cellHasExecutionOrder=Ce,this.custom=Ve,this.runState=Qe,this.trusted=nt}with(x){let{editable:se,cellEditable:Ce,cellHasExecutionOrder:Ve,custom:Qe,runState:nt,trusted:ot}=x;return se===void 0?se=this.editable:se===null&&(se=void 0),Ce===void 0?Ce=this.cellEditable:Ce===null&&(Ce=void 0),Ve===void 0?Ve=this.cellHasExecutionOrder:Ve===null&&(Ve=void 0),Qe===void 0?Qe=this.custom:Qe===null&&(Qe=void 0),nt===void 0?nt=this.runState:nt===null&&(nt=void 0),ot===void 0?ot=this.trusted:ot===null&&(ot=void 0),se===this.editable&&Ce===this.cellEditable&&Ve===this.cellHasExecutionOrder&&Qe===this.custom&&nt===this.runState&&ot===this.trusted?this:new Mt(se,Ce,Ve,Qe,nt,ot)}}e.NotebookDocumentMetadata=Mt;class Kt{constructor(x,se,Ce,Ve,Qe){this.kind=x,this.source=se,this.language=Ce,this.outputs=Ve!=null?Ve:[],this.metadata=Qe}}e.NotebookCellData=Kt;class Oe{constructor(x,se){this.cells=x,this.metadata=se!=null?se:new Mt}}e.NotebookData=Oe;class Nt{constructor(x,se,Ce){this.mime=x,this.value=se,this.metadata=Ce}static isNotebookCellOutputItem(x){return x instanceof Nt}}e.NotebookCellOutputItem=Nt;class Xt{constructor(x,se,Ce){this.outputs=x,typeof se=="string"?(this.id=se,this.metadata=Ce):(this.id=(0,S.generateUuid)(),this.metadata=se!=null?se:Ce)}}e.NotebookCellOutput=Xt;var ft;(function(B){B[B.Markdown=1]="Markdown",B[B.Code=2]="Code"})(ft=e.NotebookCellKind||(e.NotebookCellKind={}));var bn;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle",B[B.Success=3]="Success",B[B.Error=4]="Error"})(bn=e.NotebookCellRunState||(e.NotebookCellRunState={}));var sn;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(sn=e.NotebookRunState||(e.NotebookRunState={}));var on;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(on=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var an;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(an=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Yt=class{constructor(x,se){this.label=x,this.timestamp=se}};Yt=je([c],Yt),e.TimelineItem=Yt;var En;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(En=e.ExtensionMode||(e.ExtensionMode={}));var Sn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(Sn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var yn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=4]="RegEx"})(yn=e.StandardTokenType||(e.StandardTokenType={}));class ln{constructor(x,se){this.ranges=x,this.wordPattern=se}}e.LinkedEditingRanges=ln;var Dn;(function(B){B[B.Unset=0]="Unset",B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(Dn=e.TestResult||(e.TestResult={}));var cn;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information",B[B.Hint=3]="Hint"})(cn=e.TestMessageSeverity||(e.TestMessageSeverity={}));class Cn{constructor(x,se){this.label=se,this.runnable=!0,this.debuggable=!1,this.children=[],Object.defineProperty(this,"id",{value:x,enumerable:!0,writable:!1})}}e.TestItem=Cn;class kn{constructor(x){this.state=x,this.messages=[]}}e.TestState=kn;class Qt{constructor(x){this.message=x,this.severity=cn.Error}static diff(x,se,Ce){const Ve=new Qt(x);return Ve.expectedOutput=se,Ve.actualOutput=Ce,Ve}}e.TestMessage=Qt;var re;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(re=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var de;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unknown=2]="Unknown"})(de=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Pe;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore"})(Pe=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[117],pe([0,1,52,11,9,142,104,8,12]),function(Z,e,p,D,R,I,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const i=new Map;function T(l,m){m?i.set(l,m):i.delete(l)}e.setWordDefinitionFor=T;function k(l){return i.get(l)}e.getWordDefinitionFor=k;class E extends I.MirrorTextModel{constructor(m,y,g,v,d,u,o,t){super(y,g,v,d);this._proxy=m,this._languageId=u,this._isDirty=o,this._notebook=t,this._isDisposed=!1}dispose(){(0,p.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(m){return(0,S.equals)(this._lines,m)}get document(){if(!this._document){const m=this;this._document={get uri(){return m._uri},get fileName(){return m._uri.fsPath},get isUntitled(){return m._uri.scheme===D.Schemas.untitled},get languageId(){return m._languageId},get version(){return m._versionId},get isClosed(){return m._isDisposed},get isDirty(){return m._isDirty},get notebook(){return m._notebook},save(){return m._save()},getText(y){return y?m._getTextInRange(y):m.getText()},get eol(){return m._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return m._lines.length},lineAt(y){return m._lineAt(y)},offsetAt(y){return m._offsetAt(y)},positionAt(y){return m._positionAt(y)},validateRange(y){return m._validateRange(y)},validatePosition(y){return m._validatePosition(y)},getWordRangeAtPosition(y,g){return m._getWordRangeAtPosition(y,g)}}}return Object.freeze(this._document)}_acceptLanguageId(m){(0,p.ok)(!this._isDisposed),this._languageId=m}_acceptIsDirty(m){(0,p.ok)(!this._isDisposed),this._isDirty=m}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(m){const y=this._validateRange(m);if(y.isEmpty)return"";if(y.isSingleLine)return this._lines[y.start.line].substring(y.start.character,y.end.character);const g=this._eol,v=y.start.line,d=y.end.line,u=[];u.push(this._lines[v].substring(y.start.character));for(let o=v+1;o<d;o++)u.push(this._lines[o]);return u.push(this._lines[d].substring(0,y.end.character)),u.join(g)}_lineAt(m){let y;if(m instanceof P.Position?y=m.line:typeof m=="number"&&(y=m),typeof y!="number"||y<0||y>=this._lines.length||Math.floor(y)!==y)throw new Error("Illegal value for `line`");return new f(y,this._lines[y],y===this._lines.length-1)}_offsetAt(m){return m=this._validatePosition(m),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(m.line-1)+m.character}_positionAt(m){m=Math.floor(m),m=Math.max(0,m),this._ensureLineStarts();const y=this._lineStarts.getIndexOf(m),g=this._lines[y.index].length;return new P.Position(y.index,Math.min(y.remainder,g))}_validateRange(m){if(!(m instanceof P.Range))throw new Error("Invalid argument");const y=this._validatePosition(m.start),g=this._validatePosition(m.end);return y===m.start&&g===m.end?m:new P.Range(y.line,y.character,g.line,g.character)}_validatePosition(m){if(!(m instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return m.with(0,0);let{line:y,character:g}=m,v=!1;if(y<0)y=0,g=0,v=!0;else if(y>=this._lines.length)y=this._lines.length-1,g=this._lines[y].length,v=!0;else{const d=this._lines[y].length;g<0?(g=0,v=!0):g>d&&(g=d,v=!0)}return v?new P.Position(y,g):m}_getWordRangeAtPosition(m,y){const g=this._validatePosition(m);if(!y)y=k(this._languageId);else if((0,R.regExpLeadsToEndlessLoop)(y))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${y.source}' because it matches the empty string.`);const v=(0,C.getWordAtText)(g.character+1,(0,C.ensureValidWordDefinition)(y),this._lines[g.line],0);if(v)return new P.Range(g.line,v.startColumn-1,g.line,v.endColumn-1)}}e.ExtHostDocumentData=E;class f{constructor(m,y,g){this._line=m,this._text=y,this._isLastLine=g}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(ge[195],pe([0,1,8,3,106,6,77,23,2,28]),function(Z,e,p,D,R,I,C,P,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(E,f,l,m){this._notebook=l,this._selector=m,this._disposables=new I.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,i.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(g=>{const v=this._cellUris.get(g.document.uri);v!==void 0&&(this._cellLengths.changeValue(v,this._cells[v].document.getText().length+1),this._cellLines.changeValue(v,this._cells[v].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const y=g=>{g===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(E.onDidChangeNotebookCells(g=>y(g.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const E=[],f=[];for(const l of this._notebook.cells)l.kind===p.NotebookCellKind.Code&&(!this._selector||(0,C.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),E.push(l.document.getText().length+1),f.push(l.document.lineCount));this._cellLengths=new R.PrefixSumComputer(new Uint32Array(E)),this._cellLines=new R.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(E){var f,l;if(!E){let d="";for(const u of this._cells)d+=u.document.getText()+`
`;return d=d.slice(0,-1),d}if(E.isEmpty)return"";const m=this.locationAt(E.start),y=this.locationAt(E.end),g=this._cells[(f=this._cellUris.get(m.uri))!==null&&f!==void 0?f:-1],v=this._cells[(l=this._cellUris.get(y.uri))!==null&&l!==void 0?l:-1];if(!g||!v)return"";if(g===v)return g.document.getText(new p.Range(m.range.start,y.range.end));{const d=g.document.getText(new p.Range(m.range.start,new p.Position(g.document.lineCount,0))),u=v.document.getText(new p.Range(new p.Position(0,0),y.range.end));return d+`
`+u}}offsetAt(E){const f=this._cellLines.getIndexOf(E.line),l=this._cellLengths.getAccumulatedValue(f.index-1),m=this._cells[f.index].document.offsetAt(E.with(f.remainder));return l+m}positionAt(E){if(typeof E=="number"){const l=this._cellLengths.getIndexOf(E),m=this._cellLines.getAccumulatedValue(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(m)}const f=this._cellUris.get(E.uri);if(f!==void 0){const l=this._cellLines.getAccumulatedValue(f-1);return new p.Position(l+E.range.start.line,E.range.start.character)}return new p.Position(0,0)}locationAt(E){p.Range.isRange(E)||(E=new p.Range(E,E));const f=this._cellLines.getIndexOf(E.start.line);let l=f;E.isEmpty||(l=this._cellLines.getIndexOf(E.end.line));const m=new p.Position(f.remainder,E.start.character),y=new p.Position(l.remainder,E.end.character),g=new p.Range(m,y),v=this._cells[f.index];return new p.Location(v.document.uri,v.document.validateRange(g))}contains(E){return this._cellUris.has(E)}validateRange(E){const f=this.validatePosition(E.start),l=this.validatePosition(E.end);return E.with(f,l)}validatePosition(E){const f=this._cellLines.getIndexOf(E.line),l=new p.Position(f.remainder,E.character),m=this._cells[f.index].document.validatePosition(l),y=this._cellLines.getAccumulatedValue(f.index-1);return new p.Position(y+m.line,m.character)}}e.ExtHostNotebookConcatDocument=T}),define(ge[196],pe([0,1,8,14,3]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let I=class{constructor(P){this._actual=new p.ColorTheme(p.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new R.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let S=P==="light"?p.ColorThemeKind.Light:P==="dark"?p.ColorThemeKind.Dark:p.ColorThemeKind.HighContrast;this._actual=new p.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};I=je([Ue(0,D.IExtHostRpcService)],I),e.ExtHostTheming=I}),define(ge[62],pe([0,1,4]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,p.createDecorator)("IURITransformerService");class D{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=D}),define(ge[84],pe([0,1,2]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function D(I,C,P){const S=I.webviewResourceRoot.replace("{{resource}}",P.scheme+R(P)).replace("{{uuid}}",C);return p.URI.parse(S)}e.asWebviewUri=D;function R(I){return I.toString().replace(/^\S+?:/,"")}}),define(ge[197],pe([0,1,3,6,84,28]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(S,i,T){this._proxy=S,this._editors=i,this._initData=T,this._handlePool=0,this._disposables=new D.DisposableStore,this._insets=new Map,this._disposables.add(i.onDidChangeVisibleTextEditors(()=>{const k=i.getVisibleTextEditors();for(const E of this._insets.values())k.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,i,T,k,E){let f;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===S){f=u;break}if(!f)throw new Error("not a visible editor");const l=this,m=this._handlePool++,y=new p.Emitter,g=new p.Emitter,v=new class{constructor(){this._uuid=(0,I.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,R.asWebviewUri)(l._initData,this._uuid,u)}get cspSource(){return l._initData.webviewCspSource}set options(u){this._options=u,l._proxy.$setOptions(m,u)}get options(){return this._options}set html(u){this._html=u,l._proxy.$setHtml(m,u)}get html(){return this._html}get onDidReceiveMessage(){return y.event}postMessage(u){return l._proxy.$postMessage(m,u)}},d=new class{constructor(){this.editor=S,this.line=i,this.height=T,this.webview=v,this.onDidDispose=g.event}dispose(){l._insets.has(m)&&(l._insets.delete(m),l._proxy.$disposeEditorInset(m),g.fire(),g.dispose(),y.dispose())}};return this._proxy.$createEditorInset(m,f.id,f.value.document.uri,i+1,T,k||{},E.identifier,E.extensionLocation),this._insets.set(m,{editor:S,inset:d,onDidReceiveMessage:y}),d}$onDidDispose(S){const i=this._insets.get(S);i&&i.inset.dispose()}$onDidReceiveMessage(S,i){const T=this._insets.get(S);T&&T.onDidReceiveMessage.fire(i)}}e.ExtHostEditorInsets=C}),define(ge[198],pe([0,1,3,59,166,4,6,23,40,12,53,22,47,191]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",E.Codicon.window,(0,R.localize)(0,null));var l;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(l=e.Extensions||(e.Extensions={}));var m;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={}));function y(n){switch(n){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=y;function g(n){return`viewContainer.${n}.enabled`}e.getEnabledViewContainerContextKey=g;class v extends C.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new p.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new p.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,i.flatten)([...this.viewContainers.values()])}registerViewContainer(c,b,w){var h;const _=this.get(c.id);if(_)return _;const A=c;return A.openCommandActionDescriptor=(w==null?void 0:w.donotRegisterOpenCommand)?void 0:(h=A.openCommandActionDescriptor)!==null&&h!==void 0?h:{id:A.id},(0,P.getOrSet)(this.viewContainers,b,[]).push(A),(w==null?void 0:w.isDefault)&&this.defaultViewContainers.push(A),this._onDidRegister.fire({viewContainer:A,viewContainerLocation:b}),A}deregisterViewContainer(c){for(const b of this.viewContainers.keys()){const w=this.viewContainers.get(b),h=w==null?void 0:w.indexOf(c);if(h!==-1){w==null||w.splice(h,1),w.length===0&&this.viewContainers.delete(b),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:b});return}}}get(c){return this.all.filter(b=>b.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(b=>this.getViewContainers(b).filter(w=>(w==null?void 0:w.id)===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(b=>this.getViewContainerLocation(b)===c)}}S.Registry.add(l.ViewContainersRegistry,new v);var d;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function u(n,c){var b,w,h,_;const A=(b=n.group)!==null&&b!==void 0?b:d.More,L=(w=c.group)!==null&&w!==void 0?w:d.More;return A!==L?A.localeCompare(L):((h=n.order)!==null&&h!==void 0?h:5)-((_=c.order)!==null&&_!==void 0?_:5)}class o extends C.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new p.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new p.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new p.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new p.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(c,b){this.registerViews2([{views:c,viewContainer:b}])}registerViews2(c){c.forEach(({views:b,viewContainer:w})=>this.addViews(b,w)),this._onViewsRegistered.fire(c)}deregisterViews(c,b){const w=this.removeViews(c,b);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:b})}moveViews(c,b){for(const w of this._views.keys())if(w!==b){const h=this.removeViews(c,w);h.length&&(this.addViews(h,b),this._onDidChangeContainer.fire({views:h,from:w,to:b}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const b of this._viewContainers){const w=(this._views.get(b)||[]).filter(h=>h.id===c)[0];if(w)return w}return null}getViewContainer(c){for(const b of this._viewContainers)if((this._views.get(b)||[]).filter(h=>h.id===c)[0])return b;return null}registerViewWelcomeContent(c,b){return this._viewWelcomeContents.add(c,b),this._onDidChangeViewWelcomeContent.fire(c),(0,C.toDisposable)(()=>{this._viewWelcomeContents.delete(c,b),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,b){const w=new Map;for(const[h,_]of b)this._viewWelcomeContents.add(c,_),w.set(h,(0,C.toDisposable)(()=>{this._viewWelcomeContents.delete(c,_),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),w}getViewWelcomeContent(c){const b=[];return this._viewWelcomeContents.forEach(c,w=>b.push(w)),b.sort(u)}addViews(c,b){let w=this._views.get(b);w||(w=[],this._views.set(b,w),this._viewContainers.push(b));for(const h of c){if(this.getView(h.id)!==null)throw new Error((0,R.localize)(1,null,h.id));w.push(h)}}removeViews(c,b){const w=this._views.get(b);if(!w)return[];const h=[],_=[];for(const A of w)c.includes(A)?h.push(A):_.push(A);return h.length&&(_.length?this._views.set(b,_):(this._views.delete(b),this._viewContainers.splice(this._viewContainers.indexOf(b),1))),h}}S.Registry.add(l.ViewsRegistry,new o),e.IViewsService=(0,I.createDecorator)("viewsService"),e.FocusedViewContext=new D.RawContextKey("focusedView","",(0,R.localize)(2,null));function t(n){return`view.${n}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,I.createDecorator)("viewDescriptorService");var r;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class a{constructor(c,b){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,c),this._hasResolve=!!b,this.resolve=async w=>{var h,_;if(b&&!this.resolved){const A=await b(w);A&&(this.tooltip=(h=this.tooltip)!==null&&h!==void 0?h:A.tooltip,this.command=(_=this.command)!==null&&_!==void 0?_:A.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a}),define(ge[199],pe([0,1,2,178,114,13,179,198]),function(Z,e,p,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function S(m){return(y,...g)=>m(y.get(D.ICommandService),...g)}class i{static execute(y,g){const v={forceReuseWindow:g&&g.reuseWindow,remoteAuthority:g&&g.remoteAuthority};return y.executeCommand("_files.newWindow",v)}}e.NewWindowAPICommand=i,i.ID="vscode.newWindow",D.CommandsRegistry.registerCommand({id:i.ID,handler:S(i.execute),description:{description:"Opens an new window",args:[]}}),D.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(m,y){return m.get(R.IWorkspacesService).removeRecentlyOpened([y])});class T{static execute(y,g){return typeof g=="string"?g=g.match(/^[^:/?#]+:\/\//)?p.URI.parse(g):p.URI.file(g):g=p.URI.revive(g),y.executeCommand("_workbench.removeFromRecentlyOpened",g)}}e.RemoveFromRecentlyOpenedAPICommand=T,T.ID="vscode.removeFromRecentlyOpened",D.CommandsRegistry.registerCommand(T.ID,S(T.execute));class k{static execute(y,g){const v=typeof g=="string"?{extensionId:g}:g;return y.executeCommand("workbench.action.openIssueReporter",v)}}e.OpenIssueReporter=k,k.ID="vscode.openIssueReporter",D.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(m,y){const g=m.get(R.IWorkspacesService);let v;const d=y.uri,u=y.label,o=y.remoteAuthority;return y.type==="workspace"?v={workspace:await g.getWorkspaceIdentifier(d),label:u,remoteAuthority:o}:y.type==="folder"?v={folderUri:d,label:u,remoteAuthority:o}:v={fileUri:d,label:u,remoteAuthority:o},g.addRecentlyOpened([v])}),D.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(m){return m.get(R.IWorkspacesService).getRecentlyOpened()}),D.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(m,y){const g=m.get(I.ILogService),v=m.get(C.IEnvironmentService);v.isExtensionDevelopment&&!!v.extensionTestsLocationURI&&g.setLevel(y)}),D.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(m){return m.get(I.ILogService).getLevel()}),D.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(m,y){const g=m.get(P.IViewDescriptorService),v=g.getViewContainerById(y.destinationId);if(!!v){for(const d of y.viewIds){const u=g.getViewDescriptorById(d);(u==null?void 0:u.canMoveView)&&g.moveViewsToContainer([u],v,P.ViewVisibilityState.Default)}await m.get(P.IViewsService).openViewContainer(v.id,!0)}});class E{static execute(y,g){return!Array.isArray(g==null?void 0:g.viewIds)||typeof(g==null?void 0:g.destinationId)!="string"?Promise.reject("Invalid arguments"):y.executeCommand("_workbench.action.moveViews",g)}}e.MoveViewsAPICommand=E,E.ID="vscode.moveViews",D.CommandsRegistry.registerCommand({id:E.ID,handler:S(E.execute),description:{description:"Move Views",args:[]}});class f{static execute(y,g){return y.executeCommand("_workbench.open",g)}}f.ID="vscode.open",D.CommandsRegistry.registerCommand(f.ID,S(f.execute));class l{static execute(y,g,v,d,u){return y.executeCommand("_workbench.diff",[g,v,d])}}l.ID="vscode.diff",D.CommandsRegistry.registerCommand(l.ID,S(l.execute))}),define(ge[118],pe([0,1,3,19,167]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class I{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new p.Emitter,this._onExit=new p.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,S,i,T){const k={command:P};if(S&&Object.keys(S).length>0&&(k.arguments=S),this.internalSend("request",k),typeof T=="number"){const E=setTimeout(()=>{clearTimeout(E);const f=this.pendingRequests.get(k.seq);if(f){this.pendingRequests.delete(k.seq);const l={type:"response",seq:0,request_seq:k.seq,success:!1,command:P,message:(0,R.localize)(0,null,T,P)};f(l)}},T)}return i&&this.pendingRequests.set(k.seq,i),k.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,S){return P.type!=="event"||S.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,D.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const S=P,i=this.pendingRequests.get(S.request_seq);i&&(this.pendingRequests.delete(S.request_seq),i(S));break}}}internalSend(P,S){S.type=P,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((S,i)=>P.set(i,S)),await(0,D.timeout)(500),P.forEach((S,i)=>{S({type:"response",seq:0,request_seq:i,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(i)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=I}),define(ge[200],pe([0,1,9,2,7,22,11]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function S(r,s,a){return r.replace(P,function(n,c){return s&&c.length>0&&c[0]!=="_"?n:a&&a.hasOwnProperty(c)?a[c]:n})}e.formatPII=S;function i(r){const s={};for(const a of Object.keys(r))a.startsWith("!")||(s[a]=r[a]);return s}e.filterExceptionsFromTelemetry=i;function T(r){return r.configuration.request==="attach"&&!k(r)}e.isSessionAttach=T;function k(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,p.equalsIgnoreCase)(s,"extensionhost")||(0,p.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?k(r.parentSession):void 0}e.getExtensionHostDebugSession=k;function E(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=E;function f(r,s,a){let n,c=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,w=null;for(;w=b.exec(r);){let h=w.index+1,_=h+w[0].length;if(h<=s&&_>=a){n=w[0],c=h;break}}if(n){let h=/\w+/g,_=null;for(;(_=h.exec(n))&&!(_.index+1+c+_[0].length>=a););_&&(n=n.substring(0,h.lastIndex))}return n?{start:c,end:c+n.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(r){return!!(r&&r.match(l))}e.isUri=m;function y(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(m(r.path))return D.URI.parse(r.path);if((0,R.isAbsolute)(r.path))return D.URI.file(r.path)}return r.path}function g(r){if(typeof r.path=="object"){const s=D.URI.revive(r.path);if(s)return s.scheme===C.Schemas.file?s.fsPath:s.toString()}return r.path}function v(r,s){const a=s?y:g,n=(0,I.deepClone)(r);return u(n,(c,b)=>{c&&b&&(b.path=a(b))}),n}e.convertToDAPaths=v;function d(r,s){const a=s?y:g,n=(0,I.deepClone)(r);return u(n,(c,b)=>{!c&&b&&(b.path=a(b))}),n}e.convertToVSCPaths=d;function u(r,s){switch(r.type){case"event":const a=r;switch(a.event){case"output":s(!1,a.body.source);break;case"loadedSource":s(!1,a.body.source);break;case"breakpoint":s(!1,a.body.breakpoint.source);break;default:break}break;case"request":const n=r;switch(n.command){case"setBreakpoints":s(!0,n.arguments.source);break;case"breakpointLocations":s(!0,n.arguments.source);break;case"source":s(!0,n.arguments.source);break;case"gotoTargets":s(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(b=>s(!1,b));break;default:break}break;case"response":const c=r;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(b=>s(!1,b.source));break;case"loadedSources":c.body.sources.forEach(b=>s(!1,b));break;case"scopes":c.body.scopes.forEach(b=>s(!1,b.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(b=>s(!1,b.source));break;case"setBreakpoints":c.body.breakpoints.forEach(b=>s(!1,b.source));break;default:break}break}}function o(r){return r.filter(s=>{var a;return!((a=s.presentation)===null||a===void 0?void 0:a.hidden)}).sort((s,a)=>s.presentation?a.presentation?s.presentation.group?a.presentation.group?s.presentation.group!==a.presentation.group?s.presentation.group.localeCompare(a.presentation.group):t(s.presentation.order,a.presentation.order):-1:a.presentation.group?1:t(s.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=o;function t(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}}),define(ge[201],pe([0,1,25,39,168,119,7,9,22,10,180,118]),function(Z,e,p,D,R,I,C,P,S,i,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class E extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(v,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,v.on("data",u=>this.handleData(u))}sendMessage(v){if(this.outputStream){const d=JSON.stringify(v);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${E.TWO_CRLF}${d}`,"utf8")}}handleData(v){for(this.rawData=Buffer.concat([this.rawData,v]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(u){this._onError.fire(new Error((u.message||u)+`
`+d))}continue}}else{const d=this.rawData.indexOf(E.TWO_CRLF);if(d!==-1){const o=this.rawData.toString("utf8",0,d).split(E.HEADER_LINESEPARATOR);for(const t of o){const r=t.split(E.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(d+E.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=E,E.TWO_CRLF=`\r
\r
`,E.HEADER_LINESEPARATOR=/\r?\n/,E.HEADER_FIELDSEPARATOR=/: */;class f extends E{startSession(){return new Promise((v,d)=>{let u=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),v(),u=!0}),this.socket.on("close",()=>{u?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",o=>{u?this._onError.fire(o):d(o)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class l extends f{constructor(v){super();this.adapterServer=v}createConnection(v){return I.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",v)}}e.SocketDebugAdapter=l;class m extends f{constructor(v){super();this.adapterServer=v}createConnection(v){return I.createConnection(this.adapterServer.path,v)}}e.NamedPipeDebugAdapter=m;class y extends E{constructor(v,d,u){super();this.adapterExecutable=v,this.debugType=d,this.outputService=u}async startSession(){const v=this.adapterExecutable.command,d=this.adapterExecutable.args,u=this.adapterExecutable.options||{};try{if(v)if(C.isAbsolute(v)){if(!await(0,p.exists)(v))throw new Error(R.localize(0,null,v))}else v.indexOf("/")<0&&v.indexOf("\\")<0;else throw new Error(R.localize(1,null,this.debugType));let o=process.env;if(u.env&&Object.keys(u.env).length>0&&(o=S.mixin(S.deepClone(process.env),u.env)),v==="node")if(Array.isArray(d)&&d.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:o,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};u.cwd&&(s.cwd=u.cwd);const a=D.fork(d[0],d.slice(1),s);if(!a.pid)throw new Error(R.localize(2,null,d[0]));this.serverProcess=a}else throw new Error(R.localize(3,null));else{const r={env:o};u.cwd&&(r.cwd=u.cwd),this.serverProcess=D.spawn(v,d,r)}this.serverProcess.on("error",r=>{this._onError.fire(r)}),this.serverProcess.on("exit",(r,s)=>{this._onExit.fire(r)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",r=>{this._onError.fire(r)}),this.serverProcess.stdin.on("error",r=>{this._onError.fire(r)});const t=this.outputService;if(t){const r=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const a=t.getChannel(T.ExtensionsChannelId);a&&a.append(r(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(o){this._onError.fire(o)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),i.isWindows?new Promise((v,d)=>{const u=D.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(o,t,r){if(o)return d(o)});u.on("exit",v),u.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(v,d){if(!!v){const u=Object.create(null);v.runtime&&(v.runtime.indexOf("./")===0?u.runtime=C.join(d,v.runtime):u.runtime=v.runtime),v.runtimeArgs&&(u.runtimeArgs=v.runtimeArgs),v.program&&(C.isAbsolute(v.program)?u.program=v.program:u.program=C.join(d,v.program)),v.args&&(u.args=v.args);const o=v;return o.win&&(u.win=y.extract(o.win,d)),o.winx86&&(u.winx86=y.extract(o.winx86,d)),o.windows&&(u.windows=y.extract(o.windows,d)),o.osx&&(u.osx=y.extract(o.osx,d)),o.linux&&(u.linux=y.extract(o.linux,d)),u}}static platformAdapterExecutable(v,d){let u=Object.create(null);d=d.toLowerCase();for(const n of v)if(n.contributes){const c=n.contributes.debuggers;c&&c.length>0&&c.filter(b=>typeof b.type=="string"&&P.equalsIgnoreCase(b.type,d)).forEach(b=>{const w=y.extract(b,n.extensionLocation.fsPath);u=S.mixin(u,w,n.isBuiltin)})}let o;i.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=u.winx86||u.win||u.windows:i.isWindows?o=u.win||u.windows:i.isMacintosh?o=u.osx:i.isLinux&&(o=u.linux),o=o||u;let t=o.program||u.program;const r=o.args||u.args;let s=o.runtime||u.runtime;const a=o.runtimeArgs||u.runtimeArgs;if(s)return{type:"executable",command:s,args:(a||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.ExecutableDebugAdapter=y}),define(ge[202],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ge[203],pe([0,1,39,7,78,169,25,10,83,4,202,11]),function(Z,e,p,D,R,I,C,P,S,i,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=I.localize(0,null);let f=class Ut{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(p,u,R.getWindowsShell(),d)}}runInTerminal(d,u,o,t,r){const s=r.windowsExec||Ut.getDefaultTerminalWindows();return new Promise((a,n)=>{const c=`"${u} - ${E}"`,b=`""${o.join('" "')}" & pause"`,w=["/c","start",c,"/wait",s,"/c",b],h=Object.assign({},process.env,t);Object.keys(h).filter(L=>h[L]===null).forEach(L=>delete h[L]);const _={cwd:u,env:h,windowsVerbatimArguments:!0};p.spawn(Ut.CMD,w,_).on("error",L=>{n(y(L))}),a(void 0)})}spawnTerminal(d,u,o,t){const s=u.terminal.external.windowsExec||Ut.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const a=D.basename(s).toLowerCase();if(a==="cmder"||a==="cmder.exe")return d.spawn(s,t?[t]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return s.indexOf(" ")>=0&&n.push('""'),n.push(s),(a==="wt"||a==="wt.exe")&&n.push("-d ."),new Promise((c,b)=>{const w=t?{cwd:t}:void 0,h=d.spawn(o,n,w);h.on("error",b),h.on("exit",()=>c())})}static getDefaultTerminalWindows(){if(!Ut._DEFAULT_TERMINAL_WINDOWS){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Ut._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return Ut._DEFAULT_TERMINAL_WINDOWS}};f.CMD="cmd.exe",f=je([Ue(0,(0,i.optional)(S.IConfigurationService))],f),e.WindowsExternalTerminalService=f;let l=class Tn{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(p,u,d)}}runInTerminal(d,u,o,t,r){const s=r.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((a,n)=>{if(s===T.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const c=s===T.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",w=[k.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,Z).fsPath,"-t",d||E,"-w",u];for(let A of o)w.push("-a"),w.push(A);if(t)for(let A in t){const L=t[A];L===null?(w.push("-u"),w.push(A)):(w.push("-e"),w.push(`${A}=${L}`))}let h="";const _=p.spawn(Tn.OSASCRIPT,w);_.on("error",A=>{n(y(A))}),_.stderr.on("data",A=>{h+=A.toString()}),_.on("exit",A=>{if(A===0)a(void 0);else if(h){const L=h.split(`
`,1);n(new Error(L[0]))}else n(new Error(I.localize(1,null,c,A)))})}else n(new Error(I.localize(2,null,s)))})}spawnTerminal(d,u,o){const r=u.terminal.external.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{const n=["-a",r];o&&n.push(o);const c=d.spawn("/usr/bin/open",n);c.on("error",a),c.on("exit",()=>s())})}};l.OSASCRIPT="/usr/bin/osascript",l=je([Ue(0,(0,i.optional)(S.IConfigurationService))],l),e.MacExternalTerminalService=l;let m=class xt{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(p,u,d)}}runInTerminal(d,u,o,t,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):xt.getDefaultTerminalLinuxReady();return new Promise((a,n)=>{let c=[];s.then(b=>{b.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const w=`${g(o)}; echo; read -p "${xt.WAIT_MESSAGE}" -n1;`;c.push(`''${w}''`);const h=Object.assign({},process.env,t);Object.keys(h).filter(W=>h[W]===null).forEach(W=>delete h[W]);const _={cwd:u,env:h};let A="";const L=p.spawn(b,c,_);L.on("error",W=>{n(y(W))}),L.stderr.on("data",W=>{A+=W.toString()}),L.on("exit",W=>{if(W===0)a(void 0);else if(A){const j=A.split(`
`,1);n(new Error(j[0]))}else n(new Error(I.localize(4,null,b,W)))})})})}spawnTerminal(d,u,o){const t=u.terminal.external,r=t.linuxExec?Promise.resolve(t.linuxExec):xt.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{r.then(n=>{const c=o?{cwd:o}:void 0,b=d.spawn(n,[],c);b.on("error",a),b.on("exit",()=>s())})})}static async getDefaultTerminalLinuxReady(){return xt._DEFAULT_TERMINAL_LINUX_READY||(xt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async d=>{P.isLinux?await C.exists("/etc/debian_version")?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm"):d("xterm")})),xt._DEFAULT_TERMINAL_LINUX_READY}};m.WAIT_MESSAGE=I.localize(3,null),m=je([Ue(0,(0,i.optional)(S.IConfigurationService))],m),e.LinuxExternalTerminalService=m;function y(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(I.localize(5,null,v.path)):v}function g(v){let d="";for(let u of v)u.indexOf(" ")>=0?d+='"'+u+'"':d+=u,d+=" ";return d}}),define(ge[204],pe([0,1,39,10,203,30]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let C;function P(E,f){if(!C)if(D.isWindows)C=new R.WindowsExternalTerminalService(void 0);else if(D.isMacintosh)C=new R.MacExternalTerminalService(void 0);else if(D.isLinux)C=new R.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const l=f.getConfiguration("terminal");return C.runInTerminal(E.title,E.cwd,E.args,E.env||{},l.external||{})}e.runInExternalTerminal=P;function S(E,f){return new Promise((l,m)=>{let y="";const g=p.spawn(E,f);g.pid&&g.stdout.on("data",v=>{y+=v.toString()}),g.on("error",v=>{m(v)}),g.on("close",v=>{l(y)})})}function i(E){return E?D.isWindows?S("wmic",["process","get","ParentProcessId"]).then(f=>f.split(`\r
`).some(m=>parseInt(m)===E),f=>!0):S("/usr/bin/pgrep",["-lP",String(E)]).then(f=>{const l=f.trim();return!(l.length===0||l.indexOf(" tmux")>=0)},f=>!0):Promise.resolve(!0)}e.hasChildProcesses=i;var T;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})(T||(T={}));function k(E,f,l,m){E=E.trim().toLowerCase();let y;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?y=1:E.indexOf("cmd.exe")>=0?y=0:E.indexOf("bash")>=0?y=2:D.isWindows?y=0:y=2;let g,v=" ";switch(y){case 1:if(g=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),l){const u=(0,I.getDriveLetter)(l);u&&(v+=`${u}:; `),v+=`cd ${g(l)}; `}if(m)for(let u in m){const o=m[u];o===null?v+=`Remove-Item env:${u}; `:v+=`\${env:${u}}='${o}'; `}if(f.length>0){const u=g(f.shift());v+=u[0]==="'"?`& ${u} `:`${u} `;for(let o of f)v+=`${g(o)} `}break;case 0:if(g=u=>(u=u.replace(/\"/g,'""'),u.indexOf(" ")>=0||u.indexOf('"')>=0||u.length===0?`"${u}"`:u),l){const u=(0,I.getDriveLetter)(l);u&&(v+=`${u}: && `),v+=`cd ${g(l)} && `}if(m){v+='cmd /C "';for(let u in m){let o=m[u];o===null?v+=`set "${u}=" && `:(o=o.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),v+=`set "${u}=${o}" && `)}}for(let u of f)v+=`${g(u)} `;m&&(v+='"');break;case 2:g=u=>(u=u.replace(/(["'\\\$])/g,"\\$1"),u.indexOf(" ")>=0||u.indexOf(";")>=0||u.length===0?`"${u}"`:u);const d=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(l&&(v+=`cd ${g(l)} ; `),m){v+="/usr/bin/env";for(let u in m){const o=m[u];o===null?v+=` -u ${d(u)}`:v+=` ${d(`${u}=${o}`)}`}v+=" "}for(let u of f)v+=`${g(u)} `;break}return v}e.prepareCommand=k}),define(ge[85],pe([0,1,33,11,7,10,59]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellRunState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(w){w[w.Markdown=1]="Markdown",w[w.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(w){w[w.Running=1]="Running",w[w.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,cellHasExecutionOrder:!0,custom:{},runState:S.Idle,trusted:!0};var i;(function(w){w[w.Running=1]="Running",w[w.Idle=2]="Idle",w[w.Success=3]="Success",w[w.Error=4]="Error"})(i=e.NotebookCellRunState||(e.NotebookCellRunState={}));var T;(function(w){w[w.ModelChange=1]="ModelChange",w[w.Move=2]="Move",w[w.CellClearOutput=3]="CellClearOutput",w[w.CellsClearOutput=4]="CellsClearOutput",w[w.ChangeLanguage=5]="ChangeLanguage",w[w.Initialize=6]="Initialize",w[w.ChangeCellMetadata=7]="ChangeCellMetadata",w[w.Output=8]="Output",w[w.OutputItem=9]="OutputItem",w[w.ChangeCellContent=10]="ChangeCellContent",w[w.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",w[w.Unknown=12]="Unknown"})(T=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var k;(function(w){w[w.Handle=0]="Handle",w[w.Index=1]="Index"})(k=e.SelectionStateType||(e.SelectionStateType={}));var E;(function(w){w[w.Replace=1]="Replace",w[w.Output=2]="Output",w[w.Metadata=3]="Metadata",w[w.CellLanguage=4]="CellLanguage",w[w.DocumentMetadata=5]="DocumentMetadata",w[w.OutputsSplice=6]="OutputsSplice",w[w.Move=7]="Move",w[w.Unknown=8]="Unknown",w[w.CellContent=9]="CellContent",w[w.OutputItems=10]="OutputItems"})(E=e.CellEditType||(e.CellEditType={}));function f(w){const h=l.parse(w);return h?h.notebook.toString():w.toString()}e.getCellUndoRedoComparisonKey=f;var l;(function(w){w.scheme=D.Schemas.vscodeNotebookCell;const h=/^ch(\d{7,})/;function _(j,K){return j.with({scheme:w.scheme,fragment:`ch${K.toString().padStart(7,"0")}${j.scheme!==D.Schemas.file?j.scheme:""}`})}w.generate=_;function A(j){if(j.scheme===w.scheme){const K=h.exec(j.fragment);if(!!K)return{handle:Number(K[1]),notebook:j.with({scheme:j.fragment.substr(K[0].length)||D.Schemas.file,fragment:null})}}}w.parse=A;function L(j,K){return j.with({scheme:D.Schemas.vscodeNotebookCellMetadata,fragment:`ch${K.toString().padStart(7,"0")}${j.scheme!==D.Schemas.file?j.scheme:""}`})}w.generateCellMetadataUri=L;function W(j){if(j.scheme===D.Schemas.vscodeNotebookCellMetadata){const K=h.exec(j.fragment);if(!!K)return{handle:Number(K[1]),notebook:j.with({scheme:j.fragment.substr(K[0].length)||D.Schemas.file,fragment:null})}}}w.parseCellMetadataUri=W})(l=e.CellUri||(e.CellUri={}));const m=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}]]);function y(w){var h,_;return(_=(h=m.get(w))===null||h===void 0?void 0:h.alwaysSecure)!==null&&_!==void 0?_:!1}e.mimeTypeIsAlwaysSecure=y;function g(w){var h,_;return(_=(h=m.get(w))===null||h===void 0?void 0:h.supportedByCore)!==null&&_!==void 0?_:!1}e.mimeTypeSupportedByCore=g;function v(w,h){return I.isWindows&&(w=w.replace(/\//g,"\\"),h=h.replace(/\//g,"\\")),p.match(w,h)}function d(w,h,_){let A=0;for(let L=0;L<h.length;L++){if(v(h[L],w))return A;A++}for(let L=0;L<_.length;L++){if(v(_[L],w))return A;A++}return A}function u(w,h,_){return w.sort((A,L)=>d(A,h,_)-d(L,h,_))}e.sortMimeTypes=u;function o(w,h,_,A=(L,W)=>L===W){const L=[];function W(H,$,M){if(!($===0&&M.length===0)){const U=L[L.length-1];U&&U.start+U.deleteCount===H?(U.deleteCount+=$,U.toInsert.push(...M)):L.push({start:H,deleteCount:$,toInsert:M})}}let j=0,K=0;for(;;){if(j===w.length){W(j,0,h.slice(K));break}if(K===h.length){W(j,w.length-j,[]);break}const H=w[j],$=h[K];if(A(H,$)){j+=1,K+=1;continue}_($)?(W(j,1,[]),j+=1):(W(j,0,[$]),K+=1)}return L}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new C.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var t;(function(w){w.default="default",w.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(w){const h=w;return!!((typeof h.include=="string"||p.isRelativePattern(h.include))&&(typeof h.exclude=="string"||p.isRelativePattern(h.exclude)))}e.isDocumentExcludePattern=r;function s(w,h,_){if(Array.isArray(w.viewType)&&w.viewType.indexOf(h)>=0||w.viewType===h)return!0;if(w.filenamePattern){let A=r(w.filenamePattern)?w.filenamePattern.include:w.filenamePattern,L=r(w.filenamePattern)?w.filenamePattern.exclude:void 0;if(p.match(A,(0,R.basename)(_.fsPath).toLowerCase()))return!(L&&p.match(L,(0,R.basename)(_.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s;class a{constructor(h){this.textModel=h}getElements(){const h=new Int32Array(this.textModel.cells.length);for(let _=0;_<this.textModel.cells.length;_++)h[_]=this.textModel.cells[_].getHashValue();return h}}e.CellSequence=a,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var n;(function(w){w[w.LEFT=0]="LEFT",w[w.RIGHT=1]="RIGHT"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function c(w){const h=w.shift();return h===void 0?[]:w.reduce(function(_,A){return A<=_[0][1]?_[0][1]=A+1:_.unshift([A,A+1]),_},[[h,h+1]]).reverse().map(_=>({start:_[0],end:_[1]}))}e.cellIndexesToRanges=c;function b(w){return w.reduce((_,A)=>{for(let L=A.start;L<A.end;L++)_.push(L);return _},[])}e.cellRangesToIndexes=b}),define(ge[205],pe([0,1,171,4,59]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new R.RawContextKey("customExecutionSupported",!0,p.localize(0,null)),e.ShellExecutionSupportedContext=new R.RawContextKey("shellExecutionSupported",!1,p.localize(1,null)),e.ProcessExecutionSupportedContext=new R.RawContextKey("processExecutionSupported",!1,p.localize(2,null)),e.ITaskService=(0,D.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[206],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function p(R){return[...R.entries()]}e.serializeEnvironmentVariableCollection=p;function D(R){return new Map(R)}e.deserializeEnvironmentVariableCollection=D}),define(ge[207],pe([0,1,172,59]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalContributionsDescriptor=e.DEFAULT_COMMANDS_TO_SKIP_SHELL=e.TERMINAL_COMMAND_ID=e.TitleEventSource=e.LinuxDistro=e.ProcessState=e.DEFAULT_LOCAL_ECHO_EXCLUDE=e.SUGGESTIONS_FONT_WEIGHT=e.DEFAULT_BOLD_FONT_WEIGHT=e.DEFAULT_FONT_WEIGHT=e.MAXIMUM_FONT_WEIGHT=e.MINIMUM_FONT_WEIGHT=e.DEFAULT_LINE_HEIGHT=e.MINIMUM_LETTER_SPACING=e.DEFAULT_LETTER_SPACING=e.TERMINAL_ACTION_CATEGORY=e.TERMINAL_CONFIG_SECTION=e.TerminalCursorStyle=e.SUGGESTED_RENDERER_TYPE=e.TERMINAL_CREATION_COMMANDS=e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY=e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=e.TERMINAL_VIEW_ID=void 0,e.TERMINAL_VIEW_ID="terminal",e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=new D.RawContextKey("terminalIsOpen",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=new D.RawContextKey("terminalFocus",!1,p.localize(0,null)),e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY="terminalShellType",e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=new D.RawContextKey(e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY,void 0,{type:"string",description:p.localize(1,null)}),e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=new D.RawContextKey("terminalAltBufferActive",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=new D.RawContextKey("terminalA11yTreeFocus",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=new D.RawContextKey("terminalTextSelected",!1,p.localize(2,null)),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=new D.RawContextKey("terminalFindVisible",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=new D.RawContextKey("terminalFindInputFocused",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=new D.RawContextKey("terminalFindFocused",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=new D.RawContextKey("terminalProcessSupported",!1,p.localize(3,null)),e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY="terminal.integrated.isWorkspaceShellAllowed",e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY="terminal.integrated.neverMeasureRenderTime",e.TERMINAL_CREATION_COMMANDS=["workbench.action.terminal.toggleTerminal","workbench.action.terminal.new","workbench.action.togglePanel","workbench.action.terminal.focus"],e.SUGGESTED_RENDERER_TYPE="terminal.integrated.suggestedRendererType",e.TerminalCursorStyle={BLOCK:"block",LINE:"line",UNDERLINE:"underline"},e.TERMINAL_CONFIG_SECTION="terminal.integrated",e.TERMINAL_ACTION_CATEGORY=p.localize(4,null),e.DEFAULT_LETTER_SPACING=0,e.MINIMUM_LETTER_SPACING=-5,e.DEFAULT_LINE_HEIGHT=1,e.MINIMUM_FONT_WEIGHT=1,e.MAXIMUM_FONT_WEIGHT=1e3,e.DEFAULT_FONT_WEIGHT="normal",e.DEFAULT_BOLD_FONT_WEIGHT="bold",e.SUGGESTIONS_FONT_WEIGHT=["normal","bold","100","200","300","400","500","600","700","800","900"],e.DEFAULT_LOCAL_ECHO_EXCLUDE=["vim","vi","nano","tmux"];var R;(function(S){S[S.UNINITIALIZED=0]="UNINITIALIZED",S[S.LAUNCHING=1]="LAUNCHING",S[S.RUNNING=2]="RUNNING",S[S.KILLED_DURING_LAUNCH=3]="KILLED_DURING_LAUNCH",S[S.KILLED_BY_USER=4]="KILLED_BY_USER",S[S.KILLED_BY_PROCESS=5]="KILLED_BY_PROCESS"})(R=e.ProcessState||(e.ProcessState={}));var I;(function(S){S[S.Fedora=0]="Fedora",S[S.Ubuntu=1]="Ubuntu",S[S.Unknown=2]="Unknown"})(I=e.LinuxDistro||(e.LinuxDistro={}));var C;(function(S){S[S.Api=0]="Api",S[S.Process=1]="Process",S[S.Sequence=2]="Sequence"})(C=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(S){S.FIND_NEXT="workbench.action.terminal.findNext",S.FIND_PREVIOUS="workbench.action.terminal.findPrevious",S.TOGGLE="workbench.action.terminal.toggleTerminal",S.KILL="workbench.action.terminal.kill",S.QUICK_KILL="workbench.action.terminal.quickKill",S.CONFIGURE_TERMINAL_SETTINGS="workbench.action.terminal.openSettings",S.COPY_SELECTION="workbench.action.terminal.copySelection",S.SELECT_ALL="workbench.action.terminal.selectAll",S.DELETE_WORD_LEFT="workbench.action.terminal.deleteWordLeft",S.DELETE_WORD_RIGHT="workbench.action.terminal.deleteWordRight",S.DELETE_TO_LINE_START="workbench.action.terminal.deleteToLineStart",S.MOVE_TO_LINE_START="workbench.action.terminal.moveToLineStart",S.MOVE_TO_LINE_END="workbench.action.terminal.moveToLineEnd",S.NEW="workbench.action.terminal.new",S.NEW_WITH_CWD="workbench.action.terminal.newWithCwd",S.NEW_LOCAL="workbench.action.terminal.newLocal",S.NEW_IN_ACTIVE_WORKSPACE="workbench.action.terminal.newInActiveWorkspace",S.SPLIT="workbench.action.terminal.split",S.SPLIT_IN_ACTIVE_WORKSPACE="workbench.action.terminal.splitInActiveWorkspace",S.RELAUNCH="workbench.action.terminal.relaunch",S.FOCUS_PREVIOUS_PANE="workbench.action.terminal.focusPreviousPane",S.FOCUS_NEXT_PANE="workbench.action.terminal.focusNextPane",S.RESIZE_PANE_LEFT="workbench.action.terminal.resizePaneLeft",S.RESIZE_PANE_RIGHT="workbench.action.terminal.resizePaneRight",S.RESIZE_PANE_UP="workbench.action.terminal.resizePaneUp",S.RESIZE_PANE_DOWN="workbench.action.terminal.resizePaneDown",S.FOCUS="workbench.action.terminal.focus",S.FOCUS_NEXT="workbench.action.terminal.focusNext",S.FOCUS_PREVIOUS="workbench.action.terminal.focusPrevious",S.PASTE="workbench.action.terminal.paste",S.SELECT_DEFAULT_SHELL="workbench.action.terminal.selectDefaultShell",S.RUN_SELECTED_TEXT="workbench.action.terminal.runSelectedText",S.RUN_ACTIVE_FILE="workbench.action.terminal.runActiveFile",S.SWITCH_TERMINAL="workbench.action.terminal.switchTerminal",S.SCROLL_DOWN_LINE="workbench.action.terminal.scrollDown",S.SCROLL_DOWN_PAGE="workbench.action.terminal.scrollDownPage",S.SCROLL_TO_BOTTOM="workbench.action.terminal.scrollToBottom",S.SCROLL_UP_LINE="workbench.action.terminal.scrollUp",S.SCROLL_UP_PAGE="workbench.action.terminal.scrollUpPage",S.SCROLL_TO_TOP="workbench.action.terminal.scrollToTop",S.CLEAR="workbench.action.terminal.clear",S.CLEAR_SELECTION="workbench.action.terminal.clearSelection",S.MANAGE_WORKSPACE_SHELL_PERMISSIONS="workbench.action.terminal.manageWorkspaceShellPermissions",S.RENAME="workbench.action.terminal.rename",S.RENAME_WITH_ARG="workbench.action.terminal.renameWithArg",S.FIND_FOCUS="workbench.action.terminal.focusFind",S.FIND_HIDE="workbench.action.terminal.hideFind",S.QUICK_OPEN_TERM="workbench.action.quickOpenTerm",S.SCROLL_TO_PREVIOUS_COMMAND="workbench.action.terminal.scrollToPreviousCommand",S.SCROLL_TO_NEXT_COMMAND="workbench.action.terminal.scrollToNextCommand",S.SELECT_TO_PREVIOUS_COMMAND="workbench.action.terminal.selectToPreviousCommand",S.SELECT_TO_NEXT_COMMAND="workbench.action.terminal.selectToNextCommand",S.SELECT_TO_PREVIOUS_LINE="workbench.action.terminal.selectToPreviousLine",S.SELECT_TO_NEXT_LINE="workbench.action.terminal.selectToNextLine",S.TOGGLE_ESCAPE_SEQUENCE_LOGGING="toggleEscapeSequenceLogging",S.SEND_SEQUENCE="workbench.action.terminal.sendSequence",S.TOGGLE_FIND_REGEX="workbench.action.terminal.toggleFindRegex",S.TOGGLE_FIND_WHOLE_WORD="workbench.action.terminal.toggleFindWholeWord",S.TOGGLE_FIND_CASE_SENSITIVE="workbench.action.terminal.toggleFindCaseSensitive",S.NAVIGATION_MODE_EXIT="workbench.action.terminal.navigationModeExit",S.NAVIGATION_MODE_FOCUS_NEXT="workbench.action.terminal.navigationModeFocusNext",S.NAVIGATION_MODE_FOCUS_PREVIOUS="workbench.action.terminal.navigationModeFocusPrevious",S.SHOW_ENVIRONMENT_INFORMATION="workbench.action.terminal.showEnvironmentInformation",S.SEARCH_WORKSPACE="workbench.action.terminal.searchWorkspace",S.ATTACH_TO_REMOTE_TERMINAL="workbench.action.terminal.attachToSession"})(P=e.TERMINAL_COMMAND_ID||(e.TERMINAL_COMMAND_ID={})),e.DEFAULT_COMMANDS_TO_SKIP_SHELL=["workbench.action.terminal.clearSelection","workbench.action.terminal.clear","workbench.action.terminal.copySelection","workbench.action.terminal.deleteToLineStart","workbench.action.terminal.deleteWordLeft","workbench.action.terminal.deleteWordRight","workbench.action.terminal.focusFind","workbench.action.terminal.hideFind","workbench.action.terminal.findNext","workbench.action.terminal.findPrevious","workbench.action.terminal.toggleFindRegex","workbench.action.terminal.toggleFindWholeWord","workbench.action.terminal.toggleFindCaseSensitive","workbench.action.terminal.focusNextPane","workbench.action.terminal.focusNext","workbench.action.terminal.focusPreviousPane","workbench.action.terminal.focusPrevious","workbench.action.terminal.focus","workbench.action.terminal.kill","workbench.action.terminal.moveToLineEnd","workbench.action.terminal.moveToLineStart","workbench.action.terminal.newInActiveWorkspace","workbench.action.terminal.new","workbench.action.terminal.paste","workbench.action.terminal.resizePaneDown","workbench.action.terminal.resizePaneLeft","workbench.action.terminal.resizePaneRight","workbench.action.terminal.resizePaneUp","workbench.action.terminal.runActiveFile","workbench.action.terminal.runSelectedText","workbench.action.terminal.scrollDown","workbench.action.terminal.scrollDownPage","workbench.action.terminal.scrollToBottom","workbench.action.terminal.scrollToNextCommand","workbench.action.terminal.scrollToPreviousCommand","workbench.action.terminal.scrollToTop","workbench.action.terminal.scrollUp","workbench.action.terminal.scrollUpPage","workbench.action.terminal.sendSequence","workbench.action.terminal.selectAll","workbench.action.terminal.selectToNextCommand","workbench.action.terminal.selectToNextLine","workbench.action.terminal.selectToPreviousCommand","workbench.action.terminal.selectToPreviousLine","workbench.action.terminal.splitInActiveWorkspace","workbench.action.terminal.split","workbench.action.terminal.toggleTerminal","workbench.action.terminal.navigationModeExit","workbench.action.terminal.navigationModeFocusNext","workbench.action.terminal.navigationModeFocusPrevious","editor.action.toggleTabFocusMode","workbench.action.quickOpen","workbench.action.quickOpenPreviousEditor","workbench.action.showCommands","workbench.action.tasks.build","workbench.action.tasks.restartTask","workbench.action.tasks.runTask","workbench.action.tasks.reRunTask","workbench.action.tasks.showLog","workbench.action.tasks.showTasks","workbench.action.tasks.terminate","workbench.action.tasks.test","workbench.action.toggleFullScreen","workbench.action.terminal.focusAtIndex1","workbench.action.terminal.focusAtIndex2","workbench.action.terminal.focusAtIndex3","workbench.action.terminal.focusAtIndex4","workbench.action.terminal.focusAtIndex5","workbench.action.terminal.focusAtIndex6","workbench.action.terminal.focusAtIndex7","workbench.action.terminal.focusAtIndex8","workbench.action.terminal.focusAtIndex9","workbench.action.focusSecondEditorGroup","workbench.action.focusThirdEditorGroup","workbench.action.focusFourthEditorGroup","workbench.action.focusFifthEditorGroup","workbench.action.focusSixthEditorGroup","workbench.action.focusSeventhEditorGroup","workbench.action.focusEighthEditorGroup","workbench.action.focusNextPart","workbench.action.focusPreviousPart","workbench.action.nextPanelView","workbench.action.previousPanelView","workbench.action.nextSideBarView","workbench.action.previousSideBarView","workbench.action.debug.start","workbench.action.debug.stop","workbench.action.debug.run","workbench.action.debug.restart","workbench.action.debug.continue","workbench.action.debug.pause","workbench.action.debug.stepInto","workbench.action.debug.stepOut","workbench.action.debug.stepOver","workbench.action.nextEditor","workbench.action.previousEditor","workbench.action.nextEditorInGroup","workbench.action.previousEditorInGroup","workbench.action.openNextRecentlyUsedEditor","workbench.action.openPreviousRecentlyUsedEditor","workbench.action.openNextRecentlyUsedEditorInGroup","workbench.action.openPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenPreviousRecentlyUsedEditor","workbench.action.quickOpenLeastRecentlyUsedEditor","workbench.action.quickOpenPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenLeastRecentlyUsedEditorInGroup","workbench.action.focusActiveEditorGroup","workbench.action.focusFirstEditorGroup","workbench.action.focusLastEditorGroup","workbench.action.firstEditorInGroup","workbench.action.lastEditorInGroup","workbench.action.navigateUp","workbench.action.navigateDown","workbench.action.navigateRight","workbench.action.navigateLeft","workbench.action.togglePanel","workbench.action.quickOpenView","workbench.action.toggleMaximizedPanel"],e.terminalContributionsDescriptor={extensionPoint:"terminal",defaultExtensionKind:"workspace",jsonSchema:{description:p.localize(5,null),type:"object",properties:{types:{type:"array",description:p.localize(6,null),items:{type:"object",required:["command","title"],properties:{command:{description:p.localize(7,null),type:"string"},title:{description:p.localize(8,null),type:"string"}}}}}}}}),define(ge[208],pe([0,1,7,10,132]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function I(o,t){if(!!t)if(D.isWindows)for(const r in t){let s=r;for(const n in o)if(r.toLowerCase()===n.toLowerCase()){s=n;break}const a=t[r];C(o,s,a)}else Object.keys(t).forEach(r=>{const s=t[r];C(o,r,s)})}e.mergeEnvironments=I;function C(o,t,r){typeof r=="string"?o[t]=r:delete o[t]}function P(o,t,r,s){o.TERM_PROGRAM="vscode",t&&(o.TERM_PROGRAM_VERSION=t),T(o,s)&&(o.LANG=k(r)),o.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=P;function S(o,t){if(!!t)for(const r of Object.keys(t)){const s=t[r];s&&(o[r]=s)}}function i(o,t){return Object.keys(t).forEach(r=>{const s=t[r];if(typeof s=="string")try{t[r]=o(s)}catch(a){t[r]=s}}),t}function T(o,t){if(t==="on")return!0;if(t==="auto"){const r=o.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function k(o){const t=o?o.split("-"):[],r=t.length;if(r===0)return"en_US.UTF-8";if(r===1){const s={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in s&&t.push(s[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=k;function E(o,t,r,s,a,n){if(o.cwd){const b=typeof o.cwd=="object"?o.cwd.fsPath:o.cwd,w=f(b,r);return l(w||b)}let c;return!o.ignoreConfigurationCwd&&a&&(r&&(a=f(a,r,n)),a&&(p.isAbsolute(a)?c=a:s&&(c=p.join(s.fsPath,a)))),c||(c=s?s.fsPath:t||""),l(c)}e.getCwd=E;function f(o,t,r){if(t)try{return t(o)}catch(s){r==null||r.error("Could not resolve terminal cwd",s);return}return o}function l(o){return D.platform===3&&o&&o[1]===":"?o[0].toUpperCase()+o.substr(1):o}function m(o){let t=o;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(r,""),`'${t}'`}e.escapeNonWindowsPath=m;function y(o,t){if(!!t)return r=>t.resolve(o,r)}e.createVariableResolver=y;function g(o,t,r,s,a,n,c,b,w=D.platform){let h=null;b&&(h=d(o,t,"automationShell",w)),h||(h=d(o,t,"shell",w));let _=h||r;if(w===3&&!s&&a){const A=p.join(a,"Sysnative").replace(/\//g,"\\").toLowerCase();_&&_.toLowerCase().indexOf(A)===0&&(_=p.join(a,"System32",_.substr(A.length+1)))}if(_&&w===3&&(_=_.replace(/\//g,"\\")),n)try{_=n(_)}catch(A){c.error("Could not resolve shell",A)}return _}e.getDefaultShell=g;function v(o,t,r,s,a,n=D.platform){if(r&&d(o,t,"automationShell",n))return[];const c=n===3?"windows":n===1?"osx":"linux",b=o(`terminal.integrated.shellArgs.${c}`);let w=(t?b.value:b.userValue)||b.defaultValue;if(!w)return[];if(typeof w=="string"&&n===3)return s?s(w):w;if(s){const h=[];for(const _ of w)try{h.push(s(_))}catch(A){a.error(`Could not resolve terminal.integrated.shellArgs.${c}`,A),h.push(_)}w=h}return w}e.getDefaultShellArgs=v;function d(o,t,r,s=D.platform){const n=o(`terminal.integrated.${r}.${s===3?"windows":s===1?"osx":"linux"}`);return(t?n.value:n.userValue)||n.defaultValue}function u(o,t,r,s,a,n,c){let b={};if(o.strictEnv)S(b,o.env);else{S(b,c);const w=Object.assign({},s?t.value:t.userValue);r&&(w&&i(r,w),o.env&&i(r,o.env)),(0,R.sanitizeProcessEnvironment)(b,"VSCODE_IPC_HOOK_CLI"),I(b,w),I(b,o.env),P(b,a,D.locale,n)}return b}e.createTerminalEnvironment=u});var en=this&&this.__asyncValues||function(Z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Z[Symbol.asyncIterator],p;return e?e.call(Z):(Z=typeof __values=="function"?__values(Z):Z[Symbol.iterator](),p={},D("next"),D("throw"),D("return"),p[Symbol.asyncIterator]=function(){return this},p);function D(I){p[I]=Z[I]&&function(C){return new Promise(function(P,S){C=Z[I](C),R(P,S,C.done,C.value)})}}function R(I,C,P,S){Promise.resolve(S).then(function(i){I({value:i,done:P})},C)}};define(ge[209],pe([0,1,37,10,25,12,7,99,188,207]),function(Z,e,p,D,R,I,C,P,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableShells=e.linuxDistro=void 0;let T=i.LinuxDistro.Unknown;if(D.isLinux){const m="/etc/os-release";R.SymlinkSupport.existsFile(m).then(async y=>{if(!!y){const v=(await p.promises.readFile(m)).toString();/NAME="?Fedora"?/.test(v)?T=i.LinuxDistro.Fedora:/NAME="?Ubuntu"?/.test(v)&&(T=i.LinuxDistro.Ubuntu)}})}e.linuxDistro=T;function k(){return D.isWindows?E():f()}e.detectAvailableShells=k;async function E(){var m,y;const g=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${process.env.windir}\\${g?"Sysnative":"System32"}`;let d=!1;(0,S.getWindowsBuildNumber)()>=16299&&(d=!0);const u={"Command Prompt":[`${v}\\cmd.exe`],"WSL Bash":[`${v}\\${d?"wsl.exe":"bash.exe"}`],"Git Bash":[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`]};try{for(var o=en((0,P.enumeratePowerShellInstallations)()),t;t=await o.next(),!t.done;){const a=t.value;u[a.displayName]=[a.exePath]}}catch(a){m={error:a}}finally{try{t&&!t.done&&(y=o.return)&&await y.call(o)}finally{if(m)throw m.error}}const r=[];Object.keys(u).forEach(a=>r.push(l(a,u[a])));const s=await Promise.all(r);return(0,I.coalesce)(s)}async function f(){return(await p.promises.readFile("/etc/shells","utf8")).split(`
`).filter(g=>g.trim().indexOf("#")!==0&&g.trim().length>0).map(g=>({label:(0,C.basename)(g),path:g}))}async function l(m,y){if(y.length===0)return Promise.resolve(void 0);const g=y.shift();if(g==="")return l(m,y);try{const v=await p.promises.stat((0,C.normalize)(g));if(v.isFile()||v.isSymbolicLink())return{label:m,path:g}}catch(v){try{const d=await p.promises.lstat((0,C.normalize)(g));if(d.isFile()||d.isSymbolicLink())return{label:m,path:g}}catch(d){}}return l(m,y)}}),define(ge[210],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=void 0;var p;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.DeltaDiscoverComplete=3]="DeltaDiscoverComplete",C[C.DeltaRootsComplete=4]="DeltaRootsComplete"})(p=e.TestDiffOpType||(e.TestDiffOpType={}));const D=(C,P)=>`${C}:${P.toString()}`;e.getTestSubscriptionKey=D;class R{add(P){}update(P){}remove(P,S){}complete(){}}e.IncrementalChangeCollector=R;class I{constructor(){this.items=new Map,this.roots=new Set}apply(P){const S=this.createChangeCollector();for(const i of P)switch(i[0]){case 0:{const T=i[1];if(T.parent){if(this.items.has(T.parent)){const k=this.items.get(T.parent);k.children.add(T.item.extId);const E=this.createItem(T,k);this.items.set(T.item.extId,E),S.add(E)}}else{this.roots.add(T.item.extId);const k=this.createItem(T);this.items.set(T.item.extId,k),S.add(k)}break}case 1:{const T=i[1],k=this.items.get(T.item.extId);k&&(Object.assign(k.item,T.item),S.update(k));break}case 2:{const T=this.items.get(i[1]);if(!T)break;T.parent?this.items.get(T.parent).children.delete(T.item.extId):this.roots.delete(T.item.extId);const k=[[i[1]]];for(;k.length;)for(const E of k.pop()){const f=this.items.get(E);f&&(k.push(f.children),this.items.delete(E),S.remove(f,f!==T))}break}case 3:this.updateBusyProviders(i[1]);break;case 4:this.updatePendingRoots(i[1]);break}S.complete()}updateBusyProviders(P){}updatePendingRoots(P){}createChangeCollector(){return new R}}e.AbstractIncrementalTestCollection=I}),define(ge[211],pe([0,1,7,36,15,22,10,76,173]),function(Z,e,p,D,R,I,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class i{constructor(k,E,f){if(this._contributedVariables=new Map,this._context=k,this._labelService=E,f)if(C.isWindows){const l=Object.create(null);this._envVariables=l,Object.keys(f).forEach(m=>{l[m.toLowerCase()]=f[m]})}else this._envVariables=f}resolve(k,E){return this.recursiveResolve(k?k.uri:void 0,E)}resolveAnyBase(k,E,f,l){const m=I.deepClone(E);return C.isWindows&&m.windows?Object.keys(m.windows).forEach(y=>m[y]=m.windows[y]):C.isMacintosh&&m.osx?Object.keys(m.osx).forEach(y=>m[y]=m.osx[y]):C.isLinux&&m.linux&&Object.keys(m.linux).forEach(y=>m[y]=m.linux[y]),delete m.windows,delete m.osx,delete m.linux,this.recursiveResolve(k?k.uri:void 0,m,f,l)}resolveAny(k,E,f){return this.resolveAnyBase(k,E,f)}resolveAnyMap(k,E,f){const l=new Map;return{newConfig:this.resolveAnyBase(k,E,f,l),resolvedVariables:l}}resolveWithInteractionReplace(k,E,f,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,E,f,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,E){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,E)}recursiveResolve(k,E,f,l){if(R.isString(E))return this.resolveString(k,E,f,l);if(R.isArray(E))return E.map(m=>this.recursiveResolve(k,m,f,l));if(R.isObject(E)){let m=Object.create(null);return Object.keys(E).forEach(y=>{const g=this.resolveString(k,y,f,l);m[g]=this.recursiveResolve(k,E[y],f,l)}),m}return E}resolveString(k,E,f,l){return E.replace(i.VARIABLE_REGEXP,(y,g)=>{if(g.includes(i.VARIABLE_LHS))return y;let v=this.evaluateSingleVariable(y,g,k,f);return l&&l.set(g,v),v})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,E,f,l){let m;const y=E.split(":");y.length>1&&(E=y[0],m=y[1]);const g=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,S.localize)(0,null,k))},v=()=>{const u=g();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,S.localize)(1,null,k,p.basename(u)))},d=()=>{if(m){const u=this._context.getFolderUri(m);if(u)return u;throw new Error((0,S.localize)(2,null,k,m))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,k)):new Error((0,S.localize)(4,null,k))};switch(E){case"env":if(m){if(this._envVariables){const u=this._envVariables[C.isWindows?m.toLowerCase():m];if(R.isString(u))return u}return""}throw new Error((0,S.localize)(5,null,k));case"config":if(m){const u=this._context.getConfigurationValue(f,m);if(R.isUndefinedOrNull(u))throw new Error((0,S.localize)(6,null,k,m));if(R.isObject(u))throw new Error((0,S.localize)(7,null,k,m));return u}throw new Error((0,S.localize)(8,null,k));case"command":return this.resolveFromMap(k,m,l,"command");case"input":return this.resolveFromMap(k,m,l,"input");default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return f||m?(0,P.normalizeDriveLetter)(this.fsPath(d())):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return p.basename(this.fsPath(d()));case"lineNumber":const u=this._context.getLineNumber();if(u)return u;throw new Error((0,S.localize)(9,null,k));case"selectedText":const o=this._context.getSelectedText();if(o)return o;throw new Error((0,S.localize)(10,null,k));case"file":return g();case"fileWorkspaceFolder":return v();case"relativeFile":return f||m?p.relative(this.fsPath(d()),g()):g();case"relativeFileDirname":const t=p.dirname(g());if(f||m){const n=p.relative(this.fsPath(d()),t);return n.length===0?".":n}return t;case"fileDirname":return p.dirname(g());case"fileExtname":return p.extname(g());case"fileBasename":return p.basename(g());case"fileBasenameNoExtension":const r=p.basename(g());return r.slice(0,r.length-p.extname(r).length);case"fileDirnameBasename":return p.basename(p.dirname(g()));case"execPath":const s=this._context.getExecPath();return s||k;case"execInstallFolder":const a=this._context.getAppRoot();return a||k;case"pathSeparator":return p.sep;default:try{const n=m?`${E}:${m}`:E;return this.resolveFromMap(k,n,l,void 0)}catch(n){return k}}}}resolveFromMap(k,E,f,l){if(E&&f){const m=l===void 0?f[E]:f[l+":"+E];if(typeof m=="string")return m;throw new Error((0,S.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=i,i.VARIABLE_LHS="${",i.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[212],pe([0,1,4]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,p.createDecorator)("editorGroupsService");var D;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var R;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var C;(function(E){E[E.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",E[E.EVEN=1]="EVEN",E[E.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var S;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(S=e.GroupsOrder||(e.GroupsOrder={}));var i;(function(E){E[E.GROUP_ACTIVE=0]="GROUP_ACTIVE",E[E.GROUP_INDEX=1]="GROUP_INDEX",E[E.EDITOR_OPEN=2]="EDITOR_OPEN",E[E.EDITOR_CLOSE=3]="EDITOR_CLOSE",E[E.EDITOR_MOVE=4]="EDITOR_MOVE",E[E.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",E[E.EDITOR_LABEL=6]="EDITOR_LABEL",E[E.EDITOR_PIN=7]="EDITOR_PIN",E[E.EDITOR_STICKY=8]="EDITOR_STICKY",E[E.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(i=e.GroupChangeKind||(e.GroupChangeKind={}));var T;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function k(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(ge[213],pe([0,1,4]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,p.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],pe([0,1,80,8,174,2,43,94,109,213,15,282,57,22,12,85]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.TestState=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var y;(function(be){function he(ee){const{selectionStartLineNumber:Te,selectionStartColumn:Re,positionLineNumber:et,positionColumn:Ke}=ee,rt=new D.Position(Te-1,Re-1),lt=new D.Position(et-1,Ke-1);return new D.Selection(rt,lt)}be.to=he;function ce(ee){const{anchor:Te,active:Re}=ee;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}be.from=ce})(y=e.Selection||(e.Selection={}));var g;(function(be){function he(ee){if(!!ee){const{start:Te,end:Re}=ee;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}}be.from=he;function ce(ee){if(!!ee){const{startLineNumber:Te,startColumn:Re,endLineNumber:et,endColumn:Ke}=ee;return new D.Range(Te-1,Re-1,et-1,Ke-1)}}be.to=ce})(g=e.Range||(e.Range={}));var v;(function(be){function he(ce){switch(ce){case 1:return D.StandardTokenType.Comment;case 0:return D.StandardTokenType.Other;case 4:return D.StandardTokenType.RegEx;case 2:return D.StandardTokenType.String}}be.to=he})(v=e.TokenType||(e.TokenType={}));var d;(function(be){function he(ee){return new D.Position(ee.lineNumber-1,ee.column-1)}be.to=he;function ce(ee){return{lineNumber:ee.line+1,column:ee.character+1}}be.from=ce})(d=e.Position||(e.Position={}));var u;(function(be){function he(ee){switch(ee){case D.DiagnosticTag.Unnecessary:return 1;case D.DiagnosticTag.Deprecated:return 2}}be.from=he;function ce(ee){switch(ee){case 1:return D.DiagnosticTag.Unnecessary;case 2:return D.DiagnosticTag.Deprecated;default:return}}be.to=ce})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(be){function he(ee){let Te;return ee.code&&((0,T.isString)(ee.code)||(0,T.isNumber)(ee.code)?Te=String(ee.code):Te={value:String(ee.code.value),target:ee.code.target}),Object.assign(Object.assign({},g.from(ee.range)),{message:ee.message,source:ee.source,code:Te,severity:r.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(t.from),tags:Array.isArray(ee.tags)?(0,l.coalesce)(ee.tags.map(u.from)):void 0})}be.from=he;function ce(ee){var Te;const Re=new D.Diagnostic(g.to(ee),ee.message,r.to(ee.severity));return Re.source=ee.source,Re.code=(0,T.isString)(ee.code)?ee.code:(Te=ee.code)===null||Te===void 0?void 0:Te.value,Re.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(t.to),Re.tags=ee.tags&&(0,l.coalesce)(ee.tags.map(u.to)),Re}be.to=ce})(o=e.Diagnostic||(e.Diagnostic={}));var t;(function(be){function he(ee){return Object.assign(Object.assign({},g.from(ee.location.range)),{message:ee.message,resource:ee.location.uri})}be.from=he;function ce(ee){return new D.DiagnosticRelatedInformation(new D.Location(ee.resource,g.to(ee)),ee.message)}be.to=ce})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(be){function he(ee){switch(ee){case D.DiagnosticSeverity.Error:return S.MarkerSeverity.Error;case D.DiagnosticSeverity.Warning:return S.MarkerSeverity.Warning;case D.DiagnosticSeverity.Information:return S.MarkerSeverity.Info;case D.DiagnosticSeverity.Hint:return S.MarkerSeverity.Hint}return S.MarkerSeverity.Error}be.from=he;function ce(ee){switch(ee){case S.MarkerSeverity.Info:return D.DiagnosticSeverity.Information;case S.MarkerSeverity.Warning:return D.DiagnosticSeverity.Warning;case S.MarkerSeverity.Error:return D.DiagnosticSeverity.Error;case S.MarkerSeverity.Hint:return D.DiagnosticSeverity.Hint;default:return D.DiagnosticSeverity.Error}}be.to=ce})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(be){function he(ee){return typeof ee=="number"&&ee>=D.ViewColumn.One?ee-1:ee===D.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}be.from=he;function ce(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ce})(s=e.ViewColumn||(e.ViewColumn={}));function a(be){return typeof be.range!="undefined"}function n(be){return be.length===0?!0:!!a(be[0])}e.isDecorationOptionsArr=n;var c;(function(be){function he(Ke){return Ke.map(be.from)}be.fromMany=he;function ce(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function ee(Ke){let rt;if(ce(Ke)){const{language:dt,value:at}=Ke;rt={value:"```"+dt+`
`+at+"\n```\n"}}else D.MarkdownString.isMarkdownString(Ke)?rt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons}:typeof Ke=="string"?rt={value:Ke}:rt={value:""};const lt=Object.create(null);rt.uris=lt;const Ye=dt=>{try{let at=I.URI.parse(dt,!0);at=at.with({query:Te(at.query,lt)}),lt[dt]=at}catch(at){}return""},it=new k.Renderer;return it.link=Ye,it.image=dt=>Ye(P.parseHrefAndDimensions(dt).href),k(rt.value,{renderer:it}),rt}be.from=ee;function Te(Ke,rt){if(!Ke)return Ke;let lt;try{lt=(0,E.parse)(Ke)}catch(it){}if(!lt)return Ke;let Ye=!1;return lt=(0,f.cloneAndChange)(lt,it=>{if(I.URI.isUri(it)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[dt]=it,Ye=!0,dt}else return}),Ye?JSON.stringify(lt):Ke}function Re(Ke){const rt=new D.MarkdownString(Ke.value,Ke.supportThemeIcons);return rt.isTrusted=Ke.isTrusted,rt}be.to=Re;function et(Ke){if(!!Ke)return typeof Ke=="string"?Ke:be.from(Ke)}be.fromStrict=et})(c=e.MarkdownString||(e.MarkdownString={}));function b(be){return n(be)?be.map(he=>({range:g.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?c.fromMany(he.hoverMessage):he.hoverMessage?c.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):be.map(he=>({range:g.from(he)}))}e.fromRangeOrRangeWithMessage=b;function w(be){return typeof be=="undefined"?be:typeof be=="string"?I.URI.file(be):be}e.pathOrURIToURI=w;var h;(function(be){function he(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?w(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}be.from=he})(h=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var _;(function(be){function he(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?w(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?h.from(ce.before):void 0,after:ce.after?h.from(ce.after):void 0}}be.from=he})(_=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var A;(function(be){function he(ce){if(typeof ce=="undefined")return ce;switch(ce){case D.DecorationRangeBehavior.OpenOpen:return 0;case D.DecorationRangeBehavior.ClosedClosed:return 1;case D.DecorationRangeBehavior.OpenClosed:return 2;case D.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=he})(A=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(be){function he(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?A.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?_.from(ce.light):void 0,dark:ce.dark?_.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?w(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?h.from(ce.before):void 0,after:ce.after?h.from(ce.after):void 0}}be.from=he})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(be){function he(ee){return{text:ee.newText,eol:ee.newEol&&ie.from(ee.newEol),range:g.from(ee.range)}}be.from=he;function ce(ee){const Te=new D.TextEdit(g.to(ee.range),ee.text);return Te.newEol=typeof ee.eol=="undefined"?void 0:ie.to(ee.eol),Te}be.to=ce})(W=e.TextEdit||(e.TextEdit={}));var j;(function(be){function he(ee,Te,Re){var et,Ke,rt;const lt={edits:[]};if(ee instanceof D.WorkspaceEdit)for(let Ye of ee._allEntries())if(Ye._type===1)lt.edits.push({_type:1,oldUri:Ye.from,newUri:Ye.to,options:Ye.options,metadata:Ye.metadata});else if(Ye._type===2){const it=Te==null?void 0:Te.getDocument(Ye.uri);lt.edits.push({_type:2,resource:Ye.uri,edit:W.from(Ye.edit),modelVersionId:it==null?void 0:it.version,metadata:Ye.metadata})}else Ye._type===3?lt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:(et=Re==null?void 0:Re.lookupNotebookDocument(Ye.uri))===null||et===void 0?void 0:et.notebookDocument.version}):Ye._type===4?(Ye.newOutputs&&lt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:2,index:Ye.index,append:Ye.append,outputs:Ye.newOutputs.map(Ee.from)}}),Ye.newMetadata&&lt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:3,index:Ye.index,metadata:Ye.newMetadata}})):Ye._type===5?lt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:(Ke=Re==null?void 0:Re.lookupNotebookDocument(Ye.uri))===null||Ke===void 0?void 0:Ke.notebookDocument.version,edit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(le.from)}}):Ye._type===6&&lt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:10,index:Ye.index,outputId:Ye.outputId,items:((rt=Ye.newOutputItems)===null||rt===void 0?void 0:rt.map(me.from))||[],append:Ye.append}});return lt}be.from=he;function ce(ee){const Te=new D.WorkspaceEdit;for(const Re of ee.edits)Re.edit?Te.replace(I.URI.revive(Re.resource),g.to(Re.edit.range),Re.edit.text):Te.renameFile(I.URI.revive(Re.oldUri),I.URI.revive(Re.newUri),Re.options);return Te}be.to=ce})(j=e.WorkspaceEdit||(e.WorkspaceEdit={}));var K;(function(be){const he=Object.create(null);he[D.SymbolKind.File]=0,he[D.SymbolKind.Module]=1,he[D.SymbolKind.Namespace]=2,he[D.SymbolKind.Package]=3,he[D.SymbolKind.Class]=4,he[D.SymbolKind.Method]=5,he[D.SymbolKind.Property]=6,he[D.SymbolKind.Field]=7,he[D.SymbolKind.Constructor]=8,he[D.SymbolKind.Enum]=9,he[D.SymbolKind.Interface]=10,he[D.SymbolKind.Function]=11,he[D.SymbolKind.Variable]=12,he[D.SymbolKind.Constant]=13,he[D.SymbolKind.String]=14,he[D.SymbolKind.Number]=15,he[D.SymbolKind.Boolean]=16,he[D.SymbolKind.Array]=17,he[D.SymbolKind.Object]=18,he[D.SymbolKind.Key]=19,he[D.SymbolKind.Null]=20,he[D.SymbolKind.EnumMember]=21,he[D.SymbolKind.Struct]=22,he[D.SymbolKind.Event]=23,he[D.SymbolKind.Operator]=24,he[D.SymbolKind.TypeParameter]=25;function ce(Te){return typeof he[Te]=="number"?he[Te]:6}be.from=ce;function ee(Te){for(const Re in he)if(he[Re]===Te)return Number(Re);return D.SymbolKind.Property}be.to=ee})(K=e.SymbolKind||(e.SymbolKind={}));var H;(function(be){function he(ee){switch(ee){case D.SymbolTag.Deprecated:return 1}}be.from=he;function ce(ee){switch(ee){case 1:return D.SymbolTag.Deprecated}}be.to=ce})(H=e.SymbolTag||(e.SymbolTag={}));var $;(function(be){function he(ee){return{name:ee.name,kind:K.from(ee.kind),tags:ee.tags&&ee.tags.map(H.from),containerName:ee.containerName,location:O.from(ee.location)}}be.from=he;function ce(ee){const Te=new D.SymbolInformation(ee.name,K.to(ee.kind),ee.containerName,O.to(ee.location));return Te.tags=ee.tags&&ee.tags.map(H.to),Te}be.to=ce})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var M;(function(be){function he(ee){var Te,Re;const et={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:g.from(ee.range),selectionRange:g.from(ee.selectionRange),kind:K.from(ee.kind),tags:(Re=(Te=ee.tags)===null||Te===void 0?void 0:Te.map(H.from))!==null&&Re!==void 0?Re:[]};return ee.children&&(et.children=ee.children.map(he)),et}be.from=he;function ce(ee){const Te=new D.DocumentSymbol(ee.name,ee.detail,K.to(ee.kind),g.to(ee.range),g.to(ee.selectionRange));return(0,l.isNonEmptyArray)(ee.tags)&&(Te.tags=ee.tags.map(H.to)),ee.children&&(Te.children=ee.children.map(ce)),Te}be.to=ce})(M=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(be){function he(ce){const ee=new D.CallHierarchyItem(K.to(ce.kind),ce.name,ce.detail||"",I.URI.revive(ce.uri),g.to(ce.range),g.to(ce.selectionRange));return ee._sessionId=ce._sessionId,ee._itemId=ce._itemId,ee}be.to=he})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var F;(function(be){function he(ce){return new D.CallHierarchyIncomingCall(U.to(ce.from),ce.fromRanges.map(ee=>g.to(ee)))}be.to=he})(F=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var N;(function(be){function he(ce){return new D.CallHierarchyOutgoingCall(U.to(ce.to),ce.fromRanges.map(ee=>g.to(ee)))}be.to=he})(N=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(be){function he(ee){return{range:ee.range&&g.from(ee.range),uri:ee.uri}}be.from=he;function ce(ee){return new D.Location(I.URI.revive(ee.uri),g.to(ee.range))}be.to=ce})(O=e.location||(e.location={}));var V;(function(be){function he(ee){const Te=ee,Re=ee;return{originSelectionRange:Te.originSelectionRange?g.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Re.uri,range:g.from(Te.targetRange?Te.targetRange:Re.range),targetSelectionRange:Te.targetSelectionRange?g.from(Te.targetSelectionRange):void 0}}be.from=he;function ce(ee){return{targetUri:I.URI.revive(ee.uri),targetRange:g.to(ee.range),targetSelectionRange:ee.targetSelectionRange?g.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?g.to(ee.originSelectionRange):void 0}}be.to=ce})(V=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(be){function he(ee){return{range:g.from(ee.range),contents:c.fromMany(ee.contents)}}be.from=he;function ce(ee){return new D.Hover(ee.contents.map(c.to),g.to(ee.range))}be.to=ce})(q=e.Hover||(e.Hover={}));var Y;(function(be){function he(ee){return{range:g.from(ee.range),expression:ee.expression}}be.from=he;function ce(ee){return new D.EvaluatableExpression(g.to(ee.range),ee.expression)}be.to=ce})(Y=e.EvaluatableExpression||(e.EvaluatableExpression={}));var fe;(function(be){function he(ee){if(ee instanceof D.InlineValueText)return{type:"text",range:g.from(ee.range),text:ee.text};if(ee instanceof D.InlineValueVariableLookup)return{type:"variable",range:g.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof D.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}be.from=he;function ce(ee){switch(ee.type){case"text":return{range:g.to(ee.range),text:ee.text};case"variable":return{range:g.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:g.to(ee.range),expression:ee.expression}}}be.to=ce})(fe=e.InlineValue||(e.InlineValue={}));var _e;(function(be){function he(ee){return{frameId:ee.frameId,stoppedLocation:g.from(ee.stoppedLocation)}}be.from=he;function ce(ee){return new D.InlineValueContext(ee.frameId,g.to(ee.stoppedLocation))}be.to=ce})(_e=e.InlineValueContext||(e.InlineValueContext={}));var Le;(function(be){function he(ee){return{range:g.from(ee.range),kind:ee.kind}}be.from=he;function ce(ee){return new D.DocumentHighlight(g.to(ee.range),ee.kind)}be.to=ce})(Le=e.DocumentHighlight||(e.DocumentHighlight={}));var Ie;(function(be){function he(ce){switch(ce){case 1:return D.CompletionTriggerKind.TriggerCharacter;case 2:return D.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return D.CompletionTriggerKind.Invoke}}be.to=he})(Ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Fe;(function(be){function he(ce){return{triggerKind:Ie.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}be.to=he})(Fe=e.CompletionContext||(e.CompletionContext={}));var z;(function(be){function he(ee){switch(ee){case D.CompletionItemTag.Deprecated:return 1}}be.from=he;function ce(ee){switch(ee){case 1:return D.CompletionItemTag.Deprecated}}be.to=ce})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var Q;(function(be){const he=new Map([[D.CompletionItemKind.Method,0],[D.CompletionItemKind.Function,1],[D.CompletionItemKind.Constructor,2],[D.CompletionItemKind.Field,3],[D.CompletionItemKind.Variable,4],[D.CompletionItemKind.Class,5],[D.CompletionItemKind.Interface,7],[D.CompletionItemKind.Struct,6],[D.CompletionItemKind.Module,8],[D.CompletionItemKind.Property,9],[D.CompletionItemKind.Unit,12],[D.CompletionItemKind.Value,13],[D.CompletionItemKind.Constant,14],[D.CompletionItemKind.Enum,15],[D.CompletionItemKind.EnumMember,16],[D.CompletionItemKind.Keyword,17],[D.CompletionItemKind.Snippet,27],[D.CompletionItemKind.Text,18],[D.CompletionItemKind.Color,19],[D.CompletionItemKind.File,20],[D.CompletionItemKind.Reference,21],[D.CompletionItemKind.Folder,23],[D.CompletionItemKind.Event,10],[D.CompletionItemKind.Operator,11],[D.CompletionItemKind.TypeParameter,24],[D.CompletionItemKind.Issue,26],[D.CompletionItemKind.User,25]]);function ce(Re){var et;return(et=he.get(Re))!==null&&et!==void 0?et:9}be.from=ce;const ee=new Map([[0,D.CompletionItemKind.Method],[1,D.CompletionItemKind.Function],[2,D.CompletionItemKind.Constructor],[3,D.CompletionItemKind.Field],[4,D.CompletionItemKind.Variable],[5,D.CompletionItemKind.Class],[7,D.CompletionItemKind.Interface],[6,D.CompletionItemKind.Struct],[8,D.CompletionItemKind.Module],[9,D.CompletionItemKind.Property],[12,D.CompletionItemKind.Unit],[13,D.CompletionItemKind.Value],[14,D.CompletionItemKind.Constant],[15,D.CompletionItemKind.Enum],[16,D.CompletionItemKind.EnumMember],[17,D.CompletionItemKind.Keyword],[27,D.CompletionItemKind.Snippet],[18,D.CompletionItemKind.Text],[19,D.CompletionItemKind.Color],[20,D.CompletionItemKind.File],[21,D.CompletionItemKind.Reference],[23,D.CompletionItemKind.Folder],[10,D.CompletionItemKind.Event],[11,D.CompletionItemKind.Operator],[24,D.CompletionItemKind.TypeParameter],[25,D.CompletionItemKind.User],[26,D.CompletionItemKind.Issue]]);function Te(Re){var et;return(et=ee.get(Re))!==null&&et!==void 0?et:D.CompletionItemKind.Property}be.to=Te})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(be){function he(ce,ee){var Te;const Re=new D.CompletionItem(typeof ce.label=="string"?ce.label:ce.label.name);return typeof ce.label!="string"&&(Re.label2=ce.label),Re.insertText=ce.insertText,Re.kind=Q.to(ce.kind),Re.tags=(Te=ce.tags)===null||Te===void 0?void 0:Te.map(z.to),Re.detail=ce.detail,Re.documentation=P.isMarkdownString(ce.documentation)?c.to(ce.documentation):ce.documentation,Re.sortText=ce.sortText,Re.filterText=ce.filterText,Re.preselect=ce.preselect,Re.commitCharacters=ce.commitCharacters,C.Range.isIRange(ce.range)?Re.range=g.to(ce.range):typeof ce.range=="object"&&(Re.range={inserting:g.to(ce.range.insert),replacing:g.to(ce.range.replace)}),Re.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Re.insertText=new D.SnippetString(ce.insertText):(Re.insertText=ce.insertText,Re.textEdit=Re.range instanceof D.Range?new D.TextEdit(Re.range,Re.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Re.additionalTextEdits=ce.additionalTextEdits.map(et=>W.to(et))),Re.command=ee&&ce.command?ee.fromInternal(ce.command):void 0,Re}be.to=he})(te=e.CompletionItem||(e.CompletionItem={}));var ae;(function(be){function he(ee){return{label:ee.label,documentation:ee.documentation?c.fromStrict(ee.documentation):void 0}}be.from=he;function ce(ee){return{label:ee.label,documentation:P.isMarkdownString(ee.documentation)?c.to(ee.documentation):ee.documentation}}be.to=ce})(ae=e.ParameterInformation||(e.ParameterInformation={}));var ve;(function(be){function he(ee){return{label:ee.label,documentation:ee.documentation?c.fromStrict(ee.documentation):void 0,parameters:Array.isArray(ee.parameters)?ee.parameters.map(ae.from):[],activeParameter:ee.activeParameter}}be.from=he;function ce(ee){return{label:ee.label,documentation:P.isMarkdownString(ee.documentation)?c.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(ae.to):[],activeParameter:ee.activeParameter}}be.to=ce})(ve=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(be){function he(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(ve.from):[]}}be.from=he;function ce(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(ve.to):[]}}be.to=ce})(De=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(be){function he(ee){var Te;return{text:ee.text,range:g.from(ee.range),kind:we.from((Te=ee.kind)!==null&&Te!==void 0?Te:D.InlineHintKind.Other),description:ee.description&&c.fromStrict(ee.description),whitespaceBefore:ee.whitespaceBefore,whitespaceAfter:ee.whitespaceAfter}}be.from=he;function ce(ee){const Te=new D.InlineHint(ee.text,g.to(ee.range),we.to(ee.kind));return Te.whitespaceAfter=ee.whitespaceAfter,Te.whitespaceBefore=ee.whitespaceBefore,Te.description=P.isMarkdownString(ee.description)?c.to(ee.description):ee.description,Te}be.to=ce})(Me=e.InlineHint||(e.InlineHint={}));var we;(function(be){function he(ee){return ee}be.from=he;function ce(ee){return ee}be.to=ce})(we=e.InlineHintKind||(e.InlineHintKind={}));var ke;(function(be){function he(ee){return{range:g.from(ee.range),url:ee.target,tooltip:ee.tooltip}}be.from=he;function ce(ee){let Te;if(ee.url)try{Te=typeof ee.url=="string"?I.URI.parse(ee.url,!0):I.URI.revive(ee.url)}catch(Re){}return new D.DocumentLink(g.to(ee.range),Te)}be.to=ce})(ke=e.DocumentLink||(e.DocumentLink={}));var Ae;(function(be){function he(ee){const Te=new D.ColorPresentation(ee.label);return ee.textEdit&&(Te.textEdit=W.to(ee.textEdit)),ee.additionalTextEdits&&(Te.additionalTextEdits=ee.additionalTextEdits.map(Re=>W.to(Re))),Te}be.to=he;function ce(ee){return{label:ee.label,textEdit:ee.textEdit?W.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Te=>W.from(Te)):void 0}}be.from=ce})(Ae=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(be){function he(ee){return new D.Color(ee[0],ee[1],ee[2],ee[3])}be.to=he;function ce(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}be.from=ce})(xe=e.Color||(e.Color={}));var ye;(function(be){function he(ee){return{range:g.from(ee.range)}}be.from=he;function ce(ee){return new D.SelectionRange(g.to(ee.range))}be.to=ce})(ye=e.SelectionRange||(e.SelectionRange={}));var Ge;(function(be){function he(ce){switch(ce){case 2:return D.TextDocumentSaveReason.AfterDelay;case 1:return D.TextDocumentSaveReason.Manual;case 3:case 4:return D.TextDocumentSaveReason.FocusOut}}be.to=he})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(be){function he(ee){switch(ee){case D.TextEditorLineNumbersStyle.Off:return 0;case D.TextEditorLineNumbersStyle.Relative:return 2;case D.TextEditorLineNumbersStyle.On:default:return 1}}be.from=he;function ce(ee){switch(ee){case 0:return D.TextEditorLineNumbersStyle.Off;case 2:return D.TextEditorLineNumbersStyle.Relative;case 1:default:return D.TextEditorLineNumbersStyle.On}}be.to=ce})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ie;(function(be){function he(ee){if(ee===D.EndOfLine.CRLF)return 1;if(ee===D.EndOfLine.LF)return 0}be.from=he;function ce(ee){if(ee===1)return D.EndOfLine.CRLF;if(ee===0)return D.EndOfLine.LF}be.to=ce})(ie=e.EndOfLine||(e.EndOfLine={}));var Se;(function(be){function he(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case D.ProgressLocation.SourceControl:return 3;case D.ProgressLocation.Window:return 10;case D.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=he})(Se=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(be){function he(ce){const ee={start:ce.start+1,end:ce.end+1};return ce.kind&&(ee.kind=ze.from(ce.kind)),ee}be.from=he})(Ne=e.FoldingRange||(e.FoldingRange={}));var ze;(function(be){function he(ce){if(ce)switch(ce){case D.FoldingRangeKind.Comment:return p.FoldingRangeKind.Comment;case D.FoldingRangeKind.Imports:return p.FoldingRangeKind.Imports;case D.FoldingRangeKind.Region:return p.FoldingRangeKind.Region}}be.from=he})(ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var We;(function(be){function he(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?g.from(ce.selection):void 0,override:typeof ce.override=="boolean"?R.EditorOverride.DISABLED:void 0}}be.from=he})(We=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Je;(function(be){function he(ee){return ee instanceof D.RelativePattern||typeof ee=="string"?ee:ce(ee)?new D.RelativePattern(ee.base,ee.pattern):ee}be.from=he;function ce(ee){const Te=ee;return Te&&typeof Te.base=="string"&&typeof Te.pattern=="string"}})(Je=e.GlobPattern||(e.GlobPattern={}));var G;(function(be){function he(ce){if(ce){if(Array.isArray(ce))return ce.map(he);if(typeof ce=="string")return ce;{const ee=ce;return{language:ee.language,scheme:ee.scheme,pattern:typeof ee.pattern=="undefined"?void 0:Je.from(ee.pattern),exclusive:ee.exclusive}}}else return}be.from=he})(G=e.LanguageSelector||(e.LanguageSelector={}));var oe;(function(be){function he(ee){return{start:ee.start,end:ee.end}}be.from=he;function ce(ee){return new D.NotebookCellRange(ee.start,ee.end)}be.to=ce})(oe=e.NotebookCellRange||(e.NotebookCellRange={}));var ue;(function(be){function he(ce){return new D.NotebookCellMetadata(ce.editable,ce.breakpointMargin,ce.hasExecutionOrder,ce.executionOrder,ce.runState,ce.runStartTime,ce.statusMessage,ce.lastRunDuration,ce.inputCollapsed,ce.outputCollapsed,ce.custom)}be.to=he})(ue=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var J;(function(be){function he(ee){return ee}be.from=he;function ce(ee){return new D.NotebookDocumentMetadata(ee.editable,ee.cellEditable,ee.cellHasExecutionOrder,ee.custom,ee.runState,ee.trusted)}be.to=ce})(J=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ne;(function(be){function he(ee){switch(ee){case D.NotebookCellKind.Markdown:return m.CellKind.Markdown;case D.NotebookCellKind.Code:default:return m.CellKind.Code}}be.from=he;function ce(ee){switch(ee){case m.CellKind.Markdown:return D.NotebookCellKind.Markdown;case m.CellKind.Code:default:return D.NotebookCellKind.Code}}be.to=ce})(ne=e.NotebookCellKind||(e.NotebookCellKind={}));var le;(function(be){function he(ce){return{cellKind:ne.from(ce.kind),language:ce.language,source:ce.source,metadata:ce.metadata,outputs:ce.outputs?ce.outputs.map(Ee.from):[]}}be.from=he})(le=e.NotebookCellData||(e.NotebookCellData={}));var me;(function(be){function he(ee){return{mime:ee.mime,value:ee.value,metadata:ee.metadata}}be.from=he;function ce(ee){return new D.NotebookCellOutputItem(ee.mime,ee.value,ee.metadata)}be.to=ce})(me=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ee;(function(be){function he(ee){return{outputId:ee.id,outputs:ee.outputs.map(me.from),metadata:ee.metadata}}be.from=he;function ce(ee){const Te=ee.outputs.map(me.to);return new D.NotebookCellOutput(Te,ee.outputId,ee.metadata)}be.to=ce})(Ee=e.NotebookCellOutput||(e.NotebookCellOutput={}));var He;(function(be){function he(Re){if(Re!=null){if(Re instanceof D.RelativePattern||typeof Re=="string")return Re;if(Te(Re))return new D.RelativePattern(Re.base,Re.pattern);if(ee(Re))return{include:Je.from(Re.include)||void 0,exclude:Je.from(Re.exclude)||void 0}}}be.from=he;function ce(Re){return typeof Re=="string"?Re:Te(Re)?{base:Re.base,pattern:Re.pattern}:{include:Re.include,exclude:Re.exclude}}be.to=ce;function ee(Re){const et=Re,Ke=Je.from(et.include);if(!(Ke&&Ke instanceof D.RelativePattern||typeof Ke=="string"))return!1;const rt=Je.from(et.exclude);return!!(rt&&rt instanceof D.RelativePattern||typeof rt=="string")}function Te(Re){const et=Re;return et&&typeof et.base=="string"&&typeof et.pattern=="string"}})(He=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Be;(function(be){function he(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?h.from(ce.top):void 0}}be.from=he})(Be=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var qe;(function(be){function he(ee){return{state:ee.state,duration:ee.duration,messages:ee.messages.map(Xe.from)}}be.from=he;function ce(ee){const Te=new D.TestState(ee.state);return Te.duration=ee.duration,Te.messages=ee.messages.map(Xe.to),Te}be.to=ce})(qe=e.TestState||(e.TestState={}));var Xe;(function(be){function he(ee){return{message:c.fromStrict(ee.message)||"",severity:ee.severity,expectedOutput:ee.expectedOutput,actualOutput:ee.actualOutput,location:ee.location?O.from(ee.location):void 0}}be.from=he;function ce(ee){const Te=new D.TestMessage(typeof ee.message=="string"?ee.message:c.to(ee.message));return Te.severity=ee.severity,Te.actualOutput=ee.actualOutput,Te.expectedOutput=ee.expectedOutput,Te}be.to=ce})(Xe=e.TestMessage||(e.TestMessage={}));var Ze;(function(be){function he(Te){var Re,et;return{extId:Te.id,label:Te.label,location:Te.location?O.from(Te.location):void 0,debuggable:(Re=Te.debuggable)!==null&&Re!==void 0?Re:!1,description:Te.description,runnable:(et=Te.runnable)!==null&&et!==void 0?et:!0}}be.from=he;function ce(Te){return{id:Te.extId,label:Te.label,location:Te.location&&O.to({range:Te.location.range,uri:I.URI.revive(Te.location.uri)}),debuggable:Te.debuggable,description:Te.description,runnable:Te.runnable}}be.toPlainShallow=ce;function ee(Te){const Re=new D.TestItem(Te.extId,Te.label);return Te.location&&(Re.location=O.to({range:Te.location.range,uri:I.URI.revive(Te.location.uri)})),Re.debuggable=Te.debuggable,Re.description=Te.description,Re.runnable=Te.runnable,Re}be.toShallow=ee})(Ze=e.TestItem||(e.TestItem={}));var ut;(function(be){function he(Te,Re){var et,Ke,rt;const lt={completedAt:Re.completedAt,id:Te,items:[]},Ye=[[null,Re.results]];for(;Ye.length;){const[it,dt]=Ye.pop();for(const at of dt){const Ct={children:(Ke=(et=at.children)===null||et===void 0?void 0:et.map(gt=>gt.id))!==null&&Ke!==void 0?Ke:[],computedState:at.result.state,item:Ze.from(at),state:qe.from(at.result),retired:void 0,parent:(rt=it==null?void 0:it.item.extId)!==null&&rt!==void 0?rt:null,providerId:"",direct:!it};lt.items.push(Ct),at.children&&Ye.push([Ct,at.children])}}return lt}be.from=he;const ce=(Te,Re)=>Object.assign(Object.assign({},Ze.toPlainShallow(Te.item)),{result:qe.to(Te.state),children:Te.children.map(et=>Re.get(et)).filter(T.isDefined).map(et=>ce(et,Re))});function ee(Te){const Re=[],et=new Map;for(const Ke of Te.items)et.set(Ke.item.extId,Ke),Ke.direct&&Re.push(Ke);return{completedAt:Te.completedAt,results:Re.map(Ke=>ce(Ke,et))}}be.to=ee})(ut=e.TestResults||(e.TestResults={}));var st;(function(be){function he(ce){switch(ce){case 1:return D.CodeActionTriggerKind.Automatic;case 2:return D.CodeActionTriggerKind.Manual}}be.to=he})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[214],pe([0,1,2,18,8,20,56]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(i,T,k,E={timeout:1500,errors:3}){this._logService=i,this._documents=T,this._mainThreadBulkEdits=k,this._thresholds=E,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(i){return(T,k,E)=>{const l={dispose:this._callbacks.push([T,k,i])};return Array.isArray(E)&&E.push(l),l}}async $participateInSave(i,T){const k=p.URI.revive(i);let E=!1;const f=setTimeout(()=>E=!0,this._thresholds.timeout),l=[];try{for(let m of[...this._callbacks]){if(E)break;const y=this._documents.getDocument(k),g=await this._deliverEventAsyncAndBlameBadListeners(m,{document:y,reason:I.TextDocumentSaveReason.to(T)});l.push(g)}}finally{clearTimeout(f)}return l}_deliverEventAsyncAndBlameBadListeners([i,T,k],E){const f=this._badListeners.get(i);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,i,T,E).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const m=this._badListeners.get(i);this._badListeners.set(i,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(i,T,k,E){const f=[],l=Date.now(),{document:m,reason:y}=E,{version:g}=m,v=Object.freeze({document:m,reason:y,waitUntil(d){if(Object.isFrozen(f))throw(0,D.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(d))}});try{T.apply(k,[v])}catch(d){return Promise.reject(d)}return Object.freeze(f),new Promise((d,u)=>{const o=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${i.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(o),d(t)}).catch(t=>{clearTimeout(o),u(t)})}).then(d=>{const u={edits:[]};for(const o of d)if(Array.isArray(o)&&o.every(t=>t instanceof R.TextEdit))for(const{newText:t,newEol:r,range:s}of o)u.edits.push({_type:2,resource:m.uri,edit:{range:s&&I.Range.from(s),text:t,eol:r&&I.EndOfLine.from(r)}});if(u.edits.length!==0)return g===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ge[215],pe([0,1,3,19,33,2,20,8]),function(Z,e,p,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(k,E,f,l,m){this._onDidCreate=new p.Emitter,this._onDidChange=new p.Emitter,this._onDidDelete=new p.Emitter,this._config=0,f&&(this._config+=1),l&&(this._config+=2),m&&(this._config+=4);const y=(0,R.parse)(E),g=k(v=>{if(!f)for(let d of v.created){const u=I.URI.revive(d);y(u.fsPath)&&this._onDidCreate.fire(u)}if(!l)for(let d of v.changed){const u=I.URI.revive(d);y(u.fsPath)&&this._onDidChange.fire(u)}if(!m)for(let d of v.deleted){const u=I.URI.revive(d);y(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,g)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class i{constructor(k,E,f){this._logService=E,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new p.Emitter,this._onDidRenameFile=new p.Emitter,this._onDidCreateFile=new p.Emitter,this._onDidDeleteFile=new p.Emitter,this._onWillRenameFile=new D.AsyncEmitter,this._onWillCreateFile=new D.AsyncEmitter,this._onWillDeleteFile=new D.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,E,f,l){return new S(this._onFileSystemEvent.event,k,E,f,l)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,E){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(f=>({oldUri:I.URI.revive(f.source),newUri:I.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(f=>I.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:E.map(f=>I.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,E){return(f,l,m)=>{const y=function(v){f.call(l,v)};return y.extension=k,E.event(y,void 0,m)}}async $onWillRunFileOperation(k,E,f,l){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(m=>({oldUri:I.URI.revive(m.source),newUri:I.URI.revive(m.target)}))},f,l);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(m=>I.URI.revive(m.target))},f,l);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(m=>I.URI.revive(m.target))},f,l)}}async _fireWillEvent(k,E,f,l){const m=new Set,y=[];if(await k.fireAsync(E,l,async(v,d)=>{var u;const o=Date.now(),t=await Promise.resolve(v);t instanceof P.WorkspaceEdit&&(y.push(t),m.add((u=d.extension.displayName)!==null&&u!==void 0?u:d.extension.identifier.value)),Date.now()-o>f&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),!l.isCancellationRequested&&y.length!==0){const g={edits:[]};for(let v of y){let{edits:d}=C.WorkspaceEdit.from(v,this._extHostDocumentsAndEditors);g.edits=g.edits.concat(d)}return{edit:g,extensionNames:Array.from(m)}}}}e.ExtHostFileSystemEventService=i}),define(ge[216],pe([0,1,3,6,11,22,2,20,85]),function(Z,e,p,D,R,I,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class i{constructor(f,l,m,y){this.start=f,this.deletedCount=l,this.deletedItems=m,this.items=y}static asApiEvents(f){return f.map(l=>({start:l.start,deletedCount:l.deletedCount,deletedItems:l.deletedItems,items:l.items.map(m=>m.cell)}))}}class T{constructor(f,l,m){var y;this._notebook=f,this._extHostDocument=l,this._cellData=m,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=m.handle,this.uri=C.URI.revive(m.uri),this.cellKind=m.cellKind,this._outputs=m.outputs.map(P.NotebookCellOutput.to),this._metadata=P.NotebookCellMetadata.to((y=m.metadata)!==null&&y!==void 0?y:{})}static asModelAddData(f,l){return{EOL:l.eol,lines:l.source,modeId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:f}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get cell(){if(!this._cell){const f=this,l=this._extHostDocument.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return f._notebook.getCellIndex(f)},notebook:f._notebook.notebookDocument,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:l.document,get outputs(){return f._outputs.slice(0)},get metadata(){return f._metadata}})}return this._cell}setOutputs(f){this._outputs=f.map(P.NotebookCellOutput.to)}setOutputItems(f,l,m){const y=m.map(P.NotebookCellOutputItem.to),g=this._outputs.find(v=>v.id===f);g&&(l||(g.outputs.length=0),g.outputs.push(...y))}setMetadata(f){this._metadata=P.NotebookCellMetadata.to(f)}}e.ExtHostCell=T;class k extends D.Disposable{constructor(f,l,m,y,g,v,d){super();this._proxy=f,this._textDocumentsAndEditors=l,this._textDocuments=m,this._emitter=y,this._viewType=g,this._metadata=v,this.uri=d,this.handle=k._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,D.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const f=this;this._notebook=Object.freeze({get uri(){return f.uri},get version(){return f._versionId},get fileName(){return f.uri.fsPath},get viewType(){return f._viewType},get isDirty(){return f._isDirty},get isUntitled(){return f.uri.scheme===R.Schemas.untitled},get cells(){return f._cells.map(l=>l.cell)},get metadata(){return f._metadata},set metadata(l){throw new Error("Use WorkspaceEdit to update metadata.")},save(){return f._save()}})}return this._notebook}updateBackup(f){var l;(l=this._backup)===null||l===void 0||l.delete(),this._backup=f}disposeBackup(){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(f){f.metadata&&(this._metadata=this._metadata.with(f.metadata))}acceptModelChanged(f,l){this._versionId=f.versionId,this._isDirty=l;for(const m of f.rawEvents)m.kind===S.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(m.changes,!0),m.kind===S.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(m.changes,!1):m.kind===S.NotebookCellsChangeType.Move?this._moveCell(m.index,m.newIdx):m.kind===S.NotebookCellsChangeType.Output?this._setCellOutputs(m.index,m.outputs):m.kind===S.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(m.index,m.outputId,m.append,m.outputItems):m.kind===S.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(m.index,m.language):m.kind===S.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(m.index,m.metadata)}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(f,l){if(!this._disposed){const m=[],y=[],g=[];f.reverse().forEach(v=>{var d;const o=v[2].map(s=>{const a=new T(this,this._textDocumentsAndEditors,s);if(l||y.push(T.asModelAddData(this.notebookDocument,s)),!this._cellDisposableMapping.has(a.handle)){const n=new D.DisposableStore;n.add(a),this._cellDisposableMapping.set(a.handle,n)}return a});for(let s=v[0];s<v[0]+v[1];s++)(d=this._cellDisposableMapping.get(this._cells[s].handle))===null||d===void 0||d.dispose(),this._cellDisposableMapping.delete(this._cells[s].handle);const t=new i(v[0],v[1],[],o),r=this._cells.splice(v[0],v[1],...o);for(let s of r)g.push(s.uri),t.deletedItems.push(s.cell);m.push(t)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:y,removedDocuments:g}),l||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.notebookDocument,changes:i.asApiEvents(m)}))}}_moveCell(f,l){const m=this._cells.splice(f,1);this._cells.splice(l,0,...m);const y=[new i(f,1,m.map(g=>g.cell),[]),new i(l,0,[],m)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.notebookDocument,changes:i.asApiEvents(y)}))}_setCellOutputs(f,l){const m=this._cells[f];m.setOutputs(l),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.notebookDocument,cells:[m.cell]}))}_setCellOutputItems(f,l,m,y){const g=this._cells[f];g.setOutputItems(l,m,y),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.notebookDocument,cells:[g.cell]}))}_changeCellLanguage(f,l){const m=this._cells[f];m.cell.document.languageId!==l&&this._textDocuments.$acceptModelModeChanged(m.uri,l)}_changeCellMetadata(f,l){const m=this._cells[f];m.setMetadata(l||{}),this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.notebookDocument,cell:m.cell}))}getCellFromIndex(f){return this._cells[f]}getCell(f){return this._cells.find(l=>l.handle===f)}getCellIndex(f){return this._cells.indexOf(f)}}e.ExtHostNotebookDocument=k,k._handlePool=0}),define(ge[217],pe([0,1,3,8,20]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class I{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,i){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:S,metadata:i})}replaceCellOutput(S,i){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:S,outputs:i.map(T=>R.NotebookCellOutput.from(T))})}replaceCells(S,i,T){this._throwIfFinalized(),!(S===i&&T.length===0)&&this._collectedEdits.push({editType:1,index:S,count:i-S,cells:T.map(R.NotebookCellData.from)})}}class C{constructor(S,i,T,k,E,f,l){this.id=S,this._viewType=i,this._proxy=T,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=f,this._visibleRanges=E,this._viewColumn=l}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.notebookDocument},get selection(){var i;const T=S._selections[0];return T&&((i=S.notebookData.getCellFromIndex(T.start))===null||i===void 0?void 0:i.cell)},get selections(){return S._selections},get visibleRanges(){return S._visibleRanges},revealRange(i,T){S._proxy.$tryRevealRange(S.id,R.NotebookCellRange.from(i),T!=null?T:D.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},get onDidDispose(){return S.onDidDispose},edit(i){const T=new I(this.document.version);return i(T),S._applyEdit(T.finalize())},get kernel(){return S._kernel},setDecorations(i,T){return S.setDecorations(i,T)}}}return this._editor}_acceptKernel(S){this._kernel=S}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const i=[];let T=-1;for(let k=0;k<S.cellEdits.length;k++){if(T<0){i.push(S.cellEdits[k]),T++;continue}const f=i[T];if(f.editType===1&&S.cellEdits[k].editType===1){const l=S.cellEdits[k];if(l.editType!==5&&f.index===l.index){f.cells.push(...S.cellEdits[k].cells),f.count+=S.cellEdits[k].count;continue}}i.push(S.cellEdits[k]),T++}return this._proxy.$tryApplyEdits(this._viewType,this.notebookData.uri,S.documentVersionId,i)}setDecorations(S,i){if(!(i.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return i.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,R.NotebookCellRange.from(i),S.key)}}e.ExtHostNotebookEditor=C}),define(ge[218],pe([0,1,20,110,160,21,54]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,E,f){const l=this._handles++,{title:m,location:y,cancellable:g}=E,v=(0,R.localize)(0,null,k.displayName||k.name);return this._proxy.$startProgress(l,{location:p.ProgressLocation.from(y),title:m,source:v,cancellable:g},k),this._withProgress(l,f,!!g)}_withProgress(k,E,f){let l;f&&(l=new I.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,l));const m=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),l&&l.dispose()};let y;try{y=E(new i(this._proxy,k),f&&l?l.token:I.CancellationToken.None)}catch(g){throw m(k),g}return y.then(g=>m(k),g=>m(k)),y}$acceptProgressCanceled(k){const E=this._mapHandleToCancellationSource.get(k);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=P;function S(T,k){return T.message=k.message,typeof k.increment=="number"&&(typeof T.increment=="number"?T.increment+=k.increment:T.increment=k.increment),T}class i extends D.Progress{constructor(k,E){super(f=>this.throttledReport(f));this._proxy=k,this._handle=E}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}je([(0,C.throttle)(100,(T,k)=>S(T,k),()=>Object.create(null))],i.prototype,"throttledReport",null)}),define(ge[120],pe([0,1,52,18,70,20,8]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(E,f){const l=P._Keys.nextId();E.$registerTextEditorDecorationType(l,I.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:l,dispose(){E.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=P,P._Keys=new R.IdGenerator("TextEditorDecorationType");class S{constructor(E,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=E,this._documentVersionId=E.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(E,f){this._throwIfFinalized();let l=null;if(E instanceof C.Position)l=new C.Range(E,E);else if(E instanceof C.Range)l=E;else throw new Error("Unrecognized location");this._pushEdit(l,f,!1)}insert(E,f){this._throwIfFinalized(),this._pushEdit(new C.Range(E,E),f,!0)}delete(E){this._throwIfFinalized();let f=null;if(E instanceof C.Range)f=E;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(E,f,l){const m=this._document.validateRange(E);this._collectedEdits.push({range:m,text:f,forceMoveMarkers:l})}setEndOfLine(E){if(this._throwIfFinalized(),E!==C.EndOfLine.LF&&E!==C.EndOfLine.CRLF)throw(0,D.illegalArgument)("endOfLine");this._setEndOfLine=E}}e.TextEditorEdit=S;class i{constructor(E,f,l,m){this._proxy=E,this._id=f,this._accept(l),this._logService=m;const y=this;this.value={get tabSize(){return y._tabSize},set tabSize(g){y._setTabSize(g)},get insertSpaces(){return y._insertSpaces},set insertSpaces(g){y._setInsertSpaces(g)},get cursorStyle(){return y._cursorStyle},set cursorStyle(g){y._setCursorStyle(g)},get lineNumbers(){return y._lineNumbers},set lineNumbers(g){y._setLineNumbers(g)}}}_accept(E){this._tabSize=E.tabSize,this._insertSpaces=E.insertSpaces,this._cursorStyle=E.cursorStyle,this._lineNumbers=I.TextEditorLineNumbersStyle.to(E.lineNumbers)}_validateTabSize(E){if(E==="auto")return"auto";if(typeof E=="number"){const f=Math.floor(E);return f>0?f:null}if(typeof E=="string"){const f=parseInt(E,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(E){const f=this._validateTabSize(E);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(E){return E==="auto"?"auto":E==="false"?!1:Boolean(E)}_setInsertSpaces(E){const f=this._validateInsertSpaces(E);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(E){this._cursorStyle!==E&&(this._cursorStyle=E,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:E})))}_setLineNumbers(E){this._lineNumbers!==E&&(this._lineNumbers=E,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:I.TextEditorLineNumbersStyle.from(E)})))}assign(E){const f={};let l=!1;if(typeof E.tabSize!="undefined"){const m=this._validateTabSize(E.tabSize);m==="auto"?(l=!0,f.tabSize=m):typeof m=="number"&&this._tabSize!==m&&(this._tabSize=m,l=!0,f.tabSize=m)}if(typeof E.insertSpaces!="undefined"){const m=this._validateInsertSpaces(E.insertSpaces);m==="auto"?(l=!0,f.insertSpaces=m):this._insertSpaces!==m&&(this._insertSpaces=m,l=!0,f.insertSpaces=m)}typeof E.cursorStyle!="undefined"&&this._cursorStyle!==E.cursorStyle&&(this._cursorStyle=E.cursorStyle,l=!0,f.cursorStyle=E.cursorStyle),typeof E.lineNumbers!="undefined"&&this._lineNumbers!==E.lineNumbers&&(this._lineNumbers=E.lineNumbers,l=!0,f.lineNumbers=I.TextEditorLineNumbersStyle.from(E.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(E){E.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=i;class T{constructor(E,f,l,m,y,g,v,d){this.id=E,this._proxy=f,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=y,this._options=new i(this._proxy,this.id,g,l),this._visibleRanges=v,this._viewColumn=d;const u=this;this.value=Object.freeze({get document(){return m.getValue()},set document(o){throw(0,D.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(o){if(!(o instanceof C.Selection))throw(0,D.illegalArgument)("selection");u._selections=[o],u._trySetSelection()},get selections(){return u._selections},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof C.Selection)))throw(0,D.illegalArgument)("selections");u._selections=o,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(o){throw(0,D.readonly)("visibleRanges")},get options(){return u._options.value},set options(o){u._disposed||u._options.assign(o)},get viewColumn(){return u._viewColumn},set viewColumn(o){throw(0,D.readonly)("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new S(m.getValue(),t);return o(r),u._applyEdit(r)},insertSnippet(o,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=u._selections.map(a=>I.Range.from(a));else if(t instanceof C.Position){const{lineNumber:a,column:n}=I.Position.from(t);s=[{startLineNumber:a,startColumn:n,endLineNumber:a,endColumn:n}]}else if(t instanceof C.Range)s=[I.Range.from(t)];else{s=[];for(const a of t)if(a instanceof C.Range)s.push(I.Range.from(a));else{const{lineNumber:n,column:c}=I.Position.from(a);s.push({startLineNumber:n,startColumn:c,endLineNumber:n,endColumn:c})}}return f.$tryInsertSnippet(E,o.value,s,r)},setDecorations(o,t){const r=t.length===0;r&&!u._hasDecorationsForKey.has(o.key)||(r?u._hasDecorationsForKey.delete(o.key):u._hasDecorationsForKey.add(o.key),u._runOnProxy(()=>{if(I.isDecorationOptionsArr(t))return f.$trySetDecorations(E,o.key,I.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let a=0,n=t.length;a<n;a++){const c=t[a];s[4*a]=c.start.line+1,s[4*a+1]=c.start.character+1,s[4*a+2]=c.end.line+1,s[4*a+3]=c.end.character+1}return f.$trySetDecorationsFast(E,o.key,s)}}))},revealRange(o,t){u._runOnProxy(()=>f.$tryRevealRange(E,I.Range.from(o),t||C.TextEditorRevealType.Default))},show(o){f.$tryShowEditor(E,I.ViewColumn.from(o))},hide(){f.$tryHideEditor(E)}})}dispose(){(0,p.ok)(!this._disposed),this._disposed=!0}_acceptOptions(E){(0,p.ok)(!this._disposed),this._options._accept(E)}_acceptVisibleRanges(E){(0,p.ok)(!this._disposed),this._visibleRanges=E}_acceptViewColumn(E){(0,p.ok)(!this._disposed),this._viewColumn=E}_acceptSelections(E){(0,p.ok)(!this._disposed),this._selections=E}async _trySetSelection(){const E=this._selections.map(I.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,E)),this.value}_applyEdit(E){const f=E.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const l=f.edits.map(y=>y.range);l.sort((y,g)=>y.end.line===g.end.line?y.end.character===g.end.character?y.start.line===g.start.line?y.start.character-g.start.character:y.start.line-g.start.line:y.end.character-g.end.character:y.end.line-g.end.line);for(let y=0,g=l.length-1;y<g;y++){const v=l[y].end;if(l[y+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=f.edits.map(y=>({range:I.Range.from(y.range),text:y.text,forceMoveMarkers:y.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,m,{setEndOfLine:typeof f.setEndOfLine=="number"?I.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(E){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=T}),define(ge[219],pe([0,1,163,24,2,3,6,19,8,15,12,20,21]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(y,g){if((0,i.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let v;return Array.isArray(y.highlights)&&(v=y.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),v=v.length?v:void 0),{label:y.label,highlights:v}}}class l{constructor(g,v,d){this._proxy=g,this.commands=v,this.logService=d,this.treeViews=new Map;function u(o){return o&&o.$treeViewId&&o.$treeItemHandle}v.registerArgumentProcessor({processArgument:o=>u(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(t=>u(t)?this.convertArgument(t):t):o})}registerTreeDataProvider(g,v,d){const u=this.createTreeView(g,{treeDataProvider:v},d);return{dispose:()=>u.dispose()}}createTreeView(g,v,d){if(!v||!v.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(g,{showCollapseAll:!!v.showCollapseAll,canSelectMany:!!v.canSelectMany}),o=this.createExtHostTreeView(g,v,d);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(t){o.message=t},get title(){return o.title},set title(t){o.title=t},get description(){return o.description},set description(t){o.description=t},reveal:(t,r)=>o.reveal(t,r),dispose:async()=>{await u,this.treeViews.delete(g),o.dispose()}}}$getChildren(g,v){const d=this.treeViews.get(g);return d?d.getChildren(v):Promise.reject(new Error((0,p.localize)(0,null,g)))}async $hasResolve(g){const v=this.treeViews.get(g);if(!v)throw new Error((0,p.localize)(1,null,g));return v.hasResolve}$resolve(g,v,d){const u=this.treeViews.get(g);if(!u)throw new Error((0,p.localize)(2,null,g));return u.resolveTreeItem(v,d)}$setExpanded(g,v,d){const u=this.treeViews.get(g);if(!u)throw new Error((0,p.localize)(3,null,g));u.setExpanded(v,d)}$setSelection(g,v){const d=this.treeViews.get(g);if(!d)throw new Error((0,p.localize)(4,null,g));d.setSelection(v)}$setVisible(g,v){const d=this.treeViews.get(g);if(!d)throw new Error((0,p.localize)(5,null,g));d.setVisible(v)}createExtHostTreeView(g,v,d){const u=new m(g,v,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(g,u),u}convertArgument(g){const v=this.treeViews.get(g.$treeViewId);return v?v.getExtensionElement(g.$treeItemHandle):null}}e.ExtHostTreeViews=l;class m extends C.Disposable{constructor(g,v,d,u,o,t){super();if(this.viewId=g,this.proxy=d,this.commands=u,this.logService=o,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new I.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new I.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new I.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new I.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new E.CancellationTokenSource,t.contributes&&t.contributes.views)for(const a in t.contributes.views)for(const n of t.contributes.views[a])n.id===g&&(this._title=n.name);this.dataProvider=v.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let r,s;this._register(I.Event.debounce(this._onDidChangeData.event,(a,n)=>(a||(a={message:!1,elements:[]}),n.element!==!1&&(r||(r=new Promise(c=>s=c),this.refreshPromise=this.refreshPromise.then(()=>r)),a.elements.push(n.element)),n.message&&(a.message=!0),a),200,!0)(({message:a,elements:n})=>{n.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=s;return r=null,this.refresh(n).then(()=>c())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(g=>this.getExtensionElement(g)).filter(g=>!(0,i.isUndefinedOrNull)(g))}getChildren(g){const v=g?this.getExtensionElement(g):void 0;if(g&&!v)return this.logService.error(`No tree item with id '${g}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(g);return(d?Promise.resolve(d):this.fetchChildrenNodes(v)).then(u=>u.map(o=>o.item))}getExtensionElement(g){return this.elements.get(g)}reveal(g,v){v=v||{select:!0,focus:!1};const d=(0,i.isUndefinedOrNull)(v.select)?!0:v.select,u=(0,i.isUndefinedOrNull)(v.focus)?!1:v.focus,o=(0,i.isUndefinedOrNull)(v.expand)?!1:v.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.refreshPromise.then(()=>this.resolveUnknownParentChain(g)).then(t=>this.resolveTreeNode(g,t[t.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:t.map(s=>s.item)},{select:d,focus:u,expand:o})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:u,expand:o})}get message(){return this._message}set message(g){this._message=g,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(g){this._title=g,this.proxy.$setTitle(this.viewId,g,this._description)}get description(){return this._description}set description(g){this._description=g,this.proxy.$setTitle(this.viewId,this._title,g)}setExpanded(g,v){const d=this.getExtensionElement(g);d&&(v?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(g){(0,T.equals)(this._selectedHandles,g)||(this._selectedHandles=g,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(g){g!==this._visible&&(this._visible=g,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(g,v){var d;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(g);if(u){const o=this.nodes.get(u);if(o){const t=(d=await this.dataProvider.resolveTreeItem(o.extensionItem,u,v))!==null&&d!==void 0?d:o.extensionItem;return o.item.tooltip=this.getTooltip(t.tooltip),o.item.command=this.getCommand(o.disposableStore,t.command),o.item}}}}resolveUnknownParentChain(g){return this.resolveParent(g).then(v=>v?this.resolveUnknownParentChain(v).then(d=>this.resolveTreeNode(v,d[d.length-1]).then(u=>(d.push(u),d))):Promise.resolve([]))}resolveParent(g){const v=this.nodes.get(g);return v?Promise.resolve(v.parent?this.elements.get(v.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(g))}resolveTreeNode(g,v){const d=this.nodes.get(g);return d?Promise.resolve(d):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(u=>this.createHandle(g,u,v,!0)).then(u=>this.getChildren(v?v.item.handle:void 0).then(()=>{const o=this.getExtensionElement(u);if(o){const t=this.nodes.get(o);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(g){if(g){let v;if(typeof g=="string"){const d=this.getExtensionElement(g);v=d?this.nodes.get(d):void 0}else v=g;return v&&v.children||null}return this.roots}async fetchChildrenNodes(g){this.clearChildren(g);const v=new E.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=g?this.nodes.get(g):void 0,u=await this.dataProvider.getChildren(g);if(v.token.isCancellationRequested)return[];const o=await Promise.all((0,T.coalesce)(u||[]).map(async t=>{const r=await this.dataProvider.getTreeItem(t);return r&&!v.token.isCancellationRequested?this.createAndRegisterTreeNode(t,r,d):null}));return v.token.isCancellationRequested?[]:(0,T.coalesce)(o)}finally{v.dispose()}}refresh(g){if(g.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new E.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(g);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(g){const v=new Set;for(const u of g){const o=this.nodes.get(u);if(o&&!v.has(o.item.handle)){let t=o;for(;t&&t.parent&&!v.has(t.parent.item.handle);){const r=this.elements.get(t.parent.item.handle);t=r?this.nodes.get(r):void 0}t&&!t.parent&&v.add(o.item.handle)}}const d=[];return v.forEach(u=>{const o=this.elements.get(u);if(o){const t=this.nodes.get(o);t&&(!t.parent||!v.has(t.parent.item.handle))&&d.push(u)}}),d}refreshHandles(g){const v={};return Promise.all(g.map(d=>this.refreshNode(d).then(u=>{u&&(v[d]=u.item)}))).then(()=>Object.keys(v).length?this.proxy.$refresh(this.viewId,v):void 0)}refreshNode(g){const v=this.getExtensionElement(g);if(v){const d=this.nodes.get(v);if(d)return this.clearChildren(v),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(u=>{if(u){const o=this.createTreeNode(v,u,d.parent);return this.updateNodeCache(v,o,d,d.parent),d.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(g,v,d){const u=this.createTreeNode(g,v,d);if(v.id&&this.elements.has(u.item.handle))throw new Error((0,p.localize)(6,null,v.id));return this.addNodeToCache(g,u),this.addNodeToParentCache(u,d),u}getTooltip(g){return S.MarkdownString.isMarkdownString(g)?k.MarkdownString.from(g):g}getCommand(g,v){return v?this.commands.toInternal(v,g):void 0}createTreeNode(g,v,d){const u=new C.DisposableStore,o=this.createHandle(g,v,d),t=this.getLightIconPath(v);return{item:{handle:o,parentHandle:d?d.item.handle:void 0,label:f(v.label,this.extension),description:v.description,resourceUri:v.resourceUri,tooltip:this.getTooltip(v.tooltip),command:this.getCommand(u,v.command),contextValue:v.contextValue,icon:t,iconDark:this.getDarkIconPath(v)||t,themeIcon:this.getThemeIcon(v),collapsibleState:(0,i.isUndefinedOrNull)(v.collapsibleState)?S.TreeItemCollapsibleState.None:v.collapsibleState,accessibilityInformation:v.accessibilityInformation},extensionItem:v,parent:d,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(g){return g.iconPath instanceof S.ThemeIcon?g.iconPath:void 0}createHandle(g,{id:v,label:d,resourceUri:u},o,t){if(v)return`${m.ID_HANDLE_PREFIX}/${v}`;const r=f(d,this.extension),s=o?o.item.handle:m.LABEL_HANDLE_PREFIX;let a=r?r.label:u?(0,D.basename)(u):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const n=this.nodes.has(g)?this.nodes.get(g).item.handle:void 0,c=this.getChildrenNodes(o)||[];let b,w=0;do{if(b=`${s}/${w}:${a}`,t||!this.elements.has(b)||n===b)break;w++}while(w<=c.length);return b}getLightIconPath(g){if(g.iconPath&&!(g.iconPath instanceof S.ThemeIcon))return typeof g.iconPath=="string"||R.URI.isUri(g.iconPath)?this.getIconPath(g.iconPath):this.getIconPath(g.iconPath.light)}getDarkIconPath(g){if(g.iconPath&&!(g.iconPath instanceof S.ThemeIcon)&&g.iconPath.dark)return this.getIconPath(g.iconPath.dark)}getIconPath(g){return R.URI.isUri(g)?g:R.URI.file(g)}addNodeToCache(g,v){this.elements.set(v.item.handle,g),this.nodes.set(g,v)}updateNodeCache(g,v,d,u){this.elements.delete(v.item.handle),this.nodes.delete(g),v.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(g,v);const o=this.getChildrenNodes(u)||[],t=o.filter(r=>r.item.handle===d.item.handle)[0];t&&o.splice(o.indexOf(t),1,v)}addNodeToParentCache(g,v){v?(v.children||(v.children=[]),v.children.push(g)):(this.roots||(this.roots=[]),this.roots.push(g))}clearChildren(g){if(g){const v=this.nodes.get(g);if(v){if(v.children)for(const d of v.children){const u=this.elements.get(d.item.handle);u&&this.clear(u)}v.children=void 0}}else this.clearAll()}clear(g){const v=this.nodes.get(g);if(v){if(v.children)for(const d of v.children){const u=this.elements.get(d.item.handle);u&&this.clear(u)}this.nodes.delete(g),this.elements.delete(v.item.handle),v.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(g=>g.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}m.LABEL_HANDLE_PREFIX="0",m.ID_HANDLE_PREFIX="1"}),define(ge[220],pe([0,1,12,19,54,20]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class C{constructor(){this.testIdsToInternal=new Set}getTestById(l){return(0,p.mapFind)(this.testIdsToInternal,m=>{const y=m.get(l);return y&&[m,y]})}createForHierarchy(l=()=>{}){return new i(this.createIdMap(),l)}createIdMap(){const l=new S;return this.testIdsToInternal.add(l),{object:l,dispose:()=>this.testIdsToInternal.delete(l)}}}e.OwnedTestCollection=C;var P;(function(f){f[f.Disconnected=0]="Disconnected",f[f.IsChild=1]="IsChild",f[f.IsParent=2]="IsParent",f[f.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));class S{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(l){if(this.map.has(l.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${l.item.extId}`);this.map.set(l.item.extId,l),l.parent||this._roots.add(l)}has(l){return this.map.has(l)}delete(l){const m=this.map.get(l);return m?(this.map.delete(l),this._roots.delete(m),!0):!1}get(l){return this.map.get(l)}comparePositions(l,m){const y=typeof l=="string"?this.map.get(l):l,g=typeof m=="string"?this.map.get(m):m;if(!y||!g)return 0;if(y===g)return 3;for(let v=this.map.get(g.parent);v;v=this.map.get(v.parent))if(v===y)return 1;for(let v=this.map.get(y.parent);v;v=this.map.get(v.parent))if(v===g)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=S;class i{constructor(l,m){this.testIdToInternal=l,this.publishDiff=m,this.testItemToInternal=new Map,this.diff=[],this.disposed=!1,this.debounceSendDiff=new D.RunOnceScheduler(()=>this.throttleSendDiff(),2)}addRoot(l,m){this.addItem(l,m,null),this.debounceSendDiff.schedule()}getTestByReference(l){return this.testItemToInternal.get(l)}onItemChange(l,m){const y=this.testItemToInternal.get(l);if(!y){this.disposed||console.warn("Received a TestProvider.onDidChangeTest for a test that wasn't seen before as a child.");return}this.addItem(l,m,y.parent),this.debounceSendDiff.schedule()}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){this.diff.push(l),this.debounceSendDiff.schedule()}dispose(){this.testIdToInternal.dispose(),this.diff=[],this.disposed=!0}addItem(l,m,y){let g=this.testItemToInternal.get(l);if(g)g.previousEquals(l)||(g.item=I.TestItem.from(l),g.previousEquals=E(l),this.diff.push([1,{parent:y,providerId:m,item:g.item}]));else{if(this.testIdToInternal.object.has(l.id))throw new Error(`Attempted to insert a duplicate test item ID ${l.id}`);g={actual:l,parent:y,item:I.TestItem.from(l),providerId:m,previousChildren:new Set,previousEquals:E(l)},this.testIdToInternal.object.add(g),this.testItemToInternal.set(l,g),this.diff.push([0,{parent:y,providerId:m,item:g.item}])}if(l.children){const v=g.previousChildren,d=new Set;for(const u of l.children){const o=this.testIdToInternal.object.get(u.id);o&&o.actual!==u&&this.removeItembyId(u.id);const t=this.addItem(u,m,g.item.extId);v.delete(t.item.extId),d.add(t.item.extId)}for(const u of v)this.removeItembyId(u);g.previousChildren=d}return g}removeItembyId(l){this.diff.push([2,l]);const m=[this.testIdToInternal.object.get(l)];for(;m.length;){const y=m.pop();if(!!y){this.testIdToInternal.object.delete(y.item.extId),this.testItemToInternal.delete(y.actual);for(const g of y.previousChildren)m.push(this.testIdToInternal.object.get(g))}}}throttleSendDiff(){this.flushDiff()}flushDiff(){const l=this.collectDiff();l.length&&this.publishDiff(l)}}je([(0,R.throttle)(200)],i.prototype,"throttleSendDiff",null),e.SingleUseTestCollection=i;const k=Object.keys({id:null,label:null,location:null,debuggable:null,description:null,runnable:null}),E=f=>{const l=[];for(const m of k)l.push(f[m]);return m=>{for(let y=0;y<k.length;y++)if(l[y]!==m[k[y]])return!1;return!0}}}),define(ge[221],pe([0,1,29,3,7]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class I{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=I;class C{constructor(T){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(p.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(p.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let k of T.activationEvents)k==="onUri"&&(k=`onUri:${p.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(T)}}keepOnly(T){const k=new Set;T.forEach(E=>k.add(p.ExtensionIdentifier.toKey(E))),this._extensionDescriptions=this._extensionDescriptions.filter(E=>k.has(p.ExtensionIdentifier.toKey(E.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,k){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const E=C._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(E.map(f=>f.identifier)),k.length>0){const f=new Set;k.forEach(l=>f.add(p.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!f.has(p.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new I(E)}static _findLoopingExtensions(T){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(y){this._nodesSet.has(y)||(this._nodesSet.add(y),this._nodesArr.push(y))}addArc(y,g){this.addNode(y),this.addNode(g),this._arcs.has(y)?this._arcs.get(y).push(g):this._arcs.set(y,[g])}getArcs(y){return this._arcs.has(y)?this._arcs.get(y):[]}hasOnlyGoodArcs(y,g){const v=k.getArcs(y);for(let d=0;d<v.length;d++)if(!g.has(v[d]))return!1;return!0}getNodes(){return this._nodesArr}};let E=new Map;for(let y of T){const g=p.ExtensionIdentifier.toKey(y.identifier);if(E.set(g,y),y.extensionDependencies)for(let v of y.extensionDependencies){const d=p.ExtensionIdentifier.toKey(v);k.addArc(g,d)}}let f=new Set;k.getNodes().filter(y=>k.getArcs(y).length===0).forEach(y=>f.add(y));let l=k.getNodes().filter(y=>!f.has(y)),m;do{m=!1;for(let y=0;y<l.length;y++){const g=l[y];k.hasOnlyGoodArcs(g,f)&&(l.splice(y,1),y--,f.add(g),m=!0)}}while(m);return l.map(y=>E.get(y))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(p.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const k=this._activationMap.get(T);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const k=this._extensionsMap.get(p.ExtensionIdentifier.toKey(T));return k||void 0}}e.ExtensionDescriptionRegistry=C;var P;(function(i){i[i.Builtin=0]="Builtin",i[i.User=1]="User",i[i.Dev=2]="Dev"})(P||(P={}));function S(i,T){const k=i.isBuiltin?0:i.isUnderDevelopment?2:1,E=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(k!==E)return k-E;const f=R.posix.basename(i.extensionLocation.path),l=R.posix.basename(T.extensionLocation.path);return f<l?-1:f>l?1:0}}),define(ge[222],pe([0,1,26]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var D;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function I(P){const S=p.VSBuffer.alloc(1);switch(P){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=I;function C(P,S){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=C}),define(ge[41],pe([0,1,3,2,4,29,181]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwRequiresWorkspaceTrustError=e.checkRequiresWorkspaceTrust=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new I.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class P{constructor(u){this.dependency=u}}e.MissingDependencyError=P;var S;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));class i{constructor(u,o,t,r){this.codeLoadingTime=u,this.activateCallTime=o,this.activateResolvedTime=t,this.activationReason=r}}e.ActivationTimes=i;class T{constructor(u,o){this.description=u,this.value=o}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost";var k;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(k=e.ActivationKind||(e.ActivationKind={}));function E(d){d.enableProposedApi||f(d)}e.checkProposedApiEnabled=E;function f(d){throw new Error(`[${d.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.throwProposedApiError=f;function l(d){d.requiresWorkspaceTrust||m(d)}e.checkRequiresWorkspaceTrust=l;function m(d){throw new Error(`[${d.identifier.value}]: This API is only available when the "requiresWorkspaceTrust" is set to "onStart" or "onDemand" in the extension's package.json.`)}e.throwRequiresWorkspaceTrustError=m;function y(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=y;function g(d){return Object.assign(Object.assign({identifier:new I.ExtensionIdentifier(d.identifier.id),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!1,extensionLocation:d.location},d.manifest),{uuid:d.identifier.uuid})}e.toExtensionDescription=g;class v{constructor(){this.onDidRegisterExtensions=p.Event.None,this.onDidChangeExtensionsStatus=p.Event.None,this.onDidChangeExtensions=p.Event.None,this.onWillActivateByEvent=p.Event.None,this.onDidChangeResponsiveChange=p.Event.None}activateByEvent(u){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(u,o){}_activateById(u,o){return Promise.resolve()}_onWillActivateExtension(u){}_onDidActivateExtension(u,o,t,r,s){}_onExtensionRuntimeError(u,o){}_onExtensionHostExit(u){}}e.NullExtensionService=v}),define(ge[223],pe([0,1,158,29,41,13]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class P{constructor(m,y,g,v){this.startup=m,this.codeLoadingTime=y,this.activateCallTime=g,this.activateResolvedTime=v}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class S{constructor(m){this._startup=m,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(m,y){return m===-1||y===-1?-1:y-m}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class i{constructor(m,y,g,v,d,u){this.activationFailed=m,this.activationFailedError=y,this.activationTimes=g,this.module=v,this.exports=d,this.subscriptions=u}}e.ActivatedExtension=i;class T extends i{constructor(m){super(!1,null,m,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class k extends i{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class E extends i{constructor(m){super(!0,m,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=E;let f=class{constructor(m,y,g,v,d){this._logService=d,this._registry=m,this._resolvedExtensionsSet=new Set,y.forEach(u=>this._resolvedExtensionsSet.add(D.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,g.forEach(u=>this._hostExtensionsMap.set(D.ExtensionIdentifier.toKey(u),u)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(m){const y=D.ExtensionIdentifier.toKey(m);return this._activatedExtensions.has(y)}getActivatedExtension(m){const y=D.ExtensionIdentifier.toKey(m),g=this._activatedExtensions.get(y);if(!g)throw new Error("Extension `"+m.value+"` is not known or not activated");return g}activateByEvent(m,y){if(this._alreadyActivatedEvents[m])return C;const g=this._registry.getExtensionDescriptionsForActivationEvent(m);return this._activateExtensions(g.map(v=>({id:v.identifier,reason:{startup:y,extensionId:v.identifier,activationEvent:m}}))).then(()=>{this._alreadyActivatedEvents[m]=!0})}activateById(m,y){const g=this._registry.getExtensionDescription(m);if(!g)throw new Error("Extension `"+m+"` is not known");return this._activateExtensions([{id:g.identifier,reason:y}])}_handleActivateRequest(m,y,g){if(this._hostExtensionsMap.has(D.ExtensionIdentifier.toKey(m.id))){y[D.ExtensionIdentifier.toKey(m.id)]=m;return}const v=this._registry.getExtensionDescription(m.id);if(!v){this._host.onExtensionActivationError(m.id,new R.MissingDependencyError(m.id.value));const o=new Error(`Unknown dependency '${m.id.value}'`);this._activatedExtensions.set(D.ExtensionIdentifier.toKey(m.id),new E(o));return}const d=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let u=!0;for(let o=0,t=d.length;o<t;o++){const r=d[o];if(!this._resolvedExtensionsSet.has(D.ExtensionIdentifier.toKey(r))){const s=this._activatedExtensions.get(D.ExtensionIdentifier.toKey(r));if(!(s&&!s.activationFailed)){if(s&&s.activationFailed){this._host.onExtensionActivationError(v.identifier,p.localize(0,null,v.displayName||v.identifier.value,r));const c=new Error(`Dependency ${r} failed to activate`);c.detail=s.activationFailedError,this._activatedExtensions.set(D.ExtensionIdentifier.toKey(v.identifier),new E(c));return}if(this._hostExtensionsMap.has(D.ExtensionIdentifier.toKey(r))){u=!1,y[D.ExtensionIdentifier.toKey(r)]={id:this._hostExtensionsMap.get(D.ExtensionIdentifier.toKey(r)),reason:m.reason};continue}const a=this._registry.getExtensionDescription(r);if(a){u=!1,y[D.ExtensionIdentifier.toKey(r)]={id:a.identifier,reason:m.reason};continue}this._host.onExtensionActivationError(v.identifier,new R.MissingDependencyError(r));const n=new Error(`Unknown dependency '${r}'`);this._activatedExtensions.set(D.ExtensionIdentifier.toKey(v.identifier),new E(n));return}}}u?y[D.ExtensionIdentifier.toKey(v.identifier)]=m:g.push(m)}_activateExtensions(m){if(m.length===0||(m=m.filter(d=>!this._activatedExtensions.has(D.ExtensionIdentifier.toKey(d.id))),m.length===0))return Promise.resolve(void 0);const y=Object.create(null),g=[];for(let d=0,u=m.length;d<u;d++)this._handleActivateRequest(m[d],y,g);for(let d=0,u=g.length;d<u;d++){const o=D.ExtensionIdentifier.toKey(g[d].id);y[o]&&delete y[o]}const v=Object.keys(y).map(d=>y[d]);return g.length===0?Promise.all(v.map(d=>this._activateExtension(d.id,d.reason))).then(d=>{}):this._activateExtensions(v).then(d=>this._activateExtensions(g))}_activateExtension(m,y){const g=D.ExtensionIdentifier.toKey(m);if(this._activatedExtensions.has(g))return Promise.resolve(void 0);const v=this._activatingExtensions.get(g);if(v)return v;const d=this._host.actualActivateExtension(m,y).then(void 0,u=>(this._host.onExtensionActivationError(m,p.localize(1,null,m.value,u.message)),this._logService.error(`Activating extension ${m.value} failed due to an error:`),this._logService.error(u),new E(u))).then(u=>{this._activatedExtensions.set(g,u),this._activatingExtensions.delete(g)});return this._activatingExtensions.set(g,d),d}};f=je([Ue(4,I.ILogService)],f),e.ExtensionsActivator=f}),define(ge[224],pe([0,1,13,41,27,11,108]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends p.LogService{constructor(i){if(i.logFile.scheme!==I.Schemas.file)throw new Error("Only file-logging supported");super(new C.SpdLogLogger(D.ExtensionHostLogFileName,i.logFile.fsPath,!0,i.logLevel))}$setLevel(i){this.setLevel(i)}};P=je([Ue(0,R.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(ge[225],pe([0,1,18]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class D{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((I,C)=>{this._actualOk=I,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(I){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=I,this._actual&&this._actualOk(I))}resolveErr(I){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=I,this._actual?this._actualErr(I):(0,p.onUnexpectedError)(I))}then(I,C){return this._ensureActual().then(I,C)}catch(I){return this._ensureActual().then(void 0,I)}finally(I){return this._ensureActual().finally(I)}}e.LazyPromise=D}),define(ge[121],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class p{constructor(S,i){this.isMain=S,this.sid=i,this.nid=++p.count}}e.ProxyIdentifier=p,p.count=0;const D=[];function R(P){const S=new p(!0,P);return D[S.nid]=S,S}e.createMainContextProxyIdentifier=R;function I(P){const S=new p(!1,P);return D[S.nid]=S,S}e.createExtHostContextProxyIdentifier=I;function C(P){return D[P].sid}e.getStringIdentifierForProxy=C}),define(ge[5],pe([0,1,2,121,57]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var I;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var C;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(d){d[d.Markdown=1]="Markdown",d[d.Code=2]="Code"})(S=e.CellKind||(e.CellKind={}));var i;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var E;(function(d){d.name="$ident";function u(t,r){return Object.defineProperty(t,d.name,{value:r,enumerable:!0}),t}d.mixin=u;function o(t){return t[d.name]}d.of=o})(E=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(u){return u._id=f._n++,u}}e.IdObject=f,f._n=0;var l;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n",d.label2="o"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var m;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(m=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var y;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(y=e.WorkspaceEditType||(e.WorkspaceEditType={}));function g(d){if(d&&d.edits)for(const u of d.edits)typeof u.resource=="object"?u.resource=p.URI.revive(u.resource):(u.newUri=p.URI.revive(u.newUri),u.oldUri=p.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,R.revive)(u.metadata));return d}e.reviveWorkspaceEditDto=g;var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,D.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[86],pe([0,1,5,3,4]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class I{constructor(P){this._onDidChangePassword=new D.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(p.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,S){return this._proxy.$getPassword(P,S)}store(P,S,i){return this._proxy.$setPassword(P,S,i)}delete(P,S){return this._proxy.$deletePassword(P,S)}}e.ExtHostSecretState=I,e.IExtHostSecretState=(0,R.createDecorator)("IExtHostSecretState")}),define(ge[63],pe([0,1,4,13,5,14]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,p.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,i){this._extHostLogService=i,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(R.MainContext.MainThreadTelemetry)}report(S,i,T){const k=this.getUsageKey(S,i);this._reportedUsages.has(k)||(this._reportedUsages.add(k),i.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:i.identifier.value,apiId:S}))}getUsageKey(S,i){return`${S}-${i.identifier.value}`}};C=je([Ue(0,I.IExtHostRpcService),Ue(1,D.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(P,S,i){}})}),define(ge[226],pe([0,1,3,5,8,29]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new p.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new p.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(D.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(S,i,T,k={}){const E=I.ExtensionIdentifier.toKey(S.identifier),f=this._inFlightRequests.get(E)||[],l=T.sort().join(" ");let m=f.find(y=>y.scopes===l);if(m)return m.result;{const y=this._getSession(S,E,i,T,k);m={scopes:l,result:y},f.push(m),this._inFlightRequests.set(E,f);try{await y}finally{const g=f.findIndex(v=>v.scopes===l);g>-1&&(f.splice(g),this._inFlightRequests.set(E,f))}return y}}async _getSession(S,i,T,k,E={}){await this._proxy.$ensureProvider(T);const f=S.displayName||S.name;return this._proxy.$getSession(T,k,i,f,E)}async removeSession(S,i){const T=this._authenticationProviders.get(S);return T?T.provider.removeSession(i):this._proxy.$removeSession(S,i)}registerAuthenticationProvider(S,i,T,k){var E;if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:i,provider:T,options:k!=null?k:{supportsMultipleAccounts:!1}}),this._providers.find(l=>l.id===S)||this._providers.push({id:S,label:i});const f=T.onDidChangeSessions(l=>{var m,y,g;this._proxy.$sendDidChangeSessions(S,{added:(m=l.added)!==null&&m!==void 0?m:[],changed:(y=l.changed)!==null&&y!==void 0?y:[],removed:(g=l.removed)!==null&&g!==void 0?g:[]})});return this._proxy.$registerAuthenticationProvider(S,i,(E=k==null?void 0:k.supportsMultipleAccounts)!==null&&E!==void 0?E:!1),new R.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(S);const l=this._providers.findIndex(m=>m.id===S);l>-1&&this._providers.splice(l),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,i){const T=this._authenticationProviders.get(S);if(T)return Promise.resolve(T.provider.createSession(i));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,i){const T=this._authenticationProviders.get(S);if(T)return Promise.resolve(T.provider.removeSession(i));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,i){const T=this._authenticationProviders.get(S);if(T)return Promise.resolve(T.provider.getSessions(i));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,i){return this._onDidChangeSessions.fire({provider:{id:S,label:i}}),Promise.resolve()}$onDidChangeAuthenticationProviders(S,i){return S.forEach(T=>{this._providers.some(k=>k.id===T.id)||this._providers.push(T)}),i.forEach(T=>{const k=this._providers.findIndex(E=>E.id===T.id);k>-1&&this._providers.splice(k)}),this._onDidChangeAuthenticationProviders.fire({added:S,removed:i}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(ge[227],pe([0,1,5,14,20]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let I=class{constructor(P,S){this._extHostDocumentsAndEditors=S,this._proxy=P.getProxy(p.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const S=R.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};I=je([Ue(0,D.IExtHostRpcService)],I),e.ExtHostBulkEdits=I}),define(ge[228],pe([0,1,5]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class D{constructor(I){const C=I.getProxy(p.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(P){return C.$writeText(P)}})}}e.ExtHostClipboard=D}),define(ge[51],pe([0,1,15,8,20,22,5,12,13,57,43,49,2,6,4,14]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let y=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(C.MainContext.MainThreadCommands),this._logService=r,this.converter=new g(this,s=>{const a=this._apiCommands.get(s);return(a==null?void 0:a.result)===d.Void?a:void 0},r),this._argumentProcessors=[{processArgument(s){return(0,i.revive)(s)}},{processArgument(s){return(0,I.cloneAndChange)(s,function(a){if(T.Range.isIRange(a))return R.Range.to(a);if(k.Position.isIPosition(a))return R.Position.to(a);if(T.Range.isIRange(a.range)&&E.URI.isUri(a.uri))return R.location.to(a);if(!Array.isArray(a))return a})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...s)=>{const a=t.args.map((c,b)=>{if(!c.validate(s[b]))throw new Error(`Invalid argument '${c.name}' when running '${t.id}', received: ${s[b]}`);return c.convert(s[b])}),n=await this.executeCommand(t.internalId,...a);return t.result.convert(n,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new D.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,s,a,n){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:s,thisArg:a,description:n}),t&&this._proxy.$registerCommand(r),new D.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,s){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const a=(0,I.cloneAndChange)(r,function(n){if(n instanceof D.Position)return R.Position.from(n);if(n instanceof D.Range)return R.Range.from(n);if(n instanceof D.Location)return R.location.from(n);if(!Array.isArray(n))return n});try{const n=await this._proxy.$executeCommand(t,a,s);return(0,i.revive)(n)}catch(n){if(n instanceof Error&&n.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw n}}}async _executeContributedCommand(t,r){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:a,thisArg:n,description:c}=s;if(c)for(let b=0;b<c.args.length;b++)try{(0,p.validateConstraint)(r[b],c.args[b].constraint)}catch(w){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${c.args[b].name}' - ${c.args[b].description}`)}try{return await a.apply(n,r)}catch(b){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...r);w&&(t=w.command)}throw this._logService.error(b,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(s=>this._argumentProcessors.reduce((a,n)=>n.processArgument(a),s)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(s=>s[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,s]of this._commands){let{description:a}=s;a&&(t[r]=a)}return Promise.resolve(t)}};y=je([Ue(0,m.IExtHostRpcService),Ue(1,S.ILogService)],y),e.ExtHostCommands=y,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class g{constructor(t,r,s){this._commands=t,this._lookupApiCommand=r,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!!t){const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const a=this._lookupApiCommand(t.command);if(a)s.id=a.internalId,s.arguments=a.args.map((n,c)=>n.convert(t.arguments&&t.arguments[c]));else if((0,P.isNonEmptyArray)(t.arguments)){const n=++this._cachIdPool;this._cache.set(n,t),r.add((0,f.toDisposable)(()=>{this._cache.delete(n),this._logService.trace("CommandsConverter#DISPOSE",n)})),s.$ident=n,s.id=this.delegatingCommandId,s.arguments=[n],this._logService.trace("CommandsConverter#CREATE",t.command,n)}return s}}fromInternal(t){const r=C.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class v{constructor(t,r,s,a){this.name=t,this.description=r,this.validate=s,this.convert=a}optional(){return new v(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new v(t!=null?t:this.name,r!=null?r:this.description,this.validate,this.convert)}}e.ApiCommandArgument=v,v.Uri=new v("uri","Uri of a text document",o=>E.URI.isUri(o),o=>o),v.Position=new v("position","A position in a text document",o=>D.Position.isPosition(o),R.Position.from),v.Range=new v("range","A range in a text document",o=>D.Range.isRange(o),R.Range.from),v.Selection=new v("selection","A selection in a text document",o=>D.Selection.isSelection(o),R.Selection.from),v.Number=new v("number","",o=>typeof o=="number",o=>o),v.String=new v("string","",o=>typeof o=="string",o=>o),v.CallHierarchyItem=new v("item","A call hierarchy item",o=>o instanceof D.CallHierarchyItem,R.CallHierarchyItem.to);class d{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=d,d.Void=new d("no result",o=>o);class u{constructor(t,r,s,a,n){this.id=t,this.internalId=r,this.description=s,this.args=a,this.result=n}}e.ApiCommand=u}),define(ge[229],pe([0,1,6,20,8,80,51,199,12,105]),function(Z,e,p,D,R,I,C,P,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",E(D.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(l,m)=>{if(!(0,S.isFalsyOrEmpty)(l)){class y extends R.SymbolInformation{static to(v){const d=new y(v.name,D.SymbolKind.to(v.kind),v.containerName||"",new R.Location(m[0],D.Range.to(v.range)));return d.detail=v.detail,d.range=d.location.range,d.selectionRange=D.Range.to(v.selectionRange),d.children=v.children?v.children.map(y.to):[],d}}return l.map(y.to)}})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(D.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(D.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(D.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",E(D.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",E(D.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(m=>R.Position.isPosition(m)),l=>l.map(D.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(m=>{let y;for(const g of m.reverse())y=new R.SelectionRange(D.Range.to(g),y);return y}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const m=[];if(Array.isArray(l))for(let y of l)m.push(...y[1].map(D.WorkspaceSymbol.to));return m})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(D.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(D.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(D.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return D.WorkspaceEdit.to(l)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(D.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!!l){const m=(0,i.decodeSemanticTokensDto)(l);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)}})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!!l){const m=(0,i.decodeSemanticTokensDto)(l);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)}})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,m,y)=>{if(!l)return new R.CompletionList([]);const g=l.suggestions.map(v=>D.CompletionItem.to(v,y));return new R.CompletionList(g,l.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return D.SignatureHelp.to(l)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,m,y)=>E(g=>new R.CodeLens(D.Range.to(g.range),g.command&&y.fromInternal(g.command)))(l))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.Range.isRange(l),l=>R.Selection.isSelection(l)?D.Selection.from(l):D.Range.from(l)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,m,y)=>E(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return y.fromInternal(g.command)}else{const v=new R.CodeAction(g.title,g.kind?new R.CodeActionKind(g.kind):void 0);return g.edit&&(v.edit=D.WorkspaceEdit.to(g.edit)),g.command&&(v.command=y.fromInternal(g.command)),v.isPreferred=g.isPreferred,v}})(l))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(m=>new R.ColorInformation(D.Range.to(m.range),D.Color.to(m.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",l=>l instanceof R.Color,D.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:D.Range.from(l.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(D.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineHint objects",l=>l.map(D.InlineHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",E(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientMetadata:l.options.transientMetadata},filenamePattern:l.filenamePattern.map(m=>D.NotebookExclusiveDocumentPattern.to(m))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(D.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[D.ViewColumn.from(l.viewColumn),D.TextEditorOpenOptions.from(l)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[D.ViewColumn.from(l.viewColumn),D.TextEditorOpenOptions.from(l)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[D.ViewColumn.from(l.viewColumn),D.TextEditorOpenOptions.from(l)]).optional()],C.ApiCommandResult.Void)];class k{constructor(m){this._disposables=new p.DisposableStore,this._commands=m}static register(m){return T.forEach(m.registerApiCommand,m),new k(m).registerCommands()}registerCommands(){const m=y=>(...g)=>y(this._commands,...g);this._register(P.RemoveFromRecentlyOpenedAPICommand.ID,m(P.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:y=>typeof y=="string"}]}),this._register(P.OpenIssueReporter.ID,m(P.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:y=>typeof y=="string"||typeof y=="object"&&typeof y.extensionId=="string"}]})}_register(m,y,g){const v=this._commands.registerCommand(!1,m,y,this,g);this._disposables.add(v)}}e.ExtHostApiCommands=k;function E(l){return m=>{if(Array.isArray(m))return m.map(l)}}function f(l){if(!!Array.isArray(l)){const m=[];for(const y of l)I.isLocationLink(y)?m.push(D.DefinitionLink.to(y)):m.push(D.location.to(y));return m}}}),define(ge[230],pe([0,1,19,54,3,6,2,80,29,20,8,5]),function(Z,e,p,D,R,I,C,P,S,i,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class E{constructor(u,o,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(k.MainContext.MainThreadComments),o.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const s=this._commentControllers.get(r.handle);return s||r}else if(r&&r.$mid===7){const s=this._commentControllers.get(r.commentControlHandle);if(!s)return r;const a=s.getCommentThread(r.commentThreadHandle);return a||r}else if(r&&r.$mid===8){const s=this._commentControllers.get(r.thread.commentControlHandle);if(!s)return r;const a=s.getCommentThread(r.thread.commentThreadHandle);return a?{thread:a,text:r.text}:r}else if(r&&r.$mid===9){const s=this._commentControllers.get(r.thread.commentControlHandle);if(!s)return r;const a=s.getCommentThread(r.thread.commentThreadHandle);if(!a)return r;let n=r.commentUniqueId,c=a.getCommentByUniqueId(n);return c||r}else if(r&&r.$mid===10){const s=this._commentControllers.get(r.thread.commentControlHandle);if(!s)return r;const a=s.getCommentThread(r.thread.commentThreadHandle);if(!a)return r;let n=r.text,c=r.commentUniqueId,b=a.getCommentByUniqueId(c);return b?(b.body=n,b):r}return r}})}createCommentController(u,o,t){const r=E.handlePool++,s=new l(u,r,this._proxy,o,t);this._commentControllers.set(s.handle,s);const a=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(u.identifier))||[];return a.push(s),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(u.identifier),a),s}$createCommentThreadTemplate(u,o,t){const r=this._commentControllers.get(u);!r||r.$createCommentThreadTemplate(o,t)}async $updateCommentThreadTemplate(u,o,t){const r=this._commentControllers.get(u);!r||r.$updateCommentThreadTemplate(o,t)}$deleteCommentThread(u,o){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(o)}$provideCommentingRanges(u,o,t){const r=this._commentControllers.get(u);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(C.URI.revive(o));return(0,p.asPromise)(()=>r.commentingRangeProvider.provideCommentingRanges(s,t)).then(a=>a?a.map(n=>i.Range.from(n)):void 0)}$toggleReaction(u,o,t,r,s){const a=this._commentControllers.get(u);return!a||!a.reactionHandler?Promise.resolve(void 0):(0,p.asPromise)(()=>{const n=a.getCommentThread(o);if(n){const c=n.getCommentByUniqueId(r.uniqueIdInThread);if(a!==void 0&&c&&a.reactionHandler)return a.reactionHandler(c,g(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=E,E.handlePool=0;class f{constructor(u,o,t,r,s,a,n){this._proxy=u,this._commentController=o,this._id=t,this._uri=r,this._range=s,this._comments=a,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new R.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputDisposables.value=new I.DisposableStore,this._id===void 0&&(this._id=`${o.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,i.Range.from(this._range),n),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=a}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new I.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),o={};u("range")&&(o.range=i.Range.from(this._range)),u("label")&&(o.label=this.label),u("contextValue")&&(o.contextValue=this.contextValue),u("comments")&&(o.comments=this._comments.map(t=>m(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(o.collapseState=v(this._collapseState)),u("canReply")&&(o.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,o)}}getCommentByUniqueId(u){for(let o of this._commentsMap){let t=o[0],r=o[1];if(u===r)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,je([(0,D.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class l{constructor(u,o,t,r,s){this._extension=u,this._handle=o,this._proxy=t,this._id=r,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,r,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,o,t,r){if(typeof u=="string"){const s=new f(this._proxy,this,u,o,t,r,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new f(this._proxy,this,void 0,u,o,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(u,o){const t=new f(this._proxy,this,void 0,C.URI.revive(u),i.Range.to(o),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,o){let t=this._threads.get(u);t&&(t.range=i.Range.to(o))}$deleteCommentThread(u){let o=this._threads.get(u);o&&o.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function m(d,u,o,t){let r=t.get(o);r||(r=++d.commentHandle,t.set(o,r));const s=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:r,body:i.MarkdownString.from(o.body),userName:o.author.name,userIconPath:s,label:o.label,commentReactions:o.reactions?o.reactions.map(a=>y(a)):void 0}}function y(d){return{label:d.label,iconPath:d.iconPath?i.pathOrURIToURI(d.iconPath):void 0,count:d.count,hasReacted:d.authorHasReacted}}function g(d){return{label:d.label||"",count:d.count||0,iconPath:d.iconPath?C.URI.revive(d.iconPath):"",authorHasReacted:d.hasReacted||!1}}function v(d){if(d!==void 0)switch(d){case T.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(ge[122],pe([0,1,2,5,8,4,14,13,12,9,7]),function(Z,e,p,D,R,I,C,P,S,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class un{constructor(f,l){this._logService=l,this._provider=new Map,this._proxy=f.getProxy(D.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,l){const m=un._handlePool++;this._provider.set(m,{provider:f,extensionId:l}),this._proxy.$registerDecorationProvider(m,l.value);const y=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(g=>{if(!g){this._proxy.$onDidChange(m,null);return}let v=(0,S.asArray)(g);if(v.length<=un._maxEventSize){this._proxy.$onDidChange(m,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,v.length);const d=v.map(t=>({uri:t,rank:(0,i.count)(t.path,"/")})),u=(0,S.groupBy)(d,(t,r)=>t.rank-r.rank||(0,i.compare)(t.uri.path,r.uri.path));let o=[];e:for(let t of u){let r;for(let s of t){let a=(0,T.dirname)(s.uri.path);if(r!==a&&(r=a,o.push(s.uri)>=un._maxEventSize))break e}}this._proxy.$onDidChange(m,o)});return new R.Disposable(()=>{y==null||y.dispose(),this._proxy.$unregisterDecorationProvider(m),this._provider.delete(m)})}async $provideDecorations(f,l,m){if(!this._provider.has(f))return Object.create(null);const y=Object.create(null),{provider:g,extensionId:v}=this._provider.get(f);return await Promise.all(l.map(async d=>{try{const{uri:u,id:o}=d,t=await Promise.resolve(g.provideFileDecoration(p.URI.revive(u),m));if(!t)return;try{R.FileDecoration.validate(t),y[o]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${v.value}': ${r}`)}}catch(u){this._logService.error(u)}})),y}};k._handlePool=0,k._maxEventSize=250,k=je([Ue(0,C.IExtHostRpcService),Ue(1,P.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,I.createDecorator)("IExtHostDecorations")}),define(ge[231],pe([0,1,157,109,2,5,8,20,3,13,23]),function(Z,e,p,D,R,I,C,P,S,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(l,m,y,g,v){this._name=l,this._owner=m,this._maxDiagnosticsPerFile=y,this._proxy=g,this._onDidChangeDiagnostics=v,this._isDisposed=!1,this._data=new T.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,m){if(!l){this.clear();return}this._checkDisposed();let y=[];if(R.URI.isUri(l)){if(!m){this.delete(l);return}this._data.set(l,m.slice()),y=[l]}else if(Array.isArray(l)){y=[];let v;l=[...l].sort(k._compareIndexedTuplesByUri);for(const d of l){const[u,o]=d;if((!v||u.toString()!==v.toString())&&(v&&this._data.get(v).length===0&&this._data.delete(v),v=u,y.push(u),this._data.set(u,[])),o){const t=this._data.get(u);t&&t.push(...o)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(y),!!this._proxy){const g=[];for(let v of y){let d=[];const u=this._data.get(v);if(u)if(u.length>this._maxDiagnosticsPerFile){d=[];const o=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of u)if(r.severity===o[t]&&d.push(P.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;d.push({severity:D.MarkerSeverity.Info,message:(0,p.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=u.map(o=>P.Diagnostic.from(o));g.push([v,d])}this._proxy.$changeMany(this._owner,g)}}delete(l){this._checkDisposed(),this._onDidChangeDiagnostics.fire([l]),this._data.delete(l),this._proxy&&this._proxy.$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(l,m){this._checkDisposed();for(let y of this._data.keys())l.apply(m,[y,this.get(y),this])}get(l){this._checkDisposed();const m=this._data.get(l);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(this._data.get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,m){return l[0].toString()<m[0].toString()?-1:l[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=k;let E=class Wt{constructor(l,m){this._logService=m,this._collections=new Map,this._onDidChangeDiagnostics=new S.Emitter,this.onDidChangeDiagnostics=S.Event.map(S.Event.debounce(this._onDidChangeDiagnostics.event,Wt._debouncer,50),Wt._mapper),this._proxy=l.getProxy(I.MainContext.MainThreadDiagnostics)}static _debouncer(l,m){return l?l.concat(m):m}static _mapper(l){const m=[],y=new Set;for(const g of l)typeof g=="string"?y.has(g)||(y.add(g),m.push(R.URI.parse(g))):y.has(g.toString())||(y.add(g.toString()),m.push(g));return Object.freeze(m),{uris:m}}createDiagnosticCollection(l,m){const{_collections:y,_proxy:g,_onDidChangeDiagnostics:v,_logService:d}=this,u=new class{$changeMany(r,s){g.$changeMany(r,s),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,r,s.length===0?"CLEARING":s)}$clear(r){g.$clear(r),d.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,r)}dispose(){g.dispose()}};let o;if(!m)m="_generated_diagnostic_collection_name_#"+Wt._idPool++,o=m;else if(!y.has(m))o=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do o=m+Wt._idPool++;while(y.has(o))}return new class extends k{constructor(){super(m,o,Wt._maxDiagnosticsPerFile,u,v);y.set(o,this)}dispose(){super.dispose(),y.delete(o)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const m=new Map,y=[];for(const g of this._collections.values())g.forEach((v,d)=>{let u=m.get(v.toString());typeof u=="undefined"&&(u=y.length,m.set(v.toString(),u),y.push([v,[]])),y[u][1]=y[u][1].concat(...d)});return y}}_getDiagnostics(l){let m=[];for(let y of this._collections.values())y.has(l)&&(m=m.concat(y.get(l)));return m}$acceptMarkersChange(l){if(!this._mirrorCollection){const m="_generated_mirror",y=new k(m,m,Wt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(m,y),this._mirrorCollection=y}for(const[m,y]of l)this._mirrorCollection.set(R.URI.revive(m),y.map(P.Diagnostic.to))}};E._idPool=0,E._maxDiagnosticsPerFile=1e3,E=je([Ue(1,i.ILogService)],E),e.ExtHostDiagnostics=E}),define(ge[232],pe([0,1,2,5]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(C){this._proxy=C.getProxy(D.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(P=>P?P.map(S=>p.URI.revive(S)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(P=>P?p.URI.revive(P):void 0)}}e.ExtHostDialogs=R}),define(ge[233],pe([0,1,18,2,8,5,11,21,9]),function(Z,e,p,D,R,I,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class i{constructor(k,E,f){this._documentsAndEditors=E,this._logService=f,this._documentContentProviders=new Map,this._proxy=k.getProxy(I.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,E){if(Object.keys(C.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const f=i._handlePool++;this._documentContentProviders.set(f,E),this._proxy.$registerTextContentProvider(f,k);let l;return typeof E.onDidChange=="function"&&(l=E.onDidChange(m=>{if(m.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(m)&&this.$provideTextDocumentContent(f,m).then(y=>{if(!(!y&&typeof y!="string")){const g=this._documentsAndEditors.getDocument(m);if(!!g){const v=(0,S.splitLines)(y);if(!g.equalLines(v))return this._proxy.$onVirtualDocumentChange(m,y)}}},p.onUnexpectedError)})),new R.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(k,E){const f=this._documentContentProviders.get(k);return f?Promise.resolve(f.provideTextDocumentContent(D.URI.revive(E),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=i,i._handlePool=0}),define(ge[234],pe([0,1,3,6,2,5,117,20,15,22]),function(Z,e,p,D,R,I,C,P,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(E,f){this._onDidAddDocument=new p.Emitter,this._onDidRemoveDocument=new p.Emitter,this._onDidChangeDocument=new p.Emitter,this._onDidSaveDocument=new p.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new D.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(I.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const m of l)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const m of l)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!!E){const f=this._documentsAndEditors.getDocument(E);if(f)return f}}getDocument(E){const f=this.getDocumentData(E);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${E}'`);return f.document}ensureDocumentData(E){const f=this._documentsAndEditors.getDocument(E);if(f)return Promise.resolve(f);let l=this._documentLoader.get(E.toString());return l||(l=this._proxy.$tryOpenDocument(E).then(m=>{this._documentLoader.delete(E.toString());const y=R.URI.revive(m);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(y))},m=>(this._documentLoader.delete(E.toString()),Promise.reject(m))),this._documentLoader.set(E.toString(),l)),l}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(f=>R.URI.revive(f))}$acceptModelModeChanged(E,f){const l=R.URI.revive(E),m=this._documentsAndEditors.getDocument(l);if(!m)throw new Error("unknown document");this._onDidRemoveDocument.fire(m.document),m._acceptLanguageId(f),this._onDidAddDocument.fire(m.document)}$acceptModelSaved(E){const f=R.URI.revive(E),l=this._documentsAndEditors.getDocument(f);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(E,f){const l=R.URI.revive(E),m=this._documentsAndEditors.getDocument(l);if(!m)throw new Error("unknown document");m._acceptIsDirty(f),this._onDidChangeDocument.fire({document:m.document,contentChanges:[]})}$acceptModelChanged(E,f,l){const m=R.URI.revive(E),y=this._documentsAndEditors.getDocument(m);if(!y)throw new Error("unknown document");y._acceptIsDirty(l),y.onEvents(f),this._onDidChangeDocument.fire((0,i.deepFreeze)({document:y.document,contentChanges:f.changes.map(g=>({range:P.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text}))}))}setWordDefinitionFor(E,f){(0,C.setWordDefinitionFor)(E,f)}}e.ExtHostDocuments=T}),define(ge[38],pe([0,1,52,3,6,2,4,5,117,14,120,20,13,23,11,71,131]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class g{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(u,o){this._extHostRpc=u,this._logService=o,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new D.Emitter,this._onDidRemoveDocuments=new D.Emitter,this._onDidChangeVisibleTextEditors=new D.Emitter,this._onDidChangeActiveTextEditor=new D.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const o=[],t=[],r=[];if(u.removedDocuments)for(const s of u.removedDocuments){const a=I.URI.revive(s),n=this._documents.get(a);(n==null?void 0:n.unref())&&(this._documents.delete(a),o.push(n.value))}if(u.addedDocuments)for(const s of u.addedDocuments){const a=I.URI.revive(s.uri);let n=this._documents.get(a);if(n&&a.scheme!==l.Schemas.vscodeNotebookCell)throw new Error(`document '${a} already exists!'`);n||(n=new g(new S.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),a,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(a,n),t.push(n.value)),n.ref()}if(u.removedEditors)for(const s of u.removedEditors){const a=this._editors.get(s);this._editors.delete(s),a&&r.push(a)}if(u.addedEditors)for(const s of u.addedEditors){const a=I.URI.revive(s.documentUri);p.ok(this._documents.has(a),`document '${a}' does not exist`),p.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const n=this._documents.get(a).value,c=new T.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new y.Lazy(()=>n.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(b=>k.Range.to(b)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,c)}u.newActiveEditor!==void 0&&(p.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,R.dispose)(o),(0,R.dispose)(r),u.removedDocuments&&this._onDidRemoveDocuments.fire(o),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var o;return(o=this._documents.get(u))===null||o===void 0?void 0:o.value}allDocuments(){return m.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const o=this._editors.get(this._activeEditorId);return u?o:o==null?void 0:o.value}}allEditors(){return[...this._editors.values()]}};v=je([Ue(0,i.IExtHostRpcService),Ue(1,E.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[235],pe([0,1,2,5,6,8,20,140,9,26]),function(Z,e,p,D,R,I,C,P,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const l=this._schemes.indexOf(f);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),l=[];let m,y,g=14,v=14;for(const d of f){let u=m?(0,S.commonPrefixLength)(m,d):0;for(u===0?y=1:y=v;u<d.length;u++)u+1===d.length?(g=v,v=9):v+=1,l.push([y,d.toUpperCase().charCodeAt(u),v]),l.push([y,d.toLowerCase().charCodeAt(u),v]),y=v;m=d,v=g}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new P.StateMachine(l)}}provideDocumentLinks(f){this._initStateMachine();const l=[],m=P.LinkComputer.computeLinks({getLineContent(y){return f.lineAt(y-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const y of m){const g=C.DocumentLink.to(y);g.target&&l.push(g)}return l}}class k{constructor(f,l){this._extHostLanguageFeatures=l,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(D.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,l,m,y={}){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const g=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(g,m);let v=2;y.isCaseSensitive&&(v+=1024),y.isReadonly&&(v+=2048),typeof m.copy=="function"&&(v+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&(v+=4),this._proxy.$registerFileSystemProvider(g,l,v).catch(u=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${l}`),console.error(u)});const d=m.onDidChangeFile(u=>{const o=[];for(const t of u){let{uri:r,type:s}=t;if(r.scheme===l){let a;switch(s){case I.FileChangeType.Changed:a=0;break;case I.FileChangeType.Created:a=1;break;case I.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:r,type:a})}}this._proxy.$onFileSystemChange(g,o)});return(0,R.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(f){const{type:l,ctime:m,mtime:y,size:g}=f;return{type:l,ctime:m,mtime:y,size:g}}$stat(f,l){return Promise.resolve(this._getFsProvider(f).stat(p.URI.revive(l))).then(k._asIStat)}$readdir(f,l){return Promise.resolve(this._getFsProvider(f).readDirectory(p.URI.revive(l)))}$readFile(f,l){return Promise.resolve(this._getFsProvider(f).readFile(p.URI.revive(l))).then(m=>i.VSBuffer.wrap(m))}$writeFile(f,l,m,y){return Promise.resolve(this._getFsProvider(f).writeFile(p.URI.revive(l),m.buffer,y))}$delete(f,l,m){return Promise.resolve(this._getFsProvider(f).delete(p.URI.revive(l),m))}$rename(f,l,m,y){return Promise.resolve(this._getFsProvider(f).rename(p.URI.revive(l),p.URI.revive(m),y))}$copy(f,l,m,y){const g=this._getFsProvider(f);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(p.URI.revive(l),p.URI.revive(m),y))}$mkdir(f,l){return Promise.resolve(this._getFsProvider(f).createDirectory(p.URI.revive(l)))}$watch(f,l,m,y){const g=this._getFsProvider(f).watch(p.URI.revive(m),y);this._watches.set(l,g)}$unwatch(f,l){const m=this._watches.get(l);m&&(m.dispose(),this._watches.delete(l))}$open(f,l,m){const y=this._getFsProvider(f);if(!y.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(y.open(p.URI.revive(l),m))}$close(f,l){const m=this._getFsProvider(f);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(l))}$read(f,l,m,y){const g=this._getFsProvider(f);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const v=i.VSBuffer.alloc(y);return Promise.resolve(g.read(l,m,v.buffer,0,y)).then(d=>v.slice(0,d))}$write(f,l,m,y){const g=this._getFsProvider(f);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(l,m,y.buffer,0,y.byteLength))}_getFsProvider(f){const l=this._fsProvider.get(f);if(!l){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return l}}e.ExtHostFileSystem=k}),define(ge[87],pe([0,1,5,44,8,26,4,14,61]),function(Z,e,p,D,R,I,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let i=class Rt{constructor(k,E){const f=k.getProxy(p.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return f.$stat(l).catch(Rt._handleError)},readDirectory(l){return f.$readdir(l).catch(Rt._handleError)},createDirectory(l){return f.$mkdir(l).catch(Rt._handleError)},async readFile(l){return f.$readFile(l).then(m=>m.buffer).catch(Rt._handleError)},writeFile(l,m){return f.$writeFile(l,I.VSBuffer.wrap(m)).catch(Rt._handleError)},delete(l,m){return f.$delete(l,Object.assign({recursive:!1,useTrash:!1},m)).catch(Rt._handleError)},rename(l,m,y){return f.$rename(l,m,Object.assign({overwrite:!1},y)).catch(Rt._handleError)},copy(l,m,y){return f.$copy(l,m,Object.assign({overwrite:!1},y)).catch(Rt._handleError)},isWritableFileSystem(l){const m=E.getCapabilities(l);if(typeof m=="number")return!(m&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new R.FileSystemError(String(k));if(k.name==="ENOPRO")throw R.FileSystemError.Unavailable(k.message);switch(k.name){case D.FileSystemProviderErrorCode.FileExists:throw R.FileSystemError.FileExists(k.message);case D.FileSystemProviderErrorCode.FileNotFound:throw R.FileSystemError.FileNotFound(k.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw R.FileSystemError.FileNotADirectory(k.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw R.FileSystemError.FileIsADirectory(k.message);case D.FileSystemProviderErrorCode.NoPermissions:throw R.FileSystemError.NoPermissions(k.message);case D.FileSystemProviderErrorCode.Unavailable:throw R.FileSystemError.Unavailable(k.message);default:throw new R.FileSystemError(k.message,k.name)}}};i=je([Ue(0,P.IExtHostRpcService),Ue(1,S.IExtHostFileSystemInfo)],i),e.ExtHostConsumerFileSystem=i,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[236],pe([0,1,6,5]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class R{constructor(C){this._handlePool=0,this._proxy=C.getProxy(D.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,C),(0,p.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=R}),define(ge[237],pe([0,1,2,22,20,8,19,5,9,43,12,15,137,6,105,70,115,46,18]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(z,Q){this._documents=z,this._provider=Q}provideDocumentSymbols(z,Q){const te=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideDocumentSymbols(te,Q)).then(ae=>{if(!(0,T.isFalsyOrEmpty)(ae))return ae[0]instanceof I.DocumentSymbol?ae.map(R.DocumentSymbol.from):d._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(z){var Q;z=z.slice(0).sort((ve,De)=>{let Me=ve.location.range.start.compareTo(De.location.range.start);return Me===0&&(Me=De.location.range.end.compareTo(ve.location.range.end)),Me});const te=[],ae=[];for(const ve of z){const De={name:ve.name||"!!MISSING: name!!",kind:R.SymbolKind.from(ve.kind),tags:((Q=ve.tags)===null||Q===void 0?void 0:Q.map(R.SymbolTag.from))||[],detail:"",containerName:ve.containerName,range:R.Range.from(ve.location.range),selectionRange:R.Range.from(ve.location.range),children:[]};for(;;){if(ae.length===0){ae.push(De),te.push(De);break}const Me=ae[ae.length-1];if(i.Range.containsRange(Me.range,De.range)&&!i.Range.equalsRange(Me.range,De.range)){Me.children&&Me.children.push(De),ae.push(De);break}ae.pop()}}return te}}class u{constructor(z,Q,te){this._documents=z,this._commands=Q,this._provider=te,this._cache=new y.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,Q){const te=this._documents.getDocument(z),ae=await this._provider.provideCodeLenses(te,Q);if(!(!ae||Q.isCancellationRequested)){const ve=this._cache.add(ae),De=new f.DisposableStore;this._disposables.set(ve,De);const Me={cacheId:ve,lenses:[]};for(let we=0;we<ae.length;we++)Me.lenses.push({cacheId:[ve,we],range:R.Range.from(ae[we].range),command:this._commands.toInternal(ae[we].command,De)});return Me}}async resolveCodeLens(z,Q){var te;const ae=z.cacheId&&this._cache.get(...z.cacheId);if(!!ae){let ve;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?ve=ae:ve=await this._provider.resolveCodeLens(ae,Q),ve||(ve=ae),!Q.isCancellationRequested){const De=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!De)return z.command=this._commands.toInternal((te=ve.command)!==null&&te!==void 0?te:u._badCmd,De),z}}}releaseCodeLenses(z){var Q;(Q=this._disposables.get(z))===null||Q===void 0||Q.dispose(),this._disposables.delete(z),this._cache.delete(z)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function o(Fe){return Array.isArray(Fe)?Fe.map(R.DefinitionLink.from):Fe?[R.DefinitionLink.from(Fe)]:[]}class t{constructor(z,Q){this._documents=z,this._provider=Q}provideDefinition(z,Q,te){const ae=this._documents.getDocument(z),ve=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideDefinition(ae,ve,te)).then(o)}}class r{constructor(z,Q){this._documents=z,this._provider=Q}provideDeclaration(z,Q,te){const ae=this._documents.getDocument(z),ve=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideDeclaration(ae,ve,te)).then(o)}}class s{constructor(z,Q){this._documents=z,this._provider=Q}provideImplementation(z,Q,te){const ae=this._documents.getDocument(z),ve=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideImplementation(ae,ve,te)).then(o)}}class a{constructor(z,Q){this._documents=z,this._provider=Q}provideTypeDefinition(z,Q,te){const ae=this._documents.getDocument(z),ve=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideTypeDefinition(ae,ve,te)).then(o)}}class n{constructor(z,Q){this._documents=z,this._provider=Q}provideHover(z,Q,te){const ae=this._documents.getDocument(z),ve=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideHover(ae,ve,te)).then(De=>{if(!(!De||(0,T.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=ae.getWordRangeAtPosition(ve)),De.range||(De.range=new I.Range(ve,ve)),R.Hover.from(De)})}}class c{constructor(z,Q){this._documents=z,this._provider=Q}provideEvaluatableExpression(z,Q,te){const ae=this._documents.getDocument(z),ve=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,ve,te)).then(De=>{if(De)return R.EvaluatableExpression.from(De)})}}class b{constructor(z,Q){this._documents=z,this._provider=Q}provideInlineValues(z,Q,te,ae){const ve=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideInlineValues(ve,R.Range.to(Q),R.InlineValueContext.to(te),ae)).then(De=>{if(Array.isArray(De))return De.map(Me=>R.InlineValue.from(Me))})}}class w{constructor(z,Q){this._documents=z,this._provider=Q}provideDocumentHighlights(z,Q,te){const ae=this._documents.getDocument(z),ve=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideDocumentHighlights(ae,ve,te)).then(De=>{if(Array.isArray(De))return De.map(R.DocumentHighlight.from)})}}class h{constructor(z,Q){this._documents=z,this._provider=Q}provideLinkedEditingRanges(z,Q,te){const ae=this._documents.getDocument(z),ve=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,ve,te)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,T.coalesce)(De.ranges.map(R.Range.from)),wordPattern:De.wordPattern}})}}class _{constructor(z,Q){this._documents=z,this._provider=Q}provideReferences(z,Q,te,ae){const ve=this._documents.getDocument(z),De=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideReferences(ve,De,te,ae)).then(Me=>{if(Array.isArray(Me))return Me.map(R.location.from)})}}class A{constructor(z,Q,te,ae,ve,De,Me){this._documents=z,this._commands=Q,this._diagnostics=te,this._provider=ae,this._logService=ve,this._extension=De,this._apiDeprecation=Me,this._cache=new y.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(z,Q,te,ae){const ve=this._documents.getDocument(z),De=E.Selection.isISelection(Q)?R.Selection.to(Q):R.Range.to(Q),Me=[];for(const ke of this._diagnostics.getDiagnostics(z))if(De.intersection(ke.range)&&Me.push(ke)>A._maxCodeActionsPerFile)break;const we={diagnostics:Me,only:te.only?new I.CodeActionKind(te.only):void 0,triggerKind:R.CodeActionTriggerKind.to(te.trigger)};return(0,C.asPromise)(()=>this._provider.provideCodeActions(ve,De,we,ae)).then(ke=>{var Ae;if(!(!(0,T.isNonEmptyArray)(ke)||ae.isCancellationRequested)){const xe=this._cache.add(ke),ye=new f.DisposableStore;this._disposables.set(xe,ye);const Ge=[];for(let X=0;X<ke.length;X++){const ie=ke[X];!ie||(A._isCommand(ie)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:ie.title,command:this._commands.toInternal(ie,ye)})):(we.only&&(ie.kind?we.only.contains(ie.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[xe,X],title:ie.title,command:ie.command&&this._commands.toInternal(ie.command,ye),diagnostics:ie.diagnostics&&ie.diagnostics.map(R.Diagnostic.from),edit:ie.edit&&R.WorkspaceEdit.from(ie.edit),kind:ie.kind&&ie.kind.value,isPreferred:ie.isPreferred,disabled:(Ae=ie.disabled)===null||Ae===void 0?void 0:Ae.reason})))}return{cacheId:xe,actions:Ge}}})}async resolveCodeAction(z,Q){var te;const[ae,ve]=z,De=this._cache.get(ae,ve);if(!(!De||A._isCommand(De))&&!!this._provider.resolveCodeAction){const Me=(te=await this._provider.resolveCodeAction(De,Q))!==null&&te!==void 0?te:De;return(Me==null?void 0:Me.edit)?R.WorkspaceEdit.from(Me.edit):void 0}}releaseCodeActions(z){var Q;(Q=this._disposables.get(z))===null||Q===void 0||Q.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}A._maxCodeActionsPerFile=1e3;class L{constructor(z,Q){this._documents=z,this._provider=Q}provideDocumentFormattingEdits(z,Q,te){const ae=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,Q,te)).then(ve=>{if(Array.isArray(ve))return ve.map(R.TextEdit.from)})}}class W{constructor(z,Q){this._documents=z,this._provider=Q}provideDocumentRangeFormattingEdits(z,Q,te,ae){const ve=this._documents.getDocument(z),De=R.Range.to(Q);return(0,C.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(ve,De,te,ae)).then(Me=>{if(Array.isArray(Me))return Me.map(R.TextEdit.from)})}}class j{constructor(z,Q){this._documents=z,this._provider=Q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(z,Q,te,ae,ve){const De=this._documents.getDocument(z),Me=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Me,te,ae,ve)).then(we=>{if(Array.isArray(we))return we.map(R.TextEdit.from)})}}class K{constructor(z,Q){this._provider=z,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(z,Q){const te=P.IdObject.mixin({symbols:[]});return(0,C.asPromise)(()=>this._provider.provideWorkspaceSymbols(z,Q)).then(ae=>{if((0,T.isNonEmptyArray)(ae)){for(const ve of ae)if(!!ve){if(!ve.name){this._logService.warn("INVALID SymbolInformation, lacks name",ve);continue}const De=P.IdObject.mixin(R.WorkspaceSymbol.from(ve));this._symbolCache.set(De._id,ve),te.symbols.push(De)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(z,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const te=this._symbolCache.get(z._id);if(te){const ae=await(0,C.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,Q));return ae&&(0,D.mixin)(z,R.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(z){const Q=this._resultCache.get(z);if(Q){for(let[te,ae]=Q;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(z)}}}class H{constructor(z,Q,te){this._documents=z,this._provider=Q,this._logService=te}static supportsResolving(z){return typeof z.prepareRename=="function"}provideRenameEdits(z,Q,te,ae){const ve=this._documents.getDocument(z),De=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideRenameEdits(ve,De,te,ae)).then(Me=>{if(!!Me)return R.WorkspaceEdit.from(Me)},Me=>{const we=H._asMessage(Me);return we?{rejectReason:we,edits:void 0}:Promise.reject(Me)})}resolveRenameLocation(z,Q,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(z),ve=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.prepareRename(ae,ve,te)).then(De=>{let Me,we;if(I.Range.isRange(De)?(Me=De,we=ae.getText(De)):(0,k.isObject)(De)&&(Me=De.range,we=De.placeholder),!!Me){if(Me.start.line>ve.line||Me.end.line<ve.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:R.Range.from(Me),text:we}}},De=>{const Me=H._asMessage(De);return Me?{rejectReason:Me,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ${constructor(z,Q){this.resultId=z,this.tokens=Q}}class M{constructor(z,Q){this._documents=z,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(z,Q,te){const ae=this._documents.getDocument(z),ve=Q!==0?this._previousResults.get(Q):null;return(0,C.asPromise)(()=>ve&&typeof ve.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,ve.resultId,te):this._provider.provideDocumentSemanticTokens(ae,te)).then(De=>(ve&&this._previousResults.delete(Q),De?(De=M._fixProvidedSemanticTokens(De),this._send(M._convertToEdits(ve,De),De)):null))}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return M._isSemanticTokens(z)?M._isCorrectSemanticTokens(z)?z:new I.SemanticTokens(new Uint32Array(z.data),z.resultId):M._isSemanticTokensEdits(z)?M._isCorrectSemanticTokensEdits(z)?z:new I.SemanticTokensEdits(z.edits.map(Q=>new I.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const Q of z.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,Q){if(!M._isSemanticTokens(Q)||!z||!z.tokens)return Q;const te=z.tokens,ae=te.length,ve=Q.data,De=ve.length;let Me=0;const we=Math.min(ae,De);for(;Me<we&&te[Me]===ve[Me];)Me++;if(Me===ae&&Me===De)return new I.SemanticTokensEdits([],Q.resultId);let ke=0;const Ae=we-Me;for(;ke<Ae&&te[ae-ke-1]===ve[De-ke-1];)ke++;return new I.SemanticTokensEdits([{start:Me,deleteCount:ae-Me-ke,data:ve.subarray(Me,De-ke)}],Q.resultId)}_send(z,Q){if(M._isSemanticTokens(z)){const te=this._nextResultId++;return this._previousResults.set(te,new $(z.resultId,z.data)),(0,l.encodeSemanticTokensDto)({id:te,type:"full",data:z.data})}if(M._isSemanticTokensEdits(z)){const te=this._nextResultId++;return M._isSemanticTokens(Q)?this._previousResults.set(te,new $(Q.resultId,Q.data)):this._previousResults.set(te,new $(z.resultId)),(0,l.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(z.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=M;class U{constructor(z,Q){this._documents=z,this._provider=Q}provideDocumentRangeSemanticTokens(z,Q,te){const ae=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,R.Range.to(Q),te)).then(ve=>ve?this._send(ve):null)}_send(z){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=U;class F{constructor(z,Q,te,ae,ve){this._documents=z,this._commands=Q,this._provider=te,this._apiDeprecation=ae,this._extension=ve,this._cache=new y.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,Q,te,ae){const ve=this._documents.getDocument(z),De=R.Position.to(Q),Me=ve.getWordRangeAtPosition(De)||new I.Range(De,De),we=Me.with({end:De}),ke=new g.StopWatch(!0),Ae=await(0,C.asPromise)(()=>this._provider.provideCompletionItems(ve,De,ae,R.CompletionContext.to(te)));if(!!Ae&&!ae.isCancellationRequested){const xe=Array.isArray(Ae)?new I.CompletionList(Ae):Ae,ye=F.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),Ge=new f.DisposableStore;this._disposables.set(ye,Ge);const X=[],ie={x:ye,b:X,a:{replace:R.Range.from(Me),insert:R.Range.from(we)},c:xe.isIncomplete||void 0,d:ke.elapsed()};for(let Se=0;Se<xe.items.length;Se++){const Ne=xe.items[Se],ze=this._convertCompletionItem(Ne,[ye,Se],we,Me);X.push(ze)}return ie}}async resolveCompletionItem(z,Q){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...z);if(!!te){const ae=await(0,C.asPromise)(()=>this._provider.resolveCompletionItem(te,Q));if(!!ae)return this._convertCompletionItem(ae,z)}}}releaseCompletionItems(z){var Q;(Q=this._disposables.get(z))===null||Q===void 0||Q.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,Q,te,ae){var ve;const De=this._disposables.get(Q[0]);if(!De)throw Error("DisposableStore is missing...");const Me={x:Q,a:(ve=z.label)!==null&&ve!==void 0?ve:"",o:z.label2,b:z.kind!==void 0?R.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(R.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:R.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(R.TextEdit.from),m:this._commands.toInternal(z.command,De)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Me.h=z.textEdit.newText):typeof z.insertText=="string"?Me.h=z.insertText:z.insertText instanceof I.SnippetString&&(Me.h=z.insertText.value,Me.i|=4);let we;return z.textEdit?we=z.textEdit.range:z.range&&(we=z.range),I.Range.isRange(we)?Me.j=R.Range.from(we):we&&(!(te==null?void 0:te.isEqual(we.inserting))||!(ae==null?void 0:ae.isEqual(we.replacing)))&&(Me.j={insert:R.Range.from(we.inserting),replace:R.Range.from(we.replacing)}),Me}}class N{constructor(z,Q){this._documents=z,this._provider=Q,this._cache=new y.Cache("SignatureHelp")}provideSignatureHelp(z,Q,te,ae){const ve=this._documents.getDocument(z),De=R.Position.to(Q),Me=this.reviveContext(te);return(0,C.asPromise)(()=>this._provider.provideSignatureHelp(ve,De,ae,Me)).then(we=>{if(we){const ke=this._cache.add([we]);return Object.assign(Object.assign({},R.SignatureHelp.from(we)),{id:ke})}})}reviveContext(z){let Q;if(z.activeSignatureHelp){const te=R.SignatureHelp.to(z.activeSignatureHelp),ae=this._cache.get(z.activeSignatureHelp.id,0);ae?(Q=ae,Q.activeSignature=te.activeSignature,Q.activeParameter=te.activeParameter):Q=te}return Object.assign(Object.assign({},z),{activeSignatureHelp:Q})}releaseSignatureHelp(z){this._cache.delete(z)}}class O{constructor(z,Q){this._documents=z,this._provider=Q}provideInlineHints(z,Q,te){const ae=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideInlineHints(ae,R.Range.to(Q),te)).then(ve=>ve?{hints:ve.map(R.InlineHint.from)}:void 0)}}class V{constructor(z,Q){this._documents=z,this._provider=Q,this._cache=new y.Cache("DocumentLink")}provideLinks(z,Q){const te=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideDocumentLinks(te,Q)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(R.DocumentLink.from)};{const ve=this._cache.add(ae),De={links:[],id:ve};for(let Me=0;Me<ae.length;Me++){const we=R.DocumentLink.from(ae[Me]);we.cacheId=[ve,Me],De.links.push(we)}return De}}})}resolveLink(z,Q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...z);return te?(0,C.asPromise)(()=>this._provider.resolveDocumentLink(te,Q)).then(ae=>ae&&R.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(z){this._cache.delete(z)}}class q{constructor(z,Q){this._documents=z,this._provider=Q}provideColors(z,Q){const te=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideDocumentColors(te,Q)).then(ae=>Array.isArray(ae)?ae.map(De=>({color:R.Color.from(De.color),range:R.Range.from(De.range)})):[])}provideColorPresentations(z,Q,te){const ae=this._documents.getDocument(z),ve=R.Range.to(Q.range),De=R.Color.to(Q.color);return(0,C.asPromise)(()=>this._provider.provideColorPresentations(De,{document:ae,range:ve},te)).then(Me=>{if(!!Array.isArray(Me))return Me.map(R.ColorPresentation.from)})}}class Y{constructor(z,Q){this._documents=z,this._provider=Q}provideFoldingRanges(z,Q,te){const ae=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideFoldingRanges(ae,Q,te)).then(ve=>{if(!!Array.isArray(ve))return ve.map(R.FoldingRange.from)})}}class fe{constructor(z,Q,te){this._documents=z,this._provider=Q,this._logService=te}provideSelectionRanges(z,Q,te){const ae=this._documents.getDocument(z),ve=Q.map(R.Position.to);return(0,C.asPromise)(()=>this._provider.provideSelectionRanges(ae,ve,te)).then(De=>{if(!(0,T.isNonEmptyArray)(De))return[];if(De.length!==ve.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Me=[];for(let we=0;we<ve.length;we++){const ke=[];Me.push(ke);let Ae=ve[we],xe=De[we];for(;;){if(!xe.range.contains(Ae))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(R.SelectionRange.from(xe)),!xe.parent)break;Ae=xe.range,xe=xe.parent}}return Me})}}class _e{constructor(z,Q){this._documents=z,this._provider=Q,this._idPool=new m.IdGenerator(""),this._cache=new Map}async prepareSession(z,Q,te){const ae=this._documents.getDocument(z),ve=R.Position.to(Q),De=await this._provider.prepareCallHierarchy(ae,ve,te);if(!!De){const Me=this._idPool.nextId();return this._cache.set(Me,new Map),Array.isArray(De)?De.map(we=>this._cacheAndConvertItem(Me,we)):[this._cacheAndConvertItem(Me,De)]}}async provideCallsTo(z,Q,te){const ae=this._itemFromCache(z,Q);if(!ae)throw new Error("missing call hierarchy item");const ve=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!ve)return ve.map(De=>({from:this._cacheAndConvertItem(z,De.from),fromRanges:De.fromRanges.map(Me=>R.Range.from(Me))}))}async provideCallsFrom(z,Q,te){const ae=this._itemFromCache(z,Q);if(!ae)throw new Error("missing call hierarchy item");const ve=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!ve)return ve.map(De=>({to:this._cacheAndConvertItem(z,De.to),fromRanges:De.fromRanges.map(Me=>R.Range.from(Me))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,Q){var te;const ae=this._cache.get(z),ve={_sessionId:z,_itemId:ae.size.toString(36),name:Q.name,detail:Q.detail,kind:R.SymbolKind.from(Q.kind),uri:Q.uri,range:R.Range.from(Q.range),selectionRange:R.Range.from(Q.selectionRange),tags:(te=Q.tags)===null||te===void 0?void 0:te.map(R.SymbolTag.from)};return ae.set(ve._itemId,Q),ve}_itemFromCache(z,Q){const te=this._cache.get(z);return te==null?void 0:te.get(Q)}}class Le{constructor(z,Q){this.adapter=z,this.extension=Q}}class Ie{constructor(z,Q,te,ae,ve,De,Me){this._adapter=new Map,this._uriTransformer=Q,this._proxy=z.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=ve,this._logService=De,this._apiDeprecation=Me}_transformDocumentSelector(z){return(0,T.coalesce)((0,T.asArray)(z).map(Q=>this._doTransformDocumentSelector(Q)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:R.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new I.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Ie._handlePool++}_withAdapter(z,Q,te,ae,ve=!1){const De=this._adapter.get(z);if(!De)return Promise.resolve(ae);if(De.adapter instanceof Q){let Me;De.extension&&(Me=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${Q.name}'`));const we=te(De.adapter,De.extension),ke=De.extension;return ke&&Promise.resolve(we).then(()=>this._logService.trace(`[${ke.identifier.value}] provider DONE after ${Date.now()-Me}ms`),Ae=>{ve&&Ae instanceof v.CancellationError||(this._logService.error(`[${ke.identifier.value}] provider FAILED`),this._logService.error(Ae))}),we}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,Q){const te=this._nextHandle();return this._adapter.set(te,new Le(z,Q)),te}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,Q,te,ae){const ve=this._addNewAdapter(new d(this._documents,te),z),De=ae&&ae.label||Ie._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(ve,this._transformDocumentSelector(Q),De),this._createDisposable(ve)}$provideDocumentSymbols(z,Q,te){return this._withAdapter(z,d,ae=>ae.provideDocumentSymbols(p.URI.revive(Q),te),void 0)}registerCodeLensProvider(z,Q,te){const ae=this._nextHandle(),ve=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Le(new u(this._documents,this._commands.converter,te),z)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Q),ve);let De=this._createDisposable(ae);if(ve!==void 0){const Me=te.onDidChangeCodeLenses(we=>this._proxy.$emitCodeLensEvent(ve));De=I.Disposable.from(De,Me)}return De}$provideCodeLenses(z,Q,te){return this._withAdapter(z,u,ae=>ae.provideCodeLenses(p.URI.revive(Q),te),void 0)}$resolveCodeLens(z,Q,te){return this._withAdapter(z,u,ae=>ae.resolveCodeLens(Q,te),void 0)}$releaseCodeLenses(z,Q){this._withAdapter(z,u,te=>Promise.resolve(te.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(z,Q,te){const ae=this._addNewAdapter(new t(this._documents,te),z);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDefinition(z,Q,te,ae){return this._withAdapter(z,t,ve=>ve.provideDefinition(p.URI.revive(Q),te,ae),[])}registerDeclarationProvider(z,Q,te){const ae=this._addNewAdapter(new r(this._documents,te),z);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDeclaration(z,Q,te,ae){return this._withAdapter(z,r,ve=>ve.provideDeclaration(p.URI.revive(Q),te,ae),[])}registerImplementationProvider(z,Q,te){const ae=this._addNewAdapter(new s(this._documents,te),z);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideImplementation(z,Q,te,ae){return this._withAdapter(z,s,ve=>ve.provideImplementation(p.URI.revive(Q),te,ae),[])}registerTypeDefinitionProvider(z,Q,te){const ae=this._addNewAdapter(new a(this._documents,te),z);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideTypeDefinition(z,Q,te,ae){return this._withAdapter(z,a,ve=>ve.provideTypeDefinition(p.URI.revive(Q),te,ae),[])}registerHoverProvider(z,Q,te,ae){const ve=this._addNewAdapter(new n(this._documents,te),z);return this._proxy.$registerHoverProvider(ve,this._transformDocumentSelector(Q)),this._createDisposable(ve)}$provideHover(z,Q,te,ae){return this._withAdapter(z,n,ve=>ve.provideHover(p.URI.revive(Q),te,ae),void 0)}registerEvaluatableExpressionProvider(z,Q,te,ae){const ve=this._addNewAdapter(new c(this._documents,te),z);return this._proxy.$registerEvaluatableExpressionProvider(ve,this._transformDocumentSelector(Q)),this._createDisposable(ve)}$provideEvaluatableExpression(z,Q,te,ae){return this._withAdapter(z,c,ve=>ve.provideEvaluatableExpression(p.URI.revive(Q),te,ae),void 0)}registerInlineValuesProvider(z,Q,te,ae){const ve=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new b(this._documents,te),z);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(Q),ve);let Me=this._createDisposable(De);if(ve!==void 0){const we=te.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(ve));Me=I.Disposable.from(Me,we)}return Me}$provideInlineValues(z,Q,te,ae,ve){return this._withAdapter(z,b,De=>De.provideInlineValues(p.URI.revive(Q),te,ae,ve),void 0)}registerDocumentHighlightProvider(z,Q,te){const ae=this._addNewAdapter(new w(this._documents,te),z);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentHighlights(z,Q,te,ae){return this._withAdapter(z,w,ve=>ve.provideDocumentHighlights(p.URI.revive(Q),te,ae),void 0)}registerLinkedEditingRangeProvider(z,Q,te){const ae=this._addNewAdapter(new h(this._documents,te),z);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideLinkedEditingRanges(z,Q,te,ae){return this._withAdapter(z,h,async ve=>{const De=await ve.provideLinkedEditingRanges(p.URI.revive(Q),te,ae);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Ie._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(z,Q,te){const ae=this._addNewAdapter(new _(this._documents,te),z);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideReferences(z,Q,te,ae,ve){return this._withAdapter(z,_,De=>De.provideReferences(p.URI.revive(Q),te,ae,ve),void 0)}registerCodeActionProvider(z,Q,te,ae){var ve,De;const Me=new f.DisposableStore,we=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,te,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(Q),{providedKinds:(ve=ae==null?void 0:ae.providedCodeActionKinds)===null||ve===void 0?void 0:ve.map(ke=>ke.value),documentation:(De=ae==null?void 0:ae.documentation)===null||De===void 0?void 0:De.map(ke=>({kind:ke.kind.value,command:this._commands.converter.toInternal(ke.command,Me)}))},Ie._extLabel(z),Boolean(te.resolveCodeAction)),Me.add(this._createDisposable(we)),Me}$provideCodeActions(z,Q,te,ae,ve){return this._withAdapter(z,A,De=>De.provideCodeActions(p.URI.revive(Q),te,ae,ve),void 0)}$resolveCodeAction(z,Q,te){return this._withAdapter(z,A,ae=>ae.resolveCodeAction(Q,te),void 0)}$releaseCodeActions(z,Q){this._withAdapter(z,A,te=>Promise.resolve(te.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(z,Q,te){const ae=this._addNewAdapter(new L(this._documents,te),z);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Q),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(z,Q,te,ae){return this._withAdapter(z,L,ve=>ve.provideDocumentFormattingEdits(p.URI.revive(Q),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(z,Q,te){const ae=this._addNewAdapter(new W(this._documents,te),z);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Q),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(z,Q,te,ae,ve){return this._withAdapter(z,W,De=>De.provideDocumentRangeFormattingEdits(p.URI.revive(Q),te,ae,ve),void 0)}registerOnTypeFormattingEditProvider(z,Q,te,ae){const ve=this._addNewAdapter(new j(this._documents,te),z);return this._proxy.$registerOnTypeFormattingSupport(ve,this._transformDocumentSelector(Q),ae,z.identifier),this._createDisposable(ve)}$provideOnTypeFormattingEdits(z,Q,te,ae,ve,De){return this._withAdapter(z,j,Me=>Me.provideOnTypeFormattingEdits(p.URI.revive(Q),te,ae,ve,De),void 0)}registerWorkspaceSymbolProvider(z,Q){const te=this._addNewAdapter(new K(Q,this._logService),z);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(z,Q,te){return this._withAdapter(z,K,ae=>ae.provideWorkspaceSymbols(Q,te),{symbols:[]})}$resolveWorkspaceSymbol(z,Q,te){return this._withAdapter(z,K,ae=>ae.resolveWorkspaceSymbol(Q,te),void 0)}$releaseWorkspaceSymbols(z,Q){this._withAdapter(z,K,te=>te.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(z,Q,te){const ae=this._addNewAdapter(new H(this._documents,te,this._logService),z);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Q),H.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(z,Q,te,ae,ve){return this._withAdapter(z,H,De=>De.provideRenameEdits(p.URI.revive(Q),te,ae,ve),void 0)}$resolveRenameLocation(z,Q,te,ae){return this._withAdapter(z,H,ve=>ve.resolveRenameLocation(p.URI.revive(Q),te,ae),void 0)}registerDocumentSemanticTokensProvider(z,Q,te,ae){const ve=this._nextHandle(),De=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(ve,new Le(new M(this._documents,te),z)),this._proxy.$registerDocumentSemanticTokensProvider(ve,this._transformDocumentSelector(Q),ae,De);let Me=this._createDisposable(ve);if(De){const we=te.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(De));Me=I.Disposable.from(Me,we)}return Me}$provideDocumentSemanticTokens(z,Q,te,ae){return this._withAdapter(z,M,ve=>ve.provideDocumentSemanticTokens(p.URI.revive(Q),te,ae),null,!0)}$releaseDocumentSemanticTokens(z,Q){this._withAdapter(z,M,te=>te.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(z,Q,te,ae){const ve=this._addNewAdapter(new U(this._documents,te),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ve,this._transformDocumentSelector(Q),ae),this._createDisposable(ve)}$provideDocumentRangeSemanticTokens(z,Q,te,ae){return this._withAdapter(z,U,ve=>ve.provideDocumentRangeSemanticTokens(p.URI.revive(Q),te,ae),null,!0)}registerCompletionItemProvider(z,Q,te,ae){const ve=this._addNewAdapter(new F(this._documents,this._commands.converter,te,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(ve,this._transformDocumentSelector(Q),ae,F.supportsResolving(te),`${z.identifier.value}(${ae.join("")})`),this._createDisposable(ve)}$provideCompletionItems(z,Q,te,ae,ve){return this._withAdapter(z,F,De=>De.provideCompletionItems(p.URI.revive(Q),te,ae,ve),void 0)}$resolveCompletionItem(z,Q,te){return this._withAdapter(z,F,ae=>ae.resolveCompletionItem(Q,te),void 0)}$releaseCompletionItems(z,Q){this._withAdapter(z,F,te=>te.releaseCompletionItems(Q),void 0)}registerSignatureHelpProvider(z,Q,te,ae){const ve=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,De=this._addNewAdapter(new N(this._documents,te),z);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(Q),ve),this._createDisposable(De)}$provideSignatureHelp(z,Q,te,ae,ve){return this._withAdapter(z,N,De=>De.provideSignatureHelp(p.URI.revive(Q),te,ae,ve),void 0)}$releaseSignatureHelp(z,Q){this._withAdapter(z,N,te=>te.releaseSignatureHelp(Q),void 0)}registerInlineHintsProvider(z,Q,te){const ae=typeof te.onDidChangeInlineHints=="function"?this._nextHandle():void 0,ve=this._addNewAdapter(new O(this._documents,te),z);this._proxy.$registerInlineHintsProvider(ve,this._transformDocumentSelector(Q),ae);let De=this._createDisposable(ve);if(ae!==void 0){const Me=te.onDidChangeInlineHints(we=>this._proxy.$emitInlineHintsEvent(ae));De=I.Disposable.from(De,Me)}return De}$provideInlineHints(z,Q,te,ae){return this._withAdapter(z,O,ve=>ve.provideInlineHints(p.URI.revive(Q),te,ae),void 0)}registerDocumentLinkProvider(z,Q,te){const ae=this._addNewAdapter(new V(this._documents,te),z);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Q),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(z,Q,te){return this._withAdapter(z,V,ae=>ae.provideLinks(p.URI.revive(Q),te),void 0)}$resolveDocumentLink(z,Q,te){return this._withAdapter(z,V,ae=>ae.resolveLink(Q,te),void 0)}$releaseDocumentLinks(z,Q){this._withAdapter(z,V,te=>te.releaseLinks(Q),void 0)}registerColorProvider(z,Q,te){const ae=this._addNewAdapter(new q(this._documents,te),z);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentColors(z,Q,te){return this._withAdapter(z,q,ae=>ae.provideColors(p.URI.revive(Q),te),[])}$provideColorPresentations(z,Q,te,ae){return this._withAdapter(z,q,ve=>ve.provideColorPresentations(p.URI.revive(Q),te,ae),void 0)}registerFoldingRangeProvider(z,Q,te){const ae=this._nextHandle(),ve=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Le(new Y(this._documents,te),z)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Q),ve);let De=this._createDisposable(ae);if(ve!==void 0){const Me=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ve));De=I.Disposable.from(De,Me)}return De}$provideFoldingRanges(z,Q,te,ae){return this._withAdapter(z,Y,ve=>ve.provideFoldingRanges(p.URI.revive(Q),te,ae),void 0)}registerSelectionRangeProvider(z,Q,te){const ae=this._addNewAdapter(new fe(this._documents,te,this._logService),z);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideSelectionRanges(z,Q,te,ae){return this._withAdapter(z,fe,ve=>ve.provideSelectionRanges(p.URI.revive(Q),te,ae),[])}registerCallHierarchyProvider(z,Q,te){const ae=this._addNewAdapter(new _e(this._documents,te),z);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareCallHierarchy(z,Q,te,ae){return this._withAdapter(z,_e,ve=>Promise.resolve(ve.prepareSession(p.URI.revive(Q),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(z,Q,te,ae){return this._withAdapter(z,_e,ve=>ve.provideCallsTo(Q,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(z,Q,te,ae){return this._withAdapter(z,_e,ve=>ve.provideCallsFrom(Q,te,ae),void 0)}$releaseCallHierarchy(z,Q){this._withAdapter(z,_e,te=>Promise.resolve(te.releaseSession(Q)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,S.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Ie._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Ie._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ie._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ie._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Ie._serializeRegExp(z.beforeText),afterText:z.afterText?Ie._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Ie._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Ie._serializeOnEnterRule)}setLanguageConfiguration(z,Q,te){let{wordPattern:ae}=te;if(ae&&(0,S.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Q,ae):this._documents.setWordDefinitionFor(Q,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ve=this._nextHandle(),De={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Ie._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Ie._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Ie._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ve,Q,De),this._createDisposable(ve)}$setWordDefinitions(z){for(const Q of z)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=Ie,Ie._handlePool=0}),define(ge[238],pe([0,1,5,20,8]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class I{constructor(P,S){this._proxy=P.getProxy(p.MainContext.MainThreadLanguages),this._documents=S}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,S){await this._proxy.$changeLanguage(P,S);const i=this._documents.getDocumentData(P);if(!i)throw new Error(`document '${P.toString}' NOT found`);return i.document}async tokenAtPosition(P,S){var i;const T=P.version,k=D.Position.from(S),E=await this._proxy.$tokensAtPosition(P.uri,k),f={type:R.StandardTokenType.Other,range:(i=P.getWordRangeAtPosition(S))!==null&&i!==void 0?i:new R.Range(S.line,S.character,S.line,S.character)};if(!E)return f;const l={range:D.Range.to(E.range),type:D.TokenType.to(E.type)};return!l.range.contains(S)||T!==P.version?f:l}}e.ExtHostLanguages=I}),define(ge[239],pe([0,1,5,13,41]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function I(P){return P&&P.title}let C=class{constructor(S,i){this._logService=i,this._proxy=S.getProxy(p.MainContext.MainThreadMessageService)}showMessage(S,i,T,k,E){const f={extension:S};let l;typeof k=="string"||I(k)?l=[k,...E]:(f.modal=k&&k.modal,f.useCustom=k&&k.useCustom,l=E),f.useCustom&&(0,R.checkProposedApiEnabled)(S);const m=[];for(let y=0;y<l.length;y++){const g=l[y];if(typeof g=="string")m.push({title:g,handle:y,isCloseAffordance:!1});else if(typeof g=="object"){let{title:v,isCloseAffordance:d}=g;m.push({title:v,isCloseAffordance:!!d,handle:y})}else this._logService.warn("Invalid message item:",g)}return this._proxy.$showMessage(i,T,f,m).then(y=>{if(typeof y=="number")return l[y]})}};C=je([Ue(1,D.ILogService)],C),e.ExtHostMessageService=C}),define(ge[240],pe([0,1,21,3,6,2,28,5,20,8,84,85,23,216,217,70,15,73]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class v extends R.Disposable{constructor(n,c,b,w,h){super();this._editorId=n,this.uri=c,this._proxy=b,this._webviewInitData=w,this.document=h,this._onDidReceiveDocumentMessage=new D.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:_=>this._proxy.$postMessage(this._editorId,void 0,_),asWebviewUri:_=>this._asWebviewUri(_)}}onDidReceiveMessage(n,c){var b;this._onDidReceiveDocumentMessage.fire(c),n!==void 0&&((b=this._rendererIdToEmitters.get(n))===null||b===void 0||b.fire(c))}getRendererComm(n){const c=new D.Emitter;return this._rendererIdToEmitters.set(n,c),{editorId:this._editorId,onDidReceiveMessage:c.event,postMessage:b=>this._proxy.$postMessage(this._editorId,n,b),asWebviewUri:b=>this._asWebviewUri(b)}}_asWebviewUri(n){return(0,T.asWebviewUri)(this._webviewInitData,this._editorId,n)}}class d extends R.Disposable{constructor(n,c,b,w){super();this._proxy=n,this._handle=c,this._extension=b,this._provider=w,this._kernelToFriendlyId=new E.ResourceMap,this._friendlyIdToKernel=new E.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(h=>{const _=h==null?void 0:h.uri;this._proxy.$onNotebookKernelChange(this._handle,_)}))}async provideKernels(n,c){const b=await this._provider.provideKernels(n.notebookDocument,c)||[],w=new Map;let h=0;const _=new Set,A=this._kernelToFriendlyId.get(n.uri),L=b.map(j=>{let K=A==null?void 0:A.get(j);return K===void 0&&(j.id&&_.has(j.id)?K=`${this._extension.identifier.value}_${j.id}_${h++}`:K=`${this._extension.identifier.value}_${j.id||C.generateUuid()}`),w.set(j,K),{id:j.id,friendlyId:K,label:j.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:j.description,detail:j.detail,isPreferred:j.isPreferred,preloads:j.preloads,supportedLanguages:j.supportedLanguages}});this._kernelToFriendlyId.set(n.uri,w);const W=new Map;return w.forEach((j,K)=>{W.set(j,K)}),this._friendlyIdToKernel.set(n.uri,W),L}getKernelByFriendlyId(n,c){var b;return(b=this._friendlyIdToKernel.get(n))===null||b===void 0?void 0:b.get(c)}async resolveNotebook(n,c,b,w){var h;const _=(h=this._friendlyIdToKernel.get(c.uri))===null||h===void 0?void 0:h.get(n);if(_&&this._provider.resolveKernel)return this._provider.resolveKernel(_,c.notebookDocument,b,w)}async executeNotebook(n,c,b){var w;const h=(w=this._friendlyIdToKernel.get(c.uri))===null||w===void 0?void 0:w.get(n);if(!!h)return u(b?_=>h.executeCell(c.notebookDocument,b.cell,_):_=>h.executeAllCells(c.notebookDocument,_))}async cancelNotebook(n,c,b){var w;const h=(w=this._friendlyIdToKernel.get(c.uri))===null||w===void 0?void 0:w.get(n);if(!!h)return b?h.cancelCellExecution(c.notebookDocument,b.cell):h.cancelAllCellsExecution(c.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=d;async function u(a){const n=new p.CancellationTokenSource;try{await a(n.token)}finally{n.dispose()}}class o{constructor(n,c){const b=o._Keys.nextId();n.$registerNotebookEditorDecorationType(b,S.NotebookDecorationRenderOptions.from(c)),this.value={key:b,dispose(){n.$removeNotebookEditorDecorationType(b)}}}}e.NotebookEditorDecorationType=o,o._Keys=new m.IdGenerator("NotebookEditorDecorationType");class t{constructor(n,c,b,w,h,_,A){this._textDocumentsAndEditors=b,this._textDocuments=w,this._webviewInitData=h,this.logService=_,this._extensionStoragePaths=A,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new E.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new D.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new D.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new D.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new D.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new D.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new D.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new D.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new D.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new D.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new D.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new D.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new D.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._backupIdPool=0,this._proxy=n.getProxy(P.MainContext.MainThreadNotebook),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:L=>{var W;if(L&&L.$mid===12){const j=(W=L.notebookEditor)===null||W===void 0?void 0:W.notebookUri,K=L.cell.handle,H=this._documents.get(j),$=H==null?void 0:H.getCell(K);if($)return $.cell}return L}})}get activeNotebookEditor(){var n;return(n=this._activeNotebookEditor)===null||n===void 0?void 0:n.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(n=>n.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(n){return this._documents.get(n)}_getNotebookDocument(n){const c=this._documents.get(n);if(!c)throw new Error(`NO notebook document for '${n}'`);return c}_getProviderData(n){const c=this._notebookContentProviders.get(n);if(!c)throw new Error(`NO provider for '${n}'`);return c}registerNotebookContentProvider(n,c,b,w){var h,_,A;if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:n,provider:b});let L;b.onDidChangeNotebookContentOptions&&(L=b.onDidChangeNotebookContentOptions(()=>{this._proxy.$updateNotebookProviderOptions(c,b.options)}));const W=(h=w==null?void 0:w.viewOptions)===null||h===void 0?void 0:h.filenamePattern.map(j=>S.NotebookExclusiveDocumentPattern.from(j)).filter(j=>j!==void 0);return((_=w==null?void 0:w.viewOptions)===null||_===void 0?void 0:_.filenamePattern)&&!W&&console.warn(`Notebook content provider view options file name pattern is invalid ${(A=w==null?void 0:w.viewOptions)===null||A===void 0?void 0:A.filenamePattern}`),this._proxy.$registerNotebookProvider({id:n.identifier,location:n.extensionLocation,description:n.description},c,{transientOutputs:(w==null?void 0:w.transientOutputs)||!1,transientMetadata:(w==null?void 0:w.transientMetadata)||{},viewOptions:(w==null?void 0:w.viewOptions)&&W?{displayName:w.viewOptions.displayName,filenamePattern:W,exclusive:w.viewOptions.exclusive||!1}:void 0}),new i.Disposable(()=>{L==null||L.dispose(),this._notebookContentProviders.delete(c),this._proxy.$unregisterNotebookProvider(c)})}registerNotebookKernelProvider(n,c,b){const w=t._notebookKernelProviderHandlePool++,h=new d(this._proxy,w,n,b);return this._notebookKernelProviders.set(w,h),this._proxy.$registerNotebookKernelProvider({id:n.identifier,location:n.extensionLocation,description:n.description},w,{viewType:c.viewType,filenamePattern:c.filenamePattern?S.NotebookExclusiveDocumentPattern.from(c.filenamePattern):void 0}),new i.Disposable(()=>{h.dispose(),this._notebookKernelProviders.delete(w),this._proxy.$unregisterNotebookKernelProvider(w)})}createNotebookEditorDecorationType(n){return new o(this._proxy,n).value}async openNotebookDocument(n){const c=this._documents.get(n);if(c)return c.notebookDocument;const b=await this._proxy.$tryOpenDocument(n),w=this._documents.get(I.URI.revive(b));return(0,y.assertIsDefined)(w==null?void 0:w.notebookDocument)}_withAdapter(n,c,b){const w=this._documents.get(I.URI.revive(c));if(!w)return[];const h=this._notebookKernelProviders.get(n);return h?b(h,w):[]}async showNotebookDocument(n,c){var b;I.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let w;typeof c=="object"?w={position:S.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:c.selection&&S.NotebookCellRange.from(c.selection),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:w={preserveFocus:!1};const h=await this._proxy.$tryShowNotebookDocument(n.uri,n.viewType,w),_=h&&((b=this._editors.get(h))===null||b===void 0?void 0:b.editor);if(_)return _.editor;throw h?new Error(`Could NOT open editor for "${n.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.toString()}".`)}async $provideNotebookKernels(n,c,b){return this._withAdapter(n,c,(w,h)=>w.provideKernels(h,b))}async $resolveNotebookKernel(n,c,b,w,h){await this._withAdapter(n,b,async(_,A)=>{const L=this._webviewComm.get(c);L&&await _.resolveNotebook(w,A,L.contentProviderComm,h)})}async $resolveNotebookEditor(n,c,b){const w=this._notebookContentProviders.get(n),h=I.URI.revive(c),_=this._documents.get(h);if(!(!_||!w)){let A=this._webviewComm.get(b);A||(A=new v(b,h,this._proxy,this._webviewInitData,_),this._webviewComm.set(b,A)),!!w.provider.resolveNotebook&&await w.provider.resolveNotebook(_.notebookDocument,A.contentProviderComm)}}async $executeNotebookKernelFromProvider(n,c,b,w){await this._withAdapter(n,c,async(h,_)=>{const A=w!==void 0?_.getCell(w):void 0;return h.executeNotebook(b,_,A)})}async $cancelNotebookKernelFromProvider(n,c,b,w){await this._withAdapter(n,c,async(h,_)=>{const A=w!==void 0?_.getCell(w):void 0;return h.cancelNotebook(b,_,A)})}async $openNotebook(n,c,b,w,h){const{provider:_}=this._getProviderData(n),A=await _.openNotebook(I.URI.revive(c),{backupId:b,untitledDocumentData:h==null?void 0:h.buffer},w);return{metadata:S.NotebookDocumentMetadata.from(A.metadata),cells:A.cells.map(S.NotebookCellData.from)}}async $saveNotebook(n,c,b){const w=this._getNotebookDocument(I.URI.revive(c)),{provider:h}=this._getProviderData(n);return await h.saveNotebook(w.notebookDocument,b),!0}async $saveNotebookAs(n,c,b,w){const h=this._getNotebookDocument(I.URI.revive(c)),{provider:_}=this._getProviderData(n);return await _.saveNotebookAs(I.URI.revive(b),h.notebookDocument,w),!0}async $backupNotebook(n,c,b){var w;const h=this._getNotebookDocument(I.URI.revive(c)),_=this._getProviderData(n),A=(w=this._extensionStoragePaths.workspaceValue(_.extension))!==null&&w!==void 0?w:this._extensionStoragePaths.globalValue(_.extension),L=String((0,g.hash)([h.uri.toString(),this._backupIdPool++])),W=I.URI.joinPath(A,L),j=await _.provider.backupNotebook(h.notebookDocument,{destination:W},b);return h.updateBackup(j),j.id}$acceptNotebookActiveKernelChange(n){n.providerHandle!==void 0&&this._withAdapter(n.providerHandle,n.uri,async(c,b)=>{const w=n.kernelFriendlyId?c.getKernelByFriendlyId(I.URI.revive(n.uri),n.kernelFriendlyId):void 0;this._editors.forEach(h=>{h.editor.notebookData===b&&h.editor._acceptKernel(w)}),this._onDidChangeActiveNotebookKernel.fire({document:b.notebookDocument,kernel:w})})}$onDidReceiveMessage(n,c,b){var w;(w=this._webviewComm.get(n))===null||w===void 0||w.onDidReceiveMessage(c,b)}$acceptModelChanged(n,c,b){this._getNotebookDocument(I.URI.revive(n)).acceptModelChanged(c,b)}$acceptDirtyStateChanged(n,c){const b=this._getNotebookDocument(I.URI.revive(n));b.acceptModelChanged({rawEvents:[],versionId:b.notebookDocument.version},c)}$acceptModelSaved(n){const c=this._getNotebookDocument(I.URI.revive(n));this._onDidSaveNotebookDocument.fire(c.notebookDocument)}$acceptEditorPropertiesChanged(n,c){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",n,c);const b=this._editors.get(n);if(!b)throw new Error(`unknown text editor: ${n}`);c.visibleRanges&&b.editor._acceptVisibleRanges(c.visibleRanges.ranges.map(S.NotebookCellRange.to)),c.selections&&b.editor._acceptSelections(c.selections.selections.map(S.NotebookCellRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:b.editor.editor,visibleRanges:b.editor.editor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:b.editor.editor,selections:b.editor.editor.selections}))}$acceptDocumentPropertiesChanged(n,c){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",n.path,c);const b=this._getNotebookDocument(I.URI.revive(n));b.acceptDocumentPropertiesChanged(c),c.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:b.notebookDocument})}_createExtHostEditor(n,c,b){var w;const h=n.uri;let _=this._webviewComm.get(c);_||(_=new v(c,h,this._proxy,this._webviewInitData,n),this._webviewComm.set(c,_));const A=new l.ExtHostNotebookEditor(c,n.notebookDocument.viewType,this._proxy,n,b.visibleRanges.map(S.NotebookCellRange.to),b.selections.map(S.NotebookCellRange.to),typeof b.viewColumn=="number"?S.ViewColumn.to(b.viewColumn):void 0);(w=this._editors.get(c))===null||w===void 0||w.editor.dispose(),this._editors.set(c,{editor:A})}$acceptDocumentAndEditorsDelta(n){var c,b,w,h;let _=!1;if(n.removedDocuments)for(const L of n.removedDocuments){const W=I.URI.revive(L),j=this._documents.get(W);j&&(j.dispose(),this._documents.delete(W),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:j.notebookDocument.cells.map(K=>K.document.uri)}),this._onDidCloseNotebookDocument.fire(j.notebookDocument));for(const K of this._editors.values())K.editor.notebookData.uri.toString()===W.toString()&&(K.editor.dispose(),this._editors.delete(K.editor.id),_=!0)}if(n.addedDocuments){const L=[];for(const W of n.addedDocuments){const j=I.URI.revive(W.uri),K=W.viewType;if(this._documents.has(j))throw new Error(`adding EXISTING notebook ${j}`);const H=this,$=new f.ExtHostNotebookDocument(this._proxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(M){H._onDidChangeNotebookCells.fire(M)},emitCellOutputsChange(M){H._onDidChangeCellOutputs.fire(M)},emitCellMetadataChange(M){H._onDidChangeCellMetadata.fire(M)}},K,W.metadata?S.NotebookDocumentMetadata.to(W.metadata):new i.NotebookDocumentMetadata,j);$.acceptModelChanged({versionId:W.versionId,rawEvents:[{kind:k.NotebookCellsChangeType.Initialize,changes:[[0,0,W.cells]]}]},!1),L.push(...W.cells.map(M=>f.ExtHostCell.asModelAddData($.notebookDocument,M))),(c=this._documents.get(j))===null||c===void 0||c.dispose(),this._documents.set(j,$),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:L}),this._onDidOpenNotebookDocument.fire($.notebookDocument)}}if(n.addedEditors)for(const L of n.addedEditors){if(this._editors.has(L.id))return;const W=I.URI.revive(L.documentUri),j=this._documents.get(W);j&&(this._createExtHostEditor(j,L.id,L),_=!0)}const A=[];if(n.removedEditors)for(const L of n.removedEditors){const W=this._editors.get(L);W&&(_=!0,this._editors.delete(L),((b=this._activeNotebookEditor)===null||b===void 0?void 0:b.id)===W.editor.id&&(this._activeNotebookEditor=void 0),A.push(W))}if(_&&A.forEach(L=>{L.editor.dispose()}),n.visibleEditors){this._visibleNotebookEditors=n.visibleEditors.map(W=>this._editors.get(W).editor).filter(W=>!!W);const L=new Set;this._visibleNotebookEditors.forEach(W=>L.add(W.id));for(const W of this._editors.values()){const j=L.has(W.editor.id);W.editor._acceptVisibility(j)}this._visibleNotebookEditors=[...this._editors.values()].map(W=>W.editor).filter(W=>W.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}n.newActiveEditor===null?this._activeNotebookEditor=void 0:n.newActiveEditor&&(this._activeNotebookEditor=(w=this._editors.get(n.newActiveEditor))===null||w===void 0?void 0:w.editor),n.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((h=this._activeNotebookEditor)===null||h===void 0?void 0:h.editor)}createNotebookCellStatusBarItemInternal(n,c,b){const w=new r(this._proxy,this._commandsConverter,n,c,b),h=k.CellUri.parse(n.document.uri);if(h){const _=this._documents.get(h.notebook);if(_){const A=_.getCell(h.handle);A&&D.Event.once(A.onDidDispose)(()=>w.dispose())}}return w}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class r extends R.Disposable{constructor(n,c,b,w,h){super();this._proxy=n,this._commands=c,this._cell=b,this._priority=h,this._id=r.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new R.DisposableStore),this._alignment=w!=null?w:i.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=s(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(n){this._alignment=n,this.update()}get priority(){return this._priority}set priority(n){this._priority=n,this.update()}get text(){return this._text}set text(n){this._text=n,this.update()}get tooltip(){return this._tooltip}set tooltip(n){this._tooltip=n,this.update()}get command(){var n;return(n=this._command)===null||n===void 0?void 0:n.fromApi}set command(n){var c;((c=this._command)===null||c===void 0?void 0:c.fromApi)!==n&&(this._internalCommandRegistration.clear(),typeof n=="string"?this._command={fromApi:n,internal:this._commands.toInternal({title:"",command:n},this._internalCommandRegistration)}:n?this._command={fromApi:n,internal:this._commands.toInternal(n,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(n){this._accessibilityInformation=n,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var n;if(!this._isDisposed){const c={alignment:this.alignment===i.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(n=this._command)===null||n===void 0?void 0:n.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,c)}}}e.NotebookCellStatusBarItemInternal=r,r.NEXT_ID=0;function s(a){return Object.freeze({cell:a.cell,get alignment(){return a.alignment},set alignment(n){a.alignment=n},get priority(){return a.priority},set priority(n){a.priority=n},get text(){return a.text},set text(n){a.text=n},get tooltip(){return a.tooltip},set tooltip(n){a.tooltip=n},get command(){return a.command},set command(n){a.command=n},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(n){a.accessibilityInformation=n},show(){a.show()},hide(){a.hide()},dispose(){a.dispose()}})}}),define(ge[64],pe([0,1,5,3,6,26,4,14]),function(Z,e,p,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends R.Disposable{constructor(l,m,y,g){super();this._onDidAppend=this._register(new D.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=g,this._id=g.$register(this.name,m,y),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?I.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(m=>this._proxy.$clear(m,l))}show(l,m){this.validate(),this._id.then(y=>this._proxy.$reveal(y,!!(typeof l=="boolean"?l:m)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class i extends S{constructor(l,m){super(l,!1,void 0,m)}append(l){super.append(l),this._id.then(m=>this._proxy.$append(m,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=i;class T extends S{constructor(l,m,y){super(l,!0,m,y)}append(l){throw new Error("Not supported")}}class k{constructor(l,m){this.name=l,this._channel=m}append(l){this._channel.then(m=>m.append(l))}appendLine(l){this._channel.then(m=>m.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,m){this._channel.then(y=>y.show(l,m))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=k;let E=class{constructor(l){this._proxy=l.getProxy(p.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new i(l,this._proxy)}createOutputChannelFromLogFile(l,m){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!m)throw new Error("illegal argument `file`. must not be falsy");return new T(l,m,this._proxy)}};E=je([Ue(0,P.IExtHostRpcService)],E),e.ExtHostOutputService=E,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(ge[241],pe([0,1,19,21,3,6,5,2,8,18,12]),function(Z,e,p,D,R,I,C,P,S,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function k(E,f,l){const m=E.getProxy(C.MainContext.MainThreadQuickOpen);class y{constructor(s,a){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=a}showQuickPick(s,a,n,c=D.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(s),w=++this._instances,h=m.$show(w,{placeHolder:n&&n.placeHolder,matchOnDescription:n&&n.matchOnDescription,matchOnDetail:n&&n.matchOnDetail,ignoreFocusLost:n&&n.ignoreFocusOut,canPickMany:n&&n.canPickMany},c),_={},A=h.then(()=>_);return Promise.race([A,b]).then(L=>{if(L!==_)return b.then(W=>{const j=[];for(let K=0;K<W.length;K++){const H=W[K];let $,M,U,F,N;typeof H=="string"?$=H:($=H.label,M=H.description,U=H.detail,F=H.picked,N=H.alwaysShow),j.push({label:$,description:M,handle:K,detail:U,picked:F,alwaysShow:N})}return n&&typeof n.onDidSelectItem=="function"&&(this._onDidSelectItem=K=>{n.onDidSelectItem(W[K])}),m.$setItems(w,j),h.then(K=>{if(typeof K=="number")return W[K];if(Array.isArray(K))return K.map(H=>W[H])})})}).then(void 0,L=>{if(!(0,i.isPromiseCanceledError)(L))return m.$setError(w,L),Promise.reject(L)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,a=D.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,m.$input(s,typeof this._validateInput=="function",a).then(void 0,n=>{if(!(0,i.isPromiseCanceledError)(n))return Promise.reject(n)})}$validateInput(s){return this._validateInput?(0,p.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,a=D.CancellationToken.None){const n=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!!n){const c=await this._workspace.getWorkspaceFolders2();if(!!c)return c.find(b=>b.uri.toString()===n.uri.toString())}}createQuickPick(s,a){const n=new o(s,a,()=>this._sessions.delete(n._id));return this._sessions.set(n._id,n),n}createInputBox(s){const a=new t(s,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(s,a){const n=this._sessions.get(s);n&&n._fireDidChangeValue(a)}$onDidAccept(s){const a=this._sessions.get(s);a&&a._fireDidAccept()}$onDidChangeActive(s,a){const n=this._sessions.get(s);n instanceof o&&n._fireDidChangeActive(a)}$onDidChangeSelection(s,a){const n=this._sessions.get(s);n instanceof o&&n._fireDidChangeSelection(a)}$onDidTriggerButton(s,a){const n=this._sessions.get(s);n&&n._fireDidTriggerButton(a)}$onDidHide(s){const a=this._sessions.get(s);a&&a._fireDidHide()}}class g{constructor(s,a){this._extensionId=s,this._onDidDispose=a,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new R.Emitter,this._onDidChangeValueEmitter=new R.Emitter,this._onDidTriggerButtonEmitter=new R.Emitter,this._onDidHideEmitter=new R.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((a,n)=>{const c=a===S.QuickInputButtons.Back?-1:n;this._handlesToButtons.set(c,a)}),this.update({buttons:s.map((a,n)=>({iconPath:v(a.iconPath),tooltip:a.tooltip,handle:a===S.QuickInputButtons.Back?-1:n}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const a=this._handlesToButtons.get(s);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),m.$dispose(this._id))}update(s){if(!this._disposed){for(const a of Object.keys(s)){const n=s[a];this._pendingUpdate[a]=n===void 0?null:n}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){m.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function v(r){if(r instanceof S.ThemeIcon)return{id:r.id};const s=u(r),a=d(r);return{dark:typeof s=="string"?P.URI.file(s):s,light:typeof a=="string"?P.URI.file(a):a}}function d(r){return typeof r=="object"&&"light"in r?r.light:r}function u(r){return typeof r=="object"&&"dark"in r?r.dark:r}class o extends g{constructor(s,a,n){super(s,n);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new R.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new R.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((a,n)=>{this._handlesToItems.set(n,a),this._itemsToHandles.set(a,n)}),this.update({items:s.map((a,n)=>({label:a.label,description:a.description,handle:n,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(s){const a=(0,T.coalesce)(s.map(n=>this._handlesToItems.get(n)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(s){const a=(0,T.coalesce)(s.map(n=>this._handlesToItems.get(n)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class t extends g{constructor(s,a){super(s,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s})}}return new y(f,l)}e.createExtHostQuickOpen=k}),define(ge[242],pe([0,1,2,3,54,6,19,5,12,95,13,29,41]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(a){if(a)return typeof a.iconPath=="string"?p.URI.file(a.iconPath):a.iconPath}function l(a,n){if(!a.iconPath&&!n.iconPath)return 0;if(a.iconPath){if(!n.iconPath)return 1}else return-1;const c=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath,b=typeof n.iconPath=="string"?n.iconPath:n.iconPath.fsPath;return(0,i.comparePaths)(c,b)}function m(a,n){let c=0;if(a.strikeThrough!==n.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==n.faded)return a.faded?1:-1;if(a.tooltip!==n.tooltip)return(a.tooltip||"").localeCompare(n.tooltip||"");if(c=l(a,n),c!==0)return c;if(a.light&&n.light)c=l(a.light,n.light);else{if(a.light)return 1;if(n.light)return-1}if(c!==0)return c;if(a.dark&&n.dark)c=l(a.dark,n.dark);else{if(a.dark)return 1;if(n.dark)return-1}return c}function y(a,n){if(a.command!==n.command)return a.command<n.command?-1:1;if(a.title!==n.title)return a.title<n.title?-1:1;if(a.tooltip!==n.tooltip){if(a.tooltip!==void 0&&n.tooltip!==void 0)return a.tooltip<n.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(n.tooltip!==void 0)return-1}if(a.arguments===n.arguments)return 0;if(a.arguments)if(n.arguments){if(a.arguments.length!==n.arguments.length)return a.arguments.length-n.arguments.length}else return 1;else return-1;for(let c=0;c<a.arguments.length;c++){const b=a.arguments[c],w=n.arguments[c];if(b!==w)return b<w?-1:1}return 0}function g(a,n){let c=(0,i.comparePaths)(a.resourceUri.fsPath,n.resourceUri.fsPath,!0);if(c!==0)return c;if(a.command&&n.command)c=y(a.command,n.command);else{if(a.command)return 1;if(n.command)return-1}if(c!==0)return c;if(a.decorations&&n.decorations)c=m(a.decorations,n.decorations);else{if(a.decorations)return 1;if(n.decorations)return-1}return c}function v(a,n){for(let c=0;c<a.length;c++)if(a[c]!==n[c])return!1;return!0}function d(a,n){return a.command===n.command&&a.title===n.title&&a.tooltip===n.tooltip&&(a.arguments&&n.arguments?v(a.arguments,n.arguments):a.arguments===n.arguments)}function u(a,n){return(0,S.equals)(a,n,d)}class o{constructor(n,c,b){this._extension=n,this._proxy=c,this._sourceControlHandle=b,this._value="",this._onDidChange=new D.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(n){this._proxy.$setInputBoxValue(this._sourceControlHandle,n),this.updateValue(n)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(n){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,n),this._placeholder=n}get validateInput(){return(0,E.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(n){if((0,E.checkProposedApiEnabled)(this._extension),n&&typeof n!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=n,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!n)}get visible(){return this._visible}set visible(n){n=!!n,this._visible!==n&&(this._visible=n,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,n))}$onInputBoxValueChange(n){this.updateValue(n)}updateValue(n){this._value=n,this._onDidChange.fire(n)}}e.ExtHostSCMInputBox=o;class t{constructor(n,c,b,w,h){this._proxy=n,this._commands=c,this._sourceControlHandle=b,this._id=w,this._label=h,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new D.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new D.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(n){this._label=n,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,n)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(n){this._hideWhenEmpty=n,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(n){this._resourceStates=[...n],this._onDidUpdateResourceStates.fire()}getResourceState(n){return this._resourceStatesMap.get(n)}$executeResourceCommand(n,c){const b=this._resourceStatesCommandsMap.get(n);return b?(0,C.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],c)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var n;const c=[...this._resourceStates].sort(g),w=(0,S.sortedDiff)(this._resourceSnapshot,c,g).map(A=>{const L=A.toInsert.map(W=>{const j=this._resourceHandlePool++;this._resourceStatesMap.set(j,W);const K=W.resourceUri,H=f(W.decorations),$=W.decorations&&f(W.decorations.light)||H,M=W.decorations&&f(W.decorations.dark)||H,U=[];let F;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const fe=new I.DisposableStore;F=this._commands.converter.toInternal(W.command,fe),this._resourceStatesDisposablesMap.set(j,fe)}else this._resourceStatesCommandsMap.set(j,W.command);$&&U.push($),M&&M.toString()!==($==null?void 0:$.toString())&&U.push(M);const N=W.decorations&&W.decorations.tooltip||"",O=W.decorations&&!!W.decorations.strikeThrough,V=W.decorations&&!!W.decorations.faded,q=W.contextValue||"";return{rawResource:[j,K,U,N,O,V,q,F],handle:j}});return{start:A.start,deleteCount:A.deleteCount,toInsert:L}}),h=w.map(({start:A,deleteCount:L,toInsert:W})=>[A,L,W.map(j=>j.rawResource)]),_=w.reverse();for(const{start:A,deleteCount:L,toInsert:W}of _){const j=W.map(H=>H.handle),K=this._handlesSnapshot.splice(A,L,...j);for(const H of K)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),(n=this._resourceStatesDisposablesMap.get(H))===null||n===void 0||n.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=c,h}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class r{constructor(n,c,b,w,h,_){this._proxy=c,this._commands=b,this._id=w,this._label=h,this._rootUri=_,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new I.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new D.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new o(n,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,w,h,_)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(n){this._count!==n&&(this._count=n,this._proxy.$updateSourceControl(this.handle,{count:n}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(n){this._quickDiffProvider=n,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!n})}get commitTemplate(){return this._commitTemplate}set commitTemplate(n){n!==this._commitTemplate&&(this._commitTemplate=n,this._proxy.$updateSourceControl(this.handle,{commitTemplate:n}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(n){this._acceptInputDisposables.value=new I.DisposableStore,this._acceptInputCommand=n;const c=this._commands.converter.toInternal(n,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:c})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(n){if(!(this._statusBarCommands&&n&&u(this._statusBarCommands,n))){this._statusBarDisposables.value=new I.DisposableStore,this._statusBarCommands=n;const c=(n||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:c})}}get selected(){return this._selected}createResourceGroup(n,c){const b=new t(this._proxy,this._commands,this.handle,n,c),w=D.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,w),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const n=[],c=[];for(const[b,w]of this.createdResourceGroups){w.dispose();const h=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});D.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),h.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),n.push([b.handle,b.id,b.label,b.features]);const _=b._takeResourceStateSnapshot();_.length>0&&c.push([b.handle,_]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,n,c),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const n=[];this.updatedResourceGroups.forEach(c=>{const b=c._takeResourceStateSnapshot();b.length!==0&&n.push([c.handle,b])}),n.length>0&&this._proxy.$spliceResourceStates(this.handle,n),this.updatedResourceGroups.clear()}getResourceGroup(n){return this._groups.get(n)}setSelectionState(n){this._selected=n,this._onDidChangeSelection.fire(n)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(n=>n.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,je([(0,R.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),je([(0,R.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let s=class An{constructor(n,c,b){this._commands=c,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new D.Emitter,this._proxy=n.getProxy(P.MainContext.MainThreadSCM),this._telemetry=n.getProxy(P.MainContext.MainThreadTelemetry),c.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===3){const h=this._sourceControls.get(w.sourceControlHandle);if(!h)return w;const _=h.getResourceGroup(w.groupHandle);return _?_.getResourceState(w.handle):w}else if(w&&w.$mid===4){const h=this._sourceControls.get(w.sourceControlHandle);return h?h.getResourceGroup(w.groupHandle):w}else if(w&&w.$mid===5){const h=this._sourceControls.get(w.handle);return h||w}return w}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(n,c,b,w){this.logService.trace("ExtHostSCM#createSourceControl",n.identifier.value,c,b,w),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:n.identifier.value});const h=An._handlePool++,_=new r(n,this._proxy,this._commands,c,b,w);this._sourceControls.set(h,_);const A=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(n.identifier))||[];return A.push(_),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(n.identifier),A),_}getLastInputBox(n){this.logService.trace("ExtHostSCM#getLastInputBox",n.identifier.value);const c=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(n.identifier)),b=c&&c[c.length-1];return b&&b.inputBox}$provideOriginalResource(n,c,b){const w=p.URI.revive(c);this.logService.trace("ExtHostSCM#$provideOriginalResource",n,w.toString());const h=this._sourceControls.get(n);return!h||!h.quickDiffProvider||!h.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>h.quickDiffProvider.provideOriginalResource(w,b)).then(_=>_||null)}$onInputBoxValueChange(n,c){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",n);const b=this._sourceControls.get(n);return b&&b.inputBox.$onInputBoxValueChange(c),Promise.resolve(void 0)}$executeResourceCommand(n,c,b,w){this.logService.trace("ExtHostSCM#$executeResourceCommand",n,c,b);const h=this._sourceControls.get(n);if(!h)return Promise.resolve(void 0);const _=h.getResourceGroup(c);return _?_.$executeResourceCommand(b,w):Promise.resolve(void 0)}$validateInput(n,c,b){this.logService.trace("ExtHostSCM#$validateInput",n);const w=this._sourceControls.get(n);return!w||!w.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>w.inputBox.validateInput(c,b)).then(h=>h?Promise.resolve([h.message,h.type]):Promise.resolve(void 0))}$setSelectedSourceControl(n){var c,b;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",n),n!==void 0&&((c=this._sourceControls.get(n))===null||c===void 0||c.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((b=this._sourceControls.get(this._selectedSourceControlHandle))===null||b===void 0||b.setSelectionState(!1)),this._selectedSourceControlHandle=n,Promise.resolve(void 0)}};s._handlePool=0,s=je([Ue(2,T.ILogService)],s),e.ExtHostSCM=s});var tt=this&&this.__classPrivateFieldSet||function(Z,e,p){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,p),p},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[243],pe([0,1,8,5,161,6]),function(Z,e,p,D,R,I){"use strict";var C,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class S{constructor(E,f,l,m,y=p.StatusBarAlignment.Left,g,v){C.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new I.DisposableStore,tt(this,C,E),tt(this,P,f),this._id=S.ID_GEN++,this._statusId=l,this._statusName=m,this._alignment=y,this._priority=g,this._accessibilityInformation=v}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var E;return(E=this._command)===null||E===void 0?void 0:E.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(E){this._text=E,this.update()}set tooltip(E){this._tooltip=E,this.update()}set color(E){this._color=E,this.update()}set backgroundColor(E){E&&!S.ALLOWED_BACKGROUND_COLORS.has(E.id)&&(E=void 0),this._backgroundColor=E,this.update()}set command(E){var f;((f=this._command)===null||f===void 0?void 0:f.fromApi)!==E&&(this._internalCommandRegistration.clear(),typeof E=="string"?this._command={fromApi:E,internal:$e(this,P).toInternal({title:"",command:E},this._internalCommandRegistration)}:E?this._command={fromApi:E,internal:$e(this,P).toInternal(E,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(E){this._accessibilityInformation=E,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,C).$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var E;this._timeoutHandle=void 0;let f=this._color;this._backgroundColor&&(f=S.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),$e(this,C).$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(E=this._command)===null||E===void 0?void 0:E.internal,f,this._backgroundColor,this._alignment===p.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=S,C=new WeakMap,P=new WeakMap,S.ID_GEN=0,S.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new p.ThemeColor("statusBarItem.errorForeground")]]);class i{constructor(E){this._messages=[],this._item=E.createStatusBarEntry("status.extensionMessage",(0,R.localize)(0,null),p.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(E){const f={message:E};return this._messages.unshift(f),this._update(),new p.Disposable(()=>{const l=this._messages.indexOf(f);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(E,f){this._proxy=E.getProxy(D.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new i(this)}createStatusBarEntry(E,f,l,m,y){return new S(this._proxy,this._commands,E,f,l,m,y)}setStatusBarMessage(E,f){const l=this._statusMessage.setMessage(E);let m;return typeof f=="number"?m=setTimeout(()=>l.dispose(),f):typeof f!="undefined"&&f.then(()=>l.dispose(),()=>l.dispose()),new p.Disposable(()=>{l.dispose(),clearTimeout(m)})}}e.ExtHostStatusBar=T}),define(ge[88],pe([0,1,5,3,4]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class I{constructor(P){this._onDidChangeStorage=new D.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(p.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,S){this._proxy.$registerExtensionStorageKeysToSync(P,S)}getValue(P,S,i){return this._proxy.$getValue(P,S).then(T=>T||i)}setValue(P,S,i){return this._proxy.$setValue(P,S,i)}$acceptValue(P,S,i){this._onDidChangeStorage.fire({shared:P,key:S,value:i})}}e.ExtHostStorage=I,e.IExtHostStorage=(0,R.createDecorator)("IExtHostStorage")}),define(ge[89],pe([0,1,4,27,13,87,2]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,p.createDecorator)("IExtensionStoragePaths");let P=class{constructor(i,T,k){var E;this._logService=T,this._extHostFileSystem=k,this._workspace=(E=i.workspace)!==null&&E!==void 0?E:void 0,this._environment=i.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var i;if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,k=C.URI.joinPath(this._environment.workspaceStorageHome,T);try{return await this._extHostFileSystem.value.stat(k),this._logService.trace("[ExtHostStorage] storage dir already exists",k),k}catch(E){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",k),await this._extHostFileSystem.value.createDirectory(k),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(i=C.URI.revive(this._workspace.configuration))===null||i===void 0?void 0:i.toString(),name:this._workspace.name},void 0,2))),k}catch(E){this._logService.error("[ExtHostStorage]",E);return}}workspaceValue(i){if(this._value)return C.URI.joinPath(this._value,i.identifier.value)}globalValue(i){return C.URI.joinPath(this._environment.globalStorageHome,i.identifier.value.toLowerCase())}};P=je([Ue(0,D.IExtHostInitDataService),Ue(1,R.ILogService),Ue(2,I.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ge[34],pe([0,1,3,5,4,2,14,6,8,162,18,206,21,28,187]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,R.createDecorator)("IExtHostTerminalService");class m{constructor(t,r,s,a){this._proxy=t,this._id=r,this._creationOptions=s,this._name=a,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(c=>this._pidPromiseComplete=c);const n=this;this.value={get name(){return n._name||""},get processId(){return n._pidPromise},get creationOptions(){return n._creationOptions},get exitStatus(){return n._exitStatus},sendText(c,b=!0){n._checkDisposed(),n._proxy.$sendText(n._id,c,b)},show(c){n._checkDisposed(),n._proxy.$show(n._id,c)},hide(){n._checkDisposed(),n._proxy.$hide(n._id)},dispose(){n._disposed||(n._disposed=!0,n._proxy.$dispose(n._id))},get dimensions(){if(!(n._cols===void 0||n._rows===void 0))return{columns:n._cols,rows:n._rows}}}}async create(t,r,s,a,n,c,b,w,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:r,cwd:s,env:a,waitOnExit:n,strictEnv:c,hideFromUser:b,isFeatureTerminal:w,isExtensionOwnedTerminal:h})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,r){return t===this._cols&&r===this._rows||t===0||r===0?!1:(this._cols=t,this._rows=r,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=m;class y{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new p.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new p.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new p.Emitter,this._onProcessTitleChanged=new p.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new p.Emitter,this._onProcessShellTypeChanged=new p.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,r){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:r})}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=y;let g=1,v=class extends P.Disposable{constructor(t,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new p.Emitter,this._onDidOpenTerminal=new p.Emitter,this._onDidChangeActiveTerminal=new p.Emitter,this._onDidChangeTerminalDimensions=new p.Emitter,this._proxy=r.getProxy(D.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new p.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,a]of this._terminalProcesses)a.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const r=new m(this._proxy,(0,f.generateUuid)(),t,t.name),s=new y(t.pty);return r.createExtensionTerminal().then(a=>{const n=this._setupExtHostProcessListeners(a,s);this._terminalProcessDisposables[a]=n}),this._terminals.push(r),r.value}attachPtyToTerminal(t,r){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const a=new y(r),n=this._setupExtHostProcessListeners(t,a);this._terminalProcessDisposables[t]=n}async $acceptActiveTerminalChanged(t){const r=this._activeTerminal;if(t===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,r){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:r})}async $acceptTerminalDimensions(t,r,s){const a=this._getTerminalById(t);a&&a.setDimensions(r,s)&&this._onDidChangeTerminalDimensions.fire({terminal:a.value,dimensions:a.value.dimensions})}async $acceptTerminalMaximumDimensions(t,r,s){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(r,s)}async $acceptTerminalTitleChange(t,r){const s=this._getTerminalById(t);s&&(s.name=r)}async $acceptTerminalClosed(t,r){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const a=this._terminals.splice(s,1)[0];a.setExitCode(r),this._onDidCloseTerminal.fire(a.value)}}$acceptTerminalOpened(t,r,s,a){if(r){const b=this._getTerminalObjectIndexById(this._terminals,r);if(b!==null){this._terminals[b]._id=t,this._onDidOpenTerminal.fire(this.terminals[b]),this._terminals[b].isOpen=!0;return}}const n={name:a.name,shellPath:a.executable,shellArgs:a.args,cwd:typeof a.cwd=="string"?a.cwd:I.URI.revive(a.cwd),env:a.env,hideFromUser:a.hideFromUser},c=new m(this._proxy,t,n,s);this._terminals.push(c),this._onDidOpenTerminal.fire(c.value),c.isOpen=!0}async $acceptTerminalProcessId(t,r){const s=this._getTerminalById(t);s&&s._setProcessId(r)}async $startExtensionTerminal(t,r){const s=this._getTerminalById(t);if(!s)return{message:(0,i.localize)(0,null,t)};s.isOpen||await new Promise(n=>{const c=this.onDidOpenTerminal(async b=>{b===s.value&&(c.dispose(),n())})});const a=this._terminalProcesses.get(t);a?a.startSendingEvents(r):this._extensionTerminalAwaitingStart[t]={initialDimensions:r}}_setupExtHostProcessListeners(t,r){const s=new P.DisposableStore;s.add(r.onProcessReady(n=>this._proxy.$sendProcessReady(t,n.pid,n.cwd))),s.add(r.onProcessTitleChanged(n=>this._proxy.$sendProcessTitle(t,n))),this._bufferer.startBuffering(t,r.onProcessData),s.add(r.onProcessExit(n=>this._onProcessExit(t,n))),r.onProcessOverrideDimensions&&s.add(r.onProcessOverrideDimensions(n=>this._proxy.$sendOverrideDimensions(t,n))),this._terminalProcesses.set(t,r);const a=this._extensionTerminalAwaitingStart[t];return a&&r instanceof y&&(r.startSendingEvents(a.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,r){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(r)}$acceptProcessInput(t,r){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(r)}$acceptProcessResize(t,r,s){var a;try{(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(r,s)}catch(n){if(n.code!=="EPIPE"&&n.code!=="ERR_IPC_CHANNEL_CLOSED")throw n}}$acceptProcessShutdown(t,r){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(r)}$acceptProcessRequestInitialCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,r){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const a=this._terminalLinkCancellationSource.get(t);a&&a.dispose(!0);const n=new E.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,n);const c=[],b={terminal:s.value,line:r},w=[];for(const A of this._linkProviders)w.push(new Promise(async L=>{n.token.onCancellationRequested(()=>L({provider:A,links:[]}));const W=await A.provideTerminalLinks(b,n.token)||[];n.token.isCancellationRequested||L({provider:A,links:W})}));const h=await Promise.all(w);if(n.token.isCancellationRequested)return[];const _=new Map;for(const A of h)A&&A.links.length>0&&c.push(...A.links.map(L=>{const W={id:g++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return _.set(W.id,{provider:A.provider,link:L}),W}));return this._terminalLinkCache.set(t,_),c}$activateLink(t,r){var s;const a=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(r);!a||a.provider.handleTerminalLink(a.link)}_onProcessExit(t,r){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,r)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,r){const s=this._getTerminalObjectIndexById(t,r);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,r){let s=null;return t.some((a,n)=>a._id===r?(s=n,!0):!1),s}getEnvironmentVariableCollection(t){let r=this._environmentVariableCollections.get(t.identifier.value);return r||(r=new d,this._setEnvironmentVariableCollection(t.identifier.value,r)),r}_syncEnvironmentVariableCollection(t,r){const s=(0,k.serializeEnvironmentVariableCollection)(r.map);this._proxy.$setEnvironmentVariableCollection(t,r.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(r=>{const s=r[0],a=new d(r[1]);this._setEnvironmentVariableCollection(s,a)})}_setEnvironmentVariableCollection(t,r){this._environmentVariableCollections.set(t,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,r)})}};v=je([Ue(1,C.IExtHostRpcService)],v),e.BaseExtHostTerminalService=v;class d{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new p.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,r){this._setIfDiffers(t,{value:r,type:S.EnvironmentVariableMutatorType.Replace})}append(t,r){this._setIfDiffers(t,{value:r,type:S.EnvironmentVariableMutatorType.Append})}prepend(t,r){this._setIfDiffers(t,{value:r,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,r){const s=this.map.get(t);(!s||s.value!==r.value||s.type!==r.type)&&(this.map.set(t,r),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,r){this.map.forEach((s,a)=>t.call(r,a,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let u=class extends v{constructor(t){super(!1,t)}createTerminal(t,r,s){throw new T.NotSupportedError}createTerminalFromOptions(t){throw new T.NotSupportedError}getDefaultShell(t,r){return""}getDefaultShellArgs(t,r){throw new T.NotSupportedError}$getAvailableShells(){throw new T.NotSupportedError}async $getDefaultShellAndArgs(t){throw new T.NotSupportedError}$acceptWorkspacePermissionsChanged(t){}};u=je([Ue(0,C.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(ge[244],pe([0,1,3,12,5,120,20,8]),function(Z,e,p,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(T,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(R.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(E=>this._onDidChangeVisibleTextEditors.fire(E)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(E=>this._onDidChangeActiveTextEditor.fire(E))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const k=this._extHostDocumentsAndEditors.allEditors();return T?k:k.map(E=>E.value)}async showTextDocument(T,k,E){let f;typeof k=="number"?f={position:C.ViewColumn.from(k),preserveFocus:E}:typeof k=="object"?f={position:C.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?C.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:f={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(T.uri,f),m=l&&this._extHostDocumentsAndEditors.getEditor(l);if(m)return m.value;throw l?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T){return new I.TextEditorDecorationType(this._proxy,T).value}$acceptEditorPropertiesChanged(T,k){const E=this._extHostDocumentsAndEditors.getEditor(T);if(!E)throw new Error("unknown text editor");if(k.options&&E._acceptOptions(k.options),k.selections){const f=k.selections.selections.map(C.Selection.to);E._acceptSelections(f)}if(k.visibleRanges){const f=D.coalesce(k.visibleRanges.map(C.Range.to));E._acceptVisibleRanges(f)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:E.value,options:Object.assign(Object.assign({},k.options),{lineNumbers:C.TextEditorLineNumbersStyle.to(k.options.lineNumbers)})}),k.selections){const f=P.TextEditorSelectionChangeKind.fromValue(k.selections.source),l=k.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:E.value,selections:l,kind:f})}if(k.visibleRanges){const f=D.coalesce(k.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:E.value,visibleRanges:f})}}$acceptEditorPositionData(T){for(const k in T){const E=this._extHostDocumentsAndEditors.getEditor(k);if(!E)throw new Error("Unknown text editor");const f=C.ViewColumn.to(T[k]);E.value.viewColumn!==f&&(E._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:E.value,viewColumn:f}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=S});var dn=this&&this.__rest||function(Z,e){var p={};for(var D in Z)Object.prototype.hasOwnProperty.call(Z,D)&&e.indexOf(D)<0&&(p[D]=Z[D]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,D=Object.getOwnPropertySymbols(Z);R<D.length;R++)e.indexOf(D[R])<0&&Object.prototype.propertyIsEnumerable.call(Z,D[R])&&(p[D[R]]=Z[D[R]]);return p};define(ge[245],pe([0,1,2,4,5,6,8]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,D.createDecorator)("IExtHostTimeline");class P{constructor(T,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(R.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:E=>{var f,l;if(E&&E.$mid===11){const m=E.uri===void 0?void 0:p.URI.revive(E.uri);return(l=(f=this._itemsBySourceAndUriMap.get(E.source))===null||f===void 0?void 0:f.get(S(m)))===null||l===void 0?void 0:l.get(E.handle)}return E}})}async $getTimeline(T,k,E,f,l){const m=this._providers.get(T);return m==null?void 0:m.provideTimeline(p.URI.revive(k),E,f,l)}registerTimelineProvider(T,k,E,f){const l=new I.DisposableStore,m=this.convertTimelineItem(k.id,f,l).bind(this);let y;k.onDidChange&&(y=k.onDidChange(v=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},v),{id:k.id})),this));const g=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},k),{scheme:T,onDidChange:void 0,async provideTimeline(v,d,u,o){var t;(o==null?void 0:o.resetCache)&&(l.clear(),(t=g.get(k.id))===null||t===void 0||t.clear());const r=await k.provideTimeline(v,d,u);if(r!=null){const s=m(v,o);return Object.assign(Object.assign({},r),{source:k.id,items:r.items.map(s)})}},dispose(){var v;for(const d of g.values())(v=d.get(k.id))===null||v===void 0||v.clear();y==null||y.dispose(),l.dispose()}}))}convertTimelineItem(T,k,E){return(f,l)=>{let m;if(l==null?void 0:l.cacheResults){let y=this._itemsBySourceAndUriMap.get(T);y===void 0&&(y=new Map,this._itemsBySourceAndUriMap.set(T,y));const g=S(f);m=y.get(g),m===void 0&&(m=new Map,y.set(g,m))}return y=>{var g,v;const{iconPath:d}=y,u=dn(y,["iconPath"]),o=`${T}|${(g=y.id)!==null&&g!==void 0?g:y.timestamp}`;m==null||m.set(o,y);let t,r,s;return y.iconPath&&(d instanceof C.ThemeIcon?s={id:d.id}:p.URI.isUri(d)?(t=d,r=d):{light:t,dark:r}=d),Object.assign(Object.assign({},u),{id:(v=u.id)!==null&&v!==void 0?v:void 0,handle:o,source:T,command:y.command?k.toInternal(y.command,E):void 0,icon:t,iconDark:r,themeIcon:s,accessibilityInformation:y.accessibilityInformation})}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,I.toDisposable)(()=>{var E;for(const f of this._itemsBySourceAndUriMap.values())(E=f.get(T.id))===null||E===void 0||E.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=P;function S(i){return i==null?void 0:i.toString()}}),define(ge[246],pe([0,1,6,11,2,5]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this._openers=new Map,this._proxy=S.getProxy(I.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,i,T,k){if(this._openers.has(i))throw new Error(`Opener with id '${i}' already registered`);const E=k.schemes.find(f=>!C.supportedSchemes.has(f));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this._openers.set(i,T),this._proxy.$registerUriOpener(i,k.schemes,S,k.label),(0,p.toDisposable)(()=>{this._openers.delete(i),this._proxy.$unregisterUriOpener(i)})}async $canOpenUri(S,i,T){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener with id: ${S}`);const E=R.URI.revive(i);return k.canOpenExternalUri(E,T)}async $openUri(S,i,T){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener id: '${S}'`);return k.openExternalUri(R.URI.revive(i.resolvedUri),{sourceUri:R.URI.revive(i.sourceUri)},T)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([D.Schemas.http,D.Schemas.https])}),define(ge[247],pe([0,1,5,2,6,18,29]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(i){this.handles=new Set,this.handlers=new Map,this._proxy=i.getProxy(p.MainContext.MainThreadUrls)}registerUriHandler(i,T){if(this.handles.has(C.ExtensionIdentifier.toKey(i)))throw new Error(`Protocol handler already registered for extension ${i}`);const k=P.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(i)),this.handlers.set(k,T),this._proxy.$registerUriHandler(k,i),(0,R.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(i)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(i,T){const k=this.handlers.get(i);if(!k)return Promise.resolve(void 0);try{k.handleUri(D.URI.revive(T))}catch(E){(0,I.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(i){return D.URI.revive(await this._proxy.$createAppUri(i))}}e.ExtHostUrls=P,P.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Z,e,p){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,p),p},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[65],pe([0,1,3,2,84,5]),function(Z,e,p,D,R,I){"use strict";var C,P,S,i,T,k,E,f,l,m,y;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.ExtHostWebview=void 0;class g{constructor(s,a,n,c,b,w,h){C.set(this,void 0),P.set(this,void 0),S.set(this,void 0),i.set(this,void 0),T.set(this,void 0),k.set(this,void 0),E.set(this,""),f.set(this,void 0),l.set(this,!1),m.set(this,!1),this._onMessageEmitter=new p.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,y.set(this,new p.Emitter),this._onDidDispose=$e(this,y).event,tt(this,C,s),tt(this,P,a),tt(this,f,n),tt(this,i,c),tt(this,T,b),tt(this,k,w),tt(this,S,h)}dispose(){tt(this,l,!0),$e(this,y).fire(),$e(this,y).dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return tt(this,m,!0),(0,R.asWebviewUri)($e(this,i),$e(this,C),s)}get cspSource(){return $e(this,i).webviewCspSource.replace("{{uuid}}",$e(this,C))}get html(){return this.assertNotDisposed(),$e(this,E)}set html(s){this.assertNotDisposed(),$e(this,E)!==s&&(tt(this,E,s),!$e(this,m)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(tt(this,m,!0),$e(this,S).report("Webview vscode-resource: uris",$e(this,k),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,P).$setHtml($e(this,C),s))}get options(){return this.assertNotDisposed(),$e(this,f)}set options(s){this.assertNotDisposed(),$e(this,P).$setOptions($e(this,C),u($e(this,k),$e(this,T),s)),tt(this,f,s)}async postMessage(s){return $e(this,l)?!1:$e(this,P).$postMessage($e(this,C),s)}assertNotDisposed(){if($e(this,l))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,C=new WeakMap,P=new WeakMap,S=new WeakMap,i=new WeakMap,T=new WeakMap,k=new WeakMap,E=new WeakMap,f=new WeakMap,l=new WeakMap,m=new WeakMap,y=new WeakMap;class v{constructor(s,a,n,c,b){this.initData=a,this.workspace=n,this._logService=c,this._deprecationService=b,this._webviews=new Map,this._webviewProxy=s.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(s,a){const n=this.getWebview(s);n&&n._onMessageEmitter.fire(a)}$onMissingCsp(s,a){this._logService.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,a,n){const c=new g(s,this._webviewProxy,o(a),this.initData,this.workspace,n,this._deprecationService);return this._webviews.set(s,c),c._onDidDispose(()=>{this._webviews.delete(s)}),c}deleteWebview(s){this._webviews.delete(s)}getWebview(s){return this._webviews.get(s)}}e.ExtHostWebviews=v;function d(r){return{id:r.identifier,location:r.extensionLocation}}e.toExtensionData=d;function u(r,s,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||t(r,s)}}e.serializeWebviewOptions=u;function o(r){var s;return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,portMapping:r.portMapping,localResourceRoots:(s=r.localResourceRoots)===null||s===void 0?void 0:s.map(a=>D.URI.from(a))}}e.reviveOptions=o;function t(r,s){return[...((s==null?void 0:s.getWorkspaceFolders())||[]).map(a=>a.uri),r.extensionLocation]}}),define(ge[248],pe([0,1,21,73,6,11,24,2,20,65,115,5,8]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,t)}updateBackup(t){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class l{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,s){const a=this.key(t,r.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const n=new f(r,s);return this._documents.set(a,n),n}delete(t,r){const s=this.key(t,r.uri);this._documents.delete(s)}key(t,r){return`${t}@@@${r}`}}var m;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(m||(m={}));class y{constructor(){this._providers=new Map}addTextProvider(t,r,s){return this.add(0,t,r,s)}addCustomProvider(t,r,s){return this.add(1,t,r,s)}get(t){return this._providers.get(t)}add(t,r,s,a){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:s,provider:a}),new E.Disposable(()=>this._providers.delete(r))}}class g{constructor(t,r,s,a,n){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=a,this._extHostWebviewPanels=n,this._editorProviders=new y,this._documents=new l,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,s,a){const n=new R.DisposableStore;return v(s)?(n.add(this._editorProviders.addTextProvider(r,t,s)),this._proxy.$registerTextEditorProvider((0,i.toExtensionData)(t),r,a.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor})):(n.add(this._editorProviders.addCustomProvider(r,t,s)),this.supportEditing(s)&&n.add(s.onDidChangeCustomDocument(c=>{const b=this.getCustomDocumentEntry(r,c.document.uri);if(d(c)){const w=b.addEdit(c);this._proxy.$onDidEdit(c.document.uri,r,w,c.label)}else this._proxy.$onContentChange(c.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,i.toExtensionData)(t),r,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument)),E.Disposable.from(n,new E.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,s,a,n){var c;const b=this._editorProviders.get(r);if(!b)throw new Error(`No provider found for '${r}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${r}'`);const w=P.URI.revive(t),h=await b.provider.openCustomDocument(w,{backupId:s,untitledDocumentData:a==null?void 0:a.buffer},n);let _;return this.supportEditing(b.provider)&&this._extensionStoragePaths&&(_=(c=this._extensionStoragePaths.workspaceValue(b.extension))!==null&&c!==void 0?c:this._extensionStoragePaths.globalValue(b.extension)),this._documents.add(r,h,_),{editable:this.supportEditing(b.provider)}}async $disposeCustomDocument(t,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const a=P.URI.revive(t),{document:n}=this.getCustomDocumentEntry(r,a);this._documents.delete(r,n),n.dispose()}async $resolveWebviewEditor(t,r,s,a,n,c){const b=this._editorProviders.get(s);if(!b)throw new Error(`No provider found for '${s}'`);const w=S.ViewColumn.to(n),h=this._extHostWebview.createNewWebview(r,a.webviewOptions,b.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(r,s,a.title,w,a.panelOptions,h),A=P.URI.revive(t);switch(b.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,A);return b.provider.resolveCustomEditor(L,_,c)}case 0:{const L=this._extHostDocuments.getDocument(A);return b.provider.resolveCustomTextEditor(L,_,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,s){this.getCustomDocumentEntry(r,t).disposeEdits(s)}async $onMoveCustomEditor(t,r,s){const a=this._editorProviders.get(s);if(!a)throw new Error(`No provider found for '${s}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const n=this._extHostWebviewPanels.getWebviewPanel(t);if(!n)throw new Error("No webview found");const c=P.URI.revive(r),b=this._extHostDocuments.getDocument(c);await a.provider.moveCustomTextEditor(b,n,p.CancellationToken.None)}async $undo(t,r,s,a){return this.getCustomDocumentEntry(r,t).undo(s,a)}async $redo(t,r,s,a){return this.getCustomDocumentEntry(r,t).redo(s,a)}async $revert(t,r,s){const a=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(a.document,s),a.disposeBackup()}async $onSave(t,r,s){const a=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(a.document,s),a.disposeBackup()}async $onSaveAs(t,r,s,a){const n=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(n.document,P.URI.revive(s),a)}async $backup(t,r,s){const a=this.getCustomDocumentEntry(r,t),c=await this.getCustomEditorProvider(r).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},s);return a.updateBackup(c),c.id}getCustomDocumentEntry(t,r){const s=this._documents.get(t,P.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const r=this._editorProviders.get(t),s=r==null?void 0:r.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=g;function v(o){return typeof o.resolveCustomTextEditor=="function"}function d(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function u(o){const t=o.scheme===I.Schemas.file||o.scheme===I.Schemas.untitled?o.fsPath:o.toString();return(0,D.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Z,e,p){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,p),p},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[249],pe([0,1,3,6,2,28,20,65,5,8]),function(Z,e,p,D,R,I,C,P,S,i){"use strict";var T,k,E,f,l,m,y,g,v,d,u,o,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends D.Disposable{constructor(c,b,w,h,_,A,L){super();T.set(this,void 0),k.set(this,void 0),E.set(this,void 0),f.set(this,void 0),l.set(this,void 0),m.set(this,void 0),y.set(this,void 0),g.set(this,void 0),v.set(this,!0),d.set(this,!0),u.set(this,!1),o.set(this,this._register(new p.Emitter)),this.onDidDispose=$e(this,o).event,t.set(this,this._register(new p.Emitter)),this.onDidChangeViewState=$e(this,t).event,tt(this,T,c),tt(this,k,b),tt(this,E,w),tt(this,l,A),tt(this,g,_),tt(this,m,h),tt(this,f,L)}dispose(){$e(this,u)||(tt(this,u,!0),$e(this,o).fire(),$e(this,k).$disposeWebview($e(this,T)),$e(this,f).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,f)}get viewType(){return this.assertNotDisposed(),$e(this,E)}get title(){return this.assertNotDisposed(),$e(this,m)}set title(c){this.assertNotDisposed(),$e(this,m)!==c&&(tt(this,m,c),$e(this,k).$setTitle($e(this,T),c))}get iconPath(){return this.assertNotDisposed(),$e(this,y)}set iconPath(c){this.assertNotDisposed(),$e(this,y)!==c&&(tt(this,y,c),$e(this,k).$setIconPath($e(this,T),R.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return $e(this,l)}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,g)=="number"&&$e(this,g)<0))return $e(this,g)}get active(){return this.assertNotDisposed(),$e(this,d)}get visible(){return this.assertNotDisposed(),$e(this,v)}_updateViewState(c){$e(this,u)||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(tt(this,d,c.active),tt(this,v,c.visible),tt(this,g,c.viewColumn),$e(this,t).fire({webviewPanel:this}))}reveal(c,b){this.assertNotDisposed(),$e(this,k).$reveal($e(this,T),{viewColumn:c?C.ViewColumn.from(c):void 0,preserveFocus:!!b})}assertNotDisposed(){if($e(this,u))throw new Error("Webview is disposed")}}T=new WeakMap,k=new WeakMap,E=new WeakMap,f=new WeakMap,l=new WeakMap,m=new WeakMap,y=new WeakMap,g=new WeakMap,v=new WeakMap,d=new WeakMap,u=new WeakMap,o=new WeakMap,t=new WeakMap;class s{constructor(c,b,w){this.webviews=b,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,I.generateUuid)()}createWebviewPanel(c,b,w,h,_={}){const A=typeof h=="object"?h.viewColumn:h,L={viewColumn:C.ViewColumn.from(A),preserveFocus:typeof h=="object"&&!!h.preserveFocus},W=s.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(c),W,b,{title:w,panelOptions:a(_),webviewOptions:(0,P.serializeWebviewOptions)(c,this.workspace,_)},L);const j=this.webviews.createNewWebview(W,_,c);return this.createNewWebviewPanel(W,b,w,A,_,j)}$onDidChangeWebviewPanelViewStates(c){const b=Object.keys(c);b.sort((w,h)=>{const _=c[w],A=c[h];return _.active?1:A.active?-1:+_.visible-+A.visible});for(const w of b){const h=this.getWebviewPanel(w);if(!!h){const _=c[w];h._updateViewState({active:_.active,visible:_.visible,viewColumn:C.ViewColumn.to(_.position)})}}}async $onDidDisposeWebviewPanel(c){const b=this.getWebviewPanel(c);b==null||b.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,b,w){if(this._serializers.has(b))throw new Error(`Serializer for '${b}' already registered`);return this._serializers.set(b,{serializer:w,extension:c}),this._proxy.$registerSerializer(b),new i.Disposable(()=>{this._serializers.delete(b),this._proxy.$unregisterSerializer(b)})}async $deserializeWebviewPanel(c,b,w,h){const _=this._serializers.get(b);if(!_)throw new Error(`No serializer found for '${b}'`);const{serializer:A,extension:L}=_,W=this.webviews.createNewWebview(c,w.webviewOptions,L),j=this.createNewWebviewPanel(c,b,w.title,h,w.panelOptions,W);await A.deserializeWebviewPanel(j,w.state)}createNewWebviewPanel(c,b,w,h,_,A){const L=new r(c,this._proxy,b,w,h,_,A);return this._webviewPanels.set(c,L),L}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=s;function a(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Z,e,p){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,p),p},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[250],pe([0,1,3,6,65,5,8]),function(Z,e,p,D,R,I,C){"use strict";var P,S,i,T,k,E,f,l,m,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class g extends D.Disposable{constructor(u,o,t,r,s,a){super();P.set(this,void 0),S.set(this,void 0),i.set(this,void 0),T.set(this,void 0),k.set(this,!1),E.set(this,void 0),f.set(this,void 0),l.set(this,void 0),m.set(this,this._register(new p.Emitter)),this.onDidChangeVisibility=$e(this,m).event,y.set(this,this._register(new p.Emitter)),this.onDidDispose=$e(this,y).event,tt(this,i,t),tt(this,f,r),tt(this,P,u),tt(this,S,o),tt(this,T,s),tt(this,E,a)}dispose(){$e(this,k)||(tt(this,k,!0),$e(this,y).fire(),$e(this,T).dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,f)}set title(u){this.assertNotDisposed(),$e(this,f)!==u&&(tt(this,f,u),$e(this,S).$setWebviewViewTitle($e(this,P),u))}get description(){return this.assertNotDisposed(),$e(this,l)}set description(u){this.assertNotDisposed(),$e(this,l)!==u&&(tt(this,l,u),$e(this,S).$setWebviewViewDescription($e(this,P),u))}get visible(){return $e(this,E)}get webview(){return $e(this,T)}get viewType(){return $e(this,i)}_setVisible(u){u===$e(this,E)||$e(this,k)||(tt(this,E,u),$e(this,m).fire())}show(u){this.assertNotDisposed(),$e(this,S).$show($e(this,P),!!u)}assertNotDisposed(){if($e(this,k))throw new Error("Webview is disposed")}}P=new WeakMap,S=new WeakMap,i=new WeakMap,T=new WeakMap,k=new WeakMap,E=new WeakMap,f=new WeakMap,l=new WeakMap,m=new WeakMap,y=new WeakMap;class v{constructor(u,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,o,t,r){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,R.toExtensionData)(u),o,r),new C.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(u,o,t,r,s){const a=this._viewProviders.get(o);if(!a)throw new Error(`No view provider found for '${o}'`);const{provider:n,extension:c}=a,b=this._extHostWebview.createNewWebview(u,{},c),w=new g(u,this._proxy,o,t,b,!0);this._webviewViews.set(u,w),await n.resolveWebviewView(w,{state:r},s)}async $onDidChangeWebviewViewVisibility(u,o){this.getWebviewView(u)._setVisible(o)}async $disposeWebviewView(u){const o=this.getWebviewView(u);this._webviewViews.delete(u),o.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const o=this._webviewViews.get(u);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=v}),define(ge[123],pe([0,1,3,5,2,11,9,4,14]),function(Z,e,p,D,R,I,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let i=class Rn{constructor(k){this._onDidChangeWindowState=new p.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Rn.InitialState,this._proxy=k.getProxy(D.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:k}),this._onDidChangeWindowState.fire(this._state))}openUri(k,E){let f;if(typeof k=="string"){f=k;try{k=R.URI.parse(k)}catch(l){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,C.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,f,E)}async asExternalUri(k,E){if((0,C.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([I.Schemas.http,I.Schemas.https]).has(k.scheme))return Promise.reject(`Invalid scheme '${k.scheme}'`);const f=await this._proxy.$asExternalUri(k,E);return R.URI.from(f)}};i.InitialState={focused:!0},i=je([Ue(0,S.IExtHostRpcService)],i),e.ExtHostWindow=i,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ge[251],pe([0,1,7,48,28,51,6,5,2,14]),function(Z,e,p,D,R,I,C,P,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=class extends C.Disposable{constructor(E,f){super();const l=E.getProxy(P.MainContext.MainThreadDownloadService);f.registerCommand(!1,"_workbench.downloadResource",async m=>{const y=S.URI.file((0,p.join)((0,D.tmpdir)(),(0,R.generateUuid)()));return await l.$download(m,y),y})}};T=je([Ue(0,i.IExtHostRpcService),Ue(1,I.IExtHostCommands)],T),e.ExtHostDownloadService=T}),define(ge[252],pe([0,1,2,7,144,25,37,64,27,14,6,13,108,44]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class l{constructor(v,d){this.file=d,this.appender=(0,E.createRotatingLogger)(v,d,30*f.ByteSize.MB,1),this.appender.clearFormatters()}append(v){this.appender.critical(v)}flush(){this.appender.flush()}}class m extends P.AbstractExtHostOutputChannel{constructor(v,d,u){super(v,!1,p.URI.file(d.file),u);this._appender=d}append(v){super.append(v),this._appender.append(v),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(v,d){this._appender.flush(),super.show(v,d)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=m;let y=class extends P.ExtHostOutputService{constructor(v,d,u){super(v);this.logService=d,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new T.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(v){if(v){const d=this._channels.get(v);d&&(this._visibleChannelDisposable.value=d.onDidAppend(()=>d.update()))}}createOutputChannel(v){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const d=this._doCreateOutChannel(v);return d.then(u=>u._id.then(o=>this._channels.set(o,u))),new P.LazyOutputChannel(v,d)}async _doCreateOutChannel(v){try{const d=(0,D.join)(this._logsLocation.fsPath,`output_logging_${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await I.SymlinkSupport.existsDirectory(d)||await C.promises.mkdir(d,{recursive:!0});const o=`${this._namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=p.URI.file((0,D.join)(d,`${o}.log`)),r=new l(o,t.fsPath);return new m(v,r,this._proxy)}catch(d){return this.logService.error(d),new P.ExtHostPushOutputChannel(v,this._proxy)}}};y=je([Ue(0,i.IExtHostRpcService),Ue(1,k.ILogService),Ue(2,S.IExtHostInitDataService)],y),e.ExtHostOutputService2=y}),define(ge[253],pe([0,1,5,14,6,27,2,39,24,37,25,8,10,50,3,72,13,12]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.findPorts=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v{constructor(c,b,w){this.remoteAddress=c,this.localAddress=b,this._dispose=w,this._onDispose=new l.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function d(n){const c=n.trim().split(`
`),b=[];return c.forEach(w=>{const h=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(w);h&&h.length>=3&&b.push({pid:parseInt(h[1],10),socket:parseInt(h[2],10)})}),b}e.getSockets=d;function u(...n){const c=[].concat(...n.map(t));return[...new Map(c.filter(b=>b.st==="0A").map(b=>{const w=b.local_address.split(":");return{socket:parseInt(b.inode,10),ip:o(w[0]),port:parseInt(w[1],16)}}).map(b=>[b.ip+":"+b.port,b])).values()]}e.loadListeningPorts=u;function o(n){let c="";if(n.length===8)for(let b=n.length-2;b>=0;b-=2)c+=parseInt(n.substr(b,2),16),b!==0&&(c+=".");else for(let b=n.length-4;b>=0;b-=4)c+=parseInt(n.substr(b,4),16).toString(16),b!==0&&(c+=":");return c}e.parseIpAddress=o;function t(n){const c=n.trim().split(`
`),b=c.shift().trim().split(/\s+/).filter(h=>h!=="rx_queue"&&h!=="tm->when");return c.map(h=>h.trim().split(/\s+/).reduce((_,A,L)=>(_[b[L]||L]=A,_),{}))}e.loadConnectionTable=t;function r(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/vs/server/main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}async function s(n,c,b,w){const h=u(n,c),A=d(b).reduce((j,K)=>(j[K.socket]=K,j),{}),L=w.reduce((j,K)=>(j[K.pid]=K,j),{}),W=[];return h.filter(j=>A[j.socket]).forEach(({socket:j,ip:K,port:H})=>{var $;const M=($=L[A[j].pid])===null||$===void 0?void 0:$.cmd;M&&!r(M)&&W.push({host:K,port:H,detail:M,pid:A[j].pid})}),W}e.findPorts=s;let a=class extends R.Disposable{constructor(c,b,w){super();this.logService=w,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new l.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=c.getProxy(p.MainContext.MainThreadTunnelService),E.isLinux&&b.remote.isRemote&&b.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(c,b){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier} called openTunnel API for ${b.remoteAddress.port}.`);const w=await this._proxy.$openTunnel(b,c.displayName);if(w){const h=new v(w.remoteAddress,w.localAddress,()=>this._proxy.$closeTunnel(w.remoteAddress));return this._register(h),h}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(c){return Math.max(c*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(c,b){const w=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(w,{selector:c,provider:b}),this._proxy.$registerPortsAttributesProvider(c,w),new k.Disposable(()=>{this._portAttributesProviders.delete(w),this._proxy.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(c,b,w,h,_){const L=(await Promise.all(c.map(W=>{const j=this._portAttributesProviders.get(W);return j?j.provider.providePortAttributes(b,w,h,_):[]}))).filter(W=>!!W&&W.length>0);return L.length>0?(0,g.flatten)(L).map(W=>({autoForwardAction:W.autoForwardAction,port:W.port})):[]}async $registerCandidateFinder(c){if(!(c&&this._candidateFindingEnabled)){this._candidateFindingEnabled=c;let b=new m.MovingAverage,w;for(;this._candidateFindingEnabled;){const h=new Date().getTime(),_=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${_.map(L=>L.port).join(", ")}`);const A=new Date().getTime()-h;b.update(A),(!w||JSON.stringify(w)!==JSON.stringify(_))&&(w=_,await this._proxy.$onFoundNewCandidates(w)),await new Promise(L=>setTimeout(()=>L(),this.calculateDelay(b.value)))}}}async setTunnelExtensionFunctions(c){var b;return c?(c.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this._showCandidatePort=c.showCandidatePort,await this._proxy.$setCandidateFilter()),c.tunnelFactory&&(this._forwardPortProvider=c.tunnelFactory,await this._proxy.$setTunnelProvider((b=c.tunnelFeatures)!==null&&b!==void 0?b:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,R.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(c,b){if(this._extensionTunnels.has(c.host)){const w=this._extensionTunnels.get(c.host);w.has(c.port)&&(b&&w.get(c.port).disposeListener.dispose(),await w.get(c.port).tunnel.dispose(),w.delete(c.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(c,b){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this._forwardPortProvider(c,b);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const h=await w;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(c.remoteAddress.host)||this._extensionTunnels.set(c.remoteAddress.host,new Map);const _=this._register(h.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(h.remoteAddress))));return this._extensionTunnels.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:h,disposeListener:_}),f.TunnelDto.fromApiTunnel(h)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(w){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(c){const b=await Promise.all(c.map(h=>this._showCandidatePort(h.host,h.port,h.detail))),w=c.filter((h,_)=>b[_]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(h=>h.port).join(", ")} to ${w.map(h=>h.port).join(", ")}`),w}async findCandidatePorts(){let c="",b="";try{c=await i.promises.readFile("/proc/net/tcp","utf8"),b=await i.promises.readFile("/proc/net/tcp6","utf8")}catch(A){}const w=await new Promise(A=>{(0,P.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(L,W,j)=>{A(W)})}),h=await T.readdir("/proc"),_=[];for(let A of h)try{const L=Number(A),W=S.joinPath(C.URI.file("/proc"),A);if((await i.promises.stat(W.fsPath)).isDirectory()&&!isNaN(L)){const K=await i.promises.readlink(S.joinPath(W,"cwd").fsPath),H=await i.promises.readFile(S.joinPath(W,"cmdline").fsPath,"utf8");_.push({pid:L,cwd:K,cmd:H})}}catch(L){}return s(c,b,w,_)}};a=je([Ue(0,D.IExtHostRpcService),Ue(1,I.IExtHostInitDataService),Ue(2,y.ILogService)],a),e.ExtHostTunnelService=a}),define(ge[254],pe([0,1,19,21,18,3,6,97,225,121,26]),function(Z,e,p,D,R,I,C,P,S,i,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function E(a,n){try{return JSON.stringify(a,n)}catch(c){return"null"}}function f(a,n){return JSON.stringify(a,n)}function l(a){return a?(n,c)=>c&&c.$mid===1?a.transformOutgoing(c):c:null}var m;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));var y;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(y=e.ResponsiveState||(e.ResponsiveState={}));const g=()=>{},v=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class u extends C.Disposable{constructor(n,c=null,b=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=n,this._logger=c,this._uriTransformer=b,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,h=i.ProxyIdentifier.count;w<h;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new p.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(n=>{this._pendingRPCReplies[n].resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(n){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(n){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(n){this._responsiveState!==n&&(this._responsiveState=n,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(n){return this._uriTransformer?(0,P.transformIncomingURIs)(n,this._uriTransformer):n}getProxy(n){const{nid:c,sid:b}=n;return this._proxies[c]||(this._proxies[c]=this._createProxy(c,b)),this._proxies[c]}_createProxy(n,c){let b={get:(w,h)=>(typeof h=="string"&&!w[h]&&h.charCodeAt(0)===36&&(w[h]=(..._)=>this._remoteCall(n,h,_)),h===d?c:w[h])};return new Proxy(Object.create(null),b)}set(n,c){return this._locals[n.nid]=c,c}assertRegistered(n){for(let c=0,b=n.length;c<b;c++){const w=n[c];if(!this._locals[w.nid])throw new Error(`Missing actor ${w.sid} (isMain: ${w.isMain})`)}}_receiveOneMessage(n){if(!this._isDisposed){const c=n.byteLength,b=o.read(n,0),w=b.readUInt8(),h=b.readUInt32();switch(w){case 1:case 2:{let{rpcId:_,method:A,args:L}=t.deserializeRequestJSONArgs(b);this._uriTransformer&&(L=(0,P.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(c,h,_,A,L,w===2);break}case 3:case 4:{let{rpcId:_,method:A,args:L}=t.deserializeRequestMixedArgs(b);this._uriTransformer&&(L=(0,P.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(c,h,_,A,L,w===4);break}case 5:{this._logger&&this._logger.logIncoming(c,h,0,"ack"),this._onDidReceiveAcknowledge(h);break}case 6:{this._receiveCancel(c,h);break}case 7:{this._receiveReply(c,h,void 0);break}case 9:{let _=t.deserializeReplyOKJSON(b);this._uriTransformer&&(_=(0,P.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReply(c,h,_);break}case 8:{let _=t.deserializeReplyOKVSBuffer(b);this._receiveReply(c,h,_);break}case 10:{let _=t.deserializeReplyErrError(b);this._uriTransformer&&(_=(0,P.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReplyErr(c,h,_);break}case 11:{this._receiveReplyErr(c,h,void 0);break}default:console.error("received unexpected message"),console.error(n)}}}_receiveRequest(n,c,b,w,h,_){this._logger&&this._logger.logIncoming(n,c,1,`receiveRequest ${(0,i.getStringIdentifierForProxy)(b)}.${w}(`,h);const A=String(c);let L,W;if(_){const K=new D.CancellationTokenSource;h.push(K.token),L=this._invokeHandler(b,w,h),W=()=>K.cancel()}else L=this._invokeHandler(b,w,h),W=g;this._cancelInvokedHandlers[A]=W;const j=t.serializeAcknowledged(c);this._logger&&this._logger.logOutgoing(j.byteLength,c,1,"ack"),this._protocol.send(j),L.then(K=>{delete this._cancelInvokedHandlers[A];const H=t.serializeReplyOK(c,K,this._uriReplacer);this._logger&&this._logger.logOutgoing(H.byteLength,c,1,"reply:",K),this._protocol.send(H)},K=>{delete this._cancelInvokedHandlers[A];const H=t.serializeReplyErr(c,K);this._logger&&this._logger.logOutgoing(H.byteLength,c,1,"replyErr:",K),this._protocol.send(H)})}_receiveCancel(n,c){this._logger&&this._logger.logIncoming(n,c,1,"receiveCancel");const b=String(c);this._cancelInvokedHandlers[b]&&this._cancelInvokedHandlers[b]()}_receiveReply(n,c,b){this._logger&&this._logger.logIncoming(n,c,0,"receiveReply:",b);const w=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(w)){const h=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],h.resolveOk(b)}}_receiveReplyErr(n,c,b){this._logger&&this._logger.logIncoming(n,c,0,"receiveReplyErr:",b);const w=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(w)){const h=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let _;b&&(b.$isError?(_=new Error,_.name=b.name,_.message=b.message,_.stack=b.stack):_=b),h.resolveErr(_)}}_invokeHandler(n,c,b){try{return Promise.resolve(this._doInvokeHandler(n,c,b))}catch(w){return Promise.reject(w)}}_doInvokeHandler(n,c,b){const w=this._locals[n];if(!w)throw new Error("Unknown actor "+(0,i.getStringIdentifierForProxy)(n));let h=w[c];if(typeof h!="function")throw new Error("Unknown method "+c+" on actor "+(0,i.getStringIdentifierForProxy)(n));return h.apply(w,b)}_remoteCall(n,c,b){if(this._isDisposed)return Promise.reject(R.canceled());let w=null;if(b.length>0&&D.CancellationToken.isCancellationToken(b[b.length-1])&&(w=b.pop()),w&&w.isCancellationRequested)return Promise.reject(R.canceled());const h=t.serializeRequestArguments(b,this._uriReplacer),_=++this._lastMessageId,A=String(_),L=new S.LazyPromise;w&&w.onCancellationRequested(()=>{const j=t.serializeCancel(_);this._logger&&this._logger.logOutgoing(j.byteLength,_,0,"cancel"),this._protocol.send(t.serializeCancel(_))}),this._pendingRPCReplies[A]=L,this._onWillSendRequest(_);const W=t.serializeRequest(_,n,c,h,!!w);return this._logger&&this._logger.logOutgoing(W.byteLength,_,0,`request: ${(0,i.getStringIdentifierForProxy)(n)}.${c}(`,b),this._protocol.send(W),L}}e.RPCProtocol=u,k=v,u.UNRESPONSIVE_TIME=3*1e3;class o{constructor(n,c){this._buff=n,this._offset=c}static alloc(n,c,b){let w=new o(T.VSBuffer.alloc(b+1+4),0);return w.writeUInt8(n),w.writeUInt32(c),w}static read(n,c){return new o(n,c)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(n){this._buff.writeUInt8(n,this._offset),this._offset+=1}readUInt8(){const n=this._buff.readUInt8(this._offset);return this._offset+=1,n}writeUInt32(n){this._buff.writeUInt32BE(n,this._offset),this._offset+=4}readUInt32(){const n=this._buff.readUInt32BE(this._offset);return this._offset+=4,n}static sizeShortString(n){return 1+n.byteLength}writeShortString(n){this._buff.writeUInt8(n.byteLength,this._offset),this._offset+=1,this._buff.set(n,this._offset),this._offset+=n.byteLength}readShortString(){const n=this._buff.readUInt8(this._offset);this._offset+=1;const b=this._buff.slice(this._offset,this._offset+n).toString();return this._offset+=n,b}static sizeLongString(n){return 4+n.byteLength}writeLongString(n){this._buff.writeUInt32BE(n.byteLength,this._offset),this._offset+=4,this._buff.set(n,this._offset),this._offset+=n.byteLength}readLongString(){const n=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+n).toString();return this._offset+=n,b}writeBuffer(n){this._buff.writeUInt32BE(n.byteLength,this._offset),this._offset+=4,this._buff.set(n,this._offset),this._offset+=n.byteLength}static sizeVSBuffer(n){return 4+n.byteLength}writeVSBuffer(n){this._buff.writeUInt32BE(n.byteLength,this._offset),this._offset+=4,this._buff.set(n,this._offset),this._offset+=n.byteLength}readVSBuffer(){const n=this._buff.readUInt32BE(this._offset);this._offset+=4;const c=this._buff.slice(this._offset,this._offset+n);return this._offset+=n,c}static sizeMixedArray(n,c){let b=0;b+=1;for(let w=0,h=n.length;w<h;w++){const _=n[w],A=c[w];switch(b+=1,A){case 1:b+=this.sizeLongString(_);break;case 2:b+=this.sizeVSBuffer(_);break;case 3:break}}return b}writeMixedArray(n,c){this._buff.writeUInt8(n.length,this._offset),this._offset+=1;for(let b=0,w=n.length;b<w;b++){const h=n[b];switch(c[b]){case 1:this.writeUInt8(1),this.writeLongString(h);break;case 2:this.writeUInt8(2),this.writeVSBuffer(h);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const n=this._buff.readUInt8(this._offset);this._offset+=1;let c=new Array(n);for(let b=0;b<n;b++)switch(this.readUInt8()){case 1:c[b]=this.readLongString();break;case 2:c[b]=this.readVSBuffer();break;case 3:c[b]=void 0;break}return c}}class t{static _arrayContainsBufferOrUndefined(n){for(let c=0,b=n.length;c<b;c++)if(n[c]instanceof T.VSBuffer||typeof n[c]=="undefined")return!0;return!1}static serializeRequestArguments(n,c){if(this._arrayContainsBufferOrUndefined(n)){let b=[],w=[];for(let h=0,_=n.length;h<_;h++){const A=n[h];A instanceof T.VSBuffer?(b[h]=A,w[h]=2):typeof A=="undefined"?(b[h]=T.VSBuffer.alloc(0),w[h]=3):(b[h]=T.VSBuffer.fromString(f(A,c)),w[h]=1)}return{type:"mixed",args:b,argsType:w}}return{type:"simple",args:f(n,c)}}static serializeRequest(n,c,b,w,h){return w.type==="mixed"?this._requestMixedArgs(n,c,b,w.args,w.argsType,h):this._requestJSONArgs(n,c,b,w.args,h)}static _requestJSONArgs(n,c,b,w,h){const _=T.VSBuffer.fromString(b),A=T.VSBuffer.fromString(w);let L=0;L+=o.sizeUInt8(),L+=o.sizeShortString(_),L+=o.sizeLongString(A);let W=o.alloc(h?2:1,n,L);return W.writeUInt8(c),W.writeShortString(_),W.writeLongString(A),W.buffer}static deserializeRequestJSONArgs(n){const c=n.readUInt8(),b=n.readShortString(),w=n.readLongString();return{rpcId:c,method:b,args:JSON.parse(w)}}static _requestMixedArgs(n,c,b,w,h,_){const A=T.VSBuffer.fromString(b);let L=0;L+=o.sizeUInt8(),L+=o.sizeShortString(A),L+=o.sizeMixedArray(w,h);let W=o.alloc(_?4:3,n,L);return W.writeUInt8(c),W.writeShortString(A),W.writeMixedArray(w,h),W.buffer}static deserializeRequestMixedArgs(n){const c=n.readUInt8(),b=n.readShortString(),w=n.readMixedArray(),h=new Array(w.length);for(let _=0,A=w.length;_<A;_++){const L=w[_];typeof L=="string"?h[_]=JSON.parse(L):h[_]=L}return{rpcId:c,method:b,args:h}}static serializeAcknowledged(n){return o.alloc(5,n,0).buffer}static serializeCancel(n){return o.alloc(6,n,0).buffer}static serializeReplyOK(n,c,b){return typeof c=="undefined"?this._serializeReplyOKEmpty(n):c instanceof T.VSBuffer?this._serializeReplyOKVSBuffer(n,c):this._serializeReplyOKJSON(n,E(c,b))}static _serializeReplyOKEmpty(n){return o.alloc(7,n,0).buffer}static _serializeReplyOKVSBuffer(n,c){let b=0;b+=o.sizeVSBuffer(c);let w=o.alloc(8,n,b);return w.writeVSBuffer(c),w.buffer}static deserializeReplyOKVSBuffer(n){return n.readVSBuffer()}static _serializeReplyOKJSON(n,c){const b=T.VSBuffer.fromString(c);let w=0;w+=o.sizeLongString(b);let h=o.alloc(9,n,w);return h.writeLongString(b),h.buffer}static deserializeReplyOKJSON(n){const c=n.readLongString();return JSON.parse(c)}static serializeReplyErr(n,c){return c?this._serializeReplyErrEror(n,c):this._serializeReplyErrEmpty(n)}static _serializeReplyErrEror(n,c){const b=T.VSBuffer.fromString(E(R.transformErrorForSerialization(c),null));let w=0;w+=o.sizeLongString(b);let h=o.alloc(10,n,w);return h.writeLongString(b),h.buffer}static deserializeReplyErrError(n){const c=n.readLongString();return JSON.parse(c)}static _serializeReplyErrEmpty(n){return o.alloc(11,n,0).buffer}}var r;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyErrError=10]="ReplyErrError",a[a.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var s;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.Undefined=3]="Undefined"})(s||(s={}))}),define(ge[255],pe([0,1,4]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,p.createDecorator)("remoteAgentService")}),define(ge[256],pe([0,1,11,7,10,2,4,255]),function(Z,e,p,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let S=class{constructor(T,k){this.localUserHome=T,this.remoteAgentService=k,this.resolveOS=(async()=>{const E=await this.remoteAgentService.getEnvironment();return(E==null?void 0:E.os)||R.OS})(),this.resolveUserHome=(async()=>{const E=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(E==null?void 0:E.userHome)||T})()}async userHome(T){return(T==null?void 0:T.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(T=>T===1?D.win32:D.posix)}async fileURI(T){let k="";if(await this.resolveOS===1&&(T=T.replace(/\\/g,"/")),T[0]==="/"&&T[1]==="/"){const f=T.indexOf("/",2);f===-1?(k=T.substring(2),T="/"):(k=T.substring(2,f),T=T.substring(f)||"/")}return I.URI.from({scheme:p.Schemas.file,authority:k,path:T,query:"",fragment:""})}};S=je([Ue(1,P.IRemoteAgentService)],S),e.AbstractPathService=S}),define(ge[31],pe([0,1,12,33,22,30,9,4,7,18]),function(Z,e,p,D,R,I,C,P,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const T="\u27EA ",k=" characters skipped \u27EB",E=(T.length+k.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var f;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var l;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(l=e.QueryType||(e.QueryType={}));function m(M){return!!M.preview}e.resultIsMatch=m;function y(M){return!!M.resource}e.isFileMatch=y;function g(M){return!!M.message}e.isProgressMessage=g;var v;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(v=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class d{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=d;class u{constructor(U,F,N){this.ranges=F;const O=Array.isArray(F)?F:[F];if(N&&N.matchLines===1&&o(O)){U=(0,C.getNLines)(U,N.matchLines);let V="",q=0,Y=0;const fe=Math.floor(N.charsPerLine/5),_e=[];for(const Le of O){const Ie=Math.max(Le.startColumn-fe,0),Fe=Le.startColumn+N.charsPerLine;if(Ie>Y+fe+E){const z=T+(Ie-Y)+k;V+=z+U.slice(Ie,Fe),q+=Ie-(Y+z.length)}else V+=U.slice(Y,Fe);_e.push(new r(0,Le.startColumn-q,Le.endColumn-q)),Y=Fe}this.preview={text:V,matches:Array.isArray(this.ranges)?_e:_e[0]}}else{const V=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:U,matches:(0,p.mapArrayOrNot)(F,q=>new t(q.startLineNumber-V,q.startColumn,q.endLineNumber-V,q.endColumn))}}}}e.TextSearchMatch=u;function o(M){const U=M[0].startLineNumber;for(const F of M)if(F.startLineNumber!==U||F.endLineNumber!==U)return!1;return!0}class t{constructor(U,F,N,O){this.startLineNumber=U,this.startColumn=F,this.endLineNumber=N,this.endColumn=O}}e.SearchRange=t;class r extends t{constructor(U,F,N){super(U,F,U,N)}}e.OneLineRange=r;var s;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function a(M,U=!0){const F=M&&M.files&&M.files.exclude,N=U&&M&&M.search&&M.search.exclude;if(!(!F&&!N)){if(!F||!N)return F||N;let O=Object.create(null);return O=R.mixin(O,R.deepClone(F)),O=R.mixin(O,R.deepClone(N),!0),O}}e.getExcludes=a;function n(M,U){return M.excludePattern&&D.match(M.excludePattern,U)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&D.match(M.includePattern,U)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(F=>{const N=F.folder.fsPath;if(I.isEqualOrParent(U,N)){const O=S.relative(N,U);return!F.includePattern||!!D.match(F.includePattern,O)}else return!1}):!1:!0}e.pathIncludedInQuery=n;var c;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(c=e.SearchErrorCode||(e.SearchErrorCode={}));class b extends Error{constructor(U,F){super(U);this.code=F}}e.SearchError=b;function w(M){const U=M.message;if((0,i.isPromiseCanceledError)(M))return new b(U,c.canceled);try{const F=JSON.parse(U);return new b(F.message,F.code)}catch(F){return new b(U,c.other)}}e.deserializeSearchError=w;function h(M){const U={message:M.message,code:M.code};return new Error(JSON.stringify(U))}e.serializeSearchError=h;function _(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=_;function A(M){return M.type==="success"}e.isSerializedSearchSuccess=A;function L(M){return!!M.path}e.isSerializedFileMatch=L;function W(M,U){const F=M.searchPath?M.searchPath:M.relativePath;return(0,C.fuzzyContains)(F,U)}e.isFilePatternMatch=W;class j{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=j;function K(M,U){const F=Object.assign(Object.assign({},M||{}),U||{});return Object.keys(F).filter(N=>{const O=F[N];return typeof O=="boolean"&&O})}e.resolvePatternsForProvider=K;class H{constructor(U,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=D.parse(this._excludeExpression);let N=U.includePattern;F.includePattern&&(N?N=Object.assign(Object.assign({},N),F.includePattern):N=F.includePattern),N&&(this._parsedIncludeExpression=D.parse(N))}includedInQuerySync(U,F,N){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,F,N)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,F,N))}includedInQuery(U,F,N){return Promise.resolve(this._parsedExcludeExpression(U,F,N)).then(V=>!!V).then(V=>V?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,F,N)).then(q=>!!q):Promise.resolve(!0)).then(V=>V)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=H;function $(M){for(const U in M)if(typeof M[U]!="boolean")return!0;return!1}}),define(ge[32],pe([0,1,12,19,21,3,23,11,72,24,9,15,2,164,4,13,183,60,61,27,14,8,31,5]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g,v,d,u,o,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(A,L,W){return new i.ExtUri(j=>b(j,W)).isEqual(A,L)}function a(A,L,W){return s(A.uri,L.uri,W)?0:(0,T.compare)(A.uri.toString(),L.uri.toString())}function n(A,L,W){return A.index!==L.index?A.index<L.index?-1:1:s(A.uri,L.uri,W)?(0,T.compare)(A.name,L.name):(0,T.compare)(A.uri.toString(),L.uri.toString())}function c(A,L,W,j){const K=A.slice(0).sort(($,M)=>W($,M,j)),H=L.slice(0).sort(($,M)=>W($,M,j));return(0,p.delta)(K,H,($,M)=>W($,M,j))}function b(A,L){const W=L.getCapabilities(A.scheme);return!(W&&W&1024)}class w extends g.Workspace{constructor(L,W,j,K,H,$){super(L,j.map(M=>new g.WorkspaceFolder(M)),K,$);this._name=W,this._isUntitled=H,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris($),j.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(L,W,j,K){if(!L)return{workspace:null,added:[],removed:[]};const{id:H,name:$,folders:M,configuration:U,isUntitled:F}=L,N=[],O=W;W?M.forEach((fe,_e)=>{const Le=E.URI.revive(fe.uri),Ie=w._findFolder(j||W,Le,K);Ie?(Ie.name=fe.name,Ie.index=fe.index,N.push(Ie)):N.push({uri:Le,name:fe.name,index:_e})}):N.push(...M.map(({uri:fe,name:_e,index:Le})=>({uri:E.URI.revive(fe),name:_e,index:Le}))),N.sort((fe,_e)=>fe.index<_e.index?-1:1);const V=new w(H,$,N,U?E.URI.revive(U):null,!!F,fe=>b(fe,K)),{added:q,removed:Y}=c(O?O.workspaceFolders:[],V.workspaceFolders,a,K);return{workspace:V,added:q,removed:Y}}static _findFolder(L,W,j){for(let K=0;K<L.folders.length;K++){const H=L.workspaceFolders[K];if(s(H.uri,W,j))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,W){return W&&this._structure.get(L)&&(L=(0,i.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let h=class{constructor(L,W,j,K){this._onDidChangeWorkspace=new I.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new I.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=o.WorkspaceTrustState.Unknown,this._logService=K,this._extHostFileSystemInfo=j,this._requestIdProvider=new S.Counter,this._barrier=new D.Barrier,this._proxy=L.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(r.MainContext.MainThreadMessageService);const H=W.workspace;this._confirmedWorkspace=H?new w(H.id,H.name,[],H.configuration?E.URI.revive(H.configuration):null,!!H.isUntitled,$=>b($,j)):void 0}$initializeWorkspace(L,W){this._workspaceTrustState=W,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?E.URI.from({scheme:P.Schemas.untitled,path:(0,i.basename)((0,i.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,W,j,...K){const H=[];if(Array.isArray(K)&&K.forEach(N=>{E.URI.isUri(N.uri)&&!H.some(O=>s(O.uri,N.uri,this._extHostFileSystemInfo))&&H.push({uri:N.uri,name:N.name||(0,i.basenameOrAuthority)(N.uri)})}),this._unconfirmedWorkspace||[W,j].some(N=>typeof N!="number"||N<0)||j===0&&H.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(W+j>$.length)return!1;const M=$.slice(0);M.splice(W,j,...H.map(N=>({uri:N.uri,name:N.name||(0,i.basenameOrAuthority)(N.uri),index:void 0})));for(let N=0;N<M.length;N++){const O=M[N];if(M.some((V,q)=>q!==N&&s(O.uri,V.uri,this._extHostFileSystemInfo)))return!1}M.forEach((N,O)=>N.index=O);const{added:U,removed:F}=c($,M,n,this._extHostFileSystemInfo);if(U.length===0&&F.length===0)return!1;if(this._proxy){const N=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(N,W,j,H).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(y.Severity.Error,(0,f.localize)(0,null,N,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(M),!0}getWorkspaceFolder(L,W){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,W)}async getWorkspaceFolder2(L,W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,W)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,W){let j,K="";if(typeof L=="string"?(j=E.URI.file(L),K=L):typeof L!="undefined"&&(j=L,K=L.fsPath),!j)return K;const H=this.getWorkspaceFolder(j,!0);if(!H)return K;typeof W=="undefined"&&this._actualWorkspace&&(W=this._actualWorkspace.folders.length>1);let $=(0,i.relativePath)(H.uri,j);return W&&H.name&&($=`${H.name}/${$}`),$}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:W,added:j,removed:K}=w.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=W||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:j,removed:K}))}findFiles(L,W,j,K,H=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let $;if(W===null?$=!1:W&&(typeof W=="string"?$=W:$=W.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:M,folder:U}=_(L);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(M),(0,k.withUndefinedAsNull)(U),(0,k.withUndefinedAsNull)($),(0,k.withUndefinedAsNull)(j),H).then(F=>Array.isArray(F)?F.map(N=>E.URI.revive(N)):[])}async findTextInFiles(L,W,j,K,H=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),M=typeof W.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:U,folder:F}=_(W.include),N=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,O={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:M,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:U,excludePattern:N},V=!1;if(this._activeSearchCallbacks[$]=q=>{if(!V){const Y=E.URI.revive(q.resource);q.results.forEach(fe=>{(0,t.resultIsMatch)(fe)?j({uri:Y,preview:{text:fe.preview.text,matches:(0,p.mapArrayOrNot)(fe.preview.matches,_e=>new o.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))},ranges:(0,p.mapArrayOrNot)(fe.ranges,_e=>new o.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))}):j({uri:Y,text:fe.text,lineNumber:fe.lineNumber})})}},H.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(L,(0,k.withUndefinedAsNull)(F),O,$,H);return delete this._activeSearchCallbacks[$],q||{}}catch(q){throw delete this._activeSearchCallbacks[$],q}}$handleTextSearchResult(L,W){this._activeSearchCallbacks[W]&&this._activeSearchCallbacks[W](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trustState(){return this._workspaceTrustState}requireWorkspaceTrust(L){return this._proxy.$requireWorkspaceTrust(L)}$onDidChangeWorkspaceTrustState(L){this._workspaceTrustState=L.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze(L))}};h=je([Ue(0,u.IExtHostRpcService),Ue(1,d.IExtHostInitDataService),Ue(2,v.IExtHostFileSystemInfo),Ue(3,m.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function _(A){let L,W;return A&&(typeof A=="string"?L=A:(L=A.pattern,W=A.baseFolder||E.URI.file(A.base))),{includePattern:L,folder:W}}}),define(ge[35],pe([0,1,22,3,32,5,8,185,82,15,19,4,14,13,2]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(r,s){if(s){const a=s.split(".");let n=r;for(let c=0;n&&c<a.length;c++)n=n[a[c]];return n}}function y(r){return r instanceof l.URI}function g(r){return r&&r.uri instanceof l.URI&&r.languageId&&typeof r.languageId=="string"}function v(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function d(r){return r&&r.uri instanceof l.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function u(r){if(y(r))return{resource:r};if(g(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(v(r))return{overrideIdentifier:r.languageId};if(d(r))return{resource:r.uri};if(r===null)return{resource:null}}let o=class{constructor(s,a,n){this._proxy=s.getProxy(I.MainContext.MainThreadConfiguration),this._extHostWorkspace=a,this._logService=n,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,a){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(s,a))}};o=je([Ue(0,E.IExtHostRpcService),Ue(1,R.IExtHostWorkspace),Ue(2,f.ILogService)],o),e.ExtHostConfiguration=o;class t{constructor(s,a,n,c){this._onDidChangeConfiguration=new D.Emitter,this._proxy=s,this._logService=c,this._extHostWorkspace=a,this._configuration=P.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,a){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(a,n))}getConfiguration(s,a,n){const c=u(a)||{},b=this._toReadonlyValue(s?m(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,c,n==null?void 0:n.identifier);function w(_){if(_==null)return null;if(typeof _=="boolean")return _?1:4;switch(_){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(_){return typeof m(b,_)!="undefined"},get:(_,A)=>{this._validateConfigurationAccess(s?`${s}.${_}`:_,c,n==null?void 0:n.identifier);let L=m(b,_);if(typeof L=="undefined")L=A;else{let W;const j=(K,H)=>{let $;const M=()=>{W=W||(0,p.deepClone)(b),$=$||m(W,H)};return(0,i.isObject)(K)?new Proxy(K,{get:(U,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return M(),()=>$;if(W)return $=$||m(W,H),$[F];const N=U[F];return typeof F=="string"?j(N,`${H}.${F}`):N},set:(U,F,N)=>(M(),$&&($[F]=N),!0),deleteProperty:(U,F)=>(M(),$&&delete $[F],!0),defineProperty:(U,F,N)=>(M(),$&&Object.defineProperty($,F,N),!0)}):K};L=j(L,_)}return L},update:(_,A,L,W)=>{_=s?`${s}.${_}`:_;const j=w(L);return A!==void 0?this._proxy.$updateConfigurationOption(j,_,A,c,W):this._proxy.$removeConfigurationOption(j,_,c,W)},inspect:_=>{var A,L,W,j,K,H,$,M;_=s?`${s}.${_}`:_;const U=(0,p.deepClone)(this._configuration.inspect(_,c,this._extHostWorkspace.workspace));if(U)return{key:_,defaultValue:(A=U.default)===null||A===void 0?void 0:A.value,globalValue:(L=U.user)===null||L===void 0?void 0:L.value,workspaceValue:(W=U.workspace)===null||W===void 0?void 0:W.value,workspaceFolderValue:(j=U.workspaceFolder)===null||j===void 0?void 0:j.value,defaultLanguageValue:(K=U.default)===null||K===void 0?void 0:K.override,globalLanguageValue:(H=U.user)===null||H===void 0?void 0:H.override,workspaceLanguageValue:($=U.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(M=U.workspaceFolder)===null||M===void 0?void 0:M.override,languageIds:U.overrideIdentifiers}}};return typeof b=="object"&&(0,p.mixin)(h,b,!1),Object.freeze(h)}_toReadonlyValue(s){const a=n=>(0,i.isObject)(n)?new Proxy(n,{get:(c,b)=>a(c[b]),set:(c,b,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(c,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(c,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return a(s)}_validateConfigurationAccess(s,a,n){const c=S.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),b=n?`[${n.value}] `:"";if(c===4){typeof(a==null?void 0:a.resource)=="undefined"&&this._logService.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){(a==null?void 0:a.resource)&&this._logService.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,a){const n=new P.ConfigurationChangeEvent(s,a,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,b)=>n.affectsConfiguration(c,u(b))})}_toMap(s){return s.reduce((a,n)=>(a.set(n[0],n[1]),a),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Z,e,p){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,p),p},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[66],pe([0,1,2,19,3,5,8,32,38,35,21,34,14,27,4,11,10,13,63,205,18]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g,v,d,u){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(K){function H(M){if(M!=null)return M}K.from=H;function $(M){if(M!=null)return M}K.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(K){function H(M){if(M!=null)return M}K.from=H;function $(M){if(M!=null)return M}K.to=$})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(K){function H(M){if(M!=null)return M}K.from=H;function $(M){if(M!=null)return M}K.to=$})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(K){function H(U){if(U){const F=U;return F&&!!F.process}else return!1}K.is=H;function $(U){if(U!=null){const F={process:U.process,args:U.args};return U.options&&(F.options=s.from(U.options)),F}}K.from=$;function M(U){if(U!=null)return new C.ProcessExecution(U.process,U.args,U.options)}K.to=M})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(K){function H(M){if(M!=null)return M}K.from=H;function $(M){if(M!=null)return M}K.to=$})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(K){function H(U){if(U){const F=U;return F&&(!!F.commandLine||!!F.command)}else return!1}K.is=H;function $(U){if(U!=null){const F={};return U.commandLine!==void 0?F.commandLine=U.commandLine:(F.command=U.command,F.args=U.args),U.options&&(F.options=n.from(U.options)),F}}K.from=$;function M(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new C.ShellExecution(U.commandLine,U.options):new C.ShellExecution(U.command,U.args?U.args:[],U.options)}K.to=M})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var b;(function(K){function H(U){if(U){let F=U;return F&&F.customExecution==="customExecution"}else return!1}K.is=H;function $(U){return{customExecution:"customExecution"}}K.from=$;function M(U,F){return F.get(U)}K.to=M})(b=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function(K){function H($,M){let U;return $.scope!==void 0&&typeof $.scope!="number"?U=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===C.TaskScope.Workspace&&M&&M.workspaceFile?U=M.workspaceFile:U=d.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:U}}K.from=H})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(K){function H(U,F){if(U==null)return[];const N=[];for(let O of U){const V=$(O,F);V&&N.push(V)}return N}K.fromMany=H;function $(U,F){if(U!=null){let N;U.execution instanceof C.ProcessExecution?N=a.from(U.execution):U.execution instanceof C.ShellExecution?N=c.from(U.execution):U.execution&&U.execution instanceof C.CustomExecution&&(N=b.from(U.execution));const O=t.from(U.definition);let V;if(U.scope?typeof U.scope=="number"?V=U.scope:V=U.scope.uri:V=C.TaskScope.Workspace,!(!O||!V)){const q=U.group?U.group.id:void 0;return{_id:U._id,definition:O,name:U.name,source:{extensionId:F.identifier.value,label:U.source,scope:V},execution:N,isBackground:U.isBackground,group:q,presentationOptions:r.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}}}K.from=$;async function M(U,F,N){if(U!=null){let O;a.is(U.execution)?O=a.to(U.execution):c.is(U.execution)?O=c.to(U.execution):b.is(U.execution)&&(O=b.to(U._id,N));const V=t.to(U.definition);let q;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?q=U.source.scope:q=await F.resolveWorkspaceFolder(p.URI.revive(U.source.scope)):q=C.TaskScope.Workspace),!(!V||!q)){const Y=new C.Task(V,q,U.name,U.source.label,O,U.problemMatchers);return U.isBackground!==void 0&&(Y.isBackground=U.isBackground),U.group!==void 0&&(Y.group=C.TaskGroup.from(U.group)),U.presentationOptions&&(Y.presentationOptions=r.to(U.presentationOptions)),U._id&&(Y._id=U._id),U.detail&&(Y.detail=U.detail),Y}}}K.to=M})(h=e.TaskDTO||(e.TaskDTO={}));var _;(function(K){function H(M){return M}K.from=H;function $(M){if(!!M)return Object.assign(Object.create(null),M)}K.to=$})(_=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(H,$,M){this._id=$,this._task=M,o.set(this,void 0),tt(this,o,H)}get task(){return this._task}terminate(){$e(this,o).terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}o=new WeakMap;var L;(function(K){function H($){return{id:$._id,task:void 0}}K.from=H})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let W=class{constructor(H,$,M,U,F,N,O,V){this._onDidExecuteTask=new R.Emitter,this._onDidTerminateTask=new R.Emitter,this._onDidTaskProcessStarted=new R.Emitter,this._onDidTaskProcessEnded=new R.Emitter,this._proxy=H.getProxy(I.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=U,this._configurationService=F,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=V,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,$,M){if(!M)return new C.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:$,provider:M,extension:H}),this._proxy.$registerTaskProvider(U,$),new C.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(H,$){this._proxy.$registerTaskSystem(H,$)}fetchTasks(H){return this._proxy.$fetchTasks(_.from(H)).then(async $=>{const M=[];for(let U of $){const F=await h.to(U,this._workspaceProvider,this._providedCustomExecutions2);F&&M.push(F)}return M})}get taskExecutions(){const H=[];return this._taskExecutions.forEach($=>H.push($)),H}terminateTask(H){if(!(H instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,$,M){const U=this._providedCustomExecutions2.get(H.id);if(U){if(this._activeCustomExecutions2.get(H.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(H.id,U),this._terminalService.attachPtyToTerminal($,await U.callback(M))}this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const $=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const $=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:$,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const $=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:H.exitCode})}$provideTasks(H,$){const M=this._handlers.get(H);if(!M)return Promise.reject(new Error("no handler found"));const U=[],F=(0,D.asPromise)(()=>M.provider.provideTasks(T.CancellationToken.None)).then(N=>this.provideTasksInternal($,U,M,N));return new Promise(N=>{F.then(O=>{Promise.all(U).then(()=>{N(O)})})})}async $resolveTask(H,$){const M=this._handlers.get(H);if(!M)return Promise.reject(new Error("no handler found"));if($.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${M.type}].`);const U=await h.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const F=await M.provider.resolveTask(U,T.CancellationToken.None);if(!!F){this.checkDeprecation(F,M);const N=h.from(F,M.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(F.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(N.execution)&&await this.addCustomExecution(N,F,!0),await this.resolveTaskInternal(N)}}nextHandle(){return this._handleCounter++}async addCustomExecution(H,$,M){const U=await this._proxy.$createTaskId(H);!M&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,$.execution)}async getTaskExecution(H,$){if(typeof H=="string"){const F=this._taskExecutionPromises.get(H);if(!F)throw new Error("Unexpected: The specified task is missing an execution");return F}let M=this._taskExecutionPromises.get(H.id);if(M)return M;const U=new Promise(async(F,N)=>{const O=$||await h.to(H.task,this._workspaceProvider,this._providedCustomExecutions2);O?F(new A(this,H.id,O)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(H.id,U),U.then(F=>(this._taskExecutions.set(H.id,F),F),F=>Promise.reject(F))}checkDeprecation(H,$){H._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let M=this._notProvidedCustomExecutions.values(),U=M.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=M.next()}};W=je([Ue(0,E.IExtHostRpcService),Ue(1,f.IExtHostInitDataService),Ue(2,P.IExtHostWorkspace),Ue(3,S.IExtHostDocumentsAndEditors),Ue(4,i.IExtHostConfiguration),Ue(5,k.IExtHostTerminalService),Ue(6,g.ILogService),Ue(7,v.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let j=class extends W{constructor(H,$,M,U,F,N,O,V){super(H,$,M,U,F,N,O,V);this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:y.PlatformToString(0)})}async executeTask(H,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const M=h.from($,H);if(M===void 0)throw new Error("Task is not valid");if(b.is(M.execution))await this.addCustomExecution(M,$,!1);else throw new u.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),$);return this._proxy.$executeTask(M).catch(F=>{throw new Error(F)}),U}provideTasksInternal(H,$,M,U){const F=[];if(U)for(let N of U){this.checkDeprecation(N,M),(!N.definition||!H[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const O=h.from(N,M.extension);O&&b.is(O.execution)?(F.push(O),$.push(this.addCustomExecution(O,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:F,extension:M.extension}}async resolveTaskInternal(H){if(b.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,$){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(H,$,M){}};j=je([Ue(0,E.IExtHostRpcService),Ue(1,f.IExtHostInitDataService),Ue(2,P.IExtHostWorkspace),Ue(3,S.IExtHostDocumentsAndEditors),Ue(4,i.IExtHostConfiguration),Ue(5,k.IExtHostTerminalService),Ue(6,g.ILogService),Ue(7,v.IExtHostApiDeprecationService)],j),e.WorkerExtHostTask=j,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(Z,e,p){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,p),p},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)},dn=this&&this.__rest||function(Z,e){var p={};for(var D in Z)Object.prototype.hasOwnProperty.call(Z,D)&&e.indexOf(D)<0&&(p[D]=Z[D]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,D=Object.getOwnPropertySymbols(Z);R<D.length;R++)e.indexOf(D[R])<0&&Object.prototype.propertyIsEnumerable.call(Z,D[R])&&(p[D[R]]=Z[D[R]]);return p};define(ge[257],pe([0,1,12,19,21,3,69,6,22,15,2,28,5,38,14,20,8,32,220,210]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g,v,d){"use strict";var u,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.ExtHostTesting=void 0;const t=(_,A)=>`${_}:${A.toString()}`;let r=class{constructor(A,L,W){this.documents=L,this.workspace=W,this.resultsChangedEmitter=new I.Emitter,this.providers=new Map,this.ownedTests=new v.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(E.MainContext.MainThreadTesting),this.workspaceObservers=new w(this.proxy),this.textDocumentObservers=new h(this.proxy,L)}registerTestProvider(A){const L=(0,k.generateUuid)();this.providers.set(L,A),this.proxy.$registerTestProvider(L);const W=[...this.testSubscriptions.keys()];return setTimeout(()=>{var j;for(const K of W)(j=this.testSubscriptions.get(K))===null||j===void 0||j.subscribeFn(L,A)},0),new y.Disposable(()=>{this.providers.delete(L),this.proxy.$unregisterTestProvider(L)})}createTextDocumentTestObserver(A){return this.textDocumentObservers.checkout(A.uri)}createWorkspaceTestObserver(A){return this.workspaceObservers.checkout(A.uri)}async runTests(A,L=R.CancellationToken.None){const W=j=>j.map(this.getInternalTestForReference,this).filter(i.isDefined).map(K=>({providerId:K.providerId,testId:K.item.extId}));await this.proxy.$runTests({exclude:A.exclude?W(A.exclude).map(j=>j.testId):void 0,tests:W(A.tests),debug:A.debug},L)}publishExtensionProvidedResults(A,L){this.proxy.$publishExtensionProvidedResults(m.TestResults.from((0,k.generateUuid)(),A),L)}$publishTestResults(A){this.results=Object.freeze(A.map(L=>(0,S.deepFreeze)(m.TestResults.to(L))).concat(this.results).sort((L,W)=>W.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(A,L){const W=T.URI.revive(L),j=t(A,W);if(!this.testSubscriptions.has(j)){const K=new R.CancellationTokenSource;let H;if(A===1){let F=this.documents.getDocument(W);if(!F){const N=new P.DisposableStore;F=await new Promise(O=>{N.add((0,D.disposableTimeout)(()=>O(void 0),5e3)),N.add(this.documents.onDidAddDocuments(V=>{const q=V.find(Y=>Y.document.uri.toString()===W.toString());q&&O(q)}))}).finally(()=>N.dispose())}if(F){const N=await this.workspace.getWorkspaceFolder2(W,!1);H=O=>O.provideDocumentTestHierarchy?O.provideDocumentTestHierarchy(F.document,K.token):this.createDefaultDocumentTestHierarchy(O,F.document,N,K.token)}}else{const F=await this.workspace.getWorkspaceFolder2(W,!1);F&&(H=N=>N.provideWorkspaceTestHierarchy(F,K.token))}if(!!H){const $=async(F,N)=>{var O;try{U.pushDiff([3,1]);const V=await H(N);if(!V){U.pushDiff([3,-1]);return}U.addRoot(V.root,F),Promise.resolve(V.discoveredInitialTests).then(()=>U.pushDiff([3,-1])),V.onDidChangeTest(q=>U.onItemChange(q,F)),(O=V.onDidInvalidateTest)===null||O===void 0||O.call(V,q=>{const Y=U.getTestByReference(q);Y?this.proxy.$retireTest(Y.item.extId):console.warn("Received a TestProvider.onDidInvalidateTest for a test that does not currently exist.")})}catch(V){console.error(V)}},M=new P.DisposableStore,U=M.add(this.ownedTests.createForHierarchy(F=>this.proxy.$publishDiff(A,L,F)));M.add((0,P.toDisposable)(()=>K.dispose(!0)));for(const[F,N]of this.providers)$(F,N);U.pushDiff([4,-1]),this.testSubscriptions.set(j,{store:M,collection:U,subscribeFn:$})}}}$unsubscribeFromTests(A,L){var W;const j=T.URI.revive(L),K=t(A,j);(W=this.testSubscriptions.get(K))===null||W===void 0||W.store.dispose(),this.testSubscriptions.delete(K)}$acceptDiff(A,L,W){A===1?this.textDocumentObservers.acceptDiff(T.URI.revive(L),W):this.workspaceObservers.acceptDiff(T.URI.revive(L),W)}async $runTestsForProvider(A,L){const W=this.providers.get(A.providerId);if(!!W){const j=A.ids.map(H=>{var $;return($=this.ownedTests.getTestById(H))===null||$===void 0?void 0:$[1]}).filter(i.isDefined),K=A.excludeExtIds.map(H=>this.ownedTests.getTestById(H)).filter(i.isDefined).filter(([H,$])=>j.some(M=>H.comparePositions(M,$)===1));if(!!j.length)try{await W.runTests({setState:(H,$)=>{for(const[M,U]of K){const F=M.comparePositions(U,H.id);if(F===1||F===3)return}this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(A.runId,H.id,m.TestState.from($))},tests:j.map(H=>s.unwrap(H.actual)),exclude:K.map(([,H])=>s.unwrap(H.actual)),debug:A.debug},L);for(const{collection:H}of this.testSubscriptions.values())H.flushDiff();return}catch(H){throw console.error(H),H}}}$lookupTest(A){const L=this.ownedTests.getTestById(A.testId);if(!L)return Promise.resolve(void 0);const W=L[1],{actual:j,previousChildren:K,previousEquals:H}=W,$=dn(W,["actual","previousChildren","previousEquals"]);return Promise.resolve($)}flushCollectionDiffs(){for(const{collection:A}of this.testSubscriptions.values())A.flushDiff()}getInternalTestForReference(A){var L,W;return(W=(L=this.workspaceObservers.getMirroredTestDataByReference(A))!==null&&L!==void 0?L:(0,p.mapFind)(this.testSubscriptions.values(),j=>j.collection.getTestByReference(A)))!==null&&W!==void 0?W:this.textDocumentObservers.getMirroredTestDataByReference(A)}async createDefaultDocumentTestHierarchy(A,L,W,j){var K;if(!!W){const H=await A.provideWorkspaceTestHierarchy(W,j);if(!!H){const $=new I.Emitter;(K=H.onDidInvalidateTest)===null||K===void 0||K.call(H,U=>{const F=s.getWrapperForTestItem(U,L);F.hasNodeMatchingFilter&&$.fire(F)});const M=new I.Emitter;return H.onDidChangeTest(U=>{const F=s.getWrapperForTestItem(U,L);if(F.hasNodeMatchingFilter){if(F.reset(),F.hasNodeMatchingFilter){M.fire(F);return}M.fire(F.visibleParent);return}const O=F.visibleParent;F.reset(),!!F.hasNodeMatchingFilter&&(O.reset(),M.fire(O))}),j.onCancellationRequested(()=>{s.removeFilter(L),M.dispose()}),{root:s.getWrapperForTestItem(H.root,L),discoveredInitialTests:H.discoveredInitialTests,onDidInvalidateTest:$.event,onDidChangeTest:M.event}}}}};r=je([Ue(0,l.IExtHostRpcService),Ue(1,f.IExtHostDocumentsAndEditors),Ue(2,g.IExtHostWorkspace)],r),e.ExtHostTesting=r;class s{constructor(A,L,W){this.actual=A,this.filterDocument=L,this.parent=W,this.getWrappedChildren()}static removeFilter(A){this.wrapperMap.delete(A)}static getWrapperForTestItem(A,L,W){let j=this.wrapperMap.get(L);if(j==null?void 0:j.has(A))return j.get(A);j||(j=new WeakMap,this.wrapperMap.set(L,j));const K=new s(A,L,W);return j.set(A,K),K}static unwrap(A){return A instanceof s?A.actual:A}get id(){return this.actual.id}get label(){return this.actual.label}get debuggable(){return this.actual.debuggable}get description(){return this.actual.description}get location(){return this.actual.location}get runnable(){return this.actual.runnable}get children(){return this.getWrappedChildren().filter(A=>A.hasNodeMatchingFilter)}get visibleParent(){return this.hasNodeMatchingFilter?this:this.parent.visibleParent}get hasNodeMatchingFilter(){var A;return this.matchesFilter===void 0&&(this.matchesFilter=!this.parent||((A=this.actual.location)===null||A===void 0?void 0:A.uri.toString())===this.filterDocument.uri.toString()||this.getWrappedChildren().some(L=>L.hasNodeMatchingFilter)),this.matchesFilter}reset(){var A;this!==this.visibleParent&&((A=this.parent)===null||A===void 0||A.reset()),this.matchesFilter=void 0}getWrappedChildren(){var A;return((A=this.actual.children)===null||A===void 0?void 0:A.map(L=>s.getWrapperForTestItem(L,this.filterDocument,this)))||[]}}e.TestItemFilteredWrapper=s,s.wrapperMap=new WeakMap;class a extends d.IncrementalChangeCollector{constructor(A,L){super();this.collection=A,this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,m.TestItem.toPlainShallow(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{collection:A,added:L,updated:W,removed:j}=this;return{get added(){return[...L].map(A.getPublicTestItem,A)},get updated(){return[...W].map(A.getPublicTestItem,A)},get removed(){return[...j].map(A.getPublicTestItem,A)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class n extends d.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new I.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(A){let L=[];for(const W of A){const j=this.items.get(W);j&&L.push(this.getPublicTestItem(j))}return L}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,L){return Object.assign(Object.assign({},A),{revived:m.TestItem.toPlainShallow(A.item),depth:L?L.depth+1:0,children:new Set})}createChangeCollector(){return new a(this,this.changeEmitter)}getPublicTestItem(A){return A.wrapped||(A.wrapped=new c(A,this)),A.wrapped}}e.MirroredTestCollection=n;class c{constructor(A,L){u.set(this,void 0),o.set(this,void 0),tt(this,u,A),tt(this,o,L)}get id(){return $e(this,u).revived.id}get label(){return $e(this,u).revived.label}get description(){return $e(this,u).revived.description}get location(){return $e(this,u).revived.location}get runnable(){var A;return(A=$e(this,u).revived.runnable)!==null&&A!==void 0?A:!0}get debuggable(){var A;return(A=$e(this,u).revived.debuggable)!==null&&A!==void 0?A:!1}get children(){return $e(this,o).getAllAsTestItem($e(this,u).children)}toJSON(){return{id:this.id,label:this.label,description:this.description,location:this.location,runnable:this.runnable,debuggable:this.debuggable,children:this.children.map(L=>L.toJSON()),providerId:$e(this,u).providerId,testId:this.id}}}u=new WeakMap,o=new WeakMap;class b{constructor(){this.resources=new Map}checkout(A){var L,W;const j=A.toString(),K=(L=this.resources.get(j))!==null&&L!==void 0?L:this.createObserverData(A);return(W=K.pendingDeletion)===null||W===void 0||W.dispose(),K.observers++,{onDidChangeTest:K.tests.onDidChangeTests,onDidDiscoverInitialTests:new I.Emitter().event,get tests(){return K.tests.rootTestItems},dispose:(0,C.once)(()=>{--K.observers||(K.pendingDeletion=this.eventuallyDispose(A))})}}getMirroredTestDataByReference(A){for(const{tests:L}of this.resources.values()){const W=L.getMirroredTestDataByReference(A);if(W)return W}}eventuallyDispose(A){return(0,D.disposableTimeout)(()=>this.unlisten(A),10*1e3)}createObserverData(A){const L=new n,W=this.listen(A,K=>L.apply(K)),j={observers:0,tests:L,listener:W};return this.resources.set(A.toString(),j),j}unlisten(A){var L;const W=A.toString(),j=this.resources.get(W);j&&(j.observers=-1,(L=j.pendingDeletion)===null||L===void 0||L.dispose(),j.listener.dispose(),this.resources.delete(W))}}class w extends b{constructor(A){super();this.proxy=A,this.diffListeners=new Map}acceptDiff(A,L){var W;(W=this.diffListeners.get(A.toString()))===null||W===void 0||W(L)}listen(A,L){this.proxy.$subscribeToDiffs(0,A);const W=A.toString();return this.diffListeners.set(W,L),new y.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,A),this.diffListeners.delete(W)})}}class h extends b{constructor(A,L){super();this.proxy=A,this.documents=L,this.diffListeners=new Map}acceptDiff(A,L){var W;(W=this.diffListeners.get(A.toString()))===null||W===void 0||W(L)}listen(A,L){if(!this.documents.getDocument(A))return new y.Disposable(()=>{});const j=A.toString();return this.diffListeners.set(j,L),this.proxy.$subscribeToDiffs(1,A),new y.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,A),this.diffListeners.delete(j)})}}}),define(ge[258],pe([0,1,12,53,33,76,23,11,7,24,9,15,2,138,170,83,60,212,256,31]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(w,h,_,A){this.configurationService=w,this.workspaceContextService=h,this.editorGroupsService=_,this.pathService=A}text(w,h,_={}){w=this.getContentPattern(w,_);const A=this.configurationService.getValue(),L=h&&h.some(j=>!this.configurationService.getValue({resource:j}).search.useRipgrep),W=this.commonQuery(h==null?void 0:h.map(y.toWorkspaceFolder),_);return Object.assign(Object.assign({},W),{type:2,contentPattern:w,previewOptions:_.previewOptions,maxFileSize:_.maxFileSize,usePCRE2:A.search.usePCRE2||L||!1,beforeContext:_.beforeContext,afterContext:_.afterContext,userDisabledExcludesAndIgnoreFiles:_.disregardExcludeSettings&&_.disregardIgnoreFiles})}getContentPattern(w,h){const _=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const A=Object.assign(Object.assign({},w),{wordSeparators:_.editor.wordSeparators});return this.isCaseSensitive(w,h)&&(A.isCaseSensitive=!0),this.isMultiline(w)&&(A.isMultiline=!0),A}file(w,h={}){const _=this.commonQuery(w,h);return Object.assign(Object.assign({},_),{type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey})}handleIncludeExclude(w,h){return w?(w=Array.isArray(w)?w.map(a):a(w),h?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],h={}){const _=this.handleIncludeExclude(h.includePattern,h.expandPatterns),A=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),L=w.length>1,W=(_.searchPaths&&_.searchPaths.length?_.searchPaths.map(H=>this.getFolderQueryForSearchPath(H,h,A)):w.map(H=>this.getFolderQueryForRoot(H,h,A,L))).filter(H=>!!H),j={_reason:h._reason,folderQueries:W,usingSearchPaths:!!(_.searchPaths&&_.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:A.pattern,includePattern:_.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const $=p.coalesce(p.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(F=>F.resource)))).filter(U=>(0,d.pathIncludedInQuery)(j,U.fsPath)),M=this.commonQueryFromFileList($);return Object.assign(Object.assign({},j),M)}const K=h.extraFileResources&&h.extraFileResources.filter(H=>(0,d.pathIncludedInQuery)(j,H.fsPath));return j.extraFileResources=K&&K.length?K:void 0,j}commonQueryFromFileList(w){const h=[],_=new C.ResourceMap,A={};let L=!1;return w.forEach(W=>{var j,K;if(W.scheme!==P.Schemas.walkThrough)if((0,i.isAbsolutePath)(W)){const $=(K=(j=this.workspaceContextService.getWorkspaceFolder(W))===null||j===void 0?void 0:j.uri)!==null&&K!==void 0?K:W.with({path:S.dirname(W.fsPath)});let M=_.get($);M||(L=!0,M={folder:$,includePattern:{}},h.push(M),_.set($,M));const U=S.relative($.fsPath,W.fsPath);(0,k.assertIsDefined)(M.includePattern)[U.replace(/\\/g,"/")]=!0}else W.fsPath&&(L=!0,A[W.fsPath]=!0)}),{folderQueries:h,includePattern:A,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(w,h){if(h.isSmartCase){if(w.isRegExp){if(T.containsUppercaseCharacter(w.pattern,!0))return!0}else if(T.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,f.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const h=M=>S.isAbsolute(M)||/^\.\.?([\/\\]|$)/.test(M),A=(Array.isArray(w)?w:r(w)).map(M=>{const U=this.pathService.resolvedUserHome;return U?(0,I.untildify)(M,U.scheme===P.Schemas.file?U.fsPath:U.path):M}),L=D.groupBy(A,M=>h(M)?"searchPaths":"exprSegments"),W=(L.exprSegments||[]).map(M=>T.rtrim(M,"/")).map(M=>T.rtrim(M,"\\")).map(M=>(M[0]==="."&&(M="*"+M),s(M))),j={},K=this.expandSearchPathPatterns(L.searchPaths||[]);K&&K.length&&(j.searchPaths=K);const H=p.flatten(W),$=t(...H);return $&&(j.pattern=$),j}getExcludesForFolder(w,h){return h.disregardExcludeSettings?void 0:(0,d.getExcludes)(w,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const h=p.flatten(w.map(A=>{let{pathPortion:L,globPortion:W}=o(A);W&&(W=n(W));const j=this.expandOneSearchPath(L);return p.flatten(j.map(K=>this.resolveOneSearchPathPattern(K,W)))})),_=new Map;return h.forEach(A=>{const L=A.searchPath.toString(),W=_.get(L);W?A.pattern&&(W.pattern=W.pattern||{},W.pattern[A.pattern]=!0):_.set(L,{searchPath:A.searchPath,pattern:A.pattern?t(A.pattern):void 0})}),Array.from(_.values())}expandOneSearchPath(w){if(S.isAbsolute(w)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==P.Schemas.file?[{searchPath:h[0].uri.with({path:w})}]:[{searchPath:E.URI.file(S.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=a(w),w.startsWith("../")||w===".."){const A=S.posix.resolve(h.path,w);return[{searchPath:h.with({path:A})}]}const _=n(w);return[{searchPath:h,pattern:_}]}else{if(w==="./"||w===".\\")return[];{const h=w.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(h){const _=h[1],A=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===_);if(A.length)return A.map(L=>{const W=h[2];return{searchPath:L.uri,pattern:W&&n(W)}});{const L=l.localize(0,null,_);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(w,h){const _=w.pattern&&h?`${w.pattern}/${h}`:w.pattern||h,A=[{searchPath:w.searchPath,pattern:_}];return _&&!_.endsWith("**")&&A.push({searchPath:w.searchPath,pattern:_+"/**"}),A}getFolderQueryForSearchPath(w,h,_){const A=this.getFolderQueryForRoot((0,y.toWorkspaceFolder)(w.searchPath),h,_,!1);return A?Object.assign(Object.assign({},A),{includePattern:w.pattern}):null}getFolderQueryForRoot(w,h,_,A){let L;const W=E.URI.isUri(w)?w:w.uri;if(_.searchPaths){const M=_.searchPaths.filter(U=>(0,i.isEqual)(U.searchPath,W))[0];if(M&&!M.pattern)return null;M&&(L=M.pattern)}const j=this.configurationService.getValue({resource:W}),K=this.getExcludesForFolder(j,h),H=Object.assign(Object.assign({},K||{}),L||{}),$=E.URI.isUri(w)?(0,i.basename)(w):w.name;return{folder:W,folderName:A?$:void 0,excludePattern:Object.keys(H).length>0?H:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!j.search.followSymlinks}}};u=je([Ue(0,m.IConfigurationService),Ue(1,y.IWorkspaceContextService),Ue(2,g.IEditorGroupsService),Ue(3,v.IPathService)],u),e.QueryBuilder=u;function o(b){const w=b.match(/[\*\{\}\(\)\[\]\?]/);if(w){const h=w.index,_=b.substr(0,h).match(/[/|\\][^/\\]*$/);if(_){let A=b.substr(0,_.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:b.substr((_.index||0)+1)}}}return{pathPortion:b}}function t(...b){return b.length?b.reduce((w,h)=>(w[h]=!0,w),Object.create(null)):void 0}function r(b){return R.splitGlobAware(b,",").map(w=>w.trim()).filter(w=>!!w.length)}function s(b){return[`**/${b}/**`,`**/${b}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function a(b){return b.replace(/\\/g,"/")}function n(b){return a(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(b,w){b=p.distinct(b,A=>A.toString());const h=[],_=w.getWorkspace();return b&&b.forEach(A=>{let L;if(w.getWorkbenchState()===2)L=(0,i.relativePath)(_.folders[0].uri,A),L&&L!=="."&&(L="./"+L);else{const W=w.getWorkspaceFolder(A);if(W){const j=W.name;if(_.folders.filter(H=>H.name===j).length===1){const H=(0,i.relativePath)(W.uri,A);H===""?L=`./${W.name}`:L=`./${W.name}/${H}`}else L=A.fsPath}}L&&h.push(L)}),h}e.resolveResourcesForSearchIncludes=c}),define(ge[259],pe([0,1,24,2,21,18,4,258,31,60]),function(Z,e,p,D,R,I,C,P,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function k(m,y){const g=y.activationEvents;if(!g)return Promise.resolve(void 0);const v=[],d=[];for(const a of g)if(/^workspaceContains:/.test(a)){const n=a.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||m.forceUsingSearch?d.push(n):v.push(n)}if(v.length===0&&d.length===0)return Promise.resolve(void 0);let u;const o=new Promise((a,n)=>{u=a}),t=a=>u({activationEvent:a}),r=Promise.all(v.map(a=>E(m,a,t))).then(()=>{}),s=f(m,y.identifier,d,t);return Promise.all([r,s]).then(()=>{u(void 0)}),o}e.checkActivateWorkspaceContainsExtension=k;async function E(m,y,g){for(const v of m.folders)if(await m.exists(p.joinPath(D.URI.revive(v),y))){g(`workspaceContains:${y}`);return}}async function f(m,y,g,v){if(g.length===0)return Promise.resolve(void 0);const d=new R.CancellationTokenSource,u=m.checkExists(m.folders,g,d.token),o=setTimeout(async()=>{d.cancel(),v(`workspaceContainsTimeout:${g.join(",")}`)},T);let t=!1;try{t=await u}catch(r){I.isPromiseCanceledError(r)||I.onUnexpectedError(r)}d.dispose(),clearTimeout(o),t&&v(`workspaceContains:${g.join(",")}`)}function l(m,y,g,v){const d=m.get(C.IInstantiationService),u=m.get(S.ISearchService),t=d.createInstance(P.QueryBuilder).file(y.map(r=>(0,i.toWorkspaceFolder)(D.URI.revive(r))),{_reason:"checkExists",includePattern:g,exists:!0});return u.fileSearch(t,v).then(r=>!!r.limitHit,r=>I.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=l});var tt=this&&this.__classPrivateFieldSet||function(Z,e,p){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,p),p},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[42],pe([0,1,159,7,67,24,19,6,23,2,13,5,35,223,88,32,41,221,18,29,11,26,193,8,112,4,27,89,14,81,50,34,3,259,86,194]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g,v,d,u,o,t,r,s,a,n,c,b,w,h,_,A,L,W,j){"use strict";var K,H,$;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let M=class Ln extends P.Disposable{constructor(O,V,q,Y,fe,_e,Le,Ie,Fe,z){super();this._onDidChangeRemoteConnectionData=this._register(new A.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=V,this._extHostContext=q,this._initData=Le,this._extHostWorkspace=Y,this._extHostConfiguration=fe,this._logService=_e,this._extHostTunnelService=Fe,this._extHostTerminalService=z,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._registry=new g.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new W.ExtHostSecretState(this._extHostContext),this._storagePath=Ie,this._instaService=O.createChild(new w.ServiceCollection([l.IExtHostStorage,this._storage],[W.IExtHostSecretState,this._secretState]));const Q=new Set;this._initData.hostExtensions.forEach(te=>Q.add(d.ExtensionIdentifier.toKey(te))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(te,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,ae)},actualActivateExtension:async(te,ae)=>{if(Q.has(d.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,ae),new f.HostExtension;const ve=this._registry.getExtensionDescription(te);return this._activateExtension(ve,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),R.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){v.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this._deactivate(fe))}catch(V){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,V){return this._activator.activateByEvent(O,V)}_activateById(O,V){return this._activator.activateById(O,V)}activateByIdWithErrors(O,V){return this._activateById(O,V).then(()=>{const q=this._activator.getActivatedExtension(O);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=S.TernarySearchTree.forPaths(),V=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(Y=>O.set(i.URI.file(Y).fsPath,q))});this._extensionPathIndex=Promise.all(V).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let V=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return V;const q=this._activator.getActivatedExtension(O);if(!q)return V;try{typeof q.module.deactivate=="function"&&(V=Promise.resolve(q.module.deactivate()).then(void 0,Y=>Promise.resolve(void 0)))}catch(Y){}try{(0,P.dispose)(q.subscriptions)}catch(Y){}return V}async _activateExtension(O,V){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,V).then(q=>{const Y=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,Y.codeLoadingTime,Y.activateCallTime,Y.activateResolvedTime,V),this._logExtensionActivationTimes(O,V,"success",Y),q},q=>{throw this._logExtensionActivationTimes(O,V,"failure"),q})}_logExtensionActivationTimes(O,V,q,Y){const fe=U(O,V);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},fe),Y||{}),{outcome:q}))}_doActivateExtension(O,V){const q=U(O,V);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const Y=this._getEntryPoint(O);if(!Y)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(V)}`),this._logService.flush();const fe=new f.ExtensionActivationTimesBuilder(V.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,I.joinPath)(O.extensionLocation,Y),fe),this._loadExtensionContext(O)]).then(_e=>(R.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Ln._callActivate(this._logService,O.identifier,_e[0],_e[1],fe))).then(_e=>(R.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),_e))}_loadExtensionContext(O){const V=new t.ExtensionGlobalMemento(O,this._storage),q=new t.ExtensionMemento(O.identifier.value,!1,this._storage),Y=new j.ExtensionSecrets(O,this._secretState),fe=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,_e=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([V.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Le=this;let Ie;return Object.freeze({globalState:V,workspaceState:q,secrets:Y,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Fe){return D.join(O.extensionLocation.fsPath,Fe)},get storagePath(){var Fe;return(Fe=Le._storagePath.workspaceValue(O))===null||Fe===void 0?void 0:Fe.fsPath},get globalStoragePath(){return Le._storagePath.globalValue(O).fsPath},get logPath(){return D.join(Le._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return i.URI.joinPath(Le._initData.logsLocation,O.identifier.value)},get storageUri(){return Le._storagePath.workspaceValue(O)},get globalStorageUri(){return Le._storagePath.globalValue(O)},get extensionMode(){return fe},get extension(){return(0,y.checkProposedApiEnabled)(O),Ie===void 0&&(Ie=new F(this,O.identifier,O,_e)),Ie},get extensionRuntime(){return(0,y.checkProposedApiEnabled)(O),Le.extensionRuntime},get environmentVariableCollection(){return Le._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,V,q,Y,fe){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,V,q,Y,fe).then(_e=>new f.ActivatedExtension(!1,null,fe.build(),q,_e,Y.subscriptions))}static _callActivateOptional(O,V,q,Y,fe){if(typeof q.activate=="function")try{fe.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${V.value}`);const _e=typeof global=="object"?global:self,Le=q.activate.apply(_e,[Y]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(Le).then(Ie=>(fe.activateResolveStop(),Ie))}catch(_e){return Promise.reject(_e)}else return Promise.resolve(q)}_activateOneStartupFinished(O,V){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:V}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(R.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const V of O.activationEvents)V==="onStartupFinished"&&this._activateOneStartupFinished(O,V)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,fe=>{this._logService.error(fe)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(fe=>this._handleWorkspaceContainsEagerExtensions(fe.added)));const V=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(V),Y=Promise.all([O,q]).then(()=>{});return Promise.race([Y,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Y}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(V=>this._handleWorkspaceContainsEagerExtension(O,V))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,V){if(!this.isActivated(V.identifier)){const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Y={folders:O.map(_e=>_e.uri),forceUsingSearch:q,exists:_e=>this._hostUtils.exists(_e.fsPath),checkExists:(_e,Le,Ie)=>this._mainThreadWorkspaceProxy.$checkExists(_e,Le,Ie)},fe=await(0,L.checkActivateWorkspaceContainsExtension)(Y,V);if(!!fe)return this._activateById(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:fe.activationEvent}).then(void 0,_e=>this._logService.error(_e))}}$extensionTestsExecute(){return this._doHandleExtensionTests().then(void 0,O=>(console.error(O),Promise.reject(O)))}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:V}=this._initData.environment;if(!O||!V||V.scheme!==u.Schemas.file)throw new Error(p.localize(0,null));const q=(0,I.originalFSPath)(V),Y=await this._loadCommonJSModule(null,i.URI.file(q),new f.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(p.localize(1,null,q));return new Promise((fe,_e)=>{const Le=(Fe,z)=>{Fe?_e(Fe):fe(typeof z=="number"&&z>0?1:0)},Ie=Y.run(q,Le);Ie&&Ie.then&&Ie.then(()=>{fe(0)}).catch(Fe=>{_e(Fe.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,V){return this._resolvers[O]=V,(0,P.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,V){const q=O.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const Y=O.substr(0,q);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1);const fe=this._resolvers[Y];if(!fe)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{R.mark(`code/extHost/willResolveAuthority/${Y}`);const _e=await fe.resolve(O,{resolveAttempt:V});R.mark(`code/extHost/didResolveAuthorityOK/${Y}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(fe));const Le={authority:O,host:_e.host,port:_e.port,connectionToken:_e.connectionToken},Ie={extensionHostEnv:_e.extensionHostEnv};return{type:"ok",value:{authority:Le,options:Ie,tunnelInformation:{environmentTunnels:_e.environmentTunnels}}}}catch(_e){if(R.mark(`code/extHost/didResolveAuthorityError/${Y}`),_e instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:_e._code,message:_e._message,detail:_e._detail}};throw _e}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,V){return V===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(O,!1))}async $activate(O,V){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,V),!0):!1}async $deltaExtensions(O,V){O.forEach(Y=>Y.extensionLocation=i.URI.revive(Y.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(V.map(async Y=>{const fe=this._registry.getExtensionDescription(Y);if(!!fe){const _e=await this._hostUtils.realpath(fe.extensionLocation.fsPath);q.delete(i.URI.file(_e).fsPath)}})),await Promise.all(O.map(async Y=>{const fe=await this._hostUtils.realpath(Y.extensionLocation.fsPath);q.set(i.URI.file(fe).fsPath,Y)})),this._registry.deltaExtensions(O,V),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let V=o.VSBuffer.alloc(O),q=Math.random()%256;for(let Y=0;Y<O;Y++)V.writeUInt8(q,Y);return V}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};M=je([Ue(0,a.IInstantiationService),Ue(1,e.IHostUtils),Ue(2,b.IExtHostRpcService),Ue(3,m.IExtHostWorkspace),Ue(4,E.IExtHostConfiguration),Ue(5,T.ILogService),Ue(6,n.IExtHostInitDataService),Ue(7,c.IExtensionStoragePaths),Ue(8,h.IExtHostTunnelService),Ue(9,_.IExtHostTerminalService)],M),e.AbstractExtHostExtensionService=M;function U(N,O){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class F{constructor(O,V,q,Y){K.set(this,void 0),H.set(this,void 0),$.set(this,void 0),tt(this,K,O),tt(this,H,V),tt(this,$,q.identifier),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=D.normalize((0,I.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=Y}get isActive(){return $e(this,K).isActivated($e(this,$))}get exports(){if(this.packageJSON.api!=="none")return $e(this,K).getExtensionExports($e(this,$))}activate(){return $e(this,K).activateByIdWithErrors($e(this,$),{startup:!1,extensionId:$e(this,H),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,K=new WeakMap,H=new WeakMap,$=new WeakMap}),define(ge[45],pe([0,1,7,2,3,19,5,8,118,32,42,38,211,35,200,14,4,15]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let v=class{constructor(n,c,b,w,h){this._workspaceService=c,this._extensionService=b,this._editorsService=w,this._configurationService=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new R.Emitter,this._onDidTerminateDebugSession=new R.Emitter,this._onDidChangeActiveDebugSession=new R.Emitter,this._onDidReceiveDebugSessionCustomEvent=new R.Emitter,this._debugServiceProxy=n.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new R.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new u(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(_=>{_.onDidChange(A=>{this.registerAllDebugTypes(_)}),this.registerAllDebugTypes(_)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(n,c){const b=n;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let w=`debug:${encodeURIComponent(b.path||"")}`,h="?";return c&&(w+=`${h}session=${encodeURIComponent(c.id)}`,h="&"),w+=`${h}ref=${b.sourceReference}`,D.URI.parse(w)}else{if(b.path)return D.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const c=[];for(const b of n.getAllExtensionDescriptions())if(b.contributes){const w=b.contributes.debuggers;if(w&&w.length>0)for(const h of w)(0,l.isDebuggerMainContribution)(h)&&c.push(h.type)}this._debugServiceProxy.$registerDebugTypes(c)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(c=>n.push(c)),n}addBreakpoints(n){this.startBreakpoints();const c=n.filter(h=>{const _=h.id;return this._breakpoints.has(_)?!1:(this._breakpoints.set(_,h),!0)});this.fireBreakpointChanges(c,[],[]);const b=[],w=new Map;for(const h of c)if(h instanceof P.SourceBreakpoint){let _=w.get(h.location.uri.toString());_||(_={type:"sourceMulti",uri:h.location.uri,lines:[]},w.set(h.location.uri.toString(),_),b.push(_)),_.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof P.FunctionBreakpoint&&b.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this._debugServiceProxy.$registerBreakpoints(b)}removeBreakpoints(n){this.startBreakpoints();const c=n.filter(_=>this._breakpoints.delete(_.id));this.fireBreakpointChanges([],c,[]);const b=c.filter(_=>_ instanceof P.SourceBreakpoint).map(_=>_.id),w=c.filter(_=>_ instanceof P.FunctionBreakpoint).map(_=>_.id),h=c.filter(_=>_ instanceof P.DataBreakpoint).map(_=>_.id);return this._debugServiceProxy.$unregisterBreakpoints(b,w,h)}startDebugging(n,c,b){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,c,{parentSessionID:b.parentSession?b.parentSession.id:void 0,repl:b.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,c,b){if(!c)return new P.Disposable(()=>{});const w=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:w,provider:c}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,b,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,w),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(h=>h.provider!==c),this._debugServiceProxy.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(n,c,b){if(!b)return new P.Disposable(()=>{});if(!this.definesDebugType(n,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.getAdapterDescriptorFactoryByType(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:c,handle:w,factory:b}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(c,w),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(h=>h.factory!==b),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(n,c){if(!c)return new P.Disposable(()=>{});const b=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:b,factory:c}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(w=>w.factory!==c)})}async $runInTerminal(n,c){return Promise.resolve(void 0)}async $substituteVariables(n,c){if(!this._variableResolver){const[h,_]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(h||[],this._editorsService,_)}let b;const w=await this.getFolder(n);return w&&(b={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(b,c)}createDebugAdapter(n,c){if(n.type==="implementation")return new r(n.implementation)}createSignService(){}async $startDASession(n,c){const b=this,w=await this.getSession(c);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(w.type),w).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const _=this.convertToDto(h),A=this.createDebugAdapter(_,w);if(!A)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const L=A;return this._debugAdapters.set(n,L),this.getDebugAdapterTrackers(w).then(W=>(W&&this._debugAdaptersTrackers.set(n,W),L.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const K=j,H={type:"response",seq:0,command:K.command,request_seq:K.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(K.arguments.value);H.body={signature:$},L.sendResponse(H)}else throw new Error("no signer")}catch($){H.success=!1,H.message=$.message,L.sendResponse(H)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(j),j=(0,l.convertToVSCPaths)(j,!0),b._debugServiceProxy.$acceptDAMessage(n,j)}),L.onError(j=>{W&&W.onError&&W.onError(j),this._debugServiceProxy.$acceptDAError(n,j.name,j.message,j.stack)}),L.onExit(j=>{W&&W.onExit&&W.onExit((0,g.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,g.withNullAsUndefined)(j),void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),L.startSession()))})}$sendDAMessage(n,c){c=(0,l.convertToDAPaths)(c,!1);const b=this._debugAdaptersTrackers.get(n);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(c);const w=this._debugAdapters.get(n);w&&w.sendMessage(c)}$stopDASession(n){const c=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),c&&c.onWillStopSession&&c.onWillStopSession();const b=this._debugAdapters.get(n);return this._debugAdapters.delete(n),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const c=[],b=[],w=[];if(n.added)for(const h of n.added){const _=h.id;if(_&&!this._breakpoints.has(_)){let A;if(h.type==="function")A=new P.FunctionBreakpoint(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")A=new P.DataBreakpoint(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const L=D.URI.revive(h.uri);A=new P.SourceBreakpoint(new P.Location(L,new P.Position(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}A._id=_,this._breakpoints.set(_,A),c.push(A)}}if(n.removed)for(const h of n.removed){const _=this._breakpoints.get(h);_&&(this._breakpoints.delete(h),b.push(_))}if(n.changed){for(const h of n.changed)if(h.id){const _=this._breakpoints.get(h.id);if(_){if(_ instanceof P.FunctionBreakpoint&&h.type==="function"){const A=_;A.enabled=h.enabled,A.condition=h.condition,A.hitCondition=h.hitCondition,A.logMessage=h.logMessage,A.functionName=h.functionName}else if(_ instanceof P.SourceBreakpoint&&h.type==="source"){const A=_;A.enabled=h.enabled,A.condition=h.condition,A.hitCondition=h.hitCondition,A.logMessage=h.logMessage,A.location=new P.Location(D.URI.revive(h.uri),new P.Position(h.line,h.character))}w.push(_)}}}this.fireBreakpointChanges(c,b,w)}$provideDebugConfigurations(n,c,b){return(0,I.asPromise)(async()=>{const w=this.getConfigProviderByHandle(n);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.getFolder(c);return w.provideDebugConfigurations(h,b)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(n,c,b,w){return(0,I.asPromise)(async()=>{const h=this.getConfigProviderByHandle(n);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const _=await this.getFolder(c);return h.resolveDebugConfiguration(_,b,w)})}$resolveDebugConfigurationWithSubstitutedVariables(n,c,b,w){return(0,I.asPromise)(async()=>{const h=this.getConfigProviderByHandle(n);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const _=await this.getFolder(c);return h.resolveDebugConfigurationWithSubstitutedVariables(_,b,w)})}async $provideDebugAdapter(n,c){const b=this.getAdapterDescriptorFactoryByHandle(n);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.getSession(c);return this.getAdapterDescriptor(b,w).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.convertToDto(h)})}async $acceptDebugSessionStarted(n){const c=await this.getSession(n);this._onDidStartDebugSession.fire(c)}async $acceptDebugSessionTerminated(n){const c=await this.getSession(n);c&&(this._onDidTerminateDebugSession.fire(c),this._debugSessions.delete(c.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,c){const b=await this.getSession(n);b&&b._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(n,c){const w={session:await this.getSession(n),event:c.event,body:c.body};this._onDidReceiveDebugSessionCustomEvent.fire(w)}convertToDto(n){if(n instanceof P.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof P.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const c=this._adapterFactories.filter(b=>b.type===n);if(c.length>0)return c[0].factory}getAdapterDescriptorFactoryByHandle(n){const c=this._adapterFactories.filter(b=>b.handle===n);if(c.length>0)return c[0].factory}getConfigProviderByHandle(n){const c=this._configProviders.filter(b=>b.handle===n);if(c.length>0)return c[0].provider}definesDebugType(n,c){if(n.contributes){const b=n.contributes.debuggers;if(b&&b.length>0){for(const w of b)if(w.label&&w.type&&w.type===c)return!0}}return!1}getDebugAdapterTrackers(n){const b=n.configuration.type,w=this._trackerFactories.filter(h=>h.type===b||h.type==="*").map(h=>(0,I.asPromise)(()=>h.factory.createDebugAdapterTracker(n)).then(_=>_,_=>null));return Promise.race([Promise.all(w).then(h=>{const _=h.filter(A=>!!A);if(_.length>0)return new t(_)}),new Promise((h,_)=>{const A=setTimeout(()=>{clearTimeout(A),_(new Error("timeout"))},1e3)})]).catch(h=>{})}async getAdapterDescriptor(n,c){const b=c.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new P.DebugAdapterServer(b));if(n){const h=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>n.createDebugAdapterDescriptor(c,this.daExecutableFromPackage(c,h))).then(_=>{if(_)return _})}const w=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(c,w))}daExecutableFromPackage(n,c){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,c,b){(n.length>0||c.length>0||b.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:c,changed:b}))}async getSession(n){if(n)if(typeof n=="string"){const c=this._debugSessions.get(n);if(c)return c}else{let c=this._debugSessions.get(n.id);if(!c){const b=await this.getFolder(n.folderUri);c=new d(this._debugServiceProxy,n.id,n.type,n.name,b,n.configuration),this._debugSessions.set(c.id,c),this._debugServiceProxy.$sessionCached(c.id)}return c}throw new Error("cannot find session")}getFolder(n){if(n){const c=D.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};v=je([Ue(0,m.IExtHostRpcService),Ue(1,i.IExtHostWorkspace),Ue(2,T.IExtHostExtensionService),Ue(3,k.IExtHostDocumentsAndEditors),Ue(4,f.IExtHostConfiguration)],v),e.ExtHostDebugServiceBase=v;class d{constructor(n,c,b,w,h,_){this._debugServiceProxy=n,this._id=c,this._type=b,this._name=w,this._workspaceFolder=h,this._configuration=_}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,c){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,c)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=d;class u{constructor(n){this.value=Object.freeze({append(c){n.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.ExtHostDebugConsole=u;class o extends E.AbstractVariableResolverService{constructor(n,c,b,w,h){super({getFolderUri:_=>{const A=n.filter(L=>L.name===_);if(A&&A.length>0)return A[0].uri},getWorkspaceFolderCount:()=>n.length,getConfigurationValue:(_,A)=>b.getConfiguration(void 0,_).get(A),getAppRoot:()=>w?w.VSCODE_CWD:void 0,getExecPath:()=>w?w.VSCODE_EXEC_PATH:void 0,getFilePath:()=>{if(c){const _=c.activeEditor();if(_)return p.normalize(_.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(c&&h){const _=c.activeEditor();if(_){const A=h.getWorkspaceFolder(_.document.uri);if(A)return p.normalize(A.uri.fsPath)}}},getSelectedText:()=>{if(c){const _=c.activeEditor();if(_&&!_.selection.isEmpty)return _.document.getText(_.selection)}},getLineNumber:()=>{if(c){const _=c.activeEditor();if(_)return String(_.selection.end.line+1)}}},void 0,w)}}e.ExtHostVariableResolverService=o;class t{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(c=>c.onError?c.onError(n):void 0)}onExit(n,c){this.trackers.forEach(b=>b.onExit?b.onExit(n,c):void 0)}}class r extends S.AbstractDebugAdapter{constructor(n){super();this.implementation=n,n.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends v{constructor(n,c,b,w,h){super(n,c,b,w,h)}createVariableResolver(n,c,b){return new o(n,c,b)}};s=je([Ue(0,m.IExtHostRpcService),Ue(1,i.IExtHostWorkspace),Ue(2,T.IExtHostExtensionService),Ue(3,k.IExtHostDocumentsAndEditors),Ue(4,f.IExtHostConfiguration)],s),e.WorkerExtHostDebugService=s}),define(ge[260],pe([0,1,67,2,5,35,41,29,14,27,4,42,36,13]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(d,u,o,t,r,s,a){this._apiFactory=d,this._extensionRegistry=u,this._instaService=o,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=s,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),p.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();p.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,u,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(y)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(g,u,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let u of d.nodeModuleName)this._factories.set(u,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(u=>d.alternativeModuleName(u))}};l=je([Ue(2,T.IInstantiationService),Ue(3,I.IExtHostConfiguration),Ue(4,k.IExtHostExtensionService),Ue(5,i.IExtHostInitDataService),Ue(6,f.ILogService)],l),e.RequireInterceptor=l;class m{constructor(d,u,o,t,r){this._apiFactory=d,this._extensionPaths=u,this._extensionRegistry=o,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,u){const o=this._extensionPaths.findSubstr(u.fsPath);if(o){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(o.identifier));return t||(t=this._apiFactory(o,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(o.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,s)=>t+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let y=class{constructor(d,u){this.nodeModuleName="keytar";const{environment:o}=u,t=d.getProxy(R.MainContext.MainThreadKeytar);if(o.appRoot){let r=o.appRoot.fsPath;E.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,s)=>t.$getPassword(r,s),setPassword:(r,s,a)=>t.$setPassword(r,s,a),deletePassword:(r,s)=>t.$deletePassword(r,s),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(d,u){return this._impl}alternativeModuleName(d){const u=d.length;if(!(u<=7||!this.alternativeNames)){const o=u-7;if((d.charAt(o)==="/"||d.charAt(o)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}}};y=je([Ue(0,S.IExtHostRpcService),Ue(1,i.IExtHostInitDataService)],y);let g=class{constructor(d,u,o){this._extensionPaths=d,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=o.getProxy(R.MainContext.MainThreadTelemetry);const t=o.getProxy(R.MainContext.MainThreadWindow);this._impl=(r,s)=>{const a=D.URI.parse(r);return s?this.callOriginal(r,s):a.scheme==="http"||a.scheme==="https"?t.$openUri(a,r,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?t.$openUri(a,r,{}):this.callOriginal(r,s)}}load(d,u,o){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=o(d),this._impl}callOriginal(d,u){return this.sendNoForwardTelemetry(),this._original(d,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};g=je([Ue(2,S.IExtHostRpcService)],g)}),define(ge[261],pe([0,1,165,8,201,32,42,38,35,34,14,45,186,204,19]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let m=class extends k.ExtHostDebugServiceBase{constructor(v,d,u,o,t,r){super(v,d,u,o,t);this._terminalService=r,this._integratedTerminalInstances=new y}createDebugAdapter(v,d){switch(v.type){case"server":return new R.SocketDebugAdapter(v);case"pipeServer":return new R.NamedPipeDebugAdapter(v);case"executable":return new R.ExecutableDebugAdapter(v,d.type)}return super.createDebugAdapter(v,d)}daExecutableFromPackage(v,d){const u=R.ExecutableDebugAdapter.platformAdapterExecutable(d.getAllExtensionDescriptions(),v.type);if(u)return new D.DebugAdapterExecutable(u.command,u.args,u.options)}createSignService(){return new E.SignService}async $runInTerminal(v,d){if(v.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(h=>{this._integratedTerminalInstances.onTerminalClosed(h)}));const u=await this._configurationService.getConfigProvider(),o=this._terminalService.getDefaultShell(!0,u),t=this._terminalService.getDefaultShellArgs(!0,u),r=JSON.stringify({shell:o,shellArgs:t});let s=await this._integratedTerminalInstances.checkout(r),a,n=!1;if(s)a=v.cwd;else{const h={shellPath:o,shellArgs:t,cwd:v.cwd,name:v.title||p.localize(0,null)};n=!0,s=this._terminalService.createTerminalFromOptions(h,!0),this._integratedTerminalInstances.insert(s,r)}s.show(!0);const c=await s.processId;n&&await new Promise(h=>setTimeout(h,1e3));const b=(0,f.prepareCommand)(o,v.args,a,v.env);s.sendText(b,!0);const w=this.onDidTerminateDebugSession(h=>{h.id===d&&(this._integratedTerminalInstances.free(s),w.dispose())});return c}else if(v.kind==="external")return(0,f.runInExternalTerminal)(v,await this._configurationService.getConfigProvider());return super.$runInTerminal(v,d)}createVariableResolver(v,d,u){return new k.ExtHostVariableResolverService(v,d,u,process.env,this._workspaceService)}};m=je([Ue(0,T.IExtHostRpcService),Ue(1,I.IExtHostWorkspace),Ue(2,C.IExtHostExtensionService),Ue(3,P.IExtHostDocumentsAndEditors),Ue(4,S.IExtHostConfiguration),Ue(5,i.IExtHostTerminalService)],m),e.ExtHostDebugService=m;class y{constructor(){this._terminalInstances=new Map}async checkout(v){const u=[...this._terminalInstances.entries()].map(([o,t])=>(0,l.createCancelablePromise)(async r=>{if(t.lastUsedAt!==-1&&await(0,f.hasChildProcesses)(await o.processId))return null;const s=Date.now();return t.lastUsedAt+y.minUseDelay>s||r.isCancellationRequested||t.config!==v?null:(t.lastUsedAt=s,o)}));return await(0,l.firstParallel)(u,o=>!!o)}insert(v,d){this._terminalInstances.set(v,{lastUsedAt:Date.now(),config:d})}free(v){const d=this._terminalInstances.get(v);d&&(d.lastUsedAt=-1)}onTerminalClosed(v){this._terminalInstances.delete(v)}}y.minUseDelay=1e3}),define(ge[262],pe([0,1,7,2,78,32,45,38,35,34,14,27,66,11,13,63]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let y=class extends E.ExtHostTaskBase{constructor(v,d,u,o,t,r,s,a){super(v,d,u,o,t,r,s,a);this.workspaceService=u,d.remote.isRemote&&d.remote.authority&&this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:d.remote.authority,platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(v,d){const u=d;if(!d.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const o=E.TaskHandleDTO.from(u,this.workspaceService),t=await this._proxy.$getTaskExecution(o);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(t,d);return this._proxy.$executeTask(o).catch(()=>{}),r}else{const o=E.TaskDTO.from(d,v);if(o===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(o.execution)&&await this.addCustomExecution(o,d,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(o),d);return this._proxy.$executeTask(o).catch(()=>{}),t}}provideTasksInternal(v,d,u,o){const t=[];if(o)for(let r of o){this.checkDeprecation(r,u),(!r.definition||!v[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const s=E.TaskDTO.from(r,u.extension);s&&(t.push(s),E.CustomExecutionDTO.is(s.execution)&&d.push(this.addCustomExecution(s,r,!0)))}return{tasks:t,extension:u.extension}}async resolveTaskInternal(v){return v}async getVariableResolver(v){if(this._variableResolver===void 0){const d=await this._configurationService.getConfigProvider();this._variableResolver=new C.ExtHostVariableResolverService(v,this._editorService,d,process.env,this.workspaceService)}return this._variableResolver}async $resolveVariables(v,d){const u=D.URI.revive(v),o={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(u),r=await this._workspaceProvider.getWorkspaceFolders2();if(!r||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const s=await this.getVariableResolver(r),a={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let n of d.variables)o.variables[n]=s.resolve(a,n);if(d.process!==void 0){let n;if(d.process.path!==void 0){n=d.process.path.split(p.delimiter);for(let c=0;c<n.length;c++)n[c]=s.resolve(a,n[c])}o.process=await R.win32.findExecutable(s.resolve(a,d.process.name),d.process.cwd!==void 0?s.resolve(a,d.process.cwd):void 0,n)}return o}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(v,d,u){return R.win32.findExecutable(v,d,u)}};y=je([Ue(0,T.IExtHostRpcService),Ue(1,k.IExtHostInitDataService),Ue(2,I.IExtHostWorkspace),Ue(3,P.IExtHostDocumentsAndEditors),Ue(4,S.IExtHostConfiguration),Ue(5,i.IExtHostTerminalService),Ue(6,l.ILogService),Ue(7,m.IExtHostApiDeprecationService)],y),e.ExtHostTask=y}),define(ge[263],pe([0,1,10,15,28,147,13,35,45,38,14,34,32,208,209]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let m=class extends k.BaseExtHostTerminalService{constructor(g,v,d,u,o){super(!0,g);this._extHostConfiguration=v,this._extHostWorkspace=d,this._extHostDocumentsAndEditors=u,this._logService=o,this._isWorkspaceShellAllowed=!1,(0,I.getSystemShell)(p.platform,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._updateVariableResolver(),this._registerListeners()}createTerminal(g,v,d){const u=new k.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),{name:g,shellPath:v,shellArgs:d},g);return this._terminals.push(u),u.create(v,d),u.value}createTerminalFromOptions(g,v){const d=new k.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),g,g.name);return this._terminals.push(d),d.create((0,D.withNullAsUndefined)(g.shellPath),(0,D.withNullAsUndefined)(g.shellArgs),(0,D.withNullAsUndefined)(g.cwd),(0,D.withNullAsUndefined)(g.env),void 0,(0,D.withNullAsUndefined)(g.strictEnv),(0,D.withNullAsUndefined)(g.hideFromUser),(0,D.withNullAsUndefined)(v),!0),d.value}getDefaultShell(g,v){var d;const u=o=>{const t=v.getConfiguration(o.substr(0,o.lastIndexOf("."))).inspect(o.substr(o.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(t)};return f.getDefaultShell(u,this._isWorkspaceShellAllowed,(d=this._defaultShell)!==null&&d!==void 0?d:(0,I.getSystemShellSync)(p.platform,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,f.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,g)}getDefaultShellArgs(g,v){const d=u=>{const o=v.getConfiguration(u.substr(0,u.lastIndexOf("."))).inspect(u.substr(u.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(o)};return f.getDefaultShellArgs(d,this._isWorkspaceShellAllowed,g,f.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_apiInspectConfigToPlain(g){return{userValue:g?g.globalValue:void 0,value:g?g.workspaceValue:void 0,defaultValue:g?g.defaultValue:void 0}}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>this._updateVariableResolver())}_updateLastActiveWorkspace(){const g=this._extHostDocumentsAndEditors.activeEditor();g&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(g.document.uri))}async _updateVariableResolver(){const g=await this._extHostConfiguration.getConfigProvider(),v=await this._extHostWorkspace.getWorkspaceFolders2();this._variableResolver=new S.ExtHostVariableResolverService(v||[],this._extHostDocumentsAndEditors,g,process.env)}$getAvailableShells(){return(0,l.detectAvailableShells)()}async $getDefaultShellAndArgs(g){const v=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(g,v),args:this.getDefaultShellArgs(g,v)}}$acceptWorkspacePermissionsChanged(g){this._isWorkspaceShellAllowed=g}};m=je([Ue(0,T.IExtHostRpcService),Ue(1,P.IExtHostConfiguration),Ue(2,E.IExtHostWorkspace),Ue(3,i.IExtHostDocumentsAndEditors),Ue(4,C.ILogService)],m),e.ExtHostTerminalService=m}),define(ge[264],pe([0,1,19,18,67,6,2,5,254,13,79,81,27,182,14,62,42,34]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class v{constructor(u,o,t,r){this._disposables=new I.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const s=new S.RPCProtocol(u,null,r);o=v._transform(o,s);const a=new k.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());a.set(E.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},o)),a.set(l.IExtHostRpcService,new l.ExtHostRpcService(s)),a.set(m.IURITransformerService,new m.URITransformerService(r)),a.set(y.IHostUtils,t);const n=new f.InstantiationService(a,!0),c=n.invokeFunction(_=>_.get(g.IExtHostTerminalService));this._disposables.add(c),this._logService=n.invokeFunction(_=>_.get(i.ILogService)),R.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",o),this._extensionService=n.invokeFunction(_=>_.get(y.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const b=new WeakMap;this._extensionService.getExtensionPathIndex().then(_=>{Error.prepareStackTrace=(A,L)=>{let W="",j,K;for(const H of L)W+=`
	at ${H.toString()}`,K=H.getFileName(),!j&&K&&(j=_.findSubstr(K));return b.set(A,j),`${A.name||"Error"}: ${A.message||""}${W}`}});const w=s.getProxy(P.MainContext.MainThreadExtensionService),h=s.getProxy(P.MainContext.MainThreadErrors);D.setUnexpectedErrorHandler(_=>{const A=D.transformErrorForSerialization(_),L=b.get(_);L?w.$onExtensionRuntimeError(L.identifier,A):h.$onUnexpectedError(A)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),D.setUnexpectedErrorHandler(t=>{});const o=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,p.timeout)(4e3),o]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,o){u.extensions.forEach(r=>r.extensionLocation=C.URI.revive(o.transformIncomingURIs(r.extensionLocation))),u.environment.appRoot=C.URI.revive(o.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(r=>C.URI.revive(o.transformIncomingURIs(r)))),u.environment.extensionTestsLocationURI=C.URI.revive(o.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=C.URI.revive(o.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=C.URI.revive(o.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=C.URI.revive(o.transformIncomingURIs(u.logsLocation)),u.logFile=C.URI.revive(o.transformIncomingURIs(u.logFile)),u.workspace=o.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=v}),define(ge[265],pe([0,1,7,21,58,33,24,46,31,36]),function(Z,e,p,D,R,I,C,P,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(f,l,m){this.config=f,this.provider=l,this.sessionToken=m,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&I.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&I.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const l=this.config.folderQueries||[];return new Promise((m,y)=>{const g=v=>{this.resultCount++,f(v)};if(this.isCanceled)return m({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(v=>{const d=v.toString(),u=p.basename(d);this.globalExcludePattern&&this.globalExcludePattern(d,u)||this.matchFile(g,{base:v,basename:u})}),Promise.all(l.map(v=>this.searchInFolder(v,g))).then(v=>{m({limitHit:this.isLimitHit,stats:v[0]||void 0})},v=>{y(new Error((0,R.toErrorMessage)(v)))})})}searchInFolder(f,l){const m=new D.CancellationTokenSource;return new Promise((y,g)=>{const v=this.getSearchOptionsForFolder(f),d=this.initDirectoryTree(),u=new S.QueryGlobTester(this.config,f),o=!u.hasSiblingExcludeClauses();let t;new Promise(r=>(0,i.nextTick)(r)).then(()=>(this.activeCancellationTokens.add(m),t=P.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,m.token))).then(r=>{const s=t.elapsed(),a=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(n=>{const c=p.posix.relative(f.folder.path,n.path);if(o){const b=p.basename(n.path);this.matchFile(l,{base:f.folder,relativePath:c,basename:b});return}this.addDirectoryEntries(d,f.folder,c,l)}),this.activeCancellationTokens.delete(m),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,u,l),{providerTime:s,postProcessTime:a.elapsed()})}).then(r=>{m.dispose(),y(r)},r=>{m.dispose(),g(r)})})}getSearchOptionsForFolder(f){const l=(0,S.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),m=(0,S.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:m,includes:l,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},l,m,y){if(m===this.filePattern){const v=p.basename(this.filePattern);this.matchFile(y,{base:l,relativePath:this.filePattern,basename:v})}function g(v){const d=p.basename(v),u=p.dirname(v);let o=f[u];o||(o=f[u]=[],g(u)),o.push({base:l,relativePath:v,basename:d})}g(m)}matchDirectoryTree({rootEntries:f,pathToEntries:l},m,y){const g=this,v=this.filePattern;function d(u){const o=I.hasSiblingFn(()=>u.map(t=>t.basename));for(let t=0,r=u.length;t<r;t++){const s=u[t],{relativePath:a,basename:n}=s;if(!!m.includedInQuerySync(a,n,v!==n?o:void 0)){const c=l[a];if(c)d(c);else{if(a===v)continue;g.matchFile(y,s)}if(g.isLimitHit)break}}}d(f)}matchFile(f,l){(!this.includePattern||l.relativePath&&this.includePattern(l.relativePath,l.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(l))}}class k{constructor(){this.sessions=new Map}fileSearch(f,l,m,y){const g=this.getSessionTokenSource(f.cacheKey),v=new T(f,l,g&&g.token);let d=0;const u=o=>{d+=o.length,m(o.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(v,k.BATCH_SIZE,u,y).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:o.stats}}))}clearCache(f){const l=this.getSessionTokenSource(f);l&&l.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new D.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:C.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,l,m,y){y.onCancellationRequested(()=>{f.cancel()});const g=d=>{d&&(v.push(d),l>0&&v.length>=l&&(m(v),v=[]))};let v=[];return f.search(g).then(d=>(v.length&&m(v),d),d=>(v.length&&m(v),Promise.reject(d)))}}e.FileSearchManager=k,k.BATCH_SIZE=512}),define(ge[124],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class p{constructor(I,C){this.line=I,this.character=C}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,C){return new p(0,0)}with(I){return new p(0,0)}}e.Position=p;class D{constructor(I,C,P,S){this.isEmpty=!1,this.isSingleLine=!1,this.start=new p(I,C),this.end=new p(P,S)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new D(0,0,0,0)}with(I){return new D(0,0,0,0)}}e.Range=D}),define(ge[125],pe([0,1,7,12,21,58,24,33,2,31,36,11]),function(Z,e,p,D,R,I,C,P,S,i,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class E{constructor(d,u,o){this.query=d,this.provider=u,this.fileUtils=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,u){const o=this.query.folderQueries||[],t=new R.CancellationTokenSource;return u.onCancellationRequested(()=>t.cancel()),new Promise((r,s)=>{this.collector=new l(d);let a=!1;const n=(c,b)=>{if(!a&&!this.isLimitHit){const w=this.resultSize(c);y(c)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,a=!0,t.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const h=this.resultSize(c);this.resultCount+=h,(h>0||!y(c))&&this.collector.add(c,b)}};Promise.all(o.map((c,b)=>this.searchInFolder(c,w=>n(w,b),t.token))).then(c=>{t.dispose(),this.collector.flush();const b=c.some(w=>!!w&&!!w.limitHit);r({limitHit:this.isLimitHit||b,stats:{type:"textSearchProvider"}})},c=>{t.dispose();const b=(0,I.toErrorMessage)(c);s(new Error(b))})})}resultSize(d){return y(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,u){const o=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:o.slice(0,u),preview:{matches:t.slice(0,u),text:d.preview.text},uri:d.uri}}searchInFolder(d,u,o){const t=new i.QueryGlobTester(this.query,d),r=[],s={report:n=>{if(!!this.validateProviderResult(n)){const c=d.folder.scheme===k.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(n.uri))):void 0,b=C.relativePath(d.folder,n.uri);b&&r.push(t.includedInQuery(b,p.basename(b),c).then(w=>{w&&u(n)}))}}},a=this.getSearchOptionsForFolder(d);return new Promise(n=>(0,T.nextTick)(n)).then(()=>this.provider.provideTextSearchResults(f(this.query.contentPattern),a,s,o)).then(n=>Promise.all(r).then(()=>n))}validateProviderResult(d){if(y(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const u=(0,i.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),o=(0,i.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),t={folder:S.URI.from(d.folder),excludes:o,includes:u,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=E;function f(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class l{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,u=>this.sendItems(u))}add(d,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!C.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(m(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=l;function m(v){return y(v)?{preview:{matches:(0,D.mapArrayOrNot)(v.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:v.preview.text},ranges:(0,D.mapArrayOrNot)(v.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function y(v){return!!v.preview}e.extensionResultIsMatch=y;class g{constructor(d,u){this.maxBatchSize=d,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,u){!d||this.addItemToBatch(d,u)}addItems(d,u){!d||this.addItemsToBatch(d,u)}addItemToBatch(d,u){this.batch.push(d),this.batchSize+=u,this.onUpdate()}addItemsToBatch(d,u){this.batch=this.batch.concat(d),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(ge[68],pe([0,1,6,5,4,265,14,62,13,2,125]),function(Z,e,p,D,R,I,C,P,S,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,R.createDecorator)("IExtHostSearch");let k=class{constructor(m,y,g){this.extHostRpc=m,this._uriTransformer=y,this._logService=g,this._proxy=this.extHostRpc.getProxy(D.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new I.FileSearchManager}_transformScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}registerTextSearchProvider(m,y){if(this._textSearchUsedSchemes.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this._textSearchUsedSchemes.add(m);const g=this._handlePool++;return this._textSearchProvider.set(g,y),this._proxy.$registerTextSearchProvider(g,this._transformScheme(m)),(0,p.toDisposable)(()=>{this._textSearchUsedSchemes.delete(m),this._textSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}registerFileSearchProvider(m,y){if(this._fileSearchUsedSchemes.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this._fileSearchUsedSchemes.add(m);const g=this._handlePool++;return this._fileSearchProvider.set(g,y),this._proxy.$registerFileSearchProvider(g,this._transformScheme(m)),(0,p.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(m),this._fileSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(m,y,g,v){const d=E(g),u=this._fileSearchProvider.get(m);if(u)return this._fileSearchManager.fileSearch(d,u,o=>{this._proxy.$handleFileMatch(m,y,o.map(t=>t.resource))},v);throw new Error("unknown provider: "+m)}$clearCache(m){return this._fileSearchManager.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,y,g,v){const d=this._textSearchProvider.get(m);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const u=E(g);return this.createTextSearchManager(u,d).search(t=>this._proxy.$handleTextMatch(m,y,t),v)}createTextSearchManager(m,y){return new T.TextSearchManager(m,y,{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g})}};k=je([Ue(0,C.IExtHostRpcService),Ue(1,P.IURITransformerService),Ue(2,S.ILogService)],k),e.ExtHostSearch=k;function E(l){return Object.assign(Object.assign({},l),{folderQueries:l.folderQueries&&l.folderQueries.map(f),extraFileResources:l.extraFileResources&&l.extraFileResources.map(m=>i.URI.revive(m))})}e.reviveQuery=E;function f(l){return Object.assign(Object.assign({},l),{folder:i.URI.revive(l.folder)})}}),define(ge[266],pe([0,1,156,21,18,3,74,2,149,103,139,77,44,5,229,228,51,230,35,231,232,233,214,234,38,42,235,215,237,238,239,64,218,241,242,243,88,34,244,219,20,8,247,65,123,32,41,53,197,236,113,122,66,45,68,13,62,14,27,240,196,50,63,226,245,195,89,87,250,248,249,227,61,257,246,86,192,116]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g,v,d,u,o,t,r,s,a,n,c,b,w,h,_,A,L,W,j,K,H,$,M,U,F,N,O,V,q,Y,fe,_e,Le,Ie,Fe,z,Q,te,ae,ve,De,Me,we,ke,Ae,xe,ye,Ge,X,ie,Se,Ne,ze,We,Je,G,oe,ue,J,ne,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function me(Ee){const He=Ee.get(Me.IExtHostInitDataService),Be=Ee.get(G.IExtHostFileSystemInfo),qe=Ee.get(Se.IExtHostConsumerFileSystem),Xe=Ee.get(a.IExtHostExtensionService),Ze=Ee.get(q.IExtHostWorkspace),ut=Ee.get(le.IExtHostTelemetry),st=Ee.get(v.IExtHostConfiguration),be=Ee.get(ve.IURITransformerService),he=Ee.get(De.IExtHostRpcService),ce=Ee.get(K.IExtHostStorage),ee=Ee.get(ie.IExtensionStoragePaths),Te=Ee.get(ae.ILogService),Re=Ee.get(Ae.IExtHostTunnelService),et=Ee.get(xe.IExtHostApiDeprecationService),Ke=Ee.get(V.IExtHostWindow),rt=Ee.get(J.IExtHostSecretState);he.set(f.ExtHostContext.ExtHostFileSystemInfo,Be),he.set(f.ExtHostContext.ExtHostLogService,Te),he.set(f.ExtHostContext.ExtHostWorkspace,Ze),he.set(f.ExtHostContext.ExtHostConfiguration,st),he.set(f.ExtHostContext.ExtHostExtensionService,Xe),he.set(f.ExtHostContext.ExtHostStorage,ce),he.set(f.ExtHostContext.ExtHostTunnelService,Re),he.set(f.ExtHostContext.ExtHostWindow,Ke),he.set(f.ExtHostContext.ExtHostSecretState,rt),he.set(f.ExtHostContext.ExtHostTelemetry,ut);const lt=he.set(f.ExtHostContext.ExtHostDecorations,Ee.get(Fe.IExtHostDecorations)),Ye=he.set(f.ExtHostContext.ExtHostDocumentsAndEditors,Ee.get(s.IExtHostDocumentsAndEditors)),it=he.set(f.ExtHostContext.ExtHostCommands,Ee.get(y.IExtHostCommands)),dt=he.set(f.ExtHostContext.ExtHostTerminalService,Ee.get(H.IExtHostTerminalService)),at=he.set(f.ExtHostContext.ExtHostDebugService,Ee.get(Q.IExtHostDebugService)),Ct=he.set(f.ExtHostContext.ExtHostSearch,Ee.get(te.IExtHostSearch)),gt=he.set(f.ExtHostContext.ExtHostTask,Ee.get(z.IExtHostTask)),kt=he.set(f.ExtHostContext.ExtHostOutputService,Ee.get(_.IExtHostOutputService)),Et=he.set(f.ExtHostContext.ExtHostEditorTabs,new ne.ExtHostEditorTabs),St=he.set(f.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(he)),mt=he.set(f.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(he,Ye)),Lt=he.set(f.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(he,Ye,Te)),Ft=he.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Te,mt,he.getProxy(f.MainContext.MainThreadBulkEdits))),ht=he.set(f.ExtHostContext.ExtHostNotebook,new we.ExtHostNotebookController(he,it,Ye,mt,He.environment,Te,ee)),yt=he.set(f.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(he,Ye)),Bt=he.set(f.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(he.getProxy(f.MainContext.MainThreadTreeViews),it,Te)),Ht=he.set(f.ExtHostContext.ExtHostEditorInsets,new _e.ExtHostEditorInsets(he.getProxy(f.MainContext.MainThreadEditorInsets),yt,He.environment)),Ot=he.set(f.ExtHostContext.ExtHostDiagnostics,new d.ExtHostDiagnostics(he,Te)),ct=he.set(f.ExtHostContext.ExtHostLanguageFeatures,new b.ExtHostLanguageFeatures(he,be,mt,it,Ot,Te,et)),hn=he.set(f.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(he,ct)),Pt=he.set(f.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(he,Te,Ye)),At=he.set(f.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(he,Ze,it)),tn=he.set(f.ExtHostContext.ExtHostSCM,new W.ExtHostSCM(he,it,Te)),fn=he.set(f.ExtHostContext.ExtHostComments,new g.ExtHostComments(he,it,mt)),nn=he.set(f.ExtHostContext.ExtHostProgress,new A.ExtHostProgress(he.getProxy(f.MainContext.MainThreadProgress))),mn=he.set(f.ExtHostContext.ExtHosLabelService,new Le.ExtHostLabelService(he)),rn=he.set(f.ExtHostContext.ExtHostTheming,new ke.ExtHostTheming(he)),Tt=he.set(f.ExtHostContext.ExtHostAuthentication,new ye.ExtHostAuthentication(he)),zt=he.set(f.ExtHostContext.ExtHostTimeline,new Ge.ExtHostTimeline(he,it)),Vt=he.set(f.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(he,He.environment,Ze,Te,et)),jt=he.set(f.ExtHostContext.ExtHostWebviewPanels,new We.ExtHostWebviewPanels(he,Vt,Ze)),gn=he.set(f.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(he,mt,ee,Vt,jt)),pn=he.set(f.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(he,Vt)),It=he.set(f.ExtHostContext.ExtHostTesting,new oe.ExtHostTesting(he,Ye,Ze)),vn=he.set(f.ExtHostContext.ExtHostUriOpeners,new ue.ExtHostUriOpeners(he)),wn=(0,fe.values)(f.ExtHostContext);he.assertRegistered(wn);const qt=new Je.ExtHostBulkEdits(he,Ye),_n=new m.ExtHostClipboard(he),Gt=new h.ExtHostMessageService(he,Te),$t=new u.ExtHostDialogs(he),Mt=new j.ExtHostStatusBar(he,it.converter),Kt=new w.ExtHostLanguages(he,mt);return l.ExtHostApiCommands.register(it),function(Oe,Nt,Xt){const ft=function(){let re=!Oe.isUnderDevelopment;function de(Pe){re||(Te.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Pe(B){if(Array.isArray(B))B.forEach(Pe);else if(typeof B=="string")de(B);else{const x=B;typeof x.scheme=="undefined"&&de(B),!Oe.enableProposedApi&&typeof x.exclusive=="boolean"&&(0,Y.throwProposedApiError)(Oe)}return B}}(),bn={getSession(re,de,Pe){return Tt.getSession(Oe,re,de,Pe)},get onDidChangeSessions(){return Tt.onDidChangeSessions},registerAuthenticationProvider(re,de,Pe,B){return Tt.registerAuthenticationProvider(re,de,Pe,B)},get onDidChangeAuthenticationProviders(){return(0,Y.checkProposedApiEnabled)(Oe),Tt.onDidChangeAuthenticationProviders},get providers(){return(0,Y.checkProposedApiEnabled)(Oe),Tt.providers},logout(re,de){return(0,Y.checkProposedApiEnabled)(Oe),Tt.removeSession(re,de)}},sn={registerCommand(re,de,Pe){return it.registerCommand(!0,re,de,Pe)},registerTextEditorCommand(re,de,Pe){return it.registerCommand(!0,re,(...B)=>{const x=yt.getActiveTextEditor();if(!x){Te.warn("Cannot execute "+re+" because there is no active text editor.");return}return x.edit(se=>{de.apply(Pe,[x,se,...B])}).then(se=>{se||Te.warn("Edits from command "+re+" were not applied.")},se=>{Te.warn("An error occurred while running command "+re,se)})})},registerDiffInformationCommand:(re,de,Pe)=>((0,Y.checkProposedApiEnabled)(Oe),it.registerCommand(!0,re,async(...B)=>{const x=Ye.activeEditor(!0);if(!x){Te.warn("Cannot execute "+re+" because there is no active text editor.");return}const se=await yt.getDiffInformation(x.id);de.apply(Pe,[se,...B])})),executeCommand(re,...de){return it.executeCommand(re,...de)},getCommands(re=!1){return it.getCommands(re)}},on={get machineId(){return He.telemetryInfo.machineId},get sessionId(){return He.telemetryInfo.sessionId},get language(){return He.environment.appLanguage},get appName(){return He.environment.appName},get appRoot(){var re,de;return(de=(re=He.environment.appRoot)===null||re===void 0?void 0:re.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return He.environment.appUriScheme},get clipboard(){return _n.value},get shell(){return dt.getDefaultShell(!1,Xt)},get isTelemetryEnabled(){return ut.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ut.onDidChangeTelemetryEnabled},get isNewAppInstall(){const re=Date.now()-new Date(He.telemetryInfo.firstSessionDate).getTime();return isNaN(re)?!1:re<1e3*60*60*24},openExternal(re,de){return Ke.openUri(re,{allowTunneling:!!He.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(re){return re.scheme===He.environment.appUriScheme?St.createAppUri(re):Ke.asExternalUri(re,{allowTunneling:!!He.remote.authority})},get remoteName(){return(0,Ie.getRemoteName)(He.remote.authority)},get uiKind(){return He.uiKind}};He.environment.extensionTestsLocationURI||Object.freeze(on);const an=He.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Yt={registerTestProvider(re){return(0,Y.checkProposedApiEnabled)(Oe),It.registerTestProvider(re)},createDocumentTestObserver(re){return(0,Y.checkProposedApiEnabled)(Oe),It.createTextDocumentTestObserver(re)},createWorkspaceTestObserver(re){return(0,Y.checkProposedApiEnabled)(Oe),It.createWorkspaceTestObserver(re)},runTests(re){return(0,Y.checkProposedApiEnabled)(Oe),It.runTests(re)},publishTestResult(re,de=!0){return(0,Y.checkProposedApiEnabled)(Oe),It.publishExtensionProvidedResults(re,de)},get onDidChangeTestResults(){return(0,Y.checkProposedApiEnabled)(Oe),It.onResultsChanged},get testResults(){return(0,Y.checkProposedApiEnabled)(Oe),It.results}},En={getExtension(re){const de=Nt.getExtensionDescription(re);if(de)return new a.Extension(Xe,Oe.identifier,de,an)},get all(){return Nt.getAllExtensionDescriptions().map(re=>new a.Extension(Xe,Oe.identifier,re,an))},get onDidChange(){return Nt.onDidChange}},Sn={createDiagnosticCollection(re){return Ot.createDiagnosticCollection(Oe.identifier,re)},get onDidChangeDiagnostics(){return Ot.onDidChangeDiagnostics},getDiagnostics:re=>Ot.getDiagnostics(re),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(re,de){return Kt.changeLanguage(re.uri,de)},match(re,de){return(0,k.score)(U.LanguageSelector.from(re),de.uri,de.languageId,!0)},registerCodeActionsProvider(re,de,Pe){return ct.registerCodeActionProvider(Oe,ft(re),de,Pe)},registerCodeLensProvider(re,de){return ct.registerCodeLensProvider(Oe,ft(re),de)},registerDefinitionProvider(re,de){return ct.registerDefinitionProvider(Oe,ft(re),de)},registerDeclarationProvider(re,de){return ct.registerDeclarationProvider(Oe,ft(re),de)},registerImplementationProvider(re,de){return ct.registerImplementationProvider(Oe,ft(re),de)},registerTypeDefinitionProvider(re,de){return ct.registerTypeDefinitionProvider(Oe,ft(re),de)},registerHoverProvider(re,de){return ct.registerHoverProvider(Oe,ft(re),de,Oe.identifier)},registerEvaluatableExpressionProvider(re,de){return ct.registerEvaluatableExpressionProvider(Oe,ft(re),de,Oe.identifier)},registerInlineValuesProvider(re,de){return(0,Y.checkProposedApiEnabled)(Oe),ct.registerInlineValuesProvider(Oe,ft(re),de,Oe.identifier)},registerDocumentHighlightProvider(re,de){return ct.registerDocumentHighlightProvider(Oe,ft(re),de)},registerLinkedEditingRangeProvider(re,de){return ct.registerLinkedEditingRangeProvider(Oe,ft(re),de)},registerReferenceProvider(re,de){return ct.registerReferenceProvider(Oe,ft(re),de)},registerRenameProvider(re,de){return ct.registerRenameProvider(Oe,ft(re),de)},registerDocumentSymbolProvider(re,de,Pe){return ct.registerDocumentSymbolProvider(Oe,ft(re),de,Pe)},registerWorkspaceSymbolProvider(re){return ct.registerWorkspaceSymbolProvider(Oe,re)},registerDocumentFormattingEditProvider(re,de){return ct.registerDocumentFormattingEditProvider(Oe,ft(re),de)},registerDocumentRangeFormattingEditProvider(re,de){return ct.registerDocumentRangeFormattingEditProvider(Oe,ft(re),de)},registerOnTypeFormattingEditProvider(re,de,Pe,...B){return ct.registerOnTypeFormattingEditProvider(Oe,ft(re),de,[Pe].concat(B))},registerDocumentSemanticTokensProvider(re,de,Pe){return ct.registerDocumentSemanticTokensProvider(Oe,ft(re),de,Pe)},registerDocumentRangeSemanticTokensProvider(re,de,Pe){return ct.registerDocumentRangeSemanticTokensProvider(Oe,ft(re),de,Pe)},registerSignatureHelpProvider(re,de,Pe,...B){return typeof Pe=="object"?ct.registerSignatureHelpProvider(Oe,ft(re),de,Pe):ct.registerSignatureHelpProvider(Oe,ft(re),de,typeof Pe=="undefined"?[]:[Pe,...B])},registerCompletionItemProvider(re,de,...Pe){return ct.registerCompletionItemProvider(Oe,ft(re),de,Pe)},registerDocumentLinkProvider(re,de){return ct.registerDocumentLinkProvider(Oe,ft(re),de)},registerColorProvider(re,de){return ct.registerColorProvider(Oe,ft(re),de)},registerFoldingRangeProvider(re,de){return ct.registerFoldingRangeProvider(Oe,ft(re),de)},registerSelectionRangeProvider(re,de){return ct.registerSelectionRangeProvider(Oe,re,de)},registerCallHierarchyProvider(re,de){return ct.registerCallHierarchyProvider(Oe,re,de)},setLanguageConfiguration:(re,de)=>ct.setLanguageConfiguration(Oe,re,de),getTokenInformationAtPosition(re,de){return(0,Y.checkProposedApiEnabled)(Oe),Kt.tokenAtPosition(re,de)},registerInlineHintsProvider(re,de){return(0,Y.checkProposedApiEnabled)(Oe),ct.registerInlineHintsProvider(Oe,re,de)}},yn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(re,de,Pe){const B=await(P.URI.isUri(re)?Promise.resolve(ln.openTextDocument(re)):Promise.resolve(re));return yt.showTextDocument(B,de,Pe)},createTextEditorDecorationType(re){return yt.createTextEditorDecorationType(re)},onDidChangeActiveTextEditor(re,de,Pe){return yt.onDidChangeActiveTextEditor(re,de,Pe)},onDidChangeVisibleTextEditors(re,de,Pe){return yt.onDidChangeVisibleTextEditors(re,de,Pe)},onDidChangeTextEditorSelection(re,de,Pe){return yt.onDidChangeTextEditorSelection(re,de,Pe)},onDidChangeTextEditorOptions(re,de,Pe){return yt.onDidChangeTextEditorOptions(re,de,Pe)},onDidChangeTextEditorVisibleRanges(re,de,Pe){return yt.onDidChangeTextEditorVisibleRanges(re,de,Pe)},onDidChangeTextEditorViewColumn(re,de,Pe){return yt.onDidChangeTextEditorViewColumn(re,de,Pe)},onDidCloseTerminal(re,de,Pe){return dt.onDidCloseTerminal(re,de,Pe)},onDidOpenTerminal(re,de,Pe){return dt.onDidOpenTerminal(re,de,Pe)},onDidChangeActiveTerminal(re,de,Pe){return dt.onDidChangeActiveTerminal(re,de,Pe)},onDidChangeTerminalDimensions(re,de,Pe){return(0,Y.checkProposedApiEnabled)(Oe),dt.onDidChangeTerminalDimensions(re,de,Pe)},onDidWriteTerminalData(re,de,Pe){return(0,Y.checkProposedApiEnabled)(Oe),dt.onDidWriteTerminalData(re,de,Pe)},get state(){return Ke.state},onDidChangeWindowState(re,de,Pe){return Ke.onDidChangeWindowState(re,de,Pe)},showInformationMessage(re,...de){return Gt.showMessage(Oe,C.default.Info,re,de[0],de.slice(1))},showWarningMessage(re,...de){return Gt.showMessage(Oe,C.default.Warning,re,de[0],de.slice(1))},showErrorMessage(re,...de){return Gt.showMessage(Oe,C.default.Error,re,de[0],de.slice(1))},showQuickPick(re,de,Pe){return At.showQuickPick(re,!!Oe.enableProposedApi,de,Pe)},showWorkspaceFolderPick(re){return At.showWorkspaceFolderPick(re)},showInputBox(re,de){return At.showInput(re,de)},showOpenDialog(re){return $t.showOpenDialog(re)},showSaveDialog(re){return $t.showSaveDialog(re)},createStatusBarItem(re,de){let Pe,B,x,se;return re&&typeof re!="number"?(Pe=re.id,B=re.name,x=re.alignment,de=re.priority,se=re.accessibilityInformation):(Pe=Oe.identifier.value,B=p.localize(0,null,Oe.displayName||Oe.name),x=re),Mt.createStatusBarEntry(Pe,B,x,de,se)},setStatusBarMessage(re,de){return Mt.setStatusBarMessage(re,de)},withScmProgress(re){return et.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),nn.withProgress(Oe,{location:F.ProgressLocation.SourceControl},(de,Pe)=>re({report(B){}}))},withProgress(re,de){return nn.withProgress(Oe,re,de)},createOutputChannel(re){return kt.createOutputChannel(re)},createWebviewPanel(re,de,Pe,B){return jt.createWebviewPanel(Oe,re,de,Pe,B)},createWebviewTextEditorInset(re,de,Pe,B){return(0,Y.checkProposedApiEnabled)(Oe),Ht.createWebviewEditorInset(re,de,Pe,B,Oe)},createTerminal(re,de,Pe){return typeof re=="object"?"pty"in re?dt.createExtensionTerminal(re):dt.createTerminalFromOptions(re):dt.createTerminal(re,de,Pe)},registerTerminalLinkProvider(re){return dt.registerLinkProvider(re)},registerTreeDataProvider(re,de){return Bt.registerTreeDataProvider(re,de,Oe)},createTreeView(re,de){return Bt.createTreeView(re,de,Oe)},registerWebviewPanelSerializer:(re,de)=>jt.registerWebviewPanelSerializer(Oe,re,de),registerCustomEditorProvider:(re,de,Pe={})=>gn.registerCustomEditorProvider(Oe,re,de,Pe),registerFileDecorationProvider(re){return lt.registerFileDecorationProvider(re,Oe.identifier)},registerUriHandler(re){return St.registerUriHandler(Oe.identifier,re)},createQuickPick(){return At.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return At.createInputBox(Oe.identifier)},get activeColorTheme(){return rn.activeColorTheme},onDidChangeActiveColorTheme(re,de,Pe){return rn.onDidChangeActiveColorTheme(re,de,Pe)},registerWebviewViewProvider(re,de,Pe){return pn.registerWebviewViewProvider(Oe,re,de,Pe==null?void 0:Pe.webviewOptions)},get activeNotebookEditor(){return(0,Y.checkProposedApiEnabled)(Oe),ht.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,de,Pe){return(0,Y.checkProposedApiEnabled)(Oe),ht.onDidChangeActiveNotebookEditor(re,de,Pe)},get visibleNotebookEditors(){return(0,Y.checkProposedApiEnabled)(Oe),ht.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Y.checkProposedApiEnabled)(Oe),ht.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,de,Pe){return(0,Y.checkProposedApiEnabled)(Oe),ht.onDidChangeNotebookEditorSelection(re,de,Pe)},onDidChangeNotebookEditorVisibleRanges(re,de,Pe){return(0,Y.checkProposedApiEnabled)(Oe),ht.onDidChangeNotebookEditorVisibleRanges(re,de,Pe)},showNotebookDocument(re,de){return(0,Y.checkProposedApiEnabled)(Oe),ht.showNotebookDocument(re,de)},registerExternalUriOpener(re,de,Pe){return(0,Y.checkProposedApiEnabled)(Oe),vn.registerExternalUriOpener(Oe.identifier,re,de,Pe)},get openEditors(){return(0,Y.checkProposedApiEnabled)(Oe),Et.tabs},get onDidChangeOpenEditors(){return(0,Y.checkProposedApiEnabled)(Oe),Et.onDidChangeTabs}},ln={get rootPath(){return et.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(re){throw R.readonly()},getWorkspaceFolder(re){return Ze.getWorkspaceFolder(re)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(re){throw R.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(re){throw R.readonly()},updateWorkspaceFolders:(re,de,...Pe)=>Ze.updateWorkspaceFolders(Oe,re,de||0,...Pe),onDidChangeWorkspaceFolders:function(re,de,Pe){return Ze.onDidChangeWorkspace(re,de,Pe)},asRelativePath:(re,de)=>Ze.getRelativePath(re,de),findFiles:(re,de,Pe,B)=>Ze.findFiles(U.GlobPattern.from(re),U.GlobPattern.from(de),Pe,Oe.identifier,B),findTextInFiles:(re,de,Pe,B)=>{let x,se;return typeof de=="object"?(x=de,se=Pe):(x={},se=de,B=Pe),Ze.findTextInFiles(re,x||{},se,Oe.identifier,B)},saveAll:re=>Ze.saveAll(re),applyEdit(re){return qt.applyWorkspaceEdit(re)},createFileSystemWatcher:(re,de,Pe,B)=>Pt.createFileSystemWatcher(U.GlobPattern.from(re),de,Pe,B),get textDocuments(){return mt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw R.readonly()},openTextDocument(re){let de;const Pe=re;if(typeof re=="string")de=Promise.resolve(P.URI.file(re));else if(P.URI.isUri(re))de=Promise.resolve(re);else if(!Pe||typeof Pe=="object")de=mt.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(B=>mt.ensureDocumentData(B).then(x=>x.document))},onDidOpenTextDocument:(re,de,Pe)=>mt.onDidAddDocument(re,de,Pe),onDidCloseTextDocument:(re,de,Pe)=>mt.onDidRemoveDocument(re,de,Pe),onDidChangeTextDocument:(re,de,Pe)=>mt.onDidChangeDocument(re,de,Pe),onDidSaveTextDocument:(re,de,Pe)=>mt.onDidSaveDocument(re,de,Pe),onWillSaveTextDocument:(re,de,Pe)=>Ft.getOnWillSaveTextDocumentEvent(Oe)(re,de,Pe),onDidChangeConfiguration:(re,de,Pe)=>Xt.onDidChangeConfiguration(re,de,Pe),getConfiguration(re,de){return de=arguments.length===1?void 0:de,Xt.getConfiguration(re,de,Oe)},registerTextDocumentContentProvider(re,de){return Lt.registerTextDocumentContentProvider(re,de)},registerTaskProvider:(re,de)=>(et.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),gt.registerTaskProvider(Oe,re,de)),registerFileSystemProvider(re,de,Pe){return hn.registerFileSystemProvider(Oe.identifier,re,de,Pe)},get fs(){return qe.value},registerFileSearchProvider:(re,de)=>((0,Y.checkProposedApiEnabled)(Oe),Ct.registerFileSearchProvider(re,de)),registerTextSearchProvider:(re,de)=>((0,Y.checkProposedApiEnabled)(Oe),Ct.registerTextSearchProvider(re,de)),registerRemoteAuthorityResolver:(re,de)=>((0,Y.checkProposedApiEnabled)(Oe),Xe.registerRemoteAuthorityResolver(re,de)),registerResourceLabelFormatter:re=>((0,Y.checkProposedApiEnabled)(Oe),mn.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,de,Pe)=>Pt.onDidCreateFile(re,de,Pe),onDidDeleteFiles:(re,de,Pe)=>Pt.onDidDeleteFile(re,de,Pe),onDidRenameFiles:(re,de,Pe)=>Pt.onDidRenameFile(re,de,Pe),onWillCreateFiles:(re,de,Pe)=>Pt.getOnWillCreateFileEvent(Oe)(re,de,Pe),onWillDeleteFiles:(re,de,Pe)=>Pt.getOnWillDeleteFileEvent(Oe)(re,de,Pe),onWillRenameFiles:(re,de,Pe)=>Pt.getOnWillRenameFileEvent(Oe)(re,de,Pe),openTunnel:re=>((0,Y.checkProposedApiEnabled)(Oe),Re.openTunnel(Oe,re).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Y.checkProposedApiEnabled)(Oe),Re.getTunnels()},onDidChangeTunnels:(re,de,Pe)=>((0,Y.checkProposedApiEnabled)(Oe),Re.onDidChangeTunnels(re,de,Pe)),registerPortAttributesProvider:(re,de)=>((0,Y.checkProposedApiEnabled)(Oe),Re.registerPortsAttributesProvider(re,de)),registerTimelineProvider:(re,de)=>((0,Y.checkProposedApiEnabled)(Oe),zt.registerTimelineProvider(re,de,Oe.identifier,it.converter)),get trustState(){return(0,Y.checkProposedApiEnabled)(Oe),(0,Y.checkRequiresWorkspaceTrust)(Oe),Ze.trustState},requireWorkspaceTrust:re=>((0,Y.checkProposedApiEnabled)(Oe),(0,Y.checkRequiresWorkspaceTrust)(Oe),Ze.requireWorkspaceTrust(re)),onDidChangeWorkspaceTrustState:(re,de,Pe)=>Ze.onDidChangeWorkspaceTrustState(re,de,Pe)},Dn={get inputBox(){return et.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),tn.getLastInputBox(Oe)},createSourceControl(re,de,Pe){return tn.createSourceControl(Oe,re,de,Pe)}},cn={createCommentController(re,de){return fn.createCommentController(Oe,re,de)}},Cn={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(re,de,Pe){return at.onDidStartDebugSession(re,de,Pe)},onDidTerminateDebugSession(re,de,Pe){return at.onDidTerminateDebugSession(re,de,Pe)},onDidChangeActiveDebugSession(re,de,Pe){return at.onDidChangeActiveDebugSession(re,de,Pe)},onDidReceiveDebugSessionCustomEvent(re,de,Pe){return at.onDidReceiveDebugSessionCustomEvent(re,de,Pe)},onDidChangeBreakpoints(re,de,Pe){return at.onDidChangeBreakpoints(re,de,Pe)},registerDebugConfigurationProvider(re,de,Pe){return at.registerDebugConfigurationProvider(re,de,Pe||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,de){return at.registerDebugAdapterDescriptorFactory(Oe,re,de)},registerDebugAdapterTrackerFactory(re,de){return at.registerDebugAdapterTrackerFactory(re,de)},startDebugging(re,de,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?at.startDebugging(re,de,{parentSession:Pe}):at.startDebugging(re,de,Pe||{})},stopDebugging(re){return at.stopDebugging(re)},addBreakpoints(re){return at.addBreakpoints(re)},removeBreakpoints(re){return at.removeBreakpoints(re)},asDebugSourceUri(re,de){return at.asDebugSourceUri(re,de)}},kn={registerTaskProvider:(re,de)=>gt.registerTaskProvider(Oe,re,de),fetchTasks:re=>gt.fetchTasks(re),executeTask:re=>gt.executeTask(Oe,re),get taskExecutions(){return gt.taskExecutions},onDidStartTask:(re,de,Pe)=>gt.onDidStartTask(re,de,Pe),onDidEndTask:(re,de,Pe)=>gt.onDidEndTask(re,de,Pe),onDidStartTaskProcess:(re,de,Pe)=>gt.onDidStartTaskProcess(re,de,Pe),onDidEndTaskProcess:(re,de,Pe)=>gt.onDidEndTaskProcess(re,de,Pe)},Qt={openNotebookDocument:re=>((0,Y.checkProposedApiEnabled)(Oe),ht.openNotebookDocument(re)),get onDidOpenNotebookDocument(){return(0,Y.checkProposedApiEnabled)(Oe),ht.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,Y.checkProposedApiEnabled)(Oe),ht.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,Y.checkProposedApiEnabled)(Oe),ht.onDidSaveNotebookDocument},get notebookDocuments(){return(0,Y.checkProposedApiEnabled)(Oe),ht.notebookDocuments.map(re=>re.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,Y.checkProposedApiEnabled)(Oe),ht.onDidChangeActiveNotebookKernel},registerNotebookContentProvider:(re,de,Pe)=>((0,Y.checkProposedApiEnabled)(Oe),ht.registerNotebookContentProvider(Oe,re,de,Pe)),registerNotebookKernelProvider:(re,de)=>((0,Y.checkProposedApiEnabled)(Oe),ht.registerNotebookKernelProvider(Oe,re,de)),createNotebookEditorDecorationType(re){return(0,Y.checkProposedApiEnabled)(Oe),ht.createNotebookEditorDecorationType(re)},onDidChangeNotebookDocumentMetadata(re,de,Pe){return(0,Y.checkProposedApiEnabled)(Oe),ht.onDidChangeNotebookDocumentMetadata(re,de,Pe)},onDidChangeNotebookCells(re,de,Pe){return(0,Y.checkProposedApiEnabled)(Oe),ht.onDidChangeNotebookCells(re,de,Pe)},onDidChangeCellOutputs(re,de,Pe){return(0,Y.checkProposedApiEnabled)(Oe),ht.onDidChangeCellOutputs(re,de,Pe)},onDidChangeCellMetadata(re,de,Pe){return(0,Y.checkProposedApiEnabled)(Oe),ht.onDidChangeCellMetadata(re,de,Pe)},createConcatTextDocument(re,de){return(0,Y.checkProposedApiEnabled)(Oe),new X.ExtHostNotebookConcatDocument(ht,mt,re,de)},createCellStatusBarItem(re,de,Pe){return(0,Y.checkProposedApiEnabled)(Oe),ht.createNotebookCellStatusBarItemInternal(re,de,Pe)}};return{version:He.version,authentication:bn,commands:sn,comments:cn,debug:Cn,env:on,extensions:En,languages:Sn,notebook:Qt,scm:Dn,tasks:kn,test:Yt,window:yn,workspace:ln,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:D.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,EventEmitter:I.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:E.FileType,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,Hover:F.Hover,IndentAction:T.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:i.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,UIKind:f.UIKind,Uri:P.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlineHint:F.InlineHint,InlineHintKind:F.InlineHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookCellRange:F.NotebookCellRange,NotebookCellKind:F.NotebookCellKind,NotebookCellRunState:F.NotebookCellRunState,NotebookDocumentMetadata:F.NotebookDocumentMetadata,NotebookCellMetadata:F.NotebookCellMetadata,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRunState:F.NotebookRunState,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,LinkedEditingRanges:F.LinkedEditingRanges,TestItem:F.TestItem,TestState:F.TestState,TestResult:F.TestResult,TestMessage:F.TestMessage,TestMessageSeverity:F.TestMessageSeverity,WorkspaceTrustState:F.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=me}),define(ge[267],pe([0,1,79,64,32,122,35,51,38,34,66,45,68,89,88,50,63,123,87,61,86,116]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g,v,d,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.registerSingleton)(f.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,p.registerSingleton)(y.IExtHostApiDeprecationService,y.ExtHostApiDeprecationService),(0,p.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,p.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,p.registerSingleton)(v.IExtHostConsumerFileSystem,v.ExtHostConsumerFileSystem),(0,p.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,p.registerSingleton)(I.IExtHostDecorations,I.ExtHostDecorations),(0,p.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,p.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo),(0,p.registerSingleton)(D.IExtHostOutputService,D.ExtHostOutputService),(0,p.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch),(0,p.registerSingleton)(l.IExtHostStorage,l.ExtHostStorage),(0,p.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,p.registerSingleton)(i.IExtHostTerminalService,i.WorkerExtHostTerminalService),(0,p.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService),(0,p.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,p.registerSingleton)(R.IExtHostWorkspace,R.ExtHostWorkspace),(0,p.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,p.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry)}),define(ge[90],pe([0,1,12,13,31,124]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=C;function P(k,E,f,l){const m=(0,p.mapArrayOrNot)(f,S),y=new R.TextSearchMatch(E,m,l),g=y.preview.matches;return{ranges:(0,p.mapArrayOrNot)(m,i),uri:k,preview:{text:y.preview.text,matches:(0,p.mapArrayOrNot)(g,i)}}}e.createTextSearchResult=P;function S(k){return new R.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function i(k){return new I.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let T=class{constructor(E,f){this.prefix=E,this.logService=f}appendLine(E){this.logService.debug(`${this.prefix}#search`,E)}};T=je([Ue(1,D.ILogService)],T),e.OutputChannel=T}),define(ge[268],pe([0,1,91,26]),function(Z,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function R(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===t)}e.isUTFEncoding=R,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const I=512,C=512,P=512*8,S=512*128;class i{constructor(r){this.iconvLiteDecoder=r}static async create(r){let s;if(r!==e.UTF8)s=(await new Promise((n,c)=>{Z(["iconv-lite-umd"],n,c)})).getDecoder(f(r));else{const a=new TextDecoder;s={write(n){return a.decode(n,{stream:!0})},end(){return a.decode()}}}return new i(s)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function T(t,r){var s;const a=((s=r.minBytesRequiredForDetection)!==null&&s!==void 0?s:r.guessEncoding)?P:C;return new Promise((n,c)=>{const b=(0,p.newWriteableStream)(L=>L.join("")),w=[];let h=0,_;const A=async()=>{try{const L=await o({buffer:D.VSBuffer.concat(w),bytesRead:h},r.guessEncoding);L.encoding=await r.overwriteEncoding(L.encoding),_=await i.create(L.encoding);const W=_.write(D.VSBuffer.concat(w).buffer);b.write(W),w.length=0,h=0,n({stream:b,detected:L})}catch(L){c(L)}};(0,p.listenStream)(t,{onData:async L=>{_?b.write(_.write(L.buffer)):(w.push(L),h+=L.byteLength,h>=a&&(t.pause(),await A(),setTimeout(()=>t.resume())))},onError:L=>b.error(L),onEnd:async()=>{_||await A(),b.end(_==null?void 0:_.end())}})})}e.toDecodeStream=T;async function k(t,r,s){const n=(await new Promise((w,h)=>{Z(["iconv-lite-umd"],w,h)})).getEncoder(f(r),s);let c=!1,b=!1;return{read(){if(b)return null;const w=t.read();if(typeof w!="string"){if(b=!0,!c&&(s==null?void 0:s.addBOM))switch(r){case e.UTF8:case e.UTF8_with_bom:return D.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return D.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return D.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const h=n.end();return h&&h.length>0?(c=!0,D.VSBuffer.wrap(h)):null}return c=!0,D.VSBuffer.wrap(n.write(w))}}}e.toEncodeReadable=k;async function E(t){return(await new Promise((s,a)=>{Z(["iconv-lite-umd"],s,a)})).encodingExists(f(t))}e.encodingExists=E;function f(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=f;function l(t,r){if(!t||r<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),a=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&a===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&a===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const n=t.readUInt8(2);return s===e.UTF8_BOM[0]&&a===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=l;const m=["ascii","utf-16","utf-32"];async function y(t){const r=await new Promise((b,w)=>{Z(["jschardet"],b,w)}),s=t.slice(0,S),a=d(s.buffer),n=r.detect(a);if(!n||!n.encoding)return null;const c=n.encoding.toLowerCase();return 0<=m.indexOf(c)?null:v(n.encoding)}const g={ibm866:"cp866",big5:"cp950"};function v(t){const r=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return g[r]||r}function d(t){let r="";for(let s=0;s<t.length;s++)r+=String.fromCharCode(t[s]);return r}function u(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const r=t.match(/windows(\d+)/);return r?"windows-"+r[1]:t}}e.toCanonicalName=u;function o({buffer:t,bytesRead:r},s){let a=l(t,r),n=!1;if(a!==e.UTF16be&&a!==e.UTF16le&&t){let c=!0,b=!0,w=!1;for(let h=0;h<r&&h<I;h++){const _=h%2==1,A=t.readUInt8(h)===0;if(A&&(w=!0),c&&(_&&!A||!_&&A)&&(c=!1),b&&(_&&A||!_&&!A)&&(b=!1),A&&!c&&!b)break}w&&(c?a=e.UTF16le:b?a=e.UTF16be:n=!0)}return s&&!n&&!a&&t?y(t.slice(0,r)).then(c=>({seemsBinary:!1,encoding:c})):{seemsBinary:n,encoding:a}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[126],pe([0,1,268,25,125]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class I extends R.TextSearchManager{constructor(P,S,i=D){super(P,S,{readdir:T=>i.readdir(T.fsPath),toCanonicalName:T=>(0,p.toCanonicalName)(T)})}}e.NativeTextSearchManager=I}),define(ge[269],pe([0,1,270,283,284,2,285]),function(Z,e,p,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(k,E,f,l,m,y){const g=y.environment.useHostProxy,v=typeof g=="boolean"?g:!y.remote.isRemote,d=(0,C.createProxyResolver)({resolveProxy:o=>k.resolveProxy(o),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(o,t,...r)=>{switch(o){case C.LogLevel.Trace:l.trace(t,...r);break;case C.LogLevel.Debug:l.debug(t,...r);break;case C.LogLevel.Info:l.info(t,...r);break;case C.LogLevel.Warning:l.warn(t,...r);break;case C.LogLevel.Error:l.error(t,...r);break;case C.LogLevel.Critical:l.critical(t,...r);break;case C.LogLevel.Off:break;default:s(o,t,r);break}function s(a,n,...c){l.error("Unknown log level",a),l.error(n,...c)}},getLogLevel:()=>l.getLevel(),proxyResolveTelemetry:o=>{m.$publicLog2("resolveProxy",o)},useHostProxy:v,env:process.env}),u=S(E,d);return T(f,u)}e.connectProxyResolver=P;function S(k,E){const f={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(m=>{f.config=k.getConfiguration("http").get("proxySupport")||"off"});const l={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(m=>{l.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},p,(0,C.createHttpPatch)(p,E,{config:"off"},l,!0)),on:Object.assign({},p,(0,C.createHttpPatch)(p,E,{config:"on"},l,!0)),override:Object.assign({},p,(0,C.createHttpPatch)(p,E,{config:"override"},l,!0)),onRequest:Object.assign({},p,(0,C.createHttpPatch)(p,E,f,l,!0)),default:Object.assign(p,(0,C.createHttpPatch)(p,E,f,l,!1))},https:{off:Object.assign({},D,(0,C.createHttpPatch)(D,E,{config:"off"},l,!0)),on:Object.assign({},D,(0,C.createHttpPatch)(D,E,{config:"on"},l,!0)),override:Object.assign({},D,(0,C.createHttpPatch)(D,E,{config:"override"},l,!0)),onRequest:Object.assign({},D,(0,C.createHttpPatch)(D,E,f,l,!0)),default:Object.assign(D,(0,C.createHttpPatch)(D,E,f,l,!1))},tls:Object.assign(R,(0,C.createTlsPatch)(R))}}const i=new Map;function T(k,E){return k.getExtensionPathIndex().then(f=>{const l=Z.__$__nodeRequire("module"),m=l._load;l._load=function(g,v,d){if(g==="tls")return E.tls;if(g!=="http"&&g!=="https")return m.apply(this,arguments);const u=E[g],o=f.findSubstr(I.URI.file(v.filename).fsPath);let t=i.get(o);if(t||i.set(o,t={}),!t[g]){let r=u.default;o&&o.enableProposedApi&&(r=u[o.proxySupport]||u.onRequest),t[g]=Object.assign({},r)}return t[g]}})}}),define(ge[271],pe([0,1,39,7,75,30,10,9,90,272]),function(Z,e,p,D,R,I,C,P,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const T=i.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(d,u,o,t){const r=E(d,u,o,t),s=u.folder.fsPath;return{cmd:p.spawn(T,r.args,{cwd:s}),rgDiskPath:T,siblingClauses:r.siblingClauses,rgArgs:r,cwd:s}}e.spawnRipgrepCmd=k;function E(d,u,o,t){const r=["--files","--hidden","--case-sensitive"];l([u],o,!1).forEach(a=>{const n=(0,S.anchorGlob)(a);if(r.push("-g",n),C.isMacintosh){const c=(0,R.normalizeNFD)(n);c!==n&&r.push("-g",c)}});const s=f([u],t,void 0,!1);return s.globArgs.forEach(a=>{const n=`!${(0,S.anchorGlob)(a)}`;if(r.push("-g",n),C.isMacintosh){const c=(0,R.normalizeNFD)(n);c!==n&&r.push("-g",c)}}),u.disregardIgnoreFiles!==!1?r.push("--no-ignore"):r.push("--no-ignore-parent"),u.ignoreSymlinks||r.push("--follow"),d.exists&&r.push("--quiet"),r.push("--no-config"),u.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:s.siblingClauses}}function f(d,u,o,t=!0){const r=[];let s={};return d.forEach(a=>{const n=Object.assign({},a.excludePattern||{},u||{}),c=m(n,t?a.folder.fsPath:void 0,o);r.push(...c.globArgs),c.siblingClauses&&(s=Object.assign(s,c.siblingClauses))}),{globArgs:r,siblingClauses:s}}e.foldersToRgExcludeGlobs=f;function l(d,u,o=!0){const t=[];return d.forEach(r=>{const s=Object.assign({},u||{},r.includePattern||{}),a=m(s,o?r.folder.fsPath:void 0);t.push(...a.globArgs)}),t}e.foldersToIncludeGlobs=l;function m(d,u,o){const t=[],r={};return Object.keys(d).forEach(s=>{if(!(o&&o.has(s))&&!!s){const a=d[s];s=g(u?y(u,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof a=="boolean"&&a?(s.startsWith("\\\\")&&(s+="**"),t.push(v(s))):a&&a.when&&(r[s]=a)}}),{globArgs:t,siblingClauses:r}}function y(d,u){return D.isAbsolute(u)?u:D.join(d,u)}e.getAbsoluteGlob=y;function g(d){return d=P.rtrim(d,"\\"),P.rtrim(d,"/")}function v(d){return I.getRoot(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.fixDriveC=v}),define(ge[273],pe([0,1,39,37,7,98,12,58,33,75,30,10,46,9,15,25,31,271,96]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const d=new Set;process.on("exit",()=>{d.forEach(s=>s())});class u{constructor(a){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=a,this.filePattern=a.filePattern||"",this.includePattern=a.includePattern&&S.parse(a.includePattern),this.maxResults=a.maxResults||null,this.exists=!!a.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,v.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=a.excludePattern&&S.parse(a.excludePattern),this.folderExcludePatterns=new Map,a.folderQueries.forEach(n=>{const c=Object.assign({},n.excludePattern||{},this.config.excludePattern||{}),b=n.folder.fsPath;a.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==b).forEach(w=>{(0,T.isEqualOrParent)(w,b)&&(c[R.relative(b,w)]=!0)}),this.folderExcludePatterns.set(b,new t(c,b))})}cancel(){this.isCanceled=!0}walk(a,n,c,b,w){if(this.fileWalkSW=E.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);n.forEach(h=>{const _=R.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,_)||this.matchFile(c,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=E.StopWatch.create(!1),this.parallel(a,(h,_)=>{this.call(this.cmdTraversal,this,h,c,b,A=>{if(A){const L=(0,P.toErrorMessage)(A);console.error(L),this.errors.push(L),_(A,void 0)}else _(null,void 0)})},(h,_)=>{this.fileWalkSW.stop();const A=h?C.coalesce(h)[0]:null;w(A,this.isLimitHit)})}parallel(a,n,c){const b=new Array(a.length),w=new Array(a.length);let h=!1,_=0;if(a.length===0)return c(null,[]);a.forEach((A,L)=>{n(A,(W,j)=>{if(W?(h=!0,b[L]=null,w[L]=W):(b[L]=j,w[L]=null),++_===a.length)return c(h?w:null,b)})})}call(a,n,...c){try{a.apply(n,c)}catch(b){c[c.length-1](b)}}cmdTraversal(a,n,c,b){const w=a.folder.fsPath,h=k.isMacintosh;let _;const A=()=>_&&_.kill();d.add(A);let L=U=>{d.delete(A),L=()=>{},b(U)},W="";const j=this.initDirectoryTree();let K;const H=(0,g.spawnRipgrepCmd)(this.config,a,this.config.includePattern,this.folderExcludePatterns.get(a.folder.fsPath).expression);_=H.cmd,K=!Object.keys(H.siblingClauses).length;const $=H.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let M=`${H.rgDiskPath} ${$}
 - cwd: ${H.cwd}`;H.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(H.rgArgs.siblingClauses)}`),c({message:M}),this.cmdResultCount=0,this.collectStdout(_,"utf8",c,(U,F,N)=>{if(U){L(U);return}if(this.isLimitHit){L();return}const V=(W+(h?i.normalizeNFC(F||""):F)).split(`
`);if(N){const q=V.length;V[q-1]=V[q-1].trim(),V[q-1]||V.pop()}else W=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,K){for(const q of V)if(this.matchFile(n,{base:w,relativePath:q,searchPath:this.getSearchPath(a,q)}),this.isLimitHit){A();break}(N||this.isLimitHit)&&L();return}this.addDirectoryEntries(a,j,w,V,n),N&&(this.matchDirectoryTree(j,w,n),L())})}spawnFindCmd(a){const n=this.folderExcludePatterns.get(a.folder.fsPath),c=n.getBasenameTerms(),b=n.getPathTerms(),w=["-L","."];if(c.length||b.length){w.push("-not","(","(");for(const h of c)w.push("-name",h),w.push("-o");for(const h of b)w.push("-path",h),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),p.spawn("find",w,{cwd:a.folder.fsPath})}readStdout(a,n,c){let b="";this.collectStdout(a,n,()=>{},(w,h,_)=>{if(w){c(w);return}b+=h,_&&c(null,b)})}collectStdout(a,n,c,b){let w=(A,L,W)=>{(A||W)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),b(A,L,W)},h=!1;a.stdout?(this.forwardData(a.stdout,n,w),a.stdout.once("data",()=>h=!0)):c({message:"stdout is null"});let _;a.stderr?_=this.collectData(a.stderr):c({message:"stderr is null"}),a.on("error",A=>{w(A)}),a.on("close",A=>{let L;!h&&(L=this.decodeData(_,n))&&r(L)?w(new Error(`command failed with error code ${A}: ${this.decodeData(_,n)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(a,n,c){const b=new I.StringDecoder(n);return a.on("data",w=>{c(null,b.write(w))}),b}collectData(a){const n=[];return a.on("data",c=>{n.push(c)}),n}decodeData(a,n){const c=new I.StringDecoder(n);return a.map(b=>c.write(b)).join("")}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries(a,{pathToEntries:n},c,b,w){b.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(a,this.filePattern)});const h=_=>{const A=R.basename(_),L=R.dirname(_);let W=n[L];W||(W=n[L]=[],h(L)),W.push({base:c,relativePath:_,basename:A,searchPath:this.getSearchPath(a,_)})};b.forEach(h)}matchDirectoryTree({rootEntries:a,pathToEntries:n},c,b){const w=this,h=this.folderExcludePatterns.get(c),_=this.filePattern;function A(L){w.directoriesWalked++;const W=S.hasSiblingFn(()=>L.map(j=>j.basename));for(let j=0,K=L.length;j<K;j++){const H=L[j],{relativePath:$,basename:M}=H;if(!h.test($,M,_!==M?W:void 0)){const U=n[$];if(U)A(U);else{if(w.filesWalked++,$===_)continue;w.matchFile(b,H)}if(w.isLimitHit)break}}}A(a)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(a,n,c,b,w){const h=a.folder,_=S.hasSiblingFn(()=>c);this.parallel(c,(A,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const W=n?[n,A].join(R.sep):A;if(this.folderExcludePatterns.get(a.folder.fsPath).test(W,A,this.config.filePattern!==A?_:void 0))return L(null);const j=[h.fsPath,W].join(R.sep);D.lstat(j,(K,H)=>{if(K||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(j,H,($,M)=>$||this.isCanceled||this.isLimitHit?L(null):M.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(j,H,(U,F)=>U||this.isCanceled||this.isLimitHit||(F=F||"",this.walkedPaths[F])?L(null):(this.walkedPaths[F]=!0,(0,m.readdir)(j).then(N=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(a,W,N,b,O=>L(O||null))},N=>{L(null)})))):(this.filesWalked++,W===this.filePattern||this.maxFilesize&&l.isNumber(M.size)&&M.size>this.maxFilesize||this.matchFile(b,{base:h.fsPath,relativePath:W,searchPath:this.getSearchPath(a,W)}),L(null,void 0)))})},A=>{const L=A&&C.coalesce(A);return w(L&&L.length>0?L[0]:void 0)})}matchFile(a,n){this.isFileMatch(n)&&(!this.includePattern||this.includePattern(n.relativePath,R.basename(n.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||a(n))}isFileMatch(a){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,y.isFilePatternMatch)(a,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(a,n,c){return n.isSymbolicLink()?D.stat(a,c):c(null,n)}realPathIfNeeded(a,n,c){return n.isSymbolicLink()?D.realpath(a,(b,w)=>b?c(b):c(null,w)):c(null,a)}getSearchPath(a,n){return a.folderName?R.join(a.folderName,n):n}}e.FileWalker=u;class o{constructor(a){this.folderQueries=a.folderQueries,this.extraFiles=a.extraFileResources||[],this.walker=new u(a)}search(a,n,c){this.walker.walk(this.folderQueries,this.extraFiles,a,n,(b,w)=>{c(b,{limitHit:w,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=o;class t{constructor(a,n){this.expression=a,this.root=n,this.init(a)}init(a){let n,c;Object.keys(a).filter(b=>a[b]).forEach(b=>{R.isAbsolute(b)?(n=n||S.getEmptyExpression(),n[b]=a[b]):(c=c||S.getEmptyExpression(),c[b]=a[b])}),this.absoluteParsedExpr=n&&S.parse(n,{trimForExclusions:!0}),this.relativeParsedExpr=c&&S.parse(c,{trimForExclusions:!0})}test(a,n,c){return this.relativeParsedExpr&&this.relativeParsedExpr(a,n,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(R.join(this.root,a),n,c)}getBasenameTerms(){const a=[];return this.absoluteParsedExpr&&a.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&a.push(...S.getBasenameTerms(this.relativeParsedExpr)),a}getPathTerms(){const a=[];return this.absoluteParsedExpr&&a.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&a.push(...S.getPathTerms(this.relativeParsedExpr)),a}}function r(s){const a=s.trim().split(`
`),n=a[0].trim();if(n.startsWith("Error parsing regex"))return n;if(n.startsWith("regex parse error"))return f.uppercaseFirstLetter(a[a.length-1].trim());if(n.startsWith("error parsing glob")||n.startsWith("unsupported encoding"))return n.charAt(0).toUpperCase()+n.substr(1);if(n==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(n.startsWith("Literal "))return n}e.rgErrorMsgForDisplay=r}),define(ge[127],pe([0,1,39,286,98,12,53,33,7,9,2,31,124,287,272,90]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const y=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(h){this.outputChannel=h}provideTextSearchResults(h,_,A,L){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify(Object.assign(Object.assign({},_),{folder:_.folder.toString()}))}`),new Promise((W,j)=>{L.onCancellationRequested(()=>O());const K=r(h,_),H=_.folder.fsPath,$=K.map(_e=>_e.match(/^-/)?_e:`'${_e}'`).join(" ");this.outputChannel.appendLine(`${y} ${$}
 - cwd: ${H}`);let M=p.spawn(y,K,{cwd:H});M.on("error",_e=>{console.error(_e),this.outputChannel.appendLine("Error: "+(_e&&_e.message)),j((0,k.serializeSearchError)(new k.SearchError(_e&&_e.message,k.SearchErrorCode.rgProcessError)))});let U=!1;const F=new u(_.maxResults,H,_.previewOptions);F.on("result",_e=>{U=!0,q="",A.report(_e)});let N=!1;const O=()=>{N=!0,M&&M.kill(),F&&F.cancel()};let V=!1;F.on("hitLimit",()=>{V=!0,O()});let q="";M.stdout.on("data",_e=>{F.handleData(_e),U||(q+=_e)});let Y=!1;M.stdout.once("data",()=>Y=!0);let fe="";M.stderr.on("data",_e=>{const Le=_e.toString();this.outputChannel.appendLine(Le),fe+=Le}),M.on("close",()=>{if(this.outputChannel.appendLine(Y?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),N)W({limitHit:V});else{F.flush(),M=null;let _e;fe&&!Y&&(_e=v(fe))?j((0,k.serializeSearchError)(new k.SearchError(_e.message,_e.code))):W({limitHit:V})}})})}}e.RipgrepTextSearchEngine=g;function v(w){const h=w.split(`
`),_=h[0].trim();if(h.some(L=>L.startsWith("regex parse error")))return new k.SearchError(d(h),k.SearchErrorCode.regexParseError);const A=_.match(/grep config error: unknown encoding: (.*)/);if(A)return new k.SearchError(`Unknown encoding: ${A[1]}`,k.SearchErrorCode.unknownEncoding);if(_.startsWith("error parsing glob"))return new k.SearchError(_.charAt(0).toUpperCase()+_.substr(1),k.SearchErrorCode.globParseError);if(_.startsWith("the literal"))return new k.SearchError(_.charAt(0).toUpperCase()+_.substr(1),k.SearchErrorCode.invalidLiteral);if(_.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(_,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=v;function d(w){const h=["Regex parse error"],_=w.filter(A=>A.startsWith("PCRE2:"));if(_.length>=1){const A=_[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const L=A.split(":")[1];h.push(":"+L)}}return h.join("")}e.buildRegexParseError=d;class u extends D.EventEmitter{constructor(h,_,A){super();this.maxResults=h,this.rootFolder=_,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new R.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,_){return super.on(h,_),this}handleData(h){if(!this.isDone){const _=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(_)}}handleDecodedData(h){let _=h.indexOf(`
`);const A=this.remainder+h;if(_>=0)_+=this.remainder.length;else{this.remainder=A;return}let L=0;for(;_>=0;)this.handleLine(A.substring(L,_).trim()),L=_+1,_=A.indexOf(`
`,L);this.remainder=A.substring(L)}handleLine(h){if(!(this.isDone||!h)){let _;try{_=JSON.parse(h)}catch(A){throw new Error(`malformed line from rg: ${h}`)}if(_.type==="match"){const A=o(_.data.path),L=T.URI.file(S.join(this.rootFolder,A)),W=this.createTextSearchMatch(_.data,L);this.onResult(W),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(_.type==="context"){const A=o(_.data.path),L=T.URI.file(S.join(this.rootFolder,A));this.createTextSearchContext(_.data,L).forEach(j=>this.onResult(j))}}}createTextSearchMatch(h,_){const A=h.line_number-1;let L=!1,W=o(h.lines);A===0&&(0,i.startsWithUTF8BOM)(W)&&(L=!0,W=(0,i.stripUTF8BOM)(W));const j=Buffer.from(W);let K=0,H=0,$=A;h.submatches.length===0&&h.submatches.push(W.length?{start:0,end:1,match:{text:W[0]}}:{start:0,end:0,match:{text:""}});const M=(0,I.coalesce)(h.submatches.map((U,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let N=o(U.match);A===0&&F===0&&L&&(N=(0,i.stripUTF8BOM)(N),U.start=U.start<=3?0:U.start-3,U.end=U.end<=3?0:U.end-3);const O=j.slice(K,U.start).toString().length,V=H+O,q=t(N),Y=$,fe=q.numLines+Y,_e=q.numLines>0?q.lastLineLength:q.lastLineLength+V;return K=U.end,H=_e,$=fe,new E.Range(Y,V,fe,_e)}));return(0,m.createTextSearchResult)(_,W,M,this.previewOptions)}createTextSearchContext(h,_){const A=o(h.lines),L=h.line_number;return A.replace(/\r?\n$/,"").split(`
`).map((W,j)=>({text:W,uri:_,lineNumber:L+j}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=u;function o(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const h=/\n/g;let _=0,A=-1,L;for(;L=h.exec(w);)_++,A=L.index;const W=A>=0?w.length-A-1:w.length;return{numLines:_,lastLineLength:W}}function r(w,h){const _=["--hidden"];_.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:L}=(0,C.groupBy)(h.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const j=new Set;L.forEach(K=>{j.add(K)}),_.push("-g","!*"),j.forEach(K=>{s(K).map(m.anchorGlob).forEach(H=>{_.push("-g",H)})})}A&&A.length&&A.forEach(j=>{_.push("-g",j)}),h.excludes.map(m.anchorGlob).forEach(j=>_.push("-g",`!${j}`)),h.maxFileSize&&_.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?_.push("--no-ignore-parent"):_.push("--no-ignore"),h.followSymlinks&&_.push("--follow"),h.encoding&&h.encoding!=="utf8"&&_.push("--encoding",h.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,i.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),h.usePCRE2&&_.push("--pcre2"),_.push("--crlf"),w.isRegExp&&(w.pattern=a(w.pattern),_.push("--auto-hybrid-regex"));let W;if(w.isWordMatch){const K=(0,i.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");_.push("--regexp",K)}else if(w.isRegExp){let j=c(w.pattern);j=b(j),_.push("--regexp",j)}else W=w.pattern,_.push("--fixed-strings");return _.push("--no-config"),h.useGlobalIgnoreFiles||_.push("--no-ignore-global"),_.push("--json"),w.isMultiline&&_.push("--multiline"),h.beforeContext&&_.push("--before-context",h.beforeContext+""),h.afterContext&&_.push("--after-context",h.afterContext+""),_.push("--"),W&&_.push(W),_.push("."),_}function s(w){const h=(0,P.splitGlobAware)(w,"/");return h.map((_,A)=>h.slice(0,A+1).join("/"))}e.spreadGlobComponents=s;function a(w){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(h);)w=w.replace(h,"$1\\x{$2}");const _=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(_);)w=w.replace(_,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=a;const n=w=>w.type==="Assertion"&&w.kind==="lookbehind";function c(w){let h;try{h=new f.RegExpParser().parsePattern(w)}catch(K){return w}let _="",A=0;const L=(K,H,$)=>{_+=w.slice(A,K)+$,A=H},W=[];return new f.RegExpVisitor({onCharacterEnter(K){if(K.raw==="\\n"){const H=W[0];if(!H)L(K.start,K.end,"\\r?\\n");else if(!W.some(n))if(H.type==="CharacterClass"){const $=w.slice(H.start+1,K.start)+w.slice(K.end,H.end-1);L(H.start,H.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else H.type==="Quantifier"&&L(K.start,K.end,"(?:\\r?\\n)")}},onQuantifierEnter(K){W.unshift(K)},onQuantifierLeave(){W.shift()},onCharacterClassRangeEnter(K){W.unshift(K)},onCharacterClassRangeLeave(){W.shift()},onCharacterClassEnter(K){W.unshift(K)},onCharacterClassLeave(){W.shift()},onAssertionEnter(K){n(K)&&W.push(K)},onAssertionLeave(K){W[0]===K&&W.shift()}}).visit(h),_+=w.slice(A),_}e.fixRegexNewline=c;function b(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=b}),define(ge[274],pe([0,1,21,127,110,11]),function(Z,e,p,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(i){this.outputChannel=i,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(i,T,k,E){const f=new D.RipgrepTextSearchEngine(this.outputChannel);if(T.folder.scheme===I.Schemas.userData){const l=Object.assign(Object.assign({},T),{folder:T.folder.with({scheme:I.Schemas.file})}),m=new R.Progress(y=>k.report(Object.assign(Object.assign({},y),{uri:y.uri.with({scheme:T.folder.scheme})})));return this.withToken(E,y=>f.provideTextSearchResults(i,l,m,y))}else return this.withToken(E,l=>f.provideTextSearchResults(i,T,k,l))}async withToken(i,T){const k=P(i);this.inProgress.add(k);const E=await T(k.token);return this.inProgress.delete(k),E}dispose(){this.inProgress.forEach(i=>i.cancel())}}e.RipgrepSearchProvider=C;function P(S){const i=new p.CancellationTokenSource;return S.onCancellationRequested(()=>i.cancel()),i}}),define(ge[275],pe([0,1,25,127,126]),function(Z,e,p,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class I{constructor(S){this.query=S}search(S,i,T){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(f){T({message:f})}},E=new R.NativeTextSearchManager(this.query,new D.RipgrepTextSearchEngine(k),p);return new Promise((f,l)=>E.search(m=>{i(m.map(C))},S).then(m=>f({limitHit:m.limitHit,type:"success"}),l))}}e.TextSearchEngineAdapter=I;function C(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((S,i)=>{if(i.ranges){const T=i;return S+(Array.isArray(T.ranges)?T.ranges.length:1)}else return S+1},0)}}}),define(ge[276],pe([0,1,37,288,12,19,18,3,96,7,46,2,44,31,273,275]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,D.gracefulify(p);class y{constructor(){this.caches=Object.create(null)}fileSearch(t){let r;const s=d(t),a=new P.Emitter({onFirstListenerDidAdd:()=>{r=(0,I.createCancelablePromise)(n=>this.doFileSearchWithEngine(l.Engine,s,c=>a.fire(c),n)),r.then(n=>a.fire(n),n=>a.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return a.event}textSearch(t){let r;const s=d(t),a=new P.Emitter({onFirstListenerDidAdd:()=>{r=(0,I.createCancelablePromise)(n=>this.ripgrepTextSearch(s,c=>a.fire(c),n)),r.then(n=>a.fire(n),n=>a.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return a.event}ripgrepTextSearch(t,r,s){return t.maxFileSize=(0,E.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new m.TextSearchEngineAdapter(t).search(s,r,r)}doFileSearch(t,r,s){return this.doFileSearchWithEngine(l.Engine,t,r,s)}doFileSearchWithEngine(t,r,s,a,n=y.BATCH_SIZE){let c=0;const b=h=>{Array.isArray(h)?(c+=h.length,s(h.map(_=>this.rawMatchToSearchItem(_)))):h.relativePath?(c++,s(this.rawMatchToSearchItem(h))):s(h)};if(r.sortByScore){let h=this.trySortedSearchFromCache(r,b,a);if(!h){const _=r.maxResults?Object.assign({},r,{maxResults:null}):r,A=new t(_);h=this.doSortedSearch(A,r,s,b,a)}return new Promise((_,A)=>{h.then(([L,W])=>{const j=W.map(K=>this.rawMatchToSearchItem(K));this.sendProgress(j,s,n),_(L)},A)})}const w=new t(r);return this.doSearch(w,b,n,a).then(h=>({limitHit:h.limitHit,type:"success",stats:{detailStats:h.stats,type:"searchProcess",fromCache:!1,resultCount:c,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,i.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,r,s,a,n){const c=new P.Emitter;let b=(0,I.createCancelablePromise)(h=>{let _=[];const A=L=>{Array.isArray(L)?_=L:(a(L),c.fire(L))};return this.doSearch(t,A,-1,h).then(L=>[L,_])}),w;if(r.cacheKey){w=this.getOrCreateCache(r.cacheKey);const h={promise:b,event:c.event,resolved:!1};w.resultsToSearchCache[r.filePattern||""]=h,b.then(()=>{h.resolved=!0},_=>{delete w.resultsToSearchCache[r.filePattern||""]}),b=this.preventCancellation(b)}return b.then(([h,_])=>{const A=w?w.scorerCache:Object.create(null),L=(typeof r.maxResults!="number"||r.maxResults>0)&&T.StopWatch.create(!1);return this.sortResults(r,_,A,n).then(W=>{const j=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:h.stats,sortingTime:j,fromCache:!1,type:"searchProcess",workspaceFolderCount:r.folderQueries.length,resultCount:W.length},limitHit:h.limitHit||typeof r.maxResults=="number"&&_.length>r.maxResults},W]})})}getOrCreateCache(t){const r=this.caches[t];return r||(this.caches[t]=new g)}trySortedSearchFromCache(t,r,s){const a=t.cacheKey&&this.caches[t.cacheKey];if(!!a){const n=this.getResultsFromCache(a,t.filePattern||"",r,s);if(n)return n.then(([c,b,w])=>{const h=T.StopWatch.create(!1);return this.sortResults(t,b,a.scorerCache,s).then(_=>{const A=h.elapsed(),L={fromCache:!0,detailStats:w,type:"searchProcess",resultCount:b.length,sortingTime:A};return[{type:"success",limitHit:c.limitHit||typeof t.maxResults=="number"&&b.length>t.maxResults,stats:L},_]})})}}sortResults(t,r,s,a){const n=(0,S.prepareQuery)(t.filePattern||""),c=(w,h)=>(0,S.compareItemsByFuzzyScore)(w,h,n,!0,v,s),b=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return R.topAsync(r,c,b,1e4,a)}sendProgress(t,r,s){if(s&&s>0)for(let a=0;a<t.length;a+=s)r(t.slice(a,a+s));else r(t)}getResultsFromCache(t,r,s,a){const n=T.StopWatch.create(!1),c=r.indexOf(i.sep)>=0;let b;for(const A in t.resultsToSearchCache)if(r.startsWith(A)){if(c&&A.indexOf(i.sep)<0&&A!=="")continue;const L=t.resultsToSearchCache[A];b={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!b)return null;const w=n.elapsed(),h=T.StopWatch.create(!1),_=b.event(s);return a&&a.onCancellationRequested(()=>{_.dispose()}),b.promise.then(([A,L])=>{if(a&&a.isCancellationRequested)throw(0,C.canceled)();const W=[],j=(0,S.prepareQuery)(r).normalizedLowercase;for(const K of L)!(0,f.isFilePatternMatch)(K,j)||W.push(K);return[A,W,{cacheWasResolved:b.resolved,cacheLookupTime:w,cacheFilterTime:h.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,r,s,a){return new Promise((n,c)=>{let b=[];a&&a.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(s?(b.push(w),s>0&&b.length>=s&&(r(b),b=[])):r(w))},w=>{r(w)},(w,h)=>{b.length&&r(b),w?c(w):n(h)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,s){return t.then(r,s)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.SearchService=y,y.BATCH_SIZE=512;class g{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(o){return(0,i.basename)(o.relativePath)}getItemDescription(o){return(0,i.dirname)(o.relativePath)}getItemPath(o){return o.relativePath}};function d(o){return Object.assign(Object.assign({},o),{folderQueries:o.folderQueries&&o.folderQueries.map(u),extraFileResources:o.extraFileResources&&o.extraFileResources.map(t=>k.URI.revive(t))})}function u(o){return Object.assign(Object.assign({},o),{folder:k.URI.revive(o.folder)})}}),define(ge[277],pe([0,1,6,2,25,13,31,276,274,90,14,62,27,68,11,126]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let y=class extends f.ExtHostSearch{constructor(v,d,u,o){super(v,u,o);this._pfs=R,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new i.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(l.Schemas.userData,new S.RipgrepSearchProvider(t)),d.remote.isRemote&&d.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const v=new i.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(l.Schemas.file,new S.RipgrepSearchProvider(v)),this.registerInternalFileSearchProvider(l.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(v,d){const u=this._handlePool++;return this._internalFileSearchProvider=d,this._internalFileSearchHandle=u,this._proxy.$registerFileSearchProvider(u,this._transformScheme(v)),(0,p.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(v,d,u,o){const t=(0,f.reviveQuery)(u);return v===this._internalFileSearchHandle?this.doInternalFileSearch(v,d,t,o):super.$provideFileSearchResults(v,d,u,o)}doInternalFileSearch(v,d,u,o){const t=r=>{if((0,C.isSerializedFileMatch)(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(v,d,r.map(s=>D.URI.file(s.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(u,t,o)}$clearCache(v){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(v),super.$clearCache(v)}createTextSearchManager(v,d){return new m.NativeTextSearchManager(v,d)}};y=je([Ue(0,T.IExtHostRpcService),Ue(1,E.IExtHostInitDataService),Ue(2,k.IURITransformerService),Ue(3,I.ILogService)],y),e.NativeExtHostSearch=y}),define(ge[128],pe([0,1,289,119,290,3,100,7,48,28,6,26,101,18,10]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(b){this.socket=b}dispose(){this.socket.destroy()}onData(b){const w=h=>b(k.VSBuffer.wrap(h));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(b){return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(b){return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(b){if(!this.socket.destroyed)try{this.socket.write(b.buffer)}catch(w){if(w.code==="EPIPE")return;(0,f.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((b,w)=>{if(this.socket.bufferSize===0){b();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),b()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=m;var y;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var g;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(g||(g={}));class v extends T.Disposable{constructor(b,w,h,_){super();this._onDidZlibFlush=this._register(new I.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=b,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=_,w?(this._zlibInflate=R.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),(0,f.onUnexpectedError)(A),this._onClose.fire()}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),h&&(this._zlibInflate.write(h.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=R.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),(0,f.onUnexpectedError)(A),this._onClose.fire()}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this._onData.event(b)}onClose(b){return this._onClose.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){this._totalOutgoingDataBytes+=b.byteLength,this._zlibDeflate?(this._zlibDeflate.write(b.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(k.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(b,!1)}_write(b,w){let h=2;b.byteLength<126?h+=0:b.byteLength<2**16?h+=2:h+=8;const _=k.VSBuffer.alloc(h);if(w?_.writeUInt8(194,0):_.writeUInt8(130,0),b.byteLength<126)_.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){_.writeUInt8(126,1);let A=1;_.writeUInt8(b.byteLength>>>8&255,++A),_.writeUInt8(b.byteLength>>>0&255,++A)}else{_.writeUInt8(127,1);let A=1;_.writeUInt8(0,++A),_.writeUInt8(0,++A),_.writeUInt8(0,++A),_.writeUInt8(0,++A),_.writeUInt8(b.byteLength>>>24&255,++A),_.writeUInt8(b.byteLength>>>16&255,++A),_.writeUInt8(b.byteLength>>>8&255,++A),_.writeUInt8(b.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=_.byteLength+b.byteLength,this.socket.write(k.VSBuffer.concat([_,b]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(b){if(b.byteLength!==0){for(this._totalIncomingWireBytes+=b.byteLength,this._incomingData.acceptChunk(b);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),_=(w.readUInt8(0)&128)>>>7,A=w.readUInt8(1),L=(A&128)>>>7,W=A&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=_,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),h=w.readUInt8(1),_=(h&128)>>>7;let A=h&127,L=1;A===126?A=w.readUInt8(++L)*2**8+w.readUInt8(++L):A===127&&(A=w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L));let W=0;_&&(W=w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L)),this._state.state=3,this._state.readLen=A,this._state.mask=W}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);d(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const h=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=h.length,this._onData.fire(k.VSBuffer.wrap(h))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await I.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=v;function d(c,b){if(b!==0){let w=c.byteLength>>>2;for(let j=0;j<w;j++){const K=c.readUInt32BE(j*4);c.writeUInt32BE(K^b,j*4)}let h=w*4,_=c.byteLength-h;const A=b>>>24&255,L=b>>>16&255,W=b>>>8&255;_>=1&&c.writeUInt8(c.readUInt8(h)^A,h),_>=2&&c.writeUInt8(c.readUInt8(h+1)^L,h+1),_>=3&&c.writeUInt8(c.readUInt8(h+2)^W,h+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function o(){const c=(0,i.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let b;return e.XDG_RUNTIME_DIR?b=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):b=(0,P.join)((0,S.tmpdir)(),`vscode-ipc-${c}.sock`),r(b),b}e.createRandomIPCHandle=o;function t(c,b,w){const h=(0,p.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${w}-${b}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${h.substr(0,8)}-${w}-${b}.sock`):_=(0,P.join)(c,`${w}-${b}.sock`),r(_),_}e.createStaticIPCHandle=t;function r(c){const b=u[l.platform];typeof b=="number"&&c.length>=b&&console.warn(`WARNING: IPC handle "${c}" is longer than ${b} chars, try a shorter --user-data-dir`)}class s extends C.IPCServer{constructor(b){super(s.toClientConnectionEvent(b));this.server=b}static toClientConnectionEvent(b){const w=I.Event.fromNodeEventEmitter(b,"connection");return I.Event.map(w,h=>({protocol:new E.Protocol(new m(h)),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(h,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(c){return new Promise((b,w)=>{const h=(0,D.createServer)();h.on("error",w),h.listen(c,()=>{h.removeListener("error",w),b(new s(h))})})}e.serve=a;function n(c,b){return new Promise((w,h)=>{const _=(0,D.createConnection)(c,()=>{_.removeListener("error",h),w(E.Client.fromSocket(new m(_),b))});_.once("error",h)})}e.connect=n}),define(ge[278],pe([0,1,128,270,37,51,2,114,13]),function(Z,e,p,D,R,I,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class i{constructor(E,f,l){this._commands=E,this.logService=f,this._ipcHandlePath=l,this._server=D.createServer((m,y)=>this.onRequest(m,y)),this.setup().catch(m=>(f.error(m),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",E=>this.logService.error(E))}catch(E){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(E,f){const l=[];E.setEncoding("utf8"),E.on("data",m=>l.push(m)),E.on("end",()=>{const m=JSON.parse(l.join(""));switch(m.type){case"open":this.open(m,f);break;case"openExternal":this.openExternal(m,f);break;case"status":this.getStatus(m,f);break;case"command":this.runCommand(m,f).catch(this.logService.error);break;case"extensionManagement":this.manageExtensions(m,f).catch(this.logService.error);break;default:f.writeHead(404),f.write(`Unknown message type: ${m.type}`,y=>{y&&this.logService.error(y)}),f.end();break}})}open(E,f){let{fileURIs:l,folderURIs:m,forceNewWindow:y,diffMode:g,addMode:v,forceReuseWindow:d,gotoLineMode:u,waitMarkerFilePath:o}=E;const t=[];if(Array.isArray(m))for(const r of m)try{t.push({folderUri:C.URI.parse(r)})}catch(s){}if(Array.isArray(l))for(const r of l)try{(0,P.hasWorkspaceFileExtension)(r)?t.push({workspaceUri:C.URI.parse(r)}):t.push({fileUri:C.URI.parse(r)})}catch(s){}if(t.length){const r=o?C.URI.file(o):void 0,a={forceNewWindow:y,diffMode:g,addMode:v,gotoLineMode:u,forceReuseWindow:d,preferNewWindow:!d&&!r&&!v,waitMarkerFileURI:r};this._commands.executeCommand("_files.windowOpen",t,a)}f.writeHead(200),f.end()}async openExternal(E,f){for(const l of E.uris){const m=C.URI.parse(l),y=m.scheme==="file"?m:l;await this._commands.executeCommand("_remoteCLI.openExternal",y)}f.writeHead(200),f.end()}async manageExtensions(E,f){console.log("server: manageExtensions");try{const l=g=>g==null?void 0:g.map(v=>/\.vsix$/i.test(v)?C.URI.parse(v):v),m={list:E.list,install:l(E.install),uninstall:l(E.uninstall),force:E.force},y=await this._commands.executeCommand("_remoteCLI.manageExtensions",m,{allowTunneling:!0});f.writeHead(200),f.write(y)}catch(l){f.writeHead(500),f.write(String(l))}f.end()}async getStatus(E,f){try{const l=await this._commands.executeCommand("_issues.getSystemStatus");f.writeHead(200),f.write(l),f.end()}catch(l){f.writeHead(500),f.write(String(l),m=>{m&&this.logService.error(m)}),f.end()}}async runCommand(E,f){try{const{command:l,args:m}=E,y=await this._commands.executeCommand(l,...m);f.writeHead(200),f.write(JSON.stringify(y),g=>{g&&this.logService.error(g)}),f.end()}catch(l){f.writeHead(500),f.write(String(l),m=>{m&&this.logService.error(m)}),f.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&R.existsSync(this._ipcHandlePath)&&R.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=i;let T=class extends i{constructor(E,f){super(E,f,(0,p.createRandomIPCHandle)())}};T=je([Ue(0,I.IExtHostCommands),Ue(1,S.ILogService)],T),e.CLIServer=T}),define(ge[279],pe([0,1,67,266,260,5,269,42,251,2,11,8,278]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class f extends R.RequireInterceptor{_installInterceptor(){const y=this,g=Z.__$__nodeRequire("module"),v=g._load;g._load=function(u,o,t){for(let r of y._alternatives){let s=r(u);if(s){u=s;break}}return y._factories.has(u)?y._factories.get(u).load(u,i.URI.file(o.filename),r=>v.apply(this,[r,o,t])):v.apply(this,arguments)}}}class l extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=k.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const y=this._instaService.invokeFunction(D.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const o=this._instaService.createInstance(E.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}await this._instaService.createInstance(f,y,this._registry).install(),p.mark("code/extHost/didInitAPI");const v=await this._extHostConfiguration.getConfigProvider();await(0,C.connectProxyResolver)(this._extHostWorkspace,v,this,this._logService,this._mainThreadTelemetryProxy,this._initData),p.mark("code/extHost/didInitProxyResolver");const d=process.send,u=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);process.send=(...o)=>o.length===0||!o[0]||o[0].type!=="__$console"?d.apply(process,o):(u.$logExtensionHostMessage(o[0]),!1)}_getEntryPoint(y){return y.main}_loadCommonJSModule(y,g,v){if(g.scheme!==T.Schemas.file)throw new Error(`Cannot load URI: '${g}', must be of file-scheme`);let d=null;v.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${g.toString(!0)}`),this._logService.flush();try{y&&p.mark(`code/extHost/willLoadExtensionCode/${y.value}`),d=Z.__$__nodeRequire(g.fsPath)}catch(u){return Promise.reject(u)}finally{y&&p.mark(`code/extHost/didLoadExtensionCode/${y.value}`),v.codeLoadingStop()}return Promise.resolve(d)}async $setRemoteEnvironment(y){if(!!this._initData.remote.isRemote)for(const g in y){const v=y[g];v===null?delete process.env[g]:process.env[g]=v}}}e.ExtHostExtensionService=l}),define(ge[280],pe([0,1,79,252,263,262,261,277,279,224,253,45,42,64,68,66,34,50,13]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m,y,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.registerSingleton)(E.IExtHostExtensionService,S.ExtHostExtensionService),(0,p.registerSingleton)(v.ILogService,i.ExtHostLogService),(0,p.registerSingleton)(k.IExtHostDebugService,C.ExtHostDebugService),(0,p.registerSingleton)(f.IExtHostOutputService,D.ExtHostOutputService2),(0,p.registerSingleton)(l.IExtHostSearch,P.NativeExtHostSearch),(0,p.registerSingleton)(m.IExtHostTask,I.ExtHostTask),(0,p.registerSingleton)(y.IExtHostTerminalService,R.ExtHostTerminalService),(0,p.registerSingleton)(g.IExtHostTunnelService,T.ExtHostTunnelService)}),define(ge[281],pe([0,1,119,291,67,18,101,128,184,222,264,26,97,25,135,19,267,280]),function(Z,e,p,D,R,I,C,P,S,i,T,k,E,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let a=0;a<process.execArgv.length;a++)process.execArgv[a]==="--inspect-port=0"&&(process.execArgv.splice(a,1),a--)}();const y=D(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=Z.__$__nodeRequire("module"),a=s._load;s._load=function(n){if(n==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return a.apply(this,arguments)}})();const g=process.exit.bind(process);function v(s){process.exit=function(a){if(s)g(a);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const a=new Error("An extension called process.crash() and this was prevented.");console.warn(a.stack)}}let d=function(s){g()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,a)=>{let n=null,c=setTimeout(()=>{a(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const b=108e5,w=3e5,h=new m.RunOnceScheduler(()=>d("renderer disconnected for too long (1)"),b),_=new m.RunOnceScheduler(()=>d("renderer disconnected for too long (2)"),w);process.on("message",(L,W)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const j=k.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let K;if(L.skipWebSocketFrames)K=new P.NodeSocket(W);else{const H=k.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));K=new P.WebSocketNodeSocket(new P.NodeSocket(W),L.permessageDeflate,H,!1)}n?(h.cancel(),_.cancel(),n.beginAcceptReconnection(K,j),n.endAcceptReconnection()):(clearTimeout(c),n=new C.PersistentProtocol(K,j),n.onDidDispose(()=>d("renderer disconnected")),s(n),n.onSocketClose(()=>{h.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(_.isScheduled())return;h.isScheduled()&&_.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((a,n)=>{const c=p.createConnection(s,()=>{c.removeListener("error",n),a(new C.PersistentProtocol(new P.NodeSocket(c)))});c.once("error",n)})}}async function o(){const s=await u();return new class{constructor(){this._onMessage=new C.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(a=>{(0,i.isMessageOfType)(a,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(a)})}send(a){this._terminating||s.send(a)}drain(){return s.drain()}}}function t(s){return new Promise(a=>{const n=s.onMessage(c=>{n.dispose();const b=JSON.parse(c.toString()),w=b.commit,h=S.default.commit;w&&h&&w!==h&&g(55);const _=[];process.on("unhandledRejection",(W,j)=>{_.push(j),setTimeout(()=>{const K=_.indexOf(j);K>=0&&j.catch(H=>{_.splice(K,1),console.warn(`rejected promise not handled within 1 second: ${H}`),H&&H.stack&&console.warn(`stack trace: ${H.stack}`),(0,I.onUnexpectedError)(W)})},1e3)}),process.on("rejectionHandled",W=>{const j=_.indexOf(W);j>=0&&_.splice(j,1)}),process.on("uncaughtException",function(W){(0,I.onUnexpectedError)(W)});let A=0;setInterval(function(){try{process.kill(b.parentPid,0),A=0}catch(W){W&&W.code==="EPERM"?(A++,A>=3&&d(`parent process ${b.parentPid} does not exist anymore (3 x EPERM): ${W.message} (code: ${W.code}) (errno: ${W.errno})`)):d(`parent process ${b.parentPid} does not exist anymore: ${W.message} (code: ${W.code}) (errno: ${W.errno})`)}},1e3);let L;try{L=Z.__$__nodeRequire("native-watchdog"),L.start(b.parentPid)}catch(W){(0,I.onUnexpectedError)(W)}s.send((0,i.createMessageOfType)(0)),a({protocol:s,initData:b})});s.send((0,i.createMessageOfType)(1))})}async function r(){R.mark("code/extHost/willConnectToRenderer");const s=await o();R.mark("code/extHost/didConnectToRenderer");const a=await t(s);R.mark("code/extHost/didWaitForInitData");const{initData:n}=a;v(!!n.environment.extensionTestsLocationURI),n.environment.useHostProxy=y.useHostProxy!==void 0?y.useHostProxy!=="false":void 0;const c=new class{exit(_){g(_)}exists(_){return(0,f.exists)(_)}realpath(_){return(0,l.realpath)(_)}};let b=null;if(n.remote.authority&&y.uriTransformerPath)try{const _=Z.__$__nodeRequire(y.uriTransformerPath)(n.remote.authority);b=new E.URITransformer(_)}catch(h){console.error(h)}const w=new T.ExtensionHostMain(a.protocol,n,c,b);d=h=>w.terminate(h)}e.startExtensionHostProcess=r}),define(ge[292],pe([0,1,281]),function(Z,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.startExtensionHostProcess)().catch(D=>console.log(D))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/06b54543d660353a04cdab6554d1f27266a537fd/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
