/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/network","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/linkedList","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(ae){for(var e=[],_=0,S=ae.length;_<S;_++)e[_]=we[ae[_]];return e};define(we[43],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(S,T){if(!S)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=_}),define(we[50],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function S(A){const I=[];for(let v in A)_.call(A,v)&&I.push(A[v]);return I}e.values=S;function T(A,I){for(let v in A)if(_.call(A,v)&&I({key:v,value:A[v]},function(){delete A[v]})===!1)return}e.forEach=T;function P(A,I){const v=Object.create(null);for(const d of A){const s=I(d);let f=v[s];f||(f=v[s]=[]),f.push(d)}return v}e.groupBy=P;function E(A){const I=Object.create(null);return A&&A.forEach((v,d)=>{I[d]=v}),I}e.fromMap=E;function k(A,I){const v=[],d=[];for(let s of A)I.has(s)||v.push(s);for(let s of I)A.has(s)||d.push(s);return{removed:v,added:d}}e.diffSets=k;function w(A,I){const v=[],d=[];for(let[s,f]of A)I.has(s)||v.push(f);for(let[s,f]of I)A.has(s)||d.push(f);return{removed:v,added:d}}e.diffMaps=w;class n{constructor(){this.map=new Map}add(I,v){let d=this.map.get(I);d||(d=new Set,this.map.set(I,d)),d.add(v)}delete(I,v){const d=this.map.get(I);!d||(d.delete(v),d.size===0&&this.map.delete(I))}forEach(I,v){const d=this.map.get(I);!d||d.forEach(v)}}e.SetMap=n}),define(we[44],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function _(w){return(n,A,I)=>{let v=null,d=null;if(typeof I.value=="function"?(v="value",d=I.value):typeof I.get=="function"&&(v="get",d=I.get),!d)throw new Error("not supported");I[v]=w(d,A)}}e.createDecorator=_;let S=0;function T(){const w=`$memoize${S++}`;let n;const A=function(v,d,s){let f=null,p=null;if(typeof s.value=="function"?(f="value",p=s.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof s.get=="function"&&(f="get",p=s.get),!p)throw new Error("not supported");const m=`${w}:${d}`;s[f]=function(...b){return n=this,this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!0,enumerable:!1,writable:!0,value:p.apply(this,b)}),this[m]}};return A.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(I=>{I.indexOf(w)===0&&delete n[I]})},A}e.createMemoizer=T;function P(w,n,A){return T()(w,n,A)}e.memoize=P;function E(w,n,A){return _((I,v)=>{const d=`$debounce$${v}`,s=`$debounce$result$${v}`;return function(...f){this[s]||(this[s]=A?A():void 0),clearTimeout(this[d]),n&&(this[s]=n(this[s],...f),f=[this[s]]),this[d]=setTimeout(()=>{I.apply(this,f),this[s]=A?A():void 0},w)}})}e.debounce=E;function k(w,n,A){return _((I,v)=>{const d=`$throttle$timer$${v}`,s=`$throttle$result$${v}`,f=`$throttle$lastRun$${v}`,p=`$throttle$pending$${v}`;return function(...m){if(this[s]||(this[s]=A?A():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),n&&(this[s]=n(this[s],...m)),!this[p]){const b=this[f]+w;b<=Date.now()?(this[f]=Date.now(),I.apply(this,[this[s]]),this[s]=A?A():void 0):(this[p]=!0,this[d]=setTimeout(()=>{this[p]=!1,this[f]=Date.now(),I.apply(this,[this[s]]),this[s]=A?A():void 0},b-Date.now()))}}})}e.throttle=k}),define(we[10],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function S(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=S;function T(a){w(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=T;function P(a){w(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=P;function E(a){if(a instanceof Error){let{name:t,message:r}=a;const o=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:o}}return a}e.transformErrorForSerialization=E;const k="Canceled";function w(a){return a instanceof Error&&a.name===k&&a.message===k}e.isPromiseCanceledError=w;class n extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=n;function A(){const a=new Error(k);return a.name=a.message,a}e.canceled=A;function I(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=I;function v(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=v;function d(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function s(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=s;function f(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=f;class p extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=p;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function c(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function u(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=u}),define(we[15],Ee([0,1,10]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function S(L,$=0){return L[L.length-(1+$)]}e.tail=S;function T(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}e.tail2=T;function P(L,$,W=(K,U)=>K===U){if(L===$)return!0;if(!L||!$||L.length!==$.length)return!1;for(let K=0,U=L.length;K<U;K++)if(!W(L[K],$[K]))return!1;return!0}e.equals=P;function E(L,$,W){let K=0,U=L.length-1;for(;K<=U;){const ee=(K+U)/2|0,ie=W(L[ee],$);if(ie<0)K=ee+1;else if(ie>0)U=ee-1;else return ee}return-(K+1)}e.binarySearch=E;function k(L,$){let W=0,K=L.length;if(K===0)return 0;for(;W<K;){const U=Math.floor((W+K)/2);$(L[U])?K=U:W=U+1}return W}e.findFirstInSorted=k;function w(L,$,W){if(L=L|0,L>=$.length)throw new TypeError("invalid index");let K=$[Math.floor($.length*Math.random())],U=[],ee=[],ie=[];for(let se of $){const Se=W(se,K);Se<0?U.push(se):Se>0?ee.push(se):ie.push(se)}return L<U.length?w(L,U,W):L<U.length+ie.length?ie[0]:w(L-(U.length+ie.length),ee,W)}e.quickSelect=w;function n(L,$){const W=[];let K;for(const U of L.slice(0).sort($))!K||$(K[0],U)!==0?(K=[U],W.push(K)):K.push(U);return W}e.groupBy=n;function A(L,$,W){const K=[];function U(se,Se,Ae){if(!(Se===0&&Ae.length===0)){const Be=K[K.length-1];Be&&Be.start+Be.deleteCount===se?(Be.deleteCount+=Se,Be.toInsert.push(...Ae)):K.push({start:se,deleteCount:Se,toInsert:Ae})}}let ee=0,ie=0;for(;;){if(ee===L.length){U(ee,0,$.slice(ie));break}if(ie===$.length){U(ee,L.length-ee,[]);break}const se=L[ee],Se=$[ie],Ae=W(se,Se);Ae===0?(ee+=1,ie+=1):Ae<0?(U(ee,1,[]),ee+=1):Ae>0&&(U(ee,0,[Se]),ie+=1)}return K}e.sortedDiff=A;function I(L,$,W){const K=A(L,$,W),U=[],ee=[];for(const ie of K)U.push(...L.slice(ie.start,ie.start+ie.deleteCount)),ee.push(...ie.toInsert);return{removed:U,added:ee}}e.delta=I;function v(L,$,W){if(W===0)return[];const K=L.slice(0,W).sort($);return s(L,$,K,W,L.length),K}e.top=v;function d(L,$,W,K,U){return W===0?Promise.resolve([]):new Promise((ee,ie)=>{(async()=>{const se=L.length,Se=L.slice(0,W).sort($);for(let Ae=W,Be=Math.min(W+K,se);Ae<se;Ae=Be,Be=Math.min(Be+K,se)){if(Ae>W&&await new Promise(Re=>setTimeout(Re)),U&&U.isCancellationRequested)throw(0,_.canceled)();s(L,$,Se,Ae,Be)}return Se})().then(ee,ie)})}e.topAsync=d;function s(L,$,W,K,U){for(const ee=W.length;K<U;K++){const ie=L[K];if($(ie,W[ee-1])<0){W.pop();const se=k(W,Se=>$(ie,Se)<0);W.splice(se,0,ie)}}}function f(L){return L.filter($=>!!$)}e.coalesce=f;function p(L){let $=0;for(let W=0;W<L.length;W++)L[W]&&(L[$]=L[W],$+=1);L.length=$}e.coalesceInPlace=p;function m(L,$,W){L.splice(W,0,L.splice($,1)[0])}e.move=m;function b(L){return!Array.isArray(L)||L.length===0}e.isFalsyOrEmpty=b;function c(L){return Array.isArray(L)&&L.length>0}e.isNonEmptyArray=c;function u(L,$){if(!$)return L.filter((K,U)=>L.indexOf(K)===U);const W=Object.create(null);return L.filter(K=>{const U=$(K);return W[U]?!1:(W[U]=!0,!0)})}e.distinct=u;function a(L){const $=new Set;return L.filter(W=>$.has(W)?!1:($.add(W),!0))}e.distinctES6=a;function t(L){const $=Object.create(null);return W=>{const K=L(W);return $[K]?!1:($[K]=!0,!0)}}e.uniqueFilter=t;function r(L,$){for(let W=L.length-1;W>=0;W--){const K=L[W];if($(K))return W}return-1}e.lastIndex=r;function o(L,$){return L.length>0?L[0]:$}e.firstOrDefault=o;function l(L,$,W=(K,U)=>K===U){let K=0;for(let U=0,ee=Math.min(L.length,$.length);U<ee&&W(L[U],$[U]);U++)K++;return K}e.commonPrefixLength=l;function i(L){return[].concat(...L)}e.flatten=i;function h(L,$){let W=typeof $=="number"?L:0;typeof $=="number"?W=L:(W=0,$=L);const K=[];if(W<=$)for(let U=W;U<$;U++)K.push(U);else for(let U=W;U>$;U--)K.push(U);return K}e.range=h;function D(L,$,W){return L.reduce((K,U)=>(K[$(U)]=W?W(U):U,K),Object.create(null))}e.index=D;function C(L,$){return L.push($),()=>g(L,$)}e.insert=C;function g(L,$){const W=L.indexOf($);if(W>-1)return L.splice(W,1),$}e.remove=g;function y(L,$,W){const K=L.slice(0,$),U=L.slice($);return K.concat(W,U)}e.arrayInsert=y;function R(L,$){let W;if(typeof $=="number"){let K=$;W=()=>{const U=Math.sin(K++)*179426549;return U-Math.floor(U)}}else W=Math.random;for(let K=L.length-1;K>0;K-=1){const U=Math.floor(W()*(K+1)),ee=L[K];L[K]=L[U],L[U]=ee}}e.shuffle=R;function O(L,$){const W=L.indexOf($);W>-1&&(L.splice(W,1),L.unshift($))}e.pushToStart=O;function x(L,$){const W=L.indexOf($);W>-1&&(L.splice(W,1),L.push($))}e.pushToEnd=x;function z(L,$){return Array.isArray(L)?L.map($):$(L)}e.mapArrayOrNot=z;function Q(L){return Array.isArray(L)?L:[L]}e.asArray=Q;function j(L){return L[Math.floor(Math.random()*L.length)]}e.getRandomElement=j;function Y(L,$){for(const W of L){const K=$(W);if(K!==void 0)return K}}e.mapFind=Y}),define(we[51],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(S){const T=this;let P=!1,E;return function(){return P||(P=!0,E=S.apply(T,arguments)),E}}e.once=_}),define(we[52],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(we[53],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(S){function T(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}S.is=T;const P=Object.freeze([]);function E(){return P}S.empty=E;function*k(a){yield a}S.single=k;function w(a){return a||P}S.from=w;function n(a){return!a||a[Symbol.iterator]().next().done===!0}S.isEmpty=n;function A(a){return a[Symbol.iterator]().next().value}S.first=A;function I(a,t){for(const r of a)if(t(r))return!0;return!1}S.some=I;function v(a,t){for(const r of a)if(t(r))return r}S.find=v;function*d(a,t){for(const r of a)t(r)&&(yield r)}S.filter=d;function*s(a,t){for(const r of a)yield t(r)}S.map=s;function*f(...a){for(const t of a)for(const r of t)yield r}S.concat=f;function*p(a){for(const t of a)for(const r of t)yield r}S.concatNested=p;function m(a,t,r){let o=r;for(const l of a)o=t(o,l);return o}S.reduce=m;function*b(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}S.slice=b;function c(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const o=a[Symbol.iterator]();for(let l=0;l<t;l++){const i=o.next();if(i.done)return[r,S.empty()];r.push(i.value)}return[r,{[Symbol.iterator](){return o}}]}S.consume=c;function u(a,t,r=(o,l)=>o===l){const o=a[Symbol.iterator](),l=t[Symbol.iterator]();for(;;){const i=o.next(),h=l.next();if(i.done!==h.done)return!1;if(i.done)return!0;if(!r(i.value,h.value))return!1}}S.equals=u})(_=e.Iterable||(e.Iterable={}))}),define(we[45],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var S;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(S=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function E(t,r=!1){let o=0,l=t.length,i="",h=0,D=16,C=0;function g(j){let Y=0,L=0;for(;Y<j;){const $=t.charCodeAt(o);if($>=48&&$<=57)L=L*16+$-48;else if($>=65&&$<=70)L=L*16+$-65+10;else if($>=97&&$<=102)L=L*16+$-97+10;else break;o++,Y++}return Y<j&&(L=-1),L}function y(j){o=j,i="",h=0,D=16,C=0}function R(){const j=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&n(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&n(t.charCodeAt(o)))for(o++;o<t.length&&n(t.charCodeAt(o));)o++;else return C=3,t.substring(j,o);let Y=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&n(t.charCodeAt(o))){for(o++;o<t.length&&n(t.charCodeAt(o));)o++;Y=o}else C=3;return t.substring(j,Y)}function O(){let j="",Y=o;for(;;){if(o>=l){j+=t.substring(Y,o),C=2;break}const L=t.charCodeAt(o);if(L===34){j+=t.substring(Y,o),o++;break}if(L===92){if(j+=t.substring(Y,o),o++,o>=l){C=2;break}switch(t.charCodeAt(o++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:const W=g(4);W>=0?j+=String.fromCharCode(W):C=4;break;default:C=5}Y=o;continue}if(L>=0&&L<=31)if(w(L)){j+=t.substring(Y,o),C=2;break}else C=6;o++}return j}function x(){if(i="",C=0,h=o,o>=l)return h=l,D=17;let j=t.charCodeAt(o);if(k(j)){do o++,i+=String.fromCharCode(j),j=t.charCodeAt(o);while(k(j));return D=15}if(w(j))return o++,i+=String.fromCharCode(j),j===13&&t.charCodeAt(o)===10&&(o++,i+=`
`),D=14;switch(j){case 123:return o++,D=1;case 125:return o++,D=2;case 91:return o++,D=3;case 93:return o++,D=4;case 58:return o++,D=6;case 44:return o++,D=5;case 34:return o++,i=O(),D=10;case 47:const Y=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<l&&!w(t.charCodeAt(o));)o++;return i=t.substring(Y,o),D=12}if(t.charCodeAt(o+1)===42){o+=2;const L=l-1;let $=!1;for(;o<L;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,$=!0;break}o++}return $||(o++,C=1),i=t.substring(Y,o),D=13}return i+=String.fromCharCode(j),o++,D=16;case 45:if(i+=String.fromCharCode(j),o++,o===l||!n(t.charCodeAt(o)))return D=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=R(),D=11;default:for(;o<l&&z(j);)o++,j=t.charCodeAt(o);if(h!==o){switch(i=t.substring(h,o),i){case"true":return D=8;case"false":return D=9;case"null":return D=7}return D=16}return i+=String.fromCharCode(j),o++,D=16}}function z(j){if(k(j)||w(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let j;do j=x();while(j>=12&&j<=15);return j}return{setPosition:y,getPosition:()=>o,scan:r?Q:x,getToken:()=>D,getTokenValue:()=>i,getTokenOffset:()=>h,getTokenLength:()=>o-h,getTokenError:()=>C}}e.createScanner=E;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function I(t,r){const o=[],l=new Object;let i;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function C(g,y,R,O){h.value=g,h.offset=y,h.length=R,h.type=O,h.colonOffset=void 0,i=h}try{c(t,{onObjectBegin:(g,y)=>{if(r<=g)throw l;i=void 0,D=r>g,o.push("")},onObjectProperty:(g,y,R)=>{if(r<y||(C(g,y,R,"property"),o[o.length-1]=g,r<=y+R))throw l},onObjectEnd:(g,y)=>{if(r<=g)throw l;i=void 0,o.pop()},onArrayBegin:(g,y)=>{if(r<=g)throw l;i=void 0,o.push(0)},onArrayEnd:(g,y)=>{if(r<=g)throw l;i=void 0,o.pop()},onLiteralValue:(g,y,R)=>{if(r<y||(C(g,y,R,a(g)),r<=y+R))throw l},onSeparator:(g,y,R)=>{if(r<=y)throw l;if(g===":"&&i&&i.type==="property")i.colonOffset=y,D=!1,i=void 0;else if(g===","){const O=o[o.length-1];typeof O=="number"?o[o.length-1]=O+1:(D=!0,o[o.length-1]=""),i=void 0}}})}catch(g){if(g!==l)throw g}return{path:o,previousNode:i,isAtPropertyKey:D,matches:g=>{let y=0;for(let R=0;y<g.length&&R<o.length;R++)if(g[y]===o[R]||g[y]==="*")y++;else if(g[y]!=="**")return!1;return y===g.length}}}e.getLocation=I;function v(t,r=[],o=P.DEFAULT){let l=null,i=[];const h=[];function D(g){Array.isArray(i)?i.push(g):l!==null&&(i[l]=g)}return c(t,{onObjectBegin:()=>{const g={};D(g),h.push(i),i=g,l=null},onObjectProperty:g=>{l=g},onObjectEnd:()=>{i=h.pop()},onArrayBegin:()=>{const g=[];D(g),h.push(i),i=g,l=null},onArrayEnd:()=>{i=h.pop()},onLiteralValue:D,onError:(g,y,R)=>{r.push({error:g,offset:y,length:R})}},o),i[0]}e.parse=v;function d(t,r=[],o=P.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(g){l.type==="property"&&(l.length=g-l.offset,l=l.parent)}function h(g){return l.children.push(g),g}c(t,{onObjectBegin:g=>{l=h({type:"object",offset:g,length:-1,parent:l,children:[]})},onObjectProperty:(g,y,R)=>{l=h({type:"property",offset:y,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:g,offset:y,length:R,parent:l})},onObjectEnd:(g,y)=>{l.length=g+y-l.offset,l=l.parent,i(g+y)},onArrayBegin:(g,y)=>{l=h({type:"array",offset:g,length:-1,parent:l,children:[]})},onArrayEnd:(g,y)=>{l.length=g+y-l.offset,l=l.parent,i(g+y)},onLiteralValue:(g,y,R)=>{h({type:a(g),offset:y,length:R,parent:l,value:g}),i(y+R)},onSeparator:(g,y,R)=>{l.type==="property"&&(g===":"?l.colonOffset=y:g===","&&i(y))},onError:(g,y,R)=>{r.push({error:g,offset:y,length:R})}},o);const C=l.children[0];return C&&delete C.parent,C}e.parseTree=d;function s(t,r){if(!!t){let o=t;for(let l of r)if(typeof l=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let i=!1;for(const h of o.children)if(Array.isArray(h.children)&&h.children[0].value===l){o=h.children[1],i=!0;break}if(!i)return}else{const i=l;if(o.type!=="array"||i<0||!Array.isArray(o.children)||i>=o.children.length)return;o=o.children[i]}return o}}e.findNodeAtLocation=s;function f(t){if(!t.parent||!t.parent.children)return[];const r=f(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;r.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&r.push(o)}return r}e.getNodePath=f;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const r=Object.create(null);for(let o of t.children){const l=o.children[1];l&&(r[o.children[0].value]=p(l))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function m(t,r,o=!1){return r>=t.offset&&r<t.offset+t.length||o&&r===t.offset+t.length}e.contains=m;function b(t,r,o=!1){if(m(t,r,o)){const l=t.children;if(Array.isArray(l))for(let i=0;i<l.length&&l[i].offset<=r;i++){const h=b(l[i],r,o);if(h)return h}return t}}e.findNodeAtOffset=b;function c(t,r,o=P.DEFAULT){const l=E(t,!1);function i(Se){return Se?()=>Se(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(Se){return Se?Ae=>Se(Ae,l.getTokenOffset(),l.getTokenLength()):()=>!0}const D=i(r.onObjectBegin),C=h(r.onObjectProperty),g=i(r.onObjectEnd),y=i(r.onArrayBegin),R=i(r.onArrayEnd),O=h(r.onLiteralValue),x=h(r.onSeparator),z=i(r.onComment),Q=h(r.onError),j=o&&o.disallowComments,Y=o&&o.allowTrailingComma;function L(){for(;;){const Se=l.scan();switch(l.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:j||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(Se){case 12:case 13:j?$(10):z();break;case 16:$(1);break;case 15:case 14:break;default:return Se}}}function $(Se,Ae=[],Be=[]){if(Q(Se),Ae.length+Be.length>0){let Re=l.getToken();for(;Re!==17;){if(Ae.indexOf(Re)!==-1){L();break}else if(Be.indexOf(Re)!==-1)break;Re=L()}}}function W(Se){const Ae=l.getTokenValue();return Se?O(Ae):C(Ae),L(),!0}function K(){switch(l.getToken()){case 11:let Se=0;try{Se=JSON.parse(l.getTokenValue()),typeof Se!="number"&&($(2),Se=0)}catch(Ae){$(2)}O(Se);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return L(),!0}function U(){return l.getToken()!==10?($(3,[],[2,5]),!1):(W(!1),l.getToken()===6?(x(":"),L(),se()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function ee(){D(),L();let Se=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(Se||$(4,[],[]),x(","),L(),l.getToken()===2&&Y)break}else Se&&$(6,[],[]);U()||$(4,[],[2,5]),Se=!0}return g(),l.getToken()!==2?$(7,[2],[]):L(),!0}function ie(){y(),L();let Se=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(Se||$(4,[],[]),x(","),L(),l.getToken()===4&&Y)break}else Se&&$(6,[],[]);se()||$(4,[],[4,5]),Se=!0}return R(),l.getToken()!==4?$(8,[4],[]):L(),!0}function se(){switch(l.getToken()){case 3:return ie();case 1:return ee();case 10:return W(!0);default:return K()}}return L(),l.getToken()===17?o.allowEmptyContent?!0:($(4,[],[]),!1):se()?(l.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=c;function u(t,r){let o=E(t),l=[],i,h=0,D;do switch(D=o.getPosition(),i=o.scan(),i){case 12:case 13:case 17:h!==D&&l.push(t.substring(h,D)),r!==void 0&&l.push(o.getTokenValue().replace(/[^\r\n]/g,r)),h=o.getPosition();break}while(i!==17);return l.join("")}e.stripComments=u;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(we[103],Ee([0,1,45]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function S(w,n,A){let I,v,d,s,f;if(n){for(s=n.offset,f=s+n.length,d=s;d>0&&!k(w,d-1);)d--;let h=f;for(;h<w.length&&!k(w,h);)h++;v=w.substring(d,h),I=P(v,A)}else v=w,I=0,d=0,s=0,f=w.length;const p=E(A,w);let m=!1,b=0,c;A.insertSpaces?c=T(" ",A.tabSize||4):c="	";const u=(0,_.createScanner)(v,!1);let a=!1;function t(){return p+T(c,I+b)}function r(){let h=u.scan();for(m=!1;h===15||h===14;)m=m||h===14,h=u.scan();return a=h===16||u.getTokenError()!==0,h}const o=[];function l(h,D,C){!a&&D<f&&C>s&&w.substring(D,C)!==h&&o.push({offset:D,length:C-D,content:h})}let i=r();if(i!==17){const h=u.getTokenOffset()+d,D=T(c,I);l(D,d,h)}for(;i!==17;){let h=u.getTokenOffset()+u.getTokenLength()+d,D=r(),C="";for(;!m&&(D===12||D===13);){const y=u.getTokenOffset()+d;l(" ",h,y),h=u.getTokenOffset()+u.getTokenLength()+d,C=D===12?t():"",D=r()}if(D===2)i!==1&&(b--,C=t());else if(D===4)i!==3&&(b--,C=t());else{switch(i){case 3:case 1:b++,C=t();break;case 5:case 12:C=t();break;case 13:m?C=t():C=" ";break;case 6:C=" ";break;case 10:if(D===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?C=" ":D!==5&&D!==17&&(a=!0);break;case 16:a=!0;break}m&&(D===12||D===13)&&(C=t())}const g=u.getTokenOffset()+d;l(C,h,g),i=D}return o}e.format=S;function T(w,n){let A="";for(let I=0;I<n;I++)A+=w;return A}function P(w,n){let A=0,I=0;const v=n.tabSize||4;for(;A<w.length;){const d=w.charAt(A);if(d===" ")I++;else if(d==="	")I+=v;else break;A++}return Math.floor(I/v)}function E(w,n){for(let A=0;A<n.length;A++){const I=n.charAt(A);if(I==="\r")return A+1<n.length&&n.charAt(A+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=E;function k(w,n){return`\r
`.indexOf(w.charAt(n))!==-1}e.isEOL=k}),define(we[104],Ee([0,1,45,103]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(n,A,I){return P(n,A,void 0,I)}e.removeProperty=T;function P(n,A,I,v,d){const s=A.slice(),f=[],p=(0,_.parseTree)(n,f);let m,b;for(;s.length>0&&(b=s.pop(),m=(0,_.findNodeAtLocation)(p,s),m===void 0&&I!==void 0);)typeof b=="string"?I={[b]:I}:I=[I];if(m)if(m.type==="object"&&typeof b=="string"&&Array.isArray(m.children)){const c=(0,_.findNodeAtLocation)(m,[b]);if(c!==void 0)if(I===void 0){if(!c.parent)throw new Error("Malformed AST");const u=m.children.indexOf(c.parent);let a,t=c.parent.offset+c.parent.length;if(u>0){const r=m.children[u-1];a=r.offset+r.length}else a=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return E(n,{offset:a,length:t-a,content:""},v)}else return E(n,{offset:c.offset,length:c.length,content:JSON.stringify(I)},v);else{if(I===void 0)return[];const u=`${JSON.stringify(b)}: ${JSON.stringify(I)}`,a=d?d(m.children.map(r=>r.children[0].value)):m.children.length;let t;if(a>0){const r=m.children[a-1];t={offset:r.offset+r.length,length:0,content:","+u}}else m.children.length===0?t={offset:m.offset+1,length:0,content:u}:t={offset:m.offset+1,length:0,content:u+","};return E(n,t,v)}}else if(m.type==="array"&&typeof b=="number"&&Array.isArray(m.children))if(I!==void 0){const c=`${JSON.stringify(I)}`;let u;if(m.children.length===0||b===0)u={offset:m.offset+1,length:0,content:m.children.length===0?c:c+","};else{const a=b===-1||b>m.children.length?m.children.length:b,t=m.children[a-1];u={offset:t.offset+t.length,length:0,content:","+c}}return E(n,u,v)}else{const c=b,u=m.children[c];let a;if(m.children.length===1)a={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===c){const t=m.children[c-1],r=t.offset+t.length,o=m.offset+m.length;a={offset:r,length:o-2-r,content:""}}else a={offset:u.offset,length:m.children[c+1].offset-u.offset,content:""};return E(n,a,v)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${m.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return E(n,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(I)},v)}}e.setProperty=P;function E(n,A,I){let v=k(n,A),d=A.offset,s=A.offset+A.content.length;if(A.length===0||A.content.length===0){for(;d>0&&!(0,S.isEOL)(v,d-1);)d--;for(;s<v.length&&!(0,S.isEOL)(v,s);)s++}const f=(0,S.format)(v,{offset:d,length:s-d},I);for(let m=f.length-1;m>=0;m--){const b=f[m];v=k(v,b),d=Math.min(d,b.offset),s=Math.max(s,b.offset+b.length),s+=b.content.length-b.length}const p=n.length-(v.length-s)-d;return[{offset:d,length:p,content:v.substring(d,s)}]}e.withFormatting=E;function k(n,A){return n.substring(0,A.offset)+A.content+n.substring(A.offset+A.length)}e.applyEdit=k;function w(n,A){let I=A.slice(0).sort((d,s)=>{const f=d.offset-s.offset;return f===0?d.length-s.length:f}),v=n.length;for(let d=I.length-1;d>=0;d--){let s=I[d];if(s.offset+s.length<=v)n=k(n,s);else throw new Error("Overlapping edit");v=s.offset}return n}e.applyEdits=w}),define(we[105],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new _(()=>T(this.getValue()))}}e.Lazy=_}),define(we[6],Ee([0,1,51,53]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let P=null;function E(c){P=c}if(e.setDisposableTracker=E,T){const c="__is_disposable_tracked__";P=new class{trackDisposable(u){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[c]||console.log(a)},3e3)}markTracked(u){if(u&&u!==f.None)try{u[c]=!0}catch(a){}}}}function k(c){!P||P.markTracked(c)}function w(c){return P&&P.trackDisposable(c),c}e.trackDisposable=w;class n extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=n;function A(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=A;function I(c){if(S.Iterable.is(c)){let u=[];for(const a of c)if(a){k(a);try{a.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new n(u);return Array.isArray(c)?[]:c}else if(c)return k(c),c.dispose(),c}e.dispose=I;function v(...c){return c.forEach(k),d(()=>I(c))}e.combinedDisposable=v;function d(c){const u=w({dispose:()=>{k(u),c()}});return u}e.toDisposable=d;class s{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(k(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return k(u),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=s,s.DISABLE_DISPOSED_WARNING=!1;class f{constructor(){this._store=new s,w(this)}dispose(){k(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=f,f.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var a;this._isDisposed||u===this._value||((a=this._value)===null||a===void 0||a.dispose(),u&&k(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,k(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=p;class m{constructor(){this.references=new Map}acquire(u,...a){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...a)},this.references.set(u,t));const{object:r}=t,o=(0,_.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:r,dispose:o}}}e.ReferenceCollection=m;class b{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=b}),define(we[46],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(P){this.element=P,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class S{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,E){const k=new _(P);if(this._first===_.Undefined)this._first=k,this._last=k;else if(E){const n=this._last;this._last=k,k.prev=n,n.next=k}else{const n=this._first;this._first=k,k.next=n,n.prev=k}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(k))}}shift(){if(this._first!==_.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==_.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==_.Undefined&&P.next!==_.Undefined){const E=P.prev;E.next=P.next,P.next.prev=E}else P.prev===_.Undefined&&P.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):P.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):P.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==_.Undefined;)yield P.element,P=P.next}}e.LinkedList=S}),function(ae,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ae=typeof globalThis!="undefined"?globalThis:ae||self,ae.marked=e())}(this,function(){"use strict";function ae(B,re){for(var ce=0;ce<re.length;ce++){var V=re[ce];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(B,V.key,V)}}function e(B,re,ce){return re&&ae(B.prototype,re),ce&&ae(B,ce),B}function _(B,re){if(!!B){if(typeof B=="string")return S(B,re);var ce=Object.prototype.toString.call(B).slice(8,-1);if(ce==="Object"&&B.constructor&&(ce=B.constructor.name),ce==="Map"||ce==="Set")return Array.from(B);if(ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ce))return S(B,re)}}function S(B,re){(re==null||re>B.length)&&(re=B.length);for(var ce=0,V=new Array(re);ce<re;ce++)V[ce]=B[ce];return V}function T(B,re){var ce;if(typeof Symbol=="undefined"||B[Symbol.iterator]==null){if(Array.isArray(B)||(ce=_(B))||re&&B&&typeof B.length=="number"){ce&&(B=ce);var V=0;return function(){return V>=B.length?{done:!0}:{done:!1,value:B[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ce=B[Symbol.iterator](),ce.next.bind(ce)}function P(B){var re={exports:{}};return B(re,re.exports),re.exports}var E=P(function(B){function re(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ce(V){B.exports.defaults=V}B.exports={defaults:re(),getDefaults:re,changeDefaults:ce}}),k=/[&<>"']/,w=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(re){return I[re]};function d(B,re){if(re){if(k.test(B))return B.replace(w,v)}else if(n.test(B))return B.replace(A,v);return B}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(B){return B.replace(s,function(re,ce){return ce=ce.toLowerCase(),ce==="colon"?":":ce.charAt(0)==="#"?ce.charAt(1)==="x"?String.fromCharCode(parseInt(ce.substring(2),16)):String.fromCharCode(+ce.substring(1)):""})}var p=/(^|[^\[])\^/g;function m(B,re){B=B.source||B,re=re||"";var ce={replace:function(X,oe){return oe=oe.source||oe,oe=oe.replace(p,"$1"),B=B.replace(X,oe),ce},getRegex:function(){return new RegExp(B,re)}};return ce}var b=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(B,re,ce){if(B){var V;try{V=decodeURIComponent(f(ce)).replace(b,"").toLowerCase()}catch(X){return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}re&&!c.test(ce)&&(ce=l(re,ce));try{ce=encodeURI(ce).replace(/%25/g,"%")}catch(X){return null}return ce}var a={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(B,re){a[" "+B]||(t.test(B)?a[" "+B]=B+"/":a[" "+B]=C(B,"/",!0)),B=a[" "+B];var ce=B.indexOf(":")===-1;return re.substring(0,2)==="//"?ce?re:B.replace(r,"$1")+re:re.charAt(0)==="/"?ce?re:B.replace(o,"$1")+re:B+re}var i={exec:function(){}};function h(B){for(var re=1,ce,V;re<arguments.length;re++){ce=arguments[re];for(V in ce)Object.prototype.hasOwnProperty.call(ce,V)&&(B[V]=ce[V])}return B}function D(B,re){var ce=B.replace(/\|/g,function(oe,fe,ve){for(var $e=!1,Ne=fe;--Ne>=0&&ve[Ne]==="\\";)$e=!$e;return $e?"|":" |"}),V=ce.split(/ \|/),X=0;if(V.length>re)V.splice(re);else for(;V.length<re;)V.push("");for(;X<V.length;X++)V[X]=V[X].trim().replace(/\\\|/g,"|");return V}function C(B,re,ce){var V=B.length;if(V===0)return"";for(var X=0;X<V;){var oe=B.charAt(V-X-1);if(oe===re&&!ce)X++;else if(oe!==re&&ce)X++;else break}return B.substr(0,V-X)}function g(B,re){if(B.indexOf(re[1])===-1)return-1;for(var ce=B.length,V=0,X=0;X<ce;X++)if(B[X]==="\\")X++;else if(B[X]===re[0])V++;else if(B[X]===re[1]&&(V--,V<0))return X;return-1}function y(B){B&&B.sanitize&&!B.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(B,re){if(re<1)return"";for(var ce="";re>1;)re&1&&(ce+=B),re>>=1,B+=B;return ce+B}var O={escape:d,unescape:f,edit:m,cleanUrl:u,resolveUrl:l,noopTest:i,merge:h,splitCells:D,rtrim:C,findClosingBracket:g,checkSanitizeDeprecation:y,repeatString:R},x=E.defaults,z=O.rtrim,Q=O.splitCells,j=O.escape,Y=O.findClosingBracket;function L(B,re,ce){var V=re.href,X=re.title?j(re.title):null,oe=B[1].replace(/\\([\[\]])/g,"$1");return B[0].charAt(0)!=="!"?{type:"link",raw:ce,href:V,title:X,text:oe}:{type:"image",raw:ce,href:V,title:X,text:j(oe)}}function $(B,re){var ce=B.match(/^(\s+)(?:```)/);if(ce===null)return re;var V=ce[1];return re.split(`
`).map(function(X){var oe=X.match(/^\s+/);if(oe===null)return X;var fe=oe[0];return fe.length>=V.length?X.slice(V.length):X}).join(`
`)}var W=function(){function B(ce){this.options=ce||x}var re=B.prototype;return re.space=function(V){var X=this.rules.block.newline.exec(V);if(X)return X[0].length>1?{type:"space",raw:X[0]}:{raw:`
`}},re.code=function(V){var X=this.rules.block.code.exec(V);if(X){var oe=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:z(oe,`
`)}}},re.fences=function(V){var X=this.rules.block.fences.exec(V);if(X){var oe=X[0],fe=$(oe,X[3]||"");return{type:"code",raw:oe,lang:X[2]?X[2].trim():X[2],text:fe}}},re.heading=function(V){var X=this.rules.block.heading.exec(V);if(X){var oe=X[2].trim();if(/#$/.test(oe)){var fe=z(oe,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(oe=fe.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:oe}}},re.nptable=function(V){var X=this.rules.block.nptable.exec(V);if(X){var oe={type:"table",header:Q(X[1].replace(/^ *| *\| *$/g,"")),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:X[3]?X[3].replace(/\n$/,"").split(`
`):[],raw:X[0]};if(oe.header.length===oe.align.length){var fe=oe.align.length,ve;for(ve=0;ve<fe;ve++)/^ *-+: *$/.test(oe.align[ve])?oe.align[ve]="right":/^ *:-+: *$/.test(oe.align[ve])?oe.align[ve]="center":/^ *:-+ *$/.test(oe.align[ve])?oe.align[ve]="left":oe.align[ve]=null;for(fe=oe.cells.length,ve=0;ve<fe;ve++)oe.cells[ve]=Q(oe.cells[ve],oe.header.length);return oe}}},re.hr=function(V){var X=this.rules.block.hr.exec(V);if(X)return{type:"hr",raw:X[0]}},re.blockquote=function(V){var X=this.rules.block.blockquote.exec(V);if(X){var oe=X[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:X[0],text:oe}}},re.list=function(V){var X=this.rules.block.list.exec(V);if(X){var oe=X[0],fe=X[2],ve=fe.length>1,$e={type:"list",raw:oe,ordered:ve,start:ve?+fe.slice(0,-1):"",loose:!1,items:[]},Ne=X[0].match(this.rules.block.item),Ve=!1,Qe,Ze,ct,st,me,he,ue,G,Ie=Ne.length;ct=this.rules.block.listItemStart.exec(Ne[0]);for(var Pe=0;Pe<Ie;Pe++){if(Qe=Ne[Pe],oe=Qe,Pe!==Ie-1){if(st=this.rules.block.listItemStart.exec(Ne[Pe+1]),this.options.pedantic?st[1].length>ct[1].length:st[1].length>ct[0].length||st[1].length>3){Ne.splice(Pe,2,Ne[Pe]+`
`+Ne[Pe+1]),Pe--,Ie--;continue}else(!this.options.pedantic||this.options.smartLists?st[2][st[2].length-1]!==fe[fe.length-1]:ve===(st[2].length===1))&&(me=Ne.slice(Pe+1).join(`
`),$e.raw=$e.raw.substring(0,$e.raw.length-me.length),Pe=Ie-1);ct=st}Ze=Qe.length,Qe=Qe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Qe.indexOf(`
 `)&&(Ze-=Qe.length,Qe=this.options.pedantic?Qe.replace(/^ {1,4}/gm,""):Qe.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),he=Ve||/\n\n(?!\s*$)/.test(Qe),Pe!==Ie-1&&(Ve=Qe.charAt(Qe.length-1)===`
`,he||(he=Ve)),he&&($e.loose=!0),this.options.gfm&&(ue=/^\[[ xX]\] /.test(Qe),G=void 0,ue&&(G=Qe[1]!==" ",Qe=Qe.replace(/^\[[ xX]\] +/,""))),$e.items.push({type:"list_item",raw:oe,task:ue,checked:G,loose:he,text:Qe})}return $e}},re.html=function(V){var X=this.rules.block.html.exec(V);if(X)return{type:this.options.sanitize?"paragraph":"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):j(X[0]):X[0]}},re.def=function(V){var X=this.rules.block.def.exec(V);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var oe=X[1].toLowerCase().replace(/\s+/g," ");return{tag:oe,raw:X[0],href:X[2],title:X[3]}}},re.table=function(V){var X=this.rules.block.table.exec(V);if(X){var oe={type:"table",header:Q(X[1].replace(/^ *| *\| *$/g,"")),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:X[3]?X[3].replace(/\n$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=X[0];var fe=oe.align.length,ve;for(ve=0;ve<fe;ve++)/^ *-+: *$/.test(oe.align[ve])?oe.align[ve]="right":/^ *:-+: *$/.test(oe.align[ve])?oe.align[ve]="center":/^ *:-+ *$/.test(oe.align[ve])?oe.align[ve]="left":oe.align[ve]=null;for(fe=oe.cells.length,ve=0;ve<fe;ve++)oe.cells[ve]=Q(oe.cells[ve].replace(/^ *\| *| *\| *$/g,""),oe.header.length);return oe}}},re.lheading=function(V){var X=this.rules.block.lheading.exec(V);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1]}},re.paragraph=function(V){var X=this.rules.block.paragraph.exec(V);if(X)return{type:"paragraph",raw:X[0],text:X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1]}},re.text=function(V){var X=this.rules.block.text.exec(V);if(X)return{type:"text",raw:X[0],text:X[0]}},re.escape=function(V){var X=this.rules.inline.escape.exec(V);if(X)return{type:"escape",raw:X[0],text:j(X[1])}},re.tag=function(V,X,oe){var fe=this.rules.inline.tag.exec(V);if(fe)return!X&&/^<a /i.test(fe[0])?X=!0:X&&/^<\/a>/i.test(fe[0])&&(X=!1),!oe&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?oe=!0:oe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(oe=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:X,inRawBlock:oe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):j(fe[0]):fe[0]}},re.link=function(V){var X=this.rules.inline.link.exec(V);if(X){var oe=X[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var fe=z(oe.slice(0,-1),"\\");if((oe.length-fe.length)%2==0)return}else{var ve=Y(X[2],"()");if(ve>-1){var $e=X[0].indexOf("!")===0?5:4,Ne=$e+X[1].length+ve;X[2]=X[2].substring(0,ve),X[0]=X[0].substring(0,Ne).trim(),X[3]=""}}var Ve=X[2],Qe="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);Ze&&(Ve=Ze[1],Qe=Ze[3])}else Qe=X[3]?X[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(oe)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),L(X,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:Qe&&Qe.replace(this.rules.inline._escapes,"$1")},X[0])}},re.reflink=function(V,X){var oe;if((oe=this.rules.inline.reflink.exec(V))||(oe=this.rules.inline.nolink.exec(V))){var fe=(oe[2]||oe[1]).replace(/\s+/g," ");if(fe=X[fe.toLowerCase()],!fe||!fe.href){var ve=oe[0].charAt(0);return{type:"text",raw:ve,text:ve}}return L(oe,fe,oe[0])}},re.emStrong=function(V,X,oe){oe===void 0&&(oe="");var fe=this.rules.inline.emStrong.lDelim.exec(V);if(!!fe&&!(fe[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ve=fe[1]||fe[2]||"";if(!ve||ve&&(oe===""||this.rules.inline.punctuation.exec(oe))){var $e=fe[0].length-1,Ne,Ve,Qe=$e,Ze=0,ct=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ct.lastIndex=0,X=X.slice(-1*V.length+$e);(fe=ct.exec(X))!=null;)if(Ne=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ne){if(Ve=Ne.length,fe[3]||fe[4]){Qe+=Ve;continue}else if((fe[5]||fe[6])&&$e%3&&!(($e+Ve)%3)){Ze+=Ve;continue}if(Qe-=Ve,!(Qe>0)){if(Qe+Ze-Ve<=0&&!X.slice(ct.lastIndex).match(ct)&&(Ve=Math.min(Ve,Ve+Qe+Ze)),Math.min($e,Ve)%2)return{type:"em",raw:V.slice(0,$e+fe.index+Ve+1),text:V.slice(1,$e+fe.index+Ve)};if(Math.min($e,Ve)%2==0)return{type:"strong",raw:V.slice(0,$e+fe.index+Ve+1),text:V.slice(2,$e+fe.index+Ve-1)}}}}}},re.codespan=function(V){var X=this.rules.inline.code.exec(V);if(X){var oe=X[2].replace(/\n/g," "),fe=/[^ ]/.test(oe),ve=/^ /.test(oe)&&/ $/.test(oe);return fe&&ve&&(oe=oe.substring(1,oe.length-1)),oe=j(oe,!0),{type:"codespan",raw:X[0],text:oe}}},re.br=function(V){var X=this.rules.inline.br.exec(V);if(X)return{type:"br",raw:X[0]}},re.del=function(V){var X=this.rules.inline.del.exec(V);if(X)return{type:"del",raw:X[0],text:X[2]}},re.autolink=function(V,X){var oe=this.rules.inline.autolink.exec(V);if(oe){var fe,ve;return oe[2]==="@"?(fe=j(this.options.mangle?X(oe[1]):oe[1]),ve="mailto:"+fe):(fe=j(oe[1]),ve=fe),{type:"link",raw:oe[0],text:fe,href:ve,tokens:[{type:"text",raw:fe,text:fe}]}}},re.url=function(V,X){var oe;if(oe=this.rules.inline.url.exec(V)){var fe,ve;if(oe[2]==="@")fe=j(this.options.mangle?X(oe[0]):oe[0]),ve="mailto:"+fe;else{var $e;do $e=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while($e!==oe[0]);fe=j(oe[0]),oe[1]==="www."?ve="http://"+fe:ve=fe}return{type:"link",raw:oe[0],text:fe,href:ve,tokens:[{type:"text",raw:fe,text:fe}]}}},re.inlineText=function(V,X,oe){var fe=this.rules.inline.text.exec(V);if(fe){var ve;return X?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):j(fe[0]):fe[0]:ve=j(this.options.smartypants?oe(fe[0]):fe[0]),{type:"text",raw:fe[0],text:ve}}},B}(),K=O.noopTest,U=O.edit,ee=O.merge,ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:K,table:K,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=U(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,ie.item=U(ie.item,"gm").replace(/bull/g,ie.bullet).getRegex(),ie.listItemStart=U(/^( *)(bull)/).replace("bull",ie.bullet).getRegex(),ie.list=U(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=U(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=U(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=U(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=ee({},ie),ie.gfm=ee({},ie.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.nptable=U(ie.gfm.nptable).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.table=U(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=ee({},ie.normal,{html:U(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:K,paragraph:U(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:K,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:K,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=U(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=U(ie._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=U(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=U(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=U(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=U(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=U(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=U(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=U(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=U(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=ee({},se),se.pedantic=ee({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:U(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:U(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=ee({},se.normal,{escape:U(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),se.gfm.url=U(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=ee({},se.gfm,{br:U(se.br).replace("{2,}","*").getRegex(),text:U(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Se={block:ie,inline:se},Ae=E.defaults,Be=Se.block,Re=Se.inline,xe=O.repeatString;function N(B){return B.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(B){var re="",ce,V,X=B.length;for(ce=0;ce<X;ce++)V=B.charCodeAt(ce),Math.random()>.5&&(V="x"+V.toString(16)),re+="&#"+V+";";return re}var J=function(){function B(ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=ce||Ae,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var V={block:Be.normal,inline:Re.normal};this.options.pedantic?(V.block=Be.pedantic,V.inline=Re.pedantic):this.options.gfm&&(V.block=Be.gfm,this.options.breaks?V.inline=Re.breaks:V.inline=Re.gfm),this.tokenizer.rules=V}B.lex=function(V,X){var oe=new B(X);return oe.lex(V)},B.lexInline=function(V,X){var oe=new B(X);return oe.inlineTokens(V)};var re=B.prototype;return re.lex=function(V){return V=V.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(V,this.tokens,!0),this.inline(this.tokens),this.tokens},re.blockTokens=function(V,X,oe){X===void 0&&(X=[]),oe===void 0&&(oe=!0),this.options.pedantic&&(V=V.replace(/^ +$/gm,""));for(var fe,ve,$e,Ne;V;){if(fe=this.tokenizer.space(V)){V=V.substring(fe.raw.length),fe.type&&X.push(fe);continue}if(fe=this.tokenizer.code(V)){V=V.substring(fe.raw.length),Ne=X[X.length-1],Ne&&Ne.type==="paragraph"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text):X.push(fe);continue}if(fe=this.tokenizer.fences(V)){V=V.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.heading(V)){V=V.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.nptable(V)){V=V.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.hr(V)){V=V.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.blockquote(V)){V=V.substring(fe.raw.length),fe.tokens=this.blockTokens(fe.text,[],oe),X.push(fe);continue}if(fe=this.tokenizer.list(V)){for(V=V.substring(fe.raw.length),$e=fe.items.length,ve=0;ve<$e;ve++)fe.items[ve].tokens=this.blockTokens(fe.items[ve].text,[],!1);X.push(fe);continue}if(fe=this.tokenizer.html(V)){V=V.substring(fe.raw.length),X.push(fe);continue}if(oe&&(fe=this.tokenizer.def(V))){V=V.substring(fe.raw.length),this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(V)){V=V.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.lheading(V)){V=V.substring(fe.raw.length),X.push(fe);continue}if(oe&&(fe=this.tokenizer.paragraph(V))){V=V.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.text(V)){V=V.substring(fe.raw.length),Ne=X[X.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text):X.push(fe);continue}if(V){var Ve="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return X},re.inline=function(V){var X,oe,fe,ve,$e,Ne,Ve=V.length;for(X=0;X<Ve;X++)switch(Ne=V[X],Ne.type){case"paragraph":case"text":case"heading":{Ne.tokens=[],this.inlineTokens(Ne.text,Ne.tokens);break}case"table":{for(Ne.tokens={header:[],cells:[]},ve=Ne.header.length,oe=0;oe<ve;oe++)Ne.tokens.header[oe]=[],this.inlineTokens(Ne.header[oe],Ne.tokens.header[oe]);for(ve=Ne.cells.length,oe=0;oe<ve;oe++)for($e=Ne.cells[oe],Ne.tokens.cells[oe]=[],fe=0;fe<$e.length;fe++)Ne.tokens.cells[oe][fe]=[],this.inlineTokens($e[fe],Ne.tokens.cells[oe][fe]);break}case"blockquote":{this.inline(Ne.tokens);break}case"list":{for(ve=Ne.items.length,oe=0;oe<ve;oe++)this.inline(Ne.items[oe].tokens);break}}return V},re.inlineTokens=function(V,X,oe,fe){X===void 0&&(X=[]),oe===void 0&&(oe=!1),fe===void 0&&(fe=!1);var ve,$e,Ne=V,Ve,Qe,Ze;if(this.tokens.links){var ct=Object.keys(this.tokens.links);if(ct.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)ct.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,Ve.index)+"["+xe("a",Ve[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,Ve.index)+"["+xe("a",Ve[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,Ve.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;){if(Qe||(Ze=""),Qe=!1,ve=this.tokenizer.escape(V)){V=V.substring(ve.raw.length),X.push(ve);continue}if(ve=this.tokenizer.tag(V,oe,fe)){V=V.substring(ve.raw.length),oe=ve.inLink,fe=ve.inRawBlock;var st=X[X.length-1];st&&ve.type==="text"&&st.type==="text"?(st.raw+=ve.raw,st.text+=ve.text):X.push(ve);continue}if(ve=this.tokenizer.link(V)){V=V.substring(ve.raw.length),ve.type==="link"&&(ve.tokens=this.inlineTokens(ve.text,[],!0,fe)),X.push(ve);continue}if(ve=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(ve.raw.length);var me=X[X.length-1];ve.type==="link"?(ve.tokens=this.inlineTokens(ve.text,[],!0,fe),X.push(ve)):me&&ve.type==="text"&&me.type==="text"?(me.raw+=ve.raw,me.text+=ve.text):X.push(ve);continue}if(ve=this.tokenizer.emStrong(V,Ne,Ze)){V=V.substring(ve.raw.length),ve.tokens=this.inlineTokens(ve.text,[],oe,fe),X.push(ve);continue}if(ve=this.tokenizer.codespan(V)){V=V.substring(ve.raw.length),X.push(ve);continue}if(ve=this.tokenizer.br(V)){V=V.substring(ve.raw.length),X.push(ve);continue}if(ve=this.tokenizer.del(V)){V=V.substring(ve.raw.length),ve.tokens=this.inlineTokens(ve.text,[],oe,fe),X.push(ve);continue}if(ve=this.tokenizer.autolink(V,q)){V=V.substring(ve.raw.length),X.push(ve);continue}if(!oe&&(ve=this.tokenizer.url(V,q))){V=V.substring(ve.raw.length),X.push(ve);continue}if(ve=this.tokenizer.inlineText(V,fe,N)){V=V.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(Ze=ve.raw.slice(-1)),Qe=!0,$e=X[X.length-1],$e&&$e.type==="text"?($e.raw+=ve.raw,$e.text+=ve.text):X.push(ve);continue}if(V){var he="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return X},e(B,null,[{key:"rules",get:function(){return{block:Be,inline:Re}}}]),B}(),le=E.defaults,ge=O.cleanUrl,De=O.escape,Le=function(){function B(ce){this.options=ce||le}var re=B.prototype;return re.code=function(V,X,oe){var fe=(X||"").match(/\S*/)[0];if(this.options.highlight){var ve=this.options.highlight(V,fe);ve!=null&&ve!==V&&(oe=!0,V=ve)}return V=V.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+De(fe,!0)+'">'+(oe?V:De(V,!0))+`</code></pre>
`:"<pre><code>"+(oe?V:De(V,!0))+`</code></pre>
`},re.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},re.html=function(V){return V},re.heading=function(V,X,oe,fe){return this.options.headerIds?"<h"+X+' id="'+this.options.headerPrefix+fe.slug(oe)+'">'+V+"</h"+X+`>
`:"<h"+X+">"+V+"</h"+X+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(V,X,oe){var fe=X?"ol":"ul",ve=X&&oe!==1?' start="'+oe+'"':"";return"<"+fe+ve+`>
`+V+"</"+fe+`>
`},re.listitem=function(V){return"<li>"+V+`</li>
`},re.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(V){return"<p>"+V+`</p>
`},re.table=function(V,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+X+`</table>
`},re.tablerow=function(V){return`<tr>
`+V+`</tr>
`},re.tablecell=function(V,X){var oe=X.header?"th":"td",fe=X.align?"<"+oe+' align="'+X.align+'">':"<"+oe+">";return fe+V+"</"+oe+`>
`},re.strong=function(V){return"<strong>"+V+"</strong>"},re.em=function(V){return"<em>"+V+"</em>"},re.codespan=function(V){return"<code>"+V+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(V){return"<del>"+V+"</del>"},re.link=function(V,X,oe){if(V=ge(this.options.sanitize,this.options.baseUrl,V),V===null)return oe;var fe='<a href="'+De(V)+'"';return X&&(fe+=' title="'+X+'"'),fe+=">"+oe+"</a>",fe},re.image=function(V,X,oe){if(V=ge(this.options.sanitize,this.options.baseUrl,V),V===null)return oe;var fe='<img src="'+V+'" alt="'+oe+'"';return X&&(fe+=' title="'+X+'"'),fe+=this.options.xhtml?"/>":">",fe},re.text=function(V){return V},B}(),pe=function(){function B(){}var re=B.prototype;return re.strong=function(V){return V},re.em=function(V){return V},re.codespan=function(V){return V},re.del=function(V){return V},re.html=function(V){return V},re.text=function(V){return V},re.link=function(V,X,oe){return""+oe},re.image=function(V,X,oe){return""+oe},re.br=function(){return""},B}(),Ce=function(){function B(){this.seen={}}var re=B.prototype;return re.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(V,X){var oe=V,fe=0;if(this.seen.hasOwnProperty(oe)){fe=this.seen[V];do fe++,oe=V+"-"+fe;while(this.seen.hasOwnProperty(oe))}return X||(this.seen[V]=fe,this.seen[oe]=0),oe},re.slug=function(V,X){X===void 0&&(X={});var oe=this.serialize(V);return this.getNextSafeSlug(oe,X.dryrun)},B}(),Te=E.defaults,Ue=O.unescape,be=function(){function B(ce){this.options=ce||Te,this.options.renderer=this.options.renderer||new Le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new Ce}B.parse=function(V,X){var oe=new B(X);return oe.parse(V)},B.parseInline=function(V,X){var oe=new B(X);return oe.parseInline(V)};var re=B.prototype;return re.parse=function(V,X){X===void 0&&(X=!0);var oe="",fe,ve,$e,Ne,Ve,Qe,Ze,ct,st,me,he,ue,G,Ie,Pe,et,Ge,rt,lt=V.length;for(fe=0;fe<lt;fe++)switch(me=V[fe],me.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(me.tokens),me.depth,Ue(this.parseInline(me.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(me.text,me.lang,me.escaped);continue}case"table":{for(ct="",Ze="",Ne=me.header.length,ve=0;ve<Ne;ve++)Ze+=this.renderer.tablecell(this.parseInline(me.tokens.header[ve]),{header:!0,align:me.align[ve]});for(ct+=this.renderer.tablerow(Ze),st="",Ne=me.cells.length,ve=0;ve<Ne;ve++){for(Qe=me.tokens.cells[ve],Ze="",Ve=Qe.length,$e=0;$e<Ve;$e++)Ze+=this.renderer.tablecell(this.parseInline(Qe[$e]),{header:!1,align:me.align[$e]});st+=this.renderer.tablerow(Ze)}oe+=this.renderer.table(ct,st);continue}case"blockquote":{st=this.parse(me.tokens),oe+=this.renderer.blockquote(st);continue}case"list":{for(he=me.ordered,ue=me.start,G=me.loose,Ne=me.items.length,st="",ve=0;ve<Ne;ve++)Pe=me.items[ve],et=Pe.checked,Ge=Pe.task,Ie="",Pe.task&&(rt=this.renderer.checkbox(et),G?Pe.tokens.length>0&&Pe.tokens[0].type==="text"?(Pe.tokens[0].text=rt+" "+Pe.tokens[0].text,Pe.tokens[0].tokens&&Pe.tokens[0].tokens.length>0&&Pe.tokens[0].tokens[0].type==="text"&&(Pe.tokens[0].tokens[0].text=rt+" "+Pe.tokens[0].tokens[0].text)):Pe.tokens.unshift({type:"text",text:rt}):Ie+=rt),Ie+=this.parse(Pe.tokens,G),st+=this.renderer.listitem(Ie,Ge,et);oe+=this.renderer.list(st,he,ue);continue}case"html":{oe+=this.renderer.html(me.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(me.tokens));continue}case"text":{for(st=me.tokens?this.parseInline(me.tokens):me.text;fe+1<lt&&V[fe+1].type==="text";)me=V[++fe],st+=`
`+(me.tokens?this.parseInline(me.tokens):me.text);oe+=X?this.renderer.paragraph(st):st;continue}default:{var Je='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}return oe},re.parseInline=function(V,X){X=X||this.renderer;var oe="",fe,ve,$e=V.length;for(fe=0;fe<$e;fe++)switch(ve=V[fe],ve.type){case"escape":{oe+=X.text(ve.text);break}case"html":{oe+=X.html(ve.text);break}case"link":{oe+=X.link(ve.href,ve.title,this.parseInline(ve.tokens,X));break}case"image":{oe+=X.image(ve.href,ve.title,ve.text);break}case"strong":{oe+=X.strong(this.parseInline(ve.tokens,X));break}case"em":{oe+=X.em(this.parseInline(ve.tokens,X));break}case"codespan":{oe+=X.codespan(ve.text);break}case"br":{oe+=X.br();break}case"del":{oe+=X.del(this.parseInline(ve.tokens,X));break}case"text":{oe+=X.text(ve.text);break}default:{var Ne='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}return oe},B}(),Ke=O.merge,H=O.checkSanitizeDeprecation,Z=O.escape,_e=E.getDefaults,Me=E.changeDefaults,He=E.defaults;function Oe(B,re,ce){if(typeof B=="undefined"||B===null)throw new Error("marked(): input parameter is undefined or null");if(typeof B!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(B)+", string expected");if(typeof re=="function"&&(ce=re,re=null),re=Ke({},Oe.defaults,re||{}),H(re),ce){var V=re.highlight,X;try{X=J.lex(B,re)}catch($e){return ce($e)}var oe=function(Ne){var Ve;if(!Ne)try{Ve=be.parse(X,re)}catch(Qe){Ne=Qe}return re.highlight=V,Ne?ce(Ne):ce(null,Ve)};if(!V||V.length<3||(delete re.highlight,!X.length))return oe();var fe=0;Oe.walkTokens(X,function($e){$e.type==="code"&&(fe++,setTimeout(function(){V($e.text,$e.lang,function(Ne,Ve){if(Ne)return oe(Ne);Ve!=null&&Ve!==$e.text&&($e.text=Ve,$e.escaped=!0),fe--,fe===0&&oe()})},0))}),fe===0&&oe();return}try{var ve=J.lex(B,re);return re.walkTokens&&Oe.walkTokens(ve,re.walkTokens),be.parse(ve,re)}catch($e){if($e.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+Z($e.message+"",!0)+"</pre>";throw $e}}Oe.options=Oe.setOptions=function(B){return Ke(Oe.defaults,B),Me(Oe.defaults),Oe},Oe.getDefaults=_e,Oe.defaults=He,Oe.use=function(B){var re=Ke({},B);if(B.renderer&&function(){var V=Oe.defaults.renderer||new Le,X=function(ve){var $e=V[ve];V[ve]=function(){for(var Ne=arguments.length,Ve=new Array(Ne),Qe=0;Qe<Ne;Qe++)Ve[Qe]=arguments[Qe];var Ze=B.renderer[ve].apply(V,Ve);return Ze===!1&&(Ze=$e.apply(V,Ve)),Ze}};for(var oe in B.renderer)X(oe);re.renderer=V}(),B.tokenizer&&function(){var V=Oe.defaults.tokenizer||new W,X=function(ve){var $e=V[ve];V[ve]=function(){for(var Ne=arguments.length,Ve=new Array(Ne),Qe=0;Qe<Ne;Qe++)Ve[Qe]=arguments[Qe];var Ze=B.tokenizer[ve].apply(V,Ve);return Ze===!1&&(Ze=$e.apply(V,Ve)),Ze}};for(var oe in B.tokenizer)X(oe);re.tokenizer=V}(),B.walkTokens){var ce=Oe.defaults.walkTokens;re.walkTokens=function(V){B.walkTokens(V),ce&&ce(V)}}Oe.setOptions(re)},Oe.walkTokens=function(B,re){for(var ce=T(B),V;!(V=ce()).done;){var X=V.value;switch(re(X),X.type){case"table":{for(var oe=T(X.tokens.header),fe;!(fe=oe()).done;){var ve=fe.value;Oe.walkTokens(ve,re)}for(var $e=T(X.tokens.cells),Ne;!(Ne=$e()).done;)for(var Ve=Ne.value,Qe=T(Ve),Ze;!(Ze=Qe()).done;){var ct=Ze.value;Oe.walkTokens(ct,re)}break}case"list":{Oe.walkTokens(X.items,re);break}default:X.tokens&&Oe.walkTokens(X.tokens,re)}}},Oe.parseInline=function(B,re){if(typeof B=="undefined"||B===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof B!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(B)+", string expected");re=Ke({},Oe.defaults,re||{}),H(re);try{var ce=J.lexInline(B,re);return re.walkTokens&&Oe.walkTokens(ce,re.walkTokens),be.parseInline(ce,re)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+Z(V.message+"",!0)+"</pre>";throw V}},Oe.Parser=be,Oe.parser=be.parse,Oe.Renderer=Le,Oe.TextRenderer=pe,Oe.Lexer=J,Oe.lexer=J.lex,Oe.Tokenizer=W,Oe.Slugger=Ce,Oe.parse=Oe;var Xe=Oe;return Xe}),define(we[78],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(E,k,w){return Math.min(Math.max(E,k),w)}e.clamp=_;function S(E,k){return(k+E%k)%k}e.rot=S;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class P{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P});"use strict";(function(){function ae(T){const P=[];typeof T=="number"&&P.push("code/timeOrigin",T);function E(w){P.push(w,Date.now())}function k(){const w=[];for(let n=0;n<P.length;n+=2)w.push({name:P[n],startTime:P[n+1]});return w}return{mark:E,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const E of performance.getEntriesByType("mark"))P.push({name:E.name,startTime:Math.round(T+E.startTime)});return P}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function _(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=_(S))})(),define(we[21],Ee([0,1]),function(ae,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const S="en";let T=!1,P=!1,E=!1,k=!1,w=!1,n=!1,A=!1,I,v=S,d,s;const f=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof process!="undefined"?p=process:typeof f.vscode!="undefined"&&(p=f.vscode.process);const m=typeof((_=p==null?void 0:p.versions)===null||_===void 0?void 0:_.electron)=="string"&&p.type==="renderer";if(e.isElectronSandboxed=m&&(p==null?void 0:p.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=p==null?void 0:p.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!m)s=navigator.userAgent,T=s.indexOf("Windows")>=0,P=s.indexOf("Macintosh")>=0,A=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=s.indexOf("Linux")>=0,n=!0,I=navigator.language,v=I;else if(typeof p=="object"){T=p.platform==="win32",P=p.platform==="darwin",E=p.platform==="linux",k=E&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,I=S,v=S;const i=p.env.VSCODE_NLS_CONFIG;if(i)try{const h=JSON.parse(i),D=h.availableLanguages["*"];I=h.locale,v=D||S,d=h._translationsConfigFile}catch(h){}w=!0}else console.error("Unable to resolve platform.");var b;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function c(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let u=0;P?u=1:T?u=3:E&&(u=2),e.isWindows=T,e.isMacintosh=P,e.isLinux=E,e.isLinuxSnap=k,e.isNative=w,e.isWeb=n,e.isIOS=A,e.platform=u,e.userAgent=s,e.language=v;var a;(function(i){function h(){return e.language}i.value=h;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=D;function C(){return e.language==="en"}i.isDefault=C})(a=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=d,e.globals=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let D=[];e.globals.addEventListener("message",g=>{if(g.data&&g.data.vscodeSetImmediateId)for(let y=0,R=D.length;y<R;y++){const O=D[y];if(O.id===g.data.vscodeSetImmediateId){D.splice(y,1),O.callback();return}}});let C=0;return g=>{const y=++C;D.push({id:y,callback:g}),e.globals.postMessage({vscodeSetImmediateId:y},"*")}}if(p&&typeof p.nextTick=="function")return p.nextTick.bind(p);const h=Promise.resolve();return D=>h.then(D)}();var t;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||A?2:T?1:3;let r=!0,o=!1;function l(){if(!o){o=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,r=new Uint16Array(i.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=l}),define(we[36],Ee([0,1,21]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let S;typeof process!="undefined"?S=process:typeof _.globals.vscode!="undefined"?S={get platform(){return _.globals.vscode.process.platform},get env(){return _.globals.vscode.process.env},nextTick(T){return(0,_.setImmediate)(T)},cwd(){return _.globals.vscode.process.env.VSCODE_CWD||_.globals.vscode.process.execPath.substr(0,_.globals.vscode.process.execPath.lastIndexOf(_.globals.vscode.process.platform==="win32"?"\\":"/"))}}:S={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(T){return(0,_.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=S.cwd,e.env=S.env,e.platform=S.platform,e.nextTick=S.nextTick}),define(we[11],Ee([0,1,36]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const S=65,T=97,P=90,E=122,k=46,w=47,n=92,A=58,I=63;class v extends Error{constructor(u,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const o=u.indexOf(".")!==-1?"property":"argument";let l=`The "${u}" ${o} ${r} of type ${a}`;l+=`. Received type ${typeof t}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function d(c,u){if(typeof c!="string")throw new v(u,"string",c)}function s(c){return c===w||c===n}function f(c){return c===w}function p(c){return c>=S&&c<=P||c>=T&&c<=E}function m(c,u,a,t){let r="",o=0,l=-1,i=0,h=0;for(let D=0;D<=c.length;++D){if(D<c.length)h=c.charCodeAt(D);else{if(t(h))break;h=w}if(t(h)){if(!(l===D-1||i===1))if(i===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==k||r.charCodeAt(r.length-2)!==k){if(r.length>2){const C=r.lastIndexOf(a);C===-1?(r="",o=0):(r=r.slice(0,C),o=r.length-1-r.lastIndexOf(a)),l=D,i=0;continue}else if(r.length!==0){r="",o=0,l=D,i=0;continue}}u&&(r+=r.length>0?`${a}..`:"..",o=2)}else r.length>0?r+=`${a}${c.slice(l+1,D)}`:r=c.slice(l+1,D),o=D-l-1;l=D,i=0}else h===k&&i!==-1?++i:i=-1}return r}function b(c,u){if(u===null||typeof u!="object")throw new v("pathObject","Object",u);const a=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return a?a===u.root?`${a}${t}`:`${a}${c}${t}`:t}e.win32={resolve(...c){let u="",a="",t=!1;for(let r=c.length-1;r>=-1;r--){let o;if(r>=0){if(o=c[r],d(o,"path"),o.length===0)continue}else u.length===0?o=_.cwd():(o=_.env[`=${u}`]||_.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==u.toLowerCase()&&o.charCodeAt(2)===n)&&(o=`${u}\\`));const l=o.length;let i=0,h="",D=!1;const C=o.charCodeAt(0);if(l===1)s(C)&&(i=1,D=!0);else if(s(C))if(D=!0,s(o.charCodeAt(1))){let g=2,y=g;for(;g<l&&!s(o.charCodeAt(g));)g++;if(g<l&&g!==y){const R=o.slice(y,g);for(y=g;g<l&&s(o.charCodeAt(g));)g++;if(g<l&&g!==y){for(y=g;g<l&&!s(o.charCodeAt(g));)g++;(g===l||g!==y)&&(h=`\\\\${R}\\${o.slice(y,g)}`,i=g)}}}else i=1;else p(C)&&o.charCodeAt(1)===A&&(h=o.slice(0,2),i=2,l>2&&s(o.charCodeAt(2))&&(D=!0,i=3));if(h.length>0)if(u.length>0){if(h.toLowerCase()!==u.toLowerCase())continue}else u=h;if(t){if(u.length>0)break}else if(a=`${o.slice(i)}\\${a}`,t=D,D&&u.length>0)break}return a=m(a,!t,"\\",s),t?`${u}\\${a}`:`${u}${a}`||"."},normalize(c){d(c,"path");const u=c.length;if(u===0)return".";let a=0,t,r=!1;const o=c.charCodeAt(0);if(u===1)return f(o)?"\\":c;if(s(o))if(r=!0,s(c.charCodeAt(1))){let i=2,h=i;for(;i<u&&!s(c.charCodeAt(i));)i++;if(i<u&&i!==h){const D=c.slice(h,i);for(h=i;i<u&&s(c.charCodeAt(i));)i++;if(i<u&&i!==h){for(h=i;i<u&&!s(c.charCodeAt(i));)i++;if(i===u)return`\\\\${D}\\${c.slice(h)}\\`;i!==h&&(t=`\\\\${D}\\${c.slice(h,i)}`,a=i)}}}else a=1;else p(o)&&c.charCodeAt(1)===A&&(t=c.slice(0,2),a=2,u>2&&s(c.charCodeAt(2))&&(r=!0,a=3));let l=a<u?m(c.slice(a),!r,"\\",s):"";return l.length===0&&!r&&(l="."),l.length>0&&s(c.charCodeAt(u-1))&&(l+="\\"),t===void 0?r?`\\${l}`:l:r?`${t}\\${l}`:`${t}${l}`},isAbsolute(c){d(c,"path");const u=c.length;if(u===0)return!1;const a=c.charCodeAt(0);return s(a)||u>2&&p(a)&&c.charCodeAt(1)===A&&s(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let u,a;for(let o=0;o<c.length;++o){const l=c[o];d(l,"path"),l.length>0&&(u===void 0?u=a=l:u+=`\\${l}`)}if(u===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&s(a.charCodeAt(0))){++r;const o=a.length;o>1&&s(a.charCodeAt(1))&&(++r,o>2&&(s(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<u.length&&s(u.charCodeAt(r));)r++;r>=2&&(u=`\\${u.slice(r)}`)}return e.win32.normalize(u)},relative(c,u){if(d(c,"from"),d(u,"to"),c===u)return"";const a=e.win32.resolve(c),t=e.win32.resolve(u);if(a===t||(c=a.toLowerCase(),u=t.toLowerCase(),c===u))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===n;)r++;let o=c.length;for(;o-1>r&&c.charCodeAt(o-1)===n;)o--;const l=o-r;let i=0;for(;i<u.length&&u.charCodeAt(i)===n;)i++;let h=u.length;for(;h-1>i&&u.charCodeAt(h-1)===n;)h--;const D=h-i,C=l<D?l:D;let g=-1,y=0;for(;y<C;y++){const O=c.charCodeAt(r+y);if(O!==u.charCodeAt(i+y))break;O===n&&(g=y)}if(y!==C){if(g===-1)return t}else{if(D>C){if(u.charCodeAt(i+y)===n)return t.slice(i+y+1);if(y===2)return t.slice(i+y)}l>C&&(c.charCodeAt(r+y)===n?g=y:y===2&&(g=3)),g===-1&&(g=0)}let R="";for(y=r+g+1;y<=o;++y)(y===o||c.charCodeAt(y)===n)&&(R+=R.length===0?"..":"\\..");return i+=g,R.length>0?`${R}${t.slice(i,h)}`:(t.charCodeAt(i)===n&&++i,t.slice(i,h))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const u=e.win32.resolve(c);if(u.length<=2)return c;if(u.charCodeAt(0)===n){if(u.charCodeAt(1)===n){const a=u.charCodeAt(2);if(a!==I&&a!==k)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(p(u.charCodeAt(0))&&u.charCodeAt(1)===A&&u.charCodeAt(2)===n)return`\\\\?\\${u}`;return c},dirname(c){d(c,"path");const u=c.length;if(u===0)return".";let a=-1,t=0;const r=c.charCodeAt(0);if(u===1)return s(r)?c:".";if(s(r)){if(a=t=1,s(c.charCodeAt(1))){let i=2,h=i;for(;i<u&&!s(c.charCodeAt(i));)i++;if(i<u&&i!==h){for(h=i;i<u&&s(c.charCodeAt(i));)i++;if(i<u&&i!==h){for(h=i;i<u&&!s(c.charCodeAt(i));)i++;if(i===u)return c;i!==h&&(a=t=i+1)}}}}else p(r)&&c.charCodeAt(1)===A&&(a=u>2&&s(c.charCodeAt(2))?3:2,t=a);let o=-1,l=!0;for(let i=u-1;i>=t;--i)if(s(c.charCodeAt(i))){if(!l){o=i;break}}else l=!1;if(o===-1){if(a===-1)return".";o=a}return c.slice(0,o)},basename(c,u){u!==void 0&&d(u,"ext"),d(c,"path");let a=0,t=-1,r=!0,o;if(c.length>=2&&p(c.charCodeAt(0))&&c.charCodeAt(1)===A&&(a=2),u!==void 0&&u.length>0&&u.length<=c.length){if(u===c)return"";let l=u.length-1,i=-1;for(o=c.length-1;o>=a;--o){const h=c.charCodeAt(o);if(s(h)){if(!r){a=o+1;break}}else i===-1&&(r=!1,i=o+1),l>=0&&(h===u.charCodeAt(l)?--l==-1&&(t=o):(l=-1,t=i))}return a===t?t=i:t===-1&&(t=c.length),c.slice(a,t)}for(o=c.length-1;o>=a;--o)if(s(c.charCodeAt(o))){if(!r){a=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":c.slice(a,t)},extname(c){d(c,"path");let u=0,a=-1,t=0,r=-1,o=!0,l=0;c.length>=2&&c.charCodeAt(1)===A&&p(c.charCodeAt(0))&&(u=t=2);for(let i=c.length-1;i>=u;--i){const h=c.charCodeAt(i);if(s(h)){if(!o){t=i+1;break}continue}r===-1&&(o=!1,r=i+1),h===k?a===-1?a=i:l!==1&&(l=1):a!==-1&&(l=-1)}return a===-1||r===-1||l===0||l===1&&a===r-1&&a===t+1?"":c.slice(a,r)},format:b.bind(null,"\\"),parse(c){d(c,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return u;const a=c.length;let t=0,r=c.charCodeAt(0);if(a===1)return s(r)?(u.root=u.dir=c,u):(u.base=u.name=c,u);if(s(r)){if(t=1,s(c.charCodeAt(1))){let g=2,y=g;for(;g<a&&!s(c.charCodeAt(g));)g++;if(g<a&&g!==y){for(y=g;g<a&&s(c.charCodeAt(g));)g++;if(g<a&&g!==y){for(y=g;g<a&&!s(c.charCodeAt(g));)g++;g===a?t=g:g!==y&&(t=g+1)}}}}else if(p(r)&&c.charCodeAt(1)===A){if(a<=2)return u.root=u.dir=c,u;if(t=2,s(c.charCodeAt(2))){if(a===3)return u.root=u.dir=c,u;t=3}}t>0&&(u.root=c.slice(0,t));let o=-1,l=t,i=-1,h=!0,D=c.length-1,C=0;for(;D>=t;--D){if(r=c.charCodeAt(D),s(r)){if(!h){l=D+1;break}continue}i===-1&&(h=!1,i=D+1),r===k?o===-1?o=D:C!==1&&(C=1):o!==-1&&(C=-1)}return i!==-1&&(o===-1||C===0||C===1&&o===i-1&&o===l+1?u.base=u.name=c.slice(l,i):(u.name=c.slice(l,o),u.base=c.slice(l,i),u.ext=c.slice(o,i))),l>0&&l!==t?u.dir=c.slice(0,l-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let u="",a=!1;for(let t=c.length-1;t>=-1&&!a;t--){const r=t>=0?c[t]:_.cwd();d(r,"path"),r.length!==0&&(u=`${r}/${u}`,a=r.charCodeAt(0)===w)}return u=m(u,!a,"/",f),a?`/${u}`:u.length>0?u:"."},normalize(c){if(d(c,"path"),c.length===0)return".";const u=c.charCodeAt(0)===w,a=c.charCodeAt(c.length-1)===w;return c=m(c,!u,"/",f),c.length===0?u?"/":a?"./":".":(a&&(c+="/"),u?`/${c}`:c)},isAbsolute(c){return d(c,"path"),c.length>0&&c.charCodeAt(0)===w},join(...c){if(c.length===0)return".";let u;for(let a=0;a<c.length;++a){const t=c[a];d(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(c,u){if(d(c,"from"),d(u,"to"),c===u||(c=e.posix.resolve(c),u=e.posix.resolve(u),c===u))return"";const a=1,t=c.length,r=t-a,o=1,l=u.length-o,i=r<l?r:l;let h=-1,D=0;for(;D<i;D++){const g=c.charCodeAt(a+D);if(g!==u.charCodeAt(o+D))break;g===w&&(h=D)}if(D===i)if(l>i){if(u.charCodeAt(o+D)===w)return u.slice(o+D+1);if(D===0)return u.slice(o+D)}else r>i&&(c.charCodeAt(a+D)===w?h=D:D===0&&(h=0));let C="";for(D=a+h+1;D<=t;++D)(D===t||c.charCodeAt(D)===w)&&(C+=C.length===0?"..":"/..");return`${C}${u.slice(o+h)}`},toNamespacedPath(c){return c},dirname(c){if(d(c,"path"),c.length===0)return".";const u=c.charCodeAt(0)===w;let a=-1,t=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===w){if(!t){a=r;break}}else t=!1;return a===-1?u?"/":".":u&&a===1?"//":c.slice(0,a)},basename(c,u){u!==void 0&&d(u,"ext"),d(c,"path");let a=0,t=-1,r=!0,o;if(u!==void 0&&u.length>0&&u.length<=c.length){if(u===c)return"";let l=u.length-1,i=-1;for(o=c.length-1;o>=0;--o){const h=c.charCodeAt(o);if(h===w){if(!r){a=o+1;break}}else i===-1&&(r=!1,i=o+1),l>=0&&(h===u.charCodeAt(l)?--l==-1&&(t=o):(l=-1,t=i))}return a===t?t=i:t===-1&&(t=c.length),c.slice(a,t)}for(o=c.length-1;o>=0;--o)if(c.charCodeAt(o)===w){if(!r){a=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":c.slice(a,t)},extname(c){d(c,"path");let u=-1,a=0,t=-1,r=!0,o=0;for(let l=c.length-1;l>=0;--l){const i=c.charCodeAt(l);if(i===w){if(!r){a=l+1;break}continue}t===-1&&(r=!1,t=l+1),i===k?u===-1?u=l:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||t===-1||o===0||o===1&&u===t-1&&u===a+1?"":c.slice(u,t)},format:b.bind(null,"/"),parse(c){d(c,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return u;const a=c.charCodeAt(0)===w;let t;a?(u.root="/",t=1):t=0;let r=-1,o=0,l=-1,i=!0,h=c.length-1,D=0;for(;h>=t;--h){const C=c.charCodeAt(h);if(C===w){if(!i){o=h+1;break}continue}l===-1&&(i=!1,l=h+1),C===k?r===-1?r=h:D!==1&&(D=1):r!==-1&&(D=-1)}if(l!==-1){const C=o===0&&a?1:o;r===-1||D===0||D===1&&r===l-1&&r===o+1?u.base=u.name=c.slice(C,l):(u.name=c.slice(C,r),u.base=c.slice(C,l),u.ext=c.slice(r,l))}return o>0?u.dir=c.slice(0,o-1):a&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[54],Ee([0,1,21]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const S=_.globals.performance&&typeof _.globals.performance.now=="function";class T{constructor(E){this._highResolution=S&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new T(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=T}),define(we[3],Ee([0,1,10,51,6,46,54]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(m){m.None=()=>T.Disposable.None;function b(Q){return(j,Y=null,L)=>{let $=!1,W;return W=Q(K=>{if(!$)return W?W.dispose():$=!0,j.call(Y,K)},null,L),$&&W.dispose(),W}}m.once=b;function c(Q,j){return l((Y,L=null,$)=>Q(W=>Y.call(L,j(W)),null,$))}m.map=c;function u(Q,j){return l((Y,L=null,$)=>Q(W=>{j(W),Y.call(L,W)},null,$))}m.forEach=u;function a(Q,j){return l((Y,L=null,$)=>Q(W=>j(W)&&Y.call(L,W),null,$))}m.filter=a;function t(Q){return Q}m.signal=t;function r(...Q){return(j,Y=null,L)=>(0,T.combinedDisposable)(...Q.map($=>$(W=>j.call(Y,W),null,L)))}m.any=r;function o(Q,j,Y){let L=Y;return c(Q,$=>(L=j(L,$),L))}m.reduce=o;function l(Q){let j;const Y=new v({onFirstListenerAdd(){j=Q(Y.fire,Y)},onLastListenerRemove(){j.dispose()}});return Y.event}m.snapshot=l;function i(Q,j,Y=100,L=!1,$){let W,K,U,ee=0;const ie=new v({leakWarningThreshold:$,onFirstListenerAdd(){W=Q(se=>{ee++,K=j(K,se),L&&!U&&(ie.fire(K),K=void 0),clearTimeout(U),U=setTimeout(()=>{const Se=K;K=void 0,U=void 0,(!L||ee>1)&&ie.fire(Se),ee=0},Y)})},onLastListenerRemove(){W.dispose()}});return ie.event}m.debounce=i;function h(Q){const j=new Date().getTime();return c(b(Q),Y=>new Date().getTime()-j)}m.stopwatch=h;function D(Q){let j=!0,Y;return a(Q,L=>{const $=j||L!==Y;return j=!1,Y=L,$})}m.latch=D;function C(Q,j=!1,Y=[]){let L=Y.slice(),$=Q(U=>{L?L.push(U):K.fire(U)});const W=()=>{L&&L.forEach(U=>K.fire(U)),L=null},K=new v({onFirstListenerAdd(){$||($=Q(U=>K.fire(U)))},onFirstListenerDidAdd(){L&&(j?setTimeout(W):W())},onLastListenerRemove(){$&&$.dispose(),$=null}});return K.event}m.buffer=C;class g{constructor(j){this.event=j}map(j){return new g(c(this.event,j))}forEach(j){return new g(u(this.event,j))}filter(j){return new g(a(this.event,j))}reduce(j,Y){return new g(o(this.event,j,Y))}latch(){return new g(D(this.event))}debounce(j,Y=100,L=!1,$){return new g(i(this.event,j,Y,L,$))}on(j,Y,L){return this.event(j,Y,L)}once(j,Y,L){return b(this.event)(j,Y,L)}}function y(Q){return new g(Q)}m.chain=y;function R(Q,j,Y=L=>L){const L=(...U)=>K.fire(Y(...U)),$=()=>Q.on(j,L),W=()=>Q.removeListener(j,L),K=new v({onFirstListenerAdd:$,onLastListenerRemove:W});return K.event}m.fromNodeEventEmitter=R;function O(Q,j,Y=L=>L){const L=(...U)=>K.fire(Y(...U)),$=()=>Q.addEventListener(j,L),W=()=>Q.removeEventListener(j,L),K=new v({onFirstListenerAdd:$,onLastListenerRemove:W});return K.event}m.fromDOMEventEmitter=O;function x(Q){const j=new v;let Y=!1;return Q.then(void 0,()=>null).then(()=>{Y?j.fire(void 0):setTimeout(()=>j.fire(void 0),0)}),Y=!0,j.event}m.fromPromise=x;function z(Q){return new Promise(j=>b(Q)(j))}m.toPromise=z})(k=e.Event||(e.Event={}));class w{constructor(b){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${b}_${w._idPool++}`}start(b){this._stopWatch=new E.StopWatch(!0),this._listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this._elapsedOverall+=b,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${b.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let n=-1;function A(m){const b=n;return n=m,{dispose(){n=b}}}e.setGlobalLeakWarningThreshold=A;class I{constructor(b,c=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b){let c=n;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),!(c<=0||b<c)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(u)||0;if(this._stacks.set(u,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,r=0;for(const[o,l]of this._stacks)(!t||r<l)&&(t=o,r=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class v{constructor(b){var c;this._disposed=!1,this._options=b,this._leakageMon=n>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(b,c,u)=>{var a;this._listeners||(this._listeners=new P.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(c?[b,c]:b);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,c);const o=(a=this._leakageMon)===null||a===void 0?void 0:a.check(this._listeners.size);let l;return l={dispose:()=>{o&&o(),l.dispose=v._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof T.DisposableStore?u.add(l):Array.isArray(u)&&u.push(l),l}),this._event}fire(b){var c,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,b]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(r){(0,_.onUnexpectedError)(r)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var b,c,u;(b=this._listeners)===null||b===void 0||b.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=v,v._noop=function(){};class d extends v{constructor(b){super(b);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=b==null?void 0:b.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}e.PauseableEmitter=d;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const c={event:b,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const u=()=>{this.hasListeners&&this.unhook(c);const a=this.events.indexOf(c);this.events.splice(a,1)};return(0,T.toDisposable)((0,S.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(c=>this.emitter.fire(c))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class f{constructor(){this.buffers=[]}wrapEvent(b){return(c,u,a)=>b(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>c.call(u,t)):c.call(u,t)},void 0,a)}bufferEvents(b){const c=[];this.buffers.push(c);const u=b();return this.buffers.pop(),c.forEach(a=>a()),u}}e.EventBufferer=f;class p{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=T.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(we[20],Ee([0,1,3]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const S=Object.freeze(function(k,w){const n=setTimeout(k.bind(w),0);return{dispose(){clearTimeout(n)}}});var T;(function(k){function w(n){return n===k.None||n===k.Cancelled||n instanceof P?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}k.isCancellationToken=w,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(T=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?S:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=T.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=E}),define(we[37],Ee([0,1,3]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class S{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(A){const I=this._icons.get(A.id);I?A.description?I.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new S;e.iconRegistry=T;function P(n,A){return new E(n,A)}e.registerCodicon=P;class E{constructor(A,I,v){this.id=A,this.definition=I,this.description=v,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=E;function k(n,A){const I=["codicon","codicon-"+n];return A&&I.push("codicon-modifier-"+A),I}e.getClassNamesArray=k;var w;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function I(s){if(s instanceof E)return["codicon","codicon-"+s.id];const f=A.exec(s.id);if(!f)return I(E.error);let[,p,m]=f;const b=["codicon","codicon-"+p];return m&&b.push("codicon-modifier-"+m.substr(1)),b}n.asClassNameArray=I;function v(s){return I(s).join(" ")}n.asClassName=v;function d(s){return"."+I(s).join(".")}n.asCSSSelector=d})(w=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnknown=new n("workspace-unknown",{fontCharacter:"\\ebc3"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(E=e.Codicon||(e.Codicon={}))}),define(we[106],Ee([0,1,10,6]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(p){const m=p;return m&&[m.on,m.pause,m.resume,m.destroy].every(b=>typeof b=="function")}e.isReadableStream=T;function P(p){const m=p;return m&&T(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean"}e.isReadableBufferedStream=P;function E(p,m){return new k(p,m)}e.newWriteableStream=E;class k{constructor(m,b){this.reducer=m,this.options=b,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){var b;if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof((b=this.options)===null||b===void 0?void 0:b.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(b=>b(m))}emitError(m){this.listeners.error.length===0?(0,_.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(b=>b(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,b){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(b),this.resume();break;case"end":this.listeners.end.push(b),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(b),this.state.flowing&&this.flowErrors();break}}removeListener(m,b){if(!this.state.destroyed){let c;switch(m){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const u=c.indexOf(b);u>=0&&c.splice(u,1)}}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const b=[...this.pendingWritePromises];this.pendingWritePromises.length=0,b.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(p,m){const b=[];let c;for(;(c=p.read())!==null;)b.push(c);return m(b)}e.consumeReadable=w;function n(p,m,b){const c=[];let u;for(;(u=p.read())!==null&&c.length<b;)c.push(u);return u===null&&c.length>0?m(c):{read:()=>{if(c.length>0)return c.shift();if(typeof u!="undefined"){const a=u;return u=void 0,a}return p.read()}}}e.peekReadable=n;function A(p,m){return new Promise((b,c)=>{const u=[];I(p,{onData:a=>{m&&u.push(a)},onError:a=>{m?c(a):b(void 0)},onEnd:()=>{b(m?m(u):void 0)}})})}e.consumeStream=A;function I(p,m){p.on("error",b=>m.onError(b)),p.on("end",()=>m.onEnd()),p.on("data",b=>m.onData(b))}e.listenStream=I;function v(p,m){return new Promise((b,c)=>{const u=new S.DisposableStore,a=[],t=l=>{if(a.push(l),a.length>m)return u.dispose(),p.pause(),b({stream:p,buffer:a,ended:!1})},r=l=>c(l),o=()=>b({stream:p,buffer:a,ended:!0});u.add((0,S.toDisposable)(()=>p.removeListener("error",r))),p.on("error",r),u.add((0,S.toDisposable)(()=>p.removeListener("end",o))),p.on("end",o),u.add((0,S.toDisposable)(()=>p.removeListener("data",t))),p.on("data",t)})}e.peekStream=v;function d(p,m){const b=E(m);return b.end(p),b}e.toStream=d;function s(p){let m=!1;return{read:()=>m?null:(m=!0,p)}}e.toReadable=s;function f(p,m,b){const c=E(b);return I(p,{onData:u=>c.write(m.data(u)),onError:u=>c.error(m.error?m.error(u):u),onEnd:()=>c.end()}),c}e.transform=f}),define(we[8],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=_;const S=/{(\d+)}/g;function T(B,...re){return re.length===0?B:B.replace(S,function(ce,V){const X=parseInt(V,10);return isNaN(X)||X<0||X>=re.length?ce:re[X]})}e.format=T;function P(B){return B.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=P;function E(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function k(B,re){let ce=0;const V=re.charCodeAt(0);for(let X=B.length-1;X>=0;X--)B.charCodeAt(X)===V&&ce++;return ce}e.count=k;function w(B,re,ce="\u2026"){return B.length<=re?B:`${B.substr(0,re)}${ce}`}e.truncate=w;function n(B,re=" "){const ce=A(B,re);return I(ce,re)}e.trim=n;function A(B,re){if(!B||!re)return B;const ce=re.length;if(ce===0||B.length===0)return B;let V=0;for(;B.indexOf(re,V)===V;)V=V+ce;return B.substring(V)}e.ltrim=A;function I(B,re){if(!B||!re)return B;const ce=re.length,V=B.length;if(ce===0||V===0)return B;let X=V,oe=-1;for(;oe=B.lastIndexOf(re,X-1),!(oe===-1||oe+ce!==X);){if(oe===0)return"";X=oe}return B.substring(0,X)}e.rtrim=I;function v(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function d(B){return B.replace(/\*/g,"")}e.stripWildcards=d;function s(B,re,ce={}){if(!B)throw new Error("Cannot create regex from empty string");re||(B=E(B)),ce.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let V="";return ce.global&&(V+="g"),ce.matchCase||(V+="i"),ce.multiline&&(V+="m"),ce.unicode&&(V+="u"),new RegExp(B,V)}e.createRegExp=s;function f(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function p(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function m(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=m;function b(B){return B.split(/\r\n|\r|\n/)}e.splitLines=b;function c(B){for(let re=0,ce=B.length;re<ce;re++){const V=B.charCodeAt(re);if(V!==32&&V!==9)return re}return-1}e.firstNonWhitespaceIndex=c;function u(B,re=0,ce=B.length){for(let V=re;V<ce;V++){const X=B.charCodeAt(V);if(X!==32&&X!==9)return B.substring(re,V)}return B.substring(re,ce)}e.getLeadingWhitespace=u;function a(B,re=B.length-1){for(let ce=re;ce>=0;ce--){const V=B.charCodeAt(ce);if(V!==32&&V!==9)return ce}return-1}e.lastNonWhitespaceIndex=a;function t(B,re){return B<re?-1:B>re?1:0}e.compare=t;function r(B,re,ce=0,V=B.length,X=0,oe=re.length){for(;ce<V&&X<oe;ce++,X++){let $e=B.charCodeAt(ce),Ne=re.charCodeAt(X);if($e<Ne)return-1;if($e>Ne)return 1}const fe=V-ce,ve=oe-X;return fe<ve?-1:fe>ve?1:0}e.compareSubstring=r;function o(B,re){return l(B,re,0,B.length,0,re.length)}e.compareIgnoreCase=o;function l(B,re,ce=0,V=B.length,X=0,oe=re.length){for(;ce<V&&X<oe;ce++,X++){let $e=B.charCodeAt(ce),Ne=re.charCodeAt(X);if($e!==Ne){const Ve=$e-Ne;if(!(Ve===32&&h(Ne))&&!(Ve===-32&&h($e)))return i($e)&&i(Ne)?Ve:r(B.toLowerCase(),re.toLowerCase(),ce,V,X,oe)}}const fe=V-ce,ve=oe-X;return fe<ve?-1:fe>ve?1:0}e.compareSubstringIgnoreCase=l;function i(B){return B>=97&&B<=122}e.isLowerAsciiLetter=i;function h(B){return B>=65&&B<=90}e.isUpperAsciiLetter=h;function D(B){return i(B)||h(B)}function C(B,re){return B.length===re.length&&g(B,re)}e.equalsIgnoreCase=C;function g(B,re,ce=B.length){for(let V=0;V<ce;V++){const X=B.charCodeAt(V),oe=re.charCodeAt(V);if(X!==oe){if(D(X)&&D(oe)){const fe=Math.abs(X-oe);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(X).toLowerCase()!==String.fromCharCode(oe).toLowerCase())return!1}}return!0}function y(B,re){const ce=re.length;return re.length>B.length?!1:g(B,re,ce)}e.startsWithIgnoreCase=y;function R(B,re){let ce,V=Math.min(B.length,re.length);for(ce=0;ce<V;ce++)if(B.charCodeAt(ce)!==re.charCodeAt(ce))return ce;return V}e.commonPrefixLength=R;function O(B,re){let ce,V=Math.min(B.length,re.length);const X=B.length-1,oe=re.length-1;for(ce=0;ce<V;ce++)if(B.charCodeAt(X-ce)!==re.charCodeAt(oe-ce))return ce;return V}e.commonSuffixLength=O;function x(B){return 55296<=B&&B<=56319}e.isHighSurrogate=x;function z(B){return 56320<=B&&B<=57343}e.isLowSurrogate=z;function Q(B,re){return(B-55296<<10)+(re-56320)+65536}e.computeCodePoint=Q;function j(B,re,ce){const V=B.charCodeAt(ce);if(x(V)&&ce+1<re){const X=B.charCodeAt(ce+1);if(z(X))return Q(V,X)}return V}e.getNextCodePoint=j;function Y(B,re){const ce=B.charCodeAt(re-1);if(z(ce)&&re>1){const V=B.charCodeAt(re-2);if(x(V))return Q(V,ce)}return ce}function L(B,re){const ce=Oe.getInstance(),V=re,X=B.length,oe=j(B,X,re);re+=oe>=65536?2:1;let fe=ce.getGraphemeBreakType(oe);for(;re<X;){const ve=j(B,X,re),$e=ce.getGraphemeBreakType(ve);if(Me(fe,$e))break;re+=ve>=65536?2:1,fe=$e}return re-V}e.nextCharLength=L;function $(B,re){const ce=Oe.getInstance(),V=re,X=Y(B,re);re-=X>=65536?2:1;let oe=ce.getGraphemeBreakType(X);for(;re>0;){const fe=Y(B,re),ve=ce.getGraphemeBreakType(fe);if(Me(ve,oe))break;re-=fe>=65536?2:1,oe=ve}return V-re}e.prevCharLength=$;function W(B,re){const ce=Oe.getInstance(),V=B.length,X=re,oe=j(B,V,re),fe=ce.getGraphemeBreakType(oe);re+=oe>=65536?2:1;let ve=fe;for(;re<V;){const Ne=j(B,V,re),Ve=ce.getGraphemeBreakType(Ne);if(Me(ve,Ve))break;re+=Ne>=65536?2:1,ve=Ve}const $e=re;for(re=X,ve=fe;re>0;){const Ne=Y(B,re),Ve=ce.getGraphemeBreakType(Ne);if(Me(Ve,ve))break;re-=Ne>=65536?2:1,ve=Ve}return[re,$e]}function K(B,re){return re>0&&z(B.charCodeAt(re))?W(B,re-1):W(B,re)}e.getCharContainingOffset=K;function U(B){const re=B.length;let ce=0,V=0;for(;V<re;){const fe=j(B,re,V);V+=fe>=65536?2:1,fe<128?ce+=1:fe<2048?ce+=2:fe<65536?ce+=3:ce+=4}const X=new Uint8Array(ce);V=0;let oe=0;for(;V<re;){const fe=j(B,re,V);V+=fe>=65536?2:1,fe<128?X[oe++]=fe:fe<2048?(X[oe++]=192|(fe&1984)>>>6,X[oe++]=128|(fe&63)>>>0):fe<65536?(X[oe++]=224|(fe&61440)>>>12,X[oe++]=128|(fe&4032)>>>6,X[oe++]=128|(fe&63)>>>0):(X[oe++]=240|(fe&1835008)>>>18,X[oe++]=128|(fe&258048)>>>12,X[oe++]=128|(fe&4032)>>>6,X[oe++]=128|(fe&63)>>>0)}return X}e.encodeUTF8=U;function ee(B){const re=B.byteLength,ce=[];let V=0;for(;V<re;){const X=B[V];let oe;if(X>=240&&V+3<re?oe=(B[V++]&7)<<18>>>0|(B[V++]&63)<<12>>>0|(B[V++]&63)<<6>>>0|(B[V++]&63)<<0>>>0:X>=224&&V+2<re?oe=(B[V++]&15)<<12>>>0|(B[V++]&63)<<6>>>0|(B[V++]&63)<<0>>>0:X>=192&&V+1<re?oe=(B[V++]&31)<<6>>>0|(B[V++]&63)<<0>>>0:oe=B[V++],oe>=0&&oe<=55295||oe>=57344&&oe<=65535)ce.push(String.fromCharCode(oe));else if(oe>=65536&&oe<=1114111){const fe=oe-65536,ve=55296+((fe&1047552)>>>10),$e=56320+((fe&1023)>>>0);ce.push(String.fromCharCode(ve)),ce.push(String.fromCharCode($e))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=ee;const ie=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function se(B){return ie.test(B)}e.containsRTL=se;const Se=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ae(B){return Se.test(B)}e.containsEmoji=Ae;const Be=/^[\t\n\r\x20-\x7E]*$/;function Re(B){return Be.test(B)}e.isBasicASCII=Re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function xe(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=xe;function N(B){for(let re=0,ce=B.length;re<ce;re++)if(q(B.charCodeAt(re)))return!0;return!1}e.containsFullWidthCharacter=N;function q(B){return B=+B,B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=q;function J(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129003||B>=129280&&B<=129535||B>=129648&&B<=129750}e.isEmojiImprecise=J;function le(B,re){if(B.length<re)return B;const ce=/\b/g;let V=0;for(;ce.test(B)&&!(B.length-ce.lastIndex<re);)V=ce.lastIndex,ce.lastIndex+=1;return B.substring(V).replace(/^\s/,"")}e.lcut=le;const ge=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Le=/\x1b\[0?m/g;function pe(B){return B&&(B=B.replace(ge,""),B=B.replace(De,""),B=B.replace(Le,"")),B}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Te(B){return Ce(B)?B.substr(1):B}e.stripUTF8BOM=Te;function Ue(B,re){if(!B||!re||B.length<re.length)return!1;const ce=re.length,V=B.toLowerCase();let X=0,oe=-1;for(;X<ce;){const fe=V.indexOf(re[X],oe+1);if(fe<0)return!1;oe=fe,X++}return!0}e.fuzzyContains=Ue;function be(B,re=!1){return B?(re&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=be;function Ke(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=Ke;function H(B,re=1){if(re===0)return"";let ce=-1;do ce=B.indexOf(`
`,ce+1),re--;while(re>0&&ce>=0);return ce===-1?B:(B[ce-1]==="\r"&&ce--,B.substr(0,ce))}e.getNLines=H;function Z(B){const re=90-65+1;return B=B%(2*re),B<re?String.fromCharCode(97+B):String.fromCharCode(65+B-re)}e.singleLetterHash=Z;function _e(B){return Oe.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=_e;function Me(B,re){return B===0?re!==5&&re!==7:B===2&&re===3?!1:B===4||B===2||B===3||re===4||re===2||re===3?!0:!(B===8&&(re===8||re===9||re===11||re===12)||(B===11||B===9)&&(re===9||re===10)||(B===12||B===10)&&re===10||re===5||re===13||re===7||B===1||B===13&&re===14||B===6&&re===6)}e.breakBetweenGraphemeBreakType=Me;var He;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=Xe()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const ce=this._data,V=ce.length/3;let X=1;for(;X<=V;)if(re<ce[3*X])X=2*X;else if(re>ce[3*X+1])X=2*X+1;else return ce[3*X+2];return 0}}Oe._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(we[26],Ee([0,1,8,106]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",E=typeof TextDecoder!="undefined";let k,w;class n{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return T?new n(Buffer.allocUnsafe(i)):new n(new Uint8Array(i))}static wrap(i){return T&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new n(i)}static fromString(i,h){return!((h==null?void 0:h.dontUseNodeBuffer)||!1)&&T?new n(Buffer.from(i)):P?(k||(k=new TextEncoder),new n(k.encode(i))):new n(_.encodeUTF8(i))}static concat(i,h){if(typeof h=="undefined"){h=0;for(let g=0,y=i.length;g<y;g++)h+=i[g].byteLength}const D=n.alloc(h);let C=0;for(let g=0,y=i.length;g<y;g++){const R=i[g];D.set(R,C),C+=R.byteLength}return D}toString(){return T?this.buffer.toString():E?(w||(w=new TextDecoder),w.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(i,h){return new n(this.buffer.subarray(i,h))}set(i,h){i instanceof n?this.buffer.set(i.buffer,h):this.buffer.set(i,h)}readUInt32BE(i){return v(this.buffer,i)}writeUInt32BE(i,h){d(this.buffer,i,h)}readUInt32LE(i){return s(this.buffer,i)}writeUInt32LE(i,h){f(this.buffer,i,h)}readUInt8(i){return p(this.buffer,i)}writeUInt8(i,h){m(this.buffer,i,h)}}e.VSBuffer=n;function A(l,i){return l[i+0]<<0>>>0|l[i+1]<<8>>>0}e.readUInt16LE=A;function I(l,i,h){l[h+0]=i&255,i=i>>>8,l[h+1]=i&255}e.writeUInt16LE=I;function v(l,i){return l[i]*2**24+l[i+1]*2**16+l[i+2]*2**8+l[i+3]}e.readUInt32BE=v;function d(l,i,h){l[h+3]=i,i=i>>>8,l[h+2]=i,i=i>>>8,l[h+1]=i,i=i>>>8,l[h]=i}e.writeUInt32BE=d;function s(l,i){return l[i+0]<<0>>>0|l[i+1]<<8>>>0|l[i+2]<<16>>>0|l[i+3]<<24>>>0}e.readUInt32LE=s;function f(l,i,h){l[h+0]=i&255,i=i>>>8,l[h+1]=i&255,i=i>>>8,l[h+2]=i&255,i=i>>>8,l[h+3]=i&255}e.writeUInt32LE=f;function p(l,i){return l[i]}e.readUInt8=p;function m(l,i,h){l[h]=i}e.writeUInt8=m;function b(l){return S.consumeReadable(l,i=>n.concat(i))}e.readableToBuffer=b;function c(l){return S.toReadable(l)}e.bufferToReadable=c;function u(l){return S.consumeStream(l,i=>n.concat(i))}e.streamToBuffer=u;async function a(l){return l.ended?n.concat(l.buffer):n.concat([...l.buffer,await u(l.stream)])}e.bufferedStreamToBuffer=a;function t(l){return S.toStream(l,i=>n.concat(i))}e.bufferToStream=t;function r(l){return S.transform(l,{data:i=>typeof i=="string"?n.fromString(i):n.wrap(i)},i=>n.concat(i))}e.streamToBufferReadableStream=r;function o(l){return S.newWriteableStream(i=>n.concat(i),l)}e.newWriteableBufferStream=o}),define(we[55],Ee([0,1,8]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function S(m){return T(m,0)}e.hash=S;function T(m,b){switch(typeof m){case"object":return m===null?P(349,b):Array.isArray(m)?w(m,b):n(m,b);case"string":return k(m,b);case"boolean":return E(m,b);case"number":return P(m,b);case"undefined":return P(937,b);default:return P(617,b)}}e.doHash=T;function P(m,b){return(b<<5)-b+m|0}function E(m,b){return P(m?433:863,b)}function k(m,b){b=P(149417,b);for(let c=0,u=m.length;c<u;c++)b=P(m.charCodeAt(c),b);return b}e.stringHash=k;function w(m,b){return b=P(104579,b),m.reduce((c,u)=>T(u,c),b)}function n(m,b){return b=P(181387,b),Object.keys(m).sort().reduce((c,u)=>(c=k(u,c),T(m[u],c)),b)}class A{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=T(b,this._value),this._value}}e.Hasher=A;var I;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function v(m,b,c=32){const u=c-b,a=~((1<<u)-1);return(m<<b|(a&m)>>>u)>>>0}function d(m,b=0,c=m.byteLength,u=0){for(let a=0;a<c;a++)m[b+a]=u}function s(m,b,c="0"){for(;m.length<b;)m=c+m;return m}function f(m,b=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(c=>c.toString(16).padStart(2,"0")).join(""):s((m>>>0).toString(16),b/4)}e.toHexString=f;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const c=b.length;if(c!==0){const u=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,r,o;for(t!==0?(r=t,o=-1,t=0):(r=b.charCodeAt(0),o=0);;){let l=r;if(_.isHighSurrogate(r))if(o+1<c){const i=b.charCodeAt(o+1);_.isLowSurrogate(i)?(o++,l=_.computeCodePoint(r,i)):l=65533}else{t=r;break}else _.isLowSurrogate(r)&&(l=65533);if(a=this._push(u,a,l),o++,o<c)r=b.charCodeAt(o);else break}this._buffLen=a,this._leftoverHighSurrogate=t}}_push(b,c,u){return u<128?b[c++]=u:u<2048?(b[c++]=192|(u&1984)>>>6,b[c++]=128|(u&63)>>>0):u<65536?(b[c++]=224|(u&61440)>>>12,b[c++]=128|(u&4032)>>>6,b[c++]=128|(u&63)>>>0):(b[c++]=240|(u&1835008)>>>18,b[c++]=128|(u&258048)>>>12,b[c++]=128|(u&4032)>>>6,b[c++]=128|(u&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=p._bigBlock32,c=this._buffDV;for(let D=0;D<64;D+=4)b.setUint32(D,c.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)b.setUint32(D,v(b.getUint32(D-12,!1)^b.getUint32(D-32,!1)^b.getUint32(D-56,!1)^b.getUint32(D-64,!1),1),!1);let u=this._h0,a=this._h1,t=this._h2,r=this._h3,o=this._h4,l,i,h;for(let D=0;D<80;D++)D<20?(l=a&t|~a&r,i=1518500249):D<40?(l=a^t^r,i=1859775393):D<60?(l=a&t|a&r|t&r,i=2400959708):(l=a^t^r,i=3395469782),h=v(u,5)+l+o+i+b.getUint32(D*4,!1)&4294967295,o=r,r=t,t=v(a,30),a=u,u=h;this._h0=this._h0+u&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[56],Ee([0,1,8]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var S;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(S||(S={})),function(T){const P="error",E="warning",k="warn",w="info";function n(A){return A?_.equalsIgnoreCase(P,A)?T.Error:_.equalsIgnoreCase(E,A)||_.equalsIgnoreCase(k,A)?T.Warning:_.equalsIgnoreCase(w,A)?T.Info:T.Ignore:T.Ignore}T.fromValue=n}(S||(S={})),e.default=S}),define(we[12],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(i){return Array.isArray(i)}e.isArray=_;function S(i){return typeof i=="string"}e.isString=S;function T(i){return Array.isArray(i)&&i.every(h=>S(h))}e.isStringArray=T;function P(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}e.isObject=P;function E(i){return typeof i=="number"&&!isNaN(i)}e.isNumber=E;function k(i){return i===!0||i===!1}e.isBoolean=k;function w(i){return typeof i=="undefined"}e.isUndefined=w;function n(i){return!A(i)}e.isDefined=n;function A(i){return w(i)||i===null}e.isUndefinedOrNull=A;function I(i,h){if(!i)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}e.assertType=I;function v(i){if(A(i))throw new Error("Assertion Failed: argument is undefined or null");return i}e.assertIsDefined=v;function d(...i){const h=[];for(let D=0;D<i.length;D++){const C=i[D];if(A(C))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);h.push(C)}return h}e.assertAllDefined=d;const s=Object.prototype.hasOwnProperty;function f(i){if(!P(i))return!1;for(let h in i)if(s.call(i,h))return!1;return!0}e.isEmptyObject=f;function p(i){return typeof i=="function"}e.isFunction=p;function m(...i){return i.length>0&&i.every(p)}e.areFunctions=m;function b(i,h){const D=Math.min(i.length,h.length);for(let C=0;C<D;C++)c(i[C],h[C])}e.validateConstraints=b;function c(i,h){if(S(h)){if(typeof i!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(p(h)){try{if(i instanceof h)return}catch(D){}if(!A(i)&&i.constructor===h||h.length===1&&h.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function u(i){let h=[],D=Object.getPrototypeOf(i);for(;Object.prototype!==D;)h=h.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return h}e.getAllPropertyNames=u;function a(i){const h=[];for(const D of u(i))typeof i[D]=="function"&&h.push(D);return h}e.getAllMethodNames=a;function t(i,h){const D=g=>function(){const y=Array.prototype.slice.call(arguments,0);return h(g,y)};let C={};for(const g of i)C[g]=D(g);return C}e.createProxyObject=t;function r(i){return i===null?void 0:i}e.withNullAsUndefined=r;function o(i){return typeof i=="undefined"?null:i}e.withUndefinedAsNull=o;function l(i){return class{constructor(){return new Proxy({},{get(h,D){if(h[D])return h[D];throw new Error(`Not Implemented: ${i}->${String(D)}`)}})}}}e.NotImplementedProxy=l}),define(we[38],Ee([0,1,21,8,11,12]),function(ae,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function E(r){return r===47||r===92}e.isPathSeparator=E;function k(r){return r.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=k;function w(r,o=T.posix.sep){if(!r)return"";const l=r.length,i=r.charCodeAt(0);if(E(i)){if(E(r.charCodeAt(1))&&!E(r.charCodeAt(2))){let D=3;const C=D;for(;D<l&&!E(r.charCodeAt(D));D++);if(C!==D&&!E(r.charCodeAt(D+1))){for(D+=1;D<l;D++)if(E(r.charCodeAt(D)))return r.slice(0,D+1).replace(/[\\/]/g,o)}}return o}else if(p(i)&&r.charCodeAt(1)===58)return E(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<l;h++)if(E(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.getRoot=w;function n(r){if(!_.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let l=2;const i=l;for(;l<r.length&&(o=r.charCodeAt(l),o!==92);l++);return!(i===l||(o=r.charCodeAt(l+1),isNaN(o)||o===92))}e.isUNC=n;const A=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,o=_.isWindows){const l=o?A:I;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||o&&v.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function s(r,o,l){const i=r===o;return!l||i?i:!r||!o?!1:(0,S.equalsIgnoreCase)(r,o)}e.isEqual=s;function f(r,o,l,i=T.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(l){if(!(0,S.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let D=o.length;return o.charAt(o.length-1)===i&&D--,r.charAt(D)===i}return o.charAt(o.length-1)!==i&&(o+=i),r.indexOf(o)===0}e.isEqualOrParent=f;function p(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=p;function m(r,o){return _.isWindows&&r.endsWith(":")&&(r+=T.sep),(0,T.isAbsolute)(r)||(r=(0,T.join)(o,r)),r=(0,T.normalize)(r),_.isWindows?(r=(0,S.rtrim)(r,T.sep),r.endsWith(":")&&(r+=T.sep)):(r=(0,S.rtrim)(r,T.sep),r||(r=T.sep)),r}e.sanitizeFilePath=m;function b(r){const o=(0,T.normalize)(r);return _.isWindows?r.length>3?!1:c(o)&&(r.length===2||o.charCodeAt(2)===92):o===T.posix.sep}e.isRootOrDriveLetter=b;function c(r){return _.isWindows?p(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function u(r){return c(r)?r[0]:void 0}e.getDriveLetter=u;function a(r,o,l){return o.length>r.length?-1:r===o?0:(l&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=a;function t(r){const o=r.split(":");let l,i,h;if(o.forEach(D=>{const C=Number(D);(0,P.isNumber)(C)?i===void 0?i=C:h===void 0&&(h=C):l=l?[l,D].join(":"):D}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:i!==void 0?i:void 0,column:h!==void 0?h:i!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(we[23],Ee([0,1,12]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function S(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const f=Array.isArray(s)?[]:{};return Object.keys(s).forEach(p=>{s[p]&&typeof s[p]=="object"?f[p]=S(s[p]):f[p]=s[p]}),f}e.deepClone=S;function T(s){if(!s||typeof s!="object")return s;const f=[s];for(;f.length>0;){const p=f.shift();Object.freeze(p);for(const m in p)if(P.call(p,m)){const b=p[m];typeof b=="object"&&!Object.isFrozen(b)&&f.push(b)}}return s}e.deepFreeze=T;const P=Object.prototype.hasOwnProperty;function E(s,f){return k(s,f,new Set)}e.cloneAndChange=E;function k(s,f,p){if((0,_.isUndefinedOrNull)(s))return s;const m=f(s);if(typeof m!="undefined")return m;if((0,_.isArray)(s)){const b=[];for(const c of s)b.push(k(c,f,p));return b}if((0,_.isObject)(s)){if(p.has(s))throw new Error("Cannot clone recursive data-structure");p.add(s);const b={};for(let c in s)P.call(s,c)&&(b[c]=k(s[c],f,p));return p.delete(s),b}return s}function w(s,f,p=!0){return(0,_.isObject)(s)?((0,_.isObject)(f)&&Object.keys(f).forEach(m=>{m in s?p&&((0,_.isObject)(s[m])&&(0,_.isObject)(f[m])?w(s[m],f[m],p):s[m]=f[m]):s[m]=f[m]}),s):f}e.mixin=w;function n(s,f){if(s===f)return!0;if(s==null||f===null||f===void 0||typeof s!=typeof f||typeof s!="object"||Array.isArray(s)!==Array.isArray(f))return!1;let p,m;if(Array.isArray(s)){if(s.length!==f.length)return!1;for(p=0;p<s.length;p++)if(!n(s[p],f[p]))return!1}else{const b=[];for(m in s)b.push(m);b.sort();const c=[];for(m in f)c.push(m);if(c.sort(),!n(b,c))return!1;for(p=0;p<b.length;p++)if(!n(s[b[p]],f[b[p]]))return!1}return!0}e.equals=n;function A(s){const f=new Set;return JSON.stringify(s,(p,m)=>{if((0,_.isObject)(m)||Array.isArray(m)){if(f.has(m))return"[Circular]";f.add(m)}return m})}e.safeStringify=A;function I(s,f,p){const m=f(s);return typeof m=="undefined"?p:m}e.getOrDefault=I;function v(s,f){const p=Object.create(null);return!s||!f||Object.keys(f).forEach(b=>{const c=s[b],u=f[b];n(c,u)||(p[b]=u)}),p}e.distinct=v;function d(s,f){const p=f.toLowerCase(),m=Object.keys(s).find(b=>b.toLowerCase()===p);return m?s[m]:s[f]}e.getCaseInsensitive=d}),define(we[79],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function S(P){return P<0?0:P>255?255:P|0}e.toUint8=S;function T(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=T}),define(we[2],Ee([0,1,21,11]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,P=/^\//,E=/^\/\//;function k(o,l){if(!o.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!T.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!P.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(o,l){return!o&&!l?"file":o}function n(o,l){switch(o){case"https":case"http":case"file":l?l[0]!==I&&(l=I+l):l=I;break}return l}const A="",I="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(l,i,h,D,C,g=!1){typeof l=="object"?(this.scheme=l.scheme||A,this.authority=l.authority||A,this.path=l.path||A,this.query=l.query||A,this.fragment=l.fragment||A):(this.scheme=w(l,g),this.authority=i||A,this.path=n(this.scheme,h||A),this.query=D||A,this.fragment=C||A,k(this,g))}static isUri(l){return l instanceof d?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}get fsPath(){return c(this,!1)}with(l){if(!l)return this;let{scheme:i,authority:h,path:D,query:C,fragment:g}=l;return i===void 0?i=this.scheme:i===null&&(i=A),h===void 0?h=this.authority:h===null&&(h=A),D===void 0?D=this.path:D===null&&(D=A),C===void 0?C=this.query:C===null&&(C=A),g===void 0?g=this.fragment:g===null&&(g=A),i===this.scheme&&h===this.authority&&D===this.path&&C===this.query&&g===this.fragment?this:new f(i,h,D,C,g)}static parse(l,i=!1){const h=v.exec(l);return h?new f(h[2]||A,r(h[4]||A),r(h[5]||A),r(h[7]||A),r(h[9]||A),i):new f(A,A,A,A,A)}static file(l){let i=A;if(_.isWindows&&(l=l.replace(/\\/g,I)),l[0]===I&&l[1]===I){const h=l.indexOf(I,2);h===-1?(i=l.substring(2),l=I):(i=l.substring(2,h),l=l.substring(h)||I)}return new f("file",i,l,A,A)}static from(l){return new f(l.scheme,l.authority,l.path,l.query,l.fragment)}static joinPath(l,...i){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return _.isWindows&&l.scheme==="file"?h=d.file(S.win32.join(c(l,!0),...i)).path:h=S.posix.join(l.path,...i),l.with({path:h})}toString(l=!1){return u(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof d)return l;{const i=new f(l);return i._formatted=l.external,i._fsPath=l._sep===s?l.fsPath:null,i}}else return l}}e.URI=d;const s=_.isWindows?1:void 0;class f extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(l=!1){return l?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=s),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(o,l){let i,h=-1;for(let D=0;D<o.length;D++){const C=o.charCodeAt(D);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||l&&C===47)h!==-1&&(i+=encodeURIComponent(o.substring(h,D)),h=-1),i!==void 0&&(i+=o.charAt(D));else{i===void 0&&(i=o.substr(0,D));const g=p[C];g!==void 0?(h!==-1&&(i+=encodeURIComponent(o.substring(h,D)),h=-1),i+=g):h===-1&&(h=D)}}return h!==-1&&(i+=encodeURIComponent(o.substring(h))),i!==void 0?i:o}function b(o){let l;for(let i=0;i<o.length;i++){const h=o.charCodeAt(i);h===35||h===63?(l===void 0&&(l=o.substr(0,i)),l+=p[h]):l!==void 0&&(l+=o[i])}return l!==void 0?l:o}function c(o,l){let i;return o.authority&&o.path.length>1&&o.scheme==="file"?i=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?l?i=o.path.substr(1):i=o.path[1].toLowerCase()+o.path.substr(2):i=o.path,_.isWindows&&(i=i.replace(/\//g,"\\")),i}e.uriToFsPath=c;function u(o,l){const i=l?b:m;let h="",{scheme:D,authority:C,path:g,query:y,fragment:R}=o;if(D&&(h+=D,h+=":"),(C||D==="file")&&(h+=I,h+=I),C){let O=C.indexOf("@");if(O!==-1){const x=C.substr(0,O);C=C.substr(O+1),O=x.indexOf(":"),O===-1?h+=i(x,!1):(h+=i(x.substr(0,O),!1),h+=":",h+=i(x.substr(O+1),!1)),h+="@"}C=C.toLowerCase(),O=C.indexOf(":"),O===-1?h+=i(C,!1):(h+=i(C.substr(0,O),!1),h+=C.substr(O))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const O=g.charCodeAt(1);O>=65&&O<=90&&(g=`/${String.fromCharCode(O+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const O=g.charCodeAt(0);O>=65&&O<=90&&(g=`${String.fromCharCode(O+32)}:${g.substr(2)}`)}h+=i(g,!0)}return y&&(h+="?",h+=i(y,!1)),R&&(h+="#",h+=l?R:m(R,!1)),h}function a(o){try{return decodeURIComponent(o)}catch(l){return o.length>3?o.substr(0,3)+a(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(o){return o.match(t)?o.replace(t,l=>a(l)):o}}),define(we[22],Ee([0,1,2,8]),function(ae,e,_,S){"use strict";var T,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(u,a,t){let r=u.get(a);return r===void 0&&(r=t,u.set(a,r)),r}e.getOrSet=E;function k(u){const a=[];return u.forEach((t,r)=>{a.push(`${r} => ${t}`)}),`Map(${u.size}) {${a.join(", ")}}`}e.mapToString=k;function w(u){const a=[];return u.forEach(t=>{a.push(t)}),`Set(${u.size}) {${a.join(", ")}}`}e.setToString=w;class n{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const t=a.charCodeAt(0),r=this._value.charCodeAt(this._pos);return t-r}value(){return this._value[this._pos]}}e.StringIterator=n;class A{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,S.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,S.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class I{constructor(a=!0,t=!0){this._splitOnBackslash=a,this._caseSensitive=t}reset(a){return this._value=a.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,S.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,S.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var v;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(v||(v={}));class d{constructor(a){this._ignorePathCasing=a,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return(0,S.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,S.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return(0,S.compare)(a,this._value.query);if(this._states[this._stateIdx]===5)return(0,S.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class s{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class f{constructor(a){this._iter=a}static forUris(a=()=>!1){return new f(new d(a))}static forPaths(){return new f(new I)}static forStrings(){return new f(new n)}static forConfigKeys(){return new f(new A)}clear(){this._root=void 0}set(a,t){const r=this._iter.reset(a);let o;for(this._root||(this._root=new s,this._root.segment=r.value()),o=this._root;;){const i=r.cmp(o.segment);if(i>0)o.left||(o.left=new s,o.left.segment=r.value()),o=o.left;else if(i<0)o.right||(o.right=new s,o.right.segment=r.value()),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new s,o.mid.segment=r.value()),o=o.mid;else break}const l=o.value;return o.value=t,o.key=a,l}get(a){var t;return(t=this._getNode(a))===null||t===void 0?void 0:t.value}_getNode(a){const t=this._iter.reset(a);let r=this._root;for(;r;){const o=t.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else break}return r}has(a){const t=this._getNode(a);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,t){const r=this._iter.reset(a),o=[];let l=this._root;for(;l;){const i=r.cmp(l.segment);if(i>0)o.push([1,l]),l=l.left;else if(i<0)o.push([-1,l]),l=l.right;else if(r.hasNext())r.next(),o.push([0,l]),l=l.mid;else{for(t?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;o.length>0&&l.isEmpty();){let[h,D]=o.pop();switch(h){case 1:D.left=void 0;break;case 0:D.mid=void 0;break;case-1:D.right=void 0;break}l=D}break}}}findSubstr(a){const t=this._iter.reset(a);let r=this._root,o;for(;r;){const l=t.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(t.hasNext())t.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(a){const t=this._iter.reset(a);let r=this._root;for(;r;){const o=t.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(a){for(const[t,r]of this)a(r,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(a){a&&(yield*this._entries(a.left),a.value&&(yield[a.key,a.value]),yield*this._entries(a.mid),yield*this._entries(a.right))}}e.TernarySearchTree=f;class p{constructor(a,t){this[T]="ResourceMap",a instanceof p?(this.map=new Map(a.map),this.toKey=t!=null?t:p.defaultToKey):(this.map=new Map,this.toKey=a!=null?a:p.defaultToKey)}set(a,t){return this.map.set(this.toKey(a),t),this}get(a){return this.map.get(this.toKey(a))}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,t){typeof t!="undefined"&&(a=a.bind(t));for(let[r,o]of this.map)a(o,_.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let a of this.map.keys())yield _.URI.parse(a)}*entries(){for(let a of this.map.entries())yield[_.URI.parse(a[0]),a[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let a of this.map)yield[_.URI.parse(a[0]),a[1]]}}e.ResourceMap=p,p.defaultToKey=u=>u.toString();var m;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(m=e.Touch||(e.Touch={}));class b{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var a;return(a=this._head)===null||a===void 0?void 0:a.value}get last(){var a;return(a=this._tail)===null||a===void 0?void 0:a.value}has(a){return this._map.has(a)}get(a,t=0){const r=this._map.get(a);if(!!r)return t!==0&&this.touch(r,t),r.value}set(a,t,r=0){let o=this._map.get(a);if(o)o.value=t,r!==0&&this.touch(o,r);else{switch(o={key:a,value:t,next:void 0,previous:void 0},r){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(a,o),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const t=this._map.get(a);if(!!t)return this._map.delete(a),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}}forEach(a,t){const r=this._state;let o=this._head;for(;o;){if(t?a.bind(t)(o.value,o.key,this):a(o.value,o.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const a=this,t=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const l={value:r.key,done:!1};return r=r.next,l}else return{value:void 0,done:!0}}};return o}values(){const a=this,t=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const l={value:r.value,done:!1};return r=r.next,l}else return{value:void 0,done:!0}}};return o}entries(){const a=this,t=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const l={value:[r.key,r.value],done:!1};return r=r.next,l}else return{value:void 0,done:!0}}};return o}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(!(a>=this.size)){if(a===0){this.clear();return}let t=this._head,r=this.size;for(;t&&r>a;)this._map.delete(t.key),t=t.next,r--;this._head=t,this._size=r,t&&(t.previous=void 0),this._state++}}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const t=a.next,r=a.previous;if(!t||!r)throw new Error("Invalid list");t.previous=r,r.next=t}a.next=void 0,a.previous=void 0,this._state++}touch(a,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(a===this._head)return;const r=a.next,o=a.previous;a===this._tail?(o.next=void 0,this._tail=o):(r.previous=o,o.next=r),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(t===2){if(a===this._tail)return;const r=a.next,o=a.previous;a===this._head?(r.previous=void 0,this._head=r):(r.previous=o,o.next=r),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((t,r)=>{a.push([r,t])}),a}fromJSON(a){this.clear();for(const[t,r]of a)this.set(t,r)}}e.LinkedMap=b;class c extends b{constructor(a,t=1){super();this._limit=a,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,t=2){return super.get(a,t)}peek(a){return super.get(a,0)}set(a,t){return super.set(a,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c}),define(we[107],Ee([0,1,22,8]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...pe){return function(Ce,Te){for(let Ue=0,be=pe.length;Ue<be;Ue++){const Ke=pe[Ue](Ce,Te);if(Ke)return Ke}return null}}e.or=T,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(pe,Ce,Te){if(!Te||Te.length<Ce.length)return null;let Ue;return pe?Ue=S.startsWithIgnoreCase(Te,Ce):Ue=Te.indexOf(Ce)===0,Ue?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function E(pe,Ce){const Te=Ce.toLowerCase().indexOf(pe.toLowerCase());return Te===-1?null:[{start:Te,end:Te+pe.length}]}e.matchesContiguousSubString=E;function k(pe,Ce){return w(pe.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=k;function w(pe,Ce,Te,Ue){if(Te===pe.length)return[];if(Ue===Ce.length)return null;if(pe[Te]===Ce[Ue]){let be=null;return(be=w(pe,Ce,Te+1,Ue+1))?m({start:Ue,end:Ue+1},be):null}return w(pe,Ce,Te,Ue+1)}function n(pe){return 97<=pe&&pe<=122}function A(pe){return 65<=pe&&pe<=90}e.isUpper=A;function I(pe){return 48<=pe&&pe<=57}function v(pe){return pe===32||pe===9||pe===10||pe===13}const d=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(pe=>d.add(pe.charCodeAt(0)));function s(pe){return v(pe)||d.has(pe)}function f(pe,Ce){return pe===Ce||s(pe)&&s(Ce)}function p(pe){return n(pe)||A(pe)||I(pe)}function m(pe,Ce){return Ce.length===0?Ce=[pe]:pe.end===Ce[0].start?Ce[0].start=pe.start:Ce.unshift(pe),Ce}function b(pe,Ce){for(let Te=Ce;Te<pe.length;Te++){const Ue=pe.charCodeAt(Te);if(A(Ue)||I(Ue)||Te>0&&!p(pe.charCodeAt(Te-1)))return Te}return pe.length}function c(pe,Ce,Te,Ue){if(Te===pe.length)return[];if(Ue===Ce.length)return null;if(pe[Te]!==Ce[Ue].toLowerCase())return null;{let be=null,Ke=Ue+1;for(be=c(pe,Ce,Te+1,Ue+1);!be&&(Ke=b(Ce,Ke))<Ce.length;)be=c(pe,Ce,Te+1,Ke),Ke++;return be===null?null:m({start:Ue,end:Ue+1},be)}}function u(pe){let Ce=0,Te=0,Ue=0,be=0,Ke=0;for(let He=0;He<pe.length;He++)Ke=pe.charCodeAt(He),A(Ke)&&Ce++,n(Ke)&&Te++,p(Ke)&&Ue++,I(Ke)&&be++;const H=Ce/pe.length,Z=Te/pe.length,_e=Ue/pe.length,Me=be/pe.length;return{upperPercent:H,lowerPercent:Z,alphaPercent:_e,numericPercent:Me}}function a(pe){const{upperPercent:Ce,lowerPercent:Te}=pe;return Te===0&&Ce>.6}function t(pe){const{upperPercent:Ce,lowerPercent:Te,alphaPercent:Ue,numericPercent:be}=pe;return Te>.2&&Ce<.8&&Ue>.6&&be<.2}function r(pe){let Ce=0,Te=0,Ue=0,be=0;for(let Ke=0;Ke<pe.length;Ke++)Ue=pe.charCodeAt(Ke),A(Ue)&&Ce++,n(Ue)&&Te++,v(Ue)&&be++;return(Ce===0||Te===0)&&be===0?pe.length<=30:Ce<=5}function o(pe,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!r(pe)||Ce.length>60)return null;const Te=u(Ce);if(!t(Te)){if(!a(Te))return null;Ce=Ce.toLowerCase()}let Ue=null,be=0;for(pe=pe.toLowerCase();be<Ce.length&&(Ue=c(pe,Ce,0,be))===null;)be=b(Ce,be+1);return Ue}e.matchesCamelCase=o;function l(pe,Ce,Te=!1){if(!Ce||Ce.length===0)return null;let Ue=null,be=0;for(pe=pe.toLowerCase(),Ce=Ce.toLowerCase();be<Ce.length&&(Ue=i(pe,Ce,0,be,Te))===null;)be=h(Ce,be+1);return Ue}e.matchesWords=l;function i(pe,Ce,Te,Ue,be){if(Te===pe.length)return[];if(Ue===Ce.length)return null;if(f(pe.charCodeAt(Te),Ce.charCodeAt(Ue))){let Ke=null,H=Ue+1;if(Ke=i(pe,Ce,Te+1,Ue+1,be),!be)for(;!Ke&&(H=h(Ce,H))<Ce.length;)Ke=i(pe,Ce,Te+1,H,be),H++;return Ke===null?null:m({start:Ue,end:Ue+1},Ke)}else return null}function h(pe,Ce){for(let Te=Ce;Te<pe.length;Te++)if(s(pe.charCodeAt(Te))||Te>0&&s(pe.charCodeAt(Te-1)))return Te;return pe.length}const D=T(e.matchesPrefix,o,E),C=T(e.matchesPrefix,o,k),g=new _.LRUCache(1e4);function y(pe,Ce,Te=!1){if(typeof pe!="string"||typeof Ce!="string")return null;let Ue=g.get(pe);Ue||(Ue=new RegExp(S.convertSimple2RegExpPattern(pe),"i"),g.set(pe,Ue));const be=Ue.exec(Ce);return be?[{start:be.index,end:be.index+be[0].length}]:Te?C(pe,Ce):D(pe,Ce)}e.matchesFuzzy=y;function R(pe,Ce){const Te=N(pe,pe.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Te?x(Te):null}e.matchesFuzzy2=R;function O(pe,Ce,Te,Ue,be,Ke){const H=Math.min(13,pe.length);for(;Te<H;Te++){const Z=N(pe,Ce,Te,Ue,be,Ke,!1);if(Z)return Z}return[0,Ke]}e.anyScore=O;function x(pe){if(typeof pe=="undefined")return[];const Ce=[],Te=pe[1];for(let Ue=pe.length-1;Ue>1;Ue--){const be=pe[Ue]+Te,Ke=Ce[Ce.length-1];Ke&&Ke.end===be?Ke.end=be+1:Ce.push({start:be,end:be+1})}return Ce}e.createMatches=x;const z=128;function Q(){const pe=[],Ce=[];for(let Te=0;Te<=z;Te++)Ce[Te]=0;for(let Te=0;Te<=z;Te++)pe.push(Ce.slice(0));return pe}function j(pe){const Ce=[];for(let Te=0;Te<=pe;Te++)Ce[Te]=0;return Ce}const Y=j(2*z),L=j(2*z),$=Q(),W=Q(),K=Q(),U=!1;function ee(pe,Ce,Te,Ue,be){function Ke(Z,_e,Me=" "){for(;Z.length<_e;)Z=Me+Z;return Z}let H=` |   |${Ue.split("").map(Z=>Ke(Z,3)).join("|")}
`;for(let Z=0;Z<=Te;Z++)Z===0?H+=" |":H+=`${Ce[Z-1]}|`,H+=pe[Z].slice(0,be+1).map(_e=>Ke(_e.toString(),3)).join("|")+`
`;return H}function ie(pe,Ce,Te,Ue){pe=pe.substr(Ce),Te=Te.substr(Ue),console.log(ee(W,pe,pe.length,Te,Te.length)),console.log(ee(K,pe,pe.length,Te,Te.length)),console.log(ee($,pe,pe.length,Te,Te.length))}function se(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;const Te=pe.codePointAt(Ce);switch(Te){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!S.isEmojiImprecise(Te)}}function Se(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;switch(pe.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Ae(pe,Ce,Te){return Ce[pe]!==Te[pe]}function Be(pe,Ce,Te,Ue,be,Ke,H=!1){for(;Ce<Te&&be<Ke;)pe[Ce]===Ue[be]&&(H&&(Y[Ce]=be),Ce+=1),be+=1;return Ce===Te}e.isPatternInWord=Be;var Re;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var xe;(function(pe){pe.Default=[-100,0];function Ce(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}pe.isDefault=Ce})(xe=e.FuzzyScore||(e.FuzzyScore={}));function N(pe,Ce,Te,Ue,be,Ke,H){const Z=pe.length>z?z:pe.length,_e=Ue.length>z?z:Ue.length;if(!(Te>=Z||Ke>=_e||Z-Te>_e-Ke)&&!!Be(Ce,Te,Z,be,Ke,_e,!0)){q(Z,_e,Te,Ke,Ce,be);let Me=1,He=1,Oe=Te,Xe=Ke;const B=[!1];for(Me=1,Oe=Te;Oe<Z;Me++,Oe++){const oe=Y[Oe],fe=L[Oe],ve=Oe+1<Z?L[Oe+1]:_e;for(He=oe-Ke+1,Xe=oe;Xe<ve;He++,Xe++){let $e=Number.MIN_SAFE_INTEGER,Ne=!1;Xe<=fe&&($e=J(pe,Ce,Oe,Te,Ue,be,Xe,_e,Ke,$[Me-1][He-1]===0,B));let Ve=0;$e!==Number.MAX_SAFE_INTEGER&&(Ne=!0,Ve=$e+W[Me-1][He-1]);const Qe=Xe>oe,Ze=Qe?W[Me][He-1]+($[Me][He-1]>0?-5:0):0,ct=Xe>oe+1&&$[Me][He-1]>0,st=ct?W[Me][He-2]+($[Me][He-2]>0?-5:0):0;if(ct&&(!Qe||st>=Ze)&&(!Ne||st>=Ve))W[Me][He]=st,K[Me][He]=3,$[Me][He]=0;else if(Qe&&(!Ne||Ze>=Ve))W[Me][He]=Ze,K[Me][He]=2,$[Me][He]=0;else if(Ne)W[Me][He]=Ve,K[Me][He]=1,$[Me][He]=$[Me-1][He-1]+1;else throw new Error("not possible")}}if(U&&ie(pe,Te,Ue,Ke),!(!B[0]&&!H)){Me--,He--;const re=[W[Me][He],Ke];let ce=0,V=0;for(;Me>=1;){let oe=He;do{const fe=K[Me][oe];if(fe===3)oe=oe-2;else if(fe===2)oe=oe-1;else break}while(oe>=1);ce>1&&Ce[Te+Me-1]===be[Ke+He-1]&&!Ae(oe+Ke-1,Ue,be)&&ce+1>$[Me][oe]&&(oe=He),oe===He?ce++:ce=1,V||(V=oe),Me--,He=oe-1,re.push(He)}_e===Z&&(re[0]+=2);const X=V-Z;return re[0]-=X,re}}}e.fuzzyScore=N;function q(pe,Ce,Te,Ue,be,Ke){let H=pe-1,Z=Ce-1;for(;H>=Te&&Z>=Ue;)be[H]===Ke[Z]&&(L[H]=Z,H--),Z--}function J(pe,Ce,Te,Ue,be,Ke,H,Z,_e,Me,He){if(Ce[Te]!==Ke[H])return Number.MIN_SAFE_INTEGER;let Oe=1,Xe=!1;return H===Te-Ue?Oe=pe[Te]===be[H]?7:5:Ae(H,be,Ke)&&(H===0||!Ae(H-1,be,Ke))?(Oe=pe[Te]===be[H]?7:5,Xe=!0):se(Ke,H)&&(H===0||!se(Ke,H-1))?Oe=5:(se(Ke,H-1)||Se(Ke,H-1))&&(Oe=5,Xe=!0),Oe>1&&Te===Ue&&(He[0]=!0),Xe||(Xe=Ae(H,be,Ke)||se(Ke,H-1)||Se(Ke,H-1)),Te===Ue?H>_e&&(Oe-=Xe?3:5):Me?Oe+=Xe?2:0:Oe+=Xe?0:1,H+1===Z&&(Oe-=Xe?3:5),Oe}function le(pe,Ce,Te,Ue,be,Ke,H){return De(pe,Ce,Te,Ue,be,Ke,!0,H)}e.fuzzyScoreGracefulAggressive=le;function ge(pe,Ce,Te,Ue,be,Ke,H){return De(pe,Ce,Te,Ue,be,Ke,!1,H)}e.fuzzyScoreGraceful=ge;function De(pe,Ce,Te,Ue,be,Ke,H,Z){let _e=N(pe,Ce,Te,Ue,be,Ke,Z);if(_e&&!H)return _e;if(pe.length>=3){const Me=Math.min(7,pe.length-1);for(let He=Te+1;He<Me;He++){const Oe=Le(pe,He);if(Oe){const Xe=N(Oe,Oe.toLowerCase(),Te,Ue,be,Ke,Z);Xe&&(Xe[0]-=3,(!_e||Xe[0]>_e[0])&&(_e=Xe))}}}return _e}function Le(pe,Ce){if(!(Ce+1>=pe.length)){const Te=pe[Ce],Ue=pe[Ce+1];if(Te!==Ue)return pe.slice(0,Ce)+Ue+Te+pe.slice(Ce+2)}}}),define(we[108],Ee([0,1,37,107,8]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),E=new RegExp(`(\\\\)?${P.source}`,"g");function k(f){return f.replace(E,(p,m)=>m?p:`\\${p}`)}e.escapeIcons=k;const w=new RegExp(`\\\\${P.source}`,"g");function n(f){return f.replace(w,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=n;const A=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function I(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(A,(p,m,b,c)=>b?p:m||c||"")}e.stripIcons=I;function v(f){const p=f.indexOf(e.iconStartMarker);return p===-1?{text:f}:d(f,p)}e.parseLabelWithIcons=v;function d(f,p){const m=[];let b="";function c(h){if(h){b+=h;for(const D of h)m.push(t)}}let u=-1,a="",t=0,r,o,l=p;const i=f.length;for(c(f.substr(0,p));l<i;)r=f[l],o=f[l+1],r===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(u=l,c(a),a=e.iconStartMarker,l++):r===")"&&u!==-1?(t+=l-u+1,u=-1,a=""):u!==-1?/^[a-z0-9\-]$/i.test(r)?a+=r:(c(a),u=-1,a=""):c(r),l++;return c(a),{text:b,iconOffsets:m}}function s(f,p,m=!1){const{text:b,iconOffsets:c}=p;if(!c||c.length===0)return(0,S.matchesFuzzy)(f,b,m);const u=(0,T.ltrim)(b," "),a=b.length-u.length,t=(0,S.matchesFuzzy)(f,u,m);if(t)for(const r of t){const o=c[r.start+a]+a;r.start+=o,r.end+=o}return t}e.matchesFuzzyIconAware=s}),define(we[80],Ee([0,1,15,108,10]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(f="",p=!1){var m,b;if(this.value=f,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1):(this.isTrusted=(m=p.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(b=p.supportThemeIcons)!==null&&b!==void 0?b:!1)}appendText(f,p=0){return this.value+=I(this.supportThemeIcons?(0,S.escapeIcons)(f):f).replace(/([ \t]+)/g,(m,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,p){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=E;function k(s){return w(s)?!s.value:Array.isArray(s)?s.every(k):!0}e.isEmptyMarkdownString=k;function w(s){return s instanceof E?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=w;function n(s,f){return!s&&!f?!0:!s||!f?!1:Array.isArray(s)&&Array.isArray(f)?(0,_.equals)(s,f,A):w(s)&&w(f)?A(s,f):!1}e.markedStringsEquals=n;function A(s,f){return s===f?!0:!s||!f?!1:s.value===f.value&&s.isTrusted===f.isTrusted&&s.supportThemeIcons===f.supportThemeIcons}function I(s){return s.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function v(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=v;function d(s){const f=[],p=s.split("|").map(b=>b.trim());s=p[0];const m=p[1];if(m){const b=/height=(\d+)/.exec(m),c=/width=(\d+)/.exec(m),u=b?b[1]:"",a=c?c[1]:"",t=isFinite(parseInt(a)),r=isFinite(parseInt(u));t&&f.push(`width="${a}"`),r&&f.push(`height="${u}"`)}return{href:s,dimensions:f}}e.parseHrefAndDimensions=d}),define(we[57],Ee([0,1,26,8,2]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(n){return JSON.stringify(n,k)}e.stringify=P;function E(n){let A=JSON.parse(n);return A=w(A),A}e.parse=E;function k(n,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,S.regExpFlags)(A)}:A}function w(n,A=0){if(!n||A>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return T.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof _.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let I=0;I<n.length;++I)n[I]=w(n[I],A+1);else for(const I in n)Object.hasOwnProperty.call(n,I)&&(n[I]=w(n[I],A+1))}return n}e.revive=w}),define(we[16],Ee([0,1,2,21]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.vscodeWebviewResource="vscode-webview-resource",k.extension="extension",k.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,n,A){this._hosts[w]=n,this._ports[w]=A}setConnectionToken(w,n){this._connectionTokens[w]=n}rewrite(w){if(this._delegate)return this._delegate(w);const n=w.authority;let A=this._hosts[n];A&&A.indexOf(":")!==-1&&(A=`[${A}]`);const I=this._ports[n],v=this._connectionTokens[n];let d=`path=${encodeURIComponent(w.path)}`;return typeof v=="string"&&(d+=`&tkn=${encodeURIComponent(v)}`),_.URI.from({scheme:S.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${A}:${I}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new P;class E{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(w,n,A){const I=this.toUri(w,n);return I.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(I):S.isNative&&(A||S.isPreferringBrowserCodeLoad)&&I.scheme===T.file?I.with({scheme:T.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(w,n){const A=this.toUri(w,n);return A.scheme===T.vscodeFileResource?A.with({scheme:T.file,authority:A.authority!==this.FALLBACK_AUTHORITY?A.authority:null,query:null,fragment:null}):A}toUri(w,n){return _.URI.isUri(w)?w:_.URI.parse(n.toUrl(w))}}e.FileAccess=new E}),define(we[24],Ee([0,1,38,11,2,8,16,21]),function(ae,e,_,S,T,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(d){return(0,T.uriToFsPath)(d,!0)}e.originalFSPath=w;class n{constructor(s){this._ignorePathCasing=s}compare(s,f,p=!1){return s===f?0:(0,P.compare)(this.getComparisonKey(s,p),this.getComparisonKey(f,p))}isEqual(s,f,p=!1){return s===f?!0:!s||!f?!1:this.getComparisonKey(s,p)===this.getComparisonKey(f,p)}getComparisonKey(s,f=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,f,p=!1){if(s.scheme===f.scheme){if(s.scheme===E.Schemas.file)return _.isEqualOrParent(w(s),w(f),this._ignorePathCasing(s))&&s.query===f.query&&(p||s.fragment===f.fragment);if((0,e.isEqualAuthority)(s.authority,f.authority))return _.isEqualOrParent(s.path,f.path,this._ignorePathCasing(s),"/")&&s.query===f.query&&(p||s.fragment===f.fragment)}return!1}joinPath(s,...f){return T.URI.joinPath(s,...f)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return S.posix.basename(s.path)}extname(s){return S.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let f;return s.scheme===E.Schemas.file?f=T.URI.file(S.dirname(w(s))).path:(f=S.posix.dirname(s.path),s.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),f="/")),s.with({path:f})}normalizePath(s){if(!s.path.length)return s;let f;return s.scheme===E.Schemas.file?f=T.URI.file(S.normalize(w(s))).path:f=S.posix.normalize(s.path),s.with({path:f})}relativePath(s,f){if(!(s.scheme!==f.scheme||!(0,e.isEqualAuthority)(s.authority,f.authority))){if(s.scheme===E.Schemas.file){const b=S.relative(w(s),w(f));return k.isWindows?_.toSlashes(b):b}let p=s.path||"/",m=f.path||"/";if(this._ignorePathCasing(s)){let b=0;for(const c=Math.min(p.length,m.length);b<c&&!(p.charCodeAt(b)!==m.charCodeAt(b)&&p.charAt(b).toLowerCase()!==m.charAt(b).toLowerCase());b++);p=m.substr(0,b)+p.substr(b)}return S.posix.relative(p,m)}}resolvePath(s,f){if(s.scheme===E.Schemas.file){const p=T.URI.file(S.resolve(w(s),f));return s.with({authority:p.authority,path:p.path})}return f.indexOf("/")===-1&&(f=_.toSlashes(f),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f)),s.with({path:S.posix.resolve(s.path,f)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,f){return s===f||(0,P.equalsIgnoreCase)(s,f)}hasTrailingPathSeparator(s,f=S.sep){if(s.scheme===E.Schemas.file){const p=w(s);return p.length>_.getRoot(p).length&&p[p.length-1]===f}else{const p=s.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,f=S.sep){return(0,e.hasTrailingPathSeparator)(s,f)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,f=S.sep){let p=!1;if(s.scheme===E.Schemas.file){const m=w(s);p=m!==void 0&&m.length===_.getRoot(m).length&&m[m.length-1]===f}else{f="/";const m=s.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(s,f)?s.with({path:s.path+"/"}):s}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(d=>d.scheme===E.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new n(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(d,s){const f=[];for(let p=0;p<d.length;p++){const m=s(d[p]);d.some((b,c)=>c===p?!1:(0,e.isEqualOrParent)(m,s(b)))||f.push(d[p])}return f}e.distinctParents=A;var I;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function s(f){const p=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(c=>{const[u,a]=c.split(":");u&&a&&p.set(u,a)});const b=f.path.substring(0,f.path.indexOf(";"));return b&&p.set(d.META_DATA_MIME,b),p}d.parseMetaData=s})(I=e.DataUri||(e.DataUri={}));function v(d,s,f){if(s){let p=d.path;return p&&p[0]!==S.posix.sep&&(p=S.posix.sep+p),d.with({scheme:f,authority:s,path:p})}return d.with({scheme:f})}e.toLocalResource=v}),define(we[13],Ee([0,1,20,10,3,6,46,24]),function(ae,e,_,S,T,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(W){return!!W&&typeof W.then=="function"}e.isThenable=w;function n(W){const K=new _.CancellationTokenSource,U=W(K.token),ee=new Promise((ie,se)=>{K.token.onCancellationRequested(()=>{se((0,S.canceled)())}),Promise.resolve(U).then(Se=>{K.dispose(),ie(Se)},Se=>{K.dispose(),se(Se)})});return new class{cancel(){K.cancel()}then(ie,se){return ee.then(ie,se)}catch(ie){return this.then(void 0,ie)}finally(ie){return ee.finally(ie)}}}e.createCancelablePromise=n;function A(W,K,U){return Promise.race([W,new Promise(ee=>K.onCancellationRequested(()=>ee(U)))])}e.raceCancellation=A;async function I(W){let K=-1;const U=W.map((ie,se)=>ie.then(Se=>(K=se,Se))),ee=await Promise.race(U);return W.forEach((ie,se)=>{se!==K&&ie.cancel()}),ee}e.raceCancellablePromises=I;function v(W,K,U){let ee;const ie=setTimeout(()=>{ee==null||ee(void 0),U==null||U()},K);return Promise.race([W.finally(()=>clearTimeout(ie)),new Promise(se=>ee=se)])}e.raceTimeout=v;function d(W){return new Promise((K,U)=>{const ee=W();w(ee)?ee.then(K,U):K(ee)})}e.asPromise=d;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(K){if(this.activePromise){if(this.queuedPromiseFactory=K,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ee};this.queuedPromise=new Promise(ee=>{this.activePromise.then(U,U).then(ee)})}return new Promise((U,ee)=>{this.queuedPromise.then(U,ee)})}return this.activePromise=K(),new Promise((U,ee)=>{this.activePromise.then(ie=>{this.activePromise=null,U(ie)},ie=>{this.activePromise=null,ee(ie)})})}}e.Throttler=s;class f{constructor(){this.current=Promise.resolve(null)}queue(K){return this.current=this.current.then(()=>K(),()=>K())}}e.Sequencer=f;class p{constructor(){this.promiseMap=new Map}queue(K,U){var ee;const se=((ee=this.promiseMap.get(K))!==null&&ee!==void 0?ee:Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(K)===se&&this.promiseMap.delete(K)});return this.promiseMap.set(K,se),se}}e.SequencerByKey=p;class m{constructor(K){this.defaultDelay=K,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(K,U=this.defaultDelay){return this.task=K,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ee,ie)=>{this.doResolve=ee,this.doReject=ie}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ee=this.task;return this.task=null,ee()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,S.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class b{constructor(K){this.delayer=new m(K),this.throttler=new s}trigger(K,U){return this.delayer.trigger(()=>this.throttler.queue(K),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class c{constructor(){this._isOpen=!1,this._promise=new Promise((K,U)=>{this._completePromise=K})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class u extends c{constructor(K){super();this._timeout=setTimeout(()=>this.open(),K)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function a(W,K){return K?new Promise((U,ee)=>{const ie=setTimeout(U,W);K.onCancellationRequested(()=>{clearTimeout(ie),ee((0,S.canceled)())})}):n(U=>a(W,U))}e.timeout=a;function t(W,K=0){const U=setTimeout(W,K);return(0,P.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=t;function r(W){return W.then(void 0,K=>{})}e.ignoreErrors=r;function o(W){const K=[];let U=0;const ee=W.length;function ie(){return U<ee?W[U++]():null}function se(Se){Se!=null&&K.push(Se);const Ae=ie();return Ae?Ae.then(se):Promise.resolve(K)}return Promise.resolve(null).then(se)}e.sequence=o;function l(W,K=ee=>!!ee,U=null){let ee=0;const ie=W.length,se=()=>{if(ee>=ie)return Promise.resolve(U);const Se=W[ee++];return Promise.resolve(Se()).then(Be=>K(Be)?Promise.resolve(Be):se())};return se()}e.first=l;function i(W,K=ee=>!!ee,U=null){if(W.length===0)return Promise.resolve(U);let ee=W.length;const ie=()=>{var se,Se;ee=-1;for(const Ae of W)(Se=(se=Ae).cancel)===null||Se===void 0||Se.call(se)};return new Promise((se,Se)=>{for(const Ae of W)Ae.then(Be=>{--ee>=0&&K(Be)?(ie(),se(Be)):ee===0&&se(U)}).catch(Be=>{--ee>=0&&(ie(),Se(Be))})})}e.firstParallel=i;class h{constructor(K){this._size=0,this.maxDegreeOfParalellism=K,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(K){return this._size++,new Promise((U,ee)=>{this.outstandingPromises.push({factory:K,c:U,e:ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const K=this.outstandingPromises.shift();this.runningPromises++;const U=K.factory();U.then(K.c,K.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class D extends h{constructor(){super(1)}}e.Queue=D;class C{constructor(){this.queues=new Map}queueFor(K,U=k.extUri){const ee=U.getComparisonKey(K);let ie=this.queues.get(ee);return ie||(ie=new D,T.Event.once(ie.onFinished)(()=>{ie==null||ie.dispose(),this.queues.delete(ee)}),this.queues.set(ee,ie)),ie}dispose(){this.queues.forEach(K=>K.dispose()),this.queues.clear()}}e.ResourceQueue=C;class g{constructor(K,U){this._token=-1,typeof K=="function"&&typeof U=="number"&&this.setIfNotSet(K,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(K,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,K()},U)}setIfNotSet(K,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,K()},U))}}e.TimeoutTimer=g;class y{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(K,U){this.cancel(),this._token=setInterval(()=>{K()},U)}}e.IntervalTimer=y;class R{constructor(K,U){this.timeoutToken=-1,this.runner=K,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(K=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,K)}get delay(){return this.timeout}set delay(K){this.timeout=K}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class O extends R{constructor(K,U){super(K,U);this.units=[]}work(K){this.units.push(K),this.isScheduled()||this.schedule()}doRun(){const K=this.units;this.units=[],this.runner&&this.runner(K)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=K=>{const U=setTimeout(()=>K(W));let ee=!1;return{dispose(){ee||(ee=!0,clearTimeout(U))}}}}else e.runWhenIdle=(W,K)=>{const U=requestIdleCallback(W,typeof K=="number"?{timeout:K}:void 0);let ee=!1;return{dispose(){ee||(ee=!0,cancelIdleCallback(U))}}}}();class x{constructor(K){this._didRun=!1,this._executor=()=>{try{this._value=K()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=x;async function z(W,K,U){let ee;for(let ie=0;ie<U;ie++)try{return await W()}catch(se){ee=se,await a(K)}throw ee}e.retry=z;class Q{hasPending(K){return this._pending?typeof K=="number"?this._pending.taskId===K:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var K;(K=this._pending)===null||K===void 0||K.cancel()}setPending(K,U,ee){return this._pending={taskId:K,cancel:()=>ee==null?void 0:ee(),promise:U},U.then(()=>this.donePending(K),()=>this.donePending(K)),U}donePending(K){this._pending&&K===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const K=this._next;this._next=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}setNext(K){if(this._next)this._next.run=K;else{let U,ee;const ie=new Promise((se,Se)=>{U=se,ee=Se});this._next={run:K,promise:ie,promiseResolve:U,promiseReject:ee}}return this._next.promise}}e.TaskSequentializer=Q;class j{constructor(K){this.interval=K,this.lastIncrementTime=0,this.value=0}increment(){const K=Date.now();return K-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=K,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class Y{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((K,U)=>{this.completeCallback=K,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(K){return new Promise(U=>{this.completeCallback(K),this.resolved=!0,U()})}error(K){return new Promise(U=>{this.errorCallback(K),this.rejected=!0,U()})}cancel(){new Promise(K=>{this.errorCallback((0,S.canceled)()),this.rejected=!0,K()})}}e.DeferredPromise=Y;class L extends T.Emitter{async fireAsync(K,U,ee){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new E.LinkedList);for(const ie of this._listeners)this._asyncDeliveryQueue.push([ie,K]);for(;this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[ie,se]=this._asyncDeliveryQueue.shift(),Se=[],Ae=Object.assign(Object.assign({},se),{waitUntil:Be=>{if(Object.isFrozen(Se))throw new Error("waitUntil can NOT be called asynchronous");ee&&(Be=ee(Be,typeof ie=="function"?ie:ie[0])),Se.push(Be)}});try{typeof ie=="function"?ie.call(void 0,Ae):ie[0].call(ie[1],Ae)}catch(Be){(0,S.onUnexpectedError)(Be);continue}Object.freeze(Se),await $.settled(Se).catch(Be=>(0,S.onUnexpectedError)(Be))}}}}e.AsyncEmitter=L;var $;(function(W){async function K(se){return typeof Promise.allSettled=="function"?U(se):ee(se)}W.allSettled=K;async function U(se){return Promise.allSettled(se)}async function ee(se){return Promise.all(se.map(Se=>Se.then(Ae=>({status:"fulfilled",value:Ae}),Ae=>({status:"rejected",reason:Ae}))))}async function ie(se){let Se;const Ae=await Promise.all(se.map(Be=>Be.then(Re=>Re,Re=>{Se||(Se=Re)})));if(typeof Se!="undefined")throw Se;return Ae}W.settled=ie})($=e.Promises||(e.Promises={}))}),define(we[109],Ee([0,1,11,13]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new S.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),P=new S.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),E=new S.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(u,a,t=!1){const r=u||"",o=a||"",l=T.value.collator.compare(r,o);return T.value.collatorIsNumeric&&l===0&&r!==o?r<o?-1:1:l}e.compareFileNames=k;function w(u,a){const t=P.value.collator;return u=u||"",a=a||"",f(t,u,a)}e.compareFileNamesDefault=w;function n(u,a,t=!1){t||(u=u&&u.toLowerCase(),a=a&&a.toLowerCase());const[r,o]=d(u),[l,i]=d(a);return r!==l?r<l?-1:1:o===i?0:o<i?-1:1}e.noIntlCompareFileNames=n;function A(u,a){const[t,r]=d(u),[o,l]=d(a);let i=T.value.collator.compare(r,l);if(i===0){if(T.value.collatorIsNumeric&&r!==l)return r<l?-1:1;if(i=T.value.collator.compare(t,o),T.value.collatorIsNumeric&&i===0&&t!==o)return t<o?-1:1}return i}e.compareFileExtensions=A;function I(u,a){u=u||"",a=a||"";const t=s(u),r=s(a),o=P.value.collator,l=E.value.collator;let i;return i=f(l,t,r),i!==0?i:f(o,u,a)}e.compareFileExtensionsDefault=I;const v=/^(.*?)(\.([^.]*))?$/;function d(u,a=!1){const t=u?v.exec(u):[];let r=[t&&t[1]||"",t&&t[3]||""];return a&&(!r[0]&&r[1]||r[0]&&r[0].charAt(0)===".")&&(r=[r[0]+"."+r[1],""]),r}function s(u){const a=u?v.exec(u):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function f(u,a,t){let r=u.compare(a,t);return r!==0?r:a.length!==t.length?a.length<t.length?-1:1:0}function p(u,a,t=!1){return t||(u=u&&u.toLowerCase(),a=a&&a.toLowerCase()),u===a?0:u<a?-1:1}function m(u,a,t=!1){const r=u.split(_.sep),o=a.split(_.sep),l=r.length-1,i=o.length-1;let h,D;for(let C=0;;C++){if(h=l===C,D=i===C,h&&D)return k(r[C],o[C],t);if(h)return-1;if(D)return 1;const g=p(r[C],o[C],t);if(g!==0)return g}}e.comparePaths=m;function b(u,a,t){const r=u.toLowerCase(),o=a.toLowerCase(),l=c(u,a,t);if(l)return l;const i=r.endsWith(t),h=o.endsWith(t);if(i!==h)return i?-1:1;const D=k(r,o);return D!==0?D:r.localeCompare(o)}e.compareAnything=b;function c(u,a,t){const r=u.toLowerCase(),o=a.toLowerCase(),l=r.startsWith(t),i=o.startsWith(t);if(l!==i)return l?-1:1;if(l&&i){if(r.length<o.length)return-1;if(r.length>o.length)return 1}return 0}e.compareByPrefix=c}),define(we[28],Ee([0,1,8,38,11,22,13]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const w="**",n="/",A="[/\\\\]",I="[^/\\\\]",v=/\//g;function d(U){switch(U){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}|${A}${I}+)*?`}}function s(U,ee){if(!U)return[];const ie=[];let se=!1,Se=!1,Ae="";for(const Be of U){switch(Be){case ee:if(!se&&!Se){ie.push(Ae),Ae="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":Se=!0;break;case"]":Se=!1;break}Ae+=Be}return Ae&&ie.push(Ae),ie}e.splitGlobAware=s;function f(U){if(!U)return"";let ee="";const ie=s(U,n);if(ie.every(se=>se===w))ee=".*";else{let se=!1;ie.forEach((Se,Ae)=>{if(Se===w){se||(ee+=d(2),se=!0);return}let Be=!1,Re="",xe=!1,N="";for(const q of Se){if(q!=="}"&&Be){Re+=q;continue}if(xe&&(q!=="]"||!N)){let J;q==="-"?J=q:(q==="^"||q==="!")&&!N?J="^":q===n?J="":J=_.escapeRegExpCharacters(q),N+=J;continue}switch(q){case"{":Be=!0;continue;case"[":xe=!0;continue;case"}":ee+=`(?:${s(Re,",").map(ge=>f(ge)).join("|")})`,Be=!1,Re="";break;case"]":ee+="["+N+"]",xe=!1,N="";break;case"?":ee+=I;continue;case"*":ee+=d(1);continue;default:ee+=_.escapeRegExpCharacters(q)}}Ae<ie.length-1&&(ie[Ae+1]!==w||Ae+2<ie.length)&&(ee+=A),se=!1})}return ee}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),r=function(){return!1},o=function(){return null};function l(U,ee){if(!U)return o;let ie;typeof U!="string"?ie=U.pattern:ie=U,ie=ie.trim();const se=`${ie}_${!!ee.trimForExclusions}`;let Se=t.get(se);if(Se)return i(Se,U);let Ae;if(p.test(ie)){const Be=ie.substr(4);Se=function(Re,xe){return typeof Re=="string"&&Re.endsWith(Be)?ie:null}}else(Ae=m.exec(h(ie,ee)))?Se=D(Ae[1],ie):(ee.trimForExclusions?c:b).test(ie)?Se=C(ie,ee):(Ae=u.exec(h(ie,ee)))?Se=g(Ae[1].substr(1),ie,!0):(Ae=a.exec(h(ie,ee)))?Se=g(Ae[1],ie,!1):Se=y(ie);return t.set(se,Se),i(Se,U)}function i(U,ee){return typeof ee=="string"?U:function(ie,se){return S.isEqualOrParent(ie,ee.base)?U(T.relative(ee.base,ie),se):null}}function h(U,ee){return ee.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function D(U,ee){const ie=`/${U}`,se=`\\${U}`,Se=function(Be,Re){return typeof Be!="string"?null:Re?Re===U?ee:null:Be===U||Be.endsWith(ie)||Be.endsWith(se)?ee:null},Ae=[U];return Se.basenames=Ae,Se.patterns=[ee],Se.allBasenames=Ae,Se}function C(U,ee){const ie=K(U.slice(1,-1).split(",").map(Re=>l(Re,ee)).filter(Re=>Re!==o),U),se=ie.length;if(!se)return o;if(se===1)return ie[0];const Se=function(Re,xe){for(let N=0,q=ie.length;N<q;N++)if(ie[N](Re,xe))return U;return null},Ae=ie.find(Re=>!!Re.allBasenames);Ae&&(Se.allBasenames=Ae.allBasenames);const Be=ie.reduce((Re,xe)=>xe.allPaths?Re.concat(xe.allPaths):Re,[]);return Be.length&&(Se.allPaths=Be),Se}function g(U,ee,ie){const se=T.sep===T.posix.sep,Se=se?U:U.replace(v,T.sep),Ae=T.sep+Se,Be=T.posix.sep+U,Re=ie?function(xe,N){return typeof xe=="string"&&(xe===Se||xe.endsWith(Ae)||!se&&(xe===U||xe.endsWith(Be)))?ee:null}:function(xe,N){return typeof xe=="string"&&(xe===Se||!se&&xe===U)?ee:null};return Re.allPaths=[(ie?"*/":"./")+U],Re}function y(U){try{const ee=new RegExp(`^${f(U)}$`);return function(ie){return ee.lastIndex=0,typeof ie=="string"&&ee.test(ie)?U:null}}catch(ee){return o}}function R(U,ee,ie){return!U||typeof ee!="string"?!1:O(U)(ee,void 0,ie)}e.match=R;function O(U,ee={}){if(!U)return r;if(typeof U=="string"||j(U)){const ie=l(U,ee);if(ie===o)return r;const se=function(Se,Ae){return!!ie(Se,Ae)};return ie.allBasenames&&(se.allBasenames=ie.allBasenames),ie.allPaths&&(se.allPaths=ie.allPaths),se}return $(U,ee)}e.parse=O;function x(U){if(!!U){let ee;return ie=>(ee||(ee=(U()||Promise.resolve([])).then(se=>se?Q(se):{})),ee.then(se=>!!se[ie]))}}e.hasSiblingPromiseFn=x;function z(U){if(!!U){let ee;return ie=>{if(!ee){const se=U();ee=se?Q(se):{}}return!!ee[ie]}}}e.hasSiblingFn=z;function Q(U){const ee={};for(const ie of U)ee[ie]=!0;return ee}function j(U){const ee=U;return ee&&typeof ee.base=="string"&&typeof ee.pattern=="string"}e.isRelativePattern=j;function Y(U){return U.allBasenames||[]}e.getBasenameTerms=Y;function L(U){return U.allPaths||[]}e.getPathTerms=L;function $(U,ee){const ie=K(Object.getOwnPropertyNames(U).map(Re=>W(Re,U[Re],ee)).filter(Re=>Re!==o)),se=ie.length;if(!se)return o;if(!ie.some(Re=>!!Re.requiresSiblings)){if(se===1)return ie[0];const Re=function(q,J){for(let le=0,ge=ie.length;le<ge;le++){const De=ie[le](q,J);if(De)return De}return null},xe=ie.find(q=>!!q.allBasenames);xe&&(Re.allBasenames=xe.allBasenames);const N=ie.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return N.length&&(Re.allPaths=N),Re}const Se=function(Re,xe,N){let q;for(let J=0,le=ie.length;J<le;J++){const ge=ie[J];ge.requiresSiblings&&N&&(xe||(xe=T.basename(Re)),q||(q=xe.substr(0,xe.length-T.extname(Re).length)));const De=ge(Re,xe,q,N);if(De)return De}return null},Ae=ie.find(Re=>!!Re.allBasenames);Ae&&(Se.allBasenames=Ae.allBasenames);const Be=ie.reduce((Re,xe)=>xe.allPaths?Re.concat(xe.allPaths):Re,[]);return Be.length&&(Se.allPaths=Be),Se}function W(U,ee,ie){if(ee===!1)return o;const se=l(U,ie);if(se===o)return o;if(typeof ee=="boolean")return se;if(ee){const Se=ee.when;if(typeof Se=="string"){const Ae=(Be,Re,xe,N)=>{if(!N||!se(Be,Re))return null;const q=Se.replace("$(basename)",xe),J=N(q);return(0,E.isThenable)(J)?J.then(le=>le?U:null):J?U:null};return Ae.requiresSiblings=!0,Ae}}return se}function K(U,ee){const ie=U.filter(Re=>!!Re.basenames);if(ie.length<2)return U;const se=ie.reduce((Re,xe)=>{const N=xe.basenames;return N?Re.concat(N):Re},[]);let Se;if(ee){Se=[];for(let Re=0,xe=se.length;Re<xe;Re++)Se.push(ee)}else Se=ie.reduce((Re,xe)=>{const N=xe.patterns;return N?Re.concat(N):Re},[]);const Ae=function(Re,xe){if(typeof Re!="string")return null;if(!xe){let q;for(q=Re.length;q>0;q--){const J=Re.charCodeAt(q-1);if(J===47||J===92)break}xe=Re.substr(q)}const N=se.indexOf(xe);return N!==-1?Se[N]:null};Ae.basenames=se,Ae.patterns=Se,Ae.allBasenames=se;const Be=U.filter(Re=>!Re.basenames);return Be.push(Ae),Be}}),define(we[58],Ee([0,1,2,11,8,16,21,24,38]),function(ae,e,_,S,T,P,E,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(l,i,h){if(typeof l=="string"&&(l=_.URI.file(l)),h){const C=h.getWorkspaceFolder(l);if(C){const g=h.getWorkspace().folders.length>1;let y;if((0,k.isEqual)(C.uri,l)?y="":y=(0,k.relativePath)(C.uri,l),g){const R=C.name?C.name:(0,k.basename)(C.uri);y=y?R+" \u2022 "+y:R}return y}}if(l.scheme!==P.Schemas.file&&l.scheme!==P.Schemas.untitled)return l.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(l.fsPath))return(0,S.normalize)(I(l.fsPath));let D=(0,S.normalize)(l.fsPath);return!E.isWindows&&(i==null?void 0:i.userHome)&&(D=d(D,i.userHome.fsPath)),D}e.getPathLabel=n;function A(l){if(!!l){typeof l=="string"&&(l=_.URI.file(l));const i=(0,k.basename)(l)||(l.scheme===P.Schemas.file?l.fsPath:l.path);return E.isWindows&&(0,w.isRootOrDriveLetter)(i)?I(i):i}}e.getBaseLabel=A;function I(l){return(0,w.hasDriveLetter)(l)?l.charAt(0).toUpperCase()+l.slice(1):l}e.normalizeDriveLetter=I;let v=Object.create(null);function d(l,i){if(E.isWindows||!l||!i)return l;let h=v.original===i?v.normalized:void 0;return h||(h=`${(0,T.rtrim)(i,S.posix.sep)}${S.posix.sep}`,v={original:i,normalized:h}),(E.isLinux?l.startsWith(h):(0,T.startsWithIgnoreCase)(l,h))&&(l=`~/${l.substr(h.length)}`),l}e.tildify=d;function s(l,i){return l.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=s;const f="\u2026",p="\\\\",m="~";function b(l,i=S.sep){const h=new Array(l.length);let D=!1;for(let C=0;C<l.length;C++){let g=l[C];if(g===""){h[C]=`.${i}`;continue}if(!g){h[C]=g;continue}D=!0;let y="";g.indexOf(p)===0?(y=g.substr(0,g.indexOf(p)+p.length),g=g.substr(g.indexOf(p)+p.length)):g.indexOf(i)===0?(y=g.substr(0,g.indexOf(i)+i.length),g=g.substr(g.indexOf(i)+i.length)):g.indexOf(m)===0&&(y=g.substr(0,g.indexOf(m)+m.length),g=g.substr(g.indexOf(m)+m.length));const R=g.split(i);for(let O=1;D&&O<=R.length;O++)for(let x=R.length-O;D&&x>=0;x--){D=!1;let z=R.slice(x,x+O).join(i);for(let Q=0;!D&&Q<l.length;Q++)if(Q!==C&&l[Q]&&l[Q].indexOf(z)>-1){const j=x+O===R.length,Y=x>0&&l[Q].indexOf(i)>-1?i+z:z,L=l[Q].endsWith(Y);D=!j||L}if(!D){let Q="";(R[0].endsWith(":")||y!=="")&&(x===1&&(x=0,O++,z=R[0]+i+z),x>0&&(Q=R[0]+i),Q=y+Q),x>0&&(Q=Q+f+i),Q=Q+z,x+O<R.length&&(Q=Q+i+f),h[C]=Q}}D&&(h[C]=g)}return h}e.shorten=b;var c;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function u(l,i=Object.create(null)){const h=[];let D=!1,C="";for(const g of l)if(g==="$"||D&&g==="{")C&&h.push({value:C,type:c.TEXT}),C="",D=!0;else if(g==="}"&&D){const y=i[C];if(typeof y=="string")y.length&&h.push({value:y,type:c.VARIABLE});else if(y){const R=h[h.length-1];(!R||R.type!==c.SEPARATOR)&&h.push({value:y.label,type:c.SEPARATOR})}C="",D=!1}else C+=g;return C&&!D&&h.push({value:C,type:c.TEXT}),h.filter((g,y)=>{if(g.type===c.SEPARATOR){const R=h[y-1],O=h[y+1];return[R,O].every(x=>x&&(x.type===c.VARIABLE||x.type===c.TEXT)&&x.value.length>0)}return!0}).map(g=>g.value).join("")}e.template=u;function a(l,i){return E.isMacintosh||i?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,E.isMacintosh?"&":"&&"):l.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function t(l,i){return E.isMacintosh||i?l.replace(/\(&&\w\)|&&/g,""):E.isWindows?l.replace(/&&|&/g,h=>h==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(l){return l.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(l){const i=l.indexOf("/")!==-1?S.posix:S.win32,h=i.basename(l),D=i.dirname(l);return h.length?{name:h,parentPath:D}:{name:D,parentPath:""}}e.splitName=o}),define(we[110],Ee([0,1,2]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function S(A){return A.toJSON()}class T{constructor(I){this._uriTransformer=I}transformIncoming(I){const v=this._uriTransformer.transformIncoming(I);return v===I?I:S(_.URI.from(v))}transformOutgoing(I){const v=this._uriTransformer.transformOutgoing(I);return v===I?I:S(_.URI.from(v))}transformOutgoingURI(I){const v=this._uriTransformer.transformOutgoing(I);return v===I?I:_.URI.from(v)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function P(A,I,v){if(!A||v>200)return null;if(typeof A=="object"){if(A instanceof _.URI)return I.transformOutgoing(A);for(let d in A)if(Object.hasOwnProperty.call(A,d)){const s=P(A[d],I,v+1);s!==null&&(A[d]=s)}}return null}function E(A,I){const v=P(A,I,0);return v===null?A:v}e.transformOutgoingURIs=E;function k(A,I,v,d){if(!A||d>200)return null;if(typeof A=="object"){if(A.$mid===1)return v?_.URI.revive(I.transformIncoming(A)):I.transformIncoming(A);for(let s in A)if(Object.hasOwnProperty.call(A,s)){const f=k(A[s],I,v,d+1);f!==null&&(A[s]=f)}}return null}function w(A,I){const v=k(A,I,!1,0);return v===null?A:v}e.transformIncomingURIs=w;function n(A,I){const v=k(A,I,!0,0);return v===null?A:v}e.transformAndReviveIncomingURIs=n}),define(we[29],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(w){return _.test(w)}e.isUUID=S;const T=new Uint8Array(16),P=[];for(let w=0;w<256;w++)P.push(w.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(w){for(let n=0;n<w.length;n++)w[n]=Math.floor(Math.random()*256);return w};function k(){E(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let w=0,n="";return n+=P[T[w++]],n+=P[T[w++]],n+=P[T[w++]],n+=P[T[w++]],n+="-",n+=P[T[w++]],n+=P[T[w++]],n+="-",n+=P[T[w++]],n+=P[T[w++]],n+="-",n+=P[T[w++]],n+=P[T[w++]],n+="-",n+=P[T[w++]],n+=P[T[w++]],n+=P[T[w++]],n+=P[T[w++]],n+=P[T[w++]],n+=P[T[w++]],n}e.generateUuid=k}),define(we[81],Ee([0,1,79]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class S{constructor(k){let w=(0,_.toUint8)(k);this._defaultValue=w,this._asciiMap=S._createAsciiMap(w),this._map=new Map}static _createAsciiMap(k){let w=new Uint8Array(256);for(let n=0;n<256;n++)w[n]=k;return w}set(k,w){let n=(0,_.toUint8)(w);k>=0&&k<256?this._asciiMap[k]=n:this._map.set(k,n)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=S;var T;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(T||(T={}));class P{constructor(){this._actual=new S(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=P}),define(we[111],Ee([0,1,81]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var S;(function(E){E[E.Regular=0]="Regular",E[E.Whitespace=1]="Whitespace",E[E.WordSeparator=2]="WordSeparator"})(S=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends _.CharacterClassifier{constructor(k){super(0);for(let w=0,n=k.length;w<n;w++)this.set(k.charCodeAt(w),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function P(E){let k={};return w=>(k.hasOwnProperty(w)||(k[w]=E(w)),k[w])}e.getMapForWordSeparators=P(E=>new T(E))}),define(we[39],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(T,P){this.lineNumber=T,this.column=P}with(T=this.lineNumber,P=this.column){return T===this.lineNumber&&P===this.column?this:new _(T,P)}delta(T=0,P=0){return this.with(this.lineNumber+T,this.column+P)}equals(T){return _.equals(this,T)}static equals(T,P){return!T&&!P?!0:!!T&&!!P&&T.lineNumber===P.lineNumber&&T.column===P.column}isBefore(T){return _.isBefore(this,T)}static isBefore(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<P.column}isBeforeOrEqual(T){return _.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<=P.column}static compare(T,P){let E=T.lineNumber|0,k=P.lineNumber|0;if(E===k){let w=T.column|0,n=P.column|0;return w-n}return E-k}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new _(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=_}),define(we[32],Ee([0,1,39]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class S{constructor(P,E,k,w){P>k||P===k&&E>w?(this.startLineNumber=k,this.startColumn=w,this.endLineNumber=P,this.endColumn=E):(this.startLineNumber=P,this.startColumn=E,this.endLineNumber=k,this.endColumn=w)}isEmpty(){return S.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return S.containsPosition(this,P)}static containsPosition(P,E){return!(E.lineNumber<P.startLineNumber||E.lineNumber>P.endLineNumber||E.lineNumber===P.startLineNumber&&E.column<P.startColumn||E.lineNumber===P.endLineNumber&&E.column>P.endColumn)}containsRange(P){return S.containsRange(this,P)}static containsRange(P,E){return!(E.startLineNumber<P.startLineNumber||E.endLineNumber<P.startLineNumber||E.startLineNumber>P.endLineNumber||E.endLineNumber>P.endLineNumber||E.startLineNumber===P.startLineNumber&&E.startColumn<P.startColumn||E.endLineNumber===P.endLineNumber&&E.endColumn>P.endColumn)}strictContainsRange(P){return S.strictContainsRange(this,P)}static strictContainsRange(P,E){return!(E.startLineNumber<P.startLineNumber||E.endLineNumber<P.startLineNumber||E.startLineNumber>P.endLineNumber||E.endLineNumber>P.endLineNumber||E.startLineNumber===P.startLineNumber&&E.startColumn<=P.startColumn||E.endLineNumber===P.endLineNumber&&E.endColumn>=P.endColumn)}plusRange(P){return S.plusRange(this,P)}static plusRange(P,E){let k,w,n,A;return E.startLineNumber<P.startLineNumber?(k=E.startLineNumber,w=E.startColumn):E.startLineNumber===P.startLineNumber?(k=E.startLineNumber,w=Math.min(E.startColumn,P.startColumn)):(k=P.startLineNumber,w=P.startColumn),E.endLineNumber>P.endLineNumber?(n=E.endLineNumber,A=E.endColumn):E.endLineNumber===P.endLineNumber?(n=E.endLineNumber,A=Math.max(E.endColumn,P.endColumn)):(n=P.endLineNumber,A=P.endColumn),new S(k,w,n,A)}intersectRanges(P){return S.intersectRanges(this,P)}static intersectRanges(P,E){let k=P.startLineNumber,w=P.startColumn,n=P.endLineNumber,A=P.endColumn,I=E.startLineNumber,v=E.startColumn,d=E.endLineNumber,s=E.endColumn;return k<I?(k=I,w=v):k===I&&(w=Math.max(w,v)),n>d?(n=d,A=s):n===d&&(A=Math.min(A,s)),k>n||k===n&&w>A?null:new S(k,w,n,A)}equalsRange(P){return S.equalsRange(this,P)}static equalsRange(P,E){return!!P&&!!E&&P.startLineNumber===E.startLineNumber&&P.startColumn===E.startColumn&&P.endLineNumber===E.endLineNumber&&P.endColumn===E.endColumn}getEndPosition(){return S.getEndPosition(this)}static getEndPosition(P){return new _.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return S.getStartPosition(this)}static getStartPosition(P){return new _.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,E){return new S(this.startLineNumber,this.startColumn,P,E)}setStartPosition(P,E){return new S(P,E,this.endLineNumber,this.endColumn)}collapseToStart(){return S.collapseToStart(this)}static collapseToStart(P){return new S(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,E=P){return new S(P.lineNumber,P.column,E.lineNumber,E.column)}static lift(P){return P?new S(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,E){return!(P.endLineNumber<E.startLineNumber||P.endLineNumber===E.startLineNumber&&P.endColumn<E.startColumn||E.endLineNumber<P.startLineNumber||E.endLineNumber===P.startLineNumber&&E.endColumn<P.startColumn)}static areIntersecting(P,E){return!(P.endLineNumber<E.startLineNumber||P.endLineNumber===E.startLineNumber&&P.endColumn<=E.startColumn||E.endLineNumber<P.startLineNumber||E.endLineNumber===P.startLineNumber&&E.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,E){if(P&&E){const n=P.startLineNumber|0,A=E.startLineNumber|0;if(n===A){const I=P.startColumn|0,v=E.startColumn|0;if(I===v){const d=P.endLineNumber|0,s=E.endLineNumber|0;if(d===s){const f=P.endColumn|0,p=E.endColumn|0;return f-p}return d-s}return I-v}return n-A}return(P?1:0)-(E?1:0)}static compareRangesUsingEnds(P,E){return P.endLineNumber===E.endLineNumber?P.endColumn===E.endColumn?P.startLineNumber===E.startLineNumber?P.startColumn-E.startColumn:P.startLineNumber-E.startLineNumber:P.endColumn-E.endColumn:P.endLineNumber-E.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}}e.Range=S}),define(we[112],Ee([0,1,39,32]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class P extends S.Range{constructor(k,w,n,A){super(k,w,n,A);this.selectionStartLineNumber=k,this.selectionStartColumn=w,this.positionLineNumber=n,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return P.selectionsEqual(this,k)}static selectionsEqual(k,w){return k.selectionStartLineNumber===w.selectionStartLineNumber&&k.selectionStartColumn===w.selectionStartColumn&&k.positionLineNumber===w.positionLineNumber&&k.positionColumn===w.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,w){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,k,w):new P(k,w,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,w){return this.getDirection()===0?new P(k,w,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,k,w)}static fromPositions(k,w=k){return new P(k.lineNumber,k.column,w.lineNumber,w.column)}static liftSelection(k){return new P(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,w){if(k&&!w||!k&&w)return!1;if(!k&&!w)return!0;if(k.length!==w.length)return!1;for(let n=0,A=k.length;n<A;n++)if(!this.selectionsEqual(k[n],w[n]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,w,n,A,I){return I===0?new P(k,w,n,A):new P(n,A,k,w)}}e.Selection=P}),define(we[82],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var S;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(S=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(s){this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace)}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class w{constructor(s,f){this.range=s,this.matches=f}}e.FindMatch=w;var n;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var A;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A=e.ModelConstants||(e.ModelConstants={}));class I{constructor(s,f,p,m,b,c){this.identifier=s,this.range=f,this.text=p,this.forceMoveMarkers=m,this.isAutoWhitespaceEdit=b,this._isTracked=c}}e.ValidAnnotatedEditOperation=I;class v{constructor(s,f,p){this.reverseEdits=s,this.changes=f,this.trimAutoWhitespaceLineNumbers=p}}e.ApplyEditsResult=v}),define(we[113],Ee([0,1,8,111,39,32,82]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class w{constructor(c,u,a,t){this.searchString=c,this.isRegex=u,this.matchCase=a,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=n(this.searchString):c=this.searchString.indexOf(`
`)>=0;let u=null;try{u=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let a=!this.isRegex&&!c;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new A(u,this.wordSeparators?(0,S.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}e.SearchParams=w;function n(b){if(!b||b.length===0)return!1;for(let c=0,u=b.length;c<u;c++)if(b.charCodeAt(c)===92){if(c++,c>=u)break;const t=b.charCodeAt(c);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class A{constructor(c,u,a){this.regex=c,this.wordSeparators=u,this.simpleSearch=a}}e.SearchData=A;function I(b,c,u){if(!u)return new E.FindMatch(b,null);let a=[];for(let t=0,r=c.length;t<r;t++)a[t]=c[t];return new E.FindMatch(b,a)}e.createFindMatch=I;class v{constructor(c){let u=[],a=0;for(let t=0,r=c.length;t<r;t++)c.charCodeAt(t)===10&&(u[a++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(c){const u=this._lineFeedsOffsets;let a=0,t=u.length-1;if(t===-1||c<=u[0])return 0;for(;a<t;){const r=a+((t-a)/2>>0);u[r]>=c?t=r-1:u[r+1]>=c?(a=r,t=r):a=r+1}return a+1}}class d{static findMatches(c,u,a,t,r){const o=u.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(c,a,new m(o.wordSeparators,o.regex),t,r):this._doFindMatchesLineByLine(c,a,o,t,r):[]}static _getMultilineMatchRange(c,u,a,t,r,o){let l,i=0;t?(i=t.findLineFeedCountBeforeOffset(r),l=u+r+i):l=u+r;let h;if(t){let y=t.findLineFeedCountBeforeOffset(r+o.length)-i;h=l+o.length+y}else h=l+o.length;const D=c.getPositionAt(l),C=c.getPositionAt(h);return new P.Range(D.lineNumber,D.column,C.lineNumber,C.column)}static _doFindMatchesMultiline(c,u,a,t,r){const o=c.getOffsetAt(u.getStartPosition()),l=c.getValueInRange(u,1),i=c.getEOL()===`\r
`?new v(l):null,h=[];let D=0,C;for(a.reset(0);C=a.next(l);)if(h[D++]=I(this._getMultilineMatchRange(c,o,l,i,C.index,C[0]),C,t),D>=r)return h;return h}static _doFindMatchesLineByLine(c,u,a,t,r){const o=[];let l=0;if(u.startLineNumber===u.endLineNumber){const h=c.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return l=this._findMatchesInLine(a,h,u.startLineNumber,u.startColumn-1,l,o,t,r),o}const i=c.getLineContent(u.startLineNumber).substring(u.startColumn-1);l=this._findMatchesInLine(a,i,u.startLineNumber,u.startColumn-1,l,o,t,r);for(let h=u.startLineNumber+1;h<u.endLineNumber&&l<r;h++)l=this._findMatchesInLine(a,c.getLineContent(h),h,0,l,o,t,r);if(l<r){const h=c.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);l=this._findMatchesInLine(a,h,u.endLineNumber,0,l,o,t,r)}return o}static _findMatchesInLine(c,u,a,t,r,o,l,i){const h=c.wordSeparators;if(!l&&c.simpleSearch){const g=c.simpleSearch,y=g.length,R=u.length;let O=-y;for(;(O=u.indexOf(g,O+y))!==-1;)if((!h||p(h,u,R,O,y))&&(o[r++]=new E.FindMatch(new P.Range(a,O+1+t,a,O+1+y+t),null),r>=i))return r;return r}const D=new m(c.wordSeparators,c.regex);let C;D.reset(0);do if(C=D.next(u),C&&(o[r++]=I(new P.Range(a,C.index+1+t,a,C.index+1+C[0].length+t),C,l),r>=i))return r;while(C);return r}static findNextMatch(c,u,a,t){const r=u.parseSearchRequest();if(!r)return null;const o=new m(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(c,a,o,t):this._doFindNextMatchLineByLine(c,a,o,t)}static _doFindNextMatchMultiline(c,u,a,t){const r=new T.Position(u.lineNumber,1),o=c.getOffsetAt(r),l=c.getLineCount(),i=c.getValueInRange(new P.Range(r.lineNumber,r.column,l,c.getLineMaxColumn(l)),1),h=c.getEOL()===`\r
`?new v(i):null;a.reset(u.column-1);let D=a.next(i);return D?I(this._getMultilineMatchRange(c,o,i,h,D.index,D[0]),D,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(c,new T.Position(1,1),a,t):null}static _doFindNextMatchLineByLine(c,u,a,t){const r=c.getLineCount(),o=u.lineNumber,l=c.getLineContent(o),i=this._findFirstMatchInLine(a,l,o,u.column,t);if(i)return i;for(let h=1;h<=r;h++){const D=(o+h-1)%r,C=c.getLineContent(D+1),g=this._findFirstMatchInLine(a,C,D+1,1,t);if(g)return g}return null}static _findFirstMatchInLine(c,u,a,t,r){c.reset(t-1);const o=c.next(u);return o?I(new P.Range(a,o.index+1,a,o.index+1+o[0].length),o,r):null}static findPreviousMatch(c,u,a,t){const r=u.parseSearchRequest();if(!r)return null;const o=new m(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(c,a,o,t):this._doFindPreviousMatchLineByLine(c,a,o,t)}static _doFindPreviousMatchMultiline(c,u,a,t){const r=this._doFindMatchesMultiline(c,new P.Range(1,1,u.lineNumber,u.column),a,t,10*k);if(r.length>0)return r[r.length-1];const o=c.getLineCount();return u.lineNumber!==o||u.column!==c.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(c,new T.Position(o,c.getLineMaxColumn(o)),a,t):null}static _doFindPreviousMatchLineByLine(c,u,a,t){const r=c.getLineCount(),o=u.lineNumber,l=c.getLineContent(o).substring(0,u.column-1),i=this._findLastMatchInLine(a,l,o,t);if(i)return i;for(let h=1;h<=r;h++){const D=(r+o-h-1)%r,C=c.getLineContent(D+1),g=this._findLastMatchInLine(a,C,D+1,t);if(g)return g}return null}static _findLastMatchInLine(c,u,a,t){let r=null,o;for(c.reset(0);o=c.next(u);)r=I(new P.Range(a,o.index+1,a,o.index+1+o[0].length),o,t);return r}}e.TextModelSearch=d;function s(b,c,u,a,t){if(a===0)return!0;const r=c.charCodeAt(a-1);if(b.get(r)!==0||r===13||r===10)return!0;if(t>0){const o=c.charCodeAt(a);if(b.get(o)!==0)return!0}return!1}function f(b,c,u,a,t){if(a+t===u)return!0;const r=c.charCodeAt(a+t);if(b.get(r)!==0||r===13||r===10)return!0;if(t>0){const o=c.charCodeAt(a+t-1);if(b.get(o)!==0)return!0}return!1}function p(b,c,u,a,t){return s(b,c,u,a,t)&&f(b,c,u,a,t)}e.isValidMatch=p;class m{constructor(c,u){this._wordSeparators=c,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const u=c.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(a=this._searchRegex.exec(c),!a))return null;const t=a.index,r=a[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){_.getNextCodePoint(c,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||p(this._wordSeparators,c,u,t,r))return a}while(a);return null}}e.Searcher=m}),define(we[83],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(k=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)k.indexOf(n)>=0||(w+="\\"+n);return w+="\\s]+)",new RegExp(w,"g")}e.DEFAULT_WORD_REGEXP=_();function S(k){let w=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)w=k;else{let n="g";k.ignoreCase&&(n+="i"),k.multiline&&(n+="m"),k.unicode&&(n+="u"),w=new RegExp(k.source,n)}return w.lastIndex=0,w}e.ensureValidWordDefinition=S;const T={maxLen:1e3,windowSize:15,timeBudget:150};function P(k,w,n,A,I=T){if(n.length>I.maxLen){let p=k-I.maxLen/2;return p<0?p=0:A+=p,n=n.substring(p,k+I.maxLen/2),P(k,w,n,A,I)}const v=Date.now(),d=k-1-A;let s=-1,f=null;for(let p=1;!(Date.now()-v>=I.timeBudget);p++){const m=d-I.windowSize*p;w.lastIndex=Math.max(0,m);const b=E(w,n,d,s);if(!b&&f||(f=b,m<=0))break;s=m}if(f){let p={word:f[0],startColumn:A+1+f.index,endColumn:A+1+f.index+f[0].length};return w.lastIndex=0,p}return null}e.getWordAtText=P;function E(k,w,n,A){let I;for(;I=k.exec(w);){const v=I.index||0;if(v<=n&&k.lastIndex>=n)return I;if(A>0&&v>A)return null}return null}}),define(we[114],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(E){E[E.None=0]="None",E[E.Indent=1]="Indent",E[E.IndentOutdent=2]="IndentOutdent",E[E.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class S{constructor(k){if(this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let w=0,n=k.notIn.length;w<n;w++)switch(k.notIn[w]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=S;class T{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of k)P(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),P(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),P(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),P(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&P(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=T;function P(E,k,w){E.has(k)?E.get(k).push(w):E.set(k,[w])}}),define(we[59],Ee([0,1,28,11]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(P,E,k,w){if(Array.isArray(P)){let n=0;for(const A of P){const I=T(A,E,k,w);if(I===10)return I;I>n&&(n=I)}return n}else{if(typeof P=="string")return w?P==="*"?5:P===k?10:0:0;if(P){const{language:n,pattern:A,scheme:I,hasAccessToAllModels:v}=P;if(!w&&!v)return 0;let d=0;if(I)if(I===E.scheme)d=10;else if(I==="*")d=5;else return 0;if(n)if(n===k)d=10;else if(n==="*")d=Math.max(d,5);else return 0;if(A){let s;if(typeof A=="string"?s=A:s=Object.assign(Object.assign({},A),{base:(0,S.normalize)(A.base)}),s===E.fsPath||(0,_.match)(s,E.fsPath))d=10;else return 0}return d}else return 0}}e.score=T}),define(we[115],Ee([0,1,81]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var S;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(S=e.State||(e.State={}));class T{constructor(s,f,p){const m=new Uint8Array(s*f);for(let b=0,c=s*f;b<c;b++)m[b]=p;this._data=m,this.rows=s,this.cols=f}get(s,f){return this._data[s*this.cols+f]}set(s,f,p){this._data[s*this.cols+f]=p}}e.Uint8Matrix=T;class P{constructor(s){let f=0,p=0;for(let b=0,c=s.length;b<c;b++){let[u,a,t]=s[b];a>f&&(f=a),u>p&&(p=u),t>p&&(p=t)}f++,p++;let m=new T(p,f,0);for(let b=0,c=s.length;b<c;b++){let[u,a,t]=s[b];m.set(u,a,t)}this._states=m,this._maxCharCode=f}nextState(s,f){return f<0||f>=this._maxCharCode?0:this._states.get(s,f)}}e.StateMachine=P;let E=null;function k(){return E===null&&(E=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),E}var w;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(w||(w={}));let n=null;function A(){if(n===null){n=new _.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<d.length;f++)n.set(d.charCodeAt(f),1);const s=".,;";for(let f=0;f<s.length;f++)n.set(s.charCodeAt(f),2)}return n}class I{static _createLink(s,f,p,m,b){let c=b-1;do{const u=f.charCodeAt(c);if(s.get(u)!==2)break;c--}while(c>m);if(m>0){const u=f.charCodeAt(m-1),a=f.charCodeAt(c);(u===40&&a===41||u===91&&a===93||u===123&&a===125)&&c--}return{range:{startLineNumber:p,startColumn:m+1,endLineNumber:p,endColumn:c+2},url:f.substring(m,c+1)}}static computeLinks(s,f=k()){const p=A();let m=[];for(let b=1,c=s.getLineCount();b<=c;b++){const u=s.getLineContent(b),a=u.length;let t=0,r=0,o=0,l=1,i=!1,h=!1,D=!1,C=!1;for(;t<a;){let g=!1;const y=u.charCodeAt(t);if(l===13){let R;switch(y){case 40:i=!0,R=0;break;case 41:R=i?0:1;break;case 91:D=!0,h=!0,R=0;break;case 93:D=!1,R=h?0:1;break;case 123:C=!0,R=0;break;case 125:R=C?0:1;break;case 39:R=o===34||o===96?0:1;break;case 34:R=o===39||o===96?0:1;break;case 96:R=o===39||o===34?0:1;break;case 42:R=o===42?1:0;break;case 124:R=o===124?1:0;break;case 32:R=D?0:1;break;default:R=p.get(y)}R===1&&(m.push(I._createLink(p,u,b,r,t)),g=!0)}else if(l===12){let R;y===91?(h=!0,R=0):R=p.get(y),R===1?g=!0:l=13}else l=f.nextState(l,y),l===0&&(g=!0);g&&(l=1,i=!1,h=!1,C=!1,r=t+1,o=y),t++}l===13&&m.push(I._createLink(p,u,b,r,a))}return m}}e.LinkComputer=I;function v(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:I.computeLinks(d)}e.computeLinks=v}),define(we[116],Ee([0,1,3,6]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(E){this._onDidChange.fire({changedLanguages:E,changedColorMap:!1})}register(E,k){return this._map.set(E,k),this.fire([E]),(0,S.toDisposable)(()=>{this._map.get(E)===k&&(this._map.delete(E),this.fire([E]))})}registerPromise(E,k){let w=null,n=!1;return this._promises.set(E,k.then(A=>{this._promises.delete(E),!(n||!A)&&(w=this.register(E,A))})),(0,S.toDisposable)(()=>{n=!0,w&&w.dispose()})}getPromise(E){const k=this.get(E);if(k)return Promise.resolve(k);const w=this._promises.get(E);return w?w.then(n=>this.get(E)):null}get(E){return this._map.get(E)||null}setColorMap(E){this._colorMap=E,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(we[84],Ee([0,1,26,21]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(T||(T={}));function P(I){for(let v=0,d=I.length;v<d;v+=4){const s=I[v+0],f=I[v+1],p=I[v+2],m=I[v+3];I[v+0]=m,I[v+1]=p,I[v+2]=f,I[v+3]=s}}function E(I){const v=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return S.isLittleEndian()||P(v),_.VSBuffer.wrap(v)}function k(I){const v=I.buffer;if(S.isLittleEndian()||P(v),v.byteOffset%4==0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const d=new Uint8Array(v.byteLength);return d.set(v),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function w(I){const v=new Uint32Array(n(I));let d=0;if(v[d++]=I.id,I.type==="full")v[d++]=1,v[d++]=I.data.length,v.set(I.data,d),d+=I.data.length;else{v[d++]=2,v[d++]=I.deltas.length;for(const s of I.deltas)v[d++]=s.start,v[d++]=s.deleteCount,s.data?(v[d++]=s.data.length,v.set(s.data,d),d+=s.data.length):v[d++]=0}return E(v)}e.encodeSemanticTokensDto=w;function n(I){let v=0;if(v+=1+1,I.type==="full")v+=1+I.data.length;else{v+=1,v+=(1+1+1)*I.deltas.length;for(const d of I.deltas)d.data&&(v+=d.data.length)}return v}function A(I){const v=k(I);let d=0;const s=v[d++];if(v[d++]===1){const b=v[d++],c=v.subarray(d,d+b);return d+=b,{id:s,type:"full",data:c}}const p=v[d++];let m=[];for(let b=0;b<p;b++){const c=v[d++],u=v[d++],a=v[d++];let t;a>0&&(t=v.subarray(d,d+a),d+=a),m[b]={start:c,deleteCount:u,data:t}}return{id:s,type:"delta",deltas:m}}e.decodeSemanticTokensDto=A}),define(we[85],Ee([0,1,79]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class S{constructor(E,k){this.index=E,this.remainder=k}}e.PrefixSumIndexOfResult=S;class T{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,k){E=(0,_.toUint32)(E);const w=this.values,n=this.prefixSum,A=k.length;return A===0?!1:(this.values=new Uint32Array(w.length+A),this.values.set(w.subarray(0,E),0),this.values.set(w.subarray(E),E+A),this.values.set(k,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(E,k){return E=(0,_.toUint32)(E),k=(0,_.toUint32)(k),this.values[E]===k?!1:(this.values[E]=k,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,k){E=(0,_.toUint32)(E),k=(0,_.toUint32)(k);const w=this.values,n=this.prefixSum;if(E>=w.length)return!1;let A=w.length-E;return k>=A&&(k=A),k===0?!1:(this.values=new Uint32Array(w.length-k),this.values.set(w.subarray(0,E),0),this.values.set(w.subarray(E+k),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(E){return E<0?0:(E=(0,_.toUint32)(E),this._getAccumulatedValue(E))}_getAccumulatedValue(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),E>=this.values.length&&(E=this.values.length-1);for(let w=k;w<=E;w++)this.prefixSum[w]=this.prefixSum[w-1]+this.values[w];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalValue();let k=0,w=this.values.length-1,n=0,A=0,I=0;for(;k<=w;)if(n=k+(w-k)/2|0,A=this.prefixSum[n],I=A-this.values[n],E<I)w=n-1;else if(E>=A)k=n+1;else break;return new S(n,E-I)}}e.PrefixSumComputer=T}),define(we[117],Ee([0,1,8,39,85]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(k,w,n,A){this._uri=k,this._lines=w,this._eol=n,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const w=k.changes;for(const n of w)this._acceptDeleteRange(n.range),this._acceptInsertText(new S.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,w=this._lines.length,n=new Uint32Array(w);for(let A=0;A<w;A++)n[A]=this._lines[A].length+k;this._lineStarts=new T.PrefixSumComputer(n)}}_setLineText(k,w){this._lines[k]=w,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,w){if(w.length!==0){let n=(0,_.splitLines)(w);if(n.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+n[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}n[n.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+n[0]);let A=new Uint32Array(n.length-1);for(let I=1;I<n.length;I++)this._lines.splice(k.lineNumber+I-1,0,n[I]),A[I-1]=n[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,A)}}}e.MirrorTextModel=P}),define(we[118],Ee([17,18]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(we[60],Ee([0,1,118,12,15]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(n,A){return A&&(n.stack||n.stacktrace)?_.localize(0,null,k(n),E(n.stack)||E(n.stacktrace)):k(n)}function E(n){return Array.isArray(n)?n.join(`
`):n}function k(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?_.localize(1,null,n.message):n.message||_.localize(2,null)}function w(n=null,A=!1){if(!n)return _.localize(3,null);if(Array.isArray(n)){const I=T.coalesce(n),v=w(I[0],A);return I.length>1?_.localize(4,null,v,I.length):v}if(S.isString(n))return n;if(n.detail){const I=n.detail;if(I.error)return P(I.error,A);if(I.exception)return P(I.exception,A)}return n.stack?P(n,A):n.message?n.message:_.localize(5,null)}e.toErrorMessage=w}),define(we[119],Ee([17,18]),function(ae,e){return ae.create("vs/editor/common/config/editorOptions",e)}),define(we[120],Ee([0,1,119,21,83]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=E;class k{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,_e){this._values[Z]=_e}}e.ValidatedEditorOptions=k;class w{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=w;class n{constructor(Z,_e,Me,He){this.id=Z,this.name=_e,this.defaultValue=Me,this.schema=He}compute(Z,_e,Me){return Me}}class A{constructor(Z,_e=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(Z){return this.defaultValue}}class I{constructor(Z,_e,Me,He){this.id=Z,this.name=_e,this.defaultValue=Me,this.schema=He}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,_e,Me){return Me}}function v(H,Z){return typeof H=="undefined"?Z:H==="false"?!1:Boolean(H)}e.boolean=v;class d extends I{constructor(Z,_e,Me,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Me),super(Z,_e,Me,He)}validate(Z){return v(Z,this.defaultValue)}}class s extends I{constructor(Z,_e,Me,He,Oe,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Me,Xe.minimum=He,Xe.maximum=Oe),super(Z,_e,Me,Xe),this.minimum=He,this.maximum=Oe}static clampedInt(Z,_e,Me,He){if(typeof Z=="undefined")return _e;let Oe=parseInt(Z,10);return isNaN(Oe)?_e:(Oe=Math.max(Me,Oe),Oe=Math.min(He,Oe),Oe|0)}validate(Z){return s.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class f extends I{constructor(Z,_e,Me,He,Oe){typeof Oe!="undefined"&&(Oe.type="number",Oe.default=Me),super(Z,_e,Me,Oe),this.validationFn=He}static clamp(Z,_e,Me){return Z<_e?_e:Z>Me?Me:Z}static float(Z,_e){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return _e;const Me=parseFloat(Z);return isNaN(Me)?_e:Me}validate(Z){return this.validationFn(f.float(Z,this.defaultValue))}}class p extends I{static string(Z,_e){return typeof Z!="string"?_e:Z}constructor(Z,_e,Me,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Me),super(Z,_e,Me,He)}validate(Z){return p.string(Z,this.defaultValue)}}function m(H,Z,_e){return typeof H!="string"||_e.indexOf(H)===-1?Z:H}e.stringSet=m;class b extends I{constructor(Z,_e,Me,He,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="string",Oe.enum=He,Oe.default=Me),super(Z,_e,Me,Oe),this._allowedValues=He}validate(Z){return m(Z,this.defaultValue,this._allowedValues)}}class c extends n{constructor(Z,_e,Me,He,Oe,Xe,B=void 0){typeof B!="undefined"&&(B.type="string",B.enum=Oe,B.default=He),super(Z,_e,Me,B),this._allowedValues=Oe,this._convert=Xe}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function u(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,_e,Me){return Me===0?Z.accessibilitySupport:Me}}class t extends n{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(16,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:_.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{insertSpace:v(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(l=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function i(H){switch(H){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=i;function h(H){switch(H){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class D extends A{constructor(){super(121,[60,29])}compute(Z,_e,Me){const He=["monaco-editor"];return _e.get(29)&&He.push(_e.get(29)),Z.extraEditorClassName&&He.push(Z.extraEditorClassName),_e.get(60)==="default"?He.push("mouse-default"):_e.get(60)==="copy"&&He.push("mouse-copy"),_e.get(95)&&He.push("showUnused"),_e.get(119)&&He.push("showDeprecated"),He.join(" ")}}class C extends d{constructor(){super(28,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(Z,_e,Me){return Me&&Z.emptySelectionClipboard}}class g extends n{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(31,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:Z.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:_.localize(13,null),included:S.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:_.localize(15,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{cursorMoveOnType:v(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:v(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":m(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(_e.loop,this.defaultValue.loop)}}}class y extends n{constructor(){super(39,"fontLigatures",y.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?y.OFF:Z==="true"?y.ON:Z:Boolean(Z)?y.ON:y.OFF}}e.EditorFontLigatures=y,y.OFF='"liga" off, "calt" off',y.ON='"liga" on, "calt" on';class R extends A{constructor(){super(38)}compute(Z,_e,Me){return Z.fontInfo}}class O extends I{constructor(){super(40,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(Z){let _e=f.float(Z,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(_e,6,100)}compute(Z,_e,Me){return Z.fontInfo.fontSize}}class x extends n{constructor(){super(41,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(s.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class z extends n{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]};super(45,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,description:_.localize(35,null)}})}validate(Z){var _e,Me,He,Oe,Xe;if(!Z||typeof Z!="object")return this.defaultValue;const B=Z;return{multiple:m(B.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=B.multipleDefinitions)!==null&&_e!==void 0?_e:m(B.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Me=B.multipleTypeDefinitions)!==null&&Me!==void 0?Me:m(B.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=B.multipleDeclarations)!==null&&He!==void 0?He:m(B.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Oe=B.multipleImplementations)!==null&&Oe!==void 0?Oe:m(B.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=B.multipleReferences)!==null&&Xe!==void 0?Xe:m(B.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(B.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(B.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(B.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(B.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(B.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Q extends n{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(48,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:_.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{enabled:v(_e.enabled,this.defaultValue.enabled),delay:s.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:v(_e.sticky,this.defaultValue.sticky)}}}var j;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(j=e.RenderMinimap||(e.RenderMinimap={}));class Y extends A{constructor(){super(124,[44,52,33,59,87,54,55,89,111,114,115,116,2])}compute(Z,_e,Me){return Y.computeLayout(_e,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const _e=Z.height/Z.lineHeight,Me=Z.scrollBeyondLastLine?_e-1:0,He=(Z.viewLineCount+Me)/(Z.pixelRatio*Z.height),Oe=Math.floor(Z.viewLineCount/He);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:Me,desiredRatio:He,minimapLineCount:Oe}}static _computeMinimapLayout(Z,_e){const Me=Z.outerWidth,He=Z.outerHeight,Oe=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Oe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Xe=_e.stableMinimapLayoutInput,B=Xe&&Z.outerHeight===Xe.outerHeight&&Z.lineHeight===Xe.lineHeight&&Z.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&Z.pixelRatio===Xe.pixelRatio&&Z.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&Z.minimap.enabled===Xe.minimap.enabled&&Z.minimap.side===Xe.minimap.side&&Z.minimap.size===Xe.minimap.size&&Z.minimap.showSlider===Xe.minimap.showSlider&&Z.minimap.renderCharacters===Xe.minimap.renderCharacters&&Z.minimap.maxColumn===Xe.minimap.maxColumn&&Z.minimap.scale===Xe.minimap.scale&&Z.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&Z.isViewportWrapping===Xe.isViewportWrapping,re=Z.lineHeight,ce=Z.typicalHalfwidthCharacterWidth,V=Z.scrollBeyondLastLine,X=Z.minimap.renderCharacters;let oe=Oe>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const fe=Z.minimap.maxColumn,ve=Z.minimap.size,$e=Z.minimap.side,Ne=Z.verticalScrollbarWidth,Ve=Z.viewLineCount,Qe=Z.remainingWidth,Ze=Z.isViewportWrapping,ct=X?2:3;let st=Math.floor(Oe*He);const me=st/Oe;let he=!1,ue=!1,G=ct*oe,Ie=oe/Oe,Pe=1;if(ve==="fill"||ve==="fit"){const{typicalViewportLineCount:dt,extraLinesBeyondLastLine:at,desiredRatio:Dt,minimapLineCount:gt}=Y.computeContainedMinimapLineCount({viewLineCount:Ve,scrollBeyondLastLine:V,height:He,lineHeight:re,pixelRatio:Oe});if(Ve/gt>1)he=!0,ue=!0,oe=1,G=1,Ie=oe/Oe;else{let wt=!1,Et=oe+1;if(ve==="fit"){const mt=Math.ceil((Ve+at)*G);Ze&&B&&Qe<=_e.stableFitRemainingWidth?(wt=!0,Et=_e.stableFitMaxMinimapScale):(wt=mt>st,Ze&&wt?(_e.stableMinimapLayoutInput=Z,_e.stableFitRemainingWidth=Qe):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(ve==="fill"||wt){he=!0;const mt=oe;G=Math.min(re*Oe,Math.max(1,Math.floor(1/Dt))),oe=Math.min(Et,Math.max(1,Math.floor(G/ct))),oe>mt&&(Pe=Math.min(2,oe/mt)),Ie=oe/Oe/Pe,st=Math.ceil(Math.max(dt,Ve+at)*G),Ze&&wt&&(_e.stableFitMaxMinimapScale=oe)}}}const et=Math.floor(fe*Ie),Ge=Math.min(et,Math.max(0,Math.floor((Qe-Ne-2)*Ie/(ce+Ie)))+e.MINIMAP_GUTTER_WIDTH);let rt=Math.floor(Oe*Ge);const lt=rt/Oe;rt=Math.floor(rt*Pe);const Je=X?1:2,it=$e==="left"?0:Me-Ge-Ne;return{renderMinimap:Je,minimapLeft:it,minimapWidth:Ge,minimapHeightIsEditorHeight:he,minimapIsSampling:ue,minimapScale:oe,minimapLineHeight:G,minimapCanvasInnerWidth:rt,minimapCanvasInnerHeight:st,minimapCanvasOuterWidth:lt,minimapCanvasOuterHeight:me}}static computeLayout(Z,_e){const Me=_e.outerWidth|0,He=_e.outerHeight|0,Oe=_e.lineHeight|0,Xe=_e.lineNumbersDigitCount|0,B=_e.typicalHalfwidthCharacterWidth,re=_e.maxDigitWidth,ce=_e.pixelRatio,V=_e.viewLineCount,X=Z.get(116),oe=X==="inherit"?Z.get(115):X,fe=oe==="inherit"?Z.get(111):oe,ve=Z.get(114),$e=Z.get(2),Ne=_e.isDominatedByLongLines,Ve=Z.get(44),Qe=Z.get(54).renderType!==0,Ze=Z.get(55),ct=Z.get(89),st=Z.get(59),me=Z.get(87),he=me.verticalScrollbarSize,ue=me.verticalHasArrows,G=me.arrowSize,Ie=me.horizontalScrollbarSize,Pe=Z.get(52),et=Z.get(33);let Ge;if(typeof Pe=="string"&&/^\d+(\.\d+)?ch$/.test(Pe)){const ht=parseFloat(Pe.substr(0,Pe.length-2));Ge=s.clampedInt(ht*B,0,0,1e3)}else Ge=s.clampedInt(Pe,0,0,1e3);et&&(Ge+=16);let rt=0;if(Qe){const ht=Math.max(Xe,Ze);rt=Math.round(ht*re)}let lt=0;Ve&&(lt=Oe);let Je=0,it=Je+lt,dt=it+rt,at=dt+Ge;const Dt=Me-lt-rt-Ge;let gt=!1,Ct=!1,wt=-1;$e!==2&&(oe==="inherit"&&Ne?(gt=!0,Ct=!0):fe==="on"||fe==="bounded"?Ct=!0:fe==="wordWrapColumn"&&(wt=ve));const Et=Y._computeMinimapLayout({outerWidth:Me,outerHeight:He,lineHeight:Oe,typicalHalfwidthCharacterWidth:B,pixelRatio:ce,scrollBeyondLastLine:ct,minimap:st,verticalScrollbarWidth:he,viewLineCount:V,remainingWidth:Dt,isViewportWrapping:Ct},_e.memory||new w);Et.renderMinimap!==0&&Et.minimapLeft===0&&(Je+=Et.minimapWidth,it+=Et.minimapWidth,dt+=Et.minimapWidth,at+=Et.minimapWidth);const mt=Dt-Et.minimapWidth,Rt=Math.max(1,Math.floor((mt-he-2)/B)),Ft=ue?G:0;return Ct&&(wt=Math.max(1,Rt),fe==="bounded"&&(wt=Math.min(wt,ve))),{width:Me,height:He,glyphMarginLeft:Je,glyphMarginWidth:lt,lineNumbersLeft:it,lineNumbersWidth:rt,decorationsLeft:dt,decorationsWidth:Ge,contentLeft:at,contentWidth:mt,minimap:Et,viewportColumn:Rt,isWordWrapMinified:gt,isViewportWrapping:Ct,wrappingColumn:wt,verticalScrollbarWidth:he,horizontalScrollbarHeight:Ie,overviewRuler:{top:Ft,width:he,height:He-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=Y;class L extends n{constructor(){const Z={enabled:!0};super(51,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:_.localize(39,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:v(Z.enabled,this.defaultValue.enabled)}}}class $ extends n{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(120,"inlineHints",Z,{"editor.inlineHints.enabled":{type:"boolean",default:Z.enabled,description:_.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:Z.fontSize,description:_.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:Z.fontFamily,description:_.localize(42,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{enabled:v(_e.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class W extends s{constructor(){super(53,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(Z,_e,Me){return Z.fontInfo.lineHeight}}class K extends n{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(59,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:Z.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:_.localize(53,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{enabled:v(_e.enabled,this.defaultValue.enabled),size:m(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(_e.side,this.defaultValue.side,["right","left"]),showSlider:m(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(_e.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(_e.scale,1,1,3),maxColumn:s.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function U(H){return H==="ctrlCmd"?S.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ee extends n{constructor(){super(69,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{top:s.clampedInt(_e.top,0,0,1e3),bottom:s.clampedInt(_e.bottom,0,0,1e3)}}}class ie extends n{constructor(){const Z={enabled:!0,cycle:!1};super(70,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:_.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{enabled:v(_e.enabled,this.defaultValue.enabled),cycle:v(_e.cycle,this.defaultValue.cycle)}}}class se extends A{constructor(){super(122)}compute(Z,_e,Me){return Z.pixelRatio}}class Se extends n{constructor(){const Z={other:!0,comments:!1,strings:!1};super(73,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:_.localize(58,null)},comments:{type:"boolean",default:Z.comments,description:_.localize(59,null)},other:{type:"boolean",default:Z.other,description:_.localize(60,null)}}}],default:Z,description:_.localize(61,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const _e=Z,Me={other:v(_e.other,this.defaultValue.other),comments:v(_e.comments,this.defaultValue.comments),strings:v(_e.strings,this.defaultValue.strings)};return Me.other&&Me.comments&&Me.strings?!0:!Me.other&&!Me.comments&&!Me.strings?!1:Me}return this.defaultValue}}var Ae;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Ae=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Be extends n{constructor(){super(54,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(Z){let _e=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(_e=4,Me=Z):Z==="interval"?_e=3:Z==="relative"?_e=2:Z==="on"?_e=1:_e=0),{renderType:_e,renderFn:Me}}}function Re(H){const Z=H.get(82);return Z==="editable"?H.get(75):Z!=="on"}e.filterValidationDecorations=Re;class xe extends n{constructor(){const Z=[],_e={type:"number",description:_.localize(67,null)};super(86,"rulers",Z,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:Z,description:_.localize(69,null)})}validate(Z){if(Array.isArray(Z)){let _e=[];for(let Me of Z)if(typeof Me=="number")_e.push({column:s.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const He=Me;_e.push({column:s.clampedInt(He.column,0,0,1e4),color:He.color})}return _e.sort((Me,He)=>Me.column-He.column),_e}return this.defaultValue}}function N(H,Z){if(typeof H!="string")return Z;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends n{constructor(){super(87,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z,Me=s.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=s.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(_e.vertical,this.defaultValue.vertical),horizontal:N(_e.horizontal,this.defaultValue.horizontal),useShadows:v(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:s.clampedInt(_e.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:He,verticalSliderSize:s.clampedInt(_e.verticalSliderSize,He,0,1e3),scrollByPage:v(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class J extends n{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(101,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:Z.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{insertMode:m(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(_e.showIcons,this.defaultValue.showIcons),showStatusBar:v(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:v(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(_e.showMethods,this.defaultValue.showMethods),showFunctions:v(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:v(_e.showConstructors,this.defaultValue.showConstructors),showFields:v(_e.showFields,this.defaultValue.showFields),showVariables:v(_e.showVariables,this.defaultValue.showVariables),showClasses:v(_e.showClasses,this.defaultValue.showClasses),showStructs:v(_e.showStructs,this.defaultValue.showStructs),showInterfaces:v(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:v(_e.showModules,this.defaultValue.showModules),showProperties:v(_e.showProperties,this.defaultValue.showProperties),showEvents:v(_e.showEvents,this.defaultValue.showEvents),showOperators:v(_e.showOperators,this.defaultValue.showOperators),showUnits:v(_e.showUnits,this.defaultValue.showUnits),showValues:v(_e.showValues,this.defaultValue.showValues),showConstants:v(_e.showConstants,this.defaultValue.showConstants),showEnums:v(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:v(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(_e.showKeywords,this.defaultValue.showKeywords),showWords:v(_e.showWords,this.defaultValue.showWords),showColors:v(_e.showColors,this.defaultValue.showColors),showFiles:v(_e.showFiles,this.defaultValue.showFiles),showReferences:v(_e.showReferences,this.defaultValue.showReferences),showFolders:v(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:v(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(_e.showSnippets,this.defaultValue.showSnippets),showUsers:v(_e.showUsers,this.defaultValue.showUsers),showIssues:v(_e.showIssues,this.defaultValue.showIssues)}}}class le extends n{constructor(){super(97,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ge extends A{constructor(){super(123,[75])}compute(Z,_e,Me){return _e.get(75)?!0:Z.tabFocusMode}}var De;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Le(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class pe extends A{constructor(){super(125,[124])}compute(Z,_e,Me){const He=_e.get(124);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",Ue="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:S.isMacintosh?Te:S.isLinux?Ue:Ce,fontWeight:"normal",fontSize:S.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(H){return e.editorOptionsRegistry[H.id]=H,H}var Ke;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingOvertype=6]="autoClosingOvertype",H[H.autoClosingQuotes=7]="autoClosingQuotes",H[H.autoIndent=8]="autoIndent",H[H.automaticLayout=9]="automaticLayout",H[H.autoSurround=10]="autoSurround",H[H.codeLens=11]="codeLens",H[H.codeLensFontFamily=12]="codeLensFontFamily",H[H.codeLensFontSize=13]="codeLensFontSize",H[H.colorDecorators=14]="colorDecorators",H[H.columnSelection=15]="columnSelection",H[H.comments=16]="comments",H[H.contextmenu=17]="contextmenu",H[H.copyWithSyntaxHighlighting=18]="copyWithSyntaxHighlighting",H[H.cursorBlinking=19]="cursorBlinking",H[H.cursorSmoothCaretAnimation=20]="cursorSmoothCaretAnimation",H[H.cursorStyle=21]="cursorStyle",H[H.cursorSurroundingLines=22]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=23]="cursorSurroundingLinesStyle",H[H.cursorWidth=24]="cursorWidth",H[H.disableLayerHinting=25]="disableLayerHinting",H[H.disableMonospaceOptimizations=26]="disableMonospaceOptimizations",H[H.dragAndDrop=27]="dragAndDrop",H[H.emptySelectionClipboard=28]="emptySelectionClipboard",H[H.extraEditorClassName=29]="extraEditorClassName",H[H.fastScrollSensitivity=30]="fastScrollSensitivity",H[H.find=31]="find",H[H.fixedOverflowWidgets=32]="fixedOverflowWidgets",H[H.folding=33]="folding",H[H.foldingStrategy=34]="foldingStrategy",H[H.foldingHighlight=35]="foldingHighlight",H[H.unfoldOnClickAfterEndOfLine=36]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=37]="fontFamily",H[H.fontInfo=38]="fontInfo",H[H.fontLigatures=39]="fontLigatures",H[H.fontSize=40]="fontSize",H[H.fontWeight=41]="fontWeight",H[H.formatOnPaste=42]="formatOnPaste",H[H.formatOnType=43]="formatOnType",H[H.glyphMargin=44]="glyphMargin",H[H.gotoLocation=45]="gotoLocation",H[H.hideCursorInOverviewRuler=46]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=47]="highlightActiveIndentGuide",H[H.hover=48]="hover",H[H.inDiffEditor=49]="inDiffEditor",H[H.letterSpacing=50]="letterSpacing",H[H.lightbulb=51]="lightbulb",H[H.lineDecorationsWidth=52]="lineDecorationsWidth",H[H.lineHeight=53]="lineHeight",H[H.lineNumbers=54]="lineNumbers",H[H.lineNumbersMinChars=55]="lineNumbersMinChars",H[H.linkedEditing=56]="linkedEditing",H[H.links=57]="links",H[H.matchBrackets=58]="matchBrackets",H[H.minimap=59]="minimap",H[H.mouseStyle=60]="mouseStyle",H[H.mouseWheelScrollSensitivity=61]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=62]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=63]="multiCursorMergeOverlapping",H[H.multiCursorModifier=64]="multiCursorModifier",H[H.multiCursorPaste=65]="multiCursorPaste",H[H.occurrencesHighlight=66]="occurrencesHighlight",H[H.overviewRulerBorder=67]="overviewRulerBorder",H[H.overviewRulerLanes=68]="overviewRulerLanes",H[H.padding=69]="padding",H[H.parameterHints=70]="parameterHints",H[H.peekWidgetDefaultFocus=71]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=72]="definitionLinkOpensInPeek",H[H.quickSuggestions=73]="quickSuggestions",H[H.quickSuggestionsDelay=74]="quickSuggestionsDelay",H[H.readOnly=75]="readOnly",H[H.renameOnType=76]="renameOnType",H[H.renderControlCharacters=77]="renderControlCharacters",H[H.renderIndentGuides=78]="renderIndentGuides",H[H.renderFinalNewline=79]="renderFinalNewline",H[H.renderLineHighlight=80]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=81]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=82]="renderValidationDecorations",H[H.renderWhitespace=83]="renderWhitespace",H[H.revealHorizontalRightPadding=84]="revealHorizontalRightPadding",H[H.roundedSelection=85]="roundedSelection",H[H.rulers=86]="rulers",H[H.scrollbar=87]="scrollbar",H[H.scrollBeyondLastColumn=88]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=89]="scrollBeyondLastLine",H[H.scrollPredominantAxis=90]="scrollPredominantAxis",H[H.selectionClipboard=91]="selectionClipboard",H[H.selectionHighlight=92]="selectionHighlight",H[H.selectOnLineNumbers=93]="selectOnLineNumbers",H[H.showFoldingControls=94]="showFoldingControls",H[H.showUnused=95]="showUnused",H[H.snippetSuggestions=96]="snippetSuggestions",H[H.smartSelect=97]="smartSelect",H[H.smoothScrolling=98]="smoothScrolling",H[H.stickyTabStops=99]="stickyTabStops",H[H.stopRenderingLineAfter=100]="stopRenderingLineAfter",H[H.suggest=101]="suggest",H[H.suggestFontSize=102]="suggestFontSize",H[H.suggestLineHeight=103]="suggestLineHeight",H[H.suggestOnTriggerCharacters=104]="suggestOnTriggerCharacters",H[H.suggestSelection=105]="suggestSelection",H[H.tabCompletion=106]="tabCompletion",H[H.tabIndex=107]="tabIndex",H[H.unusualLineTerminators=108]="unusualLineTerminators",H[H.useTabStops=109]="useTabStops",H[H.wordSeparators=110]="wordSeparators",H[H.wordWrap=111]="wordWrap",H[H.wordWrapBreakAfterCharacters=112]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=113]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=114]="wordWrapColumn",H[H.wordWrapOverride1=115]="wordWrapOverride1",H[H.wordWrapOverride2=116]="wordWrapOverride2",H[H.wrappingIndent=117]="wrappingIndent",H[H.wrappingStrategy=118]="wrappingStrategy",H[H.showDeprecated=119]="showDeprecated",H[H.inlineHints=120]="inlineHints",H[H.editorClassName=121]="editorClassName",H[H.pixelRatio=122]="pixelRatio",H[H.tabFocusMode=123]="tabFocusMode",H[H.layoutInfo=124]="layoutInfo",H[H.wrappingInfo=125]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:be(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:be(new a),accessibilityPageSize:be(new s(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null),deprecationMessage:_.localize(115,null)})),ariaLabel:be(new p(4,"ariaLabel",_.localize(116,null))),autoClosingBrackets:be(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(117,null),_.localize(118,null),""],description:_.localize(119,null)})),autoClosingOvertype:be(new b(6,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(120,null),""],description:_.localize(121,null)})),autoClosingQuotes:be(new b(7,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(122,null),_.localize(123,null),""],description:_.localize(124,null)})),autoIndent:be(new c(8,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[_.localize(125,null),_.localize(126,null),_.localize(127,null),_.localize(128,null),_.localize(129,null)],description:_.localize(130,null)})),automaticLayout:be(new d(9,"automaticLayout",!1)),autoSurround:be(new b(10,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(131,null),_.localize(132,null),_.localize(133,null),""],description:_.localize(134,null)})),stickyTabStops:be(new d(99,"stickyTabStops",!1,{description:_.localize(135,null)})),codeLens:be(new d(11,"codeLens",!0,{description:_.localize(136,null)})),codeLensFontFamily:be(new p(12,"codeLensFontFamily","",{description:_.localize(137,null)})),codeLensFontSize:be(new s(13,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(138,null)})),colorDecorators:be(new d(14,"colorDecorators",!0,{description:_.localize(139,null)})),columnSelection:be(new d(15,"columnSelection",!1,{description:_.localize(140,null)})),comments:be(new t),contextmenu:be(new d(17,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new d(18,"copyWithSyntaxHighlighting",!0,{description:_.localize(141,null)})),cursorBlinking:be(new c(19,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:_.localize(142,null)})),cursorSmoothCaretAnimation:be(new d(20,"cursorSmoothCaretAnimation",!1,{description:_.localize(143,null)})),cursorStyle:be(new c(21,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:_.localize(144,null)})),cursorSurroundingLines:be(new s(22,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(145,null)})),cursorSurroundingLinesStyle:be(new b(23,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(146,null),_.localize(147,null)],description:_.localize(148,null)})),cursorWidth:be(new s(24,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(149,null)})),disableLayerHinting:be(new d(25,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new d(26,"disableMonospaceOptimizations",!1)),dragAndDrop:be(new d(27,"dragAndDrop",!0,{description:_.localize(150,null)})),emptySelectionClipboard:be(new C),extraEditorClassName:be(new p(29,"extraEditorClassName","")),fastScrollSensitivity:be(new f(30,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:_.localize(151,null)})),find:be(new g),fixedOverflowWidgets:be(new d(32,"fixedOverflowWidgets",!1)),folding:be(new d(33,"folding",!0,{description:_.localize(152,null)})),foldingStrategy:be(new b(34,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(153,null),_.localize(154,null)],description:_.localize(155,null)})),foldingHighlight:be(new d(35,"foldingHighlight",!0,{description:_.localize(156,null)})),unfoldOnClickAfterEndOfLine:be(new d(36,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(157,null)})),fontFamily:be(new p(37,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(158,null)})),fontInfo:be(new R),fontLigatures2:be(new y),fontSize:be(new O),fontWeight:be(new x),formatOnPaste:be(new d(42,"formatOnPaste",!1,{description:_.localize(159,null)})),formatOnType:be(new d(43,"formatOnType",!1,{description:_.localize(160,null)})),glyphMargin:be(new d(44,"glyphMargin",!0,{description:_.localize(161,null)})),gotoLocation:be(new z),hideCursorInOverviewRuler:be(new d(46,"hideCursorInOverviewRuler",!1,{description:_.localize(162,null)})),highlightActiveIndentGuide:be(new d(47,"highlightActiveIndentGuide",!0,{description:_.localize(163,null)})),hover:be(new Q),inDiffEditor:be(new d(49,"inDiffEditor",!1)),letterSpacing:be(new f(50,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>f.clamp(H,-5,20),{description:_.localize(164,null)})),lightbulb:be(new L),lineDecorationsWidth:be(new I(52,"lineDecorationsWidth",10)),lineHeight:be(new W),lineNumbers:be(new Be),lineNumbersMinChars:be(new s(55,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new d(56,"linkedEditing",!1,{description:_.localize(165,null)})),links:be(new d(57,"links",!0,{description:_.localize(166,null)})),matchBrackets:be(new b(58,"matchBrackets","always",["always","near","never"],{description:_.localize(167,null)})),minimap:be(new K),mouseStyle:be(new b(60,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new f(61,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:_.localize(168,null)})),mouseWheelZoom:be(new d(62,"mouseWheelZoom",!1,{markdownDescription:_.localize(169,null)})),multiCursorMergeOverlapping:be(new d(63,"multiCursorMergeOverlapping",!0,{description:_.localize(170,null)})),multiCursorModifier:be(new c(64,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],U,{markdownEnumDescriptions:[_.localize(171,null),_.localize(172,null)],markdownDescription:_.localize(173,null)})),multiCursorPaste:be(new b(65,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(174,null),_.localize(175,null)],markdownDescription:_.localize(176,null)})),occurrencesHighlight:be(new d(66,"occurrencesHighlight",!0,{description:_.localize(177,null)})),overviewRulerBorder:be(new d(67,"overviewRulerBorder",!0,{description:_.localize(178,null)})),overviewRulerLanes:be(new s(68,"overviewRulerLanes",3,0,3)),padding:be(new ee),parameterHints:be(new ie),peekWidgetDefaultFocus:be(new b(71,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(179,null),_.localize(180,null)],description:_.localize(181,null)})),definitionLinkOpensInPeek:be(new d(72,"definitionLinkOpensInPeek",!1,{description:_.localize(182,null)})),quickSuggestions:be(new Se),quickSuggestionsDelay:be(new s(74,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(183,null)})),readOnly:be(new d(75,"readOnly",!1)),renameOnType:be(new d(76,"renameOnType",!1,{description:_.localize(184,null),markdownDeprecationMessage:_.localize(185,null)})),renderControlCharacters:be(new d(77,"renderControlCharacters",!1,{description:_.localize(186,null)})),renderIndentGuides:be(new d(78,"renderIndentGuides",!0,{description:_.localize(187,null)})),renderFinalNewline:be(new d(79,"renderFinalNewline",!0,{description:_.localize(188,null)})),renderLineHighlight:be(new b(80,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(189,null)],description:_.localize(190,null)})),renderLineHighlightOnlyWhenFocus:be(new d(81,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(191,null)})),renderValidationDecorations:be(new b(82,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new b(83,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(192,null),_.localize(193,null),_.localize(194,null),""],description:_.localize(195,null)})),revealHorizontalRightPadding:be(new s(84,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new d(85,"roundedSelection",!0,{description:_.localize(196,null)})),rulers:be(new xe),scrollbar:be(new q),scrollBeyondLastColumn:be(new s(88,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(197,null)})),scrollBeyondLastLine:be(new d(89,"scrollBeyondLastLine",!0,{description:_.localize(198,null)})),scrollPredominantAxis:be(new d(90,"scrollPredominantAxis",!0,{description:_.localize(199,null)})),selectionClipboard:be(new d(91,"selectionClipboard",!0,{description:_.localize(200,null),included:S.isLinux})),selectionHighlight:be(new d(92,"selectionHighlight",!0,{description:_.localize(201,null)})),selectOnLineNumbers:be(new d(93,"selectOnLineNumbers",!0)),showFoldingControls:be(new b(94,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(202,null),_.localize(203,null)],description:_.localize(204,null)})),showUnused:be(new d(95,"showUnused",!0,{description:_.localize(205,null)})),showDeprecated:be(new d(119,"showDeprecated",!0,{description:_.localize(206,null)})),inlineHints:be(new $),snippetSuggestions:be(new b(96,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(207,null),_.localize(208,null),_.localize(209,null),_.localize(210,null)],description:_.localize(211,null)})),smartSelect:be(new le),smoothScrolling:be(new d(98,"smoothScrolling",!1,{description:_.localize(212,null)})),stopRenderingLineAfter:be(new s(100,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new J),suggestFontSize:be(new s(102,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(213,null)})),suggestLineHeight:be(new s(103,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(214,null)})),suggestOnTriggerCharacters:be(new d(104,"suggestOnTriggerCharacters",!0,{description:_.localize(215,null)})),suggestSelection:be(new b(105,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(216,null),_.localize(217,null),_.localize(218,null)],description:_.localize(219,null)})),tabCompletion:be(new b(106,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(220,null),_.localize(221,null),_.localize(222,null)],description:_.localize(223,null)})),tabIndex:be(new s(107,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new b(108,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(224,null),_.localize(225,null),_.localize(226,null)],description:_.localize(227,null)})),useTabStops:be(new d(109,"useTabStops",!0,{description:_.localize(228,null)})),wordSeparators:be(new p(110,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:_.localize(229,null)})),wordWrap:be(new b(111,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(230,null),_.localize(231,null),_.localize(232,null),_.localize(233,null)],description:_.localize(234,null)})),wordWrapBreakAfterCharacters:be(new p(112,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new p(113,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new s(114,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(235,null)})),wordWrapOverride1:be(new b(115,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new b(116,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new c(117,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Le,{enumDescriptions:[_.localize(236,null),_.localize(237,null),_.localize(238,null),_.localize(239,null)],description:_.localize(240,null)})),wrappingStrategy:be(new b(118,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(241,null),_.localize(242,null)],description:_.localize(243,null)})),editorClassName:be(new D),pixelRatio:be(new se),tabFocusMode:be(new ge),layoutInfo:be(new Y),wrappingInfo:be(new pe)}}),define(we[121],Ee([17,18]),function(ae,e){return ae.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[122],Ee([17,18]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(we[123],Ee([17,18]),function(ae,e){return ae.create("vs/platform/markers/common/markers",e)}),define(we[124],Ee([17,18]),function(ae,e){return ae.create("vs/platform/theme/common/iconRegistry",e)}),define(we[125],Ee([17,18]),function(ae,e){return ae.create("vs/platform/workspaces/common/workspaces",e)}),define(we[126],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHost.api.impl",e)}),define(we[127],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[128],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(we[129],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[130],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostProgress",e)}),define(we[131],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[132],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[133],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[134],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[135],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/common/views",e)}),define(we[136],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[137],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[138],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[139],Ee([17,18]),function(ae,e){return ae.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[140],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var _;(function(E){E[E.ACTIVATE=0]="ACTIVATE",E[E.RESTORE=1]="RESTORE",E[E.PRESERVE=2]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var S;(function(E){E[E.PICK=1]="PICK",E[E.DISABLED=2]="DISABLED"})(S=e.EditorOverride||(e.EditorOverride={}));var T;(function(E){E[E.API=0]="API",E[E.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(E){E[E.Center=0]="Center",E[E.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",E[E.NearTop=2]="NearTop",E[E.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[86],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(P,E=[],k=!1){this.ctor=P,this.staticArguments=E,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=_;const S=(T,...P)=>new _(T,P);e.createSyncDescriptor=S}),define(we[61],Ee([0,1,86]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const S=[];function T(E,k,w){k instanceof _.SyncDescriptor||(k=new _.SyncDescriptor(k,[],w)),S.push([E,k])}e.registerSingleton=T;function P(){return S}e.getSingletonServiceDescriptors=P}),define(we[141],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=_;class S{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let E of this._nodes.values())E.outgoing.size===0&&P.push(E);return P}insertEdge(P,E){const k=this.lookupOrInsertNode(P),w=this.lookupOrInsertNode(E);k.outgoing.set(this._hashFn(E),w),w.incoming.set(this._hashFn(P),k)}removeNode(P){const E=this._hashFn(P);this._nodes.delete(E);for(let k of this._nodes.values())k.outgoing.delete(E),k.incoming.delete(E)}lookupOrInsertNode(P){const E=this._hashFn(P);let k=this._nodes.get(E);return k||(k=new _(P),this._nodes.set(E,k)),k}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[E,k]of this._nodes)P.push(`${E}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return P.join(`
`)}}e.Graph=S}),define(we[4],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function w(n){return n[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=w})(_=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function S(k,w,n,A){w[_.DI_TARGET]===w?w[_.DI_DEPENDENCIES].push({id:k,index:n,optional:A}):(w[_.DI_DEPENDENCIES]=[{id:k,index:n,optional:A}],w[_.DI_TARGET]=w)}function T(k){if(_.serviceIds.has(k))return _.serviceIds.get(k);const w=function(n,A,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");S(w,n,I,!1)};return w.toString=()=>k,_.serviceIds.set(k,w),w}e.createDecorator=T;function P(k){return k}e.refineServiceDecorator=P;function E(k){return function(w,n,A){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");S(k,w,A,!0)}}e.optional=E}),define(we[142],Ee([0,1,4]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,_.createDecorator)("modelService");function S(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=S}),define(we[143],Ee([0,1,3,55,6,22,78,59,142]),function(ae,e,_,S,T,P,E,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(v){return typeof v=="string"?!1:Array.isArray(v)?v.every(n):!!v.exclusive}class A{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(d,s){let f={selector:d,provider:s,_score:-1,_time:this._clock++};return this._entries.push(f),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(f){let p=this._entries.indexOf(f);p>=0&&(this._entries.splice(p,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),f=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const s=[];for(let f of this._entries)f._score>0&&s.push(f.provider);return s}ordered(d){const s=[];return this._orderedForEach(d,f=>s.push(f.provider)),s}orderedGroups(d){const s=[];let f,p;return this._orderedForEach(d,m=>{f&&p===m._score?f.push(m.provider):(p=m._score,f=[m.provider],s.push(f))}),s}_orderedForEach(d,s){if(!!d){this._updateScores(d);for(const f of this._entries)f._score>0&&s(f)}}_updateScores(d){let s={uri:d.uri.toString(),language:d.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===s.language&&this._lastCandidate.uri===s.uri)){this._lastCandidate=s;for(let f of this._entries)if(f._score=(0,k.score)(f.selector,d.uri,d.getLanguageIdentifier().language,(0,w.shouldSynchronizeModel)(d)),n(f.selector)&&f._score>0){for(let p of this._entries)p._score=0;f._score=1e3;break}this._entries.sort(A._compareByScoreAndTime)}}static _compareByScoreAndTime(d,s){return d._score<s._score?1:d._score>s._score?-1:d._time<s._time?1:d._time>s._time?-1:0}}e.LanguageFeatureRegistry=A;class I{constructor(d,s,f=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=s,this.max=f,this._cache=new P.LRUCache(50,.7)}_key(d){return d.id+(0,S.hash)(this._registry.all(d))}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const s=this._key(d),f=this._cache.get(s);return this._clamp(f==null?void 0:f.value)}update(d,s){const f=this._key(d);let p=this._cache.get(f);return p||(p=new E.MovingAverage,this._cache.set(f,p)),p.update(s),this.get(d)}}e.LanguageFeatureRequestDelays=I}),define(we[62],Ee([0,1,2,32,143,116,37]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class w{constructor(y,R){this.language=y,this.id=R}}e.LanguageIdentifier=w;var n;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var A;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(A=e.ColorId||(e.ColorId={}));var I;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var v;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(v=e.MetadataConsts||(e.MetadataConsts={}));class d{static getLanguageId(y){return(y&255)>>>0}static getTokenType(y){return(y&1792)>>>8}static getFontStyle(y){return(y&14336)>>>11}static getForeground(y){return(y&8372224)>>>14}static getBackground(y){return(y&4286578688)>>>23}static getClassNameFromMetadata(y){let R=this.getForeground(y),O="mtk"+R,x=this.getFontStyle(y);return x&1&&(O+=" mtki"),x&2&&(O+=" mtkb"),x&4&&(O+=" mtku"),O}static getInlineStyleFromMetadata(y,R){const O=this.getForeground(y),x=this.getFontStyle(y);let z=`color: ${R[O]};`;return x&1&&(z+="font-style: italic;"),x&2&&(z+="font-weight: bold;"),x&4&&(z+="text-decoration: underline;"),z}}e.TokenMetadata=d;var s;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(s=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(y){const R=g[y];let O=R&&E.iconRegistry.get(R);return O||(console.info("No codicon found for CompletionItemKind "+y),O=E.Codicon.symbolProperty),O.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(y,R){let O=g[y];return typeof O=="undefined"&&!R&&(O=9),O}}();var f;(function(g){g[g.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(g){g[g.Auto=1]="Auto",g[g.Manual=2]="Manual"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var c;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(c=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function a(g){return g&&_.URI.isUri(g.uri)&&S.Range.isIRange(g.range)&&(S.Range.isIRange(g.originSelectionRange)||S.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=a;var t;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var r;(function(g){g[g.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var o;(function(g){const y=new Map;y.set("file",0),y.set("module",1),y.set("namespace",2),y.set("package",3),y.set("class",4),y.set("method",5),y.set("property",6),y.set("field",7),y.set("constructor",8),y.set("enum",9),y.set("interface",10),y.set("function",11),y.set("variable",12),y.set("constant",13),y.set("string",14),y.set("number",15),y.set("boolean",16),y.set("array",17),y.set("object",18),y.set("key",19),y.set("null",20),y.set("enum-member",21),y.set("struct",22),y.set("event",23),y.set("operator",24),y.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function O(Q){return y.get(Q)}g.fromString=O;function x(Q){return R.get(Q)}g.toString=x;function z(Q,j){const Y=R.get(Q);let L=Y&&E.iconRegistry.get("symbol-"+Y);return L||(console.info("No codicon found for SymbolKind "+Q),L=E.Codicon.symbolProperty),`${j?"inline":"block"} ${L.classNames}`}g.toCssClassName=z})(o=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(y){this.value=y}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var i;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(i=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var D;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(D=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var C;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(C=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[144],Ee([0,1,6,12,4,3,46,53]),function(ae,e,_,S,T,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new P.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(w,n){if(!w)throw new Error("invalid command");if(typeof w=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:w,handler:n})}if(w.description){const s=[];for(let p of w.description.args)s.push(p.constraint);const f=w.handler;w.handler=function(p,...m){return(0,S.validateConstraints)(m,s),f(p,...m)}}const{id:A}=w;let I=this._commands.get(A);I||(I=new E.LinkedList,this._commands.set(A,I));let v=I.unshift(w),d=(0,_.toDisposable)(()=>{v();const s=this._commands.get(A);(s==null?void 0:s.isEmpty())&&this._commands.delete(A)});return this._onDidRegisterCommand.fire(A),d}registerCommandAlias(w,n){return e.CommandsRegistry.registerCommand(w,(A,...I)=>A.get(e.ICommandService).executeCommand(n,...I))}getCommand(w){const n=this._commands.get(w);if(!(!n||n.isEmpty()))return k.Iterable.first(n)}getCommands(){const w=new Map;for(const n of this._commands.keys()){const A=this.getCommand(n);A&&w.set(n,A)}return w}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(we[63],Ee([0,1,8,4,21]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=T.userAgent||"";const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",T.isMacintosh),E.set("isLinux",T.isLinux),E.set("isWindows",T.isWindows),E.set("isWeb",T.isWeb),E.set("isMacNative",T.isMacintosh&&!T.isWeb),E.set("isEdge",P.indexOf("Edg/")>=0),E.set("isFirefox",P.indexOf("Firefox")>=0),E.set("isChrome",P.indexOf("Chrome")>=0),E.set("isSafari",P.indexOf("Safari")>=0),E.set("isIPad",P.indexOf("iPad")>=0);const k=Object.prototype.hasOwnProperty;var w;(function(g){g[g.False=0]="False",g[g.True=1]="True",g[g.Defined=2]="Defined",g[g.Not=3]="Not",g[g.Equals=4]="Equals",g[g.NotEquals=5]="NotEquals",g[g.And=6]="And",g[g.Regex=7]="Regex",g[g.NotRegex=8]="NotRegex",g[g.Or=9]="Or",g[g.In=10]="In",g[g.NotIn=11]="NotIn",g[g.Greater=12]="Greater",g[g.GreaterEquals=13]="GreaterEquals",g[g.Smaller=14]="Smaller",g[g.SmallerEquals=15]="SmallerEquals"})(w=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return I.INSTANCE}static true(){return v.INSTANCE}static has(y){return d.create(y)}static equals(y,R){return s.create(y,R)}static notEquals(y,R){return m.create(y,R)}static regex(y,R){return r.create(y,R)}static in(y,R){return f.create(y,R)}static not(y){return b.create(y)}static and(...y){return l.create(y)}static or(...y){return i.create(y)}static greater(y,R){return c.create(y,R)}static less(y,R){return a.create(y,R)}static deserialize(y,R=!1){if(!!y)return this._deserializeOrExpression(y,R)}static _deserializeOrExpression(y,R){let O=y.split("||");return i.create(O.map(x=>this._deserializeAndExpression(x,R)))}static _deserializeAndExpression(y,R){let O=y.split("&&");return l.create(O.map(x=>this._deserializeOne(x,R)))}static _deserializeOne(y,R){if(y=y.trim(),y.indexOf("!=")>=0){let O=y.split("!=");return m.create(O[0].trim(),this._deserializeValue(O[1],R))}if(y.indexOf("==")>=0){let O=y.split("==");return s.create(O[0].trim(),this._deserializeValue(O[1],R))}if(y.indexOf("=~")>=0){let O=y.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],R))}if(y.indexOf(" in ")>=0){let O=y.split(" in ");return f.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const O=y.split(">=");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const O=y.split(">");return c.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const O=y.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const O=y.split("<");return a.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(y)?b.create(y.substr(1).trim()):d.create(y)}static _deserializeValue(y,R){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let O=/^'([^']*)'$/.exec(y);return O?O[1].trim():y}static _deserializeRegexValue(y,R){if((0,_.isFalsyOrWhitespace)(y)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=y.indexOf("/"),x=y.lastIndexOf("/");if(O===x||O<0){if(R)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let z=y.slice(O+1,x),Q=y[x+1]==="i"?"i":"";try{return new RegExp(z,Q)}catch(j){if(R)throw new Error(`bad regexp-value '${y}', parse error: ${j}`);return console.warn(`bad regexp-value '${y}', parse error: ${j}`),null}}}e.ContextKeyExpr=n;function A(g,y){return g.cmp(y)}class I{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class v{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class d{constructor(y){this.key=y,this.type=2}static create(y){const R=E.get(y);return typeof R=="boolean"?R?v.INSTANCE:I.INSTANCE:new d(y)}cmp(y){return y.type!==this.type?this.type-y.type:D(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=d;class s{constructor(y,R){this.key=y,this.value=R,this.type=4}static create(y,R){if(typeof R=="boolean")return R?d.create(y):b.create(y);const O=E.get(y);return typeof O=="boolean"?R===(O?"true":"false")?v.INSTANCE:I.INSTANCE:new s(y,R)}cmp(y){return y.type!==this.type?this.type-y.type:C(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyEqualsExpr=s;class f{constructor(y,R){this.key=y,this.valueKey=R,this.type=10}static create(y,R){return new f(y,R)}cmp(y){return y.type!==this.type?this.type-y.type:C(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}evaluate(y){const R=y.getValue(this.valueKey),O=y.getValue(this.key);return Array.isArray(R)?R.indexOf(O)>=0:typeof O=="string"&&typeof R=="object"&&R!==null?k.call(R,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=f;class p{constructor(y){this._actual=y,this.type=11}static create(y){return new p(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new p(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class m{constructor(y,R){this.key=y,this.value=R,this.type=5}static create(y,R){if(typeof R=="boolean")return R?b.create(y):d.create(y);const O=E.get(y);return typeof O=="boolean"?R===(O?"true":"false")?I.INSTANCE:v.INSTANCE:new m(y,R)}cmp(y){return y.type!==this.type?this.type-y.type:C(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=m;class b{constructor(y){this.key=y,this.type=3}static create(y){const R=E.get(y);return typeof R=="boolean"?R?I.INSTANCE:v.INSTANCE:new b(y)}cmp(y){return y.type!==this.type?this.type-y.type:D(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return d.create(this.key)}}e.ContextKeyNotExpr=b;class c{constructor(y,R){this.key=y,this.value=R,this.type=12}static create(y,R){return new c(y,R)}cmp(y){return y.type!==this.type?this.type-y.type:C(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return parseFloat(y.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class u{constructor(y,R){this.key=y,this.value=R,this.type=13}static create(y,R){return new u(y,R)}cmp(y){return y.type!==this.type?this.type-y.type:C(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return parseFloat(y.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class a{constructor(y,R){this.key=y,this.value=R,this.type=14}static create(y,R){return new a(y,R)}cmp(y){return y.type!==this.type?this.type-y.type:C(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return parseFloat(y.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=a;class t{constructor(y,R){this.key=y,this.value=R,this.type=15}static create(y,R){return new t(y,R)}cmp(y){return y.type!==this.type?this.type-y.type:C(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return parseFloat(y.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(y,R){this.key=y,this.regexp=R,this.type=7}static create(y,R){return new r(y,R)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const R=this.regexp?this.regexp.source:"",O=y.regexp?y.regexp.source:"";return R<O?-1:R>O?1:0}equals(y){if(y.type===this.type){const R=this.regexp?this.regexp.source:"",O=y.regexp?y.regexp.source:"";return this.key===y.key&&R===O}return!1}evaluate(y){let R=y.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=r;class o{constructor(y){this._actual=y,this.type=8}static create(y){return new o(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new o(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class l{constructor(y){this.expr=y,this.type=6}static create(y){return l._normalizeArr(y)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let R=0,O=this.expr.length;R<O;R++){const x=A(this.expr[R],y.expr[R]);if(x!==0)return x}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].equals(y.expr[R]))return!1;return!0}return!1}evaluate(y){for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].evaluate(y))return!1;return!0}static _normalizeArr(y){const R=[];let O=!1;for(const x of y)if(!!x){if(x.type===1){O=!0;continue}if(x.type===0)return I.INSTANCE;if(x.type===6){R.push(...x.expr);continue}R.push(x)}if(R.length===0&&O)return v.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(A);R.length>1;){const x=R[R.length-1];if(x.type!==9)break;R.pop();const z=R.pop(),Q=i.create(x.expr.map(j=>l.create([j,z])));Q&&(R.push(Q),R.sort(A))}return R.length===1?R[0]:new l(R)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let R of this.expr)y.push(...R.keys());return y}map(y){return new l(this.expr.map(R=>R.map(y)))}negate(){let y=[];for(let R of this.expr)y.push(R.negate());return i.create(y)}}e.ContextKeyAndExpr=l;class i{constructor(y){this.expr=y,this.type=9}static create(y){const R=i._normalizeArr(y);if(R.length!==0)return R.length===1?R[0]:new i(R)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let R=0,O=this.expr.length;R<O;R++){const x=A(this.expr[R],y.expr[R]);if(x!==0)return x}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].equals(y.expr[R]))return!1;return!0}return!1}evaluate(y){for(let R=0,O=this.expr.length;R<O;R++)if(this.expr[R].evaluate(y))return!0;return!1}static _normalizeArr(y){let R=[],O=!1;if(y){for(let x=0,z=y.length;x<z;x++){const Q=y[x];if(!!Q){if(Q.type===0){O=!0;continue}if(Q.type===1)return[v.INSTANCE];if(Q.type===9){R=R.concat(Q.expr);continue}R.push(Q)}}if(R.length===0&&O)return[I.INSTANCE];R.sort(A)}return R}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let R of this.expr)y.push(...R.keys());return y}map(y){return new i(this.expr.map(R=>R.map(y)))}negate(){let y=[];for(let O of this.expr)y.push(O.negate());const R=O=>O.type===9?O.expr:[O];for(;y.length>1;){const O=y.shift(),x=y.shift(),z=[];for(const Q of R(O))for(const j of R(x))z.push(n.and(Q,j));y.unshift(n.or(...z))}return y[0]}}e.ContextKeyOrExpr=i;class h extends d{constructor(y,R,O){super(y);this.key=y,this._defaultValue=R,typeof O=="object"?h._info.push(Object.assign(Object.assign({},O),{key:y})):O!==!0&&h._info.push({key:y,description:O,type:R!=null?typeof R:void 0})}static all(){return h._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(y){return n.equals(this.key,y)}notEqualsTo(y){return n.notEquals(this.key,y)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function D(g,y){return g<y?-1:g>y?1:0}function C(g,y,R,O){return g<R?-1:g>R?1:y<O?-1:y>O?1:0}}),define(we[145],Ee([0,1,4]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(we[25],Ee([0,1,8,4]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class E{constructor(A){this.value=A,this._lower=A.toLowerCase()}static equals(A,I){if(typeof A=="undefined"||A===null)return typeof I=="undefined"||I===null;if(typeof I=="undefined"||I===null)return!1;if(typeof A=="string"||typeof I=="string"){let v=typeof A=="string"?A:A.value,d=typeof I=="string"?I:I.value;return _.equalsIgnoreCase(v,d)}return A._lower===I._lower}static toKey(A){return typeof A=="string"?A.toLowerCase():A._lower}}e.ExtensionIdentifier=E;function k(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function w(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,S.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[146],Ee([0,1,8,25]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(d,s){return d.uuid&&s.uuid?d.uuid===s.uuid:d.id===s.id?!0:(0,_.compareIgnoreCase)(d.id,s.id)===0}e.areSameExtensions=T;class P{constructor(s,f){this.version=f,this.id=s.id,this.uuid=s.uuid}key(){return`${this.id}-${this.version}`}equals(s){return s instanceof P?T(this,s)&&this.version===s.version:!1}}e.ExtensionIdentifierWithVersion=P;function E(d,s){return`${d}.${s}`}e.getExtensionId=E;function k(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function w(d,s){return k(E(d,s))}e.getGalleryExtensionId=w;function n(d,s){const f=[],p=m=>{for(const b of f)if(b.some(c=>T(s(c),s(m))))return b;return null};for(const m of d){const b=p(m);b?b.push(m):f.push([m])}return f}e.groupByExtension=n;function A(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=A;function I(d){return Object.assign({id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0)},d.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function v(d){const s=new Set;for(const f of d)f.malicious&&s.add(f.id.id);return s}e.getMaliciousExtensionsSet=v}),define(we[64],Ee([0,1,122,11,2,4,8,12,22]),function(ae,e,_,S,T,P,E,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");var n;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var A;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash"})(A=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function I(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=I;function v(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=v;function d(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function s(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=s;var f;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(Q,j){super(Q);this.code=j}}e.FileSystemProviderError=p;function m(z,Q){const j=new p(z.toString(),Q);return c(j,Q),j}e.createFileSystemProviderError=m;function b(z){return z||m((0,_.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=b;function c(z,Q){return z.name=Q?`${Q} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=c;function u(z){if(!z)return f.Unknown;if(z instanceof p)return z.code;const Q=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!Q)return f.Unknown;switch(Q[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=u;function a(z){if(z instanceof h)return z.fileOperationResult;switch(u(z)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var t;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class r{constructor(Q,j,Y){this.resource=Q,this.operation=j,this.target=Y}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=r;var o;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(Q,j){this.ignorePathCasing=j,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=Q;for(const Y of Q)switch(Y.type){case 1:this.added||(this.added=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(Y.resource,Y);break;case 0:this.updated||(this.updated=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(Y.resource,Y);break;case 2:this.deleted||(this.deleted=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(Y.resource,Y);break}}contains(Q,...j){return this.doContains(Q,{includeChildren:!1},...j)}affects(Q,...j){return this.doContains(Q,{includeChildren:!0},...j)}doContains(Q,j,...Y){var L,$,W,K,U,ee;if(!Q)return!1;const ie=Y.length>0;return!!((!ie||Y.includes(1))&&(((L=this.added)===null||L===void 0?void 0:L.get(Q))||j.includeChildren&&(($=this.added)===null||$===void 0?void 0:$.findSuperstr(Q)))||(!ie||Y.includes(0))&&(((W=this.updated)===null||W===void 0?void 0:W.get(Q))||j.includeChildren&&((K=this.updated)===null||K===void 0?void 0:K.findSuperstr(Q)))||(!ie||Y.includes(2))&&(((U=this.deleted)===null||U===void 0?void 0:U.findSubstr(Q))||j.includeChildren&&((ee=this.deleted)===null||ee===void 0?void 0:ee.findSuperstr(Q))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(Q){const j=[],Y=Q===1?this.added:Q===0?this.updated:this.deleted;if(Y)for(const[,L]of Y)j.push(L);return j}filter(Q){return new l(this.changes.filter(j=>Q(j)),this.ignorePathCasing)}}e.FileChangesEvent=l;function i(z,Q,j){return!z||!Q||z===Q||Q.length>z.length?!1:(Q.charAt(Q.length-1)!==S.sep&&(Q+=S.sep),j?(0,E.startsWithIgnoreCase)(z,Q):z.indexOf(Q)===0)}e.isParent=i;class h extends Error{constructor(Q,j,Y){super(Q);this.fileOperationResult=j,this.options=Y}static isFileOperationError(Q){return Q instanceof Error&&!(0,k.isUndefinedOrNull)(Q.fileOperationResult)}}e.FileOperationError=h;var D;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_READ_ONLY=5]="FILE_READ_ONLY",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(D=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var C;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(C=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function g(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=g;async function y(z,Q){if(!Q.canHandleResource(T.URI.from({scheme:z.scheme})))return new Promise(j=>{const Y=Q.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===z.scheme&&L.added&&(Y.dispose(),j())})})}e.whenProviderRegistered=y,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class R{static formatSize(Q){return(0,k.isNumber)(Q)||(Q=0),Q<R.KB?(0,_.localize)(1,null,Q.toFixed(0)):Q<R.MB?(0,_.localize)(2,null,(Q/R.KB).toFixed(2)):Q<R.GB?(0,_.localize)(3,null,(Q/R.MB).toFixed(2)):Q<R.TB?(0,_.localize)(4,null,(Q/R.GB).toFixed(2)):(0,_.localize)(5,null,(Q/R.TB).toFixed(2))}}e.ByteSize=R,R.KB=1024,R.MB=R.KB*R.KB,R.GB=R.MB*R.KB,R.TB=R.GB*R.KB;var O;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function x(z){return{maxFileSize:z===0?300*R.MB:16*R.GB,maxHeapSize:z===0?700*R.MB:2*700*R.MB}}e.getPlatformLimits=x}),define(we[65],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...T){this._entries=new Map;for(let[P,E]of T)this.set(P,E)}set(T,P){const E=this._entries.get(T);return this._entries.set(T,P),E}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=_}),define(we[147],Ee([0,1,10,141,86,4,65,13]),function(ae,e,_,S,T,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class n extends Error{constructor(s){super("cyclic dependency between services");this.message=s.toString()}}class A{constructor(s=new E.ServiceCollection,f=!1,p){this._activeInstantiations=new Set,this._services=s,this._strict=f,this._parent=p,this._services.set(P.IInstantiationService,this)}createChild(s){return new A(s,this._strict,this)}invokeFunction(s,...f){let p=v.traceInvocation(s),m=!1;try{return s({get:(c,u)=>{if(m)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(c,p);if(!a&&u!==P.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return a}},...f)}finally{m=!0,p.stop()}}createInstance(s,...f){let p,m;return s instanceof T.SyncDescriptor?(p=v.traceCreation(s.ctor),m=this._createInstance(s.ctor,s.staticArguments.concat(f),p)):(p=v.traceCreation(s),m=this._createInstance(s,f,p)),p.stop(),m}_createInstance(s,f=[],p){let m=P._util.getServiceDependencies(s).sort((u,a)=>u.index-a.index),b=[];for(const u of m){let a=this._getOrCreateServiceInstance(u.id,p);if(!a&&this._strict&&!u.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${u.id}.`);b.push(a)}let c=m.length>0?m[0].index:f.length;if(f.length!==c){console.warn(`[createInstance] First service dependency of ${s.name} at position ${c+1} conflicts with ${f.length} static arguments`);let u=c-f.length;u>0?f=f.concat(new Array(u)):f=f.slice(0,c)}return new s(...[...f,...b])}_setServiceInstance(s,f){if(this._services.get(s)instanceof T.SyncDescriptor)this._services.set(s,f);else if(this._parent)this._parent._setServiceInstance(s,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let f=this._services.get(s);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):f}_getOrCreateServiceInstance(s,f){let p=this._getServiceInstanceOrDescriptor(s);return p instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,p,f.branch(s,!0)):(f.branch(s,!1),p)}_safeCreateAndCacheServiceInstance(s,f,p){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,f,p)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,f,p){const m=new S.Graph(u=>u.id.toString());let b=0;const c=[{id:s,desc:f,_trace:p}];for(;c.length;){const u=c.pop();if(m.lookupOrInsertNode(u),b++>1e3)throw new n(m);for(let a of P._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${s} depends on ${a.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const r={id:a.id,desc:t,_trace:u._trace.branch(a.id,!0)};m.insertEdge(u,r),c.push(r)}}}for(;;){const u=m.roots();if(u.length===0){if(!m.isEmpty())throw new n(m);break}for(const{data:a}of u){if(this._getServiceInstanceOrDescriptor(a.id)instanceof T.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}m.removeNode(a)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,f,p=[],m,b){if(this._services.get(s)instanceof T.SyncDescriptor)return this._createServiceInstance(f,p,m,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,f,p,m,b);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(s,f=[],p,m){if(p){const b=new k.IdleValue(()=>this._createInstance(s,f,m));return new Proxy(Object.create(null),{get(c,u){if(u in c)return c[u];let a=b.value,t=a[u];return typeof t!="function"||(t=t.bind(a),c[u]=t),t},set(c,u,a){return b.value[u]=a,!0}})}else return this._createInstance(s,f,m)}}e.InstantiationService=A;var I;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(I||(I={}));class v{constructor(s,f){this.type=s,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return w?new v(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(s){return w?new v(0,s.name):v._None}branch(s,f){let p=new v(2,s.toString());return this._dep.push([s,f,p]),p}stop(){let s=Date.now()-this._start;v._totals+=s;let f=!1;function p(b,c){let u=[],a=new Array(b+1).join("	");for(const[t,r,o]of c._dep)if(r&&o){f=!0,u.push(`${a}CREATES -> ${t}`);let l=p(b+1,o);l&&u.push(l)}else u.push(`${a}uses -> ${t}`);return u.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(s>2||f)&&console.log(m.join(`
`))}}v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(we[19],Ee([0,1,4,6,21,3,60]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function k(){return new Date().toISOString()}var w;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class n extends S.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class A extends n{constructor(a){super();this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...t){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([a,...t]))}debug(a,...t){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([a,...t]))}info(a,...t){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([a,...t]))}warn(a,...t){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([a,...t]))}error(a,...t){if(this.checkLogLevel(w.Error))if(a instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=a.stack,this.log(w.Error,this.format(r))}else this.log(w.Error,this.format([a,...t]))}critical(a,...t){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([a,...t]))}flush(){}format(a){let t="";for(let r=0;r<a.length;r++){let o=a[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch(l){}t+=(r>0?" ":"")+o}return t}}e.AbstractMessageLogger=A;class I extends n{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a),this.useColors=!T.isWindows}trace(a,...t){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,a,...t):console.log(`[main ${k()}]`,a,...t))}debug(a,...t){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,a,...t):console.log(`[main ${k()}]`,a,...t))}info(a,...t){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,a,...t):console.log(`[main ${k()}]`,a,...t))}warn(a,...t){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,a,...t):console.warn(`[main ${k()}]`,a,...t))}error(a,...t){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,a,...t):console.error(`[main ${k()}]`,a,...t))}critical(a,...t){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,a,...t):console.error(`[main ${k()}]`,a,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class v extends n{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a)}trace(a,...t){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",a,...t)}debug(a,...t){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...t)}info(a,...t){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",a,...t)}warn(a,...t){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",a,...t)}error(a,...t){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",a,...t)}critical(a,...t){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...t)}dispose(){}flush(){}}e.ConsoleLogger=v;class d extends n{constructor(a,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=a,this.setLevel(t)}trace(a,...t){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(a),...t])}debug(a,...t){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(a),...t])}info(a,...t){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(a),...t])}warn(a,...t){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(a),...t])}error(a,...t){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(a),...t])}critical(a,...t){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(a),...t])}extractMessage(a){return typeof a=="string"?a:(0,E.toErrorMessage)(a,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class s extends n{constructor(a){super();this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const t of this.logServices)t.setLevel(a);super.setLevel(a)}trace(a,...t){for(const r of this.logServices)r.trace(a,...t)}debug(a,...t){for(const r of this.logServices)r.debug(a,...t)}info(a,...t){for(const r of this.logServices)r.info(a,...t)}warn(a,...t){for(const r of this.logServices)r.warn(a,...t)}error(a,...t){for(const r of this.logServices)r.error(a,...t)}critical(a,...t){for(const r of this.logServices)r.critical(a,...t)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=s;class f extends S.Disposable{constructor(a){super();this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...t){this.logger.trace(a,...t)}debug(a,...t){this.logger.debug(a,...t)}info(a,...t){this.logger.info(a,...t)}warn(a,...t){this.logger.warn(a,...t)}error(a,...t){this.logger.error(a,...t)}critical(a,...t){this.logger.critical(a,...t)}flush(){this.logger.flush()}}e.LogService=f;class p{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(a){}getLevel(){return w.Info}trace(a,...t){}debug(a,...t){}info(a,...t){}warn(a,...t){}error(a,...t){}critical(a,...t){}dispose(){}flush(){}}e.NullLogService=p;function m(u){if(u.verbose)return w.Trace;if(typeof u.logLevel=="string"){const a=b(u.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=m;function b(u){switch(u){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=b;function c(u){switch(u){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=c}),define(we[87],Ee([0,1,4,123,56]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var E;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(E=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function n(s,f){return f-s}w.compare=n;const A=Object.create(null);A[w.Error]=(0,S.localize)(0,null),A[w.Warning]=(0,S.localize)(1,null),A[w.Info]=(0,S.localize)(2,null);function I(s){return A[s]||""}w.toString=I;function v(s){switch(s){case T.default.Error:return w.Error;case T.default.Warning:return w.Warning;case T.default.Info:return w.Info;case T.default.Ignore:return w.Hint}}w.fromSeverity=v;function d(s){switch(s){case w.Error:return T.default.Error;case w.Warning:return T.default.Warning;case w.Info:return T.default.Info;case w.Hint:return T.default.Ignore}}w.toSeverity=d}(E=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(w){const n="";function A(v){return I(v,!0)}w.makeKey=A;function I(v,d){let s=[n];return v.source?s.push(v.source.replace("\xA6","\\\xA6")):s.push(n),v.code?typeof v.code=="string"?s.push(v.code.replace("\xA6","\\\xA6")):s.push(v.code.value.replace("\xA6","\\\xA6")):s.push(n),v.severity!==void 0&&v.severity!==null?s.push(E.toString(v.severity)):s.push(n),v.message&&d?s.push(v.message.replace("\xA6","\\\xA6")):s.push(n),v.startLineNumber!==void 0&&v.startLineNumber!==null?s.push(v.startLineNumber.toString()):s.push(n),v.startColumn!==void 0&&v.startColumn!==null?s.push(v.startColumn.toString()):s.push(n),v.endLineNumber!==void 0&&v.endLineNumber!==null?s.push(v.endLineNumber.toString()):s.push(n),v.endColumn!==void 0&&v.endColumn!==null?s.push(v.endColumn.toString()):s.push(n),s.push(n),s.join("\xA6")}w.makeKeyOptionalMessage=I})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(we[148],Ee([0,1,56,4,3]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,S.createDecorator)("notificationService");var P;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var E;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(E=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new w,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=k;class w{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=w});var je=this&&this.__decorate||function(ae,e,_,S){var T=arguments.length,P=T<3?e:S===null?S=Object.getOwnPropertyDescriptor(e,_):S,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(ae,e,_,S);else for(var k=ae.length-1;k>=0;k--)(E=ae[k])&&(P=(T<3?E(P):T>3?E(e,_,P):E(e,_))||P);return T>3&&P&&Object.defineProperty(e,_,P),P},qe=this&&this.__param||function(ae,e){return function(_,S){e(_,S,ae)}};define(we[149],Ee([0,1,4,20,6,13]),function(ae,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var E;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(E=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let w=class extends T.Disposable{constructor(I,v){super();this.deferred=new P.DeferredPromise,v.withProgress(I,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};w=je([qe(1,e.IProgressService)],w),e.UnmanagedProgress=w;class n extends T.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(I){this.stop();const v=++this.currentOperationId,d=new S.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{v===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:v,token:d.token,stop:()=>this.doStop(v),isCurrent:()=>this.currentOperationId===v}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(we[30],Ee([0,1,12,43]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(E,k){S.ok(_.isString(E)),S.ok(_.isObject(k)),S.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,k)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new T}),define(we[88],Ee([0,1,30,3]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class P{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,n){this.schemasById[T(w)]=n,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new P;_.Registry.add(e.Extensions.JSONContribution,E)}),define(we[66],Ee([0,1,121,3,30,12,88]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=T.Registry.as(E.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new S.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new S.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,b=!0){this.registerConfigurations([m],b)}registerConfigurations(m,b=!0){const c=[];m.forEach(u=>{c.push(...this.validateAndRegisterProperties(u,b)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(m){const b=[],c=u=>{if(u.properties)for(const a in u.properties)b.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,u.properties[a]);u.allOf&&u.allOf.forEach(a=>c(a))};for(const u of m){c(u);const a=this.configurationContributors.indexOf(u);a!==-1&&this.configurationContributors.splice(a,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(m){const b=[],c=[];for(const u of m)for(const a in u)if(b.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]=Object.assign(Object.assign({},this.defaultValues[a]||{}),u[a]);const t={type:"object",default:this.defaultValues[a],description:_.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};c.push(I(a)),this.configurationProperties[a]=t,this.defaultLanguageConfigurationOverridesNode.properties[a]=t}else{this.defaultValues[a]=u[a];const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(m){const b=[];for(const c of m)for(const u in c)if(b.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const a=this.configurationProperties[u];a&&(this.updatePropertyDefaultValue(u,a),this.updateSchema(u,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const b of m)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,b=!0,c=3){c=P.isUndefinedOrNull(m.scope)?c:m.scope;let u=[],a=m.properties;if(a)for(let r in a){if(b&&s(r)){delete a[r];continue}const o=a[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:o.scope=P.isUndefinedOrNull(o.scope)?c:o.scope,a[r].hasOwnProperty("included")&&!a[r].included){this.excludedConfigurationProperties[r]=a[r],delete a[r];continue}else this.configurationProperties[r]=a[r];!a[r].deprecationMessage&&a[r].markdownDeprecationMessage&&(a[r].deprecationMessage=a[r].markdownDeprecationMessage),u.push(r)}let t=m.allOf;if(t)for(let r of t)u.push(...this.validateAndRegisterProperties(r,b,c));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const b=c=>{let u=c.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let a=c.allOf;a&&a.forEach(b)};b(m)}updateSchema(m,b){switch(e.allSettings.properties[m]=b,b.scope){case 1:e.applicationSettings.properties[m]=b;break;case 2:e.machineSettings.properties[m]=b;break;case 6:e.machineOverridableSettings.properties[m]=b;break;case 3:e.windowSettings.properties[m]=b;break;case 4:e.resourceSettings.properties[m]=b;break;case 5:e.resourceSettings.properties[m]=b,this.resourceLanguageSettingsSchema.properties[m]=b;break}}removeFromSchema(m,b){switch(delete e.allSettings.properties[m],b.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const b=`[${m}]`,c={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,c),e.allSettings.properties[b]=c,e.applicationSettings.properties[b]=c,e.machineSettings.properties[b]=c,e.machineOverridableSettings.properties[b]=c,e.windowSettings.properties[b]=c,e.resourceSettings.properties[b]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,b){let c=this.defaultValues[m];P.isUndefined(c)&&(c=b.default),P.isUndefined(c)&&(c=v(b.type)),b.default=c}}const A="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(A);function I(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=I;function v(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const d=new n;T.Registry.add(e.Extensions.Configuration,d);function s(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?_.localize(5,null,p):d.getConfigurationProperties()[p]!==void 0?_.localize(6,null,p):null:_.localize(4,null)}e.validateProperty=s;function f(){const p=[],m=d.getConfigurationProperties();for(const b of Object.keys(m))p.push([b,m[b].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=f}),define(we[89],Ee([0,1,23,12,2,30,4,66]),function(ae,e,_,S,T,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function w(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof T.URI)}e.isConfigurationOverrides=w;var n;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function A(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=A;function I(r,o){const l=o?r?o.keys.filter(R=>r.keys.indexOf(R)===-1):[...o.keys]:[],i=r?o?r.keys.filter(R=>o.keys.indexOf(R)===-1):[...r.keys]:[],h=[];if(o&&r){for(const R of r.keys)if(o.keys.indexOf(R)!==-1){const O=m(r.contents,R),x=m(o.contents,R);_.equals(O,x)||h.push(R)}}const D=[],C=R=>{const O={};for(const x of R)for(const z of x.identifiers)O[a(z)]=x;return O},g=o?C(o.overrides):{},y=r?C(r.overrides):{};if(Object.keys(g).length)for(const R of l){const O=g[R];O&&D.push([(0,k.overrideIdentifierFromKey)(R),O.keys])}if(Object.keys(y).length)for(const R of i){const O=y[R];O&&D.push([(0,k.overrideIdentifierFromKey)(R),O.keys])}if(Object.keys(g).length&&Object.keys(y).length)for(const R of h){const O=y[R],x=g[R];if(O&&x){const z=I({contents:O.contents,keys:O.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});D.push([(0,k.overrideIdentifierFromKey)(R),[...z.added,...z.removed,...z.updated]])}}return{added:l,removed:i,updated:h,overrides:D}}e.compare=I;function v(r,o){const l=[];for(const i of Object.keys(r))if(k.OVERRIDE_PROPERTY_PATTERN.test(i)){const h={};for(const D in r[i])h[D]=r[i][D];l.push({identifiers:[(0,k.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(h),contents:d(h,o)})}return l}e.toOverrides=v;function d(r,o){const l=Object.create(null);for(let i in r)s(l,i,r[i],o);return l}e.toValuesTree=d;function s(r,o,l,i){const h=o.split("."),D=h.pop();let C=r;for(let g=0;g<h.length;g++){let y=h[g],R=C[y];switch(typeof R){case"undefined":R=C[y]=Object.create(null);break;case"object":break;default:i(`Ignoring ${o} as ${h.slice(0,g+1).join(".")} is ${JSON.stringify(R)}`);return}C=R}if(typeof C=="object"&&C!==null)try{C[D]=l}catch(g){i(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(C)}`)}else i(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(C)}`)}e.addToValueTree=s;function f(r,o){const l=o.split(".");p(r,l)}e.removeFromValueTree=f;function p(r,o){const l=o.shift();if(o.length===0){delete r[l];return}if(Object.keys(r).indexOf(l)!==-1){const i=r[l];typeof i=="object"&&!Array.isArray(i)&&(p(i,o),Object.keys(i).length===0&&delete r[l])}}function m(r,o,l){function i(C,g){let y=C;for(const R of g){if(typeof y!="object"||y===null)return;y=y[R]}return y}const h=o.split("."),D=i(r,h);return typeof D=="undefined"?l:D}e.getConfigurationValue=m;function b(r,o,l){Object.keys(o).forEach(i=>{i!=="__proto__"&&(i in r?S.isObject(r[i])&&S.isObject(o[i])?b(r[i],o[i],l):l&&(r[i]=o[i]):r[i]=o[i])})}e.merge=b;function c(){const r=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=c;function u(){const r=Object.create(null),o=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let l in o){let i=o[l].default;s(r,l,i,h=>console.error(`Conflict in default settings: ${h}`))}return r}e.getDefaultValues=u;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,o,l){const i=r.inspect(o),h=r.inspect(l);return typeof i.userValue!="undefined"||typeof i.workspaceValue!="undefined"||typeof i.workspaceFolderValue!="undefined"?i.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:i.defaultValue}e.getMigratedSettingValue=t}),define(we[150],Ee([0,1,45,22,15,12,23,2,66,89,30,6,3]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(t={},r=[],o=[]){this._contents=t,this._keys=r,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const o=this.getContentsForOverrideIdentifer(r);return o?t?(0,n.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let o={};for(const l of T.distinct([...Object.keys(this.contents),...Object.keys(r)])){let i=this.contents[l],h=r[l];h&&(typeof i=="object"&&typeof h=="object"?(i=E.deepClone(i),this.mergeContents(i,h)):i=h),o[l]=i}return new d(o,this.keys,this.overrides)}merge(...t){const r=E.deepClone(this.contents),o=E.deepClone(this.overrides),l=[...this.keys];for(const i of t){this.mergeContents(r,i.contents);for(const h of i.overrides){const[D]=o.filter(C=>T.equals(C.identifiers,h.identifiers));D?this.mergeContents(D.contents,h.contents):o.push(E.deepClone(h))}for(const h of i.keys)l.indexOf(h)===-1&&l.push(h)}return new d(r,l,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const o of Object.keys(r)){if(o in t&&P.isObject(t[o])&&P.isObject(r[o])){this.mergeContents(t[o],r[o]);continue}t[o]=E.deepClone(r[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let o=0;o<r;o++)t.indexOf(this.keys[o])===0&&(r=o);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=d;class s extends d{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),o=[];for(const l of Object.keys(t))w.OVERRIDE_PROPERTY_PATTERN.test(l)&&o.push({identifiers:[(0,w.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(t[l]),contents:(0,n.toValuesTree)(t[l],i=>console.error(`Conflict in default settings file: ${i}`))});super(t,r,o)}}e.DefaultConfigurationModel=s;class f{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get errors(){return this._parseErrors}parseContent(t){if(!P.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new d(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},o=null,l=[],i=[],h=[];function D(g){Array.isArray(l)?l.push(g):o&&(l[o]=g)}let C={onObjectBegin:()=>{let g={};D(g),i.push(l),l=g,o=null},onObjectProperty:g=>{o=g},onObjectEnd:()=>{l=i.pop()},onArrayBegin:()=>{let g=[];D(g),i.push(l),l=g,o=null},onArrayEnd:()=>{l=i.pop()},onLiteralValue:D,onError:(g,y,R)=>{h.push({error:g,offset:y,length:R})}};if(t)try{_.visit(t,C),r=l[0]||{}}catch(g){console.error(`Error while parsing settings file ${this._name}: ${g}`),this._parseErrors=[g]}return r}doParseRaw(t){if(this._scopes){const i=A.Registry.as(w.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,i,!0,this._scopes)}const r=(0,n.toValuesTree)(t,i=>console.error(`Conflict in settings file ${this._name}: ${i}`)),o=Object.keys(t),l=(0,n.toOverrides)(t,i=>console.error(`Conflict in settings file ${this._name}: ${i}`));return{contents:r,keys:o,overrides:l}}filterByScope(t,r,o,l){const i={};for(let h in t)if(w.OVERRIDE_PROPERTY_PATTERN.test(h)&&o)i[h]=this.filterByScope(t[h],r,!1,l);else{const D=this.getScope(h,r);(D===void 0||l.indexOf(D)!==-1)&&(i[h]=t[h])}return i}getScope(t,r){const o=r[t];return o?typeof o.scope!="undefined"?o.scope:3:void 0}}e.ConfigurationModelParser=f;class p extends I.Disposable{constructor(t,r,o,l){super();this.userSettingsResource=t,this.scopes=r,this.fileService=l,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(v.Event.filter(this.fileService.onDidFilesChange,i=>i.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new d}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=p;class m{constructor(t,r,o=new d,l=new d,i=new S.ResourceMap,h=new d,D=new S.ResourceMap,C=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=l,this._folderConfigurations=i,this._memoryConfiguration=h,this._memoryConfigurationByResource=D,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new S.ResourceMap,this._userConfiguration=null}getValue(t,r,o){return this.getConsolidateConfigurationModel(r,o).getValue(t)}updateValue(t,r,o={}){let l;o.resource?(l=this._memoryConfigurationByResource.get(o.resource),l||(l=new d,this._memoryConfigurationByResource.set(o.resource,l))):l=this._memoryConfiguration,r===void 0?l.removeValue(t):l.setValue(t,r),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,o){const l=this.getConsolidateConfigurationModel(r,o),i=this.getFolderConfigurationModelForResource(r.resource,o),h=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,D=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),C=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),g=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),y=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=o?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=i?r.overrideIdentifier?i.freeze().override(r.overrideIdentifier).getValue(t):i.freeze().getValue(t):void 0,x=r.overrideIdentifier?h.override(r.overrideIdentifier).getValue(t):h.getValue(t),z=l.getValue(t),Q=T.distinct(T.flatten(l.overrides.map(j=>j.identifiers))).filter(j=>l.getOverrideValue(t,j)!==void 0);return{defaultValue:D,userValue:C,userLocalValue:g,userRemoteValue:y,workspaceValue:R,workspaceFolderValue:O,memoryValue:x,value:z,default:D!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:g!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:y!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:i==null?void 0:i.freeze().getValue(t),override:r.overrideIdentifier?i==null?void 0:i.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:h.getValue(t),override:r.overrideIdentifier?h.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Q.length?Q:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const o=r.filter(l=>w.OVERRIDE_PROPERTY_PATTERN.test(l)).map(l=>{const i=(0,w.overrideIdentifierFromKey)(l),h=this._defaultConfiguration.getKeysForOverrideIdentifier(i),D=t.getKeysForOverrideIdentifier(i),C=[...D.filter(g=>h.indexOf(g)===-1),...h.filter(g=>D.indexOf(g)===-1),...h.filter(g=>!E.equals(this._defaultConfiguration.override(i).getValue(g),t.override(i).getValue(g)))];return[i,C]});return this.updateDefaultConfiguration(t),{keys:r,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:o,removed:l,overrides:i}=(0,n.compare)(this.localUserConfiguration,t),h=[...r,...o,...l];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:i}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:o,removed:l,overrides:i}=(0,n.compare)(this.remoteUserConfiguration,t);let h=[...r,...o,...l];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:i}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:o,removed:l,overrides:i}=(0,n.compare)(this.workspaceConfiguration,t);let h=[...r,...o,...l];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:i}}compareAndUpdateFolderConfiguration(t,r){const o=this.folderConfigurations.get(t),{added:l,updated:i,removed:h,overrides:D}=(0,n.compare)(o,r);let C=[...l,...i,...h];return(C.length||!o)&&this.updateFolderConfiguration(t,r),{keys:C,overrides:D}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:l,removed:i,overrides:h}=(0,n.compare)(r,void 0);return{keys:[...o,...l,...i],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let o=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},r){let o=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const l=r.getFolder(t);l&&(o=this.getFolderConsolidatedConfiguration(l.uri)||o);const i=this._memoryConfigurationByResource.get(t);i&&(o=o.merge(i))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const o=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(t);l?(r=o.merge(l),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=o}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const o=r.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:o,overrides:l,keys:i}=this._folderConfigurations.get(r);return t.push([r,{contents:o,overrides:l,keys:i}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(l=>r.add(l))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),l=this.parseConfigurationModel(t.workspace),i=t.folders.reduce((h,D)=>(h.set(k.URI.revive(D[0]),this.parseConfigurationModel(D[1])),h),new S.ResourceMap);return new m(r,o,new d,l,i,new d,new S.ResourceMap,!1)}static parseConfigurationModel(t){return new d(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function b(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const l of a)l.keys.forEach(i=>t.add(i)),l.overrides.forEach(([i,h])=>{const D=(0,S.getOrSet)(r,i,new Set);h.forEach(C=>D.add(C))});const o=[];return r.forEach((l,i)=>o.push([i,[...l.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=b;class c{constructor(t,r,o,l){this.change=t,this.previous=r,this.currentConfiguraiton=o,this.currentWorkspace=l,this._previousConfiguration=void 0;const i=new Set;t.keys.forEach(D=>i.add(D)),t.overrides.forEach(([,D])=>D.forEach(C=>i.add(C))),this.affectedKeys=[...i.values()];const h=new d;this.affectedKeys.forEach(D=>h.setValue(D,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const l=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!E.equals(l,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let o=(0,n.toValuesTree)({[r]:!0},()=>{}),l;for(;typeof o=="object"&&(l=Object.keys(o)[0]);){if(t=t[l],!t)return!1;o=o[l]}return!0}}e.ConfigurationChangeEvent=c;class u extends c{constructor(t,r,o,l){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=o,this.sourceConfig=l}}e.AllKeysConfigurationChangeEvent=u}),define(we[90],Ee([0,1,4]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var S;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(E,k=S.Unknown,w){super(E);this._message=E,this._code=k,this._detail=w,this.isHandled=k===S.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(E){return E instanceof T&&E._code===S.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof T&&E._code===S.NoResolverFound}static isHandled(E){return E instanceof T&&E.isHandled}}e.RemoteAuthorityResolverError=T}),define(we[91],Ee([0,1,16]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function S(P){return P.scheme===_.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=S;function T(P){if(!!P){const E=P.indexOf("+");return E<0?P:P.substr(0,E)}}e.getRemoteName=T}),define(we[151],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,P,E=5){let k;return k=P(w=>{const n=typeof w=="string"?w:w.data;let A=this._terminalBufferMap.get(T);if(A){A.data.push(n);return}const I=setTimeout(()=>this._flushBuffer(T),E);A={data:[n],timeoutId:I,dispose:()=>{clearTimeout(I),this._flushBuffer(T),k.dispose()}},this._terminalBufferMap.set(T,A)}),k}stopBuffering(T){const P=this._terminalBufferMap.get(T);P&&P.dispose()}_flushBuffer(T){const P=this._terminalBufferMap.get(T);P&&(this._terminalBufferMap.delete(T),this._callback(T,P.data.join("")))}}e.TerminalDataBufferer=_}),define(we[152],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(S){S.DARK="dark",S.LIGHT="light",S.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(we[153],Ee([0,1,4,6,30,3,152,37]),function(ae,e,_,S,T,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var w;(function(p){function m(b){return b&&typeof b=="object"&&typeof b.id=="string"}p.isThemeColor=m})(w=e.ThemeColor||(e.ThemeColor={}));function n(p){return{id:p}}e.themeColorFromId=n;var A;(function(p){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||w.isThemeColor(t.color))}p.isThemeIcon=m;const b=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function c(t){const r=b.exec(t);if(!!r){let[,o]=r;return{id:o}}}p.fromString=c;function u(t,r){let o=t.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),r&&(o=`${o}~${r}`),{id:o}}p.modify=u;function a(t,r){var o,l;return t.id===r.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((l=r.color)===null||l===void 0?void 0:l.id)}p.isEqual=a,p.asClassNameArray=k.CSSIcon.asClassNameArray,p.asClassName=k.CSSIcon.asClassName,p.asCSSSelector=k.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function I(p){switch(p){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new P.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,S.toDisposable)(()=>{const b=this.themingParticipants.indexOf(m);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new v;T.Registry.add(e.Extensions.ThemingContribution,d);function s(p){return d.onColorThemeChange(p)}e.registerThemingParticipant=s;class f extends S.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,b){let c=this.theme.getColor(m);return c&&b&&(c=b(c,this.theme)),c?c.toString():null}}e.Themable=f}),define(we[154],Ee([0,1,30,153,3,124,88,13,37]),function(ae,e,_,S,T,P,E,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,P.localize)(0,null)},fontCharacter:{type:"string",description:(0,P.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${w.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,b,c,u){const a=this.iconsById[m];if(a){if(c&&!a.description){a.description=c,this.iconSchema.properties[m].markdownDescription=`${c} $(${m})`;const o=this.iconReferenceSchema.enum.indexOf(m);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=c),this._onDidChange.fire()}return a}let t={id:m,description:c,defaults:b,deprecationMessage:u};this.iconsById[m]=t;let r={$ref:"#/definitions/icons"};return u&&(r.deprecationMessage=u),c&&(r.markdownDescription=`${c}: $(${m})`),this.iconSchema.properties[m]=r,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const b=this.iconReferenceSchema.enum.indexOf(m);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,b){const c=this.iconFontsById[m];if(c)return c;let u={id:m,definition:b};return this.iconFontsById[m]=u,this._onDidChange.fire(),u}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFonts(){return Object.keys(this.iconFontsById).map(m=>this.iconFontsById[m])}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(a,t)=>a.id.localeCompare(t.id),b=a=>{for(;S.ThemeIcon.isThemeIcon(a.defaults);)a=this.iconsById[a.defaults.id];return`codicon codicon-${a?a.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(a=>this.iconsById[a]);for(const a of u.filter(t=>!!t.description).sort(m))c.push(`|<i class="${b(a)}"></i>|${a.id}|${S.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const a of u.filter(t=>!S.ThemeIcon.isThemeIcon(t.defaults)).sort(m))c.push(`|<i class="${b(a)}"></i>|${a.id}|`);return c.join(`
`)}}const A=new n;_.Registry.add(e.Extensions.IconContribution,A);function I(p,m,b,c){return A.registerIcon(p,m,b,c)}e.registerIcon=I;function v(){return A}e.getIconRegistry=v;function d(){for(const p of w.iconRegistry.all)A.registerIcon(p.id,p.definition,p.description);w.iconRegistry.onDidRegister(p=>A.registerIcon(p.id,p.definition,p.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let s=_.Registry.as(E.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,A.getIconSchema());const f=new k.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);A.onDidChange(()=>{f.isScheduled()||f.schedule()}),e.widgetClose=I("widget-close",w.Codicon.close,(0,P.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",w.Codicon.arrowUp,(0,P.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",w.Codicon.arrowDown,(0,P.localize)(4,null)),e.syncing=S.ThemeIcon.modify(w.Codicon.sync,"spin")}),define(we[47],Ee([0,1,2,24,4,22]),function(ae,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var E;(function(v){v[v.EMPTY=1]="EMPTY",v[v.FOLDER=2]="FOLDER",v[v.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function k(v){const d=v;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=k;function w(v){const d=v;return!!(d&&typeof d=="object"&&_.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=w;class n{constructor(d,s,f,p){this._id=d,this._configuration=f,this._ignorePathCasing=p,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(d){this._id=d.id,this._configuration=d.configuration,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class A{constructor(d,s){this.raw=s,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,S.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=A;function I(v){return new A({uri:v,index:0,name:(0,S.basenameOrAuthority)(v)},{uri:v.toString()})}e.toWorkspaceFolder=I}),define(we[155],Ee([0,1,4,125,47,2,21,11,24,104,45,16,58,38,91]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(Y){return(typeof Y=="string"?(0,k.extname)(Y):(0,w.extname)(Y))===f}e.hasWorkspaceFileExtension=p,e.IWorkspacesService=(0,_.createDecorator)("workspacesService");function m(Y){return Y.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function b(Y){return Y.hasOwnProperty("folderUri")}e.isRecentFolder=b;function c(Y){return Y.hasOwnProperty("fileUri")}e.isRecentFile=c;function u(Y){const L=Y;return typeof(L==null?void 0:L.id)=="string"&&P.URI.isUri(L.uri)}e.isSingleFolderWorkspaceIdentifier=u;function a(Y){if(Y.configuration)return{id:Y.id,configPath:Y.configuration};if(Y.folders.length===1)return{id:Y.id,uri:Y.folders[0].uri}}e.toWorkspaceIdentifier=a;function t(Y){const L=Y;return typeof(L==null?void 0:L.id)=="string"&&P.URI.isUri(L.configPath)}e.isWorkspaceIdentifier=t;function r(Y){const L=Y;if(L==null?void 0:L.uri)return{id:L.id,uri:P.URI.revive(L.uri)};const $=Y;if($==null?void 0:$.configPath)return{id:$.id,configPath:P.URI.revive($.configPath)};if(Y==null?void 0:Y.id)return{id:Y.id}}e.reviveIdentifier=r;function o(Y,L){return w.extUriBiasedIgnorePathCase.isEqualOrParent(Y,L.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function l(Y){return i(Y)||h(Y)}e.isStoredWorkspaceFolder=l;function i(Y){const L=Y;return typeof(L==null?void 0:L.path)=="string"&&(!L.name||typeof L.name=="string")}e.isRawFileWorkspaceFolder=i;function h(Y){const L=Y;return typeof(L==null?void 0:L.uri)=="string"&&(!L.name||typeof L.name=="string")}e.isRawUriWorkspaceFolder=h;function D(Y,L,$,W,K=!E.isWindows,U){if(Y.scheme!==W.scheme)return{name:$,uri:Y.toString(!0)};let ee=L?void 0:U.relativePath(W,Y);if(ee!==void 0)ee.length===0?ee=".":E.isWindows&&Y.scheme===I.Schemas.file&&!K&&(ee=ee.replace(/\//g,"\\"));else if(Y.scheme===I.Schemas.file)ee=Y.fsPath,E.isWindows&&(ee=(0,v.normalizeDriveLetter)(ee),K&&(ee=(0,d.toSlashes)(ee)));else{if(!U.isEqualAuthority(Y.authority,W.authority))return{name:$,uri:Y.toString(!0)};ee=Y.path}return{name:$,path:ee}}e.getStoredWorkspaceFolder=D;function C(Y,L,$){let W=[],K=new Set;const U=$.dirname(L);for(let ee of Y){let ie=null;if(i(ee))ee.path&&(ie=$.resolvePath(U,ee.path));else if(h(ee))try{ie=P.URI.parse(ee.uri),ie.path[0]!=="/"&&(ie=ie.with({path:"/"+ie.path}))}catch(se){console.warn(se)}if(ie){let se=$.getComparisonKey(ie);if(!K.has(se)){K.add(se);const Se=ee.name||$.basenameOrAuthority(ie);W.push(new T.WorkspaceFolder({uri:ie,name:Se,index:W.length},ee))}}}return W}e.toWorkspaceFolders=C;function g(Y,L,$,W,K){let U=y(L,Y);const ee=K.dirname(L),ie=K.dirname(W),se=[],Se=R(U.folders);for(const xe of U.folders){const N=i(xe)?K.resolvePath(ee,xe.path):P.URI.parse(xe.uri);let q;$?q=!1:q=!i(xe)||(0,k.isAbsolute)(xe.path),se.push(D(N,q,xe.name,ie,Se,K))}const Ae={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},Be=n.setProperty(Y,["folders"],se,Ae);let Re=n.applyEdits(Y,Be);return U.remoteAuthority===(0,s.getRemoteAuthority)(W)&&(Re=n.applyEdits(Re,n.removeProperty(Re,["remoteAuthority"],Ae))),Re}e.rewriteWorkspaceFileForNewLocation=g;function y(Y,L){let $=A.parse(L);if($&&Array.isArray($.folders))$.folders=$.folders.filter(W=>l(W));else throw new Error(`${Y} looks like an invalid workspace file.`);return $}function R(Y){return E.isWindows?Y.some(L=>i(L)&&L.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function O(Y){return Y.workspace&&typeof Y.workspace=="object"&&typeof Y.workspace.id=="string"&&typeof Y.workspace.configPath=="string"}function x(Y){return typeof Y.folderUri=="string"}function z(Y){return typeof Y.fileUri=="string"}function Q(Y,L){const $={workspaces:[],files:[]};if(Y){const W=function(U,ee){for(let ie=0;ie<U.length;ie++)try{ee(U[ie],ie)}catch(se){L.warn(`Error restoring recent entry ${JSON.stringify(U[ie])}: ${se.toString()}. Skip entry.`)}},K=Y;if(Array.isArray(K.entries))W(K.entries,U=>{const ee=U.label,ie=U.remoteAuthority;O(U)?$.workspaces.push({label:ee,remoteAuthority:ie,workspace:{id:U.workspace.id,configPath:P.URI.parse(U.workspace.configPath)}}):x(U)?$.workspaces.push({label:ee,remoteAuthority:ie,folderUri:P.URI.parse(U.folderUri)}):z(U)&&$.files.push({label:ee,remoteAuthority:ie,fileUri:P.URI.parse(U.fileUri)})});else{const U=Y;Array.isArray(U.workspaces3)&&W(U.workspaces3,(ee,ie)=>{const se=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[ie]||void 0;typeof ee=="object"&&typeof ee.id=="string"&&typeof ee.configURIPath=="string"?$.workspaces.push({label:se,workspace:{id:ee.id,configPath:P.URI.parse(ee.configURIPath)}}):typeof ee=="string"&&$.workspaces.push({label:se,folderUri:P.URI.parse(ee)})}),Array.isArray(U.files2)&&W(U.files2,(ee,ie)=>{const se=Array.isArray(U.fileLabels)&&U.fileLabels[ie]||void 0;typeof ee=="string"&&$.files.push({label:se,fileUri:P.URI.parse(ee)})})}}return $}e.restoreRecentlyOpened=Q;function j(Y){const L={entries:[]};for(const $ of Y.workspaces)b($)?L.entries.push({folderUri:$.folderUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority}):L.entries.push({workspace:{id:$.workspace.id,configPath:$.workspace.configPath.toString()},label:$.label,remoteAuthority:$.remoteAuthority});for(const $ of Y.files)L.entries.push({fileUri:$.fileUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority});return L}e.toStoreData=j}),define(we[92],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const P=this._idPool++;return this._data.set(P,T),this.logDebugInfo(),P}get(T,P){return this._data.has(T)?this._data.get(T)[P]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(we[156],Ee([0,1,2,3]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new S.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(E){this._tabs=E.map(k=>({name:k.name,group:k.group,resource:_.URI.revive(k.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(we[48],Ee([0,1,16,4]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(E,k){k===null?this._providerInfo.delete(E):this._providerInfo.set(E,k)}isFreeScheme(E){return!this._providerInfo.has(E)&&!this._systemSchemes.has(E)}getCapabilities(E){return this._providerInfo.get(E)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(we[27],Ee([0,1,4]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(we[157],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class _{constructor(P,E,k){this._id=P,this._shared=E,this._storage=k,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(w=>(this._value=w,this)),this._storageListener=this._storage.onDidChangeStorage(w=>{w.shared===this._shared&&w.key===this._id&&(this._value=w.value)})}get whenReady(){return this._init}get(P,E){let k=this._value[P];return typeof k=="undefined"&&(k=E),k}update(P,E){return this._value[P]=E,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=_;class S extends _{constructor(P,E){super(P.identifier.value,!0,E);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=S}),define(we[14],Ee([0,1,4]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class S{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=S});var tt=this&&this.__classPrivateFieldSet||function(ae,e,_){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,_),_},We=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(we[158],Ee([0,1,25,3]),function(ae,e,_,S){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(k,w){T.set(this,void 0),this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(k.identifier),tt(this,T,w),We(this,T).onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(k){return We(this,T).get(this._id,k)}store(k,w){return We(this,T).store(this._id,k,w)}delete(k){return We(this,T).delete(this._id,k)}}e.ExtensionSecrets=P,T=new WeakMap}),define(we[93],Ee([0,1,4,3]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new S.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(E){this._enabled=E}$onDidChangeTelemetryEnabled(E){this._enabled=E,this._onDidChangeTelemetryEnabled.fire(E)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")}),define(we[67],Ee([0,1,4,3,14]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(k){function w(A){return{remoteAddress:A.remoteAddress,localAddress:A.localAddress,public:!!A.public}}k.fromApiTunnel=w;function n(A){return{remoteAddress:{host:A.tunnelRemoteHost,port:A.tunnelRemotePort},localAddress:A.localAddress,public:A.public}}k.fromServiceTunnel=n})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,_.createDecorator)("IExtHostTunnelService");let E=class{constructor(w){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(w){return w}async openTunnel(w,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(w){return{dispose:()=>{}}}registerPortsAttributesProvider(w,n){return{dispose:()=>{}}}async $providePortAttributes(w,n,A,I,v){return[]}async $forwardPort(w,n){}async $closeTunnel(w){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};E=je([qe(0,T.IExtHostRpcService)],E),e.ExtHostTunnelService=E});var tt=this&&this.__classPrivateFieldSet||function(ae,e,_){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,_),_},We=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(we[7],Ee([0,1,15,10,80,22,12,2,29,64,90]),function(ae,e,_,S,T,P,E,k,w,n,A){"use strict";var I,v,d,s,f,p,m,b,c,u,a,t,r,o,l,i;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestState=e.TestItem=e.TestMessageSeverity=e.TestResult=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookRunState=e.NotebookCellRunState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function h(M){function F(){return Reflect.construct(M,arguments,this.constructor)}return Object.defineProperty(F,"name",Object.getOwnPropertyDescriptor(M,"name")),Object.setPrototypeOf(F,M),Object.setPrototypeOf(F.prototype,M.prototype),F}let D=d=class{constructor(F){I.set(this,void 0),tt(this,I,F)}static from(...F){let ne=F;return new d(function(){if(ne){for(const ye of ne)ye&&typeof ye.dispose=="function"&&ye.dispose();ne=void 0}})}dispose(){typeof We(this,I)=="function"&&(We(this,I).call(this),tt(this,I,void 0))}};I=new WeakMap,D=d=je([h],D),e.Disposable=D;let C=s=class{constructor(F,ne){if(F<0)throw(0,S.illegalArgument)("line must be non-negative");if(ne<0)throw(0,S.illegalArgument)("character must be non-negative");this._line=F,this._character=ne}static Min(...F){if(F.length===0)throw new TypeError;let ne=F[0];for(let ye=1;ye<F.length;ye++){const ze=F[ye];ze.isBefore(ne)&&(ne=ze)}return ne}static Max(...F){if(F.length===0)throw new TypeError;let ne=F[0];for(let ye=1;ye<F.length;ye++){const ze=F[ye];ze.isAfter(ne)&&(ne=ze)}return ne}static isPosition(F){if(!F)return!1;if(F instanceof s)return!0;let{line:ne,character:ye}=F;return typeof ne=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,ne=0){if(F===null||ne===null)throw(0,S.illegalArgument)();let ye;return typeof F=="undefined"?ye=0:typeof F=="number"?ye=F:(ye=typeof F.lineDelta=="number"?F.lineDelta:0,ne=typeof F.characterDelta=="number"?F.characterDelta:0),ye===0&&ne===0?this:new s(this.line+ye,this.character+ne)}with(F,ne=this.character){if(F===null||ne===null)throw(0,S.illegalArgument)();let ye;return typeof F=="undefined"?ye=this.line:typeof F=="number"?ye=F:(ye=typeof F.line=="number"?F.line:this.line,ne=typeof F.character=="number"?F.character:this.character),ye===this.line&&ne===this.character?this:new s(ye,ne)}toJSON(){return{line:this.line,character:this.character}}};C=s=je([h],C),e.Position=C;let g=f=class{constructor(F,ne,ye,ze){let Ye,nt;if(typeof F=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof ze=="number"?(Ye=new C(F,ne),nt=new C(ye,ze)):F instanceof C&&ne instanceof C&&(Ye=F,nt=ne),!Ye||!nt)throw new Error("Invalid arguments");Ye.isBefore(nt)?(this._start=Ye,this._end=nt):(this._start=nt,this._end=Ye)}static isRange(F){return F instanceof f?!0:F?C.isPosition(F.start)&&C.isPosition(F.end):!1}get start(){return this._start}get end(){return this._end}contains(F){return F instanceof f?this.contains(F._start)&&this.contains(F._end):F instanceof C?!(F.isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const ne=C.Max(F.start,this._start),ye=C.Min(F.end,this._end);if(!ne.isAfter(ye))return new f(ne,ye)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const ne=C.Min(F.start,this._start),ye=C.Max(F.end,this.end);return new f(ne,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,ne=this.end){if(F===null||ne===null)throw(0,S.illegalArgument)();let ye;return F?C.isPosition(F)?ye=F:(ye=F.start||this.start,ne=F.end||this.end):ye=this.start,ye.isEqual(this._start)&&ne.isEqual(this.end)?this:new f(ye,ne)}toJSON(){return[this.start,this.end]}};g=f=je([h],g),e.Range=g;let y=p=class extends g{constructor(F,ne,ye,ze){let Ye,nt;if(typeof F=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof ze=="number"?(Ye=new C(F,ne),nt=new C(ye,ze)):F instanceof C&&ne instanceof C&&(Ye=F,nt=ne),!Ye||!nt)throw new Error("Invalid arguments");super(Ye,nt);this._anchor=Ye,this._active=nt}static isSelection(F){return F instanceof p?!0:F?g.isRange(F)&&C.isPosition(F.anchor)&&C.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};y=p=je([h],y),e.Selection=y;class R{constructor(F,ne,ye){if(typeof F!="string"||F.length===0)throw(0,S.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,S.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,S.illegalArgument)("connectionToken");this.host=F,this.port=Math.round(ne),this.connectionToken=ye}}e.ResolvedAuthority=R;class O extends Error{constructor(F,ne=A.RemoteAuthorityResolverErrorCode.Unknown,ye){super(F);this._message=F,this._code=ne,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,O.prototype)}static NotAvailable(F,ne){return new O(F,A.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(F){return new O(F,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=O;var x;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var z;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Q=m=class{constructor(F,ne){this._range=F,this._newText=ne}static isTextEdit(F){return F instanceof m?!0:F?g.isRange(F)&&typeof F.newText=="string":!1}static replace(F,ne){return new m(F,ne)}static insert(F,ne){return m.replace(new g(F,F),ne)}static delete(F){return m.replace(F,"")}static setEndOfLine(F){const ne=new m(new g(new C(0,0),new C(0,0)),"");return ne.newEol=F,ne}get range(){return this._range}set range(F){if(F&&!g.isRange(F))throw(0,S.illegalArgument)("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw(0,S.illegalArgument)("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw(0,S.illegalArgument)("newEol");this._newEol=F}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Q=m=je([h],Q),e.TextEdit=Q;var j;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellOutput=4]="CellOutput",M[M.CellReplace=5]="CellReplace",M[M.CellOutputItem=6]="CellOutputItem"})(j=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,ne,ye,ze){this._edits.push({_type:1,from:F,to:ne,options:ye,metadata:ze})}createFile(F,ne,ye){this._edits.push({_type:1,from:void 0,to:F,options:ne,metadata:ye})}deleteFile(F,ne,ye){this._edits.push({_type:1,from:F,to:void 0,options:ne,metadata:ye})}replaceNotebookMetadata(F,ne,ye){this._edits.push({_type:3,metadata:ye,uri:F,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(F,ne,ye,ze,Ye){(ne!==ye||ze.length>0)&&this._edits.push({_type:5,uri:F,index:ne,count:ye-ne,cells:ze,metadata:Ye})}replaceNotebookCellOutput(F,ne,ye,ze){this._editNotebookCellOutput(F,ne,!1,ye,ze)}appendNotebookCellOutput(F,ne,ye,ze){this._editNotebookCellOutput(F,ne,!0,ye,ze)}replaceNotebookCellOutputItems(F,ne,ye,ze,Ye){this._editNotebookCellOutputItems(F,ne,ye,!1,ze,Ye)}appendNotebookCellOutputItems(F,ne,ye,ze,Ye){this._editNotebookCellOutputItems(F,ne,ye,!0,ze,Ye)}_editNotebookCellOutputItems(F,ne,ye,ze,Ye,nt){this._edits.push({_type:6,metadata:nt,uri:F,index:ne,outputId:ye,append:ze,newOutputItems:Ye})}_editNotebookCellOutput(F,ne,ye,ze,Ye){this._edits.push({_type:4,metadata:Ye,uri:F,index:ne,append:ye,newOutputs:ze,newMetadata:void 0})}replaceNotebookCellMetadata(F,ne,ye,ze){this._edits.push({_type:3,metadata:ze,uri:F,edit:{editType:3,index:ne,metadata:ye}})}replace(F,ne,ye,ze){this._edits.push({_type:2,uri:F,edit:new Q(ne,ye),metadata:ze})}insert(F,ne,ye,ze){this.replace(F,new g(ne,ne),ye,ze)}delete(F,ne,ye){this.replace(F,ne,"",ye)}has(F){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===F.toString())}set(F,ne){if(ne)for(const ye of ne)ye&&this._edits.push({_type:2,uri:F,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const ze=this._edits[ye];ze._type===2&&ze.uri.toString()===F.toString()&&(this._edits[ye]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(F){const ne=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===F.toString()&&ne.push(ye.edit);return ne}entries(){const F=new P.ResourceMap;for(let ne of this._edits)if(ne._type===2){let ye=F.get(ne.uri);ye||(ye=[ne.uri,[]],F.set(ne.uri,ye)),ye[1].push(ne.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=je([h],Y),e.WorkspaceEdit=Y;let L=b=class{constructor(F){this._tabstop=1,this.value=F||""}static isSnippetString(F){return F instanceof b?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}appendText(F){return this.value+=b._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,ne=this._tabstop++){if(typeof F=="function"){const ye=new b;ye._tabstop=this._tabstop,F(ye),this._tabstop=ye._tabstop,F=ye.value}else F=b._escape(F);return this.value+="${",this.value+=ne,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,ne=this._tabstop++){const ye=F.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(F,ne){if(typeof ne=="function"){const ye=new b;ye._tabstop=this._tabstop,ne(ye),this._tabstop=ye._tabstop,ne=ye.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};L=b=je([h],L),e.SnippetString=L;var $;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})($=e.DiagnosticTag||(e.DiagnosticTag={}));var W;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(W=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let K=c=class{constructor(F,ne){if(this.uri=F,ne)if(ne instanceof g)this.range=ne;else if(ne instanceof C)this.range=new g(ne,ne);else throw new Error("Illegal argument")}static isLocation(F){return F instanceof c?!0:F?g.isRange(F.range)&&k.URI.isUri(F.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};K=c=je([h],K),e.Location=K;let U=class{constructor(F,ne){this.location=F,this.message=ne}static is(F){return F?typeof F.message=="string"&&F.location&&g.isRange(F.location.range)&&k.URI.isUri(F.location.uri):!1}static isEqual(F,ne){return F===ne?!0:!F||!ne?!1:F.message===ne.message&&F.location.range.isEqual(ne.location.range)&&F.location.uri.toString()===ne.location.uri.toString()}};U=je([h],U),e.DiagnosticRelatedInformation=U;let ee=class{constructor(F,ne,ye=W.Error){if(!g.isRange(F))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=F,this.message=ne,this.severity=ye}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,ne){return F===ne?!0:!F||!ne?!1:F.message===ne.message&&F.severity===ne.severity&&F.code===ne.code&&F.severity===ne.severity&&F.source===ne.source&&F.range.isEqual(ne.range)&&(0,_.equals)(F.tags,ne.tags)&&(0,_.equals)(F.relatedInformation,ne.relatedInformation,U.isEqual)}};ee=je([h],ee),e.Diagnostic=ee;let ie=class{constructor(F,ne){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:(0,T.isMarkdownString)(F)?this.contents=[F]:this.contents=[F],this.range=ne}};ie=je([h],ie),e.Hover=ie;var se;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(se=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Se=class{constructor(F,ne=se.Text){this.range=F,this.kind=ne}toJSON(){return{range:this.range,kind:se[this.kind]}}};Se=je([h],Se),e.DocumentHighlight=Se;var Ae;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(Ae=e.SymbolKind||(e.SymbolKind={}));var Be;(function(M){M[M.Deprecated=1]="Deprecated"})(Be=e.SymbolTag||(e.SymbolTag={}));let Re=u=class{constructor(F,ne,ye,ze,Ye){this.name=F,this.kind=ne,this.containerName=Ye,typeof ye=="string"&&(this.containerName=ye),ze instanceof K?this.location=ze:ye instanceof g&&(this.location=new K(ze,ye)),u.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};Re=u=je([h],Re),e.SymbolInformation=Re;let xe=a=class{constructor(F,ne,ye,ze,Ye){this.name=F,this.detail=ne,this.kind=ye,this.range=ze,this.selectionRange=Ye,this.children=[],a.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children&&F.children.forEach(a.validate)}};xe=a=je([h],xe),e.DocumentSymbol=xe;var N;(function(M){M[M.Automatic=1]="Automatic",M[M.Manual=2]="Manual"})(N=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let q=class{constructor(F,ne){this.title=F,this.kind=ne}};q=je([h],q),e.CodeAction=q;let J=t=class{constructor(F){this.value=F}append(F){return new t(this.value?this.value+t.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+t.sep)}};J.sep=".",J=t=je([h],J),e.CodeActionKind=J,J.Empty=new J(""),J.QuickFix=J.Empty.append("quickfix"),J.Refactor=J.Empty.append("refactor"),J.RefactorExtract=J.Refactor.append("extract"),J.RefactorInline=J.Refactor.append("inline"),J.RefactorRewrite=J.Refactor.append("rewrite"),J.Source=J.Empty.append("source"),J.SourceOrganizeImports=J.Source.append("organizeImports"),J.SourceFixAll=J.Source.append("fixAll");let le=class{constructor(F,ne){if(this.range=F,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};le=je([h],le),e.SelectionRange=le;class ge{constructor(F,ne,ye,ze,Ye,nt){this.kind=F,this.name=ne,this.detail=ye,this.uri=ze,this.range=Ye,this.selectionRange=nt}}e.CallHierarchyItem=ge;class De{constructor(F,ne){this.fromRanges=ne,this.from=F}}e.CallHierarchyIncomingCall=De;class Le{constructor(F,ne){this.fromRanges=ne,this.to=F}}e.CallHierarchyOutgoingCall=Le;let pe=class{constructor(F,ne){this.range=F,this.command=ne}get isResolved(){return!!this.command}};pe=je([h],pe),e.CodeLens=pe;let Ce=r=class{constructor(F,ne=!1){v.set(this,void 0),tt(this,v,new T.MarkdownString(F,{supportThemeIcons:ne}))}static isMarkdownString(F){return F instanceof r?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}get value(){return We(this,v).value}set value(F){We(this,v).value=F}get isTrusted(){return We(this,v).isTrusted}set isTrusted(F){We(this,v).isTrusted=F}get supportThemeIcons(){return We(this,v).supportThemeIcons}appendText(F){return We(this,v).appendText(F),this}appendMarkdown(F){return We(this,v).appendMarkdown(F),this}appendCodeblock(F,ne){return We(this,v).appendCodeblock(ne!=null?ne:"",F),this}};v=new WeakMap,Ce=r=je([h],Ce),e.MarkdownString=Ce;let Te=class{constructor(F,ne){this.label=F,this.documentation=ne}};Te=je([h],Te),e.ParameterInformation=Te;let Ue=class{constructor(F,ne){this.label=F,this.documentation=ne,this.parameters=[]}};Ue=je([h],Ue),e.SignatureInformation=Ue;let be=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};be=je([h],be),e.SignatureHelp=be;var Ke;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(Ke=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var H;(function(M){M[M.Other=0]="Other",M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(H=e.InlineHintKind||(e.InlineHintKind={}));let Z=class{constructor(F,ne,ye){this.text=F,this.range=ne,this.kind=ye}};Z=je([h],Z),e.InlineHint=Z;var _e;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Me;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(Me=e.CompletionItemKind||(e.CompletionItemKind={}));var He;(function(M){M[M.Deprecated=1]="Deprecated"})(He=e.CompletionItemTag||(e.CompletionItemTag={}));let Oe=class{constructor(F,ne){this.label=F,this.kind=ne}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Me[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Oe=je([h],Oe),e.CompletionItem=Oe;let Xe=class{constructor(F=[],ne=!1){this.items=F,this.isIncomplete=ne}};Xe=je([h],Xe),e.CompletionList=Xe;var B;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(B=e.ViewColumn||(e.ViewColumn={}));var re;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(re=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ce;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative"})(ce=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var V;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(V=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(X=e.TextEditorRevealType||(e.TextEditorRevealType={}));var oe;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var fe;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(fe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(M){function F(ne){switch(ne){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=F}(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ve=class{constructor(F,ne){if(ne&&!k.URI.isUri(ne))throw(0,S.illegalArgument)("target");if(!g.isRange(F)||F.isEmpty)throw(0,S.illegalArgument)("range");this.range=F,this.target=ne}};ve=je([h],ve),e.DocumentLink=ve;let $e=class{constructor(F,ne,ye,ze){this.red=F,this.green=ne,this.blue=ye,this.alpha=ze}};$e=je([h],$e),e.Color=$e;let Ne=class{constructor(F,ne){if(ne&&!(ne instanceof $e))throw(0,S.illegalArgument)("color");if(!g.isRange(F)||F.isEmpty)throw(0,S.illegalArgument)("range");this.range=F,this.color=ne}};Ne=je([h],Ne),e.ColorInformation=Ne;let Ve=class{constructor(F){if(!F||typeof F!="string")throw(0,S.illegalArgument)("label");this.label=F}};Ve=je([h],Ve),e.ColorPresentation=Ve;var Qe;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(Qe=e.ColorFormat||(e.ColorFormat={}));var Ze;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(Ze=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ct;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(ct=e.TaskRevealKind||(e.TaskRevealKind={}));var st;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(st=e.TaskPanelKind||(e.TaskPanelKind={}));let me=o=class{constructor(F,ne){if(typeof F!="string"||typeof ne!="string")throw(0,S.illegalArgument)("name");this._id=F}static from(F){switch(F){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};me.Clean=new o("clean","Clean"),me.Build=new o("build","Build"),me.Rebuild=new o("rebuild","Rebuild"),me.Test=new o("test","Test"),me=o=je([h],me),e.TaskGroup=me;function he(M){let F="";for(let ne=0;ne<M.length;ne++)F+=M[ne].replace(/,/g,",,")+",";return F}let ue=class{constructor(F,ne,ye){if(typeof F!="string")throw(0,S.illegalArgument)("process");this._args=[],this._process=F,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=ye):this._options=ne)}get process(){return this._process}set process(F){if(typeof F!="string")throw(0,S.illegalArgument)("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)F.push(ne);return he(F)}};ue=je([h],ue),e.ProcessExecution=ue;let G=class{constructor(F,ne,ye){if(this._args=[],Array.isArray(ne)){if(!F)throw(0,S.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,S.illegalArgument)("command");this._command=F,this._args=ne,this._options=ye}else{if(typeof F!="string")throw(0,S.illegalArgument)("commandLine");this._commandLine=F,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw(0,S.illegalArgument)("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,S.illegalArgument)("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)F.push(typeof ne=="string"?ne:ne.value);return he(F)}};G=je([h],G),e.ShellExecution=G;var Ie;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(Ie=e.ShellQuoting||(e.ShellQuoting={}));var Pe;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(Pe=e.TaskScope||(e.TaskScope={}));class et{constructor(F){this._callback=F}computeId(){return"customExecution"+(0,w.generateUuid)()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=et;let Ge=l=class{constructor(F,ne,ye,ze,Ye,nt){this.__deprecated=!1,this._definition=this.definition=F;let ot;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=ye,this.execution=ze,ot=Ye,this.__deprecated=!0):ne===Pe.Global||ne===Pe.Workspace?(this.target=ne,this._name=this.name=ye,this._source=this.source=ze,this.execution=Ye,ot=nt):(this.target=ne,this._name=this.name=ye,this._source=this.source=ze,this.execution=Ye,ot=nt),typeof ot=="string"?(this._problemMatchers=[ot],this._hasDefinedMatchers=!0):Array.isArray(ot)?(this._problemMatchers=ot,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ue?this._definition={type:l.ProcessType,id:this._execution.computeId()}:this._execution instanceof G?this._definition={type:l.ShellType,id:this._execution.computeId()}:this._execution instanceof et?this._definition={type:l.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:l.EmptyType,id:(0,w.generateUuid)()}}get definition(){return this._definition}set definition(F){if(F==null)throw(0,S.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw(0,S.illegalArgument)("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const ne=this._definition.type;(l.EmptyType===ne||l.ProcessType===ne||l.ShellType===ne||l.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw(0,S.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};Ge.ExtensionCallbackType="customExecution",Ge.ProcessType="process",Ge.ShellType="shell",Ge.EmptyType="$empty",Ge=l=je([h],Ge),e.Task=Ge;var rt;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(rt=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(F,ne=Je.None){this.collapsibleState=ne,k.URI.isUri(F)?this.resourceUri=F:this.label=F}};lt=je([h],lt),e.TreeItem=lt;var Je;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(Je=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let it=class{constructor(F,ne){this.id=F,this.color=ne}};it=je([h],it),e.ThemeIcon=it,it.File=new it("file"),it.Folder=new it("folder");let dt=class{constructor(F){this.id=F}};dt=je([h],dt),e.ThemeColor=dt;var at;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(at=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Dt=class{constructor(F,ne){if(typeof F!="string"&&(!F||!k.URI.isUri(F)&&!k.URI.isUri(F.uri)))throw(0,S.illegalArgument)("base");if(typeof ne!="string")throw(0,S.illegalArgument)("pattern");typeof F=="string"?(this.baseFolder=k.URI.file(F),this.base=F):k.URI.isUri(F)?(this.baseFolder=F,this.base=F.fsPath):(this.baseFolder=F.uri,this.base=F.uri.fsPath),this.pattern=ne}};Dt=je([h],Dt),e.RelativePattern=Dt;let gt=class{constructor(F,ne,ye,ze){this.enabled=typeof F=="boolean"?F:!0,typeof ne=="string"&&(this.condition=ne),typeof ye=="string"&&(this.hitCondition=ye),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,w.generateUuid)()),this._id}};gt=je([h],gt),e.Breakpoint=gt;let Ct=class extends gt{constructor(F,ne,ye,ze,Ye){super(ne,ye,ze,Ye);if(F===null)throw(0,S.illegalArgument)("location");this.location=F}};Ct=je([h],Ct),e.SourceBreakpoint=Ct;let wt=class extends gt{constructor(F,ne,ye,ze,Ye){super(ne,ye,ze,Ye);this.functionName=F}};wt=je([h],wt),e.FunctionBreakpoint=wt;let Et=class extends gt{constructor(F,ne,ye,ze,Ye,nt,ot){super(ze,Ye,nt,ot);if(!ne)throw(0,S.illegalArgument)("dataId");this.label=F,this.dataId=ne,this.canPersist=ye}};Et=je([h],Et),e.DataBreakpoint=Et;let mt=class{constructor(F,ne,ye){this.command=F,this.args=ne||[],this.options=ye}};mt=je([h],mt),e.DebugAdapterExecutable=mt;let Rt=class{constructor(F,ne){this.port=F,this.host=ne}};Rt=je([h],Rt),e.DebugAdapterServer=Rt;let Ft=class{constructor(F){this.path=F}};Ft=je([h],Ft),e.DebugAdapterNamedPipeServer=Ft;let ht=class{constructor(F){this.implementation=F}};ht=je([h],ht),e.DebugAdapterInlineImplementation=ht;let St=class{constructor(F,ne){this.range=F,this.expression=ne}};St=je([h],St),e.EvaluatableExpression=St;let Ut=class{constructor(F,ne){this.range=F,this.text=ne}};Ut=je([h],Ut),e.InlineValueText=Ut;let $t=class{constructor(F,ne,ye=!0){this.range=F,this.variableName=ne,this.caseSensitiveLookup=ye}};$t=je([h],$t),e.InlineValueVariableLookup=$t;let Lt=class{constructor(F,ne){this.range=F,this.expression=ne}};Lt=je([h],Lt),e.InlineValueEvaluatableExpression=Lt;let ut=class{constructor(F,ne){this.frameId=F,this.stoppedLocation=ne}};ut=je([h],ut),e.InlineValueContext=ut;var ln;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(ln=e.FileChangeType||(e.FileChangeType={}));let It=i=class extends Error{constructor(F,ne=n.FileSystemProviderErrorCode.Unknown,ye){var ze;super(k.URI.isUri(F)?F.toString(!0):F);this.code=(ze=ye==null?void 0:ye.name)!==null&&ze!==void 0?ze:"Unknown",(0,n.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,i.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(F){return new i(F,n.FileSystemProviderErrorCode.FileExists,i.FileExists)}static FileNotFound(F){return new i(F,n.FileSystemProviderErrorCode.FileNotFound,i.FileNotFound)}static FileNotADirectory(F){return new i(F,n.FileSystemProviderErrorCode.FileNotADirectory,i.FileNotADirectory)}static FileIsADirectory(F){return new i(F,n.FileSystemProviderErrorCode.FileIsADirectory,i.FileIsADirectory)}static NoPermissions(F){return new i(F,n.FileSystemProviderErrorCode.NoPermissions,i.NoPermissions)}static Unavailable(F){return new i(F,n.FileSystemProviderErrorCode.Unavailable,i.Unavailable)}};It=i=je([h],It),e.FileSystemError=It;let At=class{constructor(F,ne,ye){this.start=F,this.end=ne,this.kind=ye}};At=je([h],At),e.FoldingRange=At;var Yt;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(Yt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var un;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(un=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Xt;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(Xt=e.CommentMode||(e.CommentMode={}));class cn{constructor(F,ne=[]){this.tokenTypes=F,this.tokenModifiers=ne}}e.SemanticTokensLegend=cn;function Zt(M){return typeof M=="undefined"||(0,E.isStringArray)(M)}class Pt{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let ne=0,ye=F.tokenTypes.length;ne<ye;ne++)this._tokenTypeStrToInt.set(F.tokenTypes[ne],ne);for(let ne=0,ye=F.tokenModifiers.length;ne<ye;ne++)this._tokenModifierStrToInt.set(F.tokenModifiers[ne],ne)}}push(F,ne,ye,ze,Ye){if(typeof F=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof ze=="number"&&(typeof Ye=="number"||typeof Ye=="undefined"))return typeof Ye=="undefined"&&(Ye=0),this._pushEncoded(F,ne,ye,ze,Ye);if(g.isRange(F)&&typeof ne=="string"&&Zt(ye))return this._push(F,ne,ye);throw(0,S.illegalArgument)()}_push(F,ne,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const ze=F.start.line,Ye=F.start.character,nt=F.end.character-F.start.character,ot=this._tokenTypeStrToInt.get(ne);let pt=0;if(ye)for(const vt of ye){if(!this._tokenModifierStrToInt.has(vt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this._tokenModifierStrToInt.get(vt);pt|=1<<_t>>>0}this._pushEncoded(ze,Ye,nt,ot,pt)}_pushEncoded(F,ne,ye,ze,Ye){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const pt=this._data.length/5|0;let vt=0,_t=0;for(let bt=0;bt<pt;bt++){let yt=this._data[5*bt],Qt=this._data[5*bt+1];yt===0?(yt=vt,Qt+=_t):yt+=vt,this._data[5*bt]=yt,this._data[5*bt+1]=Qt,vt=yt,_t=Qt}}let nt=F,ot=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(nt-=this._prevLine,nt===0&&(ot-=this._prevChar)),this._data[this._dataLen++]=nt,this._data[this._dataLen++]=ot,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Ye,this._prevLine=F,this._prevChar=ne}static _sortAndDeltaEncode(F){let ne=[];const ye=F.length/5|0;for(let ot=0;ot<ye;ot++)ne[ot]=ot;ne.sort((ot,pt)=>{const vt=F[5*ot],_t=F[5*pt];if(vt===_t){const bt=F[5*ot+1],yt=F[5*pt+1];return bt-yt}return vt-_t});const ze=new Uint32Array(F.length);let Ye=0,nt=0;for(let ot=0;ot<ye;ot++){const pt=5*ne[ot],vt=F[pt+0],_t=F[pt+1],bt=F[pt+2],yt=F[pt+3],Qt=F[pt+4],yn=vt-Ye,In=yn===0?_t-nt:_t,Jt=5*ot;ze[Jt+0]=yn,ze[Jt+1]=In,ze[Jt+2]=bt,ze[Jt+3]=yt,ze[Jt+4]=Qt,Ye=vt,nt=_t}return ze}build(F){return this._dataIsSortedAndDeltaEncoded?new Bt(new Uint32Array(this._data),F):new Bt(Pt._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=Pt;class Bt{constructor(F,ne){this.resultId=ne,this.data=F}}e.SemanticTokens=Bt;class xt{constructor(F,ne,ye){this.start=F,this.deleteCount=ne,this.data=ye}}e.SemanticTokensEdit=xt;class Ht{constructor(F,ne){this.resultId=ne,this.edits=F}}e.SemanticTokensEdits=Ht;var dn;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(dn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var hn;(function(M){M[M.Initial=1]="Initial",M[M.Dynamic=2]="Dynamic"})(hn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let kt=class{constructor(){}};kt.Back={iconPath:new it("arrow-left")},kt=je([h],kt),e.QuickInputButtons=kt;var fn;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(fn=e.ExtensionKind||(e.ExtensionKind={}));class mn{constructor(F,ne,ye){this.badge=F,this.tooltip=ne,this.color=ye}static validate(F){if(F.badge&&F.badge.length!==1&&F.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=mn;let zt=class{constructor(F){this.kind=F}};zt=je([h],zt),e.ColorTheme=zt;var gn;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast"})(gn=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(F,ne){if(F<0)throw(0,S.illegalArgument)("start must be positive");if(ne<F)throw(0,S.illegalArgument)("end cannot be smaller than start");this._start=F,this._end=ne}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}}e.NotebookCellRange=Vt;class Wt{constructor(F,ne,ye,ze,Ye,nt,ot,pt,vt,_t,bt){this.editable=F,this.breakpointMargin=ne,this.hasExecutionOrder=ye,this.executionOrder=ze,this.runState=Ye,this.runStartTime=nt,this.statusMessage=ot,this.lastRunDuration=pt,this.inputCollapsed=vt,this.outputCollapsed=_t,this.custom=bt}with(F){let{editable:ne,breakpointMargin:ye,hasExecutionOrder:ze,executionOrder:Ye,runState:nt,runStartTime:ot,statusMessage:pt,lastRunDuration:vt,inputCollapsed:_t,outputCollapsed:bt,custom:yt}=F;return ne===void 0?ne=this.editable:ne===null&&(ne=void 0),ye===void 0?ye=this.breakpointMargin:ye===null&&(ye=void 0),ze===void 0?ze=this.hasExecutionOrder:ze===null&&(ze=void 0),Ye===void 0?Ye=this.executionOrder:Ye===null&&(Ye=void 0),nt===void 0?nt=this.runState:nt===null&&(nt=void 0),ot===void 0?ot=this.runStartTime:ot===null&&(ot=void 0),pt===void 0?pt=this.statusMessage:pt===null&&(pt=void 0),vt===void 0?vt=this.lastRunDuration:vt===null&&(vt=void 0),_t===void 0?_t=this.inputCollapsed:_t===null&&(_t=void 0),bt===void 0?bt=this.outputCollapsed:bt===null&&(bt=void 0),yt===void 0?yt=this.custom:yt===null&&(yt=void 0),ne===this.editable&&ye===this.breakpointMargin&&ze===this.hasExecutionOrder&&Ye===this.executionOrder&&nt===this.runState&&ot===this.runStartTime&&pt===this.statusMessage&&vt===this.lastRunDuration&&_t===this.inputCollapsed&&bt===this.outputCollapsed&&yt===this.custom?this:new Wt(ne,ye,ze,Ye,nt,ot,pt,vt,_t,bt,yt)}}e.NotebookCellMetadata=Wt;class Mt{constructor(F=!0,ne=!0,ye=!0,ze={},Ye=en.Idle,nt=!0){this.editable=F,this.cellEditable=ne,this.cellHasExecutionOrder=ye,this.custom=ze,this.runState=Ye,this.trusted=nt}with(F){let{editable:ne,cellEditable:ye,cellHasExecutionOrder:ze,custom:Ye,runState:nt,trusted:ot}=F;return ne===void 0?ne=this.editable:ne===null&&(ne=void 0),ye===void 0?ye=this.cellEditable:ye===null&&(ye=void 0),ze===void 0?ze=this.cellHasExecutionOrder:ze===null&&(ze=void 0),Ye===void 0?Ye=this.custom:Ye===null&&(Ye=void 0),nt===void 0?nt=this.runState:nt===null&&(nt=void 0),ot===void 0?ot=this.trusted:ot===null&&(ot=void 0),ne===this.editable&&ye===this.cellEditable&&ze===this.cellHasExecutionOrder&&Ye===this.custom&&nt===this.runState&&ot===this.trusted?this:new Mt(ne,ye,ze,Ye,nt,ot)}}e.NotebookDocumentMetadata=Mt;class jt{constructor(F,ne,ye,ze,Ye){this.kind=F,this.source=ne,this.language=ye,this.outputs=ze!=null?ze:[],this.metadata=Ye}}e.NotebookCellData=jt;class Fe{constructor(F,ne){this.cells=F,this.metadata=ne!=null?ne:new Mt}}e.NotebookData=Fe;class Ot{constructor(F,ne,ye){this.mime=F,this.value=ne,this.metadata=ye}static isNotebookCellOutputItem(F){return F instanceof Ot}}e.NotebookCellOutputItem=Ot;class qt{constructor(F,ne,ye){this.outputs=F,typeof ne=="string"?(this.id=ne,this.metadata=ye):(this.id=(0,w.generateUuid)(),this.metadata=ne!=null?ne:ye)}}e.NotebookCellOutput=qt;var ft;(function(M){M[M.Markdown=1]="Markdown",M[M.Code=2]="Code"})(ft=e.NotebookCellKind||(e.NotebookCellKind={}));var pn;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle",M[M.Success=3]="Success",M[M.Error=4]="Error"})(pn=e.NotebookCellRunState||(e.NotebookCellRunState={}));var en;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(en=e.NotebookRunState||(e.NotebookRunState={}));var tn;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(tn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var nn;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(nn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Kt=class{constructor(F,ne){this.label=F,this.timestamp=ne}};Kt=je([h],Kt),e.TimelineItem=Kt;var vn;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(vn=e.ExtensionMode||(e.ExtensionMode={}));var _n;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(_n=e.ExtensionRuntime||(e.ExtensionRuntime={}));var bn;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=4]="RegEx"})(bn=e.StandardTokenType||(e.StandardTokenType={}));class rn{constructor(F,ne){this.ranges=F,this.wordPattern=ne}}e.LinkedEditingRanges=rn;var wn;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(wn=e.TestResult||(e.TestResult={}));var sn;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information",M[M.Hint=3]="Hint"})(sn=e.TestMessageSeverity||(e.TestMessageSeverity={}));class En{constructor(F,ne){this.label=ne,this.runnable=!0,this.debuggable=!1,this.children=[],Object.defineProperty(this,"id",{value:F,enumerable:!0,writable:!1})}}e.TestItem=En;class Sn{constructor(F){this.state=F,this.messages=[]}}e.TestState=Sn;class Gt{constructor(F){this.message=F,this.severity=sn.Error}static diff(F,ne,ye){const ze=new Gt(F);return ze.expectedOutput=ne,ze.actualOutput=ye,ze}}e.TestMessage=Gt;var te;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(te=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var de;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unknown=2]="Unknown"})(de=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ke;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore"})(ke=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(we[94],Ee([0,1,43,16,8,117,83,7,15]),function(ae,e,_,S,T,P,E,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function A(s,f){f?n.set(s,f):n.delete(s)}e.setWordDefinitionFor=A;function I(s){return n.get(s)}e.getWordDefinitionFor=I;class v extends P.MirrorTextModel{constructor(f,p,m,b,c,u,a,t){super(p,m,b,c);this._proxy=f,this._languageId=u,this._isDirty=a,this._notebook=t,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(f){return(0,w.equals)(this._lines,f)}get document(){if(!this._document){const f=this;this._document={get uri(){return f._uri},get fileName(){return f._uri.fsPath},get isUntitled(){return f._uri.scheme===S.Schemas.untitled},get languageId(){return f._languageId},get version(){return f._versionId},get isClosed(){return f._isDisposed},get isDirty(){return f._isDirty},get notebook(){return f._notebook},save(){return f._save()},getText(p){return p?f._getTextInRange(p):f.getText()},get eol(){return f._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return f._lines.length},lineAt(p){return f._lineAt(p)},offsetAt(p){return f._offsetAt(p)},positionAt(p){return f._positionAt(p)},validateRange(p){return f._validateRange(p)},validatePosition(p){return f._validatePosition(p)},getWordRangeAtPosition(p,m){return f._getWordRangeAtPosition(p,m)}}}return Object.freeze(this._document)}_acceptLanguageId(f){(0,_.ok)(!this._isDisposed),this._languageId=f}_acceptIsDirty(f){(0,_.ok)(!this._isDisposed),this._isDirty=f}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(f){const p=this._validateRange(f);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const m=this._eol,b=p.start.line,c=p.end.line,u=[];u.push(this._lines[b].substring(p.start.character));for(let a=b+1;a<c;a++)u.push(this._lines[a]);return u.push(this._lines[c].substring(0,p.end.character)),u.join(m)}_lineAt(f){let p;if(f instanceof k.Position?p=f.line:typeof f=="number"&&(p=f),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new d(p,this._lines[p],p===this._lines.length-1)}_offsetAt(f){return f=this._validatePosition(f),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(f.line-1)+f.character}_positionAt(f){f=Math.floor(f),f=Math.max(0,f),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(f),m=this._lines[p.index].length;return new k.Position(p.index,Math.min(p.remainder,m))}_validateRange(f){if(!(f instanceof k.Range))throw new Error("Invalid argument");const p=this._validatePosition(f.start),m=this._validatePosition(f.end);return p===f.start&&m===f.end?f:new k.Range(p.line,p.character,m.line,m.character)}_validatePosition(f){if(!(f instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return f.with(0,0);let{line:p,character:m}=f,b=!1;if(p<0)p=0,m=0,b=!0;else if(p>=this._lines.length)p=this._lines.length-1,m=this._lines[p].length,b=!0;else{const c=this._lines[p].length;m<0?(m=0,b=!0):m>c&&(m=c,b=!0)}return b?new k.Position(p,m):f}_getWordRangeAtPosition(f,p){const m=this._validatePosition(f);if(!p)p=I(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const b=(0,E.getWordAtText)(m.character+1,(0,E.ensureValidWordDefinition)(p),this._lines[m.line],0);if(b)return new k.Range(m.line,b.startColumn-1,m.line,b.endColumn-1)}}e.ExtHostDocumentData=v;class d{constructor(f,p,m){this._line=f,this._text=p,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(we[159],Ee([0,1,7,3,85,6,59,22,2,29]),function(ae,e,_,S,T,P,E,k,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class A{constructor(v,d,s,f){this._notebook=s,this._selector=f,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this.uri=w.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(m=>{const b=this._cellUris.get(m.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=m=>{m===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(v.onDidChangeNotebookCells(m=>p(m.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const v=[],d=[];for(const s of this._notebook.cells)s.kind===_.NotebookCellKind.Code&&(!this._selector||(0,E.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),v.push(s.document.getText().length+1),d.push(s.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(v)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(v){var d,s;if(!v){let c="";for(const u of this._cells)c+=u.document.getText()+`
`;return c=c.slice(0,-1),c}if(v.isEmpty)return"";const f=this.locationAt(v.start),p=this.locationAt(v.end),m=this._cells[(d=this._cellUris.get(f.uri))!==null&&d!==void 0?d:-1],b=this._cells[(s=this._cellUris.get(p.uri))!==null&&s!==void 0?s:-1];if(!m||!b)return"";if(m===b)return m.document.getText(new _.Range(f.range.start,p.range.end));{const c=m.document.getText(new _.Range(f.range.start,new _.Position(m.document.lineCount,0))),u=b.document.getText(new _.Range(new _.Position(0,0),p.range.end));return c+`
`+u}}offsetAt(v){const d=this._cellLines.getIndexOf(v.line),s=this._cellLengths.getAccumulatedValue(d.index-1),f=this._cells[d.index].document.offsetAt(v.with(d.remainder));return s+f}positionAt(v){if(typeof v=="number"){const s=this._cellLengths.getIndexOf(v),f=this._cellLines.getAccumulatedValue(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(f)}const d=this._cellUris.get(v.uri);if(d!==void 0){const s=this._cellLines.getAccumulatedValue(d-1);return new _.Position(s+v.range.start.line,v.range.start.character)}return new _.Position(0,0)}locationAt(v){_.Range.isRange(v)||(v=new _.Range(v,v));const d=this._cellLines.getIndexOf(v.start.line);let s=d;v.isEmpty||(s=this._cellLines.getIndexOf(v.end.line));const f=new _.Position(d.remainder,v.start.character),p=new _.Position(s.remainder,v.end.character),m=new _.Range(f,p),b=this._cells[d.index];return new _.Location(b.document.uri,b.document.validateRange(m))}contains(v){return this._cellUris.has(v)}validateRange(v){const d=this.validatePosition(v.start),s=this.validatePosition(v.end);return v.with(d,s)}validatePosition(v){const d=this._cellLines.getIndexOf(v.line),s=new _.Position(d.remainder,v.character),f=this._cells[d.index].document.validatePosition(s),p=this._cellLines.getAccumulatedValue(d.index-1);return new _.Position(p+f.line,f.character)}}e.ExtHostNotebookConcatDocument=A}),define(we[160],Ee([0,1,7,14,3]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(k){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let w=k==="light"?_.ColorThemeKind.Light:k==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(w),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([qe(0,S.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(we[68],Ee([0,1,4]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class S{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=E=>E,this.transformOutgoing=E=>E,this.transformOutgoingURI=E=>E,this.transformOutgoingScheme=E=>E)}}e.URITransformerService=S}),define(we[69],Ee([0,1,2]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function S(P,E,k){const w=P.webviewResourceRoot.replace("{{resource}}",k.scheme+T(k)).replace("{{uuid}}",E);return _.URI.parse(w)}e.asWebviewUri=S;function T(P){return P.toString().replace(/^\S+?:/,"")}}),define(we[161],Ee([0,1,3,6,69,29]),function(ae,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class E{constructor(w,n,A){this._proxy=w,this._editors=n,this._initData=A,this._handlePool=0,this._disposables=new S.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const I=n.getVisibleTextEditors();for(const v of this._insets.values())I.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this._insets.forEach(w=>w.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(w,n,A,I,v){let d;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===w){d=u;break}if(!d)throw new Error("not a visible editor");const s=this,f=this._handlePool++,p=new _.Emitter,m=new _.Emitter,b=new class{constructor(){this._uuid=(0,P.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,T.asWebviewUri)(s._initData,this._uuid,u)}get cspSource(){return s._initData.webviewCspSource}set options(u){this._options=u,s._proxy.$setOptions(f,u)}get options(){return this._options}set html(u){this._html=u,s._proxy.$setHtml(f,u)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(u){return s._proxy.$postMessage(f,u)}},c=new class{constructor(){this.editor=w,this.line=n,this.height=A,this.webview=b,this.onDidDispose=m.event}dispose(){s._insets.has(f)&&(s._insets.delete(f),s._proxy.$disposeEditorInset(f),m.fire(),m.dispose(),p.dispose())}};return this._proxy.$createEditorInset(f,d.id,d.value.document.uri,n+1,A,I||{},v.identifier,v.extensionLocation),this._insets.set(f,{editor:w,inset:c,onDidReceiveMessage:p}),c}$onDidDispose(w){const n=this._insets.get(w);n&&n.inset.dispose()}$onDidReceiveMessage(w,n){const A=this._insets.get(w);A&&A.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=E}),define(we[162],Ee([0,1,3,63,135,4,6,22,30,15,50,23,37,154]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",v.Codicon.window,(0,T.localize)(0,null));var s;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var f;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel"})(f=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(i){switch(i){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;function m(i){return`viewContainer.${i}.enabled`}e.getEnabledViewContainerContextKey=m;class b extends E.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(h,D,C){var g;const y=this.get(h.id);if(y)return y;const R=h;return R.openCommandActionDescriptor=(C==null?void 0:C.donotRegisterOpenCommand)?void 0:(g=R.openCommandActionDescriptor)!==null&&g!==void 0?g:{id:R.id},(0,k.getOrSet)(this.viewContainers,D,[]).push(R),(C==null?void 0:C.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:D}),R}deregisterViewContainer(h){for(const D of this.viewContainers.keys()){const C=this.viewContainers.get(D),g=C==null?void 0:C.indexOf(h);if(g!==-1){C==null||C.splice(g,1),C.length===0&&this.viewContainers.delete(D),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:D});return}}}get(h){return this.all.filter(D=>D.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(D=>this.getViewContainers(D).filter(C=>(C==null?void 0:C.id)===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(D=>this.getViewContainerLocation(D)===h)}}w.Registry.add(s.ViewContainersRegistry,new b);var c;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function u(i,h){var D,C,g,y;const R=(D=i.group)!==null&&D!==void 0?D:c.More,O=(C=h.group)!==null&&C!==void 0?C:c.More;return R!==O?R.localeCompare(O):((g=i.order)!==null&&g!==void 0?g:5)-((y=h.order)!==null&&y!==void 0?y:5)}class a extends E.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(h,D){this.registerViews2([{views:h,viewContainer:D}])}registerViews2(h){h.forEach(({views:D,viewContainer:C})=>this.addViews(D,C)),this._onViewsRegistered.fire(h)}deregisterViews(h,D){const C=this.removeViews(h,D);C.length&&this._onViewsDeregistered.fire({views:C,viewContainer:D})}moveViews(h,D){for(const C of this._views.keys())if(C!==D){const g=this.removeViews(h,C);g.length&&(this.addViews(g,D),this._onDidChangeContainer.fire({views:g,from:C,to:D}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const D of this._viewContainers){const C=(this._views.get(D)||[]).filter(g=>g.id===h)[0];if(C)return C}return null}getViewContainer(h){for(const D of this._viewContainers)if((this._views.get(D)||[]).filter(g=>g.id===h)[0])return D;return null}registerViewWelcomeContent(h,D){return this._viewWelcomeContents.add(h,D),this._onDidChangeViewWelcomeContent.fire(h),(0,E.toDisposable)(()=>{this._viewWelcomeContents.delete(h,D),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,D){const C=new Map;for(const[g,y]of D)this._viewWelcomeContents.add(h,y),C.set(g,(0,E.toDisposable)(()=>{this._viewWelcomeContents.delete(h,y),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),C}getViewWelcomeContent(h){const D=[];return this._viewWelcomeContents.forEach(h,C=>D.push(C)),D.sort(u)}addViews(h,D){let C=this._views.get(D);C||(C=[],this._views.set(D,C),this._viewContainers.push(D));for(const g of h){if(this.getView(g.id)!==null)throw new Error((0,T.localize)(1,null,g.id));C.push(g)}}removeViews(h,D){const C=this._views.get(D);if(!C)return[];const g=[],y=[];for(const R of C)h.includes(R)?g.push(R):y.push(R);return g.length&&(y.length?this._views.set(D,y):(this._views.delete(D),this._viewContainers.splice(this._viewContainers.indexOf(D),1))),g}}w.Registry.add(s.ViewsRegistry,new a),e.IViewsService=(0,P.createDecorator)("viewsService"),e.FocusedViewContext=new S.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(i){return`view.${i}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var r;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class l{constructor(h,D){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,h),this._hasResolve=!!D,this.resolve=async C=>{var g,y;if(D&&!this.resolved){const R=await D(C);R&&(this.tooltip=(g=this.tooltip)!==null&&g!==void 0?g:R.tooltip,this.command=(y=this.command)!==null&&y!==void 0?y:R.command)}C.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=l}),define(we[163],Ee([0,1,2,144,155,19,145,162]),function(ae,e,_,S,T,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function w(f){return(p,...m)=>f(p.get(S.ICommandService),...m)}class n{static execute(p,m){const b={forceReuseWindow:m&&m.reuseWindow,remoteAuthority:m&&m.remoteAuthority};return p.executeCommand("_files.newWindow",b)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",S.CommandsRegistry.registerCommand({id:n.ID,handler:w(n.execute),description:{description:"Opens an new window",args:[]}}),S.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(f,p){return f.get(T.IWorkspacesService).removeRecentlyOpened([p])});class A{static execute(p,m){return typeof m=="string"?m=m.match(/^[^:/?#]+:\/\//)?_.URI.parse(m):_.URI.file(m):m=_.URI.revive(m),p.executeCommand("_workbench.removeFromRecentlyOpened",m)}}e.RemoveFromRecentlyOpenedAPICommand=A,A.ID="vscode.removeFromRecentlyOpened",S.CommandsRegistry.registerCommand(A.ID,w(A.execute));class I{static execute(p,m){const b=typeof m=="string"?{extensionId:m}:m;return p.executeCommand("workbench.action.openIssueReporter",b)}}e.OpenIssueReporter=I,I.ID="vscode.openIssueReporter",S.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(f,p){const m=f.get(T.IWorkspacesService);let b;const c=p.uri,u=p.label,a=p.remoteAuthority;return p.type==="workspace"?b={workspace:await m.getWorkspaceIdentifier(c),label:u,remoteAuthority:a}:p.type==="folder"?b={folderUri:c,label:u,remoteAuthority:a}:b={fileUri:c,label:u,remoteAuthority:a},m.addRecentlyOpened([b])}),S.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(f){return f.get(T.IWorkspacesService).getRecentlyOpened()}),S.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(f,p){const m=f.get(P.ILogService),b=f.get(E.IEnvironmentService);b.isExtensionDevelopment&&!!b.extensionTestsLocationURI&&m.setLevel(p)}),S.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(f){return f.get(P.ILogService).getLevel()}),S.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(f,p){const m=f.get(k.IViewDescriptorService),b=m.getViewContainerById(p.destinationId);if(!!b){for(const c of p.viewIds){const u=m.getViewDescriptorById(c);(u==null?void 0:u.canMoveView)&&m.moveViewsToContainer([u],b,k.ViewVisibilityState.Default)}await f.get(k.IViewsService).openViewContainer(b.id,!0)}});class v{static execute(p,m){return!Array.isArray(m==null?void 0:m.viewIds)||typeof(m==null?void 0:m.destinationId)!="string"?Promise.reject("Invalid arguments"):p.executeCommand("_workbench.action.moveViews",m)}}e.MoveViewsAPICommand=v,v.ID="vscode.moveViews",S.CommandsRegistry.registerCommand({id:v.ID,handler:w(v.execute),description:{description:"Move Views",args:[]}});class d{static execute(p,m){return p.executeCommand("_workbench.open",m)}}d.ID="vscode.open",S.CommandsRegistry.registerCommand(d.ID,w(d.execute));class s{static execute(p,m,b,c,u){return p.executeCommand("_workbench.diff",[m,b,c])}}s.ID="vscode.diff",S.CommandsRegistry.registerCommand(s.ID,w(s.execute))}),define(we[164],Ee([0,1,3,13,136]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,w,n,A){const I={command:k};if(w&&Object.keys(w).length>0&&(I.arguments=w),this.internalSend("request",I),typeof A=="number"){const v=setTimeout(()=>{clearTimeout(v);const d=this.pendingRequests.get(I.seq);if(d){this.pendingRequests.delete(I.seq);const s={type:"response",seq:0,request_seq:I.seq,success:!1,command:k,message:(0,T.localize)(0,null,A,k)};d(s)}},A)}return n&&this.pendingRequests.set(I.seq,n),I.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,w){return k.type!=="event"||w.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,S.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const w=k,n=this.pendingRequests.get(w.request_seq);n&&(this.pendingRequests.delete(w.request_seq),n(w));break}}}internalSend(k,w){w.type=k,w.seq=this.sequence++,this.sendMessage(w)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((w,n)=>k.set(n,w)),await(0,S.timeout)(500),k.forEach((w,n)=>{w({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(we[165],Ee([0,1,8,2,11,23,16]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function w(r,o,l){return r.replace(k,function(i,h){return o&&h.length>0&&h[0]!=="_"?i:l&&l.hasOwnProperty(h)?l[h]:i})}e.formatPII=w;function n(r){const o={};for(const l of Object.keys(r))l.startsWith("!")||(o[l]=r[l]);return o}e.filterExceptionsFromTelemetry=n;function A(r){return r.configuration.request==="attach"&&!I(r)}e.isSessionAttach=A;function I(r){let o=r.configuration.type;if(!!o)return o==="vslsShare"&&(o=r.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(o,"extensionhost")||(0,_.equalsIgnoreCase)(o,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function v(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=v;function d(r,o,l){let i,h=0,D=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,C=null;for(;C=D.exec(r);){let g=C.index+1,y=g+C[0].length;if(g<=o&&y>=l){i=C[0],h=g;break}}if(i){let g=/\w+/g,y=null;for(;(y=g.exec(i))&&!(y.index+1+h+y[0].length>=l););y&&(i=i.substring(0,g.lastIndex))}return i?{start:h,end:h+i.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(r){return!!(r&&r.match(s))}e.isUri=f;function p(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(f(r.path))return S.URI.parse(r.path);if((0,T.isAbsolute)(r.path))return S.URI.file(r.path)}return r.path}function m(r){if(typeof r.path=="object"){const o=S.URI.revive(r.path);if(o)return o.scheme===E.Schemas.file?o.fsPath:o.toString()}return r.path}function b(r,o){const l=o?p:m,i=(0,P.deepClone)(r);return u(i,(h,D)=>{h&&D&&(D.path=l(D))}),i}e.convertToDAPaths=b;function c(r,o){const l=o?p:m,i=(0,P.deepClone)(r);return u(i,(h,D)=>{!h&&D&&(D.path=l(D))}),i}e.convertToVSCPaths=c;function u(r,o){switch(r.type){case"event":const l=r;switch(l.event){case"output":o(!1,l.body.source);break;case"loadedSource":o(!1,l.body.source);break;case"breakpoint":o(!1,l.body.breakpoint.source);break;default:break}break;case"request":const i=r;switch(i.command){case"setBreakpoints":o(!0,i.arguments.source);break;case"breakpointLocations":o(!0,i.arguments.source);break;case"source":o(!0,i.arguments.source);break;case"gotoTargets":o(!0,i.arguments.source);break;case"launchVSCode":i.arguments.args.forEach(D=>o(!1,D));break;default:break}break;case"response":const h=r;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(D=>o(!1,D.source));break;case"loadedSources":h.body.sources.forEach(D=>o(!1,D));break;case"scopes":h.body.scopes.forEach(D=>o(!1,D.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(D=>o(!1,D.source));break;case"setBreakpoints":h.body.breakpoints.forEach(D=>o(!1,D.source));break;default:break}break}}function a(r){return r.filter(o=>{var l;return!((l=o.presentation)===null||l===void 0?void 0:l.hidden)}).sort((o,l)=>o.presentation?l.presentation?o.presentation.group?l.presentation.group?o.presentation.group!==l.presentation.group?o.presentation.group.localeCompare(l.presentation.group):t(o.presentation.order,l.presentation.order):-1:l.presentation.group?1:t(o.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=a;function t(r,o){return typeof r!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:r-o}}),define(we[70],Ee([0,1,28,16,11,21,63]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellRunState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(C){C[C.Markdown=1]="Markdown",C[C.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(C){C[C.Running=1]="Running",C[C.Idle=2]="Idle"})(w=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,cellHasExecutionOrder:!0,custom:{},runState:w.Idle,trusted:!0};var n;(function(C){C[C.Running=1]="Running",C[C.Idle=2]="Idle",C[C.Success=3]="Success",C[C.Error=4]="Error"})(n=e.NotebookCellRunState||(e.NotebookCellRunState={}));var A;(function(C){C[C.ModelChange=1]="ModelChange",C[C.Move=2]="Move",C[C.CellClearOutput=3]="CellClearOutput",C[C.CellsClearOutput=4]="CellsClearOutput",C[C.ChangeLanguage=5]="ChangeLanguage",C[C.Initialize=6]="Initialize",C[C.ChangeCellMetadata=7]="ChangeCellMetadata",C[C.Output=8]="Output",C[C.OutputItem=9]="OutputItem",C[C.ChangeCellContent=10]="ChangeCellContent",C[C.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",C[C.Unknown=12]="Unknown"})(A=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var I;(function(C){C[C.Handle=0]="Handle",C[C.Index=1]="Index"})(I=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(C){C[C.Replace=1]="Replace",C[C.Output=2]="Output",C[C.Metadata=3]="Metadata",C[C.CellLanguage=4]="CellLanguage",C[C.DocumentMetadata=5]="DocumentMetadata",C[C.OutputsSplice=6]="OutputsSplice",C[C.Move=7]="Move",C[C.Unknown=8]="Unknown",C[C.CellContent=9]="CellContent",C[C.OutputItems=10]="OutputItems"})(v=e.CellEditType||(e.CellEditType={}));function d(C){const g=s.parse(C);return g?g.notebook.toString():C.toString()}e.getCellUndoRedoComparisonKey=d;var s;(function(C){C.scheme=S.Schemas.vscodeNotebookCell;const g=/^ch(\d{7,})/;function y(z,Q){return z.with({scheme:C.scheme,fragment:`ch${Q.toString().padStart(7,"0")}${z.scheme!==S.Schemas.file?z.scheme:""}`})}C.generate=y;function R(z){if(z.scheme===C.scheme){const Q=g.exec(z.fragment);if(!!Q)return{handle:Number(Q[1]),notebook:z.with({scheme:z.fragment.substr(Q[0].length)||S.Schemas.file,fragment:null})}}}C.parse=R;function O(z,Q){return z.with({scheme:S.Schemas.vscodeNotebookCellMetadata,fragment:`ch${Q.toString().padStart(7,"0")}${z.scheme!==S.Schemas.file?z.scheme:""}`})}C.generateCellMetadataUri=O;function x(z){if(z.scheme===S.Schemas.vscodeNotebookCellMetadata){const Q=g.exec(z.fragment);if(!!Q)return{handle:Number(Q[1]),notebook:z.with({scheme:z.fragment.substr(Q[0].length)||S.Schemas.file,fragment:null})}}}C.parseCellMetadataUri=x})(s=e.CellUri||(e.CellUri={}));const f=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}]]);function p(C){var g,y;return(y=(g=f.get(C))===null||g===void 0?void 0:g.alwaysSecure)!==null&&y!==void 0?y:!1}e.mimeTypeIsAlwaysSecure=p;function m(C){var g,y;return(y=(g=f.get(C))===null||g===void 0?void 0:g.supportedByCore)!==null&&y!==void 0?y:!1}e.mimeTypeSupportedByCore=m;function b(C,g){return P.isWindows&&(C=C.replace(/\//g,"\\"),g=g.replace(/\//g,"\\")),_.match(C,g)}function c(C,g,y){let R=0;for(let O=0;O<g.length;O++){if(b(g[O],C))return R;R++}for(let O=0;O<y.length;O++){if(b(y[O],C))return R;R++}return R}function u(C,g,y){return C.sort((R,O)=>c(R,g,y)-c(O,g,y))}e.sortMimeTypes=u;function a(C,g,y,R=(O,x)=>O===x){const O=[];function x(j,Y,L){if(!(Y===0&&L.length===0)){const $=O[O.length-1];$&&$.start+$.deleteCount===j?($.deleteCount+=Y,$.toInsert.push(...L)):O.push({start:j,deleteCount:Y,toInsert:L})}}let z=0,Q=0;for(;;){if(z===C.length){x(z,0,g.slice(Q));break}if(Q===g.length){x(z,C.length-z,[]);break}const j=C[z],Y=g[Q];if(R(j,Y)){z+=1,Q+=1;continue}y(Y)?(x(z,1,[]),z+=1):(x(z,0,[Y]),Q+=1)}return O}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new E.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var t;(function(C){C.default="default",C.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(C){const g=C;return!!((typeof g.include=="string"||_.isRelativePattern(g.include))&&(typeof g.exclude=="string"||_.isRelativePattern(g.exclude)))}e.isDocumentExcludePattern=r;function o(C,g,y){if(Array.isArray(C.viewType)&&C.viewType.indexOf(g)>=0||C.viewType===g)return!0;if(C.filenamePattern){let R=r(C.filenamePattern)?C.filenamePattern.include:C.filenamePattern,O=r(C.filenamePattern)?C.filenamePattern.exclude:void 0;if(_.match(R,(0,T.basename)(y.fsPath).toLowerCase()))return!(O&&_.match(O,(0,T.basename)(y.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class l{constructor(g){this.textModel=g}getElements(){const g=new Int32Array(this.textModel.cells.length);for(let y=0;y<this.textModel.cells.length;y++)g[y]=this.textModel.cells[y].getHashValue();return g}}e.CellSequence=l,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var i;(function(C){C[C.LEFT=0]="LEFT",C[C.RIGHT=1]="RIGHT"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function h(C){const g=C.shift();return g===void 0?[]:C.reduce(function(y,R){return R<=y[0][1]?y[0][1]=R+1:y.unshift([R,R+1]),y},[[g,g+1]]).reverse().map(y=>({start:y[0],end:y[1]}))}e.cellIndexesToRanges=h;function D(C){return C.reduce((y,R)=>{for(let O=R.start;O<R.end;O++)y.push(O);return y},[])}e.cellRangesToIndexes=D}),define(we[166],Ee([0,1,138,4,63]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,_.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,_.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,_.localize(2,null)),e.ITaskService=(0,S.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[167],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=_;function S(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=S}),define(we[168],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=void 0;var _;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.Remove=2]="Remove",E[E.DeltaDiscoverComplete=3]="DeltaDiscoverComplete",E[E.DeltaRootsComplete=4]="DeltaRootsComplete"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));const S=(E,k)=>`${E}:${k.toString()}`;e.getTestSubscriptionKey=S;class T{add(k){}update(k){}remove(k,w){}complete(){}}e.IncrementalChangeCollector=T;class P{constructor(){this.items=new Map,this.roots=new Set}apply(k){const w=this.createChangeCollector();for(const n of k)switch(n[0]){case 0:{const A=n[1];if(A.parent){if(this.items.has(A.parent)){const I=this.items.get(A.parent);I.children.add(A.item.extId);const v=this.createItem(A,I);this.items.set(A.item.extId,v),w.add(v)}}else{this.roots.add(A.item.extId);const I=this.createItem(A);this.items.set(A.item.extId,I),w.add(I)}break}case 1:{const A=n[1],I=this.items.get(A.item.extId);I&&(Object.assign(I.item,A.item),w.update(I));break}case 2:{const A=this.items.get(n[1]);if(!A)break;A.parent?this.items.get(A.parent).children.delete(A.item.extId):this.roots.delete(A.item.extId);const I=[[n[1]]];for(;I.length;)for(const v of I.pop()){const d=this.items.get(v);d&&(I.push(d.children),this.items.delete(v),w.remove(d,d!==A))}break}case 3:this.updateBusyProviders(n[1]);break;case 4:this.updatePendingRoots(n[1]);break}w.complete()}updateBusyProviders(k){}updatePendingRoots(k){}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=P}),define(we[169],Ee([0,1,11,36,12,23,21,58,139]),function(ae,e,_,S,T,P,E,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(I,v,d){if(this._contributedVariables=new Map,this._context=I,this._labelService=v,d)if(E.isWindows){const s=Object.create(null);this._envVariables=s,Object.keys(d).forEach(f=>{s[f.toLowerCase()]=d[f]})}else this._envVariables=d}resolve(I,v){return this.recursiveResolve(I?I.uri:void 0,v)}resolveAnyBase(I,v,d,s){const f=P.deepClone(v);return E.isWindows&&f.windows?Object.keys(f.windows).forEach(p=>f[p]=f.windows[p]):E.isMacintosh&&f.osx?Object.keys(f.osx).forEach(p=>f[p]=f.osx[p]):E.isLinux&&f.linux&&Object.keys(f.linux).forEach(p=>f[p]=f.linux[p]),delete f.windows,delete f.osx,delete f.linux,this.recursiveResolve(I?I.uri:void 0,f,d,s)}resolveAny(I,v,d){return this.resolveAnyBase(I,v,d)}resolveAnyMap(I,v,d){const s=new Map;return{newConfig:this.resolveAnyBase(I,v,d,s),resolvedVariables:s}}resolveWithInteractionReplace(I,v,d,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,v,d,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,v){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,v)}recursiveResolve(I,v,d,s){if(T.isString(v))return this.resolveString(I,v,d,s);if(T.isArray(v))return v.map(f=>this.recursiveResolve(I,f,d,s));if(T.isObject(v)){let f=Object.create(null);return Object.keys(v).forEach(p=>{const m=this.resolveString(I,p,d,s);f[m]=this.recursiveResolve(I,v[p],d,s)}),f}return v}resolveString(I,v,d,s){return v.replace(n.VARIABLE_REGEXP,(p,m)=>{if(m.includes(n.VARIABLE_LHS))return p;let b=this.evaluateSingleVariable(p,m,I,d);return s&&s.set(m,b),b})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,v,d,s){let f;const p=v.split(":");p.length>1&&(v=p[0],f=p[1]);const m=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,w.localize)(0,null,I))},b=()=>{const u=m();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,w.localize)(1,null,I,_.basename(u)))},c=()=>{if(f){const u=this._context.getFolderUri(f);if(u)return u;throw new Error((0,w.localize)(2,null,I,f))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new Error((0,w.localize)(3,null,I)):new Error((0,w.localize)(4,null,I))};switch(v){case"env":if(f){if(this._envVariables){const u=this._envVariables[E.isWindows?f.toLowerCase():f];if(T.isString(u))return u}return""}throw new Error((0,w.localize)(5,null,I));case"config":if(f){const u=this._context.getConfigurationValue(d,f);if(T.isUndefinedOrNull(u))throw new Error((0,w.localize)(6,null,I,f));if(T.isObject(u))throw new Error((0,w.localize)(7,null,I,f));return u}throw new Error((0,w.localize)(8,null,I));case"command":return this.resolveFromMap(I,f,s,"command");case"input":return this.resolveFromMap(I,f,s,"input");default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return d||f?(0,k.normalizeDriveLetter)(this.fsPath(c())):S.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(c()));case"lineNumber":const u=this._context.getLineNumber();if(u)return u;throw new Error((0,w.localize)(9,null,I));case"selectedText":const a=this._context.getSelectedText();if(a)return a;throw new Error((0,w.localize)(10,null,I));case"file":return m();case"fileWorkspaceFolder":return b();case"relativeFile":return d||f?_.relative(this.fsPath(c()),m()):m();case"relativeFileDirname":const t=_.dirname(m());if(d||f){const i=_.relative(this.fsPath(c()),t);return i.length===0?".":i}return t;case"fileDirname":return _.dirname(m());case"fileExtname":return _.extname(m());case"fileBasename":return _.basename(m());case"fileBasenameNoExtension":const r=_.basename(m());return r.slice(0,r.length-_.extname(r).length);case"fileDirnameBasename":return _.basename(_.dirname(m()));case"execPath":const o=this._context.getExecPath();return o||I;case"execInstallFolder":const l=this._context.getAppRoot();return l||I;case"pathSeparator":return _.sep;default:try{const i=f?`${v}:${f}`:v;return this.resolveFromMap(I,i,s,void 0)}catch(i){return I}}}}resolveFromMap(I,v,d,s){if(v&&d){const f=s===void 0?d[v]:d[s+":"+v];if(typeof f=="string")return f;throw new Error((0,w.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[170],Ee([0,1,4]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var S;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var T;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var E;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(E=e.GroupsArrangement||(e.GroupsArrangement={}));var k;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(k=e.MergeGroupMode||(e.MergeGroupMode={}));var w;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(w=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.EDITOR_OPEN=2]="EDITOR_OPEN",v[v.EDITOR_CLOSE=3]="EDITOR_CLOSE",v[v.EDITOR_MOVE=4]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=6]="EDITOR_LABEL",v[v.EDITOR_PIN=7]="EDITOR_PIN",v[v.EDITOR_STICKY=8]="EDITOR_STICKY",v[v.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var A;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(A=e.OpenEditorContext||(e.OpenEditorContext={}));function I(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(we[171],Ee([0,1,4]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(we[9],Ee([0,1,62,7,140,2,32,80,87,171,12,224,57,23,15,70]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.TestState=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(me){function he(G){const{selectionStartLineNumber:Ie,selectionStartColumn:Pe,positionLineNumber:et,positionColumn:Ge}=G,rt=new S.Position(Ie-1,Pe-1),lt=new S.Position(et-1,Ge-1);return new S.Selection(rt,lt)}me.to=he;function ue(G){const{anchor:Ie,active:Pe}=G;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}me.from=ue})(p=e.Selection||(e.Selection={}));var m;(function(me){function he(G){if(!!G){const{start:Ie,end:Pe}=G;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}}me.from=he;function ue(G){if(!!G){const{startLineNumber:Ie,startColumn:Pe,endLineNumber:et,endColumn:Ge}=G;return new S.Range(Ie-1,Pe-1,et-1,Ge-1)}}me.to=ue})(m=e.Range||(e.Range={}));var b;(function(me){function he(ue){switch(ue){case 1:return S.StandardTokenType.Comment;case 0:return S.StandardTokenType.Other;case 4:return S.StandardTokenType.RegEx;case 2:return S.StandardTokenType.String}}me.to=he})(b=e.TokenType||(e.TokenType={}));var c;(function(me){function he(G){return new S.Position(G.lineNumber-1,G.column-1)}me.to=he;function ue(G){return{lineNumber:G.line+1,column:G.character+1}}me.from=ue})(c=e.Position||(e.Position={}));var u;(function(me){function he(G){switch(G){case S.DiagnosticTag.Unnecessary:return 1;case S.DiagnosticTag.Deprecated:return 2}}me.from=he;function ue(G){switch(G){case 1:return S.DiagnosticTag.Unnecessary;case 2:return S.DiagnosticTag.Deprecated;default:return}}me.to=ue})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var a;(function(me){function he(G){let Ie;return G.code&&((0,A.isString)(G.code)||(0,A.isNumber)(G.code)?Ie=String(G.code):Ie={value:String(G.code.value),target:G.code.target}),Object.assign(Object.assign({},m.from(G.range)),{message:G.message,source:G.source,code:Ie,severity:r.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(t.from),tags:Array.isArray(G.tags)?(0,s.coalesce)(G.tags.map(u.from)):void 0})}me.from=he;function ue(G){var Ie;const Pe=new S.Diagnostic(m.to(G),G.message,r.to(G.severity));return Pe.source=G.source,Pe.code=(0,A.isString)(G.code)?G.code:(Ie=G.code)===null||Ie===void 0?void 0:Ie.value,Pe.relatedInformation=G.relatedInformation&&G.relatedInformation.map(t.to),Pe.tags=G.tags&&(0,s.coalesce)(G.tags.map(u.to)),Pe}me.to=ue})(a=e.Diagnostic||(e.Diagnostic={}));var t;(function(me){function he(G){return Object.assign(Object.assign({},m.from(G.location.range)),{message:G.message,resource:G.location.uri})}me.from=he;function ue(G){return new S.DiagnosticRelatedInformation(new S.Location(G.resource,m.to(G)),G.message)}me.to=ue})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(me){function he(G){switch(G){case S.DiagnosticSeverity.Error:return w.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return w.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return w.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return w.MarkerSeverity.Hint}return w.MarkerSeverity.Error}me.from=he;function ue(G){switch(G){case w.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case w.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case w.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case w.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}me.to=ue})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(me){function he(G){return typeof G=="number"&&G>=S.ViewColumn.One?G-1:G===S.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}me.from=he;function ue(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=ue})(o=e.ViewColumn||(e.ViewColumn={}));function l(me){return typeof me.range!="undefined"}function i(me){return me.length===0?!0:!!l(me[0])}e.isDecorationOptionsArr=i;var h;(function(me){function he(Ge){return Ge.map(me.from)}me.fromMany=he;function ue(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function G(Ge){let rt;if(ue(Ge)){const{language:dt,value:at}=Ge;rt={value:"```"+dt+`
`+at+"\n```\n"}}else S.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const lt=Object.create(null);rt.uris=lt;const Je=dt=>{try{let at=P.URI.parse(dt,!0);at=at.with({query:Ie(at.query,lt)}),lt[dt]=at}catch(at){}return""},it=new I.Renderer;return it.link=Je,it.image=dt=>Je(k.parseHrefAndDimensions(dt).href),I(rt.value,{renderer:it}),rt}me.from=G;function Ie(Ge,rt){if(!Ge)return Ge;let lt;try{lt=(0,v.parse)(Ge)}catch(it){}if(!lt)return Ge;let Je=!1;return lt=(0,d.cloneAndChange)(lt,it=>{if(P.URI.isUri(it)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[dt]=it,Je=!0,dt}else return}),Je?JSON.stringify(lt):Ge}function Pe(Ge){const rt=new S.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt}me.to=Pe;function et(Ge){if(!!Ge)return typeof Ge=="string"?Ge:me.from(Ge)}me.fromStrict=et})(h=e.MarkdownString||(e.MarkdownString={}));function D(me){return i(me)?me.map(he=>({range:m.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?h.fromMany(he.hoverMessage):he.hoverMessage?h.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):me.map(he=>({range:m.from(he)}))}e.fromRangeOrRangeWithMessage=D;function C(me){return typeof me=="undefined"?me:typeof me=="string"?P.URI.file(me):me}e.pathOrURIToURI=C;var g;(function(me){function he(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?C(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}me.from=he})(g=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var y;(function(me){function he(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?C(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?g.from(ue.before):void 0,after:ue.after?g.from(ue.after):void 0}}me.from=he})(y=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(me){function he(ue){if(typeof ue=="undefined")return ue;switch(ue){case S.DecorationRangeBehavior.OpenOpen:return 0;case S.DecorationRangeBehavior.ClosedClosed:return 1;case S.DecorationRangeBehavior.OpenClosed:return 2;case S.DecorationRangeBehavior.ClosedOpen:return 3}}me.from=he})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(me){function he(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?R.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?y.from(ue.light):void 0,dark:ue.dark?y.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?C(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?g.from(ue.before):void 0,after:ue.after?g.from(ue.after):void 0}}me.from=he})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var x;(function(me){function he(G){return{text:G.newText,eol:G.newEol&&Z.from(G.newEol),range:m.from(G.range)}}me.from=he;function ue(G){const Ie=new S.TextEdit(m.to(G.range),G.text);return Ie.newEol=typeof G.eol=="undefined"?void 0:Z.to(G.eol),Ie}me.to=ue})(x=e.TextEdit||(e.TextEdit={}));var z;(function(me){function he(G,Ie,Pe){var et,Ge,rt;const lt={edits:[]};if(G instanceof S.WorkspaceEdit)for(let Je of G._allEntries())if(Je._type===1)lt.edits.push({_type:1,oldUri:Je.from,newUri:Je.to,options:Je.options,metadata:Je.metadata});else if(Je._type===2){const it=Ie==null?void 0:Ie.getDocument(Je.uri);lt.edits.push({_type:2,resource:Je.uri,edit:x.from(Je.edit),modelVersionId:it==null?void 0:it.version,metadata:Je.metadata})}else Je._type===3?lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:(et=Pe==null?void 0:Pe.lookupNotebookDocument(Je.uri))===null||et===void 0?void 0:et.notebookDocument.version}):Je._type===4?(Je.newOutputs&&lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:2,index:Je.index,append:Je.append,outputs:Je.newOutputs.map(ve.from)}}),Je.newMetadata&&lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:3,index:Je.index,metadata:Je.newMetadata}})):Je._type===5?lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,notebookVersionId:(Ge=Pe==null?void 0:Pe.lookupNotebookDocument(Je.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(oe.from)}}):Je._type===6&&lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:10,index:Je.index,outputId:Je.outputId,items:((rt=Je.newOutputItems)===null||rt===void 0?void 0:rt.map(fe.from))||[],append:Je.append}});return lt}me.from=he;function ue(G){const Ie=new S.WorkspaceEdit;for(const Pe of G.edits)Pe.edit?Ie.replace(P.URI.revive(Pe.resource),m.to(Pe.edit.range),Pe.edit.text):Ie.renameFile(P.URI.revive(Pe.oldUri),P.URI.revive(Pe.newUri),Pe.options);return Ie}me.to=ue})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(me){const he=Object.create(null);he[S.SymbolKind.File]=0,he[S.SymbolKind.Module]=1,he[S.SymbolKind.Namespace]=2,he[S.SymbolKind.Package]=3,he[S.SymbolKind.Class]=4,he[S.SymbolKind.Method]=5,he[S.SymbolKind.Property]=6,he[S.SymbolKind.Field]=7,he[S.SymbolKind.Constructor]=8,he[S.SymbolKind.Enum]=9,he[S.SymbolKind.Interface]=10,he[S.SymbolKind.Function]=11,he[S.SymbolKind.Variable]=12,he[S.SymbolKind.Constant]=13,he[S.SymbolKind.String]=14,he[S.SymbolKind.Number]=15,he[S.SymbolKind.Boolean]=16,he[S.SymbolKind.Array]=17,he[S.SymbolKind.Object]=18,he[S.SymbolKind.Key]=19,he[S.SymbolKind.Null]=20,he[S.SymbolKind.EnumMember]=21,he[S.SymbolKind.Struct]=22,he[S.SymbolKind.Event]=23,he[S.SymbolKind.Operator]=24,he[S.SymbolKind.TypeParameter]=25;function ue(Ie){return typeof he[Ie]=="number"?he[Ie]:6}me.from=ue;function G(Ie){for(const Pe in he)if(he[Pe]===Ie)return Number(Pe);return S.SymbolKind.Property}me.to=G})(Q=e.SymbolKind||(e.SymbolKind={}));var j;(function(me){function he(G){switch(G){case S.SymbolTag.Deprecated:return 1}}me.from=he;function ue(G){switch(G){case 1:return S.SymbolTag.Deprecated}}me.to=ue})(j=e.SymbolTag||(e.SymbolTag={}));var Y;(function(me){function he(G){return{name:G.name,kind:Q.from(G.kind),tags:G.tags&&G.tags.map(j.from),containerName:G.containerName,location:U.from(G.location)}}me.from=he;function ue(G){const Ie=new S.SymbolInformation(G.name,Q.to(G.kind),G.containerName,U.to(G.location));return Ie.tags=G.tags&&G.tags.map(j.to),Ie}me.to=ue})(Y=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var L;(function(me){function he(G){var Ie,Pe;const et={name:G.name||"!!MISSING: name!!",detail:G.detail,range:m.from(G.range),selectionRange:m.from(G.selectionRange),kind:Q.from(G.kind),tags:(Pe=(Ie=G.tags)===null||Ie===void 0?void 0:Ie.map(j.from))!==null&&Pe!==void 0?Pe:[]};return G.children&&(et.children=G.children.map(he)),et}me.from=he;function ue(G){const Ie=new S.DocumentSymbol(G.name,G.detail,Q.to(G.kind),m.to(G.range),m.to(G.selectionRange));return(0,s.isNonEmptyArray)(G.tags)&&(Ie.tags=G.tags.map(j.to)),G.children&&(Ie.children=G.children.map(ue)),Ie}me.to=ue})(L=e.DocumentSymbol||(e.DocumentSymbol={}));var $;(function(me){function he(ue){const G=new S.CallHierarchyItem(Q.to(ue.kind),ue.name,ue.detail||"",P.URI.revive(ue.uri),m.to(ue.range),m.to(ue.selectionRange));return G._sessionId=ue._sessionId,G._itemId=ue._itemId,G}me.to=he})($=e.CallHierarchyItem||(e.CallHierarchyItem={}));var W;(function(me){function he(ue){return new S.CallHierarchyIncomingCall($.to(ue.from),ue.fromRanges.map(G=>m.to(G)))}me.to=he})(W=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var K;(function(me){function he(ue){return new S.CallHierarchyOutgoingCall($.to(ue.to),ue.fromRanges.map(G=>m.to(G)))}me.to=he})(K=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(me){function he(G){return{range:G.range&&m.from(G.range),uri:G.uri}}me.from=he;function ue(G){return new S.Location(P.URI.revive(G.uri),m.to(G.range))}me.to=ue})(U=e.location||(e.location={}));var ee;(function(me){function he(G){const Ie=G,Pe=G;return{originSelectionRange:Ie.originSelectionRange?m.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Pe.uri,range:m.from(Ie.targetRange?Ie.targetRange:Pe.range),targetSelectionRange:Ie.targetSelectionRange?m.from(Ie.targetSelectionRange):void 0}}me.from=he;function ue(G){return{targetUri:P.URI.revive(G.uri),targetRange:m.to(G.range),targetSelectionRange:G.targetSelectionRange?m.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?m.to(G.originSelectionRange):void 0}}me.to=ue})(ee=e.DefinitionLink||(e.DefinitionLink={}));var ie;(function(me){function he(G){return{range:m.from(G.range),contents:h.fromMany(G.contents)}}me.from=he;function ue(G){return new S.Hover(G.contents.map(h.to),m.to(G.range))}me.to=ue})(ie=e.Hover||(e.Hover={}));var se;(function(me){function he(G){return{range:m.from(G.range),expression:G.expression}}me.from=he;function ue(G){return new S.EvaluatableExpression(m.to(G.range),G.expression)}me.to=ue})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(me){function he(G){if(G instanceof S.InlineValueText)return{type:"text",range:m.from(G.range),text:G.text};if(G instanceof S.InlineValueVariableLookup)return{type:"variable",range:m.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}me.from=he;function ue(G){switch(G.type){case"text":return{range:m.to(G.range),text:G.text};case"variable":return{range:m.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:m.to(G.range),expression:G.expression}}}me.to=ue})(Se=e.InlineValue||(e.InlineValue={}));var Ae;(function(me){function he(G){return{frameId:G.frameId,stoppedLocation:m.from(G.stoppedLocation)}}me.from=he;function ue(G){return new S.InlineValueContext(G.frameId,m.to(G.stoppedLocation))}me.to=ue})(Ae=e.InlineValueContext||(e.InlineValueContext={}));var Be;(function(me){function he(G){return{range:m.from(G.range),kind:G.kind}}me.from=he;function ue(G){return new S.DocumentHighlight(m.to(G.range),G.kind)}me.to=ue})(Be=e.DocumentHighlight||(e.DocumentHighlight={}));var Re;(function(me){function he(ue){switch(ue){case 1:return S.CompletionTriggerKind.TriggerCharacter;case 2:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return S.CompletionTriggerKind.Invoke}}me.to=he})(Re=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var xe;(function(me){function he(ue){return{triggerKind:Re.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}me.to=he})(xe=e.CompletionContext||(e.CompletionContext={}));var N;(function(me){function he(G){switch(G){case S.CompletionItemTag.Deprecated:return 1}}me.from=he;function ue(G){switch(G){case 1:return S.CompletionItemTag.Deprecated}}me.to=ue})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(me){const he=new Map([[S.CompletionItemKind.Method,0],[S.CompletionItemKind.Function,1],[S.CompletionItemKind.Constructor,2],[S.CompletionItemKind.Field,3],[S.CompletionItemKind.Variable,4],[S.CompletionItemKind.Class,5],[S.CompletionItemKind.Interface,7],[S.CompletionItemKind.Struct,6],[S.CompletionItemKind.Module,8],[S.CompletionItemKind.Property,9],[S.CompletionItemKind.Unit,12],[S.CompletionItemKind.Value,13],[S.CompletionItemKind.Constant,14],[S.CompletionItemKind.Enum,15],[S.CompletionItemKind.EnumMember,16],[S.CompletionItemKind.Keyword,17],[S.CompletionItemKind.Snippet,27],[S.CompletionItemKind.Text,18],[S.CompletionItemKind.Color,19],[S.CompletionItemKind.File,20],[S.CompletionItemKind.Reference,21],[S.CompletionItemKind.Folder,23],[S.CompletionItemKind.Event,10],[S.CompletionItemKind.Operator,11],[S.CompletionItemKind.TypeParameter,24],[S.CompletionItemKind.Issue,26],[S.CompletionItemKind.User,25]]);function ue(Pe){var et;return(et=he.get(Pe))!==null&&et!==void 0?et:9}me.from=ue;const G=new Map([[0,S.CompletionItemKind.Method],[1,S.CompletionItemKind.Function],[2,S.CompletionItemKind.Constructor],[3,S.CompletionItemKind.Field],[4,S.CompletionItemKind.Variable],[5,S.CompletionItemKind.Class],[7,S.CompletionItemKind.Interface],[6,S.CompletionItemKind.Struct],[8,S.CompletionItemKind.Module],[9,S.CompletionItemKind.Property],[12,S.CompletionItemKind.Unit],[13,S.CompletionItemKind.Value],[14,S.CompletionItemKind.Constant],[15,S.CompletionItemKind.Enum],[16,S.CompletionItemKind.EnumMember],[17,S.CompletionItemKind.Keyword],[27,S.CompletionItemKind.Snippet],[18,S.CompletionItemKind.Text],[19,S.CompletionItemKind.Color],[20,S.CompletionItemKind.File],[21,S.CompletionItemKind.Reference],[23,S.CompletionItemKind.Folder],[10,S.CompletionItemKind.Event],[11,S.CompletionItemKind.Operator],[24,S.CompletionItemKind.TypeParameter],[25,S.CompletionItemKind.User],[26,S.CompletionItemKind.Issue]]);function Ie(Pe){var et;return(et=G.get(Pe))!==null&&et!==void 0?et:S.CompletionItemKind.Property}me.to=Ie})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(me){function he(ue,G){var Ie;const Pe=new S.CompletionItem(typeof ue.label=="string"?ue.label:ue.label.name);return typeof ue.label!="string"&&(Pe.label2=ue.label),Pe.insertText=ue.insertText,Pe.kind=q.to(ue.kind),Pe.tags=(Ie=ue.tags)===null||Ie===void 0?void 0:Ie.map(N.to),Pe.detail=ue.detail,Pe.documentation=k.isMarkdownString(ue.documentation)?h.to(ue.documentation):ue.documentation,Pe.sortText=ue.sortText,Pe.filterText=ue.filterText,Pe.preselect=ue.preselect,Pe.commitCharacters=ue.commitCharacters,E.Range.isIRange(ue.range)?Pe.range=m.to(ue.range):typeof ue.range=="object"&&(Pe.range={inserting:m.to(ue.range.insert),replacing:m.to(ue.range.replace)}),Pe.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Pe.insertText=new S.SnippetString(ue.insertText):(Pe.insertText=ue.insertText,Pe.textEdit=Pe.range instanceof S.Range?new S.TextEdit(Pe.range,Pe.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Pe.additionalTextEdits=ue.additionalTextEdits.map(et=>x.to(et))),Pe.command=G&&ue.command?G.fromInternal(ue.command):void 0,Pe}me.to=he})(J=e.CompletionItem||(e.CompletionItem={}));var le;(function(me){function he(G){return{label:G.label,documentation:G.documentation?h.fromStrict(G.documentation):void 0}}me.from=he;function ue(G){return{label:G.label,documentation:k.isMarkdownString(G.documentation)?h.to(G.documentation):G.documentation}}me.to=ue})(le=e.ParameterInformation||(e.ParameterInformation={}));var ge;(function(me){function he(G){return{label:G.label,documentation:G.documentation?h.fromStrict(G.documentation):void 0,parameters:Array.isArray(G.parameters)?G.parameters.map(le.from):[],activeParameter:G.activeParameter}}me.from=he;function ue(G){return{label:G.label,documentation:k.isMarkdownString(G.documentation)?h.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(le.to):[],activeParameter:G.activeParameter}}me.to=ue})(ge=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(me){function he(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(ge.from):[]}}me.from=he;function ue(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(ge.to):[]}}me.to=ue})(De=e.SignatureHelp||(e.SignatureHelp={}));var Le;(function(me){function he(G){var Ie;return{text:G.text,range:m.from(G.range),kind:pe.from((Ie=G.kind)!==null&&Ie!==void 0?Ie:S.InlineHintKind.Other),description:G.description&&h.fromStrict(G.description),whitespaceBefore:G.whitespaceBefore,whitespaceAfter:G.whitespaceAfter}}me.from=he;function ue(G){const Ie=new S.InlineHint(G.text,m.to(G.range),pe.to(G.kind));return Ie.whitespaceAfter=G.whitespaceAfter,Ie.whitespaceBefore=G.whitespaceBefore,Ie.description=k.isMarkdownString(G.description)?h.to(G.description):G.description,Ie}me.to=ue})(Le=e.InlineHint||(e.InlineHint={}));var pe;(function(me){function he(G){return G}me.from=he;function ue(G){return G}me.to=ue})(pe=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(me){function he(G){return{range:m.from(G.range),url:G.target,tooltip:G.tooltip}}me.from=he;function ue(G){let Ie;if(G.url)try{Ie=typeof G.url=="string"?P.URI.parse(G.url,!0):P.URI.revive(G.url)}catch(Pe){}return new S.DocumentLink(m.to(G.range),Ie)}me.to=ue})(Ce=e.DocumentLink||(e.DocumentLink={}));var Te;(function(me){function he(G){const Ie=new S.ColorPresentation(G.label);return G.textEdit&&(Ie.textEdit=x.to(G.textEdit)),G.additionalTextEdits&&(Ie.additionalTextEdits=G.additionalTextEdits.map(Pe=>x.to(Pe))),Ie}me.to=he;function ue(G){return{label:G.label,textEdit:G.textEdit?x.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ie=>x.from(Ie)):void 0}}me.from=ue})(Te=e.ColorPresentation||(e.ColorPresentation={}));var Ue;(function(me){function he(G){return new S.Color(G[0],G[1],G[2],G[3])}me.to=he;function ue(G){return[G.red,G.green,G.blue,G.alpha]}me.from=ue})(Ue=e.Color||(e.Color={}));var be;(function(me){function he(G){return{range:m.from(G.range)}}me.from=he;function ue(G){return new S.SelectionRange(m.to(G.range))}me.to=ue})(be=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(me){function he(ue){switch(ue){case 2:return S.TextDocumentSaveReason.AfterDelay;case 1:return S.TextDocumentSaveReason.Manual;case 3:case 4:return S.TextDocumentSaveReason.FocusOut}}me.to=he})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var H;(function(me){function he(G){switch(G){case S.TextEditorLineNumbersStyle.Off:return 0;case S.TextEditorLineNumbersStyle.Relative:return 2;case S.TextEditorLineNumbersStyle.On:default:return 1}}me.from=he;function ue(G){switch(G){case 0:return S.TextEditorLineNumbersStyle.Off;case 2:return S.TextEditorLineNumbersStyle.Relative;case 1:default:return S.TextEditorLineNumbersStyle.On}}me.to=ue})(H=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Z;(function(me){function he(G){if(G===S.EndOfLine.CRLF)return 1;if(G===S.EndOfLine.LF)return 0}me.from=he;function ue(G){if(G===1)return S.EndOfLine.CRLF;if(G===0)return S.EndOfLine.LF}me.to=ue})(Z=e.EndOfLine||(e.EndOfLine={}));var _e;(function(me){function he(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case S.ProgressLocation.SourceControl:return 3;case S.ProgressLocation.Window:return 10;case S.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}me.from=he})(_e=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(me){function he(ue){const G={start:ue.start+1,end:ue.end+1};return ue.kind&&(G.kind=He.from(ue.kind)),G}me.from=he})(Me=e.FoldingRange||(e.FoldingRange={}));var He;(function(me){function he(ue){if(ue)switch(ue){case S.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}me.from=he})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Oe;(function(me){function he(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?m.from(ue.selection):void 0,override:typeof ue.override=="boolean"?T.EditorOverride.DISABLED:void 0}}me.from=he})(Oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(me){function he(G){return G instanceof S.RelativePattern||typeof G=="string"?G:ue(G)?new S.RelativePattern(G.base,G.pattern):G}me.from=he;function ue(G){const Ie=G;return Ie&&typeof Ie.base=="string"&&typeof Ie.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var B;(function(me){function he(ue){if(ue){if(Array.isArray(ue))return ue.map(he);if(typeof ue=="string")return ue;{const G=ue;return{language:G.language,scheme:G.scheme,pattern:typeof G.pattern=="undefined"?void 0:Xe.from(G.pattern),exclusive:G.exclusive}}}else return}me.from=he})(B=e.LanguageSelector||(e.LanguageSelector={}));var re;(function(me){function he(G){return{start:G.start,end:G.end}}me.from=he;function ue(G){return new S.NotebookCellRange(G.start,G.end)}me.to=ue})(re=e.NotebookCellRange||(e.NotebookCellRange={}));var ce;(function(me){function he(ue){return new S.NotebookCellMetadata(ue.editable,ue.breakpointMargin,ue.hasExecutionOrder,ue.executionOrder,ue.runState,ue.runStartTime,ue.statusMessage,ue.lastRunDuration,ue.inputCollapsed,ue.outputCollapsed,ue.custom)}me.to=he})(ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var V;(function(me){function he(G){return G}me.from=he;function ue(G){return new S.NotebookDocumentMetadata(G.editable,G.cellEditable,G.cellHasExecutionOrder,G.custom,G.runState,G.trusted)}me.to=ue})(V=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var X;(function(me){function he(G){switch(G){case S.NotebookCellKind.Markdown:return f.CellKind.Markdown;case S.NotebookCellKind.Code:default:return f.CellKind.Code}}me.from=he;function ue(G){switch(G){case f.CellKind.Markdown:return S.NotebookCellKind.Markdown;case f.CellKind.Code:default:return S.NotebookCellKind.Code}}me.to=ue})(X=e.NotebookCellKind||(e.NotebookCellKind={}));var oe;(function(me){function he(ue){return{cellKind:X.from(ue.kind),language:ue.language,source:ue.source,metadata:ue.metadata,outputs:ue.outputs?ue.outputs.map(ve.from):[]}}me.from=he})(oe=e.NotebookCellData||(e.NotebookCellData={}));var fe;(function(me){function he(G){return{mime:G.mime,value:G.value,metadata:G.metadata}}me.from=he;function ue(G){return new S.NotebookCellOutputItem(G.mime,G.value,G.metadata)}me.to=ue})(fe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ve;(function(me){function he(G){return{outputId:G.id,outputs:G.outputs.map(fe.from),metadata:G.metadata}}me.from=he;function ue(G){const Ie=G.outputs.map(fe.to);return new S.NotebookCellOutput(Ie,G.outputId,G.metadata)}me.to=ue})(ve=e.NotebookCellOutput||(e.NotebookCellOutput={}));var $e;(function(me){function he(Pe){if(Pe!=null){if(Pe instanceof S.RelativePattern||typeof Pe=="string")return Pe;if(Ie(Pe))return new S.RelativePattern(Pe.base,Pe.pattern);if(G(Pe))return{include:Xe.from(Pe.include)||void 0,exclude:Xe.from(Pe.exclude)||void 0}}}me.from=he;function ue(Pe){return typeof Pe=="string"?Pe:Ie(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}me.to=ue;function G(Pe){const et=Pe,Ge=Xe.from(et.include);if(!(Ge&&Ge instanceof S.RelativePattern||typeof Ge=="string"))return!1;const rt=Xe.from(et.exclude);return!!(rt&&rt instanceof S.RelativePattern||typeof rt=="string")}function Ie(Pe){const et=Pe;return et&&typeof et.base=="string"&&typeof et.pattern=="string"}})($e=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ne;(function(me){function he(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?g.from(ue.top):void 0}}me.from=he})(Ne=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ve;(function(me){function he(G){return{state:G.state,duration:G.duration,messages:G.messages.map(Qe.from)}}me.from=he;function ue(G){const Ie=new S.TestState(G.state);return Ie.duration=G.duration,Ie.messages=G.messages.map(Qe.to),Ie}me.to=ue})(Ve=e.TestState||(e.TestState={}));var Qe;(function(me){function he(G){return{message:h.fromStrict(G.message)||"",severity:G.severity,expectedOutput:G.expectedOutput,actualOutput:G.actualOutput,location:G.location?U.from(G.location):void 0}}me.from=he;function ue(G){const Ie=new S.TestMessage(typeof G.message=="string"?G.message:h.to(G.message));return Ie.severity=G.severity,Ie.actualOutput=G.actualOutput,Ie.expectedOutput=G.expectedOutput,Ie}me.to=ue})(Qe=e.TestMessage||(e.TestMessage={}));var Ze;(function(me){function he(Ie){var Pe,et;return{extId:Ie.id,label:Ie.label,location:Ie.location?U.from(Ie.location):void 0,debuggable:(Pe=Ie.debuggable)!==null&&Pe!==void 0?Pe:!1,description:Ie.description,runnable:(et=Ie.runnable)!==null&&et!==void 0?et:!0}}me.from=he;function ue(Ie){return{id:Ie.extId,label:Ie.label,location:Ie.location&&U.to({range:Ie.location.range,uri:P.URI.revive(Ie.location.uri)}),debuggable:Ie.debuggable,description:Ie.description,runnable:Ie.runnable}}me.toPlainShallow=ue;function G(Ie){const Pe=new S.TestItem(Ie.extId,Ie.label);return Ie.location&&(Pe.location=U.to({range:Ie.location.range,uri:P.URI.revive(Ie.location.uri)})),Pe.debuggable=Ie.debuggable,Pe.description=Ie.description,Pe.runnable=Ie.runnable,Pe}me.toShallow=G})(Ze=e.TestItem||(e.TestItem={}));var ct;(function(me){function he(Ie,Pe){var et,Ge,rt;const lt={completedAt:Pe.completedAt,id:Ie,items:[]},Je=[[null,Pe.results]];for(;Je.length;){const[it,dt]=Je.pop();for(const at of dt){const Dt={children:(Ge=(et=at.children)===null||et===void 0?void 0:et.map(gt=>gt.id))!==null&&Ge!==void 0?Ge:[],computedState:at.result.state,item:Ze.from(at),state:Ve.from(at.result),retired:void 0,parent:(rt=it==null?void 0:it.item.extId)!==null&&rt!==void 0?rt:null,providerId:"",direct:!it};lt.items.push(Dt),at.children&&Je.push([Dt,at.children])}}return lt}me.from=he;const ue=(Ie,Pe)=>Object.assign(Object.assign({},Ze.toPlainShallow(Ie.item)),{result:Ve.to(Ie.state),children:Ie.children.map(et=>Pe.get(et)).filter(A.isDefined).map(et=>ue(et,Pe))});function G(Ie){const Pe=[],et=new Map;for(const Ge of Ie.items)et.set(Ge.item.extId,Ge),Ge.direct&&Pe.push(Ge);return{completedAt:Ie.completedAt,results:Pe.map(Ge=>ue(Ge,et))}}me.to=G})(ct=e.TestResults||(e.TestResults={}));var st;(function(me){function he(ue){switch(ue){case 1:return S.CodeActionTriggerKind.Automatic;case 2:return S.CodeActionTriggerKind.Manual}}me.to=he})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(we[172],Ee([0,1,2,10,7,9,46]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(n,A,I,v={timeout:1500,errors:3}){this._logService=n,this._documents=A,this._mainThreadBulkEdits=I,this._thresholds=v,this._callbacks=new E.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(A,I,v)=>{const s={dispose:this._callbacks.push([A,I,n])};return Array.isArray(v)&&v.push(s),s}}async $participateInSave(n,A){const I=_.URI.revive(n);let v=!1;const d=setTimeout(()=>v=!0,this._thresholds.timeout),s=[];try{for(let f of[...this._callbacks]){if(v)break;const p=this._documents.getDocument(I),m=await this._deliverEventAsyncAndBlameBadListeners(f,{document:p,reason:P.TextDocumentSaveReason.to(A)});s.push(m)}}finally{clearTimeout(d)}return s}_deliverEventAsyncAndBlameBadListeners([n,A,I],v){const d=this._badListeners.get(n);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,n,A,v).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const f=this._badListeners.get(n);this._badListeners.set(n,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,A,I,v){const d=[],s=Date.now(),{document:f,reason:p}=v,{version:m}=f,b=Object.freeze({document:f,reason:p,waitUntil(c){if(Object.isFrozen(d))throw(0,S.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(c))}});try{A.apply(I,[b])}catch(c){return Promise.reject(c)}return Object.freeze(d),new Promise((c,u)=>{const a=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(a),c(t)}).catch(t=>{clearTimeout(a),u(t)})}).then(c=>{const u={edits:[]};for(const a of c)if(Array.isArray(a)&&a.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:r,range:o}of a)u.edits.push({_type:2,resource:f.uri,edit:{range:o&&P.Range.from(o),text:t,eol:r&&P.EndOfLine.from(r)}});if(u.edits.length!==0)return m===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(we[173],Ee([0,1,3,13,28,2,9,7]),function(ae,e,_,S,T,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{constructor(I,v,d,s,f){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,d&&(this._config+=1),s&&(this._config+=2),f&&(this._config+=4);const p=(0,T.parse)(v),m=I(b=>{if(!d)for(let c of b.created){const u=P.URI.revive(c);p(u.fsPath)&&this._onDidCreate.fire(u)}if(!s)for(let c of b.changed){const u=P.URI.revive(c);p(u.fsPath)&&this._onDidChange.fire(u)}if(!f)for(let c of b.deleted){const u=P.URI.revive(c);p(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,m)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(I,v,d){this._logService=v,this._extHostDocumentsAndEditors=d,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new S.AsyncEmitter,this._onWillCreateFile=new S.AsyncEmitter,this._onWillDeleteFile=new S.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,v,d,s){return new w(this._onFileSystemEvent.event,I,v,d,s)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,v){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:v.map(d=>({oldUri:P.URI.revive(d.source),newUri:P.URI.revive(d.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:v.map(d=>P.URI.revive(d.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:v.map(d=>P.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,v){return(d,s,f)=>{const p=function(b){d.call(s,b)};return p.extension=I,v.event(p,void 0,f)}}async $onWillRunFileOperation(I,v,d,s){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:v.map(f=>({oldUri:P.URI.revive(f.source),newUri:P.URI.revive(f.target)}))},d,s);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:v.map(f=>P.URI.revive(f.target))},d,s);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:v.map(f=>P.URI.revive(f.target))},d,s)}}async _fireWillEvent(I,v,d,s){const f=new Set,p=[];if(await I.fireAsync(v,s,async(b,c)=>{var u;const a=Date.now(),t=await Promise.resolve(b);t instanceof k.WorkspaceEdit&&(p.push(t),f.add((u=c.extension.displayName)!==null&&u!==void 0?u:c.extension.identifier.value)),Date.now()-a>d&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),!s.isCancellationRequested&&p.length!==0){const m={edits:[]};for(let b of p){let{edits:c}=E.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);m.edits=m.edits.concat(c)}return{edit:m,extensionNames:Array.from(f)}}}}e.ExtHostFileSystemEventService=n}),define(we[174],Ee([0,1,3,6,16,23,2,9,70]),function(ae,e,_,S,T,P,E,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class n{constructor(d,s,f,p){this.start=d,this.deletedCount=s,this.deletedItems=f,this.items=p}static asApiEvents(d){return d.map(s=>({start:s.start,deletedCount:s.deletedCount,deletedItems:s.deletedItems,items:s.items.map(f=>f.cell)}))}}class A{constructor(d,s,f){var p;this._notebook=d,this._extHostDocument=s,this._cellData=f,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=f.handle,this.uri=E.URI.revive(f.uri),this.cellKind=f.cellKind,this._outputs=f.outputs.map(k.NotebookCellOutput.to),this._metadata=k.NotebookCellMetadata.to((p=f.metadata)!==null&&p!==void 0?p:{})}static asModelAddData(d,s){return{EOL:s.eol,lines:s.source,modeId:s.language,uri:s.uri,isDirty:!1,versionId:1,notebook:d}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get cell(){if(!this._cell){const d=this,s=this._extHostDocument.getDocument(this.uri);if(!s)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return d._notebook.getCellIndex(d)},notebook:d._notebook.notebookDocument,kind:k.NotebookCellKind.to(this._cellData.cellKind),document:s.document,get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata}})}return this._cell}setOutputs(d){this._outputs=d.map(k.NotebookCellOutput.to)}setOutputItems(d,s,f){const p=f.map(k.NotebookCellOutputItem.to),m=this._outputs.find(b=>b.id===d);m&&(s||(m.outputs.length=0),m.outputs.push(...p))}setMetadata(d){this._metadata=k.NotebookCellMetadata.to(d)}}e.ExtHostCell=A;class I extends S.Disposable{constructor(d,s,f,p,m,b,c){super();this._proxy=d,this._textDocumentsAndEditors=s,this._textDocuments=f,this._emitter=p,this._viewType=m,this._metadata=b,this.uri=c,this.handle=I._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,S.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const d=this;this._notebook=Object.freeze({get uri(){return d.uri},get version(){return d._versionId},get fileName(){return d.uri.fsPath},get viewType(){return d._viewType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===T.Schemas.untitled},get cells(){return d._cells.map(s=>s.cell)},get metadata(){return d._metadata},set metadata(s){throw new Error("Use WorkspaceEdit to update metadata.")},save(){return d._save()}})}return this._notebook}updateBackup(d){var s;(s=this._backup)===null||s===void 0||s.delete(),this._backup=d}disposeBackup(){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=this._metadata.with(d.metadata))}acceptModelChanged(d,s){this._versionId=d.versionId,this._isDirty=s;for(const f of d.rawEvents)f.kind===w.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(f.changes,!0),f.kind===w.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1):f.kind===w.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx):f.kind===w.NotebookCellsChangeType.Output?this._setCellOutputs(f.index,f.outputs):f.kind===w.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems):f.kind===w.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(f.index,f.language):f.kind===w.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(f.index,f.metadata)}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(d,s){if(!this._disposed){const f=[],p=[],m=[];d.reverse().forEach(b=>{var c;const a=b[2].map(o=>{const l=new A(this,this._textDocumentsAndEditors,o);if(s||p.push(A.asModelAddData(this.notebookDocument,o)),!this._cellDisposableMapping.has(l.handle)){const i=new S.DisposableStore;i.add(l),this._cellDisposableMapping.set(l.handle,i)}return l});for(let o=b[0];o<b[0]+b[1];o++)(c=this._cellDisposableMapping.get(this._cells[o].handle))===null||c===void 0||c.dispose(),this._cellDisposableMapping.delete(this._cells[o].handle);const t=new n(b[0],b[1],[],a),r=this._cells.splice(b[0],b[1],...a);for(let o of r)m.push(o.uri),t.deletedItems.push(o.cell);f.push(t)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:m}),s||this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:n.asApiEvents(f)}))}}_moveCell(d,s){const f=this._cells.splice(d,1);this._cells.splice(s,0,...f);const p=[new n(d,1,f.map(m=>m.cell),[]),new n(s,0,[],f)];this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:n.asApiEvents(p)}))}_setCellOutputs(d,s){const f=this._cells[d];f.setOutputs(s),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[f.cell]}))}_setCellOutputItems(d,s,f,p){const m=this._cells[d];m.setOutputItems(s,f,p),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[m.cell]}))}_changeCellLanguage(d,s){const f=this._cells[d];f.cell.document.languageId!==s&&this._textDocuments.$acceptModelModeChanged(f.uri,s)}_changeCellMetadata(d,s){const f=this._cells[d];f.setMetadata(s||{}),this._emitter.emitCellMetadataChange((0,P.deepFreeze)({document:this.notebookDocument,cell:f.cell}))}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(s=>s.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=I,I._handlePool=0}),define(we[175],Ee([0,1,3,7,9]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(w){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=w}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(w){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:w})}replaceCellMetadata(w,n){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:w,metadata:n})}replaceCellOutput(w,n){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:w,outputs:n.map(A=>T.NotebookCellOutput.from(A))})}replaceCells(w,n,A){this._throwIfFinalized(),!(w===n&&A.length===0)&&this._collectedEdits.push({editType:1,index:w,count:n-w,cells:A.map(T.NotebookCellData.from)})}}class E{constructor(w,n,A,I,v,d,s){this.id=w,this._viewType=n,this._proxy=A,this.notebookData=I,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=d,this._visibleRanges=v,this._viewColumn=s}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const w=this;this._editor={get document(){return w.notebookData.notebookDocument},get selection(){var n;const A=w._selections[0];return A&&((n=w.notebookData.getCellFromIndex(A.start))===null||n===void 0?void 0:n.cell)},get selections(){return w._selections},get visibleRanges(){return w._visibleRanges},revealRange(n,A){w._proxy.$tryRevealRange(w.id,T.NotebookCellRange.from(n),A!=null?A:S.NotebookEditorRevealType.Default)},get viewColumn(){return w._viewColumn},get onDidDispose(){return w.onDidDispose},edit(n){const A=new P(this.document.version);return n(A),w._applyEdit(A.finalize())},get kernel(){return w._kernel},setDecorations(n,A){return w.setDecorations(n,A)}}}return this._editor}_acceptKernel(w){this._kernel=w}get visible(){return this._visible}_acceptVisibility(w){this._visible=w}_acceptVisibleRanges(w){this._visibleRanges=w}_acceptSelections(w){this._selections=w}_applyEdit(w){if(w.cellEdits.length===0)return Promise.resolve(!0);const n=[];let A=-1;for(let I=0;I<w.cellEdits.length;I++){if(A<0){n.push(w.cellEdits[I]),A++;continue}const d=n[A];if(d.editType===1&&w.cellEdits[I].editType===1){const s=w.cellEdits[I];if(s.editType!==5&&d.index===s.index){d.cells.push(...w.cellEdits[I].cells),d.count+=w.cellEdits[I].count;continue}}n.push(w.cellEdits[I]),A++}return this._proxy.$tryApplyEdits(this._viewType,this.notebookData.uri,w.documentVersionId,n)}setDecorations(w,n){if(!(n.isEmpty&&!this._hasDecorationsForKey.has(w.key)))return n.isEmpty?this._hasDecorationsForKey.delete(w.key):this._hasDecorationsForKey.add(w.key),this._proxy.$trySetDecorations(this.id,T.NotebookCellRange.from(n),w.key)}}e.ExtHostNotebookEditor=E}),define(we[176],Ee([0,1,9,149,130,20,44]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,v,d){const s=this._handles++,{title:f,location:p,cancellable:m}=v,b=(0,T.localize)(0,null,I.displayName||I.name);return this._proxy.$startProgress(s,{location:_.ProgressLocation.from(p),title:f,source:b,cancellable:m},I),this._withProgress(s,d,!!m)}_withProgress(I,v,d){let s;d&&(s=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,s));const f=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),s&&s.dispose()};let p;try{p=v(new n(this._proxy,I),d&&s?s.token:P.CancellationToken.None)}catch(m){throw f(I),m}return p.then(m=>f(I),m=>f(I)),p}$acceptProgressCanceled(I){const v=this._mapHandleToCancellationSource.get(I);v&&(v.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=k;function w(A,I){return A.message=I.message,typeof I.increment=="number"&&(typeof A.increment=="number"?A.increment+=I.increment:A.increment=I.increment),A}class n extends S.Progress{constructor(I,v){super(d=>this.throttledReport(d));this._proxy=I,this._handle=v}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}je([(0,E.throttle)(100,(A,I)=>w(A,I),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(we[95],Ee([0,1,43,10,52,9,7]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(v,d){const s=k._Keys.nextId();v.$registerTextEditorDecorationType(s,P.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:s,dispose(){v.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=k,k._Keys=new T.IdGenerator("TextEditorDecorationType");class w{constructor(v,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=v,this._documentVersionId=v.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(v,d){this._throwIfFinalized();let s=null;if(v instanceof E.Position)s=new E.Range(v,v);else if(v instanceof E.Range)s=v;else throw new Error("Unrecognized location");this._pushEdit(s,d,!1)}insert(v,d){this._throwIfFinalized(),this._pushEdit(new E.Range(v,v),d,!0)}delete(v){this._throwIfFinalized();let d=null;if(v instanceof E.Range)d=v;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(v,d,s){const f=this._document.validateRange(v);this._collectedEdits.push({range:f,text:d,forceMoveMarkers:s})}setEndOfLine(v){if(this._throwIfFinalized(),v!==E.EndOfLine.LF&&v!==E.EndOfLine.CRLF)throw(0,S.illegalArgument)("endOfLine");this._setEndOfLine=v}}e.TextEditorEdit=w;class n{constructor(v,d,s,f){this._proxy=v,this._id=d,this._accept(s),this._logService=f;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(m){p._setTabSize(m)},get insertSpaces(){return p._insertSpaces},set insertSpaces(m){p._setInsertSpaces(m)},get cursorStyle(){return p._cursorStyle},set cursorStyle(m){p._setCursorStyle(m)},get lineNumbers(){return p._lineNumbers},set lineNumbers(m){p._setLineNumbers(m)}}}_accept(v){this._tabSize=v.tabSize,this._insertSpaces=v.insertSpaces,this._cursorStyle=v.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(v.lineNumbers)}_validateTabSize(v){if(v==="auto")return"auto";if(typeof v=="number"){const d=Math.floor(v);return d>0?d:null}if(typeof v=="string"){const d=parseInt(v,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(v){const d=this._validateTabSize(v);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}_setInsertSpaces(v){const d=this._validateInsertSpaces(v);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(v){this._cursorStyle!==v&&(this._cursorStyle=v,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:v})))}_setLineNumbers(v){this._lineNumbers!==v&&(this._lineNumbers=v,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(v)})))}assign(v){const d={};let s=!1;if(typeof v.tabSize!="undefined"){const f=this._validateTabSize(v.tabSize);f==="auto"?(s=!0,d.tabSize=f):typeof f=="number"&&this._tabSize!==f&&(this._tabSize=f,s=!0,d.tabSize=f)}if(typeof v.insertSpaces!="undefined"){const f=this._validateInsertSpaces(v.insertSpaces);f==="auto"?(s=!0,d.insertSpaces=f):this._insertSpaces!==f&&(this._insertSpaces=f,s=!0,d.insertSpaces=f)}typeof v.cursorStyle!="undefined"&&this._cursorStyle!==v.cursorStyle&&(this._cursorStyle=v.cursorStyle,s=!0,d.cursorStyle=v.cursorStyle),typeof v.lineNumbers!="undefined"&&this._lineNumbers!==v.lineNumbers&&(this._lineNumbers=v.lineNumbers,s=!0,d.lineNumbers=P.TextEditorLineNumbersStyle.from(v.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(v){v.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=n;class A{constructor(v,d,s,f,p,m,b,c){this.id=v,this._proxy=d,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new n(this._proxy,this.id,m,s),this._visibleRanges=b,this._viewColumn=c;const u=this;this.value=Object.freeze({get document(){return f.getValue()},set document(a){throw(0,S.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(a){if(!(a instanceof E.Selection))throw(0,S.illegalArgument)("selection");u._selections=[a],u._trySetSelection()},get selections(){return u._selections},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof E.Selection)))throw(0,S.illegalArgument)("selections");u._selections=a,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(a){throw(0,S.readonly)("visibleRanges")},get options(){return u._options.value},set options(a){u._disposed||u._options.assign(a)},get viewColumn(){return u._viewColumn},set viewColumn(a){throw(0,S.readonly)("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new w(f.getValue(),t);return a(r),u._applyEdit(r)},insertSnippet(a,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=u._selections.map(l=>P.Range.from(l));else if(t instanceof E.Position){const{lineNumber:l,column:i}=P.Position.from(t);o=[{startLineNumber:l,startColumn:i,endLineNumber:l,endColumn:i}]}else if(t instanceof E.Range)o=[P.Range.from(t)];else{o=[];for(const l of t)if(l instanceof E.Range)o.push(P.Range.from(l));else{const{lineNumber:i,column:h}=P.Position.from(l);o.push({startLineNumber:i,startColumn:h,endLineNumber:i,endColumn:h})}}return d.$tryInsertSnippet(v,a.value,o,r)},setDecorations(a,t){const r=t.length===0;r&&!u._hasDecorationsForKey.has(a.key)||(r?u._hasDecorationsForKey.delete(a.key):u._hasDecorationsForKey.add(a.key),u._runOnProxy(()=>{if(P.isDecorationOptionsArr(t))return d.$trySetDecorations(v,a.key,P.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let l=0,i=t.length;l<i;l++){const h=t[l];o[4*l]=h.start.line+1,o[4*l+1]=h.start.character+1,o[4*l+2]=h.end.line+1,o[4*l+3]=h.end.character+1}return d.$trySetDecorationsFast(v,a.key,o)}}))},revealRange(a,t){u._runOnProxy(()=>d.$tryRevealRange(v,P.Range.from(a),t||E.TextEditorRevealType.Default))},show(a){d.$tryShowEditor(v,P.ViewColumn.from(a))},hide(){d.$tryHideEditor(v)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(v){(0,_.ok)(!this._disposed),this._options._accept(v)}_acceptVisibleRanges(v){(0,_.ok)(!this._disposed),this._visibleRanges=v}_acceptViewColumn(v){(0,_.ok)(!this._disposed),this._viewColumn=v}_acceptSelections(v){(0,_.ok)(!this._disposed),this._selections=v}async _trySetSelection(){const v=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,v)),this.value}_applyEdit(v){const d=v.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const s=d.edits.map(p=>p.range);s.sort((p,m)=>p.end.line===m.end.line?p.end.character===m.end.character?p.start.line===m.start.line?p.start.character-m.start.character:p.start.line-m.start.line:p.end.character-m.end.character:p.end.line-m.end.line);for(let p=0,m=s.length-1;p<m;p++){const b=s[p].end;if(s[p+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=d.edits.map(p=>({range:P.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,f,{setEndOfLine:typeof d.setEndOfLine=="number"?P.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(v){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=A}),define(we[177],Ee([0,1,133,24,2,3,6,13,7,12,15,9,20]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(p,m){if((0,n.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let b;return Array.isArray(p.highlights)&&(b=p.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),b=b.length?b:void 0),{label:p.label,highlights:b}}}class s{constructor(m,b,c){this._proxy=m,this.commands=b,this.logService=c,this.treeViews=new Map;function u(a){return a&&a.$treeViewId&&a.$treeItemHandle}b.registerArgumentProcessor({processArgument:a=>u(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(t=>u(t)?this.convertArgument(t):t):a})}registerTreeDataProvider(m,b,c){const u=this.createTreeView(m,{treeDataProvider:b},c);return{dispose:()=>u.dispose()}}createTreeView(m,b,c){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany}),a=this.createExtHostTreeView(m,b,c);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(t){a.message=t},get title(){return a.title},set title(t){a.title=t},get description(){return a.description},set description(t){a.description=t},reveal:(t,r)=>a.reveal(t,r),dispose:async()=>{await u,this.treeViews.delete(m),a.dispose()}}}$getChildren(m,b){const c=this.treeViews.get(m);return c?c.getChildren(b):Promise.reject(new Error((0,_.localize)(0,null,m)))}async $hasResolve(m){const b=this.treeViews.get(m);if(!b)throw new Error((0,_.localize)(1,null,m));return b.hasResolve}$resolve(m,b,c){const u=this.treeViews.get(m);if(!u)throw new Error((0,_.localize)(2,null,m));return u.resolveTreeItem(b,c)}$setExpanded(m,b,c){const u=this.treeViews.get(m);if(!u)throw new Error((0,_.localize)(3,null,m));u.setExpanded(b,c)}$setSelection(m,b){const c=this.treeViews.get(m);if(!c)throw new Error((0,_.localize)(4,null,m));c.setSelection(b)}$setVisible(m,b){const c=this.treeViews.get(m);if(!c)throw new Error((0,_.localize)(5,null,m));c.setVisible(b)}createExtHostTreeView(m,b,c){const u=new f(m,b,this._proxy,this.commands.converter,this.logService,c);return this.treeViews.set(m,u),u}convertArgument(m){const b=this.treeViews.get(m.$treeViewId);return b?b.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=s;class f extends E.Disposable{constructor(m,b,c,u,a,t){super();if(this.viewId=m,this.proxy=c,this.commands=u,this.logService=a,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new v.CancellationTokenSource,t.contributes&&t.contributes.views)for(const l in t.contributes.views)for(const i of t.contributes.views[l])i.id===m&&(this._title=i.name);this.dataProvider=b.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let r,o;this._register(P.Event.debounce(this._onDidChangeData.event,(l,i)=>(l||(l={message:!1,elements:[]}),i.element!==!1&&(r||(r=new Promise(h=>o=h),this.refreshPromise=this.refreshPromise.then(()=>r)),l.elements.push(i.element)),i.message&&(l.message=!0),l),200,!0)(({message:l,elements:i})=>{i.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=o;return r=null,this.refresh(i).then(()=>h())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,n.isUndefinedOrNull)(m))}getChildren(m){const b=m?this.getExtensionElement(m):void 0;if(m&&!b)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);const c=this.getChildrenNodes(m);return(c?Promise.resolve(c):this.fetchChildrenNodes(b)).then(u=>u.map(a=>a.item))}getExtensionElement(m){return this.elements.get(m)}reveal(m,b){b=b||{select:!0,focus:!1};const c=(0,n.isUndefinedOrNull)(b.select)?!0:b.select,u=(0,n.isUndefinedOrNull)(b.focus)?!1:b.focus,a=(0,n.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(t=>this.resolveTreeNode(m,t[t.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:t.map(o=>o.item)},{select:c,focus:u,expand:a})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:c,focus:u,expand:a})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,b){const c=this.getExtensionElement(m);c&&(b?this._onDidExpandElement.fire(Object.freeze({element:c})):this._onDidCollapseElement.fire(Object.freeze({element:c})))}setSelection(m){(0,A.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,b){var c;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(m);if(u){const a=this.nodes.get(u);if(a){const t=(c=await this.dataProvider.resolveTreeItem(a.extensionItem,u,b))!==null&&c!==void 0?c:a.extensionItem;return a.item.tooltip=this.getTooltip(t.tooltip),a.item.command=this.getCommand(a.disposableStore,t.command),a.item}}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(b=>b?this.resolveUnknownParentChain(b).then(c=>this.resolveTreeNode(b,c[c.length-1]).then(u=>(c.push(u),c))):Promise.resolve([]))}resolveParent(m){const b=this.nodes.get(m);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,b){const c=this.nodes.get(m);return c?Promise.resolve(c):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(u=>this.createHandle(m,u,b,!0)).then(u=>this.getChildren(b?b.item.handle:void 0).then(()=>{const a=this.getExtensionElement(u);if(a){const t=this.nodes.get(a);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(m){if(m){let b;if(typeof m=="string"){const c=this.getExtensionElement(m);b=c?this.nodes.get(c):void 0}else b=m;return b&&b.children||null}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const b=new v.CancellationTokenSource(this._refreshCancellationSource.token);try{const c=m?this.nodes.get(m):void 0,u=await this.dataProvider.getChildren(m);if(b.token.isCancellationRequested)return[];const a=await Promise.all((0,A.coalesce)(u||[]).map(async t=>{const r=await this.dataProvider.getTreeItem(t);return r&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,r,c):null}));return b.token.isCancellationRequested?[]:(0,A.coalesce)(a)}finally{b.dispose()}}refresh(m){if(m.some(c=>!c))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new v.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const c=this.getHandlesToRefresh(m);if(c.length)return this.refreshHandles(c)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const b=new Set;for(const u of m){const a=this.nodes.get(u);if(a&&!b.has(a.item.handle)){let t=a;for(;t&&t.parent&&!b.has(t.parent.item.handle);){const r=this.elements.get(t.parent.item.handle);t=r?this.nodes.get(r):void 0}t&&!t.parent&&b.add(a.item.handle)}}const c=[];return b.forEach(u=>{const a=this.elements.get(u);if(a){const t=this.nodes.get(a);t&&(!t.parent||!b.has(t.parent.item.handle))&&c.push(u)}}),c}refreshHandles(m){const b={};return Promise.all(m.map(c=>this.refreshNode(c).then(u=>{u&&(b[c]=u.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(m){const b=this.getExtensionElement(m);if(b){const c=this.nodes.get(b);if(c)return this.clearChildren(b),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(u=>{if(u){const a=this.createTreeNode(b,u,c.parent);return this.updateNodeCache(b,a,c,c.parent),c.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,b,c){const u=this.createTreeNode(m,b,c);if(b.id&&this.elements.has(u.item.handle))throw new Error((0,_.localize)(6,null,b.id));return this.addNodeToCache(m,u),this.addNodeToParentCache(u,c),u}getTooltip(m){return w.MarkdownString.isMarkdownString(m)?I.MarkdownString.from(m):m}getCommand(m,b){return b?this.commands.toInternal(b,m):void 0}createTreeNode(m,b,c){const u=new E.DisposableStore,a=this.createHandle(m,b,c),t=this.getLightIconPath(b);return{item:{handle:a,parentHandle:c?c.item.handle:void 0,label:d(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(u,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:(0,n.isUndefinedOrNull)(b.collapsibleState)?w.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:c,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(m){return m.iconPath instanceof w.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:b,label:c,resourceUri:u},a,t){if(b)return`${f.ID_HANDLE_PREFIX}/${b}`;const r=d(c,this.extension),o=a?a.item.handle:f.LABEL_HANDLE_PREFIX;let l=r?r.label:u?(0,S.basename)(u):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const i=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,h=this.getChildrenNodes(a)||[];let D,C=0;do{if(D=`${o}/${C}:${l}`,t||!this.elements.has(D)||i===D)break;C++}while(C<=h.length);return D}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof w.ThemeIcon))return typeof m.iconPath=="string"||T.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof w.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return T.URI.isUri(m)?m:T.URI.file(m)}addNodeToCache(m,b){this.elements.set(b.item.handle,m),this.nodes.set(m,b)}updateNodeCache(m,b,c,u){this.elements.delete(b.item.handle),this.nodes.delete(m),b.item.handle!==c.item.handle&&this.elements.delete(c.item.handle),this.addNodeToCache(m,b);const a=this.getChildrenNodes(u)||[],t=a.filter(r=>r.item.handle===c.item.handle)[0];t&&a.splice(a.indexOf(t),1,b)}addNodeToParentCache(m,b){b?(b.children||(b.children=[]),b.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const b=this.nodes.get(m);if(b){if(b.children)for(const c of b.children){const u=this.elements.get(c.item.handle);u&&this.clear(u)}b.children=void 0}}else this.clearAll()}clear(m){const b=this.nodes.get(m);if(b){if(b.children)for(const c of b.children){const u=this.elements.get(c.item.handle);u&&this.clear(u)}this.nodes.delete(m),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}f.LABEL_HANDLE_PREFIX="0",f.ID_HANDLE_PREFIX="1"}),define(we[178],Ee([0,1,15,13,44,9]),function(ae,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class E{constructor(){this.testIdsToInternal=new Set}getTestById(s){return(0,_.mapFind)(this.testIdsToInternal,f=>{const p=f.get(s);return p&&[f,p]})}createForHierarchy(s=()=>{}){return new n(this.createIdMap(),s)}createIdMap(){const s=new w;return this.testIdsToInternal.add(s),{object:s,dispose:()=>this.testIdsToInternal.delete(s)}}}e.OwnedTestCollection=E;var k;(function(d){d[d.Disconnected=0]="Disconnected",d[d.IsChild=1]="IsChild",d[d.IsParent=2]="IsParent",d[d.IsSame=3]="IsSame"})(k=e.TestPosition||(e.TestPosition={}));class w{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(s){if(this.map.has(s.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${s.item.extId}`);this.map.set(s.item.extId,s),s.parent||this._roots.add(s)}has(s){return this.map.has(s)}delete(s){const f=this.map.get(s);return f?(this.map.delete(s),this._roots.delete(f),!0):!1}get(s){return this.map.get(s)}comparePositions(s,f){const p=typeof s=="string"?this.map.get(s):s,m=typeof f=="string"?this.map.get(f):f;if(!p||!m)return 0;if(p===m)return 3;for(let b=this.map.get(m.parent);b;b=this.map.get(b.parent))if(b===p)return 1;for(let b=this.map.get(p.parent);b;b=this.map.get(b.parent))if(b===m)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=w;class n{constructor(s,f){this.testIdToInternal=s,this.publishDiff=f,this.testItemToInternal=new Map,this.diff=[],this.disposed=!1,this.debounceSendDiff=new S.RunOnceScheduler(()=>this.throttleSendDiff(),2)}addRoot(s,f){this.addItem(s,f,null),this.debounceSendDiff.schedule()}getTestByReference(s){return this.testItemToInternal.get(s)}onItemChange(s,f){const p=this.testItemToInternal.get(s);if(!p){this.disposed||console.warn("Received a TestProvider.onDidChangeTest for a test that wasn't seen before as a child.");return}this.addItem(s,f,p.parent),this.debounceSendDiff.schedule()}collectDiff(){const s=this.diff;return this.diff=[],s}pushDiff(s){this.diff.push(s),this.debounceSendDiff.schedule()}dispose(){this.testIdToInternal.dispose(),this.diff=[],this.disposed=!0}addItem(s,f,p){let m=this.testItemToInternal.get(s);if(m)m.previousEquals(s)||(m.item=P.TestItem.from(s),m.previousEquals=v(s),this.diff.push([1,{parent:p,providerId:f,item:m.item}]));else{if(this.testIdToInternal.object.has(s.id))throw new Error(`Attempted to insert a duplicate test item ID ${s.id}`);m={actual:s,parent:p,item:P.TestItem.from(s),providerId:f,previousChildren:new Set,previousEquals:v(s)},this.testIdToInternal.object.add(m),this.testItemToInternal.set(s,m),this.diff.push([0,{parent:p,providerId:f,item:m.item}])}if(s.children){const b=m.previousChildren,c=new Set;for(const u of s.children){const a=this.testIdToInternal.object.get(u.id);a&&a.actual!==u&&this.removeItembyId(u.id);const t=this.addItem(u,f,m.item.extId);b.delete(t.item.extId),c.add(t.item.extId)}for(const u of b)this.removeItembyId(u);m.previousChildren=c}return m}removeItembyId(s){this.diff.push([2,s]);const f=[this.testIdToInternal.object.get(s)];for(;f.length;){const p=f.pop();if(!!p){this.testIdToInternal.object.delete(p.item.extId),this.testItemToInternal.delete(p.actual);for(const m of p.previousChildren)f.push(this.testIdToInternal.object.get(m))}}}throttleSendDiff(){this.flushDiff()}flushDiff(){const s=this.collectDiff();s.length&&this.publishDiff(s)}}je([(0,T.throttle)(200)],n.prototype,"throttleSendDiff",null),e.SingleUseTestCollection=n;const I=Object.keys({id:null,label:null,location:null,debuggable:null,description:null,runnable:null}),v=d=>{const s=[];for(const f of I)s.push(d[f]);return f=>{for(let p=0;p<I.length;p++)if(s[p]!==f[I[p]])return!1;return!0}}}),define(we[179],Ee([0,1,25,3,11]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(A){this.removedDueToLooping=A}}e.DeltaExtensionsResult=P;class E{constructor(A){this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=A,this._initialize()}_initialize(){this._extensionDescriptions.sort(w),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const A of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(A.identifier))){console.error("Extension `"+A.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(A.identifier),A),this._extensionsArr.push(A),Array.isArray(A.activationEvents))for(let I of A.activationEvents)I==="onUri"&&(I=`onUri:${_.ExtensionIdentifier.toKey(A.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(A)}}keepOnly(A){const I=new Set;A.forEach(v=>I.add(_.ExtensionIdentifier.toKey(v))),this._extensionDescriptions=this._extensionDescriptions.filter(v=>I.has(_.ExtensionIdentifier.toKey(v.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(A,I){A.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(A));const v=E._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(v.map(d=>d.identifier)),I.length>0){const d=new Set;I.forEach(s=>d.add(_.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!d.has(_.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(v)}static _findLoopingExtensions(A){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,m){this.addNode(p),this.addNode(m),this._arcs.has(p)?this._arcs.get(p).push(m):this._arcs.set(p,[m])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,m){const b=I.getArcs(p);for(let c=0;c<b.length;c++)if(!m.has(b[c]))return!1;return!0}getNodes(){return this._nodesArr}};let v=new Map;for(let p of A){const m=_.ExtensionIdentifier.toKey(p.identifier);if(v.set(m,p),p.extensionDependencies)for(let b of p.extensionDependencies){const c=_.ExtensionIdentifier.toKey(b);I.addArc(m,c)}}let d=new Set;I.getNodes().filter(p=>I.getArcs(p).length===0).forEach(p=>d.add(p));let s=I.getNodes().filter(p=>!d.has(p)),f;do{f=!1;for(let p=0;p<s.length;p++){const m=s[p];I.hasOnlyGoodArcs(m,d)&&(s.splice(p,1),p--,d.add(m),f=!0)}}while(f);return s.map(p=>v.get(p))}containsActivationEvent(A){return this._activationMap.has(A)}containsExtension(A){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(A))}getExtensionDescriptionsForActivationEvent(A){const I=this._activationMap.get(A);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(A){const I=this._extensionsMap.get(_.ExtensionIdentifier.toKey(A));return I||void 0}}e.ExtensionDescriptionRegistry=E;var k;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(k||(k={}));function w(n,A){const I=n.isBuiltin?0:n.isUnderDevelopment?2:1,v=A.isBuiltin?0:A.isUnderDevelopment?2:1;if(I!==v)return I-v;const d=T.posix.basename(n.extensionLocation.path),s=T.posix.basename(A.extensionLocation.path);return d<s?-1:d>s?1:0}}),define(we[180],Ee([0,1,26]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var S;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function P(k){const w=_.VSBuffer.alloc(1);switch(k){case 0:w.writeUInt8(1,0);break;case 1:w.writeUInt8(2,0);break;case 2:w.writeUInt8(3,0);break}return w}e.createMessageOfType=P;function E(k,w){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return w===0;case 2:return w===1;case 3:return w===2;default:return!1}}e.isMessageOfType=E}),define(we[33],Ee([0,1,3,2,4,25,146]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwRequiresWorkspaceTrustError=e.checkRequiresWorkspaceTrust=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:S.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class k{constructor(u){this.dependency=u}}e.MissingDependencyError=k;var w;(function(c){c[c.LocalProcess=0]="LocalProcess",c[c.LocalWebWorker=1]="LocalWebWorker",c[c.Remote=2]="Remote"})(w=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(u,a,t,r){this.codeLoadingTime=u,this.activateCallTime=a,this.activateResolvedTime=t,this.activationReason=r}}e.ActivationTimes=n;class A{constructor(u,a){this.description=u,this.value=a}}e.ExtensionPointContribution=A,e.ExtensionHostLogFileName="exthost";var I;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function v(c){c.enableProposedApi||d(c)}e.checkProposedApiEnabled=v;function d(c){throw new Error(`[${c.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.throwProposedApiError=d;function s(c){c.requiresWorkspaceTrust||f(c)}e.checkRequiresWorkspaceTrust=s;function f(c){throw new Error(`[${c.identifier.value}]: This API is only available when the "requiresWorkspaceTrust" is set to "onStart" or "onDemand" in the extension's package.json.`)}e.throwRequiresWorkspaceTrustError=f;function p(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,E.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation}}e.toExtension=p;function m(c){return Object.assign(Object.assign({identifier:new P.ExtensionIdentifier(c.identifier.id),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!1,extensionLocation:c.location},c.manifest),{uuid:c.identifier.uuid})}e.toExtensionDescription=m;class b{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(u){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(u,a){}_activateById(u,a){return Promise.resolve()}_onWillActivateExtension(u){}_onDidActivateExtension(u,a,t,r,o){}_onExtensionRuntimeError(u,a){}_onExtensionHostExit(u){}}e.NullExtensionService=b}),define(we[181],Ee([0,1,128,25,33,19]),function(ae,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const E=Promise.resolve(void 0);class k{constructor(f,p,m,b){this.startup=f,this.codeLoadingTime=p,this.activateCallTime=m,this.activateResolvedTime=b}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class w{constructor(f){this._startup=f,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(f,p){return f===-1||p===-1?-1:p-f}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=w;class n{constructor(f,p,m,b,c,u){this.activationFailed=f,this.activationFailedError=p,this.activationTimes=m,this.module=b,this.exports=c,this.subscriptions=u}}e.ActivatedExtension=n;class A extends n{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class I extends n{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=I;class v extends n{constructor(f){super(!0,f,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=v;let d=class{constructor(f,p,m,b,c){this._logService=c,this._registry=f,this._resolvedExtensionsSet=new Set,p.forEach(u=>this._resolvedExtensionsSet.add(S.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,m.forEach(u=>this._hostExtensionsMap.set(S.ExtensionIdentifier.toKey(u),u)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(f){const p=S.ExtensionIdentifier.toKey(f);return this._activatedExtensions.has(p)}getActivatedExtension(f){const p=S.ExtensionIdentifier.toKey(f),m=this._activatedExtensions.get(p);if(!m)throw new Error("Extension `"+f.value+"` is not known or not activated");return m}activateByEvent(f,p){if(this._alreadyActivatedEvents[f])return E;const m=this._registry.getExtensionDescriptionsForActivationEvent(f);return this._activateExtensions(m.map(b=>({id:b.identifier,reason:{startup:p,extensionId:b.identifier,activationEvent:f}}))).then(()=>{this._alreadyActivatedEvents[f]=!0})}activateById(f,p){const m=this._registry.getExtensionDescription(f);if(!m)throw new Error("Extension `"+f+"` is not known");return this._activateExtensions([{id:m.identifier,reason:p}])}_handleActivateRequest(f,p,m){if(this._hostExtensionsMap.has(S.ExtensionIdentifier.toKey(f.id))){p[S.ExtensionIdentifier.toKey(f.id)]=f;return}const b=this._registry.getExtensionDescription(f.id);if(!b){this._host.onExtensionActivationError(f.id,new T.MissingDependencyError(f.id.value));const a=new Error(`Unknown dependency '${f.id.value}'`);this._activatedExtensions.set(S.ExtensionIdentifier.toKey(f.id),new v(a));return}const c=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let u=!0;for(let a=0,t=c.length;a<t;a++){const r=c[a];if(!this._resolvedExtensionsSet.has(S.ExtensionIdentifier.toKey(r))){const o=this._activatedExtensions.get(S.ExtensionIdentifier.toKey(r));if(!(o&&!o.activationFailed)){if(o&&o.activationFailed){this._host.onExtensionActivationError(b.identifier,_.localize(0,null,b.displayName||b.identifier.value,r));const h=new Error(`Dependency ${r} failed to activate`);h.detail=o.activationFailedError,this._activatedExtensions.set(S.ExtensionIdentifier.toKey(b.identifier),new v(h));return}if(this._hostExtensionsMap.has(S.ExtensionIdentifier.toKey(r))){u=!1,p[S.ExtensionIdentifier.toKey(r)]={id:this._hostExtensionsMap.get(S.ExtensionIdentifier.toKey(r)),reason:f.reason};continue}const l=this._registry.getExtensionDescription(r);if(l){u=!1,p[S.ExtensionIdentifier.toKey(r)]={id:l.identifier,reason:f.reason};continue}this._host.onExtensionActivationError(b.identifier,new T.MissingDependencyError(r));const i=new Error(`Unknown dependency '${r}'`);this._activatedExtensions.set(S.ExtensionIdentifier.toKey(b.identifier),new v(i));return}}}u?p[S.ExtensionIdentifier.toKey(b.identifier)]=f:m.push(f)}_activateExtensions(f){if(f.length===0||(f=f.filter(c=>!this._activatedExtensions.has(S.ExtensionIdentifier.toKey(c.id))),f.length===0))return Promise.resolve(void 0);const p=Object.create(null),m=[];for(let c=0,u=f.length;c<u;c++)this._handleActivateRequest(f[c],p,m);for(let c=0,u=m.length;c<u;c++){const a=S.ExtensionIdentifier.toKey(m[c].id);p[a]&&delete p[a]}const b=Object.keys(p).map(c=>p[c]);return m.length===0?Promise.all(b.map(c=>this._activateExtension(c.id,c.reason))).then(c=>{}):this._activateExtensions(b).then(c=>this._activateExtensions(m))}_activateExtension(f,p){const m=S.ExtensionIdentifier.toKey(f);if(this._activatedExtensions.has(m))return Promise.resolve(void 0);const b=this._activatingExtensions.get(m);if(b)return b;const c=this._host.actualActivateExtension(f,p).then(void 0,u=>(this._host.onExtensionActivationError(f,_.localize(1,null,f.value,u.message)),this._logService.error(`Activating extension ${f.value} failed due to an error:`),this._logService.error(u),new v(u))).then(u=>{this._activatedExtensions.set(m,u),this._activatingExtensions.delete(m)});return this._activatingExtensions.set(m,c),c}};d=je([qe(4,P.ILogService)],d),e.ExtensionsActivator=d}),define(we[182],Ee([0,1,10]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class S{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,E)=>{this._actualOk=P,this._actualErr=E,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,_.onUnexpectedError)(P))}then(P,E){return this._ensureActual().then(P,E)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=S}),define(we[96],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(w,n){this.isMain=w,this.sid=n,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const S=[];function T(k){const w=new _(!0,k);return S[w.nid]=w,w}e.createMainContextProxyIdentifier=T;function P(k){const w=new _(!1,k);return S[w.nid]=w,w}e.createExtHostContextProxyIdentifier=P;function E(k){return S[k].sid}e.getStringIdentifierForProxy=E}),define(we[5],Ee([0,1,2,96,57]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var E;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(E=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var w;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(w=e.CellKind||(e.CellKind={}));var n;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(n=e.CellOutputKind||(e.CellOutputKind={}));var A;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(A=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var v;(function(c){c.name="$ident";function u(t,r){return Object.defineProperty(t,c.name,{value:r,enumerable:!0}),t}c.mixin=u;function a(t){return t[c.name]}c.of=a})(v=e.ObjectIdentifier||(e.ObjectIdentifier={}));class d{static mixin(u){return u._id=d._n++,u}}e.IdObject=d,d._n=0;var s;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var f;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(f=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function m(c){if(c&&c.edits)for(const u of c.edits)typeof u.resource=="object"?u.resource=_.URI.revive(u.resource):(u.newUri=_.URI.revive(u.newUri),u.oldUri=_.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,T.revive)(u.metadata));return c}e.reviveWorkspaceEditDto=m;var b;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,S.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,S.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadTheming:(0,S.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,S.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,S.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,S.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,S.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[71],Ee([0,1,5,3,4]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(k){this._onDidChangePassword=new S.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,w){return this._proxy.$getPassword(k,w)}store(k,w,n){return this._proxy.$setPassword(k,w,n)}delete(k,w){return this._proxy.$deletePassword(k,w)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(we[72],Ee([0,1,4,19,5,14]),function(ae,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let E=class{constructor(w,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=w.getProxy(T.MainContext.MainThreadTelemetry)}report(w,n,A){const I=this.getUsageKey(w,n);this._reportedUsages.has(I)||(this._reportedUsages.add(I),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${w}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:w}))}getUsageKey(w,n){return`${w}-${n.identifier.value}`}};E=je([qe(0,P.IExtHostRpcService),qe(1,S.ILogService)],E),e.ExtHostApiDeprecationService=E,e.NullApiDeprecationService=Object.freeze(new class{report(k,w,n){}})}),define(we[183],Ee([0,1,3,5,7,25]),function(ae,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class E{constructor(w){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=w.getProxy(S.MainContext.MainThreadAuthentication)}$setProviders(w){return this._providers=w,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(w,n,A,I={}){const v=P.ExtensionIdentifier.toKey(w.identifier),d=this._inFlightRequests.get(v)||[],s=A.sort().join(" ");let f=d.find(p=>p.scopes===s);if(f)return f.result;{const p=this._getSession(w,v,n,A,I);f={scopes:s,result:p},d.push(f),this._inFlightRequests.set(v,d);try{await p}finally{const m=d.findIndex(b=>b.scopes===s);m>-1&&(d.splice(m),this._inFlightRequests.set(v,d))}return p}}async _getSession(w,n,A,I,v={}){await this._proxy.$ensureProvider(A);const d=w.displayName||w.name;return this._proxy.$getSession(A,I,n,d,v)}async removeSession(w,n){const A=this._authenticationProviders.get(w);return A?A.provider.removeSession(n):this._proxy.$removeSession(w,n)}registerAuthenticationProvider(w,n,A,I){var v;if(this._authenticationProviders.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this._authenticationProviders.set(w,{label:n,provider:A,options:I!=null?I:{supportsMultipleAccounts:!1}}),this._providers.find(s=>s.id===w)||this._providers.push({id:w,label:n});const d=A.onDidChangeSessions(s=>{var f,p,m;this._proxy.$sendDidChangeSessions(w,{added:(f=s.added)!==null&&f!==void 0?f:[],changed:(p=s.changed)!==null&&p!==void 0?p:[],removed:(m=s.removed)!==null&&m!==void 0?m:[]})});return this._proxy.$registerAuthenticationProvider(w,n,(v=I==null?void 0:I.supportsMultipleAccounts)!==null&&v!==void 0?v:!1),new T.Disposable(()=>{d.dispose(),this._authenticationProviders.delete(w);const s=this._providers.findIndex(f=>f.id===w);s>-1&&this._providers.splice(s),this._proxy.$unregisterAuthenticationProvider(w)})}$createSession(w,n){const A=this._authenticationProviders.get(w);if(A)return Promise.resolve(A.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,n){const A=this._authenticationProviders.get(w);if(A)return Promise.resolve(A.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,n){const A=this._authenticationProviders.get(w);if(A)return Promise.resolve(A.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,n){return this._onDidChangeSessions.fire({provider:{id:w,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(w,n){return w.forEach(A=>{this._providers.some(I=>I.id===A.id)||this._providers.push(A)}),n.forEach(A=>{const I=this._providers.findIndex(v=>v.id===A.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:w,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=E}),define(we[184],Ee([0,1,5,14,9]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(k,w){this._extHostDocumentsAndEditors=w,this._proxy=k.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const w=T.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(w)}};P=je([qe(0,S.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(we[185],Ee([0,1,5]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class S{constructor(P){const E=P.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return E.$readText()},writeText(k){return E.$writeText(k)}})}}e.ExtHostClipboard=S}),define(we[73],Ee([0,1,12,7,9,23,5,15,19,57,32,39,2,6,4,14]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadCommands),this._logService=r,this.converter=new m(this,o=>{const l=this._apiCommands.get(o);return(l==null?void 0:l.result)===c.Void?l:void 0},r),this._argumentProcessors=[{processArgument(o){return(0,n.revive)(o)}},{processArgument(o){return(0,P.cloneAndChange)(o,function(l){if(A.Range.isIRange(l))return T.Range.to(l);if(I.Position.isIPosition(l))return T.Position.to(l);if(A.Range.isIRange(l.range)&&v.URI.isUri(l.uri))return T.location.to(l);if(!Array.isArray(l))return l})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...o)=>{const l=t.args.map((h,D)=>{if(!h.validate(o[D]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${o[D]}`);return h.convert(o[D])}),i=await this.executeCommand(t.internalId,...l);return t.result.convert(i,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new S.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,o,l,i){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:o,thisArg:l,description:i}),t&&this._proxy.$registerCommand(r),new S.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,o){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const l=(0,P.cloneAndChange)(r,function(i){if(i instanceof S.Position)return T.Position.from(i);if(i instanceof S.Range)return T.Range.from(i);if(i instanceof S.Location)return T.location.from(i);if(!Array.isArray(i))return i});try{const i=await this._proxy.$executeCommand(t,l,o);return(0,n.revive)(i)}catch(i){if(i instanceof Error&&i.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw i}}}async _executeContributedCommand(t,r){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:l,thisArg:i,description:h}=o;if(h)for(let D=0;D<h.args.length;D++)try{(0,_.validateConstraint)(r[D],h.args[D].constraint)}catch(C){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[D].name}' - ${h.args[D].description}`)}try{return await l.apply(i,r)}catch(D){if(t===this.converter.delegatingCommandId){const C=this.converter.getActualCommand(...r);C&&(t=C.command)}throw this._logService.error(D,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(o=>this._argumentProcessors.reduce((l,i)=>i.processArgument(l),o)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(o=>o[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,o]of this._commands){let{description:l}=o;l&&(t[r]=l)}return Promise.resolve(t)}};p=je([qe(0,f.IExtHostRpcService),qe(1,w.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class m{constructor(t,r,o){this._commands=t,this._lookupApiCommand=r,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const l=this._lookupApiCommand(t.command);if(l)o.id=l.internalId,o.arguments=l.args.map((i,h)=>i.convert(t.arguments&&t.arguments[h]));else if((0,k.isNonEmptyArray)(t.arguments)){const i=++this._cachIdPool;this._cache.set(i,t),r.add((0,d.toDisposable)(()=>{this._cache.delete(i),this._logService.trace("CommandsConverter#DISPOSE",i)})),o.$ident=i,o.id=this.delegatingCommandId,o.arguments=[i],this._logService.trace("CommandsConverter#CREATE",t.command,i)}return o}}fromInternal(t){const r=E.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class b{constructor(t,r,o,l){this.name=t,this.description=r,this.validate=o,this.convert=l}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new b(t!=null?t:this.name,r!=null?r:this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",a=>v.URI.isUri(a),a=>a),b.Position=new b("position","A position in a text document",a=>S.Position.isPosition(a),T.Position.from),b.Range=new b("range","A range in a text document",a=>S.Range.isRange(a),T.Range.from),b.Selection=new b("selection","A selection in a text document",a=>S.Selection.isSelection(a),T.Selection.from),b.Number=new b("number","",a=>typeof a=="number",a=>a),b.String=new b("string","",a=>typeof a=="string",a=>a),b.CallHierarchyItem=new b("item","A call hierarchy item",a=>a instanceof S.CallHierarchyItem,T.CallHierarchyItem.to);class c{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=c,c.Void=new c("no result",a=>a);class u{constructor(t,r,o,l,i){this.id=t,this.internalId=r,this.description=o,this.args=l,this.result=i}}e.ApiCommand=u}),define(we[186],Ee([0,1,6,9,7,62,73,163,15,84]),function(ae,e,_,S,T,P,E,k,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const A=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",v(S.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(s,f)=>{if(!(0,w.isFalsyOrEmpty)(s)){class p extends T.SymbolInformation{static to(b){const c=new p(b.name,S.SymbolKind.to(b.kind),b.containerName||"",new T.Location(f[0],S.Range.to(b.range)));return c.detail=b.detail,c.range=c.location.range,c.selectionRange=S.Range.to(b.selectionRange),c.children=b.children?b.children.map(p.to):[],c}}return s.map(p.to)}})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(S.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(S.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",s=>typeof s=="string",s=>s),new E.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(S.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",v(S.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",v(S.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",s=>Array.isArray(s)&&s.every(f=>T.Position.isPosition(f)),s=>s.map(S.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",s=>s.map(f=>{let p;for(const m of f.reverse())p=new T.SelectionRange(S.Range.to(m),p);return p}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",s=>{const f=[];if(Array.isArray(s))for(let p of s)f.push(...p[1].map(S.WorkspaceSymbol.to));return f})),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(S.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(S.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(S.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",s=>{if(!!s){if(s.rejectReason)throw new Error(s.rejectReason);return S.WorkspaceEdit.to(s)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(S.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const f=(0,n.decodeSemanticTokensDto)(s);if(f.type==="full")return new T.SemanticTokens(f.data,void 0)}})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const f=(0,n.decodeSemanticTokensDto)(s);if(f.type==="full")return new T.SemanticTokens(f.data,void 0)}})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(s,f,p)=>{if(!s)return new T.CompletionList([]);const m=s.suggestions.map(b=>S.CompletionItem.to(b,p));return new T.CompletionList(m,s.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",s=>{if(s)return S.SignatureHelp.to(s)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(s,f,p)=>v(m=>new T.CodeLens(S.Range.to(m.range),m.command&&p.fromInternal(m.command)))(s))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>T.Range.isRange(s),s=>T.Selection.isSelection(s)?S.Selection.from(s):S.Range.from(s)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(s,f,p)=>v(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(m.command)}else{const b=new T.CodeAction(m.title,m.kind?new T.CodeActionKind(m.kind):void 0);return m.edit&&(b.edit=S.WorkspaceEdit.to(m.edit)),m.command&&(b.command=p.fromInternal(m.command)),b.isPreferred=m.isPreferred,b}})(s))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(f=>new T.ColorInformation(S.Range.to(f.range),S.Color.to(f.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",s=>s instanceof T.Color,S.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:S.Range.from(s.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(S.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineHint objects",s=>s.map(S.InlineHint.to))),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",v(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientMetadata:s.options.transientMetadata},filenamePattern:s.filenamePattern.map(f=>S.NotebookExclusiveDocumentPattern.to(f))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",s=>s.map(S.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[S.ViewColumn.from(s.viewColumn),S.TextEditorOpenOptions.from(s)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[S.ViewColumn.from(s.viewColumn),S.TextEditorOpenOptions.from(s)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[S.ViewColumn.from(s.viewColumn),S.TextEditorOpenOptions.from(s)]).optional()],E.ApiCommandResult.Void)];class I{constructor(f){this._disposables=new _.DisposableStore,this._commands=f}static register(f){return A.forEach(f.registerApiCommand,f),new I(f).registerCommands()}registerCommands(){const f=p=>(...m)=>p(this._commands,...m);this._register(k.RemoveFromRecentlyOpenedAPICommand.ID,f(k.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:p=>typeof p=="string"}]}),this._register(k.OpenIssueReporter.ID,f(k.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:p=>typeof p=="string"||typeof p=="object"&&typeof p.extensionId=="string"}]})}_register(f,p,m){const b=this._commands.registerCommand(!1,f,p,this,m);this._disposables.add(b)}}e.ExtHostApiCommands=I;function v(s){return f=>{if(Array.isArray(f))return f.map(s)}}function d(s){if(!!Array.isArray(s)){const f=[];for(const p of s)P.isLocationLink(p)?f.push(S.DefinitionLink.to(p)):f.push(S.location.to(p));return f}}}),define(we[187],Ee([0,1,13,44,3,6,2,62,25,9,7,5]),function(ae,e,_,S,T,P,E,k,w,n,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class v{constructor(u,a,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(I.MainContext.MainThreadComments),a.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const o=this._commentControllers.get(r.handle);return o||r}else if(r&&r.$mid===7){const o=this._commentControllers.get(r.commentControlHandle);if(!o)return r;const l=o.getCommentThread(r.commentThreadHandle);return l||r}else if(r&&r.$mid===8){const o=this._commentControllers.get(r.thread.commentControlHandle);if(!o)return r;const l=o.getCommentThread(r.thread.commentThreadHandle);return l?{thread:l,text:r.text}:r}else if(r&&r.$mid===9){const o=this._commentControllers.get(r.thread.commentControlHandle);if(!o)return r;const l=o.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let i=r.commentUniqueId,h=l.getCommentByUniqueId(i);return h||r}else if(r&&r.$mid===10){const o=this._commentControllers.get(r.thread.commentControlHandle);if(!o)return r;const l=o.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let i=r.text,h=r.commentUniqueId,D=l.getCommentByUniqueId(h);return D?(D.body=i,D):r}return r}})}createCommentController(u,a,t){const r=v.handlePool++,o=new s(u,r,this._proxy,a,t);this._commentControllers.set(o.handle,o);const l=this._commentControllersByExtension.get(w.ExtensionIdentifier.toKey(u.identifier))||[];return l.push(o),this._commentControllersByExtension.set(w.ExtensionIdentifier.toKey(u.identifier),l),o}$createCommentThreadTemplate(u,a,t){const r=this._commentControllers.get(u);!r||r.$createCommentThreadTemplate(a,t)}async $updateCommentThreadTemplate(u,a,t){const r=this._commentControllers.get(u);!r||r.$updateCommentThreadTemplate(a,t)}$deleteCommentThread(u,a){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(a)}$provideCommentingRanges(u,a,t){const r=this._commentControllers.get(u);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(E.URI.revive(a));return(0,_.asPromise)(()=>r.commentingRangeProvider.provideCommentingRanges(o,t)).then(l=>l?l.map(i=>n.Range.from(i)):void 0)}$toggleReaction(u,a,t,r,o){const l=this._commentControllers.get(u);return!l||!l.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const i=l.getCommentThread(a);if(i){const h=i.getCommentByUniqueId(r.uniqueIdInThread);if(l!==void 0&&h&&l.reactionHandler)return l.reactionHandler(h,m(o))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=v,v.handlePool=0;class d{constructor(u,a,t,r,o,l,i){this._proxy=u,this._commentController=a,this._id=t,this._uri=r,this._range=o,this._comments=l,this.handle=d._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${a.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),i),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=l}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),a={};u("range")&&(a.range=n.Range.from(this._range)),u("label")&&(a.label=this.label),u("contextValue")&&(a.contextValue=this.contextValue),u("comments")&&(a.comments=this._comments.map(t=>f(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(a.collapseState=b(this._collapseState)),u("canReply")&&(a.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,a)}}getCommentByUniqueId(u){for(let a of this._commentsMap){let t=a[0],r=a[1];if(u===r)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}d._handlePool=0,je([(0,S.debounce)(100)],d.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=d;class s{constructor(u,a,t,r,o){this._extension=u,this._handle=a,this._proxy=t,this._id=r,this._label=o,this._threads=new Map,this._proxy.$registerCommentController(this.handle,r,o)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,a,t,r){if(typeof u=="string"){const o=new d(this._proxy,this,u,a,t,r,this._extension.identifier);return this._threads.set(o.handle,o),o}else{const o=new d(this._proxy,this,void 0,u,a,t,this._extension.identifier);return this._threads.set(o.handle,o),o}}$createCommentThreadTemplate(u,a){const t=new d(this._proxy,this,void 0,E.URI.revive(u),n.Range.to(a),[],this._extension.identifier);return t.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,a){let t=this._threads.get(u);t&&(t.range=n.Range.to(a))}$deleteCommentThread(u){let a=this._threads.get(u);a&&a.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function f(c,u,a,t){let r=t.get(a);r||(r=++c.commentHandle,t.set(a,r));const o=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:r,body:n.MarkdownString.from(a.body),userName:a.author.name,userIconPath:o,label:a.label,commentReactions:a.reactions?a.reactions.map(l=>p(l)):void 0}}function p(c){return{label:c.label,iconPath:c.iconPath?n.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function m(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?E.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function b(c){if(c!==void 0)switch(c){case A.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}}),define(we[97],Ee([0,1,2,5,7,4,14,19,15,8,11]),function(ae,e,_,S,T,P,E,k,w,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class on{constructor(d,s){this._logService=s,this._provider=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,s){const f=on._handlePool++;this._provider.set(f,{provider:d,extensionId:s}),this._proxy.$registerDecorationProvider(f,s.value);const p=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(f,null);return}let b=(0,w.asArray)(m);if(b.length<=on._maxEventSize){this._proxy.$onDidChange(f,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,b.length);const c=b.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),u=(0,w.groupBy)(c,(t,r)=>t.rank-r.rank||(0,n.compare)(t.uri.path,r.uri.path));let a=[];e:for(let t of u){let r;for(let o of t){let l=(0,A.dirname)(o.uri.path);if(r!==l&&(r=l,a.push(o.uri)>=on._maxEventSize))break e}}this._proxy.$onDidChange(f,a)});return new T.Disposable(()=>{p==null||p.dispose(),this._proxy.$unregisterDecorationProvider(f),this._provider.delete(f)})}async $provideDecorations(d,s,f){if(!this._provider.has(d))return Object.create(null);const p=Object.create(null),{provider:m,extensionId:b}=this._provider.get(d);return await Promise.all(s.map(async c=>{try{const{uri:u,id:a}=c,t=await Promise.resolve(m.provideFileDecoration(_.URI.revive(u),f));if(!t)return;try{T.FileDecoration.validate(t),p[a]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${b.value}': ${r}`)}}catch(u){this._logService.error(u)}})),p}};I._handlePool=0,I._maxEventSize=250,I=je([qe(0,E.IExtHostRpcService),qe(1,k.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")}),define(we[188],Ee([0,1,127,87,2,5,7,9,3,19,22]),function(ae,e,_,S,T,P,E,k,w,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(s,f,p,m,b){this._name=s,this._owner=f,this._maxDiagnosticsPerFile=p,this._proxy=m,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new A.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(s,f){if(!s){this.clear();return}this._checkDisposed();let p=[];if(T.URI.isUri(s)){if(!f){this.delete(s);return}this._data.set(s,f.slice()),p=[s]}else if(Array.isArray(s)){p=[];let b;s=[...s].sort(I._compareIndexedTuplesByUri);for(const c of s){const[u,a]=c;if((!b||u.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=u,p.push(u),this._data.set(u,[])),a){const t=this._data.get(u);t&&t.push(...a)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!!this._proxy){const m=[];for(let b of p){let c=[];const u=this._data.get(b);if(u)if(u.length>this._maxDiagnosticsPerFile){c=[];const a=[E.DiagnosticSeverity.Error,E.DiagnosticSeverity.Warning,E.DiagnosticSeverity.Information,E.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of u)if(r.severity===a[t]&&c.push(k.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;c.push({severity:S.MarkerSeverity.Info,message:(0,_.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=u.map(a=>k.Diagnostic.from(a));m.push([b,c])}this._proxy.$changeMany(this._owner,m)}}delete(s){this._checkDisposed(),this._onDidChangeDiagnostics.fire([s]),this._data.delete(s),this._proxy&&this._proxy.$changeMany(this._owner,[[s,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(s,f){this._checkDisposed();for(let p of this._data.keys())s.apply(f,[p,this.get(p),this])}get(s){this._checkDisposed();const f=this._data.get(s);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(s){return this._checkDisposed(),Array.isArray(this._data.get(s))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(s,f){return s[0].toString()<f[0].toString()?-1:s[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=I;let v=class Nt{constructor(s,f){this._logService=f,this._collections=new Map,this._onDidChangeDiagnostics=new w.Emitter,this.onDidChangeDiagnostics=w.Event.map(w.Event.debounce(this._onDidChangeDiagnostics.event,Nt._debouncer,50),Nt._mapper),this._proxy=s.getProxy(P.MainContext.MainThreadDiagnostics)}static _debouncer(s,f){return s?s.concat(f):f}static _mapper(s){const f=[],p=new Set;for(const m of s)typeof m=="string"?p.has(m)||(p.add(m),f.push(T.URI.parse(m))):p.has(m.toString())||(p.add(m.toString()),f.push(m));return Object.freeze(f),{uris:f}}createDiagnosticCollection(s,f){const{_collections:p,_proxy:m,_onDidChangeDiagnostics:b,_logService:c}=this,u=new class{$changeMany(r,o){m.$changeMany(r,o),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,r,o.length===0?"CLEARING":o)}$clear(r){m.$clear(r),c.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,r)}dispose(){m.dispose()}};let a;if(!f)f="_generated_diagnostic_collection_name_#"+Nt._idPool++,a=f;else if(!p.has(f))a=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do a=f+Nt._idPool++;while(p.has(a))}return new class extends I{constructor(){super(f,a,Nt._maxDiagnosticsPerFile,u,b);p.set(a,this)}dispose(){super.dispose(),p.delete(a)}}}getDiagnostics(s){if(s)return this._getDiagnostics(s);{const f=new Map,p=[];for(const m of this._collections.values())m.forEach((b,c)=>{let u=f.get(b.toString());typeof u=="undefined"&&(u=p.length,f.set(b.toString(),u),p.push([b,[]])),p[u][1]=p[u][1].concat(...c)});return p}}_getDiagnostics(s){let f=[];for(let p of this._collections.values())p.has(s)&&(f=f.concat(p.get(s)));return f}$acceptMarkersChange(s){if(!this._mirrorCollection){const f="_generated_mirror",p=new I(f,f,Nt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(f,p),this._mirrorCollection=p}for(const[f,p]of s)this._mirrorCollection.set(T.URI.revive(f),p.map(k.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=je([qe(1,n.ILogService)],v),e.ExtHostDiagnostics=v}),define(we[189],Ee([0,1,2,5]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(E){this._proxy=E.getProxy(S.MainContext.MainThreadDialogs)}showOpenDialog(E){return this._proxy.$showOpenDialog(E).then(k=>k?k.map(w=>_.URI.revive(w)):void 0)}showSaveDialog(E){return this._proxy.$showSaveDialog(E).then(k=>k?_.URI.revive(k):void 0)}}e.ExtHostDialogs=T}),define(we[190],Ee([0,1,10,2,7,5,16,20,8]),function(ae,e,_,S,T,P,E,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(I,v,d){this._documentsAndEditors=v,this._logService=d,this._documentContentProviders=new Map,this._proxy=I.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,v){if(Object.keys(E.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const d=n._handlePool++;this._documentContentProviders.set(d,v),this._proxy.$registerTextContentProvider(d,I);let s;return typeof v.onDidChange=="function"&&(s=v.onDidChange(f=>{if(f.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(f)&&this.$provideTextDocumentContent(d,f).then(p=>{if(!(!p&&typeof p!="string")){const m=this._documentsAndEditors.getDocument(f);if(!!m){const b=(0,w.splitLines)(p);if(!m.equalLines(b))return this._proxy.$onVirtualDocumentChange(f,p)}}},_.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(I,v){const d=this._documentContentProviders.get(I);return d?Promise.resolve(d.provideTextDocumentContent(S.URI.revive(v),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(we[191],Ee([0,1,3,6,2,5,94,9,12,23]),function(ae,e,_,S,T,P,E,k,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class A{constructor(v,d){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new S.DisposableStore,this._documentLoader=new Map,this._proxy=v.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=d,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const f of s)this._onDidRemoveDocument.fire(f.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const f of s)this._onDidAddDocument.fire(f.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(v){if(!!v){const d=this._documentsAndEditors.getDocument(v);if(d)return d}}getDocument(v){const d=this.getDocumentData(v);if(!(d==null?void 0:d.document))throw new Error(`Unable to retrieve document from URI '${v}'`);return d.document}ensureDocumentData(v){const d=this._documentsAndEditors.getDocument(v);if(d)return Promise.resolve(d);let s=this._documentLoader.get(v.toString());return s||(s=this._proxy.$tryOpenDocument(v).then(f=>{this._documentLoader.delete(v.toString());const p=T.URI.revive(f);return(0,w.assertIsDefined)(this._documentsAndEditors.getDocument(p))},f=>(this._documentLoader.delete(v.toString()),Promise.reject(f))),this._documentLoader.set(v.toString(),s)),s}createDocumentData(v){return this._proxy.$tryCreateDocument(v).then(d=>T.URI.revive(d))}$acceptModelModeChanged(v,d){const s=T.URI.revive(v),f=this._documentsAndEditors.getDocument(s);if(!f)throw new Error("unknown document");this._onDidRemoveDocument.fire(f.document),f._acceptLanguageId(d),this._onDidAddDocument.fire(f.document)}$acceptModelSaved(v){const d=T.URI.revive(v),s=this._documentsAndEditors.getDocument(d);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(v,d){const s=T.URI.revive(v),f=this._documentsAndEditors.getDocument(s);if(!f)throw new Error("unknown document");f._acceptIsDirty(d),this._onDidChangeDocument.fire({document:f.document,contentChanges:[]})}$acceptModelChanged(v,d,s){const f=T.URI.revive(v),p=this._documentsAndEditors.getDocument(f);if(!p)throw new Error("unknown document");p._acceptIsDirty(s),p.onEvents(d),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:p.document,contentChanges:d.changes.map(m=>({range:k.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text}))}))}setWordDefinitionFor(v,d){(0,E.setWordDefinitionFor)(v,d)}}e.ExtHostDocuments=A}),define(we[40],Ee([0,1,43,3,6,2,4,5,94,14,95,9,19,22,16,53,105]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(u,a){this._extHostRpc=u,this._logService=a,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new S.Emitter,this._onDidRemoveDocuments=new S.Emitter,this._onDidChangeVisibleTextEditors=new S.Emitter,this._onDidChangeActiveTextEditor=new S.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const a=[],t=[],r=[];if(u.removedDocuments)for(const o of u.removedDocuments){const l=P.URI.revive(o),i=this._documents.get(l);(i==null?void 0:i.unref())&&(this._documents.delete(l),a.push(i.value))}if(u.addedDocuments)for(const o of u.addedDocuments){const l=P.URI.revive(o.uri);let i=this._documents.get(l);if(i&&l.scheme!==s.Schemas.vscodeNotebookCell)throw new Error(`document '${l} already exists!'`);i||(i=new m(new w.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),l,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(l,i),t.push(i.value)),i.ref()}if(u.removedEditors)for(const o of u.removedEditors){const l=this._editors.get(o);this._editors.delete(o),l&&r.push(l)}if(u.addedEditors)for(const o of u.addedEditors){const l=P.URI.revive(o.documentUri);_.ok(this._documents.has(l),`document '${l}' does not exist`),_.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const i=this._documents.get(l).value,h=new A.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>i.document),o.selections.map(I.Selection.to),o.options,o.visibleRanges.map(D=>I.Range.to(D)),typeof o.editorPosition=="number"?I.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,h)}u.newActiveEditor!==void 0&&(_.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,T.dispose)(a),(0,T.dispose)(r),u.removedDocuments&&this._onDidRemoveDocuments.fire(a),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var a;return(a=this._documents.get(u))===null||a===void 0?void 0:a.value}allDocuments(){return f.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const a=this._editors.get(this._activeEditorId);return u?a:a==null?void 0:a.value}}allEditors(){return[...this._editors.values()]}};b=je([qe(0,n.IExtHostRpcService),qe(1,v.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,E.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[192],Ee([0,1,2,5,6,7,9,115,8,26]),function(ae,e,_,S,T,P,E,k,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class A{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const s=this._schemes.indexOf(d);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),s=[];let f,p,m=14,b=14;for(const c of d){let u=f?(0,w.commonPrefixLength)(f,c):0;for(u===0?p=1:p=b;u<c.length;u++)u+1===c.length?(m=b,b=9):b+=1,s.push([p,c.toUpperCase().charCodeAt(u),b]),s.push([p,c.toLowerCase().charCodeAt(u),b]),p=b;f=c,b=m}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new k.StateMachine(s)}}provideDocumentLinks(d){this._initStateMachine();const s=[],f=k.LinkComputer.computeLinks({getLineContent(p){return d.lineAt(p-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const p of f){const m=E.DocumentLink.to(p);m.target&&s.push(m)}return s}}class I{constructor(d,s){this._extHostLanguageFeatures=s,this._linkProvider=new A,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=d.getProxy(S.MainContext.MainThreadFileSystem)}dispose(){var d;(d=this._linkProviderRegistration)===null||d===void 0||d.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,s,f,p={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const m=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(m,f);let b=2;p.isCaseSensitive&&(b+=1024),p.isReadonly&&(b+=2048),typeof f.copy=="function"&&(b+=8),typeof f.open=="function"&&typeof f.close=="function"&&typeof f.read=="function"&&typeof f.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(m,s,b).catch(u=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${s}`),console.error(u)});const c=f.onDidChangeFile(u=>{const a=[];for(const t of u){let{uri:r,type:o}=t;if(r.scheme===s){let l;switch(o){case P.FileChangeType.Changed:l=0;break;case P.FileChangeType.Created:l=1;break;case P.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:r,type:l})}}this._proxy.$onFileSystemChange(m,a)});return(0,T.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(m),this._proxy.$unregisterProvider(m)})}static _asIStat(d){const{type:s,ctime:f,mtime:p,size:m}=d;return{type:s,ctime:f,mtime:p,size:m}}$stat(d,s){return Promise.resolve(this._getFsProvider(d).stat(_.URI.revive(s))).then(I._asIStat)}$readdir(d,s){return Promise.resolve(this._getFsProvider(d).readDirectory(_.URI.revive(s)))}$readFile(d,s){return Promise.resolve(this._getFsProvider(d).readFile(_.URI.revive(s))).then(f=>n.VSBuffer.wrap(f))}$writeFile(d,s,f,p){return Promise.resolve(this._getFsProvider(d).writeFile(_.URI.revive(s),f.buffer,p))}$delete(d,s,f){return Promise.resolve(this._getFsProvider(d).delete(_.URI.revive(s),f))}$rename(d,s,f,p){return Promise.resolve(this._getFsProvider(d).rename(_.URI.revive(s),_.URI.revive(f),p))}$copy(d,s,f,p){const m=this._getFsProvider(d);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(_.URI.revive(s),_.URI.revive(f),p))}$mkdir(d,s){return Promise.resolve(this._getFsProvider(d).createDirectory(_.URI.revive(s)))}$watch(d,s,f,p){const m=this._getFsProvider(d).watch(_.URI.revive(f),p);this._watches.set(s,m)}$unwatch(d,s){const f=this._watches.get(s);f&&(f.dispose(),this._watches.delete(s))}$open(d,s,f){const p=this._getFsProvider(d);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(_.URI.revive(s),f))}$close(d,s){const f=this._getFsProvider(d);if(!f.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(f.close(s))}$read(d,s,f,p){const m=this._getFsProvider(d);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const b=n.VSBuffer.alloc(p);return Promise.resolve(m.read(s,f,b.buffer,0,p)).then(c=>b.slice(0,c))}$write(d,s,f,p){const m=this._getFsProvider(d);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(s,f,p.buffer,0,p.byteLength))}_getFsProvider(d){const s=this._fsProvider.get(d);if(!s){const f=new Error;throw f.name="ENOPRO",f.message="no provider",f}return s}}e.ExtHostFileSystem=I}),define(we[74],Ee([0,1,5,64,7,26,4,14,48]),function(ae,e,_,S,T,P,E,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Tt{constructor(I,v){const d=I.getProxy(_.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return d.$stat(s).catch(Tt._handleError)},readDirectory(s){return d.$readdir(s).catch(Tt._handleError)},createDirectory(s){return d.$mkdir(s).catch(Tt._handleError)},async readFile(s){return d.$readFile(s).then(f=>f.buffer).catch(Tt._handleError)},writeFile(s,f){return d.$writeFile(s,P.VSBuffer.wrap(f)).catch(Tt._handleError)},delete(s,f){return d.$delete(s,Object.assign({recursive:!1,useTrash:!1},f)).catch(Tt._handleError)},rename(s,f,p){return d.$rename(s,f,Object.assign({overwrite:!1},p)).catch(Tt._handleError)},copy(s,f,p){return d.$copy(s,f,Object.assign({overwrite:!1},p)).catch(Tt._handleError)},isWritableFileSystem(s){const f=v.getCapabilities(s);if(typeof f=="number")return!(f&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new T.FileSystemError(String(I));if(I.name==="ENOPRO")throw T.FileSystemError.Unavailable(I.message);switch(I.name){case S.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(I.message);case S.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(I.message);case S.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(I.message);case S.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(I.message);case S.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(I.message);case S.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(I.message);default:throw new T.FileSystemError(I.message,I.name)}}};n=je([qe(0,k.IExtHostRpcService),qe(1,w.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,E.createDecorator)("IExtHostConsumerFileSystem")}),define(we[193],Ee([0,1,6,5]),function(ae,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(E){this._handlePool=0,this._proxy=E.getProxy(S.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(E){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,E),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=T}),define(we[194],Ee([0,1,2,23,9,7,13,5,8,32,15,12,112,6,84,52,92,54,10]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(N,q){this._documents=N,this._provider=q}provideDocumentSymbols(N,q){const J=this._documents.getDocument(N);return(0,E.asPromise)(()=>this._provider.provideDocumentSymbols(J,q)).then(le=>{if(!(0,A.isFalsyOrEmpty)(le))return le[0]instanceof P.DocumentSymbol?le.map(T.DocumentSymbol.from):c._asDocumentSymbolTree(le)})}static _asDocumentSymbolTree(N){var q;N=N.slice(0).sort((ge,De)=>{let Le=ge.location.range.start.compareTo(De.location.range.start);return Le===0&&(Le=De.location.range.end.compareTo(ge.location.range.end)),Le});const J=[],le=[];for(const ge of N){const De={name:ge.name||"!!MISSING: name!!",kind:T.SymbolKind.from(ge.kind),tags:((q=ge.tags)===null||q===void 0?void 0:q.map(T.SymbolTag.from))||[],detail:"",containerName:ge.containerName,range:T.Range.from(ge.location.range),selectionRange:T.Range.from(ge.location.range),children:[]};for(;;){if(le.length===0){le.push(De),J.push(De);break}const Le=le[le.length-1];if(n.Range.containsRange(Le.range,De.range)&&!n.Range.equalsRange(Le.range,De.range)){Le.children&&Le.children.push(De),le.push(De);break}le.pop()}}return J}}class u{constructor(N,q,J){this._documents=N,this._commands=q,this._provider=J,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(N,q){const J=this._documents.getDocument(N),le=await this._provider.provideCodeLenses(J,q);if(!(!le||q.isCancellationRequested)){const ge=this._cache.add(le),De=new d.DisposableStore;this._disposables.set(ge,De);const Le={cacheId:ge,lenses:[]};for(let pe=0;pe<le.length;pe++)Le.lenses.push({cacheId:[ge,pe],range:T.Range.from(le[pe].range),command:this._commands.toInternal(le[pe].command,De)});return Le}}async resolveCodeLens(N,q){var J;const le=N.cacheId&&this._cache.get(...N.cacheId);if(!!le){let ge;if(typeof this._provider.resolveCodeLens!="function"||le.isResolved?ge=le:ge=await this._provider.resolveCodeLens(le,q),ge||(ge=le),!q.isCancellationRequested){const De=N.cacheId&&this._disposables.get(N.cacheId[0]);if(!!De)return N.command=this._commands.toInternal((J=ge.command)!==null&&J!==void 0?J:u._badCmd,De),N}}}releaseCodeLenses(N){var q;(q=this._disposables.get(N))===null||q===void 0||q.dispose(),this._disposables.delete(N),this._cache.delete(N)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function a(xe){return Array.isArray(xe)?xe.map(T.DefinitionLink.from):xe?[T.DefinitionLink.from(xe)]:[]}class t{constructor(N,q){this._documents=N,this._provider=q}provideDefinition(N,q,J){const le=this._documents.getDocument(N),ge=T.Position.to(q);return(0,E.asPromise)(()=>this._provider.provideDefinition(le,ge,J)).then(a)}}class r{constructor(N,q){this._documents=N,this._provider=q}provideDeclaration(N,q,J){const le=this._documents.getDocument(N),ge=T.Position.to(q);return(0,E.asPromise)(()=>this._provider.provideDeclaration(le,ge,J)).then(a)}}class o{constructor(N,q){this._documents=N,this._provider=q}provideImplementation(N,q,J){const le=this._documents.getDocument(N),ge=T.Position.to(q);return(0,E.asPromise)(()=>this._provider.provideImplementation(le,ge,J)).then(a)}}class l{constructor(N,q){this._documents=N,this._provider=q}provideTypeDefinition(N,q,J){const le=this._documents.getDocument(N),ge=T.Position.to(q);return(0,E.asPromise)(()=>this._provider.provideTypeDefinition(le,ge,J)).then(a)}}class i{constructor(N,q){this._documents=N,this._provider=q}provideHover(N,q,J){const le=this._documents.getDocument(N),ge=T.Position.to(q);return(0,E.asPromise)(()=>this._provider.provideHover(le,ge,J)).then(De=>{if(!(!De||(0,A.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=le.getWordRangeAtPosition(ge)),De.range||(De.range=new P.Range(ge,ge)),T.Hover.from(De)})}}class h{constructor(N,q){this._documents=N,this._provider=q}provideEvaluatableExpression(N,q,J){const le=this._documents.getDocument(N),ge=T.Position.to(q);return(0,E.asPromise)(()=>this._provider.provideEvaluatableExpression(le,ge,J)).then(De=>{if(De)return T.EvaluatableExpression.from(De)})}}class D{constructor(N,q){this._documents=N,this._provider=q}provideInlineValues(N,q,J,le){const ge=this._documents.getDocument(N);return(0,E.asPromise)(()=>this._provider.provideInlineValues(ge,T.Range.to(q),T.InlineValueContext.to(J),le)).then(De=>{if(Array.isArray(De))return De.map(Le=>T.InlineValue.from(Le))})}}class C{constructor(N,q){this._documents=N,this._provider=q}provideDocumentHighlights(N,q,J){const le=this._documents.getDocument(N),ge=T.Position.to(q);return(0,E.asPromise)(()=>this._provider.provideDocumentHighlights(le,ge,J)).then(De=>{if(Array.isArray(De))return De.map(T.DocumentHighlight.from)})}}class g{constructor(N,q){this._documents=N,this._provider=q}provideLinkedEditingRanges(N,q,J){const le=this._documents.getDocument(N),ge=T.Position.to(q);return(0,E.asPromise)(()=>this._provider.provideLinkedEditingRanges(le,ge,J)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,A.coalesce)(De.ranges.map(T.Range.from)),wordPattern:De.wordPattern}})}}class y{constructor(N,q){this._documents=N,this._provider=q}provideReferences(N,q,J,le){const ge=this._documents.getDocument(N),De=T.Position.to(q);return(0,E.asPromise)(()=>this._provider.provideReferences(ge,De,J,le)).then(Le=>{if(Array.isArray(Le))return Le.map(T.location.from)})}}class R{constructor(N,q,J,le,ge,De,Le){this._documents=N,this._commands=q,this._diagnostics=J,this._provider=le,this._logService=ge,this._extension=De,this._apiDeprecation=Le,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(N,q,J,le){const ge=this._documents.getDocument(N),De=v.Selection.isISelection(q)?T.Selection.to(q):T.Range.to(q),Le=[];for(const Ce of this._diagnostics.getDiagnostics(N))if(De.intersection(Ce.range)&&Le.push(Ce)>R._maxCodeActionsPerFile)break;const pe={diagnostics:Le,only:J.only?new P.CodeActionKind(J.only):void 0,triggerKind:T.CodeActionTriggerKind.to(J.trigger)};return(0,E.asPromise)(()=>this._provider.provideCodeActions(ge,De,pe,le)).then(Ce=>{var Te;if(!(!(0,A.isNonEmptyArray)(Ce)||le.isCancellationRequested)){const Ue=this._cache.add(Ce),be=new d.DisposableStore;this._disposables.set(Ue,be);const Ke=[];for(let H=0;H<Ce.length;H++){const Z=Ce[H];!Z||(R._isCommand(Z)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:Z.title,command:this._commands.toInternal(Z,be)})):(pe.only&&(Z.kind?pe.only.contains(Z.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${Z.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[Ue,H],title:Z.title,command:Z.command&&this._commands.toInternal(Z.command,be),diagnostics:Z.diagnostics&&Z.diagnostics.map(T.Diagnostic.from),edit:Z.edit&&T.WorkspaceEdit.from(Z.edit),kind:Z.kind&&Z.kind.value,isPreferred:Z.isPreferred,disabled:(Te=Z.disabled)===null||Te===void 0?void 0:Te.reason})))}return{cacheId:Ue,actions:Ke}}})}async resolveCodeAction(N,q){var J;const[le,ge]=N,De=this._cache.get(le,ge);if(!(!De||R._isCommand(De))&&!!this._provider.resolveCodeAction){const Le=(J=await this._provider.resolveCodeAction(De,q))!==null&&J!==void 0?J:De;return(Le==null?void 0:Le.edit)?T.WorkspaceEdit.from(Le.edit):void 0}}releaseCodeActions(N){var q;(q=this._disposables.get(N))===null||q===void 0||q.dispose(),this._disposables.delete(N),this._cache.delete(N)}static _isCommand(N){return typeof N.command=="string"&&typeof N.title=="string"}}R._maxCodeActionsPerFile=1e3;class O{constructor(N,q){this._documents=N,this._provider=q}provideDocumentFormattingEdits(N,q,J){const le=this._documents.getDocument(N);return(0,E.asPromise)(()=>this._provider.provideDocumentFormattingEdits(le,q,J)).then(ge=>{if(Array.isArray(ge))return ge.map(T.TextEdit.from)})}}class x{constructor(N,q){this._documents=N,this._provider=q}provideDocumentRangeFormattingEdits(N,q,J,le){const ge=this._documents.getDocument(N),De=T.Range.to(q);return(0,E.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(ge,De,J,le)).then(Le=>{if(Array.isArray(Le))return Le.map(T.TextEdit.from)})}}class z{constructor(N,q){this._documents=N,this._provider=q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(N,q,J,le,ge){const De=this._documents.getDocument(N),Le=T.Position.to(q);return(0,E.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Le,J,le,ge)).then(pe=>{if(Array.isArray(pe))return pe.map(T.TextEdit.from)})}}class Q{constructor(N,q){this._provider=N,this._logService=q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(N,q){const J=k.IdObject.mixin({symbols:[]});return(0,E.asPromise)(()=>this._provider.provideWorkspaceSymbols(N,q)).then(le=>{if((0,A.isNonEmptyArray)(le)){for(const ge of le)if(!!ge){if(!ge.name){this._logService.warn("INVALID SymbolInformation, lacks name",ge);continue}const De=k.IdObject.mixin(T.WorkspaceSymbol.from(ge));this._symbolCache.set(De._id,ge),J.symbols.push(De)}}}).then(()=>(J.symbols.length>0&&this._resultCache.set(J._id,[J.symbols[0]._id,J.symbols[J.symbols.length-1]._id]),J))}async resolveWorkspaceSymbol(N,q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return N;const J=this._symbolCache.get(N._id);if(J){const le=await(0,E.asPromise)(()=>this._provider.resolveWorkspaceSymbol(J,q));return le&&(0,S.mixin)(N,T.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(N){const q=this._resultCache.get(N);if(q){for(let[J,le]=q;J<=le;J++)this._symbolCache.delete(J);this._resultCache.delete(N)}}}class j{constructor(N,q,J){this._documents=N,this._provider=q,this._logService=J}static supportsResolving(N){return typeof N.prepareRename=="function"}provideRenameEdits(N,q,J,le){const ge=this._documents.getDocument(N),De=T.Position.to(q);return(0,E.asPromise)(()=>this._provider.provideRenameEdits(ge,De,J,le)).then(Le=>{if(!!Le)return T.WorkspaceEdit.from(Le)},Le=>{const pe=j._asMessage(Le);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Le)})}resolveRenameLocation(N,q,J){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(N),ge=T.Position.to(q);return(0,E.asPromise)(()=>this._provider.prepareRename(le,ge,J)).then(De=>{let Le,pe;if(P.Range.isRange(De)?(Le=De,pe=le.getText(De)):(0,I.isObject)(De)&&(Le=De.range,pe=De.placeholder),!!Le){if(Le.start.line>ge.line||Le.end.line<ge.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Le),text:pe}}},De=>{const Le=j._asMessage(De);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class Y{constructor(N,q){this.resultId=N,this.tokens=q}}class L{constructor(N,q){this._documents=N,this._provider=q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(N,q,J){const le=this._documents.getDocument(N),ge=q!==0?this._previousResults.get(q):null;return(0,E.asPromise)(()=>ge&&typeof ge.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(le,ge.resultId,J):this._provider.provideDocumentSemanticTokens(le,J)).then(De=>(ge&&this._previousResults.delete(q),De?(De=L._fixProvidedSemanticTokens(De),this._send(L._convertToEdits(ge,De),De)):null))}async releaseDocumentSemanticColoring(N){this._previousResults.delete(N)}static _fixProvidedSemanticTokens(N){return L._isSemanticTokens(N)?L._isCorrectSemanticTokens(N)?N:new P.SemanticTokens(new Uint32Array(N.data),N.resultId):L._isSemanticTokensEdits(N)?L._isCorrectSemanticTokensEdits(N)?N:new P.SemanticTokensEdits(N.edits.map(q=>new P.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),N.resultId):N}static _isSemanticTokens(N){return N&&!!N.data}static _isCorrectSemanticTokens(N){return N.data instanceof Uint32Array}static _isSemanticTokensEdits(N){return N&&Array.isArray(N.edits)}static _isCorrectSemanticTokensEdits(N){for(const q of N.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(N,q){if(!L._isSemanticTokens(q)||!N||!N.tokens)return q;const J=N.tokens,le=J.length,ge=q.data,De=ge.length;let Le=0;const pe=Math.min(le,De);for(;Le<pe&&J[Le]===ge[Le];)Le++;if(Le===le&&Le===De)return new P.SemanticTokensEdits([],q.resultId);let Ce=0;const Te=pe-Le;for(;Ce<Te&&J[le-Ce-1]===ge[De-Ce-1];)Ce++;return new P.SemanticTokensEdits([{start:Le,deleteCount:le-Le-Ce,data:ge.subarray(Le,De-Ce)}],q.resultId)}_send(N,q){if(L._isSemanticTokens(N)){const J=this._nextResultId++;return this._previousResults.set(J,new Y(N.resultId,N.data)),(0,s.encodeSemanticTokensDto)({id:J,type:"full",data:N.data})}if(L._isSemanticTokensEdits(N)){const J=this._nextResultId++;return L._isSemanticTokens(q)?this._previousResults.set(J,new Y(q.resultId,q.data)):this._previousResults.set(J,new Y(N.resultId)),(0,s.encodeSemanticTokensDto)({id:J,type:"delta",deltas:(N.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=L;class ${constructor(N,q){this._documents=N,this._provider=q}provideDocumentRangeSemanticTokens(N,q,J){const le=this._documents.getDocument(N);return(0,E.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(le,T.Range.to(q),J)).then(ge=>ge?this._send(ge):null)}_send(N){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}e.DocumentRangeSemanticTokensAdapter=$;class W{constructor(N,q,J,le,ge){this._documents=N,this._commands=q,this._provider=J,this._apiDeprecation=le,this._extension=ge,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}async provideCompletionItems(N,q,J,le){const ge=this._documents.getDocument(N),De=T.Position.to(q),Le=ge.getWordRangeAtPosition(De)||new P.Range(De,De),pe=Le.with({end:De}),Ce=new m.StopWatch(!0),Te=await(0,E.asPromise)(()=>this._provider.provideCompletionItems(ge,De,le,T.CompletionContext.to(J)));if(!!Te&&!le.isCancellationRequested){const Ue=Array.isArray(Te)?new P.CompletionList(Te):Te,be=W.supportsResolving(this._provider)?this._cache.add(Ue.items):this._cache.add([]),Ke=new d.DisposableStore;this._disposables.set(be,Ke);const H=[],Z={x:be,b:H,a:{replace:T.Range.from(Le),insert:T.Range.from(pe)},c:Ue.isIncomplete||void 0,d:Ce.elapsed()};for(let _e=0;_e<Ue.items.length;_e++){const Me=Ue.items[_e],He=this._convertCompletionItem(Me,[be,_e],pe,Le);H.push(He)}return Z}}async resolveCompletionItem(N,q){if(typeof this._provider.resolveCompletionItem=="function"){const J=this._cache.get(...N);if(!!J){const le=await(0,E.asPromise)(()=>this._provider.resolveCompletionItem(J,q));if(!!le)return this._convertCompletionItem(le,N)}}}releaseCompletionItems(N){var q;(q=this._disposables.get(N))===null||q===void 0||q.dispose(),this._disposables.delete(N),this._cache.delete(N)}_convertCompletionItem(N,q,J,le){var ge;const De=this._disposables.get(q[0]);if(!De)throw Error("DisposableStore is missing...");const Le={x:q,a:(ge=N.label)!==null&&ge!==void 0?ge:"",o:N.label2,b:N.kind!==void 0?T.CompletionItemKind.from(N.kind):void 0,n:N.tags&&N.tags.map(T.CompletionItemTag.from),c:N.detail,d:typeof N.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters,l:N.additionalTextEdits&&N.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(N.command,De)};N.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=N.textEdit.newText):typeof N.insertText=="string"?Le.h=N.insertText:N.insertText instanceof P.SnippetString&&(Le.h=N.insertText.value,Le.i|=4);let pe;return N.textEdit?pe=N.textEdit.range:N.range&&(pe=N.range),P.Range.isRange(pe)?Le.j=T.Range.from(pe):pe&&(!(J==null?void 0:J.isEqual(pe.inserting))||!(le==null?void 0:le.isEqual(pe.replacing)))&&(Le.j={insert:T.Range.from(pe.inserting),replace:T.Range.from(pe.replacing)}),Le}}class K{constructor(N,q){this._documents=N,this._provider=q,this._cache=new p.Cache("SignatureHelp")}provideSignatureHelp(N,q,J,le){const ge=this._documents.getDocument(N),De=T.Position.to(q),Le=this.reviveContext(J);return(0,E.asPromise)(()=>this._provider.provideSignatureHelp(ge,De,le,Le)).then(pe=>{if(pe){const Ce=this._cache.add([pe]);return Object.assign(Object.assign({},T.SignatureHelp.from(pe)),{id:Ce})}})}reviveContext(N){let q;if(N.activeSignatureHelp){const J=T.SignatureHelp.to(N.activeSignatureHelp),le=this._cache.get(N.activeSignatureHelp.id,0);le?(q=le,q.activeSignature=J.activeSignature,q.activeParameter=J.activeParameter):q=J}return Object.assign(Object.assign({},N),{activeSignatureHelp:q})}releaseSignatureHelp(N){this._cache.delete(N)}}class U{constructor(N,q){this._documents=N,this._provider=q}provideInlineHints(N,q,J){const le=this._documents.getDocument(N);return(0,E.asPromise)(()=>this._provider.provideInlineHints(le,T.Range.to(q),J)).then(ge=>ge?{hints:ge.map(T.InlineHint.from)}:void 0)}}class ee{constructor(N,q){this._documents=N,this._provider=q,this._cache=new p.Cache("DocumentLink")}provideLinks(N,q){const J=this._documents.getDocument(N);return(0,E.asPromise)(()=>this._provider.provideDocumentLinks(J,q)).then(le=>{if(!(!Array.isArray(le)||le.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.map(T.DocumentLink.from)};{const ge=this._cache.add(le),De={links:[],id:ge};for(let Le=0;Le<le.length;Le++){const pe=T.DocumentLink.from(le[Le]);pe.cacheId=[ge,Le],De.links.push(pe)}return De}}})}resolveLink(N,q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const J=this._cache.get(...N);return J?(0,E.asPromise)(()=>this._provider.resolveDocumentLink(J,q)).then(le=>le&&T.DocumentLink.from(le)||void 0):Promise.resolve(void 0)}releaseLinks(N){this._cache.delete(N)}}class ie{constructor(N,q){this._documents=N,this._provider=q}provideColors(N,q){const J=this._documents.getDocument(N);return(0,E.asPromise)(()=>this._provider.provideDocumentColors(J,q)).then(le=>Array.isArray(le)?le.map(De=>({color:T.Color.from(De.color),range:T.Range.from(De.range)})):[])}provideColorPresentations(N,q,J){const le=this._documents.getDocument(N),ge=T.Range.to(q.range),De=T.Color.to(q.color);return(0,E.asPromise)(()=>this._provider.provideColorPresentations(De,{document:le,range:ge},J)).then(Le=>{if(!!Array.isArray(Le))return Le.map(T.ColorPresentation.from)})}}class se{constructor(N,q){this._documents=N,this._provider=q}provideFoldingRanges(N,q,J){const le=this._documents.getDocument(N);return(0,E.asPromise)(()=>this._provider.provideFoldingRanges(le,q,J)).then(ge=>{if(!!Array.isArray(ge))return ge.map(T.FoldingRange.from)})}}class Se{constructor(N,q,J){this._documents=N,this._provider=q,this._logService=J}provideSelectionRanges(N,q,J){const le=this._documents.getDocument(N),ge=q.map(T.Position.to);return(0,E.asPromise)(()=>this._provider.provideSelectionRanges(le,ge,J)).then(De=>{if(!(0,A.isNonEmptyArray)(De))return[];if(De.length!==ge.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let pe=0;pe<ge.length;pe++){const Ce=[];Le.push(Ce);let Te=ge[pe],Ue=De[pe];for(;;){if(!Ue.range.contains(Te))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(T.SelectionRange.from(Ue)),!Ue.parent)break;Te=Ue.range,Ue=Ue.parent}}return Le})}}class Ae{constructor(N,q){this._documents=N,this._provider=q,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(N,q,J){const le=this._documents.getDocument(N),ge=T.Position.to(q),De=await this._provider.prepareCallHierarchy(le,ge,J);if(!!De){const Le=this._idPool.nextId();return this._cache.set(Le,new Map),Array.isArray(De)?De.map(pe=>this._cacheAndConvertItem(Le,pe)):[this._cacheAndConvertItem(Le,De)]}}async provideCallsTo(N,q,J){const le=this._itemFromCache(N,q);if(!le)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyIncomingCalls(le,J);if(!!ge)return ge.map(De=>({from:this._cacheAndConvertItem(N,De.from),fromRanges:De.fromRanges.map(Le=>T.Range.from(Le))}))}async provideCallsFrom(N,q,J){const le=this._itemFromCache(N,q);if(!le)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyOutgoingCalls(le,J);if(!!ge)return ge.map(De=>({to:this._cacheAndConvertItem(N,De.to),fromRanges:De.fromRanges.map(Le=>T.Range.from(Le))}))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,q){var J;const le=this._cache.get(N),ge={_sessionId:N,_itemId:le.size.toString(36),name:q.name,detail:q.detail,kind:T.SymbolKind.from(q.kind),uri:q.uri,range:T.Range.from(q.range),selectionRange:T.Range.from(q.selectionRange),tags:(J=q.tags)===null||J===void 0?void 0:J.map(T.SymbolTag.from)};return le.set(ge._itemId,q),ge}_itemFromCache(N,q){const J=this._cache.get(N);return J==null?void 0:J.get(q)}}class Be{constructor(N,q){this.adapter=N,this.extension=q}}class Re{constructor(N,q,J,le,ge,De,Le){this._adapter=new Map,this._uriTransformer=q,this._proxy=N.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=J,this._commands=le,this._diagnostics=ge,this._logService=De,this._apiDeprecation=Le}_transformDocumentSelector(N){return(0,A.coalesce)((0,A.asArray)(N).map(q=>this._doTransformDocumentSelector(q)))}_doTransformDocumentSelector(N){if(typeof N=="string")return{$serialized:!0,language:N};if(N)return{$serialized:!0,language:N.language,scheme:this._transformScheme(N.scheme),pattern:typeof N.pattern=="undefined"?void 0:T.GlobPattern.from(N.pattern),exclusive:N.exclusive}}_transformScheme(N){return this._uriTransformer&&typeof N=="string"?this._uriTransformer.transformOutgoingScheme(N):N}_createDisposable(N){return new P.Disposable(()=>{this._adapter.delete(N),this._proxy.$unregister(N)})}_nextHandle(){return Re._handlePool++}_withAdapter(N,q,J,le,ge=!1){const De=this._adapter.get(N);if(!De)return Promise.resolve(le);if(De.adapter instanceof q){let Le;De.extension&&(Le=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${q.name}'`));const pe=J(De.adapter,De.extension),Ce=De.extension;return Ce&&Promise.resolve(pe).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Le}ms`),Te=>{ge&&Te instanceof b.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Te))}),pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(N,q){const J=this._nextHandle();return this._adapter.set(J,new Be(N,q)),J}static _extLabel(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,q,J,le){const ge=this._addNewAdapter(new c(this._documents,J),N),De=le&&le.label||Re._extLabel(N);return this._proxy.$registerDocumentSymbolProvider(ge,this._transformDocumentSelector(q),De),this._createDisposable(ge)}$provideDocumentSymbols(N,q,J){return this._withAdapter(N,c,le=>le.provideDocumentSymbols(_.URI.revive(q),J),void 0)}registerCodeLensProvider(N,q,J){const le=this._nextHandle(),ge=typeof J.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new u(this._documents,this._commands.converter,J),N)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(q),ge);let De=this._createDisposable(le);if(ge!==void 0){const Le=J.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(ge));De=P.Disposable.from(De,Le)}return De}$provideCodeLenses(N,q,J){return this._withAdapter(N,u,le=>le.provideCodeLenses(_.URI.revive(q),J),void 0)}$resolveCodeLens(N,q,J){return this._withAdapter(N,u,le=>le.resolveCodeLens(q,J),void 0)}$releaseCodeLenses(N,q){this._withAdapter(N,u,J=>Promise.resolve(J.releaseCodeLenses(q)),void 0)}registerDefinitionProvider(N,q,J){const le=this._addNewAdapter(new t(this._documents,J),N);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDefinition(N,q,J,le){return this._withAdapter(N,t,ge=>ge.provideDefinition(_.URI.revive(q),J,le),[])}registerDeclarationProvider(N,q,J){const le=this._addNewAdapter(new r(this._documents,J),N);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDeclaration(N,q,J,le){return this._withAdapter(N,r,ge=>ge.provideDeclaration(_.URI.revive(q),J,le),[])}registerImplementationProvider(N,q,J){const le=this._addNewAdapter(new o(this._documents,J),N);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideImplementation(N,q,J,le){return this._withAdapter(N,o,ge=>ge.provideImplementation(_.URI.revive(q),J,le),[])}registerTypeDefinitionProvider(N,q,J){const le=this._addNewAdapter(new l(this._documents,J),N);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideTypeDefinition(N,q,J,le){return this._withAdapter(N,l,ge=>ge.provideTypeDefinition(_.URI.revive(q),J,le),[])}registerHoverProvider(N,q,J,le){const ge=this._addNewAdapter(new i(this._documents,J),N);return this._proxy.$registerHoverProvider(ge,this._transformDocumentSelector(q)),this._createDisposable(ge)}$provideHover(N,q,J,le){return this._withAdapter(N,i,ge=>ge.provideHover(_.URI.revive(q),J,le),void 0)}registerEvaluatableExpressionProvider(N,q,J,le){const ge=this._addNewAdapter(new h(this._documents,J),N);return this._proxy.$registerEvaluatableExpressionProvider(ge,this._transformDocumentSelector(q)),this._createDisposable(ge)}$provideEvaluatableExpression(N,q,J,le){return this._withAdapter(N,h,ge=>ge.provideEvaluatableExpression(_.URI.revive(q),J,le),void 0)}registerInlineValuesProvider(N,q,J,le){const ge=typeof J.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new D(this._documents,J),N);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(q),ge);let Le=this._createDisposable(De);if(ge!==void 0){const pe=J.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(ge));Le=P.Disposable.from(Le,pe)}return Le}$provideInlineValues(N,q,J,le,ge){return this._withAdapter(N,D,De=>De.provideInlineValues(_.URI.revive(q),J,le,ge),void 0)}registerDocumentHighlightProvider(N,q,J){const le=this._addNewAdapter(new C(this._documents,J),N);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDocumentHighlights(N,q,J,le){return this._withAdapter(N,C,ge=>ge.provideDocumentHighlights(_.URI.revive(q),J,le),void 0)}registerLinkedEditingRangeProvider(N,q,J){const le=this._addNewAdapter(new g(this._documents,J),N);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideLinkedEditingRanges(N,q,J,le){return this._withAdapter(N,g,async ge=>{const De=await ge.provideLinkedEditingRanges(_.URI.revive(q),J,le);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Re._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(N,q,J){const le=this._addNewAdapter(new y(this._documents,J),N);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideReferences(N,q,J,le,ge){return this._withAdapter(N,y,De=>De.provideReferences(_.URI.revive(q),J,le,ge),void 0)}registerCodeActionProvider(N,q,J,le){var ge,De;const Le=new d.DisposableStore,pe=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,J,this._logService,N,this._apiDeprecation),N);return this._proxy.$registerQuickFixSupport(pe,this._transformDocumentSelector(q),{providedKinds:(ge=le==null?void 0:le.providedCodeActionKinds)===null||ge===void 0?void 0:ge.map(Ce=>Ce.value),documentation:(De=le==null?void 0:le.documentation)===null||De===void 0?void 0:De.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Le)}))},Re._extLabel(N),Boolean(J.resolveCodeAction)),Le.add(this._createDisposable(pe)),Le}$provideCodeActions(N,q,J,le,ge){return this._withAdapter(N,R,De=>De.provideCodeActions(_.URI.revive(q),J,le,ge),void 0)}$resolveCodeAction(N,q,J){return this._withAdapter(N,R,le=>le.resolveCodeAction(q,J),void 0)}$releaseCodeActions(N,q){this._withAdapter(N,R,J=>Promise.resolve(J.releaseCodeActions(q)),void 0)}registerDocumentFormattingEditProvider(N,q,J){const le=this._addNewAdapter(new O(this._documents,J),N);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(q),N.identifier,N.displayName||N.name),this._createDisposable(le)}$provideDocumentFormattingEdits(N,q,J,le){return this._withAdapter(N,O,ge=>ge.provideDocumentFormattingEdits(_.URI.revive(q),J,le),void 0)}registerDocumentRangeFormattingEditProvider(N,q,J){const le=this._addNewAdapter(new x(this._documents,J),N);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(q),N.identifier,N.displayName||N.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(N,q,J,le,ge){return this._withAdapter(N,x,De=>De.provideDocumentRangeFormattingEdits(_.URI.revive(q),J,le,ge),void 0)}registerOnTypeFormattingEditProvider(N,q,J,le){const ge=this._addNewAdapter(new z(this._documents,J),N);return this._proxy.$registerOnTypeFormattingSupport(ge,this._transformDocumentSelector(q),le,N.identifier),this._createDisposable(ge)}$provideOnTypeFormattingEdits(N,q,J,le,ge,De){return this._withAdapter(N,z,Le=>Le.provideOnTypeFormattingEdits(_.URI.revive(q),J,le,ge,De),void 0)}registerWorkspaceSymbolProvider(N,q){const J=this._addNewAdapter(new Q(q,this._logService),N);return this._proxy.$registerNavigateTypeSupport(J),this._createDisposable(J)}$provideWorkspaceSymbols(N,q,J){return this._withAdapter(N,Q,le=>le.provideWorkspaceSymbols(q,J),{symbols:[]})}$resolveWorkspaceSymbol(N,q,J){return this._withAdapter(N,Q,le=>le.resolveWorkspaceSymbol(q,J),void 0)}$releaseWorkspaceSymbols(N,q){this._withAdapter(N,Q,J=>J.releaseWorkspaceSymbols(q),void 0)}registerRenameProvider(N,q,J){const le=this._addNewAdapter(new j(this._documents,J,this._logService),N);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(q),j.supportsResolving(J)),this._createDisposable(le)}$provideRenameEdits(N,q,J,le,ge){return this._withAdapter(N,j,De=>De.provideRenameEdits(_.URI.revive(q),J,le,ge),void 0)}$resolveRenameLocation(N,q,J,le){return this._withAdapter(N,j,ge=>ge.resolveRenameLocation(_.URI.revive(q),J,le),void 0)}registerDocumentSemanticTokensProvider(N,q,J,le){const ge=this._nextHandle(),De=typeof J.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(ge,new Be(new L(this._documents,J),N)),this._proxy.$registerDocumentSemanticTokensProvider(ge,this._transformDocumentSelector(q),le,De);let Le=this._createDisposable(ge);if(De){const pe=J.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(De));Le=P.Disposable.from(Le,pe)}return Le}$provideDocumentSemanticTokens(N,q,J,le){return this._withAdapter(N,L,ge=>ge.provideDocumentSemanticTokens(_.URI.revive(q),J,le),null,!0)}$releaseDocumentSemanticTokens(N,q){this._withAdapter(N,L,J=>J.releaseDocumentSemanticColoring(q),void 0)}registerDocumentRangeSemanticTokensProvider(N,q,J,le){const ge=this._addNewAdapter(new $(this._documents,J),N);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ge,this._transformDocumentSelector(q),le),this._createDisposable(ge)}$provideDocumentRangeSemanticTokens(N,q,J,le){return this._withAdapter(N,$,ge=>ge.provideDocumentRangeSemanticTokens(_.URI.revive(q),J,le),null,!0)}registerCompletionItemProvider(N,q,J,le){const ge=this._addNewAdapter(new W(this._documents,this._commands.converter,J,this._apiDeprecation,N),N);return this._proxy.$registerSuggestSupport(ge,this._transformDocumentSelector(q),le,W.supportsResolving(J),`${N.identifier.value}(${le.join("")})`),this._createDisposable(ge)}$provideCompletionItems(N,q,J,le,ge){return this._withAdapter(N,W,De=>De.provideCompletionItems(_.URI.revive(q),J,le,ge),void 0)}$resolveCompletionItem(N,q,J){return this._withAdapter(N,W,le=>le.resolveCompletionItem(q,J),void 0)}$releaseCompletionItems(N,q){this._withAdapter(N,W,J=>J.releaseCompletionItems(q),void 0)}registerSignatureHelpProvider(N,q,J,le){const ge=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,De=this._addNewAdapter(new K(this._documents,J),N);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(q),ge),this._createDisposable(De)}$provideSignatureHelp(N,q,J,le,ge){return this._withAdapter(N,K,De=>De.provideSignatureHelp(_.URI.revive(q),J,le,ge),void 0)}$releaseSignatureHelp(N,q){this._withAdapter(N,K,J=>J.releaseSignatureHelp(q),void 0)}registerInlineHintsProvider(N,q,J){const le=typeof J.onDidChangeInlineHints=="function"?this._nextHandle():void 0,ge=this._addNewAdapter(new U(this._documents,J),N);this._proxy.$registerInlineHintsProvider(ge,this._transformDocumentSelector(q),le);let De=this._createDisposable(ge);if(le!==void 0){const Le=J.onDidChangeInlineHints(pe=>this._proxy.$emitInlineHintsEvent(le));De=P.Disposable.from(De,Le)}return De}$provideInlineHints(N,q,J,le){return this._withAdapter(N,U,ge=>ge.provideInlineHints(_.URI.revive(q),J,le),void 0)}registerDocumentLinkProvider(N,q,J){const le=this._addNewAdapter(new ee(this._documents,J),N);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(q),typeof J.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(N,q,J){return this._withAdapter(N,ee,le=>le.provideLinks(_.URI.revive(q),J),void 0)}$resolveDocumentLink(N,q,J){return this._withAdapter(N,ee,le=>le.resolveLink(q,J),void 0)}$releaseDocumentLinks(N,q){this._withAdapter(N,ee,J=>J.releaseLinks(q),void 0)}registerColorProvider(N,q,J){const le=this._addNewAdapter(new ie(this._documents,J),N);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDocumentColors(N,q,J){return this._withAdapter(N,ie,le=>le.provideColors(_.URI.revive(q),J),[])}$provideColorPresentations(N,q,J,le){return this._withAdapter(N,ie,ge=>ge.provideColorPresentations(_.URI.revive(q),J,le),void 0)}registerFoldingRangeProvider(N,q,J){const le=this._nextHandle(),ge=typeof J.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new se(this._documents,J),N)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(q),ge);let De=this._createDisposable(le);if(ge!==void 0){const Le=J.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ge));De=P.Disposable.from(De,Le)}return De}$provideFoldingRanges(N,q,J,le){return this._withAdapter(N,se,ge=>ge.provideFoldingRanges(_.URI.revive(q),J,le),void 0)}registerSelectionRangeProvider(N,q,J){const le=this._addNewAdapter(new Se(this._documents,J,this._logService),N);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideSelectionRanges(N,q,J,le){return this._withAdapter(N,Se,ge=>ge.provideSelectionRanges(_.URI.revive(q),J,le),[])}registerCallHierarchyProvider(N,q,J){const le=this._addNewAdapter(new Ae(this._documents,J),N);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$prepareCallHierarchy(N,q,J,le){return this._withAdapter(N,Ae,ge=>Promise.resolve(ge.prepareSession(_.URI.revive(q),J,le)),void 0)}$provideCallHierarchyIncomingCalls(N,q,J,le){return this._withAdapter(N,Ae,ge=>ge.provideCallsTo(q,J,le),void 0)}$provideCallHierarchyOutgoingCalls(N,q,J,le){return this._withAdapter(N,Ae,ge=>ge.provideCallsFrom(q,J,le),void 0)}$releaseCallHierarchy(N,q){this._withAdapter(N,Ae,J=>Promise.resolve(J.releaseSession(q)),void 0)}static _serializeRegExp(N){return{pattern:N.source,flags:(0,w.regExpFlags)(N)}}static _serializeIndentationRule(N){return{decreaseIndentPattern:Re._serializeRegExp(N.decreaseIndentPattern),increaseIndentPattern:Re._serializeRegExp(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?Re._serializeRegExp(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?Re._serializeRegExp(N.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(N){return{beforeText:Re._serializeRegExp(N.beforeText),afterText:N.afterText?Re._serializeRegExp(N.afterText):void 0,previousLineText:N.previousLineText?Re._serializeRegExp(N.previousLineText):void 0,action:N.action}}static _serializeOnEnterRules(N){return N.map(Re._serializeOnEnterRule)}setLanguageConfiguration(N,q,J){let{wordPattern:le}=J;if(le&&(0,w.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(q,le):this._documents.setWordDefinitionFor(q,void 0),J.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),J.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const ge=this._nextHandle(),De={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Re._serializeRegExp(J.wordPattern):void 0,indentationRules:J.indentationRules?Re._serializeIndentationRule(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Re._serializeOnEnterRules(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ge,q,De),this._createDisposable(ge)}$setWordDefinitions(N){for(const q of N)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=Re,Re._handlePool=0}),define(we[195],Ee([0,1,5,9,7]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class P{constructor(k,w){this._proxy=k.getProxy(_.MainContext.MainThreadLanguages),this._documents=w}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,w){await this._proxy.$changeLanguage(k,w);const n=this._documents.getDocumentData(k);if(!n)throw new Error(`document '${k.toString}' NOT found`);return n.document}async tokenAtPosition(k,w){var n;const A=k.version,I=S.Position.from(w),v=await this._proxy.$tokensAtPosition(k.uri,I),d={type:T.StandardTokenType.Other,range:(n=k.getWordRangeAtPosition(w))!==null&&n!==void 0?n:new T.Range(w.line,w.character,w.line,w.character)};if(!v)return d;const s={range:S.Range.to(v.range),type:S.TokenType.to(v.type)};return!s.range.contains(w)||A!==k.version?d:s}}e.ExtHostLanguages=P}),define(we[196],Ee([0,1,5,19,33]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(k){return k&&k.title}let E=class{constructor(w,n){this._logService=n,this._proxy=w.getProxy(_.MainContext.MainThreadMessageService)}showMessage(w,n,A,I,v){const d={extension:w};let s;typeof I=="string"||P(I)?s=[I,...v]:(d.modal=I&&I.modal,d.useCustom=I&&I.useCustom,s=v),d.useCustom&&(0,T.checkProposedApiEnabled)(w);const f=[];for(let p=0;p<s.length;p++){const m=s[p];if(typeof m=="string")f.push({title:m,handle:p,isCloseAffordance:!1});else if(typeof m=="object"){let{title:b,isCloseAffordance:c}=m;f.push({title:b,isCloseAffordance:!!c,handle:p})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(n,A,d,f).then(p=>{if(typeof p=="number")return s[p]})}};E=je([qe(1,S.ILogService)],E),e.ExtHostMessageService=E}),define(we[197],Ee([0,1,20,3,6,2,29,5,9,7,69,70,22,174,175,52,12,55]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class b extends T.Disposable{constructor(i,h,D,C,g){super();this._editorId=i,this.uri=h,this._proxy=D,this._webviewInitData=C,this.document=g,this._onDidReceiveDocumentMessage=new S.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:y=>this._proxy.$postMessage(this._editorId,void 0,y),asWebviewUri:y=>this._asWebviewUri(y)}}onDidReceiveMessage(i,h){var D;this._onDidReceiveDocumentMessage.fire(h),i!==void 0&&((D=this._rendererIdToEmitters.get(i))===null||D===void 0||D.fire(h))}getRendererComm(i){const h=new S.Emitter;return this._rendererIdToEmitters.set(i,h),{editorId:this._editorId,onDidReceiveMessage:h.event,postMessage:D=>this._proxy.$postMessage(this._editorId,i,D),asWebviewUri:D=>this._asWebviewUri(D)}}_asWebviewUri(i){return(0,A.asWebviewUri)(this._webviewInitData,this._editorId,i)}}class c extends T.Disposable{constructor(i,h,D,C){super();this._proxy=i,this._handle=h,this._extension=D,this._provider=C,this._kernelToFriendlyId=new v.ResourceMap,this._friendlyIdToKernel=new v.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(g=>{const y=g==null?void 0:g.uri;this._proxy.$onNotebookKernelChange(this._handle,y)}))}async provideKernels(i,h){const D=await this._provider.provideKernels(i.notebookDocument,h)||[],C=new Map;let g=0;const y=new Set,R=this._kernelToFriendlyId.get(i.uri),O=D.map(z=>{let Q=R==null?void 0:R.get(z);return Q===void 0&&(z.id&&y.has(z.id)?Q=`${this._extension.identifier.value}_${z.id}_${g++}`:Q=`${this._extension.identifier.value}_${z.id||E.generateUuid()}`),C.set(z,Q),{id:z.id,friendlyId:Q,label:z.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:z.description,detail:z.detail,isPreferred:z.isPreferred,preloads:z.preloads,supportedLanguages:z.supportedLanguages}});this._kernelToFriendlyId.set(i.uri,C);const x=new Map;return C.forEach((z,Q)=>{x.set(z,Q)}),this._friendlyIdToKernel.set(i.uri,x),O}getKernelByFriendlyId(i,h){var D;return(D=this._friendlyIdToKernel.get(i))===null||D===void 0?void 0:D.get(h)}async resolveNotebook(i,h,D,C){var g;const y=(g=this._friendlyIdToKernel.get(h.uri))===null||g===void 0?void 0:g.get(i);if(y&&this._provider.resolveKernel)return this._provider.resolveKernel(y,h.notebookDocument,D,C)}async executeNotebook(i,h,D){var C;const g=(C=this._friendlyIdToKernel.get(h.uri))===null||C===void 0?void 0:C.get(i);if(!!g)return u(D?y=>g.executeCell(h.notebookDocument,D.cell,y):y=>g.executeAllCells(h.notebookDocument,y))}async cancelNotebook(i,h,D){var C;const g=(C=this._friendlyIdToKernel.get(h.uri))===null||C===void 0?void 0:C.get(i);if(!!g)return D?g.cancelCellExecution(h.notebookDocument,D.cell):g.cancelAllCellsExecution(h.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=c;async function u(l){const i=new _.CancellationTokenSource;try{await l(i.token)}finally{i.dispose()}}class a{constructor(i,h){const D=a._Keys.nextId();i.$registerNotebookEditorDecorationType(D,w.NotebookDecorationRenderOptions.from(h)),this.value={key:D,dispose(){i.$removeNotebookEditorDecorationType(D)}}}}e.NotebookEditorDecorationType=a,a._Keys=new f.IdGenerator("NotebookEditorDecorationType");class t{constructor(i,h,D,C,g,y,R){this._textDocumentsAndEditors=D,this._textDocuments=C,this._webviewInitData=g,this.logService=y,this._extensionStoragePaths=R,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new v.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new S.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new S.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new S.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new S.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new S.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new S.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new S.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new S.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new S.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new S.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new S.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new S.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._backupIdPool=0,this._proxy=i.getProxy(k.MainContext.MainThreadNotebook),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:O=>{var x;if(O&&O.$mid===12){const z=(x=O.notebookEditor)===null||x===void 0?void 0:x.notebookUri,Q=O.cell.handle,j=this._documents.get(z),Y=j==null?void 0:j.getCell(Q);if(Y)return Y.cell}return O}})}get activeNotebookEditor(){var i;return(i=this._activeNotebookEditor)===null||i===void 0?void 0:i.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(i=>i.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(i){return this._documents.get(i)}_getNotebookDocument(i){const h=this._documents.get(i);if(!h)throw new Error(`NO notebook document for '${i}'`);return h}_getProviderData(i){const h=this._notebookContentProviders.get(i);if(!h)throw new Error(`NO provider for '${i}'`);return h}registerNotebookContentProvider(i,h,D,C){var g,y,R;if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:i,provider:D});let O;D.onDidChangeNotebookContentOptions&&(O=D.onDidChangeNotebookContentOptions(()=>{this._proxy.$updateNotebookProviderOptions(h,D.options)}));const x=(g=C==null?void 0:C.viewOptions)===null||g===void 0?void 0:g.filenamePattern.map(z=>w.NotebookExclusiveDocumentPattern.from(z)).filter(z=>z!==void 0);return((y=C==null?void 0:C.viewOptions)===null||y===void 0?void 0:y.filenamePattern)&&!x&&console.warn(`Notebook content provider view options file name pattern is invalid ${(R=C==null?void 0:C.viewOptions)===null||R===void 0?void 0:R.filenamePattern}`),this._proxy.$registerNotebookProvider({id:i.identifier,location:i.extensionLocation,description:i.description},h,{transientOutputs:(C==null?void 0:C.transientOutputs)||!1,transientMetadata:(C==null?void 0:C.transientMetadata)||{},viewOptions:(C==null?void 0:C.viewOptions)&&x?{displayName:C.viewOptions.displayName,filenamePattern:x,exclusive:C.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{O==null||O.dispose(),this._notebookContentProviders.delete(h),this._proxy.$unregisterNotebookProvider(h)})}registerNotebookKernelProvider(i,h,D){const C=t._notebookKernelProviderHandlePool++,g=new c(this._proxy,C,i,D);return this._notebookKernelProviders.set(C,g),this._proxy.$registerNotebookKernelProvider({id:i.identifier,location:i.extensionLocation,description:i.description},C,{viewType:h.viewType,filenamePattern:h.filenamePattern?w.NotebookExclusiveDocumentPattern.from(h.filenamePattern):void 0}),new n.Disposable(()=>{g.dispose(),this._notebookKernelProviders.delete(C),this._proxy.$unregisterNotebookKernelProvider(C)})}createNotebookEditorDecorationType(i){return new a(this._proxy,i).value}async openNotebookDocument(i){const h=this._documents.get(i);if(h)return h.notebookDocument;const D=await this._proxy.$tryOpenDocument(i),C=this._documents.get(P.URI.revive(D));return(0,p.assertIsDefined)(C==null?void 0:C.notebookDocument)}_withAdapter(i,h,D){const C=this._documents.get(P.URI.revive(h));if(!C)return[];const g=this._notebookKernelProviders.get(i);return g?D(g,C):[]}async showNotebookDocument(i,h){var D;P.URI.isUri(i)&&(i=await this.openNotebookDocument(i));let C;typeof h=="object"?C={position:w.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selection:h.selection&&w.NotebookCellRange.from(h.selection),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:C={preserveFocus:!1};const g=await this._proxy.$tryShowNotebookDocument(i.uri,i.viewType,C),y=g&&((D=this._editors.get(g))===null||D===void 0?void 0:D.editor);if(y)return y.editor;throw g?new Error(`Could NOT open editor for "${i.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.toString()}".`)}async $provideNotebookKernels(i,h,D){return this._withAdapter(i,h,(C,g)=>C.provideKernels(g,D))}async $resolveNotebookKernel(i,h,D,C,g){await this._withAdapter(i,D,async(y,R)=>{const O=this._webviewComm.get(h);O&&await y.resolveNotebook(C,R,O.contentProviderComm,g)})}async $resolveNotebookEditor(i,h,D){const C=this._notebookContentProviders.get(i),g=P.URI.revive(h),y=this._documents.get(g);if(!(!y||!C)){let R=this._webviewComm.get(D);R||(R=new b(D,g,this._proxy,this._webviewInitData,y),this._webviewComm.set(D,R)),!!C.provider.resolveNotebook&&await C.provider.resolveNotebook(y.notebookDocument,R.contentProviderComm)}}async $executeNotebookKernelFromProvider(i,h,D,C){await this._withAdapter(i,h,async(g,y)=>{const R=C!==void 0?y.getCell(C):void 0;return g.executeNotebook(D,y,R)})}async $cancelNotebookKernelFromProvider(i,h,D,C){await this._withAdapter(i,h,async(g,y)=>{const R=C!==void 0?y.getCell(C):void 0;return g.cancelNotebook(D,y,R)})}async $openNotebook(i,h,D,C,g){const{provider:y}=this._getProviderData(i),R=await y.openNotebook(P.URI.revive(h),{backupId:D,untitledDocumentData:g==null?void 0:g.buffer},C);return{metadata:w.NotebookDocumentMetadata.from(R.metadata),cells:R.cells.map(w.NotebookCellData.from)}}async $saveNotebook(i,h,D){const C=this._getNotebookDocument(P.URI.revive(h)),{provider:g}=this._getProviderData(i);return await g.saveNotebook(C.notebookDocument,D),!0}async $saveNotebookAs(i,h,D,C){const g=this._getNotebookDocument(P.URI.revive(h)),{provider:y}=this._getProviderData(i);return await y.saveNotebookAs(P.URI.revive(D),g.notebookDocument,C),!0}async $backupNotebook(i,h,D){var C;const g=this._getNotebookDocument(P.URI.revive(h)),y=this._getProviderData(i),R=(C=this._extensionStoragePaths.workspaceValue(y.extension))!==null&&C!==void 0?C:this._extensionStoragePaths.globalValue(y.extension),O=String((0,m.hash)([g.uri.toString(),this._backupIdPool++])),x=P.URI.joinPath(R,O),z=await y.provider.backupNotebook(g.notebookDocument,{destination:x},D);return g.updateBackup(z),z.id}$acceptNotebookActiveKernelChange(i){i.providerHandle!==void 0&&this._withAdapter(i.providerHandle,i.uri,async(h,D)=>{const C=i.kernelFriendlyId?h.getKernelByFriendlyId(P.URI.revive(i.uri),i.kernelFriendlyId):void 0;this._editors.forEach(g=>{g.editor.notebookData===D&&g.editor._acceptKernel(C)}),this._onDidChangeActiveNotebookKernel.fire({document:D.notebookDocument,kernel:C})})}$onDidReceiveMessage(i,h,D){var C;(C=this._webviewComm.get(i))===null||C===void 0||C.onDidReceiveMessage(h,D)}$acceptModelChanged(i,h,D){this._getNotebookDocument(P.URI.revive(i)).acceptModelChanged(h,D)}$acceptDirtyStateChanged(i,h){const D=this._getNotebookDocument(P.URI.revive(i));D.acceptModelChanged({rawEvents:[],versionId:D.notebookDocument.version},h)}$acceptModelSaved(i){const h=this._getNotebookDocument(P.URI.revive(i));this._onDidSaveNotebookDocument.fire(h.notebookDocument)}$acceptEditorPropertiesChanged(i,h){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",i,h);const D=this._editors.get(i);if(!D)throw new Error(`unknown text editor: ${i}`);h.visibleRanges&&D.editor._acceptVisibleRanges(h.visibleRanges.ranges.map(w.NotebookCellRange.to)),h.selections&&D.editor._acceptSelections(h.selections.selections.map(w.NotebookCellRange.to)),h.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:D.editor.editor,visibleRanges:D.editor.editor.visibleRanges}),h.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:D.editor.editor,selections:D.editor.editor.selections}))}$acceptDocumentPropertiesChanged(i,h){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",i.path,h);const D=this._getNotebookDocument(P.URI.revive(i));D.acceptDocumentPropertiesChanged(h),h.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:D.notebookDocument})}_createExtHostEditor(i,h,D){var C;const g=i.uri;let y=this._webviewComm.get(h);y||(y=new b(h,g,this._proxy,this._webviewInitData,i),this._webviewComm.set(h,y));const R=new s.ExtHostNotebookEditor(h,i.notebookDocument.viewType,this._proxy,i,D.visibleRanges.map(w.NotebookCellRange.to),D.selections.map(w.NotebookCellRange.to),typeof D.viewColumn=="number"?w.ViewColumn.to(D.viewColumn):void 0);(C=this._editors.get(h))===null||C===void 0||C.editor.dispose(),this._editors.set(h,{editor:R})}$acceptDocumentAndEditorsDelta(i){var h,D,C,g;let y=!1;if(i.removedDocuments)for(const O of i.removedDocuments){const x=P.URI.revive(O),z=this._documents.get(x);z&&(z.dispose(),this._documents.delete(x),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:z.notebookDocument.cells.map(Q=>Q.document.uri)}),this._onDidCloseNotebookDocument.fire(z.notebookDocument));for(const Q of this._editors.values())Q.editor.notebookData.uri.toString()===x.toString()&&(Q.editor.dispose(),this._editors.delete(Q.editor.id),y=!0)}if(i.addedDocuments){const O=[];for(const x of i.addedDocuments){const z=P.URI.revive(x.uri),Q=x.viewType;if(this._documents.has(z))throw new Error(`adding EXISTING notebook ${z}`);const j=this,Y=new d.ExtHostNotebookDocument(this._proxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(L){j._onDidChangeNotebookCells.fire(L)},emitCellOutputsChange(L){j._onDidChangeCellOutputs.fire(L)},emitCellMetadataChange(L){j._onDidChangeCellMetadata.fire(L)}},Q,x.metadata?w.NotebookDocumentMetadata.to(x.metadata):new n.NotebookDocumentMetadata,z);Y.acceptModelChanged({versionId:x.versionId,rawEvents:[{kind:I.NotebookCellsChangeType.Initialize,changes:[[0,0,x.cells]]}]},!1),O.push(...x.cells.map(L=>d.ExtHostCell.asModelAddData(Y.notebookDocument,L))),(h=this._documents.get(z))===null||h===void 0||h.dispose(),this._documents.set(z,Y),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:O}),this._onDidOpenNotebookDocument.fire(Y.notebookDocument)}}if(i.addedEditors)for(const O of i.addedEditors){if(this._editors.has(O.id))return;const x=P.URI.revive(O.documentUri),z=this._documents.get(x);z&&(this._createExtHostEditor(z,O.id,O),y=!0)}const R=[];if(i.removedEditors)for(const O of i.removedEditors){const x=this._editors.get(O);x&&(y=!0,this._editors.delete(O),((D=this._activeNotebookEditor)===null||D===void 0?void 0:D.id)===x.editor.id&&(this._activeNotebookEditor=void 0),R.push(x))}if(y&&R.forEach(O=>{O.editor.dispose()}),i.visibleEditors){this._visibleNotebookEditors=i.visibleEditors.map(x=>this._editors.get(x).editor).filter(x=>!!x);const O=new Set;this._visibleNotebookEditors.forEach(x=>O.add(x.id));for(const x of this._editors.values()){const z=O.has(x.editor.id);x.editor._acceptVisibility(z)}this._visibleNotebookEditors=[...this._editors.values()].map(x=>x.editor).filter(x=>x.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}i.newActiveEditor===null?this._activeNotebookEditor=void 0:i.newActiveEditor&&(this._activeNotebookEditor=(C=this._editors.get(i.newActiveEditor))===null||C===void 0?void 0:C.editor),i.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((g=this._activeNotebookEditor)===null||g===void 0?void 0:g.editor)}createNotebookCellStatusBarItemInternal(i,h,D){const C=new r(this._proxy,this._commandsConverter,i,h,D),g=I.CellUri.parse(i.document.uri);if(g){const y=this._documents.get(g.notebook);if(y){const R=y.getCell(g.handle);R&&S.Event.once(R.onDidDispose)(()=>C.dispose())}}return C}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class r extends T.Disposable{constructor(i,h,D,C,g){super();this._proxy=i,this._commands=h,this._cell=D,this._priority=g,this._id=r.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new T.DisposableStore),this._alignment=C!=null?C:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=o(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(i){this._alignment=i,this.update()}get priority(){return this._priority}set priority(i){this._priority=i,this.update()}get text(){return this._text}set text(i){this._text=i,this.update()}get tooltip(){return this._tooltip}set tooltip(i){this._tooltip=i,this.update()}get command(){var i;return(i=this._command)===null||i===void 0?void 0:i.fromApi}set command(i){var h;((h=this._command)===null||h===void 0?void 0:h.fromApi)!==i&&(this._internalCommandRegistration.clear(),typeof i=="string"?this._command={fromApi:i,internal:this._commands.toInternal({title:"",command:i},this._internalCommandRegistration)}:i?this._command={fromApi:i,internal:this._commands.toInternal(i,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(i){this._accessibilityInformation=i,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var i;if(!this._isDisposed){const h={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(i=this._command)===null||i===void 0?void 0:i.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,h)}}}e.NotebookCellStatusBarItemInternal=r,r.NEXT_ID=0;function o(l){return Object.freeze({cell:l.cell,get alignment(){return l.alignment},set alignment(i){l.alignment=i},get priority(){return l.priority},set priority(i){l.priority=i},get text(){return l.text},set text(i){l.text=i},get tooltip(){return l.tooltip},set tooltip(i){l.tooltip=i},get command(){return l.command},set command(i){l.command=i},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(i){l.accessibilityInformation=i},show(){l.show()},hide(){l.hide()},dispose(){l.dispose()}})}}),define(we[98],Ee([0,1,5,3,6,26,4,14]),function(ae,e,_,S,T,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class w extends T.Disposable{constructor(s,f,p,m){super();this._onDidAppend=this._register(new S.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=m,this._id=m.$register(this.name,f,p),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?P.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(f=>this._proxy.$clear(f,s))}show(s,f){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof s=="boolean"?s:f)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=w;class n extends w{constructor(s,f){super(s,!1,void 0,f)}append(s){super.append(s),this._id.then(f=>this._proxy.$append(f,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class A extends w{constructor(s,f,p){super(s,!0,f,p)}append(s){throw new Error("Not supported")}}class I{constructor(s,f){this.name=s,this._channel=f}append(s){this._channel.then(f=>f.append(s))}appendLine(s){this._channel.then(f=>f.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,f){this._channel.then(p=>p.show(s,f))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=I;let v=class{constructor(s){this._proxy=s.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new n(s,this._proxy)}createOutputChannelFromLogFile(s,f){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!f)throw new Error("illegal argument `file`. must not be falsy");return new A(s,f,this._proxy)}};v=je([qe(0,k.IExtHostRpcService)],v),e.ExtHostOutputService=v,e.IExtHostOutputService=(0,E.createDecorator)("IExtHostOutputService")}),define(we[198],Ee([0,1,13,20,3,6,5,2,7,10,15]),function(ae,e,_,S,T,P,E,k,w,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function I(v,d,s){const f=v.getProxy(E.MainContext.MainThreadQuickOpen);class p{constructor(o,l){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=l}showQuickPick(o,l,i,h=S.CancellationToken.None){this._onDidSelectItem=void 0;const D=Promise.resolve(o),C=++this._instances,g=f.$show(C,{placeHolder:i&&i.placeHolder,matchOnDescription:i&&i.matchOnDescription,matchOnDetail:i&&i.matchOnDetail,ignoreFocusLost:i&&i.ignoreFocusOut,canPickMany:i&&i.canPickMany},h),y={},R=g.then(()=>y);return Promise.race([R,D]).then(O=>{if(O!==y)return D.then(x=>{const z=[];for(let Q=0;Q<x.length;Q++){const j=x[Q];let Y,L,$,W,K;typeof j=="string"?Y=j:(Y=j.label,L=j.description,$=j.detail,W=j.picked,K=j.alwaysShow),z.push({label:Y,description:L,handle:Q,detail:$,picked:W,alwaysShow:K})}return i&&typeof i.onDidSelectItem=="function"&&(this._onDidSelectItem=Q=>{i.onDidSelectItem(x[Q])}),f.$setItems(C,z),g.then(Q=>{if(typeof Q=="number")return x[Q];if(Array.isArray(Q))return Q.map(j=>x[j])})})}).then(void 0,O=>{if(!(0,n.isPromiseCanceledError)(O))return f.$setError(C,O),Promise.reject(O)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,l=S.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,f.$input(o,typeof this._validateInput=="function",l).then(void 0,i=>{if(!(0,n.isPromiseCanceledError)(i))return Promise.reject(i)})}$validateInput(o){return this._validateInput?(0,_.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,l=S.CancellationToken.None){const i=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!!i){const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(D=>D.uri.toString()===i.uri.toString())}}createQuickPick(o,l){const i=new a(o,l,()=>this._sessions.delete(i._id));return this._sessions.set(i._id,i),i}createInputBox(o){const l=new t(o,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(o,l){const i=this._sessions.get(o);i&&i._fireDidChangeValue(l)}$onDidAccept(o){const l=this._sessions.get(o);l&&l._fireDidAccept()}$onDidChangeActive(o,l){const i=this._sessions.get(o);i instanceof a&&i._fireDidChangeActive(l)}$onDidChangeSelection(o,l){const i=this._sessions.get(o);i instanceof a&&i._fireDidChangeSelection(l)}$onDidTriggerButton(o,l){const i=this._sessions.get(o);i&&i._fireDidTriggerButton(l)}$onDidHide(o){const l=this._sessions.get(o);l&&l._fireDidHide()}}class m{constructor(o,l){this._extensionId=o,this._onDidDispose=l,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((l,i)=>{const h=l===w.QuickInputButtons.Back?-1:i;this._handlesToButtons.set(h,l)}),this.update({buttons:o.map((l,i)=>({iconPath:b(l.iconPath),tooltip:l.tooltip,handle:l===w.QuickInputButtons.Back?-1:i}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const l=this._handlesToButtons.get(o);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),f.$dispose(this._id))}update(o){if(!this._disposed){for(const l of Object.keys(o)){const i=o[l];this._pendingUpdate[l]=i===void 0?null:i}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){f.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}m._nextId=1;function b(r){if(r instanceof w.ThemeIcon)return{id:r.id};const o=u(r),l=c(r);return{dark:typeof o=="string"?k.URI.file(o):o,light:typeof l=="string"?k.URI.file(l):l}}function c(r){return typeof r=="object"&&"light"in r?r.light:r}function u(r){return typeof r=="object"&&"dark"in r?r.dark:r}class a extends m{constructor(o,l,i){super(o,i);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((l,i)=>{this._handlesToItems.set(i,l),this._itemsToHandles.set(l,i)}),this.update({items:o.map((l,i)=>({label:l.label,description:l.description,handle:i,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(o){const l=(0,A.coalesce)(o.map(i=>this._handlesToItems.get(i)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(o){const l=(0,A.coalesce)(o.map(i=>this._handlesToItems.get(i)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class t extends m{constructor(o,l){super(o,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o})}}return new p(d,s)}e.createExtHostQuickOpen=I}),define(we[199],Ee([0,1,2,3,44,6,13,5,15,109,19,25,33]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(l){if(l)return typeof l.iconPath=="string"?_.URI.file(l.iconPath):l.iconPath}function s(l,i){if(!l.iconPath&&!i.iconPath)return 0;if(l.iconPath){if(!i.iconPath)return 1}else return-1;const h=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath,D=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath;return(0,n.comparePaths)(h,D)}function f(l,i){let h=0;if(l.strikeThrough!==i.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==i.faded)return l.faded?1:-1;if(l.tooltip!==i.tooltip)return(l.tooltip||"").localeCompare(i.tooltip||"");if(h=s(l,i),h!==0)return h;if(l.light&&i.light)h=s(l.light,i.light);else{if(l.light)return 1;if(i.light)return-1}if(h!==0)return h;if(l.dark&&i.dark)h=s(l.dark,i.dark);else{if(l.dark)return 1;if(i.dark)return-1}return h}function p(l,i){if(l.command!==i.command)return l.command<i.command?-1:1;if(l.title!==i.title)return l.title<i.title?-1:1;if(l.tooltip!==i.tooltip){if(l.tooltip!==void 0&&i.tooltip!==void 0)return l.tooltip<i.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(i.tooltip!==void 0)return-1}if(l.arguments===i.arguments)return 0;if(l.arguments)if(i.arguments){if(l.arguments.length!==i.arguments.length)return l.arguments.length-i.arguments.length}else return 1;else return-1;for(let h=0;h<l.arguments.length;h++){const D=l.arguments[h],C=i.arguments[h];if(D!==C)return D<C?-1:1}return 0}function m(l,i){let h=(0,n.comparePaths)(l.resourceUri.fsPath,i.resourceUri.fsPath,!0);if(h!==0)return h;if(l.command&&i.command)h=p(l.command,i.command);else{if(l.command)return 1;if(i.command)return-1}if(h!==0)return h;if(l.decorations&&i.decorations)h=f(l.decorations,i.decorations);else{if(l.decorations)return 1;if(i.decorations)return-1}return h}function b(l,i){for(let h=0;h<l.length;h++)if(l[h]!==i[h])return!1;return!0}function c(l,i){return l.command===i.command&&l.title===i.title&&l.tooltip===i.tooltip&&(l.arguments&&i.arguments?b(l.arguments,i.arguments):l.arguments===i.arguments)}function u(l,i){return(0,w.equals)(l,i,c)}class a{constructor(i,h,D){this._extension=i,this._proxy=h,this._sourceControlHandle=D,this._value="",this._onDidChange=new S.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(i){this._proxy.$setInputBoxValue(this._sourceControlHandle,i),this.updateValue(i)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(i){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,i),this._placeholder=i}get validateInput(){return(0,v.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(i){if((0,v.checkProposedApiEnabled)(this._extension),i&&typeof i!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=i,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!i)}get visible(){return this._visible}set visible(i){i=!!i,this._visible!==i&&(this._visible=i,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,i))}$onInputBoxValueChange(i){this.updateValue(i)}updateValue(i){this._value=i,this._onDidChange.fire(i)}}e.ExtHostSCMInputBox=a;class t{constructor(i,h,D,C,g){this._proxy=i,this._commands=h,this._sourceControlHandle=D,this._id=C,this._label=g,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new S.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new S.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(i){this._label=i,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,i)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(i){this._hideWhenEmpty=i,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(i){this._resourceStates=[...i],this._onDidUpdateResourceStates.fire()}getResourceState(i){return this._resourceStatesMap.get(i)}$executeResourceCommand(i,h){const D=this._resourceStatesCommandsMap.get(i);return D?(0,E.asPromise)(()=>this._commands.executeCommand(D.command,...D.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var i;const h=[...this._resourceStates].sort(m),C=(0,w.sortedDiff)(this._resourceSnapshot,h,m).map(R=>{const O=R.toInsert.map(x=>{const z=this._resourceHandlePool++;this._resourceStatesMap.set(z,x);const Q=x.resourceUri,j=d(x.decorations),Y=x.decorations&&d(x.decorations.light)||j,L=x.decorations&&d(x.decorations.dark)||j,$=[];let W;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const Se=new P.DisposableStore;W=this._commands.converter.toInternal(x.command,Se),this._resourceStatesDisposablesMap.set(z,Se)}else this._resourceStatesCommandsMap.set(z,x.command);Y&&$.push(Y),L&&L.toString()!==(Y==null?void 0:Y.toString())&&$.push(L);const K=x.decorations&&x.decorations.tooltip||"",U=x.decorations&&!!x.decorations.strikeThrough,ee=x.decorations&&!!x.decorations.faded,ie=x.contextValue||"";return{rawResource:[z,Q,$,K,U,ee,ie,W],handle:z}});return{start:R.start,deleteCount:R.deleteCount,toInsert:O}}),g=C.map(({start:R,deleteCount:O,toInsert:x})=>[R,O,x.map(z=>z.rawResource)]),y=C.reverse();for(const{start:R,deleteCount:O,toInsert:x}of y){const z=x.map(j=>j.handle),Q=this._handlesSnapshot.splice(R,O,...z);for(const j of Q)this._resourceStatesMap.delete(j),this._resourceStatesCommandsMap.delete(j),(i=this._resourceStatesDisposablesMap.get(j))===null||i===void 0||i.dispose(),this._resourceStatesDisposablesMap.delete(j)}return this._resourceSnapshot=h,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class r{constructor(i,h,D,C,g,y){this._proxy=h,this._commands=D,this._id=C,this._label=g,this._rootUri=y,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new S.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new a(i,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,C,g,y)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(i){this._count!==i&&(this._count=i,this._proxy.$updateSourceControl(this.handle,{count:i}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(i){this._quickDiffProvider=i,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!i})}get commitTemplate(){return this._commitTemplate}set commitTemplate(i){i!==this._commitTemplate&&(this._commitTemplate=i,this._proxy.$updateSourceControl(this.handle,{commitTemplate:i}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(i){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=i;const h=this._commands.converter.toInternal(i,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:h})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(i){if(!(this._statusBarCommands&&i&&u(this._statusBarCommands,i))){this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=i;const h=(i||[]).map(D=>this._commands.converter.toInternal(D,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:h})}}get selected(){return this._selected}createResourceGroup(i,h){const D=new t(this._proxy,this._commands,this.handle,i,h),C=S.Event.once(D.onDidDispose)(()=>this.createdResourceGroups.delete(D));return this.createdResourceGroups.set(D,C),this.eventuallyAddResourceGroups(),D}eventuallyAddResourceGroups(){const i=[],h=[];for(const[D,C]of this.createdResourceGroups){C.dispose();const g=D.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(D),this.eventuallyUpdateResourceStates()});S.Event.once(D.onDidDispose)(()=>{this.updatedResourceGroups.delete(D),g.dispose(),this._groups.delete(D.handle),this._proxy.$unregisterGroup(this.handle,D.handle)}),i.push([D.handle,D.id,D.label,D.features]);const y=D._takeResourceStateSnapshot();y.length>0&&h.push([D.handle,y]),this._groups.set(D.handle,D)}this._proxy.$registerGroups(this.handle,i,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const i=[];this.updatedResourceGroups.forEach(h=>{const D=h._takeResourceStateSnapshot();D.length!==0&&i.push([h.handle,D])}),i.length>0&&this._proxy.$spliceResourceStates(this.handle,i),this.updatedResourceGroups.clear()}getResourceGroup(i){return this._groups.get(i)}setSelectionState(i){this._selected=i,this._onDidChangeSelection.fire(i)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(i=>i.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,je([(0,T.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),je([(0,T.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let o=class Dn{constructor(i,h,D){this._commands=h,this.logService=D,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new S.Emitter,this._proxy=i.getProxy(k.MainContext.MainThreadSCM),this._telemetry=i.getProxy(k.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const g=this._sourceControls.get(C.sourceControlHandle);if(!g)return C;const y=g.getResourceGroup(C.groupHandle);return y?y.getResourceState(C.handle):C}else if(C&&C.$mid===4){const g=this._sourceControls.get(C.sourceControlHandle);return g?g.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const g=this._sourceControls.get(C.handle);return g||C}return C}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(i,h,D,C){this.logService.trace("ExtHostSCM#createSourceControl",i.identifier.value,h,D,C),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:i.identifier.value});const g=Dn._handlePool++,y=new r(i,this._proxy,this._commands,h,D,C);this._sourceControls.set(g,y);const R=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(i.identifier))||[];return R.push(y),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(i.identifier),R),y}getLastInputBox(i){this.logService.trace("ExtHostSCM#getLastInputBox",i.identifier.value);const h=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(i.identifier)),D=h&&h[h.length-1];return D&&D.inputBox}$provideOriginalResource(i,h,D){const C=_.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",i,C.toString());const g=this._sourceControls.get(i);return!g||!g.quickDiffProvider||!g.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,E.asPromise)(()=>g.quickDiffProvider.provideOriginalResource(C,D)).then(y=>y||null)}$onInputBoxValueChange(i,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",i);const D=this._sourceControls.get(i);return D&&D.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(i,h,D,C){this.logService.trace("ExtHostSCM#$executeResourceCommand",i,h,D);const g=this._sourceControls.get(i);if(!g)return Promise.resolve(void 0);const y=g.getResourceGroup(h);return y?y.$executeResourceCommand(D,C):Promise.resolve(void 0)}$validateInput(i,h,D){this.logService.trace("ExtHostSCM#$validateInput",i);const C=this._sourceControls.get(i);return!C||!C.inputBox.validateInput?Promise.resolve(void 0):(0,E.asPromise)(()=>C.inputBox.validateInput(h,D)).then(g=>g?Promise.resolve([g.message,g.type]):Promise.resolve(void 0))}$setSelectedSourceControl(i){var h,D;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",i),i!==void 0&&((h=this._sourceControls.get(i))===null||h===void 0||h.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((D=this._sourceControls.get(this._selectedSourceControlHandle))===null||D===void 0||D.setSelectionState(!1)),this._selectedSourceControlHandle=i,Promise.resolve(void 0)}};o._handlePool=0,o=je([qe(2,A.ILogService)],o),e.ExtHostSCM=o});var tt=this&&this.__classPrivateFieldSet||function(ae,e,_){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,_),_},We=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(we[200],Ee([0,1,7,5,131,6]),function(ae,e,_,S,T,P){"use strict";var E,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class w{constructor(v,d,s,f,p=_.StatusBarAlignment.Left,m,b){E.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,E,v),tt(this,k,d),this._id=w.ID_GEN++,this._statusId=s,this._statusName=f,this._alignment=p,this._priority=m,this._accessibilityInformation=b}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var v;return(v=this._command)===null||v===void 0?void 0:v.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(v){this._text=v,this.update()}set tooltip(v){this._tooltip=v,this.update()}set color(v){this._color=v,this.update()}set backgroundColor(v){v&&!w.ALLOWED_BACKGROUND_COLORS.has(v.id)&&(v=void 0),this._backgroundColor=v,this.update()}set command(v){var d;((d=this._command)===null||d===void 0?void 0:d.fromApi)!==v&&(this._internalCommandRegistration.clear(),typeof v=="string"?this._command={fromApi:v,internal:We(this,k).toInternal({title:"",command:v},this._internalCommandRegistration)}:v?this._command={fromApi:v,internal:We(this,k).toInternal(v,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(v){this._accessibilityInformation=v,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,We(this,E).$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var v;this._timeoutHandle=void 0;let d=this._color;this._backgroundColor&&(d=w.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),We(this,E).$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(v=this._command)===null||v===void 0?void 0:v.internal,d,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=w,E=new WeakMap,k=new WeakMap,w.ID_GEN=0,w.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(v){this._messages=[],this._item=v.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(v){const d={message:v};return this._messages.unshift(d),this._update(),new _.Disposable(()=>{const s=this._messages.indexOf(d);s>=0&&(this._messages.splice(s,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class A{constructor(v,d){this._proxy=v.getProxy(S.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new n(this)}createStatusBarEntry(v,d,s,f,p){return new w(this._proxy,this._commands,v,d,s,f,p)}setStatusBarMessage(v,d){const s=this._statusMessage.setMessage(v);let f;return typeof d=="number"?f=setTimeout(()=>s.dispose(),d):typeof d!="undefined"&&d.then(()=>s.dispose(),()=>s.dispose()),new _.Disposable(()=>{s.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=A}),define(we[75],Ee([0,1,5,3,4]),function(ae,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(k){this._onDidChangeStorage=new S.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,w){this._proxy.$registerExtensionStorageKeysToSync(k,w)}getValue(k,w,n){return this._proxy.$getValue(k,w).then(A=>A||n)}setValue(k,w,n){return this._proxy.$setValue(k,w,n)}$acceptValue(k,w,n){this._onDidChangeStorage.fire({shared:k,key:w,value:n})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(we[76],Ee([0,1,4,27,19,74,2]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let k=class{constructor(n,A,I){var v;this._logService=A,this._extHostFileSystem=I,this._workspace=(v=n.workspace)!==null&&v!==void 0?v:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(d=>this._value=d)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,I=E.URI.joinPath(this._environment.workspaceStorageHome,A);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(v){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(E.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=E.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),I}catch(v){this._logService.error("[ExtHostStorage]",v);return}}workspaceValue(n){if(this._value)return E.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return E.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};k=je([qe(0,S.IExtHostInitDataService),qe(1,T.ILogService),qe(2,P.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(we[41],Ee([0,1,3,5,4,2,14,6,7,132,10,167,20,29,151]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class f{constructor(t,r,o,l){this._proxy=t,this._id=r,this._creationOptions=o,this._name=l,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(h=>this._pidPromiseComplete=h);const i=this;this.value={get name(){return i._name||""},get processId(){return i._pidPromise},get creationOptions(){return i._creationOptions},get exitStatus(){return i._exitStatus},sendText(h,D=!0){i._checkDisposed(),i._proxy.$sendText(i._id,h,D)},show(h){i._checkDisposed(),i._proxy.$show(i._id,h)},hide(){i._checkDisposed(),i._proxy.$hide(i._id)},dispose(){i._disposed||(i._disposed=!0,i._proxy.$dispose(i._id))},get dimensions(){if(!(i._cols===void 0||i._rows===void 0))return{columns:i._cols,rows:i._rows}}}}async create(t,r,o,l,i,h,D,C,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:r,cwd:o,env:l,waitOnExit:i,strictEnv:h,hideFromUser:D,isFeatureTerminal:C,isExtensionOwnedTerminal:g})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,r){return t===this._cols&&r===this._rows||t===0||r===0?!1:(this._cols=t,this._rows=r,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=f;class p{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter,this._onProcessShellTypeChanged=new _.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,r){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:r})}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let m=1,b=class extends k.Disposable{constructor(t,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=r.getProxy(S.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[o,l]of this._terminalProcesses)l.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const r=new f(this._proxy,(0,d.generateUuid)(),t,t.name),o=new p(t.pty);return r.createExtensionTerminal().then(l=>{const i=this._setupExtHostProcessListeners(l,o);this._terminalProcessDisposables[l]=i}),this._terminals.push(r),r.value}attachPtyToTerminal(t,r){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const l=new p(r),i=this._setupExtHostProcessListeners(t,l);this._terminalProcessDisposables[t]=i}async $acceptActiveTerminalChanged(t){const r=this._activeTerminal;if(t===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(t);o&&(this._activeTerminal=o,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,r){const o=this._getTerminalById(t);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:r})}async $acceptTerminalDimensions(t,r,o){const l=this._getTerminalById(t);l&&l.setDimensions(r,o)&&this._onDidChangeTerminalDimensions.fire({terminal:l.value,dimensions:l.value.dimensions})}async $acceptTerminalMaximumDimensions(t,r,o){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.resize(r,o)}async $acceptTerminalTitleChange(t,r){const o=this._getTerminalById(t);o&&(o.name=r)}async $acceptTerminalClosed(t,r){const o=this._getTerminalObjectIndexById(this._terminals,t);if(o!==null){const l=this._terminals.splice(o,1)[0];l.setExitCode(r),this._onDidCloseTerminal.fire(l.value)}}$acceptTerminalOpened(t,r,o,l){if(r){const D=this._getTerminalObjectIndexById(this._terminals,r);if(D!==null){this._terminals[D]._id=t,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const i={name:l.name,shellPath:l.executable,shellArgs:l.args,cwd:typeof l.cwd=="string"?l.cwd:P.URI.revive(l.cwd),env:l.env,hideFromUser:l.hideFromUser},h=new f(this._proxy,t,i,o);this._terminals.push(h),this._onDidOpenTerminal.fire(h.value),h.isOpen=!0}async $acceptTerminalProcessId(t,r){const o=this._getTerminalById(t);o&&o._setProcessId(r)}async $startExtensionTerminal(t,r){const o=this._getTerminalById(t);if(!o)return{message:(0,n.localize)(0,null,t)};o.isOpen||await new Promise(i=>{const h=this.onDidOpenTerminal(async D=>{D===o.value&&(h.dispose(),i())})});const l=this._terminalProcesses.get(t);l?l.startSendingEvents(r):this._extensionTerminalAwaitingStart[t]={initialDimensions:r}}_setupExtHostProcessListeners(t,r){const o=new k.DisposableStore;o.add(r.onProcessReady(i=>this._proxy.$sendProcessReady(t,i.pid,i.cwd))),o.add(r.onProcessTitleChanged(i=>this._proxy.$sendProcessTitle(t,i))),this._bufferer.startBuffering(t,r.onProcessData),o.add(r.onProcessExit(i=>this._onProcessExit(t,i))),r.onProcessOverrideDimensions&&o.add(r.onProcessOverrideDimensions(i=>this._proxy.$sendOverrideDimensions(t,i))),this._terminalProcesses.set(t,r);const l=this._extensionTerminalAwaitingStart[t];return l&&r instanceof p&&(r.startSendingEvents(l.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),o}$acceptProcessAckDataEvent(t,r){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.acknowledgeDataEvent(r)}$acceptProcessInput(t,r){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.input(r)}$acceptProcessResize(t,r,o){var l;try{(l=this._terminalProcesses.get(t))===null||l===void 0||l.resize(r,o)}catch(i){if(i.code!=="EPIPE"&&i.code!=="ERR_IPC_CHANNEL_CLOSED")throw i}}$acceptProcessShutdown(t,r){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.shutdown(r)}$acceptProcessRequestInitialCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(t,o))}$acceptProcessRequestCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getCwd().then(o=>this._proxy.$sendProcessCwd(t,o))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new w.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,r){const o=this._getTerminalById(t);if(!o)return[];this._terminalLinkCache.delete(t);const l=this._terminalLinkCancellationSource.get(t);l&&l.dispose(!0);const i=new v.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,i);const h=[],D={terminal:o.value,line:r},C=[];for(const R of this._linkProviders)C.push(new Promise(async O=>{i.token.onCancellationRequested(()=>O({provider:R,links:[]}));const x=await R.provideTerminalLinks(D,i.token)||[];i.token.isCancellationRequested||O({provider:R,links:x})}));const g=await Promise.all(C);if(i.token.isCancellationRequested)return[];const y=new Map;for(const R of g)R&&R.links.length>0&&h.push(...R.links.map(O=>{const x={id:m++,startIndex:O.startIndex,length:O.length,label:O.tooltip};return y.set(x.id,{provider:R.provider,link:O}),x}));return this._terminalLinkCache.set(t,y),h}$activateLink(t,r){var o;const l=(o=this._terminalLinkCache.get(t))===null||o===void 0?void 0:o.get(r);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(t,r){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const o=this._terminalProcessDisposables[t];o&&(o.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,r)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,r){const o=this._getTerminalObjectIndexById(t,r);return o!==null?t[o]:null}_getTerminalObjectIndexById(t,r){let o=null;return t.some((l,i)=>l._id===r?(o=i,!0):!1),o}getEnvironmentVariableCollection(t){let r=this._environmentVariableCollections.get(t.identifier.value);return r||(r=new c,this._setEnvironmentVariableCollection(t.identifier.value,r)),r}_syncEnvironmentVariableCollection(t,r){const o=(0,I.serializeEnvironmentVariableCollection)(r.map);this._proxy.$setEnvironmentVariableCollection(t,r.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(t){t.forEach(r=>{const o=r[0],l=new c(r[1]);this._setEnvironmentVariableCollection(o,l)})}_setEnvironmentVariableCollection(t,r){this._environmentVariableCollections.set(t,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,r)})}};b=je([qe(1,E.IExtHostRpcService)],b),e.BaseExtHostTerminalService=b;class c{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,r){this._setIfDiffers(t,{value:r,type:w.EnvironmentVariableMutatorType.Replace})}append(t,r){this._setIfDiffers(t,{value:r,type:w.EnvironmentVariableMutatorType.Append})}prepend(t,r){this._setIfDiffers(t,{value:r,type:w.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,r){const o=this.map.get(t);(!o||o.value!==r.value||o.type!==r.type)&&(this.map.set(t,r),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,r){this.map.forEach((o,l)=>t.call(r,l,o,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let u=class extends b{constructor(t){super(!1,t)}createTerminal(t,r,o){throw new A.NotSupportedError}createTerminalFromOptions(t){throw new A.NotSupportedError}getDefaultShell(t,r){return""}getDefaultShellArgs(t,r){throw new A.NotSupportedError}$getAvailableShells(){throw new A.NotSupportedError}async $getDefaultShellAndArgs(t){throw new A.NotSupportedError}$acceptWorkspacePermissionsChanged(t){}};u=je([qe(0,E.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(we[201],Ee([0,1,3,15,5,95,9,7]),function(ae,e,_,S,T,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class w{constructor(A,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(v=>this._onDidChangeVisibleTextEditors.fire(v)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(v=>this._onDidChangeActiveTextEditor.fire(v))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const I=this._extHostDocumentsAndEditors.allEditors();return A?I:I.map(v=>v.value)}async showTextDocument(A,I,v){let d;typeof I=="number"?d={position:E.ViewColumn.from(I),preserveFocus:v}:typeof I=="object"?d={position:E.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?E.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:d={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(A.uri,d),f=s&&this._extHostDocumentsAndEditors.getEditor(s);if(f)return f.value;throw s?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A){return new P.TextEditorDecorationType(this._proxy,A).value}$acceptEditorPropertiesChanged(A,I){const v=this._extHostDocumentsAndEditors.getEditor(A);if(!v)throw new Error("unknown text editor");if(I.options&&v._acceptOptions(I.options),I.selections){const d=I.selections.selections.map(E.Selection.to);v._acceptSelections(d)}if(I.visibleRanges){const d=S.coalesce(I.visibleRanges.map(E.Range.to));v._acceptVisibleRanges(d)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:v.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:E.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const d=k.TextEditorSelectionChangeKind.fromValue(I.selections.source),s=I.selections.selections.map(E.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:v.value,selections:s,kind:d})}if(I.visibleRanges){const d=S.coalesce(I.visibleRanges.map(E.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:v.value,visibleRanges:d})}}$acceptEditorPositionData(A){for(const I in A){const v=this._extHostDocumentsAndEditors.getEditor(I);if(!v)throw new Error("Unknown text editor");const d=E.ViewColumn.to(A[I]);v.value.viewColumn!==d&&(v._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:v.value,viewColumn:d}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=w});var an=this&&this.__rest||function(ae,e){var _={};for(var S in ae)Object.prototype.hasOwnProperty.call(ae,S)&&e.indexOf(S)<0&&(_[S]=ae[S]);if(ae!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,S=Object.getOwnPropertySymbols(ae);T<S.length;T++)e.indexOf(S[T])<0&&Object.prototype.propertyIsEnumerable.call(ae,S[T])&&(_[S[T]]=ae[S[T]]);return _};define(we[202],Ee([0,1,2,4,5,6,7]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,S.createDecorator)("IExtHostTimeline");class k{constructor(A,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=A.getProxy(T.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:v=>{var d,s;if(v&&v.$mid===11){const f=v.uri===void 0?void 0:_.URI.revive(v.uri);return(s=(d=this._itemsBySourceAndUriMap.get(v.source))===null||d===void 0?void 0:d.get(w(f)))===null||s===void 0?void 0:s.get(v.handle)}return v}})}async $getTimeline(A,I,v,d,s){const f=this._providers.get(A);return f==null?void 0:f.provideTimeline(_.URI.revive(I),v,d,s)}registerTimelineProvider(A,I,v,d){const s=new P.DisposableStore,f=this.convertTimelineItem(I.id,d,s).bind(this);let p;I.onDidChange&&(p=I.onDidChange(b=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},b),{id:I.id})),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:A,onDidChange:void 0,async provideTimeline(b,c,u,a){var t;(a==null?void 0:a.resetCache)&&(s.clear(),(t=m.get(I.id))===null||t===void 0||t.clear());const r=await I.provideTimeline(b,c,u);if(r!=null){const o=f(b,a);return Object.assign(Object.assign({},r),{source:I.id,items:r.items.map(o)})}},dispose(){var b;for(const c of m.values())(b=c.get(I.id))===null||b===void 0||b.clear();p==null||p.dispose(),s.dispose()}}))}convertTimelineItem(A,I,v){return(d,s)=>{let f;if(s==null?void 0:s.cacheResults){let p=this._itemsBySourceAndUriMap.get(A);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(A,p));const m=w(d);f=p.get(m),f===void 0&&(f=new Map,p.set(m,f))}return p=>{var m,b;const{iconPath:c}=p,u=an(p,["iconPath"]),a=`${A}|${(m=p.id)!==null&&m!==void 0?m:p.timestamp}`;f==null||f.set(a,p);let t,r,o;return p.iconPath&&(c instanceof E.ThemeIcon?o={id:c.id}:_.URI.isUri(c)?(t=c,r=c):{light:t,dark:r}=c),Object.assign(Object.assign({},u),{id:(b=u.id)!==null&&b!==void 0?b:void 0,handle:a,source:A,command:p.command?I.toInternal(p.command,v):void 0,icon:t,iconDark:r,themeIcon:o,accessibilityInformation:p.accessibilityInformation})}}}registerTimelineProviderCore(A){if(this._providers.get(A.id))throw new Error(`Timeline Provider ${A.id} already exists.`);return this._proxy.$registerTimelineProvider({id:A.id,label:A.label,scheme:A.scheme}),this._providers.set(A.id,A),(0,P.toDisposable)(()=>{var v;for(const d of this._itemsBySourceAndUriMap.values())(v=d.get(A.id))===null||v===void 0||v.clear();this._providers.delete(A.id),this._proxy.$unregisterTimelineProvider(A.id),A.dispose()})}}e.ExtHostTimeline=k;function w(n){return n==null?void 0:n.toString()}}),define(we[203],Ee([0,1,6,16,2,5]),function(ae,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class E{constructor(w){this._openers=new Map,this._proxy=w.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,n,A,I){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const v=I.schemes.find(d=>!E.supportedSchemes.has(d));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,A),this._proxy.$registerUriOpener(n,I.schemes,w,I.label),(0,_.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(w,n,A){const I=this._openers.get(w);if(!I)throw new Error(`Unknown opener with id: ${w}`);const v=T.URI.revive(n);return I.canOpenExternalUri(v,A)}async $openUri(w,n,A){const I=this._openers.get(w);if(!I)throw new Error(`Unknown opener id: '${w}'`);return I.openExternalUri(T.URI.revive(n.resolvedUri),{sourceUri:T.URI.revive(n.sourceUri)},A)}}e.ExtHostUriOpeners=E,E.supportedSchemes=new Set([S.Schemas.http,S.Schemas.https])}),define(we[204],Ee([0,1,5,2,6,10,25]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(n,A){if(this.handles.has(E.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const I=k.HandlePool++;return this.handles.add(E.ExtensionIdentifier.toKey(n)),this.handlers.set(I,A),this._proxy.$registerUriHandler(I,n),(0,T.toDisposable)(()=>{this.handles.delete(E.ExtensionIdentifier.toKey(n)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(n,A){const I=this.handlers.get(n);if(!I)return Promise.resolve(void 0);try{I.handleUri(S.URI.revive(A))}catch(v){(0,P.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(n){return S.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=k,k.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(ae,e,_){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,_),_},We=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(we[49],Ee([0,1,3,2,69,5]),function(ae,e,_,S,T,P){"use strict";var E,k,w,n,A,I,v,d,s,f,p;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.ExtHostWebview=void 0;class m{constructor(o,l,i,h,D,C,g){E.set(this,void 0),k.set(this,void 0),w.set(this,void 0),n.set(this,void 0),A.set(this,void 0),I.set(this,void 0),v.set(this,""),d.set(this,void 0),s.set(this,!1),f.set(this,!1),this._onMessageEmitter=new _.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,p.set(this,new _.Emitter),this._onDidDispose=We(this,p).event,tt(this,E,o),tt(this,k,l),tt(this,d,i),tt(this,n,h),tt(this,A,D),tt(this,I,C),tt(this,w,g)}dispose(){tt(this,s,!0),We(this,p).fire(),We(this,p).dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return tt(this,f,!0),(0,T.asWebviewUri)(We(this,n),We(this,E),o)}get cspSource(){return We(this,n).webviewCspSource.replace("{{uuid}}",We(this,E))}get html(){return this.assertNotDisposed(),We(this,v)}set html(o){this.assertNotDisposed(),We(this,v)!==o&&(tt(this,v,o),!We(this,f)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(tt(this,f,!0),We(this,w).report("Webview vscode-resource: uris",We(this,I),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),We(this,k).$setHtml(We(this,E),o))}get options(){return this.assertNotDisposed(),We(this,d)}set options(o){this.assertNotDisposed(),We(this,k).$setOptions(We(this,E),u(We(this,I),We(this,A),o)),tt(this,d,o)}async postMessage(o){return We(this,s)?!1:We(this,k).$postMessage(We(this,E),o)}assertNotDisposed(){if(We(this,s))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,E=new WeakMap,k=new WeakMap,w=new WeakMap,n=new WeakMap,A=new WeakMap,I=new WeakMap,v=new WeakMap,d=new WeakMap,s=new WeakMap,f=new WeakMap,p=new WeakMap;class b{constructor(o,l,i,h,D){this.initData=l,this.workspace=i,this._logService=h,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=o.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(o,l){const i=this.getWebview(o);i&&i._onMessageEmitter.fire(l)}$onMissingCsp(o,l){this._logService.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,l,i){const h=new m(o,this._webviewProxy,a(l),this.initData,this.workspace,i,this._deprecationService);return this._webviews.set(o,h),h._onDidDispose(()=>{this._webviews.delete(o)}),h}deleteWebview(o){this._webviews.delete(o)}getWebview(o){return this._webviews.get(o)}}e.ExtHostWebviews=b;function c(r){return{id:r.identifier,location:r.extensionLocation}}e.toExtensionData=c;function u(r,o,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||t(r,o)}}e.serializeWebviewOptions=u;function a(r){var o;return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,portMapping:r.portMapping,localResourceRoots:(o=r.localResourceRoots)===null||o===void 0?void 0:o.map(l=>S.URI.from(l))}}e.reviveOptions=a;function t(r,o){return[...((o==null?void 0:o.getWorkspaceFolders())||[]).map(l=>l.uri),r.extensionLocation]}}),define(we[205],Ee([0,1,20,55,6,16,24,2,9,49,92,5,7]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,E.joinPath)(this._storagePath,t)}updateBackup(t){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class s{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,o){const l=this.key(t,r.uri);if(this._documents.has(l))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const i=new d(r,o);return this._documents.set(l,i),i}delete(t,r){const o=this.key(t,r.uri);this._documents.delete(o)}key(t,r){return`${t}@@@${r}`}}var f;(function(a){a[a.Text=0]="Text",a[a.Custom=1]="Custom"})(f||(f={}));class p{constructor(){this._providers=new Map}addTextProvider(t,r,o){return this.add(0,t,r,o)}addCustomProvider(t,r,o){return this.add(1,t,r,o)}get(t){return this._providers.get(t)}add(t,r,o,l){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:o,provider:l}),new v.Disposable(()=>this._providers.delete(r))}}class m{constructor(t,r,o,l,i){this._extHostDocuments=r,this._extensionStoragePaths=o,this._extHostWebview=l,this._extHostWebviewPanels=i,this._editorProviders=new p,this._documents=new s,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,o,l){const i=new T.DisposableStore;return b(o)?(i.add(this._editorProviders.addTextProvider(r,t,o)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),r,l.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor})):(i.add(this._editorProviders.addCustomProvider(r,t,o)),this.supportEditing(o)&&i.add(o.onDidChangeCustomDocument(h=>{const D=this.getCustomDocumentEntry(r,h.document.uri);if(c(h)){const C=D.addEdit(h);this._proxy.$onDidEdit(h.document.uri,r,C,h.label)}else this._proxy.$onContentChange(h.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),r,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument)),v.Disposable.from(i,new v.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,o,l,i){var h;const D=this._editorProviders.get(r);if(!D)throw new Error(`No provider found for '${r}'`);if(D.type!==1)throw new Error(`Invalid provide type for '${r}'`);const C=k.URI.revive(t),g=await D.provider.openCustomDocument(C,{backupId:o,untitledDocumentData:l==null?void 0:l.buffer},i);let y;return this.supportEditing(D.provider)&&this._extensionStoragePaths&&(y=(h=this._extensionStoragePaths.workspaceValue(D.extension))!==null&&h!==void 0?h:this._extensionStoragePaths.globalValue(D.extension)),this._documents.add(r,g,y),{editable:this.supportEditing(D.provider)}}async $disposeCustomDocument(t,r){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${r}'`);const l=k.URI.revive(t),{document:i}=this.getCustomDocumentEntry(r,l);this._documents.delete(r,i),i.dispose()}async $resolveWebviewEditor(t,r,o,l,i,h){const D=this._editorProviders.get(o);if(!D)throw new Error(`No provider found for '${o}'`);const C=w.ViewColumn.to(i),g=this._extHostWebview.createNewWebview(r,l.webviewOptions,D.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(r,o,l.title,C,l.panelOptions,g),R=k.URI.revive(t);switch(D.type){case 1:{const{document:O}=this.getCustomDocumentEntry(o,R);return D.provider.resolveCustomEditor(O,y,h)}case 0:{const O=this._extHostDocuments.getDocument(R);return D.provider.resolveCustomTextEditor(O,y,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,o){this.getCustomDocumentEntry(r,t).disposeEdits(o)}async $onMoveCustomEditor(t,r,o){const l=this._editorProviders.get(o);if(!l)throw new Error(`No provider found for '${o}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const i=this._extHostWebviewPanels.getWebviewPanel(t);if(!i)throw new Error("No webview found");const h=k.URI.revive(r),D=this._extHostDocuments.getDocument(h);await l.provider.moveCustomTextEditor(D,i,_.CancellationToken.None)}async $undo(t,r,o,l){return this.getCustomDocumentEntry(r,t).undo(o,l)}async $redo(t,r,o,l){return this.getCustomDocumentEntry(r,t).redo(o,l)}async $revert(t,r,o){const l=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(l.document,o),l.disposeBackup()}async $onSave(t,r,o){const l=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(l.document,o),l.disposeBackup()}async $onSaveAs(t,r,o,l){const i=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(i.document,k.URI.revive(o),l)}async $backup(t,r,o){const l=this.getCustomDocumentEntry(r,t),h=await this.getCustomEditorProvider(r).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},o);return l.updateBackup(h),h.id}getCustomDocumentEntry(t,r){const o=this._documents.get(t,k.URI.revive(r));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const r=this._editorProviders.get(t),o=r==null?void 0:r.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function b(a){return typeof a.resolveCustomTextEditor=="function"}function c(a){return typeof a.undo=="function"&&typeof a.redo=="function"}function u(a){const t=a.scheme===P.Schemas.file||a.scheme===P.Schemas.untitled?a.fsPath:a.toString();return(0,S.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(ae,e,_){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,_),_},We=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(we[206],Ee([0,1,3,6,2,29,9,49,5,7]),function(ae,e,_,S,T,P,E,k,w,n){"use strict";var A,I,v,d,s,f,p,m,b,c,u,a,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends S.Disposable{constructor(h,D,C,g,y,R,O){super();A.set(this,void 0),I.set(this,void 0),v.set(this,void 0),d.set(this,void 0),s.set(this,void 0),f.set(this,void 0),p.set(this,void 0),m.set(this,void 0),b.set(this,!0),c.set(this,!0),u.set(this,!1),a.set(this,this._register(new _.Emitter)),this.onDidDispose=We(this,a).event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=We(this,t).event,tt(this,A,h),tt(this,I,D),tt(this,v,C),tt(this,s,R),tt(this,m,y),tt(this,f,g),tt(this,d,O)}dispose(){We(this,u)||(tt(this,u,!0),We(this,a).fire(),We(this,I).$disposeWebview(We(this,A)),We(this,d).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),We(this,d)}get viewType(){return this.assertNotDisposed(),We(this,v)}get title(){return this.assertNotDisposed(),We(this,f)}set title(h){this.assertNotDisposed(),We(this,f)!==h&&(tt(this,f,h),We(this,I).$setTitle(We(this,A),h))}get iconPath(){return this.assertNotDisposed(),We(this,p)}set iconPath(h){this.assertNotDisposed(),We(this,p)!==h&&(tt(this,p,h),We(this,I).$setIconPath(We(this,A),T.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return We(this,s)}get viewColumn(){if(this.assertNotDisposed(),!(typeof We(this,m)=="number"&&We(this,m)<0))return We(this,m)}get active(){return this.assertNotDisposed(),We(this,c)}get visible(){return this.assertNotDisposed(),We(this,b)}_updateViewState(h){We(this,u)||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(tt(this,c,h.active),tt(this,b,h.visible),tt(this,m,h.viewColumn),We(this,t).fire({webviewPanel:this}))}reveal(h,D){this.assertNotDisposed(),We(this,I).$reveal(We(this,A),{viewColumn:h?E.ViewColumn.from(h):void 0,preserveFocus:!!D})}assertNotDisposed(){if(We(this,u))throw new Error("Webview is disposed")}}A=new WeakMap,I=new WeakMap,v=new WeakMap,d=new WeakMap,s=new WeakMap,f=new WeakMap,p=new WeakMap,m=new WeakMap,b=new WeakMap,c=new WeakMap,u=new WeakMap,a=new WeakMap,t=new WeakMap;class o{constructor(h,D,C){this.webviews=D,this.workspace=C,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(w.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(h,D,C,g,y={}){const R=typeof g=="object"?g.viewColumn:g,O={viewColumn:E.ViewColumn.from(R),preserveFocus:typeof g=="object"&&!!g.preserveFocus},x=o.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(h),x,D,{title:C,panelOptions:l(y),webviewOptions:(0,k.serializeWebviewOptions)(h,this.workspace,y)},O);const z=this.webviews.createNewWebview(x,y,h);return this.createNewWebviewPanel(x,D,C,R,y,z)}$onDidChangeWebviewPanelViewStates(h){const D=Object.keys(h);D.sort((C,g)=>{const y=h[C],R=h[g];return y.active?1:R.active?-1:+y.visible-+R.visible});for(const C of D){const g=this.getWebviewPanel(C);if(!!g){const y=h[C];g._updateViewState({active:y.active,visible:y.visible,viewColumn:E.ViewColumn.to(y.position)})}}}async $onDidDisposeWebviewPanel(h){const D=this.getWebviewPanel(h);D==null||D.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,D,C){if(this._serializers.has(D))throw new Error(`Serializer for '${D}' already registered`);return this._serializers.set(D,{serializer:C,extension:h}),this._proxy.$registerSerializer(D),new n.Disposable(()=>{this._serializers.delete(D),this._proxy.$unregisterSerializer(D)})}async $deserializeWebviewPanel(h,D,C,g){const y=this._serializers.get(D);if(!y)throw new Error(`No serializer found for '${D}'`);const{serializer:R,extension:O}=y,x=this.webviews.createNewWebview(h,C.webviewOptions,O),z=this.createNewWebviewPanel(h,D,C.title,g,C.panelOptions,x);await R.deserializeWebviewPanel(z,C.state)}createNewWebviewPanel(h,D,C,g,y,R){const O=new r(h,this._proxy,D,C,g,y,R);return this._webviewPanels.set(h,O),O}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=o;function l(i){return{enableFindWidget:i.enableFindWidget,retainContextWhenHidden:i.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(ae,e,_){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,_),_},We=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(we[207],Ee([0,1,3,6,49,5,7]),function(ae,e,_,S,T,P,E){"use strict";var k,w,n,A,I,v,d,s,f,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends S.Disposable{constructor(u,a,t,r,o,l){super();k.set(this,void 0),w.set(this,void 0),n.set(this,void 0),A.set(this,void 0),I.set(this,!1),v.set(this,void 0),d.set(this,void 0),s.set(this,void 0),f.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=We(this,f).event,p.set(this,this._register(new _.Emitter)),this.onDidDispose=We(this,p).event,tt(this,n,t),tt(this,d,r),tt(this,k,u),tt(this,w,a),tt(this,A,o),tt(this,v,l)}dispose(){We(this,I)||(tt(this,I,!0),We(this,p).fire(),We(this,A).dispose(),super.dispose())}get title(){return this.assertNotDisposed(),We(this,d)}set title(u){this.assertNotDisposed(),We(this,d)!==u&&(tt(this,d,u),We(this,w).$setWebviewViewTitle(We(this,k),u))}get description(){return this.assertNotDisposed(),We(this,s)}set description(u){this.assertNotDisposed(),We(this,s)!==u&&(tt(this,s,u),We(this,w).$setWebviewViewDescription(We(this,k),u))}get visible(){return We(this,v)}get webview(){return We(this,A)}get viewType(){return We(this,n)}_setVisible(u){u===We(this,v)||We(this,I)||(tt(this,v,u),We(this,f).fire())}show(u){this.assertNotDisposed(),We(this,w).$show(We(this,k),!!u)}assertNotDisposed(){if(We(this,I))throw new Error("Webview is disposed")}}k=new WeakMap,w=new WeakMap,n=new WeakMap,A=new WeakMap,I=new WeakMap,v=new WeakMap,d=new WeakMap,s=new WeakMap,f=new WeakMap,p=new WeakMap;class b{constructor(u,a){this._extHostWebview=a,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,a,t,r){if(this._viewProviders.has(a))throw new Error(`View provider for '${a}' already registered`);return this._viewProviders.set(a,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(u),a,r),new E.Disposable(()=>{this._viewProviders.delete(a),this._proxy.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(u,a,t,r,o){const l=this._viewProviders.get(a);if(!l)throw new Error(`No view provider found for '${a}'`);const{provider:i,extension:h}=l,D=this._extHostWebview.createNewWebview(u,{},h),C=new m(u,this._proxy,a,t,D,!0);this._webviewViews.set(u,C),await i.resolveWebviewView(C,{state:r},o)}async $onDidChangeWebviewViewVisibility(u,a){this.getWebviewView(u)._setVisible(a)}async $disposeWebviewView(u){const a=this.getWebviewView(u);this._webviewViews.delete(u),a.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const a=this._webviewViews.get(u);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=b}),define(we[99],Ee([0,1,3,5,2,16,8,4,14]),function(ae,e,_,S,T,P,E,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Cn{constructor(I){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Cn.InitialState,this._proxy=I.getProxy(S.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,v){let d;if(typeof I=="string"){d=I;try{I=T.URI.parse(I)}catch(s){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,E.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,d,v)}async asExternalUri(I,v){if((0,E.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([P.Schemas.http,P.Schemas.https]).has(I.scheme))return Promise.reject(`Invalid scheme '${I.scheme}'`);const d=await this._proxy.$asExternalUri(I,v);return T.URI.from(d)}};n.InitialState={focused:!0},n=je([qe(0,w.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(we[208],Ee([0,1,19,5,27,14]),function(ae,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let E=class extends _.AbstractLogger{constructor(w,n){super();this._proxy=w.getProxy(S.MainContext.MainThreadLog),this._logFile=n.logFile.toJSON(),this.setLevel(n.logLevel)}$setLevel(w){this.setLevel(w)}trace(w,...n){this.getLevel()<=_.LogLevel.Trace&&this._proxy.$log(this._logFile,_.LogLevel.Trace,Array.from(arguments))}debug(w,...n){this.getLevel()<=_.LogLevel.Debug&&this._proxy.$log(this._logFile,_.LogLevel.Debug,Array.from(arguments))}info(w,...n){this.getLevel()<=_.LogLevel.Info&&this._proxy.$log(this._logFile,_.LogLevel.Info,Array.from(arguments))}warn(w,...n){this.getLevel()<=_.LogLevel.Warning&&this._proxy.$log(this._logFile,_.LogLevel.Warning,Array.from(arguments))}error(w,...n){this.getLevel()<=_.LogLevel.Error&&this._proxy.$log(this._logFile,_.LogLevel.Error,Array.from(arguments))}critical(w,...n){this.getLevel()<=_.LogLevel.Critical&&this._proxy.$log(this._logFile,_.LogLevel.Critical,Array.from(arguments))}flush(){}};E=je([qe(0,P.IExtHostRpcService),qe(1,T.IExtHostInitDataService)],E),e.ExtHostLogService=E}),define(we[209],Ee([0,1,13,20,10,3,6,110,182,96,26]),function(ae,e,_,S,T,P,E,k,w,n,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function v(l,i){try{return JSON.stringify(l,i)}catch(h){return"null"}}function d(l,i){return JSON.stringify(l,i)}function s(l){return l?(i,h)=>h&&h.$mid===1?l.transformOutgoing(h):h:null}var f;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const m=()=>{},b=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class u extends E.Disposable{constructor(i,h=null,D=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=i,this._logger=h,this._uriTransformer=D,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let C=0,g=n.ProxyIdentifier.count;C<g;C++)this._locals[C]=null,this._proxies[C]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(C=>this._receiveOneMessage(C))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(i=>{this._pendingRPCReplies[i].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(i){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(i){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(i){this._responsiveState!==i&&(this._responsiveState=i,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(i){return this._uriTransformer?(0,k.transformIncomingURIs)(i,this._uriTransformer):i}getProxy(i){const{nid:h,sid:D}=i;return this._proxies[h]||(this._proxies[h]=this._createProxy(h,D)),this._proxies[h]}_createProxy(i,h){let D={get:(C,g)=>(typeof g=="string"&&!C[g]&&g.charCodeAt(0)===36&&(C[g]=(...y)=>this._remoteCall(i,g,y)),g===c?h:C[g])};return new Proxy(Object.create(null),D)}set(i,h){return this._locals[i.nid]=h,h}assertRegistered(i){for(let h=0,D=i.length;h<D;h++){const C=i[h];if(!this._locals[C.nid])throw new Error(`Missing actor ${C.sid} (isMain: ${C.isMain})`)}}_receiveOneMessage(i){if(!this._isDisposed){const h=i.byteLength,D=a.read(i,0),C=D.readUInt8(),g=D.readUInt32();switch(C){case 1:case 2:{let{rpcId:y,method:R,args:O}=t.deserializeRequestJSONArgs(D);this._uriTransformer&&(O=(0,k.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(h,g,y,R,O,C===2);break}case 3:case 4:{let{rpcId:y,method:R,args:O}=t.deserializeRequestMixedArgs(D);this._uriTransformer&&(O=(0,k.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(h,g,y,R,O,C===4);break}case 5:{this._logger&&this._logger.logIncoming(h,g,0,"ack"),this._onDidReceiveAcknowledge(g);break}case 6:{this._receiveCancel(h,g);break}case 7:{this._receiveReply(h,g,void 0);break}case 9:{let y=t.deserializeReplyOKJSON(D);this._uriTransformer&&(y=(0,k.transformIncomingURIs)(y,this._uriTransformer)),this._receiveReply(h,g,y);break}case 8:{let y=t.deserializeReplyOKVSBuffer(D);this._receiveReply(h,g,y);break}case 10:{let y=t.deserializeReplyErrError(D);this._uriTransformer&&(y=(0,k.transformIncomingURIs)(y,this._uriTransformer)),this._receiveReplyErr(h,g,y);break}case 11:{this._receiveReplyErr(h,g,void 0);break}default:console.error("received unexpected message"),console.error(i)}}}_receiveRequest(i,h,D,C,g,y){this._logger&&this._logger.logIncoming(i,h,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(D)}.${C}(`,g);const R=String(h);let O,x;if(y){const Q=new S.CancellationTokenSource;g.push(Q.token),O=this._invokeHandler(D,C,g),x=()=>Q.cancel()}else O=this._invokeHandler(D,C,g),x=m;this._cancelInvokedHandlers[R]=x;const z=t.serializeAcknowledged(h);this._logger&&this._logger.logOutgoing(z.byteLength,h,1,"ack"),this._protocol.send(z),O.then(Q=>{delete this._cancelInvokedHandlers[R];const j=t.serializeReplyOK(h,Q,this._uriReplacer);this._logger&&this._logger.logOutgoing(j.byteLength,h,1,"reply:",Q),this._protocol.send(j)},Q=>{delete this._cancelInvokedHandlers[R];const j=t.serializeReplyErr(h,Q);this._logger&&this._logger.logOutgoing(j.byteLength,h,1,"replyErr:",Q),this._protocol.send(j)})}_receiveCancel(i,h){this._logger&&this._logger.logIncoming(i,h,1,"receiveCancel");const D=String(h);this._cancelInvokedHandlers[D]&&this._cancelInvokedHandlers[D]()}_receiveReply(i,h,D){this._logger&&this._logger.logIncoming(i,h,0,"receiveReply:",D);const C=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(C)){const g=this._pendingRPCReplies[C];delete this._pendingRPCReplies[C],g.resolveOk(D)}}_receiveReplyErr(i,h,D){this._logger&&this._logger.logIncoming(i,h,0,"receiveReplyErr:",D);const C=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(C)){const g=this._pendingRPCReplies[C];delete this._pendingRPCReplies[C];let y;D&&(D.$isError?(y=new Error,y.name=D.name,y.message=D.message,y.stack=D.stack):y=D),g.resolveErr(y)}}_invokeHandler(i,h,D){try{return Promise.resolve(this._doInvokeHandler(i,h,D))}catch(C){return Promise.reject(C)}}_doInvokeHandler(i,h,D){const C=this._locals[i];if(!C)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(i));let g=C[h];if(typeof g!="function")throw new Error("Unknown method "+h+" on actor "+(0,n.getStringIdentifierForProxy)(i));return g.apply(C,D)}_remoteCall(i,h,D){if(this._isDisposed)return Promise.reject(T.canceled());let C=null;if(D.length>0&&S.CancellationToken.isCancellationToken(D[D.length-1])&&(C=D.pop()),C&&C.isCancellationRequested)return Promise.reject(T.canceled());const g=t.serializeRequestArguments(D,this._uriReplacer),y=++this._lastMessageId,R=String(y),O=new w.LazyPromise;C&&C.onCancellationRequested(()=>{const z=t.serializeCancel(y);this._logger&&this._logger.logOutgoing(z.byteLength,y,0,"cancel"),this._protocol.send(t.serializeCancel(y))}),this._pendingRPCReplies[R]=O,this._onWillSendRequest(y);const x=t.serializeRequest(y,i,h,g,!!C);return this._logger&&this._logger.logOutgoing(x.byteLength,y,0,`request: ${(0,n.getStringIdentifierForProxy)(i)}.${h}(`,D),this._protocol.send(x),O}}e.RPCProtocol=u,I=b,u.UNRESPONSIVE_TIME=3*1e3;class a{constructor(i,h){this._buff=i,this._offset=h}static alloc(i,h,D){let C=new a(A.VSBuffer.alloc(D+1+4),0);return C.writeUInt8(i),C.writeUInt32(h),C}static read(i,h){return new a(i,h)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(i){this._buff.writeUInt8(i,this._offset),this._offset+=1}readUInt8(){const i=this._buff.readUInt8(this._offset);return this._offset+=1,i}writeUInt32(i){this._buff.writeUInt32BE(i,this._offset),this._offset+=4}readUInt32(){const i=this._buff.readUInt32BE(this._offset);return this._offset+=4,i}static sizeShortString(i){return 1+i.byteLength}writeShortString(i){this._buff.writeUInt8(i.byteLength,this._offset),this._offset+=1,this._buff.set(i,this._offset),this._offset+=i.byteLength}readShortString(){const i=this._buff.readUInt8(this._offset);this._offset+=1;const D=this._buff.slice(this._offset,this._offset+i).toString();return this._offset+=i,D}static sizeLongString(i){return 4+i.byteLength}writeLongString(i){this._buff.writeUInt32BE(i.byteLength,this._offset),this._offset+=4,this._buff.set(i,this._offset),this._offset+=i.byteLength}readLongString(){const i=this._buff.readUInt32BE(this._offset);this._offset+=4;const D=this._buff.slice(this._offset,this._offset+i).toString();return this._offset+=i,D}writeBuffer(i){this._buff.writeUInt32BE(i.byteLength,this._offset),this._offset+=4,this._buff.set(i,this._offset),this._offset+=i.byteLength}static sizeVSBuffer(i){return 4+i.byteLength}writeVSBuffer(i){this._buff.writeUInt32BE(i.byteLength,this._offset),this._offset+=4,this._buff.set(i,this._offset),this._offset+=i.byteLength}readVSBuffer(){const i=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+i);return this._offset+=i,h}static sizeMixedArray(i,h){let D=0;D+=1;for(let C=0,g=i.length;C<g;C++){const y=i[C],R=h[C];switch(D+=1,R){case 1:D+=this.sizeLongString(y);break;case 2:D+=this.sizeVSBuffer(y);break;case 3:break}}return D}writeMixedArray(i,h){this._buff.writeUInt8(i.length,this._offset),this._offset+=1;for(let D=0,C=i.length;D<C;D++){const g=i[D];switch(h[D]){case 1:this.writeUInt8(1),this.writeLongString(g);break;case 2:this.writeUInt8(2),this.writeVSBuffer(g);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const i=this._buff.readUInt8(this._offset);this._offset+=1;let h=new Array(i);for(let D=0;D<i;D++)switch(this.readUInt8()){case 1:h[D]=this.readLongString();break;case 2:h[D]=this.readVSBuffer();break;case 3:h[D]=void 0;break}return h}}class t{static _arrayContainsBufferOrUndefined(i){for(let h=0,D=i.length;h<D;h++)if(i[h]instanceof A.VSBuffer||typeof i[h]=="undefined")return!0;return!1}static serializeRequestArguments(i,h){if(this._arrayContainsBufferOrUndefined(i)){let D=[],C=[];for(let g=0,y=i.length;g<y;g++){const R=i[g];R instanceof A.VSBuffer?(D[g]=R,C[g]=2):typeof R=="undefined"?(D[g]=A.VSBuffer.alloc(0),C[g]=3):(D[g]=A.VSBuffer.fromString(d(R,h)),C[g]=1)}return{type:"mixed",args:D,argsType:C}}return{type:"simple",args:d(i,h)}}static serializeRequest(i,h,D,C,g){return C.type==="mixed"?this._requestMixedArgs(i,h,D,C.args,C.argsType,g):this._requestJSONArgs(i,h,D,C.args,g)}static _requestJSONArgs(i,h,D,C,g){const y=A.VSBuffer.fromString(D),R=A.VSBuffer.fromString(C);let O=0;O+=a.sizeUInt8(),O+=a.sizeShortString(y),O+=a.sizeLongString(R);let x=a.alloc(g?2:1,i,O);return x.writeUInt8(h),x.writeShortString(y),x.writeLongString(R),x.buffer}static deserializeRequestJSONArgs(i){const h=i.readUInt8(),D=i.readShortString(),C=i.readLongString();return{rpcId:h,method:D,args:JSON.parse(C)}}static _requestMixedArgs(i,h,D,C,g,y){const R=A.VSBuffer.fromString(D);let O=0;O+=a.sizeUInt8(),O+=a.sizeShortString(R),O+=a.sizeMixedArray(C,g);let x=a.alloc(y?4:3,i,O);return x.writeUInt8(h),x.writeShortString(R),x.writeMixedArray(C,g),x.buffer}static deserializeRequestMixedArgs(i){const h=i.readUInt8(),D=i.readShortString(),C=i.readMixedArray(),g=new Array(C.length);for(let y=0,R=C.length;y<R;y++){const O=C[y];typeof O=="string"?g[y]=JSON.parse(O):g[y]=O}return{rpcId:h,method:D,args:g}}static serializeAcknowledged(i){return a.alloc(5,i,0).buffer}static serializeCancel(i){return a.alloc(6,i,0).buffer}static serializeReplyOK(i,h,D){return typeof h=="undefined"?this._serializeReplyOKEmpty(i):h instanceof A.VSBuffer?this._serializeReplyOKVSBuffer(i,h):this._serializeReplyOKJSON(i,v(h,D))}static _serializeReplyOKEmpty(i){return a.alloc(7,i,0).buffer}static _serializeReplyOKVSBuffer(i,h){let D=0;D+=a.sizeVSBuffer(h);let C=a.alloc(8,i,D);return C.writeVSBuffer(h),C.buffer}static deserializeReplyOKVSBuffer(i){return i.readVSBuffer()}static _serializeReplyOKJSON(i,h){const D=A.VSBuffer.fromString(h);let C=0;C+=a.sizeLongString(D);let g=a.alloc(9,i,C);return g.writeLongString(D),g.buffer}static deserializeReplyOKJSON(i){const h=i.readLongString();return JSON.parse(h)}static serializeReplyErr(i,h){return h?this._serializeReplyErrEror(i,h):this._serializeReplyErrEmpty(i)}static _serializeReplyErrEror(i,h){const D=A.VSBuffer.fromString(v(T.transformErrorForSerialization(h),null));let C=0;C+=a.sizeLongString(D);let g=a.alloc(10,i,C);return g.writeLongString(D),g.buffer}static deserializeReplyErrError(i){const h=i.readLongString();return JSON.parse(h)}static _serializeReplyErrEmpty(i){return a.alloc(11,i,0).buffer}}var r;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyErrError=10]="ReplyErrError",l[l.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var o;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.Undefined=3]="Undefined"})(o||(o={}))}),define(we[210],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const _=function(P){const E=k=>{self.removeEventListener("message",E);const w=k.data;Object.defineProperties(self,{postMessage:{value(n,A){w.postMessage(n,A)}},onmessage:{get(){return w.onmessage},set(n){w.onmessage=n}}}),w.addEventListener("message",n=>{self.dispatchEvent(new MessageEvent("message",{data:n.data}))}),w.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(P)};self.addEventListener("message",E)}.toString();class S extends EventTarget{constructor(P,E,k){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const w=`((${_})('${E}'))`,n=new Blob([w],{type:"application/javascript"}),A=URL.createObjectURL(n),I=new MessageChannel,v=A,d={type:"_newWorker",id:v,port:I.port2,url:A,options:k};P(d,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:v};I.port1.postMessage(s),URL.revokeObjectURL(A),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(s){I.port1.onmessage=s}},onmessageerror:{get(){return I.port1.onmessageerror},set(s){I.port1.onmessageerror=s}}}),I.port1.addEventListener("messageerror",s=>{const f=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(f)}),I.port1.addEventListener("message",s=>{const f=new MessageEvent("message",{data:s.data});this.dispatchEvent(f)}),I.port1.start()}}e.NestedWorker=S}),define(we[211],Ee([0,1,4]),function(ae,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(we[212],Ee([0,1,16,11,21,2,4,211]),function(ae,e,_,S,T,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let w=class{constructor(A,I){this.localUserHome=A,this.remoteAgentService=I,this.resolveOS=(async()=>{const v=await this.remoteAgentService.getEnvironment();return(v==null?void 0:v.os)||T.OS})(),this.resolveUserHome=(async()=>{const v=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(v==null?void 0:v.userHome)||A})()}async userHome(A){return(A==null?void 0:A.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(A=>A===1?S.win32:S.posix)}async fileURI(A){let I="";if(await this.resolveOS===1&&(A=A.replace(/\\/g,"/")),A[0]==="/"&&A[1]==="/"){const d=A.indexOf("/",2);d===-1?(I=A.substring(2),A="/"):(I=A.substring(2,d),A=A.substring(d)||"/")}return P.URI.from({scheme:_.Schemas.file,authority:I,path:A,query:"",fragment:""})}};w=je([qe(1,k.IRemoteAgentService)],w),e.AbstractPathService=w}),define(we[42],Ee([0,1,15,28,23,38,8,4,11,10]),function(ae,e,_,S,T,P,E,k,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const A="\u27EA ",I=" characters skipped \u27EB",v=(A.length+I.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var d;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var s;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(s=e.QueryType||(e.QueryType={}));function f(L){return!!L.preview}e.resultIsMatch=f;function p(L){return!!L.resource}e.isFileMatch=p;function m(L){return!!L.message}e.isProgressMessage=m;var b;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(b=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class c{constructor($){this.resource=$,this.results=[]}}e.FileMatch=c;class u{constructor($,W,K){this.ranges=W;const U=Array.isArray(W)?W:[W];if(K&&K.matchLines===1&&a(U)){$=(0,E.getNLines)($,K.matchLines);let ee="",ie=0,se=0;const Se=Math.floor(K.charsPerLine/5),Ae=[];for(const Be of U){const Re=Math.max(Be.startColumn-Se,0),xe=Be.startColumn+K.charsPerLine;if(Re>se+Se+v){const N=A+(Re-se)+I;ee+=N+$.slice(Re,xe),ie+=Re-(se+N.length)}else ee+=$.slice(se,xe);Ae.push(new r(0,Be.startColumn-ie,Be.endColumn-ie)),se=xe}this.preview={text:ee,matches:Array.isArray(this.ranges)?Ae:Ae[0]}}else{const ee=Array.isArray(W)?W[0].startLineNumber:W.startLineNumber;this.preview={text:$,matches:(0,_.mapArrayOrNot)(W,ie=>new t(ie.startLineNumber-ee,ie.startColumn,ie.endLineNumber-ee,ie.endColumn))}}}}e.TextSearchMatch=u;function a(L){const $=L[0].startLineNumber;for(const W of L)if(W.startLineNumber!==$||W.endLineNumber!==$)return!1;return!0}class t{constructor($,W,K,U){this.startLineNumber=$,this.startColumn=W,this.endLineNumber=K,this.endColumn=U}}e.SearchRange=t;class r extends t{constructor($,W,K){super($,W,$,K)}}e.OneLineRange=r;var o;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function l(L,$=!0){const W=L&&L.files&&L.files.exclude,K=$&&L&&L.search&&L.search.exclude;if(!(!W&&!K)){if(!W||!K)return W||K;let U=Object.create(null);return U=T.mixin(U,T.deepClone(W)),U=T.mixin(U,T.deepClone(K),!0),U}}e.getExcludes=l;function i(L,$){return L.excludePattern&&S.match(L.excludePattern,$)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&S.match(L.includePattern,$)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(W=>{const K=W.folder.fsPath;if(P.isEqualOrParent($,K)){const U=w.relative(K,$);return!W.includePattern||!!S.match(W.includePattern,U)}else return!1}):!1:!0}e.pathIncludedInQuery=i;var h;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class D extends Error{constructor($,W){super($);this.code=W}}e.SearchError=D;function C(L){const $=L.message;if((0,n.isPromiseCanceledError)(L))return new D($,h.canceled);try{const W=JSON.parse($);return new D(W.message,W.code)}catch(W){return new D($,h.other)}}e.deserializeSearchError=C;function g(L){const $={message:L.message,code:L.code};return new Error(JSON.stringify($))}e.serializeSearchError=g;function y(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=y;function R(L){return L.type==="success"}e.isSerializedSearchSuccess=R;function O(L){return!!L.path}e.isSerializedFileMatch=O;function x(L,$){const W=L.searchPath?L.searchPath:L.relativePath;return(0,E.fuzzyContains)(W,$)}e.isFilePatternMatch=x;class z{constructor($){this.path=$,this.results=[]}addMatch($){this.results.push($)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=z;function Q(L,$){const W=Object.assign(Object.assign({},L||{}),$||{});return Object.keys(W).filter(K=>{const U=W[K];return typeof U=="boolean"&&U})}e.resolvePatternsForProvider=Q;class j{constructor($,W){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},$.excludePattern||{}),W.excludePattern||{}),this._parsedExcludeExpression=S.parse(this._excludeExpression);let K=$.includePattern;W.includePattern&&(K?K=Object.assign(Object.assign({},K),W.includePattern):K=W.includePattern),K&&(this._parsedIncludeExpression=S.parse(K))}includedInQuerySync($,W,K){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression($,W,K)||this._parsedIncludeExpression&&!this._parsedIncludeExpression($,W,K))}includedInQuery($,W,K){return Promise.resolve(this._parsedExcludeExpression($,W,K)).then(ee=>!!ee).then(ee=>ee?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression($,W,K)).then(ie=>!!ie):Promise.resolve(!0)).then(ee=>ee)}hasSiblingExcludeClauses(){return Y(this._excludeExpression)}}e.QueryGlobTester=j;function Y(L){for(const $ in L)if(typeof L[$]!="boolean")return!0;return!1}}),define(we[31],Ee([0,1,15,13,20,3,22,16,78,24,8,12,2,134,4,19,148,47,48,27,14,7,42,5]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f,p,m,b,c,u,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(R,O,x){return new n.ExtUri(z=>D(z,x)).isEqual(R,O)}function l(R,O,x){return o(R.uri,O.uri,x)?0:(0,A.compare)(R.uri.toString(),O.uri.toString())}function i(R,O,x){return R.index!==O.index?R.index<O.index?-1:1:o(R.uri,O.uri,x)?(0,A.compare)(R.name,O.name):(0,A.compare)(R.uri.toString(),O.uri.toString())}function h(R,O,x,z){const Q=R.slice(0).sort((Y,L)=>x(Y,L,z)),j=O.slice(0).sort((Y,L)=>x(Y,L,z));return(0,_.delta)(Q,j,(Y,L)=>x(Y,L,z))}function D(R,O){const x=O.getCapabilities(R.scheme);return!(x&&x&1024)}class C extends m.Workspace{constructor(O,x,z,Q,j,Y){super(O,z.map(L=>new m.WorkspaceFolder(L)),Q,Y);this._name=x,this._isUntitled=j,this._workspaceFolders=[],this._structure=E.TernarySearchTree.forUris(Y),z.forEach(L=>{this._workspaceFolders.push(L),this._structure.set(L.uri,L)})}static toExtHostWorkspace(O,x,z,Q){if(!O)return{workspace:null,added:[],removed:[]};const{id:j,name:Y,folders:L,configuration:$,isUntitled:W}=O,K=[],U=x;x?L.forEach((Se,Ae)=>{const Be=v.URI.revive(Se.uri),Re=C._findFolder(z||x,Be,Q);Re?(Re.name=Se.name,Re.index=Se.index,K.push(Re)):K.push({uri:Be,name:Se.name,index:Ae})}):K.push(...L.map(({uri:Se,name:Ae,index:Be})=>({uri:v.URI.revive(Se),name:Ae,index:Be}))),K.sort((Se,Ae)=>Se.index<Ae.index?-1:1);const ee=new C(j,Y,K,$?v.URI.revive($):null,!!W,Se=>D(Se,Q)),{added:ie,removed:se}=h(U?U.workspaceFolders:[],ee.workspaceFolders,l,Q);return{workspace:ee,added:ie,removed:se}}static _findFolder(O,x,z){for(let Q=0;Q<O.folders.length;Q++){const j=O.workspaceFolders[Q];if(o(j.uri,x,z))return j}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,x){return x&&this._structure.get(O)&&(O=(0,n.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let g=class{constructor(O,x,z,Q){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new P.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=a.WorkspaceTrustState.Unknown,this._logService=Q,this._extHostFileSystemInfo=z,this._requestIdProvider=new w.Counter,this._barrier=new S.Barrier,this._proxy=O.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(r.MainContext.MainThreadMessageService);const j=x.workspace;this._confirmedWorkspace=j?new C(j.id,j.name,[],j.configuration?v.URI.revive(j.configuration):null,!!j.isUntitled,Y=>D(Y,z)):void 0}$initializeWorkspace(O,x){this._workspaceTrustState=x,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?v.URI.from({scheme:k.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,x,z,...Q){const j=[];if(Array.isArray(Q)&&Q.forEach(K=>{v.URI.isUri(K.uri)&&!j.some(U=>o(U.uri,K.uri,this._extHostFileSystemInfo))&&j.push({uri:K.uri,name:K.name||(0,n.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[x,z].some(K=>typeof K!="number"||K<0)||z===0&&j.length===0)return!1;const Y=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+z>Y.length)return!1;const L=Y.slice(0);L.splice(x,z,...j.map(K=>({uri:K.uri,name:K.name||(0,n.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<L.length;K++){const U=L[K];if(L.some((ee,ie)=>ie!==K&&o(U.uri,ee.uri,this._extHostFileSystemInfo)))return!1}L.forEach((K,U)=>K.index=U);const{added:$,removed:W}=h(Y,L,i,this._extHostFileSystemInfo);if($.length===0&&W.length===0)return!1;if(this._proxy){const K=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(K,x,z,j).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,d.localize)(0,null,K,U.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(L),!0}getWorkspaceFolder(O,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,x)}async getWorkspaceFolder2(O,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,x)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!!this._actualWorkspace){const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}}getRelativePath(O,x){let z,Q="";if(typeof O=="string"?(z=v.URI.file(O),Q=O):typeof O!="undefined"&&(z=O,Q=O.fsPath),!z)return Q;const j=this.getWorkspaceFolder(z,!0);if(!j)return Q;typeof x=="undefined"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let Y=(0,n.relativePath)(j.uri,z);return x&&j.name&&(Y=`${j.name}/${Y}`),Y}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=C.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:x,added:z,removed:Q}=C.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:z,removed:Q}))}findFiles(O,x,z,Q,j=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Q.value}, entryPoint: findFiles`);let Y;if(x===null?Y=!1:x&&(typeof x=="string"?Y=x:Y=x.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:L,folder:$}=y(O);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(L),(0,I.withUndefinedAsNull)($),(0,I.withUndefinedAsNull)(Y),(0,I.withUndefinedAsNull)(z),j).then(W=>Array.isArray(W)?W.map(K=>v.URI.revive(K)):[])}async findTextInFiles(O,x,z,Q,j=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Q.value}, entryPoint: findTextInFiles`);const Y=this._requestIdProvider.getNext(),L=typeof x.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:$,folder:W}=y(x.include),K=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,U={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:L,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:$,excludePattern:K},ee=!1;if(this._activeSearchCallbacks[Y]=ie=>{if(!ee){const se=v.URI.revive(ie.resource);ie.results.forEach(Se=>{(0,t.resultIsMatch)(Se)?z({uri:se,preview:{text:Se.preview.text,matches:(0,_.mapArrayOrNot)(Se.preview.matches,Ae=>new a.Range(Ae.startLineNumber,Ae.startColumn,Ae.endLineNumber,Ae.endColumn))},ranges:(0,_.mapArrayOrNot)(Se.ranges,Ae=>new a.Range(Ae.startLineNumber,Ae.startColumn,Ae.endLineNumber,Ae.endColumn))}):z({uri:se,text:Se.text,lineNumber:Se.lineNumber})})}},j.isCancellationRequested)return{};try{const ie=await this._proxy.$startTextSearch(O,(0,I.withUndefinedAsNull)(W),U,Y,j);return delete this._activeSearchCallbacks[Y],ie||{}}catch(ie){throw delete this._activeSearchCallbacks[Y],ie}}$handleTextSearchResult(O,x){this._activeSearchCallbacks[x]&&this._activeSearchCallbacks[x](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trustState(){return this._workspaceTrustState}requireWorkspaceTrust(O){return this._proxy.$requireWorkspaceTrust(O)}$onDidChangeWorkspaceTrustState(O){this._workspaceTrustState=O.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze(O))}};g=je([qe(0,u.IExtHostRpcService),qe(1,c.IExtHostInitDataService),qe(2,b.IExtHostFileSystemInfo),qe(3,f.ILogService)],g),e.ExtHostWorkspace=g,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function y(R){let O,x;return R&&(typeof R=="string"?O=R:(O=R.pattern,x=R.baseFolder||v.URI.file(R.base))),{includePattern:O,folder:x}}}),define(we[34],Ee([0,1,23,3,31,5,7,150,66,12,13,4,14,19,2]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(r,o){if(o){const l=o.split(".");let i=r;for(let h=0;i&&h<l.length;h++)i=i[l[h]];return i}}function p(r){return r instanceof s.URI}function m(r){return r&&r.uri instanceof s.URI&&r.languageId&&typeof r.languageId=="string"}function b(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function c(r){return r&&r.uri instanceof s.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function u(r){if(p(r))return{resource:r};if(m(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(b(r))return{overrideIdentifier:r.languageId};if(c(r))return{resource:r.uri};if(r===null)return{resource:null}}let a=class{constructor(o,l,i){this._proxy=o.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=l,this._logService=i,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,l){this.getConfigProvider().then(i=>i.$acceptConfigurationChanged(o,l))}};a=je([qe(0,v.IExtHostRpcService),qe(1,T.IExtHostWorkspace),qe(2,d.ILogService)],a),e.ExtHostConfiguration=a;class t{constructor(o,l,i,h){this._onDidChangeConfiguration=new S.Emitter,this._proxy=o,this._logService=h,this._extHostWorkspace=l,this._configuration=k.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,l){const i={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(l,i))}getConfiguration(o,l,i){const h=u(l)||{},D=this._toReadonlyValue(o?f(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,h,i==null?void 0:i.identifier);function C(y){if(y==null)return null;if(typeof y=="boolean")return y?1:4;switch(y){case E.ConfigurationTarget.Global:return 1;case E.ConfigurationTarget.Workspace:return 4;case E.ConfigurationTarget.WorkspaceFolder:return 5}}const g={has(y){return typeof f(D,y)!="undefined"},get:(y,R)=>{this._validateConfigurationAccess(o?`${o}.${y}`:y,h,i==null?void 0:i.identifier);let O=f(D,y);if(typeof O=="undefined")O=R;else{let x;const z=(Q,j)=>{let Y;const L=()=>{x=x||(0,_.deepClone)(D),Y=Y||f(x,j)};return(0,n.isObject)(Q)?new Proxy(Q,{get:($,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return L(),()=>Y;if(x)return Y=Y||f(x,j),Y[W];const K=$[W];return typeof W=="string"?z(K,`${j}.${W}`):K},set:($,W,K)=>(L(),Y&&(Y[W]=K),!0),deleteProperty:($,W)=>(L(),Y&&delete Y[W],!0),defineProperty:($,W,K)=>(L(),Y&&Object.defineProperty(Y,W,K),!0)}):Q};O=z(O,y)}return O},update:(y,R,O,x)=>{y=o?`${o}.${y}`:y;const z=C(O);return R!==void 0?this._proxy.$updateConfigurationOption(z,y,R,h,x):this._proxy.$removeConfigurationOption(z,y,h,x)},inspect:y=>{var R,O,x,z,Q,j,Y,L;y=o?`${o}.${y}`:y;const $=(0,_.deepClone)(this._configuration.inspect(y,h,this._extHostWorkspace.workspace));if($)return{key:y,defaultValue:(R=$.default)===null||R===void 0?void 0:R.value,globalValue:(O=$.user)===null||O===void 0?void 0:O.value,workspaceValue:(x=$.workspace)===null||x===void 0?void 0:x.value,workspaceFolderValue:(z=$.workspaceFolder)===null||z===void 0?void 0:z.value,defaultLanguageValue:(Q=$.default)===null||Q===void 0?void 0:Q.override,globalLanguageValue:(j=$.user)===null||j===void 0?void 0:j.override,workspaceLanguageValue:(Y=$.workspace)===null||Y===void 0?void 0:Y.override,workspaceFolderLanguageValue:(L=$.workspaceFolder)===null||L===void 0?void 0:L.override,languageIds:$.overrideIdentifiers}}};return typeof D=="object"&&(0,_.mixin)(g,D,!1),Object.freeze(g)}_toReadonlyValue(o){const l=i=>(0,n.isObject)(i)?new Proxy(i,{get:(h,D)=>l(h[D]),set:(h,D,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(h,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(h,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):i;return l(o)}_validateConfigurationAccess(o,l,i){const h=w.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),D=i?`[${i.value}] `:"";if(h===4){typeof(l==null?void 0:l.resource)=="undefined"&&this._logService.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){(l==null?void 0:l.resource)&&this._logService.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,l){const i=new k.ConfigurationChangeEvent(o,l,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,D)=>i.affectsConfiguration(h,u(D))})}_toMap(o){return o.reduce((l,i)=>(l.set(i[0],i[1]),l),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(ae,e,_){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,_),_},We=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(we[100],Ee([0,1,2,13,3,5,7,31,40,34,20,41,14,27,4,16,21,19,72,166,10]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f,p,m,b,c,u){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(Q){function j(L){if(L!=null)return L}Q.from=j;function Y(L){if(L!=null)return L}Q.to=Y})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(Q){function j(L){if(L!=null)return L}Q.from=j;function Y(L){if(L!=null)return L}Q.to=Y})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(Q){function j(L){if(L!=null)return L}Q.from=j;function Y(L){if(L!=null)return L}Q.to=Y})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var l;(function(Q){function j($){if($){const W=$;return W&&!!W.process}else return!1}Q.is=j;function Y($){if($!=null){const W={process:$.process,args:$.args};return $.options&&(W.options=o.from($.options)),W}}Q.from=Y;function L($){if($!=null)return new E.ProcessExecution($.process,$.args,$.options)}Q.to=L})(l=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var i;(function(Q){function j(L){if(L!=null)return L}Q.from=j;function Y(L){if(L!=null)return L}Q.to=Y})(i=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(Q){function j($){if($){const W=$;return W&&(!!W.commandLine||!!W.command)}else return!1}Q.is=j;function Y($){if($!=null){const W={};return $.commandLine!==void 0?W.commandLine=$.commandLine:(W.command=$.command,W.args=$.args),$.options&&(W.options=i.from($.options)),W}}Q.from=Y;function L($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new E.ShellExecution($.commandLine,$.options):new E.ShellExecution($.command,$.args?$.args:[],$.options)}Q.to=L})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var D;(function(Q){function j($){if($){let W=$;return W&&W.customExecution==="customExecution"}else return!1}Q.is=j;function Y($){return{customExecution:"customExecution"}}Q.from=Y;function L($,W){return W.get($)}Q.to=L})(D=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var C;(function(Q){function j(Y,L){let $;return Y.scope!==void 0&&typeof Y.scope!="number"?$=Y.scope.uri:Y.scope!==void 0&&typeof Y.scope=="number"&&(Y.scope===E.TaskScope.Workspace&&L&&L.workspaceFile?$=L.workspaceFile:$=c.USER_TASKS_GROUP_KEY),{id:Y._id,workspaceFolder:$}}Q.from=j})(C=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(Q){function j($,W){if($==null)return[];const K=[];for(let U of $){const ee=Y(U,W);ee&&K.push(ee)}return K}Q.fromMany=j;function Y($,W){if($!=null){let K;$.execution instanceof E.ProcessExecution?K=l.from($.execution):$.execution instanceof E.ShellExecution?K=h.from($.execution):$.execution&&$.execution instanceof E.CustomExecution&&(K=D.from($.execution));const U=t.from($.definition);let ee;if($.scope?typeof $.scope=="number"?ee=$.scope:ee=$.scope.uri:ee=E.TaskScope.Workspace,!(!U||!ee)){const ie=$.group?$.group.id:void 0;return{_id:$._id,definition:U,name:$.name,source:{extensionId:W.identifier.value,label:$.source,scope:ee},execution:K,isBackground:$.isBackground,group:ie,presentationOptions:r.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}}}Q.from=Y;async function L($,W,K){if($!=null){let U;l.is($.execution)?U=l.to($.execution):h.is($.execution)?U=h.to($.execution):D.is($.execution)&&(U=D.to($._id,K));const ee=t.to($.definition);let ie;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?ie=$.source.scope:ie=await W.resolveWorkspaceFolder(_.URI.revive($.source.scope)):ie=E.TaskScope.Workspace),!(!ee||!ie)){const se=new E.Task(ee,ie,$.name,$.source.label,U,$.problemMatchers);return $.isBackground!==void 0&&(se.isBackground=$.isBackground),$.group!==void 0&&(se.group=E.TaskGroup.from($.group)),$.presentationOptions&&(se.presentationOptions=r.to($.presentationOptions)),$._id&&(se._id=$._id),$.detail&&(se.detail=$.detail),se}}}Q.to=L})(g=e.TaskDTO||(e.TaskDTO={}));var y;(function(Q){function j(L){return L}Q.from=j;function Y(L){if(!!L)return Object.assign(Object.create(null),L)}Q.to=Y})(y=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(j,Y,L){this._id=Y,this._task=L,a.set(this,void 0),tt(this,a,j)}get task(){return this._task}terminate(){We(this,a).terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}a=new WeakMap;var O;(function(Q){function j(Y){return{id:Y._id,task:void 0}}Q.from=j})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let x=class{constructor(j,Y,L,$,W,K,U,ee){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=j.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=L,this._editorService=$,this._configurationService=W,this._terminalService=K,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=U,this._deprecationService=ee,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(j,Y,L){if(!L)return new E.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:Y,provider:L,extension:j}),this._proxy.$registerTaskProvider($,Y),new E.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(j,Y){this._proxy.$registerTaskSystem(j,Y)}fetchTasks(j){return this._proxy.$fetchTasks(y.from(j)).then(async Y=>{const L=[];for(let $ of Y){const W=await g.to($,this._workspaceProvider,this._providedCustomExecutions2);W&&L.push(W)}return L})}get taskExecutions(){const j=[];return this._taskExecutions.forEach(Y=>j.push(Y)),j}terminateTask(j){if(!(j instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(j._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(j,Y,L){const $=this._providedCustomExecutions2.get(j.id);if($){if(this._activeCustomExecutions2.get(j.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(j.id,$),this._terminalService.attachPtyToTerminal(Y,await $.callback(L))}this._lastStartedTask=j.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(j)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(j){const Y=await this.getTaskExecution(j);this._taskExecutionPromises.delete(j.id),this._taskExecutions.delete(j.id),this.customExecutionComplete(j),this._onDidTerminateTask.fire({execution:Y})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(j){const Y=await this.getTaskExecution(j.id);this._onDidTaskProcessStarted.fire({execution:Y,processId:j.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(j){const Y=await this.getTaskExecution(j.id);this._onDidTaskProcessEnded.fire({execution:Y,exitCode:j.exitCode})}$provideTasks(j,Y){const L=this._handlers.get(j);if(!L)return Promise.reject(new Error("no handler found"));const $=[],W=(0,S.asPromise)(()=>L.provider.provideTasks(A.CancellationToken.None)).then(K=>this.provideTasksInternal(Y,$,L,K));return new Promise(K=>{W.then(U=>{Promise.all($).then(()=>{K(U)})})})}async $resolveTask(j,Y){const L=this._handlers.get(j);if(!L)return Promise.reject(new Error("no handler found"));if(Y.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${Y.definition.type}] cannot be resolved by provider of type [${L.type}].`);const $=await g.to(Y,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const W=await L.provider.resolveTask($,A.CancellationToken.None);if(!!W){this.checkDeprecation(W,L);const K=g.from(W,L.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(K.execution)&&await this.addCustomExecution(K,W,!0),await this.resolveTaskInternal(K)}}nextHandle(){return this._handleCounter++}async addCustomExecution(j,Y,L){const $=await this._proxy.$createTaskId(j);!L&&!this._providedCustomExecutions2.has($)&&this._notProvidedCustomExecutions.add($),this._providedCustomExecutions2.set($,Y.execution)}async getTaskExecution(j,Y){if(typeof j=="string"){const W=this._taskExecutionPromises.get(j);if(!W)throw new Error("Unexpected: The specified task is missing an execution");return W}let L=this._taskExecutionPromises.get(j.id);if(L)return L;const $=new Promise(async(W,K)=>{const U=Y||await g.to(j.task,this._workspaceProvider,this._providedCustomExecutions2);U?W(new R(this,j.id,U)):K("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(j.id,$),$.then(W=>(this._taskExecutions.set(j.id,W),W),W=>Promise.reject(W))}checkDeprecation(j,Y){j._deprecated&&this._deprecationService.report("Task.constructor",Y.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(j){this._activeCustomExecutions2.get(j.id)&&this._activeCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.has(j.id)&&this._lastStartedTask!==j.id&&(this._providedCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.delete(j.id));let L=this._notProvidedCustomExecutions.values(),$=L.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=L.next()}};x=je([qe(0,v.IExtHostRpcService),qe(1,d.IExtHostInitDataService),qe(2,k.IExtHostWorkspace),qe(3,w.IExtHostDocumentsAndEditors),qe(4,n.IExtHostConfiguration),qe(5,I.IExtHostTerminalService),qe(6,m.ILogService),qe(7,b.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let z=class extends x{constructor(j,Y,L,$,W,K,U,ee){super(j,Y,L,$,W,K,U,ee);this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(j,Y){if(!Y.execution)throw new Error("Tasks to execute must include an execution");const L=g.from(Y,j);if(L===void 0)throw new Error("Task is not valid");if(D.is(L.execution))await this.addCustomExecution(L,Y,!1);else throw new u.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(L),Y);return this._proxy.$executeTask(L).catch(W=>{throw new Error(W)}),$}provideTasksInternal(j,Y,L,$){const W=[];if($)for(let K of $){this.checkDeprecation(K,L),(!K.definition||!j[K.definition.type])&&this._logService.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const U=g.from(K,L.extension);U&&D.is(U.execution)?(W.push(U),Y.push(this.addCustomExecution(U,K,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:W,extension:L.extension}}async resolveTaskInternal(j){if(D.is(j.execution))return j;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(j,Y){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(j,Y,L){}};z=je([qe(0,v.IExtHostRpcService),qe(1,d.IExtHostInitDataService),qe(2,k.IExtHostWorkspace),qe(3,w.IExtHostDocumentsAndEditors),qe(4,n.IExtHostConfiguration),qe(5,I.IExtHostTerminalService),qe(6,m.ILogService),qe(7,b.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(ae,e,_){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,_),_},We=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)},an=this&&this.__rest||function(ae,e){var _={};for(var S in ae)Object.prototype.hasOwnProperty.call(ae,S)&&e.indexOf(S)<0&&(_[S]=ae[S]);if(ae!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,S=Object.getOwnPropertySymbols(ae);T<S.length;T++)e.indexOf(S[T])<0&&Object.prototype.propertyIsEnumerable.call(ae,S[T])&&(_[S[T]]=ae[S[T]]);return _};define(we[213],Ee([0,1,15,13,20,3,51,6,23,12,2,29,5,40,14,9,7,31,178,168]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f,p,m,b,c){"use strict";var u,a;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.ExtHostTesting=void 0;const t=(y,R)=>`${y}:${R.toString()}`;let r=class{constructor(R,O,x){this.documents=O,this.workspace=x,this.resultsChangedEmitter=new P.Emitter,this.providers=new Map,this.ownedTests=new b.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(v.MainContext.MainThreadTesting),this.workspaceObservers=new C(this.proxy),this.textDocumentObservers=new g(this.proxy,O)}registerTestProvider(R){const O=(0,I.generateUuid)();this.providers.set(O,R),this.proxy.$registerTestProvider(O);const x=[...this.testSubscriptions.keys()];return setTimeout(()=>{var z;for(const Q of x)(z=this.testSubscriptions.get(Q))===null||z===void 0||z.subscribeFn(O,R)},0),new p.Disposable(()=>{this.providers.delete(O),this.proxy.$unregisterTestProvider(O)})}createTextDocumentTestObserver(R){return this.textDocumentObservers.checkout(R.uri)}createWorkspaceTestObserver(R){return this.workspaceObservers.checkout(R.uri)}async runTests(R,O=T.CancellationToken.None){const x=z=>z.map(this.getInternalTestForReference,this).filter(n.isDefined).map(Q=>({providerId:Q.providerId,testId:Q.item.extId}));await this.proxy.$runTests({exclude:R.exclude?x(R.exclude).map(z=>z.testId):void 0,tests:x(R.tests),debug:R.debug},O)}publishExtensionProvidedResults(R,O){this.proxy.$publishExtensionProvidedResults(f.TestResults.from((0,I.generateUuid)(),R),O)}$publishTestResults(R){this.results=Object.freeze(R.map(O=>(0,w.deepFreeze)(f.TestResults.to(O))).concat(this.results).sort((O,x)=>x.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(R,O){const x=A.URI.revive(O),z=t(R,x);if(!this.testSubscriptions.has(z)){const Q=new T.CancellationTokenSource;let j;if(R===1){let W=this.documents.getDocument(x);if(!W){const K=new k.DisposableStore;W=await new Promise(U=>{K.add((0,S.disposableTimeout)(()=>U(void 0),5e3)),K.add(this.documents.onDidAddDocuments(ee=>{const ie=ee.find(se=>se.document.uri.toString()===x.toString());ie&&U(ie)}))}).finally(()=>K.dispose())}if(W){const K=await this.workspace.getWorkspaceFolder2(x,!1);j=U=>U.provideDocumentTestHierarchy?U.provideDocumentTestHierarchy(W.document,Q.token):this.createDefaultDocumentTestHierarchy(U,W.document,K,Q.token)}}else{const W=await this.workspace.getWorkspaceFolder2(x,!1);W&&(j=K=>K.provideWorkspaceTestHierarchy(W,Q.token))}if(!!j){const Y=async(W,K)=>{var U;try{$.pushDiff([3,1]);const ee=await j(K);if(!ee){$.pushDiff([3,-1]);return}$.addRoot(ee.root,W),Promise.resolve(ee.discoveredInitialTests).then(()=>$.pushDiff([3,-1])),ee.onDidChangeTest(ie=>$.onItemChange(ie,W)),(U=ee.onDidInvalidateTest)===null||U===void 0||U.call(ee,ie=>{const se=$.getTestByReference(ie);se?this.proxy.$retireTest(se.item.extId):console.warn("Received a TestProvider.onDidInvalidateTest for a test that does not currently exist.")})}catch(ee){console.error(ee)}},L=new k.DisposableStore,$=L.add(this.ownedTests.createForHierarchy(W=>this.proxy.$publishDiff(R,O,W)));L.add((0,k.toDisposable)(()=>Q.dispose(!0)));for(const[W,K]of this.providers)Y(W,K);$.pushDiff([4,-1]),this.testSubscriptions.set(z,{store:L,collection:$,subscribeFn:Y})}}}$unsubscribeFromTests(R,O){var x;const z=A.URI.revive(O),Q=t(R,z);(x=this.testSubscriptions.get(Q))===null||x===void 0||x.store.dispose(),this.testSubscriptions.delete(Q)}$acceptDiff(R,O,x){R===1?this.textDocumentObservers.acceptDiff(A.URI.revive(O),x):this.workspaceObservers.acceptDiff(A.URI.revive(O),x)}async $runTestsForProvider(R,O){const x=this.providers.get(R.providerId);if(!!x){const z=R.ids.map(j=>{var Y;return(Y=this.ownedTests.getTestById(j))===null||Y===void 0?void 0:Y[1]}).filter(n.isDefined),Q=R.excludeExtIds.map(j=>this.ownedTests.getTestById(j)).filter(n.isDefined).filter(([j,Y])=>z.some(L=>j.comparePositions(L,Y)===1));if(!!z.length)try{await x.runTests({setState:(j,Y)=>{for(const[L,$]of Q){const W=L.comparePositions($,j.id);if(W===1||W===3)return}this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(R.runId,j.id,f.TestState.from(Y))},tests:z.map(j=>o.unwrap(j.actual)),exclude:Q.map(([,j])=>o.unwrap(j.actual)),debug:R.debug},O);for(const{collection:j}of this.testSubscriptions.values())j.flushDiff();return}catch(j){throw console.error(j),j}}}$lookupTest(R){const O=this.ownedTests.getTestById(R.testId);if(!O)return Promise.resolve(void 0);const x=O[1],{actual:z,previousChildren:Q,previousEquals:j}=x,Y=an(x,["actual","previousChildren","previousEquals"]);return Promise.resolve(Y)}flushCollectionDiffs(){for(const{collection:R}of this.testSubscriptions.values())R.flushDiff()}getInternalTestForReference(R){var O,x;return(x=(O=this.workspaceObservers.getMirroredTestDataByReference(R))!==null&&O!==void 0?O:(0,_.mapFind)(this.testSubscriptions.values(),z=>z.collection.getTestByReference(R)))!==null&&x!==void 0?x:this.textDocumentObservers.getMirroredTestDataByReference(R)}async createDefaultDocumentTestHierarchy(R,O,x,z){var Q;if(!!x){const j=await R.provideWorkspaceTestHierarchy(x,z);if(!!j){const Y=new P.Emitter;(Q=j.onDidInvalidateTest)===null||Q===void 0||Q.call(j,$=>{const W=o.getWrapperForTestItem($,O);W.hasNodeMatchingFilter&&Y.fire(W)});const L=new P.Emitter;return j.onDidChangeTest($=>{const W=o.getWrapperForTestItem($,O);if(W.hasNodeMatchingFilter){if(W.reset(),W.hasNodeMatchingFilter){L.fire(W);return}L.fire(W.visibleParent);return}const U=W.visibleParent;W.reset(),!!W.hasNodeMatchingFilter&&(U.reset(),L.fire(U))}),z.onCancellationRequested(()=>{o.removeFilter(O),L.dispose()}),{root:o.getWrapperForTestItem(j.root,O),discoveredInitialTests:j.discoveredInitialTests,onDidInvalidateTest:Y.event,onDidChangeTest:L.event}}}}};r=je([qe(0,s.IExtHostRpcService),qe(1,d.IExtHostDocumentsAndEditors),qe(2,m.IExtHostWorkspace)],r),e.ExtHostTesting=r;class o{constructor(R,O,x){this.actual=R,this.filterDocument=O,this.parent=x,this.getWrappedChildren()}static removeFilter(R){this.wrapperMap.delete(R)}static getWrapperForTestItem(R,O,x){let z=this.wrapperMap.get(O);if(z==null?void 0:z.has(R))return z.get(R);z||(z=new WeakMap,this.wrapperMap.set(O,z));const Q=new o(R,O,x);return z.set(R,Q),Q}static unwrap(R){return R instanceof o?R.actual:R}get id(){return this.actual.id}get label(){return this.actual.label}get debuggable(){return this.actual.debuggable}get description(){return this.actual.description}get location(){return this.actual.location}get runnable(){return this.actual.runnable}get children(){return this.getWrappedChildren().filter(R=>R.hasNodeMatchingFilter)}get visibleParent(){return this.hasNodeMatchingFilter?this:this.parent.visibleParent}get hasNodeMatchingFilter(){var R;return this.matchesFilter===void 0&&(this.matchesFilter=!this.parent||((R=this.actual.location)===null||R===void 0?void 0:R.uri.toString())===this.filterDocument.uri.toString()||this.getWrappedChildren().some(O=>O.hasNodeMatchingFilter)),this.matchesFilter}reset(){var R;this!==this.visibleParent&&((R=this.parent)===null||R===void 0||R.reset()),this.matchesFilter=void 0}getWrappedChildren(){var R;return((R=this.actual.children)===null||R===void 0?void 0:R.map(O=>o.getWrapperForTestItem(O,this.filterDocument,this)))||[]}}e.TestItemFilteredWrapper=o,o.wrapperMap=new WeakMap;class l extends c.IncrementalChangeCollector{constructor(R,O){super();this.collection=R,this.emitter=O,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,f.TestItem.toPlainShallow(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{collection:R,added:O,updated:x,removed:z}=this;return{get added(){return[...O].map(R.getPublicTestItem,R)},get updated(){return[...x].map(R.getPublicTestItem,R)},get removed(){return[...z].map(R.getPublicTestItem,R)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class i extends c.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(R){let O=[];for(const x of R){const z=this.items.get(x);z&&O.push(this.getPublicTestItem(z))}return O}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,O){return Object.assign(Object.assign({},R),{revived:f.TestItem.toPlainShallow(R.item),depth:O?O.depth+1:0,children:new Set})}createChangeCollector(){return new l(this,this.changeEmitter)}getPublicTestItem(R){return R.wrapped||(R.wrapped=new h(R,this)),R.wrapped}}e.MirroredTestCollection=i;class h{constructor(R,O){u.set(this,void 0),a.set(this,void 0),tt(this,u,R),tt(this,a,O)}get id(){return We(this,u).revived.id}get label(){return We(this,u).revived.label}get description(){return We(this,u).revived.description}get location(){return We(this,u).revived.location}get runnable(){var R;return(R=We(this,u).revived.runnable)!==null&&R!==void 0?R:!0}get debuggable(){var R;return(R=We(this,u).revived.debuggable)!==null&&R!==void 0?R:!1}get children(){return We(this,a).getAllAsTestItem(We(this,u).children)}toJSON(){return{id:this.id,label:this.label,description:this.description,location:this.location,runnable:this.runnable,debuggable:this.debuggable,children:this.children.map(O=>O.toJSON()),providerId:We(this,u).providerId,testId:this.id}}}u=new WeakMap,a=new WeakMap;class D{constructor(){this.resources=new Map}checkout(R){var O,x;const z=R.toString(),Q=(O=this.resources.get(z))!==null&&O!==void 0?O:this.createObserverData(R);return(x=Q.pendingDeletion)===null||x===void 0||x.dispose(),Q.observers++,{onDidChangeTest:Q.tests.onDidChangeTests,onDidDiscoverInitialTests:new P.Emitter().event,get tests(){return Q.tests.rootTestItems},dispose:(0,E.once)(()=>{--Q.observers||(Q.pendingDeletion=this.eventuallyDispose(R))})}}getMirroredTestDataByReference(R){for(const{tests:O}of this.resources.values()){const x=O.getMirroredTestDataByReference(R);if(x)return x}}eventuallyDispose(R){return(0,S.disposableTimeout)(()=>this.unlisten(R),10*1e3)}createObserverData(R){const O=new i,x=this.listen(R,Q=>O.apply(Q)),z={observers:0,tests:O,listener:x};return this.resources.set(R.toString(),z),z}unlisten(R){var O;const x=R.toString(),z=this.resources.get(x);z&&(z.observers=-1,(O=z.pendingDeletion)===null||O===void 0||O.dispose(),z.listener.dispose(),this.resources.delete(x))}}class C extends D{constructor(R){super();this.proxy=R,this.diffListeners=new Map}acceptDiff(R,O){var x;(x=this.diffListeners.get(R.toString()))===null||x===void 0||x(O)}listen(R,O){this.proxy.$subscribeToDiffs(0,R);const x=R.toString();return this.diffListeners.set(x,O),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,R),this.diffListeners.delete(x)})}}class g extends D{constructor(R,O){super();this.proxy=R,this.documents=O,this.diffListeners=new Map}acceptDiff(R,O){var x;(x=this.diffListeners.get(R.toString()))===null||x===void 0||x(O)}listen(R,O){if(!this.documents.getDocument(R))return new p.Disposable(()=>{});const z=R.toString();return this.diffListeners.set(z,O),this.proxy.$subscribeToDiffs(1,R),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,R),this.diffListeners.delete(z)})}}}),define(we[214],Ee([0,1,15,50,28,58,22,16,11,24,8,12,2,113,137,89,47,170,212,42]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f,p,m,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(C,g,y,R){this.configurationService=C,this.workspaceContextService=g,this.editorGroupsService=y,this.pathService=R}text(C,g,y={}){C=this.getContentPattern(C,y);const R=this.configurationService.getValue(),O=g&&g.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep),x=this.commonQuery(g==null?void 0:g.map(p.toWorkspaceFolder),y);return Object.assign(Object.assign({},x),{type:2,contentPattern:C,previewOptions:y.previewOptions,maxFileSize:y.maxFileSize,usePCRE2:R.search.usePCRE2||O||!1,beforeContext:y.beforeContext,afterContext:y.afterContext,userDisabledExcludesAndIgnoreFiles:y.disregardExcludeSettings&&y.disregardIgnoreFiles})}getContentPattern(C,g){const y=this.configurationService.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},C),{wordSeparators:y.editor.wordSeparators});return this.isCaseSensitive(C,g)&&(R.isCaseSensitive=!0),this.isMultiline(C)&&(R.isMultiline=!0),R}file(C,g={}){const y=this.commonQuery(C,g);return Object.assign(Object.assign({},y),{type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey})}handleIncludeExclude(C,g){return C?(C=Array.isArray(C)?C.map(l):l(C),g?this.parseSearchPaths(C):{pattern:t(...Array.isArray(C)?C:[C])}):{}}commonQuery(C=[],g={}){const y=this.handleIncludeExclude(g.includePattern,g.expandPatterns),R=this.handleIncludeExclude(g.excludePattern,g.expandPatterns),O=C.length>1,x=(y.searchPaths&&y.searchPaths.length?y.searchPaths.map(j=>this.getFolderQueryForSearchPath(j,g,R)):C.map(j=>this.getFolderQueryForRoot(j,g,R,O))).filter(j=>!!j),z={_reason:g._reason,folderQueries:x,usingSearchPaths:!!(y.searchPaths&&y.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:R.pattern,includePattern:y.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const Y=_.coalesce(_.flatten(this.editorGroupsService.groups.map($=>$.editors.map(W=>W.resource)))).filter($=>(0,c.pathIncludedInQuery)(z,$.fsPath)),L=this.commonQueryFromFileList(Y);return Object.assign(Object.assign({},z),L)}const Q=g.extraFileResources&&g.extraFileResources.filter(j=>(0,c.pathIncludedInQuery)(z,j.fsPath));return z.extraFileResources=Q&&Q.length?Q:void 0,z}commonQueryFromFileList(C){const g=[],y=new E.ResourceMap,R={};let O=!1;return C.forEach(x=>{var z,Q;if(x.scheme!==k.Schemas.walkThrough)if((0,n.isAbsolutePath)(x)){const Y=(Q=(z=this.workspaceContextService.getWorkspaceFolder(x))===null||z===void 0?void 0:z.uri)!==null&&Q!==void 0?Q:x.with({path:w.dirname(x.fsPath)});let L=y.get(Y);L||(O=!0,L={folder:Y,includePattern:{}},g.push(L),y.set(Y,L));const $=w.relative(Y.fsPath,x.fsPath);(0,I.assertIsDefined)(L.includePattern)[$.replace(/\\/g,"/")]=!0}else x.fsPath&&(O=!0,R[x.fsPath]=!0)}),{folderQueries:g,includePattern:R,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(C,g){if(g.isSmartCase){if(C.isRegExp){if(A.containsUppercaseCharacter(C.pattern,!0))return!0}else if(A.containsUppercaseCharacter(C.pattern))return!0}return!!C.isCaseSensitive}isMultiline(C){return C.isMultiline||C.isRegExp&&(0,d.isMultilineRegexSource)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const g=L=>w.isAbsolute(L)||/^\.\.?([\/\\]|$)/.test(L),R=(Array.isArray(C)?C:r(C)).map(L=>{const $=this.pathService.resolvedUserHome;return $?(0,P.untildify)(L,$.scheme===k.Schemas.file?$.fsPath:$.path):L}),O=S.groupBy(R,L=>g(L)?"searchPaths":"exprSegments"),x=(O.exprSegments||[]).map(L=>A.rtrim(L,"/")).map(L=>A.rtrim(L,"\\")).map(L=>(L[0]==="."&&(L="*"+L),o(L))),z={},Q=this.expandSearchPathPatterns(O.searchPaths||[]);Q&&Q.length&&(z.searchPaths=Q);const j=_.flatten(x),Y=t(...j);return Y&&(z.pattern=Y),z}getExcludesForFolder(C,g){return g.disregardExcludeSettings?void 0:(0,c.getExcludes)(C,!g.disregardSearchExcludeSettings)}expandSearchPathPatterns(C){if(!C||!C.length)return[];const g=_.flatten(C.map(R=>{let{pathPortion:O,globPortion:x}=a(R);x&&(x=i(x));const z=this.expandOneSearchPath(O);return _.flatten(z.map(Q=>this.resolveOneSearchPathPattern(Q,x)))})),y=new Map;return g.forEach(R=>{const O=R.searchPath.toString(),x=y.get(O);x?R.pattern&&(x.pattern=x.pattern||{},x.pattern[R.pattern]=!0):y.set(O,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(y.values())}expandOneSearchPath(C){if(w.isAbsolute(C)){const g=this.workspaceContextService.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==k.Schemas.file?[{searchPath:g[0].uri.with({path:C})}]:[{searchPath:v.URI.file(w.normalize(C))}]}if(this.workspaceContextService.getWorkbenchState()===2){const g=this.workspaceContextService.getWorkspace().folders[0].uri;if(C=l(C),C.startsWith("../")||C===".."){const R=w.posix.resolve(g.path,C);return[{searchPath:g.with({path:R})}]}const y=i(C);return[{searchPath:g,pattern:y}]}else{if(C==="./"||C===".\\")return[];{const g=C.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(g){const y=g[1],R=this.workspaceContextService.getWorkspace().folders.filter(O=>O.name===y);if(R.length)return R.map(O=>{const x=g[2];return{searchPath:O.uri,pattern:x&&i(x)}});{const O=s.localize(0,null,y);throw new Error(O)}}}}return[]}resolveOneSearchPathPattern(C,g){const y=C.pattern&&g?`${C.pattern}/${g}`:C.pattern||g,R=[{searchPath:C.searchPath,pattern:y}];return y&&!y.endsWith("**")&&R.push({searchPath:C.searchPath,pattern:y+"/**"}),R}getFolderQueryForSearchPath(C,g,y){const R=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(C.searchPath),g,y,!1);return R?Object.assign(Object.assign({},R),{includePattern:C.pattern}):null}getFolderQueryForRoot(C,g,y,R){let O;const x=v.URI.isUri(C)?C:C.uri;if(y.searchPaths){const L=y.searchPaths.filter($=>(0,n.isEqual)($.searchPath,x))[0];if(L&&!L.pattern)return null;L&&(O=L.pattern)}const z=this.configurationService.getValue({resource:x}),Q=this.getExcludesForFolder(z,g),j=Object.assign(Object.assign({},Q||{}),O||{}),Y=v.URI.isUri(C)?(0,n.basename)(C):C.name;return{folder:x,folderName:R?Y:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!z.search.followSymlinks}}};u=je([qe(0,f.IConfigurationService),qe(1,p.IWorkspaceContextService),qe(2,m.IEditorGroupsService),qe(3,b.IPathService)],u),e.QueryBuilder=u;function a(D){const C=D.match(/[\*\{\}\(\)\[\]\?]/);if(C){const g=C.index,y=D.substr(0,g).match(/[/|\\][^/\\]*$/);if(y){let R=D.substr(0,y.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:D.substr((y.index||0)+1)}}}return{pathPortion:D}}function t(...D){return D.length?D.reduce((C,g)=>(C[g]=!0,C),Object.create(null)):void 0}function r(D){return T.splitGlobAware(D,",").map(C=>C.trim()).filter(C=>!!C.length)}function o(D){return[`**/${D}/**`,`**/${D}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function l(D){return D.replace(/\\/g,"/")}function i(D){return l(D).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(D,C){D=_.distinct(D,R=>R.toString());const g=[],y=C.getWorkspace();return D&&D.forEach(R=>{let O;if(C.getWorkbenchState()===2)O=(0,n.relativePath)(y.folders[0].uri,R),O&&O!=="."&&(O="./"+O);else{const x=C.getWorkspaceFolder(R);if(x){const z=x.name;if(y.folders.filter(j=>j.name===z).length===1){const j=(0,n.relativePath)(x.uri,R);j===""?O=`./${x.name}`:O=`./${x.name}/${j}`}else O=R.fsPath}}O&&g.push(O)}),g}e.resolveResourcesForSearchIncludes=h}),define(we[215],Ee([0,1,24,2,20,10,4,214,42,47]),function(ae,e,_,S,T,P,E,k,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function I(f,p){const m=p.activationEvents;if(!m)return Promise.resolve(void 0);const b=[],c=[];for(const l of m)if(/^workspaceContains:/.test(l)){const i=l.substr("workspaceContains:".length);i.indexOf("*")>=0||i.indexOf("?")>=0||f.forceUsingSearch?c.push(i):b.push(i)}if(b.length===0&&c.length===0)return Promise.resolve(void 0);let u;const a=new Promise((l,i)=>{u=l}),t=l=>u({activationEvent:l}),r=Promise.all(b.map(l=>v(f,l,t))).then(()=>{}),o=d(f,p.identifier,c,t);return Promise.all([r,o]).then(()=>{u(void 0)}),a}e.checkActivateWorkspaceContainsExtension=I;async function v(f,p,m){for(const b of f.folders)if(await f.exists(_.joinPath(S.URI.revive(b),p))){m(`workspaceContains:${p}`);return}}async function d(f,p,m,b){if(m.length===0)return Promise.resolve(void 0);const c=new T.CancellationTokenSource,u=f.checkExists(f.folders,m,c.token),a=setTimeout(async()=>{c.cancel(),b(`workspaceContainsTimeout:${m.join(",")}`)},A);let t=!1;try{t=await u}catch(r){P.isPromiseCanceledError(r)||P.onUnexpectedError(r)}c.dispose(),clearTimeout(a),t&&b(`workspaceContains:${m.join(",")}`)}function s(f,p,m,b){const c=f.get(E.IInstantiationService),u=f.get(w.ISearchService),t=c.createInstance(k.QueryBuilder).file(p.map(r=>(0,n.toWorkspaceFolder)(S.URI.revive(r))),{_reason:"checkExists",includePattern:m,exists:!0});return u.fileSearch(t,b).then(r=>!!r.limitHit,r=>P.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=s});var tt=this&&this.__classPrivateFieldSet||function(ae,e,_){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,_),_},We=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(we[35],Ee([0,1,129,11,77,24,13,6,22,2,19,5,34,181,75,31,33,179,10,25,16,26,157,7,90,4,27,76,14,65,67,41,3,215,71,158]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f,p,m,b,c,u,a,t,r,o,l,i,h,D,C,g,y,R,O,x,z){"use strict";var Q,j,Y;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let L=class kn extends k.Disposable{constructor(U,ee,ie,se,Se,Ae,Be,Re,xe,N){super();this._onDidChangeRemoteConnectionData=this._register(new R.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ee,this._extHostContext=ie,this._initData=Be,this._extHostWorkspace=se,this._extHostConfiguration=Se,this._logService=Ae,this._extHostTunnelService=xe,this._extHostTerminalService=N,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new E.Barrier,this._readyToStartExtensionHost=new E.Barrier,this._readyToRunExtensions=new E.Barrier,this._registry=new m.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new x.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=U.createChild(new C.ServiceCollection([s.IExtHostStorage,this._storage],[x.IExtHostSecretState,this._secretState]));const q=new Set;this._initData.hostExtensions.forEach(J=>q.add(c.ExtensionIdentifier.toKey(J))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(J,le)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(J,le)},actualActivateExtension:async(J,le)=>{if(q.has(c.ExtensionIdentifier.toKey(J)))return await this._mainThreadExtensionsProxy.$activateExtension(J,le),new d.HostExtension;const ge=this._registry.getExtensionDescription(J);return this._activateExtension(ge,le)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(U){b.onUnexpectedError(U)}}async deactivateAll(){let U=[];try{U=this._registry.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this._deactivate(Se))}catch(ee){}await Promise.all(U)}isActivated(U){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(U):!1}_activateByEvent(U,ee){return this._activator.activateByEvent(U,ee)}_activateById(U,ee){return this._activator.activateById(U,ee)}activateByIdWithErrors(U,ee){return this._activateById(U,ee).then(()=>{const ie=this._activator.getActivatedExtension(U);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(U=>this._registry)}getExtensionExports(U){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(U).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const U=w.TernarySearchTree.forPaths(),ee=this._registry.getAllExtensionDescriptions().map(ie=>{if(!!this._getEntryPoint(ie))return this._hostUtils.realpath(ie.extensionLocation.fsPath).then(se=>U.set(n.URI.file(se).fsPath,ie))});this._extensionPathIndex=Promise.all(ee).then(()=>U)}return this._extensionPathIndex}_deactivate(U){let ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(U))return ee;const ie=this._activator.getActivatedExtension(U);if(!ie)return ee;try{typeof ie.module.deactivate=="function"&&(ee=Promise.resolve(ie.module.deactivate()).then(void 0,se=>Promise.resolve(void 0)))}catch(se){}try{(0,k.dispose)(ie.subscriptions)}catch(se){}return ee}async _activateExtension(U,ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier),this._doActivateExtension(U,ee).then(ie=>{const se=ie.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(U.identifier,se.codeLoadingTime,se.activateCallTime,se.activateResolvedTime,ee),this._logExtensionActivationTimes(U,ee,"success",se),ie},ie=>{throw this._logExtensionActivationTimes(U,ee,"failure"),ie})}_logExtensionActivationTimes(U,ee,ie,se){const Se=$(U,ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},Se),se||{}),{outcome:ie}))}_doActivateExtension(U,ee){const ie=$(U,ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ie);const se=this._getEntryPoint(U);if(!se)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${U.identifier.value} ${JSON.stringify(ee)}`),this._logService.flush();const Se=new d.ExtensionActivationTimesBuilder(ee.startup);return Promise.all([this._loadCommonJSModule(U.identifier,(0,P.joinPath)(U.extensionLocation,se),Se),this._loadExtensionContext(U)]).then(Ae=>(T.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),kn._callActivate(this._logService,U.identifier,Ae[0],Ae[1],Se))).then(Ae=>(T.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),Ae))}_loadExtensionContext(U){const ee=new t.ExtensionGlobalMemento(U,this._storage),ie=new t.ExtensionMemento(U.identifier.value,!1,this._storage),se=new z.ExtensionSecrets(U,this._secretState),Se=U.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Ae=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([ee.whenReady,ie.whenReady,this._storagePath.whenReady]).then(()=>{const Be=this;let Re;return Object.freeze({globalState:ee,workspaceState:ie,secrets:se,subscriptions:[],get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(xe){return S.join(U.extensionLocation.fsPath,xe)},get storagePath(){var xe;return(xe=Be._storagePath.workspaceValue(U))===null||xe===void 0?void 0:xe.fsPath},get globalStoragePath(){return Be._storagePath.globalValue(U).fsPath},get logPath(){return S.join(Be._initData.logsLocation.fsPath,U.identifier.value)},get logUri(){return n.URI.joinPath(Be._initData.logsLocation,U.identifier.value)},get storageUri(){return Be._storagePath.workspaceValue(U)},get globalStorageUri(){return Be._storagePath.globalValue(U)},get extensionMode(){return Se},get extension(){return(0,p.checkProposedApiEnabled)(U),Re===void 0&&(Re=new W(this,U.identifier,U,Ae)),Re},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(U),Be.extensionRuntime},get environmentVariableCollection(){return Be._extHostTerminalService.getEnvironmentVariableCollection(U)}})})}static _callActivate(U,ee,ie,se,Se){return ie=ie||{activate:void 0,deactivate:void 0},this._callActivateOptional(U,ee,ie,se,Se).then(Ae=>new d.ActivatedExtension(!1,null,Se.build(),ie,Ae,se.subscriptions))}static _callActivateOptional(U,ee,ie,se,Se){if(typeof ie.activate=="function")try{Se.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const Ae=typeof global=="object"?global:self,Be=ie.activate.apply(Ae,[se]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(Be).then(Re=>(Se.activateResolveStop(),Re))}catch(Ae){return Promise.reject(Ae)}else return Promise.resolve(ie)}_activateOneStartupFinished(U,ee){this._activateById(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:ee}).then(void 0,ie=>{this._logService.error(ie)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const U of this._registry.getAllExtensionDescriptions())if(U.activationEvents)for(const ee of U.activationEvents)ee==="onStartupFinished"&&this._activateOneStartupFinished(U,ee)}_handleEagerExtensions(){const U=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ie=this._handleWorkspaceContainsEagerExtensions(ee),se=Promise.all([U,ie]).then(()=>{});return Promise.race([se,(0,E.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),se}_handleWorkspaceContainsEagerExtensions(U){return U.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ee=>this._handleWorkspaceContainsEagerExtension(U,ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(U,ee){if(!this.isActivated(ee.identifier)){const ie=!this._initData.remote.isRemote&&!!this._initData.remote.authority,se={folders:U.map(Ae=>Ae.uri),forceUsingSearch:ie,exists:Ae=>this._hostUtils.exists(Ae.fsPath),checkExists:(Ae,Be,Re)=>this._mainThreadWorkspaceProxy.$checkExists(Ae,Be,Re)},Se=await(0,O.checkActivateWorkspaceContainsExtension)(se,ee);if(!!Se)return this._activateById(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:Se.activationEvent}).then(void 0,Ae=>this._logService.error(Ae))}}$extensionTestsExecute(){return this._doHandleExtensionTests().then(void 0,U=>(console.error(U),Promise.reject(U)))}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:ee}=this._initData.environment;if(!U||!ee||ee.scheme!==u.Schemas.file)throw new Error(_.localize(0,null));const ie=(0,P.originalFSPath)(ee),se=await this._loadCommonJSModule(null,n.URI.file(ie),new d.ExtensionActivationTimesBuilder(!1));if(!se||typeof se.run!="function")throw new Error(_.localize(1,null,ie));return new Promise((Se,Ae)=>{const Be=(xe,N)=>{xe?Ae(xe):Se(typeof N=="number"&&N>0?1:0)},Re=se.run(ie,Be);Re&&Re.then&&Re.then(()=>{Se(0)}).catch(xe=>{Ae(xe.toString())})})}async $extensionTestsExit(U){this._logService.info(`extension host terminating: test runner requested exit with code ${U}`),this._logService.info(`exiting with code ${U}`),this._logService.flush(),this._hostUtils.exit(U)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(U,ee){return this._resolvers[U]=ee,(0,k.toDisposable)(()=>{delete this._resolvers[U]})}async $resolveAuthority(U,ee){const ie=U.indexOf("+");if(ie===-1)throw new Error("Not an authority that can be resolved!");const se=U.substr(0,ie);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${se}`,!1);const Se=this._resolvers[se];if(!Se)return{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${se}.`,detail:void 0}};try{T.mark(`code/extHost/willResolveAuthority/${se}`);const Ae=await Se.resolve(U,{resolveAttempt:ee});T.mark(`code/extHost/didResolveAuthorityOK/${se}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(Se));const Be={authority:U,host:Ae.host,port:Ae.port,connectionToken:Ae.connectionToken},Re={extensionHostEnv:Ae.extensionHostEnv};return{type:"ok",value:{authority:Be,options:Re,tunnelInformation:{environmentTunnels:Ae.environmentTunnels}}}}catch(Ae){if(T.mark(`code/extHost/didResolveAuthorityError/${se}`),Ae instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:Ae._code,message:Ae._message,detail:Ae._detail}};throw Ae}}$startExtensionHost(U){return this._registry.keepOnly(U),this._startExtensionHost()}$activateByEvent(U,ee){return ee===1?this._activateByEvent(U,!1):this._readyToRunExtensions.wait().then(ie=>this._activateByEvent(U,!1))}async $activate(U,ee){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(U)?(await this._activateById(U,ee),!0):!1}async $deltaExtensions(U,ee){U.forEach(se=>se.extensionLocation=n.URI.revive(se.extensionLocation));const ie=await this.getExtensionPathIndex();return await Promise.all(ee.map(async se=>{const Se=this._registry.getExtensionDescription(se);if(!!Se){const Ae=await this._hostUtils.realpath(Se.extensionLocation.fsPath);ie.delete(n.URI.file(Ae).fsPath)}})),await Promise.all(U.map(async se=>{const Se=await this._hostUtils.realpath(se.extensionLocation.fsPath);ie.set(n.URI.file(Se).fsPath,se)})),this._registry.deltaExtensions(U,ee),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){let ee=a.VSBuffer.alloc(U),ie=Math.random()%256;for(let se=0;se<U;se++)ee.writeUInt8(ie,se);return ee}async $updateRemoteConnectionData(U){this._remoteConnectionData=U,this._onDidChangeRemoteConnectionData.fire()}};L=je([qe(0,l.IInstantiationService),qe(1,e.IHostUtils),qe(2,D.IExtHostRpcService),qe(3,f.IExtHostWorkspace),qe(4,v.IExtHostConfiguration),qe(5,A.ILogService),qe(6,i.IExtHostInitDataService),qe(7,h.IExtensionStoragePaths),qe(8,g.IExtHostTunnelService),qe(9,y.IExtHostTerminalService)],L),e.AbstractExtHostExtensionService=L;function $(K,U){return{id:K.identifier.value,name:K.name,extensionVersion:K.version,publisherDisplayName:K.publisher,activationEvents:K.activationEvents?K.activationEvents.join(","):null,isBuiltin:K.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class W{constructor(U,ee,ie,se){Q.set(this,void 0),j.set(this,void 0),Y.set(this,void 0),tt(this,Q,U),tt(this,j,ee),tt(this,Y,ie.identifier),this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=S.normalize((0,P.originalFSPath)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=se}get isActive(){return We(this,Q).isActivated(We(this,Y))}get exports(){if(this.packageJSON.api!=="none")return We(this,Q).getExtensionExports(We(this,Y))}activate(){return We(this,Q).activateByIdWithErrors(We(this,Y),{startup:!1,extensionId:We(this,j),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,Q=new WeakMap,j=new WeakMap,Y=new WeakMap}),define(we[101],Ee([0,1,11,2,3,13,5,7,164,31,35,40,169,34,165,14,4,12]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let b=class{constructor(i,h,D,C,g){this._workspaceService=h,this._extensionService=D,this._editorsService=C,this._configurationService=g,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=i.getProxy(E.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new u(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(y=>{y.onDidChange(R=>{this.registerAllDebugTypes(y)}),this.registerAllDebugTypes(y)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(i,h){const D=i;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let C=`debug:${encodeURIComponent(D.path||"")}`,g="?";return h&&(C+=`${g}session=${encodeURIComponent(h.id)}`,g="&"),C+=`${g}ref=${D.sourceReference}`,S.URI.parse(C)}else{if(D.path)return S.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const h=[];for(const D of i.getAllExtensionDescriptions())if(D.contributes){const C=D.contributes.debuggers;if(C&&C.length>0)for(const g of C)(0,s.isDebuggerMainContribution)(g)&&h.push(g.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(h=>i.push(h)),i}addBreakpoints(i){this.startBreakpoints();const h=i.filter(g=>{const y=g.id;return this._breakpoints.has(y)?!1:(this._breakpoints.set(y,g),!0)});this.fireBreakpointChanges(h,[],[]);const D=[],C=new Map;for(const g of h)if(g instanceof k.SourceBreakpoint){let y=C.get(g.location.uri.toString());y||(y={type:"sourceMulti",uri:g.location.uri,lines:[]},C.set(g.location.uri.toString(),y),D.push(y)),y.lines.push({id:g.id,enabled:g.enabled,condition:g.condition,hitCondition:g.hitCondition,logMessage:g.logMessage,line:g.location.range.start.line,character:g.location.range.start.character})}else g instanceof k.FunctionBreakpoint&&D.push({type:"function",id:g.id,enabled:g.enabled,hitCondition:g.hitCondition,logMessage:g.logMessage,condition:g.condition,functionName:g.functionName});return this._debugServiceProxy.$registerBreakpoints(D)}removeBreakpoints(i){this.startBreakpoints();const h=i.filter(y=>this._breakpoints.delete(y.id));this.fireBreakpointChanges([],h,[]);const D=h.filter(y=>y instanceof k.SourceBreakpoint).map(y=>y.id),C=h.filter(y=>y instanceof k.FunctionBreakpoint).map(y=>y.id),g=h.filter(y=>y instanceof k.DataBreakpoint).map(y=>y.id);return this._debugServiceProxy.$unregisterBreakpoints(D,C,g)}startDebugging(i,h,D){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,h,{parentSessionID:D.parentSession?D.parentSession.id:void 0,repl:D.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,h,D){if(!h)return new k.Disposable(()=>{});const C=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:C,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,D,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,C),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(g=>g.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(C)})}registerDebugAdapterDescriptorFactory(i,h,D){if(!D)return new k.Disposable(()=>{});if(!this.definesDebugType(i,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const C=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:C,factory:D}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,C),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(g=>g.factory!==D),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(C)})}registerDebugAdapterTrackerFactory(i,h){if(!h)return new k.Disposable(()=>{});const D=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:D,factory:h}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(C=>C.factory!==h)})}async $runInTerminal(i,h){return Promise.resolve(void 0)}async $substituteVariables(i,h){if(!this._variableResolver){const[g,y]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(g||[],this._editorsService,y)}let D;const C=await this.getFolder(i);return C&&(D={uri:C.uri,name:C.name,index:C.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(D,h)}createDebugAdapter(i,h){if(i.type==="implementation")return new r(i.implementation)}createSignService(){}async $startDASession(i,h){const D=this,C=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(C.type),C).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${C.type}' (extension might have failed to activate)`);const y=this.convertToDto(g),R=this.createDebugAdapter(y,C);if(!R)throw new Error(`Couldn't create a debug adapter for type '${C.type}'.`);const O=R;return this._debugAdapters.set(i,O),this.getDebugAdapterTrackers(C).then(x=>(x&&this._debugAdaptersTrackers.set(i,x),O.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const Q=z,j={type:"response",seq:0,command:Q.command,request_seq:Q.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const Y=await this._signService.sign(Q.arguments.value);j.body={signature:Y},O.sendResponse(j)}else throw new Error("no signer")}catch(Y){j.success=!1,j.message=Y.message,O.sendResponse(j)}}else x&&x.onDidSendMessage&&x.onDidSendMessage(z),z=(0,s.convertToVSCPaths)(z,!0),D._debugServiceProxy.$acceptDAMessage(i,z)}),O.onError(z=>{x&&x.onError&&x.onError(z),this._debugServiceProxy.$acceptDAError(i,z.name,z.message,z.stack)}),O.onExit(z=>{x&&x.onExit&&x.onExit((0,m.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(i,(0,m.withNullAsUndefined)(z),void 0)}),x&&x.onWillStartSession&&x.onWillStartSession(),O.startSession()))})}$sendDAMessage(i,h){h=(0,s.convertToDAPaths)(h,!1);const D=this._debugAdaptersTrackers.get(i);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(h);const C=this._debugAdapters.get(i);C&&C.sendMessage(h)}$stopDASession(i){const h=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),h&&h.onWillStopSession&&h.onWillStopSession();const D=this._debugAdapters.get(i);return this._debugAdapters.delete(i),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const h=[],D=[],C=[];if(i.added)for(const g of i.added){const y=g.id;if(y&&!this._breakpoints.has(y)){let R;if(g.type==="function")R=new k.FunctionBreakpoint(g.functionName,g.enabled,g.condition,g.hitCondition,g.logMessage);else if(g.type==="data")R=new k.DataBreakpoint(g.label,g.dataId,g.canPersist,g.enabled,g.hitCondition,g.condition,g.logMessage);else{const O=S.URI.revive(g.uri);R=new k.SourceBreakpoint(new k.Location(O,new k.Position(g.line,g.character)),g.enabled,g.condition,g.hitCondition,g.logMessage)}R._id=y,this._breakpoints.set(y,R),h.push(R)}}if(i.removed)for(const g of i.removed){const y=this._breakpoints.get(g);y&&(this._breakpoints.delete(g),D.push(y))}if(i.changed){for(const g of i.changed)if(g.id){const y=this._breakpoints.get(g.id);if(y){if(y instanceof k.FunctionBreakpoint&&g.type==="function"){const R=y;R.enabled=g.enabled,R.condition=g.condition,R.hitCondition=g.hitCondition,R.logMessage=g.logMessage,R.functionName=g.functionName}else if(y instanceof k.SourceBreakpoint&&g.type==="source"){const R=y;R.enabled=g.enabled,R.condition=g.condition,R.hitCondition=g.hitCondition,R.logMessage=g.logMessage,R.location=new k.Location(S.URI.revive(g.uri),new k.Position(g.line,g.character))}C.push(y)}}}this.fireBreakpointChanges(h,D,C)}$provideDebugConfigurations(i,h,D){return(0,P.asPromise)(async()=>{const C=this.getConfigProviderByHandle(i);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const g=await this.getFolder(h);return C.provideDebugConfigurations(g,D)}).then(C=>{if(!C)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return C})}$resolveDebugConfiguration(i,h,D,C){return(0,P.asPromise)(async()=>{const g=this.getConfigProviderByHandle(i);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const y=await this.getFolder(h);return g.resolveDebugConfiguration(y,D,C)})}$resolveDebugConfigurationWithSubstitutedVariables(i,h,D,C){return(0,P.asPromise)(async()=>{const g=this.getConfigProviderByHandle(i);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const y=await this.getFolder(h);return g.resolveDebugConfigurationWithSubstitutedVariables(y,D,C)})}async $provideDebugAdapter(i,h){const D=this.getAdapterDescriptorFactoryByHandle(i);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const C=await this.getSession(h);return this.getAdapterDescriptor(D,C).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${C.type}'`);return this.convertToDto(g)})}async $acceptDebugSessionStarted(i){const h=await this.getSession(i);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(i){const h=await this.getSession(i);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,h){const D=await this.getSession(i);D&&D._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(i,h){const C={session:await this.getSession(i),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(C)}convertToDto(i){if(i instanceof k.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof k.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const h=this._adapterFactories.filter(D=>D.type===i);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(i){const h=this._adapterFactories.filter(D=>D.handle===i);if(h.length>0)return h[0].factory}getConfigProviderByHandle(i){const h=this._configProviders.filter(D=>D.handle===i);if(h.length>0)return h[0].provider}definesDebugType(i,h){if(i.contributes){const D=i.contributes.debuggers;if(D&&D.length>0){for(const C of D)if(C.label&&C.type&&C.type===h)return!0}}return!1}getDebugAdapterTrackers(i){const D=i.configuration.type,C=this._trackerFactories.filter(g=>g.type===D||g.type==="*").map(g=>(0,P.asPromise)(()=>g.factory.createDebugAdapterTracker(i)).then(y=>y,y=>null));return Promise.race([Promise.all(C).then(g=>{const y=g.filter(R=>!!R);if(y.length>0)return new t(y)}),new Promise((g,y)=>{const R=setTimeout(()=>{clearTimeout(R),y(new Error("timeout"))},1e3)})]).catch(g=>{})}async getAdapterDescriptor(i,h){const D=h.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new k.DebugAdapterServer(D));if(i){const g=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>i.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,g))).then(y=>{if(y)return y})}const C=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,C))}daExecutableFromPackage(i,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,h,D){(i.length>0||h.length>0||D.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:h,changed:D}))}async getSession(i){if(i)if(typeof i=="string"){const h=this._debugSessions.get(i);if(h)return h}else{let h=this._debugSessions.get(i.id);if(!h){const D=await this.getFolder(i.folderUri);h=new c(this._debugServiceProxy,i.id,i.type,i.name,D,i.configuration),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(i){if(i){const h=S.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};b=je([qe(0,f.IExtHostRpcService),qe(1,n.IExtHostWorkspace),qe(2,A.IExtHostExtensionService),qe(3,I.IExtHostDocumentsAndEditors),qe(4,d.IExtHostConfiguration)],b),e.ExtHostDebugServiceBase=b;class c{constructor(i,h,D,C,g,y){this._debugServiceProxy=i,this._id=h,this._type=D,this._name=C,this._workspaceFolder=g,this._configuration=y}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,h)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=c;class u{constructor(i){this.value=Object.freeze({append(h){i.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=u;class a extends v.AbstractVariableResolverService{constructor(i,h,D,C,g){super({getFolderUri:y=>{const R=i.filter(O=>O.name===y);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>i.length,getConfigurationValue:(y,R)=>D.getConfiguration(void 0,y).get(R),getAppRoot:()=>C?C.VSCODE_CWD:void 0,getExecPath:()=>C?C.VSCODE_EXEC_PATH:void 0,getFilePath:()=>{if(h){const y=h.activeEditor();if(y)return _.normalize(y.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(h&&g){const y=h.activeEditor();if(y){const R=g.getWorkspaceFolder(y.document.uri);if(R)return _.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(h){const y=h.activeEditor();if(y&&!y.selection.isEmpty)return y.document.getText(y.selection)}},getLineNumber:()=>{if(h){const y=h.activeEditor();if(y)return String(y.selection.end.line+1)}}},void 0,C)}}e.ExtHostVariableResolverService=a;class t{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(h=>h.onError?h.onError(i):void 0)}onExit(i,h){this.trackers.forEach(D=>D.onExit?D.onExit(i,h):void 0)}}class r extends w.AbstractDebugAdapter{constructor(i){super();this.implementation=i,i.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends b{constructor(i,h,D,C,g){super(i,h,D,C,g)}createVariableResolver(i,h,D){return new a(i,h,D)}};o=je([qe(0,f.IExtHostRpcService),qe(1,n.IExtHostWorkspace),qe(2,A.IExtHostExtensionService),qe(3,I.IExtHostDocumentsAndEditors),qe(4,d.IExtHostConfiguration)],o),e.WorkerExtHostDebugService=o}),define(we[216],Ee([0,1,77,2,5,34,33,25,14,27,4,35,36,19]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(c,u,a,t,r,o,l){this._apiFactory=c,this._extensionRegistry=u,this._instaService=a,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=o,this._logService=l,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,u,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,u,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let u of c.nodeModuleName)this._factories.set(u,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(u=>c.alternativeModuleName(u))}};s=je([qe(2,A.IInstantiationService),qe(3,P.IExtHostConfiguration),qe(4,I.IExtHostExtensionService),qe(5,n.IExtHostInitDataService),qe(6,d.ILogService)],s),e.RequireInterceptor=s;class f{constructor(c,u,a,t,r){this._apiFactory=c,this._extensionPaths=u,this._extensionRegistry=a,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,u){const a=this._extensionPaths.findSubstr(u.fsPath);if(a){let t=this._extApiImpl.get(k.ExtensionIdentifier.toKey(a.identifier));return t||(t=this._apiFactory(a,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(a.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,o)=>t+=`	${o} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(E.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(c,u){this.nodeModuleName="keytar";const{environment:a}=u,t=c.getProxy(T.MainContext.MainThreadKeytar);if(a.appRoot){let r=a.appRoot.fsPath;v.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,o)=>t.$getPassword(r,o),setPassword:(r,o,l)=>t.$setPassword(r,o,l),deletePassword:(r,o)=>t.$deletePassword(r,o),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(c,u){return this._impl}alternativeModuleName(c){const u=c.length;if(!(u<=7||!this.alternativeNames)){const a=u-7;if((c.charAt(a)==="/"||c.charAt(a)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}}};p=je([qe(0,w.IExtHostRpcService),qe(1,n.IExtHostInitDataService)],p);let m=class{constructor(c,u,a){this._extensionPaths=c,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=a.getProxy(T.MainContext.MainThreadTelemetry);const t=a.getProxy(T.MainContext.MainThreadWindow);this._impl=(r,o)=>{const l=S.URI.parse(r);return o?this.callOriginal(r,o):l.scheme==="http"||l.scheme==="https"?t.$openUri(l,r,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this._appUriScheme?t.$openUri(l,r,{}):this.callOriginal(r,o)}}load(c,u,a){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=a(c),this._impl}callOriginal(c,u){return this.sendNoForwardTelemetry(),this._original(c,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=je([qe(2,w.IExtHostRpcService)],m)}),define(we[217],Ee([0,1,13,10,77,6,2,5,209,19,61,65,27,147,14,68,35,41]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(u,a,t,r){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const o=new w.RPCProtocol(u,null,r);a=b._transform(a,o);const l=new I.ServiceCollection(...(0,A.getSingletonServiceDescriptors)());l.set(v.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},a)),l.set(s.IExtHostRpcService,new s.ExtHostRpcService(o)),l.set(f.IURITransformerService,new f.URITransformerService(r)),l.set(p.IHostUtils,t);const i=new d.InstantiationService(l,!0),h=i.invokeFunction(y=>y.get(m.IExtHostTerminalService));this._disposables.add(h),this._logService=i.invokeFunction(y=>y.get(n.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",a),this._extensionService=i.invokeFunction(y=>y.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const D=new WeakMap;this._extensionService.getExtensionPathIndex().then(y=>{Error.prepareStackTrace=(R,O)=>{let x="",z,Q;for(const j of O)x+=`
	at ${j.toString()}`,Q=j.getFileName(),!z&&Q&&(z=y.findSubstr(Q));return D.set(R,z),`${R.name||"Error"}: ${R.message||""}${x}`}});const C=o.getProxy(k.MainContext.MainThreadExtensionService),g=o.getProxy(k.MainContext.MainThreadErrors);S.setUnexpectedErrorHandler(y=>{const R=S.transformErrorForSerialization(y),O=D.get(y);O?C.$onExtensionRuntimeError(O.identifier,R):g.$onUnexpectedError(R)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),S.setUnexpectedErrorHandler(t=>{});const a=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,_.timeout)(4e3),a]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,a){u.extensions.forEach(r=>r.extensionLocation=E.URI.revive(a.transformIncomingURIs(r.extensionLocation))),u.environment.appRoot=E.URI.revive(a.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(r=>E.URI.revive(a.transformIncomingURIs(r)))),u.environment.extensionTestsLocationURI=E.URI.revive(a.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=E.URI.revive(a.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=E.URI.revive(a.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=E.URI.revive(a.transformIncomingURIs(u.logsLocation)),u.logFile=E.URI.revive(a.transformIncomingURIs(u.logFile)),u.workspace=a.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=b}),define(we[218],Ee([0,1,11,20,60,28,24,54,42,36]),function(ae,e,_,S,T,P,E,k,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(d,s,f){this.config=d,this.provider=s,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&P.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&P.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const s=this.config.folderQueries||[];return new Promise((f,p)=>{const m=b=>{this.resultCount++,d(b)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const c=b.toString(),u=_.basename(c);this.globalExcludePattern&&this.globalExcludePattern(c,u)||this.matchFile(m,{base:b,basename:u})}),Promise.all(s.map(b=>this.searchInFolder(b,m))).then(b=>{f({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{p(new Error((0,T.toErrorMessage)(b)))})})}searchInFolder(d,s){const f=new S.CancellationTokenSource;return new Promise((p,m)=>{const b=this.getSearchOptionsForFolder(d),c=this.initDirectoryTree(),u=new w.QueryGlobTester(this.config,d),a=!u.hasSiblingExcludeClauses();let t;new Promise(r=>(0,n.nextTick)(r)).then(()=>(this.activeCancellationTokens.add(f),t=k.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},b,f.token))).then(r=>{const o=t.elapsed(),l=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(i=>{const h=_.posix.relative(d.folder.path,i.path);if(a){const D=_.basename(i.path);this.matchFile(s,{base:d.folder,relativePath:h,basename:D});return}this.addDirectoryEntries(c,d.folder,h,s)}),this.activeCancellationTokens.delete(f),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(c,u,s),{providerTime:o,postProcessTime:l.elapsed()})}).then(r=>{f.dispose(),p(r)},r=>{f.dispose(),m(r)})})}getSearchOptionsForFolder(d){const s=(0,w.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),f=(0,w.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:f,includes:s,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},s,f,p){if(f===this.filePattern){const b=_.basename(this.filePattern);this.matchFile(p,{base:s,relativePath:this.filePattern,basename:b})}function m(b){const c=_.basename(b),u=_.dirname(b);let a=d[u];a||(a=d[u]=[],m(u)),a.push({base:s,relativePath:b,basename:c})}m(f)}matchDirectoryTree({rootEntries:d,pathToEntries:s},f,p){const m=this,b=this.filePattern;function c(u){const a=P.hasSiblingFn(()=>u.map(t=>t.basename));for(let t=0,r=u.length;t<r;t++){const o=u[t],{relativePath:l,basename:i}=o;if(!!f.includedInQuerySync(l,i,b!==i?a:void 0)){const h=s[l];if(h)c(h);else{if(l===b)continue;m.matchFile(p,o)}if(m.isLimitHit)break}}}c(d)}matchFile(d,s){(!this.includePattern||s.relativePath&&this.includePattern(s.relativePath,s.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(s))}}class I{constructor(){this.sessions=new Map}fileSearch(d,s,f,p){const m=this.getSessionTokenSource(d.cacheKey),b=new A(d,s,m&&m.token);let c=0;const u=a=>{c+=a.length,f(a.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(b,I.BATCH_SIZE,u,p).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:a.stats}}))}clearCache(d){const s=this.getSessionTokenSource(d);s&&s.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new S.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:E.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,s,f,p){p.onCancellationRequested(()=>{d.cancel()});const m=c=>{c&&(b.push(c),s>0&&b.length>=s&&(f(b),b=[]))};let b=[];return d.search(m).then(c=>(b.length&&f(b),c),c=>(b.length&&f(b),Promise.reject(c)))}}e.FileSearchManager=I,I.BATCH_SIZE=512}),define(we[219],Ee([0,1,11,15,20,60,24,28,2,42,36,16]),function(ae,e,_,S,T,P,E,k,w,n,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class v{constructor(c,u,a){this.query=c,this.provider=u,this.fileUtils=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,u){const a=this.query.folderQueries||[],t=new T.CancellationTokenSource;return u.onCancellationRequested(()=>t.cancel()),new Promise((r,o)=>{this.collector=new s(c);let l=!1;const i=(h,D)=>{if(!l&&!this.isLimitHit){const C=this.resultSize(h);p(h)&&typeof this.query.maxResults=="number"&&this.resultCount+C>this.query.maxResults&&(this.isLimitHit=!0,l=!0,t.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const g=this.resultSize(h);this.resultCount+=g,(g>0||!p(h))&&this.collector.add(h,D)}};Promise.all(a.map((h,D)=>this.searchInFolder(h,C=>i(C,D),t.token))).then(h=>{t.dispose(),this.collector.flush();const D=h.some(C=>!!C&&!!C.limitHit);r({limitHit:this.isLimitHit||D,stats:{type:"textSearchProvider"}})},h=>{t.dispose();const D=(0,P.toErrorMessage)(h);o(new Error(D))})})}resultSize(c){return p(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,u){const a=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:a.slice(0,u),preview:{matches:t.slice(0,u),text:c.preview.text},uri:c.uri}}searchInFolder(c,u,a){const t=new n.QueryGlobTester(this.query,c),r=[],o={report:i=>{if(!!this.validateProviderResult(i)){const h=c.folder.scheme===I.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(E.dirname(i.uri))):void 0,D=E.relativePath(c.folder,i.uri);D&&r.push(t.includedInQuery(D,_.basename(D),h).then(C=>{C&&u(i)}))}}},l=this.getSearchOptionsForFolder(c);return new Promise(i=>(0,A.nextTick)(i)).then(()=>this.provider.provideTextSearchResults(d(this.query.contentPattern),l,o,a)).then(i=>Promise.all(r).then(()=>i))}validateProviderResult(c){if(p(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const u=(0,n.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),a=(0,n.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),t={folder:w.URI.from(c.folder),excludes:a,includes:u,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=v;function d(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class s{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,u=>this.sendItems(u))}add(c,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!E.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(f(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=s;function f(b){return p(b)?{preview:{matches:(0,S.mapArrayOrNot)(b.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:b.preview.text},ranges:(0,S.mapArrayOrNot)(b.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function p(b){return!!b.preview}e.extensionResultIsMatch=p;class m{constructor(c,u){this.maxBatchSize=c,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,u){!c||this.addItemToBatch(c,u)}addItems(c,u){!c||this.addItemsToBatch(c,u)}addItemToBatch(c,u){this.batch.push(c),this.batchSize+=u,this.onUpdate()}addItemsToBatch(c,u){this.batch=this.batch.concat(c),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m,m.TIMEOUT=4e3,m.START_BATCH_AFTER_COUNT=50}),define(we[102],Ee([0,1,6,5,4,218,14,68,19,2,219]),function(ae,e,_,S,T,P,E,k,w,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let I=class{constructor(f,p,m){this.extHostRpc=f,this._uriTransformer=p,this._logService=m,this._proxy=this.extHostRpc.getProxy(S.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}registerTextSearchProvider(f,p){if(this._textSearchUsedSchemes.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this._textSearchUsedSchemes.add(f);const m=this._handlePool++;return this._textSearchProvider.set(m,p),this._proxy.$registerTextSearchProvider(m,this._transformScheme(f)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(f),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(f,p){if(this._fileSearchUsedSchemes.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this._fileSearchUsedSchemes.add(f);const m=this._handlePool++;return this._fileSearchProvider.set(m,p),this._proxy.$registerFileSearchProvider(m,this._transformScheme(f)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(f),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(f,p,m,b){const c=v(m),u=this._fileSearchProvider.get(f);if(u)return this._fileSearchManager.fileSearch(c,u,a=>{this._proxy.$handleFileMatch(f,p,a.map(t=>t.resource))},b);throw new Error("unknown provider: "+f)}$clearCache(f){return this._fileSearchManager.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,p,m,b){const c=this._textSearchProvider.get(f);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const u=v(m);return this.createTextSearchManager(u,c).search(t=>this._proxy.$handleTextMatch(f,p,t),b)}createTextSearchManager(f,p){return new A.TextSearchManager(f,p,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m})}};I=je([qe(0,E.IExtHostRpcService),qe(1,k.IURITransformerService),qe(2,w.ILogService)],I),e.ExtHostSearch=I;function v(s){return Object.assign(Object.assign({},s),{folderQueries:s.folderQueries&&s.folderQueries.map(d),extraFileResources:s.extraFileResources&&s.extraFileResources.map(f=>n.URI.revive(f))})}e.reviveQuery=v;function d(s){return Object.assign(Object.assign({},s),{folder:n.URI.revive(s.folder)})}}),define(we[220],Ee([0,1,126,20,10,3,56,2,120,82,114,59,64,5,186,185,73,187,34,188,189,190,172,191,40,35,192,173,194,195,196,98,176,198,199,200,75,41,201,177,9,7,204,49,99,31,33,50,161,193,91,97,100,101,102,19,68,14,27,197,160,67,72,183,202,159,76,74,207,205,206,184,48,213,203,71,156,93]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f,p,m,b,c,u,a,t,r,o,l,i,h,D,C,g,y,R,O,x,z,Q,j,Y,L,$,W,K,U,ee,ie,se,Se,Ae,Be,Re,xe,N,q,J,le,ge,De,Le,pe,Ce,Te,Ue,be,Ke,H,Z,_e,Me,He,Oe,Xe,B,re,ce,V,X,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function fe(ve){const $e=ve.get(Le.IExtHostInitDataService),Ne=ve.get(B.IExtHostFileSystemInfo),Ve=ve.get(_e.IExtHostConsumerFileSystem),Qe=ve.get(l.IExtHostExtensionService),Ze=ve.get(ie.IExtHostWorkspace),ct=ve.get(oe.IExtHostTelemetry),st=ve.get(b.IExtHostConfiguration),me=ve.get(ge.IURITransformerService),he=ve.get(De.IExtHostRpcService),ue=ve.get(Q.IExtHostStorage),G=ve.get(Z.IExtensionStoragePaths),Ie=ve.get(le.ILogService),Pe=ve.get(Te.IExtHostTunnelService),et=ve.get(Ue.IExtHostApiDeprecationService),Ge=ve.get(ee.IExtHostWindow),rt=ve.get(V.IExtHostSecretState);he.set(d.ExtHostContext.ExtHostFileSystemInfo,Ne),he.set(d.ExtHostContext.ExtHostLogService,Ie),he.set(d.ExtHostContext.ExtHostWorkspace,Ze),he.set(d.ExtHostContext.ExtHostConfiguration,st),he.set(d.ExtHostContext.ExtHostExtensionService,Qe),he.set(d.ExtHostContext.ExtHostStorage,ue),he.set(d.ExtHostContext.ExtHostTunnelService,Pe),he.set(d.ExtHostContext.ExtHostWindow,Ge),he.set(d.ExtHostContext.ExtHostSecretState,rt),he.set(d.ExtHostContext.ExtHostTelemetry,ct);const lt=he.set(d.ExtHostContext.ExtHostDecorations,ve.get(xe.IExtHostDecorations)),Je=he.set(d.ExtHostContext.ExtHostDocumentsAndEditors,ve.get(o.IExtHostDocumentsAndEditors)),it=he.set(d.ExtHostContext.ExtHostCommands,ve.get(p.IExtHostCommands)),dt=he.set(d.ExtHostContext.ExtHostTerminalService,ve.get(j.IExtHostTerminalService)),at=he.set(d.ExtHostContext.ExtHostDebugService,ve.get(q.IExtHostDebugService)),Dt=he.set(d.ExtHostContext.ExtHostSearch,ve.get(J.IExtHostSearch)),gt=he.set(d.ExtHostContext.ExtHostTask,ve.get(N.IExtHostTask)),Ct=he.set(d.ExtHostContext.ExtHostOutputService,ve.get(y.IExtHostOutputService)),wt=he.set(d.ExtHostContext.ExtHostEditorTabs,new X.ExtHostEditorTabs),Et=he.set(d.ExtHostContext.ExtHostUrls,new K.ExtHostUrls(he)),mt=he.set(d.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(he,Je)),Rt=he.set(d.ExtHostContext.ExtHostDocumentContentProviders,new a.ExtHostDocumentContentProvider(he,Je,Ie)),Ft=he.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Ie,mt,he.getProxy(d.MainContext.MainThreadBulkEdits))),ht=he.set(d.ExtHostContext.ExtHostNotebook,new pe.ExtHostNotebookController(he,it,Je,mt,$e.environment,Ie,G)),St=he.set(d.ExtHostContext.ExtHostEditors,new Y.ExtHostEditors(he,Je)),Ut=he.set(d.ExtHostContext.ExtHostTreeViews,new L.ExtHostTreeViews(he.getProxy(d.MainContext.MainThreadTreeViews),it,Ie)),$t=he.set(d.ExtHostContext.ExtHostEditorInsets,new Ae.ExtHostEditorInsets(he.getProxy(d.MainContext.MainThreadEditorInsets),St,$e.environment)),Lt=he.set(d.ExtHostContext.ExtHostDiagnostics,new c.ExtHostDiagnostics(he,Ie)),ut=he.set(d.ExtHostContext.ExtHostLanguageFeatures,new D.ExtHostLanguageFeatures(he,me,mt,it,Lt,Ie,et)),ln=he.set(d.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(he,ut)),It=he.set(d.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(he,Ie,Je)),At=he.set(d.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(he,Ze,it)),Yt=he.set(d.ExtHostContext.ExtHostSCM,new x.ExtHostSCM(he,it,Ie)),un=he.set(d.ExtHostContext.ExtHostComments,new m.ExtHostComments(he,it,mt)),Xt=he.set(d.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(he.getProxy(d.MainContext.MainThreadProgress))),cn=he.set(d.ExtHostContext.ExtHosLabelService,new Be.ExtHostLabelService(he)),Zt=he.set(d.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(he)),Pt=he.set(d.ExtHostContext.ExtHostAuthentication,new be.ExtHostAuthentication(he)),Bt=he.set(d.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(he,it)),xt=he.set(d.ExtHostContext.ExtHostWebviews,new U.ExtHostWebviews(he,$e.environment,Ze,Ie,et)),Ht=he.set(d.ExtHostContext.ExtHostWebviewPanels,new Oe.ExtHostWebviewPanels(he,xt,Ze)),dn=he.set(d.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(he,mt,G,xt,Ht)),hn=he.set(d.ExtHostContext.ExtHostWebviewViews,new Me.ExtHostWebviewViews(he,xt)),kt=he.set(d.ExtHostContext.ExtHostTesting,new re.ExtHostTesting(he,Je,Ze)),fn=he.set(d.ExtHostContext.ExtHostUriOpeners,new ce.ExtHostUriOpeners(he)),mn=(0,Se.values)(d.ExtHostContext);he.assertRegistered(mn);const zt=new Xe.ExtHostBulkEdits(he,Je),gn=new f.ExtHostClipboard(he),Vt=new g.ExtHostMessageService(he,Ie),Wt=new u.ExtHostDialogs(he),Mt=new z.ExtHostStatusBar(he,it.converter),jt=new C.ExtHostLanguages(he,mt);return s.ExtHostApiCommands.register(it),function(Fe,Ot,qt){const ft=function(){let te=!Fe.isUnderDevelopment;function de(ke){te||(Ie.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function ke(M){if(Array.isArray(M))M.forEach(ke);else if(typeof M=="string")de(M);else{const F=M;typeof F.scheme=="undefined"&&de(M),!Fe.enableProposedApi&&typeof F.exclusive=="boolean"&&(0,se.throwProposedApiError)(Fe)}return M}}(),pn={getSession(te,de,ke){return Pt.getSession(Fe,te,de,ke)},get onDidChangeSessions(){return Pt.onDidChangeSessions},registerAuthenticationProvider(te,de,ke,M){return Pt.registerAuthenticationProvider(te,de,ke,M)},get onDidChangeAuthenticationProviders(){return(0,se.checkProposedApiEnabled)(Fe),Pt.onDidChangeAuthenticationProviders},get providers(){return(0,se.checkProposedApiEnabled)(Fe),Pt.providers},logout(te,de){return(0,se.checkProposedApiEnabled)(Fe),Pt.removeSession(te,de)}},en={registerCommand(te,de,ke){return it.registerCommand(!0,te,de,ke)},registerTextEditorCommand(te,de,ke){return it.registerCommand(!0,te,(...M)=>{const F=St.getActiveTextEditor();if(!F){Ie.warn("Cannot execute "+te+" because there is no active text editor.");return}return F.edit(ne=>{de.apply(ke,[F,ne,...M])}).then(ne=>{ne||Ie.warn("Edits from command "+te+" were not applied.")},ne=>{Ie.warn("An error occurred while running command "+te,ne)})})},registerDiffInformationCommand:(te,de,ke)=>((0,se.checkProposedApiEnabled)(Fe),it.registerCommand(!0,te,async(...M)=>{const F=Je.activeEditor(!0);if(!F){Ie.warn("Cannot execute "+te+" because there is no active text editor.");return}const ne=await St.getDiffInformation(F.id);de.apply(ke,[ne,...M])})),executeCommand(te,...de){return it.executeCommand(te,...de)},getCommands(te=!1){return it.getCommands(te)}},tn={get machineId(){return $e.telemetryInfo.machineId},get sessionId(){return $e.telemetryInfo.sessionId},get language(){return $e.environment.appLanguage},get appName(){return $e.environment.appName},get appRoot(){var te,de;return(de=(te=$e.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return $e.environment.appUriScheme},get clipboard(){return gn.value},get shell(){return dt.getDefaultShell(!1,qt)},get isTelemetryEnabled(){return ct.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ct.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date($e.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,de){return Ge.openUri(te,{allowTunneling:!!$e.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(te){return te.scheme===$e.environment.appUriScheme?Et.createAppUri(te):Ge.asExternalUri(te,{allowTunneling:!!$e.remote.authority})},get remoteName(){return(0,Re.getRemoteName)($e.remote.authority)},get uiKind(){return $e.uiKind}};$e.environment.extensionTestsLocationURI||Object.freeze(tn);const nn=$e.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Kt={registerTestProvider(te){return(0,se.checkProposedApiEnabled)(Fe),kt.registerTestProvider(te)},createDocumentTestObserver(te){return(0,se.checkProposedApiEnabled)(Fe),kt.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return(0,se.checkProposedApiEnabled)(Fe),kt.createWorkspaceTestObserver(te)},runTests(te){return(0,se.checkProposedApiEnabled)(Fe),kt.runTests(te)},publishTestResult(te,de=!0){return(0,se.checkProposedApiEnabled)(Fe),kt.publishExtensionProvidedResults(te,de)},get onDidChangeTestResults(){return(0,se.checkProposedApiEnabled)(Fe),kt.onResultsChanged},get testResults(){return(0,se.checkProposedApiEnabled)(Fe),kt.results}},vn={getExtension(te){const de=Ot.getExtensionDescription(te);if(de)return new l.Extension(Qe,Fe.identifier,de,nn)},get all(){return Ot.getAllExtensionDescriptions().map(te=>new l.Extension(Qe,Fe.identifier,te,nn))},get onDidChange(){return Ot.onDidChange}},_n={createDiagnosticCollection(te){return Lt.createDiagnosticCollection(Fe.identifier,te)},get onDidChangeDiagnostics(){return Lt.onDidChangeDiagnostics},getDiagnostics:te=>Lt.getDiagnostics(te),getLanguages(){return jt.getLanguages()},setTextDocumentLanguage(te,de){return jt.changeLanguage(te.uri,de)},match(te,de){return(0,I.score)($.LanguageSelector.from(te),de.uri,de.languageId,!0)},registerCodeActionsProvider(te,de,ke){return ut.registerCodeActionProvider(Fe,ft(te),de,ke)},registerCodeLensProvider(te,de){return ut.registerCodeLensProvider(Fe,ft(te),de)},registerDefinitionProvider(te,de){return ut.registerDefinitionProvider(Fe,ft(te),de)},registerDeclarationProvider(te,de){return ut.registerDeclarationProvider(Fe,ft(te),de)},registerImplementationProvider(te,de){return ut.registerImplementationProvider(Fe,ft(te),de)},registerTypeDefinitionProvider(te,de){return ut.registerTypeDefinitionProvider(Fe,ft(te),de)},registerHoverProvider(te,de){return ut.registerHoverProvider(Fe,ft(te),de,Fe.identifier)},registerEvaluatableExpressionProvider(te,de){return ut.registerEvaluatableExpressionProvider(Fe,ft(te),de,Fe.identifier)},registerInlineValuesProvider(te,de){return(0,se.checkProposedApiEnabled)(Fe),ut.registerInlineValuesProvider(Fe,ft(te),de,Fe.identifier)},registerDocumentHighlightProvider(te,de){return ut.registerDocumentHighlightProvider(Fe,ft(te),de)},registerLinkedEditingRangeProvider(te,de){return ut.registerLinkedEditingRangeProvider(Fe,ft(te),de)},registerReferenceProvider(te,de){return ut.registerReferenceProvider(Fe,ft(te),de)},registerRenameProvider(te,de){return ut.registerRenameProvider(Fe,ft(te),de)},registerDocumentSymbolProvider(te,de,ke){return ut.registerDocumentSymbolProvider(Fe,ft(te),de,ke)},registerWorkspaceSymbolProvider(te){return ut.registerWorkspaceSymbolProvider(Fe,te)},registerDocumentFormattingEditProvider(te,de){return ut.registerDocumentFormattingEditProvider(Fe,ft(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return ut.registerDocumentRangeFormattingEditProvider(Fe,ft(te),de)},registerOnTypeFormattingEditProvider(te,de,ke,...M){return ut.registerOnTypeFormattingEditProvider(Fe,ft(te),de,[ke].concat(M))},registerDocumentSemanticTokensProvider(te,de,ke){return ut.registerDocumentSemanticTokensProvider(Fe,ft(te),de,ke)},registerDocumentRangeSemanticTokensProvider(te,de,ke){return ut.registerDocumentRangeSemanticTokensProvider(Fe,ft(te),de,ke)},registerSignatureHelpProvider(te,de,ke,...M){return typeof ke=="object"?ut.registerSignatureHelpProvider(Fe,ft(te),de,ke):ut.registerSignatureHelpProvider(Fe,ft(te),de,typeof ke=="undefined"?[]:[ke,...M])},registerCompletionItemProvider(te,de,...ke){return ut.registerCompletionItemProvider(Fe,ft(te),de,ke)},registerDocumentLinkProvider(te,de){return ut.registerDocumentLinkProvider(Fe,ft(te),de)},registerColorProvider(te,de){return ut.registerColorProvider(Fe,ft(te),de)},registerFoldingRangeProvider(te,de){return ut.registerFoldingRangeProvider(Fe,ft(te),de)},registerSelectionRangeProvider(te,de){return ut.registerSelectionRangeProvider(Fe,te,de)},registerCallHierarchyProvider(te,de){return ut.registerCallHierarchyProvider(Fe,te,de)},setLanguageConfiguration:(te,de)=>ut.setLanguageConfiguration(Fe,te,de),getTokenInformationAtPosition(te,de){return(0,se.checkProposedApiEnabled)(Fe),jt.tokenAtPosition(te,de)},registerInlineHintsProvider(te,de){return(0,se.checkProposedApiEnabled)(Fe),ut.registerInlineHintsProvider(Fe,te,de)}},bn={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(te,de,ke){const M=await(k.URI.isUri(te)?Promise.resolve(rn.openTextDocument(te)):Promise.resolve(te));return St.showTextDocument(M,de,ke)},createTextEditorDecorationType(te){return St.createTextEditorDecorationType(te)},onDidChangeActiveTextEditor(te,de,ke){return St.onDidChangeActiveTextEditor(te,de,ke)},onDidChangeVisibleTextEditors(te,de,ke){return St.onDidChangeVisibleTextEditors(te,de,ke)},onDidChangeTextEditorSelection(te,de,ke){return St.onDidChangeTextEditorSelection(te,de,ke)},onDidChangeTextEditorOptions(te,de,ke){return St.onDidChangeTextEditorOptions(te,de,ke)},onDidChangeTextEditorVisibleRanges(te,de,ke){return St.onDidChangeTextEditorVisibleRanges(te,de,ke)},onDidChangeTextEditorViewColumn(te,de,ke){return St.onDidChangeTextEditorViewColumn(te,de,ke)},onDidCloseTerminal(te,de,ke){return dt.onDidCloseTerminal(te,de,ke)},onDidOpenTerminal(te,de,ke){return dt.onDidOpenTerminal(te,de,ke)},onDidChangeActiveTerminal(te,de,ke){return dt.onDidChangeActiveTerminal(te,de,ke)},onDidChangeTerminalDimensions(te,de,ke){return(0,se.checkProposedApiEnabled)(Fe),dt.onDidChangeTerminalDimensions(te,de,ke)},onDidWriteTerminalData(te,de,ke){return(0,se.checkProposedApiEnabled)(Fe),dt.onDidWriteTerminalData(te,de,ke)},get state(){return Ge.state},onDidChangeWindowState(te,de,ke){return Ge.onDidChangeWindowState(te,de,ke)},showInformationMessage(te,...de){return Vt.showMessage(Fe,E.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return Vt.showMessage(Fe,E.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return Vt.showMessage(Fe,E.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,ke){return At.showQuickPick(te,!!Fe.enableProposedApi,de,ke)},showWorkspaceFolderPick(te){return At.showWorkspaceFolderPick(te)},showInputBox(te,de){return At.showInput(te,de)},showOpenDialog(te){return Wt.showOpenDialog(te)},showSaveDialog(te){return Wt.showSaveDialog(te)},createStatusBarItem(te,de){let ke,M,F,ne;return te&&typeof te!="number"?(ke=te.id,M=te.name,F=te.alignment,de=te.priority,ne=te.accessibilityInformation):(ke=Fe.identifier.value,M=_.localize(0,null,Fe.displayName||Fe.name),F=te),Mt.createStatusBarEntry(ke,M,F,de,ne)},setStatusBarMessage(te,de){return Mt.setStatusBarMessage(te,de)},withScmProgress(te){return et.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),Xt.withProgress(Fe,{location:W.ProgressLocation.SourceControl},(de,ke)=>te({report(M){}}))},withProgress(te,de){return Xt.withProgress(Fe,te,de)},createOutputChannel(te){return Ct.createOutputChannel(te)},createWebviewPanel(te,de,ke,M){return Ht.createWebviewPanel(Fe,te,de,ke,M)},createWebviewTextEditorInset(te,de,ke,M){return(0,se.checkProposedApiEnabled)(Fe),$t.createWebviewEditorInset(te,de,ke,M,Fe)},createTerminal(te,de,ke){return typeof te=="object"?"pty"in te?dt.createExtensionTerminal(te):dt.createTerminalFromOptions(te):dt.createTerminal(te,de,ke)},registerTerminalLinkProvider(te){return dt.registerLinkProvider(te)},registerTreeDataProvider(te,de){return Ut.registerTreeDataProvider(te,de,Fe)},createTreeView(te,de){return Ut.createTreeView(te,de,Fe)},registerWebviewPanelSerializer:(te,de)=>Ht.registerWebviewPanelSerializer(Fe,te,de),registerCustomEditorProvider:(te,de,ke={})=>dn.registerCustomEditorProvider(Fe,te,de,ke),registerFileDecorationProvider(te){return lt.registerFileDecorationProvider(te,Fe.identifier)},registerUriHandler(te){return Et.registerUriHandler(Fe.identifier,te)},createQuickPick(){return At.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return At.createInputBox(Fe.identifier)},get activeColorTheme(){return Zt.activeColorTheme},onDidChangeActiveColorTheme(te,de,ke){return Zt.onDidChangeActiveColorTheme(te,de,ke)},registerWebviewViewProvider(te,de,ke){return hn.registerWebviewViewProvider(Fe,te,de,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,se.checkProposedApiEnabled)(Fe),ht.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,ke){return(0,se.checkProposedApiEnabled)(Fe),ht.onDidChangeActiveNotebookEditor(te,de,ke)},get visibleNotebookEditors(){return(0,se.checkProposedApiEnabled)(Fe),ht.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,se.checkProposedApiEnabled)(Fe),ht.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,ke){return(0,se.checkProposedApiEnabled)(Fe),ht.onDidChangeNotebookEditorSelection(te,de,ke)},onDidChangeNotebookEditorVisibleRanges(te,de,ke){return(0,se.checkProposedApiEnabled)(Fe),ht.onDidChangeNotebookEditorVisibleRanges(te,de,ke)},showNotebookDocument(te,de){return(0,se.checkProposedApiEnabled)(Fe),ht.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,ke){return(0,se.checkProposedApiEnabled)(Fe),fn.registerExternalUriOpener(Fe.identifier,te,de,ke)},get openEditors(){return(0,se.checkProposedApiEnabled)(Fe),wt.tabs},get onDidChangeOpenEditors(){return(0,se.checkProposedApiEnabled)(Fe),wt.onDidChangeTabs}},rn={get rootPath(){return et.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(te){throw T.readonly()},getWorkspaceFolder(te){return Ze.getWorkspaceFolder(te)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(te){throw T.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(te){throw T.readonly()},updateWorkspaceFolders:(te,de,...ke)=>Ze.updateWorkspaceFolders(Fe,te,de||0,...ke),onDidChangeWorkspaceFolders:function(te,de,ke){return Ze.onDidChangeWorkspace(te,de,ke)},asRelativePath:(te,de)=>Ze.getRelativePath(te,de),findFiles:(te,de,ke,M)=>Ze.findFiles($.GlobPattern.from(te),$.GlobPattern.from(de),ke,Fe.identifier,M),findTextInFiles:(te,de,ke,M)=>{let F,ne;return typeof de=="object"?(F=de,ne=ke):(F={},ne=de,M=ke),Ze.findTextInFiles(te,F||{},ne,Fe.identifier,M)},saveAll:te=>Ze.saveAll(te),applyEdit(te){return zt.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,de,ke,M)=>It.createFileSystemWatcher($.GlobPattern.from(te),de,ke,M),get textDocuments(){return mt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw T.readonly()},openTextDocument(te){let de;const ke=te;if(typeof te=="string")de=Promise.resolve(k.URI.file(te));else if(k.URI.isUri(te))de=Promise.resolve(te);else if(!ke||typeof ke=="object")de=mt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(M=>mt.ensureDocumentData(M).then(F=>F.document))},onDidOpenTextDocument:(te,de,ke)=>mt.onDidAddDocument(te,de,ke),onDidCloseTextDocument:(te,de,ke)=>mt.onDidRemoveDocument(te,de,ke),onDidChangeTextDocument:(te,de,ke)=>mt.onDidChangeDocument(te,de,ke),onDidSaveTextDocument:(te,de,ke)=>mt.onDidSaveDocument(te,de,ke),onWillSaveTextDocument:(te,de,ke)=>Ft.getOnWillSaveTextDocumentEvent(Fe)(te,de,ke),onDidChangeConfiguration:(te,de,ke)=>qt.onDidChangeConfiguration(te,de,ke),getConfiguration(te,de){return de=arguments.length===1?void 0:de,qt.getConfiguration(te,de,Fe)},registerTextDocumentContentProvider(te,de){return Rt.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(et.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),gt.registerTaskProvider(Fe,te,de)),registerFileSystemProvider(te,de,ke){return ln.registerFileSystemProvider(Fe.identifier,te,de,ke)},get fs(){return Ve.value},registerFileSearchProvider:(te,de)=>((0,se.checkProposedApiEnabled)(Fe),Dt.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,se.checkProposedApiEnabled)(Fe),Dt.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,se.checkProposedApiEnabled)(Fe),Qe.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,se.checkProposedApiEnabled)(Fe),cn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,de,ke)=>It.onDidCreateFile(te,de,ke),onDidDeleteFiles:(te,de,ke)=>It.onDidDeleteFile(te,de,ke),onDidRenameFiles:(te,de,ke)=>It.onDidRenameFile(te,de,ke),onWillCreateFiles:(te,de,ke)=>It.getOnWillCreateFileEvent(Fe)(te,de,ke),onWillDeleteFiles:(te,de,ke)=>It.getOnWillDeleteFileEvent(Fe)(te,de,ke),onWillRenameFiles:(te,de,ke)=>It.getOnWillRenameFileEvent(Fe)(te,de,ke),openTunnel:te=>((0,se.checkProposedApiEnabled)(Fe),Pe.openTunnel(Fe,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,se.checkProposedApiEnabled)(Fe),Pe.getTunnels()},onDidChangeTunnels:(te,de,ke)=>((0,se.checkProposedApiEnabled)(Fe),Pe.onDidChangeTunnels(te,de,ke)),registerPortAttributesProvider:(te,de)=>((0,se.checkProposedApiEnabled)(Fe),Pe.registerPortsAttributesProvider(te,de)),registerTimelineProvider:(te,de)=>((0,se.checkProposedApiEnabled)(Fe),Bt.registerTimelineProvider(te,de,Fe.identifier,it.converter)),get trustState(){return(0,se.checkProposedApiEnabled)(Fe),(0,se.checkRequiresWorkspaceTrust)(Fe),Ze.trustState},requireWorkspaceTrust:te=>((0,se.checkProposedApiEnabled)(Fe),(0,se.checkRequiresWorkspaceTrust)(Fe),Ze.requireWorkspaceTrust(te)),onDidChangeWorkspaceTrustState:(te,de,ke)=>Ze.onDidChangeWorkspaceTrustState(te,de,ke)},wn={get inputBox(){return et.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Fe)},createSourceControl(te,de,ke){return Yt.createSourceControl(Fe,te,de,ke)}},sn={createCommentController(te,de){return un.createCommentController(Fe,te,de)}},En={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(te,de,ke){return at.onDidStartDebugSession(te,de,ke)},onDidTerminateDebugSession(te,de,ke){return at.onDidTerminateDebugSession(te,de,ke)},onDidChangeActiveDebugSession(te,de,ke){return at.onDidChangeActiveDebugSession(te,de,ke)},onDidReceiveDebugSessionCustomEvent(te,de,ke){return at.onDidReceiveDebugSessionCustomEvent(te,de,ke)},onDidChangeBreakpoints(te,de,ke){return at.onDidChangeBreakpoints(te,de,ke)},registerDebugConfigurationProvider(te,de,ke){return at.registerDebugConfigurationProvider(te,de,ke||W.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return at.registerDebugAdapterDescriptorFactory(Fe,te,de)},registerDebugAdapterTrackerFactory(te,de){return at.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,ke){return!ke||typeof ke=="object"&&"configuration"in ke?at.startDebugging(te,de,{parentSession:ke}):at.startDebugging(te,de,ke||{})},stopDebugging(te){return at.stopDebugging(te)},addBreakpoints(te){return at.addBreakpoints(te)},removeBreakpoints(te){return at.removeBreakpoints(te)},asDebugSourceUri(te,de){return at.asDebugSourceUri(te,de)}},Sn={registerTaskProvider:(te,de)=>gt.registerTaskProvider(Fe,te,de),fetchTasks:te=>gt.fetchTasks(te),executeTask:te=>gt.executeTask(Fe,te),get taskExecutions(){return gt.taskExecutions},onDidStartTask:(te,de,ke)=>gt.onDidStartTask(te,de,ke),onDidEndTask:(te,de,ke)=>gt.onDidEndTask(te,de,ke),onDidStartTaskProcess:(te,de,ke)=>gt.onDidStartTaskProcess(te,de,ke),onDidEndTaskProcess:(te,de,ke)=>gt.onDidEndTaskProcess(te,de,ke)},Gt={openNotebookDocument:te=>((0,se.checkProposedApiEnabled)(Fe),ht.openNotebookDocument(te)),get onDidOpenNotebookDocument(){return(0,se.checkProposedApiEnabled)(Fe),ht.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,se.checkProposedApiEnabled)(Fe),ht.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,se.checkProposedApiEnabled)(Fe),ht.onDidSaveNotebookDocument},get notebookDocuments(){return(0,se.checkProposedApiEnabled)(Fe),ht.notebookDocuments.map(te=>te.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,se.checkProposedApiEnabled)(Fe),ht.onDidChangeActiveNotebookKernel},registerNotebookContentProvider:(te,de,ke)=>((0,se.checkProposedApiEnabled)(Fe),ht.registerNotebookContentProvider(Fe,te,de,ke)),registerNotebookKernelProvider:(te,de)=>((0,se.checkProposedApiEnabled)(Fe),ht.registerNotebookKernelProvider(Fe,te,de)),createNotebookEditorDecorationType(te){return(0,se.checkProposedApiEnabled)(Fe),ht.createNotebookEditorDecorationType(te)},onDidChangeNotebookDocumentMetadata(te,de,ke){return(0,se.checkProposedApiEnabled)(Fe),ht.onDidChangeNotebookDocumentMetadata(te,de,ke)},onDidChangeNotebookCells(te,de,ke){return(0,se.checkProposedApiEnabled)(Fe),ht.onDidChangeNotebookCells(te,de,ke)},onDidChangeCellOutputs(te,de,ke){return(0,se.checkProposedApiEnabled)(Fe),ht.onDidChangeCellOutputs(te,de,ke)},onDidChangeCellMetadata(te,de,ke){return(0,se.checkProposedApiEnabled)(Fe),ht.onDidChangeCellMetadata(te,de,ke)},createConcatTextDocument(te,de){return(0,se.checkProposedApiEnabled)(Fe),new H.ExtHostNotebookConcatDocument(ht,mt,te,de)},createCellStatusBarItem(te,de,ke){return(0,se.checkProposedApiEnabled)(Fe),ht.createNotebookCellStatusBarItemInternal(te,de,ke)}};return{version:$e.version,authentication:pn,commands:en,comments:sn,debug:En,env:tn,extensions:vn,languages:_n,notebook:Gt,scm:wn,tasks:Sn,test:Kt,window:bn,workspace:rn,Breakpoint:W.Breakpoint,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:S.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:W.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,EventEmitter:P.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:v.FileType,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,Hover:W.Hover,IndentAction:A.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItemCollapsibleState:W.TreeItemCollapsibleState,UIKind:d.UIKind,Uri:k.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,InlineHint:W.InlineHint,InlineHintKind:W.InlineHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookCellRange:W.NotebookCellRange,NotebookCellKind:W.NotebookCellKind,NotebookCellRunState:W.NotebookCellRunState,NotebookDocumentMetadata:W.NotebookDocumentMetadata,NotebookCellMetadata:W.NotebookCellMetadata,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRunState:W.NotebookRunState,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,LinkedEditingRanges:W.LinkedEditingRanges,TestItem:W.TestItem,TestState:W.TestState,TestResult:W.TestResult,TestMessage:W.TestMessage,TestMessageSeverity:W.TestMessageSeverity,WorkspaceTrustState:W.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=fe}),define(we[221],Ee([0,1,61,98,31,97,34,73,40,41,100,101,102,76,75,67,72,99,74,48,71,93]),function(ae,e,_,S,T,P,E,k,w,n,A,I,v,d,s,f,p,m,b,c,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(d.IExtensionStoragePaths,d.ExtensionStoragePaths),(0,_.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,_.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,_.registerSingleton)(E.IExtHostConfiguration,E.ExtHostConfiguration),(0,_.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,_.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,_.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,_.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors),(0,_.registerSingleton)(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo),(0,_.registerSingleton)(S.IExtHostOutputService,S.ExtHostOutputService),(0,_.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch),(0,_.registerSingleton)(s.IExtHostStorage,s.ExtHostStorage),(0,_.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask),(0,_.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,_.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,_.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,_.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,_.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,_.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry)}),define(we[222],Ee([0,1,220,35,216,7,13]),function(ae,e,_,S,T,P,E){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var w;(function(v){var d;const s=(d=self.trustedTypes)===null||d===void 0?void 0:d.createPolicy("TrustedFunctionWorkaround",{createScript:(p,...m)=>{m.forEach(a=>{var t;if(!((t=self.trustedTypes)===null||t===void 0?void 0:t.isScript(a)))throw new Error("TrustedScripts only, please")});const b=m.slice(0,-1).join(","),c=m.pop().toString();return`(function anonymous(${b}) {
${c}
})`}});function f(...p){return s?self.eval(s.createScript("",...p)):new Function(...p)}v.create=f})(w||(w={}));class n extends T.RequireInterceptor{_installInterceptor(){}getModule(d,s){for(let f of this._alternatives){let p=f(d);if(p){d=p;break}}if(this._factories.has(d))return this._factories.get(d).load(d,s,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends S.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const d=this._instaService.invokeFunction(_.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,d,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(d){return d.browser}async _loadCommonJSModule(d,s,f){var p,m,b,c,u,a,t,r;s=s.with({path:I(s.path,".js")}),d&&performance.mark(`code/extHost/willFetchExtensionCode/${d.value}`);const o=await fetch(s.toString(!0));if(d&&performance.mark(`code/extHost/didFetchExtensionCode/${d.value}`),o.status!==200)throw new Error(o.statusText);const l=await o.text(),i=`${s.toString(!0)}#vscode-extension`,h=`${l}
//# sourceURL=${i}`;let D;try{D=w.create((m=(p=A._ttpExtensionScripts)===null||p===void 0?void 0:p.createScript("module"))!==null&&m!==void 0?m:"module",(c=(b=A._ttpExtensionScripts)===null||b===void 0?void 0:b.createScript("exports"))!==null&&c!==void 0?c:"exports",(a=(u=A._ttpExtensionScripts)===null||u===void 0?void 0:u.createScript("require"))!==null&&a!==void 0?a:"require",(r=(t=A._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript(h))!==null&&r!==void 0?r:h)}catch(R){throw d?console.error(`Loading code for extension ${d.value} failed: ${R.message}`):console.error(`Loading code failed: ${R.message}`),console.error(`${s.toString(!0)}${typeof R.line=="number"?` line ${R.line}`:""}${typeof R.column=="number"?` column ${R.column}`:""}`),console.error(R),R}const C={},g={exports:C},y=R=>{const O=this._fakeModules.getModule(R,s);if(O===void 0)throw new Error(`Cannot load module '${R}'`);return O};try{return f.codeLoadingStart(),d&&performance.mark(`code/extHost/willLoadExtensionCode/${d.value}`),D(g,C,y),g.exports!==C?g.exports:C}finally{d&&performance.mark(`code/extHost/didLoadExtensionCode/${d.value}`),f.codeLoadingStop()}}async $setRemoteEnvironment(d){throw new Error("Not supported")}async _waitForDebuggerAttachment(d=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const s=Date.now()+d;for(;Date.now()<s&&!("__jsDebugIsReady"in globalThis);)await(0,E.timeout)(10)}}}e.ExtHostExtensionService=A,A._ttpExtensionScripts=(k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy("ExtensionScripts",{createScript:v=>v});function I(v,d){return v.endsWith(d)?v:v+d}}),define(we[223],Ee([0,1,61,19,35,222,208]),function(ae,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(T.IExtHostExtensionService,P.ExtHostExtensionService),(0,_.registerSingleton)(S.ILogService,E.ExtHostLogService)}),define(we[225],Ee([0,1,26,3,180,217,210,11,77,221,223]),function(ae,e,_,S,T,P,E,k,w){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0});const A=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const I=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const p=(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("extensionHostWorker",{createScriptURL:b=>b}),m=self.Worker;Worker=function(b,c){const u=`importScripts('${b}');`;c=c||{},c.name=c.name||k.basename(b.toString());const a=new Blob([u],{type:"application/javascript"}),t=URL.createObjectURL(a);return new m(p?p.createScriptURL(t):t,c)}}else self.Worker=class extends E.NestedWorker{constructor(p,m){super(I,p,Object.assign({name:k.basename(p.toString())},m))}};const v=new class{exit(p){A()}async exists(p){return!0}async realpath(p){return p}};class d{constructor(){const m=new MessageChannel,b=new S.Emitter;let c=!1;I(m.port2,[m.port2]),m.port1.onmessage=u=>{const{data:a}=u;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const t=_.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,T.isMessageOfType)(t,2)){c=!0,f("received terminate message from renderer");return}b.fire(t)},this.protocol={onMessage:b.event,send:u=>{if(!c){const a=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);m.port1.postMessage(a,[a])}}}}}function s(p){return new Promise(m=>{const b=p.onMessage(c=>{b.dispose();const u=JSON.parse(c.toString());p.send((0,T.createMessageOfType)(0)),m({protocol:p,initData:u})});p.send((0,T.createMessageOfType)(1))})}let f=p=>A();(function(){const m=new d;w.mark("code/extHost/willConnectToRenderer"),s(m.protocol).then(b=>{w.mark("code/extHost/didWaitForInitData");const c=new P.ExtensionHostMain(b.protocol,b.initData,v,null);f=u=>c.terminate(u)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/06b54543d660353a04cdab6554d1f27266a537fd/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
